/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 94;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 66,
  Feature_HasRCPC_IMMOBit = 86,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 65,
  Feature_HasSHA3Bit = 64,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 93,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 83,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 77,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 44,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 41,
  Feature_HasSVE2SHA3Bit = 92,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 57,
  Feature_HasSMEBit = 50,
  Feature_HasSMEF64F64Bit = 52,
  Feature_HasSMEF16F16Bit = 63,
  Feature_HasSMEI16I64Bit = 55,
  Feature_HasSME2andIsNonStreamingSafeBit = 60,
  Feature_HasSME2Bit = 59,
  Feature_HasSME2p1Bit = 62,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 47,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 42,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 48,
  Feature_HasLUTBit = 49,
  Feature_HasSME_LUTv2Bit = 61,
  Feature_HasSMEF8F16Bit = 53,
  Feature_HasSMEF8F32Bit = 51,
  Feature_HasSME_MOP4Bit = 56,
  Feature_HasCMPBRBit = 84,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 46,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 58,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 45,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 54,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 74,
  Feature_HasRCPCBit = 85,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 91,
  Feature_HasMatMulFP64Bit = 43,
  Feature_HasLS64Bit = 81,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 82,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 72,
  Feature_IsBEBit = 78,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 76,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 89,
  Feature_UseSVEFPLD1RBit = 88,
  Feature_UseLDAPURBit = 87,
  Feature_AllowMisalignedMemAccessesBit = 90,
  Feature_NotForCodeSizeBit = 75,
  Feature_UseSTRQroBit = 73,
  Feature_TailCallX16X17Bit = 68,
  Feature_TailCallX17Bit = 79,
  Feature_TailCallNotX16Bit = 80,
  Feature_TailCallAnyBit = 67,
  Feature_SLSBLRMitigationBit = 71,
  Feature_NoSLSBLRMitigationBit = 70,
  Feature_OptimizedGISelOrOtherSelectorBit = 69,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(889), /*)*//*default:*//*Label 157*/ GIMT_Encode4(414208),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3354),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36349),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50577),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(52406),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(52488), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(52570),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(60316),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72095), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(79287), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(86811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(96755),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(97246),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(97737),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98005),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98155),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(98646), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(98679),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(107489),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(108539), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(111508), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(125034),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(126385),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(127377),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(128369),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(129861), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(131353),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(132345),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(133337),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(134329),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(135321),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(136313),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(137305), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(138010),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(138715), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(139420), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 35*/ GIMT_Encode4(139471),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 36*/ GIMT_Encode4(249204), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 37*/ GIMT_Encode4(260524),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 38*/ GIMT_Encode4(260814),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 39*/ GIMT_Encode4(262251),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 40*/ GIMT_Encode4(262371), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 41*/ GIMT_Encode4(262612),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 42*/ GIMT_Encode4(264510),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 43*/ GIMT_Encode4(266164),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 44*/ GIMT_Encode4(268943),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 45*/ GIMT_Encode4(269723),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 46*/ GIMT_Encode4(270116), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 47*/ GIMT_Encode4(270892),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 48*/ GIMT_Encode4(271022), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 49*/ GIMT_Encode4(271515), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(279292), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(280337),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(280821),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(281305),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(281735),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(282165),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(282595), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(283025),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(284823),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(285561),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(289657), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(305930), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(306546),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(310053),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(310301),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(310489),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(311552),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(312615),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(317012),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 69*/ GIMT_Encode4(320787),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 70*/ GIMT_Encode4(321107),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(321427), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 72*/ GIMT_Encode4(322284),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 73*/ GIMT_Encode4(322566),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 74*/ GIMT_Encode4(322944),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 75*/ GIMT_Encode4(323322),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 76*/ GIMT_Encode4(323672),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 77*/ GIMT_Encode4(324022),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 78*/ GIMT_Encode4(324725), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 79*/ GIMT_Encode4(325428),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 80*/ GIMT_Encode4(325832),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 81*/ GIMT_Encode4(326236),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 82*/ GIMT_Encode4(326640),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 83*/ GIMT_Encode4(327044),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 84*/ GIMT_Encode4(327859),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 85*/ GIMT_Encode4(328025),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 86*/ GIMT_Encode4(328124), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 87*/ GIMT_Encode4(328140),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 88*/ GIMT_Encode4(333512),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 89*/ GIMT_Encode4(360909), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 90*/ GIMT_Encode4(363827), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 91*/ GIMT_Encode4(366147), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 92*/ GIMT_Encode4(366299), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 93*/ GIMT_Encode4(366973),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 94*/ GIMT_Encode4(367133),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(367447),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 96*/ GIMT_Encode4(367601), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 97*/ GIMT_Encode4(368092),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 98*/ GIMT_Encode4(368392),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 99*/ GIMT_Encode4(368883),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 100*/ GIMT_Encode4(369374), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 101*/ GIMT_Encode4(369865),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 102*/ GIMT_Encode4(370991),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 103*/ GIMT_Encode4(371607),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 104*/ GIMT_Encode4(375329), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(375945),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 106*/ GIMT_Encode4(391552), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 107*/ GIMT_Encode4(391852),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 108*/ GIMT_Encode4(391866),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 109*/ GIMT_Encode4(391887), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 110*/ GIMT_Encode4(391912), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 111*/ GIMT_Encode4(392222),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 112*/ GIMT_Encode4(392393),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 113*/ GIMT_Encode4(392564),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 114*/ GIMT_Encode4(392735),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 115*/ GIMT_Encode4(392906), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 116*/ GIMT_Encode4(394035),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 117*/ GIMT_Encode4(394238),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 118*/ GIMT_Encode4(394441),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 119*/ GIMT_Encode4(394644), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3202 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 120*/ GIMT_Encode4(394847), GIMT_Encode4(0),
     /*   3210 */ /*AArch64::G_BSP*//*Label 121*/ GIMT_Encode4(394987),
     /*   3214 */ /*AArch64::G_DUP*//*Label 122*/ GIMT_Encode4(395527),
     /*   3218 */ /*AArch64::G_DUPLANE16*//*Label 123*/ GIMT_Encode4(397350),
     /*   3222 */ /*AArch64::G_DUPLANE32*//*Label 124*/ GIMT_Encode4(397605),
     /*   3226 */ /*AArch64::G_DUPLANE64*//*Label 125*/ GIMT_Encode4(397860),
     /*   3230 */ /*AArch64::G_DUPLANE8*//*Label 126*/ GIMT_Encode4(398006),
     /*   3234 */ /*AArch64::G_EXT*//*Label 127*/ GIMT_Encode4(398185),
     /*   3238 */ /*AArch64::G_FCMEQ*//*Label 128*/ GIMT_Encode4(399835),
     /*   3242 */ /*AArch64::G_FCMEQZ*//*Label 129*/ GIMT_Encode4(400174),
     /*   3246 */ /*AArch64::G_FCMGE*//*Label 130*/ GIMT_Encode4(400404),
     /*   3250 */ /*AArch64::G_FCMGEZ*//*Label 131*/ GIMT_Encode4(401068),
     /*   3254 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(401298),
     /*   3258 */ /*AArch64::G_FCMGTZ*//*Label 133*/ GIMT_Encode4(401962),
     /*   3262 */ /*AArch64::G_FCMLEZ*//*Label 134*/ GIMT_Encode4(402192),
     /*   3266 */ /*AArch64::G_FCMLTZ*//*Label 135*/ GIMT_Encode4(402422),
     /*   3270 */ /*AArch64::G_REV16*//*Label 136*/ GIMT_Encode4(402652),
     /*   3274 */ /*AArch64::G_REV32*//*Label 137*/ GIMT_Encode4(402806),
     /*   3278 */ /*AArch64::G_REV64*//*Label 138*/ GIMT_Encode4(402982),
     /*   3282 */ /*AArch64::G_SADDLP*//*Label 139*/ GIMT_Encode4(403256),
     /*   3286 */ /*AArch64::G_SADDLV*//*Label 140*/ GIMT_Encode4(403462),
     /*   3290 */ /*AArch64::G_SDOT*//*Label 141*/ GIMT_Encode4(403861),
     /*   3294 */ /*AArch64::G_SITOF*//*Label 142*/ GIMT_Encode4(404231),
     /*   3298 */ /*AArch64::G_SMULL*//*Label 143*/ GIMT_Encode4(404348),
     /*   3302 */ /*AArch64::G_TRN1*//*Label 144*/ GIMT_Encode4(405581),
     /*   3306 */ /*AArch64::G_TRN2*//*Label 145*/ GIMT_Encode4(406361),
     /*   3310 */ /*AArch64::G_UADDLP*//*Label 146*/ GIMT_Encode4(407141),
     /*   3314 */ /*AArch64::G_UADDLV*//*Label 147*/ GIMT_Encode4(407347),
     /*   3318 */ /*AArch64::G_UDOT*//*Label 148*/ GIMT_Encode4(408214),
     /*   3322 */ /*AArch64::G_UITOF*//*Label 149*/ GIMT_Encode4(408584),
     /*   3326 */ /*AArch64::G_UMULL*//*Label 150*/ GIMT_Encode4(408701),
     /*   3330 */ /*AArch64::G_UZP1*//*Label 151*/ GIMT_Encode4(409934),
     /*   3334 */ /*AArch64::G_UZP2*//*Label 152*/ GIMT_Encode4(410714),
     /*   3338 */ /*AArch64::G_VASHR*//*Label 153*/ GIMT_Encode4(411494),
     /*   3342 */ /*AArch64::G_VLSHR*//*Label 154*/ GIMT_Encode4(412192),
     /*   3346 */ /*AArch64::G_ZIP1*//*Label 155*/ GIMT_Encode4(412648),
     /*   3350 */ /*AArch64::G_ZIP2*//*Label 156*/ GIMT_Encode4(413428),
     /*   3354 */ // Label 0: @3354
     /*   3354 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 171*/ GIMT_Encode4(36348),
     /*   3365 */ /*GILLT_s32*//*Label 158*/ GIMT_Encode4(3453),
     /*   3369 */ /*GILLT_s64*//*Label 159*/ GIMT_Encode4(6232), GIMT_Encode4(0),
     /*   3377 */ /*GILLT_v2s32*//*Label 160*/ GIMT_Encode4(11560),
     /*   3381 */ /*GILLT_v2s64*//*Label 161*/ GIMT_Encode4(15168),
     /*   3385 */ /*GILLT_v4s16*//*Label 162*/ GIMT_Encode4(21070),
     /*   3389 */ /*GILLT_v4s32*//*Label 163*/ GIMT_Encode4(24568),
     /*   3393 */ /*GILLT_v8s8*//*Label 164*/ GIMT_Encode4(30746),
     /*   3397 */ /*GILLT_v8s16*//*Label 165*/ GIMT_Encode4(31596),
     /*   3401 */ /*GILLT_v16s8*//*Label 166*/ GIMT_Encode4(35174), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3421 */ /*GILLT_nxv2s64*//*Label 167*/ GIMT_Encode4(35898), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_nxv4s32*//*Label 168*/ GIMT_Encode4(36270), GIMT_Encode4(0),
     /*   3441 */ /*GILLT_nxv8s16*//*Label 169*/ GIMT_Encode4(36296), GIMT_Encode4(0),
     /*   3449 */ /*GILLT_nxv16s8*//*Label 170*/ GIMT_Encode4(36322),
     /*   3453 */ // Label 158: @3453
     /*   3453 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(6231),
     /*   3458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3464 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3497), // Rule ID 13129 //
     /*   3469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3484 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3495 */     GIR_RootConstrainSelectedInstOperands,
     /*   3496 */     // GIR_Coverage, 13129,
     /*   3496 */     GIR_EraseRootFromParent_Done,
     /*   3497 */   // Label 173: @3497
     /*   3497 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3649), // Rule ID 13556 //
     /*   3502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3529 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3532 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3537 */     // MIs[2] pattern
     /*   3537 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3540 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3551 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3551 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3554 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3558 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3577 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3584 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3592 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3648 */     // GIR_Coverage, 13556,
     /*   3648 */     GIR_EraseRootFromParent_Done,
     /*   3649 */   // Label 174: @3649
     /*   3649 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3801), // Rule ID 15407 //
     /*   3654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3681 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3684 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3689 */     // MIs[2] pattern
     /*   3689 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3692 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3703 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3703 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3706 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3710 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3729 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3732 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3736 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3773 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3783 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3800 */     // GIR_Coverage, 15407,
     /*   3800 */     GIR_EraseRootFromParent_Done,
     /*   3801 */   // Label 175: @3801
     /*   3801 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(3953), // Rule ID 15419 //
     /*   3806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3841 */     // MIs[2] pattern
     /*   3841 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3844 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3855 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3855 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3858 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3862 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3869 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3872 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3876 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3881 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3884 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3888 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3891 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3896 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3901 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3952 */     // GIR_Coverage, 15419,
     /*   3952 */     GIR_EraseRootFromParent_Done,
     /*   3953 */   // Label 176: @3953
     /*   3953 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4105), // Rule ID 15431 //
     /*   3958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3985 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3988 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   3993 */     // MIs[2] pattern
     /*   3993 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3996 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4007 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4007 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4010 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4014 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4033 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4087 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4104 */     // GIR_Coverage, 15431,
     /*   4104 */     GIR_EraseRootFromParent_Done,
     /*   4105 */   // Label 177: @4105
     /*   4105 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4138), // Rule ID 91 //
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4125 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4136 */     GIR_RootConstrainSelectedInstOperands,
     /*   4137 */     // GIR_Coverage, 91,
     /*   4137 */     GIR_EraseRootFromParent_Done,
     /*   4138 */   // Label 178: @4138
     /*   4138 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4290), // Rule ID 2656 //
     /*   4143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4174 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4177 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4182 */     // MIs[2] pattern
     /*   4182 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4185 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4192 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4272 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4289 */     // GIR_Coverage, 2656,
     /*   4289 */     GIR_EraseRootFromParent_Done,
     /*   4290 */   // Label 179: @4290
     /*   4290 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4442), // Rule ID 9888 //
     /*   4295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4326 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4329 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4334 */     // MIs[2] pattern
     /*   4334 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4337 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4344 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4344 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4347 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4351 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4370 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4373 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4377 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4424 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4441 */     // GIR_Coverage, 9888,
     /*   4441 */     GIR_EraseRootFromParent_Done,
     /*   4442 */   // Label 180: @4442
     /*   4442 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4594), // Rule ID 9900 //
     /*   4447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4478 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4481 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4486 */     // MIs[2] pattern
     /*   4486 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4489 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4496 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4593 */     // GIR_Coverage, 9900,
     /*   4593 */     GIR_EraseRootFromParent_Done,
     /*   4594 */   // Label 181: @4594
     /*   4594 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4746), // Rule ID 9912 //
     /*   4599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4630 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4633 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4638 */     // MIs[2] pattern
     /*   4638 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4641 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4648 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4674 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4677 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4681 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4714 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4745 */     // GIR_Coverage, 9912,
     /*   4745 */     GIR_EraseRootFromParent_Done,
     /*   4746 */   // Label 182: @4746
     /*   4746 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4903), // Rule ID 15450 //
     /*   4751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4778 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4781 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4790 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4797 */     // MIs[2] pred
     /*   4797 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4808 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4808 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4811 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4815 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4834 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4844 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4885 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4902 */     // GIR_Coverage, 15450,
     /*   4902 */     GIR_EraseRootFromParent_Done,
     /*   4903 */   // Label 183: @4903
     /*   4903 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5060), // Rule ID 15451 //
     /*   4908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4935 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4938 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   4947 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4954 */     // MIs[2] pred
     /*   4954 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4965 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4991 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4998 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5042 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5059 */     // GIR_Coverage, 15451,
     /*   5059 */     GIR_EraseRootFromParent_Done,
     /*   5060 */   // Label 184: @5060
     /*   5060 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5217), // Rule ID 15452 //
     /*   5065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5111 */     // MIs[2] pred
     /*   5111 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5122 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5148 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5189 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5216 */     // GIR_Coverage, 15452,
     /*   5216 */     GIR_EraseRootFromParent_Done,
     /*   5217 */   // Label 185: @5217
     /*   5217 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5374), // Rule ID 15453 //
     /*   5222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5249 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5252 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5261 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5268 */     // MIs[2] pred
     /*   5268 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5279 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5279 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5282 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5286 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5305 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5308 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5312 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5346 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5356 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5373 */     // GIR_Coverage, 15453,
     /*   5373 */     GIR_EraseRootFromParent_Done,
     /*   5374 */   // Label 186: @5374
     /*   5374 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5531), // Rule ID 10004 //
     /*   5379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5410 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5413 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5422 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5429 */     // MIs[2] pred
     /*   5429 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5436 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5436 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5439 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5443 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5462 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5465 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5469 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5482 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5530 */     // GIR_Coverage, 10004,
     /*   5530 */     GIR_EraseRootFromParent_Done,
     /*   5531 */   // Label 187: @5531
     /*   5531 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5688), // Rule ID 10005 //
     /*   5536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5567 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5570 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5586 */     // MIs[2] pred
     /*   5586 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5593 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5593 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5596 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5600 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5619 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5626 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5670 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5687 */     // GIR_Coverage, 10005,
     /*   5687 */     GIR_EraseRootFromParent_Done,
     /*   5688 */   // Label 188: @5688
     /*   5688 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5845), // Rule ID 10006 //
     /*   5693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5724 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5727 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5743 */     // MIs[2] pred
     /*   5743 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5750 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5764 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5767 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5771 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5776 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5783 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5786 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5791 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5827 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5844 */     // GIR_Coverage, 10006,
     /*   5844 */     GIR_EraseRootFromParent_Done,
     /*   5845 */   // Label 189: @5845
     /*   5845 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6002), // Rule ID 10007 //
     /*   5850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5881 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5884 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5893 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5900 */     // MIs[2] pred
     /*   5900 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5907 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5907 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5910 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5914 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5933 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5940 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5984 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6001 */     // GIR_Coverage, 10007,
     /*   6001 */     GIR_EraseRootFromParent_Done,
     /*   6002 */   // Label 190: @6002
     /*   6002 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6035), // Rule ID 13133 //
     /*   6007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6022 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6033 */     GIR_RootConstrainSelectedInstOperands,
     /*   6034 */     // GIR_Coverage, 13133,
     /*   6034 */     GIR_EraseRootFromParent_Done,
     /*   6035 */   // Label 191: @6035
     /*   6035 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6071), // Rule ID 13696 //
     /*   6040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6055 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6069 */     GIR_RootConstrainSelectedInstOperands,
     /*   6070 */     // GIR_Coverage, 13696,
     /*   6070 */     GIR_EraseRootFromParent_Done,
     /*   6071 */   // Label 192: @6071
     /*   6071 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6104), // Rule ID 97 //
     /*   6076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6091 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6102 */     GIR_RootConstrainSelectedInstOperands,
     /*   6103 */     // GIR_Coverage, 97,
     /*   6103 */     GIR_EraseRootFromParent_Done,
     /*   6104 */   // Label 193: @6104
     /*   6104 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6140), // Rule ID 3911 //
     /*   6109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6124 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6138 */     GIR_RootConstrainSelectedInstOperands,
     /*   6139 */     // GIR_Coverage, 3911,
     /*   6139 */     GIR_EraseRootFromParent_Done,
     /*   6140 */   // Label 194: @6140
     /*   6140 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6173), // Rule ID 13131 //
     /*   6145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6160 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6171 */     GIR_RootConstrainSelectedInstOperands,
     /*   6172 */     // GIR_Coverage, 13131,
     /*   6172 */     GIR_EraseRootFromParent_Done,
     /*   6173 */   // Label 195: @6173
     /*   6173 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6206), // Rule ID 95 //
     /*   6178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6193 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6204 */     GIR_RootConstrainSelectedInstOperands,
     /*   6205 */     // GIR_Coverage, 95,
     /*   6205 */     GIR_EraseRootFromParent_Done,
     /*   6206 */   // Label 196: @6206
     /*   6206 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6230), // Rule ID 93 //
     /*   6211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6223 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6228 */     GIR_RootConstrainSelectedInstOperands,
     /*   6229 */     // GIR_Coverage, 93,
     /*   6229 */     GIR_Done,
     /*   6230 */   // Label 197: @6230
     /*   6230 */   GIM_Reject,
     /*   6231 */ // Label 172: @6231
     /*   6231 */ GIM_Reject,
     /*   6232 */ // Label 159: @6232
     /*   6232 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(11559),
     /*   6237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6243 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6379), // Rule ID 5362 //
     /*   6248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6281 */     // MIs[1] Operand 2
     /*   6281 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6308 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6312 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6316 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6321 */     // MIs[3] Operand 2
     /*   6321 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6332 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6334 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6378 */     // GIR_Coverage, 5362,
     /*   6378 */     GIR_EraseRootFromParent_Done,
     /*   6379 */   // Label 199: @6379
     /*   6379 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6515), // Rule ID 5361 //
     /*   6384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6417 */     // MIs[1] Operand 2
     /*   6417 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6448 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6452 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6457 */     // MIs[3] Operand 2
     /*   6457 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6468 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6470 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6497 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6514 */     // GIR_Coverage, 5361,
     /*   6514 */     GIR_EraseRootFromParent_Done,
     /*   6515 */   // Label 200: @6515
     /*   6515 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6651), // Rule ID 5371 //
     /*   6520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6553 */     // MIs[1] Operand 2
     /*   6553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6588 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6593 */     // MIs[3] Operand 2
     /*   6593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6606 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6650 */     // GIR_Coverage, 5371,
     /*   6650 */     GIR_EraseRootFromParent_Done,
     /*   6651 */   // Label 201: @6651
     /*   6651 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6787), // Rule ID 5360 //
     /*   6656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6689 */     // MIs[1] Operand 2
     /*   6689 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6708 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6716 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6720 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6724 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6729 */     // MIs[3] Operand 2
     /*   6729 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6740 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6742 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6786 */     // GIR_Coverage, 5360,
     /*   6786 */     GIR_EraseRootFromParent_Done,
     /*   6787 */   // Label 202: @6787
     /*   6787 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6923), // Rule ID 5359 //
     /*   6792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6825 */     // MIs[1] Operand 2
     /*   6825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6844 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6856 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6860 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6865 */     // MIs[3] Operand 2
     /*   6865 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6876 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6878 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6922 */     // GIR_Coverage, 5359,
     /*   6922 */     GIR_EraseRootFromParent_Done,
     /*   6923 */   // Label 203: @6923
     /*   6923 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6991), // Rule ID 6876 //
     /*   6928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   6957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   6961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   6969 */     // MIs[2] Rn
     /*   6969 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   6974 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   6978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   6980 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   6980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   6983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6989 */     GIR_RootConstrainSelectedInstOperands,
     /*   6990 */     // GIR_Coverage, 6876,
     /*   6990 */     GIR_EraseRootFromParent_Done,
     /*   6991 */   // Label 204: @6991
     /*   6991 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7059), // Rule ID 13851 //
     /*   6996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7037 */     // MIs[2] Rn
     /*   7037 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7042 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7048 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7057 */     GIR_RootConstrainSelectedInstOperands,
     /*   7058 */     // GIR_Coverage, 13851,
     /*   7058 */     GIR_EraseRootFromParent_Done,
     /*   7059 */   // Label 205: @7059
     /*   7059 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7092), // Rule ID 13130 //
     /*   7064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7079 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7090 */     GIR_RootConstrainSelectedInstOperands,
     /*   7091 */     // GIR_Coverage, 13130,
     /*   7091 */     GIR_EraseRootFromParent_Done,
     /*   7092 */   // Label 206: @7092
     /*   7092 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7225), // Rule ID 3963 //
     /*   7097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7134 */     // MIs[2] Operand 2
     /*   7134 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7157 */     // MIs[3] Operand 1
     /*   7157 */     // No operand predicates
     /*   7157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7163 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7175 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7194 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7223 */     GIR_RootConstrainSelectedInstOperands,
     /*   7224 */     // GIR_Coverage, 3963,
     /*   7224 */     GIR_EraseRootFromParent_Done,
     /*   7225 */   // Label 207: @7225
     /*   7225 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7320), // Rule ID 3961 //
     /*   7230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7279 */     // MIs[3] Operand 1
     /*   7279 */     // No operand predicates
     /*   7279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7285 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7297 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7318 */     GIR_RootConstrainSelectedInstOperands,
     /*   7319 */     // GIR_Coverage, 3961,
     /*   7319 */     GIR_EraseRootFromParent_Done,
     /*   7320 */   // Label 208: @7320
     /*   7320 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7415), // Rule ID 3962 //
     /*   7325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7374 */     // MIs[3] Operand 1
     /*   7374 */     // No operand predicates
     /*   7374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7380 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7392 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7413 */     GIR_RootConstrainSelectedInstOperands,
     /*   7414 */     // GIR_Coverage, 3962,
     /*   7414 */     GIR_EraseRootFromParent_Done,
     /*   7415 */   // Label 209: @7415
     /*   7415 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7448), // Rule ID 92 //
     /*   7420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7435 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7446 */     GIR_RootConstrainSelectedInstOperands,
     /*   7447 */     // GIR_Coverage, 92,
     /*   7447 */     GIR_EraseRootFromParent_Done,
     /*   7448 */   // Label 210: @7448
     /*   7448 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7581), // Rule ID 13706 //
     /*   7453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7494 */     // MIs[2] Operand 2
     /*   7494 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7517 */     // MIs[3] Operand 1
     /*   7517 */     // No operand predicates
     /*   7517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7519 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7531 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7579 */     GIR_RootConstrainSelectedInstOperands,
     /*   7580 */     // GIR_Coverage, 13706,
     /*   7580 */     GIR_EraseRootFromParent_Done,
     /*   7581 */   // Label 211: @7581
     /*   7581 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7676), // Rule ID 13704 //
     /*   7586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7635 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7639 */     // MIs[3] Operand 1
     /*   7639 */     // No operand predicates
     /*   7639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7641 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7653 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 13704,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 212: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7771), // Rule ID 13705 //
     /*   7681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7734 */     // MIs[3] Operand 1
     /*   7734 */     // No operand predicates
     /*   7734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7736 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7748 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7769 */     GIR_RootConstrainSelectedInstOperands,
     /*   7770 */     // GIR_Coverage, 13705,
     /*   7770 */     GIR_EraseRootFromParent_Done,
     /*   7771 */   // Label 213: @7771
     /*   7771 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7853), // Rule ID 13141 //
     /*   7776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7836 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7851 */     GIR_RootConstrainSelectedInstOperands,
     /*   7852 */     // GIR_Coverage, 13141,
     /*   7852 */     GIR_EraseRootFromParent_Done,
     /*   7853 */   // Label 214: @7853
     /*   7853 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7935), // Rule ID 13142 //
     /*   7858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7918 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7933 */     GIR_RootConstrainSelectedInstOperands,
     /*   7934 */     // GIR_Coverage, 13142,
     /*   7934 */     GIR_EraseRootFromParent_Done,
     /*   7935 */   // Label 215: @7935
     /*   7935 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8017), // Rule ID 123 //
     /*   7940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8000 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8015 */     GIR_RootConstrainSelectedInstOperands,
     /*   8016 */     // GIR_Coverage, 123,
     /*   8016 */     GIR_EraseRootFromParent_Done,
     /*   8017 */   // Label 216: @8017
     /*   8017 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8099), // Rule ID 125 //
     /*   8022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8071 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8082 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8097 */     GIR_RootConstrainSelectedInstOperands,
     /*   8098 */     // GIR_Coverage, 125,
     /*   8098 */     GIR_EraseRootFromParent_Done,
     /*   8099 */   // Label 217: @8099
     /*   8099 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8157), // Rule ID 13551 //
     /*   8104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8119 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8122 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8127 */     // MIs[1] pattern
     /*   8127 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8130 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8141 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8155 */     GIR_RootConstrainSelectedInstOperands,
     /*   8156 */     // GIR_Coverage, 13551,
     /*   8156 */     GIR_EraseRootFromParent_Done,
     /*   8157 */   // Label 218: @8157
     /*   8157 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8215), // Rule ID 15402 //
     /*   8162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8177 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8180 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8185 */     // MIs[1] pattern
     /*   8185 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8188 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8199 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8213 */     GIR_RootConstrainSelectedInstOperands,
     /*   8214 */     // GIR_Coverage, 15402,
     /*   8214 */     GIR_EraseRootFromParent_Done,
     /*   8215 */   // Label 219: @8215
     /*   8215 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8273), // Rule ID 15414 //
     /*   8220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8235 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8238 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8243 */     // MIs[1] pattern
     /*   8243 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8246 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8257 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8271 */     GIR_RootConstrainSelectedInstOperands,
     /*   8272 */     // GIR_Coverage, 15414,
     /*   8272 */     GIR_EraseRootFromParent_Done,
     /*   8273 */   // Label 220: @8273
     /*   8273 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8331), // Rule ID 15426 //
     /*   8278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8293 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8296 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8301 */     // MIs[1] pattern
     /*   8301 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8304 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8315 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8329 */     GIR_RootConstrainSelectedInstOperands,
     /*   8330 */     // GIR_Coverage, 15426,
     /*   8330 */     GIR_EraseRootFromParent_Done,
     /*   8331 */   // Label 221: @8331
     /*   8331 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8389), // Rule ID 2653 //
     /*   8336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8355 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8358 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8363 */     // MIs[1] pattern
     /*   8363 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8366 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8373 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8387 */     GIR_RootConstrainSelectedInstOperands,
     /*   8388 */     // GIR_Coverage, 2653,
     /*   8388 */     GIR_EraseRootFromParent_Done,
     /*   8389 */   // Label 222: @8389
     /*   8389 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8447), // Rule ID 9885 //
     /*   8394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8413 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8416 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8421 */     // MIs[1] pattern
     /*   8421 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8424 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8431 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8445 */     GIR_RootConstrainSelectedInstOperands,
     /*   8446 */     // GIR_Coverage, 9885,
     /*   8446 */     GIR_EraseRootFromParent_Done,
     /*   8447 */   // Label 223: @8447
     /*   8447 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8505), // Rule ID 9897 //
     /*   8452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8471 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8474 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8479 */     // MIs[1] pattern
     /*   8479 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8482 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8489 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8503 */     GIR_RootConstrainSelectedInstOperands,
     /*   8504 */     // GIR_Coverage, 9897,
     /*   8504 */     GIR_EraseRootFromParent_Done,
     /*   8505 */   // Label 224: @8505
     /*   8505 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8563), // Rule ID 9909 //
     /*   8510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8529 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8532 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8537 */     // MIs[1] pattern
     /*   8537 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8540 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8547 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8561 */     GIR_RootConstrainSelectedInstOperands,
     /*   8562 */     // GIR_Coverage, 9909,
     /*   8562 */     GIR_EraseRootFromParent_Done,
     /*   8563 */   // Label 225: @8563
     /*   8563 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8726), // Rule ID 13823 //
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8610 */     // MIs[1] Operand 2
     /*   8610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8627 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8627 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8630 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8634 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8653 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8660 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8708 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8725 */     // GIR_Coverage, 13823,
     /*   8725 */     GIR_EraseRootFromParent_Done,
     /*   8726 */   // Label 226: @8726
     /*   8726 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8889), // Rule ID 13820 //
     /*   8731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8773 */     // MIs[1] Operand 2
     /*   8773 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8790 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8816 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8853 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8888 */     // GIR_Coverage, 13820,
     /*   8888 */     GIR_EraseRootFromParent_Done,
     /*   8889 */   // Label 227: @8889
     /*   8889 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9039), // Rule ID 13829 //
     /*   8894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8927 */     // MIs[1] Operand 2
     /*   8927 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8944 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8944 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8947 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8951 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8970 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   8977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9038 */     // GIR_Coverage, 13829,
     /*   9038 */     GIR_EraseRootFromParent_Done,
     /*   9039 */   // Label 228: @9039
     /*   9039 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9189), // Rule ID 13832 //
     /*   9044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9077 */     // MIs[1] Operand 2
     /*   9077 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9094 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9094 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9097 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9101 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9120 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9123 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9127 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9140 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9171 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9188 */     // GIR_Coverage, 13832,
     /*   9188 */     GIR_EraseRootFromParent_Done,
     /*   9189 */   // Label 229: @9189
     /*   9189 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9339), // Rule ID 13828 //
     /*   9194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9227 */     // MIs[1] Operand 2
     /*   9227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9244 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9244 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9247 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9251 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9270 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9277 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9290 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9338 */     // GIR_Coverage, 13828,
     /*   9338 */     GIR_EraseRootFromParent_Done,
     /*   9339 */   // Label 230: @9339
     /*   9339 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9502), // Rule ID 5344 //
     /*   9344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9390 */     // MIs[1] Operand 2
     /*   9390 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9403 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9403 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9406 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9410 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9429 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9432 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9436 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9466 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9484 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9501 */     // GIR_Coverage, 5344,
     /*   9501 */     GIR_EraseRootFromParent_Done,
     /*   9502 */   // Label 231: @9502
     /*   9502 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9665), // Rule ID 5341 //
     /*   9507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9553 */     // MIs[1] Operand 2
     /*   9553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9566 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9566 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9569 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9573 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9592 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9599 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9647 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9664 */     // GIR_Coverage, 5341,
     /*   9664 */     GIR_EraseRootFromParent_Done,
     /*   9665 */   // Label 232: @9665
     /*   9665 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9815), // Rule ID 5368 //
     /*   9670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9707 */     // MIs[1] Operand 2
     /*   9707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9720 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9720 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9723 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9727 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9734 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9737 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9741 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9746 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9753 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9814 */     // GIR_Coverage, 5368,
     /*   9814 */     GIR_EraseRootFromParent_Done,
     /*   9815 */   // Label 233: @9815
     /*   9815 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9965), // Rule ID 5374 //
     /*   9820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9857 */     // MIs[1] Operand 2
     /*   9857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9870 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9870 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9873 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9877 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9884 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9887 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9891 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9896 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9903 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9906 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9947 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9964 */     // GIR_Coverage, 5374,
     /*   9964 */     GIR_EraseRootFromParent_Done,
     /*   9965 */   // Label 234: @9965
     /*   9965 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10115), // Rule ID 5367 //
     /*   9970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10007 */     // MIs[1] Operand 2
     /*  10007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10020 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10020 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10023 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10027 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10046 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10049 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10053 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10097 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10114 */     // GIR_Coverage, 5367,
     /*  10114 */     GIR_EraseRootFromParent_Done,
     /*  10115 */   // Label 235: @10115
     /*  10115 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10148), // Rule ID 13134 //
     /*  10120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10135 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10146 */     GIR_RootConstrainSelectedInstOperands,
     /*  10147 */     // GIR_Coverage, 13134,
     /*  10147 */     GIR_EraseRootFromParent_Done,
     /*  10148 */   // Label 236: @10148
     /*  10148 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10184), // Rule ID 13697 //
     /*  10153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10168 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10182 */     GIR_RootConstrainSelectedInstOperands,
     /*  10183 */     // GIR_Coverage, 13697,
     /*  10183 */     GIR_EraseRootFromParent_Done,
     /*  10184 */   // Label 237: @10184
     /*  10184 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10217), // Rule ID 98 //
     /*  10189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10204 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10215 */     GIR_RootConstrainSelectedInstOperands,
     /*  10216 */     // GIR_Coverage, 98,
     /*  10216 */     GIR_EraseRootFromParent_Done,
     /*  10217 */   // Label 238: @10217
     /*  10217 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10253), // Rule ID 3912 //
     /*  10222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10237 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 3912,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 239: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10286), // Rule ID 13132 //
     /*  10258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10273 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10284 */     GIR_RootConstrainSelectedInstOperands,
     /*  10285 */     // GIR_Coverage, 13132,
     /*  10285 */     GIR_EraseRootFromParent_Done,
     /*  10286 */   // Label 240: @10286
     /*  10286 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10349), // Rule ID 15442 //
     /*  10291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10306 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10309 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10325 */     // MIs[1] pred
     /*  10325 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10336 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10347 */     GIR_RootConstrainSelectedInstOperands,
     /*  10348 */     // GIR_Coverage, 15442,
     /*  10348 */     GIR_EraseRootFromParent_Done,
     /*  10349 */   // Label 241: @10349
     /*  10349 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10412), // Rule ID 15443 //
     /*  10354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10369 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10372 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10388 */     // MIs[1] pred
     /*  10388 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10399 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10410 */     GIR_RootConstrainSelectedInstOperands,
     /*  10411 */     // GIR_Coverage, 15443,
     /*  10411 */     GIR_EraseRootFromParent_Done,
     /*  10412 */   // Label 242: @10412
     /*  10412 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10475), // Rule ID 15444 //
     /*  10417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10432 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10435 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10444 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10451 */     // MIs[1] pred
     /*  10451 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10462 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10473 */     GIR_RootConstrainSelectedInstOperands,
     /*  10474 */     // GIR_Coverage, 15444,
     /*  10474 */     GIR_EraseRootFromParent_Done,
     /*  10475 */   // Label 243: @10475
     /*  10475 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10538), // Rule ID 15445 //
     /*  10480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10495 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10498 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10507 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10514 */     // MIs[1] pred
     /*  10514 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10525 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10536 */     GIR_RootConstrainSelectedInstOperands,
     /*  10537 */     // GIR_Coverage, 15445,
     /*  10537 */     GIR_EraseRootFromParent_Done,
     /*  10538 */   // Label 244: @10538
     /*  10538 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10571), // Rule ID 96 //
     /*  10543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10558 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10569 */     GIR_RootConstrainSelectedInstOperands,
     /*  10570 */     // GIR_Coverage, 96,
     /*  10570 */     GIR_EraseRootFromParent_Done,
     /*  10571 */   // Label 245: @10571
     /*  10571 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10634), // Rule ID 9996 //
     /*  10576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10595 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10598 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10607 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10614 */     // MIs[1] pred
     /*  10614 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10621 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10632 */     GIR_RootConstrainSelectedInstOperands,
     /*  10633 */     // GIR_Coverage, 9996,
     /*  10633 */     GIR_EraseRootFromParent_Done,
     /*  10634 */   // Label 246: @10634
     /*  10634 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10697), // Rule ID 9997 //
     /*  10639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10658 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10661 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10677 */     // MIs[1] pred
     /*  10677 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10695 */     GIR_RootConstrainSelectedInstOperands,
     /*  10696 */     // GIR_Coverage, 9997,
     /*  10696 */     GIR_EraseRootFromParent_Done,
     /*  10697 */   // Label 247: @10697
     /*  10697 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10760), // Rule ID 9998 //
     /*  10702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10721 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10724 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10733 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10740 */     // MIs[1] pred
     /*  10740 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10747 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10758 */     GIR_RootConstrainSelectedInstOperands,
     /*  10759 */     // GIR_Coverage, 9998,
     /*  10759 */     GIR_EraseRootFromParent_Done,
     /*  10760 */   // Label 248: @10760
     /*  10760 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(10823), // Rule ID 9999 //
     /*  10765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10784 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10787 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10803 */     // MIs[1] pred
     /*  10803 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10810 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10821 */     GIR_RootConstrainSelectedInstOperands,
     /*  10822 */     // GIR_Coverage, 9999,
     /*  10822 */     GIR_EraseRootFromParent_Done,
     /*  10823 */   // Label 249: @10823
     /*  10823 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10879), // Rule ID 13240 //
     /*  10828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10843 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10846 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 13240,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 250: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10935), // Rule ID 13252 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13252,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 251: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11002), // Rule ID 13458 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  10955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10964 */     // MIs[1] imm
     /*  10964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  10968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  10976 */     // MIs[2] Operand 1
     /*  10976 */     // No operand predicates
     /*  10976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  10984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10986 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  10989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11000 */     GIR_RootConstrainSelectedInstOperands,
     /*  11001 */     // GIR_Coverage, 13458,
     /*  11001 */     GIR_EraseRootFromParent_Done,
     /*  11002 */   // Label 252: @11002
     /*  11002 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11069), // Rule ID 13461 //
     /*  11007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11031 */     // MIs[1] imm
     /*  11031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11039 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11043 */     // MIs[2] Operand 1
     /*  11043 */     // No operand predicates
     /*  11043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11053 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11067 */     GIR_RootConstrainSelectedInstOperands,
     /*  11068 */     // GIR_Coverage, 13461,
     /*  11068 */     GIR_EraseRootFromParent_Done,
     /*  11069 */   // Label 253: @11069
     /*  11069 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11125), // Rule ID 997 //
     /*  11074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11093 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11096 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11112 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11123 */     GIR_RootConstrainSelectedInstOperands,
     /*  11124 */     // GIR_Coverage, 997,
     /*  11124 */     GIR_EraseRootFromParent_Done,
     /*  11125 */   // Label 254: @11125
     /*  11125 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11181), // Rule ID 1058 //
     /*  11130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11168 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11179 */     GIR_RootConstrainSelectedInstOperands,
     /*  11180 */     // GIR_Coverage, 1058,
     /*  11180 */     GIR_EraseRootFromParent_Done,
     /*  11181 */   // Label 255: @11181
     /*  11181 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11248), // Rule ID 2121 //
     /*  11186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11214 */     // MIs[1] imm
     /*  11214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11222 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11226 */     // MIs[2] Operand 1
     /*  11226 */     // No operand predicates
     /*  11226 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11232 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11246 */     GIR_RootConstrainSelectedInstOperands,
     /*  11247 */     // GIR_Coverage, 2121,
     /*  11247 */     GIR_EraseRootFromParent_Done,
     /*  11248 */   // Label 256: @11248
     /*  11248 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11315), // Rule ID 2130 //
     /*  11253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11281 */     // MIs[1] imm
     /*  11281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11289 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11293 */     // MIs[2] Operand 1
     /*  11293 */     // No operand predicates
     /*  11293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11299 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11313 */     GIR_RootConstrainSelectedInstOperands,
     /*  11314 */     // GIR_Coverage, 2130,
     /*  11314 */     GIR_EraseRootFromParent_Done,
     /*  11315 */   // Label 257: @11315
     /*  11315 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11363), // Rule ID 13239 //
     /*  11320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11350 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11361 */     GIR_RootConstrainSelectedInstOperands,
     /*  11362 */     // GIR_Coverage, 13239,
     /*  11362 */     GIR_EraseRootFromParent_Done,
     /*  11363 */   // Label 258: @11363
     /*  11363 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11411), // Rule ID 13251 //
     /*  11368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11398 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11409 */     GIR_RootConstrainSelectedInstOperands,
     /*  11410 */     // GIR_Coverage, 13251,
     /*  11410 */     GIR_EraseRootFromParent_Done,
     /*  11411 */   // Label 259: @11411
     /*  11411 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11459), // Rule ID 996 //
     /*  11416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11446 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11457 */     GIR_RootConstrainSelectedInstOperands,
     /*  11458 */     // GIR_Coverage, 996,
     /*  11458 */     GIR_EraseRootFromParent_Done,
     /*  11459 */   // Label 260: @11459
     /*  11459 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11507), // Rule ID 1057 //
     /*  11464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11494 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11505 */     GIR_RootConstrainSelectedInstOperands,
     /*  11506 */     // GIR_Coverage, 1057,
     /*  11506 */     GIR_EraseRootFromParent_Done,
     /*  11507 */   // Label 261: @11507
     /*  11507 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11531), // Rule ID 94 //
     /*  11512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11524 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11524 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11529 */     GIR_RootConstrainSelectedInstOperands,
     /*  11530 */     // GIR_Coverage, 94,
     /*  11530 */     GIR_Done,
     /*  11531 */   // Label 262: @11531
     /*  11531 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11558), // Rule ID 1607 //
     /*  11536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11551 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11551 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11556 */     GIR_RootConstrainSelectedInstOperands,
     /*  11557 */     // GIR_Coverage, 1607,
     /*  11557 */     GIR_Done,
     /*  11558 */   // Label 263: @11558
     /*  11558 */   GIM_Reject,
     /*  11559 */ // Label 198: @11559
     /*  11559 */ GIM_Reject,
     /*  11560 */ // Label 160: @11560
     /*  11560 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(15167),
     /*  11565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11571 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(11759), // Rule ID 6897 //
     /*  11576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11613 */     // MIs[2] Operand 2
     /*  11613 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11632 */     // MIs[3] Rn
     /*  11632 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11637 */     // MIs[3] Operand 2
     /*  11637 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11656 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11660 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11664 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11668 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11672 */     // MIs[5] Rn
     /*  11672 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11677 */     // MIs[5] Operand 2
     /*  11677 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11692 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11696 */     // MIs[6] Rn
     /*  11696 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11701 */     // MIs[6] Operand 2
     /*  11701 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11712 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11714 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11758 */     // GIR_Coverage, 6897,
     /*  11758 */     GIR_EraseRootFromParent_Done,
     /*  11759 */   // Label 265: @11759
     /*  11759 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(11947), // Rule ID 13862 //
     /*  11764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11801 */     // MIs[2] Operand 2
     /*  11801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11820 */     // MIs[3] Rn
     /*  11820 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11825 */     // MIs[3] Operand 2
     /*  11825 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11840 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11844 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11848 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11852 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11856 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11860 */     // MIs[5] Rn
     /*  11860 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11865 */     // MIs[5] Operand 2
     /*  11865 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11876 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11880 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11884 */     // MIs[6] Rn
     /*  11884 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11889 */     // MIs[6] Operand 2
     /*  11889 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11900 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11902 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11929 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11946 */     // GIR_Coverage, 13862,
     /*  11946 */     GIR_EraseRootFromParent_Done,
     /*  11947 */   // Label 266: @11947
     /*  11947 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12083), // Rule ID 5358 //
     /*  11952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11985 */     // MIs[1] Operand 2
     /*  11985 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  11996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12016 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12025 */     // MIs[3] Operand 2
     /*  12025 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12038 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12065 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12082 */     // GIR_Coverage, 5358,
     /*  12082 */     GIR_EraseRootFromParent_Done,
     /*  12083 */   // Label 267: @12083
     /*  12083 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12219), // Rule ID 5357 //
     /*  12088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12121 */     // MIs[1] Operand 2
     /*  12121 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12140 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12152 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12156 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12161 */     // MIs[3] Operand 2
     /*  12161 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12172 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12174 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12218 */     // GIR_Coverage, 5357,
     /*  12218 */     GIR_EraseRootFromParent_Done,
     /*  12219 */   // Label 268: @12219
     /*  12219 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12355), // Rule ID 5370 //
     /*  12224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12257 */     // MIs[1] Operand 2
     /*  12257 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12276 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12284 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12288 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12292 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12297 */     // MIs[3] Operand 2
     /*  12297 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12308 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12310 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12337 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12354 */     // GIR_Coverage, 5370,
     /*  12354 */     GIR_EraseRootFromParent_Done,
     /*  12355 */   // Label 269: @12355
     /*  12355 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12491), // Rule ID 5356 //
     /*  12360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12393 */     // MIs[1] Operand 2
     /*  12393 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12420 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12424 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12428 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12433 */     // MIs[3] Operand 2
     /*  12433 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12444 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12446 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12473 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12490 */     // GIR_Coverage, 5356,
     /*  12490 */     GIR_EraseRootFromParent_Done,
     /*  12491 */   // Label 270: @12491
     /*  12491 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12627), // Rule ID 5355 //
     /*  12496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12529 */     // MIs[1] Operand 2
     /*  12529 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12556 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12560 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12564 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12569 */     // MIs[3] Operand 2
     /*  12569 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12582 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12609 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12626 */     // GIR_Coverage, 5355,
     /*  12626 */     GIR_EraseRootFromParent_Done,
     /*  12627 */   // Label 271: @12627
     /*  12627 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12790), // Rule ID 13822 //
     /*  12632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12669 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12674 */     // MIs[1] Operand 2
     /*  12674 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12691 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12691 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12694 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12698 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12717 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12720 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12724 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12754 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12761 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12772 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12784 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12789 */     // GIR_Coverage, 13822,
     /*  12789 */     GIR_EraseRootFromParent_Done,
     /*  12790 */   // Label 272: @12790
     /*  12790 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12953), // Rule ID 13819 //
     /*  12795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12837 */     // MIs[1] Operand 2
     /*  12837 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12854 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12854 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12857 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12861 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12868 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12871 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12875 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12880 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12883 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12887 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12890 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12917 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12952 */     // GIR_Coverage, 13819,
     /*  12952 */     GIR_EraseRootFromParent_Done,
     /*  12953 */   // Label 273: @12953
     /*  12953 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13103), // Rule ID 13827 //
     /*  12958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12991 */     // MIs[1] Operand 2
     /*  12991 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13008 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13008 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13011 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13015 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13034 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13037 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13041 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13054 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13074 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13085 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13102 */     // GIR_Coverage, 13827,
     /*  13102 */     GIR_EraseRootFromParent_Done,
     /*  13103 */   // Label 274: @13103
     /*  13103 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13253), // Rule ID 13831 //
     /*  13108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13141 */     // MIs[1] Operand 2
     /*  13141 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13158 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13158 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13161 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13165 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13184 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13187 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13191 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13221 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13235 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13252 */     // GIR_Coverage, 13831,
     /*  13252 */     GIR_EraseRootFromParent_Done,
     /*  13253 */   // Label 275: @13253
     /*  13253 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13403), // Rule ID 13826 //
     /*  13258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13291 */     // MIs[1] Operand 2
     /*  13291 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13308 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13308 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13311 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13315 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13334 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13337 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13341 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13349 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13385 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13402 */     // GIR_Coverage, 13826,
     /*  13402 */     GIR_EraseRootFromParent_Done,
     /*  13403 */   // Label 276: @13403
     /*  13403 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13566), // Rule ID 5343 //
     /*  13408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13454 */     // MIs[1] Operand 2
     /*  13454 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13467 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13467 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13470 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13474 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13481 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13484 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13488 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13493 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13496 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13500 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13503 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13508 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13513 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13530 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13548 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13565 */     // GIR_Coverage, 5343,
     /*  13565 */     GIR_EraseRootFromParent_Done,
     /*  13566 */   // Label 277: @13566
     /*  13566 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13729), // Rule ID 5340 //
     /*  13571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13617 */     // MIs[1] Operand 2
     /*  13617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13630 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13644 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13647 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13651 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13656 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13663 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13671 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13711 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13728 */     // GIR_Coverage, 5340,
     /*  13728 */     GIR_EraseRootFromParent_Done,
     /*  13729 */   // Label 278: @13729
     /*  13729 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13879), // Rule ID 5366 //
     /*  13734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13771 */     // MIs[1] Operand 2
     /*  13771 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13784 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13784 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13787 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13791 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13798 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13801 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13805 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13810 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13813 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13817 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13820 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13878 */     // GIR_Coverage, 5366,
     /*  13878 */     GIR_EraseRootFromParent_Done,
     /*  13879 */   // Label 279: @13879
     /*  13879 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14029), // Rule ID 5373 //
     /*  13884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13921 */     // MIs[1] Operand 2
     /*  13921 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13934 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13934 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13937 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13941 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13948 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13951 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13955 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13960 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13963 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13967 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13970 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13975 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13997 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14011 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14028 */     // GIR_Coverage, 5373,
     /*  14028 */     GIR_EraseRootFromParent_Done,
     /*  14029 */   // Label 280: @14029
     /*  14029 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14179), // Rule ID 5365 //
     /*  14034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14071 */     // MIs[1] Operand 2
     /*  14071 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14084 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14084 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14087 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14091 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14110 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14113 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14120 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14125 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14147 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14178 */     // GIR_Coverage, 5365,
     /*  14178 */     GIR_EraseRootFromParent_Done,
     /*  14179 */   // Label 281: @14179
     /*  14179 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14248), // Rule ID 13274 //
     /*  14184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14199 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14202 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14211 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14231 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14246 */     GIR_RootConstrainSelectedInstOperands,
     /*  14247 */     // GIR_Coverage, 13274,
     /*  14247 */     GIR_EraseRootFromParent_Done,
     /*  14248 */   // Label 282: @14248
     /*  14248 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14317), // Rule ID 13286 //
     /*  14253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14268 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14271 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14280 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14300 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 13286,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 283: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14373), // Rule ID 13236 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14337 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14340 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14360 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14371 */     GIR_RootConstrainSelectedInstOperands,
     /*  14372 */     // GIR_Coverage, 13236,
     /*  14372 */     GIR_EraseRootFromParent_Done,
     /*  14373 */   // Label 284: @14373
     /*  14373 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14429), // Rule ID 13248 //
     /*  14378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14416 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14427 */     GIR_RootConstrainSelectedInstOperands,
     /*  14428 */     // GIR_Coverage, 13248,
     /*  14428 */     GIR_EraseRootFromParent_Done,
     /*  14429 */   // Label 285: @14429
     /*  14429 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14496), // Rule ID 13478 //
     /*  14434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14458 */     // MIs[1] imm
     /*  14458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14466 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14470 */     // MIs[2] Operand 1
     /*  14470 */     // No operand predicates
     /*  14470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14480 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14494 */     GIR_RootConstrainSelectedInstOperands,
     /*  14495 */     // GIR_Coverage, 13478,
     /*  14495 */     GIR_EraseRootFromParent_Done,
     /*  14496 */   // Label 286: @14496
     /*  14496 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14563), // Rule ID 13499 //
     /*  14501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14525 */     // MIs[1] imm
     /*  14525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14537 */     // MIs[2] Operand 1
     /*  14537 */     // No operand predicates
     /*  14537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14547 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14561 */     GIR_RootConstrainSelectedInstOperands,
     /*  14562 */     // GIR_Coverage, 13499,
     /*  14562 */     GIR_EraseRootFromParent_Done,
     /*  14563 */   // Label 287: @14563
     /*  14563 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14632), // Rule ID 1365 //
     /*  14568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14587 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14590 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14615 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14630 */     GIR_RootConstrainSelectedInstOperands,
     /*  14631 */     // GIR_Coverage, 1365,
     /*  14631 */     GIR_EraseRootFromParent_Done,
     /*  14632 */   // Label 288: @14632
     /*  14632 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14701), // Rule ID 1488 //
     /*  14637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14656 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14659 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14668 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14684 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14699 */     GIR_RootConstrainSelectedInstOperands,
     /*  14700 */     // GIR_Coverage, 1488,
     /*  14700 */     GIR_EraseRootFromParent_Done,
     /*  14701 */   // Label 289: @14701
     /*  14701 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14757), // Rule ID 993 //
     /*  14706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14725 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14728 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14744 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14755 */     GIR_RootConstrainSelectedInstOperands,
     /*  14756 */     // GIR_Coverage, 993,
     /*  14756 */     GIR_EraseRootFromParent_Done,
     /*  14757 */   // Label 290: @14757
     /*  14757 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14813), // Rule ID 1054 //
     /*  14762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14800 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14811 */     GIR_RootConstrainSelectedInstOperands,
     /*  14812 */     // GIR_Coverage, 1054,
     /*  14812 */     GIR_EraseRootFromParent_Done,
     /*  14813 */   // Label 291: @14813
     /*  14813 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14880), // Rule ID 2238 //
     /*  14818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14846 */     // MIs[1] imm
     /*  14846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14858 */     // MIs[2] Operand 1
     /*  14858 */     // No operand predicates
     /*  14858 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14864 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14878 */     GIR_RootConstrainSelectedInstOperands,
     /*  14879 */     // GIR_Coverage, 2238,
     /*  14879 */     GIR_EraseRootFromParent_Done,
     /*  14880 */   // Label 292: @14880
     /*  14880 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14947), // Rule ID 2297 //
     /*  14885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14913 */     // MIs[1] imm
     /*  14913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14921 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14925 */     // MIs[2] Operand 1
     /*  14925 */     // No operand predicates
     /*  14925 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14931 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14945 */     GIR_RootConstrainSelectedInstOperands,
     /*  14946 */     // GIR_Coverage, 2297,
     /*  14946 */     GIR_EraseRootFromParent_Done,
     /*  14947 */   // Label 293: @14947
     /*  14947 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(14995), // Rule ID 13235 //
     /*  14952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  14967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14982 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14993 */     GIR_RootConstrainSelectedInstOperands,
     /*  14994 */     // GIR_Coverage, 13235,
     /*  14994 */     GIR_EraseRootFromParent_Done,
     /*  14995 */   // Label 294: @14995
     /*  14995 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15043), // Rule ID 13247 //
     /*  15000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15030 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15041 */     GIR_RootConstrainSelectedInstOperands,
     /*  15042 */     // GIR_Coverage, 13247,
     /*  15042 */     GIR_EraseRootFromParent_Done,
     /*  15043 */   // Label 295: @15043
     /*  15043 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15091), // Rule ID 992 //
     /*  15048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15078 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15089 */     GIR_RootConstrainSelectedInstOperands,
     /*  15090 */     // GIR_Coverage, 992,
     /*  15090 */     GIR_EraseRootFromParent_Done,
     /*  15091 */   // Label 296: @15091
     /*  15091 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15139), // Rule ID 1053 //
     /*  15096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15126 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15137 */     GIR_RootConstrainSelectedInstOperands,
     /*  15138 */     // GIR_Coverage, 1053,
     /*  15138 */     GIR_EraseRootFromParent_Done,
     /*  15139 */   // Label 297: @15139
     /*  15139 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15166), // Rule ID 1104 //
     /*  15144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15159 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15164 */     GIR_RootConstrainSelectedInstOperands,
     /*  15165 */     // GIR_Coverage, 1104,
     /*  15165 */     GIR_Done,
     /*  15166 */   // Label 298: @15166
     /*  15166 */   GIM_Reject,
     /*  15167 */ // Label 264: @15167
     /*  15167 */ GIM_Reject,
     /*  15168 */ // Label 161: @15168
     /*  15168 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(21069),
     /*  15173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15179 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15297), // Rule ID 13413 //
     /*  15184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15227 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15231 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15235 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15240 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15244 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15248 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15252 */     // MIs[4] Operand 1
     /*  15252 */     // No operand predicates
     /*  15252 */     // MIs[2] Operand 2
     /*  15252 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15276 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15295 */     GIR_RootConstrainSelectedInstOperands,
     /*  15296 */     // GIR_Coverage, 13413,
     /*  15296 */     GIR_EraseRootFromParent_Done,
     /*  15297 */   // Label 300: @15297
     /*  15297 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15415), // Rule ID 13414 //
     /*  15302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15349 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15353 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15358 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15362 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15366 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15370 */     // MIs[4] Operand 1
     /*  15370 */     // No operand predicates
     /*  15370 */     // MIs[2] Operand 2
     /*  15370 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15385 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15394 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15413 */     GIR_RootConstrainSelectedInstOperands,
     /*  15414 */     // GIR_Coverage, 13414,
     /*  15414 */     GIR_EraseRootFromParent_Done,
     /*  15415 */   // Label 301: @15415
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15533), // Rule ID 13443 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15467 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15471 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15480 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15484 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15488 */     // MIs[4] Operand 1
     /*  15488 */     // No operand predicates
     /*  15488 */     // MIs[2] Operand 2
     /*  15488 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15503 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15512 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15531 */     GIR_RootConstrainSelectedInstOperands,
     /*  15532 */     // GIR_Coverage, 13443,
     /*  15532 */     GIR_EraseRootFromParent_Done,
     /*  15533 */   // Label 302: @15533
     /*  15533 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15651), // Rule ID 13444 //
     /*  15538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15585 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15589 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15598 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15602 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15606 */     // MIs[4] Operand 1
     /*  15606 */     // No operand predicates
     /*  15606 */     // MIs[2] Operand 2
     /*  15606 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15621 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15630 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15649 */     GIR_RootConstrainSelectedInstOperands,
     /*  15650 */     // GIR_Coverage, 13444,
     /*  15650 */     GIR_EraseRootFromParent_Done,
     /*  15651 */   // Label 303: @15651
     /*  15651 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15769), // Rule ID 2042 //
     /*  15656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15703 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15707 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15724 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15728 */     // MIs[4] Operand 1
     /*  15728 */     // No operand predicates
     /*  15728 */     // MIs[2] Operand 2
     /*  15728 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15748 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15767 */     GIR_RootConstrainSelectedInstOperands,
     /*  15768 */     // GIR_Coverage, 2042,
     /*  15768 */     GIR_EraseRootFromParent_Done,
     /*  15769 */   // Label 304: @15769
     /*  15769 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15887), // Rule ID 13412 //
     /*  15774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15825 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15829 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15838 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15842 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15846 */     // MIs[4] Operand 1
     /*  15846 */     // No operand predicates
     /*  15846 */     // MIs[2] Operand 2
     /*  15846 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15857 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15859 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15866 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15885 */     GIR_RootConstrainSelectedInstOperands,
     /*  15886 */     // GIR_Coverage, 13412,
     /*  15886 */     GIR_EraseRootFromParent_Done,
     /*  15887 */   // Label 305: @15887
     /*  15887 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16005), // Rule ID 2094 //
     /*  15892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15939 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15943 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15947 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15956 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15960 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15964 */     // MIs[4] Operand 1
     /*  15964 */     // No operand predicates
     /*  15964 */     // MIs[2] Operand 2
     /*  15964 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15975 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15984 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16003 */     GIR_RootConstrainSelectedInstOperands,
     /*  16004 */     // GIR_Coverage, 2094,
     /*  16004 */     GIR_EraseRootFromParent_Done,
     /*  16005 */   // Label 306: @16005
     /*  16005 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16123), // Rule ID 13442 //
     /*  16010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16057 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16061 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16065 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16070 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16074 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16078 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16082 */     // MIs[4] Operand 1
     /*  16082 */     // No operand predicates
     /*  16082 */     // MIs[2] Operand 2
     /*  16082 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16093 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16102 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16121 */     GIR_RootConstrainSelectedInstOperands,
     /*  16122 */     // GIR_Coverage, 13442,
     /*  16122 */     GIR_EraseRootFromParent_Done,
     /*  16123 */   // Label 307: @16123
     /*  16123 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16210), // Rule ID 13318 //
     /*  16128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16155 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16158 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16167 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16177 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16191 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16208 */     GIR_RootConstrainSelectedInstOperands,
     /*  16209 */     // GIR_Coverage, 13318,
     /*  16209 */     GIR_EraseRootFromParent_Done,
     /*  16210 */   // Label 308: @16210
     /*  16210 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16297), // Rule ID 13342 //
     /*  16215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16242 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16245 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16254 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16278 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16295 */     GIR_RootConstrainSelectedInstOperands,
     /*  16296 */     // GIR_Coverage, 13342,
     /*  16296 */     GIR_EraseRootFromParent_Done,
     /*  16297 */   // Label 309: @16297
     /*  16297 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16384), // Rule ID 1699 //
     /*  16302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16333 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16336 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16345 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16351 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16358 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16365 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16382 */     GIR_RootConstrainSelectedInstOperands,
     /*  16383 */     // GIR_Coverage, 1699,
     /*  16383 */     GIR_EraseRootFromParent_Done,
     /*  16384 */   // Label 310: @16384
     /*  16384 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16471), // Rule ID 1777 //
     /*  16389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16420 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16423 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16432 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16452 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16469 */     GIR_RootConstrainSelectedInstOperands,
     /*  16470 */     // GIR_Coverage, 1777,
     /*  16470 */     GIR_EraseRootFromParent_Done,
     /*  16471 */   // Label 311: @16471
     /*  16471 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16586), // Rule ID 13408 //
     /*  16476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16540 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16544 */     // MIs[4] Operand 1
     /*  16544 */     // No operand predicates
     /*  16544 */     // MIs[2] Operand 2
     /*  16544 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16564 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16566 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16584 */     GIR_RootConstrainSelectedInstOperands,
     /*  16585 */     // GIR_Coverage, 13408,
     /*  16585 */     GIR_EraseRootFromParent_Done,
     /*  16586 */   // Label 312: @16586
     /*  16586 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16701), // Rule ID 13407 //
     /*  16591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16635 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16639 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16643 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16656 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16660 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16664 */     // MIs[4] Operand 1
     /*  16664 */     // No operand predicates
     /*  16664 */     // MIs[2] Operand 2
     /*  16664 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16679 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16681 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16699 */     GIR_RootConstrainSelectedInstOperands,
     /*  16700 */     // GIR_Coverage, 13407,
     /*  16700 */     GIR_EraseRootFromParent_Done,
     /*  16701 */   // Label 313: @16701
     /*  16701 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16816), // Rule ID 13438 //
     /*  16706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16757 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16766 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16770 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16774 */     // MIs[4] Operand 1
     /*  16774 */     // No operand predicates
     /*  16774 */     // MIs[2] Operand 2
     /*  16774 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16796 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16814 */     GIR_RootConstrainSelectedInstOperands,
     /*  16815 */     // GIR_Coverage, 13438,
     /*  16815 */     GIR_EraseRootFromParent_Done,
     /*  16816 */   // Label 314: @16816
     /*  16816 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16931), // Rule ID 13437 //
     /*  16821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16861 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16865 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16869 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16873 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16877 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16882 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16886 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16890 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16894 */     // MIs[4] Operand 1
     /*  16894 */     // No operand predicates
     /*  16894 */     // MIs[2] Operand 2
     /*  16894 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16909 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16911 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16929 */     GIR_RootConstrainSelectedInstOperands,
     /*  16930 */     // GIR_Coverage, 13437,
     /*  16930 */     GIR_EraseRootFromParent_Done,
     /*  16931 */   // Label 315: @16931
     /*  16931 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17000), // Rule ID 1801 //
     /*  16936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  16951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  16963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16983 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  16986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16998 */     GIR_RootConstrainSelectedInstOperands,
     /*  16999 */     // GIR_Coverage, 1801,
     /*  16999 */     GIR_EraseRootFromParent_Done,
     /*  17000 */   // Label 316: @17000
     /*  17000 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17069), // Rule ID 1800 //
     /*  17005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17045 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17052 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17067 */     GIR_RootConstrainSelectedInstOperands,
     /*  17068 */     // GIR_Coverage, 1800,
     /*  17068 */     GIR_EraseRootFromParent_Done,
     /*  17069 */   // Label 317: @17069
     /*  17069 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17138), // Rule ID 1717 //
     /*  17074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17121 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17136 */     GIR_RootConstrainSelectedInstOperands,
     /*  17137 */     // GIR_Coverage, 1717,
     /*  17137 */     GIR_EraseRootFromParent_Done,
     /*  17138 */   // Label 318: @17138
     /*  17138 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17207), // Rule ID 1799 //
     /*  17143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17190 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17205 */     GIR_RootConstrainSelectedInstOperands,
     /*  17206 */     // GIR_Coverage, 1799,
     /*  17206 */     GIR_EraseRootFromParent_Done,
     /*  17207 */   // Label 319: @17207
     /*  17207 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17276), // Rule ID 1798 //
     /*  17212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17259 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17274 */     GIR_RootConstrainSelectedInstOperands,
     /*  17275 */     // GIR_Coverage, 1798,
     /*  17275 */     GIR_EraseRootFromParent_Done,
     /*  17276 */   // Label 320: @17276
     /*  17276 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17391), // Rule ID 13406 //
     /*  17281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17332 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17336 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17341 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17345 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17349 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17353 */     // MIs[4] Operand 1
     /*  17353 */     // No operand predicates
     /*  17353 */     // MIs[2] Operand 2
     /*  17353 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17369 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17371 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17389 */     GIR_RootConstrainSelectedInstOperands,
     /*  17390 */     // GIR_Coverage, 13406,
     /*  17390 */     GIR_EraseRootFromParent_Done,
     /*  17391 */   // Label 321: @17391
     /*  17391 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17506), // Rule ID 2040 //
     /*  17396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17452 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17456 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17469 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17473 */     // MIs[4] Operand 1
     /*  17473 */     // No operand predicates
     /*  17473 */     // MIs[2] Operand 2
     /*  17473 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17486 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17504 */     GIR_RootConstrainSelectedInstOperands,
     /*  17505 */     // GIR_Coverage, 2040,
     /*  17505 */     GIR_EraseRootFromParent_Done,
     /*  17506 */   // Label 322: @17506
     /*  17506 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17621), // Rule ID 13436 //
     /*  17511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17562 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17566 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17571 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17575 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17579 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17583 */     // MIs[4] Operand 1
     /*  17583 */     // No operand predicates
     /*  17583 */     // MIs[2] Operand 2
     /*  17583 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17599 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17601 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17619 */     GIR_RootConstrainSelectedInstOperands,
     /*  17620 */     // GIR_Coverage, 13436,
     /*  17620 */     GIR_EraseRootFromParent_Done,
     /*  17621 */   // Label 323: @17621
     /*  17621 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17736), // Rule ID 2092 //
     /*  17626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17682 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17686 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17691 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17695 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17699 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17703 */     // MIs[4] Operand 1
     /*  17703 */     // No operand predicates
     /*  17703 */     // MIs[2] Operand 2
     /*  17703 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17714 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17716 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17734 */     GIR_RootConstrainSelectedInstOperands,
     /*  17735 */     // GIR_Coverage, 2092,
     /*  17735 */     GIR_EraseRootFromParent_Done,
     /*  17736 */   // Label 324: @17736
     /*  17736 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17803), // Rule ID 13330 //
     /*  17741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17784 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17801 */     GIR_RootConstrainSelectedInstOperands,
     /*  17802 */     // GIR_Coverage, 13330,
     /*  17802 */     GIR_EraseRootFromParent_Done,
     /*  17803 */   // Label 325: @17803
     /*  17803 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17870), // Rule ID 13360 //
     /*  17808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17837 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17851 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17868 */     GIR_RootConstrainSelectedInstOperands,
     /*  17869 */     // GIR_Coverage, 13360,
     /*  17869 */     GIR_EraseRootFromParent_Done,
     /*  17870 */   // Label 326: @17870
     /*  17870 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17937), // Rule ID 1729 //
     /*  17875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17918 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17935 */     GIR_RootConstrainSelectedInstOperands,
     /*  17936 */     // GIR_Coverage, 1729,
     /*  17936 */     GIR_EraseRootFromParent_Done,
     /*  17937 */   // Label 327: @17937
     /*  17937 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18004), // Rule ID 1819 //
     /*  17942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17971 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17985 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18002 */     GIR_RootConstrainSelectedInstOperands,
     /*  18003 */     // GIR_Coverage, 1819,
     /*  18003 */     GIR_EraseRootFromParent_Done,
     /*  18004 */   // Label 328: @18004
     /*  18004 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18085), // Rule ID 13316 //
     /*  18009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18036 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18039 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18048 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18068 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18083 */     GIR_RootConstrainSelectedInstOperands,
     /*  18084 */     // GIR_Coverage, 13316,
     /*  18084 */     GIR_EraseRootFromParent_Done,
     /*  18085 */   // Label 329: @18085
     /*  18085 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18166), // Rule ID 13340 //
     /*  18090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18117 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18120 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18125 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18129 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18149 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18164 */     GIR_RootConstrainSelectedInstOperands,
     /*  18165 */     // GIR_Coverage, 13340,
     /*  18165 */     GIR_EraseRootFromParent_Done,
     /*  18166 */   // Label 330: @18166
     /*  18166 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18247), // Rule ID 1697 //
     /*  18171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18202 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18205 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18210 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18214 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18230 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18245 */     GIR_RootConstrainSelectedInstOperands,
     /*  18246 */     // GIR_Coverage, 1697,
     /*  18246 */     GIR_EraseRootFromParent_Done,
     /*  18247 */   // Label 331: @18247
     /*  18247 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18328), // Rule ID 1775 //
     /*  18252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18283 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18286 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18295 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18311 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18326 */     GIR_RootConstrainSelectedInstOperands,
     /*  18327 */     // GIR_Coverage, 1775,
     /*  18327 */     GIR_EraseRootFromParent_Done,
     /*  18328 */   // Label 332: @18328
     /*  18328 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18420), // Rule ID 13411 //
     /*  18333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18389 */     // MIs[3] Operand 1
     /*  18389 */     // No operand predicates
     /*  18389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18398 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18400 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18418 */     GIR_RootConstrainSelectedInstOperands,
     /*  18419 */     // GIR_Coverage, 13411,
     /*  18419 */     GIR_EraseRootFromParent_Done,
     /*  18420 */   // Label 333: @18420
     /*  18420 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18512), // Rule ID 13410 //
     /*  18425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18482 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18486 */     // MIs[3] Operand 1
     /*  18486 */     // No operand predicates
     /*  18486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18492 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18510 */     GIR_RootConstrainSelectedInstOperands,
     /*  18511 */     // GIR_Coverage, 13410,
     /*  18511 */     GIR_EraseRootFromParent_Done,
     /*  18512 */   // Label 334: @18512
     /*  18512 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18604), // Rule ID 13441 //
     /*  18517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18573 */     // MIs[3] Operand 1
     /*  18573 */     // No operand predicates
     /*  18573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18584 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18602 */     GIR_RootConstrainSelectedInstOperands,
     /*  18603 */     // GIR_Coverage, 13441,
     /*  18603 */     GIR_EraseRootFromParent_Done,
     /*  18604 */   // Label 335: @18604
     /*  18604 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(18696), // Rule ID 13440 //
     /*  18609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18666 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18670 */     // MIs[3] Operand 1
     /*  18670 */     // No operand predicates
     /*  18670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18676 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18694 */     GIR_RootConstrainSelectedInstOperands,
     /*  18695 */     // GIR_Coverage, 13440,
     /*  18695 */     GIR_EraseRootFromParent_Done,
     /*  18696 */   // Label 336: @18696
     /*  18696 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18788), // Rule ID 13409 //
     /*  18701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18757 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18761 */     // MIs[3] Operand 1
     /*  18761 */     // No operand predicates
     /*  18761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18768 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18786 */     GIR_RootConstrainSelectedInstOperands,
     /*  18787 */     // GIR_Coverage, 13409,
     /*  18787 */     GIR_EraseRootFromParent_Done,
     /*  18788 */   // Label 337: @18788
     /*  18788 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18880), // Rule ID 2041 //
     /*  18793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18854 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18858 */     // MIs[3] Operand 1
     /*  18858 */     // No operand predicates
     /*  18858 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18860 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18878 */     GIR_RootConstrainSelectedInstOperands,
     /*  18879 */     // GIR_Coverage, 2041,
     /*  18879 */     GIR_EraseRootFromParent_Done,
     /*  18880 */   // Label 338: @18880
     /*  18880 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18972), // Rule ID 13439 //
     /*  18885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18924 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18941 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18945 */     // MIs[3] Operand 1
     /*  18945 */     // No operand predicates
     /*  18945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18952 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18970 */     GIR_RootConstrainSelectedInstOperands,
     /*  18971 */     // GIR_Coverage, 13439,
     /*  18971 */     GIR_EraseRootFromParent_Done,
     /*  18972 */   // Label 339: @18972
     /*  18972 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19064), // Rule ID 2093 //
     /*  18977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19038 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19042 */     // MIs[3] Operand 1
     /*  19042 */     // No operand predicates
     /*  19042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19044 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19062 */     GIR_RootConstrainSelectedInstOperands,
     /*  19063 */     // GIR_Coverage, 2093,
     /*  19063 */     GIR_EraseRootFromParent_Done,
     /*  19064 */   // Label 340: @19064
     /*  19064 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19115), // Rule ID 13354 //
     /*  19069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19101 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19113 */     GIR_RootConstrainSelectedInstOperands,
     /*  19114 */     // GIR_Coverage, 13354,
     /*  19114 */     GIR_EraseRootFromParent_Done,
     /*  19115 */   // Label 341: @19115
     /*  19115 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19166), // Rule ID 13324 //
     /*  19120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19152 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19164 */     GIR_RootConstrainSelectedInstOperands,
     /*  19165 */     // GIR_Coverage, 13324,
     /*  19165 */     GIR_EraseRootFromParent_Done,
     /*  19166 */   // Label 342: @19166
     /*  19166 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19217), // Rule ID 13353 //
     /*  19171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19203 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19215 */     GIR_RootConstrainSelectedInstOperands,
     /*  19216 */     // GIR_Coverage, 13353,
     /*  19216 */     GIR_EraseRootFromParent_Done,
     /*  19217 */   // Label 343: @19217
     /*  19217 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19268), // Rule ID 1813 //
     /*  19222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19254 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19266 */     GIR_RootConstrainSelectedInstOperands,
     /*  19267 */     // GIR_Coverage, 1813,
     /*  19267 */     GIR_EraseRootFromParent_Done,
     /*  19268 */   // Label 344: @19268
     /*  19268 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19319), // Rule ID 1723 //
     /*  19273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19305 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19317 */     GIR_RootConstrainSelectedInstOperands,
     /*  19318 */     // GIR_Coverage, 1723,
     /*  19318 */     GIR_EraseRootFromParent_Done,
     /*  19319 */   // Label 345: @19319
     /*  19319 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19370), // Rule ID 1812 //
     /*  19324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19356 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19368 */     GIR_RootConstrainSelectedInstOperands,
     /*  19369 */     // GIR_Coverage, 1812,
     /*  19369 */     GIR_EraseRootFromParent_Done,
     /*  19370 */   // Label 346: @19370
     /*  19370 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19426), // Rule ID 13242 //
     /*  19375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19390 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19393 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19413 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19424 */     GIR_RootConstrainSelectedInstOperands,
     /*  19425 */     // GIR_Coverage, 13242,
     /*  19425 */     GIR_EraseRootFromParent_Done,
     /*  19426 */   // Label 347: @19426
     /*  19426 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19482), // Rule ID 13254 //
     /*  19431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19469 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19480 */     GIR_RootConstrainSelectedInstOperands,
     /*  19481 */     // GIR_Coverage, 13254,
     /*  19481 */     GIR_EraseRootFromParent_Done,
     /*  19482 */   // Label 348: @19482
     /*  19482 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19549), // Rule ID 13482 //
     /*  19487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19511 */     // MIs[1] imm
     /*  19511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19519 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19523 */     // MIs[2] Operand 1
     /*  19523 */     // No operand predicates
     /*  19523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19533 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19547 */     GIR_RootConstrainSelectedInstOperands,
     /*  19548 */     // GIR_Coverage, 13482,
     /*  19548 */     GIR_EraseRootFromParent_Done,
     /*  19549 */   // Label 349: @19549
     /*  19549 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19616), // Rule ID 13503 //
     /*  19554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19578 */     // MIs[1] imm
     /*  19578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19586 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19590 */     // MIs[2] Operand 1
     /*  19590 */     // No operand predicates
     /*  19590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19600 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19614 */     GIR_RootConstrainSelectedInstOperands,
     /*  19615 */     // GIR_Coverage, 13503,
     /*  19615 */     GIR_EraseRootFromParent_Done,
     /*  19616 */   // Label 350: @19616
     /*  19616 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19672), // Rule ID 999 //
     /*  19621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19640 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19643 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19659 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19670 */     GIR_RootConstrainSelectedInstOperands,
     /*  19671 */     // GIR_Coverage, 999,
     /*  19671 */     GIR_EraseRootFromParent_Done,
     /*  19672 */   // Label 351: @19672
     /*  19672 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19728), // Rule ID 1060 //
     /*  19677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19715 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19726 */     GIR_RootConstrainSelectedInstOperands,
     /*  19727 */     // GIR_Coverage, 1060,
     /*  19727 */     GIR_EraseRootFromParent_Done,
     /*  19728 */   // Label 352: @19728
     /*  19728 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(19795), // Rule ID 2242 //
     /*  19733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19761 */     // MIs[1] imm
     /*  19761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19769 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19773 */     // MIs[2] Operand 1
     /*  19773 */     // No operand predicates
     /*  19773 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19779 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19793 */     GIR_RootConstrainSelectedInstOperands,
     /*  19794 */     // GIR_Coverage, 2242,
     /*  19794 */     GIR_EraseRootFromParent_Done,
     /*  19795 */   // Label 353: @19795
     /*  19795 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19862), // Rule ID 2301 //
     /*  19800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19828 */     // MIs[1] imm
     /*  19828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19840 */     // MIs[2] Operand 1
     /*  19840 */     // No operand predicates
     /*  19840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19846 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19860 */     GIR_RootConstrainSelectedInstOperands,
     /*  19861 */     // GIR_Coverage, 2301,
     /*  19861 */     GIR_EraseRootFromParent_Done,
     /*  19862 */   // Label 354: @19862
     /*  19862 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19932), // Rule ID 6893 //
     /*  19867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19905 */     // MIs[2] Rn
     /*  19905 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19910 */     // MIs[2] Rm
     /*  19910 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19917 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 6893,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 355: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20002), // Rule ID 13858 //
     /*  19937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19975 */     // MIs[2] Rn
     /*  19975 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19980 */     // MIs[2] Rm
     /*  19980 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19987 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20000 */     GIR_RootConstrainSelectedInstOperands,
     /*  20001 */     // GIR_Coverage, 13858,
     /*  20001 */     GIR_EraseRootFromParent_Done,
     /*  20002 */   // Label 356: @20002
     /*  20002 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20065), // Rule ID 1797 //
     /*  20007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20050 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 1797,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 357: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20128), // Rule ID 1796 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20113 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20126 */     GIR_RootConstrainSelectedInstOperands,
     /*  20127 */     // GIR_Coverage, 1796,
     /*  20127 */     GIR_EraseRootFromParent_Done,
     /*  20128 */   // Label 358: @20128
     /*  20128 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20191), // Rule ID 1716 //
     /*  20133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20176 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20189 */     GIR_RootConstrainSelectedInstOperands,
     /*  20190 */     // GIR_Coverage, 1716,
     /*  20190 */     GIR_EraseRootFromParent_Done,
     /*  20191 */   // Label 359: @20191
     /*  20191 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20254), // Rule ID 1795 //
     /*  20196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20239 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20252 */     GIR_RootConstrainSelectedInstOperands,
     /*  20253 */     // GIR_Coverage, 1795,
     /*  20253 */     GIR_EraseRootFromParent_Done,
     /*  20254 */   // Label 360: @20254
     /*  20254 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20317), // Rule ID 1794 //
     /*  20259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20302 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20315 */     GIR_RootConstrainSelectedInstOperands,
     /*  20316 */     // GIR_Coverage, 1794,
     /*  20316 */     GIR_EraseRootFromParent_Done,
     /*  20317 */   // Label 361: @20317
     /*  20317 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20378), // Rule ID 13329 //
     /*  20322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20361 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20376 */     GIR_RootConstrainSelectedInstOperands,
     /*  20377 */     // GIR_Coverage, 13329,
     /*  20377 */     GIR_EraseRootFromParent_Done,
     /*  20378 */   // Label 362: @20378
     /*  20378 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20439), // Rule ID 13359 //
     /*  20383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20422 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20437 */     GIR_RootConstrainSelectedInstOperands,
     /*  20438 */     // GIR_Coverage, 13359,
     /*  20438 */     GIR_EraseRootFromParent_Done,
     /*  20439 */   // Label 363: @20439
     /*  20439 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20487), // Rule ID 13352 //
     /*  20444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20474 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20485 */     GIR_RootConstrainSelectedInstOperands,
     /*  20486 */     // GIR_Coverage, 13352,
     /*  20486 */     GIR_EraseRootFromParent_Done,
     /*  20487 */   // Label 364: @20487
     /*  20487 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20535), // Rule ID 13241 //
     /*  20492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20522 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20533 */     GIR_RootConstrainSelectedInstOperands,
     /*  20534 */     // GIR_Coverage, 13241,
     /*  20534 */     GIR_EraseRootFromParent_Done,
     /*  20535 */   // Label 365: @20535
     /*  20535 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20583), // Rule ID 13323 //
     /*  20540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20570 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20581 */     GIR_RootConstrainSelectedInstOperands,
     /*  20582 */     // GIR_Coverage, 13323,
     /*  20582 */     GIR_EraseRootFromParent_Done,
     /*  20583 */   // Label 366: @20583
     /*  20583 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20631), // Rule ID 13253 //
     /*  20588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20618 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20629 */     GIR_RootConstrainSelectedInstOperands,
     /*  20630 */     // GIR_Coverage, 13253,
     /*  20630 */     GIR_EraseRootFromParent_Done,
     /*  20631 */   // Label 367: @20631
     /*  20631 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20679), // Rule ID 13351 //
     /*  20636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20666 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20677 */     GIR_RootConstrainSelectedInstOperands,
     /*  20678 */     // GIR_Coverage, 13351,
     /*  20678 */     GIR_EraseRootFromParent_Done,
     /*  20679 */   // Label 368: @20679
     /*  20679 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20740), // Rule ID 1728 //
     /*  20684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20723 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20738 */     GIR_RootConstrainSelectedInstOperands,
     /*  20739 */     // GIR_Coverage, 1728,
     /*  20739 */     GIR_EraseRootFromParent_Done,
     /*  20740 */   // Label 369: @20740
     /*  20740 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20801), // Rule ID 1818 //
     /*  20745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20784 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20799 */     GIR_RootConstrainSelectedInstOperands,
     /*  20800 */     // GIR_Coverage, 1818,
     /*  20800 */     GIR_EraseRootFromParent_Done,
     /*  20801 */   // Label 370: @20801
     /*  20801 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20849), // Rule ID 1811 //
     /*  20806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20836 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20847 */     GIR_RootConstrainSelectedInstOperands,
     /*  20848 */     // GIR_Coverage, 1811,
     /*  20848 */     GIR_EraseRootFromParent_Done,
     /*  20849 */   // Label 371: @20849
     /*  20849 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20897), // Rule ID 998 //
     /*  20854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20884 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20895 */     GIR_RootConstrainSelectedInstOperands,
     /*  20896 */     // GIR_Coverage, 998,
     /*  20896 */     GIR_EraseRootFromParent_Done,
     /*  20897 */   // Label 372: @20897
     /*  20897 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20945), // Rule ID 1722 //
     /*  20902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20932 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20943 */     GIR_RootConstrainSelectedInstOperands,
     /*  20944 */     // GIR_Coverage, 1722,
     /*  20944 */     GIR_EraseRootFromParent_Done,
     /*  20945 */   // Label 373: @20945
     /*  20945 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(20993), // Rule ID 1059 //
     /*  20950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20980 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20991 */     GIR_RootConstrainSelectedInstOperands,
     /*  20992 */     // GIR_Coverage, 1059,
     /*  20992 */     GIR_EraseRootFromParent_Done,
     /*  20993 */   // Label 374: @20993
     /*  20993 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21041), // Rule ID 1810 //
     /*  20998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21028 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21039 */     GIR_RootConstrainSelectedInstOperands,
     /*  21040 */     // GIR_Coverage, 1810,
     /*  21040 */     GIR_EraseRootFromParent_Done,
     /*  21041 */   // Label 375: @21041
     /*  21041 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21068), // Rule ID 1106 //
     /*  21046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21061 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21066 */     GIR_RootConstrainSelectedInstOperands,
     /*  21067 */     // GIR_Coverage, 1106,
     /*  21067 */     GIR_Done,
     /*  21068 */   // Label 376: @21068
     /*  21068 */   GIM_Reject,
     /*  21069 */ // Label 299: @21069
     /*  21069 */ GIM_Reject,
     /*  21070 */ // Label 162: @21070
     /*  21070 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(24567),
     /*  21075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21081 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21217), // Rule ID 5354 //
     /*  21086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21119 */     // MIs[1] Operand 2
     /*  21119 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21146 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21150 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21154 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21159 */     // MIs[3] Operand 2
     /*  21159 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21172 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21216 */     // GIR_Coverage, 5354,
     /*  21216 */     GIR_EraseRootFromParent_Done,
     /*  21217 */   // Label 378: @21217
     /*  21217 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21353), // Rule ID 5353 //
     /*  21222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21255 */     // MIs[1] Operand 2
     /*  21255 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21278 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21282 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21286 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21290 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21295 */     // MIs[3] Operand 2
     /*  21295 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21306 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21308 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21335 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21352 */     // GIR_Coverage, 5353,
     /*  21352 */     GIR_EraseRootFromParent_Done,
     /*  21353 */   // Label 379: @21353
     /*  21353 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21489), // Rule ID 5369 //
     /*  21358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21391 */     // MIs[1] Operand 2
     /*  21391 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21422 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21426 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21431 */     // MIs[3] Operand 2
     /*  21431 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21442 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21444 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21460 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21471 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21478 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21488 */     // GIR_Coverage, 5369,
     /*  21488 */     GIR_EraseRootFromParent_Done,
     /*  21489 */   // Label 380: @21489
     /*  21489 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21625), // Rule ID 5352 //
     /*  21494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21527 */     // MIs[1] Operand 2
     /*  21527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21546 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21558 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21562 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21567 */     // MIs[3] Operand 2
     /*  21567 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21578 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21580 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21607 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21624 */     // GIR_Coverage, 5352,
     /*  21624 */     GIR_EraseRootFromParent_Done,
     /*  21625 */   // Label 381: @21625
     /*  21625 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21761), // Rule ID 5351 //
     /*  21630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21663 */     // MIs[1] Operand 2
     /*  21663 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21682 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21686 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21690 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21694 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21698 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21703 */     // MIs[3] Operand 2
     /*  21703 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21714 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21716 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21743 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21755 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21760 */     // GIR_Coverage, 5351,
     /*  21760 */     GIR_EraseRootFromParent_Done,
     /*  21761 */   // Label 382: @21761
     /*  21761 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(21894), // Rule ID 13863 //
     /*  21766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21803 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21807 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21811 */     // MIs[1] Operand 2
     /*  21811 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21826 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21830 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21834 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21838 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21842 */     // MIs[5] Rn
     /*  21842 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21847 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21849 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21893 */     // GIR_Coverage, 13863,
     /*  21893 */     GIR_EraseRootFromParent_Done,
     /*  21894 */   // Label 383: @21894
     /*  21894 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22027), // Rule ID 6898 //
     /*  21899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21940 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21944 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21948 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  21952 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21956 */     // MIs[4] Rn
     /*  21956 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21961 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21965 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21969 */     // MIs[3] Operand 2
     /*  21969 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21980 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21982 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22009 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22026 */     // GIR_Coverage, 6898,
     /*  22026 */     GIR_EraseRootFromParent_Done,
     /*  22027 */   // Label 384: @22027
     /*  22027 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22190), // Rule ID 13821 //
     /*  22032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22074 */     // MIs[1] Operand 2
     /*  22074 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22091 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22091 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22094 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22098 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22117 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22120 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22124 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22154 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22157 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22172 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22189 */     // GIR_Coverage, 13821,
     /*  22189 */     GIR_EraseRootFromParent_Done,
     /*  22190 */   // Label 385: @22190
     /*  22190 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22353), // Rule ID 13818 //
     /*  22195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22237 */     // MIs[1] Operand 2
     /*  22237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22254 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22254 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22257 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22261 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22280 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22287 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22290 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22295 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22335 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22352 */     // GIR_Coverage, 13818,
     /*  22352 */     GIR_EraseRootFromParent_Done,
     /*  22353 */   // Label 386: @22353
     /*  22353 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22503), // Rule ID 13825 //
     /*  22358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22391 */     // MIs[1] Operand 2
     /*  22391 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22408 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22408 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22411 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22415 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22434 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22437 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22441 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22454 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22485 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22502 */     // GIR_Coverage, 13825,
     /*  22502 */     GIR_EraseRootFromParent_Done,
     /*  22503 */   // Label 387: @22503
     /*  22503 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22653), // Rule ID 13830 //
     /*  22508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22541 */     // MIs[1] Operand 2
     /*  22541 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22558 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22584 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22635 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22652 */     // GIR_Coverage, 13830,
     /*  22652 */     GIR_EraseRootFromParent_Done,
     /*  22653 */   // Label 388: @22653
     /*  22653 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22803), // Rule ID 13824 //
     /*  22658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22691 */     // MIs[1] Operand 2
     /*  22691 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22708 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22734 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22802 */     // GIR_Coverage, 13824,
     /*  22802 */     GIR_EraseRootFromParent_Done,
     /*  22803 */   // Label 389: @22803
     /*  22803 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22966), // Rule ID 5342 //
     /*  22808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22854 */     // MIs[1] Operand 2
     /*  22854 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22867 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22867 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22870 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22874 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22893 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22896 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22900 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22908 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22948 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22965 */     // GIR_Coverage, 5342,
     /*  22965 */     GIR_EraseRootFromParent_Done,
     /*  22966 */   // Label 390: @22966
     /*  22966 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23129), // Rule ID 5339 //
     /*  22971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23017 */     // MIs[1] Operand 2
     /*  23017 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23030 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23030 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23033 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23037 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23056 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23063 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23076 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23093 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23111 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23128 */     // GIR_Coverage, 5339,
     /*  23128 */     GIR_EraseRootFromParent_Done,
     /*  23129 */   // Label 391: @23129
     /*  23129 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23279), // Rule ID 5364 //
     /*  23134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23171 */     // MIs[1] Operand 2
     /*  23171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23184 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23184 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23187 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23191 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23198 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23201 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23205 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23210 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23213 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23217 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23220 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23225 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23230 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23247 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23250 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23278 */     // GIR_Coverage, 5364,
     /*  23278 */     GIR_EraseRootFromParent_Done,
     /*  23279 */   // Label 392: @23279
     /*  23279 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23429), // Rule ID 5372 //
     /*  23284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23321 */     // MIs[1] Operand 2
     /*  23321 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23334 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23334 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23337 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23341 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23360 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23363 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23367 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23375 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23428 */     // GIR_Coverage, 5372,
     /*  23428 */     GIR_EraseRootFromParent_Done,
     /*  23429 */   // Label 393: @23429
     /*  23429 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23579), // Rule ID 5363 //
     /*  23434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23471 */     // MIs[1] Operand 2
     /*  23471 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23484 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23484 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23487 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23491 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23498 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23501 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23505 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23510 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23513 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23517 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23520 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23525 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23530 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23547 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23561 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23578 */     // GIR_Coverage, 5363,
     /*  23578 */     GIR_EraseRootFromParent_Done,
     /*  23579 */   // Label 394: @23579
     /*  23579 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23648), // Rule ID 13270 //
     /*  23584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23599 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23602 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23631 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23646 */     GIR_RootConstrainSelectedInstOperands,
     /*  23647 */     // GIR_Coverage, 13270,
     /*  23647 */     GIR_EraseRootFromParent_Done,
     /*  23648 */   // Label 395: @23648
     /*  23648 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23717), // Rule ID 13282 //
     /*  23653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23668 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23671 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23680 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23700 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23715 */     GIR_RootConstrainSelectedInstOperands,
     /*  23716 */     // GIR_Coverage, 13282,
     /*  23716 */     GIR_EraseRootFromParent_Done,
     /*  23717 */   // Label 396: @23717
     /*  23717 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(23773), // Rule ID 13232 //
     /*  23722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23737 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23740 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23760 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23771 */     GIR_RootConstrainSelectedInstOperands,
     /*  23772 */     // GIR_Coverage, 13232,
     /*  23772 */     GIR_EraseRootFromParent_Done,
     /*  23773 */   // Label 397: @23773
     /*  23773 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(23829), // Rule ID 13244 //
     /*  23778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23816 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23827 */     GIR_RootConstrainSelectedInstOperands,
     /*  23828 */     // GIR_Coverage, 13244,
     /*  23828 */     GIR_EraseRootFromParent_Done,
     /*  23829 */   // Label 398: @23829
     /*  23829 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23896), // Rule ID 13474 //
     /*  23834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23858 */     // MIs[1] imm
     /*  23858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23870 */     // MIs[2] Operand 1
     /*  23870 */     // No operand predicates
     /*  23870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23880 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23894 */     GIR_RootConstrainSelectedInstOperands,
     /*  23895 */     // GIR_Coverage, 13474,
     /*  23895 */     GIR_EraseRootFromParent_Done,
     /*  23896 */   // Label 399: @23896
     /*  23896 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23963), // Rule ID 13495 //
     /*  23901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23925 */     // MIs[1] imm
     /*  23925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23937 */     // MIs[2] Operand 1
     /*  23937 */     // No operand predicates
     /*  23937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23947 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23961 */     GIR_RootConstrainSelectedInstOperands,
     /*  23962 */     // GIR_Coverage, 13495,
     /*  23962 */     GIR_EraseRootFromParent_Done,
     /*  23963 */   // Label 400: @23963
     /*  23963 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24032), // Rule ID 1361 //
     /*  23968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23987 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23990 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24015 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24030 */     GIR_RootConstrainSelectedInstOperands,
     /*  24031 */     // GIR_Coverage, 1361,
     /*  24031 */     GIR_EraseRootFromParent_Done,
     /*  24032 */   // Label 401: @24032
     /*  24032 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24101), // Rule ID 1484 //
     /*  24037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24084 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24099 */     GIR_RootConstrainSelectedInstOperands,
     /*  24100 */     // GIR_Coverage, 1484,
     /*  24100 */     GIR_EraseRootFromParent_Done,
     /*  24101 */   // Label 402: @24101
     /*  24101 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24157), // Rule ID 989 //
     /*  24106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24125 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24128 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24144 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24155 */     GIR_RootConstrainSelectedInstOperands,
     /*  24156 */     // GIR_Coverage, 989,
     /*  24156 */     GIR_EraseRootFromParent_Done,
     /*  24157 */   // Label 403: @24157
     /*  24157 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24213), // Rule ID 1050 //
     /*  24162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24200 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24211 */     GIR_RootConstrainSelectedInstOperands,
     /*  24212 */     // GIR_Coverage, 1050,
     /*  24212 */     GIR_EraseRootFromParent_Done,
     /*  24213 */   // Label 404: @24213
     /*  24213 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24280), // Rule ID 2234 //
     /*  24218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24246 */     // MIs[1] imm
     /*  24246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24258 */     // MIs[2] Operand 1
     /*  24258 */     // No operand predicates
     /*  24258 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24264 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24278 */     GIR_RootConstrainSelectedInstOperands,
     /*  24279 */     // GIR_Coverage, 2234,
     /*  24279 */     GIR_EraseRootFromParent_Done,
     /*  24280 */   // Label 405: @24280
     /*  24280 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24347), // Rule ID 2293 //
     /*  24285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24313 */     // MIs[1] imm
     /*  24313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24325 */     // MIs[2] Operand 1
     /*  24325 */     // No operand predicates
     /*  24325 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24331 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24345 */     GIR_RootConstrainSelectedInstOperands,
     /*  24346 */     // GIR_Coverage, 2293,
     /*  24346 */     GIR_EraseRootFromParent_Done,
     /*  24347 */   // Label 406: @24347
     /*  24347 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24395), // Rule ID 13231 //
     /*  24352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24382 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24393 */     GIR_RootConstrainSelectedInstOperands,
     /*  24394 */     // GIR_Coverage, 13231,
     /*  24394 */     GIR_EraseRootFromParent_Done,
     /*  24395 */   // Label 407: @24395
     /*  24395 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24443), // Rule ID 13243 //
     /*  24400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24430 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24441 */     GIR_RootConstrainSelectedInstOperands,
     /*  24442 */     // GIR_Coverage, 13243,
     /*  24442 */     GIR_EraseRootFromParent_Done,
     /*  24443 */   // Label 408: @24443
     /*  24443 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24491), // Rule ID 988 //
     /*  24448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24478 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24489 */     GIR_RootConstrainSelectedInstOperands,
     /*  24490 */     // GIR_Coverage, 988,
     /*  24490 */     GIR_EraseRootFromParent_Done,
     /*  24491 */   // Label 409: @24491
     /*  24491 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24539), // Rule ID 1049 //
     /*  24496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24526 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24537 */     GIR_RootConstrainSelectedInstOperands,
     /*  24538 */     // GIR_Coverage, 1049,
     /*  24538 */     GIR_EraseRootFromParent_Done,
     /*  24539 */   // Label 410: @24539
     /*  24539 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24566), // Rule ID 1102 //
     /*  24544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24559 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24564 */     GIR_RootConstrainSelectedInstOperands,
     /*  24565 */     // GIR_Coverage, 1102,
     /*  24565 */     GIR_Done,
     /*  24566 */   // Label 411: @24566
     /*  24566 */   GIM_Reject,
     /*  24567 */ // Label 377: @24567
     /*  24567 */ GIM_Reject,
     /*  24568 */ // Label 163: @24568
     /*  24568 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(30745),
     /*  24573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24579 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24697), // Rule ID 13404 //
     /*  24584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24627 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24631 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24635 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24644 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24648 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24652 */     // MIs[4] Operand 1
     /*  24652 */     // No operand predicates
     /*  24652 */     // MIs[2] Operand 2
     /*  24652 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24667 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24676 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24695 */     GIR_RootConstrainSelectedInstOperands,
     /*  24696 */     // GIR_Coverage, 13404,
     /*  24696 */     GIR_EraseRootFromParent_Done,
     /*  24697 */   // Label 413: @24697
     /*  24697 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24815), // Rule ID 13405 //
     /*  24702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24745 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24749 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24753 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24758 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24762 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24766 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24770 */     // MIs[4] Operand 1
     /*  24770 */     // No operand predicates
     /*  24770 */     // MIs[2] Operand 2
     /*  24770 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24785 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24794 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24813 */     GIR_RootConstrainSelectedInstOperands,
     /*  24814 */     // GIR_Coverage, 13405,
     /*  24814 */     GIR_EraseRootFromParent_Done,
     /*  24815 */   // Label 414: @24815
     /*  24815 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24933), // Rule ID 13434 //
     /*  24820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24867 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24871 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24880 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24884 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24888 */     // MIs[4] Operand 1
     /*  24888 */     // No operand predicates
     /*  24888 */     // MIs[2] Operand 2
     /*  24888 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24912 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24931 */     GIR_RootConstrainSelectedInstOperands,
     /*  24932 */     // GIR_Coverage, 13434,
     /*  24932 */     GIR_EraseRootFromParent_Done,
     /*  24933 */   // Label 415: @24933
     /*  24933 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25051), // Rule ID 13435 //
     /*  24938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24981 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24985 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24989 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24994 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24998 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25002 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25006 */     // MIs[4] Operand 1
     /*  25006 */     // No operand predicates
     /*  25006 */     // MIs[2] Operand 2
     /*  25006 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25021 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25030 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25049 */     GIR_RootConstrainSelectedInstOperands,
     /*  25050 */     // GIR_Coverage, 13435,
     /*  25050 */     GIR_EraseRootFromParent_Done,
     /*  25051 */   // Label 416: @25051
     /*  25051 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25169), // Rule ID 2039 //
     /*  25056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25095 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25099 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25103 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25107 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25124 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25128 */     // MIs[4] Operand 1
     /*  25128 */     // No operand predicates
     /*  25128 */     // MIs[2] Operand 2
     /*  25128 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25139 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25148 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25167 */     GIR_RootConstrainSelectedInstOperands,
     /*  25168 */     // GIR_Coverage, 2039,
     /*  25168 */     GIR_EraseRootFromParent_Done,
     /*  25169 */   // Label 417: @25169
     /*  25169 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25287), // Rule ID 13403 //
     /*  25174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25221 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25225 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25229 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25242 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25246 */     // MIs[4] Operand 1
     /*  25246 */     // No operand predicates
     /*  25246 */     // MIs[2] Operand 2
     /*  25246 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25257 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25259 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25266 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25285 */     GIR_RootConstrainSelectedInstOperands,
     /*  25286 */     // GIR_Coverage, 13403,
     /*  25286 */     GIR_EraseRootFromParent_Done,
     /*  25287 */   // Label 418: @25287
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25405), // Rule ID 2091 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25335 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25339 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25343 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25347 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25356 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25360 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25364 */     // MIs[4] Operand 1
     /*  25364 */     // No operand predicates
     /*  25364 */     // MIs[2] Operand 2
     /*  25364 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25384 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25403 */     GIR_RootConstrainSelectedInstOperands,
     /*  25404 */     // GIR_Coverage, 2091,
     /*  25404 */     GIR_EraseRootFromParent_Done,
     /*  25405 */   // Label 419: @25405
     /*  25405 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25523), // Rule ID 13433 //
     /*  25410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25457 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25461 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25465 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25478 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25482 */     // MIs[4] Operand 1
     /*  25482 */     // No operand predicates
     /*  25482 */     // MIs[2] Operand 2
     /*  25482 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25493 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25502 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25521 */     GIR_RootConstrainSelectedInstOperands,
     /*  25522 */     // GIR_Coverage, 13433,
     /*  25522 */     GIR_EraseRootFromParent_Done,
     /*  25523 */   // Label 420: @25523
     /*  25523 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25610), // Rule ID 13314 //
     /*  25528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25555 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25558 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25567 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25591 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25608 */     GIR_RootConstrainSelectedInstOperands,
     /*  25609 */     // GIR_Coverage, 13314,
     /*  25609 */     GIR_EraseRootFromParent_Done,
     /*  25610 */   // Label 421: @25610
     /*  25610 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25697), // Rule ID 13338 //
     /*  25615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25642 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25645 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25654 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25664 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25678 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25695 */     GIR_RootConstrainSelectedInstOperands,
     /*  25696 */     // GIR_Coverage, 13338,
     /*  25696 */     GIR_EraseRootFromParent_Done,
     /*  25697 */   // Label 422: @25697
     /*  25697 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25784), // Rule ID 1695 //
     /*  25702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25733 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25736 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25745 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25758 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25765 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25782 */     GIR_RootConstrainSelectedInstOperands,
     /*  25783 */     // GIR_Coverage, 1695,
     /*  25783 */     GIR_EraseRootFromParent_Done,
     /*  25784 */   // Label 423: @25784
     /*  25784 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25871), // Rule ID 1773 //
     /*  25789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25820 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25823 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25832 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25838 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25852 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25869 */     GIR_RootConstrainSelectedInstOperands,
     /*  25870 */     // GIR_Coverage, 1773,
     /*  25870 */     GIR_EraseRootFromParent_Done,
     /*  25871 */   // Label 424: @25871
     /*  25871 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25986), // Rule ID 13399 //
     /*  25876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25940 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25944 */     // MIs[4] Operand 1
     /*  25944 */     // No operand predicates
     /*  25944 */     // MIs[2] Operand 2
     /*  25944 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  25955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25964 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25966 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  25969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  25977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25984 */     GIR_RootConstrainSelectedInstOperands,
     /*  25985 */     // GIR_Coverage, 13399,
     /*  25985 */     GIR_EraseRootFromParent_Done,
     /*  25986 */   // Label 425: @25986
     /*  25986 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26101), // Rule ID 13398 //
     /*  25991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26035 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26039 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26047 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26056 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26060 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26064 */     // MIs[4] Operand 1
     /*  26064 */     // No operand predicates
     /*  26064 */     // MIs[2] Operand 2
     /*  26064 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26079 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26081 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26099 */     GIR_RootConstrainSelectedInstOperands,
     /*  26100 */     // GIR_Coverage, 13398,
     /*  26100 */     GIR_EraseRootFromParent_Done,
     /*  26101 */   // Label 426: @26101
     /*  26101 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26216), // Rule ID 13429 //
     /*  26106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26153 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26162 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26166 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26170 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26174 */     // MIs[4] Operand 1
     /*  26174 */     // No operand predicates
     /*  26174 */     // MIs[2] Operand 2
     /*  26174 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26196 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26214 */     GIR_RootConstrainSelectedInstOperands,
     /*  26215 */     // GIR_Coverage, 13429,
     /*  26215 */     GIR_EraseRootFromParent_Done,
     /*  26216 */   // Label 427: @26216
     /*  26216 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26331), // Rule ID 13428 //
     /*  26221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26269 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26273 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26277 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26290 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26294 */     // MIs[4] Operand 1
     /*  26294 */     // No operand predicates
     /*  26294 */     // MIs[2] Operand 2
     /*  26294 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26309 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26311 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26329 */     GIR_RootConstrainSelectedInstOperands,
     /*  26330 */     // GIR_Coverage, 13428,
     /*  26330 */     GIR_EraseRootFromParent_Done,
     /*  26331 */   // Label 428: @26331
     /*  26331 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26400), // Rule ID 1793 //
     /*  26336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26383 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26398 */     GIR_RootConstrainSelectedInstOperands,
     /*  26399 */     // GIR_Coverage, 1793,
     /*  26399 */     GIR_EraseRootFromParent_Done,
     /*  26400 */   // Label 429: @26400
     /*  26400 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26469), // Rule ID 1792 //
     /*  26405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26452 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26467 */     GIR_RootConstrainSelectedInstOperands,
     /*  26468 */     // GIR_Coverage, 1792,
     /*  26468 */     GIR_EraseRootFromParent_Done,
     /*  26469 */   // Label 430: @26469
     /*  26469 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26538), // Rule ID 1715 //
     /*  26474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26514 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26521 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26536 */     GIR_RootConstrainSelectedInstOperands,
     /*  26537 */     // GIR_Coverage, 1715,
     /*  26537 */     GIR_EraseRootFromParent_Done,
     /*  26538 */   // Label 431: @26538
     /*  26538 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26607), // Rule ID 1791 //
     /*  26543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26576 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26583 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26590 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26605 */     GIR_RootConstrainSelectedInstOperands,
     /*  26606 */     // GIR_Coverage, 1791,
     /*  26606 */     GIR_EraseRootFromParent_Done,
     /*  26607 */   // Label 432: @26607
     /*  26607 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26676), // Rule ID 1790 //
     /*  26612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26659 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26674 */     GIR_RootConstrainSelectedInstOperands,
     /*  26675 */     // GIR_Coverage, 1790,
     /*  26675 */     GIR_EraseRootFromParent_Done,
     /*  26676 */   // Label 433: @26676
     /*  26676 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26791), // Rule ID 13397 //
     /*  26681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26736 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26741 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26745 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26749 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26753 */     // MIs[4] Operand 1
     /*  26753 */     // No operand predicates
     /*  26753 */     // MIs[2] Operand 2
     /*  26753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26769 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26771 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26789 */     GIR_RootConstrainSelectedInstOperands,
     /*  26790 */     // GIR_Coverage, 13397,
     /*  26790 */     GIR_EraseRootFromParent_Done,
     /*  26791 */   // Label 434: @26791
     /*  26791 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26906), // Rule ID 2037 //
     /*  26796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26852 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26856 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26861 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26865 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26869 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26873 */     // MIs[4] Operand 1
     /*  26873 */     // No operand predicates
     /*  26873 */     // MIs[2] Operand 2
     /*  26873 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26886 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26904 */     GIR_RootConstrainSelectedInstOperands,
     /*  26905 */     // GIR_Coverage, 2037,
     /*  26905 */     GIR_EraseRootFromParent_Done,
     /*  26906 */   // Label 435: @26906
     /*  26906 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27021), // Rule ID 13427 //
     /*  26911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26966 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26971 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26975 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26979 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26983 */     // MIs[4] Operand 1
     /*  26983 */     // No operand predicates
     /*  26983 */     // MIs[2] Operand 2
     /*  26983 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26999 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27001 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27019 */     GIR_RootConstrainSelectedInstOperands,
     /*  27020 */     // GIR_Coverage, 13427,
     /*  27020 */     GIR_EraseRootFromParent_Done,
     /*  27021 */   // Label 436: @27021
     /*  27021 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27136), // Rule ID 2089 //
     /*  27026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27091 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27095 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27099 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27103 */     // MIs[4] Operand 1
     /*  27103 */     // No operand predicates
     /*  27103 */     // MIs[2] Operand 2
     /*  27103 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27114 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27116 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27134 */     GIR_RootConstrainSelectedInstOperands,
     /*  27135 */     // GIR_Coverage, 2089,
     /*  27135 */     GIR_EraseRootFromParent_Done,
     /*  27136 */   // Label 437: @27136
     /*  27136 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27203), // Rule ID 13328 //
     /*  27141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27184 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27201 */     GIR_RootConstrainSelectedInstOperands,
     /*  27202 */     // GIR_Coverage, 13328,
     /*  27202 */     GIR_EraseRootFromParent_Done,
     /*  27203 */   // Label 438: @27203
     /*  27203 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27270), // Rule ID 13358 //
     /*  27208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27251 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27268 */     GIR_RootConstrainSelectedInstOperands,
     /*  27269 */     // GIR_Coverage, 13358,
     /*  27269 */     GIR_EraseRootFromParent_Done,
     /*  27270 */   // Label 439: @27270
     /*  27270 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27337), // Rule ID 1727 //
     /*  27275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27318 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27335 */     GIR_RootConstrainSelectedInstOperands,
     /*  27336 */     // GIR_Coverage, 1727,
     /*  27336 */     GIR_EraseRootFromParent_Done,
     /*  27337 */   // Label 440: @27337
     /*  27337 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27404), // Rule ID 1817 //
     /*  27342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27385 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27402 */     GIR_RootConstrainSelectedInstOperands,
     /*  27403 */     // GIR_Coverage, 1817,
     /*  27403 */     GIR_EraseRootFromParent_Done,
     /*  27404 */   // Label 441: @27404
     /*  27404 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27485), // Rule ID 13312 //
     /*  27409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27436 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27439 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27448 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27468 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27483 */     GIR_RootConstrainSelectedInstOperands,
     /*  27484 */     // GIR_Coverage, 13312,
     /*  27484 */     GIR_EraseRootFromParent_Done,
     /*  27485 */   // Label 442: @27485
     /*  27485 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27566), // Rule ID 13336 //
     /*  27490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27517 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27520 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27529 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27549 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27564 */     GIR_RootConstrainSelectedInstOperands,
     /*  27565 */     // GIR_Coverage, 13336,
     /*  27565 */     GIR_EraseRootFromParent_Done,
     /*  27566 */   // Label 443: @27566
     /*  27566 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27647), // Rule ID 1693 //
     /*  27571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27602 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27605 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27614 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27630 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27645 */     GIR_RootConstrainSelectedInstOperands,
     /*  27646 */     // GIR_Coverage, 1693,
     /*  27646 */     GIR_EraseRootFromParent_Done,
     /*  27647 */   // Label 444: @27647
     /*  27647 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27728), // Rule ID 1771 //
     /*  27652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27683 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27686 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27695 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27711 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27726 */     GIR_RootConstrainSelectedInstOperands,
     /*  27727 */     // GIR_Coverage, 1771,
     /*  27727 */     GIR_EraseRootFromParent_Done,
     /*  27728 */   // Label 445: @27728
     /*  27728 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27820), // Rule ID 13402 //
     /*  27733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27785 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27789 */     // MIs[3] Operand 1
     /*  27789 */     // No operand predicates
     /*  27789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27800 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27818 */     GIR_RootConstrainSelectedInstOperands,
     /*  27819 */     // GIR_Coverage, 13402,
     /*  27819 */     GIR_EraseRootFromParent_Done,
     /*  27820 */   // Label 446: @27820
     /*  27820 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27912), // Rule ID 13401 //
     /*  27825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27882 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27886 */     // MIs[3] Operand 1
     /*  27886 */     // No operand predicates
     /*  27886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27892 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27910 */     GIR_RootConstrainSelectedInstOperands,
     /*  27911 */     // GIR_Coverage, 13401,
     /*  27911 */     GIR_EraseRootFromParent_Done,
     /*  27912 */   // Label 447: @27912
     /*  27912 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28004), // Rule ID 13432 //
     /*  27917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27969 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27973 */     // MIs[3] Operand 1
     /*  27973 */     // No operand predicates
     /*  27973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27984 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28002 */     GIR_RootConstrainSelectedInstOperands,
     /*  28003 */     // GIR_Coverage, 13432,
     /*  28003 */     GIR_EraseRootFromParent_Done,
     /*  28004 */   // Label 448: @28004
     /*  28004 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28096), // Rule ID 13431 //
     /*  28009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28066 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28070 */     // MIs[3] Operand 1
     /*  28070 */     // No operand predicates
     /*  28070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28076 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28094 */     GIR_RootConstrainSelectedInstOperands,
     /*  28095 */     // GIR_Coverage, 13431,
     /*  28095 */     GIR_EraseRootFromParent_Done,
     /*  28096 */   // Label 449: @28096
     /*  28096 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28188), // Rule ID 13400 //
     /*  28101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28157 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28161 */     // MIs[3] Operand 1
     /*  28161 */     // No operand predicates
     /*  28161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28168 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28186 */     GIR_RootConstrainSelectedInstOperands,
     /*  28187 */     // GIR_Coverage, 13400,
     /*  28187 */     GIR_EraseRootFromParent_Done,
     /*  28188 */   // Label 450: @28188
     /*  28188 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28280), // Rule ID 2038 //
     /*  28193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28254 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28258 */     // MIs[3] Operand 1
     /*  28258 */     // No operand predicates
     /*  28258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28260 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28278 */     GIR_RootConstrainSelectedInstOperands,
     /*  28279 */     // GIR_Coverage, 2038,
     /*  28279 */     GIR_EraseRootFromParent_Done,
     /*  28280 */   // Label 451: @28280
     /*  28280 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28372), // Rule ID 13430 //
     /*  28285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28333 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28337 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28341 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28345 */     // MIs[3] Operand 1
     /*  28345 */     // No operand predicates
     /*  28345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28352 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28370 */     GIR_RootConstrainSelectedInstOperands,
     /*  28371 */     // GIR_Coverage, 13430,
     /*  28371 */     GIR_EraseRootFromParent_Done,
     /*  28372 */   // Label 452: @28372
     /*  28372 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28464), // Rule ID 2090 //
     /*  28377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28442 */     // MIs[3] Operand 1
     /*  28442 */     // No operand predicates
     /*  28442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28444 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28462 */     GIR_RootConstrainSelectedInstOperands,
     /*  28463 */     // GIR_Coverage, 2090,
     /*  28463 */     GIR_EraseRootFromParent_Done,
     /*  28464 */   // Label 453: @28464
     /*  28464 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28515), // Rule ID 13350 //
     /*  28469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28501 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28513 */     GIR_RootConstrainSelectedInstOperands,
     /*  28514 */     // GIR_Coverage, 13350,
     /*  28514 */     GIR_EraseRootFromParent_Done,
     /*  28515 */   // Label 454: @28515
     /*  28515 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28566), // Rule ID 13322 //
     /*  28520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28552 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28564 */     GIR_RootConstrainSelectedInstOperands,
     /*  28565 */     // GIR_Coverage, 13322,
     /*  28565 */     GIR_EraseRootFromParent_Done,
     /*  28566 */   // Label 455: @28566
     /*  28566 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28617), // Rule ID 13349 //
     /*  28571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28596 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28603 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28615 */     GIR_RootConstrainSelectedInstOperands,
     /*  28616 */     // GIR_Coverage, 13349,
     /*  28616 */     GIR_EraseRootFromParent_Done,
     /*  28617 */   // Label 456: @28617
     /*  28617 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28668), // Rule ID 1809 //
     /*  28622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28654 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28666 */     GIR_RootConstrainSelectedInstOperands,
     /*  28667 */     // GIR_Coverage, 1809,
     /*  28667 */     GIR_EraseRootFromParent_Done,
     /*  28668 */   // Label 457: @28668
     /*  28668 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28719), // Rule ID 1721 //
     /*  28673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28698 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28705 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28717 */     GIR_RootConstrainSelectedInstOperands,
     /*  28718 */     // GIR_Coverage, 1721,
     /*  28718 */     GIR_EraseRootFromParent_Done,
     /*  28719 */   // Label 458: @28719
     /*  28719 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28770), // Rule ID 1808 //
     /*  28724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28756 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28768 */     GIR_RootConstrainSelectedInstOperands,
     /*  28769 */     // GIR_Coverage, 1808,
     /*  28769 */     GIR_EraseRootFromParent_Done,
     /*  28770 */   // Label 459: @28770
     /*  28770 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28839), // Rule ID 13276 //
     /*  28775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28790 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28793 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28802 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28822 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28837 */     GIR_RootConstrainSelectedInstOperands,
     /*  28838 */     // GIR_Coverage, 13276,
     /*  28838 */     GIR_EraseRootFromParent_Done,
     /*  28839 */   // Label 460: @28839
     /*  28839 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28908), // Rule ID 13288 //
     /*  28844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28859 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28862 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28891 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28906 */     GIR_RootConstrainSelectedInstOperands,
     /*  28907 */     // GIR_Coverage, 13288,
     /*  28907 */     GIR_EraseRootFromParent_Done,
     /*  28908 */   // Label 461: @28908
     /*  28908 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28964), // Rule ID 13238 //
     /*  28913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28928 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28931 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28951 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  28951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  28954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28962 */     GIR_RootConstrainSelectedInstOperands,
     /*  28963 */     // GIR_Coverage, 13238,
     /*  28963 */     GIR_EraseRootFromParent_Done,
     /*  28964 */   // Label 462: @28964
     /*  28964 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29020), // Rule ID 13250 //
     /*  28969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  28992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29007 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29018 */     GIR_RootConstrainSelectedInstOperands,
     /*  29019 */     // GIR_Coverage, 13250,
     /*  29019 */     GIR_EraseRootFromParent_Done,
     /*  29020 */   // Label 463: @29020
     /*  29020 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29087), // Rule ID 13480 //
     /*  29025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29049 */     // MIs[1] imm
     /*  29049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29057 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29061 */     // MIs[2] Operand 1
     /*  29061 */     // No operand predicates
     /*  29061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29071 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29085 */     GIR_RootConstrainSelectedInstOperands,
     /*  29086 */     // GIR_Coverage, 13480,
     /*  29086 */     GIR_EraseRootFromParent_Done,
     /*  29087 */   // Label 464: @29087
     /*  29087 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29154), // Rule ID 13501 //
     /*  29092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29116 */     // MIs[1] imm
     /*  29116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29124 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29128 */     // MIs[2] Operand 1
     /*  29128 */     // No operand predicates
     /*  29128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29138 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29152 */     GIR_RootConstrainSelectedInstOperands,
     /*  29153 */     // GIR_Coverage, 13501,
     /*  29153 */     GIR_EraseRootFromParent_Done,
     /*  29154 */   // Label 465: @29154
     /*  29154 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29223), // Rule ID 1367 //
     /*  29159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29178 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29181 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29190 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29206 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29221 */     GIR_RootConstrainSelectedInstOperands,
     /*  29222 */     // GIR_Coverage, 1367,
     /*  29222 */     GIR_EraseRootFromParent_Done,
     /*  29223 */   // Label 466: @29223
     /*  29223 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29292), // Rule ID 1490 //
     /*  29228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29247 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29250 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29275 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29290 */     GIR_RootConstrainSelectedInstOperands,
     /*  29291 */     // GIR_Coverage, 1490,
     /*  29291 */     GIR_EraseRootFromParent_Done,
     /*  29292 */   // Label 467: @29292
     /*  29292 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29348), // Rule ID 995 //
     /*  29297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29316 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29319 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29335 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29346 */     GIR_RootConstrainSelectedInstOperands,
     /*  29347 */     // GIR_Coverage, 995,
     /*  29347 */     GIR_EraseRootFromParent_Done,
     /*  29348 */   // Label 468: @29348
     /*  29348 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29404), // Rule ID 1056 //
     /*  29353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_RootConstrainSelectedInstOperands,
     /*  29403 */     // GIR_Coverage, 1056,
     /*  29403 */     GIR_EraseRootFromParent_Done,
     /*  29404 */   // Label 469: @29404
     /*  29404 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29471), // Rule ID 2240 //
     /*  29409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29437 */     // MIs[1] imm
     /*  29437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29445 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29449 */     // MIs[2] Operand 1
     /*  29449 */     // No operand predicates
     /*  29449 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29455 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29469 */     GIR_RootConstrainSelectedInstOperands,
     /*  29470 */     // GIR_Coverage, 2240,
     /*  29470 */     GIR_EraseRootFromParent_Done,
     /*  29471 */   // Label 470: @29471
     /*  29471 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29538), // Rule ID 2299 //
     /*  29476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29504 */     // MIs[1] imm
     /*  29504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29512 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29516 */     // MIs[2] Operand 1
     /*  29516 */     // No operand predicates
     /*  29516 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29522 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29536 */     GIR_RootConstrainSelectedInstOperands,
     /*  29537 */     // GIR_Coverage, 2299,
     /*  29537 */     GIR_EraseRootFromParent_Done,
     /*  29538 */   // Label 471: @29538
     /*  29538 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29608), // Rule ID 6894 //
     /*  29543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29581 */     // MIs[2] Rn
     /*  29581 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29586 */     // MIs[2] Rm
     /*  29586 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29593 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29606 */     GIR_RootConstrainSelectedInstOperands,
     /*  29607 */     // GIR_Coverage, 6894,
     /*  29607 */     GIR_EraseRootFromParent_Done,
     /*  29608 */   // Label 472: @29608
     /*  29608 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29678), // Rule ID 13859 //
     /*  29613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29651 */     // MIs[2] Rn
     /*  29651 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29656 */     // MIs[2] Rm
     /*  29656 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29663 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29676 */     GIR_RootConstrainSelectedInstOperands,
     /*  29677 */     // GIR_Coverage, 13859,
     /*  29677 */     GIR_EraseRootFromParent_Done,
     /*  29678 */   // Label 473: @29678
     /*  29678 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29741), // Rule ID 1789 //
     /*  29683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29726 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29739 */     GIR_RootConstrainSelectedInstOperands,
     /*  29740 */     // GIR_Coverage, 1789,
     /*  29740 */     GIR_EraseRootFromParent_Done,
     /*  29741 */   // Label 474: @29741
     /*  29741 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(29804), // Rule ID 1788 //
     /*  29746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29789 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29802 */     GIR_RootConstrainSelectedInstOperands,
     /*  29803 */     // GIR_Coverage, 1788,
     /*  29803 */     GIR_EraseRootFromParent_Done,
     /*  29804 */   // Label 475: @29804
     /*  29804 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(29867), // Rule ID 1714 //
     /*  29809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29852 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29865 */     GIR_RootConstrainSelectedInstOperands,
     /*  29866 */     // GIR_Coverage, 1714,
     /*  29866 */     GIR_EraseRootFromParent_Done,
     /*  29867 */   // Label 476: @29867
     /*  29867 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29930), // Rule ID 1787 //
     /*  29872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29915 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29928 */     GIR_RootConstrainSelectedInstOperands,
     /*  29929 */     // GIR_Coverage, 1787,
     /*  29929 */     GIR_EraseRootFromParent_Done,
     /*  29930 */   // Label 477: @29930
     /*  29930 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(29993), // Rule ID 1786 //
     /*  29935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29978 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29991 */     GIR_RootConstrainSelectedInstOperands,
     /*  29992 */     // GIR_Coverage, 1786,
     /*  29992 */     GIR_EraseRootFromParent_Done,
     /*  29993 */   // Label 478: @29993
     /*  29993 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30054), // Rule ID 13327 //
     /*  29998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30037 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30052 */     GIR_RootConstrainSelectedInstOperands,
     /*  30053 */     // GIR_Coverage, 13327,
     /*  30053 */     GIR_EraseRootFromParent_Done,
     /*  30054 */   // Label 479: @30054
     /*  30054 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30115), // Rule ID 13357 //
     /*  30059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30098 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30113 */     GIR_RootConstrainSelectedInstOperands,
     /*  30114 */     // GIR_Coverage, 13357,
     /*  30114 */     GIR_EraseRootFromParent_Done,
     /*  30115 */   // Label 480: @30115
     /*  30115 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30163), // Rule ID 13348 //
     /*  30120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30150 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30161 */     GIR_RootConstrainSelectedInstOperands,
     /*  30162 */     // GIR_Coverage, 13348,
     /*  30162 */     GIR_EraseRootFromParent_Done,
     /*  30163 */   // Label 481: @30163
     /*  30163 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30211), // Rule ID 13237 //
     /*  30168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30198 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30209 */     GIR_RootConstrainSelectedInstOperands,
     /*  30210 */     // GIR_Coverage, 13237,
     /*  30210 */     GIR_EraseRootFromParent_Done,
     /*  30211 */   // Label 482: @30211
     /*  30211 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30259), // Rule ID 13321 //
     /*  30216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30246 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30257 */     GIR_RootConstrainSelectedInstOperands,
     /*  30258 */     // GIR_Coverage, 13321,
     /*  30258 */     GIR_EraseRootFromParent_Done,
     /*  30259 */   // Label 483: @30259
     /*  30259 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30307), // Rule ID 13249 //
     /*  30264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30294 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30305 */     GIR_RootConstrainSelectedInstOperands,
     /*  30306 */     // GIR_Coverage, 13249,
     /*  30306 */     GIR_EraseRootFromParent_Done,
     /*  30307 */   // Label 484: @30307
     /*  30307 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30355), // Rule ID 13347 //
     /*  30312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30342 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30353 */     GIR_RootConstrainSelectedInstOperands,
     /*  30354 */     // GIR_Coverage, 13347,
     /*  30354 */     GIR_EraseRootFromParent_Done,
     /*  30355 */   // Label 485: @30355
     /*  30355 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30416), // Rule ID 1726 //
     /*  30360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30399 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30414 */     GIR_RootConstrainSelectedInstOperands,
     /*  30415 */     // GIR_Coverage, 1726,
     /*  30415 */     GIR_EraseRootFromParent_Done,
     /*  30416 */   // Label 486: @30416
     /*  30416 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30477), // Rule ID 1816 //
     /*  30421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30460 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30475 */     GIR_RootConstrainSelectedInstOperands,
     /*  30476 */     // GIR_Coverage, 1816,
     /*  30476 */     GIR_EraseRootFromParent_Done,
     /*  30477 */   // Label 487: @30477
     /*  30477 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30525), // Rule ID 1807 //
     /*  30482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30512 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30523 */     GIR_RootConstrainSelectedInstOperands,
     /*  30524 */     // GIR_Coverage, 1807,
     /*  30524 */     GIR_EraseRootFromParent_Done,
     /*  30525 */   // Label 488: @30525
     /*  30525 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30573), // Rule ID 994 //
     /*  30530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30560 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30571 */     GIR_RootConstrainSelectedInstOperands,
     /*  30572 */     // GIR_Coverage, 994,
     /*  30572 */     GIR_EraseRootFromParent_Done,
     /*  30573 */   // Label 489: @30573
     /*  30573 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30621), // Rule ID 1720 //
     /*  30578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30608 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30619 */     GIR_RootConstrainSelectedInstOperands,
     /*  30620 */     // GIR_Coverage, 1720,
     /*  30620 */     GIR_EraseRootFromParent_Done,
     /*  30621 */   // Label 490: @30621
     /*  30621 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(30669), // Rule ID 1055 //
     /*  30626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30656 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30667 */     GIR_RootConstrainSelectedInstOperands,
     /*  30668 */     // GIR_Coverage, 1055,
     /*  30668 */     GIR_EraseRootFromParent_Done,
     /*  30669 */   // Label 491: @30669
     /*  30669 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30717), // Rule ID 1806 //
     /*  30674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30704 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30715 */     GIR_RootConstrainSelectedInstOperands,
     /*  30716 */     // GIR_Coverage, 1806,
     /*  30716 */     GIR_EraseRootFromParent_Done,
     /*  30717 */   // Label 492: @30717
     /*  30717 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30744), // Rule ID 1105 //
     /*  30722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30737 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30742 */     GIR_RootConstrainSelectedInstOperands,
     /*  30743 */     // GIR_Coverage, 1105,
     /*  30743 */     GIR_Done,
     /*  30744 */   // Label 493: @30744
     /*  30744 */   GIM_Reject,
     /*  30745 */ // Label 412: @30745
     /*  30745 */ GIM_Reject,
     /*  30746 */ // Label 164: @30746
     /*  30746 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31595),
     /*  30751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30757 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30890), // Rule ID 13864 //
     /*  30762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30807 */     // MIs[1] Operand 2
     /*  30807 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30826 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30830 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30834 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30838 */     // MIs[5] Rn
     /*  30838 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30843 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30845 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30872 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30889 */     // GIR_Coverage, 13864,
     /*  30889 */     GIR_EraseRootFromParent_Done,
     /*  30890 */   // Label 495: @30890
     /*  30890 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31023), // Rule ID 6899 //
     /*  30895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  30944 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  30948 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30952 */     // MIs[4] Rn
     /*  30952 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30957 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  30961 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30965 */     // MIs[3] Operand 2
     /*  30965 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  30976 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30978 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31022 */     // GIR_Coverage, 6899,
     /*  31022 */     GIR_EraseRootFromParent_Done,
     /*  31023 */   // Label 496: @31023
     /*  31023 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31092), // Rule ID 13266 //
     /*  31028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31043 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31046 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31075 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31090 */     GIR_RootConstrainSelectedInstOperands,
     /*  31091 */     // GIR_Coverage, 13266,
     /*  31091 */     GIR_EraseRootFromParent_Done,
     /*  31092 */   // Label 497: @31092
     /*  31092 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31161), // Rule ID 13278 //
     /*  31097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31144 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31159 */     GIR_RootConstrainSelectedInstOperands,
     /*  31160 */     // GIR_Coverage, 13278,
     /*  31160 */     GIR_EraseRootFromParent_Done,
     /*  31161 */   // Label 498: @31161
     /*  31161 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31228), // Rule ID 13470 //
     /*  31166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31190 */     // MIs[1] imm
     /*  31190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31202 */     // MIs[2] Operand 1
     /*  31202 */     // No operand predicates
     /*  31202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31212 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31226 */     GIR_RootConstrainSelectedInstOperands,
     /*  31227 */     // GIR_Coverage, 13470,
     /*  31227 */     GIR_EraseRootFromParent_Done,
     /*  31228 */   // Label 499: @31228
     /*  31228 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31295), // Rule ID 13491 //
     /*  31233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31257 */     // MIs[1] imm
     /*  31257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31265 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31269 */     // MIs[2] Operand 1
     /*  31269 */     // No operand predicates
     /*  31269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31279 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31293 */     GIR_RootConstrainSelectedInstOperands,
     /*  31294 */     // GIR_Coverage, 13491,
     /*  31294 */     GIR_EraseRootFromParent_Done,
     /*  31295 */   // Label 500: @31295
     /*  31295 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31364), // Rule ID 1357 //
     /*  31300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31319 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31322 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31331 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31347 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31362 */     GIR_RootConstrainSelectedInstOperands,
     /*  31363 */     // GIR_Coverage, 1357,
     /*  31363 */     GIR_EraseRootFromParent_Done,
     /*  31364 */   // Label 501: @31364
     /*  31364 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31433), // Rule ID 1480 //
     /*  31369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31388 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31391 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31400 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31416 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31431 */     GIR_RootConstrainSelectedInstOperands,
     /*  31432 */     // GIR_Coverage, 1480,
     /*  31432 */     GIR_EraseRootFromParent_Done,
     /*  31433 */   // Label 502: @31433
     /*  31433 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31500), // Rule ID 2230 //
     /*  31438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31466 */     // MIs[1] imm
     /*  31466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31474 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31478 */     // MIs[2] Operand 1
     /*  31478 */     // No operand predicates
     /*  31478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31484 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31498 */     GIR_RootConstrainSelectedInstOperands,
     /*  31499 */     // GIR_Coverage, 2230,
     /*  31499 */     GIR_EraseRootFromParent_Done,
     /*  31500 */   // Label 503: @31500
     /*  31500 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31567), // Rule ID 2289 //
     /*  31505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31533 */     // MIs[1] imm
     /*  31533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31545 */     // MIs[2] Operand 1
     /*  31545 */     // No operand predicates
     /*  31545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31551 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31565 */     GIR_RootConstrainSelectedInstOperands,
     /*  31566 */     // GIR_Coverage, 2289,
     /*  31566 */     GIR_EraseRootFromParent_Done,
     /*  31567 */   // Label 504: @31567
     /*  31567 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31594), // Rule ID 1100 //
     /*  31572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31587 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31587 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31592 */     GIR_RootConstrainSelectedInstOperands,
     /*  31593 */     // GIR_Coverage, 1100,
     /*  31593 */     GIR_Done,
     /*  31594 */   // Label 505: @31594
     /*  31594 */   GIM_Reject,
     /*  31595 */ // Label 494: @31595
     /*  31595 */ GIM_Reject,
     /*  31596 */ // Label 165: @31596
     /*  31596 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(35173),
     /*  31601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31607 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31694), // Rule ID 13310 //
     /*  31612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31639 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31642 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31651 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31675 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31692 */     GIR_RootConstrainSelectedInstOperands,
     /*  31693 */     // GIR_Coverage, 13310,
     /*  31693 */     GIR_EraseRootFromParent_Done,
     /*  31694 */   // Label 507: @31694
     /*  31694 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31781), // Rule ID 13334 //
     /*  31699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31726 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31729 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31738 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31755 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31762 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31779 */     GIR_RootConstrainSelectedInstOperands,
     /*  31780 */     // GIR_Coverage, 13334,
     /*  31780 */     GIR_EraseRootFromParent_Done,
     /*  31781 */   // Label 508: @31781
     /*  31781 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31868), // Rule ID 1691 //
     /*  31786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31817 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31820 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31829 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31835 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31842 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31849 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31866 */     GIR_RootConstrainSelectedInstOperands,
     /*  31867 */     // GIR_Coverage, 1691,
     /*  31867 */     GIR_EraseRootFromParent_Done,
     /*  31868 */   // Label 509: @31868
     /*  31868 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(31955), // Rule ID 1769 //
     /*  31873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31904 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31907 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31916 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31922 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31936 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31953 */     GIR_RootConstrainSelectedInstOperands,
     /*  31954 */     // GIR_Coverage, 1769,
     /*  31954 */     GIR_EraseRootFromParent_Done,
     /*  31955 */   // Label 510: @31955
     /*  31955 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32024), // Rule ID 1785 //
     /*  31960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  31983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32000 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32007 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32022 */     GIR_RootConstrainSelectedInstOperands,
     /*  32023 */     // GIR_Coverage, 1785,
     /*  32023 */     GIR_EraseRootFromParent_Done,
     /*  32024 */   // Label 511: @32024
     /*  32024 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32093), // Rule ID 1784 //
     /*  32029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32076 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32091 */     GIR_RootConstrainSelectedInstOperands,
     /*  32092 */     // GIR_Coverage, 1784,
     /*  32092 */     GIR_EraseRootFromParent_Done,
     /*  32093 */   // Label 512: @32093
     /*  32093 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32162), // Rule ID 1713 //
     /*  32098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32145 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32160 */     GIR_RootConstrainSelectedInstOperands,
     /*  32161 */     // GIR_Coverage, 1713,
     /*  32161 */     GIR_EraseRootFromParent_Done,
     /*  32162 */   // Label 513: @32162
     /*  32162 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32231), // Rule ID 1783 //
     /*  32167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32207 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32214 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32229 */     GIR_RootConstrainSelectedInstOperands,
     /*  32230 */     // GIR_Coverage, 1783,
     /*  32230 */     GIR_EraseRootFromParent_Done,
     /*  32231 */   // Label 514: @32231
     /*  32231 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32300), // Rule ID 1782 //
     /*  32236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32269 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32283 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32298 */     GIR_RootConstrainSelectedInstOperands,
     /*  32299 */     // GIR_Coverage, 1782,
     /*  32299 */     GIR_EraseRootFromParent_Done,
     /*  32300 */   // Label 515: @32300
     /*  32300 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32367), // Rule ID 13326 //
     /*  32305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32348 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32365 */     GIR_RootConstrainSelectedInstOperands,
     /*  32366 */     // GIR_Coverage, 13326,
     /*  32366 */     GIR_EraseRootFromParent_Done,
     /*  32367 */   // Label 516: @32367
     /*  32367 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32434), // Rule ID 13356 //
     /*  32372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32415 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32432 */     GIR_RootConstrainSelectedInstOperands,
     /*  32433 */     // GIR_Coverage, 13356,
     /*  32433 */     GIR_EraseRootFromParent_Done,
     /*  32434 */   // Label 517: @32434
     /*  32434 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32501), // Rule ID 1725 //
     /*  32439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32482 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32499 */     GIR_RootConstrainSelectedInstOperands,
     /*  32500 */     // GIR_Coverage, 1725,
     /*  32500 */     GIR_EraseRootFromParent_Done,
     /*  32501 */   // Label 518: @32501
     /*  32501 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32568), // Rule ID 1815 //
     /*  32506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32535 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32549 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32566 */     GIR_RootConstrainSelectedInstOperands,
     /*  32567 */     // GIR_Coverage, 1815,
     /*  32567 */     GIR_EraseRootFromParent_Done,
     /*  32568 */   // Label 519: @32568
     /*  32568 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32649), // Rule ID 13308 //
     /*  32573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32600 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32603 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32612 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32632 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32647 */     GIR_RootConstrainSelectedInstOperands,
     /*  32648 */     // GIR_Coverage, 13308,
     /*  32648 */     GIR_EraseRootFromParent_Done,
     /*  32649 */   // Label 520: @32649
     /*  32649 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32730), // Rule ID 13332 //
     /*  32654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32681 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32684 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32693 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32713 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32728 */     GIR_RootConstrainSelectedInstOperands,
     /*  32729 */     // GIR_Coverage, 13332,
     /*  32729 */     GIR_EraseRootFromParent_Done,
     /*  32730 */   // Label 521: @32730
     /*  32730 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32811), // Rule ID 1689 //
     /*  32735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32766 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32769 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32778 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32787 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32794 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32809 */     GIR_RootConstrainSelectedInstOperands,
     /*  32810 */     // GIR_Coverage, 1689,
     /*  32810 */     GIR_EraseRootFromParent_Done,
     /*  32811 */   // Label 522: @32811
     /*  32811 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32892), // Rule ID 1767 //
     /*  32816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32847 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32850 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32859 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32875 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32890 */     GIR_RootConstrainSelectedInstOperands,
     /*  32891 */     // GIR_Coverage, 1767,
     /*  32891 */     GIR_EraseRootFromParent_Done,
     /*  32892 */   // Label 523: @32892
     /*  32892 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32943), // Rule ID 13346 //
     /*  32897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32929 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32941 */     GIR_RootConstrainSelectedInstOperands,
     /*  32942 */     // GIR_Coverage, 13346,
     /*  32942 */     GIR_EraseRootFromParent_Done,
     /*  32943 */   // Label 524: @32943
     /*  32943 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32994), // Rule ID 13320 //
     /*  32948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32980 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  32983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32992 */     GIR_RootConstrainSelectedInstOperands,
     /*  32993 */     // GIR_Coverage, 13320,
     /*  32993 */     GIR_EraseRootFromParent_Done,
     /*  32994 */   // Label 525: @32994
     /*  32994 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33045), // Rule ID 13345 //
     /*  32999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33031 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33043 */     GIR_RootConstrainSelectedInstOperands,
     /*  33044 */     // GIR_Coverage, 13345,
     /*  33044 */     GIR_EraseRootFromParent_Done,
     /*  33045 */   // Label 526: @33045
     /*  33045 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33096), // Rule ID 1805 //
     /*  33050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33082 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33094 */     GIR_RootConstrainSelectedInstOperands,
     /*  33095 */     // GIR_Coverage, 1805,
     /*  33095 */     GIR_EraseRootFromParent_Done,
     /*  33096 */   // Label 527: @33096
     /*  33096 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33147), // Rule ID 1719 //
     /*  33101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33133 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33145 */     GIR_RootConstrainSelectedInstOperands,
     /*  33146 */     // GIR_Coverage, 1719,
     /*  33146 */     GIR_EraseRootFromParent_Done,
     /*  33147 */   // Label 528: @33147
     /*  33147 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33198), // Rule ID 1804 //
     /*  33152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33184 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33196 */     GIR_RootConstrainSelectedInstOperands,
     /*  33197 */     // GIR_Coverage, 1804,
     /*  33197 */     GIR_EraseRootFromParent_Done,
     /*  33198 */   // Label 529: @33198
     /*  33198 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33267), // Rule ID 13272 //
     /*  33203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33218 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33221 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33250 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33265 */     GIR_RootConstrainSelectedInstOperands,
     /*  33266 */     // GIR_Coverage, 13272,
     /*  33266 */     GIR_EraseRootFromParent_Done,
     /*  33267 */   // Label 530: @33267
     /*  33267 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33336), // Rule ID 13284 //
     /*  33272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33287 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33290 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33319 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33334 */     GIR_RootConstrainSelectedInstOperands,
     /*  33335 */     // GIR_Coverage, 13284,
     /*  33335 */     GIR_EraseRootFromParent_Done,
     /*  33336 */   // Label 531: @33336
     /*  33336 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33392), // Rule ID 13234 //
     /*  33341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33356 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33359 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33379 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33390 */     GIR_RootConstrainSelectedInstOperands,
     /*  33391 */     // GIR_Coverage, 13234,
     /*  33391 */     GIR_EraseRootFromParent_Done,
     /*  33392 */   // Label 532: @33392
     /*  33392 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33448), // Rule ID 13246 //
     /*  33397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33435 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33446 */     GIR_RootConstrainSelectedInstOperands,
     /*  33447 */     // GIR_Coverage, 13246,
     /*  33447 */     GIR_EraseRootFromParent_Done,
     /*  33448 */   // Label 533: @33448
     /*  33448 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33515), // Rule ID 13476 //
     /*  33453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33477 */     // MIs[1] imm
     /*  33477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33489 */     // MIs[2] Operand 1
     /*  33489 */     // No operand predicates
     /*  33489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33493 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33499 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33513 */     GIR_RootConstrainSelectedInstOperands,
     /*  33514 */     // GIR_Coverage, 13476,
     /*  33514 */     GIR_EraseRootFromParent_Done,
     /*  33515 */   // Label 534: @33515
     /*  33515 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33582), // Rule ID 13497 //
     /*  33520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33544 */     // MIs[1] imm
     /*  33544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33556 */     // MIs[2] Operand 1
     /*  33556 */     // No operand predicates
     /*  33556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33560 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33566 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33580 */     GIR_RootConstrainSelectedInstOperands,
     /*  33581 */     // GIR_Coverage, 13497,
     /*  33581 */     GIR_EraseRootFromParent_Done,
     /*  33582 */   // Label 535: @33582
     /*  33582 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33651), // Rule ID 1363 //
     /*  33587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33634 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33649 */     GIR_RootConstrainSelectedInstOperands,
     /*  33650 */     // GIR_Coverage, 1363,
     /*  33650 */     GIR_EraseRootFromParent_Done,
     /*  33651 */   // Label 536: @33651
     /*  33651 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33720), // Rule ID 1486 //
     /*  33656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33687 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33703 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33718 */     GIR_RootConstrainSelectedInstOperands,
     /*  33719 */     // GIR_Coverage, 1486,
     /*  33719 */     GIR_EraseRootFromParent_Done,
     /*  33720 */   // Label 537: @33720
     /*  33720 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(33776), // Rule ID 991 //
     /*  33725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33744 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33747 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33763 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33774 */     GIR_RootConstrainSelectedInstOperands,
     /*  33775 */     // GIR_Coverage, 991,
     /*  33775 */     GIR_EraseRootFromParent_Done,
     /*  33776 */   // Label 538: @33776
     /*  33776 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33832), // Rule ID 1052 //
     /*  33781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33800 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33803 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33819 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33830 */     GIR_RootConstrainSelectedInstOperands,
     /*  33831 */     // GIR_Coverage, 1052,
     /*  33831 */     GIR_EraseRootFromParent_Done,
     /*  33832 */   // Label 539: @33832
     /*  33832 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33899), // Rule ID 2236 //
     /*  33837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33865 */     // MIs[1] imm
     /*  33865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33873 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33877 */     // MIs[2] Operand 1
     /*  33877 */     // No operand predicates
     /*  33877 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33883 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33897 */     GIR_RootConstrainSelectedInstOperands,
     /*  33898 */     // GIR_Coverage, 2236,
     /*  33898 */     GIR_EraseRootFromParent_Done,
     /*  33899 */   // Label 540: @33899
     /*  33899 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33966), // Rule ID 2295 //
     /*  33904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33932 */     // MIs[1] imm
     /*  33932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33940 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33944 */     // MIs[2] Operand 1
     /*  33944 */     // No operand predicates
     /*  33944 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33950 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33964 */     GIR_RootConstrainSelectedInstOperands,
     /*  33965 */     // GIR_Coverage, 2295,
     /*  33965 */     GIR_EraseRootFromParent_Done,
     /*  33966 */   // Label 541: @33966
     /*  33966 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34036), // Rule ID 6895 //
     /*  33971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  33983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34009 */     // MIs[2] Rn
     /*  34009 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34014 */     // MIs[2] Rm
     /*  34014 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34021 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34034 */     GIR_RootConstrainSelectedInstOperands,
     /*  34035 */     // GIR_Coverage, 6895,
     /*  34035 */     GIR_EraseRootFromParent_Done,
     /*  34036 */   // Label 542: @34036
     /*  34036 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34106), // Rule ID 13860 //
     /*  34041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34079 */     // MIs[2] Rn
     /*  34079 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34084 */     // MIs[2] Rm
     /*  34084 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34091 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34104 */     GIR_RootConstrainSelectedInstOperands,
     /*  34105 */     // GIR_Coverage, 13860,
     /*  34105 */     GIR_EraseRootFromParent_Done,
     /*  34106 */   // Label 543: @34106
     /*  34106 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34169), // Rule ID 1781 //
     /*  34111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34154 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34167 */     GIR_RootConstrainSelectedInstOperands,
     /*  34168 */     // GIR_Coverage, 1781,
     /*  34168 */     GIR_EraseRootFromParent_Done,
     /*  34169 */   // Label 544: @34169
     /*  34169 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34232), // Rule ID 1780 //
     /*  34174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34217 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34230 */     GIR_RootConstrainSelectedInstOperands,
     /*  34231 */     // GIR_Coverage, 1780,
     /*  34231 */     GIR_EraseRootFromParent_Done,
     /*  34232 */   // Label 545: @34232
     /*  34232 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34295), // Rule ID 1712 //
     /*  34237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34280 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34293 */     GIR_RootConstrainSelectedInstOperands,
     /*  34294 */     // GIR_Coverage, 1712,
     /*  34294 */     GIR_EraseRootFromParent_Done,
     /*  34295 */   // Label 546: @34295
     /*  34295 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34358), // Rule ID 1779 //
     /*  34300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34343 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34356 */     GIR_RootConstrainSelectedInstOperands,
     /*  34357 */     // GIR_Coverage, 1779,
     /*  34357 */     GIR_EraseRootFromParent_Done,
     /*  34358 */   // Label 547: @34358
     /*  34358 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34421), // Rule ID 1778 //
     /*  34363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34406 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34419 */     GIR_RootConstrainSelectedInstOperands,
     /*  34420 */     // GIR_Coverage, 1778,
     /*  34420 */     GIR_EraseRootFromParent_Done,
     /*  34421 */   // Label 548: @34421
     /*  34421 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34482), // Rule ID 13325 //
     /*  34426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34465 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34480 */     GIR_RootConstrainSelectedInstOperands,
     /*  34481 */     // GIR_Coverage, 13325,
     /*  34481 */     GIR_EraseRootFromParent_Done,
     /*  34482 */   // Label 549: @34482
     /*  34482 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34543), // Rule ID 13355 //
     /*  34487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34526 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34541 */     GIR_RootConstrainSelectedInstOperands,
     /*  34542 */     // GIR_Coverage, 13355,
     /*  34542 */     GIR_EraseRootFromParent_Done,
     /*  34543 */   // Label 550: @34543
     /*  34543 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34591), // Rule ID 13344 //
     /*  34548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34578 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34589 */     GIR_RootConstrainSelectedInstOperands,
     /*  34590 */     // GIR_Coverage, 13344,
     /*  34590 */     GIR_EraseRootFromParent_Done,
     /*  34591 */   // Label 551: @34591
     /*  34591 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34639), // Rule ID 13233 //
     /*  34596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34626 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34637 */     GIR_RootConstrainSelectedInstOperands,
     /*  34638 */     // GIR_Coverage, 13233,
     /*  34638 */     GIR_EraseRootFromParent_Done,
     /*  34639 */   // Label 552: @34639
     /*  34639 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34687), // Rule ID 13319 //
     /*  34644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34674 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34685 */     GIR_RootConstrainSelectedInstOperands,
     /*  34686 */     // GIR_Coverage, 13319,
     /*  34686 */     GIR_EraseRootFromParent_Done,
     /*  34687 */   // Label 553: @34687
     /*  34687 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34735), // Rule ID 13245 //
     /*  34692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34722 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34733 */     GIR_RootConstrainSelectedInstOperands,
     /*  34734 */     // GIR_Coverage, 13245,
     /*  34734 */     GIR_EraseRootFromParent_Done,
     /*  34735 */   // Label 554: @34735
     /*  34735 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(34783), // Rule ID 13343 //
     /*  34740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34770 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34781 */     GIR_RootConstrainSelectedInstOperands,
     /*  34782 */     // GIR_Coverage, 13343,
     /*  34782 */     GIR_EraseRootFromParent_Done,
     /*  34783 */   // Label 555: @34783
     /*  34783 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(34844), // Rule ID 1724 //
     /*  34788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34827 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34842 */     GIR_RootConstrainSelectedInstOperands,
     /*  34843 */     // GIR_Coverage, 1724,
     /*  34843 */     GIR_EraseRootFromParent_Done,
     /*  34844 */   // Label 556: @34844
     /*  34844 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34905), // Rule ID 1814 //
     /*  34849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34888 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34903 */     GIR_RootConstrainSelectedInstOperands,
     /*  34904 */     // GIR_Coverage, 1814,
     /*  34904 */     GIR_EraseRootFromParent_Done,
     /*  34905 */   // Label 557: @34905
     /*  34905 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(34953), // Rule ID 1803 //
     /*  34910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34940 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  34947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34951 */     GIR_RootConstrainSelectedInstOperands,
     /*  34952 */     // GIR_Coverage, 1803,
     /*  34952 */     GIR_EraseRootFromParent_Done,
     /*  34953 */   // Label 558: @34953
     /*  34953 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35001), // Rule ID 990 //
     /*  34958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34988 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34999 */     GIR_RootConstrainSelectedInstOperands,
     /*  35000 */     // GIR_Coverage, 990,
     /*  35000 */     GIR_EraseRootFromParent_Done,
     /*  35001 */   // Label 559: @35001
     /*  35001 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35049), // Rule ID 1718 //
     /*  35006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35036 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35047 */     GIR_RootConstrainSelectedInstOperands,
     /*  35048 */     // GIR_Coverage, 1718,
     /*  35048 */     GIR_EraseRootFromParent_Done,
     /*  35049 */   // Label 560: @35049
     /*  35049 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35097), // Rule ID 1051 //
     /*  35054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35084 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35095 */     GIR_RootConstrainSelectedInstOperands,
     /*  35096 */     // GIR_Coverage, 1051,
     /*  35096 */     GIR_EraseRootFromParent_Done,
     /*  35097 */   // Label 561: @35097
     /*  35097 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35145), // Rule ID 1802 //
     /*  35102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35132 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35143 */     GIR_RootConstrainSelectedInstOperands,
     /*  35144 */     // GIR_Coverage, 1802,
     /*  35144 */     GIR_EraseRootFromParent_Done,
     /*  35145 */   // Label 562: @35145
     /*  35145 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35172), // Rule ID 1103 //
     /*  35150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35165 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35170 */     GIR_RootConstrainSelectedInstOperands,
     /*  35171 */     // GIR_Coverage, 1103,
     /*  35171 */     GIR_Done,
     /*  35172 */   // Label 563: @35172
     /*  35172 */   GIM_Reject,
     /*  35173 */ // Label 506: @35173
     /*  35173 */ GIM_Reject,
     /*  35174 */ // Label 166: @35174
     /*  35174 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35897),
     /*  35179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35185 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35254), // Rule ID 13268 //
     /*  35190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35217 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35237 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35252 */     GIR_RootConstrainSelectedInstOperands,
     /*  35253 */     // GIR_Coverage, 13268,
     /*  35253 */     GIR_EraseRootFromParent_Done,
     /*  35254 */   // Label 565: @35254
     /*  35254 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35323), // Rule ID 13280 //
     /*  35259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35306 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35321 */     GIR_RootConstrainSelectedInstOperands,
     /*  35322 */     // GIR_Coverage, 13280,
     /*  35322 */     GIR_EraseRootFromParent_Done,
     /*  35323 */   // Label 566: @35323
     /*  35323 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35390), // Rule ID 13472 //
     /*  35328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35352 */     // MIs[1] imm
     /*  35352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35364 */     // MIs[2] Operand 1
     /*  35364 */     // No operand predicates
     /*  35364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35368 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35374 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35388 */     GIR_RootConstrainSelectedInstOperands,
     /*  35389 */     // GIR_Coverage, 13472,
     /*  35389 */     GIR_EraseRootFromParent_Done,
     /*  35390 */   // Label 567: @35390
     /*  35390 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35457), // Rule ID 13493 //
     /*  35395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35419 */     // MIs[1] imm
     /*  35419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35427 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35431 */     // MIs[2] Operand 1
     /*  35431 */     // No operand predicates
     /*  35431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35435 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35441 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35455 */     GIR_RootConstrainSelectedInstOperands,
     /*  35456 */     // GIR_Coverage, 13493,
     /*  35456 */     GIR_EraseRootFromParent_Done,
     /*  35457 */   // Label 568: @35457
     /*  35457 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35526), // Rule ID 1359 //
     /*  35462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35481 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35484 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35493 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35509 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35524 */     GIR_RootConstrainSelectedInstOperands,
     /*  35525 */     // GIR_Coverage, 1359,
     /*  35525 */     GIR_EraseRootFromParent_Done,
     /*  35526 */   // Label 569: @35526
     /*  35526 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35595), // Rule ID 1482 //
     /*  35531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35550 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35553 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35562 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35578 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35593 */     GIR_RootConstrainSelectedInstOperands,
     /*  35594 */     // GIR_Coverage, 1482,
     /*  35594 */     GIR_EraseRootFromParent_Done,
     /*  35595 */   // Label 570: @35595
     /*  35595 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35662), // Rule ID 2232 //
     /*  35600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35628 */     // MIs[1] imm
     /*  35628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35636 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35640 */     // MIs[2] Operand 1
     /*  35640 */     // No operand predicates
     /*  35640 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35646 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35660 */     GIR_RootConstrainSelectedInstOperands,
     /*  35661 */     // GIR_Coverage, 2232,
     /*  35661 */     GIR_EraseRootFromParent_Done,
     /*  35662 */   // Label 571: @35662
     /*  35662 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35729), // Rule ID 2291 //
     /*  35667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35695 */     // MIs[1] imm
     /*  35695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35703 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35707 */     // MIs[2] Operand 1
     /*  35707 */     // No operand predicates
     /*  35707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35713 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35727 */     GIR_RootConstrainSelectedInstOperands,
     /*  35728 */     // GIR_Coverage, 2291,
     /*  35728 */     GIR_EraseRootFromParent_Done,
     /*  35729 */   // Label 572: @35729
     /*  35729 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(35799), // Rule ID 6896 //
     /*  35734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35772 */     // MIs[2] Rn
     /*  35772 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35777 */     // MIs[2] Rm
     /*  35777 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35784 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35797 */     GIR_RootConstrainSelectedInstOperands,
     /*  35798 */     // GIR_Coverage, 6896,
     /*  35798 */     GIR_EraseRootFromParent_Done,
     /*  35799 */   // Label 573: @35799
     /*  35799 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(35869), // Rule ID 13861 //
     /*  35804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35842 */     // MIs[2] Rn
     /*  35842 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35847 */     // MIs[2] Rm
     /*  35847 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35854 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35867 */     GIR_RootConstrainSelectedInstOperands,
     /*  35868 */     // GIR_Coverage, 13861,
     /*  35868 */     GIR_EraseRootFromParent_Done,
     /*  35869 */   // Label 574: @35869
     /*  35869 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(35896), // Rule ID 1101 //
     /*  35874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35889 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35894 */     GIR_RootConstrainSelectedInstOperands,
     /*  35895 */     // GIR_Coverage, 1101,
     /*  35895 */     GIR_Done,
     /*  35896 */   // Label 575: @35896
     /*  35896 */   GIM_Reject,
     /*  35897 */ // Label 564: @35897
     /*  35897 */ GIM_Reject,
     /*  35898 */ // Label 167: @35898
     /*  35898 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36269),
     /*  35903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35913 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(35975), // Rule ID 15045 //
     /*  35918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  35945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  35949 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  35960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35962 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  35962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  35965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  35967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  35969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  35973 */     GIR_RootConstrainSelectedInstOperands,
     /*  35974 */     // GIR_Coverage, 15045,
     /*  35974 */     GIR_EraseRootFromParent_Done,
     /*  35975 */   // Label 577: @35975
     /*  35975 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36037), // Rule ID 15044 //
     /*  35980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36011 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36024 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36035 */     GIR_RootConstrainSelectedInstOperands,
     /*  36036 */     // GIR_Coverage, 15044,
     /*  36036 */     GIR_EraseRootFromParent_Done,
     /*  36037 */   // Label 578: @36037
     /*  36037 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36099), // Rule ID 15043 //
     /*  36042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36073 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36086 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36097 */     GIR_RootConstrainSelectedInstOperands,
     /*  36098 */     // GIR_Coverage, 15043,
     /*  36098 */     GIR_EraseRootFromParent_Done,
     /*  36099 */   // Label 579: @36099
     /*  36099 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36161), // Rule ID 8835 //
     /*  36104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36135 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36148 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36159 */     GIR_RootConstrainSelectedInstOperands,
     /*  36160 */     // GIR_Coverage, 8835,
     /*  36160 */     GIR_EraseRootFromParent_Done,
     /*  36161 */   // Label 580: @36161
     /*  36161 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36207), // Rule ID 15046 //
     /*  36166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36181 */     // MIs[1] Operand 2
     /*  36181 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36194 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36205 */     GIR_RootConstrainSelectedInstOperands,
     /*  36206 */     // GIR_Coverage, 15046,
     /*  36206 */     GIR_EraseRootFromParent_Done,
     /*  36207 */   // Label 581: @36207
     /*  36207 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36253), // Rule ID 8836 //
     /*  36212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36227 */     // MIs[1] Operand 2
     /*  36227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36240 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36251 */     GIR_RootConstrainSelectedInstOperands,
     /*  36252 */     // GIR_Coverage, 8836,
     /*  36252 */     GIR_EraseRootFromParent_Done,
     /*  36253 */   // Label 582: @36253
     /*  36253 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36268), // Rule ID 2780 //
     /*  36258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36261 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36266 */     GIR_RootConstrainSelectedInstOperands,
     /*  36267 */     // GIR_Coverage, 2780,
     /*  36267 */     GIR_Done,
     /*  36268 */   // Label 583: @36268
     /*  36268 */   GIM_Reject,
     /*  36269 */ // Label 576: @36269
     /*  36269 */ GIM_Reject,
     /*  36270 */ // Label 168: @36270
     /*  36270 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36295), // Rule ID 2779 //
     /*  36275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36288 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36293 */   GIR_RootConstrainSelectedInstOperands,
     /*  36294 */   // GIR_Coverage, 2779,
     /*  36294 */   GIR_Done,
     /*  36295 */ // Label 584: @36295
     /*  36295 */ GIM_Reject,
     /*  36296 */ // Label 169: @36296
     /*  36296 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36321), // Rule ID 2778 //
     /*  36301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36314 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36319 */   GIR_RootConstrainSelectedInstOperands,
     /*  36320 */   // GIR_Coverage, 2778,
     /*  36320 */   GIR_Done,
     /*  36321 */ // Label 585: @36321
     /*  36321 */ GIM_Reject,
     /*  36322 */ // Label 170: @36322
     /*  36322 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36347), // Rule ID 2777 //
     /*  36327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36340 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36345 */   GIR_RootConstrainSelectedInstOperands,
     /*  36346 */   // GIR_Coverage, 2777,
     /*  36346 */   GIR_Done,
     /*  36347 */ // Label 586: @36347
     /*  36347 */ GIM_Reject,
     /*  36348 */ // Label 171: @36348
     /*  36348 */ GIM_Reject,
     /*  36349 */ // Label 1: @36349
     /*  36349 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 600*/ GIMT_Encode4(50576),
     /*  36360 */ /*GILLT_s32*//*Label 587*/ GIMT_Encode4(36448),
     /*  36364 */ /*GILLT_s64*//*Label 588*/ GIMT_Encode4(37930), GIMT_Encode4(0),
     /*  36372 */ /*GILLT_v2s32*//*Label 589*/ GIMT_Encode4(41212),
     /*  36376 */ /*GILLT_v2s64*//*Label 590*/ GIMT_Encode4(42703),
     /*  36380 */ /*GILLT_v4s16*//*Label 591*/ GIMT_Encode4(45163),
     /*  36384 */ /*GILLT_v4s32*//*Label 592*/ GIMT_Encode4(46654),
     /*  36388 */ /*GILLT_v8s8*//*Label 593*/ GIMT_Encode4(49114),
     /*  36392 */ /*GILLT_v8s16*//*Label 594*/ GIMT_Encode4(49189),
     /*  36396 */ /*GILLT_v16s8*//*Label 595*/ GIMT_Encode4(50397), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36416 */ /*GILLT_nxv2s64*//*Label 596*/ GIMT_Encode4(50472), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36428 */ /*GILLT_nxv4s32*//*Label 597*/ GIMT_Encode4(50498), GIMT_Encode4(0),
     /*  36436 */ /*GILLT_nxv8s16*//*Label 598*/ GIMT_Encode4(50524), GIMT_Encode4(0),
     /*  36444 */ /*GILLT_nxv16s8*//*Label 599*/ GIMT_Encode4(50550),
     /*  36448 */ // Label 587: @36448
     /*  36448 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(37929),
     /*  36453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36459 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(36611), // Rule ID 9882 //
     /*  36464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36495 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36498 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36503 */     // MIs[2] pattern
     /*  36503 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36506 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36513 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36513 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36516 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36520 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36527 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36530 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36534 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36539 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36542 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36546 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36549 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36579 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36593 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36610 */     // GIR_Coverage, 9882,
     /*  36610 */     GIR_EraseRootFromParent_Done,
     /*  36611 */   // Label 602: @36611
     /*  36611 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(36763), // Rule ID 9894 //
     /*  36616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36647 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36650 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36655 */     // MIs[2] pattern
     /*  36655 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36658 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36665 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36665 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36668 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36672 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36691 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36698 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36731 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36735 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36762 */     // GIR_Coverage, 9894,
     /*  36762 */     GIR_EraseRootFromParent_Done,
     /*  36763 */   // Label 603: @36763
     /*  36763 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(36915), // Rule ID 9906 //
     /*  36768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36799 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36802 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36807 */     // MIs[2] pattern
     /*  36807 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36810 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36817 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36817 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36820 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36824 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36843 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36850 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36914 */     // GIR_Coverage, 9906,
     /*  36914 */     GIR_EraseRootFromParent_Done,
     /*  36915 */   // Label 604: @36915
     /*  36915 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37067), // Rule ID 9918 //
     /*  36920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36951 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36954 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  36959 */     // MIs[2] pattern
     /*  36959 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36962 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36969 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36969 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36972 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36976 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36995 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37002 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37049 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37066 */     // GIR_Coverage, 9918,
     /*  37066 */     GIR_EraseRootFromParent_Done,
     /*  37067 */   // Label 605: @37067
     /*  37067 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37129), // Rule ID 3943 //
     /*  37072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37108 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37127 */     GIR_RootConstrainSelectedInstOperands,
     /*  37128 */     // GIR_Coverage, 3943,
     /*  37128 */     GIR_EraseRootFromParent_Done,
     /*  37129 */   // Label 606: @37129
     /*  37129 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37286), // Rule ID 10020 //
     /*  37134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37165 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37168 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37177 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37184 */     // MIs[2] pred
     /*  37184 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37191 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37191 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37194 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37198 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37217 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37220 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37224 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37232 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37237 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37268 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37285 */     // GIR_Coverage, 10020,
     /*  37285 */     GIR_EraseRootFromParent_Done,
     /*  37286 */   // Label 607: @37286
     /*  37286 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37443), // Rule ID 10021 //
     /*  37291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37322 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37325 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37334 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37341 */     // MIs[2] pred
     /*  37341 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37348 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37348 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37351 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37355 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37374 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37377 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37381 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37384 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37425 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37442 */     // GIR_Coverage, 10021,
     /*  37442 */     GIR_EraseRootFromParent_Done,
     /*  37443 */   // Label 608: @37443
     /*  37443 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37600), // Rule ID 10022 //
     /*  37448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37479 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37482 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37487 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37491 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37498 */     // MIs[2] pred
     /*  37498 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37505 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37505 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37508 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37512 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37531 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37538 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37541 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37546 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37551 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37568 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37582 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37589 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37599 */     // GIR_Coverage, 10022,
     /*  37599 */     GIR_EraseRootFromParent_Done,
     /*  37600 */   // Label 609: @37600
     /*  37600 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37757), // Rule ID 10023 //
     /*  37605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37636 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37639 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37648 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37655 */     // MIs[2] pred
     /*  37655 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37662 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37688 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37695 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37729 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37739 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37756 */     // GIR_Coverage, 10023,
     /*  37756 */     GIR_EraseRootFromParent_Done,
     /*  37757 */   // Label 610: @37757
     /*  37757 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37793), // Rule ID 3908 //
     /*  37762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37777 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37782 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37791 */     GIR_RootConstrainSelectedInstOperands,
     /*  37792 */     // GIR_Coverage, 3908,
     /*  37792 */     GIR_EraseRootFromParent_Done,
     /*  37793 */   // Label 611: @37793
     /*  37793 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37826), // Rule ID 3913 //
     /*  37798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37813 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37824 */     GIR_RootConstrainSelectedInstOperands,
     /*  37825 */     // GIR_Coverage, 3913,
     /*  37825 */     GIR_EraseRootFromParent_Done,
     /*  37826 */   // Label 612: @37826
     /*  37826 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37862), // Rule ID 3902 //
     /*  37831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37846 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37860 */     GIR_RootConstrainSelectedInstOperands,
     /*  37861 */     // GIR_Coverage, 3902,
     /*  37861 */     GIR_EraseRootFromParent_Done,
     /*  37862 */   // Label 613: @37862
     /*  37862 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(37898), // Rule ID 3906 //
     /*  37867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37882 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37896 */     GIR_RootConstrainSelectedInstOperands,
     /*  37897 */     // GIR_Coverage, 3906,
     /*  37897 */     GIR_EraseRootFromParent_Done,
     /*  37898 */   // Label 614: @37898
     /*  37898 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(37928), // Rule ID 3904 //
     /*  37903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37915 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37920 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37926 */     GIR_RootConstrainSelectedInstOperands,
     /*  37927 */     // GIR_Coverage, 3904,
     /*  37927 */     GIR_Done,
     /*  37928 */   // Label 615: @37928
     /*  37928 */   GIM_Reject,
     /*  37929 */ // Label 601: @37929
     /*  37929 */ GIM_Reject,
     /*  37930 */ // Label 588: @37930
     /*  37930 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(41211),
     /*  37935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37941 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38077), // Rule ID 5386 //
     /*  37946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  37962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  37970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  37974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  37979 */     // MIs[1] Operand 2
     /*  37979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  37990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  37994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  37998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38006 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38010 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38014 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38019 */     // MIs[3] Operand 2
     /*  38019 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38032 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38059 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38076 */     // GIR_Coverage, 5386,
     /*  38076 */     GIR_EraseRootFromParent_Done,
     /*  38077 */   // Label 617: @38077
     /*  38077 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38213), // Rule ID 5385 //
     /*  38082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38115 */     // MIs[1] Operand 2
     /*  38115 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38146 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38150 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38155 */     // MIs[3] Operand 2
     /*  38155 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38166 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38168 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38195 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38212 */     // GIR_Coverage, 5385,
     /*  38212 */     GIR_EraseRootFromParent_Done,
     /*  38213 */   // Label 618: @38213
     /*  38213 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38349), // Rule ID 5395 //
     /*  38218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38251 */     // MIs[1] Operand 2
     /*  38251 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38274 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38278 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38282 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38286 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38291 */     // MIs[3] Operand 2
     /*  38291 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38304 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38331 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38348 */     // GIR_Coverage, 5395,
     /*  38348 */     GIR_EraseRootFromParent_Done,
     /*  38349 */   // Label 619: @38349
     /*  38349 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38485), // Rule ID 5384 //
     /*  38354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38387 */     // MIs[1] Operand 2
     /*  38387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38414 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38418 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38422 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38427 */     // MIs[3] Operand 2
     /*  38427 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38438 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38440 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38484 */     // GIR_Coverage, 5384,
     /*  38484 */     GIR_EraseRootFromParent_Done,
     /*  38485 */   // Label 620: @38485
     /*  38485 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38621), // Rule ID 5383 //
     /*  38490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38523 */     // MIs[1] Operand 2
     /*  38523 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38546 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38550 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38554 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38558 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38563 */     // MIs[3] Operand 2
     /*  38563 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38574 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38576 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38620 */     // GIR_Coverage, 5383,
     /*  38620 */     GIR_EraseRootFromParent_Done,
     /*  38621 */   // Label 621: @38621
     /*  38621 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38758), // Rule ID 3960 //
     /*  38626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38667 */     // MIs[2] Operand 2
     /*  38667 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38686 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38690 */     // MIs[3] Operand 1
     /*  38690 */     // No operand predicates
     /*  38690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38692 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38692 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38695 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38699 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38704 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38723 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38756 */     GIR_RootConstrainSelectedInstOperands,
     /*  38757 */     // GIR_Coverage, 3960,
     /*  38757 */     GIR_EraseRootFromParent_Done,
     /*  38758 */   // Label 622: @38758
     /*  38758 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38857), // Rule ID 3958 //
     /*  38763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38812 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38816 */     // MIs[3] Operand 1
     /*  38816 */     // No operand predicates
     /*  38816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38818 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38830 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38855 */     GIR_RootConstrainSelectedInstOperands,
     /*  38856 */     // GIR_Coverage, 3958,
     /*  38856 */     GIR_EraseRootFromParent_Done,
     /*  38857 */   // Label 623: @38857
     /*  38857 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38956), // Rule ID 3959 //
     /*  38862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38915 */     // MIs[3] Operand 1
     /*  38915 */     // No operand predicates
     /*  38915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38917 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38929 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38954 */     GIR_RootConstrainSelectedInstOperands,
     /*  38955 */     // GIR_Coverage, 3959,
     /*  38955 */     GIR_EraseRootFromParent_Done,
     /*  38956 */   // Label 624: @38956
     /*  38956 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39042), // Rule ID 3953 //
     /*  38961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39010 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39014 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39021 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39040 */     GIR_RootConstrainSelectedInstOperands,
     /*  39041 */     // GIR_Coverage, 3953,
     /*  39041 */     GIR_EraseRootFromParent_Done,
     /*  39042 */   // Label 625: @39042
     /*  39042 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39128), // Rule ID 3954 //
     /*  39047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39100 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39105 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39107 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39126 */     GIR_RootConstrainSelectedInstOperands,
     /*  39127 */     // GIR_Coverage, 3954,
     /*  39127 */     GIR_EraseRootFromParent_Done,
     /*  39128 */   // Label 626: @39128
     /*  39128 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39261), // Rule ID 3966 //
     /*  39133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39174 */     // MIs[2] Operand 2
     /*  39174 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39193 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39197 */     // MIs[3] Operand 1
     /*  39197 */     // No operand predicates
     /*  39197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39199 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39199 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39202 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39206 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39211 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39230 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39259 */     GIR_RootConstrainSelectedInstOperands,
     /*  39260 */     // GIR_Coverage, 3966,
     /*  39260 */     GIR_EraseRootFromParent_Done,
     /*  39261 */   // Label 627: @39261
     /*  39261 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39356), // Rule ID 3964 //
     /*  39266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39315 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39319 */     // MIs[3] Operand 1
     /*  39319 */     // No operand predicates
     /*  39319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39321 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39333 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39354 */     GIR_RootConstrainSelectedInstOperands,
     /*  39355 */     // GIR_Coverage, 3964,
     /*  39355 */     GIR_EraseRootFromParent_Done,
     /*  39356 */   // Label 628: @39356
     /*  39356 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39451), // Rule ID 3965 //
     /*  39361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39410 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39414 */     // MIs[3] Operand 1
     /*  39414 */     // No operand predicates
     /*  39414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39416 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39428 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39449 */     GIR_RootConstrainSelectedInstOperands,
     /*  39450 */     // GIR_Coverage, 3965,
     /*  39450 */     GIR_EraseRootFromParent_Done,
     /*  39451 */   // Label 629: @39451
     /*  39451 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39533), // Rule ID 124 //
     /*  39456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39505 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39509 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39516 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39531 */     GIR_RootConstrainSelectedInstOperands,
     /*  39532 */     // GIR_Coverage, 124,
     /*  39532 */     GIR_EraseRootFromParent_Done,
     /*  39533 */   // Label 630: @39533
     /*  39533 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39615), // Rule ID 126 //
     /*  39538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39591 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39596 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39598 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39613 */     GIR_RootConstrainSelectedInstOperands,
     /*  39614 */     // GIR_Coverage, 126,
     /*  39614 */     GIR_EraseRootFromParent_Done,
     /*  39615 */   // Label 631: @39615
     /*  39615 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39677), // Rule ID 3944 //
     /*  39620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39656 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39675 */     GIR_RootConstrainSelectedInstOperands,
     /*  39676 */     // GIR_Coverage, 3944,
     /*  39676 */     GIR_EraseRootFromParent_Done,
     /*  39677 */   // Label 632: @39677
     /*  39677 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39735), // Rule ID 9879 //
     /*  39682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39701 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39704 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39709 */     // MIs[1] pattern
     /*  39709 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39712 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39719 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39733 */     GIR_RootConstrainSelectedInstOperands,
     /*  39734 */     // GIR_Coverage, 9879,
     /*  39734 */     GIR_EraseRootFromParent_Done,
     /*  39735 */   // Label 633: @39735
     /*  39735 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39793), // Rule ID 9891 //
     /*  39740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39759 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39762 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39767 */     // MIs[1] pattern
     /*  39767 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39770 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39777 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39791 */     GIR_RootConstrainSelectedInstOperands,
     /*  39792 */     // GIR_Coverage, 9891,
     /*  39792 */     GIR_EraseRootFromParent_Done,
     /*  39793 */   // Label 634: @39793
     /*  39793 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39851), // Rule ID 9903 //
     /*  39798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39817 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39820 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39825 */     // MIs[1] pattern
     /*  39825 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39828 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39835 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39849 */     GIR_RootConstrainSelectedInstOperands,
     /*  39850 */     // GIR_Coverage, 9903,
     /*  39850 */     GIR_EraseRootFromParent_Done,
     /*  39851 */   // Label 635: @39851
     /*  39851 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39909), // Rule ID 9915 //
     /*  39856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39875 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39878 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39883 */     // MIs[1] pattern
     /*  39883 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39886 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39893 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39898 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39907 */     GIR_RootConstrainSelectedInstOperands,
     /*  39908 */     // GIR_Coverage, 9915,
     /*  39908 */     GIR_EraseRootFromParent_Done,
     /*  39909 */   // Label 636: @39909
     /*  39909 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40072), // Rule ID 5350 //
     /*  39914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39960 */     // MIs[1] Operand 2
     /*  39960 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39973 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39973 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  39976 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39980 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  39990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39999 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40006 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40019 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40036 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40054 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40061 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40071 */     // GIR_Coverage, 5350,
     /*  40071 */     GIR_EraseRootFromParent_Done,
     /*  40072 */   // Label 637: @40072
     /*  40072 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40235), // Rule ID 5347 //
     /*  40077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40123 */     // MIs[1] Operand 2
     /*  40123 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40136 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40136 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40139 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40143 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40162 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40165 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40169 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40172 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40177 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40182 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40234 */     // GIR_Coverage, 5347,
     /*  40234 */     GIR_EraseRootFromParent_Done,
     /*  40235 */   // Label 638: @40235
     /*  40235 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40385), // Rule ID 5392 //
     /*  40240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40277 */     // MIs[1] Operand 2
     /*  40277 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40290 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40290 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40293 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40297 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40316 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40323 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40326 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40331 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40367 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40384 */     // GIR_Coverage, 5392,
     /*  40384 */     GIR_EraseRootFromParent_Done,
     /*  40385 */   // Label 639: @40385
     /*  40385 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40535), // Rule ID 5398 //
     /*  40390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40427 */     // MIs[1] Operand 2
     /*  40427 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40440 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40440 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40443 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40447 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40454 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40457 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40461 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40466 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40469 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40473 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40476 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40481 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40486 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40517 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40534 */     // GIR_Coverage, 5398,
     /*  40534 */     GIR_EraseRootFromParent_Done,
     /*  40535 */   // Label 640: @40535
     /*  40535 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40685), // Rule ID 5391 //
     /*  40540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40577 */     // MIs[1] Operand 2
     /*  40577 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40590 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40590 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40593 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40597 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40604 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40607 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40611 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40616 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40619 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40623 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40626 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40636 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40653 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40667 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40674 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40684 */     // GIR_Coverage, 5391,
     /*  40684 */     GIR_EraseRootFromParent_Done,
     /*  40685 */   // Label 641: @40685
     /*  40685 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40721), // Rule ID 3909 //
     /*  40690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40705 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40710 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40712 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40719 */     GIR_RootConstrainSelectedInstOperands,
     /*  40720 */     // GIR_Coverage, 3909,
     /*  40720 */     GIR_EraseRootFromParent_Done,
     /*  40721 */   // Label 642: @40721
     /*  40721 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40754), // Rule ID 3914 //
     /*  40726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40741 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40752 */     GIR_RootConstrainSelectedInstOperands,
     /*  40753 */     // GIR_Coverage, 3914,
     /*  40753 */     GIR_EraseRootFromParent_Done,
     /*  40754 */   // Label 643: @40754
     /*  40754 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(40790), // Rule ID 3903 //
     /*  40759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40774 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40788 */     GIR_RootConstrainSelectedInstOperands,
     /*  40789 */     // GIR_Coverage, 3903,
     /*  40789 */     GIR_EraseRootFromParent_Done,
     /*  40790 */   // Label 644: @40790
     /*  40790 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40826), // Rule ID 3907 //
     /*  40795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40810 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40824 */     GIR_RootConstrainSelectedInstOperands,
     /*  40825 */     // GIR_Coverage, 3907,
     /*  40825 */     GIR_EraseRootFromParent_Done,
     /*  40826 */   // Label 645: @40826
     /*  40826 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40889), // Rule ID 10012 //
     /*  40831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40850 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40853 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40869 */     // MIs[1] pred
     /*  40869 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40876 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40887 */     GIR_RootConstrainSelectedInstOperands,
     /*  40888 */     // GIR_Coverage, 10012,
     /*  40888 */     GIR_EraseRootFromParent_Done,
     /*  40889 */   // Label 646: @40889
     /*  40889 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(40952), // Rule ID 10013 //
     /*  40894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40913 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40916 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40925 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40932 */     // MIs[1] pred
     /*  40932 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40939 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40950 */     GIR_RootConstrainSelectedInstOperands,
     /*  40951 */     // GIR_Coverage, 10013,
     /*  40951 */     GIR_EraseRootFromParent_Done,
     /*  40952 */   // Label 647: @40952
     /*  40952 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41015), // Rule ID 10014 //
     /*  40957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40976 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40979 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  40988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40995 */     // MIs[1] pred
     /*  40995 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41002 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41013 */     GIR_RootConstrainSelectedInstOperands,
     /*  41014 */     // GIR_Coverage, 10014,
     /*  41014 */     GIR_EraseRootFromParent_Done,
     /*  41015 */   // Label 648: @41015
     /*  41015 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41078), // Rule ID 10015 //
     /*  41020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41039 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41042 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41051 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41058 */     // MIs[1] pred
     /*  41058 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41065 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41076 */     GIR_RootConstrainSelectedInstOperands,
     /*  41077 */     // GIR_Coverage, 10015,
     /*  41077 */     GIR_EraseRootFromParent_Done,
     /*  41078 */   // Label 649: @41078
     /*  41078 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41117), // Rule ID 1655 //
     /*  41083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41094 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41100 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41108 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41115 */     GIR_RootConstrainSelectedInstOperands,
     /*  41116 */     // GIR_Coverage, 1655,
     /*  41116 */     GIR_EraseRootFromParent_Done,
     /*  41117 */   // Label 650: @41117
     /*  41117 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41153), // Rule ID 5233 //
     /*  41122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41144 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41151 */     GIR_RootConstrainSelectedInstOperands,
     /*  41152 */     // GIR_Coverage, 5233,
     /*  41152 */     GIR_EraseRootFromParent_Done,
     /*  41153 */   // Label 651: @41153
     /*  41153 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41180), // Rule ID 1644 //
     /*  41158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41173 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41178 */     GIR_RootConstrainSelectedInstOperands,
     /*  41179 */     // GIR_Coverage, 1644,
     /*  41179 */     GIR_Done,
     /*  41180 */   // Label 652: @41180
     /*  41180 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41210), // Rule ID 3905 //
     /*  41185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41197 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41202 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41208 */     GIR_RootConstrainSelectedInstOperands,
     /*  41209 */     // GIR_Coverage, 3905,
     /*  41209 */     GIR_Done,
     /*  41210 */   // Label 653: @41210
     /*  41210 */   GIM_Reject,
     /*  41211 */ // Label 616: @41211
     /*  41211 */ GIM_Reject,
     /*  41212 */ // Label 589: @41212
     /*  41212 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(42702),
     /*  41217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41227 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41359), // Rule ID 5382 //
     /*  41232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41261 */     // MIs[1] Operand 2
     /*  41261 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41280 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41288 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41292 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41296 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41301 */     // MIs[3] Operand 2
     /*  41301 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41312 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41314 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41326 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41341 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41358 */     // GIR_Coverage, 5382,
     /*  41358 */     GIR_EraseRootFromParent_Done,
     /*  41359 */   // Label 655: @41359
     /*  41359 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41491), // Rule ID 5381 //
     /*  41364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41393 */     // MIs[1] Operand 2
     /*  41393 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41420 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41424 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41428 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41433 */     // MIs[3] Operand 2
     /*  41433 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41444 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41446 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41473 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41490 */     // GIR_Coverage, 5381,
     /*  41490 */     GIR_EraseRootFromParent_Done,
     /*  41491 */   // Label 656: @41491
     /*  41491 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41623), // Rule ID 5394 //
     /*  41496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41525 */     // MIs[1] Operand 2
     /*  41525 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41552 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41556 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41565 */     // MIs[3] Operand 2
     /*  41565 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41578 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41605 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41622 */     // GIR_Coverage, 5394,
     /*  41622 */     GIR_EraseRootFromParent_Done,
     /*  41623 */   // Label 657: @41623
     /*  41623 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(41755), // Rule ID 5380 //
     /*  41628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41657 */     // MIs[1] Operand 2
     /*  41657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41680 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41684 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41688 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41692 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41697 */     // MIs[3] Operand 2
     /*  41697 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41708 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41710 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41754 */     // GIR_Coverage, 5380,
     /*  41754 */     GIR_EraseRootFromParent_Done,
     /*  41755 */   // Label 658: @41755
     /*  41755 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41887), // Rule ID 5379 //
     /*  41760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41789 */     // MIs[1] Operand 2
     /*  41789 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41820 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41824 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41829 */     // MIs[3] Operand 2
     /*  41829 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41840 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41842 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41886 */     // GIR_Coverage, 5379,
     /*  41886 */     GIR_EraseRootFromParent_Done,
     /*  41887 */   // Label 659: @41887
     /*  41887 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42046), // Rule ID 5349 //
     /*  41892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41934 */     // MIs[1] Operand 2
     /*  41934 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41947 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41947 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  41950 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41954 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41961 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  41964 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41968 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41973 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41976 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41980 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41988 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42010 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42028 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42045 */     // GIR_Coverage, 5349,
     /*  42045 */     GIR_EraseRootFromParent_Done,
     /*  42046 */   // Label 660: @42046
     /*  42046 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42205), // Rule ID 5346 //
     /*  42051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42093 */     // MIs[1] Operand 2
     /*  42093 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42106 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42106 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42109 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42113 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42132 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42135 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42139 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42142 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42152 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42169 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42187 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42204 */     // GIR_Coverage, 5346,
     /*  42204 */     GIR_EraseRootFromParent_Done,
     /*  42205 */   // Label 661: @42205
     /*  42205 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42351), // Rule ID 5390 //
     /*  42210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42243 */     // MIs[1] Operand 2
     /*  42243 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42256 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42256 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42259 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42263 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42282 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42285 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42289 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42292 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42297 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42302 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42333 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42350 */     // GIR_Coverage, 5390,
     /*  42350 */     GIR_EraseRootFromParent_Done,
     /*  42351 */   // Label 662: @42351
     /*  42351 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42497), // Rule ID 5397 //
     /*  42356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42389 */     // MIs[1] Operand 2
     /*  42389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42402 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42402 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42405 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42409 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42416 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42419 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42423 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42428 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42431 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42435 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42438 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42448 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42465 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42479 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42496 */     // GIR_Coverage, 5397,
     /*  42496 */     GIR_EraseRootFromParent_Done,
     /*  42497 */   // Label 663: @42497
     /*  42497 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42643), // Rule ID 5389 //
     /*  42502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42535 */     // MIs[1] Operand 2
     /*  42535 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42548 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42548 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42551 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42555 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42574 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42577 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42581 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42611 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42625 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42642 */     // GIR_Coverage, 5389,
     /*  42642 */     GIR_EraseRootFromParent_Done,
     /*  42643 */   // Label 664: @42643
     /*  42643 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42678), // Rule ID 969 //
     /*  42648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42669 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42676 */     GIR_RootConstrainSelectedInstOperands,
     /*  42677 */     // GIR_Coverage, 969,
     /*  42677 */     GIR_EraseRootFromParent_Done,
     /*  42678 */   // Label 665: @42678
     /*  42678 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42701), // Rule ID 1476 //
     /*  42683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42694 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42699 */     GIR_RootConstrainSelectedInstOperands,
     /*  42700 */     // GIR_Coverage, 1476,
     /*  42700 */     GIR_Done,
     /*  42701 */   // Label 666: @42701
     /*  42701 */   GIM_Reject,
     /*  42702 */ // Label 654: @42702
     /*  42702 */ GIM_Reject,
     /*  42703 */ // Label 590: @42703
     /*  42703 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(45162),
     /*  42708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42718 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42832), // Rule ID 2048 //
     /*  42723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42774 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42787 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42791 */     // MIs[4] Operand 1
     /*  42791 */     // No operand predicates
     /*  42791 */     // MIs[2] Operand 2
     /*  42791 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42802 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42811 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42830 */     GIR_RootConstrainSelectedInstOperands,
     /*  42831 */     // GIR_Coverage, 2048,
     /*  42831 */     GIR_EraseRootFromParent_Done,
     /*  42832 */   // Label 668: @42832
     /*  42832 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42946), // Rule ID 13420 //
     /*  42837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42884 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42888 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42893 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42897 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42901 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42905 */     // MIs[4] Operand 1
     /*  42905 */     // No operand predicates
     /*  42905 */     // MIs[2] Operand 2
     /*  42905 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42916 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42925 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42944 */     GIR_RootConstrainSelectedInstOperands,
     /*  42945 */     // GIR_Coverage, 13420,
     /*  42945 */     GIR_EraseRootFromParent_Done,
     /*  42946 */   // Label 669: @42946
     /*  42946 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43060), // Rule ID 2100 //
     /*  42951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  42966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43002 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43015 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43019 */     // MIs[4] Operand 1
     /*  43019 */     // No operand predicates
     /*  43019 */     // MIs[2] Operand 2
     /*  43019 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43030 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43039 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43058 */     GIR_RootConstrainSelectedInstOperands,
     /*  43059 */     // GIR_Coverage, 2100,
     /*  43059 */     GIR_EraseRootFromParent_Done,
     /*  43060 */   // Label 670: @43060
     /*  43060 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43174), // Rule ID 13450 //
     /*  43065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43116 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43129 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43133 */     // MIs[4] Operand 1
     /*  43133 */     // No operand predicates
     /*  43133 */     // MIs[2] Operand 2
     /*  43133 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43144 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43153 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43172 */     GIR_RootConstrainSelectedInstOperands,
     /*  43173 */     // GIR_Coverage, 13450,
     /*  43173 */     GIR_EraseRootFromParent_Done,
     /*  43174 */   // Label 671: @43174
     /*  43174 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43239), // Rule ID 1855 //
     /*  43179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43215 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43222 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43237 */     GIR_RootConstrainSelectedInstOperands,
     /*  43238 */     // GIR_Coverage, 1855,
     /*  43238 */     GIR_EraseRootFromParent_Done,
     /*  43239 */   // Label 672: @43239
     /*  43239 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43304), // Rule ID 1854 //
     /*  43244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43287 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43302 */     GIR_RootConstrainSelectedInstOperands,
     /*  43303 */     // GIR_Coverage, 1854,
     /*  43303 */     GIR_EraseRootFromParent_Done,
     /*  43304 */   // Label 673: @43304
     /*  43304 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43369), // Rule ID 1759 //
     /*  43309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43352 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43367 */     GIR_RootConstrainSelectedInstOperands,
     /*  43368 */     // GIR_Coverage, 1759,
     /*  43368 */     GIR_EraseRootFromParent_Done,
     /*  43369 */   // Label 674: @43369
     /*  43369 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43434), // Rule ID 1853 //
     /*  43374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43410 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43417 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43432 */     GIR_RootConstrainSelectedInstOperands,
     /*  43433 */     // GIR_Coverage, 1853,
     /*  43433 */     GIR_EraseRootFromParent_Done,
     /*  43434 */   // Label 675: @43434
     /*  43434 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43499), // Rule ID 1852 //
     /*  43439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43482 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43497 */     GIR_RootConstrainSelectedInstOperands,
     /*  43498 */     // GIR_Coverage, 1852,
     /*  43498 */     GIR_EraseRootFromParent_Done,
     /*  43499 */   // Label 676: @43499
     /*  43499 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43610), // Rule ID 13418 //
     /*  43504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43547 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43551 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43564 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43568 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43572 */     // MIs[4] Operand 1
     /*  43572 */     // No operand predicates
     /*  43572 */     // MIs[2] Operand 2
     /*  43572 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43588 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43590 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43608 */     GIR_RootConstrainSelectedInstOperands,
     /*  43609 */     // GIR_Coverage, 13418,
     /*  43609 */     GIR_EraseRootFromParent_Done,
     /*  43610 */   // Label 677: @43610
     /*  43610 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(43721), // Rule ID 2046 //
     /*  43615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43671 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43684 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43688 */     // MIs[4] Operand 1
     /*  43688 */     // No operand predicates
     /*  43688 */     // MIs[2] Operand 2
     /*  43688 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43699 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43701 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43719 */     GIR_RootConstrainSelectedInstOperands,
     /*  43720 */     // GIR_Coverage, 2046,
     /*  43720 */     GIR_EraseRootFromParent_Done,
     /*  43721 */   // Label 678: @43721
     /*  43721 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(43832), // Rule ID 13448 //
     /*  43726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43769 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43773 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43777 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43782 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43786 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43790 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43794 */     // MIs[4] Operand 1
     /*  43794 */     // No operand predicates
     /*  43794 */     // MIs[2] Operand 2
     /*  43794 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43810 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43812 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43830 */     GIR_RootConstrainSelectedInstOperands,
     /*  43831 */     // GIR_Coverage, 13448,
     /*  43831 */     GIR_EraseRootFromParent_Done,
     /*  43832 */   // Label 679: @43832
     /*  43832 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(43943), // Rule ID 2098 //
     /*  43837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43889 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43893 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43898 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43902 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43906 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43910 */     // MIs[4] Operand 1
     /*  43910 */     // No operand predicates
     /*  43910 */     // MIs[2] Operand 2
     /*  43910 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43921 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43923 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43941 */     GIR_RootConstrainSelectedInstOperands,
     /*  43942 */     // GIR_Coverage, 2098,
     /*  43942 */     GIR_EraseRootFromParent_Done,
     /*  43943 */   // Label 680: @43943
     /*  43943 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44006), // Rule ID 1735 //
     /*  43948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43987 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  43990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44004 */     GIR_RootConstrainSelectedInstOperands,
     /*  44005 */     // GIR_Coverage, 1735,
     /*  44005 */     GIR_EraseRootFromParent_Done,
     /*  44006 */   // Label 681: @44006
     /*  44006 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44069), // Rule ID 1825 //
     /*  44011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44050 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44067 */     GIR_RootConstrainSelectedInstOperands,
     /*  44068 */     // GIR_Coverage, 1825,
     /*  44068 */     GIR_EraseRootFromParent_Done,
     /*  44069 */   // Label 682: @44069
     /*  44069 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44157), // Rule ID 13419 //
     /*  44074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44126 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44130 */     // MIs[3] Operand 1
     /*  44130 */     // No operand predicates
     /*  44130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44155 */     GIR_RootConstrainSelectedInstOperands,
     /*  44156 */     // GIR_Coverage, 13419,
     /*  44156 */     GIR_EraseRootFromParent_Done,
     /*  44157 */   // Label 683: @44157
     /*  44157 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44245), // Rule ID 2047 //
     /*  44162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44219 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44223 */     // MIs[3] Operand 1
     /*  44223 */     // No operand predicates
     /*  44223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44225 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44243 */     GIR_RootConstrainSelectedInstOperands,
     /*  44244 */     // GIR_Coverage, 2047,
     /*  44244 */     GIR_EraseRootFromParent_Done,
     /*  44245 */   // Label 684: @44245
     /*  44245 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44333), // Rule ID 13449 //
     /*  44250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44302 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44306 */     // MIs[3] Operand 1
     /*  44306 */     // No operand predicates
     /*  44306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44311 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44313 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44331 */     GIR_RootConstrainSelectedInstOperands,
     /*  44332 */     // GIR_Coverage, 13449,
     /*  44332 */     GIR_EraseRootFromParent_Done,
     /*  44333 */   // Label 685: @44333
     /*  44333 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44421), // Rule ID 2099 //
     /*  44338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44395 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44399 */     // MIs[3] Operand 1
     /*  44399 */     // No operand predicates
     /*  44399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44401 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44419 */     GIR_RootConstrainSelectedInstOperands,
     /*  44420 */     // GIR_Coverage, 2099,
     /*  44420 */     GIR_EraseRootFromParent_Done,
     /*  44421 */   // Label 686: @44421
     /*  44421 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44468), // Rule ID 1867 //
     /*  44426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44454 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44466 */     GIR_RootConstrainSelectedInstOperands,
     /*  44467 */     // GIR_Coverage, 1867,
     /*  44467 */     GIR_EraseRootFromParent_Done,
     /*  44468 */   // Label 687: @44468
     /*  44468 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44515), // Rule ID 1765 //
     /*  44473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44501 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44513 */     GIR_RootConstrainSelectedInstOperands,
     /*  44514 */     // GIR_Coverage, 1765,
     /*  44514 */     GIR_EraseRootFromParent_Done,
     /*  44515 */   // Label 688: @44515
     /*  44515 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44562), // Rule ID 1866 //
     /*  44520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44548 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44560 */     GIR_RootConstrainSelectedInstOperands,
     /*  44561 */     // GIR_Coverage, 1866,
     /*  44561 */     GIR_EraseRootFromParent_Done,
     /*  44562 */   // Label 689: @44562
     /*  44562 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44621), // Rule ID 1851 //
     /*  44567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44606 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44619 */     GIR_RootConstrainSelectedInstOperands,
     /*  44620 */     // GIR_Coverage, 1851,
     /*  44620 */     GIR_EraseRootFromParent_Done,
     /*  44621 */   // Label 690: @44621
     /*  44621 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44680), // Rule ID 1850 //
     /*  44626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44665 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44678 */     GIR_RootConstrainSelectedInstOperands,
     /*  44679 */     // GIR_Coverage, 1850,
     /*  44679 */     GIR_EraseRootFromParent_Done,
     /*  44680 */   // Label 691: @44680
     /*  44680 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44739), // Rule ID 1758 //
     /*  44685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44724 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44737 */     GIR_RootConstrainSelectedInstOperands,
     /*  44738 */     // GIR_Coverage, 1758,
     /*  44738 */     GIR_EraseRootFromParent_Done,
     /*  44739 */   // Label 692: @44739
     /*  44739 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44798), // Rule ID 1849 //
     /*  44744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44783 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44796 */     GIR_RootConstrainSelectedInstOperands,
     /*  44797 */     // GIR_Coverage, 1849,
     /*  44797 */     GIR_EraseRootFromParent_Done,
     /*  44798 */   // Label 693: @44798
     /*  44798 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44857), // Rule ID 1848 //
     /*  44803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44842 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44855 */     GIR_RootConstrainSelectedInstOperands,
     /*  44856 */     // GIR_Coverage, 1848,
     /*  44856 */     GIR_EraseRootFromParent_Done,
     /*  44857 */   // Label 694: @44857
     /*  44857 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44892), // Rule ID 971 //
     /*  44862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44869 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44875 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44883 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44890 */     GIR_RootConstrainSelectedInstOperands,
     /*  44891 */     // GIR_Coverage, 971,
     /*  44891 */     GIR_EraseRootFromParent_Done,
     /*  44892 */   // Label 695: @44892
     /*  44892 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(44949), // Rule ID 1734 //
     /*  44897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44932 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  44947 */     GIR_RootConstrainSelectedInstOperands,
     /*  44948 */     // GIR_Coverage, 1734,
     /*  44948 */     GIR_EraseRootFromParent_Done,
     /*  44949 */   // Label 696: @44949
     /*  44949 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45006), // Rule ID 1824 //
     /*  44954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44989 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  44992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45004 */     GIR_RootConstrainSelectedInstOperands,
     /*  45005 */     // GIR_Coverage, 1824,
     /*  45005 */     GIR_EraseRootFromParent_Done,
     /*  45006 */   // Label 697: @45006
     /*  45006 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45050), // Rule ID 1865 //
     /*  45011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45037 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45048 */     GIR_RootConstrainSelectedInstOperands,
     /*  45049 */     // GIR_Coverage, 1865,
     /*  45049 */     GIR_EraseRootFromParent_Done,
     /*  45050 */   // Label 698: @45050
     /*  45050 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45094), // Rule ID 1764 //
     /*  45055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45081 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45092 */     GIR_RootConstrainSelectedInstOperands,
     /*  45093 */     // GIR_Coverage, 1764,
     /*  45093 */     GIR_EraseRootFromParent_Done,
     /*  45094 */   // Label 699: @45094
     /*  45094 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45138), // Rule ID 1864 //
     /*  45099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45125 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45136 */     GIR_RootConstrainSelectedInstOperands,
     /*  45137 */     // GIR_Coverage, 1864,
     /*  45137 */     GIR_EraseRootFromParent_Done,
     /*  45138 */   // Label 700: @45138
     /*  45138 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45161), // Rule ID 1478 //
     /*  45143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45154 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45159 */     GIR_RootConstrainSelectedInstOperands,
     /*  45160 */     // GIR_Coverage, 1478,
     /*  45160 */     GIR_Done,
     /*  45161 */   // Label 701: @45161
     /*  45161 */   GIM_Reject,
     /*  45162 */ // Label 667: @45162
     /*  45162 */ GIM_Reject,
     /*  45163 */ // Label 591: @45163
     /*  45163 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(46653),
     /*  45168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45178 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45310), // Rule ID 5378 //
     /*  45183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45212 */     // MIs[1] Operand 2
     /*  45212 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45231 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45235 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45239 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45243 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45247 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45252 */     // MIs[3] Operand 2
     /*  45252 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45263 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45265 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45292 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45309 */     // GIR_Coverage, 5378,
     /*  45309 */     GIR_EraseRootFromParent_Done,
     /*  45310 */   // Label 703: @45310
     /*  45310 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45442), // Rule ID 5377 //
     /*  45315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45344 */     // MIs[1] Operand 2
     /*  45344 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45363 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45367 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45371 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45375 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45379 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45384 */     // MIs[3] Operand 2
     /*  45384 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45395 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45397 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45409 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45424 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45441 */     // GIR_Coverage, 5377,
     /*  45441 */     GIR_EraseRootFromParent_Done,
     /*  45442 */   // Label 704: @45442
     /*  45442 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45574), // Rule ID 5393 //
     /*  45447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45476 */     // MIs[1] Operand 2
     /*  45476 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45507 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45511 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45516 */     // MIs[3] Operand 2
     /*  45516 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45527 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45529 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45556 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45573 */     // GIR_Coverage, 5393,
     /*  45573 */     GIR_EraseRootFromParent_Done,
     /*  45574 */   // Label 705: @45574
     /*  45574 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(45706), // Rule ID 5376 //
     /*  45579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45608 */     // MIs[1] Operand 2
     /*  45608 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45627 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45631 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45635 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45639 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45643 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45648 */     // MIs[3] Operand 2
     /*  45648 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45659 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45661 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45688 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45705 */     // GIR_Coverage, 5376,
     /*  45705 */     GIR_EraseRootFromParent_Done,
     /*  45706 */   // Label 706: @45706
     /*  45706 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45838), // Rule ID 5375 //
     /*  45711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45740 */     // MIs[1] Operand 2
     /*  45740 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45763 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45767 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45771 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45775 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45780 */     // MIs[3] Operand 2
     /*  45780 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45791 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45793 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45820 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45837 */     // GIR_Coverage, 5375,
     /*  45837 */     GIR_EraseRootFromParent_Done,
     /*  45838 */   // Label 707: @45838
     /*  45838 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45997), // Rule ID 5348 //
     /*  45843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45885 */     // MIs[1] Operand 2
     /*  45885 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45898 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45924 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45931 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  45956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  45972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45979 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45996 */     // GIR_Coverage, 5348,
     /*  45996 */     GIR_EraseRootFromParent_Done,
     /*  45997 */   // Label 708: @45997
     /*  45997 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46156), // Rule ID 5345 //
     /*  46002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46044 */     // MIs[1] Operand 2
     /*  46044 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46057 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46057 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46060 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46064 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46083 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46090 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46138 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46155 */     // GIR_Coverage, 5345,
     /*  46155 */     GIR_EraseRootFromParent_Done,
     /*  46156 */   // Label 709: @46156
     /*  46156 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46302), // Rule ID 5388 //
     /*  46161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46194 */     // MIs[1] Operand 2
     /*  46194 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46207 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46207 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46210 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46214 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46221 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46224 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46228 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46233 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46236 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46240 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46270 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46284 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46301 */     // GIR_Coverage, 5388,
     /*  46301 */     GIR_EraseRootFromParent_Done,
     /*  46302 */   // Label 710: @46302
     /*  46302 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46448), // Rule ID 5396 //
     /*  46307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46340 */     // MIs[1] Operand 2
     /*  46340 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46353 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46353 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46356 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46360 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46379 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46382 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46386 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46389 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46394 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46399 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46430 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46447 */     // GIR_Coverage, 5396,
     /*  46447 */     GIR_EraseRootFromParent_Done,
     /*  46448 */   // Label 711: @46448
     /*  46448 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46594), // Rule ID 5387 //
     /*  46453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46486 */     // MIs[1] Operand 2
     /*  46486 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46499 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46525 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46532 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46535 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46540 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46545 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46593 */     // GIR_Coverage, 5387,
     /*  46593 */     GIR_EraseRootFromParent_Done,
     /*  46594 */   // Label 712: @46594
     /*  46594 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46629), // Rule ID 967 //
     /*  46599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46606 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46620 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46627 */     GIR_RootConstrainSelectedInstOperands,
     /*  46628 */     // GIR_Coverage, 967,
     /*  46628 */     GIR_EraseRootFromParent_Done,
     /*  46629 */   // Label 713: @46629
     /*  46629 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46652), // Rule ID 1474 //
     /*  46634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46645 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46650 */     GIR_RootConstrainSelectedInstOperands,
     /*  46651 */     // GIR_Coverage, 1474,
     /*  46651 */     GIR_Done,
     /*  46652 */   // Label 714: @46652
     /*  46652 */   GIM_Reject,
     /*  46653 */ // Label 702: @46653
     /*  46653 */ GIM_Reject,
     /*  46654 */ // Label 592: @46654
     /*  46654 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(49113),
     /*  46659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46669 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46783), // Rule ID 2045 //
     /*  46674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46717 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46721 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46725 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46738 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46742 */     // MIs[4] Operand 1
     /*  46742 */     // No operand predicates
     /*  46742 */     // MIs[2] Operand 2
     /*  46742 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46762 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46781 */     GIR_RootConstrainSelectedInstOperands,
     /*  46782 */     // GIR_Coverage, 2045,
     /*  46782 */     GIR_EraseRootFromParent_Done,
     /*  46783 */   // Label 716: @46783
     /*  46783 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46897), // Rule ID 13417 //
     /*  46788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46839 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46844 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46848 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46852 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46856 */     // MIs[4] Operand 1
     /*  46856 */     // No operand predicates
     /*  46856 */     // MIs[2] Operand 2
     /*  46856 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46867 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46876 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46895 */     GIR_RootConstrainSelectedInstOperands,
     /*  46896 */     // GIR_Coverage, 13417,
     /*  46896 */     GIR_EraseRootFromParent_Done,
     /*  46897 */   // Label 717: @46897
     /*  46897 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47011), // Rule ID 2097 //
     /*  46902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46945 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46949 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46953 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46962 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46966 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46970 */     // MIs[4] Operand 1
     /*  46970 */     // No operand predicates
     /*  46970 */     // MIs[2] Operand 2
     /*  46970 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46981 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46990 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  46993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47009 */     GIR_RootConstrainSelectedInstOperands,
     /*  47010 */     // GIR_Coverage, 2097,
     /*  47010 */     GIR_EraseRootFromParent_Done,
     /*  47011 */   // Label 718: @47011
     /*  47011 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47125), // Rule ID 13447 //
     /*  47016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47059 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47063 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47067 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47076 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47080 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47084 */     // MIs[4] Operand 1
     /*  47084 */     // No operand predicates
     /*  47084 */     // MIs[2] Operand 2
     /*  47084 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47095 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47104 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47123 */     GIR_RootConstrainSelectedInstOperands,
     /*  47124 */     // GIR_Coverage, 13447,
     /*  47124 */     GIR_EraseRootFromParent_Done,
     /*  47125 */   // Label 719: @47125
     /*  47125 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47190), // Rule ID 1847 //
     /*  47130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47173 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47188 */     GIR_RootConstrainSelectedInstOperands,
     /*  47189 */     // GIR_Coverage, 1847,
     /*  47189 */     GIR_EraseRootFromParent_Done,
     /*  47190 */   // Label 720: @47190
     /*  47190 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47255), // Rule ID 1846 //
     /*  47195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47224 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47238 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47253 */     GIR_RootConstrainSelectedInstOperands,
     /*  47254 */     // GIR_Coverage, 1846,
     /*  47254 */     GIR_EraseRootFromParent_Done,
     /*  47255 */   // Label 721: @47255
     /*  47255 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47320), // Rule ID 1757 //
     /*  47260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47303 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47318 */     GIR_RootConstrainSelectedInstOperands,
     /*  47319 */     // GIR_Coverage, 1757,
     /*  47319 */     GIR_EraseRootFromParent_Done,
     /*  47320 */   // Label 722: @47320
     /*  47320 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47385), // Rule ID 1845 //
     /*  47325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47361 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47368 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47383 */     GIR_RootConstrainSelectedInstOperands,
     /*  47384 */     // GIR_Coverage, 1845,
     /*  47384 */     GIR_EraseRootFromParent_Done,
     /*  47385 */   // Label 723: @47385
     /*  47385 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47450), // Rule ID 1844 //
     /*  47390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47419 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47433 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47448 */     GIR_RootConstrainSelectedInstOperands,
     /*  47449 */     // GIR_Coverage, 1844,
     /*  47449 */     GIR_EraseRootFromParent_Done,
     /*  47450 */   // Label 724: @47450
     /*  47450 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47561), // Rule ID 13415 //
     /*  47455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47502 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47506 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47511 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47515 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47519 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47523 */     // MIs[4] Operand 1
     /*  47523 */     // No operand predicates
     /*  47523 */     // MIs[2] Operand 2
     /*  47523 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47539 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47541 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47559 */     GIR_RootConstrainSelectedInstOperands,
     /*  47560 */     // GIR_Coverage, 13415,
     /*  47560 */     GIR_EraseRootFromParent_Done,
     /*  47561 */   // Label 725: @47561
     /*  47561 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(47672), // Rule ID 2043 //
     /*  47566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47635 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47639 */     // MIs[4] Operand 1
     /*  47639 */     // No operand predicates
     /*  47639 */     // MIs[2] Operand 2
     /*  47639 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47652 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47670 */     GIR_RootConstrainSelectedInstOperands,
     /*  47671 */     // GIR_Coverage, 2043,
     /*  47671 */     GIR_EraseRootFromParent_Done,
     /*  47672 */   // Label 726: @47672
     /*  47672 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(47783), // Rule ID 13445 //
     /*  47677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47720 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47724 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47728 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47733 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47737 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47741 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47745 */     // MIs[4] Operand 1
     /*  47745 */     // No operand predicates
     /*  47745 */     // MIs[2] Operand 2
     /*  47745 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47763 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47781 */     GIR_RootConstrainSelectedInstOperands,
     /*  47782 */     // GIR_Coverage, 13445,
     /*  47782 */     GIR_EraseRootFromParent_Done,
     /*  47783 */   // Label 727: @47783
     /*  47783 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(47894), // Rule ID 2095 //
     /*  47788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47840 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47844 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47849 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47853 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47857 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47861 */     // MIs[4] Operand 1
     /*  47861 */     // No operand predicates
     /*  47861 */     // MIs[2] Operand 2
     /*  47861 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47872 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47874 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47892 */     GIR_RootConstrainSelectedInstOperands,
     /*  47893 */     // GIR_Coverage, 2095,
     /*  47893 */     GIR_EraseRootFromParent_Done,
     /*  47894 */   // Label 728: @47894
     /*  47894 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(47957), // Rule ID 1733 //
     /*  47899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47938 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47955 */     GIR_RootConstrainSelectedInstOperands,
     /*  47956 */     // GIR_Coverage, 1733,
     /*  47956 */     GIR_EraseRootFromParent_Done,
     /*  47957 */   // Label 729: @47957
     /*  47957 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48020), // Rule ID 1823 //
     /*  47962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47994 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48001 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48018 */     GIR_RootConstrainSelectedInstOperands,
     /*  48019 */     // GIR_Coverage, 1823,
     /*  48019 */     GIR_EraseRootFromParent_Done,
     /*  48020 */   // Label 730: @48020
     /*  48020 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48108), // Rule ID 13416 //
     /*  48025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48077 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48081 */     // MIs[3] Operand 1
     /*  48081 */     // No operand predicates
     /*  48081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48106 */     GIR_RootConstrainSelectedInstOperands,
     /*  48107 */     // GIR_Coverage, 13416,
     /*  48107 */     GIR_EraseRootFromParent_Done,
     /*  48108 */   // Label 731: @48108
     /*  48108 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48196), // Rule ID 2044 //
     /*  48113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48170 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48174 */     // MIs[3] Operand 1
     /*  48174 */     // No operand predicates
     /*  48174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48176 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48194 */     GIR_RootConstrainSelectedInstOperands,
     /*  48195 */     // GIR_Coverage, 2044,
     /*  48195 */     GIR_EraseRootFromParent_Done,
     /*  48196 */   // Label 732: @48196
     /*  48196 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48284), // Rule ID 13446 //
     /*  48201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48253 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48257 */     // MIs[3] Operand 1
     /*  48257 */     // No operand predicates
     /*  48257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48264 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48282 */     GIR_RootConstrainSelectedInstOperands,
     /*  48283 */     // GIR_Coverage, 13446,
     /*  48283 */     GIR_EraseRootFromParent_Done,
     /*  48284 */   // Label 733: @48284
     /*  48284 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48372), // Rule ID 2096 //
     /*  48289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48346 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48350 */     // MIs[3] Operand 1
     /*  48350 */     // No operand predicates
     /*  48350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48352 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48370 */     GIR_RootConstrainSelectedInstOperands,
     /*  48371 */     // GIR_Coverage, 2096,
     /*  48371 */     GIR_EraseRootFromParent_Done,
     /*  48372 */   // Label 734: @48372
     /*  48372 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48419), // Rule ID 1863 //
     /*  48377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48405 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48417 */     GIR_RootConstrainSelectedInstOperands,
     /*  48418 */     // GIR_Coverage, 1863,
     /*  48418 */     GIR_EraseRootFromParent_Done,
     /*  48419 */   // Label 735: @48419
     /*  48419 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48466), // Rule ID 1763 //
     /*  48424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48452 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48464 */     GIR_RootConstrainSelectedInstOperands,
     /*  48465 */     // GIR_Coverage, 1763,
     /*  48465 */     GIR_EraseRootFromParent_Done,
     /*  48466 */   // Label 736: @48466
     /*  48466 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48513), // Rule ID 1862 //
     /*  48471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48499 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48504 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48511 */     GIR_RootConstrainSelectedInstOperands,
     /*  48512 */     // GIR_Coverage, 1862,
     /*  48512 */     GIR_EraseRootFromParent_Done,
     /*  48513 */   // Label 737: @48513
     /*  48513 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48572), // Rule ID 1843 //
     /*  48518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48557 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48570 */     GIR_RootConstrainSelectedInstOperands,
     /*  48571 */     // GIR_Coverage, 1843,
     /*  48571 */     GIR_EraseRootFromParent_Done,
     /*  48572 */   // Label 738: @48572
     /*  48572 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48631), // Rule ID 1842 //
     /*  48577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48616 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48629 */     GIR_RootConstrainSelectedInstOperands,
     /*  48630 */     // GIR_Coverage, 1842,
     /*  48630 */     GIR_EraseRootFromParent_Done,
     /*  48631 */   // Label 739: @48631
     /*  48631 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48690), // Rule ID 1756 //
     /*  48636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48675 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48688 */     GIR_RootConstrainSelectedInstOperands,
     /*  48689 */     // GIR_Coverage, 1756,
     /*  48689 */     GIR_EraseRootFromParent_Done,
     /*  48690 */   // Label 740: @48690
     /*  48690 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48749), // Rule ID 1841 //
     /*  48695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48734 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48747 */     GIR_RootConstrainSelectedInstOperands,
     /*  48748 */     // GIR_Coverage, 1841,
     /*  48748 */     GIR_EraseRootFromParent_Done,
     /*  48749 */   // Label 741: @48749
     /*  48749 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(48808), // Rule ID 1840 //
     /*  48754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48793 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48806 */     GIR_RootConstrainSelectedInstOperands,
     /*  48807 */     // GIR_Coverage, 1840,
     /*  48807 */     GIR_EraseRootFromParent_Done,
     /*  48808 */   // Label 742: @48808
     /*  48808 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(48843), // Rule ID 970 //
     /*  48813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48820 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48826 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48834 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48841 */     GIR_RootConstrainSelectedInstOperands,
     /*  48842 */     // GIR_Coverage, 970,
     /*  48842 */     GIR_EraseRootFromParent_Done,
     /*  48843 */   // Label 743: @48843
     /*  48843 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(48900), // Rule ID 1732 //
     /*  48848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48883 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48898 */     GIR_RootConstrainSelectedInstOperands,
     /*  48899 */     // GIR_Coverage, 1732,
     /*  48899 */     GIR_EraseRootFromParent_Done,
     /*  48900 */   // Label 744: @48900
     /*  48900 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(48957), // Rule ID 1822 //
     /*  48905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48940 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48955 */     GIR_RootConstrainSelectedInstOperands,
     /*  48956 */     // GIR_Coverage, 1822,
     /*  48956 */     GIR_EraseRootFromParent_Done,
     /*  48957 */   // Label 745: @48957
     /*  48957 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49001), // Rule ID 1861 //
     /*  48962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48988 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  48991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  48999 */     GIR_RootConstrainSelectedInstOperands,
     /*  49000 */     // GIR_Coverage, 1861,
     /*  49000 */     GIR_EraseRootFromParent_Done,
     /*  49001 */   // Label 746: @49001
     /*  49001 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49045), // Rule ID 1762 //
     /*  49006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49032 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49043 */     GIR_RootConstrainSelectedInstOperands,
     /*  49044 */     // GIR_Coverage, 1762,
     /*  49044 */     GIR_EraseRootFromParent_Done,
     /*  49045 */   // Label 747: @49045
     /*  49045 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49089), // Rule ID 1860 //
     /*  49050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49076 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49087 */     GIR_RootConstrainSelectedInstOperands,
     /*  49088 */     // GIR_Coverage, 1860,
     /*  49088 */     GIR_EraseRootFromParent_Done,
     /*  49089 */   // Label 748: @49089
     /*  49089 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49112), // Rule ID 1477 //
     /*  49094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49105 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49110 */     GIR_RootConstrainSelectedInstOperands,
     /*  49111 */     // GIR_Coverage, 1477,
     /*  49111 */     GIR_Done,
     /*  49112 */   // Label 749: @49112
     /*  49112 */   GIM_Reject,
     /*  49113 */ // Label 715: @49113
     /*  49113 */ GIM_Reject,
     /*  49114 */ // Label 593: @49114
     /*  49114 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49188),
     /*  49119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49129 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49164), // Rule ID 965 //
     /*  49134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49155 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49162 */     GIR_RootConstrainSelectedInstOperands,
     /*  49163 */     // GIR_Coverage, 965,
     /*  49163 */     GIR_EraseRootFromParent_Done,
     /*  49164 */   // Label 751: @49164
     /*  49164 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49187), // Rule ID 1472 //
     /*  49169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49180 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49185 */     GIR_RootConstrainSelectedInstOperands,
     /*  49186 */     // GIR_Coverage, 1472,
     /*  49186 */     GIR_Done,
     /*  49187 */   // Label 752: @49187
     /*  49187 */   GIM_Reject,
     /*  49188 */ // Label 750: @49188
     /*  49188 */ GIM_Reject,
     /*  49189 */ // Label 594: @49189
     /*  49189 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(50396),
     /*  49194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49204 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49269), // Rule ID 1839 //
     /*  49209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49238 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49252 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49267 */     GIR_RootConstrainSelectedInstOperands,
     /*  49268 */     // GIR_Coverage, 1839,
     /*  49268 */     GIR_EraseRootFromParent_Done,
     /*  49269 */   // Label 754: @49269
     /*  49269 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49334), // Rule ID 1838 //
     /*  49274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49310 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49317 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49332 */     GIR_RootConstrainSelectedInstOperands,
     /*  49333 */     // GIR_Coverage, 1838,
     /*  49333 */     GIR_EraseRootFromParent_Done,
     /*  49334 */   // Label 755: @49334
     /*  49334 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49399), // Rule ID 1755 //
     /*  49339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49382 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49397 */     GIR_RootConstrainSelectedInstOperands,
     /*  49398 */     // GIR_Coverage, 1755,
     /*  49398 */     GIR_EraseRootFromParent_Done,
     /*  49399 */   // Label 756: @49399
     /*  49399 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49464), // Rule ID 1837 //
     /*  49404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49447 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49462 */     GIR_RootConstrainSelectedInstOperands,
     /*  49463 */     // GIR_Coverage, 1837,
     /*  49463 */     GIR_EraseRootFromParent_Done,
     /*  49464 */   // Label 757: @49464
     /*  49464 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49529), // Rule ID 1836 //
     /*  49469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49505 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49512 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49527 */     GIR_RootConstrainSelectedInstOperands,
     /*  49528 */     // GIR_Coverage, 1836,
     /*  49528 */     GIR_EraseRootFromParent_Done,
     /*  49529 */   // Label 758: @49529
     /*  49529 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49592), // Rule ID 1731 //
     /*  49534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49573 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49590 */     GIR_RootConstrainSelectedInstOperands,
     /*  49591 */     // GIR_Coverage, 1731,
     /*  49591 */     GIR_EraseRootFromParent_Done,
     /*  49592 */   // Label 759: @49592
     /*  49592 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49655), // Rule ID 1821 //
     /*  49597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49636 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49653 */     GIR_RootConstrainSelectedInstOperands,
     /*  49654 */     // GIR_Coverage, 1821,
     /*  49654 */     GIR_EraseRootFromParent_Done,
     /*  49655 */   // Label 760: @49655
     /*  49655 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49702), // Rule ID 1859 //
     /*  49660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49688 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49700 */     GIR_RootConstrainSelectedInstOperands,
     /*  49701 */     // GIR_Coverage, 1859,
     /*  49701 */     GIR_EraseRootFromParent_Done,
     /*  49702 */   // Label 761: @49702
     /*  49702 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49749), // Rule ID 1761 //
     /*  49707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49728 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49735 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49747 */     GIR_RootConstrainSelectedInstOperands,
     /*  49748 */     // GIR_Coverage, 1761,
     /*  49748 */     GIR_EraseRootFromParent_Done,
     /*  49749 */   // Label 762: @49749
     /*  49749 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(49796), // Rule ID 1858 //
     /*  49754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49782 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49794 */     GIR_RootConstrainSelectedInstOperands,
     /*  49795 */     // GIR_Coverage, 1858,
     /*  49795 */     GIR_EraseRootFromParent_Done,
     /*  49796 */   // Label 763: @49796
     /*  49796 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(49855), // Rule ID 1835 //
     /*  49801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49840 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49853 */     GIR_RootConstrainSelectedInstOperands,
     /*  49854 */     // GIR_Coverage, 1835,
     /*  49854 */     GIR_EraseRootFromParent_Done,
     /*  49855 */   // Label 764: @49855
     /*  49855 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(49914), // Rule ID 1834 //
     /*  49860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49899 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49912 */     GIR_RootConstrainSelectedInstOperands,
     /*  49913 */     // GIR_Coverage, 1834,
     /*  49913 */     GIR_EraseRootFromParent_Done,
     /*  49914 */   // Label 765: @49914
     /*  49914 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(49973), // Rule ID 1754 //
     /*  49919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49958 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  49961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49971 */     GIR_RootConstrainSelectedInstOperands,
     /*  49972 */     // GIR_Coverage, 1754,
     /*  49972 */     GIR_EraseRootFromParent_Done,
     /*  49973 */   // Label 766: @49973
     /*  49973 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50032), // Rule ID 1833 //
     /*  49978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50017 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50030 */     GIR_RootConstrainSelectedInstOperands,
     /*  50031 */     // GIR_Coverage, 1833,
     /*  50031 */     GIR_EraseRootFromParent_Done,
     /*  50032 */   // Label 767: @50032
     /*  50032 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50091), // Rule ID 1832 //
     /*  50037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50076 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50089 */     GIR_RootConstrainSelectedInstOperands,
     /*  50090 */     // GIR_Coverage, 1832,
     /*  50090 */     GIR_EraseRootFromParent_Done,
     /*  50091 */   // Label 768: @50091
     /*  50091 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50126), // Rule ID 968 //
     /*  50096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50103 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50109 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50117 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50124 */     GIR_RootConstrainSelectedInstOperands,
     /*  50125 */     // GIR_Coverage, 968,
     /*  50125 */     GIR_EraseRootFromParent_Done,
     /*  50126 */   // Label 769: @50126
     /*  50126 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50183), // Rule ID 1730 //
     /*  50131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50166 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50181 */     GIR_RootConstrainSelectedInstOperands,
     /*  50182 */     // GIR_Coverage, 1730,
     /*  50182 */     GIR_EraseRootFromParent_Done,
     /*  50183 */   // Label 770: @50183
     /*  50183 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50240), // Rule ID 1820 //
     /*  50188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50223 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50238 */     GIR_RootConstrainSelectedInstOperands,
     /*  50239 */     // GIR_Coverage, 1820,
     /*  50239 */     GIR_EraseRootFromParent_Done,
     /*  50240 */   // Label 771: @50240
     /*  50240 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50284), // Rule ID 1857 //
     /*  50245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50271 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50282 */     GIR_RootConstrainSelectedInstOperands,
     /*  50283 */     // GIR_Coverage, 1857,
     /*  50283 */     GIR_EraseRootFromParent_Done,
     /*  50284 */   // Label 772: @50284
     /*  50284 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50328), // Rule ID 1760 //
     /*  50289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50315 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50326 */     GIR_RootConstrainSelectedInstOperands,
     /*  50327 */     // GIR_Coverage, 1760,
     /*  50327 */     GIR_EraseRootFromParent_Done,
     /*  50328 */   // Label 773: @50328
     /*  50328 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50372), // Rule ID 1856 //
     /*  50333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50359 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50370 */     GIR_RootConstrainSelectedInstOperands,
     /*  50371 */     // GIR_Coverage, 1856,
     /*  50371 */     GIR_EraseRootFromParent_Done,
     /*  50372 */   // Label 774: @50372
     /*  50372 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50395), // Rule ID 1475 //
     /*  50377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50388 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50393 */     GIR_RootConstrainSelectedInstOperands,
     /*  50394 */     // GIR_Coverage, 1475,
     /*  50394 */     GIR_Done,
     /*  50395 */   // Label 775: @50395
     /*  50395 */   GIM_Reject,
     /*  50396 */ // Label 753: @50396
     /*  50396 */ GIM_Reject,
     /*  50397 */ // Label 595: @50397
     /*  50397 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50471),
     /*  50402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50412 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50447), // Rule ID 966 //
     /*  50417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50430 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50438 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50445 */     GIR_RootConstrainSelectedInstOperands,
     /*  50446 */     // GIR_Coverage, 966,
     /*  50446 */     GIR_EraseRootFromParent_Done,
     /*  50447 */   // Label 777: @50447
     /*  50447 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50470), // Rule ID 1473 //
     /*  50452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50463 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50468 */     GIR_RootConstrainSelectedInstOperands,
     /*  50469 */     // GIR_Coverage, 1473,
     /*  50469 */     GIR_Done,
     /*  50470 */   // Label 778: @50470
     /*  50470 */   GIM_Reject,
     /*  50471 */ // Label 776: @50471
     /*  50471 */ GIM_Reject,
     /*  50472 */ // Label 596: @50472
     /*  50472 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50497), // Rule ID 7386 //
     /*  50477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50490 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50495 */   GIR_RootConstrainSelectedInstOperands,
     /*  50496 */   // GIR_Coverage, 7386,
     /*  50496 */   GIR_Done,
     /*  50497 */ // Label 779: @50497
     /*  50497 */ GIM_Reject,
     /*  50498 */ // Label 597: @50498
     /*  50498 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(50523), // Rule ID 7385 //
     /*  50503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50516 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50521 */   GIR_RootConstrainSelectedInstOperands,
     /*  50522 */   // GIR_Coverage, 7385,
     /*  50522 */   GIR_Done,
     /*  50523 */ // Label 780: @50523
     /*  50523 */ GIM_Reject,
     /*  50524 */ // Label 598: @50524
     /*  50524 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(50549), // Rule ID 7384 //
     /*  50529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50542 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50547 */   GIR_RootConstrainSelectedInstOperands,
     /*  50548 */   // GIR_Coverage, 7384,
     /*  50548 */   GIR_Done,
     /*  50549 */ // Label 781: @50549
     /*  50549 */ GIM_Reject,
     /*  50550 */ // Label 599: @50550
     /*  50550 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(50575), // Rule ID 7383 //
     /*  50555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50568 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50573 */   GIR_RootConstrainSelectedInstOperands,
     /*  50574 */   // GIR_Coverage, 7383,
     /*  50574 */   GIR_Done,
     /*  50575 */ // Label 782: @50575
     /*  50575 */ GIM_Reject,
     /*  50576 */ // Label 600: @50576
     /*  50576 */ GIM_Reject,
     /*  50577 */ // Label 2: @50577
     /*  50577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 791*/ GIMT_Encode4(52405),
     /*  50588 */ /*GILLT_s32*//*Label 783*/ GIMT_Encode4(50628),
     /*  50592 */ /*GILLT_s64*//*Label 784*/ GIMT_Encode4(50785), GIMT_Encode4(0),
     /*  50600 */ /*GILLT_v2s32*//*Label 785*/ GIMT_Encode4(51329), GIMT_Encode4(0),
     /*  50608 */ /*GILLT_v4s16*//*Label 786*/ GIMT_Encode4(51667),
     /*  50612 */ /*GILLT_v4s32*//*Label 787*/ GIMT_Encode4(52005),
     /*  50616 */ /*GILLT_v8s8*//*Label 788*/ GIMT_Encode4(52171),
     /*  50620 */ /*GILLT_v8s16*//*Label 789*/ GIMT_Encode4(52205),
     /*  50624 */ /*GILLT_v16s8*//*Label 790*/ GIMT_Encode4(52371),
     /*  50628 */ // Label 783: @50628
     /*  50628 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50784),
     /*  50633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50643 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(50698), // Rule ID 3945 //
     /*  50648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50679 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50696 */     GIR_RootConstrainSelectedInstOperands,
     /*  50697 */     // GIR_Coverage, 3945,
     /*  50697 */     GIR_EraseRootFromParent_Done,
     /*  50698 */   // Label 793: @50698
     /*  50698 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(50753), // Rule ID 13700 //
     /*  50703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50723 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50734 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50751 */     GIR_RootConstrainSelectedInstOperands,
     /*  50752 */     // GIR_Coverage, 13700,
     /*  50752 */     GIR_EraseRootFromParent_Done,
     /*  50753 */   // Label 794: @50753
     /*  50753 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(50783), // Rule ID 3941 //
     /*  50758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50766 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50781 */     GIR_RootConstrainSelectedInstOperands,
     /*  50782 */     // GIR_Coverage, 3941,
     /*  50782 */     GIR_EraseRootFromParent_Done,
     /*  50783 */   // Label 795: @50783
     /*  50783 */   GIM_Reject,
     /*  50784 */ // Label 792: @50784
     /*  50784 */ GIM_Reject,
     /*  50785 */ // Label 784: @50785
     /*  50785 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51328),
     /*  50790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50800 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(50855), // Rule ID 3946 //
     /*  50805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50821 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50836 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  50836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  50839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50853 */     GIR_RootConstrainSelectedInstOperands,
     /*  50854 */     // GIR_Coverage, 3946,
     /*  50854 */     GIR_EraseRootFromParent_Done,
     /*  50855 */   // Label 797: @50855
     /*  50855 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(50910), // Rule ID 13701 //
     /*  50860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50880 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50891 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  50891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  50894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50908 */     GIR_RootConstrainSelectedInstOperands,
     /*  50909 */     // GIR_Coverage, 13701,
     /*  50909 */     GIR_EraseRootFromParent_Done,
     /*  50910 */   // Label 798: @50910
     /*  50910 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51023), // Rule ID 3957 //
     /*  50915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  50923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50932 */     // MIs[1] Operand 2
     /*  50932 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  50943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  50951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  50955 */     // MIs[2] Operand 1
     /*  50955 */     // No operand predicates
     /*  50955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50957 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  50957 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50960 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  50964 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50969 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  50974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  50976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51021 */     GIR_RootConstrainSelectedInstOperands,
     /*  51022 */     // GIR_Coverage, 3957,
     /*  51022 */     GIR_EraseRootFromParent_Done,
     /*  51023 */   // Label 799: @51023
     /*  51023 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51098), // Rule ID 3955 //
     /*  51028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51057 */     // MIs[2] Operand 1
     /*  51057 */     // No operand predicates
     /*  51057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51059 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51071 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51096 */     GIR_RootConstrainSelectedInstOperands,
     /*  51097 */     // GIR_Coverage, 3955,
     /*  51097 */     GIR_EraseRootFromParent_Done,
     /*  51098 */   // Label 800: @51098
     /*  51098 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51173), // Rule ID 3956 //
     /*  51103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51128 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51132 */     // MIs[2] Operand 1
     /*  51132 */     // No operand predicates
     /*  51132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51134 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51146 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51171 */     GIR_RootConstrainSelectedInstOperands,
     /*  51172 */     // GIR_Coverage, 3956,
     /*  51172 */     GIR_EraseRootFromParent_Done,
     /*  51173 */   // Label 801: @51173
     /*  51173 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51235), // Rule ID 3949 //
     /*  51178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51214 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51233 */     GIR_RootConstrainSelectedInstOperands,
     /*  51234 */     // GIR_Coverage, 3949,
     /*  51234 */     GIR_EraseRootFromParent_Done,
     /*  51235 */   // Label 802: @51235
     /*  51235 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51297), // Rule ID 3952 //
     /*  51240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51276 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51295 */     GIR_RootConstrainSelectedInstOperands,
     /*  51296 */     // GIR_Coverage, 3952,
     /*  51296 */     GIR_EraseRootFromParent_Done,
     /*  51297 */   // Label 803: @51297
     /*  51297 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51327), // Rule ID 3942 //
     /*  51302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51310 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  51313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51325 */     GIR_RootConstrainSelectedInstOperands,
     /*  51326 */     // GIR_Coverage, 3942,
     /*  51326 */     GIR_EraseRootFromParent_Done,
     /*  51327 */   // Label 804: @51327
     /*  51327 */   GIM_Reject,
     /*  51328 */ // Label 796: @51328
     /*  51328 */ GIM_Reject,
     /*  51329 */ // Label 785: @51329
     /*  51329 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51666),
     /*  51334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  51337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51344 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(51430), // Rule ID 13394 //
     /*  51349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51393 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51397 */     // MIs[3] Operand 1
     /*  51397 */     // No operand predicates
     /*  51397 */     // MIs[1] Operand 2
     /*  51397 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51414 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51428 */     GIR_RootConstrainSelectedInstOperands,
     /*  51429 */     // GIR_Coverage, 13394,
     /*  51429 */     GIR_EraseRootFromParent_Done,
     /*  51430 */   // Label 806: @51430
     /*  51430 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(51516), // Rule ID 2034 //
     /*  51435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51483 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51487 */     // MIs[3] Operand 1
     /*  51487 */     // No operand predicates
     /*  51487 */     // MIs[1] Operand 2
     /*  51487 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51500 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51514 */     GIR_RootConstrainSelectedInstOperands,
     /*  51515 */     // GIR_Coverage, 2034,
     /*  51515 */     GIR_EraseRootFromParent_Done,
     /*  51516 */   // Label 807: @51516
     /*  51516 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(51579), // Rule ID 13395 //
     /*  51521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51553 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51557 */     // MIs[2] Operand 1
     /*  51557 */     // No operand predicates
     /*  51557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51563 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51577 */     GIR_RootConstrainSelectedInstOperands,
     /*  51578 */     // GIR_Coverage, 13395,
     /*  51578 */     GIR_EraseRootFromParent_Done,
     /*  51579 */   // Label 808: @51579
     /*  51579 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(51642), // Rule ID 2035 //
     /*  51584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51620 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51624 */     // MIs[2] Operand 1
     /*  51624 */     // No operand predicates
     /*  51624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51626 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51640 */     GIR_RootConstrainSelectedInstOperands,
     /*  51641 */     // GIR_Coverage, 2035,
     /*  51641 */     GIR_EraseRootFromParent_Done,
     /*  51642 */   // Label 809: @51642
     /*  51642 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(51665), // Rule ID 1352 //
     /*  51647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51658 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  51658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  51663 */     GIR_RootConstrainSelectedInstOperands,
     /*  51664 */     // GIR_Coverage, 1352,
     /*  51664 */     GIR_Done,
     /*  51665 */   // Label 810: @51665
     /*  51665 */   GIM_Reject,
     /*  51666 */ // Label 805: @51666
     /*  51666 */ GIM_Reject,
     /*  51667 */ // Label 786: @51667
     /*  51667 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52004),
     /*  51672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  51675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51682 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(51768), // Rule ID 13391 //
     /*  51687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51731 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51735 */     // MIs[3] Operand 1
     /*  51735 */     // No operand predicates
     /*  51735 */     // MIs[1] Operand 2
     /*  51735 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51752 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51766 */     GIR_RootConstrainSelectedInstOperands,
     /*  51767 */     // GIR_Coverage, 13391,
     /*  51767 */     GIR_EraseRootFromParent_Done,
     /*  51768 */   // Label 812: @51768
     /*  51768 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(51854), // Rule ID 2031 //
     /*  51773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51821 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51825 */     // MIs[3] Operand 1
     /*  51825 */     // No operand predicates
     /*  51825 */     // MIs[1] Operand 2
     /*  51825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51838 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51852 */     GIR_RootConstrainSelectedInstOperands,
     /*  51853 */     // GIR_Coverage, 2031,
     /*  51853 */     GIR_EraseRootFromParent_Done,
     /*  51854 */   // Label 813: @51854
     /*  51854 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(51917), // Rule ID 13392 //
     /*  51859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51891 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51895 */     // MIs[2] Operand 1
     /*  51895 */     // No operand predicates
     /*  51895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51901 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51915 */     GIR_RootConstrainSelectedInstOperands,
     /*  51916 */     // GIR_Coverage, 13392,
     /*  51916 */     GIR_EraseRootFromParent_Done,
     /*  51917 */   // Label 814: @51917
     /*  51917 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(51980), // Rule ID 2032 //
     /*  51922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  51962 */     // MIs[2] Operand 1
     /*  51962 */     // No operand predicates
     /*  51962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51964 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  51967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51978 */     GIR_RootConstrainSelectedInstOperands,
     /*  51979 */     // GIR_Coverage, 2032,
     /*  51979 */     GIR_EraseRootFromParent_Done,
     /*  51980 */   // Label 815: @51980
     /*  51980 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52003), // Rule ID 1350 //
     /*  51985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51996 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  51996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52001 */     GIR_RootConstrainSelectedInstOperands,
     /*  52002 */     // GIR_Coverage, 1350,
     /*  52002 */     GIR_Done,
     /*  52003 */   // Label 816: @52003
     /*  52003 */   GIM_Reject,
     /*  52004 */ // Label 811: @52004
     /*  52004 */ GIM_Reject,
     /*  52005 */ // Label 787: @52005
     /*  52005 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52170),
     /*  52010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52020 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52083), // Rule ID 13396 //
     /*  52025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52057 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52061 */     // MIs[2] Operand 1
     /*  52061 */     // No operand predicates
     /*  52061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52067 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52081 */     GIR_RootConstrainSelectedInstOperands,
     /*  52082 */     // GIR_Coverage, 13396,
     /*  52082 */     GIR_EraseRootFromParent_Done,
     /*  52083 */   // Label 818: @52083
     /*  52083 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52146), // Rule ID 2036 //
     /*  52088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52124 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52128 */     // MIs[2] Operand 1
     /*  52128 */     // No operand predicates
     /*  52128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52130 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52144 */     GIR_RootConstrainSelectedInstOperands,
     /*  52145 */     // GIR_Coverage, 2036,
     /*  52145 */     GIR_EraseRootFromParent_Done,
     /*  52146 */   // Label 819: @52146
     /*  52146 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52169), // Rule ID 1353 //
     /*  52151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52162 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52167 */     GIR_RootConstrainSelectedInstOperands,
     /*  52168 */     // GIR_Coverage, 1353,
     /*  52168 */     GIR_Done,
     /*  52169 */   // Label 820: @52169
     /*  52169 */   GIM_Reject,
     /*  52170 */ // Label 817: @52170
     /*  52170 */ GIM_Reject,
     /*  52171 */ // Label 788: @52171
     /*  52171 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52204), // Rule ID 1348 //
     /*  52176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52197 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52202 */   GIR_RootConstrainSelectedInstOperands,
     /*  52203 */   // GIR_Coverage, 1348,
     /*  52203 */   GIR_Done,
     /*  52204 */ // Label 821: @52204
     /*  52204 */ GIM_Reject,
     /*  52205 */ // Label 789: @52205
     /*  52205 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52370),
     /*  52210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52220 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52283), // Rule ID 13393 //
     /*  52225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52261 */     // MIs[2] Operand 1
     /*  52261 */     // No operand predicates
     /*  52261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52267 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52281 */     GIR_RootConstrainSelectedInstOperands,
     /*  52282 */     // GIR_Coverage, 13393,
     /*  52282 */     GIR_EraseRootFromParent_Done,
     /*  52283 */   // Label 823: @52283
     /*  52283 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52346), // Rule ID 2033 //
     /*  52288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52324 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52328 */     // MIs[2] Operand 1
     /*  52328 */     // No operand predicates
     /*  52328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52330 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52344 */     GIR_RootConstrainSelectedInstOperands,
     /*  52345 */     // GIR_Coverage, 2033,
     /*  52345 */     GIR_EraseRootFromParent_Done,
     /*  52346 */   // Label 824: @52346
     /*  52346 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(52369), // Rule ID 1351 //
     /*  52351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52362 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  52362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  52367 */     GIR_RootConstrainSelectedInstOperands,
     /*  52368 */     // GIR_Coverage, 1351,
     /*  52368 */     GIR_Done,
     /*  52369 */   // Label 825: @52369
     /*  52369 */   GIM_Reject,
     /*  52370 */ // Label 822: @52370
     /*  52370 */ GIM_Reject,
     /*  52371 */ // Label 790: @52371
     /*  52371 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(52404), // Rule ID 1349 //
     /*  52376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52397 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  52397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  52402 */   GIR_RootConstrainSelectedInstOperands,
     /*  52403 */   // GIR_Coverage, 1349,
     /*  52403 */   GIR_Done,
     /*  52404 */ // Label 826: @52404
     /*  52404 */ GIM_Reject,
     /*  52405 */ // Label 791: @52405
     /*  52405 */ GIM_Reject,
     /*  52406 */ // Label 3: @52406
     /*  52406 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 829*/ GIMT_Encode4(52487),
     /*  52417 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(52425),
     /*  52421 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(52456),
     /*  52425 */ // Label 827: @52425
     /*  52425 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(52455), // Rule ID 117 //
     /*  52430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52448 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  52453 */   GIR_RootConstrainSelectedInstOperands,
     /*  52454 */   // GIR_Coverage, 117,
     /*  52454 */   GIR_Done,
     /*  52455 */ // Label 830: @52455
     /*  52455 */ GIM_Reject,
     /*  52456 */ // Label 828: @52456
     /*  52456 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(52486), // Rule ID 118 //
     /*  52461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52479 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52479 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  52484 */   GIR_RootConstrainSelectedInstOperands,
     /*  52485 */   // GIR_Coverage, 118,
     /*  52485 */   GIR_Done,
     /*  52486 */ // Label 831: @52486
     /*  52486 */ GIM_Reject,
     /*  52487 */ // Label 829: @52487
     /*  52487 */ GIM_Reject,
     /*  52488 */ // Label 4: @52488
     /*  52488 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 834*/ GIMT_Encode4(52569),
     /*  52499 */ /*GILLT_s32*//*Label 832*/ GIMT_Encode4(52507),
     /*  52503 */ /*GILLT_s64*//*Label 833*/ GIMT_Encode4(52538),
     /*  52507 */ // Label 832: @52507
     /*  52507 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(52537), // Rule ID 115 //
     /*  52512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52530 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  52535 */   GIR_RootConstrainSelectedInstOperands,
     /*  52536 */   // GIR_Coverage, 115,
     /*  52536 */   GIR_Done,
     /*  52537 */ // Label 835: @52537
     /*  52537 */ GIM_Reject,
     /*  52538 */ // Label 833: @52538
     /*  52538 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(52568), // Rule ID 116 //
     /*  52543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52561 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  52566 */   GIR_RootConstrainSelectedInstOperands,
     /*  52567 */   // GIR_Coverage, 116,
     /*  52567 */   GIR_Done,
     /*  52568 */ // Label 836: @52568
     /*  52568 */ GIM_Reject,
     /*  52569 */ // Label 834: @52569
     /*  52569 */ GIM_Reject,
     /*  52570 */ // Label 5: @52570
     /*  52570 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 855*/ GIMT_Encode4(60315),
     /*  52581 */ /*GILLT_s32*//*Label 837*/ GIMT_Encode4(52669),
     /*  52585 */ /*GILLT_s64*//*Label 838*/ GIMT_Encode4(53167), GIMT_Encode4(0),
     /*  52593 */ /*GILLT_v2s32*//*Label 839*/ GIMT_Encode4(54602),
     /*  52597 */ /*GILLT_v2s64*//*Label 840*/ GIMT_Encode4(54762),
     /*  52601 */ /*GILLT_v4s16*//*Label 841*/ GIMT_Encode4(54922),
     /*  52605 */ /*GILLT_v4s32*//*Label 842*/ GIMT_Encode4(55082),
     /*  52609 */ /*GILLT_v8s8*//*Label 843*/ GIMT_Encode4(55242),
     /*  52613 */ /*GILLT_v8s16*//*Label 844*/ GIMT_Encode4(55402),
     /*  52617 */ /*GILLT_v16s8*//*Label 845*/ GIMT_Encode4(55562),
     /*  52621 */ /*GILLT_nxv1s1*//*Label 846*/ GIMT_Encode4(55722),
     /*  52625 */ /*GILLT_nxv2s1*//*Label 847*/ GIMT_Encode4(56263), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52637 */ /*GILLT_nxv2s64*//*Label 848*/ GIMT_Encode4(56804),
     /*  52641 */ /*GILLT_nxv4s1*//*Label 849*/ GIMT_Encode4(57276), GIMT_Encode4(0),
     /*  52649 */ /*GILLT_nxv4s32*//*Label 850*/ GIMT_Encode4(57817),
     /*  52653 */ /*GILLT_nxv8s1*//*Label 851*/ GIMT_Encode4(58289),
     /*  52657 */ /*GILLT_nxv8s16*//*Label 852*/ GIMT_Encode4(58830),
     /*  52661 */ /*GILLT_nxv16s1*//*Label 853*/ GIMT_Encode4(59302),
     /*  52665 */ /*GILLT_nxv16s8*//*Label 854*/ GIMT_Encode4(59843),
     /*  52669 */ // Label 837: @52669
     /*  52669 */ GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53166),
     /*  52674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52680 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(52735), // Rule ID 13153 //
     /*  52685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52705 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52722 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  52733 */     GIR_RootConstrainSelectedInstOperands,
     /*  52734 */     // GIR_Coverage, 13153,
     /*  52734 */     GIR_EraseRootFromParent_Done,
     /*  52735 */   // Label 857: @52735
     /*  52735 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(52790), // Rule ID 162 //
     /*  52740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52764 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52777 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  52788 */     GIR_RootConstrainSelectedInstOperands,
     /*  52789 */     // GIR_Coverage, 162,
     /*  52789 */     GIR_EraseRootFromParent_Done,
     /*  52790 */   // Label 858: @52790
     /*  52790 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(52859), // Rule ID 5645 //
     /*  52795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  52807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  52832 */     // MIs[2] Operand 1
     /*  52832 */     // No operand predicates
     /*  52832 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  52843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52845 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  52845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  52848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52857 */     GIR_RootConstrainSelectedInstOperands,
     /*  52858 */     // GIR_Coverage, 5645,
     /*  52858 */     GIR_EraseRootFromParent_Done,
     /*  52859 */   // Label 859: @52859
     /*  52859 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(52928), // Rule ID 5646 //
     /*  52864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  52876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52897 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52901 */     // MIs[2] Operand 1
     /*  52901 */     // No operand predicates
     /*  52901 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  52912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52914 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  52914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  52917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52926 */     GIR_RootConstrainSelectedInstOperands,
     /*  52927 */     // GIR_Coverage, 5646,
     /*  52927 */     GIR_EraseRootFromParent_Done,
     /*  52928 */   // Label 860: @52928
     /*  52928 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(52981), // Rule ID 13151 //
     /*  52933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52968 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  52971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52979 */     GIR_RootConstrainSelectedInstOperands,
     /*  52980 */     // GIR_Coverage, 13151,
     /*  52980 */     GIR_EraseRootFromParent_Done,
     /*  52981 */   // Label 861: @52981
     /*  52981 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53034), // Rule ID 160 //
     /*  52986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53021 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53032 */     GIR_RootConstrainSelectedInstOperands,
     /*  53033 */     // GIR_Coverage, 160,
     /*  53033 */     GIR_EraseRootFromParent_Done,
     /*  53034 */   // Label 862: @53034
     /*  53034 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53075), // Rule ID 142 //
     /*  53039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53055 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53059 */     // MIs[1] Operand 1
     /*  53059 */     // No operand predicates
     /*  53059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53061 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53068 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53073 */     GIR_RootConstrainSelectedInstOperands,
     /*  53074 */     // GIR_Coverage, 142,
     /*  53074 */     GIR_EraseRootFromParent_Done,
     /*  53075 */   // Label 863: @53075
     /*  53075 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53108), // Rule ID 13149 //
     /*  53080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53095 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53106 */     GIR_RootConstrainSelectedInstOperands,
     /*  53107 */     // GIR_Coverage, 13149,
     /*  53107 */     GIR_EraseRootFromParent_Done,
     /*  53108 */   // Label 864: @53108
     /*  53108 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53141), // Rule ID 158 //
     /*  53113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53128 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53139 */     GIR_RootConstrainSelectedInstOperands,
     /*  53140 */     // GIR_Coverage, 158,
     /*  53140 */     GIR_EraseRootFromParent_Done,
     /*  53141 */   // Label 865: @53141
     /*  53141 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53165), // Rule ID 156 //
     /*  53146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53158 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53163 */     GIR_RootConstrainSelectedInstOperands,
     /*  53164 */     // GIR_Coverage, 156,
     /*  53164 */     GIR_Done,
     /*  53165 */   // Label 866: @53165
     /*  53165 */   GIM_Reject,
     /*  53166 */ // Label 856: @53166
     /*  53166 */ GIM_Reject,
     /*  53167 */ // Label 838: @53167
     /*  53167 */ GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54601),
     /*  53172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53178 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53233), // Rule ID 13154 //
     /*  53183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53203 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53220 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53231 */     GIR_RootConstrainSelectedInstOperands,
     /*  53232 */     // GIR_Coverage, 13154,
     /*  53232 */     GIR_EraseRootFromParent_Done,
     /*  53233 */   // Label 868: @53233
     /*  53233 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53288), // Rule ID 163 //
     /*  53238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53262 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53275 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53282 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53286 */     GIR_RootConstrainSelectedInstOperands,
     /*  53287 */     // GIR_Coverage, 163,
     /*  53287 */     GIR_EraseRootFromParent_Done,
     /*  53288 */   // Label 869: @53288
     /*  53288 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(53401), // Rule ID 5647 //
     /*  53293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53338 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53342 */     // MIs[3] Operand 1
     /*  53342 */     // No operand predicates
     /*  53342 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53355 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  53355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53367 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53400 */     // GIR_Coverage, 5647,
     /*  53400 */     GIR_EraseRootFromParent_Done,
     /*  53401 */   // Label 870: @53401
     /*  53401 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53514), // Rule ID 5648 //
     /*  53406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53455 */     // MIs[3] Operand 1
     /*  53455 */     // No operand predicates
     /*  53455 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53468 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  53468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53513 */     // GIR_Coverage, 5648,
     /*  53513 */     GIR_EraseRootFromParent_Done,
     /*  53514 */   // Label 871: @53514
     /*  53514 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(53613), // Rule ID 7065 //
     /*  53519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53531 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53534 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53539 */     // MIs[1] addr
     /*  53539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53548 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  53552 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53565 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  53572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53577 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53581 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53612 */     // GIR_Coverage, 7065,
     /*  53612 */     GIR_EraseRootFromParent_Done,
     /*  53613 */   // Label 872: @53613
     /*  53613 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(53712), // Rule ID 7066 //
     /*  53618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53630 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53633 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53638 */     // MIs[1] addr
     /*  53638 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53647 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  53651 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53664 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  53671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53711 */     // GIR_Coverage, 7066,
     /*  53711 */     GIR_EraseRootFromParent_Done,
     /*  53712 */   // Label 873: @53712
     /*  53712 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(53811), // Rule ID 7067 //
     /*  53717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53729 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53732 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53737 */     // MIs[1] addr
     /*  53737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53746 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  53750 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  53761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53763 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  53770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53779 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53810 */     // GIR_Coverage, 7067,
     /*  53810 */     GIR_EraseRootFromParent_Done,
     /*  53811 */   // Label 874: @53811
     /*  53811 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(53910), // Rule ID 7072 //
     /*  53816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53828 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53831 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  53836 */     // MIs[1] addr
     /*  53836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53845 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  53849 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53862 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  53869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53878 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53899 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53909 */     // GIR_Coverage, 7072,
     /*  53909 */     GIR_EraseRootFromParent_Done,
     /*  53910 */   // Label 875: @53910
     /*  53910 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54009), // Rule ID 7073 //
     /*  53915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53927 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53930 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  53935 */     // MIs[1] addr
     /*  53935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53944 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  53948 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53961 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  53968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53977 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54008 */     // GIR_Coverage, 7073,
     /*  54008 */     GIR_EraseRootFromParent_Done,
     /*  54009 */   // Label 876: @54009
     /*  54009 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54108), // Rule ID 7074 //
     /*  54014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54026 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54029 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54034 */     // MIs[1] addr
     /*  54034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54043 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54047 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54060 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54107 */     // GIR_Coverage, 7074,
     /*  54107 */     GIR_EraseRootFromParent_Done,
     /*  54108 */   // Label 877: @54108
     /*  54108 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54161), // Rule ID 13152 //
     /*  54113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54138 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54148 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54159 */     GIR_RootConstrainSelectedInstOperands,
     /*  54160 */     // GIR_Coverage, 13152,
     /*  54160 */     GIR_EraseRootFromParent_Done,
     /*  54161 */   // Label 878: @54161
     /*  54161 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54214), // Rule ID 161 //
     /*  54166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54201 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54212 */     GIR_RootConstrainSelectedInstOperands,
     /*  54213 */     // GIR_Coverage, 161,
     /*  54213 */     GIR_EraseRootFromParent_Done,
     /*  54214 */   // Label 879: @54214
     /*  54214 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54314), // Rule ID 3994 //
     /*  54219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54227 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54238 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54238 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54241 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54245 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54250 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  54256 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  54273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54278 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54284 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54313 */     // GIR_Coverage, 3994,
     /*  54313 */     GIR_EraseRootFromParent_Done,
     /*  54314 */   // Label 880: @54314
     /*  54314 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54355), // Rule ID 143 //
     /*  54319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54335 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  54339 */     // MIs[1] Operand 1
     /*  54339 */     // No operand predicates
     /*  54339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54341 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  54341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  54344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54348 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  54353 */     GIR_RootConstrainSelectedInstOperands,
     /*  54354 */     // GIR_Coverage, 143,
     /*  54354 */     GIR_EraseRootFromParent_Done,
     /*  54355 */   // Label 881: @54355
     /*  54355 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54388), // Rule ID 13150 //
     /*  54360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54375 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54382 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54386 */     GIR_RootConstrainSelectedInstOperands,
     /*  54387 */     // GIR_Coverage, 13150,
     /*  54387 */     GIR_EraseRootFromParent_Done,
     /*  54388 */   // Label 882: @54388
     /*  54388 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(54421), // Rule ID 159 //
     /*  54393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54408 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54419 */     GIR_RootConstrainSelectedInstOperands,
     /*  54420 */     // GIR_Coverage, 159,
     /*  54420 */     GIR_EraseRootFromParent_Done,
     /*  54421 */   // Label 883: @54421
     /*  54421 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(54485), // Rule ID 13805 //
     /*  54426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54458 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54472 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54477 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54483 */     GIR_RootConstrainSelectedInstOperands,
     /*  54484 */     // GIR_Coverage, 13805,
     /*  54484 */     GIR_EraseRootFromParent_Done,
     /*  54485 */   // Label 884: @54485
     /*  54485 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(54549), // Rule ID 5029 //
     /*  54490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54526 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54536 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54541 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54547 */     GIR_RootConstrainSelectedInstOperands,
     /*  54548 */     // GIR_Coverage, 5029,
     /*  54548 */     GIR_EraseRootFromParent_Done,
     /*  54549 */   // Label 885: @54549
     /*  54549 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(54573), // Rule ID 157 //
     /*  54554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54566 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  54571 */     GIR_RootConstrainSelectedInstOperands,
     /*  54572 */     // GIR_Coverage, 157,
     /*  54572 */     GIR_Done,
     /*  54573 */   // Label 886: @54573
     /*  54573 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(54600), // Rule ID 2484 //
     /*  54578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54593 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54598 */     GIR_RootConstrainSelectedInstOperands,
     /*  54599 */     // GIR_Coverage, 2484,
     /*  54599 */     GIR_Done,
     /*  54600 */   // Label 887: @54600
     /*  54600 */   GIM_Reject,
     /*  54601 */ // Label 867: @54601
     /*  54601 */ GIM_Reject,
     /*  54602 */ // Label 839: @54602
     /*  54602 */ GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(54761),
     /*  54607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54617 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(54677), // Rule ID 13804 //
     /*  54622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54650 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54656 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54664 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54669 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54675 */     GIR_RootConstrainSelectedInstOperands,
     /*  54676 */     // GIR_Coverage, 13804,
     /*  54676 */     GIR_EraseRootFromParent_Done,
     /*  54677 */   // Label 889: @54677
     /*  54677 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(54737), // Rule ID 5028 //
     /*  54682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54714 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54724 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54729 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54735 */     GIR_RootConstrainSelectedInstOperands,
     /*  54736 */     // GIR_Coverage, 5028,
     /*  54736 */     GIR_EraseRootFromParent_Done,
     /*  54737 */   // Label 890: @54737
     /*  54737 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(54760), // Rule ID 2483 //
     /*  54742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54753 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54758 */     GIR_RootConstrainSelectedInstOperands,
     /*  54759 */     // GIR_Coverage, 2483,
     /*  54759 */     GIR_Done,
     /*  54760 */   // Label 891: @54760
     /*  54760 */   GIM_Reject,
     /*  54761 */ // Label 888: @54761
     /*  54761 */ GIM_Reject,
     /*  54762 */ // Label 840: @54762
     /*  54762 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(54921),
     /*  54767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54777 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(54837), // Rule ID 13808 //
     /*  54782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54810 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54816 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54824 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  54827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54829 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54835 */     GIR_RootConstrainSelectedInstOperands,
     /*  54836 */     // GIR_Coverage, 13808,
     /*  54836 */     GIR_EraseRootFromParent_Done,
     /*  54837 */   // Label 893: @54837
     /*  54837 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(54897), // Rule ID 5032 //
     /*  54842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  54861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54874 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54884 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  54887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54889 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54895 */     GIR_RootConstrainSelectedInstOperands,
     /*  54896 */     // GIR_Coverage, 5032,
     /*  54896 */     GIR_EraseRootFromParent_Done,
     /*  54897 */   // Label 894: @54897
     /*  54897 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(54920), // Rule ID 2487 //
     /*  54902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54913 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  54913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  54918 */     GIR_RootConstrainSelectedInstOperands,
     /*  54919 */     // GIR_Coverage, 2487,
     /*  54919 */     GIR_Done,
     /*  54920 */   // Label 895: @54920
     /*  54920 */   GIM_Reject,
     /*  54921 */ // Label 892: @54921
     /*  54921 */ GIM_Reject,
     /*  54922 */ // Label 841: @54922
     /*  54922 */ GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55081),
     /*  54927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  54930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54937 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(54997), // Rule ID 13803 //
     /*  54942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  54957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54970 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54984 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  54984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54989 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54995 */     GIR_RootConstrainSelectedInstOperands,
     /*  54996 */     // GIR_Coverage, 13803,
     /*  54996 */     GIR_EraseRootFromParent_Done,
     /*  54997 */   // Label 897: @54997
     /*  54997 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55057), // Rule ID 5027 //
     /*  55002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55034 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55044 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55049 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55055 */     GIR_RootConstrainSelectedInstOperands,
     /*  55056 */     // GIR_Coverage, 5027,
     /*  55056 */     GIR_EraseRootFromParent_Done,
     /*  55057 */   // Label 898: @55057
     /*  55057 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55080), // Rule ID 2482 //
     /*  55062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55073 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55078 */     GIR_RootConstrainSelectedInstOperands,
     /*  55079 */     // GIR_Coverage, 2482,
     /*  55079 */     GIR_Done,
     /*  55080 */   // Label 899: @55080
     /*  55080 */   GIM_Reject,
     /*  55081 */ // Label 896: @55081
     /*  55081 */ GIM_Reject,
     /*  55082 */ // Label 842: @55082
     /*  55082 */ GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55241),
     /*  55087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55097 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55157), // Rule ID 13807 //
     /*  55102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55130 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55136 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55144 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55149 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55155 */     GIR_RootConstrainSelectedInstOperands,
     /*  55156 */     // GIR_Coverage, 13807,
     /*  55156 */     GIR_EraseRootFromParent_Done,
     /*  55157 */   // Label 901: @55157
     /*  55157 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55217), // Rule ID 5031 //
     /*  55162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55194 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55200 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55204 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55209 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55215 */     GIR_RootConstrainSelectedInstOperands,
     /*  55216 */     // GIR_Coverage, 5031,
     /*  55216 */     GIR_EraseRootFromParent_Done,
     /*  55217 */   // Label 902: @55217
     /*  55217 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55240), // Rule ID 2486 //
     /*  55222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55233 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55238 */     GIR_RootConstrainSelectedInstOperands,
     /*  55239 */     // GIR_Coverage, 2486,
     /*  55239 */     GIR_Done,
     /*  55240 */   // Label 903: @55240
     /*  55240 */   GIM_Reject,
     /*  55241 */ // Label 900: @55241
     /*  55241 */ GIM_Reject,
     /*  55242 */ // Label 843: @55242
     /*  55242 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55401),
     /*  55247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55257 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55317), // Rule ID 13289 //
     /*  55262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55290 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55304 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55315 */     GIR_RootConstrainSelectedInstOperands,
     /*  55316 */     // GIR_Coverage, 13289,
     /*  55316 */     GIR_EraseRootFromParent_Done,
     /*  55317 */   // Label 905: @55317
     /*  55317 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55377), // Rule ID 1597 //
     /*  55322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55354 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55360 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55364 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55375 */     GIR_RootConstrainSelectedInstOperands,
     /*  55376 */     // GIR_Coverage, 1597,
     /*  55376 */     GIR_EraseRootFromParent_Done,
     /*  55377 */   // Label 906: @55377
     /*  55377 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(55400), // Rule ID 1595 //
     /*  55382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55393 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55393 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55398 */     GIR_RootConstrainSelectedInstOperands,
     /*  55399 */     // GIR_Coverage, 1595,
     /*  55399 */     GIR_Done,
     /*  55400 */   // Label 907: @55400
     /*  55400 */   GIM_Reject,
     /*  55401 */ // Label 904: @55401
     /*  55401 */ GIM_Reject,
     /*  55402 */ // Label 844: @55402
     /*  55402 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(55561),
     /*  55407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55417 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(55477), // Rule ID 13806 //
     /*  55422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55450 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55464 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55469 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55475 */     GIR_RootConstrainSelectedInstOperands,
     /*  55476 */     // GIR_Coverage, 13806,
     /*  55476 */     GIR_EraseRootFromParent_Done,
     /*  55477 */   // Label 909: @55477
     /*  55477 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(55537), // Rule ID 5030 //
     /*  55482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55514 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55520 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55524 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55529 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55535 */     GIR_RootConstrainSelectedInstOperands,
     /*  55536 */     // GIR_Coverage, 5030,
     /*  55536 */     GIR_EraseRootFromParent_Done,
     /*  55537 */   // Label 910: @55537
     /*  55537 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(55560), // Rule ID 2485 //
     /*  55542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55553 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55558 */     GIR_RootConstrainSelectedInstOperands,
     /*  55559 */     // GIR_Coverage, 2485,
     /*  55559 */     GIR_Done,
     /*  55560 */   // Label 911: @55560
     /*  55560 */   GIM_Reject,
     /*  55561 */ // Label 908: @55561
     /*  55561 */ GIM_Reject,
     /*  55562 */ // Label 845: @55562
     /*  55562 */ GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(55721),
     /*  55567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55577 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(55637), // Rule ID 13290 //
     /*  55582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55610 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55624 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55635 */     GIR_RootConstrainSelectedInstOperands,
     /*  55636 */     // GIR_Coverage, 13290,
     /*  55636 */     GIR_EraseRootFromParent_Done,
     /*  55637 */   // Label 913: @55637
     /*  55637 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(55697), // Rule ID 1598 //
     /*  55642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55674 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55680 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55684 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55695 */     GIR_RootConstrainSelectedInstOperands,
     /*  55696 */     // GIR_Coverage, 1598,
     /*  55696 */     GIR_EraseRootFromParent_Done,
     /*  55697 */   // Label 914: @55697
     /*  55697 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(55720), // Rule ID 1596 //
     /*  55702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55713 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55718 */     GIR_RootConstrainSelectedInstOperands,
     /*  55719 */     // GIR_Coverage, 1596,
     /*  55719 */     GIR_Done,
     /*  55720 */   // Label 915: @55720
     /*  55720 */   GIM_Reject,
     /*  55721 */ // Label 912: @55721
     /*  55721 */ GIM_Reject,
     /*  55722 */ // Label 846: @55722
     /*  55722 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56262),
     /*  55727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  55737 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(55794), // Rule ID 15000 //
     /*  55742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55773 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55779 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55792 */     GIR_RootConstrainSelectedInstOperands,
     /*  55793 */     // GIR_Coverage, 15000,
     /*  55793 */     GIR_EraseRootFromParent_Done,
     /*  55794 */   // Label 917: @55794
     /*  55794 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(55851), // Rule ID 15003 //
     /*  55799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55830 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55836 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  55849 */     GIR_RootConstrainSelectedInstOperands,
     /*  55850 */     // GIR_Coverage, 15003,
     /*  55850 */     GIR_EraseRootFromParent_Done,
     /*  55851 */   // Label 918: @55851
     /*  55851 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(55908), // Rule ID 14999 //
     /*  55856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  55887 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55893 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55906 */     GIR_RootConstrainSelectedInstOperands,
     /*  55907 */     // GIR_Coverage, 14999,
     /*  55907 */     GIR_EraseRootFromParent_Done,
     /*  55908 */   // Label 919: @55908
     /*  55908 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(55965), // Rule ID 15002 //
     /*  55913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  55944 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  55948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55950 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  55950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  55953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 15002,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 920: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56022), // Rule ID 14998 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  55973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  55989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  55997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56007 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56020 */     GIR_RootConstrainSelectedInstOperands,
     /*  56021 */     // GIR_Coverage, 14998,
     /*  56021 */     GIR_EraseRootFromParent_Done,
     /*  56022 */   // Label 921: @56022
     /*  56022 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56079), // Rule ID 15001 //
     /*  56027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56064 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56077 */     GIR_RootConstrainSelectedInstOperands,
     /*  56078 */     // GIR_Coverage, 15001,
     /*  56078 */     GIR_EraseRootFromParent_Done,
     /*  56079 */   // Label 922: @56079
     /*  56079 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56136), // Rule ID 8374 //
     /*  56084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56121 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56134 */     GIR_RootConstrainSelectedInstOperands,
     /*  56135 */     // GIR_Coverage, 8374,
     /*  56135 */     GIR_EraseRootFromParent_Done,
     /*  56136 */   // Label 923: @56136
     /*  56136 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56193), // Rule ID 8375 //
     /*  56141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56178 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56191 */     GIR_RootConstrainSelectedInstOperands,
     /*  56192 */     // GIR_Coverage, 8375,
     /*  56192 */     GIR_EraseRootFromParent_Done,
     /*  56193 */   // Label 924: @56193
     /*  56193 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56240), // Rule ID 10626 //
     /*  56198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56209 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56221 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56238 */     GIR_RootConstrainSelectedInstOperands,
     /*  56239 */     // GIR_Coverage, 10626,
     /*  56239 */     GIR_EraseRootFromParent_Done,
     /*  56240 */   // Label 925: @56240
     /*  56240 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56261), // Rule ID 2753 //
     /*  56245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56248 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56255 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56259 */     GIR_RootConstrainSelectedInstOperands,
     /*  56260 */     // GIR_Coverage, 2753,
     /*  56260 */     GIR_EraseRootFromParent_Done,
     /*  56261 */   // Label 926: @56261
     /*  56261 */   GIM_Reject,
     /*  56262 */ // Label 916: @56262
     /*  56262 */ GIM_Reject,
     /*  56263 */ // Label 847: @56263
     /*  56263 */ GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56803),
     /*  56268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56278 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56335), // Rule ID 14991 //
     /*  56283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56314 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56320 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56333 */     GIR_RootConstrainSelectedInstOperands,
     /*  56334 */     // GIR_Coverage, 14991,
     /*  56334 */     GIR_EraseRootFromParent_Done,
     /*  56335 */   // Label 928: @56335
     /*  56335 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(56392), // Rule ID 14994 //
     /*  56340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56371 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56377 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56390 */     GIR_RootConstrainSelectedInstOperands,
     /*  56391 */     // GIR_Coverage, 14994,
     /*  56391 */     GIR_EraseRootFromParent_Done,
     /*  56392 */   // Label 929: @56392
     /*  56392 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(56449), // Rule ID 14990 //
     /*  56397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56428 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56434 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56447 */     GIR_RootConstrainSelectedInstOperands,
     /*  56448 */     // GIR_Coverage, 14990,
     /*  56448 */     GIR_EraseRootFromParent_Done,
     /*  56449 */   // Label 930: @56449
     /*  56449 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(56506), // Rule ID 14993 //
     /*  56454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56485 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56491 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56504 */     GIR_RootConstrainSelectedInstOperands,
     /*  56505 */     // GIR_Coverage, 14993,
     /*  56505 */     GIR_EraseRootFromParent_Done,
     /*  56506 */   // Label 931: @56506
     /*  56506 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(56563), // Rule ID 14989 //
     /*  56511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56542 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56548 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56561 */     GIR_RootConstrainSelectedInstOperands,
     /*  56562 */     // GIR_Coverage, 14989,
     /*  56562 */     GIR_EraseRootFromParent_Done,
     /*  56563 */   // Label 932: @56563
     /*  56563 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(56620), // Rule ID 14992 //
     /*  56568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56599 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56605 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56618 */     GIR_RootConstrainSelectedInstOperands,
     /*  56619 */     // GIR_Coverage, 14992,
     /*  56619 */     GIR_EraseRootFromParent_Done,
     /*  56620 */   // Label 933: @56620
     /*  56620 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(56677), // Rule ID 8370 //
     /*  56625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56656 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56662 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56675 */     GIR_RootConstrainSelectedInstOperands,
     /*  56676 */     // GIR_Coverage, 8370,
     /*  56676 */     GIR_EraseRootFromParent_Done,
     /*  56677 */   // Label 934: @56677
     /*  56677 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(56734), // Rule ID 8371 //
     /*  56682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56719 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56732 */     GIR_RootConstrainSelectedInstOperands,
     /*  56733 */     // GIR_Coverage, 8371,
     /*  56733 */     GIR_EraseRootFromParent_Done,
     /*  56734 */   // Label 935: @56734
     /*  56734 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(56781), // Rule ID 10625 //
     /*  56739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56750 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  56750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56779 */     GIR_RootConstrainSelectedInstOperands,
     /*  56780 */     // GIR_Coverage, 10625,
     /*  56780 */     GIR_EraseRootFromParent_Done,
     /*  56781 */   // Label 936: @56781
     /*  56781 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(56802), // Rule ID 2752 //
     /*  56786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56789 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56800 */     GIR_RootConstrainSelectedInstOperands,
     /*  56801 */     // GIR_Coverage, 2752,
     /*  56801 */     GIR_EraseRootFromParent_Done,
     /*  56802 */   // Label 937: @56802
     /*  56802 */   GIM_Reject,
     /*  56803 */ // Label 927: @56803
     /*  56803 */ GIM_Reject,
     /*  56804 */ // Label 848: @56804
     /*  56804 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57275),
     /*  56809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  56819 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(56874), // Rule ID 14931 //
     /*  56824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56855 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56861 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56872 */     GIR_RootConstrainSelectedInstOperands,
     /*  56873 */     // GIR_Coverage, 14931,
     /*  56873 */     GIR_EraseRootFromParent_Done,
     /*  56874 */   // Label 939: @56874
     /*  56874 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(56929), // Rule ID 14934 //
     /*  56879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56910 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56916 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56927 */     GIR_RootConstrainSelectedInstOperands,
     /*  56928 */     // GIR_Coverage, 14934,
     /*  56928 */     GIR_EraseRootFromParent_Done,
     /*  56929 */   // Label 940: @56929
     /*  56929 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(56984), // Rule ID 14930 //
     /*  56934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  56949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  56953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56965 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56971 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  56971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  56974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  56976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56982 */     GIR_RootConstrainSelectedInstOperands,
     /*  56983 */     // GIR_Coverage, 14930,
     /*  56983 */     GIR_EraseRootFromParent_Done,
     /*  56984 */   // Label 941: @56984
     /*  56984 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57039), // Rule ID 14933 //
     /*  56989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57020 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57026 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57037 */     GIR_RootConstrainSelectedInstOperands,
     /*  57038 */     // GIR_Coverage, 14933,
     /*  57038 */     GIR_EraseRootFromParent_Done,
     /*  57039 */   // Label 942: @57039
     /*  57039 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57094), // Rule ID 14929 //
     /*  57044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57081 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57092 */     GIR_RootConstrainSelectedInstOperands,
     /*  57093 */     // GIR_Coverage, 14929,
     /*  57093 */     GIR_EraseRootFromParent_Done,
     /*  57094 */   // Label 943: @57094
     /*  57094 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57149), // Rule ID 14932 //
     /*  57099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57130 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57136 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57147 */     GIR_RootConstrainSelectedInstOperands,
     /*  57148 */     // GIR_Coverage, 14932,
     /*  57148 */     GIR_EraseRootFromParent_Done,
     /*  57149 */   // Label 944: @57149
     /*  57149 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57204), // Rule ID 7423 //
     /*  57154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57185 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57191 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57202 */     GIR_RootConstrainSelectedInstOperands,
     /*  57203 */     // GIR_Coverage, 7423,
     /*  57203 */     GIR_EraseRootFromParent_Done,
     /*  57204 */   // Label 945: @57204
     /*  57204 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57259), // Rule ID 7424 //
     /*  57209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57240 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57246 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57257 */     GIR_RootConstrainSelectedInstOperands,
     /*  57258 */     // GIR_Coverage, 7424,
     /*  57258 */     GIR_EraseRootFromParent_Done,
     /*  57259 */   // Label 946: @57259
     /*  57259 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57274), // Rule ID 3146 //
     /*  57264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57267 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57272 */     GIR_RootConstrainSelectedInstOperands,
     /*  57273 */     // GIR_Coverage, 3146,
     /*  57273 */     GIR_Done,
     /*  57274 */   // Label 947: @57274
     /*  57274 */   GIM_Reject,
     /*  57275 */ // Label 938: @57275
     /*  57275 */ GIM_Reject,
     /*  57276 */ // Label 849: @57276
     /*  57276 */ GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57816),
     /*  57281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57291 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(57348), // Rule ID 14982 //
     /*  57296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57327 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57333 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57346 */     GIR_RootConstrainSelectedInstOperands,
     /*  57347 */     // GIR_Coverage, 14982,
     /*  57347 */     GIR_EraseRootFromParent_Done,
     /*  57348 */   // Label 949: @57348
     /*  57348 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(57405), // Rule ID 14985 //
     /*  57353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57384 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57390 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57403 */     GIR_RootConstrainSelectedInstOperands,
     /*  57404 */     // GIR_Coverage, 14985,
     /*  57404 */     GIR_EraseRootFromParent_Done,
     /*  57405 */   // Label 950: @57405
     /*  57405 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(57462), // Rule ID 14981 //
     /*  57410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57441 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57447 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57460 */     GIR_RootConstrainSelectedInstOperands,
     /*  57461 */     // GIR_Coverage, 14981,
     /*  57461 */     GIR_EraseRootFromParent_Done,
     /*  57462 */   // Label 951: @57462
     /*  57462 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(57519), // Rule ID 14984 //
     /*  57467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57498 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57504 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57517 */     GIR_RootConstrainSelectedInstOperands,
     /*  57518 */     // GIR_Coverage, 14984,
     /*  57518 */     GIR_EraseRootFromParent_Done,
     /*  57519 */   // Label 952: @57519
     /*  57519 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(57576), // Rule ID 14980 //
     /*  57524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57555 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57561 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57574 */     GIR_RootConstrainSelectedInstOperands,
     /*  57575 */     // GIR_Coverage, 14980,
     /*  57575 */     GIR_EraseRootFromParent_Done,
     /*  57576 */   // Label 953: @57576
     /*  57576 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(57633), // Rule ID 14983 //
     /*  57581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57612 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57618 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57631 */     GIR_RootConstrainSelectedInstOperands,
     /*  57632 */     // GIR_Coverage, 14983,
     /*  57632 */     GIR_EraseRootFromParent_Done,
     /*  57633 */   // Label 954: @57633
     /*  57633 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(57690), // Rule ID 8366 //
     /*  57638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57669 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57675 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57688 */     GIR_RootConstrainSelectedInstOperands,
     /*  57689 */     // GIR_Coverage, 8366,
     /*  57689 */     GIR_EraseRootFromParent_Done,
     /*  57690 */   // Label 955: @57690
     /*  57690 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(57747), // Rule ID 8367 //
     /*  57695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57732 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57745 */     GIR_RootConstrainSelectedInstOperands,
     /*  57746 */     // GIR_Coverage, 8367,
     /*  57746 */     GIR_EraseRootFromParent_Done,
     /*  57747 */   // Label 956: @57747
     /*  57747 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(57794), // Rule ID 10624 //
     /*  57752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57763 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  57763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  57770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57792 */     GIR_RootConstrainSelectedInstOperands,
     /*  57793 */     // GIR_Coverage, 10624,
     /*  57793 */     GIR_EraseRootFromParent_Done,
     /*  57794 */   // Label 957: @57794
     /*  57794 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(57815), // Rule ID 2751 //
     /*  57799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57802 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57813 */     GIR_RootConstrainSelectedInstOperands,
     /*  57814 */     // GIR_Coverage, 2751,
     /*  57814 */     GIR_EraseRootFromParent_Done,
     /*  57815 */   // Label 958: @57815
     /*  57815 */   GIM_Reject,
     /*  57816 */ // Label 948: @57816
     /*  57816 */ GIM_Reject,
     /*  57817 */ // Label 850: @57817
     /*  57817 */ GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58288),
     /*  57822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57832 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(57887), // Rule ID 14922 //
     /*  57837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57868 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57874 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  57874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57885 */     GIR_RootConstrainSelectedInstOperands,
     /*  57886 */     // GIR_Coverage, 14922,
     /*  57886 */     GIR_EraseRootFromParent_Done,
     /*  57887 */   // Label 960: @57887
     /*  57887 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(57942), // Rule ID 14925 //
     /*  57892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57923 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57929 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  57929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57940 */     GIR_RootConstrainSelectedInstOperands,
     /*  57941 */     // GIR_Coverage, 14925,
     /*  57941 */     GIR_EraseRootFromParent_Done,
     /*  57942 */   // Label 961: @57942
     /*  57942 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(57997), // Rule ID 14921 //
     /*  57947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  57962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  57966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57978 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57984 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  57984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57995 */     GIR_RootConstrainSelectedInstOperands,
     /*  57996 */     // GIR_Coverage, 14921,
     /*  57996 */     GIR_EraseRootFromParent_Done,
     /*  57997 */   // Label 962: @57997
     /*  57997 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58052), // Rule ID 14924 //
     /*  58002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58033 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58039 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58050 */     GIR_RootConstrainSelectedInstOperands,
     /*  58051 */     // GIR_Coverage, 14924,
     /*  58051 */     GIR_EraseRootFromParent_Done,
     /*  58052 */   // Label 963: @58052
     /*  58052 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58107), // Rule ID 14920 //
     /*  58057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58094 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58105 */     GIR_RootConstrainSelectedInstOperands,
     /*  58106 */     // GIR_Coverage, 14920,
     /*  58106 */     GIR_EraseRootFromParent_Done,
     /*  58107 */   // Label 964: @58107
     /*  58107 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58162), // Rule ID 14923 //
     /*  58112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58143 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58149 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58160 */     GIR_RootConstrainSelectedInstOperands,
     /*  58161 */     // GIR_Coverage, 14923,
     /*  58161 */     GIR_EraseRootFromParent_Done,
     /*  58162 */   // Label 965: @58162
     /*  58162 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58217), // Rule ID 7419 //
     /*  58167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58198 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58204 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58215 */     GIR_RootConstrainSelectedInstOperands,
     /*  58216 */     // GIR_Coverage, 7419,
     /*  58216 */     GIR_EraseRootFromParent_Done,
     /*  58217 */   // Label 966: @58217
     /*  58217 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58272), // Rule ID 7420 //
     /*  58222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58253 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58259 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58270 */     GIR_RootConstrainSelectedInstOperands,
     /*  58271 */     // GIR_Coverage, 7420,
     /*  58271 */     GIR_EraseRootFromParent_Done,
     /*  58272 */   // Label 967: @58272
     /*  58272 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58287), // Rule ID 3145 //
     /*  58277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58280 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58285 */     GIR_RootConstrainSelectedInstOperands,
     /*  58286 */     // GIR_Coverage, 3145,
     /*  58286 */     GIR_Done,
     /*  58287 */   // Label 968: @58287
     /*  58287 */   GIM_Reject,
     /*  58288 */ // Label 959: @58288
     /*  58288 */ GIM_Reject,
     /*  58289 */ // Label 851: @58289
     /*  58289 */ GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58829),
     /*  58294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58304 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(58361), // Rule ID 14973 //
     /*  58309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58340 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58346 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58359 */     GIR_RootConstrainSelectedInstOperands,
     /*  58360 */     // GIR_Coverage, 14973,
     /*  58360 */     GIR_EraseRootFromParent_Done,
     /*  58361 */   // Label 970: @58361
     /*  58361 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(58418), // Rule ID 14976 //
     /*  58366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58397 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58403 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58416 */     GIR_RootConstrainSelectedInstOperands,
     /*  58417 */     // GIR_Coverage, 14976,
     /*  58417 */     GIR_EraseRootFromParent_Done,
     /*  58418 */   // Label 971: @58418
     /*  58418 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(58475), // Rule ID 14972 //
     /*  58423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58454 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58460 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58473 */     GIR_RootConstrainSelectedInstOperands,
     /*  58474 */     // GIR_Coverage, 14972,
     /*  58474 */     GIR_EraseRootFromParent_Done,
     /*  58475 */   // Label 972: @58475
     /*  58475 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(58532), // Rule ID 14975 //
     /*  58480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58511 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58517 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58530 */     GIR_RootConstrainSelectedInstOperands,
     /*  58531 */     // GIR_Coverage, 14975,
     /*  58531 */     GIR_EraseRootFromParent_Done,
     /*  58532 */   // Label 973: @58532
     /*  58532 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(58589), // Rule ID 14971 //
     /*  58537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58568 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58574 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58587 */     GIR_RootConstrainSelectedInstOperands,
     /*  58588 */     // GIR_Coverage, 14971,
     /*  58588 */     GIR_EraseRootFromParent_Done,
     /*  58589 */   // Label 974: @58589
     /*  58589 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(58646), // Rule ID 14974 //
     /*  58594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58631 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58644 */     GIR_RootConstrainSelectedInstOperands,
     /*  58645 */     // GIR_Coverage, 14974,
     /*  58645 */     GIR_EraseRootFromParent_Done,
     /*  58646 */   // Label 975: @58646
     /*  58646 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(58703), // Rule ID 8362 //
     /*  58651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58682 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58688 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58701 */     GIR_RootConstrainSelectedInstOperands,
     /*  58702 */     // GIR_Coverage, 8362,
     /*  58702 */     GIR_EraseRootFromParent_Done,
     /*  58703 */   // Label 976: @58703
     /*  58703 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(58760), // Rule ID 8363 //
     /*  58708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58745 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58758 */     GIR_RootConstrainSelectedInstOperands,
     /*  58759 */     // GIR_Coverage, 8363,
     /*  58759 */     GIR_EraseRootFromParent_Done,
     /*  58760 */   // Label 977: @58760
     /*  58760 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(58807), // Rule ID 10623 //
     /*  58765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58776 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  58776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  58783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58805 */     GIR_RootConstrainSelectedInstOperands,
     /*  58806 */     // GIR_Coverage, 10623,
     /*  58806 */     GIR_EraseRootFromParent_Done,
     /*  58807 */   // Label 978: @58807
     /*  58807 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(58828), // Rule ID 2750 //
     /*  58812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58815 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58826 */     GIR_RootConstrainSelectedInstOperands,
     /*  58827 */     // GIR_Coverage, 2750,
     /*  58827 */     GIR_EraseRootFromParent_Done,
     /*  58828 */   // Label 979: @58828
     /*  58828 */   GIM_Reject,
     /*  58829 */ // Label 969: @58829
     /*  58829 */ GIM_Reject,
     /*  58830 */ // Label 852: @58830
     /*  58830 */ GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59301),
     /*  58835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58845 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(58900), // Rule ID 14913 //
     /*  58850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58881 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58887 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  58887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58898 */     GIR_RootConstrainSelectedInstOperands,
     /*  58899 */     // GIR_Coverage, 14913,
     /*  58899 */     GIR_EraseRootFromParent_Done,
     /*  58900 */   // Label 981: @58900
     /*  58900 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(58955), // Rule ID 14916 //
     /*  58905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58936 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58942 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  58942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58953 */     GIR_RootConstrainSelectedInstOperands,
     /*  58954 */     // GIR_Coverage, 14916,
     /*  58954 */     GIR_EraseRootFromParent_Done,
     /*  58955 */   // Label 982: @58955
     /*  58955 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(59010), // Rule ID 14912 //
     /*  58960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  58975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  58979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58991 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58997 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  58997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59008 */     GIR_RootConstrainSelectedInstOperands,
     /*  59009 */     // GIR_Coverage, 14912,
     /*  59009 */     GIR_EraseRootFromParent_Done,
     /*  59010 */   // Label 983: @59010
     /*  59010 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59065), // Rule ID 14915 //
     /*  59015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59046 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59052 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59063 */     GIR_RootConstrainSelectedInstOperands,
     /*  59064 */     // GIR_Coverage, 14915,
     /*  59064 */     GIR_EraseRootFromParent_Done,
     /*  59065 */   // Label 984: @59065
     /*  59065 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59120), // Rule ID 14911 //
     /*  59070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59107 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59118 */     GIR_RootConstrainSelectedInstOperands,
     /*  59119 */     // GIR_Coverage, 14911,
     /*  59119 */     GIR_EraseRootFromParent_Done,
     /*  59120 */   // Label 985: @59120
     /*  59120 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59175), // Rule ID 14914 //
     /*  59125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59156 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59162 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59173 */     GIR_RootConstrainSelectedInstOperands,
     /*  59174 */     // GIR_Coverage, 14914,
     /*  59174 */     GIR_EraseRootFromParent_Done,
     /*  59175 */   // Label 986: @59175
     /*  59175 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59230), // Rule ID 7415 //
     /*  59180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59211 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59217 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59228 */     GIR_RootConstrainSelectedInstOperands,
     /*  59229 */     // GIR_Coverage, 7415,
     /*  59229 */     GIR_EraseRootFromParent_Done,
     /*  59230 */   // Label 987: @59230
     /*  59230 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59285), // Rule ID 7416 //
     /*  59235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59266 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59272 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59283 */     GIR_RootConstrainSelectedInstOperands,
     /*  59284 */     // GIR_Coverage, 7416,
     /*  59284 */     GIR_EraseRootFromParent_Done,
     /*  59285 */   // Label 988: @59285
     /*  59285 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59300), // Rule ID 3144 //
     /*  59290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59293 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59298 */     GIR_RootConstrainSelectedInstOperands,
     /*  59299 */     // GIR_Coverage, 3144,
     /*  59299 */     GIR_Done,
     /*  59300 */   // Label 989: @59300
     /*  59300 */   GIM_Reject,
     /*  59301 */ // Label 980: @59301
     /*  59301 */ GIM_Reject,
     /*  59302 */ // Label 853: @59302
     /*  59302 */ GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59842),
     /*  59307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59317 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(59374), // Rule ID 14964 //
     /*  59322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59353 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59359 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59372 */     GIR_RootConstrainSelectedInstOperands,
     /*  59373 */     // GIR_Coverage, 14964,
     /*  59373 */     GIR_EraseRootFromParent_Done,
     /*  59374 */   // Label 991: @59374
     /*  59374 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(59431), // Rule ID 14967 //
     /*  59379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59410 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59416 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59429 */     GIR_RootConstrainSelectedInstOperands,
     /*  59430 */     // GIR_Coverage, 14967,
     /*  59430 */     GIR_EraseRootFromParent_Done,
     /*  59431 */   // Label 992: @59431
     /*  59431 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(59488), // Rule ID 14963 //
     /*  59436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59467 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59473 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59486 */     GIR_RootConstrainSelectedInstOperands,
     /*  59487 */     // GIR_Coverage, 14963,
     /*  59487 */     GIR_EraseRootFromParent_Done,
     /*  59488 */   // Label 993: @59488
     /*  59488 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(59545), // Rule ID 14966 //
     /*  59493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59524 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59530 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59543 */     GIR_RootConstrainSelectedInstOperands,
     /*  59544 */     // GIR_Coverage, 14966,
     /*  59544 */     GIR_EraseRootFromParent_Done,
     /*  59545 */   // Label 994: @59545
     /*  59545 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(59602), // Rule ID 14962 //
     /*  59550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59581 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59587 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59600 */     GIR_RootConstrainSelectedInstOperands,
     /*  59601 */     // GIR_Coverage, 14962,
     /*  59601 */     GIR_EraseRootFromParent_Done,
     /*  59602 */   // Label 995: @59602
     /*  59602 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(59659), // Rule ID 14965 //
     /*  59607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59638 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59644 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59657 */     GIR_RootConstrainSelectedInstOperands,
     /*  59658 */     // GIR_Coverage, 14965,
     /*  59658 */     GIR_EraseRootFromParent_Done,
     /*  59659 */   // Label 996: @59659
     /*  59659 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(59716), // Rule ID 8358 //
     /*  59664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59695 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59701 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59714 */     GIR_RootConstrainSelectedInstOperands,
     /*  59715 */     // GIR_Coverage, 8358,
     /*  59715 */     GIR_EraseRootFromParent_Done,
     /*  59716 */   // Label 997: @59716
     /*  59716 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(59773), // Rule ID 8359 //
     /*  59721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59758 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59763 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59771 */     GIR_RootConstrainSelectedInstOperands,
     /*  59772 */     // GIR_Coverage, 8359,
     /*  59772 */     GIR_EraseRootFromParent_Done,
     /*  59773 */   // Label 998: @59773
     /*  59773 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(59820), // Rule ID 10622 //
     /*  59778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59789 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  59789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  59796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59818 */     GIR_RootConstrainSelectedInstOperands,
     /*  59819 */     // GIR_Coverage, 10622,
     /*  59819 */     GIR_EraseRootFromParent_Done,
     /*  59820 */   // Label 999: @59820
     /*  59820 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(59841), // Rule ID 2749 //
     /*  59825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59828 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59839 */     GIR_RootConstrainSelectedInstOperands,
     /*  59840 */     // GIR_Coverage, 2749,
     /*  59840 */     GIR_EraseRootFromParent_Done,
     /*  59841 */   // Label 1000: @59841
     /*  59841 */   GIM_Reject,
     /*  59842 */ // Label 990: @59842
     /*  59842 */ GIM_Reject,
     /*  59843 */ // Label 854: @59843
     /*  59843 */ GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60314),
     /*  59848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59858 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(59913), // Rule ID 14904 //
     /*  59863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59894 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59900 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  59900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59911 */     GIR_RootConstrainSelectedInstOperands,
     /*  59912 */     // GIR_Coverage, 14904,
     /*  59912 */     GIR_EraseRootFromParent_Done,
     /*  59913 */   // Label 1002: @59913
     /*  59913 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(59968), // Rule ID 14907 //
     /*  59918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59949 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59955 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  59955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59966 */     GIR_RootConstrainSelectedInstOperands,
     /*  59967 */     // GIR_Coverage, 14907,
     /*  59967 */     GIR_EraseRootFromParent_Done,
     /*  59968 */   // Label 1003: @59968
     /*  59968 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(60023), // Rule ID 14903 //
     /*  59973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  59988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  59992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60004 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60010 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60021 */     GIR_RootConstrainSelectedInstOperands,
     /*  60022 */     // GIR_Coverage, 14903,
     /*  60022 */     GIR_EraseRootFromParent_Done,
     /*  60023 */   // Label 1004: @60023
     /*  60023 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60078), // Rule ID 14906 //
     /*  60028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60059 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60065 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60076 */     GIR_RootConstrainSelectedInstOperands,
     /*  60077 */     // GIR_Coverage, 14906,
     /*  60077 */     GIR_EraseRootFromParent_Done,
     /*  60078 */   // Label 1005: @60078
     /*  60078 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60133), // Rule ID 14902 //
     /*  60083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60114 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60120 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60131 */     GIR_RootConstrainSelectedInstOperands,
     /*  60132 */     // GIR_Coverage, 14902,
     /*  60132 */     GIR_EraseRootFromParent_Done,
     /*  60133 */   // Label 1006: @60133
     /*  60133 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60188), // Rule ID 14905 //
     /*  60138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60175 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60186 */     GIR_RootConstrainSelectedInstOperands,
     /*  60187 */     // GIR_Coverage, 14905,
     /*  60187 */     GIR_EraseRootFromParent_Done,
     /*  60188 */   // Label 1007: @60188
     /*  60188 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60243), // Rule ID 7411 //
     /*  60193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60224 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60230 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60241 */     GIR_RootConstrainSelectedInstOperands,
     /*  60242 */     // GIR_Coverage, 7411,
     /*  60242 */     GIR_EraseRootFromParent_Done,
     /*  60243 */   // Label 1008: @60243
     /*  60243 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60298), // Rule ID 7412 //
     /*  60248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60279 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60285 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60296 */     GIR_RootConstrainSelectedInstOperands,
     /*  60297 */     // GIR_Coverage, 7412,
     /*  60297 */     GIR_EraseRootFromParent_Done,
     /*  60298 */   // Label 1009: @60298
     /*  60298 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60313), // Rule ID 3143 //
     /*  60303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60306 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60311 */     GIR_RootConstrainSelectedInstOperands,
     /*  60312 */     // GIR_Coverage, 3143,
     /*  60312 */     GIR_Done,
     /*  60313 */   // Label 1010: @60313
     /*  60313 */   GIM_Reject,
     /*  60314 */ // Label 1001: @60314
     /*  60314 */ GIM_Reject,
     /*  60315 */ // Label 855: @60315
     /*  60315 */ GIM_Reject,
     /*  60316 */ // Label 6: @60316
     /*  60316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1029*/ GIMT_Encode4(72094),
     /*  60327 */ /*GILLT_s32*//*Label 1011*/ GIMT_Encode4(60415),
     /*  60331 */ /*GILLT_s64*//*Label 1012*/ GIMT_Encode4(60775), GIMT_Encode4(0),
     /*  60339 */ /*GILLT_v2s32*//*Label 1013*/ GIMT_Encode4(62674),
     /*  60343 */ /*GILLT_v2s64*//*Label 1014*/ GIMT_Encode4(63982),
     /*  60347 */ /*GILLT_v4s16*//*Label 1015*/ GIMT_Encode4(65290),
     /*  60351 */ /*GILLT_v4s32*//*Label 1016*/ GIMT_Encode4(66598),
     /*  60355 */ /*GILLT_v8s8*//*Label 1017*/ GIMT_Encode4(67906),
     /*  60359 */ /*GILLT_v8s16*//*Label 1018*/ GIMT_Encode4(69214),
     /*  60363 */ /*GILLT_v16s8*//*Label 1019*/ GIMT_Encode4(70522),
     /*  60367 */ /*GILLT_nxv1s1*//*Label 1020*/ GIMT_Encode4(71830),
     /*  60371 */ /*GILLT_nxv2s1*//*Label 1021*/ GIMT_Encode4(71862), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  60383 */ /*GILLT_nxv2s64*//*Label 1022*/ GIMT_Encode4(71894),
     /*  60387 */ /*GILLT_nxv4s1*//*Label 1023*/ GIMT_Encode4(71920), GIMT_Encode4(0),
     /*  60395 */ /*GILLT_nxv4s32*//*Label 1024*/ GIMT_Encode4(71952),
     /*  60399 */ /*GILLT_nxv8s1*//*Label 1025*/ GIMT_Encode4(71978),
     /*  60403 */ /*GILLT_nxv8s16*//*Label 1026*/ GIMT_Encode4(72010),
     /*  60407 */ /*GILLT_nxv16s1*//*Label 1027*/ GIMT_Encode4(72036),
     /*  60411 */ /*GILLT_nxv16s8*//*Label 1028*/ GIMT_Encode4(72068),
     /*  60415 */ // Label 1011: @60415
     /*  60415 */ GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(60774),
     /*  60420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60426 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(60481), // Rule ID 13173 //
     /*  60431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60468 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60479 */     GIR_RootConstrainSelectedInstOperands,
     /*  60480 */     // GIR_Coverage, 13173,
     /*  60480 */     GIR_EraseRootFromParent_Done,
     /*  60481 */   // Label 1031: @60481
     /*  60481 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(60536), // Rule ID 174 //
     /*  60486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60510 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60523 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60534 */     GIR_RootConstrainSelectedInstOperands,
     /*  60535 */     // GIR_Coverage, 174,
     /*  60535 */     GIR_EraseRootFromParent_Done,
     /*  60536 */   // Label 1032: @60536
     /*  60536 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(60577), // Rule ID 146 //
     /*  60541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  60545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60557 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  60561 */     // MIs[1] Operand 1
     /*  60561 */     // No operand predicates
     /*  60561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60563 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  60563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  60566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60570 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  60575 */     GIR_RootConstrainSelectedInstOperands,
     /*  60576 */     // GIR_Coverage, 146,
     /*  60576 */     GIR_EraseRootFromParent_Done,
     /*  60577 */   // Label 1033: @60577
     /*  60577 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(60610), // Rule ID 13175 //
     /*  60582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60597 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60604 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60608 */     GIR_RootConstrainSelectedInstOperands,
     /*  60609 */     // GIR_Coverage, 13175,
     /*  60609 */     GIR_EraseRootFromParent_Done,
     /*  60610 */   // Label 1034: @60610
     /*  60610 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(60643), // Rule ID 178 //
     /*  60615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60630 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60637 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60641 */     GIR_RootConstrainSelectedInstOperands,
     /*  60642 */     // GIR_Coverage, 178,
     /*  60642 */     GIR_EraseRootFromParent_Done,
     /*  60643 */   // Label 1035: @60643
     /*  60643 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(60696), // Rule ID 13171 //
     /*  60648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60673 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60683 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60694 */     GIR_RootConstrainSelectedInstOperands,
     /*  60695 */     // GIR_Coverage, 13171,
     /*  60695 */     GIR_EraseRootFromParent_Done,
     /*  60696 */   // Label 1036: @60696
     /*  60696 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(60749), // Rule ID 172 //
     /*  60701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60730 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60736 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60747 */     GIR_RootConstrainSelectedInstOperands,
     /*  60748 */     // GIR_Coverage, 172,
     /*  60748 */     GIR_EraseRootFromParent_Done,
     /*  60749 */   // Label 1037: @60749
     /*  60749 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(60773), // Rule ID 176 //
     /*  60754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60766 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  60771 */     GIR_RootConstrainSelectedInstOperands,
     /*  60772 */     // GIR_Coverage, 176,
     /*  60772 */     GIR_Done,
     /*  60773 */   // Label 1038: @60773
     /*  60773 */   GIM_Reject,
     /*  60774 */ // Label 1030: @60774
     /*  60774 */ GIM_Reject,
     /*  60775 */ // Label 1012: @60775
     /*  60775 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(62673),
     /*  60780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  60786 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60908), // Rule ID 4007 //
     /*  60791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  60819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  60827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60832 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  60836 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  60847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  60851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  60859 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  60863 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  60867 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  60871 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  60875 */     // MIs[4] Rn
     /*  60875 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60880 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  60884 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  60895 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  60897 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  60897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  60900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  60906 */     GIR_RootConstrainSelectedInstOperands,
     /*  60907 */     // GIR_Coverage, 4007,
     /*  60907 */     GIR_EraseRootFromParent_Done,
     /*  60908 */   // Label 1040: @60908
     /*  60908 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61030), // Rule ID 13723 //
     /*  60913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  60929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  60933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  60941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  60949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  60954 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  60958 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  60969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  60973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  60977 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  60981 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  60985 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  60989 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  60993 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  60997 */     // MIs[4] Rn
     /*  60997 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61002 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61006 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61017 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61019 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61028 */     GIR_RootConstrainSelectedInstOperands,
     /*  61029 */     // GIR_Coverage, 13723,
     /*  61029 */     GIR_EraseRootFromParent_Done,
     /*  61030 */   // Label 1041: @61030
     /*  61030 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(61085), // Rule ID 13174 //
     /*  61035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61055 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61072 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61083 */     GIR_RootConstrainSelectedInstOperands,
     /*  61084 */     // GIR_Coverage, 13174,
     /*  61084 */     GIR_EraseRootFromParent_Done,
     /*  61085 */   // Label 1042: @61085
     /*  61085 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61140), // Rule ID 175 //
     /*  61090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61127 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61138 */     GIR_RootConstrainSelectedInstOperands,
     /*  61139 */     // GIR_Coverage, 175,
     /*  61139 */     GIR_EraseRootFromParent_Done,
     /*  61140 */   // Label 1043: @61140
     /*  61140 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61249), // Rule ID 13523 //
     /*  61145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61193 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61206 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61210 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61214 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61218 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61223 */     // MIs[4] LHS
     /*  61223 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61230 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61247 */     GIR_RootConstrainSelectedInstOperands,
     /*  61248 */     // GIR_Coverage, 13523,
     /*  61248 */     GIR_EraseRootFromParent_Done,
     /*  61249 */   // Label 1044: @61249
     /*  61249 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61358), // Rule ID 13522 //
     /*  61254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61302 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61315 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61319 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61323 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61327 */     // MIs[4] LHS
     /*  61327 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61332 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61337 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61339 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61356 */     GIR_RootConstrainSelectedInstOperands,
     /*  61357 */     // GIR_Coverage, 13522,
     /*  61357 */     GIR_EraseRootFromParent_Done,
     /*  61358 */   // Label 1045: @61358
     /*  61358 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61467), // Rule ID 13525 //
     /*  61363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61416 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61422 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61428 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61432 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61436 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61441 */     // MIs[4] LHS
     /*  61441 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61446 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61448 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61465 */     GIR_RootConstrainSelectedInstOperands,
     /*  61466 */     // GIR_Coverage, 13525,
     /*  61466 */     GIR_EraseRootFromParent_Done,
     /*  61467 */   // Label 1046: @61467
     /*  61467 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61576), // Rule ID 13524 //
     /*  61472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61525 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61531 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61533 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61537 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61541 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61545 */     // MIs[4] LHS
     /*  61545 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61550 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61555 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61557 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61574 */     GIR_RootConstrainSelectedInstOperands,
     /*  61575 */     // GIR_Coverage, 13524,
     /*  61575 */     GIR_EraseRootFromParent_Done,
     /*  61576 */   // Label 1047: @61576
     /*  61576 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(61685), // Rule ID 2471 //
     /*  61581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61638 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61642 */     // MIs[3] LHS
     /*  61642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61647 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61651 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61657 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61664 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61666 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61683 */     GIR_RootConstrainSelectedInstOperands,
     /*  61684 */     // GIR_Coverage, 2471,
     /*  61684 */     GIR_EraseRootFromParent_Done,
     /*  61685 */   // Label 1048: @61685
     /*  61685 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(61794), // Rule ID 13520 //
     /*  61690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61735 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61747 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61751 */     // MIs[3] LHS
     /*  61751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61756 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61760 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61773 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61775 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  61784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  61788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61792 */     GIR_RootConstrainSelectedInstOperands,
     /*  61793 */     // GIR_Coverage, 13520,
     /*  61793 */     GIR_EraseRootFromParent_Done,
     /*  61794 */   // Label 1049: @61794
     /*  61794 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(61903), // Rule ID 13519 //
     /*  61799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61861 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61865 */     // MIs[3] LHS
     /*  61865 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61870 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61874 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61882 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61884 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  61901 */     GIR_RootConstrainSelectedInstOperands,
     /*  61902 */     // GIR_Coverage, 13519,
     /*  61902 */     GIR_EraseRootFromParent_Done,
     /*  61903 */   // Label 1050: @61903
     /*  61903 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62012), // Rule ID 13521 //
     /*  61908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61974 */     // MIs[3] LHS
     /*  61974 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  61979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61983 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61989 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61993 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62010 */     GIR_RootConstrainSelectedInstOperands,
     /*  62011 */     // GIR_Coverage, 13521,
     /*  62011 */     GIR_EraseRootFromParent_Done,
     /*  62012 */   // Label 1051: @62012
     /*  62012 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62053), // Rule ID 147 //
     /*  62017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62033 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62037 */     // MIs[1] Operand 1
     /*  62037 */     // No operand predicates
     /*  62037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62039 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62046 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62051 */     GIR_RootConstrainSelectedInstOperands,
     /*  62052 */     // GIR_Coverage, 147,
     /*  62052 */     GIR_EraseRootFromParent_Done,
     /*  62053 */   // Label 1052: @62053
     /*  62053 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62086), // Rule ID 13176 //
     /*  62058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62073 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62084 */     GIR_RootConstrainSelectedInstOperands,
     /*  62085 */     // GIR_Coverage, 13176,
     /*  62085 */     GIR_EraseRootFromParent_Done,
     /*  62086 */   // Label 1053: @62086
     /*  62086 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62119), // Rule ID 179 //
     /*  62091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62106 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62117 */     GIR_RootConstrainSelectedInstOperands,
     /*  62118 */     // GIR_Coverage, 179,
     /*  62118 */     GIR_EraseRootFromParent_Done,
     /*  62119 */   // Label 1054: @62119
     /*  62119 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62186), // Rule ID 13459 //
     /*  62124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62148 */     // MIs[1] imm
     /*  62148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62156 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62160 */     // MIs[2] Operand 1
     /*  62160 */     // No operand predicates
     /*  62160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62164 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62170 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62184 */     GIR_RootConstrainSelectedInstOperands,
     /*  62185 */     // GIR_Coverage, 13459,
     /*  62185 */     GIR_EraseRootFromParent_Done,
     /*  62186 */   // Label 1055: @62186
     /*  62186 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62253), // Rule ID 13462 //
     /*  62191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62215 */     // MIs[1] imm
     /*  62215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62227 */     // MIs[2] Operand 1
     /*  62227 */     // No operand predicates
     /*  62227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62231 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62237 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62251 */     GIR_RootConstrainSelectedInstOperands,
     /*  62252 */     // GIR_Coverage, 13462,
     /*  62252 */     GIR_EraseRootFromParent_Done,
     /*  62253 */   // Label 1056: @62253
     /*  62253 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62306), // Rule ID 13172 //
     /*  62258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62293 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62304 */     GIR_RootConstrainSelectedInstOperands,
     /*  62305 */     // GIR_Coverage, 13172,
     /*  62305 */     GIR_EraseRootFromParent_Done,
     /*  62306 */   // Label 1057: @62306
     /*  62306 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62373), // Rule ID 2122 //
     /*  62311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62339 */     // MIs[1] imm
     /*  62339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62351 */     // MIs[2] Operand 1
     /*  62351 */     // No operand predicates
     /*  62351 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62357 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62371 */     GIR_RootConstrainSelectedInstOperands,
     /*  62372 */     // GIR_Coverage, 2122,
     /*  62372 */     GIR_EraseRootFromParent_Done,
     /*  62373 */   // Label 1058: @62373
     /*  62373 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(62440), // Rule ID 2131 //
     /*  62378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62406 */     // MIs[1] imm
     /*  62406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62414 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62418 */     // MIs[2] Operand 1
     /*  62418 */     // No operand predicates
     /*  62418 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62424 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62438 */     GIR_RootConstrainSelectedInstOperands,
     /*  62439 */     // GIR_Coverage, 2131,
     /*  62439 */     GIR_EraseRootFromParent_Done,
     /*  62440 */   // Label 1059: @62440
     /*  62440 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(62493), // Rule ID 173 //
     /*  62445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62474 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62480 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62491 */     GIR_RootConstrainSelectedInstOperands,
     /*  62492 */     // GIR_Coverage, 173,
     /*  62492 */     GIR_EraseRootFromParent_Done,
     /*  62493 */   // Label 1060: @62493
     /*  62493 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(62557), // Rule ID 13811 //
     /*  62498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62530 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62544 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  62547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62549 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  62551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62555 */     GIR_RootConstrainSelectedInstOperands,
     /*  62556 */     // GIR_Coverage, 13811,
     /*  62556 */     GIR_EraseRootFromParent_Done,
     /*  62557 */   // Label 1061: @62557
     /*  62557 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62621), // Rule ID 5041 //
     /*  62562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62598 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62604 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  62606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62608 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  62611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62613 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  62615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62619 */     GIR_RootConstrainSelectedInstOperands,
     /*  62620 */     // GIR_Coverage, 5041,
     /*  62620 */     GIR_EraseRootFromParent_Done,
     /*  62621 */   // Label 1062: @62621
     /*  62621 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(62645), // Rule ID 177 //
     /*  62626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62638 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  62643 */     GIR_RootConstrainSelectedInstOperands,
     /*  62644 */     // GIR_Coverage, 177,
     /*  62644 */     GIR_Done,
     /*  62645 */   // Label 1063: @62645
     /*  62645 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(62672), // Rule ID 5047 //
     /*  62650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62665 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  62665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  62670 */     GIR_RootConstrainSelectedInstOperands,
     /*  62671 */     // GIR_Coverage, 5047,
     /*  62671 */     GIR_Done,
     /*  62672 */   // Label 1064: @62672
     /*  62672 */   GIM_Reject,
     /*  62673 */ // Label 1039: @62673
     /*  62673 */ GIM_Reject,
     /*  62674 */ // Label 1013: @62674
     /*  62674 */ GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63981),
     /*  62679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62685 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62794), // Rule ID 13516 //
     /*  62690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62729 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62738 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62751 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62755 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62759 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62763 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62768 */     // MIs[4] LHS
     /*  62768 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62773 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62775 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  62775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62792 */     GIR_RootConstrainSelectedInstOperands,
     /*  62793 */     // GIR_Coverage, 13516,
     /*  62793 */     GIR_EraseRootFromParent_Done,
     /*  62794 */   // Label 1066: @62794
     /*  62794 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62903), // Rule ID 13515 //
     /*  62799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62843 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62847 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62868 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62872 */     // MIs[4] LHS
     /*  62872 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62877 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62882 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62884 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  62884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62901 */     GIR_RootConstrainSelectedInstOperands,
     /*  62902 */     // GIR_Coverage, 13515,
     /*  62902 */     GIR_EraseRootFromParent_Done,
     /*  62903 */   // Label 1067: @62903
     /*  62903 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(63012), // Rule ID 13518 //
     /*  62908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  62952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62973 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62977 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  62981 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62986 */     // MIs[4] LHS
     /*  62986 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62993 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  62993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63010 */     GIR_RootConstrainSelectedInstOperands,
     /*  63011 */     // GIR_Coverage, 13518,
     /*  63011 */     GIR_EraseRootFromParent_Done,
     /*  63012 */   // Label 1068: @63012
     /*  63012 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63121), // Rule ID 13517 //
     /*  63017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63070 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63086 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63090 */     // MIs[4] LHS
     /*  63090 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63095 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63100 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63102 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63119 */     GIR_RootConstrainSelectedInstOperands,
     /*  63120 */     // GIR_Coverage, 13517,
     /*  63120 */     GIR_EraseRootFromParent_Done,
     /*  63121 */   // Label 1069: @63121
     /*  63121 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63230), // Rule ID 2470 //
     /*  63126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63179 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63187 */     // MIs[3] LHS
     /*  63187 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63196 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63202 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63211 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63228 */     GIR_RootConstrainSelectedInstOperands,
     /*  63229 */     // GIR_Coverage, 2470,
     /*  63229 */     GIR_EraseRootFromParent_Done,
     /*  63230 */   // Label 1070: @63230
     /*  63230 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63339), // Rule ID 13513 //
     /*  63235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63292 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63296 */     // MIs[3] LHS
     /*  63296 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63301 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63305 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63311 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63318 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63320 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63337 */     GIR_RootConstrainSelectedInstOperands,
     /*  63338 */     // GIR_Coverage, 13513,
     /*  63338 */     GIR_EraseRootFromParent_Done,
     /*  63339 */   // Label 1071: @63339
     /*  63339 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63448), // Rule ID 13512 //
     /*  63344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63410 */     // MIs[3] LHS
     /*  63410 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63415 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63419 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63427 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63429 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63446 */     GIR_RootConstrainSelectedInstOperands,
     /*  63447 */     // GIR_Coverage, 13512,
     /*  63447 */     GIR_EraseRootFromParent_Done,
     /*  63448 */   // Label 1072: @63448
     /*  63448 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63557), // Rule ID 13514 //
     /*  63453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63515 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63519 */     // MIs[3] LHS
     /*  63519 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63528 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63534 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63536 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63538 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63555 */     GIR_RootConstrainSelectedInstOperands,
     /*  63556 */     // GIR_Coverage, 13514,
     /*  63556 */     GIR_EraseRootFromParent_Done,
     /*  63557 */   // Label 1073: @63557
     /*  63557 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(63624), // Rule ID 13479 //
     /*  63562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63586 */     // MIs[1] imm
     /*  63586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63594 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63598 */     // MIs[2] Operand 1
     /*  63598 */     // No operand predicates
     /*  63598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63602 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63608 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  63611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63622 */     GIR_RootConstrainSelectedInstOperands,
     /*  63623 */     // GIR_Coverage, 13479,
     /*  63623 */     GIR_EraseRootFromParent_Done,
     /*  63624 */   // Label 1074: @63624
     /*  63624 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(63691), // Rule ID 13500 //
     /*  63629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63653 */     // MIs[1] imm
     /*  63653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63665 */     // MIs[2] Operand 1
     /*  63665 */     // No operand predicates
     /*  63665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63669 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63675 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  63678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  63682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63689 */     GIR_RootConstrainSelectedInstOperands,
     /*  63690 */     // GIR_Coverage, 13500,
     /*  63690 */     GIR_EraseRootFromParent_Done,
     /*  63691 */   // Label 1075: @63691
     /*  63691 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(63758), // Rule ID 2239 //
     /*  63696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63724 */     // MIs[1] imm
     /*  63724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63732 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63736 */     // MIs[2] Operand 1
     /*  63736 */     // No operand predicates
     /*  63736 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63742 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  63745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63756 */     GIR_RootConstrainSelectedInstOperands,
     /*  63757 */     // GIR_Coverage, 2239,
     /*  63757 */     GIR_EraseRootFromParent_Done,
     /*  63758 */   // Label 1076: @63758
     /*  63758 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(63825), // Rule ID 2298 //
     /*  63763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63791 */     // MIs[1] imm
     /*  63791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63799 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  63803 */     // MIs[2] Operand 1
     /*  63803 */     // No operand predicates
     /*  63803 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63809 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  63812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63823 */     GIR_RootConstrainSelectedInstOperands,
     /*  63824 */     // GIR_Coverage, 2298,
     /*  63824 */     GIR_EraseRootFromParent_Done,
     /*  63825 */   // Label 1077: @63825
     /*  63825 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(63889), // Rule ID 13810 //
     /*  63830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63862 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63868 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63876 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  63876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63881 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63887 */     GIR_RootConstrainSelectedInstOperands,
     /*  63888 */     // GIR_Coverage, 13810,
     /*  63888 */     GIR_EraseRootFromParent_Done,
     /*  63889 */   // Label 1078: @63889
     /*  63889 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63953), // Rule ID 5040 //
     /*  63894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63930 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63940 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  63940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63945 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63951 */     GIR_RootConstrainSelectedInstOperands,
     /*  63952 */     // GIR_Coverage, 5040,
     /*  63952 */     GIR_EraseRootFromParent_Done,
     /*  63953 */   // Label 1079: @63953
     /*  63953 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(63980), // Rule ID 5046 //
     /*  63958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63973 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  63973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63978 */     GIR_RootConstrainSelectedInstOperands,
     /*  63979 */     // GIR_Coverage, 5046,
     /*  63979 */     GIR_Done,
     /*  63980 */   // Label 1080: @63980
     /*  63980 */   GIM_Reject,
     /*  63981 */ // Label 1065: @63981
     /*  63981 */ GIM_Reject,
     /*  63982 */ // Label 1014: @63982
     /*  63982 */ GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(65289),
     /*  63987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  63990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  63993 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64102), // Rule ID 13544 //
     /*  63998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64046 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64059 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64063 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64067 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64071 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64076 */     // MIs[4] LHS
     /*  64076 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64081 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64083 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64100 */     GIR_RootConstrainSelectedInstOperands,
     /*  64101 */     // GIR_Coverage, 13544,
     /*  64101 */     GIR_EraseRootFromParent_Done,
     /*  64102 */   // Label 1082: @64102
     /*  64102 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64211), // Rule ID 13543 //
     /*  64107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64155 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64168 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64172 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64176 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64180 */     // MIs[4] LHS
     /*  64180 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64185 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64190 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64192 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64209 */     GIR_RootConstrainSelectedInstOperands,
     /*  64210 */     // GIR_Coverage, 13543,
     /*  64210 */     GIR_EraseRootFromParent_Done,
     /*  64211 */   // Label 1083: @64211
     /*  64211 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(64320), // Rule ID 13546 //
     /*  64216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64269 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64275 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64277 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64281 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64285 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64289 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64294 */     // MIs[4] LHS
     /*  64294 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64299 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64301 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64318 */     GIR_RootConstrainSelectedInstOperands,
     /*  64319 */     // GIR_Coverage, 13546,
     /*  64319 */     GIR_EraseRootFromParent_Done,
     /*  64320 */   // Label 1084: @64320
     /*  64320 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64429), // Rule ID 13545 //
     /*  64325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64394 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64398 */     // MIs[4] LHS
     /*  64398 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64403 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64408 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64410 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64427 */     GIR_RootConstrainSelectedInstOperands,
     /*  64428 */     // GIR_Coverage, 13545,
     /*  64428 */     GIR_EraseRootFromParent_Done,
     /*  64429 */   // Label 1085: @64429
     /*  64429 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64538), // Rule ID 2474 //
     /*  64434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64491 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64495 */     // MIs[3] LHS
     /*  64495 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64500 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64504 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64517 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64519 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64536 */     GIR_RootConstrainSelectedInstOperands,
     /*  64537 */     // GIR_Coverage, 2474,
     /*  64537 */     GIR_EraseRootFromParent_Done,
     /*  64538 */   // Label 1086: @64538
     /*  64538 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(64647), // Rule ID 13541 //
     /*  64543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64604 */     // MIs[3] LHS
     /*  64604 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64609 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64613 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64619 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64626 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64628 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64645 */     GIR_RootConstrainSelectedInstOperands,
     /*  64646 */     // GIR_Coverage, 13541,
     /*  64646 */     GIR_EraseRootFromParent_Done,
     /*  64647 */   // Label 1087: @64647
     /*  64647 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(64756), // Rule ID 13540 //
     /*  64652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64714 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64718 */     // MIs[3] LHS
     /*  64718 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64723 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64727 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64733 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64735 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64737 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64754 */     GIR_RootConstrainSelectedInstOperands,
     /*  64755 */     // GIR_Coverage, 13540,
     /*  64755 */     GIR_EraseRootFromParent_Done,
     /*  64756 */   // Label 1088: @64756
     /*  64756 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(64865), // Rule ID 13542 //
     /*  64761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64823 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64827 */     // MIs[3] LHS
     /*  64827 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64832 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64836 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64844 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64846 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64863 */     GIR_RootConstrainSelectedInstOperands,
     /*  64864 */     // GIR_Coverage, 13542,
     /*  64864 */     GIR_EraseRootFromParent_Done,
     /*  64865 */   // Label 1089: @64865
     /*  64865 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64932), // Rule ID 13483 //
     /*  64870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64894 */     // MIs[1] imm
     /*  64894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64906 */     // MIs[2] Operand 1
     /*  64906 */     // No operand predicates
     /*  64906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64916 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  64919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64930 */     GIR_RootConstrainSelectedInstOperands,
     /*  64931 */     // GIR_Coverage, 13483,
     /*  64931 */     GIR_EraseRootFromParent_Done,
     /*  64932 */   // Label 1090: @64932
     /*  64932 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64999), // Rule ID 13504 //
     /*  64937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64961 */     // MIs[1] imm
     /*  64961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64969 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64973 */     // MIs[2] Operand 1
     /*  64973 */     // No operand predicates
     /*  64973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64977 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64983 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  64986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64997 */     GIR_RootConstrainSelectedInstOperands,
     /*  64998 */     // GIR_Coverage, 13504,
     /*  64998 */     GIR_EraseRootFromParent_Done,
     /*  64999 */   // Label 1091: @64999
     /*  64999 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65066), // Rule ID 2243 //
     /*  65004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65032 */     // MIs[1] imm
     /*  65032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65040 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65044 */     // MIs[2] Operand 1
     /*  65044 */     // No operand predicates
     /*  65044 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65050 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65064 */     GIR_RootConstrainSelectedInstOperands,
     /*  65065 */     // GIR_Coverage, 2243,
     /*  65065 */     GIR_EraseRootFromParent_Done,
     /*  65066 */   // Label 1092: @65066
     /*  65066 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65133), // Rule ID 2302 //
     /*  65071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65099 */     // MIs[1] imm
     /*  65099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65107 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65111 */     // MIs[2] Operand 1
     /*  65111 */     // No operand predicates
     /*  65111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65117 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65131 */     GIR_RootConstrainSelectedInstOperands,
     /*  65132 */     // GIR_Coverage, 2302,
     /*  65132 */     GIR_EraseRootFromParent_Done,
     /*  65133 */   // Label 1093: @65133
     /*  65133 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65197), // Rule ID 13814 //
     /*  65138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65170 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65184 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65189 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65195 */     GIR_RootConstrainSelectedInstOperands,
     /*  65196 */     // GIR_Coverage, 13814,
     /*  65196 */     GIR_EraseRootFromParent_Done,
     /*  65197 */   // Label 1094: @65197
     /*  65197 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65261), // Rule ID 5044 //
     /*  65202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65238 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65248 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65253 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65259 */     GIR_RootConstrainSelectedInstOperands,
     /*  65260 */     // GIR_Coverage, 5044,
     /*  65260 */     GIR_EraseRootFromParent_Done,
     /*  65261 */   // Label 1095: @65261
     /*  65261 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65288), // Rule ID 5050 //
     /*  65266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65281 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65286 */     GIR_RootConstrainSelectedInstOperands,
     /*  65287 */     // GIR_Coverage, 5050,
     /*  65287 */     GIR_Done,
     /*  65288 */   // Label 1096: @65288
     /*  65288 */   GIM_Reject,
     /*  65289 */ // Label 1081: @65289
     /*  65289 */ GIM_Reject,
     /*  65290 */ // Label 1015: @65290
     /*  65290 */ GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(66597),
     /*  65295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65298 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65301 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(65410), // Rule ID 13509 //
     /*  65306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65354 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65360 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65367 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65371 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65375 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65379 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65384 */     // MIs[4] LHS
     /*  65384 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65389 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65391 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65408 */     GIR_RootConstrainSelectedInstOperands,
     /*  65409 */     // GIR_Coverage, 13509,
     /*  65409 */     GIR_EraseRootFromParent_Done,
     /*  65410 */   // Label 1098: @65410
     /*  65410 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(65519), // Rule ID 13508 //
     /*  65415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65450 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65463 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65480 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65488 */     // MIs[4] LHS
     /*  65488 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65493 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65498 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65500 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65517 */     GIR_RootConstrainSelectedInstOperands,
     /*  65518 */     // GIR_Coverage, 13508,
     /*  65518 */     GIR_EraseRootFromParent_Done,
     /*  65519 */   // Label 1099: @65519
     /*  65519 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(65628), // Rule ID 13511 //
     /*  65524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65577 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65583 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65585 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65589 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65593 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65597 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65602 */     // MIs[4] LHS
     /*  65602 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65607 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65609 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65626 */     GIR_RootConstrainSelectedInstOperands,
     /*  65627 */     // GIR_Coverage, 13511,
     /*  65627 */     GIR_EraseRootFromParent_Done,
     /*  65628 */   // Label 1100: @65628
     /*  65628 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65737), // Rule ID 13510 //
     /*  65633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65673 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65686 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65692 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65694 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65698 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65702 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65706 */     // MIs[4] LHS
     /*  65706 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65711 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65716 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65718 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65735 */     GIR_RootConstrainSelectedInstOperands,
     /*  65736 */     // GIR_Coverage, 13510,
     /*  65736 */     GIR_EraseRootFromParent_Done,
     /*  65737 */   // Label 1101: @65737
     /*  65737 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65846), // Rule ID 2469 //
     /*  65742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65787 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65799 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65803 */     // MIs[3] LHS
     /*  65803 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65808 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65812 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65818 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65827 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65844 */     GIR_RootConstrainSelectedInstOperands,
     /*  65845 */     // GIR_Coverage, 2469,
     /*  65845 */     GIR_EraseRootFromParent_Done,
     /*  65846 */   // Label 1102: @65846
     /*  65846 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65955), // Rule ID 13506 //
     /*  65851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65912 */     // MIs[3] LHS
     /*  65912 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65921 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65927 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65934 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65936 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65953 */     GIR_RootConstrainSelectedInstOperands,
     /*  65954 */     // GIR_Coverage, 13506,
     /*  65954 */     GIR_EraseRootFromParent_Done,
     /*  65955 */   // Label 1103: @65955
     /*  65955 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66064), // Rule ID 13505 //
     /*  65960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66005 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66022 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66026 */     // MIs[3] LHS
     /*  66026 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66035 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66041 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66043 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66045 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66062 */     GIR_RootConstrainSelectedInstOperands,
     /*  66063 */     // GIR_Coverage, 13505,
     /*  66063 */     GIR_EraseRootFromParent_Done,
     /*  66064 */   // Label 1104: @66064
     /*  66064 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66173), // Rule ID 13507 //
     /*  66069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66131 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66135 */     // MIs[3] LHS
     /*  66135 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66140 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66144 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66150 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66152 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66154 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66171 */     GIR_RootConstrainSelectedInstOperands,
     /*  66172 */     // GIR_Coverage, 13507,
     /*  66172 */     GIR_EraseRootFromParent_Done,
     /*  66173 */   // Label 1105: @66173
     /*  66173 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66240), // Rule ID 13475 //
     /*  66178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66202 */     // MIs[1] imm
     /*  66202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66210 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66214 */     // MIs[2] Operand 1
     /*  66214 */     // No operand predicates
     /*  66214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66218 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66224 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66238 */     GIR_RootConstrainSelectedInstOperands,
     /*  66239 */     // GIR_Coverage, 13475,
     /*  66239 */     GIR_EraseRootFromParent_Done,
     /*  66240 */   // Label 1106: @66240
     /*  66240 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66307), // Rule ID 13496 //
     /*  66245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66269 */     // MIs[1] imm
     /*  66269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66277 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66281 */     // MIs[2] Operand 1
     /*  66281 */     // No operand predicates
     /*  66281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66285 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66291 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66305 */     GIR_RootConstrainSelectedInstOperands,
     /*  66306 */     // GIR_Coverage, 13496,
     /*  66306 */     GIR_EraseRootFromParent_Done,
     /*  66307 */   // Label 1107: @66307
     /*  66307 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66374), // Rule ID 2235 //
     /*  66312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66340 */     // MIs[1] imm
     /*  66340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66348 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66352 */     // MIs[2] Operand 1
     /*  66352 */     // No operand predicates
     /*  66352 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66358 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66372 */     GIR_RootConstrainSelectedInstOperands,
     /*  66373 */     // GIR_Coverage, 2235,
     /*  66373 */     GIR_EraseRootFromParent_Done,
     /*  66374 */   // Label 1108: @66374
     /*  66374 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66441), // Rule ID 2294 //
     /*  66379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66407 */     // MIs[1] imm
     /*  66407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66419 */     // MIs[2] Operand 1
     /*  66419 */     // No operand predicates
     /*  66419 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66425 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66439 */     GIR_RootConstrainSelectedInstOperands,
     /*  66440 */     // GIR_Coverage, 2294,
     /*  66440 */     GIR_EraseRootFromParent_Done,
     /*  66441 */   // Label 1109: @66441
     /*  66441 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66505), // Rule ID 13809 //
     /*  66446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66478 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66484 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66492 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66497 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  66499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66503 */     GIR_RootConstrainSelectedInstOperands,
     /*  66504 */     // GIR_Coverage, 13809,
     /*  66504 */     GIR_EraseRootFromParent_Done,
     /*  66505 */   // Label 1110: @66505
     /*  66505 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(66569), // Rule ID 5039 //
     /*  66510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66546 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66552 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66556 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66561 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66567 */     GIR_RootConstrainSelectedInstOperands,
     /*  66568 */     // GIR_Coverage, 5039,
     /*  66568 */     GIR_EraseRootFromParent_Done,
     /*  66569 */   // Label 1111: @66569
     /*  66569 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(66596), // Rule ID 5045 //
     /*  66574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66589 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  66589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66594 */     GIR_RootConstrainSelectedInstOperands,
     /*  66595 */     // GIR_Coverage, 5045,
     /*  66595 */     GIR_Done,
     /*  66596 */   // Label 1112: @66596
     /*  66596 */   GIM_Reject,
     /*  66597 */ // Label 1097: @66597
     /*  66597 */ GIM_Reject,
     /*  66598 */ // Label 1016: @66598
     /*  66598 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67905),
     /*  66603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66609 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66718), // Rule ID 13537 //
     /*  66614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66662 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66679 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66683 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66687 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66692 */     // MIs[4] LHS
     /*  66692 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66697 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66699 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66716 */     GIR_RootConstrainSelectedInstOperands,
     /*  66717 */     // GIR_Coverage, 13537,
     /*  66717 */     GIR_EraseRootFromParent_Done,
     /*  66718 */   // Label 1114: @66718
     /*  66718 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66827), // Rule ID 13536 //
     /*  66723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66771 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66788 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66792 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66796 */     // MIs[4] LHS
     /*  66796 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66801 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66806 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66808 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66825 */     GIR_RootConstrainSelectedInstOperands,
     /*  66826 */     // GIR_Coverage, 13536,
     /*  66826 */     GIR_EraseRootFromParent_Done,
     /*  66827 */   // Label 1115: @66827
     /*  66827 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66936), // Rule ID 13539 //
     /*  66832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66885 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66891 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66893 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66897 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66901 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66905 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66910 */     // MIs[4] LHS
     /*  66910 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66915 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66917 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  66917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66934 */     GIR_RootConstrainSelectedInstOperands,
     /*  66935 */     // GIR_Coverage, 13539,
     /*  66935 */     GIR_EraseRootFromParent_Done,
     /*  66936 */   // Label 1116: @66936
     /*  66936 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67045), // Rule ID 13538 //
     /*  66941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  66981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66994 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67000 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67006 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67010 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67014 */     // MIs[4] LHS
     /*  67014 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67019 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67024 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67026 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67043 */     GIR_RootConstrainSelectedInstOperands,
     /*  67044 */     // GIR_Coverage, 13538,
     /*  67044 */     GIR_EraseRootFromParent_Done,
     /*  67045 */   // Label 1117: @67045
     /*  67045 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67154), // Rule ID 2473 //
     /*  67050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67107 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67111 */     // MIs[3] LHS
     /*  67111 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67120 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67126 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67133 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67135 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67152 */     GIR_RootConstrainSelectedInstOperands,
     /*  67153 */     // GIR_Coverage, 2473,
     /*  67153 */     GIR_EraseRootFromParent_Done,
     /*  67154 */   // Label 1118: @67154
     /*  67154 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67263), // Rule ID 13534 //
     /*  67159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67216 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67220 */     // MIs[3] LHS
     /*  67220 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67225 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67229 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67235 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67242 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67244 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67261 */     GIR_RootConstrainSelectedInstOperands,
     /*  67262 */     // GIR_Coverage, 13534,
     /*  67262 */     GIR_EraseRootFromParent_Done,
     /*  67263 */   // Label 1119: @67263
     /*  67263 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67372), // Rule ID 13533 //
     /*  67268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67330 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67334 */     // MIs[3] LHS
     /*  67334 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67343 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67351 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67353 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67370 */     GIR_RootConstrainSelectedInstOperands,
     /*  67371 */     // GIR_Coverage, 13533,
     /*  67371 */     GIR_EraseRootFromParent_Done,
     /*  67372 */   // Label 1120: @67372
     /*  67372 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67481), // Rule ID 13535 //
     /*  67377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67439 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67443 */     // MIs[3] LHS
     /*  67443 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67448 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67452 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67458 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67460 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67462 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67479 */     GIR_RootConstrainSelectedInstOperands,
     /*  67480 */     // GIR_Coverage, 13535,
     /*  67480 */     GIR_EraseRootFromParent_Done,
     /*  67481 */   // Label 1121: @67481
     /*  67481 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(67548), // Rule ID 13481 //
     /*  67486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67510 */     // MIs[1] imm
     /*  67510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67518 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67522 */     // MIs[2] Operand 1
     /*  67522 */     // No operand predicates
     /*  67522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67532 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  67535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67546 */     GIR_RootConstrainSelectedInstOperands,
     /*  67547 */     // GIR_Coverage, 13481,
     /*  67547 */     GIR_EraseRootFromParent_Done,
     /*  67548 */   // Label 1122: @67548
     /*  67548 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(67615), // Rule ID 13502 //
     /*  67553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67577 */     // MIs[1] imm
     /*  67577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67585 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67589 */     // MIs[2] Operand 1
     /*  67589 */     // No operand predicates
     /*  67589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67599 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  67602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67613 */     GIR_RootConstrainSelectedInstOperands,
     /*  67614 */     // GIR_Coverage, 13502,
     /*  67614 */     GIR_EraseRootFromParent_Done,
     /*  67615 */   // Label 1123: @67615
     /*  67615 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(67682), // Rule ID 2241 //
     /*  67620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67648 */     // MIs[1] imm
     /*  67648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67660 */     // MIs[2] Operand 1
     /*  67660 */     // No operand predicates
     /*  67660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67666 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  67669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67680 */     GIR_RootConstrainSelectedInstOperands,
     /*  67681 */     // GIR_Coverage, 2241,
     /*  67681 */     GIR_EraseRootFromParent_Done,
     /*  67682 */   // Label 1124: @67682
     /*  67682 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(67749), // Rule ID 2300 //
     /*  67687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67715 */     // MIs[1] imm
     /*  67715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67723 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  67727 */     // MIs[2] Operand 1
     /*  67727 */     // No operand predicates
     /*  67727 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67733 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  67736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67747 */     GIR_RootConstrainSelectedInstOperands,
     /*  67748 */     // GIR_Coverage, 2300,
     /*  67748 */     GIR_EraseRootFromParent_Done,
     /*  67749 */   // Label 1125: @67749
     /*  67749 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(67813), // Rule ID 13813 //
     /*  67754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67786 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67792 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67800 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67805 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67811 */     GIR_RootConstrainSelectedInstOperands,
     /*  67812 */     // GIR_Coverage, 13813,
     /*  67812 */     GIR_EraseRootFromParent_Done,
     /*  67813 */   // Label 1126: @67813
     /*  67813 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67877), // Rule ID 5043 //
     /*  67818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67854 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67860 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67864 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67869 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67875 */     GIR_RootConstrainSelectedInstOperands,
     /*  67876 */     // GIR_Coverage, 5043,
     /*  67876 */     GIR_EraseRootFromParent_Done,
     /*  67877 */   // Label 1127: @67877
     /*  67877 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67904), // Rule ID 5049 //
     /*  67882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67897 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  67897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  67902 */     GIR_RootConstrainSelectedInstOperands,
     /*  67903 */     // GIR_Coverage, 5049,
     /*  67903 */     GIR_Done,
     /*  67904 */   // Label 1128: @67904
     /*  67904 */   GIM_Reject,
     /*  67905 */ // Label 1113: @67905
     /*  67905 */ GIM_Reject,
     /*  67906 */ // Label 1017: @67906
     /*  67906 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(69213),
     /*  67911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67917 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68026), // Rule ID 13297 //
     /*  67922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  67961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67970 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67983 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67987 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67991 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  67995 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68000 */     // MIs[4] Rd
     /*  68000 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68005 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68007 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68024 */     GIR_RootConstrainSelectedInstOperands,
     /*  68025 */     // GIR_Coverage, 13297,
     /*  68025 */     GIR_EraseRootFromParent_Done,
     /*  68026 */   // Label 1130: @68026
     /*  68026 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68135), // Rule ID 13296 //
     /*  68031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68066 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68079 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68085 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68096 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68100 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68104 */     // MIs[4] Rd
     /*  68104 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68109 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68114 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68116 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68133 */     GIR_RootConstrainSelectedInstOperands,
     /*  68134 */     // GIR_Coverage, 13296,
     /*  68134 */     GIR_EraseRootFromParent_Done,
     /*  68135 */   // Label 1131: @68135
     /*  68135 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68244), // Rule ID 13299 //
     /*  68140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68193 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68201 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68205 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68209 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68213 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68218 */     // MIs[4] Rd
     /*  68218 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68223 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68225 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68242 */     GIR_RootConstrainSelectedInstOperands,
     /*  68243 */     // GIR_Coverage, 13299,
     /*  68243 */     GIR_EraseRootFromParent_Done,
     /*  68244 */   // Label 1132: @68244
     /*  68244 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68353), // Rule ID 13298 //
     /*  68249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68302 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68314 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68318 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68322 */     // MIs[4] Rd
     /*  68322 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68327 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68332 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68334 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68351 */     GIR_RootConstrainSelectedInstOperands,
     /*  68352 */     // GIR_Coverage, 13298,
     /*  68352 */     GIR_EraseRootFromParent_Done,
     /*  68353 */   // Label 1133: @68353
     /*  68353 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68462), // Rule ID 1605 //
     /*  68358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68419 */     // MIs[3] Rd
     /*  68419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68428 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68443 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68460 */     GIR_RootConstrainSelectedInstOperands,
     /*  68461 */     // GIR_Coverage, 1605,
     /*  68461 */     GIR_EraseRootFromParent_Done,
     /*  68462 */   // Label 1134: @68462
     /*  68462 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68571), // Rule ID 13294 //
     /*  68467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68524 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68528 */     // MIs[3] Rd
     /*  68528 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68533 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68537 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68550 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68552 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68569 */     GIR_RootConstrainSelectedInstOperands,
     /*  68570 */     // GIR_Coverage, 13294,
     /*  68570 */     GIR_EraseRootFromParent_Done,
     /*  68571 */   // Label 1135: @68571
     /*  68571 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(68680), // Rule ID 13293 //
     /*  68576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68638 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68642 */     // MIs[3] Rd
     /*  68642 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68647 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68651 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68657 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68659 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68661 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68678 */     GIR_RootConstrainSelectedInstOperands,
     /*  68679 */     // GIR_Coverage, 13293,
     /*  68679 */     GIR_EraseRootFromParent_Done,
     /*  68680 */   // Label 1136: @68680
     /*  68680 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(68789), // Rule ID 13295 //
     /*  68685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68747 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68751 */     // MIs[3] Rd
     /*  68751 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68756 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68760 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68768 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68770 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  68779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  68787 */     GIR_RootConstrainSelectedInstOperands,
     /*  68788 */     // GIR_Coverage, 13295,
     /*  68788 */     GIR_EraseRootFromParent_Done,
     /*  68789 */   // Label 1137: @68789
     /*  68789 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68856), // Rule ID 13471 //
     /*  68794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68818 */     // MIs[1] imm
     /*  68818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68830 */     // MIs[2] Operand 1
     /*  68830 */     // No operand predicates
     /*  68830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68840 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  68843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68854 */     GIR_RootConstrainSelectedInstOperands,
     /*  68855 */     // GIR_Coverage, 13471,
     /*  68855 */     GIR_EraseRootFromParent_Done,
     /*  68856 */   // Label 1138: @68856
     /*  68856 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68923), // Rule ID 13492 //
     /*  68861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68885 */     // MIs[1] imm
     /*  68885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68893 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68897 */     // MIs[2] Operand 1
     /*  68897 */     // No operand predicates
     /*  68897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68901 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68907 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  68910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68921 */     GIR_RootConstrainSelectedInstOperands,
     /*  68922 */     // GIR_Coverage, 13492,
     /*  68922 */     GIR_EraseRootFromParent_Done,
     /*  68923 */   // Label 1139: @68923
     /*  68923 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68990), // Rule ID 2231 //
     /*  68928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68956 */     // MIs[1] imm
     /*  68956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68964 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  68968 */     // MIs[2] Operand 1
     /*  68968 */     // No operand predicates
     /*  68968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68974 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  68977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68988 */     GIR_RootConstrainSelectedInstOperands,
     /*  68989 */     // GIR_Coverage, 2231,
     /*  68989 */     GIR_EraseRootFromParent_Done,
     /*  68990 */   // Label 1140: @68990
     /*  68990 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69057), // Rule ID 2290 //
     /*  68995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69023 */     // MIs[1] imm
     /*  69023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69031 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69035 */     // MIs[2] Operand 1
     /*  69035 */     // No operand predicates
     /*  69035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69041 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69055 */     GIR_RootConstrainSelectedInstOperands,
     /*  69056 */     // GIR_Coverage, 2290,
     /*  69056 */     GIR_EraseRootFromParent_Done,
     /*  69057 */   // Label 1141: @69057
     /*  69057 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69121), // Rule ID 13291 //
     /*  69062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69094 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69108 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69119 */     GIR_RootConstrainSelectedInstOperands,
     /*  69120 */     // GIR_Coverage, 13291,
     /*  69120 */     GIR_EraseRootFromParent_Done,
     /*  69121 */   // Label 1142: @69121
     /*  69121 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69185), // Rule ID 1601 //
     /*  69126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69162 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69172 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69183 */     GIR_RootConstrainSelectedInstOperands,
     /*  69184 */     // GIR_Coverage, 1601,
     /*  69184 */     GIR_EraseRootFromParent_Done,
     /*  69185 */   // Label 1143: @69185
     /*  69185 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69212), // Rule ID 1603 //
     /*  69190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69205 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69210 */     GIR_RootConstrainSelectedInstOperands,
     /*  69211 */     // GIR_Coverage, 1603,
     /*  69211 */     GIR_Done,
     /*  69212 */   // Label 1144: @69212
     /*  69212 */   GIM_Reject,
     /*  69213 */ // Label 1129: @69213
     /*  69213 */ GIM_Reject,
     /*  69214 */ // Label 1018: @69214
     /*  69214 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(70521),
     /*  69219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69225 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69334), // Rule ID 13530 //
     /*  69230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69278 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69303 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69308 */     // MIs[4] LHS
     /*  69308 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69313 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69315 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69332 */     GIR_RootConstrainSelectedInstOperands,
     /*  69333 */     // GIR_Coverage, 13530,
     /*  69333 */     GIR_EraseRootFromParent_Done,
     /*  69334 */   // Label 1146: @69334
     /*  69334 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69443), // Rule ID 13529 //
     /*  69339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69387 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69393 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69408 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69412 */     // MIs[4] LHS
     /*  69412 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69417 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69422 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69424 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69441 */     GIR_RootConstrainSelectedInstOperands,
     /*  69442 */     // GIR_Coverage, 13529,
     /*  69442 */     GIR_EraseRootFromParent_Done,
     /*  69443 */   // Label 1147: @69443
     /*  69443 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(69552), // Rule ID 13532 //
     /*  69448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69501 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69507 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69517 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69521 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69526 */     // MIs[4] LHS
     /*  69526 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69531 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69533 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69550 */     GIR_RootConstrainSelectedInstOperands,
     /*  69551 */     // GIR_Coverage, 13532,
     /*  69551 */     GIR_EraseRootFromParent_Done,
     /*  69552 */   // Label 1148: @69552
     /*  69552 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(69661), // Rule ID 13531 //
     /*  69557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69610 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69622 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69626 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69630 */     // MIs[4] LHS
     /*  69630 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69635 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69640 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69642 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69659 */     GIR_RootConstrainSelectedInstOperands,
     /*  69660 */     // GIR_Coverage, 13531,
     /*  69660 */     GIR_EraseRootFromParent_Done,
     /*  69661 */   // Label 1149: @69661
     /*  69661 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69770), // Rule ID 2472 //
     /*  69666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69727 */     // MIs[3] LHS
     /*  69727 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69736 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69742 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69749 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69751 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69768 */     GIR_RootConstrainSelectedInstOperands,
     /*  69769 */     // GIR_Coverage, 2472,
     /*  69769 */     GIR_EraseRootFromParent_Done,
     /*  69770 */   // Label 1150: @69770
     /*  69770 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69879), // Rule ID 13527 //
     /*  69775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69836 */     // MIs[3] LHS
     /*  69836 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69841 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69845 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69860 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69877 */     GIR_RootConstrainSelectedInstOperands,
     /*  69878 */     // GIR_Coverage, 13527,
     /*  69878 */     GIR_EraseRootFromParent_Done,
     /*  69879 */   // Label 1151: @69879
     /*  69879 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69988), // Rule ID 13526 //
     /*  69884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69946 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69950 */     // MIs[3] LHS
     /*  69950 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69955 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69959 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69965 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69967 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69969 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69986 */     GIR_RootConstrainSelectedInstOperands,
     /*  69987 */     // GIR_Coverage, 13526,
     /*  69987 */     GIR_EraseRootFromParent_Done,
     /*  69988 */   // Label 1152: @69988
     /*  69988 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70097), // Rule ID 13528 //
     /*  69993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70055 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70059 */     // MIs[3] LHS
     /*  70059 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70068 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70074 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70076 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70078 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70095 */     GIR_RootConstrainSelectedInstOperands,
     /*  70096 */     // GIR_Coverage, 13528,
     /*  70096 */     GIR_EraseRootFromParent_Done,
     /*  70097 */   // Label 1153: @70097
     /*  70097 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70164), // Rule ID 13477 //
     /*  70102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70126 */     // MIs[1] imm
     /*  70126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70138 */     // MIs[2] Operand 1
     /*  70138 */     // No operand predicates
     /*  70138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70148 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70162 */     GIR_RootConstrainSelectedInstOperands,
     /*  70163 */     // GIR_Coverage, 13477,
     /*  70163 */     GIR_EraseRootFromParent_Done,
     /*  70164 */   // Label 1154: @70164
     /*  70164 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70231), // Rule ID 13498 //
     /*  70169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70193 */     // MIs[1] imm
     /*  70193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70205 */     // MIs[2] Operand 1
     /*  70205 */     // No operand predicates
     /*  70205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70215 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70229 */     GIR_RootConstrainSelectedInstOperands,
     /*  70230 */     // GIR_Coverage, 13498,
     /*  70230 */     GIR_EraseRootFromParent_Done,
     /*  70231 */   // Label 1155: @70231
     /*  70231 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70298), // Rule ID 2237 //
     /*  70236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70264 */     // MIs[1] imm
     /*  70264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70276 */     // MIs[2] Operand 1
     /*  70276 */     // No operand predicates
     /*  70276 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70282 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70296 */     GIR_RootConstrainSelectedInstOperands,
     /*  70297 */     // GIR_Coverage, 2237,
     /*  70297 */     GIR_EraseRootFromParent_Done,
     /*  70298 */   // Label 1156: @70298
     /*  70298 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70365), // Rule ID 2296 //
     /*  70303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70331 */     // MIs[1] imm
     /*  70331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70339 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70343 */     // MIs[2] Operand 1
     /*  70343 */     // No operand predicates
     /*  70343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70349 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70363 */     GIR_RootConstrainSelectedInstOperands,
     /*  70364 */     // GIR_Coverage, 2296,
     /*  70364 */     GIR_EraseRootFromParent_Done,
     /*  70365 */   // Label 1157: @70365
     /*  70365 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70429), // Rule ID 13812 //
     /*  70370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70402 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70408 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70416 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70421 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70427 */     GIR_RootConstrainSelectedInstOperands,
     /*  70428 */     // GIR_Coverage, 13812,
     /*  70428 */     GIR_EraseRootFromParent_Done,
     /*  70429 */   // Label 1158: @70429
     /*  70429 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(70493), // Rule ID 5042 //
     /*  70434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70470 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70476 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70480 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70485 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  70487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70491 */     GIR_RootConstrainSelectedInstOperands,
     /*  70492 */     // GIR_Coverage, 5042,
     /*  70492 */     GIR_EraseRootFromParent_Done,
     /*  70493 */   // Label 1159: @70493
     /*  70493 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(70520), // Rule ID 5048 //
     /*  70498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70513 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  70518 */     GIR_RootConstrainSelectedInstOperands,
     /*  70519 */     // GIR_Coverage, 5048,
     /*  70519 */     GIR_Done,
     /*  70520 */   // Label 1160: @70520
     /*  70520 */   GIM_Reject,
     /*  70521 */ // Label 1145: @70521
     /*  70521 */ GIM_Reject,
     /*  70522 */ // Label 1019: @70522
     /*  70522 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71829),
     /*  70527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70533 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(70642), // Rule ID 13304 //
     /*  70538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70586 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70592 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70599 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70603 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70607 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70611 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70616 */     // MIs[4] Rd
     /*  70616 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70621 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70623 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70640 */     GIR_RootConstrainSelectedInstOperands,
     /*  70641 */     // GIR_Coverage, 13304,
     /*  70641 */     GIR_EraseRootFromParent_Done,
     /*  70642 */   // Label 1162: @70642
     /*  70642 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(70751), // Rule ID 13303 //
     /*  70647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70682 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70695 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70701 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70720 */     // MIs[4] Rd
     /*  70720 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70725 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70730 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70732 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70749 */     GIR_RootConstrainSelectedInstOperands,
     /*  70750 */     // GIR_Coverage, 13303,
     /*  70750 */     GIR_EraseRootFromParent_Done,
     /*  70751 */   // Label 1163: @70751
     /*  70751 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(70860), // Rule ID 13306 //
     /*  70756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70809 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70817 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70821 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70825 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70829 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70834 */     // MIs[4] Rd
     /*  70834 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70839 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70841 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70858 */     GIR_RootConstrainSelectedInstOperands,
     /*  70859 */     // GIR_Coverage, 13306,
     /*  70859 */     GIR_EraseRootFromParent_Done,
     /*  70860 */   // Label 1164: @70860
     /*  70860 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(70969), // Rule ID 13305 //
     /*  70865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70918 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70930 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70934 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70938 */     // MIs[4] Rd
     /*  70938 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70943 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70948 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70950 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  70950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70967 */     GIR_RootConstrainSelectedInstOperands,
     /*  70968 */     // GIR_Coverage, 13305,
     /*  70968 */     GIR_EraseRootFromParent_Done,
     /*  70969 */   // Label 1165: @70969
     /*  70969 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71078), // Rule ID 1606 //
     /*  70974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  70993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71031 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71035 */     // MIs[3] Rd
     /*  71035 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71040 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71044 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71057 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71059 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71076 */     GIR_RootConstrainSelectedInstOperands,
     /*  71077 */     // GIR_Coverage, 1606,
     /*  71077 */     GIR_EraseRootFromParent_Done,
     /*  71078 */   // Label 1166: @71078
     /*  71078 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71187), // Rule ID 13301 //
     /*  71083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71140 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71144 */     // MIs[3] Rd
     /*  71144 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71153 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71166 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71168 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71185 */     GIR_RootConstrainSelectedInstOperands,
     /*  71186 */     // GIR_Coverage, 13301,
     /*  71186 */     GIR_EraseRootFromParent_Done,
     /*  71187 */   // Label 1167: @71187
     /*  71187 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71296), // Rule ID 13300 //
     /*  71192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71254 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71258 */     // MIs[3] Rd
     /*  71258 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71263 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71267 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71273 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71275 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71277 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71294 */     GIR_RootConstrainSelectedInstOperands,
     /*  71295 */     // GIR_Coverage, 13300,
     /*  71295 */     GIR_EraseRootFromParent_Done,
     /*  71296 */   // Label 1168: @71296
     /*  71296 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71405), // Rule ID 13302 //
     /*  71301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71346 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71363 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71367 */     // MIs[3] Rd
     /*  71367 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71372 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71376 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71382 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71384 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71386 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71403 */     GIR_RootConstrainSelectedInstOperands,
     /*  71404 */     // GIR_Coverage, 13302,
     /*  71404 */     GIR_EraseRootFromParent_Done,
     /*  71405 */   // Label 1169: @71405
     /*  71405 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71472), // Rule ID 13473 //
     /*  71410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71434 */     // MIs[1] imm
     /*  71434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71446 */     // MIs[2] Operand 1
     /*  71446 */     // No operand predicates
     /*  71446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71456 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71470 */     GIR_RootConstrainSelectedInstOperands,
     /*  71471 */     // GIR_Coverage, 13473,
     /*  71471 */     GIR_EraseRootFromParent_Done,
     /*  71472 */   // Label 1170: @71472
     /*  71472 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(71539), // Rule ID 13494 //
     /*  71477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71501 */     // MIs[1] imm
     /*  71501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71509 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71513 */     // MIs[2] Operand 1
     /*  71513 */     // No operand predicates
     /*  71513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71517 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71523 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  71526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71537 */     GIR_RootConstrainSelectedInstOperands,
     /*  71538 */     // GIR_Coverage, 13494,
     /*  71538 */     GIR_EraseRootFromParent_Done,
     /*  71539 */   // Label 1171: @71539
     /*  71539 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(71606), // Rule ID 2233 //
     /*  71544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71572 */     // MIs[1] imm
     /*  71572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71584 */     // MIs[2] Operand 1
     /*  71584 */     // No operand predicates
     /*  71584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71590 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71604 */     GIR_RootConstrainSelectedInstOperands,
     /*  71605 */     // GIR_Coverage, 2233,
     /*  71605 */     GIR_EraseRootFromParent_Done,
     /*  71606 */   // Label 1172: @71606
     /*  71606 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(71673), // Rule ID 2292 //
     /*  71611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71639 */     // MIs[1] imm
     /*  71639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71651 */     // MIs[2] Operand 1
     /*  71651 */     // No operand predicates
     /*  71651 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71657 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  71660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71671 */     GIR_RootConstrainSelectedInstOperands,
     /*  71672 */     // GIR_Coverage, 2292,
     /*  71672 */     GIR_EraseRootFromParent_Done,
     /*  71673 */   // Label 1173: @71673
     /*  71673 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(71737), // Rule ID 13292 //
     /*  71678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71710 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71724 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71735 */     GIR_RootConstrainSelectedInstOperands,
     /*  71736 */     // GIR_Coverage, 13292,
     /*  71736 */     GIR_EraseRootFromParent_Done,
     /*  71737 */   // Label 1174: @71737
     /*  71737 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(71801), // Rule ID 1602 //
     /*  71742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71778 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71788 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71799 */     GIR_RootConstrainSelectedInstOperands,
     /*  71800 */     // GIR_Coverage, 1602,
     /*  71800 */     GIR_EraseRootFromParent_Done,
     /*  71801 */   // Label 1175: @71801
     /*  71801 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(71828), // Rule ID 1604 //
     /*  71806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71821 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71826 */     GIR_RootConstrainSelectedInstOperands,
     /*  71827 */     // GIR_Coverage, 1604,
     /*  71827 */     GIR_Done,
     /*  71828 */   // Label 1176: @71828
     /*  71828 */   GIM_Reject,
     /*  71829 */ // Label 1161: @71829
     /*  71829 */ GIM_Reject,
     /*  71830 */ // Label 1020: @71830
     /*  71830 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(71861), // Rule ID 8397 //
     /*  71835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  71841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  71844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71848 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  71848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71853 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71855 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71857 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71859 */   GIR_RootConstrainSelectedInstOperands,
     /*  71860 */   // GIR_Coverage, 8397,
     /*  71860 */   GIR_EraseRootFromParent_Done,
     /*  71861 */ // Label 1177: @71861
     /*  71861 */ GIM_Reject,
     /*  71862 */ // Label 1021: @71862
     /*  71862 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(71893), // Rule ID 8396 //
     /*  71867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  71873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  71876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71880 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  71880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71885 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71887 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71889 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71891 */   GIR_RootConstrainSelectedInstOperands,
     /*  71892 */   // GIR_Coverage, 8396,
     /*  71892 */   GIR_EraseRootFromParent_Done,
     /*  71893 */ // Label 1178: @71893
     /*  71893 */ GIM_Reject,
     /*  71894 */ // Label 1022: @71894
     /*  71894 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(71919), // Rule ID 7406 //
     /*  71899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  71905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  71908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  71912 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  71912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  71917 */   GIR_RootConstrainSelectedInstOperands,
     /*  71918 */   // GIR_Coverage, 7406,
     /*  71918 */   GIR_Done,
     /*  71919 */ // Label 1179: @71919
     /*  71919 */ GIM_Reject,
     /*  71920 */ // Label 1023: @71920
     /*  71920 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(71951), // Rule ID 8395 //
     /*  71925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  71931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  71934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71938 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  71938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  71943 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  71947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  71949 */   GIR_RootConstrainSelectedInstOperands,
     /*  71950 */   // GIR_Coverage, 8395,
     /*  71950 */   GIR_EraseRootFromParent_Done,
     /*  71951 */ // Label 1180: @71951
     /*  71951 */ GIM_Reject,
     /*  71952 */ // Label 1024: @71952
     /*  71952 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(71977), // Rule ID 7405 //
     /*  71957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  71963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  71966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  71970 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  71970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  71975 */   GIR_RootConstrainSelectedInstOperands,
     /*  71976 */   // GIR_Coverage, 7405,
     /*  71976 */   GIR_Done,
     /*  71977 */ // Label 1181: @71977
     /*  71977 */ GIM_Reject,
     /*  71978 */ // Label 1025: @71978
     /*  71978 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72009), // Rule ID 8394 //
     /*  71983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  71986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  71989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  71992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  71996 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  71996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  71999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72001 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72003 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72005 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72007 */   GIR_RootConstrainSelectedInstOperands,
     /*  72008 */   // GIR_Coverage, 8394,
     /*  72008 */   GIR_EraseRootFromParent_Done,
     /*  72009 */ // Label 1182: @72009
     /*  72009 */ GIM_Reject,
     /*  72010 */ // Label 1026: @72010
     /*  72010 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72035), // Rule ID 7404 //
     /*  72015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72028 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72033 */   GIR_RootConstrainSelectedInstOperands,
     /*  72034 */   // GIR_Coverage, 7404,
     /*  72034 */   GIR_Done,
     /*  72035 */ // Label 1183: @72035
     /*  72035 */ GIM_Reject,
     /*  72036 */ // Label 1027: @72036
     /*  72036 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72067), // Rule ID 8393 //
     /*  72041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72054 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72059 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72061 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72063 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72065 */   GIR_RootConstrainSelectedInstOperands,
     /*  72066 */   // GIR_Coverage, 8393,
     /*  72066 */   GIR_EraseRootFromParent_Done,
     /*  72067 */ // Label 1184: @72067
     /*  72067 */ GIM_Reject,
     /*  72068 */ // Label 1028: @72068
     /*  72068 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(72093), // Rule ID 7403 //
     /*  72073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72086 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72091 */   GIR_RootConstrainSelectedInstOperands,
     /*  72092 */   // GIR_Coverage, 7403,
     /*  72092 */   GIR_Done,
     /*  72093 */ // Label 1185: @72093
     /*  72093 */ GIM_Reject,
     /*  72094 */ // Label 1029: @72094
     /*  72094 */ GIM_Reject,
     /*  72095 */ // Label 7: @72095
     /*  72095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1204*/ GIMT_Encode4(79286),
     /*  72106 */ /*GILLT_s32*//*Label 1186*/ GIMT_Encode4(72194),
     /*  72110 */ /*GILLT_s64*//*Label 1187*/ GIMT_Encode4(72874), GIMT_Encode4(0),
     /*  72118 */ /*GILLT_v2s32*//*Label 1188*/ GIMT_Encode4(73717),
     /*  72122 */ /*GILLT_v2s64*//*Label 1189*/ GIMT_Encode4(73952),
     /*  72126 */ /*GILLT_v4s16*//*Label 1190*/ GIMT_Encode4(74641),
     /*  72130 */ /*GILLT_v4s32*//*Label 1191*/ GIMT_Encode4(74876),
     /*  72134 */ /*GILLT_v8s8*//*Label 1192*/ GIMT_Encode4(75565),
     /*  72138 */ /*GILLT_v8s16*//*Label 1193*/ GIMT_Encode4(75803),
     /*  72142 */ /*GILLT_v16s8*//*Label 1194*/ GIMT_Encode4(76492),
     /*  72146 */ /*GILLT_nxv1s1*//*Label 1195*/ GIMT_Encode4(77184),
     /*  72150 */ /*GILLT_nxv2s1*//*Label 1196*/ GIMT_Encode4(77234), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72162 */ /*GILLT_nxv2s64*//*Label 1197*/ GIMT_Encode4(77284),
     /*  72166 */ /*GILLT_nxv4s1*//*Label 1198*/ GIMT_Encode4(77747), GIMT_Encode4(0),
     /*  72174 */ /*GILLT_nxv4s32*//*Label 1199*/ GIMT_Encode4(77797),
     /*  72178 */ /*GILLT_nxv8s1*//*Label 1200*/ GIMT_Encode4(78260),
     /*  72182 */ /*GILLT_nxv8s16*//*Label 1201*/ GIMT_Encode4(78310),
     /*  72186 */ /*GILLT_nxv16s1*//*Label 1202*/ GIMT_Encode4(78773),
     /*  72190 */ /*GILLT_nxv16s8*//*Label 1203*/ GIMT_Encode4(78823),
     /*  72194 */ // Label 1186: @72194
     /*  72194 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(72873),
     /*  72199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72205 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(72263), // Rule ID 13162 //
     /*  72210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72235 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72248 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72257 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72261 */     GIR_RootConstrainSelectedInstOperands,
     /*  72262 */     // GIR_Coverage, 13162,
     /*  72262 */     GIR_EraseRootFromParent_Done,
     /*  72263 */   // Label 1206: @72263
     /*  72263 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(72318), // Rule ID 13161 //
     /*  72268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72288 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72305 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72316 */     GIR_RootConstrainSelectedInstOperands,
     /*  72317 */     // GIR_Coverage, 13161,
     /*  72317 */     GIR_EraseRootFromParent_Done,
     /*  72318 */   // Label 1207: @72318
     /*  72318 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(72376), // Rule ID 13159 //
     /*  72323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72361 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72374 */     GIR_RootConstrainSelectedInstOperands,
     /*  72375 */     // GIR_Coverage, 13159,
     /*  72375 */     GIR_EraseRootFromParent_Done,
     /*  72376 */   // Label 1208: @72376
     /*  72376 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(72434), // Rule ID 166 //
     /*  72381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72419 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72432 */     GIR_RootConstrainSelectedInstOperands,
     /*  72433 */     // GIR_Coverage, 166,
     /*  72433 */     GIR_EraseRootFromParent_Done,
     /*  72434 */   // Label 1209: @72434
     /*  72434 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(72492), // Rule ID 13160 //
     /*  72439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72464 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72477 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72490 */     GIR_RootConstrainSelectedInstOperands,
     /*  72491 */     // GIR_Coverage, 13160,
     /*  72491 */     GIR_EraseRootFromParent_Done,
     /*  72492 */   // Label 1210: @72492
     /*  72492 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(72547), // Rule ID 13163 //
     /*  72497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72521 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72534 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72545 */     GIR_RootConstrainSelectedInstOperands,
     /*  72546 */     // GIR_Coverage, 13163,
     /*  72546 */     GIR_EraseRootFromParent_Done,
     /*  72547 */   // Label 1211: @72547
     /*  72547 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(72588), // Rule ID 144 //
     /*  72552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  72556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72568 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  72572 */     // MIs[1] Operand 1
     /*  72572 */     // No operand predicates
     /*  72572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72574 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  72574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  72577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72581 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  72586 */     GIR_RootConstrainSelectedInstOperands,
     /*  72587 */     // GIR_Coverage, 144,
     /*  72587 */     GIR_EraseRootFromParent_Done,
     /*  72588 */   // Label 1212: @72588
     /*  72588 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(72621), // Rule ID 13169 //
     /*  72593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72608 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  72611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72619 */     GIR_RootConstrainSelectedInstOperands,
     /*  72620 */     // GIR_Coverage, 13169,
     /*  72620 */     GIR_EraseRootFromParent_Done,
     /*  72621 */   // Label 1213: @72621
     /*  72621 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(72654), // Rule ID 170 //
     /*  72626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72641 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  72644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72648 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72652 */     GIR_RootConstrainSelectedInstOperands,
     /*  72653 */     // GIR_Coverage, 170,
     /*  72653 */     GIR_EraseRootFromParent_Done,
     /*  72654 */   // Label 1214: @72654
     /*  72654 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(72707), // Rule ID 13155 //
     /*  72659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72684 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72694 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  72705 */     GIR_RootConstrainSelectedInstOperands,
     /*  72706 */     // GIR_Coverage, 13155,
     /*  72706 */     GIR_EraseRootFromParent_Done,
     /*  72707 */   // Label 1215: @72707
     /*  72707 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(72763), // Rule ID 164 //
     /*  72712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72748 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72761 */     GIR_RootConstrainSelectedInstOperands,
     /*  72762 */     // GIR_Coverage, 164,
     /*  72762 */     GIR_EraseRootFromParent_Done,
     /*  72763 */   // Label 1216: @72763
     /*  72763 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(72816), // Rule ID 13156 //
     /*  72768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72797 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72803 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  72806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  72814 */     GIR_RootConstrainSelectedInstOperands,
     /*  72815 */     // GIR_Coverage, 13156,
     /*  72815 */     GIR_EraseRootFromParent_Done,
     /*  72816 */   // Label 1217: @72816
     /*  72816 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(72848), // Rule ID 3992 //
     /*  72821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72833 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  72833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  72836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  72846 */     GIR_RootConstrainSelectedInstOperands,
     /*  72847 */     // GIR_Coverage, 3992,
     /*  72847 */     GIR_EraseRootFromParent_Done,
     /*  72848 */   // Label 1218: @72848
     /*  72848 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(72872), // Rule ID 168 //
     /*  72853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72865 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  72865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  72870 */     GIR_RootConstrainSelectedInstOperands,
     /*  72871 */     // GIR_Coverage, 168,
     /*  72871 */     GIR_Done,
     /*  72872 */   // Label 1219: @72872
     /*  72872 */   GIM_Reject,
     /*  72873 */ // Label 1205: @72873
     /*  72873 */ GIM_Reject,
     /*  72874 */ // Label 1187: @72874
     /*  72874 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73716),
     /*  72879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  72882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72885 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(72943), // Rule ID 13167 //
     /*  72890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  72906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  72910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72915 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  72928 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  72928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  72931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72937 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72941 */     GIR_RootConstrainSelectedInstOperands,
     /*  72942 */     // GIR_Coverage, 13167,
     /*  72942 */     GIR_EraseRootFromParent_Done,
     /*  72943 */   // Label 1221: @72943
     /*  72943 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(72998), // Rule ID 13166 //
     /*  72948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  72964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  72968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  72976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  72985 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  72985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  72988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72996 */     GIR_RootConstrainSelectedInstOperands,
     /*  72997 */     // GIR_Coverage, 13166,
     /*  72997 */     GIR_EraseRootFromParent_Done,
     /*  72998 */   // Label 1222: @72998
     /*  72998 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(73056), // Rule ID 13164 //
     /*  73003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73041 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73054 */     GIR_RootConstrainSelectedInstOperands,
     /*  73055 */     // GIR_Coverage, 13164,
     /*  73055 */     GIR_EraseRootFromParent_Done,
     /*  73056 */   // Label 1223: @73056
     /*  73056 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73114), // Rule ID 167 //
     /*  73061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73099 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73112 */     GIR_RootConstrainSelectedInstOperands,
     /*  73113 */     // GIR_Coverage, 167,
     /*  73113 */     GIR_EraseRootFromParent_Done,
     /*  73114 */   // Label 1224: @73114
     /*  73114 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73172), // Rule ID 13165 //
     /*  73119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73144 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73157 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73170 */     GIR_RootConstrainSelectedInstOperands,
     /*  73171 */     // GIR_Coverage, 13165,
     /*  73171 */     GIR_EraseRootFromParent_Done,
     /*  73172 */   // Label 1225: @73172
     /*  73172 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73227), // Rule ID 13168 //
     /*  73177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73201 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73207 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73214 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73221 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73225 */     GIR_RootConstrainSelectedInstOperands,
     /*  73226 */     // GIR_Coverage, 13168,
     /*  73226 */     GIR_EraseRootFromParent_Done,
     /*  73227 */   // Label 1226: @73227
     /*  73227 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73327), // Rule ID 1613 //
     /*  73232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  73255 */     // MIs[1] Operand 1
     /*  73255 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  73272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  73276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  73290 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73296 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  73298 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73302 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73310 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73312 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  73312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  73315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  73321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73325 */     GIR_RootConstrainSelectedInstOperands,
     /*  73326 */     // GIR_Coverage, 1613,
     /*  73326 */     GIR_EraseRootFromParent_Done,
     /*  73327 */   // Label 1227: @73327
     /*  73327 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(73368), // Rule ID 145 //
     /*  73332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  73336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73348 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  73352 */     // MIs[1] Operand 1
     /*  73352 */     // No operand predicates
     /*  73352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73354 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  73354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  73357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73361 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  73366 */     GIR_RootConstrainSelectedInstOperands,
     /*  73367 */     // GIR_Coverage, 145,
     /*  73367 */     GIR_EraseRootFromParent_Done,
     /*  73368 */   // Label 1228: @73368
     /*  73368 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(73401), // Rule ID 13170 //
     /*  73373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73388 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73395 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73399 */     GIR_RootConstrainSelectedInstOperands,
     /*  73400 */     // GIR_Coverage, 13170,
     /*  73400 */     GIR_EraseRootFromParent_Done,
     /*  73401 */   // Label 1229: @73401
     /*  73401 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(73434), // Rule ID 171 //
     /*  73406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73421 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73432 */     GIR_RootConstrainSelectedInstOperands,
     /*  73433 */     // GIR_Coverage, 171,
     /*  73433 */     GIR_EraseRootFromParent_Done,
     /*  73434 */   // Label 1230: @73434
     /*  73434 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(73487), // Rule ID 13157 //
     /*  73439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73464 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73474 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73485 */     GIR_RootConstrainSelectedInstOperands,
     /*  73486 */     // GIR_Coverage, 13157,
     /*  73486 */     GIR_EraseRootFromParent_Done,
     /*  73487 */   // Label 1231: @73487
     /*  73487 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(73543), // Rule ID 165 //
     /*  73492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73528 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73541 */     GIR_RootConstrainSelectedInstOperands,
     /*  73542 */     // GIR_Coverage, 165,
     /*  73542 */     GIR_EraseRootFromParent_Done,
     /*  73543 */   // Label 1232: @73543
     /*  73543 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(73596), // Rule ID 13158 //
     /*  73548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73577 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73583 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  73586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73594 */     GIR_RootConstrainSelectedInstOperands,
     /*  73595 */     // GIR_Coverage, 13158,
     /*  73595 */     GIR_EraseRootFromParent_Done,
     /*  73596 */   // Label 1233: @73596
     /*  73596 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(73628), // Rule ID 3993 //
     /*  73601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73613 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  73613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  73616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  73626 */     GIR_RootConstrainSelectedInstOperands,
     /*  73627 */     // GIR_Coverage, 3993,
     /*  73627 */     GIR_EraseRootFromParent_Done,
     /*  73628 */   // Label 1234: @73628
     /*  73628 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(73664), // Rule ID 4939 //
     /*  73633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73645 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73655 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  73655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  73658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73662 */     GIR_RootConstrainSelectedInstOperands,
     /*  73663 */     // GIR_Coverage, 4939,
     /*  73663 */     GIR_EraseRootFromParent_Done,
     /*  73664 */   // Label 1235: @73664
     /*  73664 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(73688), // Rule ID 169 //
     /*  73669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73681 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  73681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  73686 */     GIR_RootConstrainSelectedInstOperands,
     /*  73687 */     // GIR_Coverage, 169,
     /*  73687 */     GIR_Done,
     /*  73688 */   // Label 1236: @73688
     /*  73688 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(73715), // Rule ID 5035 //
     /*  73693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73708 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  73708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  73713 */     GIR_RootConstrainSelectedInstOperands,
     /*  73714 */     // GIR_Coverage, 5035,
     /*  73714 */     GIR_Done,
     /*  73715 */   // Label 1237: @73715
     /*  73715 */   GIM_Reject,
     /*  73716 */ // Label 1220: @73716
     /*  73716 */ GIM_Reject,
     /*  73717 */ // Label 1188: @73717
     /*  73717 */ GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(73951),
     /*  73722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  73725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73732 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(73828), // Rule ID 1160 //
     /*  73737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  73756 */     // MIs[1] Operand 1
     /*  73756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  73773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  73791 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73797 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  73799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73803 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73811 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73813 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  73813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  73816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  73822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73826 */     GIR_RootConstrainSelectedInstOperands,
     /*  73827 */     // GIR_Coverage, 1160,
     /*  73827 */     GIR_EraseRootFromParent_Done,
     /*  73828 */   // Label 1239: @73828
     /*  73828 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(73895), // Rule ID 4983 //
     /*  73833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  73845 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  73849 */     // MIs[1] Operand 1
     /*  73849 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  73858 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73864 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  73866 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  73870 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73876 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73880 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  73880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  73883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73893 */     GIR_RootConstrainSelectedInstOperands,
     /*  73894 */     // GIR_Coverage, 4983,
     /*  73894 */     GIR_EraseRootFromParent_Done,
     /*  73895 */   // Label 1240: @73895
     /*  73895 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(73927), // Rule ID 4937 //
     /*  73900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73908 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  73916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73918 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  73918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  73921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73925 */     GIR_RootConstrainSelectedInstOperands,
     /*  73926 */     // GIR_Coverage, 4937,
     /*  73926 */     GIR_EraseRootFromParent_Done,
     /*  73927 */   // Label 1241: @73927
     /*  73927 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(73950), // Rule ID 5034 //
     /*  73932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73943 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  73943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  73948 */     GIR_RootConstrainSelectedInstOperands,
     /*  73949 */     // GIR_Coverage, 5034,
     /*  73949 */     GIR_Done,
     /*  73950 */   // Label 1242: @73950
     /*  73950 */   GIM_Reject,
     /*  73951 */ // Label 1238: @73951
     /*  73951 */ GIM_Reject,
     /*  73952 */ // Label 1189: @73952
     /*  73952 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74640),
     /*  73957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  73960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  73963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73967 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(74063), // Rule ID 1162 //
     /*  73972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  73987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  73991 */     // MIs[1] Operand 1
     /*  73991 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74032 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74034 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74038 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74046 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74048 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  74048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74061 */     GIR_RootConstrainSelectedInstOperands,
     /*  74062 */     // GIR_Coverage, 1162,
     /*  74062 */     GIR_EraseRootFromParent_Done,
     /*  74063 */   // Label 1244: @74063
     /*  74063 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74130), // Rule ID 4985 //
     /*  74068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74080 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74084 */     // MIs[1] Operand 1
     /*  74084 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74093 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74105 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74111 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74115 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  74115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74128 */     GIR_RootConstrainSelectedInstOperands,
     /*  74129 */     // GIR_Coverage, 4985,
     /*  74129 */     GIR_EraseRootFromParent_Done,
     /*  74130 */   // Label 1245: @74130
     /*  74130 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(74215), // Rule ID 13692 //
     /*  74135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74166 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74175 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74179 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74185 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74198 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74213 */     GIR_RootConstrainSelectedInstOperands,
     /*  74214 */     // GIR_Coverage, 13692,
     /*  74214 */     GIR_EraseRootFromParent_Done,
     /*  74215 */   // Label 1246: @74215
     /*  74215 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74300), // Rule ID 13691 //
     /*  74220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74269 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74275 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74283 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74298 */     GIR_RootConstrainSelectedInstOperands,
     /*  74299 */     // GIR_Coverage, 13691,
     /*  74299 */     GIR_EraseRootFromParent_Done,
     /*  74300 */   // Label 1247: @74300
     /*  74300 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(74385), // Rule ID 13690 //
     /*  74305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74353 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74359 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74368 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74383 */     GIR_RootConstrainSelectedInstOperands,
     /*  74384 */     // GIR_Coverage, 13690,
     /*  74384 */     GIR_EraseRootFromParent_Done,
     /*  74385 */   // Label 1248: @74385
     /*  74385 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(74470), // Rule ID 3820 //
     /*  74390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74443 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74451 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74453 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74468 */     GIR_RootConstrainSelectedInstOperands,
     /*  74469 */     // GIR_Coverage, 3820,
     /*  74469 */     GIR_EraseRootFromParent_Done,
     /*  74470 */   // Label 1249: @74470
     /*  74470 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(74502), // Rule ID 4940 //
     /*  74475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74483 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74489 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74493 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  74493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  74496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74500 */     GIR_RootConstrainSelectedInstOperands,
     /*  74501 */     // GIR_Coverage, 4940,
     /*  74501 */     GIR_EraseRootFromParent_Done,
     /*  74502 */   // Label 1250: @74502
     /*  74502 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(74559), // Rule ID 3816 //
     /*  74507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74542 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  74557 */     GIR_RootConstrainSelectedInstOperands,
     /*  74558 */     // GIR_Coverage, 3816,
     /*  74558 */     GIR_EraseRootFromParent_Done,
     /*  74559 */   // Label 1251: @74559
     /*  74559 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(74616), // Rule ID 13680 //
     /*  74564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74599 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  74602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  74608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  74614 */     GIR_RootConstrainSelectedInstOperands,
     /*  74615 */     // GIR_Coverage, 13680,
     /*  74615 */     GIR_EraseRootFromParent_Done,
     /*  74616 */   // Label 1252: @74616
     /*  74616 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(74639), // Rule ID 5038 //
     /*  74621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74632 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  74632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  74637 */     GIR_RootConstrainSelectedInstOperands,
     /*  74638 */     // GIR_Coverage, 5038,
     /*  74638 */     GIR_Done,
     /*  74639 */   // Label 1253: @74639
     /*  74639 */   GIM_Reject,
     /*  74640 */ // Label 1243: @74640
     /*  74640 */ GIM_Reject,
     /*  74641 */ // Label 1190: @74641
     /*  74641 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(74875),
     /*  74646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  74649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74656 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(74752), // Rule ID 1158 //
     /*  74661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74676 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  74680 */     // MIs[1] Operand 1
     /*  74680 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  74697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74715 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74723 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74727 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74733 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74735 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74737 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  74737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  74740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74750 */     GIR_RootConstrainSelectedInstOperands,
     /*  74751 */     // GIR_Coverage, 1158,
     /*  74751 */     GIR_EraseRootFromParent_Done,
     /*  74752 */   // Label 1255: @74752
     /*  74752 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(74819), // Rule ID 4981 //
     /*  74757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  74769 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  74773 */     // MIs[1] Operand 1
     /*  74773 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74788 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74804 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  74804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  74807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74817 */     GIR_RootConstrainSelectedInstOperands,
     /*  74818 */     // GIR_Coverage, 4981,
     /*  74818 */     GIR_EraseRootFromParent_Done,
     /*  74819 */   // Label 1256: @74819
     /*  74819 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(74851), // Rule ID 4935 //
     /*  74824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74832 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74838 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74842 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  74842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74849 */     GIR_RootConstrainSelectedInstOperands,
     /*  74850 */     // GIR_Coverage, 4935,
     /*  74850 */     GIR_EraseRootFromParent_Done,
     /*  74851 */   // Label 1257: @74851
     /*  74851 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(74874), // Rule ID 5033 //
     /*  74856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74867 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  74867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74872 */     GIR_RootConstrainSelectedInstOperands,
     /*  74873 */     // GIR_Coverage, 5033,
     /*  74873 */     GIR_Done,
     /*  74874 */   // Label 1258: @74874
     /*  74874 */   GIM_Reject,
     /*  74875 */ // Label 1254: @74875
     /*  74875 */ GIM_Reject,
     /*  74876 */ // Label 1191: @74876
     /*  74876 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(75564),
     /*  74881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74891 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(74987), // Rule ID 1161 //
     /*  74896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74911 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74915 */     // MIs[1] Operand 1
     /*  74915 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  74932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74950 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74956 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74962 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74968 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74972 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  74972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  74975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74985 */     GIR_RootConstrainSelectedInstOperands,
     /*  74986 */     // GIR_Coverage, 1161,
     /*  74986 */     GIR_EraseRootFromParent_Done,
     /*  74987 */   // Label 1260: @74987
     /*  74987 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75054), // Rule ID 4984 //
     /*  74992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75004 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75008 */     // MIs[1] Operand 1
     /*  75008 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75017 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75023 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75029 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75035 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75039 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  75039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75052 */     GIR_RootConstrainSelectedInstOperands,
     /*  75053 */     // GIR_Coverage, 4984,
     /*  75053 */     GIR_EraseRootFromParent_Done,
     /*  75054 */   // Label 1261: @75054
     /*  75054 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(75139), // Rule ID 13689 //
     /*  75059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75103 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75109 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75122 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75137 */     GIR_RootConstrainSelectedInstOperands,
     /*  75138 */     // GIR_Coverage, 13689,
     /*  75138 */     GIR_EraseRootFromParent_Done,
     /*  75139 */   // Label 1262: @75139
     /*  75139 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75224), // Rule ID 13688 //
     /*  75144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75193 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75207 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75222 */     GIR_RootConstrainSelectedInstOperands,
     /*  75223 */     // GIR_Coverage, 13688,
     /*  75223 */     GIR_EraseRootFromParent_Done,
     /*  75224 */   // Label 1263: @75224
     /*  75224 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75309), // Rule ID 13687 //
     /*  75229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75277 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75292 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75307 */     GIR_RootConstrainSelectedInstOperands,
     /*  75308 */     // GIR_Coverage, 13687,
     /*  75308 */     GIR_EraseRootFromParent_Done,
     /*  75309 */   // Label 1264: @75309
     /*  75309 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75394), // Rule ID 3819 //
     /*  75314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75367 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75373 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75377 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75392 */     GIR_RootConstrainSelectedInstOperands,
     /*  75393 */     // GIR_Coverage, 3819,
     /*  75393 */     GIR_EraseRootFromParent_Done,
     /*  75394 */   // Label 1265: @75394
     /*  75394 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75426), // Rule ID 4938 //
     /*  75399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75413 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75417 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  75417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75424 */     GIR_RootConstrainSelectedInstOperands,
     /*  75425 */     // GIR_Coverage, 4938,
     /*  75425 */     GIR_EraseRootFromParent_Done,
     /*  75426 */   // Label 1266: @75426
     /*  75426 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(75483), // Rule ID 3815 //
     /*  75431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75466 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75481 */     GIR_RootConstrainSelectedInstOperands,
     /*  75482 */     // GIR_Coverage, 3815,
     /*  75482 */     GIR_EraseRootFromParent_Done,
     /*  75483 */   // Label 1267: @75483
     /*  75483 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(75540), // Rule ID 13679 //
     /*  75488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75523 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75538 */     GIR_RootConstrainSelectedInstOperands,
     /*  75539 */     // GIR_Coverage, 13679,
     /*  75539 */     GIR_EraseRootFromParent_Done,
     /*  75540 */   // Label 1268: @75540
     /*  75540 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(75563), // Rule ID 5037 //
     /*  75545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75556 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  75556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75561 */     GIR_RootConstrainSelectedInstOperands,
     /*  75562 */     // GIR_Coverage, 5037,
     /*  75562 */     GIR_Done,
     /*  75563 */   // Label 1269: @75563
     /*  75563 */   GIM_Reject,
     /*  75564 */ // Label 1259: @75564
     /*  75564 */ GIM_Reject,
     /*  75565 */ // Label 1192: @75565
     /*  75565 */ GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(75802),
     /*  75570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  75573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75580 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(75676), // Rule ID 1156 //
     /*  75585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  75604 */     // MIs[1] Operand 1
     /*  75604 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  75621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75639 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75645 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75647 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75651 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75657 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75659 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75661 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  75661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  75664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75674 */     GIR_RootConstrainSelectedInstOperands,
     /*  75675 */     // GIR_Coverage, 1156,
     /*  75675 */     GIR_EraseRootFromParent_Done,
     /*  75676 */   // Label 1271: @75676
     /*  75676 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(75743), // Rule ID 4979 //
     /*  75681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  75693 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  75697 */     // MIs[1] Operand 1
     /*  75697 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75706 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75712 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75718 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75728 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  75728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  75731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75741 */     GIR_RootConstrainSelectedInstOperands,
     /*  75742 */     // GIR_Coverage, 4979,
     /*  75742 */     GIR_EraseRootFromParent_Done,
     /*  75743 */   // Label 1272: @75743
     /*  75743 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(75778), // Rule ID 972 //
     /*  75748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75759 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75769 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  75769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75776 */     GIR_RootConstrainSelectedInstOperands,
     /*  75777 */     // GIR_Coverage, 972,
     /*  75777 */     GIR_EraseRootFromParent_Done,
     /*  75778 */   // Label 1273: @75778
     /*  75778 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(75801), // Rule ID 1599 //
     /*  75783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75794 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  75794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75799 */     GIR_RootConstrainSelectedInstOperands,
     /*  75800 */     // GIR_Coverage, 1599,
     /*  75800 */     GIR_Done,
     /*  75801 */   // Label 1274: @75801
     /*  75801 */   GIM_Reject,
     /*  75802 */ // Label 1270: @75802
     /*  75802 */ GIM_Reject,
     /*  75803 */ // Label 1193: @75803
     /*  75803 */ GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(76491),
     /*  75808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75818 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(75914), // Rule ID 1159 //
     /*  75823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75838 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75842 */     // MIs[1] Operand 1
     /*  75842 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  75859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75877 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75883 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75885 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75889 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75895 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75897 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75899 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  75899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  75902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75912 */     GIR_RootConstrainSelectedInstOperands,
     /*  75913 */     // GIR_Coverage, 1159,
     /*  75913 */     GIR_EraseRootFromParent_Done,
     /*  75914 */   // Label 1276: @75914
     /*  75914 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(75981), // Rule ID 4982 //
     /*  75919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75931 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75935 */     // MIs[1] Operand 1
     /*  75935 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75944 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75950 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75956 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75962 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75966 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  75966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  75969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75979 */     GIR_RootConstrainSelectedInstOperands,
     /*  75980 */     // GIR_Coverage, 4982,
     /*  75980 */     GIR_EraseRootFromParent_Done,
     /*  75981 */   // Label 1277: @75981
     /*  75981 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(76066), // Rule ID 13686 //
     /*  75986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76021 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76030 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76036 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76047 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76049 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76064 */     GIR_RootConstrainSelectedInstOperands,
     /*  76065 */     // GIR_Coverage, 13686,
     /*  76065 */     GIR_EraseRootFromParent_Done,
     /*  76066 */   // Label 1278: @76066
     /*  76066 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(76151), // Rule ID 13685 //
     /*  76071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76120 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76126 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76134 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76149 */     GIR_RootConstrainSelectedInstOperands,
     /*  76150 */     // GIR_Coverage, 13685,
     /*  76150 */     GIR_EraseRootFromParent_Done,
     /*  76151 */   // Label 1279: @76151
     /*  76151 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(76236), // Rule ID 13684 //
     /*  76156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76204 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76210 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76219 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76234 */     GIR_RootConstrainSelectedInstOperands,
     /*  76235 */     // GIR_Coverage, 13684,
     /*  76235 */     GIR_EraseRootFromParent_Done,
     /*  76236 */   // Label 1280: @76236
     /*  76236 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(76321), // Rule ID 3818 //
     /*  76241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76281 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76294 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76302 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76304 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76319 */     GIR_RootConstrainSelectedInstOperands,
     /*  76320 */     // GIR_Coverage, 3818,
     /*  76320 */     GIR_EraseRootFromParent_Done,
     /*  76321 */   // Label 1281: @76321
     /*  76321 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(76353), // Rule ID 4936 //
     /*  76326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76334 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76344 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  76344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76351 */     GIR_RootConstrainSelectedInstOperands,
     /*  76352 */     // GIR_Coverage, 4936,
     /*  76352 */     GIR_EraseRootFromParent_Done,
     /*  76353 */   // Label 1282: @76353
     /*  76353 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(76410), // Rule ID 3814 //
     /*  76358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76393 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76408 */     GIR_RootConstrainSelectedInstOperands,
     /*  76409 */     // GIR_Coverage, 3814,
     /*  76409 */     GIR_EraseRootFromParent_Done,
     /*  76410 */   // Label 1283: @76410
     /*  76410 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(76467), // Rule ID 13678 //
     /*  76415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76450 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76465 */     GIR_RootConstrainSelectedInstOperands,
     /*  76466 */     // GIR_Coverage, 13678,
     /*  76466 */     GIR_EraseRootFromParent_Done,
     /*  76467 */   // Label 1284: @76467
     /*  76467 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(76490), // Rule ID 5036 //
     /*  76472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76483 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  76483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76488 */     GIR_RootConstrainSelectedInstOperands,
     /*  76489 */     // GIR_Coverage, 5036,
     /*  76489 */     GIR_Done,
     /*  76490 */   // Label 1285: @76490
     /*  76490 */   GIM_Reject,
     /*  76491 */ // Label 1275: @76491
     /*  76491 */ GIM_Reject,
     /*  76492 */ // Label 1194: @76492
     /*  76492 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(77183),
     /*  76497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76507 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(76603), // Rule ID 1157 //
     /*  76512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76527 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76531 */     // MIs[1] Operand 1
     /*  76531 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76566 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76574 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76578 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76584 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76586 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76588 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  76588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  76591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76601 */     GIR_RootConstrainSelectedInstOperands,
     /*  76602 */     // GIR_Coverage, 1157,
     /*  76602 */     GIR_EraseRootFromParent_Done,
     /*  76603 */   // Label 1287: @76603
     /*  76603 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(76670), // Rule ID 4980 //
     /*  76608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76624 */     // MIs[1] Operand 1
     /*  76624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76633 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76639 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76645 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76655 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  76655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  76658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76668 */     GIR_RootConstrainSelectedInstOperands,
     /*  76669 */     // GIR_Coverage, 4980,
     /*  76669 */     GIR_EraseRootFromParent_Done,
     /*  76670 */   // Label 1288: @76670
     /*  76670 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(76755), // Rule ID 13683 //
     /*  76675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76719 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76725 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76738 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76753 */     GIR_RootConstrainSelectedInstOperands,
     /*  76754 */     // GIR_Coverage, 13683,
     /*  76754 */     GIR_EraseRootFromParent_Done,
     /*  76755 */   // Label 1289: @76755
     /*  76755 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(76840), // Rule ID 13682 //
     /*  76760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76809 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76823 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76838 */     GIR_RootConstrainSelectedInstOperands,
     /*  76839 */     // GIR_Coverage, 13682,
     /*  76839 */     GIR_EraseRootFromParent_Done,
     /*  76840 */   // Label 1290: @76840
     /*  76840 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(76925), // Rule ID 13681 //
     /*  76845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76893 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76908 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76923 */     GIR_RootConstrainSelectedInstOperands,
     /*  76924 */     // GIR_Coverage, 13681,
     /*  76924 */     GIR_EraseRootFromParent_Done,
     /*  76925 */   // Label 1291: @76925
     /*  76925 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77010), // Rule ID 3817 //
     /*  76930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  76970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76983 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76989 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76991 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76993 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  76993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77008 */     GIR_RootConstrainSelectedInstOperands,
     /*  77009 */     // GIR_Coverage, 3817,
     /*  77009 */     GIR_EraseRootFromParent_Done,
     /*  77010 */   // Label 1292: @77010
     /*  77010 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(77045), // Rule ID 973 //
     /*  77015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77026 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77036 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  77036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77043 */     GIR_RootConstrainSelectedInstOperands,
     /*  77044 */     // GIR_Coverage, 973,
     /*  77044 */     GIR_EraseRootFromParent_Done,
     /*  77045 */   // Label 1293: @77045
     /*  77045 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(77102), // Rule ID 3813 //
     /*  77050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77085 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77100 */     GIR_RootConstrainSelectedInstOperands,
     /*  77101 */     // GIR_Coverage, 3813,
     /*  77101 */     GIR_EraseRootFromParent_Done,
     /*  77102 */   // Label 1294: @77102
     /*  77102 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(77159), // Rule ID 13677 //
     /*  77107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77142 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77157 */     GIR_RootConstrainSelectedInstOperands,
     /*  77158 */     // GIR_Coverage, 13677,
     /*  77158 */     GIR_EraseRootFromParent_Done,
     /*  77159 */   // Label 1295: @77159
     /*  77159 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(77182), // Rule ID 1600 //
     /*  77164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77175 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77180 */     GIR_RootConstrainSelectedInstOperands,
     /*  77181 */     // GIR_Coverage, 1600,
     /*  77181 */     GIR_Done,
     /*  77182 */   // Label 1296: @77182
     /*  77182 */   GIM_Reject,
     /*  77183 */ // Label 1286: @77183
     /*  77183 */ GIM_Reject,
     /*  77184 */ // Label 1195: @77184
     /*  77184 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(77233), // Rule ID 8387 //
     /*  77189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  77195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  77198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77202 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  77202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77214 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77227 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77229 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77231 */   GIR_RootConstrainSelectedInstOperands,
     /*  77232 */   // GIR_Coverage, 8387,
     /*  77232 */   GIR_EraseRootFromParent_Done,
     /*  77233 */ // Label 1297: @77233
     /*  77233 */ GIM_Reject,
     /*  77234 */ // Label 1196: @77234
     /*  77234 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(77283), // Rule ID 8386 //
     /*  77239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  77245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  77248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77252 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  77252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77264 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77277 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77279 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77281 */   GIR_RootConstrainSelectedInstOperands,
     /*  77282 */   // GIR_Coverage, 8386,
     /*  77282 */   GIR_EraseRootFromParent_Done,
     /*  77283 */ // Label 1298: @77283
     /*  77283 */ GIM_Reject,
     /*  77284 */ // Label 1197: @77284
     /*  77284 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(77746),
     /*  77289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77299 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(77370), // Rule ID 15529 //
     /*  77304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77343 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77353 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77368 */     GIR_RootConstrainSelectedInstOperands,
     /*  77369 */     // GIR_Coverage, 15529,
     /*  77369 */     GIR_EraseRootFromParent_Done,
     /*  77370 */   // Label 1300: @77370
     /*  77370 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(77441), // Rule ID 15528 //
     /*  77375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77414 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77420 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77424 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77439 */     GIR_RootConstrainSelectedInstOperands,
     /*  77440 */     // GIR_Coverage, 15528,
     /*  77440 */     GIR_EraseRootFromParent_Done,
     /*  77441 */   // Label 1301: @77441
     /*  77441 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(77512), // Rule ID 15527 //
     /*  77446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77485 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77495 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77510 */     GIR_RootConstrainSelectedInstOperands,
     /*  77511 */     // GIR_Coverage, 15527,
     /*  77511 */     GIR_EraseRootFromParent_Done,
     /*  77512 */   // Label 1302: @77512
     /*  77512 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(77583), // Rule ID 11797 //
     /*  77517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77548 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77556 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77562 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77566 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77581 */     GIR_RootConstrainSelectedInstOperands,
     /*  77582 */     // GIR_Coverage, 11797,
     /*  77582 */     GIR_EraseRootFromParent_Done,
     /*  77583 */   // Label 1303: @77583
     /*  77583 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(77644), // Rule ID 11821 //
     /*  77588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  77599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77607 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  77611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77615 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  77623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77625 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  77628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  77638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77642 */     GIR_RootConstrainSelectedInstOperands,
     /*  77643 */     // GIR_Coverage, 11821,
     /*  77643 */     GIR_EraseRootFromParent_Done,
     /*  77644 */   // Label 1304: @77644
     /*  77644 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(77687), // Rule ID 13644 //
     /*  77649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77670 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  77685 */     GIR_RootConstrainSelectedInstOperands,
     /*  77686 */     // GIR_Coverage, 13644,
     /*  77686 */     GIR_EraseRootFromParent_Done,
     /*  77687 */   // Label 1305: @77687
     /*  77687 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(77730), // Rule ID 3154 //
     /*  77692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77713 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  77716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77728 */     GIR_RootConstrainSelectedInstOperands,
     /*  77729 */     // GIR_Coverage, 3154,
     /*  77729 */     GIR_EraseRootFromParent_Done,
     /*  77730 */   // Label 1306: @77730
     /*  77730 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(77745), // Rule ID 7410 //
     /*  77735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77738 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  77743 */     GIR_RootConstrainSelectedInstOperands,
     /*  77744 */     // GIR_Coverage, 7410,
     /*  77744 */     GIR_Done,
     /*  77745 */   // Label 1307: @77745
     /*  77745 */   GIM_Reject,
     /*  77746 */ // Label 1299: @77746
     /*  77746 */ GIM_Reject,
     /*  77747 */ // Label 1198: @77747
     /*  77747 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(77796), // Rule ID 8385 //
     /*  77752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77765 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  77772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77777 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77790 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77792 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77794 */   GIR_RootConstrainSelectedInstOperands,
     /*  77795 */   // GIR_Coverage, 8385,
     /*  77795 */   GIR_EraseRootFromParent_Done,
     /*  77796 */ // Label 1308: @77796
     /*  77796 */ GIM_Reject,
     /*  77797 */ // Label 1199: @77797
     /*  77797 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(78259),
     /*  77802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77812 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(77883), // Rule ID 15526 //
     /*  77817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77856 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77866 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77881 */     GIR_RootConstrainSelectedInstOperands,
     /*  77882 */     // GIR_Coverage, 15526,
     /*  77882 */     GIR_EraseRootFromParent_Done,
     /*  77883 */   // Label 1310: @77883
     /*  77883 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(77954), // Rule ID 15525 //
     /*  77888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77927 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77937 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77952 */     GIR_RootConstrainSelectedInstOperands,
     /*  77953 */     // GIR_Coverage, 15525,
     /*  77953 */     GIR_EraseRootFromParent_Done,
     /*  77954 */   // Label 1311: @77954
     /*  77954 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(78025), // Rule ID 15524 //
     /*  77959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77998 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78004 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78008 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78023 */     GIR_RootConstrainSelectedInstOperands,
     /*  78024 */     // GIR_Coverage, 15524,
     /*  78024 */     GIR_EraseRootFromParent_Done,
     /*  78025 */   // Label 1312: @78025
     /*  78025 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(78096), // Rule ID 11795 //
     /*  78030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78069 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78079 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78094 */     GIR_RootConstrainSelectedInstOperands,
     /*  78095 */     // GIR_Coverage, 11795,
     /*  78095 */     GIR_EraseRootFromParent_Done,
     /*  78096 */   // Label 1313: @78096
     /*  78096 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(78157), // Rule ID 11819 //
     /*  78101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78120 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  78124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78128 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78134 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78138 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78155 */     GIR_RootConstrainSelectedInstOperands,
     /*  78156 */     // GIR_Coverage, 11819,
     /*  78156 */     GIR_EraseRootFromParent_Done,
     /*  78157 */   // Label 1314: @78157
     /*  78157 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(78200), // Rule ID 13643 //
     /*  78162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78183 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78198 */     GIR_RootConstrainSelectedInstOperands,
     /*  78199 */     // GIR_Coverage, 13643,
     /*  78199 */     GIR_EraseRootFromParent_Done,
     /*  78200 */   // Label 1315: @78200
     /*  78200 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(78243), // Rule ID 3152 //
     /*  78205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78226 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78241 */     GIR_RootConstrainSelectedInstOperands,
     /*  78242 */     // GIR_Coverage, 3152,
     /*  78242 */     GIR_EraseRootFromParent_Done,
     /*  78243 */   // Label 1316: @78243
     /*  78243 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(78258), // Rule ID 7409 //
     /*  78248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78251 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  78251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78256 */     GIR_RootConstrainSelectedInstOperands,
     /*  78257 */     // GIR_Coverage, 7409,
     /*  78257 */     GIR_Done,
     /*  78258 */   // Label 1317: @78258
     /*  78258 */   GIM_Reject,
     /*  78259 */ // Label 1309: @78259
     /*  78259 */ GIM_Reject,
     /*  78260 */ // Label 1200: @78260
     /*  78260 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(78309), // Rule ID 8384 //
     /*  78265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  78271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  78274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78278 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  78278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  78285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78290 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78303 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78305 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78307 */   GIR_RootConstrainSelectedInstOperands,
     /*  78308 */   // GIR_Coverage, 8384,
     /*  78308 */   GIR_EraseRootFromParent_Done,
     /*  78309 */ // Label 1318: @78309
     /*  78309 */ GIM_Reject,
     /*  78310 */ // Label 1201: @78310
     /*  78310 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(78772),
     /*  78315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78325 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(78396), // Rule ID 15523 //
     /*  78330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78369 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78375 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78379 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78394 */     GIR_RootConstrainSelectedInstOperands,
     /*  78395 */     // GIR_Coverage, 15523,
     /*  78395 */     GIR_EraseRootFromParent_Done,
     /*  78396 */   // Label 1320: @78396
     /*  78396 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(78467), // Rule ID 15522 //
     /*  78401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78440 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78450 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78465 */     GIR_RootConstrainSelectedInstOperands,
     /*  78466 */     // GIR_Coverage, 15522,
     /*  78466 */     GIR_EraseRootFromParent_Done,
     /*  78467 */   // Label 1321: @78467
     /*  78467 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(78538), // Rule ID 15521 //
     /*  78472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78511 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78517 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78521 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78536 */     GIR_RootConstrainSelectedInstOperands,
     /*  78537 */     // GIR_Coverage, 15521,
     /*  78537 */     GIR_EraseRootFromParent_Done,
     /*  78538 */   // Label 1322: @78538
     /*  78538 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(78609), // Rule ID 11793 //
     /*  78543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78582 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78592 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78607 */     GIR_RootConstrainSelectedInstOperands,
     /*  78608 */     // GIR_Coverage, 11793,
     /*  78608 */     GIR_EraseRootFromParent_Done,
     /*  78609 */   // Label 1323: @78609
     /*  78609 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78670), // Rule ID 11817 //
     /*  78614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78633 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  78637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78641 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78651 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78668 */     GIR_RootConstrainSelectedInstOperands,
     /*  78669 */     // GIR_Coverage, 11817,
     /*  78669 */     GIR_EraseRootFromParent_Done,
     /*  78670 */   // Label 1324: @78670
     /*  78670 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(78713), // Rule ID 13642 //
     /*  78675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78696 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78711 */     GIR_RootConstrainSelectedInstOperands,
     /*  78712 */     // GIR_Coverage, 13642,
     /*  78712 */     GIR_EraseRootFromParent_Done,
     /*  78713 */   // Label 1325: @78713
     /*  78713 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(78756), // Rule ID 3150 //
     /*  78718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78739 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78754 */     GIR_RootConstrainSelectedInstOperands,
     /*  78755 */     // GIR_Coverage, 3150,
     /*  78755 */     GIR_EraseRootFromParent_Done,
     /*  78756 */   // Label 1326: @78756
     /*  78756 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(78771), // Rule ID 7408 //
     /*  78761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78764 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  78764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78769 */     GIR_RootConstrainSelectedInstOperands,
     /*  78770 */     // GIR_Coverage, 7408,
     /*  78770 */     GIR_Done,
     /*  78771 */   // Label 1327: @78771
     /*  78771 */   GIM_Reject,
     /*  78772 */ // Label 1319: @78772
     /*  78772 */ GIM_Reject,
     /*  78773 */ // Label 1202: @78773
     /*  78773 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(78822), // Rule ID 8383 //
     /*  78778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  78784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  78787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78791 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  78791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  78798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78803 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78816 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78818 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78820 */   GIR_RootConstrainSelectedInstOperands,
     /*  78821 */   // GIR_Coverage, 8383,
     /*  78821 */   GIR_EraseRootFromParent_Done,
     /*  78822 */ // Label 1328: @78822
     /*  78822 */ GIM_Reject,
     /*  78823 */ // Label 1203: @78823
     /*  78823 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(79285),
     /*  78828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78838 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(78909), // Rule ID 15520 //
     /*  78843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78882 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78888 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78892 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78907 */     GIR_RootConstrainSelectedInstOperands,
     /*  78908 */     // GIR_Coverage, 15520,
     /*  78908 */     GIR_EraseRootFromParent_Done,
     /*  78909 */   // Label 1330: @78909
     /*  78909 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(78980), // Rule ID 15519 //
     /*  78914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  78945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  78949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78953 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78959 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78963 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  78963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78978 */     GIR_RootConstrainSelectedInstOperands,
     /*  78979 */     // GIR_Coverage, 15519,
     /*  78979 */     GIR_EraseRootFromParent_Done,
     /*  78980 */   // Label 1331: @78980
     /*  78980 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(79051), // Rule ID 15518 //
     /*  78985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79024 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79030 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79032 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79034 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79049 */     GIR_RootConstrainSelectedInstOperands,
     /*  79050 */     // GIR_Coverage, 15518,
     /*  79050 */     GIR_EraseRootFromParent_Done,
     /*  79051 */   // Label 1332: @79051
     /*  79051 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(79122), // Rule ID 11791 //
     /*  79056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79095 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79101 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79103 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79105 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79120 */     GIR_RootConstrainSelectedInstOperands,
     /*  79121 */     // GIR_Coverage, 11791,
     /*  79121 */     GIR_EraseRootFromParent_Done,
     /*  79122 */   // Label 1333: @79122
     /*  79122 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(79183), // Rule ID 11815 //
     /*  79127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79146 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  79150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79154 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79160 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79164 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79181 */     GIR_RootConstrainSelectedInstOperands,
     /*  79182 */     // GIR_Coverage, 11815,
     /*  79182 */     GIR_EraseRootFromParent_Done,
     /*  79183 */   // Label 1334: @79183
     /*  79183 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(79226), // Rule ID 13641 //
     /*  79188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79209 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79224 */     GIR_RootConstrainSelectedInstOperands,
     /*  79225 */     // GIR_Coverage, 13641,
     /*  79225 */     GIR_EraseRootFromParent_Done,
     /*  79226 */   // Label 1335: @79226
     /*  79226 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(79269), // Rule ID 3148 //
     /*  79231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79252 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79267 */     GIR_RootConstrainSelectedInstOperands,
     /*  79268 */     // GIR_Coverage, 3148,
     /*  79268 */     GIR_EraseRootFromParent_Done,
     /*  79269 */   // Label 1336: @79269
     /*  79269 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(79284), // Rule ID 7407 //
     /*  79274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79277 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  79277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79282 */     GIR_RootConstrainSelectedInstOperands,
     /*  79283 */     // GIR_Coverage, 7407,
     /*  79283 */     GIR_Done,
     /*  79284 */   // Label 1337: @79284
     /*  79284 */   GIM_Reject,
     /*  79285 */ // Label 1329: @79285
     /*  79285 */ GIM_Reject,
     /*  79286 */ // Label 1204: @79286
     /*  79286 */ GIM_Reject,
     /*  79287 */ // Label 8: @79287
     /*  79287 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(86810),
     /*  79292 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  79295 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1350*/ GIMT_Encode4(86809),
     /*  79306 */   /*GILLT_v2s64*//*Label 1339*/ GIMT_Encode4(79374), GIMT_Encode4(0),
     /*  79314 */   /*GILLT_v4s32*//*Label 1340*/ GIMT_Encode4(79895), GIMT_Encode4(0),
     /*  79322 */   /*GILLT_v8s16*//*Label 1341*/ GIMT_Encode4(82307),
     /*  79326 */   /*GILLT_v16s8*//*Label 1342*/ GIMT_Encode4(84716), GIMT_Encode4(0),
     /*  79334 */   /*GILLT_nxv2s1*//*Label 1343*/ GIMT_Encode4(86627), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  79350 */   /*GILLT_nxv4s1*//*Label 1344*/ GIMT_Encode4(86653),
     /*  79354 */   /*GILLT_nxv4s16*//*Label 1345*/ GIMT_Encode4(86679),
     /*  79358 */   /*GILLT_nxv4s32*//*Label 1346*/ GIMT_Encode4(86705),
     /*  79362 */   /*GILLT_nxv8s1*//*Label 1347*/ GIMT_Encode4(86731),
     /*  79366 */   /*GILLT_nxv8s16*//*Label 1348*/ GIMT_Encode4(86757),
     /*  79370 */   /*GILLT_nxv16s1*//*Label 1349*/ GIMT_Encode4(86783),
     /*  79374 */   // Label 1339: @79374
     /*  79374 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(79894),
     /*  79379 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  79382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  79385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79393 */     GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(79455), // Rule ID 5753 //
     /*  79398 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79402 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79408 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  79410 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79412 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  79412 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  79415 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  79419 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79424 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  79428 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79430 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79433 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79435 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79438 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79441 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79444 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79449 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79454 */       // GIR_Coverage, 5753,
     /*  79454 */       GIR_EraseRootFromParent_Done,
     /*  79455 */     // Label 1352: @79455
     /*  79455 */     GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(79517), // Rule ID 5757 //
     /*  79460 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79464 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79470 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  79472 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79474 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  79474 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  79477 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  79481 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79486 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  79490 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79492 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79495 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79497 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79500 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79503 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79506 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79511 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79516 */       // GIR_Coverage, 5757,
     /*  79516 */       GIR_EraseRootFromParent_Done,
     /*  79517 */     // Label 1353: @79517
     /*  79517 */     GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(79575), // Rule ID 5754 //
     /*  79522 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79526 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  79530 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79532 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  79532 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  79535 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79539 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79544 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79546 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79549 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79551 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79554 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  79556 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79559 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79564 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79569 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79574 */       // GIR_Coverage, 5754,
     /*  79574 */       GIR_EraseRootFromParent_Done,
     /*  79575 */     // Label 1354: @79575
     /*  79575 */     GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(79633), // Rule ID 5758 //
     /*  79580 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79584 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  79588 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79590 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  79590 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  79593 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79597 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79602 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79604 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79607 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79609 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79612 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  79614 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79617 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79622 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79627 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79632 */       // GIR_Coverage, 5758,
     /*  79632 */       GIR_EraseRootFromParent_Done,
     /*  79633 */     // Label 1355: @79633
     /*  79633 */     GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(79763), // Rule ID 5752 //
     /*  79638 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79642 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  79642 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  79645 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79649 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79654 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  79656 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  79659 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79663 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79668 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  79671 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  79675 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  79678 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79683 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79688 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79693 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79696 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79700 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79705 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79707 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79710 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79714 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79719 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79722 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79726 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79729 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79734 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79739 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79744 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79747 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79749 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79752 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79755 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79758 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79761 */       GIR_RootConstrainSelectedInstOperands,
     /*  79762 */       // GIR_Coverage, 5752,
     /*  79762 */       GIR_EraseRootFromParent_Done,
     /*  79763 */     // Label 1356: @79763
     /*  79763 */     GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(79893), // Rule ID 5756 //
     /*  79768 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79772 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  79772 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  79775 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79779 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  79786 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  79789 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79793 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79798 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  79801 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  79805 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  79808 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79813 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79818 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79823 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  79826 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79830 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79835 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  79837 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79840 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  79844 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79849 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  79852 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  79856 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  79859 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79864 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79869 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79874 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  79877 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79879 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79882 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  79885 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  79888 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79891 */       GIR_RootConstrainSelectedInstOperands,
     /*  79892 */       // GIR_Coverage, 5756,
     /*  79892 */       GIR_EraseRootFromParent_Done,
     /*  79893 */     // Label 1357: @79893
     /*  79893 */     GIM_Reject,
     /*  79894 */   // Label 1351: @79894
     /*  79894 */   GIM_Reject,
     /*  79895 */   // Label 1340: @79895
     /*  79895 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(82306),
     /*  79900 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  79903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  79906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79910 */     GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(80039), // Rule ID 5416 //
     /*  79915 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79919 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79923 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  79927 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79931 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79935 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  79939 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79943 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79947 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79951 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  79955 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  79959 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79964 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79968 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79974 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79976 */       // MIs[2] Operand 2
     /*  79976 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  79987 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79989 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  79989 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  79992 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79996 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80001 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80004 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80008 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80011 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80016 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80021 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80024 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80026 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80029 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80033 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80037 */       GIR_RootConstrainSelectedInstOperands,
     /*  80038 */       // GIR_Coverage, 5416,
     /*  80038 */       GIR_EraseRootFromParent_Done,
     /*  80039 */     // Label 1359: @80039
     /*  80039 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(80161), // Rule ID 5412 //
     /*  80044 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80048 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80052 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80056 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80060 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80064 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80068 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80072 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80076 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  80080 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80084 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80088 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80093 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80098 */       // MIs[2] Operand 2
     /*  80098 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80109 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80111 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80111 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80114 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80118 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80123 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80126 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80130 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80133 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80138 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80143 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80146 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80148 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80151 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80155 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80159 */       GIR_RootConstrainSelectedInstOperands,
     /*  80160 */       // GIR_Coverage, 5412,
     /*  80160 */       GIR_EraseRootFromParent_Done,
     /*  80161 */     // Label 1360: @80161
     /*  80161 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80283), // Rule ID 5414 //
     /*  80166 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80170 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80174 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80178 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80182 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80186 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80190 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80194 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80198 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80202 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80206 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80210 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80215 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80220 */       // MIs[2] Operand 2
     /*  80220 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80231 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80233 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80233 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80236 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80240 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80245 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80248 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80252 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80255 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80260 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80265 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80268 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80270 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80273 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80277 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80281 */       GIR_RootConstrainSelectedInstOperands,
     /*  80282 */       // GIR_Coverage, 5414,
     /*  80282 */       GIR_EraseRootFromParent_Done,
     /*  80283 */     // Label 1361: @80283
     /*  80283 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80385), // Rule ID 5562 //
     /*  80288 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80292 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80296 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80300 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80304 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80308 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80312 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80317 */       // MIs[2] Operand 2
     /*  80317 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80328 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  80332 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80336 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80340 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  80344 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80348 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80352 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80357 */       // MIs[4] Operand 2
     /*  80357 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  80368 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80370 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  80370 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  80373 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80375 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  80379 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  80383 */       GIR_RootConstrainSelectedInstOperands,
     /*  80384 */       // GIR_Coverage, 5562,
     /*  80384 */       GIR_EraseRootFromParent_Done,
     /*  80385 */     // Label 1362: @80385
     /*  80385 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80514), // Rule ID 6308 //
     /*  80390 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80394 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80398 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80402 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80405 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  80410 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80414 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  80418 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80423 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  80427 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80429 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  80429 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  80432 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  80436 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80441 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  80444 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  80446 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80449 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80453 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80458 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80460 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80463 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80467 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80472 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80475 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  80479 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80482 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80487 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80492 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80497 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  80500 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80502 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80505 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  80509 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80512 */       GIR_RootConstrainSelectedInstOperands,
     /*  80513 */       // GIR_Coverage, 6308,
     /*  80513 */       GIR_EraseRootFromParent_Done,
     /*  80514 */     // Label 1363: @80514
     /*  80514 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80556), // Rule ID 5763 //
     /*  80519 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  80526 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  80533 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  80533 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80536 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80538 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  80543 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80546 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  80551 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80554 */       GIR_RootConstrainSelectedInstOperands,
     /*  80555 */       // GIR_Coverage, 5763,
     /*  80555 */       GIR_EraseRootFromParent_Done,
     /*  80556 */     // Label 1364: @80556
     /*  80556 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80598), // Rule ID 5767 //
     /*  80561 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  80568 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  80575 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  80575 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80578 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80580 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  80585 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80588 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  80593 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80596 */       GIR_RootConstrainSelectedInstOperands,
     /*  80597 */       // GIR_Coverage, 5767,
     /*  80597 */       GIR_EraseRootFromParent_Done,
     /*  80598 */     // Label 1365: @80598
     /*  80598 */     GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(80721), // Rule ID 2578 //
     /*  80603 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80606 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80610 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80614 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80618 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80621 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  80626 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80630 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  80634 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80639 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  80643 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80647 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80651 */       // MIs[2] Operand 1
     /*  80651 */       // No operand predicates
     /*  80651 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80653 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  80653 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80656 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80660 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80665 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80667 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80670 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80674 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80679 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80682 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80686 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80689 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80699 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80704 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  80707 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80709 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80712 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  80716 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  80719 */       GIR_RootConstrainSelectedInstOperands,
     /*  80720 */       // GIR_Coverage, 2578,
     /*  80720 */       GIR_EraseRootFromParent_Done,
     /*  80721 */     // Label 1366: @80721
     /*  80721 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80844), // Rule ID 6278 //
     /*  80726 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80729 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80733 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80737 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80741 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80745 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80749 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  80753 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80757 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80762 */       // MIs[2] imm
     /*  80762 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80766 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80770 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80774 */       // MIs[3] Operand 1
     /*  80774 */       // No operand predicates
     /*  80774 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80776 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  80776 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80779 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80783 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80788 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80790 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80793 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80797 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80802 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80805 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80809 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80812 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80817 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80822 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80827 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80830 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80832 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80835 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80839 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  80842 */       GIR_RootConstrainSelectedInstOperands,
     /*  80843 */       // GIR_Coverage, 6278,
     /*  80843 */       GIR_EraseRootFromParent_Done,
     /*  80844 */     // Label 1367: @80844
     /*  80844 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80964), // Rule ID 6314 //
     /*  80849 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80853 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80857 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80861 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80865 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80869 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80873 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80877 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80882 */       // MIs[2] imm
     /*  80882 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80886 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80890 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  80894 */       // MIs[3] Operand 1
     /*  80894 */       // No operand predicates
     /*  80894 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80896 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  80896 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80899 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80903 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80908 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80910 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80913 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80917 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80922 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80925 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80929 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80932 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80937 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80942 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80947 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  80950 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80952 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80955 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  80959 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  80962 */       GIR_RootConstrainSelectedInstOperands,
     /*  80963 */       // GIR_Coverage, 6314,
     /*  80963 */       GIR_EraseRootFromParent_Done,
     /*  80964 */     // Label 1368: @80964
     /*  80964 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(81081), // Rule ID 2501 //
     /*  80969 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  80972 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80976 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80980 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80984 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80987 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  80992 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80996 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81000 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81005 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81010 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81012 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81012 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81015 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81019 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81024 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81026 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81029 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81033 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81038 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81041 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81045 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81053 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81058 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81063 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  81066 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81068 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81071 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81075 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81079 */       GIR_RootConstrainSelectedInstOperands,
     /*  81080 */       // GIR_Coverage, 2501,
     /*  81080 */       GIR_EraseRootFromParent_Done,
     /*  81081 */     // Label 1369: @81081
     /*  81081 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(81198), // Rule ID 5332 //
     /*  81086 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81089 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81093 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81097 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81101 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81104 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  81109 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81113 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81117 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81122 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81127 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81129 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81129 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81132 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81136 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81141 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81143 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81146 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81150 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81155 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81158 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81162 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81165 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81170 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81175 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81180 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81183 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81185 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81188 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81192 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81196 */       GIR_RootConstrainSelectedInstOperands,
     /*  81197 */       // GIR_Coverage, 5332,
     /*  81197 */       GIR_EraseRootFromParent_Done,
     /*  81198 */     // Label 1370: @81198
     /*  81198 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81315), // Rule ID 5335 //
     /*  81203 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81206 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81210 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81214 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81218 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81221 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  81226 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81230 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81234 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81239 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81244 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81246 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81246 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81249 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81253 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81258 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81260 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81263 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81267 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81272 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81275 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81279 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81282 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81287 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81292 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81297 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81300 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81302 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81309 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81313 */       GIR_RootConstrainSelectedInstOperands,
     /*  81314 */       // GIR_Coverage, 5335,
     /*  81314 */       GIR_EraseRootFromParent_Done,
     /*  81315 */     // Label 1371: @81315
     /*  81315 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81432), // Rule ID 5338 //
     /*  81320 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81323 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81327 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81331 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81335 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81338 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  81343 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81347 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81351 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81356 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81361 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81363 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81363 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81366 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81370 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81375 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81377 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81380 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81384 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81389 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81392 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81396 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81399 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81404 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81409 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81414 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  81417 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81419 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81422 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81426 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81430 */       GIR_RootConstrainSelectedInstOperands,
     /*  81431 */       // GIR_Coverage, 5338,
     /*  81431 */       GIR_EraseRootFromParent_Done,
     /*  81432 */     // Label 1372: @81432
     /*  81432 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81536), // Rule ID 2497 //
     /*  81437 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81440 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81444 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81448 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81452 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  81455 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  81460 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81464 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81469 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81471 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  81471 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81474 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81478 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81483 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81485 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81488 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81492 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81497 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81500 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81504 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81507 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81512 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81517 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81522 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  81525 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81527 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81530 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81534 */       GIR_RootConstrainSelectedInstOperands,
     /*  81535 */       // GIR_Coverage, 2497,
     /*  81535 */       GIR_EraseRootFromParent_Done,
     /*  81536 */     // Label 1373: @81536
     /*  81536 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(81592), // Rule ID 5495 //
     /*  81541 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81545 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81549 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81553 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81558 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81562 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81566 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81570 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81575 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81577 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  81577 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  81580 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  81582 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  81586 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  81590 */       GIR_RootConstrainSelectedInstOperands,
     /*  81591 */       // GIR_Coverage, 5495,
     /*  81591 */       GIR_EraseRootFromParent_Done,
     /*  81592 */     // Label 1374: @81592
     /*  81592 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81658), // Rule ID 5761 //
     /*  81597 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81601 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81605 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81611 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  81613 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81615 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  81615 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  81618 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  81622 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81627 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  81631 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81633 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81636 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81638 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81641 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81644 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81647 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81652 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81657 */       // GIR_Coverage, 5761,
     /*  81657 */       GIR_EraseRootFromParent_Done,
     /*  81658 */     // Label 1375: @81658
     /*  81658 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81724), // Rule ID 5765 //
     /*  81663 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81671 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81677 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  81679 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81681 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  81681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  81684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  81688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81693 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  81697 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  81702 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81704 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81710 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81713 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81718 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81723 */       // GIR_Coverage, 5765,
     /*  81723 */       GIR_EraseRootFromParent_Done,
     /*  81724 */     // Label 1376: @81724
     /*  81724 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81817), // Rule ID 4902 //
     /*  81729 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81733 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81737 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  81741 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81745 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81750 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81752 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  81752 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81755 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81759 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81764 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81766 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81769 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81773 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81778 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81781 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81785 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81788 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81793 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81798 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81803 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  81806 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81808 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81811 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81815 */       GIR_RootConstrainSelectedInstOperands,
     /*  81816 */       // GIR_Coverage, 4902,
     /*  81816 */       GIR_EraseRootFromParent_Done,
     /*  81817 */     // Label 1377: @81817
     /*  81817 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81913), // Rule ID 4949 //
     /*  81822 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81825 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81829 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81833 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81837 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81841 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81846 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81848 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  81848 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81851 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81855 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81860 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81862 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81865 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81869 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81874 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81877 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81881 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81884 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81889 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81894 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  81902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81904 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81907 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  81911 */       GIR_RootConstrainSelectedInstOperands,
     /*  81912 */       // GIR_Coverage, 4949,
     /*  81912 */       GIR_EraseRootFromParent_Done,
     /*  81913 */     // Label 1378: @81913
     /*  81913 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81975), // Rule ID 5762 //
     /*  81918 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81922 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81926 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  81930 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81932 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  81932 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81935 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81939 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81944 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  81946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81954 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  81956 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  81959 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81964 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81969 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81974 */       // GIR_Coverage, 5762,
     /*  81974 */       GIR_EraseRootFromParent_Done,
     /*  81975 */     // Label 1379: @81975
     /*  81975 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(82037), // Rule ID 5766 //
     /*  81980 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81984 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81988 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  81992 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81994 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  81994 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81997 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82001 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82006 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82008 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82011 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82013 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82016 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82018 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82021 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82026 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82031 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82036 */       // GIR_Coverage, 5766,
     /*  82036 */       GIR_EraseRootFromParent_Done,
     /*  82037 */     // Label 1380: @82037
     /*  82037 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82171), // Rule ID 5760 //
     /*  82042 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82046 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82050 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82050 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82053 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82057 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82062 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82064 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82067 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82071 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82076 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82079 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82083 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82086 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82091 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82096 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82101 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82104 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82108 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82113 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82115 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82118 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82122 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82127 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82130 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82134 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82137 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82142 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82152 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82155 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82163 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82166 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82169 */       GIR_RootConstrainSelectedInstOperands,
     /*  82170 */       // GIR_Coverage, 5760,
     /*  82170 */       GIR_EraseRootFromParent_Done,
     /*  82171 */     // Label 1381: @82171
     /*  82171 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82305), // Rule ID 5764 //
     /*  82176 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82180 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82184 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82184 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82187 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82191 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82196 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82198 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82201 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82205 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82210 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82213 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82217 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82220 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82225 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82230 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82235 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82238 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82242 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82247 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82249 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82252 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82256 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82261 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82264 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82268 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82271 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82276 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82281 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82291 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82294 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82297 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82300 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82303 */       GIR_RootConstrainSelectedInstOperands,
     /*  82304 */       // GIR_Coverage, 5764,
     /*  82304 */       GIR_EraseRootFromParent_Done,
     /*  82305 */     // Label 1382: @82305
     /*  82305 */     GIM_Reject,
     /*  82306 */   // Label 1358: @82306
     /*  82306 */   GIM_Reject,
     /*  82307 */   // Label 1341: @82307
     /*  82307 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(84715),
     /*  82312 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  82315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  82318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82322 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82451), // Rule ID 5410 //
     /*  82327 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82331 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82335 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82339 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82343 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82347 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82351 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82355 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82359 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82363 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82367 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82371 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82376 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82380 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82386 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82388 */       // MIs[2] Operand 2
     /*  82388 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82399 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82401 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  82401 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82404 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82408 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82413 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82416 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82420 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82423 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82428 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82433 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82436 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82438 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82441 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82445 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82449 */       GIR_RootConstrainSelectedInstOperands,
     /*  82450 */       // GIR_Coverage, 5410,
     /*  82450 */       GIR_EraseRootFromParent_Done,
     /*  82451 */     // Label 1384: @82451
     /*  82451 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82573), // Rule ID 5406 //
     /*  82456 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82460 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82464 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82468 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82472 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82476 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82480 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82484 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82488 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  82492 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82496 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82500 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82505 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82510 */       // MIs[2] Operand 2
     /*  82510 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82521 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82523 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82523 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82526 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82530 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82535 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82538 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82542 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82545 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82550 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82555 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  82558 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82560 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82563 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82567 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82571 */       GIR_RootConstrainSelectedInstOperands,
     /*  82572 */       // GIR_Coverage, 5406,
     /*  82572 */       GIR_EraseRootFromParent_Done,
     /*  82573 */     // Label 1385: @82573
     /*  82573 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82695), // Rule ID 5408 //
     /*  82578 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82582 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82586 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82590 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82594 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82598 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82602 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82606 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82610 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  82614 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82618 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82622 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82627 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82632 */       // MIs[2] Operand 2
     /*  82632 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82643 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82645 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  82645 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82648 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82652 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82657 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82660 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82664 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82667 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82677 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82680 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82682 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82685 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82689 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82693 */       GIR_RootConstrainSelectedInstOperands,
     /*  82694 */       // GIR_Coverage, 5408,
     /*  82694 */       GIR_EraseRootFromParent_Done,
     /*  82695 */     // Label 1386: @82695
     /*  82695 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82797), // Rule ID 5561 //
     /*  82700 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82704 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82708 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82712 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82716 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82720 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82724 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82729 */       // MIs[2] Operand 2
     /*  82729 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82740 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  82744 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82748 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82752 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  82756 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82760 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82764 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82769 */       // MIs[4] Operand 2
     /*  82769 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  82780 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82782 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  82782 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  82785 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82787 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  82791 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  82795 */       GIR_RootConstrainSelectedInstOperands,
     /*  82796 */       // GIR_Coverage, 5561,
     /*  82796 */       GIR_EraseRootFromParent_Done,
     /*  82797 */     // Label 1387: @82797
     /*  82797 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82926), // Rule ID 6307 //
     /*  82802 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82806 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82810 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  82814 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  82817 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  82822 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82826 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  82830 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82835 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  82839 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82841 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  82841 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82844 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  82848 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82853 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  82856 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  82858 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82861 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82865 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82870 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82872 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82875 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82879 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82884 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82887 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  82891 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82894 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82899 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82904 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82909 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  82912 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82914 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82917 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  82921 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82924 */       GIR_RootConstrainSelectedInstOperands,
     /*  82925 */       // GIR_Coverage, 6307,
     /*  82925 */       GIR_EraseRootFromParent_Done,
     /*  82926 */     // Label 1388: @82926
     /*  82926 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82968), // Rule ID 5771 //
     /*  82931 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82938 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  82945 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  82945 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82948 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82950 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  82955 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82958 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  82963 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82966 */       GIR_RootConstrainSelectedInstOperands,
     /*  82967 */       // GIR_Coverage, 5771,
     /*  82967 */       GIR_EraseRootFromParent_Done,
     /*  82968 */     // Label 1389: @82968
     /*  82968 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(83010), // Rule ID 5775 //
     /*  82973 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  82980 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  82987 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  82987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82992 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  82997 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83000 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83005 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83008 */       GIR_RootConstrainSelectedInstOperands,
     /*  83009 */       // GIR_Coverage, 5775,
     /*  83009 */       GIR_EraseRootFromParent_Done,
     /*  83010 */     // Label 1390: @83010
     /*  83010 */     GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(83133), // Rule ID 2576 //
     /*  83015 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83018 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83022 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83026 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83030 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83033 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83038 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83042 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83046 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83051 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  83055 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83059 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83063 */       // MIs[2] Operand 1
     /*  83063 */       // No operand predicates
     /*  83063 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83065 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83065 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83068 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83072 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83077 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83079 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83082 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83086 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83091 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83094 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83098 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83101 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83106 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83111 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83116 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  83119 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83121 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83124 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83128 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  83131 */       GIR_RootConstrainSelectedInstOperands,
     /*  83132 */       // GIR_Coverage, 2576,
     /*  83132 */       GIR_EraseRootFromParent_Done,
     /*  83133 */     // Label 1391: @83133
     /*  83133 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(83256), // Rule ID 6277 //
     /*  83138 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83141 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83145 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83149 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83153 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83157 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83161 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  83165 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83169 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83174 */       // MIs[2] imm
     /*  83174 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83178 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83182 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83186 */       // MIs[3] Operand 1
     /*  83186 */       // No operand predicates
     /*  83186 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83188 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83188 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83191 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83195 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83200 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83202 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83205 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83209 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83214 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83217 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83221 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83224 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83229 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83234 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83239 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83242 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83244 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83247 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83251 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83254 */       GIR_RootConstrainSelectedInstOperands,
     /*  83255 */       // GIR_Coverage, 6277,
     /*  83255 */       GIR_EraseRootFromParent_Done,
     /*  83256 */     // Label 1392: @83256
     /*  83256 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83376), // Rule ID 6313 //
     /*  83261 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83265 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83269 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83273 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83277 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83281 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83285 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83289 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83294 */       // MIs[2] imm
     /*  83294 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83298 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83302 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83306 */       // MIs[3] Operand 1
     /*  83306 */       // No operand predicates
     /*  83306 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83308 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83308 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83311 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83315 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83322 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83325 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83329 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83334 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83337 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83341 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83344 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83349 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83354 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83359 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83362 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83364 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83367 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83371 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83374 */       GIR_RootConstrainSelectedInstOperands,
     /*  83375 */       // GIR_Coverage, 6313,
     /*  83375 */       GIR_EraseRootFromParent_Done,
     /*  83376 */     // Label 1393: @83376
     /*  83376 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83493), // Rule ID 2500 //
     /*  83381 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83384 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83388 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83392 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83396 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83399 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  83404 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83408 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83412 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83417 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83422 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83424 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83424 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83427 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83431 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83436 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83438 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83441 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83445 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83450 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83453 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83457 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83460 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83465 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83470 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  83478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83480 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83483 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83487 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83491 */       GIR_RootConstrainSelectedInstOperands,
     /*  83492 */       // GIR_Coverage, 2500,
     /*  83492 */       GIR_EraseRootFromParent_Done,
     /*  83493 */     // Label 1394: @83493
     /*  83493 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83610), // Rule ID 5331 //
     /*  83498 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83501 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83505 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83509 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83513 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83516 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  83521 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83525 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83529 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83534 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83541 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83541 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83544 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83548 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83553 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83555 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83558 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83562 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83567 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83570 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83574 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83577 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83582 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83587 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83592 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83595 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83597 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83600 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83604 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83608 */       GIR_RootConstrainSelectedInstOperands,
     /*  83609 */       // GIR_Coverage, 5331,
     /*  83609 */       GIR_EraseRootFromParent_Done,
     /*  83610 */     // Label 1395: @83610
     /*  83610 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83727), // Rule ID 5334 //
     /*  83615 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83618 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83622 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83626 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83630 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83633 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  83638 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83642 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83646 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83651 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83656 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83658 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83658 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83661 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83665 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83670 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83672 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83675 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83679 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83684 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83687 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83691 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83699 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83704 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83709 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  83712 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83714 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83717 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83721 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83725 */       GIR_RootConstrainSelectedInstOperands,
     /*  83726 */       // GIR_Coverage, 5334,
     /*  83726 */       GIR_EraseRootFromParent_Done,
     /*  83727 */     // Label 1396: @83727
     /*  83727 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83844), // Rule ID 5337 //
     /*  83732 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83735 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83739 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83743 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83747 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83750 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  83755 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83759 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83763 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83768 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83773 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83775 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83775 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83778 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83782 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83787 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83789 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83792 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83796 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83801 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83804 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83808 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83811 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83816 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83821 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83826 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  83829 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83831 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83834 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83838 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  83842 */       GIR_RootConstrainSelectedInstOperands,
     /*  83843 */       // GIR_Coverage, 5337,
     /*  83843 */       GIR_EraseRootFromParent_Done,
     /*  83844 */     // Label 1397: @83844
     /*  83844 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83945), // Rule ID 4896 //
     /*  83849 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83853 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83857 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83861 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  83864 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  83869 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83873 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83878 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83880 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  83880 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83883 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83887 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83892 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83894 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83897 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83901 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83906 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83909 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83913 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83916 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83931 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  83934 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83936 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83939 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83943 */       GIR_RootConstrainSelectedInstOperands,
     /*  83944 */       // GIR_Coverage, 4896,
     /*  83944 */       GIR_EraseRootFromParent_Done,
     /*  83945 */     // Label 1398: @83945
     /*  83945 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(84001), // Rule ID 5486 //
     /*  83950 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83954 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83958 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83962 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83967 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83971 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83975 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83979 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83984 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83986 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  83986 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  83989 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  83991 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  83995 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  83999 */       GIR_RootConstrainSelectedInstOperands,
     /*  84000 */       // GIR_Coverage, 5486,
     /*  84000 */       GIR_EraseRootFromParent_Done,
     /*  84001 */     // Label 1399: @84001
     /*  84001 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(84067), // Rule ID 5769 //
     /*  84006 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84010 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84014 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84020 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84022 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84024 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  84024 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84027 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84031 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84036 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84040 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84042 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84045 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84047 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84050 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84053 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84056 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84061 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84066 */       // GIR_Coverage, 5769,
     /*  84066 */       GIR_EraseRootFromParent_Done,
     /*  84067 */     // Label 1400: @84067
     /*  84067 */     GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(84133), // Rule ID 5773 //
     /*  84072 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84076 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84080 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84086 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84088 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84090 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  84090 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84093 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84097 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84102 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84106 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84108 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84111 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84113 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84116 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84119 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84122 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84127 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84132 */       // GIR_Coverage, 5773,
     /*  84132 */       GIR_EraseRootFromParent_Done,
     /*  84133 */     // Label 1401: @84133
     /*  84133 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84226), // Rule ID 4904 //
     /*  84138 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84142 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84146 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  84150 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84154 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84159 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84161 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84161 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84164 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84168 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84173 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84175 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84178 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84182 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84187 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84190 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84194 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84197 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84202 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84207 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84212 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84215 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84217 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84220 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84224 */       GIR_RootConstrainSelectedInstOperands,
     /*  84225 */       // GIR_Coverage, 4904,
     /*  84225 */       GIR_EraseRootFromParent_Done,
     /*  84226 */     // Label 1402: @84226
     /*  84226 */     GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(84322), // Rule ID 4948 //
     /*  84231 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84234 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84238 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84242 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84246 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84250 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84255 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84257 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  84257 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84260 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84264 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84269 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84271 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84274 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84278 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84283 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84286 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84290 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84293 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84298 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84303 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84308 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  84311 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84313 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84316 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84320 */       GIR_RootConstrainSelectedInstOperands,
     /*  84321 */       // GIR_Coverage, 4948,
     /*  84321 */       GIR_EraseRootFromParent_Done,
     /*  84322 */     // Label 1403: @84322
     /*  84322 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(84384), // Rule ID 5770 //
     /*  84327 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84331 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84335 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84339 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84341 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  84341 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84344 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84348 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84353 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84355 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84358 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84360 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84363 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84365 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84368 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84373 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84378 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84383 */       // GIR_Coverage, 5770,
     /*  84383 */       GIR_EraseRootFromParent_Done,
     /*  84384 */     // Label 1404: @84384
     /*  84384 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(84446), // Rule ID 5774 //
     /*  84389 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84393 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84397 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84401 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84403 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  84403 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84406 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84410 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84415 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84417 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84420 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84422 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84425 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84427 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84430 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84435 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84440 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84445 */       // GIR_Coverage, 5774,
     /*  84445 */       GIR_EraseRootFromParent_Done,
     /*  84446 */     // Label 1405: @84446
     /*  84446 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(84580), // Rule ID 5768 //
     /*  84451 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84455 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84459 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  84459 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  84462 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84466 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84471 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  84473 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  84476 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84480 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84485 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  84488 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  84492 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  84495 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84500 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84505 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84510 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84513 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84517 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84522 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84524 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84527 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84531 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84536 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84539 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84543 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84546 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84551 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84556 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84561 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  84564 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84566 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84569 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  84572 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  84575 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84578 */       GIR_RootConstrainSelectedInstOperands,
     /*  84579 */       // GIR_Coverage, 5768,
     /*  84579 */       GIR_EraseRootFromParent_Done,
     /*  84580 */     // Label 1406: @84580
     /*  84580 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(84714), // Rule ID 5772 //
     /*  84585 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84589 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84593 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  84593 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  84596 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84600 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  84607 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  84610 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84614 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84619 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  84622 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  84626 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  84629 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84634 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84639 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84644 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84647 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84651 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84656 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84658 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84661 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84665 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84670 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84673 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84677 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84680 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84685 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84690 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84695 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  84698 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84700 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84703 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  84706 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  84709 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84712 */       GIR_RootConstrainSelectedInstOperands,
     /*  84713 */       // GIR_Coverage, 5772,
     /*  84713 */       GIR_EraseRootFromParent_Done,
     /*  84714 */     // Label 1407: @84714
     /*  84714 */     GIM_Reject,
     /*  84715 */   // Label 1383: @84715
     /*  84715 */   GIM_Reject,
     /*  84716 */   // Label 1342: @84716
     /*  84716 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(86626),
     /*  84721 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  84724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  84727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84731 */     GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(84860), // Rule ID 5404 //
     /*  84736 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84740 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84744 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84748 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84752 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84756 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84760 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84764 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84768 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84772 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84776 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84780 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84785 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84789 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84795 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84797 */       // MIs[2] Operand 2
     /*  84797 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84808 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84810 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  84810 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84813 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84817 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84822 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84825 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84829 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84832 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84837 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84842 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  84845 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84847 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84850 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  84854 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  84858 */       GIR_RootConstrainSelectedInstOperands,
     /*  84859 */       // GIR_Coverage, 5404,
     /*  84859 */       GIR_EraseRootFromParent_Done,
     /*  84860 */     // Label 1409: @84860
     /*  84860 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(84982), // Rule ID 5400 //
     /*  84865 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84869 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84873 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84877 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84881 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84885 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  84889 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84893 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84897 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  84901 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  84905 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84909 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84914 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84919 */       // MIs[2] Operand 2
     /*  84919 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  84930 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84932 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  84932 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84935 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84939 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84944 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  84947 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84951 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84954 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84959 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84964 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  84967 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84969 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84972 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  84976 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  84980 */       GIR_RootConstrainSelectedInstOperands,
     /*  84981 */       // GIR_Coverage, 5400,
     /*  84981 */       GIR_EraseRootFromParent_Done,
     /*  84982 */     // Label 1410: @84982
     /*  84982 */     GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(85104), // Rule ID 5402 //
     /*  84987 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84991 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84995 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84999 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85003 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85007 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85011 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85015 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85019 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  85023 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85027 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85031 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85036 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85041 */       // MIs[2] Operand 2
     /*  85041 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85052 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85054 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85054 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85057 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85061 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85066 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85069 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85073 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85076 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85081 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85086 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85089 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85091 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85094 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85098 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85102 */       GIR_RootConstrainSelectedInstOperands,
     /*  85103 */       // GIR_Coverage, 5402,
     /*  85103 */       GIR_EraseRootFromParent_Done,
     /*  85104 */     // Label 1411: @85104
     /*  85104 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(85206), // Rule ID 5560 //
     /*  85109 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85113 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85117 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85121 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85125 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85129 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85133 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85138 */       // MIs[2] Operand 2
     /*  85138 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85149 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  85153 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85157 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85161 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  85165 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85169 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85173 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85178 */       // MIs[4] Operand 2
     /*  85178 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  85189 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85191 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85191 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  85194 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85196 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  85200 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  85204 */       GIR_RootConstrainSelectedInstOperands,
     /*  85205 */       // GIR_Coverage, 5560,
     /*  85205 */       GIR_EraseRootFromParent_Done,
     /*  85206 */     // Label 1412: @85206
     /*  85206 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(85335), // Rule ID 6306 //
     /*  85211 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85215 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85219 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85223 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85226 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85231 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85235 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85239 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85244 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  85248 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85250 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  85250 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  85253 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  85257 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85262 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  85265 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  85267 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85270 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85274 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85279 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85281 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85284 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85288 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85293 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85296 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  85300 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85303 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85308 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85313 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85318 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  85321 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85323 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85326 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  85330 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85333 */       GIR_RootConstrainSelectedInstOperands,
     /*  85334 */       // GIR_Coverage, 6306,
     /*  85334 */       GIR_EraseRootFromParent_Done,
     /*  85335 */     // Label 1413: @85335
     /*  85335 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(85377), // Rule ID 5779 //
     /*  85340 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85347 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85354 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  85354 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85357 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85359 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  85364 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85367 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  85372 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85375 */       GIR_RootConstrainSelectedInstOperands,
     /*  85376 */       // GIR_Coverage, 5779,
     /*  85376 */       GIR_EraseRootFromParent_Done,
     /*  85377 */     // Label 1414: @85377
     /*  85377 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(85500), // Rule ID 2574 //
     /*  85382 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85385 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85389 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85393 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85397 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85400 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85405 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85409 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  85422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85426 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85430 */       // MIs[2] Operand 1
     /*  85430 */       // No operand predicates
     /*  85430 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85432 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85432 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85435 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85439 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85444 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85446 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85449 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85453 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85458 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85461 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85465 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85468 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85473 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85478 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  85486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85488 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85491 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85495 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  85498 */       GIR_RootConstrainSelectedInstOperands,
     /*  85499 */       // GIR_Coverage, 2574,
     /*  85499 */       GIR_EraseRootFromParent_Done,
     /*  85500 */     // Label 1415: @85500
     /*  85500 */     GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(85623), // Rule ID 6276 //
     /*  85505 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85508 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85512 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85516 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85520 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85524 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85528 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  85532 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85536 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85541 */       // MIs[2] imm
     /*  85541 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85545 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85549 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85553 */       // MIs[3] Operand 1
     /*  85553 */       // No operand predicates
     /*  85553 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85555 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85555 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85558 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85562 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85567 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85569 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85572 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85576 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85581 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85584 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85588 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85591 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85596 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85601 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85606 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  85609 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85611 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85614 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  85618 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  85621 */       GIR_RootConstrainSelectedInstOperands,
     /*  85622 */       // GIR_Coverage, 6276,
     /*  85622 */       GIR_EraseRootFromParent_Done,
     /*  85623 */     // Label 1416: @85623
     /*  85623 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(85743), // Rule ID 6312 //
     /*  85628 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85632 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85636 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85640 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85644 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85648 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85652 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85656 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85661 */       // MIs[2] imm
     /*  85661 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85665 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85669 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85673 */       // MIs[3] Operand 1
     /*  85673 */       // No operand predicates
     /*  85673 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85675 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85675 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85678 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85682 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85687 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85689 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85692 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85696 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85701 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85704 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85708 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85716 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85721 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85726 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  85729 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85731 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85734 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  85738 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  85741 */       GIR_RootConstrainSelectedInstOperands,
     /*  85742 */       // GIR_Coverage, 6312,
     /*  85742 */       GIR_EraseRootFromParent_Done,
     /*  85743 */     // Label 1417: @85743
     /*  85743 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(85860), // Rule ID 2499 //
     /*  85748 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85751 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85755 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85759 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85763 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85766 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  85771 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85775 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85779 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85784 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85789 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85791 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85791 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85794 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85798 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85803 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85805 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85808 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85812 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85817 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85820 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85824 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85827 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85832 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85837 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85842 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85845 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85847 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85850 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85854 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85858 */       GIR_RootConstrainSelectedInstOperands,
     /*  85859 */       // GIR_Coverage, 2499,
     /*  85859 */       GIR_EraseRootFromParent_Done,
     /*  85860 */     // Label 1418: @85860
     /*  85860 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(85977), // Rule ID 5330 //
     /*  85865 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85868 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85872 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85876 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85880 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85883 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  85888 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85892 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85896 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85901 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85906 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85908 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85908 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85911 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85915 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85920 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85922 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85925 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85929 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85934 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85937 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85941 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85944 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85949 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85954 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85959 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85962 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85964 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85967 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  85971 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  85975 */       GIR_RootConstrainSelectedInstOperands,
     /*  85976 */       // GIR_Coverage, 5330,
     /*  85976 */       GIR_EraseRootFromParent_Done,
     /*  85977 */     // Label 1419: @85977
     /*  85977 */     GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(86094), // Rule ID 5333 //
     /*  85982 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85985 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85989 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85993 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85997 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86000 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  86005 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86009 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86013 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86018 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86023 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86025 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86025 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86028 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86032 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86037 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86039 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86042 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86046 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86051 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86054 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86058 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86061 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86066 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86071 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86076 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86079 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86081 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86084 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86088 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86092 */       GIR_RootConstrainSelectedInstOperands,
     /*  86093 */       // GIR_Coverage, 5333,
     /*  86093 */       GIR_EraseRootFromParent_Done,
     /*  86094 */     // Label 1420: @86094
     /*  86094 */     GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(86211), // Rule ID 5336 //
     /*  86099 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86102 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86106 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86110 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86114 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86117 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  86122 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86126 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86130 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86135 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86140 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86142 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86142 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86145 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86149 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86154 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86156 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86159 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86163 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86168 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86171 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86175 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86178 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86183 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86188 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86193 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  86196 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86198 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86201 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86205 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86209 */       GIR_RootConstrainSelectedInstOperands,
     /*  86210 */       // GIR_Coverage, 5336,
     /*  86210 */       GIR_EraseRootFromParent_Done,
     /*  86211 */     // Label 1421: @86211
     /*  86211 */     GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(86267), // Rule ID 5477 //
     /*  86216 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86220 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86224 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86228 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86233 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86237 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86241 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86245 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86250 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86252 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  86252 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  86255 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86257 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  86261 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  86265 */       GIR_RootConstrainSelectedInstOperands,
     /*  86266 */       // GIR_Coverage, 5477,
     /*  86266 */       GIR_EraseRootFromParent_Done,
     /*  86267 */     // Label 1422: @86267
     /*  86267 */     GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86333), // Rule ID 5777 //
     /*  86272 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86276 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86280 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86286 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  86288 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86290 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  86290 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86293 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  86297 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86302 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  86306 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86308 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  86311 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86313 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86316 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86319 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  86322 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86327 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86332 */       // GIR_Coverage, 5777,
     /*  86332 */       GIR_EraseRootFromParent_Done,
     /*  86333 */     // Label 1423: @86333
     /*  86333 */     GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(86429), // Rule ID 4947 //
     /*  86338 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86341 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86345 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86349 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86353 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86357 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86362 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86364 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  86364 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86367 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86371 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86376 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86378 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86381 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86385 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86390 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86393 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86397 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86400 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  86418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86427 */       GIR_RootConstrainSelectedInstOperands,
     /*  86428 */       // GIR_Coverage, 4947,
     /*  86428 */       GIR_EraseRootFromParent_Done,
     /*  86429 */     // Label 1424: @86429
     /*  86429 */     GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(86491), // Rule ID 5778 //
     /*  86434 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86438 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86442 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  86446 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86448 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  86448 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  86451 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86455 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86460 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86462 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86465 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86467 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86470 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86472 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  86475 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86480 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86485 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86490 */       // GIR_Coverage, 5778,
     /*  86490 */       GIR_EraseRootFromParent_Done,
     /*  86491 */     // Label 1425: @86491
     /*  86491 */     GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(86625), // Rule ID 5776 //
     /*  86496 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86500 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86504 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  86504 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  86507 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86511 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86516 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  86518 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  86521 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86525 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86530 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  86533 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  86537 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  86540 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86545 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86550 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86555 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86558 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86562 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86567 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86569 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86572 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86576 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86581 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86584 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86588 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86591 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86596 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86601 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86606 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  86609 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86611 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86614 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  86617 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  86620 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86623 */       GIR_RootConstrainSelectedInstOperands,
     /*  86624 */       // GIR_Coverage, 5776,
     /*  86624 */       GIR_EraseRootFromParent_Done,
     /*  86625 */     // Label 1426: @86625
     /*  86625 */     GIM_Reject,
     /*  86626 */   // Label 1408: @86626
     /*  86626 */   GIM_Reject,
     /*  86627 */   // Label 1343: @86627
     /*  86627 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(86652), // Rule ID 9014 //
     /*  86632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86635 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  86638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  86641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86645 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  86645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  86650 */     GIR_RootConstrainSelectedInstOperands,
     /*  86651 */     // GIR_Coverage, 9014,
     /*  86651 */     GIR_Done,
     /*  86652 */   // Label 1427: @86652
     /*  86652 */   GIM_Reject,
     /*  86653 */   // Label 1344: @86653
     /*  86653 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(86678), // Rule ID 9015 //
     /*  86658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86661 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  86664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  86667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86671 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  86671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  86676 */     GIR_RootConstrainSelectedInstOperands,
     /*  86677 */     // GIR_Coverage, 9015,
     /*  86677 */     GIR_Done,
     /*  86678 */   // Label 1428: @86678
     /*  86678 */   GIM_Reject,
     /*  86679 */   // Label 1345: @86679
     /*  86679 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(86704), // Rule ID 9018 //
     /*  86684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86687 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  86690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  86693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86697 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  86697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  86702 */     GIR_RootConstrainSelectedInstOperands,
     /*  86703 */     // GIR_Coverage, 9018,
     /*  86703 */     GIR_Done,
     /*  86704 */   // Label 1429: @86704
     /*  86704 */   GIM_Reject,
     /*  86705 */   // Label 1346: @86705
     /*  86705 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(86730), // Rule ID 9020 //
     /*  86710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86713 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  86716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  86719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86723 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  86723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  86728 */     GIR_RootConstrainSelectedInstOperands,
     /*  86729 */     // GIR_Coverage, 9020,
     /*  86729 */     GIR_Done,
     /*  86730 */   // Label 1430: @86730
     /*  86730 */   GIM_Reject,
     /*  86731 */   // Label 1347: @86731
     /*  86731 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(86756), // Rule ID 9016 //
     /*  86736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86739 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  86742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  86745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86749 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  86749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  86754 */     GIR_RootConstrainSelectedInstOperands,
     /*  86755 */     // GIR_Coverage, 9016,
     /*  86755 */     GIR_Done,
     /*  86756 */   // Label 1431: @86756
     /*  86756 */   GIM_Reject,
     /*  86757 */   // Label 1348: @86757
     /*  86757 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(86782), // Rule ID 9019 //
     /*  86762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86765 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  86768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  86771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  86775 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  86775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  86780 */     GIR_RootConstrainSelectedInstOperands,
     /*  86781 */     // GIR_Coverage, 9019,
     /*  86781 */     GIR_Done,
     /*  86782 */   // Label 1432: @86782
     /*  86782 */   GIM_Reject,
     /*  86783 */   // Label 1349: @86783
     /*  86783 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(86808), // Rule ID 9017 //
     /*  86788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86791 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  86794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  86797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  86801 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  86801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  86806 */     GIR_RootConstrainSelectedInstOperands,
     /*  86807 */     // GIR_Coverage, 9017,
     /*  86807 */     GIR_Done,
     /*  86808 */   // Label 1433: @86808
     /*  86808 */   GIM_Reject,
     /*  86809 */   // Label 1350: @86809
     /*  86809 */   GIM_Reject,
     /*  86810 */ // Label 1338: @86810
     /*  86810 */ GIM_Reject,
     /*  86811 */ // Label 9: @86811
     /*  86811 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1448*/ GIMT_Encode4(96754),
     /*  86822 */ /*GILLT_s32*//*Label 1434*/ GIMT_Encode4(86910),
     /*  86826 */ /*GILLT_s64*//*Label 1435*/ GIMT_Encode4(87291),
     /*  86830 */ /*GILLT_s128*//*Label 1436*/ GIMT_Encode4(89266),
     /*  86834 */ /*GILLT_v2s32*//*Label 1437*/ GIMT_Encode4(89912),
     /*  86838 */ /*GILLT_v2s64*//*Label 1438*/ GIMT_Encode4(90827),
     /*  86842 */ /*GILLT_v4s16*//*Label 1439*/ GIMT_Encode4(91596),
     /*  86846 */ /*GILLT_v4s32*//*Label 1440*/ GIMT_Encode4(92511),
     /*  86850 */ /*GILLT_v8s8*//*Label 1441*/ GIMT_Encode4(93356),
     /*  86854 */ /*GILLT_v8s16*//*Label 1442*/ GIMT_Encode4(93917),
     /*  86858 */ /*GILLT_v16s8*//*Label 1443*/ GIMT_Encode4(94762), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86878 */ /*GILLT_nxv2s64*//*Label 1444*/ GIMT_Encode4(95214), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86890 */ /*GILLT_nxv4s32*//*Label 1445*/ GIMT_Encode4(95663), GIMT_Encode4(0),
     /*  86898 */ /*GILLT_nxv8s16*//*Label 1446*/ GIMT_Encode4(96112), GIMT_Encode4(0),
     /*  86906 */ /*GILLT_nxv16s8*//*Label 1447*/ GIMT_Encode4(96561),
     /*  86910 */ // Label 1434: @86910
     /*  86910 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(87290),
     /*  86915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86918 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(86988), // Rule ID 7025 //
     /*  86923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86935 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  86938 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86945 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  86948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  86961 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  86961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  86964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  86966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  86971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  86976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  86981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86986 */     GIR_RootConstrainSelectedInstOperands,
     /*  86987 */     // GIR_Coverage, 7025,
     /*  86987 */     GIR_EraseRootFromParent_Done,
     /*  86988 */   // Label 1450: @86988
     /*  86988 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(87058), // Rule ID 7026 //
     /*  86993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  86997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87005 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87008 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87015 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87018 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  87031 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  87031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  87034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87056 */     GIR_RootConstrainSelectedInstOperands,
     /*  87057 */     // GIR_Coverage, 7026,
     /*  87057 */     GIR_EraseRootFromParent_Done,
     /*  87058 */   // Label 1451: @87058
     /*  87058 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(87123), // Rule ID 7027 //
     /*  87063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87075 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87078 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87085 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87088 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  87101 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  87104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87121 */     GIR_RootConstrainSelectedInstOperands,
     /*  87122 */     // GIR_Coverage, 7027,
     /*  87122 */     GIR_EraseRootFromParent_Done,
     /*  87123 */   // Label 1452: @87123
     /*  87123 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(87188), // Rule ID 7028 //
     /*  87128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87140 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87143 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87150 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  87166 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  87169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87186 */     GIR_RootConstrainSelectedInstOperands,
     /*  87187 */     // GIR_Coverage, 7028,
     /*  87187 */     GIR_EraseRootFromParent_Done,
     /*  87188 */   // Label 1453: @87188
     /*  87188 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(87241), // Rule ID 5743 //
     /*  87193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87213 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87219 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  87219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87224 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  87230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87240 */     // GIR_Coverage, 5743,
     /*  87240 */     GIR_EraseRootFromParent_Done,
     /*  87241 */   // Label 1454: @87241
     /*  87241 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(87265), // Rule ID 6638 //
     /*  87246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87254 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  87254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87264 */     // GIR_Coverage, 6638,
     /*  87264 */     GIR_Done,
     /*  87265 */   // Label 1455: @87265
     /*  87265 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(87289), // Rule ID 6639 //
     /*  87270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87278 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  87278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87288 */     // GIR_Coverage, 6639,
     /*  87288 */     GIR_Done,
     /*  87289 */   // Label 1456: @87289
     /*  87289 */   GIM_Reject,
     /*  87290 */ // Label 1449: @87290
     /*  87290 */ GIM_Reject,
     /*  87291 */ // Label 1435: @87291
     /*  87291 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(87364), // Rule ID 7029 //
     /*  87296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87314 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87321 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87324 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87330 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  87337 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  87337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  87340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87362 */   GIR_RootConstrainSelectedInstOperands,
     /*  87363 */   // GIR_Coverage, 7029,
     /*  87363 */   GIR_EraseRootFromParent_Done,
     /*  87364 */ // Label 1457: @87364
     /*  87364 */ GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(87437), // Rule ID 7030 //
     /*  87369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87384 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87387 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87394 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87397 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87401 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87403 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  87410 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  87410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  87413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87435 */   GIR_RootConstrainSelectedInstOperands,
     /*  87436 */   // GIR_Coverage, 7030,
     /*  87436 */   GIR_EraseRootFromParent_Done,
     /*  87437 */ // Label 1458: @87437
     /*  87437 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(87505), // Rule ID 7031 //
     /*  87442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87449 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87453 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87457 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87460 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87467 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87470 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87476 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  87483 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  87486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87503 */   GIR_RootConstrainSelectedInstOperands,
     /*  87504 */   // GIR_Coverage, 7031,
     /*  87504 */   GIR_EraseRootFromParent_Done,
     /*  87505 */ // Label 1459: @87505
     /*  87505 */ GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(87573), // Rule ID 7032 //
     /*  87510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87517 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87521 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87525 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87528 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87535 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87538 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87544 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  87551 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  87554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87566 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87571 */   GIR_RootConstrainSelectedInstOperands,
     /*  87572 */   // GIR_Coverage, 7032,
     /*  87572 */   GIR_EraseRootFromParent_Done,
     /*  87573 */ // Label 1460: @87573
     /*  87573 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(87629), // Rule ID 5745 //
     /*  87578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87593 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  87597 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87601 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87607 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  87607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87612 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  87618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87628 */   // GIR_Coverage, 5745,
     /*  87628 */   GIR_EraseRootFromParent_Done,
     /*  87629 */ // Label 1461: @87629
     /*  87629 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(87659), // Rule ID 6613 //
     /*  87634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87648 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  87648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87653 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87658 */   // GIR_Coverage, 6613,
     /*  87658 */   GIR_Done,
     /*  87659 */ // Label 1462: @87659
     /*  87659 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(87689), // Rule ID 6614 //
     /*  87664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87678 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  87678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87688 */   // GIR_Coverage, 6614,
     /*  87688 */   GIR_Done,
     /*  87689 */ // Label 1463: @87689
     /*  87689 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(87719), // Rule ID 6615 //
     /*  87694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87708 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  87708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87713 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87718 */   // GIR_Coverage, 6615,
     /*  87718 */   GIR_Done,
     /*  87719 */ // Label 1464: @87719
     /*  87719 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(87749), // Rule ID 6616 //
     /*  87724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87738 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  87738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87748 */   // GIR_Coverage, 6616,
     /*  87748 */   GIR_Done,
     /*  87749 */ // Label 1465: @87749
     /*  87749 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(87779), // Rule ID 6617 //
     /*  87754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87768 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  87768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87778 */   // GIR_Coverage, 6617,
     /*  87778 */   GIR_Done,
     /*  87779 */ // Label 1466: @87779
     /*  87779 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(87809), // Rule ID 6618 //
     /*  87784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  87787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87798 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  87798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87808 */   // GIR_Coverage, 6618,
     /*  87808 */   GIR_Done,
     /*  87809 */ // Label 1467: @87809
     /*  87809 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(87859), // Rule ID 6624 //
     /*  87814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  87820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87828 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  87828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87840 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87844 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  87852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87857 */   GIR_RootConstrainSelectedInstOperands,
     /*  87858 */   // GIR_Coverage, 6624,
     /*  87858 */   GIR_EraseRootFromParent_Done,
     /*  87859 */ // Label 1468: @87859
     /*  87859 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(87909), // Rule ID 6625 //
     /*  87864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87878 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  87878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  87902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87907 */   GIR_RootConstrainSelectedInstOperands,
     /*  87908 */   // GIR_Coverage, 6625,
     /*  87908 */   GIR_EraseRootFromParent_Done,
     /*  87909 */ // Label 1469: @87909
     /*  87909 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(87959), // Rule ID 6626 //
     /*  87914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87928 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  87928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87940 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  87952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87957 */   GIR_RootConstrainSelectedInstOperands,
     /*  87958 */   // GIR_Coverage, 6626,
     /*  87958 */   GIR_EraseRootFromParent_Done,
     /*  87959 */ // Label 1470: @87959
     /*  87959 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(88009), // Rule ID 6627 //
     /*  87964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  87967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  87970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87978 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  87978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  87981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87990 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  87994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88007 */   GIR_RootConstrainSelectedInstOperands,
     /*  88008 */   // GIR_Coverage, 6627,
     /*  88008 */   GIR_EraseRootFromParent_Done,
     /*  88009 */ // Label 1471: @88009
     /*  88009 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(88059), // Rule ID 6628 //
     /*  88014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88028 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88040 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88044 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88057 */   GIR_RootConstrainSelectedInstOperands,
     /*  88058 */   // GIR_Coverage, 6628,
     /*  88058 */   GIR_EraseRootFromParent_Done,
     /*  88059 */ // Label 1472: @88059
     /*  88059 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(88086), // Rule ID 6629 //
     /*  88064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88075 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88080 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88085 */   // GIR_Coverage, 6629,
     /*  88085 */   GIR_Done,
     /*  88086 */ // Label 1473: @88086
     /*  88086 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(88113), // Rule ID 6630 //
     /*  88091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88102 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88112 */   // GIR_Coverage, 6630,
     /*  88112 */   GIR_Done,
     /*  88113 */ // Label 1474: @88113
     /*  88113 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(88140), // Rule ID 6631 //
     /*  88118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88129 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  88129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88139 */   // GIR_Coverage, 6631,
     /*  88139 */   GIR_Done,
     /*  88140 */ // Label 1475: @88140
     /*  88140 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(88167), // Rule ID 6640 //
     /*  88145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88156 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88166 */   // GIR_Coverage, 6640,
     /*  88166 */   GIR_Done,
     /*  88167 */ // Label 1476: @88167
     /*  88167 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(88194), // Rule ID 6641 //
     /*  88172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88183 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  88183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88193 */   // GIR_Coverage, 6641,
     /*  88193 */   GIR_Done,
     /*  88194 */ // Label 1477: @88194
     /*  88194 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(88221), // Rule ID 6642 //
     /*  88199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88210 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88215 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88220 */   // GIR_Coverage, 6642,
     /*  88220 */   GIR_Done,
     /*  88221 */ // Label 1478: @88221
     /*  88221 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(88253), // Rule ID 6643 //
     /*  88226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88240 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88243 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88245 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88247 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88252 */   // GIR_Coverage, 6643,
     /*  88252 */   GIR_EraseRootFromParent_Done,
     /*  88253 */ // Label 1479: @88253
     /*  88253 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(88285), // Rule ID 6644 //
     /*  88258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88272 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88275 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88277 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88284 */   // GIR_Coverage, 6644,
     /*  88284 */   GIR_EraseRootFromParent_Done,
     /*  88285 */ // Label 1480: @88285
     /*  88285 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(88317), // Rule ID 6645 //
     /*  88290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88304 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88307 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88309 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88311 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88316 */   // GIR_Coverage, 6645,
     /*  88316 */   GIR_EraseRootFromParent_Done,
     /*  88317 */ // Label 1481: @88317
     /*  88317 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(88349), // Rule ID 6646 //
     /*  88322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88336 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88339 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88341 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88343 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88348 */   // GIR_Coverage, 6646,
     /*  88348 */   GIR_EraseRootFromParent_Done,
     /*  88349 */ // Label 1482: @88349
     /*  88349 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(88381), // Rule ID 6647 //
     /*  88354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88368 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88371 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88373 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88380 */   // GIR_Coverage, 6647,
     /*  88380 */   GIR_EraseRootFromParent_Done,
     /*  88381 */ // Label 1483: @88381
     /*  88381 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(88407), // Rule ID 6648 //
     /*  88386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88400 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  88400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88405 */   GIR_RootConstrainSelectedInstOperands,
     /*  88406 */   // GIR_Coverage, 6648,
     /*  88406 */   GIR_Done,
     /*  88407 */ // Label 1484: @88407
     /*  88407 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(88433), // Rule ID 6649 //
     /*  88412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88426 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  88426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88431 */   GIR_RootConstrainSelectedInstOperands,
     /*  88432 */   // GIR_Coverage, 6649,
     /*  88432 */   GIR_Done,
     /*  88433 */ // Label 1485: @88433
     /*  88433 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(88459), // Rule ID 6650 //
     /*  88438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88452 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  88452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88457 */   GIR_RootConstrainSelectedInstOperands,
     /*  88458 */   // GIR_Coverage, 6650,
     /*  88458 */   GIR_Done,
     /*  88459 */ // Label 1486: @88459
     /*  88459 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(88485), // Rule ID 6651 //
     /*  88464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88478 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  88478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88483 */   GIR_RootConstrainSelectedInstOperands,
     /*  88484 */   // GIR_Coverage, 6651,
     /*  88484 */   GIR_Done,
     /*  88485 */ // Label 1487: @88485
     /*  88485 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(88511), // Rule ID 6652 //
     /*  88490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88504 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  88504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88509 */   GIR_RootConstrainSelectedInstOperands,
     /*  88510 */   // GIR_Coverage, 6652,
     /*  88510 */   GIR_Done,
     /*  88511 */ // Label 1488: @88511
     /*  88511 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(88540), // Rule ID 6653 //
     /*  88516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88527 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88530 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88532 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88534 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88539 */   // GIR_Coverage, 6653,
     /*  88539 */   GIR_EraseRootFromParent_Done,
     /*  88540 */ // Label 1489: @88540
     /*  88540 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(88569), // Rule ID 6654 //
     /*  88545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88556 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88559 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88561 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88568 */   // GIR_Coverage, 6654,
     /*  88568 */   GIR_EraseRootFromParent_Done,
     /*  88569 */ // Label 1490: @88569
     /*  88569 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(88601), // Rule ID 6708 //
     /*  88574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88588 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88591 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88595 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88600 */   // GIR_Coverage, 6708,
     /*  88600 */   GIR_EraseRootFromParent_Done,
     /*  88601 */ // Label 1491: @88601
     /*  88601 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(88633), // Rule ID 6709 //
     /*  88606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88620 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88623 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88625 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88632 */   // GIR_Coverage, 6709,
     /*  88632 */   GIR_EraseRootFromParent_Done,
     /*  88633 */ // Label 1492: @88633
     /*  88633 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(88665), // Rule ID 6710 //
     /*  88638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88652 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88655 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88657 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88659 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88664 */   // GIR_Coverage, 6710,
     /*  88664 */   GIR_EraseRootFromParent_Done,
     /*  88665 */ // Label 1493: @88665
     /*  88665 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(88697), // Rule ID 6711 //
     /*  88670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88684 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88696 */   // GIR_Coverage, 6711,
     /*  88696 */   GIR_EraseRootFromParent_Done,
     /*  88697 */ // Label 1494: @88697
     /*  88697 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(88729), // Rule ID 6712 //
     /*  88702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88716 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88728 */   // GIR_Coverage, 6712,
     /*  88728 */   GIR_EraseRootFromParent_Done,
     /*  88729 */ // Label 1495: @88729
     /*  88729 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(88755), // Rule ID 6713 //
     /*  88734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88748 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  88748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88753 */   GIR_RootConstrainSelectedInstOperands,
     /*  88754 */   // GIR_Coverage, 6713,
     /*  88754 */   GIR_Done,
     /*  88755 */ // Label 1496: @88755
     /*  88755 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(88781), // Rule ID 6714 //
     /*  88760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88774 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  88774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88779 */   GIR_RootConstrainSelectedInstOperands,
     /*  88780 */   // GIR_Coverage, 6714,
     /*  88780 */   GIR_Done,
     /*  88781 */ // Label 1497: @88781
     /*  88781 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(88807), // Rule ID 6715 //
     /*  88786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88800 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  88800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88805 */   GIR_RootConstrainSelectedInstOperands,
     /*  88806 */   // GIR_Coverage, 6715,
     /*  88806 */   GIR_Done,
     /*  88807 */ // Label 1498: @88807
     /*  88807 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(88833), // Rule ID 6716 //
     /*  88812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88826 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  88826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88831 */   GIR_RootConstrainSelectedInstOperands,
     /*  88832 */   // GIR_Coverage, 6716,
     /*  88832 */   GIR_Done,
     /*  88833 */ // Label 1499: @88833
     /*  88833 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(88859), // Rule ID 6717 //
     /*  88838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88852 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  88852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88857 */   GIR_RootConstrainSelectedInstOperands,
     /*  88858 */   // GIR_Coverage, 6717,
     /*  88858 */   GIR_Done,
     /*  88859 */ // Label 1500: @88859
     /*  88859 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(88888), // Rule ID 6718 //
     /*  88864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88875 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88878 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88880 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88887 */   // GIR_Coverage, 6718,
     /*  88887 */   GIR_EraseRootFromParent_Done,
     /*  88888 */ // Label 1501: @88888
     /*  88888 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(88917), // Rule ID 6719 //
     /*  88893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88904 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  88904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88916 */   // GIR_Coverage, 6719,
     /*  88916 */   GIR_EraseRootFromParent_Done,
     /*  88917 */ // Label 1502: @88917
     /*  88917 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(88949), // Rule ID 6720 //
     /*  88922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88936 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88939 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88941 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88948 */   // GIR_Coverage, 6720,
     /*  88948 */   GIR_EraseRootFromParent_Done,
     /*  88949 */ // Label 1503: @88949
     /*  88949 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(88981), // Rule ID 6721 //
     /*  88954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88968 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  88968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88971 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88980 */   // GIR_Coverage, 6721,
     /*  88980 */   GIR_EraseRootFromParent_Done,
     /*  88981 */ // Label 1504: @88981
     /*  88981 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(89013), // Rule ID 6722 //
     /*  88986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89000 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89003 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89012 */   // GIR_Coverage, 6722,
     /*  89012 */   GIR_EraseRootFromParent_Done,
     /*  89013 */ // Label 1505: @89013
     /*  89013 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(89045), // Rule ID 6723 //
     /*  89018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89032 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89035 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89044 */   // GIR_Coverage, 6723,
     /*  89044 */   GIR_EraseRootFromParent_Done,
     /*  89045 */ // Label 1506: @89045
     /*  89045 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(89077), // Rule ID 6724 //
     /*  89050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89064 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89076 */   // GIR_Coverage, 6724,
     /*  89076 */   GIR_EraseRootFromParent_Done,
     /*  89077 */ // Label 1507: @89077
     /*  89077 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(89103), // Rule ID 6725 //
     /*  89082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89096 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89101 */   GIR_RootConstrainSelectedInstOperands,
     /*  89102 */   // GIR_Coverage, 6725,
     /*  89102 */   GIR_Done,
     /*  89103 */ // Label 1508: @89103
     /*  89103 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(89129), // Rule ID 6726 //
     /*  89108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89122 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89127 */   GIR_RootConstrainSelectedInstOperands,
     /*  89128 */   // GIR_Coverage, 6726,
     /*  89128 */   GIR_Done,
     /*  89129 */ // Label 1509: @89129
     /*  89129 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(89155), // Rule ID 6727 //
     /*  89134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89148 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89153 */   GIR_RootConstrainSelectedInstOperands,
     /*  89154 */   // GIR_Coverage, 6727,
     /*  89154 */   GIR_Done,
     /*  89155 */ // Label 1510: @89155
     /*  89155 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(89181), // Rule ID 6728 //
     /*  89160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89174 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89179 */   GIR_RootConstrainSelectedInstOperands,
     /*  89180 */   // GIR_Coverage, 6728,
     /*  89180 */   GIR_Done,
     /*  89181 */ // Label 1511: @89181
     /*  89181 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(89207), // Rule ID 6729 //
     /*  89186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89200 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89205 */   GIR_RootConstrainSelectedInstOperands,
     /*  89206 */   // GIR_Coverage, 6729,
     /*  89206 */   GIR_Done,
     /*  89207 */ // Label 1512: @89207
     /*  89207 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(89236), // Rule ID 6730 //
     /*  89212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89223 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89226 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89228 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89235 */   // GIR_Coverage, 6730,
     /*  89235 */   GIR_EraseRootFromParent_Done,
     /*  89236 */ // Label 1513: @89236
     /*  89236 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(89265), // Rule ID 6731 //
     /*  89241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89252 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89255 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89257 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89264 */   // GIR_Coverage, 6731,
     /*  89264 */   GIR_EraseRootFromParent_Done,
     /*  89265 */ // Label 1514: @89265
     /*  89265 */ GIM_Reject,
     /*  89266 */ // Label 1436: @89266
     /*  89266 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(89298), // Rule ID 6745 //
     /*  89271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89285 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89288 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89297 */   // GIR_Coverage, 6745,
     /*  89297 */   GIR_EraseRootFromParent_Done,
     /*  89298 */ // Label 1515: @89298
     /*  89298 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(89330), // Rule ID 6746 //
     /*  89303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89317 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89329 */   // GIR_Coverage, 6746,
     /*  89329 */   GIR_EraseRootFromParent_Done,
     /*  89330 */ // Label 1516: @89330
     /*  89330 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(89362), // Rule ID 6747 //
     /*  89335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89349 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89361 */   // GIR_Coverage, 6747,
     /*  89361 */   GIR_EraseRootFromParent_Done,
     /*  89362 */ // Label 1517: @89362
     /*  89362 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(89394), // Rule ID 6748 //
     /*  89367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89381 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89393 */   // GIR_Coverage, 6748,
     /*  89393 */   GIR_EraseRootFromParent_Done,
     /*  89394 */ // Label 1518: @89394
     /*  89394 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(89426), // Rule ID 6749 //
     /*  89399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89413 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89416 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89425 */   // GIR_Coverage, 6749,
     /*  89425 */   GIR_EraseRootFromParent_Done,
     /*  89426 */ // Label 1519: @89426
     /*  89426 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(89458), // Rule ID 6750 //
     /*  89431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89445 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89448 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89450 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89457 */   // GIR_Coverage, 6750,
     /*  89457 */   GIR_EraseRootFromParent_Done,
     /*  89458 */ // Label 1520: @89458
     /*  89458 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(89490), // Rule ID 6751 //
     /*  89463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89477 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89480 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89482 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89489 */   // GIR_Coverage, 6751,
     /*  89489 */   GIR_EraseRootFromParent_Done,
     /*  89490 */ // Label 1521: @89490
     /*  89490 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(89523), // Rule ID 6752 //
     /*  89495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89509 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  89509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89516 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89521 */   GIR_RootConstrainSelectedInstOperands,
     /*  89522 */   // GIR_Coverage, 6752,
     /*  89522 */   GIR_EraseRootFromParent_Done,
     /*  89523 */ // Label 1522: @89523
     /*  89523 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(89594), // Rule ID 6753 //
     /*  89528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89542 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  89542 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89545 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89549 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89554 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89572 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89592 */   GIR_RootConstrainSelectedInstOperands,
     /*  89593 */   // GIR_Coverage, 6753,
     /*  89593 */   GIR_EraseRootFromParent_Done,
     /*  89594 */ // Label 1523: @89594
     /*  89594 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(89665), // Rule ID 6754 //
     /*  89599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89613 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  89613 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89616 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89620 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89625 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89643 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89647 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89657 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89663 */   GIR_RootConstrainSelectedInstOperands,
     /*  89664 */   // GIR_Coverage, 6754,
     /*  89664 */   GIR_EraseRootFromParent_Done,
     /*  89665 */ // Label 1524: @89665
     /*  89665 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(89736), // Rule ID 6755 //
     /*  89670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89684 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  89684 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89687 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89691 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89696 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  89709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89714 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89734 */   GIR_RootConstrainSelectedInstOperands,
     /*  89735 */   // GIR_Coverage, 6755,
     /*  89735 */   GIR_EraseRootFromParent_Done,
     /*  89736 */ // Label 1525: @89736
     /*  89736 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(89769), // Rule ID 6756 //
     /*  89741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89755 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  89755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89762 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89767 */   GIR_RootConstrainSelectedInstOperands,
     /*  89768 */   // GIR_Coverage, 6756,
     /*  89768 */   GIR_EraseRootFromParent_Done,
     /*  89769 */ // Label 1526: @89769
     /*  89769 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(89840), // Rule ID 6757 //
     /*  89774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89788 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  89788 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89791 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89795 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89800 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  89813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89818 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89838 */   GIR_RootConstrainSelectedInstOperands,
     /*  89839 */   // GIR_Coverage, 6757,
     /*  89839 */   GIR_EraseRootFromParent_Done,
     /*  89840 */ // Label 1527: @89840
     /*  89840 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(89911), // Rule ID 6758 //
     /*  89845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  89851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89859 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  89859 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  89862 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89866 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89871 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  89877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  89880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  89884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89889 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  89893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  89895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  89898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  89909 */   GIR_RootConstrainSelectedInstOperands,
     /*  89910 */   // GIR_Coverage, 6758,
     /*  89910 */   GIR_EraseRootFromParent_Done,
     /*  89911 */ // Label 1528: @89911
     /*  89911 */ GIM_Reject,
     /*  89912 */ // Label 1437: @89912
     /*  89912 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(89942), // Rule ID 6610 //
     /*  89917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89931 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89941 */   // GIR_Coverage, 6610,
     /*  89941 */   GIR_Done,
     /*  89942 */ // Label 1529: @89942
     /*  89942 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(89972), // Rule ID 6612 //
     /*  89947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89961 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  89961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89966 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89971 */   // GIR_Coverage, 6612,
     /*  89971 */   GIR_Done,
     /*  89972 */ // Label 1530: @89972
     /*  89972 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(90022), // Rule ID 6621 //
     /*  89977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89991 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  89991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  89994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90003 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90020 */   GIR_RootConstrainSelectedInstOperands,
     /*  90021 */   // GIR_Coverage, 6621,
     /*  90021 */   GIR_EraseRootFromParent_Done,
     /*  90022 */ // Label 1531: @90022
     /*  90022 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(90072), // Rule ID 6623 //
     /*  90027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90041 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90053 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90070 */   GIR_RootConstrainSelectedInstOperands,
     /*  90071 */   // GIR_Coverage, 6623,
     /*  90071 */   GIR_EraseRootFromParent_Done,
     /*  90072 */ // Label 1532: @90072
     /*  90072 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(90104), // Rule ID 6655 //
     /*  90077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90091 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90094 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90096 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90103 */   // GIR_Coverage, 6655,
     /*  90103 */   GIR_EraseRootFromParent_Done,
     /*  90104 */ // Label 1533: @90104
     /*  90104 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(90136), // Rule ID 6656 //
     /*  90109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90123 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90126 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90128 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90130 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90135 */   // GIR_Coverage, 6656,
     /*  90135 */   GIR_EraseRootFromParent_Done,
     /*  90136 */ // Label 1534: @90136
     /*  90136 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(90168), // Rule ID 6657 //
     /*  90141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90155 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90158 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90160 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90162 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90167 */   // GIR_Coverage, 6657,
     /*  90167 */   GIR_EraseRootFromParent_Done,
     /*  90168 */ // Label 1535: @90168
     /*  90168 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(90200), // Rule ID 6658 //
     /*  90173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90187 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90190 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90192 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90199 */   // GIR_Coverage, 6658,
     /*  90199 */   GIR_EraseRootFromParent_Done,
     /*  90200 */ // Label 1536: @90200
     /*  90200 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(90232), // Rule ID 6659 //
     /*  90205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90219 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90222 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90224 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90231 */   // GIR_Coverage, 6659,
     /*  90231 */   GIR_EraseRootFromParent_Done,
     /*  90232 */ // Label 1537: @90232
     /*  90232 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(90264), // Rule ID 6660 //
     /*  90237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90251 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90254 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90263 */   // GIR_Coverage, 6660,
     /*  90263 */   GIR_EraseRootFromParent_Done,
     /*  90264 */ // Label 1538: @90264
     /*  90264 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(90290), // Rule ID 6661 //
     /*  90269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90283 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  90283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90288 */   GIR_RootConstrainSelectedInstOperands,
     /*  90289 */   // GIR_Coverage, 6661,
     /*  90289 */   GIR_Done,
     /*  90290 */ // Label 1539: @90290
     /*  90290 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(90316), // Rule ID 6662 //
     /*  90295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90309 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  90309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90314 */   GIR_RootConstrainSelectedInstOperands,
     /*  90315 */   // GIR_Coverage, 6662,
     /*  90315 */   GIR_Done,
     /*  90316 */ // Label 1540: @90316
     /*  90316 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(90342), // Rule ID 6663 //
     /*  90321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90335 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  90335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90340 */   GIR_RootConstrainSelectedInstOperands,
     /*  90341 */   // GIR_Coverage, 6663,
     /*  90341 */   GIR_Done,
     /*  90342 */ // Label 1541: @90342
     /*  90342 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(90368), // Rule ID 6664 //
     /*  90347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90361 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  90361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90366 */   GIR_RootConstrainSelectedInstOperands,
     /*  90367 */   // GIR_Coverage, 6664,
     /*  90367 */   GIR_Done,
     /*  90368 */ // Label 1542: @90368
     /*  90368 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(90394), // Rule ID 6665 //
     /*  90373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90387 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  90387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90392 */   GIR_RootConstrainSelectedInstOperands,
     /*  90393 */   // GIR_Coverage, 6665,
     /*  90393 */   GIR_Done,
     /*  90394 */ // Label 1543: @90394
     /*  90394 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(90420), // Rule ID 6666 //
     /*  90399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90413 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  90413 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90418 */   GIR_RootConstrainSelectedInstOperands,
     /*  90419 */   // GIR_Coverage, 6666,
     /*  90419 */   GIR_Done,
     /*  90420 */ // Label 1544: @90420
     /*  90420 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(90449), // Rule ID 6667 //
     /*  90425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90436 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90439 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90441 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90448 */   // GIR_Coverage, 6667,
     /*  90448 */   GIR_EraseRootFromParent_Done,
     /*  90449 */ // Label 1545: @90449
     /*  90449 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(90481), // Rule ID 6732 //
     /*  90454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90468 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90471 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90473 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90480 */   // GIR_Coverage, 6732,
     /*  90480 */   GIR_EraseRootFromParent_Done,
     /*  90481 */ // Label 1546: @90481
     /*  90481 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(90513), // Rule ID 6733 //
     /*  90486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90500 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90503 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90505 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90512 */   // GIR_Coverage, 6733,
     /*  90512 */   GIR_EraseRootFromParent_Done,
     /*  90513 */ // Label 1547: @90513
     /*  90513 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(90545), // Rule ID 6734 //
     /*  90518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90532 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90535 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90537 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90544 */   // GIR_Coverage, 6734,
     /*  90544 */   GIR_EraseRootFromParent_Done,
     /*  90545 */ // Label 1548: @90545
     /*  90545 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(90577), // Rule ID 6735 //
     /*  90550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90564 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90567 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90569 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90576 */   // GIR_Coverage, 6735,
     /*  90576 */   GIR_EraseRootFromParent_Done,
     /*  90577 */ // Label 1549: @90577
     /*  90577 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(90609), // Rule ID 6736 //
     /*  90582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90596 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90599 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90608 */   // GIR_Coverage, 6736,
     /*  90608 */   GIR_EraseRootFromParent_Done,
     /*  90609 */ // Label 1550: @90609
     /*  90609 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(90641), // Rule ID 6737 //
     /*  90614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90628 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90631 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90633 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90640 */   // GIR_Coverage, 6737,
     /*  90640 */   GIR_EraseRootFromParent_Done,
     /*  90641 */ // Label 1551: @90641
     /*  90641 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(90667), // Rule ID 6738 //
     /*  90646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90660 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  90660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90665 */   GIR_RootConstrainSelectedInstOperands,
     /*  90666 */   // GIR_Coverage, 6738,
     /*  90666 */   GIR_Done,
     /*  90667 */ // Label 1552: @90667
     /*  90667 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(90693), // Rule ID 6739 //
     /*  90672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90686 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  90686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90691 */   GIR_RootConstrainSelectedInstOperands,
     /*  90692 */   // GIR_Coverage, 6739,
     /*  90692 */   GIR_Done,
     /*  90693 */ // Label 1553: @90693
     /*  90693 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(90719), // Rule ID 6740 //
     /*  90698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90712 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  90712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90717 */   GIR_RootConstrainSelectedInstOperands,
     /*  90718 */   // GIR_Coverage, 6740,
     /*  90718 */   GIR_Done,
     /*  90719 */ // Label 1554: @90719
     /*  90719 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(90745), // Rule ID 6741 //
     /*  90724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90738 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  90738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90743 */   GIR_RootConstrainSelectedInstOperands,
     /*  90744 */   // GIR_Coverage, 6741,
     /*  90744 */   GIR_Done,
     /*  90745 */ // Label 1555: @90745
     /*  90745 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(90771), // Rule ID 6742 //
     /*  90750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90764 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  90764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90769 */   GIR_RootConstrainSelectedInstOperands,
     /*  90770 */   // GIR_Coverage, 6742,
     /*  90770 */   GIR_Done,
     /*  90771 */ // Label 1556: @90771
     /*  90771 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(90797), // Rule ID 6743 //
     /*  90776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90790 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  90790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90795 */   GIR_RootConstrainSelectedInstOperands,
     /*  90796 */   // GIR_Coverage, 6743,
     /*  90796 */   GIR_Done,
     /*  90797 */ // Label 1557: @90797
     /*  90797 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(90826), // Rule ID 6744 //
     /*  90802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90813 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  90813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90816 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90818 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90825 */   // GIR_Coverage, 6744,
     /*  90825 */   GIR_EraseRootFromParent_Done,
     /*  90826 */ // Label 1558: @90826
     /*  90826 */ GIM_Reject,
     /*  90827 */ // Label 1438: @90827
     /*  90827 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(90859), // Rule ID 6759 //
     /*  90832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  90838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90846 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90858 */   // GIR_Coverage, 6759,
     /*  90858 */   GIR_EraseRootFromParent_Done,
     /*  90859 */ // Label 1559: @90859
     /*  90859 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(90891), // Rule ID 6760 //
     /*  90864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90878 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90881 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90883 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90890 */   // GIR_Coverage, 6760,
     /*  90890 */   GIR_EraseRootFromParent_Done,
     /*  90891 */ // Label 1560: @90891
     /*  90891 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(90923), // Rule ID 6761 //
     /*  90896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90910 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90913 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90915 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90917 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90922 */   // GIR_Coverage, 6761,
     /*  90922 */   GIR_EraseRootFromParent_Done,
     /*  90923 */ // Label 1561: @90923
     /*  90923 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(90955), // Rule ID 6762 //
     /*  90928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90942 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90945 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90947 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90954 */   // GIR_Coverage, 6762,
     /*  90954 */   GIR_EraseRootFromParent_Done,
     /*  90955 */ // Label 1562: @90955
     /*  90955 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(90987), // Rule ID 6763 //
     /*  90960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90974 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  90974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90977 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90979 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90986 */   // GIR_Coverage, 6763,
     /*  90986 */   GIR_EraseRootFromParent_Done,
     /*  90987 */ // Label 1563: @90987
     /*  90987 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(91019), // Rule ID 6764 //
     /*  90992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91006 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91009 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91011 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91018 */   // GIR_Coverage, 6764,
     /*  91018 */   GIR_EraseRootFromParent_Done,
     /*  91019 */ // Label 1564: @91019
     /*  91019 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(91052), // Rule ID 6765 //
     /*  91024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91038 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91043 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91050 */   GIR_RootConstrainSelectedInstOperands,
     /*  91051 */   // GIR_Coverage, 6765,
     /*  91051 */   GIR_EraseRootFromParent_Done,
     /*  91052 */ // Label 1565: @91052
     /*  91052 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(91078), // Rule ID 6766 //
     /*  91057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91071 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  91071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91076 */   GIR_RootConstrainSelectedInstOperands,
     /*  91077 */   // GIR_Coverage, 6766,
     /*  91077 */   GIR_Done,
     /*  91078 */ // Label 1566: @91078
     /*  91078 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(91104), // Rule ID 6767 //
     /*  91083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91097 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  91097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91102 */   GIR_RootConstrainSelectedInstOperands,
     /*  91103 */   // GIR_Coverage, 6767,
     /*  91103 */   GIR_Done,
     /*  91104 */ // Label 1567: @91104
     /*  91104 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(91130), // Rule ID 6768 //
     /*  91109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91123 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  91123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91128 */   GIR_RootConstrainSelectedInstOperands,
     /*  91129 */   // GIR_Coverage, 6768,
     /*  91129 */   GIR_Done,
     /*  91130 */ // Label 1568: @91130
     /*  91130 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(91156), // Rule ID 6769 //
     /*  91135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91149 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  91149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91154 */   GIR_RootConstrainSelectedInstOperands,
     /*  91155 */   // GIR_Coverage, 6769,
     /*  91155 */   GIR_Done,
     /*  91156 */ // Label 1569: @91156
     /*  91156 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(91182), // Rule ID 6770 //
     /*  91161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91175 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  91175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91180 */   GIR_RootConstrainSelectedInstOperands,
     /*  91181 */   // GIR_Coverage, 6770,
     /*  91181 */   GIR_Done,
     /*  91182 */ // Label 1570: @91182
     /*  91182 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(91211), // Rule ID 6771 //
     /*  91187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91198 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91210 */   // GIR_Coverage, 6771,
     /*  91210 */   GIR_EraseRootFromParent_Done,
     /*  91211 */ // Label 1571: @91211
     /*  91211 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(91243), // Rule ID 6785 //
     /*  91216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91230 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91242 */   // GIR_Coverage, 6785,
     /*  91242 */   GIR_EraseRootFromParent_Done,
     /*  91243 */ // Label 1572: @91243
     /*  91243 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(91275), // Rule ID 6786 //
     /*  91248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91262 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91274 */   // GIR_Coverage, 6786,
     /*  91274 */   GIR_EraseRootFromParent_Done,
     /*  91275 */ // Label 1573: @91275
     /*  91275 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(91307), // Rule ID 6787 //
     /*  91280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91294 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91306 */   // GIR_Coverage, 6787,
     /*  91306 */   GIR_EraseRootFromParent_Done,
     /*  91307 */ // Label 1574: @91307
     /*  91307 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(91339), // Rule ID 6788 //
     /*  91312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91326 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91338 */   // GIR_Coverage, 6788,
     /*  91338 */   GIR_EraseRootFromParent_Done,
     /*  91339 */ // Label 1575: @91339
     /*  91339 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(91371), // Rule ID 6789 //
     /*  91344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91358 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91370 */   // GIR_Coverage, 6789,
     /*  91370 */   GIR_EraseRootFromParent_Done,
     /*  91371 */ // Label 1576: @91371
     /*  91371 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(91403), // Rule ID 6790 //
     /*  91376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91390 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91402 */   // GIR_Coverage, 6790,
     /*  91402 */   GIR_EraseRootFromParent_Done,
     /*  91403 */ // Label 1577: @91403
     /*  91403 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(91436), // Rule ID 6791 //
     /*  91408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91422 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91434 */   GIR_RootConstrainSelectedInstOperands,
     /*  91435 */   // GIR_Coverage, 6791,
     /*  91435 */   GIR_EraseRootFromParent_Done,
     /*  91436 */ // Label 1578: @91436
     /*  91436 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(91462), // Rule ID 6792 //
     /*  91441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91455 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  91455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91460 */   GIR_RootConstrainSelectedInstOperands,
     /*  91461 */   // GIR_Coverage, 6792,
     /*  91461 */   GIR_Done,
     /*  91462 */ // Label 1579: @91462
     /*  91462 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(91488), // Rule ID 6793 //
     /*  91467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91481 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  91481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91486 */   GIR_RootConstrainSelectedInstOperands,
     /*  91487 */   // GIR_Coverage, 6793,
     /*  91487 */   GIR_Done,
     /*  91488 */ // Label 1580: @91488
     /*  91488 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(91514), // Rule ID 6794 //
     /*  91493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91507 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  91507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91512 */   GIR_RootConstrainSelectedInstOperands,
     /*  91513 */   // GIR_Coverage, 6794,
     /*  91513 */   GIR_Done,
     /*  91514 */ // Label 1581: @91514
     /*  91514 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(91540), // Rule ID 6795 //
     /*  91519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91533 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  91533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91538 */   GIR_RootConstrainSelectedInstOperands,
     /*  91539 */   // GIR_Coverage, 6795,
     /*  91539 */   GIR_Done,
     /*  91540 */ // Label 1582: @91540
     /*  91540 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(91566), // Rule ID 6796 //
     /*  91545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91559 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  91559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91564 */   GIR_RootConstrainSelectedInstOperands,
     /*  91565 */   // GIR_Coverage, 6796,
     /*  91565 */   GIR_Done,
     /*  91566 */ // Label 1583: @91566
     /*  91566 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(91595), // Rule ID 6797 //
     /*  91571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91582 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91585 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91594 */   // GIR_Coverage, 6797,
     /*  91594 */   GIR_EraseRootFromParent_Done,
     /*  91595 */ // Label 1584: @91595
     /*  91595 */ GIM_Reject,
     /*  91596 */ // Label 1439: @91596
     /*  91596 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(91626), // Rule ID 6609 //
     /*  91601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91615 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  91615 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91625 */   // GIR_Coverage, 6609,
     /*  91625 */   GIR_Done,
     /*  91626 */ // Label 1585: @91626
     /*  91626 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(91656), // Rule ID 6611 //
     /*  91631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91645 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  91645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91655 */   // GIR_Coverage, 6611,
     /*  91655 */   GIR_Done,
     /*  91656 */ // Label 1586: @91656
     /*  91656 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(91706), // Rule ID 6620 //
     /*  91661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91675 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  91675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91687 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  91691 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91704 */   GIR_RootConstrainSelectedInstOperands,
     /*  91705 */   // GIR_Coverage, 6620,
     /*  91705 */   GIR_EraseRootFromParent_Done,
     /*  91706 */ // Label 1587: @91706
     /*  91706 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(91756), // Rule ID 6622 //
     /*  91711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  91725 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  91725 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91728 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91732 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91737 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  91741 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91754 */   GIR_RootConstrainSelectedInstOperands,
     /*  91755 */   // GIR_Coverage, 6622,
     /*  91755 */   GIR_EraseRootFromParent_Done,
     /*  91756 */ // Label 1588: @91756
     /*  91756 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(91788), // Rule ID 6668 //
     /*  91761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91775 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91778 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91787 */   // GIR_Coverage, 6668,
     /*  91787 */   GIR_EraseRootFromParent_Done,
     /*  91788 */ // Label 1589: @91788
     /*  91788 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(91820), // Rule ID 6669 //
     /*  91793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91807 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91810 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91812 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91819 */   // GIR_Coverage, 6669,
     /*  91819 */   GIR_EraseRootFromParent_Done,
     /*  91820 */ // Label 1590: @91820
     /*  91820 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(91852), // Rule ID 6670 //
     /*  91825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91839 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91842 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91851 */   // GIR_Coverage, 6670,
     /*  91851 */   GIR_EraseRootFromParent_Done,
     /*  91852 */ // Label 1591: @91852
     /*  91852 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(91884), // Rule ID 6671 //
     /*  91857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91871 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91874 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91883 */   // GIR_Coverage, 6671,
     /*  91883 */   GIR_EraseRootFromParent_Done,
     /*  91884 */ // Label 1592: @91884
     /*  91884 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(91916), // Rule ID 6672 //
     /*  91889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91903 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91915 */   // GIR_Coverage, 6672,
     /*  91915 */   GIR_EraseRootFromParent_Done,
     /*  91916 */ // Label 1593: @91916
     /*  91916 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(91948), // Rule ID 6673 //
     /*  91921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91935 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  91935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91947 */   // GIR_Coverage, 6673,
     /*  91947 */   GIR_EraseRootFromParent_Done,
     /*  91948 */ // Label 1594: @91948
     /*  91948 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(91974), // Rule ID 6674 //
     /*  91953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91967 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  91967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  91972 */   GIR_RootConstrainSelectedInstOperands,
     /*  91973 */   // GIR_Coverage, 6674,
     /*  91973 */   GIR_Done,
     /*  91974 */ // Label 1595: @91974
     /*  91974 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(92000), // Rule ID 6675 //
     /*  91979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91993 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  91993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91998 */   GIR_RootConstrainSelectedInstOperands,
     /*  91999 */   // GIR_Coverage, 6675,
     /*  91999 */   GIR_Done,
     /*  92000 */ // Label 1596: @92000
     /*  92000 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(92026), // Rule ID 6676 //
     /*  92005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92019 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  92019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92024 */   GIR_RootConstrainSelectedInstOperands,
     /*  92025 */   // GIR_Coverage, 6676,
     /*  92025 */   GIR_Done,
     /*  92026 */ // Label 1597: @92026
     /*  92026 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(92052), // Rule ID 6677 //
     /*  92031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92045 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  92045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92050 */   GIR_RootConstrainSelectedInstOperands,
     /*  92051 */   // GIR_Coverage, 6677,
     /*  92051 */   GIR_Done,
     /*  92052 */ // Label 1598: @92052
     /*  92052 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(92078), // Rule ID 6678 //
     /*  92057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92071 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  92071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92076 */   GIR_RootConstrainSelectedInstOperands,
     /*  92077 */   // GIR_Coverage, 6678,
     /*  92077 */   GIR_Done,
     /*  92078 */ // Label 1599: @92078
     /*  92078 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(92104), // Rule ID 6679 //
     /*  92083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92097 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  92097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92102 */   GIR_RootConstrainSelectedInstOperands,
     /*  92103 */   // GIR_Coverage, 6679,
     /*  92103 */   GIR_Done,
     /*  92104 */ // Label 1600: @92104
     /*  92104 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(92133), // Rule ID 6680 //
     /*  92109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92120 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92123 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92125 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92132 */   // GIR_Coverage, 6680,
     /*  92132 */   GIR_EraseRootFromParent_Done,
     /*  92133 */ // Label 1601: @92133
     /*  92133 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(92165), // Rule ID 6681 //
     /*  92138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92152 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92155 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92157 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92164 */   // GIR_Coverage, 6681,
     /*  92164 */   GIR_EraseRootFromParent_Done,
     /*  92165 */ // Label 1602: @92165
     /*  92165 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(92197), // Rule ID 6682 //
     /*  92170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92184 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92187 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92189 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92196 */   // GIR_Coverage, 6682,
     /*  92196 */   GIR_EraseRootFromParent_Done,
     /*  92197 */ // Label 1603: @92197
     /*  92197 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(92229), // Rule ID 6683 //
     /*  92202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92216 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92219 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92221 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92223 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92228 */   // GIR_Coverage, 6683,
     /*  92228 */   GIR_EraseRootFromParent_Done,
     /*  92229 */ // Label 1604: @92229
     /*  92229 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(92261), // Rule ID 6684 //
     /*  92234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92248 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92251 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92260 */   // GIR_Coverage, 6684,
     /*  92260 */   GIR_EraseRootFromParent_Done,
     /*  92261 */ // Label 1605: @92261
     /*  92261 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(92293), // Rule ID 6685 //
     /*  92266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92280 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92283 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92287 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92292 */   // GIR_Coverage, 6685,
     /*  92292 */   GIR_EraseRootFromParent_Done,
     /*  92293 */ // Label 1606: @92293
     /*  92293 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(92325), // Rule ID 6686 //
     /*  92298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92312 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92315 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92317 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92324 */   // GIR_Coverage, 6686,
     /*  92324 */   GIR_EraseRootFromParent_Done,
     /*  92325 */ // Label 1607: @92325
     /*  92325 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(92351), // Rule ID 6687 //
     /*  92330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92344 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  92344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92349 */   GIR_RootConstrainSelectedInstOperands,
     /*  92350 */   // GIR_Coverage, 6687,
     /*  92350 */   GIR_Done,
     /*  92351 */ // Label 1608: @92351
     /*  92351 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(92377), // Rule ID 6688 //
     /*  92356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92370 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  92370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92375 */   GIR_RootConstrainSelectedInstOperands,
     /*  92376 */   // GIR_Coverage, 6688,
     /*  92376 */   GIR_Done,
     /*  92377 */ // Label 1609: @92377
     /*  92377 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(92403), // Rule ID 6689 //
     /*  92382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92396 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  92396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92401 */   GIR_RootConstrainSelectedInstOperands,
     /*  92402 */   // GIR_Coverage, 6689,
     /*  92402 */   GIR_Done,
     /*  92403 */ // Label 1610: @92403
     /*  92403 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(92429), // Rule ID 6690 //
     /*  92408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92422 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  92422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92427 */   GIR_RootConstrainSelectedInstOperands,
     /*  92428 */   // GIR_Coverage, 6690,
     /*  92428 */   GIR_Done,
     /*  92429 */ // Label 1611: @92429
     /*  92429 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(92455), // Rule ID 6691 //
     /*  92434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92448 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  92448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92453 */   GIR_RootConstrainSelectedInstOperands,
     /*  92454 */   // GIR_Coverage, 6691,
     /*  92454 */   GIR_Done,
     /*  92455 */ // Label 1612: @92455
     /*  92455 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(92481), // Rule ID 6692 //
     /*  92460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92474 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  92474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92479 */   GIR_RootConstrainSelectedInstOperands,
     /*  92480 */   // GIR_Coverage, 6692,
     /*  92480 */   GIR_Done,
     /*  92481 */ // Label 1613: @92481
     /*  92481 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(92510), // Rule ID 6693 //
     /*  92486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92497 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92500 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92502 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92509 */   // GIR_Coverage, 6693,
     /*  92509 */   GIR_EraseRootFromParent_Done,
     /*  92510 */ // Label 1614: @92510
     /*  92510 */ GIM_Reject,
     /*  92511 */ // Label 1440: @92511
     /*  92511 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(92543), // Rule ID 6772 //
     /*  92516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92530 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92533 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92542 */   // GIR_Coverage, 6772,
     /*  92542 */   GIR_EraseRootFromParent_Done,
     /*  92543 */ // Label 1615: @92543
     /*  92543 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(92575), // Rule ID 6773 //
     /*  92548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92562 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92565 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92567 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92574 */   // GIR_Coverage, 6773,
     /*  92574 */   GIR_EraseRootFromParent_Done,
     /*  92575 */ // Label 1616: @92575
     /*  92575 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(92607), // Rule ID 6774 //
     /*  92580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92594 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92597 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92599 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92601 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92606 */   // GIR_Coverage, 6774,
     /*  92606 */   GIR_EraseRootFromParent_Done,
     /*  92607 */ // Label 1617: @92607
     /*  92607 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(92639), // Rule ID 6775 //
     /*  92612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92626 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92629 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92631 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92633 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92638 */   // GIR_Coverage, 6775,
     /*  92638 */   GIR_EraseRootFromParent_Done,
     /*  92639 */ // Label 1618: @92639
     /*  92639 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(92671), // Rule ID 6776 //
     /*  92644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92658 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92661 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92663 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92670 */   // GIR_Coverage, 6776,
     /*  92670 */   GIR_EraseRootFromParent_Done,
     /*  92671 */ // Label 1619: @92671
     /*  92671 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(92703), // Rule ID 6777 //
     /*  92676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92690 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92693 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92695 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92702 */   // GIR_Coverage, 6777,
     /*  92702 */   GIR_EraseRootFromParent_Done,
     /*  92703 */ // Label 1620: @92703
     /*  92703 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(92774), // Rule ID 6778 //
     /*  92708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92722 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  92722 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  92725 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92729 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92734 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  92740 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  92743 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92747 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92752 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  92756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  92761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  92769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  92772 */   GIR_RootConstrainSelectedInstOperands,
     /*  92773 */   // GIR_Coverage, 6778,
     /*  92773 */   GIR_EraseRootFromParent_Done,
     /*  92774 */ // Label 1621: @92774
     /*  92774 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(92800), // Rule ID 6779 //
     /*  92779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92793 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  92793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92798 */   GIR_RootConstrainSelectedInstOperands,
     /*  92799 */   // GIR_Coverage, 6779,
     /*  92799 */   GIR_Done,
     /*  92800 */ // Label 1622: @92800
     /*  92800 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(92826), // Rule ID 6780 //
     /*  92805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92819 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  92819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  92824 */   GIR_RootConstrainSelectedInstOperands,
     /*  92825 */   // GIR_Coverage, 6780,
     /*  92825 */   GIR_Done,
     /*  92826 */ // Label 1623: @92826
     /*  92826 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(92852), // Rule ID 6781 //
     /*  92831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92845 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  92845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  92850 */   GIR_RootConstrainSelectedInstOperands,
     /*  92851 */   // GIR_Coverage, 6781,
     /*  92851 */   GIR_Done,
     /*  92852 */ // Label 1624: @92852
     /*  92852 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(92878), // Rule ID 6782 //
     /*  92857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92871 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  92871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92876 */   GIR_RootConstrainSelectedInstOperands,
     /*  92877 */   // GIR_Coverage, 6782,
     /*  92877 */   GIR_Done,
     /*  92878 */ // Label 1625: @92878
     /*  92878 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(92904), // Rule ID 6783 //
     /*  92883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92897 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  92897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92902 */   GIR_RootConstrainSelectedInstOperands,
     /*  92903 */   // GIR_Coverage, 6783,
     /*  92903 */   GIR_Done,
     /*  92904 */ // Label 1626: @92904
     /*  92904 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(92933), // Rule ID 6784 //
     /*  92909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92920 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  92920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92923 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92925 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92927 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92932 */   // GIR_Coverage, 6784,
     /*  92932 */   GIR_EraseRootFromParent_Done,
     /*  92933 */ // Label 1627: @92933
     /*  92933 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(92965), // Rule ID 6798 //
     /*  92938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  92944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92952 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92955 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92957 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92964 */   // GIR_Coverage, 6798,
     /*  92964 */   GIR_EraseRootFromParent_Done,
     /*  92965 */ // Label 1628: @92965
     /*  92965 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(92997), // Rule ID 6799 //
     /*  92970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92984 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  92984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92987 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92989 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92991 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92996 */   // GIR_Coverage, 6799,
     /*  92996 */   GIR_EraseRootFromParent_Done,
     /*  92997 */ // Label 1629: @92997
     /*  92997 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(93029), // Rule ID 6800 //
     /*  93002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93016 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93019 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93021 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93023 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93028 */   // GIR_Coverage, 6800,
     /*  93028 */   GIR_EraseRootFromParent_Done,
     /*  93029 */ // Label 1630: @93029
     /*  93029 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(93061), // Rule ID 6801 //
     /*  93034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93048 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93051 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93053 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93060 */   // GIR_Coverage, 6801,
     /*  93060 */   GIR_EraseRootFromParent_Done,
     /*  93061 */ // Label 1631: @93061
     /*  93061 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(93093), // Rule ID 6802 //
     /*  93066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93080 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93083 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93085 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93087 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93092 */   // GIR_Coverage, 6802,
     /*  93092 */   GIR_EraseRootFromParent_Done,
     /*  93093 */ // Label 1632: @93093
     /*  93093 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(93125), // Rule ID 6803 //
     /*  93098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93112 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93115 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93117 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93119 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93124 */   // GIR_Coverage, 6803,
     /*  93124 */   GIR_EraseRootFromParent_Done,
     /*  93125 */ // Label 1633: @93125
     /*  93125 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(93196), // Rule ID 6804 //
     /*  93130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93144 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93144 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93147 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93151 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93156 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93174 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93194 */   GIR_RootConstrainSelectedInstOperands,
     /*  93195 */   // GIR_Coverage, 6804,
     /*  93195 */   GIR_EraseRootFromParent_Done,
     /*  93196 */ // Label 1634: @93196
     /*  93196 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(93222), // Rule ID 6805 //
     /*  93201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93215 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  93215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93220 */   GIR_RootConstrainSelectedInstOperands,
     /*  93221 */   // GIR_Coverage, 6805,
     /*  93221 */   GIR_Done,
     /*  93222 */ // Label 1635: @93222
     /*  93222 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(93248), // Rule ID 6806 //
     /*  93227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93241 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  93241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93246 */   GIR_RootConstrainSelectedInstOperands,
     /*  93247 */   // GIR_Coverage, 6806,
     /*  93247 */   GIR_Done,
     /*  93248 */ // Label 1636: @93248
     /*  93248 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(93274), // Rule ID 6807 //
     /*  93253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93267 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  93267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93272 */   GIR_RootConstrainSelectedInstOperands,
     /*  93273 */   // GIR_Coverage, 6807,
     /*  93273 */   GIR_Done,
     /*  93274 */ // Label 1637: @93274
     /*  93274 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(93300), // Rule ID 6808 //
     /*  93279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93293 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  93293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93298 */   GIR_RootConstrainSelectedInstOperands,
     /*  93299 */   // GIR_Coverage, 6808,
     /*  93299 */   GIR_Done,
     /*  93300 */ // Label 1638: @93300
     /*  93300 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(93326), // Rule ID 6809 //
     /*  93305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93319 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  93319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93324 */   GIR_RootConstrainSelectedInstOperands,
     /*  93325 */   // GIR_Coverage, 6809,
     /*  93325 */   GIR_Done,
     /*  93326 */ // Label 1639: @93326
     /*  93326 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(93355), // Rule ID 6810 //
     /*  93331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93342 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93345 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93347 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93354 */   // GIR_Coverage, 6810,
     /*  93354 */   GIR_EraseRootFromParent_Done,
     /*  93355 */ // Label 1640: @93355
     /*  93355 */ GIM_Reject,
     /*  93356 */ // Label 1441: @93356
     /*  93356 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(93430), // Rule ID 5653 //
     /*  93361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93368 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93372 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  93376 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  93380 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  93385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93387 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  93387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  93394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93399 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  93403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  93408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  93419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93429 */   // GIR_Coverage, 5653,
     /*  93429 */   GIR_EraseRootFromParent_Done,
     /*  93430 */ // Label 1641: @93430
     /*  93430 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(93460), // Rule ID 6608 //
     /*  93435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  93449 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  93449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93454 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93459 */   // GIR_Coverage, 6608,
     /*  93459 */   GIR_Done,
     /*  93460 */ // Label 1642: @93460
     /*  93460 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(93510), // Rule ID 6619 //
     /*  93465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  93479 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  93479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  93482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  93495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93508 */   GIR_RootConstrainSelectedInstOperands,
     /*  93509 */   // GIR_Coverage, 6619,
     /*  93509 */   GIR_EraseRootFromParent_Done,
     /*  93510 */ // Label 1643: @93510
     /*  93510 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(93542), // Rule ID 6694 //
     /*  93515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93529 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93532 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93534 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93536 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93541 */   // GIR_Coverage, 6694,
     /*  93541 */   GIR_EraseRootFromParent_Done,
     /*  93542 */ // Label 1644: @93542
     /*  93542 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(93574), // Rule ID 6695 //
     /*  93547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93561 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93573 */   // GIR_Coverage, 6695,
     /*  93573 */   GIR_EraseRootFromParent_Done,
     /*  93574 */ // Label 1645: @93574
     /*  93574 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(93606), // Rule ID 6696 //
     /*  93579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93593 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93605 */   // GIR_Coverage, 6696,
     /*  93605 */   GIR_EraseRootFromParent_Done,
     /*  93606 */ // Label 1646: @93606
     /*  93606 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(93638), // Rule ID 6697 //
     /*  93611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93625 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93637 */   // GIR_Coverage, 6697,
     /*  93637 */   GIR_EraseRootFromParent_Done,
     /*  93638 */ // Label 1647: @93638
     /*  93638 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(93670), // Rule ID 6698 //
     /*  93643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93657 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93669 */   // GIR_Coverage, 6698,
     /*  93669 */   GIR_EraseRootFromParent_Done,
     /*  93670 */ // Label 1648: @93670
     /*  93670 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(93702), // Rule ID 6699 //
     /*  93675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93689 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93701 */   // GIR_Coverage, 6699,
     /*  93701 */   GIR_EraseRootFromParent_Done,
     /*  93702 */ // Label 1649: @93702
     /*  93702 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(93734), // Rule ID 6700 //
     /*  93707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93721 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  93721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93733 */   // GIR_Coverage, 6700,
     /*  93733 */   GIR_EraseRootFromParent_Done,
     /*  93734 */ // Label 1650: @93734
     /*  93734 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(93760), // Rule ID 6701 //
     /*  93739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93753 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  93753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93758 */   GIR_RootConstrainSelectedInstOperands,
     /*  93759 */   // GIR_Coverage, 6701,
     /*  93759 */   GIR_Done,
     /*  93760 */ // Label 1651: @93760
     /*  93760 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(93786), // Rule ID 6702 //
     /*  93765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93779 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  93779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93784 */   GIR_RootConstrainSelectedInstOperands,
     /*  93785 */   // GIR_Coverage, 6702,
     /*  93785 */   GIR_Done,
     /*  93786 */ // Label 1652: @93786
     /*  93786 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(93812), // Rule ID 6703 //
     /*  93791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93805 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  93805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93810 */   GIR_RootConstrainSelectedInstOperands,
     /*  93811 */   // GIR_Coverage, 6703,
     /*  93811 */   GIR_Done,
     /*  93812 */ // Label 1653: @93812
     /*  93812 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(93838), // Rule ID 6704 //
     /*  93817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93831 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  93831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93836 */   GIR_RootConstrainSelectedInstOperands,
     /*  93837 */   // GIR_Coverage, 6704,
     /*  93837 */   GIR_Done,
     /*  93838 */ // Label 1654: @93838
     /*  93838 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(93864), // Rule ID 6705 //
     /*  93843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  93849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93857 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  93857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  93862 */   GIR_RootConstrainSelectedInstOperands,
     /*  93863 */   // GIR_Coverage, 6705,
     /*  93863 */   GIR_Done,
     /*  93864 */ // Label 1655: @93864
     /*  93864 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(93890), // Rule ID 6706 //
     /*  93869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93883 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  93883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  93888 */   GIR_RootConstrainSelectedInstOperands,
     /*  93889 */   // GIR_Coverage, 6706,
     /*  93889 */   GIR_Done,
     /*  93890 */ // Label 1656: @93890
     /*  93890 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(93916), // Rule ID 6707 //
     /*  93895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93909 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  93909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  93914 */   GIR_RootConstrainSelectedInstOperands,
     /*  93915 */   // GIR_Coverage, 6707,
     /*  93915 */   GIR_Done,
     /*  93916 */ // Label 1657: @93916
     /*  93916 */ GIM_Reject,
     /*  93917 */ // Label 1442: @93917
     /*  93917 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(93949), // Rule ID 6811 //
     /*  93922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93936 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93939 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93941 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93948 */   // GIR_Coverage, 6811,
     /*  93948 */   GIR_EraseRootFromParent_Done,
     /*  93949 */ // Label 1658: @93949
     /*  93949 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(93981), // Rule ID 6812 //
     /*  93954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93968 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  93968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93971 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93980 */   // GIR_Coverage, 6812,
     /*  93980 */   GIR_EraseRootFromParent_Done,
     /*  93981 */ // Label 1659: @93981
     /*  93981 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(94013), // Rule ID 6813 //
     /*  93986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94000 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94003 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94012 */   // GIR_Coverage, 6813,
     /*  94012 */   GIR_EraseRootFromParent_Done,
     /*  94013 */ // Label 1660: @94013
     /*  94013 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(94045), // Rule ID 6814 //
     /*  94018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94032 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94035 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94044 */   // GIR_Coverage, 6814,
     /*  94044 */   GIR_EraseRootFromParent_Done,
     /*  94045 */ // Label 1661: @94045
     /*  94045 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(94077), // Rule ID 6815 //
     /*  94050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94064 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94076 */   // GIR_Coverage, 6815,
     /*  94076 */   GIR_EraseRootFromParent_Done,
     /*  94077 */ // Label 1662: @94077
     /*  94077 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(94109), // Rule ID 6816 //
     /*  94082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94096 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94099 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94101 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94108 */   // GIR_Coverage, 6816,
     /*  94108 */   GIR_EraseRootFromParent_Done,
     /*  94109 */ // Label 1663: @94109
     /*  94109 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(94180), // Rule ID 6817 //
     /*  94114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94128 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94128 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94131 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94135 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94140 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94158 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94178 */   GIR_RootConstrainSelectedInstOperands,
     /*  94179 */   // GIR_Coverage, 6817,
     /*  94179 */   GIR_EraseRootFromParent_Done,
     /*  94180 */ // Label 1664: @94180
     /*  94180 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(94206), // Rule ID 6818 //
     /*  94185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94199 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  94199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94204 */   GIR_RootConstrainSelectedInstOperands,
     /*  94205 */   // GIR_Coverage, 6818,
     /*  94205 */   GIR_Done,
     /*  94206 */ // Label 1665: @94206
     /*  94206 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(94232), // Rule ID 6819 //
     /*  94211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94225 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  94225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94230 */   GIR_RootConstrainSelectedInstOperands,
     /*  94231 */   // GIR_Coverage, 6819,
     /*  94231 */   GIR_Done,
     /*  94232 */ // Label 1666: @94232
     /*  94232 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(94258), // Rule ID 6820 //
     /*  94237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94251 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  94251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94256 */   GIR_RootConstrainSelectedInstOperands,
     /*  94257 */   // GIR_Coverage, 6820,
     /*  94257 */   GIR_Done,
     /*  94258 */ // Label 1667: @94258
     /*  94258 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(94284), // Rule ID 6821 //
     /*  94263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94277 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  94277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94282 */   GIR_RootConstrainSelectedInstOperands,
     /*  94283 */   // GIR_Coverage, 6821,
     /*  94283 */   GIR_Done,
     /*  94284 */ // Label 1668: @94284
     /*  94284 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(94310), // Rule ID 6822 //
     /*  94289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94303 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  94303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94308 */   GIR_RootConstrainSelectedInstOperands,
     /*  94309 */   // GIR_Coverage, 6822,
     /*  94309 */   GIR_Done,
     /*  94310 */ // Label 1669: @94310
     /*  94310 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(94339), // Rule ID 6823 //
     /*  94315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94326 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94338 */   // GIR_Coverage, 6823,
     /*  94338 */   GIR_EraseRootFromParent_Done,
     /*  94339 */ // Label 1670: @94339
     /*  94339 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(94371), // Rule ID 6824 //
     /*  94344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94358 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94370 */   // GIR_Coverage, 6824,
     /*  94370 */   GIR_EraseRootFromParent_Done,
     /*  94371 */ // Label 1671: @94371
     /*  94371 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(94403), // Rule ID 6825 //
     /*  94376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94390 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94402 */   // GIR_Coverage, 6825,
     /*  94402 */   GIR_EraseRootFromParent_Done,
     /*  94403 */ // Label 1672: @94403
     /*  94403 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(94435), // Rule ID 6826 //
     /*  94408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94422 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94434 */   // GIR_Coverage, 6826,
     /*  94434 */   GIR_EraseRootFromParent_Done,
     /*  94435 */ // Label 1673: @94435
     /*  94435 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(94467), // Rule ID 6827 //
     /*  94440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94454 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94457 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94466 */   // GIR_Coverage, 6827,
     /*  94466 */   GIR_EraseRootFromParent_Done,
     /*  94467 */ // Label 1674: @94467
     /*  94467 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94499), // Rule ID 6828 //
     /*  94472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94486 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94489 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94498 */   // GIR_Coverage, 6828,
     /*  94498 */   GIR_EraseRootFromParent_Done,
     /*  94499 */ // Label 1675: @94499
     /*  94499 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(94531), // Rule ID 6829 //
     /*  94504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94518 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94521 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94523 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94525 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94530 */   // GIR_Coverage, 6829,
     /*  94530 */   GIR_EraseRootFromParent_Done,
     /*  94531 */ // Label 1676: @94531
     /*  94531 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(94602), // Rule ID 6830 //
     /*  94536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94550 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94550 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94553 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94557 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94562 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94580 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94600 */   GIR_RootConstrainSelectedInstOperands,
     /*  94601 */   // GIR_Coverage, 6830,
     /*  94601 */   GIR_EraseRootFromParent_Done,
     /*  94602 */ // Label 1677: @94602
     /*  94602 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(94628), // Rule ID 6831 //
     /*  94607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94621 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  94621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94626 */   GIR_RootConstrainSelectedInstOperands,
     /*  94627 */   // GIR_Coverage, 6831,
     /*  94627 */   GIR_Done,
     /*  94628 */ // Label 1678: @94628
     /*  94628 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(94654), // Rule ID 6832 //
     /*  94633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94647 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  94647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94652 */   GIR_RootConstrainSelectedInstOperands,
     /*  94653 */   // GIR_Coverage, 6832,
     /*  94653 */   GIR_Done,
     /*  94654 */ // Label 1679: @94654
     /*  94654 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(94680), // Rule ID 6833 //
     /*  94659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94673 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  94673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94678 */   GIR_RootConstrainSelectedInstOperands,
     /*  94679 */   // GIR_Coverage, 6833,
     /*  94679 */   GIR_Done,
     /*  94680 */ // Label 1680: @94680
     /*  94680 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(94706), // Rule ID 6834 //
     /*  94685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94699 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  94699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94704 */   GIR_RootConstrainSelectedInstOperands,
     /*  94705 */   // GIR_Coverage, 6834,
     /*  94705 */   GIR_Done,
     /*  94706 */ // Label 1681: @94706
     /*  94706 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(94732), // Rule ID 6835 //
     /*  94711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94725 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  94725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94730 */   GIR_RootConstrainSelectedInstOperands,
     /*  94731 */   // GIR_Coverage, 6835,
     /*  94731 */   GIR_Done,
     /*  94732 */ // Label 1682: @94732
     /*  94732 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(94761), // Rule ID 6836 //
     /*  94737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94748 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94760 */   // GIR_Coverage, 6836,
     /*  94760 */   GIR_EraseRootFromParent_Done,
     /*  94761 */ // Label 1683: @94761
     /*  94761 */ GIM_Reject,
     /*  94762 */ // Label 1443: @94762
     /*  94762 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(94794), // Rule ID 6837 //
     /*  94767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94781 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94784 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94786 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94788 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94793 */   // GIR_Coverage, 6837,
     /*  94793 */   GIR_EraseRootFromParent_Done,
     /*  94794 */ // Label 1684: @94794
     /*  94794 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(94826), // Rule ID 6838 //
     /*  94799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94813 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94816 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94818 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94820 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94825 */   // GIR_Coverage, 6838,
     /*  94825 */   GIR_EraseRootFromParent_Done,
     /*  94826 */ // Label 1685: @94826
     /*  94826 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(94858), // Rule ID 6839 //
     /*  94831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94845 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94848 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94850 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94852 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94857 */   // GIR_Coverage, 6839,
     /*  94857 */   GIR_EraseRootFromParent_Done,
     /*  94858 */ // Label 1686: @94858
     /*  94858 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(94890), // Rule ID 6840 //
     /*  94863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94877 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94880 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94882 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94884 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94889 */   // GIR_Coverage, 6840,
     /*  94889 */   GIR_EraseRootFromParent_Done,
     /*  94890 */ // Label 1687: @94890
     /*  94890 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(94922), // Rule ID 6841 //
     /*  94895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94909 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94912 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94916 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94921 */   // GIR_Coverage, 6841,
     /*  94921 */   GIR_EraseRootFromParent_Done,
     /*  94922 */ // Label 1688: @94922
     /*  94922 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(94954), // Rule ID 6842 //
     /*  94927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94941 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94944 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94946 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94948 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94953 */   // GIR_Coverage, 6842,
     /*  94953 */   GIR_EraseRootFromParent_Done,
     /*  94954 */ // Label 1689: @94954
     /*  94954 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(94986), // Rule ID 6843 //
     /*  94959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94973 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  94973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94976 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94978 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94980 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94985 */   // GIR_Coverage, 6843,
     /*  94985 */   GIR_EraseRootFromParent_Done,
     /*  94986 */ // Label 1690: @94986
     /*  94986 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(95057), // Rule ID 6844 //
     /*  94991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95005 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95005 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95008 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95012 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95017 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95035 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95055 */   GIR_RootConstrainSelectedInstOperands,
     /*  95056 */   // GIR_Coverage, 6844,
     /*  95056 */   GIR_EraseRootFromParent_Done,
     /*  95057 */ // Label 1691: @95057
     /*  95057 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(95083), // Rule ID 6845 //
     /*  95062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95076 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  95076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95081 */   GIR_RootConstrainSelectedInstOperands,
     /*  95082 */   // GIR_Coverage, 6845,
     /*  95082 */   GIR_Done,
     /*  95083 */ // Label 1692: @95083
     /*  95083 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(95109), // Rule ID 6846 //
     /*  95088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95102 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  95102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95107 */   GIR_RootConstrainSelectedInstOperands,
     /*  95108 */   // GIR_Coverage, 6846,
     /*  95108 */   GIR_Done,
     /*  95109 */ // Label 1693: @95109
     /*  95109 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(95135), // Rule ID 6847 //
     /*  95114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95128 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  95128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95133 */   GIR_RootConstrainSelectedInstOperands,
     /*  95134 */   // GIR_Coverage, 6847,
     /*  95134 */   GIR_Done,
     /*  95135 */ // Label 1694: @95135
     /*  95135 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(95161), // Rule ID 6848 //
     /*  95140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95154 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  95154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95159 */   GIR_RootConstrainSelectedInstOperands,
     /*  95160 */   // GIR_Coverage, 6848,
     /*  95160 */   GIR_Done,
     /*  95161 */ // Label 1695: @95161
     /*  95161 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(95187), // Rule ID 6849 //
     /*  95166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95180 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  95180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95185 */   GIR_RootConstrainSelectedInstOperands,
     /*  95186 */   // GIR_Coverage, 6849,
     /*  95186 */   GIR_Done,
     /*  95187 */ // Label 1696: @95187
     /*  95187 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(95213), // Rule ID 6850 //
     /*  95192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95206 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  95206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95211 */   GIR_RootConstrainSelectedInstOperands,
     /*  95212 */   // GIR_Coverage, 6850,
     /*  95212 */   GIR_Done,
     /*  95213 */ // Label 1697: @95213
     /*  95213 */ GIM_Reject,
     /*  95214 */ // Label 1444: @95214
     /*  95214 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(95246), // Rule ID 10503 //
     /*  95219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95233 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95236 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95238 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95245 */   // GIR_Coverage, 10503,
     /*  95245 */   GIR_EraseRootFromParent_Done,
     /*  95246 */ // Label 1698: @95246
     /*  95246 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(95278), // Rule ID 10504 //
     /*  95251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95265 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95268 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95270 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95272 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95277 */   // GIR_Coverage, 10504,
     /*  95277 */   GIR_EraseRootFromParent_Done,
     /*  95278 */ // Label 1699: @95278
     /*  95278 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(95310), // Rule ID 10505 //
     /*  95283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95297 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95300 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95302 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95309 */   // GIR_Coverage, 10505,
     /*  95309 */   GIR_EraseRootFromParent_Done,
     /*  95310 */ // Label 1700: @95310
     /*  95310 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(95342), // Rule ID 10506 //
     /*  95315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95329 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95332 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95334 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95336 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95341 */   // GIR_Coverage, 10506,
     /*  95341 */   GIR_EraseRootFromParent_Done,
     /*  95342 */ // Label 1701: @95342
     /*  95342 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(95374), // Rule ID 10507 //
     /*  95347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95361 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95364 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95366 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95373 */   // GIR_Coverage, 10507,
     /*  95373 */   GIR_EraseRootFromParent_Done,
     /*  95374 */ // Label 1702: @95374
     /*  95374 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(95406), // Rule ID 10508 //
     /*  95379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95393 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95396 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95398 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95405 */   // GIR_Coverage, 10508,
     /*  95405 */   GIR_EraseRootFromParent_Done,
     /*  95406 */ // Label 1703: @95406
     /*  95406 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(95438), // Rule ID 10521 //
     /*  95411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95425 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95428 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95430 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95437 */   // GIR_Coverage, 10521,
     /*  95437 */   GIR_EraseRootFromParent_Done,
     /*  95438 */ // Label 1704: @95438
     /*  95438 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(95470), // Rule ID 10522 //
     /*  95443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95457 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95460 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95462 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95469 */   // GIR_Coverage, 10522,
     /*  95469 */   GIR_EraseRootFromParent_Done,
     /*  95470 */ // Label 1705: @95470
     /*  95470 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(95502), // Rule ID 10523 //
     /*  95475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95489 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95492 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95494 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95496 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95501 */   // GIR_Coverage, 10523,
     /*  95501 */   GIR_EraseRootFromParent_Done,
     /*  95502 */ // Label 1706: @95502
     /*  95502 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(95534), // Rule ID 10524 //
     /*  95507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95521 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95524 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95526 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95528 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95533 */   // GIR_Coverage, 10524,
     /*  95533 */   GIR_EraseRootFromParent_Done,
     /*  95534 */ // Label 1707: @95534
     /*  95534 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(95566), // Rule ID 10525 //
     /*  95539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95553 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95556 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95558 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95565 */   // GIR_Coverage, 10525,
     /*  95565 */   GIR_EraseRootFromParent_Done,
     /*  95566 */ // Label 1708: @95566
     /*  95566 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(95598), // Rule ID 10526 //
     /*  95571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95585 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95588 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95590 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95597 */   // GIR_Coverage, 10526,
     /*  95597 */   GIR_EraseRootFromParent_Done,
     /*  95598 */ // Label 1709: @95598
     /*  95598 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(95630), // Rule ID 10531 //
     /*  95603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95617 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95620 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95622 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95629 */   // GIR_Coverage, 10531,
     /*  95629 */   GIR_EraseRootFromParent_Done,
     /*  95630 */ // Label 1710: @95630
     /*  95630 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(95662), // Rule ID 10532 //
     /*  95635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95649 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95661 */   // GIR_Coverage, 10532,
     /*  95661 */   GIR_EraseRootFromParent_Done,
     /*  95662 */ // Label 1711: @95662
     /*  95662 */ GIM_Reject,
     /*  95663 */ // Label 1445: @95663
     /*  95663 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(95695), // Rule ID 10497 //
     /*  95668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95682 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95685 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95694 */   // GIR_Coverage, 10497,
     /*  95694 */   GIR_EraseRootFromParent_Done,
     /*  95695 */ // Label 1712: @95695
     /*  95695 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(95727), // Rule ID 10498 //
     /*  95700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95714 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95717 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95719 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95726 */   // GIR_Coverage, 10498,
     /*  95726 */   GIR_EraseRootFromParent_Done,
     /*  95727 */ // Label 1713: @95727
     /*  95727 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(95759), // Rule ID 10499 //
     /*  95732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95746 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95749 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95751 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95753 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95758 */   // GIR_Coverage, 10499,
     /*  95758 */   GIR_EraseRootFromParent_Done,
     /*  95759 */ // Label 1714: @95759
     /*  95759 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(95791), // Rule ID 10500 //
     /*  95764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95778 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95781 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95783 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95790 */   // GIR_Coverage, 10500,
     /*  95790 */   GIR_EraseRootFromParent_Done,
     /*  95791 */ // Label 1715: @95791
     /*  95791 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(95823), // Rule ID 10501 //
     /*  95796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95810 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95813 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95815 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95822 */   // GIR_Coverage, 10501,
     /*  95822 */   GIR_EraseRootFromParent_Done,
     /*  95823 */ // Label 1716: @95823
     /*  95823 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(95855), // Rule ID 10502 //
     /*  95828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95842 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  95842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95845 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95847 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95849 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95854 */   // GIR_Coverage, 10502,
     /*  95854 */   GIR_EraseRootFromParent_Done,
     /*  95855 */ // Label 1717: @95855
     /*  95855 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(95887), // Rule ID 10515 //
     /*  95860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95874 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95877 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95879 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95886 */   // GIR_Coverage, 10515,
     /*  95886 */   GIR_EraseRootFromParent_Done,
     /*  95887 */ // Label 1718: @95887
     /*  95887 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(95919), // Rule ID 10516 //
     /*  95892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95906 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95909 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95911 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95918 */   // GIR_Coverage, 10516,
     /*  95918 */   GIR_EraseRootFromParent_Done,
     /*  95919 */ // Label 1719: @95919
     /*  95919 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(95951), // Rule ID 10517 //
     /*  95924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95938 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95941 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95943 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95950 */   // GIR_Coverage, 10517,
     /*  95950 */   GIR_EraseRootFromParent_Done,
     /*  95951 */ // Label 1720: @95951
     /*  95951 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(95983), // Rule ID 10518 //
     /*  95956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95970 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  95970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95973 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95975 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95982 */   // GIR_Coverage, 10518,
     /*  95982 */   GIR_EraseRootFromParent_Done,
     /*  95983 */ // Label 1721: @95983
     /*  95983 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(96015), // Rule ID 10519 //
     /*  95988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96002 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96005 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96007 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96014 */   // GIR_Coverage, 10519,
     /*  96014 */   GIR_EraseRootFromParent_Done,
     /*  96015 */ // Label 1722: @96015
     /*  96015 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(96047), // Rule ID 10520 //
     /*  96020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96034 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96046 */   // GIR_Coverage, 10520,
     /*  96046 */   GIR_EraseRootFromParent_Done,
     /*  96047 */ // Label 1723: @96047
     /*  96047 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(96079), // Rule ID 10529 //
     /*  96052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96066 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96078 */   // GIR_Coverage, 10529,
     /*  96078 */   GIR_EraseRootFromParent_Done,
     /*  96079 */ // Label 1724: @96079
     /*  96079 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(96111), // Rule ID 10530 //
     /*  96084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96098 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96110 */   // GIR_Coverage, 10530,
     /*  96110 */   GIR_EraseRootFromParent_Done,
     /*  96111 */ // Label 1725: @96111
     /*  96111 */ GIM_Reject,
     /*  96112 */ // Label 1446: @96112
     /*  96112 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(96144), // Rule ID 10491 //
     /*  96117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96131 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96143 */   // GIR_Coverage, 10491,
     /*  96143 */   GIR_EraseRootFromParent_Done,
     /*  96144 */ // Label 1726: @96144
     /*  96144 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(96176), // Rule ID 10492 //
     /*  96149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96163 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96175 */   // GIR_Coverage, 10492,
     /*  96175 */   GIR_EraseRootFromParent_Done,
     /*  96176 */ // Label 1727: @96176
     /*  96176 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(96208), // Rule ID 10493 //
     /*  96181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96195 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96207 */   // GIR_Coverage, 10493,
     /*  96207 */   GIR_EraseRootFromParent_Done,
     /*  96208 */ // Label 1728: @96208
     /*  96208 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(96240), // Rule ID 10494 //
     /*  96213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96227 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96239 */   // GIR_Coverage, 10494,
     /*  96239 */   GIR_EraseRootFromParent_Done,
     /*  96240 */ // Label 1729: @96240
     /*  96240 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(96272), // Rule ID 10495 //
     /*  96245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96259 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96271 */   // GIR_Coverage, 10495,
     /*  96271 */   GIR_EraseRootFromParent_Done,
     /*  96272 */ // Label 1730: @96272
     /*  96272 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(96304), // Rule ID 10496 //
     /*  96277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96291 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96303 */   // GIR_Coverage, 10496,
     /*  96303 */   GIR_EraseRootFromParent_Done,
     /*  96304 */ // Label 1731: @96304
     /*  96304 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(96336), // Rule ID 10509 //
     /*  96309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96323 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96335 */   // GIR_Coverage, 10509,
     /*  96335 */   GIR_EraseRootFromParent_Done,
     /*  96336 */ // Label 1732: @96336
     /*  96336 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(96368), // Rule ID 10510 //
     /*  96341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96355 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96367 */   // GIR_Coverage, 10510,
     /*  96367 */   GIR_EraseRootFromParent_Done,
     /*  96368 */ // Label 1733: @96368
     /*  96368 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(96400), // Rule ID 10511 //
     /*  96373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96387 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96399 */   // GIR_Coverage, 10511,
     /*  96399 */   GIR_EraseRootFromParent_Done,
     /*  96400 */ // Label 1734: @96400
     /*  96400 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(96432), // Rule ID 10512 //
     /*  96405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96419 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96431 */   // GIR_Coverage, 10512,
     /*  96431 */   GIR_EraseRootFromParent_Done,
     /*  96432 */ // Label 1735: @96432
     /*  96432 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(96464), // Rule ID 10513 //
     /*  96437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96451 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96463 */   // GIR_Coverage, 10513,
     /*  96463 */   GIR_EraseRootFromParent_Done,
     /*  96464 */ // Label 1736: @96464
     /*  96464 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(96496), // Rule ID 10514 //
     /*  96469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96483 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96495 */   // GIR_Coverage, 10514,
     /*  96495 */   GIR_EraseRootFromParent_Done,
     /*  96496 */ // Label 1737: @96496
     /*  96496 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(96528), // Rule ID 10527 //
     /*  96501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96515 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96527 */   // GIR_Coverage, 10527,
     /*  96527 */   GIR_EraseRootFromParent_Done,
     /*  96528 */ // Label 1738: @96528
     /*  96528 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(96560), // Rule ID 10528 //
     /*  96533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96547 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96559 */   // GIR_Coverage, 10528,
     /*  96559 */   GIR_EraseRootFromParent_Done,
     /*  96560 */ // Label 1739: @96560
     /*  96560 */ GIM_Reject,
     /*  96561 */ // Label 1447: @96561
     /*  96561 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(96593), // Rule ID 10485 //
     /*  96566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96580 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96583 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96585 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96587 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96592 */   // GIR_Coverage, 10485,
     /*  96592 */   GIR_EraseRootFromParent_Done,
     /*  96593 */ // Label 1740: @96593
     /*  96593 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(96625), // Rule ID 10486 //
     /*  96598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96612 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96615 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96617 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96624 */   // GIR_Coverage, 10486,
     /*  96624 */   GIR_EraseRootFromParent_Done,
     /*  96625 */ // Label 1741: @96625
     /*  96625 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(96657), // Rule ID 10487 //
     /*  96630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96644 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96647 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96649 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96651 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96656 */   // GIR_Coverage, 10487,
     /*  96656 */   GIR_EraseRootFromParent_Done,
     /*  96657 */ // Label 1742: @96657
     /*  96657 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(96689), // Rule ID 10488 //
     /*  96662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96676 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96679 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96681 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96688 */   // GIR_Coverage, 10488,
     /*  96688 */   GIR_EraseRootFromParent_Done,
     /*  96689 */ // Label 1743: @96689
     /*  96689 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(96721), // Rule ID 10489 //
     /*  96694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96708 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96720 */   // GIR_Coverage, 10489,
     /*  96720 */   GIR_EraseRootFromParent_Done,
     /*  96721 */ // Label 1744: @96721
     /*  96721 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(96753), // Rule ID 10490 //
     /*  96726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96740 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  96740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96752 */   // GIR_Coverage, 10490,
     /*  96752 */   GIR_EraseRootFromParent_Done,
     /*  96753 */ // Label 1745: @96753
     /*  96753 */ GIM_Reject,
     /*  96754 */ // Label 1448: @96754
     /*  96754 */ GIM_Reject,
     /*  96755 */ // Label 10: @96755
     /*  96755 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1754*/ GIMT_Encode4(97245),
     /*  96766 */ /*GILLT_s16*//*Label 1746*/ GIMT_Encode4(96806),
     /*  96770 */ /*GILLT_s32*//*Label 1747*/ GIMT_Encode4(96837),
     /*  96774 */ /*GILLT_s64*//*Label 1748*/ GIMT_Encode4(96868), GIMT_Encode4(0),
     /*  96782 */ /*GILLT_v2s32*//*Label 1749*/ GIMT_Encode4(96899),
     /*  96786 */ /*GILLT_v2s64*//*Label 1750*/ GIMT_Encode4(96930),
     /*  96790 */ /*GILLT_v4s16*//*Label 1751*/ GIMT_Encode4(96961),
     /*  96794 */ /*GILLT_v4s32*//*Label 1752*/ GIMT_Encode4(96992), GIMT_Encode4(0),
     /*  96802 */ /*GILLT_v8s16*//*Label 1753*/ GIMT_Encode4(97023),
     /*  96806 */ // Label 1746: @96806
     /*  96806 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96836), // Rule ID 564 //
     /*  96811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  96814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  96817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  96825 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  96825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  96830 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96834 */   GIR_RootConstrainSelectedInstOperands,
     /*  96835 */   // GIR_Coverage, 564,
     /*  96835 */   GIR_Done,
     /*  96836 */ // Label 1755: @96836
     /*  96836 */ GIM_Reject,
     /*  96837 */ // Label 1747: @96837
     /*  96837 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96867), // Rule ID 566 //
     /*  96842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  96848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  96856 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  96856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  96861 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96865 */   GIR_RootConstrainSelectedInstOperands,
     /*  96866 */   // GIR_Coverage, 566,
     /*  96866 */   GIR_Done,
     /*  96867 */ // Label 1756: @96867
     /*  96867 */ GIM_Reject,
     /*  96868 */ // Label 1748: @96868
     /*  96868 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96898), // Rule ID 568 //
     /*  96873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  96876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  96879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96887 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  96887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  96892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96896 */   GIR_RootConstrainSelectedInstOperands,
     /*  96897 */   // GIR_Coverage, 568,
     /*  96897 */   GIR_Done,
     /*  96898 */ // Label 1757: @96898
     /*  96898 */ GIM_Reject,
     /*  96899 */ // Label 1749: @96899
     /*  96899 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96929), // Rule ID 933 //
     /*  96904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  96910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96918 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  96918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  96923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96927 */   GIR_RootConstrainSelectedInstOperands,
     /*  96928 */   // GIR_Coverage, 933,
     /*  96928 */   GIR_Done,
     /*  96929 */ // Label 1758: @96929
     /*  96929 */ GIM_Reject,
     /*  96930 */ // Label 1750: @96930
     /*  96930 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96960), // Rule ID 937 //
     /*  96935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  96938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  96941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  96949 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  96949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  96954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96958 */   GIR_RootConstrainSelectedInstOperands,
     /*  96959 */   // GIR_Coverage, 937,
     /*  96959 */   GIR_Done,
     /*  96960 */ // Label 1759: @96960
     /*  96960 */ GIM_Reject,
     /*  96961 */ // Label 1751: @96961
     /*  96961 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96991), // Rule ID 929 //
     /*  96966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  96969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  96972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  96980 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  96980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  96985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  96989 */   GIR_RootConstrainSelectedInstOperands,
     /*  96990 */   // GIR_Coverage, 929,
     /*  96990 */   GIR_Done,
     /*  96991 */ // Label 1760: @96991
     /*  96991 */ GIM_Reject,
     /*  96992 */ // Label 1752: @96992
     /*  96992 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97022), // Rule ID 935 //
     /*  96997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97011 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97016 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97020 */   GIR_RootConstrainSelectedInstOperands,
     /*  97021 */   // GIR_Coverage, 935,
     /*  97021 */   GIR_Done,
     /*  97022 */ // Label 1761: @97022
     /*  97022 */ GIM_Reject,
     /*  97023 */ // Label 1753: @97023
     /*  97023 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97244),
     /*  97028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97039 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97058), // Rule ID 931 //
     /*  97044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97047 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  97052 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97056 */     GIR_RootConstrainSelectedInstOperands,
     /*  97057 */     // GIR_Coverage, 931,
     /*  97057 */     GIR_Done,
     /*  97058 */   // Label 1763: @97058
     /*  97058 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97243), // Rule ID 6969 //
     /*  97063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97066 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97066 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97069 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97073 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97078 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97084 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97087 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97091 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97096 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97101 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97104 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97108 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97113 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97119 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97124 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97129 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97132 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97136 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97141 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97146 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97149 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97153 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97158 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97163 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97166 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97170 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97175 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97180 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97183 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97187 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97209 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97241 */     GIR_RootConstrainSelectedInstOperands,
     /*  97242 */     // GIR_Coverage, 6969,
     /*  97242 */     GIR_EraseRootFromParent_Done,
     /*  97243 */   // Label 1764: @97243
     /*  97243 */   GIM_Reject,
     /*  97244 */ // Label 1762: @97244
     /*  97244 */ GIM_Reject,
     /*  97245 */ // Label 1754: @97245
     /*  97245 */ GIM_Reject,
     /*  97246 */ // Label 11: @97246
     /*  97246 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1773*/ GIMT_Encode4(97736),
     /*  97257 */ /*GILLT_s16*//*Label 1765*/ GIMT_Encode4(97297),
     /*  97261 */ /*GILLT_s32*//*Label 1766*/ GIMT_Encode4(97328),
     /*  97265 */ /*GILLT_s64*//*Label 1767*/ GIMT_Encode4(97359), GIMT_Encode4(0),
     /*  97273 */ /*GILLT_v2s32*//*Label 1768*/ GIMT_Encode4(97390),
     /*  97277 */ /*GILLT_v2s64*//*Label 1769*/ GIMT_Encode4(97421),
     /*  97281 */ /*GILLT_v4s16*//*Label 1770*/ GIMT_Encode4(97452),
     /*  97285 */ /*GILLT_v4s32*//*Label 1771*/ GIMT_Encode4(97483), GIMT_Encode4(0),
     /*  97293 */ /*GILLT_v8s16*//*Label 1772*/ GIMT_Encode4(97514),
     /*  97297 */ // Label 1765: @97297
     /*  97297 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97327), // Rule ID 528 //
     /*  97302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97316 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  97321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97325 */   GIR_RootConstrainSelectedInstOperands,
     /*  97326 */   // GIR_Coverage, 528,
     /*  97326 */   GIR_Done,
     /*  97327 */ // Label 1774: @97327
     /*  97327 */ GIM_Reject,
     /*  97328 */ // Label 1766: @97328
     /*  97328 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97358), // Rule ID 530 //
     /*  97333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97347 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  97352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97356 */   GIR_RootConstrainSelectedInstOperands,
     /*  97357 */   // GIR_Coverage, 530,
     /*  97357 */   GIR_Done,
     /*  97358 */ // Label 1775: @97358
     /*  97358 */ GIM_Reject,
     /*  97359 */ // Label 1767: @97359
     /*  97359 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97389), // Rule ID 532 //
     /*  97364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97378 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  97383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97387 */   GIR_RootConstrainSelectedInstOperands,
     /*  97388 */   // GIR_Coverage, 532,
     /*  97388 */   GIR_Done,
     /*  97389 */ // Label 1776: @97389
     /*  97389 */ GIM_Reject,
     /*  97390 */ // Label 1768: @97390
     /*  97390 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97420), // Rule ID 873 //
     /*  97395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97409 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  97414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97418 */   GIR_RootConstrainSelectedInstOperands,
     /*  97419 */   // GIR_Coverage, 873,
     /*  97419 */   GIR_Done,
     /*  97420 */ // Label 1777: @97420
     /*  97420 */ GIM_Reject,
     /*  97421 */ // Label 1769: @97421
     /*  97421 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(97451), // Rule ID 877 //
     /*  97426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97440 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  97445 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97449 */   GIR_RootConstrainSelectedInstOperands,
     /*  97450 */   // GIR_Coverage, 877,
     /*  97450 */   GIR_Done,
     /*  97451 */ // Label 1778: @97451
     /*  97451 */ GIM_Reject,
     /*  97452 */ // Label 1770: @97452
     /*  97452 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(97482), // Rule ID 869 //
     /*  97457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97471 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  97476 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97480 */   GIR_RootConstrainSelectedInstOperands,
     /*  97481 */   // GIR_Coverage, 869,
     /*  97481 */   GIR_Done,
     /*  97482 */ // Label 1779: @97482
     /*  97482 */ GIM_Reject,
     /*  97483 */ // Label 1771: @97483
     /*  97483 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(97513), // Rule ID 875 //
     /*  97488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97502 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97507 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97511 */   GIR_RootConstrainSelectedInstOperands,
     /*  97512 */   // GIR_Coverage, 875,
     /*  97512 */   GIR_Done,
     /*  97513 */ // Label 1780: @97513
     /*  97513 */ GIM_Reject,
     /*  97514 */ // Label 1772: @97514
     /*  97514 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(97735),
     /*  97519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97530 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(97549), // Rule ID 871 //
     /*  97535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97538 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  97543 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97547 */     GIR_RootConstrainSelectedInstOperands,
     /*  97548 */     // GIR_Coverage, 871,
     /*  97548 */     GIR_Done,
     /*  97549 */   // Label 1782: @97549
     /*  97549 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(97734), // Rule ID 6963 //
     /*  97554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97557 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97557 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97560 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97564 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97569 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97575 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97578 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97582 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97587 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97592 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97595 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97599 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97604 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97610 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97615 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97620 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97623 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97627 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97632 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97637 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97640 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  97644 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97649 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97654 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97657 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97661 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97666 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97671 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97674 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97678 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97697 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97703 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97732 */     GIR_RootConstrainSelectedInstOperands,
     /*  97733 */     // GIR_Coverage, 6963,
     /*  97733 */     GIR_EraseRootFromParent_Done,
     /*  97734 */   // Label 1783: @97734
     /*  97734 */   GIM_Reject,
     /*  97735 */ // Label 1781: @97735
     /*  97735 */ GIM_Reject,
     /*  97736 */ // Label 1773: @97736
     /*  97736 */ GIM_Reject,
     /*  97737 */ // Label 12: @97737
     /*  97737 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1786*/ GIMT_Encode4(98004),
     /*  97748 */ /*GILLT_s32*//*Label 1784*/ GIMT_Encode4(97756),
     /*  97752 */ /*GILLT_s64*//*Label 1785*/ GIMT_Encode4(97880),
     /*  97756 */ // Label 1784: @97756
     /*  97756 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(97799), // Rule ID 4773 //
     /*  97761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97771 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97783 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  97792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97794 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97797 */   GIR_RootConstrainSelectedInstOperands,
     /*  97798 */   // GIR_Coverage, 4773,
     /*  97798 */   GIR_EraseRootFromParent_Done,
     /*  97799 */ // Label 1787: @97799
     /*  97799 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(97839), // Rule ID 4779 //
     /*  97804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97811 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  97832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97837 */   GIR_RootConstrainSelectedInstOperands,
     /*  97838 */   // GIR_Coverage, 4779,
     /*  97838 */   GIR_EraseRootFromParent_Done,
     /*  97839 */ // Label 1788: @97839
     /*  97839 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(97879), // Rule ID 4781 //
     /*  97844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  97851 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  97851 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97854 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  97858 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97863 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  97872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97877 */   GIR_RootConstrainSelectedInstOperands,
     /*  97878 */   // GIR_Coverage, 4781,
     /*  97878 */   GIR_EraseRootFromParent_Done,
     /*  97879 */ // Label 1789: @97879
     /*  97879 */ GIM_Reject,
     /*  97880 */ // Label 1785: @97880
     /*  97880 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(97923), // Rule ID 4775 //
     /*  97885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97895 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  97895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  97898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  97902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97907 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  97916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97921 */   GIR_RootConstrainSelectedInstOperands,
     /*  97922 */   // GIR_Coverage, 4775,
     /*  97922 */   GIR_EraseRootFromParent_Done,
     /*  97923 */ // Label 1790: @97923
     /*  97923 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(97963), // Rule ID 4783 //
     /*  97928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97935 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  97935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  97938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  97942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97947 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  97956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97961 */   GIR_RootConstrainSelectedInstOperands,
     /*  97962 */   // GIR_Coverage, 4783,
     /*  97962 */   GIR_EraseRootFromParent_Done,
     /*  97963 */ // Label 1791: @97963
     /*  97963 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98003), // Rule ID 4785 //
     /*  97968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  97975 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  97975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  97982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97987 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  97996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  97998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98001 */   GIR_RootConstrainSelectedInstOperands,
     /*  98002 */   // GIR_Coverage, 4785,
     /*  98002 */   GIR_EraseRootFromParent_Done,
     /*  98003 */ // Label 1792: @98003
     /*  98003 */ GIM_Reject,
     /*  98004 */ // Label 1786: @98004
     /*  98004 */ GIM_Reject,
     /*  98005 */ // Label 13: @98005
     /*  98005 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98154),
     /*  98010 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98013 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1797*/ GIMT_Encode4(98153),
     /*  98024 */   /*GILLT_s16*//*Label 1794*/ GIMT_Encode4(98036),
     /*  98028 */   /*GILLT_s32*//*Label 1795*/ GIMT_Encode4(98077),
     /*  98032 */   /*GILLT_s64*//*Label 1796*/ GIMT_Encode4(98115),
     /*  98036 */   // Label 1794: @98036
     /*  98036 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(98076), // Rule ID 4777 //
     /*  98041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98048 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98074 */     GIR_RootConstrainSelectedInstOperands,
     /*  98075 */     // GIR_Coverage, 4777,
     /*  98075 */     GIR_EraseRootFromParent_Done,
     /*  98076 */   // Label 1798: @98076
     /*  98076 */   GIM_Reject,
     /*  98077 */   // Label 1795: @98077
     /*  98077 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(98114), // Rule ID 4787 //
     /*  98082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98086 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98112 */     GIR_RootConstrainSelectedInstOperands,
     /*  98113 */     // GIR_Coverage, 4787,
     /*  98113 */     GIR_EraseRootFromParent_Done,
     /*  98114 */   // Label 1799: @98114
     /*  98114 */   GIM_Reject,
     /*  98115 */   // Label 1796: @98115
     /*  98115 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(98152), // Rule ID 4789 //
     /*  98120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98124 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98150 */     GIR_RootConstrainSelectedInstOperands,
     /*  98151 */     // GIR_Coverage, 4789,
     /*  98151 */     GIR_EraseRootFromParent_Done,
     /*  98152 */   // Label 1800: @98152
     /*  98152 */   GIM_Reject,
     /*  98153 */   // Label 1797: @98153
     /*  98153 */   GIM_Reject,
     /*  98154 */ // Label 1793: @98154
     /*  98154 */ GIM_Reject,
     /*  98155 */ // Label 14: @98155
     /*  98155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1809*/ GIMT_Encode4(98645),
     /*  98166 */ /*GILLT_s16*//*Label 1801*/ GIMT_Encode4(98206),
     /*  98170 */ /*GILLT_s32*//*Label 1802*/ GIMT_Encode4(98237),
     /*  98174 */ /*GILLT_s64*//*Label 1803*/ GIMT_Encode4(98268), GIMT_Encode4(0),
     /*  98182 */ /*GILLT_v2s32*//*Label 1804*/ GIMT_Encode4(98299),
     /*  98186 */ /*GILLT_v2s64*//*Label 1805*/ GIMT_Encode4(98330),
     /*  98190 */ /*GILLT_v4s16*//*Label 1806*/ GIMT_Encode4(98361),
     /*  98194 */ /*GILLT_v4s32*//*Label 1807*/ GIMT_Encode4(98392), GIMT_Encode4(0),
     /*  98202 */ /*GILLT_v8s16*//*Label 1808*/ GIMT_Encode4(98423),
     /*  98206 */ // Label 1801: @98206
     /*  98206 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(98236), // Rule ID 546 //
     /*  98211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98225 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  98230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98234 */   GIR_RootConstrainSelectedInstOperands,
     /*  98235 */   // GIR_Coverage, 546,
     /*  98235 */   GIR_Done,
     /*  98236 */ // Label 1810: @98236
     /*  98236 */ GIM_Reject,
     /*  98237 */ // Label 1802: @98237
     /*  98237 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(98267), // Rule ID 548 //
     /*  98242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98256 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  98261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98265 */   GIR_RootConstrainSelectedInstOperands,
     /*  98266 */   // GIR_Coverage, 548,
     /*  98266 */   GIR_Done,
     /*  98267 */ // Label 1811: @98267
     /*  98267 */ GIM_Reject,
     /*  98268 */ // Label 1803: @98268
     /*  98268 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(98298), // Rule ID 550 //
     /*  98273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98287 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  98287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  98292 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98296 */   GIR_RootConstrainSelectedInstOperands,
     /*  98297 */   // GIR_Coverage, 550,
     /*  98297 */   GIR_Done,
     /*  98298 */ // Label 1812: @98298
     /*  98298 */ GIM_Reject,
     /*  98299 */ // Label 1804: @98299
     /*  98299 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(98329), // Rule ID 903 //
     /*  98304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98318 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  98318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  98323 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98327 */   GIR_RootConstrainSelectedInstOperands,
     /*  98328 */   // GIR_Coverage, 903,
     /*  98328 */   GIR_Done,
     /*  98329 */ // Label 1813: @98329
     /*  98329 */ GIM_Reject,
     /*  98330 */ // Label 1805: @98330
     /*  98330 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(98360), // Rule ID 907 //
     /*  98335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98349 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  98349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  98354 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98358 */   GIR_RootConstrainSelectedInstOperands,
     /*  98359 */   // GIR_Coverage, 907,
     /*  98359 */   GIR_Done,
     /*  98360 */ // Label 1814: @98360
     /*  98360 */ GIM_Reject,
     /*  98361 */ // Label 1806: @98361
     /*  98361 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(98391), // Rule ID 899 //
     /*  98366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98380 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  98385 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98389 */   GIR_RootConstrainSelectedInstOperands,
     /*  98390 */   // GIR_Coverage, 899,
     /*  98390 */   GIR_Done,
     /*  98391 */ // Label 1815: @98391
     /*  98391 */ GIM_Reject,
     /*  98392 */ // Label 1807: @98392
     /*  98392 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(98422), // Rule ID 905 //
     /*  98397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98411 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98420 */   GIR_RootConstrainSelectedInstOperands,
     /*  98421 */   // GIR_Coverage, 905,
     /*  98421 */   GIR_Done,
     /*  98422 */ // Label 1816: @98422
     /*  98422 */ GIM_Reject,
     /*  98423 */ // Label 1808: @98423
     /*  98423 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(98644),
     /*  98428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98439 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(98458), // Rule ID 901 //
     /*  98444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98447 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  98452 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98456 */     GIR_RootConstrainSelectedInstOperands,
     /*  98457 */     // GIR_Coverage, 901,
     /*  98457 */     GIR_Done,
     /*  98458 */   // Label 1818: @98458
     /*  98458 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(98643), // Rule ID 6965 //
     /*  98463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  98466 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  98466 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  98469 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  98473 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98478 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  98484 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  98487 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98491 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98496 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  98499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  98501 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  98504 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98508 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98513 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  98519 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98524 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98529 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  98532 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  98536 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98541 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  98544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  98546 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  98549 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98553 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98558 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  98561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98563 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  98566 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  98570 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98575 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  98578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98606 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98609 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  98612 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98641 */     GIR_RootConstrainSelectedInstOperands,
     /*  98642 */     // GIR_Coverage, 6965,
     /*  98642 */     GIR_EraseRootFromParent_Done,
     /*  98643 */   // Label 1819: @98643
     /*  98643 */   GIM_Reject,
     /*  98644 */ // Label 1817: @98644
     /*  98644 */ GIM_Reject,
     /*  98645 */ // Label 1809: @98645
     /*  98645 */ GIM_Reject,
     /*  98646 */ // Label 15: @98646
     /*  98646 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(98678), // Rule ID 3894 //
     /*  98651 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98658 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  98658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  98661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98663 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  98673 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  98676 */   GIR_RootConstrainSelectedInstOperands,
     /*  98677 */   // GIR_Coverage, 3894,
     /*  98677 */   GIR_EraseRootFromParent_Done,
     /*  98678 */ // Label 1820: @98678
     /*  98678 */ GIM_Reject,
     /*  98679 */ // Label 16: @98679
     /*  98679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1841*/ GIMT_Encode4(107488),
     /*  98690 */ /*GILLT_s8*//*Label 1821*/ GIMT_Encode4(98786),
     /*  98694 */ /*GILLT_s16*//*Label 1822*/ GIMT_Encode4(98962),
     /*  98698 */ /*GILLT_s32*//*Label 1823*/ GIMT_Encode4(99138),
     /*  98702 */ /*GILLT_s64*//*Label 1824*/ GIMT_Encode4(101436),
     /*  98706 */ /*GILLT_s128*//*Label 1825*/ GIMT_Encode4(104117),
     /*  98710 */ /*GILLT_v2s32*//*Label 1826*/ GIMT_Encode4(104326),
     /*  98714 */ /*GILLT_v2s64*//*Label 1827*/ GIMT_Encode4(104704),
     /*  98718 */ /*GILLT_v4s16*//*Label 1828*/ GIMT_Encode4(105082),
     /*  98722 */ /*GILLT_v4s32*//*Label 1829*/ GIMT_Encode4(105460),
     /*  98726 */ /*GILLT_v8s8*//*Label 1830*/ GIMT_Encode4(105838),
     /*  98730 */ /*GILLT_v8s16*//*Label 1831*/ GIMT_Encode4(106046),
     /*  98734 */ /*GILLT_v16s8*//*Label 1832*/ GIMT_Encode4(106424), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98746 */ /*GILLT_nxv2s16*//*Label 1833*/ GIMT_Encode4(106632),
     /*  98750 */ /*GILLT_nxv2s32*//*Label 1834*/ GIMT_Encode4(106696),
     /*  98754 */ /*GILLT_nxv2s64*//*Label 1835*/ GIMT_Encode4(106760), GIMT_Encode4(0),
     /*  98762 */ /*GILLT_nxv4s16*//*Label 1836*/ GIMT_Encode4(106934),
     /*  98766 */ /*GILLT_nxv4s32*//*Label 1837*/ GIMT_Encode4(106998), GIMT_Encode4(0),
     /*  98774 */ /*GILLT_nxv8s16*//*Label 1838*/ GIMT_Encode4(107172),
     /*  98778 */ /*GILLT_nxv16s1*//*Label 1839*/ GIMT_Encode4(107346),
     /*  98782 */ /*GILLT_nxv16s8*//*Label 1840*/ GIMT_Encode4(107390),
     /*  98786 */ // Label 1821: @98786
     /*  98786 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(98961),
     /*  98791 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98794 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  98802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98806 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(98847), // Rule ID 237 //
     /*  98811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  98821 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  98821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  98824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98845 */     GIR_RootConstrainSelectedInstOperands,
     /*  98846 */     // GIR_Coverage, 237,
     /*  98846 */     GIR_EraseRootFromParent_Done,
     /*  98847 */   // Label 1843: @98847
     /*  98847 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(98888), // Rule ID 238 //
     /*  98852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  98862 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  98862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  98865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  98877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  98882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98886 */     GIR_RootConstrainSelectedInstOperands,
     /*  98887 */     // GIR_Coverage, 238,
     /*  98887 */     GIR_EraseRootFromParent_Done,
     /*  98888 */   // Label 1844: @98888
     /*  98888 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(98924), // Rule ID 261 //
     /*  98893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  98903 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  98903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  98906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98922 */     GIR_RootConstrainSelectedInstOperands,
     /*  98923 */     // GIR_Coverage, 261,
     /*  98923 */     GIR_EraseRootFromParent_Done,
     /*  98924 */   // Label 1845: @98924
     /*  98924 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(98960), // Rule ID 282 //
     /*  98929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  98939 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  98939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  98942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  98944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  98954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98958 */     GIR_RootConstrainSelectedInstOperands,
     /*  98959 */     // GIR_Coverage, 282,
     /*  98959 */     GIR_EraseRootFromParent_Done,
     /*  98960 */   // Label 1846: @98960
     /*  98960 */   GIM_Reject,
     /*  98961 */ // Label 1842: @98961
     /*  98961 */ GIM_Reject,
     /*  98962 */ // Label 1822: @98962
     /*  98962 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(99137),
     /*  98967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  98974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  98982 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(99023), // Rule ID 239 //
     /*  98987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  98997 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  98997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  99000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99021 */     GIR_RootConstrainSelectedInstOperands,
     /*  99022 */     // GIR_Coverage, 239,
     /*  99022 */     GIR_EraseRootFromParent_Done,
     /*  99023 */   // Label 1848: @99023
     /*  99023 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(99064), // Rule ID 240 //
     /*  99028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99038 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  99041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99062 */     GIR_RootConstrainSelectedInstOperands,
     /*  99063 */     // GIR_Coverage, 240,
     /*  99063 */     GIR_EraseRootFromParent_Done,
     /*  99064 */   // Label 1849: @99064
     /*  99064 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(99100), // Rule ID 262 //
     /*  99069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99079 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  99082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99098 */     GIR_RootConstrainSelectedInstOperands,
     /*  99099 */     // GIR_Coverage, 262,
     /*  99099 */     GIR_EraseRootFromParent_Done,
     /*  99100 */   // Label 1850: @99100
     /*  99100 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(99136), // Rule ID 283 //
     /*  99105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99115 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  99118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99134 */     GIR_RootConstrainSelectedInstOperands,
     /*  99135 */     // GIR_Coverage, 283,
     /*  99135 */     GIR_EraseRootFromParent_Done,
     /*  99136 */   // Label 1851: @99136
     /*  99136 */   GIM_Reject,
     /*  99137 */ // Label 1847: @99137
     /*  99137 */ GIM_Reject,
     /*  99138 */ // Label 1823: @99138
     /*  99138 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(99191), // Rule ID 233 //
     /*  99143 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99146 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99165 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99189 */   GIR_RootConstrainSelectedInstOperands,
     /*  99190 */   // GIR_Coverage, 233,
     /*  99190 */   GIR_EraseRootFromParent_Done,
     /*  99191 */ // Label 1852: @99191
     /*  99191 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(99244), // Rule ID 234 //
     /*  99196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99218 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99242 */   GIR_RootConstrainSelectedInstOperands,
     /*  99243 */   // GIR_Coverage, 234,
     /*  99243 */   GIR_EraseRootFromParent_Done,
     /*  99244 */ // Label 1853: @99244
     /*  99244 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(99300), // Rule ID 241 //
     /*  99249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99252 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99255 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99263 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99267 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99274 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  99277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99298 */   GIR_RootConstrainSelectedInstOperands,
     /*  99299 */   // GIR_Coverage, 241,
     /*  99299 */   GIR_EraseRootFromParent_Done,
     /*  99300 */ // Label 1854: @99300
     /*  99300 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(99356), // Rule ID 242 //
     /*  99305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99330 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  99333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99354 */   GIR_RootConstrainSelectedInstOperands,
     /*  99355 */   // GIR_Coverage, 242,
     /*  99355 */   GIR_EraseRootFromParent_Done,
     /*  99356 */ // Label 1855: @99356
     /*  99356 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(99416), // Rule ID 4110 //
     /*  99361 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99364 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99390 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99414 */   GIR_RootConstrainSelectedInstOperands,
     /*  99415 */   // GIR_Coverage, 4110,
     /*  99415 */   GIR_EraseRootFromParent_Done,
     /*  99416 */ // Label 1856: @99416
     /*  99416 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(99476), // Rule ID 4111 //
     /*  99421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99424 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99443 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99450 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99474 */   GIR_RootConstrainSelectedInstOperands,
     /*  99475 */   // GIR_Coverage, 4111,
     /*  99475 */   GIR_EraseRootFromParent_Done,
     /*  99476 */ // Label 1857: @99476
     /*  99476 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(99536), // Rule ID 4112 //
     /*  99481 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99484 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99510 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  99513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99534 */   GIR_RootConstrainSelectedInstOperands,
     /*  99535 */   // GIR_Coverage, 4112,
     /*  99535 */   GIR_EraseRootFromParent_Done,
     /*  99536 */ // Label 1858: @99536
     /*  99536 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(99596), // Rule ID 4113 //
     /*  99541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99544 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99548 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99563 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99570 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /*  99573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99594 */   GIR_RootConstrainSelectedInstOperands,
     /*  99595 */   // GIR_Coverage, 4113,
     /*  99595 */   GIR_EraseRootFromParent_Done,
     /*  99596 */ // Label 1859: @99596
     /*  99596 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(99656), // Rule ID 4114 //
     /*  99601 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99604 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99630 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99654 */   GIR_RootConstrainSelectedInstOperands,
     /*  99655 */   // GIR_Coverage, 4114,
     /*  99655 */   GIR_EraseRootFromParent_Done,
     /*  99656 */ // Label 1860: @99656
     /*  99656 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(99716), // Rule ID 4115 //
     /*  99661 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99664 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  99675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99679 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99683 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99690 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99710 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99714 */   GIR_RootConstrainSelectedInstOperands,
     /*  99715 */   // GIR_Coverage, 4115,
     /*  99715 */   GIR_EraseRootFromParent_Done,
     /*  99716 */ // Label 1861: @99716
     /*  99716 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(99764), // Rule ID 260 //
     /*  99721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99732 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99736 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99743 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /*  99746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99762 */   GIR_RootConstrainSelectedInstOperands,
     /*  99763 */   // GIR_Coverage, 260,
     /*  99763 */   GIR_EraseRootFromParent_Done,
     /*  99764 */ // Label 1862: @99764
     /*  99764 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(99815), // Rule ID 263 //
     /*  99769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99775 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99783 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99787 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  99794 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /*  99794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  99797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99813 */   GIR_RootConstrainSelectedInstOperands,
     /*  99814 */   // GIR_Coverage, 263,
     /*  99814 */   GIR_EraseRootFromParent_Done,
     /*  99815 */ // Label 1863: @99815
     /*  99815 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(99874), // Rule ID 6993 //
     /*  99820 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99823 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99830 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99837 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99841 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99848 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15801>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /*  99848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99858 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99872 */   GIR_RootConstrainSelectedInstOperands,
     /*  99873 */   // GIR_Coverage, 6993,
     /*  99873 */   GIR_EraseRootFromParent_Done,
     /*  99874 */ // Label 1864: @99874
     /*  99874 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(99933), // Rule ID 6995 //
     /*  99879 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99882 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99889 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99896 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99900 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99907 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15801>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /*  99907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /*  99927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99931 */   GIR_RootConstrainSelectedInstOperands,
     /*  99932 */   // GIR_Coverage, 6995,
     /*  99932 */   GIR_EraseRootFromParent_Done,
     /*  99933 */ // Label 1865: @99933
     /*  99933 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(99992), // Rule ID 7005 //
     /*  99938 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  99941 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  99948 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  99951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99959 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99966 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15810>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /*  99969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99990 */   GIR_RootConstrainSelectedInstOperands,
     /*  99991 */   // GIR_Coverage, 7005,
     /*  99991 */   GIR_EraseRootFromParent_Done,
     /*  99992 */ // Label 1866: @99992
     /*  99992 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100051), // Rule ID 7007 //
     /*  99997 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100000 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100007 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100018 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100025 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15810>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100040 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100049 */   GIR_RootConstrainSelectedInstOperands,
     /* 100050 */   // GIR_Coverage, 7007,
     /* 100050 */   GIR_EraseRootFromParent_Done,
     /* 100051 */ // Label 1867: @100051
     /* 100051 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(100110), // Rule ID 7015 //
     /* 100056 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100059 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100066 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100084 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100104 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100108 */   GIR_RootConstrainSelectedInstOperands,
     /* 100109 */   // GIR_Coverage, 7015,
     /* 100109 */   GIR_EraseRootFromParent_Done,
     /* 100110 */ // Label 1868: @100110
     /* 100110 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100169), // Rule ID 7016 //
     /* 100115 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100118 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100125 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100136 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100143 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100163 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100167 */   GIR_RootConstrainSelectedInstOperands,
     /* 100168 */   // GIR_Coverage, 7016,
     /* 100168 */   GIR_EraseRootFromParent_Done,
     /* 100169 */ // Label 1869: @100169
     /* 100169 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(100217), // Rule ID 281 //
     /* 100174 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100177 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100196 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100215 */   GIR_RootConstrainSelectedInstOperands,
     /* 100216 */   // GIR_Coverage, 281,
     /* 100216 */   GIR_EraseRootFromParent_Done,
     /* 100217 */ // Label 1870: @100217
     /* 100217 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(100268), // Rule ID 284 //
     /* 100222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100240 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100247 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 100250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100266 */   GIR_RootConstrainSelectedInstOperands,
     /* 100267 */   // GIR_Coverage, 284,
     /* 100267 */   GIR_EraseRootFromParent_Done,
     /* 100268 */ // Label 1871: @100268
     /* 100268 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(100322), // Rule ID 6997 //
     /* 100273 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100276 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100283 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100301 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15801>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100320 */   GIR_RootConstrainSelectedInstOperands,
     /* 100321 */   // GIR_Coverage, 6997,
     /* 100321 */   GIR_EraseRootFromParent_Done,
     /* 100322 */ // Label 1872: @100322
     /* 100322 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(100376), // Rule ID 6999 //
     /* 100327 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100330 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100337 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100355 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15801>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100374 */   GIR_RootConstrainSelectedInstOperands,
     /* 100375 */   // GIR_Coverage, 6999,
     /* 100375 */   GIR_EraseRootFromParent_Done,
     /* 100376 */ // Label 1873: @100376
     /* 100376 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(100430), // Rule ID 7009 //
     /* 100381 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100384 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100391 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100398 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100402 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100409 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15810>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100428 */   GIR_RootConstrainSelectedInstOperands,
     /* 100429 */   // GIR_Coverage, 7009,
     /* 100429 */   GIR_EraseRootFromParent_Done,
     /* 100430 */ // Label 1874: @100430
     /* 100430 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(100484), // Rule ID 7011 //
     /* 100435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100445 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100463 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15810>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100478 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100482 */   GIR_RootConstrainSelectedInstOperands,
     /* 100483 */   // GIR_Coverage, 7011,
     /* 100483 */   GIR_EraseRootFromParent_Done,
     /* 100484 */ // Label 1875: @100484
     /* 100484 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(100538), // Rule ID 7017 //
     /* 100489 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100492 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100499 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100517 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 100520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100536 */   GIR_RootConstrainSelectedInstOperands,
     /* 100537 */   // GIR_Coverage, 7017,
     /* 100537 */   GIR_EraseRootFromParent_Done,
     /* 100538 */ // Label 1876: @100538
     /* 100538 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(100592), // Rule ID 7018 //
     /* 100543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100553 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100571 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15818>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100590 */   GIR_RootConstrainSelectedInstOperands,
     /* 100591 */   // GIR_Coverage, 7018,
     /* 100591 */   GIR_EraseRootFromParent_Done,
     /* 100592 */ // Label 1877: @100592
     /* 100592 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(100649), // Rule ID 7373 //
     /* 100597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100628 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15799>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 100631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100643 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100647 */   GIR_RootConstrainSelectedInstOperands,
     /* 100648 */   // GIR_Coverage, 7373,
     /* 100648 */   GIR_EraseRootFromParent_Done,
     /* 100649 */ // Label 1878: @100649
     /* 100649 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(100706), // Rule ID 7375 //
     /* 100654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100657 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100660 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100667 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100685 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15808>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 100688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100700 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100704 */   GIR_RootConstrainSelectedInstOperands,
     /* 100705 */   // GIR_Coverage, 7375,
     /* 100705 */   GIR_EraseRootFromParent_Done,
     /* 100706 */ // Label 1879: @100706
     /* 100706 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(100763), // Rule ID 7377 //
     /* 100711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 100714 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100717 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100742 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15793>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 100745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100757 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100761 */   GIR_RootConstrainSelectedInstOperands,
     /* 100762 */   // GIR_Coverage, 7377,
     /* 100762 */   GIR_EraseRootFromParent_Done,
     /* 100763 */ // Label 1880: @100763
     /* 100763 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(100818), // Rule ID 4137 //
     /* 100768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100786 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100790 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100797 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100807 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100812 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100816 */   GIR_RootConstrainSelectedInstOperands,
     /* 100817 */   // GIR_Coverage, 4137,
     /* 100817 */   GIR_EraseRootFromParent_Done,
     /* 100818 */ // Label 1881: @100818
     /* 100818 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(100873), // Rule ID 4138 //
     /* 100823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100826 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100830 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100852 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100862 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100867 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100871 */   GIR_RootConstrainSelectedInstOperands,
     /* 100872 */   // GIR_Coverage, 4138,
     /* 100872 */   GIR_EraseRootFromParent_Done,
     /* 100873 */ // Label 1882: @100873
     /* 100873 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(100928), // Rule ID 4139 //
     /* 100878 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100881 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100885 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100896 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100900 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100907 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100922 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100926 */   GIR_RootConstrainSelectedInstOperands,
     /* 100927 */   // GIR_Coverage, 4139,
     /* 100927 */   GIR_EraseRootFromParent_Done,
     /* 100928 */ // Label 1883: @100928
     /* 100928 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(100983), // Rule ID 4160 //
     /* 100933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100936 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100940 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100962 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 100965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100981 */   GIR_RootConstrainSelectedInstOperands,
     /* 100982 */   // GIR_Coverage, 4160,
     /* 100982 */   GIR_EraseRootFromParent_Done,
     /* 100983 */ // Label 1884: @100983
     /* 100983 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101038), // Rule ID 4161 //
     /* 100988 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100991 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100995 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101010 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101017 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101036 */   GIR_RootConstrainSelectedInstOperands,
     /* 101037 */   // GIR_Coverage, 4161,
     /* 101037 */   GIR_EraseRootFromParent_Done,
     /* 101038 */ // Label 1885: @101038
     /* 101038 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(101093), // Rule ID 4162 //
     /* 101043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101046 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101072 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101091 */   GIR_RootConstrainSelectedInstOperands,
     /* 101092 */   // GIR_Coverage, 4162,
     /* 101092 */   GIR_EraseRootFromParent_Done,
     /* 101093 */ // Label 1886: @101093
     /* 101093 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101133), // Rule ID 6985 //
     /* 101098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101101 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101104 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101111 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101118 */   // MIs[0] ptr
     /* 101118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101126 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15789>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 101131 */   GIR_RootConstrainSelectedInstOperands,
     /* 101132 */   // GIR_Coverage, 6985,
     /* 101132 */   GIR_Done,
     /* 101133 */ // Label 1887: @101133
     /* 101133 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101173), // Rule ID 6986 //
     /* 101138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101141 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101151 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101158 */   // MIs[0] ptr
     /* 101158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101166 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15791>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 101171 */   GIR_RootConstrainSelectedInstOperands,
     /* 101172 */   // GIR_Coverage, 6986,
     /* 101172 */   GIR_Done,
     /* 101173 */ // Label 1888: @101173
     /* 101173 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101213), // Rule ID 6987 //
     /* 101178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101181 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101184 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101191 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101198 */   // MIs[0] ptr
     /* 101198 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101206 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15793>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 101211 */   GIR_RootConstrainSelectedInstOperands,
     /* 101212 */   // GIR_Coverage, 6987,
     /* 101212 */   GIR_Done,
     /* 101213 */ // Label 1889: @101213
     /* 101213 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101250), // Rule ID 6989 //
     /* 101218 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101221 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101228 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101235 */   // MIs[0] ptr
     /* 101235 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101243 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15797>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101248 */   GIR_RootConstrainSelectedInstOperands,
     /* 101249 */   // GIR_Coverage, 6989,
     /* 101249 */   GIR_Done,
     /* 101250 */ // Label 1890: @101250
     /* 101250 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(101287), // Rule ID 6991 //
     /* 101255 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101258 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101265 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101272 */   // MIs[0] ptr
     /* 101272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101280 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15799>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101285 */   GIR_RootConstrainSelectedInstOperands,
     /* 101286 */   // GIR_Coverage, 6991,
     /* 101286 */   GIR_Done,
     /* 101287 */ // Label 1891: @101287
     /* 101287 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(101324), // Rule ID 7001 //
     /* 101292 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101295 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101309 */   // MIs[0] ptr
     /* 101309 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101317 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15806>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101322 */   GIR_RootConstrainSelectedInstOperands,
     /* 101323 */   // GIR_Coverage, 7001,
     /* 101323 */   GIR_Done,
     /* 101324 */ // Label 1892: @101324
     /* 101324 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(101361), // Rule ID 7003 //
     /* 101329 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101332 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101346 */   // MIs[0] ptr
     /* 101346 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101354 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15808>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101359 */   GIR_RootConstrainSelectedInstOperands,
     /* 101360 */   // GIR_Coverage, 7003,
     /* 101360 */   GIR_Done,
     /* 101361 */ // Label 1893: @101361
     /* 101361 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(101398), // Rule ID 7013 //
     /* 101366 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101369 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101376 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101383 */   // MIs[0] ptr
     /* 101383 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101391 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15815>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101396 */   GIR_RootConstrainSelectedInstOperands,
     /* 101397 */   // GIR_Coverage, 7013,
     /* 101397 */   GIR_Done,
     /* 101398 */ // Label 1894: @101398
     /* 101398 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(101435), // Rule ID 7014 //
     /* 101403 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101406 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101413 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101420 */   // MIs[0] ptr
     /* 101420 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101428 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15793>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101433 */   GIR_RootConstrainSelectedInstOperands,
     /* 101434 */   // GIR_Coverage, 7014,
     /* 101434 */   GIR_Done,
     /* 101435 */ // Label 1895: @101435
     /* 101435 */ GIM_Reject,
     /* 101436 */ // Label 1824: @101436
     /* 101436 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(101489), // Rule ID 235 //
     /* 101441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101463 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 101466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101487 */   GIR_RootConstrainSelectedInstOperands,
     /* 101488 */   // GIR_Coverage, 235,
     /* 101488 */   GIR_EraseRootFromParent_Done,
     /* 101489 */ // Label 1896: @101489
     /* 101489 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(101542), // Rule ID 236 //
     /* 101494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101516 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 101519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101540 */   GIR_RootConstrainSelectedInstOperands,
     /* 101541 */   // GIR_Coverage, 236,
     /* 101541 */   GIR_EraseRootFromParent_Done,
     /* 101542 */ // Label 1897: @101542
     /* 101542 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(101598), // Rule ID 243 //
     /* 101547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101572 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101596 */   GIR_RootConstrainSelectedInstOperands,
     /* 101597 */   // GIR_Coverage, 243,
     /* 101597 */   GIR_EraseRootFromParent_Done,
     /* 101598 */ // Label 1898: @101598
     /* 101598 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(101654), // Rule ID 244 //
     /* 101603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 101606 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101609 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101621 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101628 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101652 */   GIR_RootConstrainSelectedInstOperands,
     /* 101653 */   // GIR_Coverage, 244,
     /* 101653 */   GIR_EraseRootFromParent_Done,
     /* 101654 */ // Label 1899: @101654
     /* 101654 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(101707), // Rule ID 4076 //
     /* 101659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101662 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101670 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101674 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101681 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101705 */   GIR_RootConstrainSelectedInstOperands,
     /* 101706 */   // GIR_Coverage, 4076,
     /* 101706 */   GIR_EraseRootFromParent_Done,
     /* 101707 */ // Label 1900: @101707
     /* 101707 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(101760), // Rule ID 4077 //
     /* 101712 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101715 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101734 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101758 */   GIR_RootConstrainSelectedInstOperands,
     /* 101759 */   // GIR_Coverage, 4077,
     /* 101759 */   GIR_EraseRootFromParent_Done,
     /* 101760 */ // Label 1901: @101760
     /* 101760 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(101813), // Rule ID 4078 //
     /* 101765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101780 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101787 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 101790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101811 */   GIR_RootConstrainSelectedInstOperands,
     /* 101812 */   // GIR_Coverage, 4078,
     /* 101812 */   GIR_EraseRootFromParent_Done,
     /* 101813 */ // Label 1902: @101813
     /* 101813 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(101866), // Rule ID 4079 //
     /* 101818 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101821 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 101840 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 101840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 101843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101864 */   GIR_RootConstrainSelectedInstOperands,
     /* 101865 */   // GIR_Coverage, 4079,
     /* 101865 */   GIR_EraseRootFromParent_Done,
     /* 101866 */ // Label 1903: @101866
     /* 101866 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(101958), // Rule ID 4102 //
     /* 101871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101874 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101878 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 101900 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101900 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101903 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 101907 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 101922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 101927 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 101947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101957 */   // GIR_Coverage, 4102,
     /* 101957 */   GIR_EraseRootFromParent_Done,
     /* 101958 */ // Label 1904: @101958
     /* 101958 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102050), // Rule ID 4103 //
     /* 101963 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101966 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101970 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 101981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 101992 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 101992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 101995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 101999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102019 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102044 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102049 */   // GIR_Coverage, 4103,
     /* 102049 */   GIR_EraseRootFromParent_Done,
     /* 102050 */ // Label 1905: @102050
     /* 102050 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102142), // Rule ID 4104 //
     /* 102055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102058 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 102084 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 102091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102111 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102125 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102141 */   // GIR_Coverage, 4104,
     /* 102141 */   GIR_EraseRootFromParent_Done,
     /* 102142 */ // Label 1906: @102142
     /* 102142 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102234), // Rule ID 4105 //
     /* 102147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102150 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 102176 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 102183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102188 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102203 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102223 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102233 */   // GIR_Coverage, 4105,
     /* 102233 */   GIR_EraseRootFromParent_Done,
     /* 102234 */ // Label 1907: @102234
     /* 102234 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102326), // Rule ID 4106 //
     /* 102239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102242 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102246 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102261 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 102268 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 102275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102295 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102320 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102325 */   // GIR_Coverage, 4106,
     /* 102325 */   GIR_EraseRootFromParent_Done,
     /* 102326 */ // Label 1908: @102326
     /* 102326 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102418), // Rule ID 4107 //
     /* 102331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102334 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102338 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102353 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 102360 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 102367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102387 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102407 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102412 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102417 */   // GIR_Coverage, 4107,
     /* 102417 */   GIR_EraseRootFromParent_Done,
     /* 102418 */ // Label 1909: @102418
     /* 102418 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102510), // Rule ID 4108 //
     /* 102423 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102426 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102430 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102452 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102479 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102499 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102509 */   // GIR_Coverage, 4108,
     /* 102509 */   GIR_EraseRootFromParent_Done,
     /* 102510 */ // Label 1910: @102510
     /* 102510 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102602), // Rule ID 4109 //
     /* 102515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102518 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102522 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102544 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102571 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102596 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102601 */   // GIR_Coverage, 4109,
     /* 102601 */   GIR_EraseRootFromParent_Done,
     /* 102602 */ // Label 1911: @102602
     /* 102602 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102650), // Rule ID 259 //
     /* 102607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102618 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102622 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102629 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 102632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102648 */   GIR_RootConstrainSelectedInstOperands,
     /* 102649 */   // GIR_Coverage, 259,
     /* 102649 */   GIR_EraseRootFromParent_Done,
     /* 102650 */ // Label 1912: @102650
     /* 102650 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102701), // Rule ID 264 //
     /* 102655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102658 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102669 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102673 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102680 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 102683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102699 */   GIR_RootConstrainSelectedInstOperands,
     /* 102700 */   // GIR_Coverage, 264,
     /* 102700 */   GIR_EraseRootFromParent_Done,
     /* 102701 */ // Label 1913: @102701
     /* 102701 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102760), // Rule ID 7021 //
     /* 102706 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102716 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102734 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102758 */   GIR_RootConstrainSelectedInstOperands,
     /* 102759 */   // GIR_Coverage, 7021,
     /* 102759 */   GIR_EraseRootFromParent_Done,
     /* 102760 */ // Label 1914: @102760
     /* 102760 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102819), // Rule ID 7022 //
     /* 102765 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102775 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102782 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102786 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102793 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102813 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102817 */   GIR_RootConstrainSelectedInstOperands,
     /* 102818 */   // GIR_Coverage, 7022,
     /* 102818 */   GIR_EraseRootFromParent_Done,
     /* 102819 */ // Label 1915: @102819
     /* 102819 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102867), // Rule ID 280 //
     /* 102824 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102827 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102835 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102839 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102846 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 102849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102865 */   GIR_RootConstrainSelectedInstOperands,
     /* 102866 */   // GIR_Coverage, 280,
     /* 102866 */   GIR_EraseRootFromParent_Done,
     /* 102867 */ // Label 1916: @102867
     /* 102867 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(102918), // Rule ID 285 //
     /* 102872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102878 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 102897 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 102897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 102900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102916 */   GIR_RootConstrainSelectedInstOperands,
     /* 102917 */   // GIR_Coverage, 285,
     /* 102917 */   GIR_EraseRootFromParent_Done,
     /* 102918 */ // Label 1917: @102918
     /* 102918 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(102972), // Rule ID 7023 //
     /* 102923 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102926 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102933 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102940 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102944 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 102951 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 102951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 102954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 102966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102970 */   GIR_RootConstrainSelectedInstOperands,
     /* 102971 */   // GIR_Coverage, 7023,
     /* 102971 */   GIR_EraseRootFromParent_Done,
     /* 102972 */ // Label 1918: @102972
     /* 102972 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103026), // Rule ID 7024 //
     /* 102977 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 102980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 102987 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 102990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103005 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15826>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103020 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103024 */   GIR_RootConstrainSelectedInstOperands,
     /* 103025 */   // GIR_Coverage, 7024,
     /* 103025 */   GIR_EraseRootFromParent_Done,
     /* 103026 */ // Label 1919: @103026
     /* 103026 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103083), // Rule ID 7378 //
     /* 103031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 103034 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103037 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103044 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103051 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103055 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103062 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15795>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 103065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103077 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103081 */   GIR_RootConstrainSelectedInstOperands,
     /* 103082 */   // GIR_Coverage, 7378,
     /* 103082 */   GIR_EraseRootFromParent_Done,
     /* 103083 */ // Label 1920: @103083
     /* 103083 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103131), // Rule ID 4123 //
     /* 103088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103110 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103125 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103129 */   GIR_RootConstrainSelectedInstOperands,
     /* 103130 */   // GIR_Coverage, 4123,
     /* 103130 */   GIR_EraseRootFromParent_Done,
     /* 103131 */ // Label 1921: @103131
     /* 103131 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103179), // Rule ID 4124 //
     /* 103136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103139 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103147 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103151 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103158 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103177 */   GIR_RootConstrainSelectedInstOperands,
     /* 103178 */   // GIR_Coverage, 4124,
     /* 103178 */   GIR_EraseRootFromParent_Done,
     /* 103179 */ // Label 1922: @103179
     /* 103179 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103266), // Rule ID 4140 //
     /* 103184 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103187 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103191 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103202 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103206 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 103213 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 103220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103235 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103265 */   // GIR_Coverage, 4140,
     /* 103265 */   GIR_EraseRootFromParent_Done,
     /* 103266 */ // Label 1923: @103266
     /* 103266 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103353), // Rule ID 4141 //
     /* 103271 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103274 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103278 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103289 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103293 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 103300 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103300 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103303 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 103307 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103322 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103336 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103352 */   // GIR_Coverage, 4141,
     /* 103352 */   GIR_EraseRootFromParent_Done,
     /* 103353 */ // Label 1924: @103353
     /* 103353 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103440), // Rule ID 4142 //
     /* 103358 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103361 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103365 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103380 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 103387 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 103394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103404 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103409 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103434 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103439 */   // GIR_Coverage, 4142,
     /* 103439 */   GIR_EraseRootFromParent_Done,
     /* 103440 */ // Label 1925: @103440
     /* 103440 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103527), // Rule ID 4143 //
     /* 103445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103448 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 103474 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 103481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103496 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103526 */   // GIR_Coverage, 4143,
     /* 103526 */   GIR_EraseRootFromParent_Done,
     /* 103527 */ // Label 1926: @103527
     /* 103527 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103575), // Rule ID 4151 //
     /* 103532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103535 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103547 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103554 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103564 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103569 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103573 */   GIR_RootConstrainSelectedInstOperands,
     /* 103574 */   // GIR_Coverage, 4151,
     /* 103574 */   GIR_EraseRootFromParent_Done,
     /* 103575 */ // Label 1927: @103575
     /* 103575 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103623), // Rule ID 4152 //
     /* 103580 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103591 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103595 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103602 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103607 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103612 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103617 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103621 */   GIR_RootConstrainSelectedInstOperands,
     /* 103622 */   // GIR_Coverage, 4152,
     /* 103622 */   GIR_EraseRootFromParent_Done,
     /* 103623 */ // Label 1928: @103623
     /* 103623 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103710), // Rule ID 4163 //
     /* 103628 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103631 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103650 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 103657 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 103664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103679 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103709 */   // GIR_Coverage, 4163,
     /* 103709 */   GIR_EraseRootFromParent_Done,
     /* 103710 */ // Label 1929: @103710
     /* 103710 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103797), // Rule ID 4164 //
     /* 103715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103718 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103722 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 103744 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 103751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103766 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103786 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103796 */   // GIR_Coverage, 4164,
     /* 103796 */   GIR_EraseRootFromParent_Done,
     /* 103797 */ // Label 1930: @103797
     /* 103797 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103884), // Rule ID 4165 //
     /* 103802 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103805 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103809 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103824 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103831 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103853 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103883 */   // GIR_Coverage, 4165,
     /* 103883 */   GIR_EraseRootFromParent_Done,
     /* 103884 */ // Label 1931: @103884
     /* 103884 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103971), // Rule ID 4166 //
     /* 103889 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103892 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103896 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103911 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 103918 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 103918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 103925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103940 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103970 */   // GIR_Coverage, 4166,
     /* 103970 */   GIR_EraseRootFromParent_Done,
     /* 103971 */ // Label 1932: @103971
     /* 103971 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(104011), // Rule ID 6988 //
     /* 103976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 103979 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103982 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103996 */   // MIs[0] ptr
     /* 103996 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104004 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15795>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 104009 */   GIR_RootConstrainSelectedInstOperands,
     /* 104010 */   // GIR_Coverage, 6988,
     /* 104010 */   GIR_Done,
     /* 104011 */ // Label 1933: @104011
     /* 104011 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104048), // Rule ID 7019 //
     /* 104016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 104029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104033 */   // MIs[0] ptr
     /* 104033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104041 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15823>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104046 */   GIR_RootConstrainSelectedInstOperands,
     /* 104047 */   // GIR_Coverage, 7019,
     /* 104047 */   GIR_Done,
     /* 104048 */ // Label 1934: @104048
     /* 104048 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(104085), // Rule ID 7020 //
     /* 104053 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104056 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104070 */   // MIs[0] ptr
     /* 104070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104078 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15795>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104083 */   GIR_RootConstrainSelectedInstOperands,
     /* 104084 */   // GIR_Coverage, 7020,
     /* 104084 */   GIR_Done,
     /* 104085 */ // Label 1935: @104085
     /* 104085 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(104116), // Rule ID 6368 //
     /* 104090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104101 */   // MIs[0] Rn
     /* 104101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104109 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 104114 */   GIR_RootConstrainSelectedInstOperands,
     /* 104115 */   // GIR_Coverage, 6368,
     /* 104115 */   GIR_Done,
     /* 104116 */ // Label 1936: @104116
     /* 104116 */ GIM_Reject,
     /* 104117 */ // Label 1825: @104117
     /* 104117 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(104325),
     /* 104122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104125 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104137 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104178), // Rule ID 245 //
     /* 104142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104152 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104176 */     GIR_RootConstrainSelectedInstOperands,
     /* 104177 */     // GIR_Coverage, 245,
     /* 104177 */     GIR_EraseRootFromParent_Done,
     /* 104178 */   // Label 1938: @104178
     /* 104178 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104219), // Rule ID 246 //
     /* 104183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104193 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104217 */     GIR_RootConstrainSelectedInstOperands,
     /* 104218 */     // GIR_Coverage, 246,
     /* 104218 */     GIR_EraseRootFromParent_Done,
     /* 104219 */   // Label 1939: @104219
     /* 104219 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104255), // Rule ID 265 //
     /* 104224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104234 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104253 */     GIR_RootConstrainSelectedInstOperands,
     /* 104254 */     // GIR_Coverage, 265,
     /* 104254 */     GIR_EraseRootFromParent_Done,
     /* 104255 */   // Label 1940: @104255
     /* 104255 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(104291), // Rule ID 286 //
     /* 104260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 104270 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 104273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104289 */     GIR_RootConstrainSelectedInstOperands,
     /* 104290 */     // GIR_Coverage, 286,
     /* 104290 */     GIR_EraseRootFromParent_Done,
     /* 104291 */   // Label 1941: @104291
     /* 104291 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104324), // Rule ID 4132 //
     /* 104296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104303 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104322 */     GIR_RootConstrainSelectedInstOperands,
     /* 104323 */     // GIR_Coverage, 4132,
     /* 104323 */     GIR_EraseRootFromParent_Done,
     /* 104324 */   // Label 1942: @104324
     /* 104324 */   GIM_Reject,
     /* 104325 */ // Label 1937: @104325
     /* 104325 */ GIM_Reject,
     /* 104326 */ // Label 1826: @104326
     /* 104326 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(104703),
     /* 104331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104334 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104342 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104387), // Rule ID 4066 //
     /* 104347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104361 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104385 */     GIR_RootConstrainSelectedInstOperands,
     /* 104386 */     // GIR_Coverage, 4066,
     /* 104386 */     GIR_EraseRootFromParent_Done,
     /* 104387 */   // Label 1944: @104387
     /* 104387 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104432), // Rule ID 4067 //
     /* 104392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104406 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104430 */     GIR_RootConstrainSelectedInstOperands,
     /* 104431 */     // GIR_Coverage, 4067,
     /* 104431 */     GIR_EraseRootFromParent_Done,
     /* 104432 */   // Label 1945: @104432
     /* 104432 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104477), // Rule ID 4068 //
     /* 104437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104451 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104475 */     GIR_RootConstrainSelectedInstOperands,
     /* 104476 */     // GIR_Coverage, 4068,
     /* 104476 */     GIR_EraseRootFromParent_Done,
     /* 104477 */   // Label 1946: @104477
     /* 104477 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104522), // Rule ID 4069 //
     /* 104482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104496 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104520 */     GIR_RootConstrainSelectedInstOperands,
     /* 104521 */     // GIR_Coverage, 4069,
     /* 104521 */     GIR_EraseRootFromParent_Done,
     /* 104522 */   // Label 1947: @104522
     /* 104522 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(104562), // Rule ID 4118 //
     /* 104527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104541 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104560 */     GIR_RootConstrainSelectedInstOperands,
     /* 104561 */     // GIR_Coverage, 4118,
     /* 104561 */     GIR_EraseRootFromParent_Done,
     /* 104562 */   // Label 1948: @104562
     /* 104562 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104602), // Rule ID 4121 //
     /* 104567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 104581 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 104584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104600 */     GIR_RootConstrainSelectedInstOperands,
     /* 104601 */     // GIR_Coverage, 4121,
     /* 104601 */     GIR_EraseRootFromParent_Done,
     /* 104602 */   // Label 1949: @104602
     /* 104602 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104642), // Rule ID 4146 //
     /* 104607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104621 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104640 */     GIR_RootConstrainSelectedInstOperands,
     /* 104641 */     // GIR_Coverage, 4146,
     /* 104641 */     GIR_EraseRootFromParent_Done,
     /* 104642 */   // Label 1950: @104642
     /* 104642 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(104682), // Rule ID 4147 //
     /* 104647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104661 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104680 */     GIR_RootConstrainSelectedInstOperands,
     /* 104681 */     // GIR_Coverage, 4147,
     /* 104681 */     GIR_EraseRootFromParent_Done,
     /* 104682 */   // Label 1951: @104682
     /* 104682 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104702), // Rule ID 6367 //
     /* 104687 */     // MIs[0] Rn
     /* 104687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104695 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 104700 */     GIR_RootConstrainSelectedInstOperands,
     /* 104701 */     // GIR_Coverage, 6367,
     /* 104701 */     GIR_Done,
     /* 104702 */   // Label 1952: @104702
     /* 104702 */   GIM_Reject,
     /* 104703 */ // Label 1943: @104703
     /* 104703 */ GIM_Reject,
     /* 104704 */ // Label 1827: @104704
     /* 104704 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(105081),
     /* 104709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104720 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(104765), // Rule ID 4080 //
     /* 104725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104739 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104763 */     GIR_RootConstrainSelectedInstOperands,
     /* 104764 */     // GIR_Coverage, 4080,
     /* 104764 */     GIR_EraseRootFromParent_Done,
     /* 104765 */   // Label 1954: @104765
     /* 104765 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104810), // Rule ID 4081 //
     /* 104770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104784 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104808 */     GIR_RootConstrainSelectedInstOperands,
     /* 104809 */     // GIR_Coverage, 4081,
     /* 104809 */     GIR_EraseRootFromParent_Done,
     /* 104810 */   // Label 1955: @104810
     /* 104810 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(104855), // Rule ID 4082 //
     /* 104815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104829 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104853 */     GIR_RootConstrainSelectedInstOperands,
     /* 104854 */     // GIR_Coverage, 4082,
     /* 104854 */     GIR_EraseRootFromParent_Done,
     /* 104855 */   // Label 1956: @104855
     /* 104855 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(104900), // Rule ID 4083 //
     /* 104860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104874 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104898 */     GIR_RootConstrainSelectedInstOperands,
     /* 104899 */     // GIR_Coverage, 4083,
     /* 104899 */     GIR_EraseRootFromParent_Done,
     /* 104900 */   // Label 1957: @104900
     /* 104900 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(104940), // Rule ID 4126 //
     /* 104905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104919 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104938 */     GIR_RootConstrainSelectedInstOperands,
     /* 104939 */     // GIR_Coverage, 4126,
     /* 104939 */     GIR_EraseRootFromParent_Done,
     /* 104940 */   // Label 1958: @104940
     /* 104940 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(104980), // Rule ID 4130 //
     /* 104945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104959 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104978 */     GIR_RootConstrainSelectedInstOperands,
     /* 104979 */     // GIR_Coverage, 4130,
     /* 104979 */     GIR_EraseRootFromParent_Done,
     /* 104980 */   // Label 1959: @104980
     /* 104980 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(105020), // Rule ID 4153 //
     /* 104985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 104999 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105018 */     GIR_RootConstrainSelectedInstOperands,
     /* 105019 */     // GIR_Coverage, 4153,
     /* 105019 */     GIR_EraseRootFromParent_Done,
     /* 105020 */   // Label 1960: @105020
     /* 105020 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(105060), // Rule ID 4154 //
     /* 105025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105039 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105058 */     GIR_RootConstrainSelectedInstOperands,
     /* 105059 */     // GIR_Coverage, 4154,
     /* 105059 */     GIR_EraseRootFromParent_Done,
     /* 105060 */   // Label 1961: @105060
     /* 105060 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(105080), // Rule ID 6364 //
     /* 105065 */     // MIs[0] Rn
     /* 105065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105073 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 105078 */     GIR_RootConstrainSelectedInstOperands,
     /* 105079 */     // GIR_Coverage, 6364,
     /* 105079 */     GIR_Done,
     /* 105080 */   // Label 1962: @105080
     /* 105080 */   GIM_Reject,
     /* 105081 */ // Label 1953: @105081
     /* 105081 */ GIM_Reject,
     /* 105082 */ // Label 1828: @105082
     /* 105082 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(105459),
     /* 105087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105090 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105098 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(105143), // Rule ID 4072 //
     /* 105103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105117 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105141 */     GIR_RootConstrainSelectedInstOperands,
     /* 105142 */     // GIR_Coverage, 4072,
     /* 105142 */     GIR_EraseRootFromParent_Done,
     /* 105143 */   // Label 1964: @105143
     /* 105143 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(105188), // Rule ID 4073 //
     /* 105148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105162 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105186 */     GIR_RootConstrainSelectedInstOperands,
     /* 105187 */     // GIR_Coverage, 4073,
     /* 105187 */     GIR_EraseRootFromParent_Done,
     /* 105188 */   // Label 1965: @105188
     /* 105188 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(105233), // Rule ID 4074 //
     /* 105193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105207 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105231 */     GIR_RootConstrainSelectedInstOperands,
     /* 105232 */     // GIR_Coverage, 4074,
     /* 105232 */     GIR_EraseRootFromParent_Done,
     /* 105233 */   // Label 1966: @105233
     /* 105233 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(105278), // Rule ID 4075 //
     /* 105238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105252 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105276 */     GIR_RootConstrainSelectedInstOperands,
     /* 105277 */     // GIR_Coverage, 4075,
     /* 105277 */     GIR_EraseRootFromParent_Done,
     /* 105278 */   // Label 1967: @105278
     /* 105278 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(105318), // Rule ID 4120 //
     /* 105283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105297 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105316 */     GIR_RootConstrainSelectedInstOperands,
     /* 105317 */     // GIR_Coverage, 4120,
     /* 105317 */     GIR_EraseRootFromParent_Done,
     /* 105318 */   // Label 1968: @105318
     /* 105318 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(105358), // Rule ID 4122 //
     /* 105323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105337 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105356 */     GIR_RootConstrainSelectedInstOperands,
     /* 105357 */     // GIR_Coverage, 4122,
     /* 105357 */     GIR_EraseRootFromParent_Done,
     /* 105358 */   // Label 1969: @105358
     /* 105358 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(105398), // Rule ID 4148 //
     /* 105363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105377 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105396 */     GIR_RootConstrainSelectedInstOperands,
     /* 105397 */     // GIR_Coverage, 4148,
     /* 105397 */     GIR_EraseRootFromParent_Done,
     /* 105398 */   // Label 1970: @105398
     /* 105398 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(105438), // Rule ID 4150 //
     /* 105403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105417 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105436 */     GIR_RootConstrainSelectedInstOperands,
     /* 105437 */     // GIR_Coverage, 4150,
     /* 105437 */     GIR_EraseRootFromParent_Done,
     /* 105438 */   // Label 1971: @105438
     /* 105438 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(105458), // Rule ID 6366 //
     /* 105443 */     // MIs[0] Rn
     /* 105443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105451 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 105456 */     GIR_RootConstrainSelectedInstOperands,
     /* 105457 */     // GIR_Coverage, 6366,
     /* 105457 */     GIR_Done,
     /* 105458 */   // Label 1972: @105458
     /* 105458 */   GIM_Reject,
     /* 105459 */ // Label 1963: @105459
     /* 105459 */ GIM_Reject,
     /* 105460 */ // Label 1829: @105460
     /* 105460 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(105837),
     /* 105465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105468 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105476 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(105521), // Rule ID 4084 //
     /* 105481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105495 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105519 */     GIR_RootConstrainSelectedInstOperands,
     /* 105520 */     // GIR_Coverage, 4084,
     /* 105520 */     GIR_EraseRootFromParent_Done,
     /* 105521 */   // Label 1974: @105521
     /* 105521 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(105566), // Rule ID 4085 //
     /* 105526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105540 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105564 */     GIR_RootConstrainSelectedInstOperands,
     /* 105565 */     // GIR_Coverage, 4085,
     /* 105565 */     GIR_EraseRootFromParent_Done,
     /* 105566 */   // Label 1975: @105566
     /* 105566 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(105611), // Rule ID 4086 //
     /* 105571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105585 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105609 */     GIR_RootConstrainSelectedInstOperands,
     /* 105610 */     // GIR_Coverage, 4086,
     /* 105610 */     GIR_EraseRootFromParent_Done,
     /* 105611 */   // Label 1976: @105611
     /* 105611 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(105656), // Rule ID 4087 //
     /* 105616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105630 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105654 */     GIR_RootConstrainSelectedInstOperands,
     /* 105655 */     // GIR_Coverage, 4087,
     /* 105655 */     GIR_EraseRootFromParent_Done,
     /* 105656 */   // Label 1977: @105656
     /* 105656 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(105696), // Rule ID 4125 //
     /* 105661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105675 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105694 */     GIR_RootConstrainSelectedInstOperands,
     /* 105695 */     // GIR_Coverage, 4125,
     /* 105695 */     GIR_EraseRootFromParent_Done,
     /* 105696 */   // Label 1978: @105696
     /* 105696 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105736), // Rule ID 4129 //
     /* 105701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105715 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105734 */     GIR_RootConstrainSelectedInstOperands,
     /* 105735 */     // GIR_Coverage, 4129,
     /* 105735 */     GIR_EraseRootFromParent_Done,
     /* 105736 */   // Label 1979: @105736
     /* 105736 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105776), // Rule ID 4155 //
     /* 105741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105755 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105774 */     GIR_RootConstrainSelectedInstOperands,
     /* 105775 */     // GIR_Coverage, 4155,
     /* 105775 */     GIR_EraseRootFromParent_Done,
     /* 105776 */   // Label 1980: @105776
     /* 105776 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(105816), // Rule ID 4156 //
     /* 105781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105795 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105814 */     GIR_RootConstrainSelectedInstOperands,
     /* 105815 */     // GIR_Coverage, 4156,
     /* 105815 */     GIR_EraseRootFromParent_Done,
     /* 105816 */   // Label 1981: @105816
     /* 105816 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(105836), // Rule ID 6363 //
     /* 105821 */     // MIs[0] Rn
     /* 105821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105829 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 105834 */     GIR_RootConstrainSelectedInstOperands,
     /* 105835 */     // GIR_Coverage, 6363,
     /* 105835 */     GIR_Done,
     /* 105836 */   // Label 1982: @105836
     /* 105836 */   GIM_Reject,
     /* 105837 */ // Label 1973: @105837
     /* 105837 */ GIM_Reject,
     /* 105838 */ // Label 1830: @105838
     /* 105838 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(106045),
     /* 105843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105846 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105854 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(105899), // Rule ID 4070 //
     /* 105859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105873 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105897 */     GIR_RootConstrainSelectedInstOperands,
     /* 105898 */     // GIR_Coverage, 4070,
     /* 105898 */     GIR_EraseRootFromParent_Done,
     /* 105899 */   // Label 1984: @105899
     /* 105899 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105944), // Rule ID 4071 //
     /* 105904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105918 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105942 */     GIR_RootConstrainSelectedInstOperands,
     /* 105943 */     // GIR_Coverage, 4071,
     /* 105943 */     GIR_EraseRootFromParent_Done,
     /* 105944 */   // Label 1985: @105944
     /* 105944 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(105984), // Rule ID 4119 //
     /* 105949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105963 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105982 */     GIR_RootConstrainSelectedInstOperands,
     /* 105983 */     // GIR_Coverage, 4119,
     /* 105983 */     GIR_EraseRootFromParent_Done,
     /* 105984 */   // Label 1986: @105984
     /* 105984 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(106024), // Rule ID 4149 //
     /* 105989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106003 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106022 */     GIR_RootConstrainSelectedInstOperands,
     /* 106023 */     // GIR_Coverage, 4149,
     /* 106023 */     GIR_EraseRootFromParent_Done,
     /* 106024 */   // Label 1987: @106024
     /* 106024 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(106044), // Rule ID 6365 //
     /* 106029 */     // MIs[0] Rn
     /* 106029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106037 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 106042 */     GIR_RootConstrainSelectedInstOperands,
     /* 106043 */     // GIR_Coverage, 6365,
     /* 106043 */     GIR_Done,
     /* 106044 */   // Label 1988: @106044
     /* 106044 */   GIM_Reject,
     /* 106045 */ // Label 1983: @106045
     /* 106045 */ GIM_Reject,
     /* 106046 */ // Label 1831: @106046
     /* 106046 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(106423),
     /* 106051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106054 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106062 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(106107), // Rule ID 4088 //
     /* 106067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106081 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106105 */     GIR_RootConstrainSelectedInstOperands,
     /* 106106 */     // GIR_Coverage, 4088,
     /* 106106 */     GIR_EraseRootFromParent_Done,
     /* 106107 */   // Label 1990: @106107
     /* 106107 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(106152), // Rule ID 4089 //
     /* 106112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106126 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106150 */     GIR_RootConstrainSelectedInstOperands,
     /* 106151 */     // GIR_Coverage, 4089,
     /* 106151 */     GIR_EraseRootFromParent_Done,
     /* 106152 */   // Label 1991: @106152
     /* 106152 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(106197), // Rule ID 4090 //
     /* 106157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106171 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106195 */     GIR_RootConstrainSelectedInstOperands,
     /* 106196 */     // GIR_Coverage, 4090,
     /* 106196 */     GIR_EraseRootFromParent_Done,
     /* 106197 */   // Label 1992: @106197
     /* 106197 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(106242), // Rule ID 4091 //
     /* 106202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106216 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106240 */     GIR_RootConstrainSelectedInstOperands,
     /* 106241 */     // GIR_Coverage, 4091,
     /* 106241 */     GIR_EraseRootFromParent_Done,
     /* 106242 */   // Label 1993: @106242
     /* 106242 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(106282), // Rule ID 4128 //
     /* 106247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106261 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106280 */     GIR_RootConstrainSelectedInstOperands,
     /* 106281 */     // GIR_Coverage, 4128,
     /* 106281 */     GIR_EraseRootFromParent_Done,
     /* 106282 */   // Label 1994: @106282
     /* 106282 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(106322), // Rule ID 4131 //
     /* 106287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106301 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106320 */     GIR_RootConstrainSelectedInstOperands,
     /* 106321 */     // GIR_Coverage, 4131,
     /* 106321 */     GIR_EraseRootFromParent_Done,
     /* 106322 */   // Label 1995: @106322
     /* 106322 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(106362), // Rule ID 4157 //
     /* 106327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106341 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106360 */     GIR_RootConstrainSelectedInstOperands,
     /* 106361 */     // GIR_Coverage, 4157,
     /* 106361 */     GIR_EraseRootFromParent_Done,
     /* 106362 */   // Label 1996: @106362
     /* 106362 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(106402), // Rule ID 4159 //
     /* 106367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106381 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106400 */     GIR_RootConstrainSelectedInstOperands,
     /* 106401 */     // GIR_Coverage, 4159,
     /* 106401 */     GIR_EraseRootFromParent_Done,
     /* 106402 */   // Label 1997: @106402
     /* 106402 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(106422), // Rule ID 6362 //
     /* 106407 */     // MIs[0] Rn
     /* 106407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106415 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 106420 */     GIR_RootConstrainSelectedInstOperands,
     /* 106421 */     // GIR_Coverage, 6362,
     /* 106421 */     GIR_Done,
     /* 106422 */   // Label 1998: @106422
     /* 106422 */   GIM_Reject,
     /* 106423 */ // Label 1989: @106423
     /* 106423 */ GIM_Reject,
     /* 106424 */ // Label 1832: @106424
     /* 106424 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(106631),
     /* 106429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106440 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(106485), // Rule ID 4092 //
     /* 106445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106459 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106483 */     GIR_RootConstrainSelectedInstOperands,
     /* 106484 */     // GIR_Coverage, 4092,
     /* 106484 */     GIR_EraseRootFromParent_Done,
     /* 106485 */   // Label 2000: @106485
     /* 106485 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(106530), // Rule ID 4093 //
     /* 106490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106504 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106528 */     GIR_RootConstrainSelectedInstOperands,
     /* 106529 */     // GIR_Coverage, 4093,
     /* 106529 */     GIR_EraseRootFromParent_Done,
     /* 106530 */   // Label 2001: @106530
     /* 106530 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(106570), // Rule ID 4127 //
     /* 106535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106549 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106568 */     GIR_RootConstrainSelectedInstOperands,
     /* 106569 */     // GIR_Coverage, 4127,
     /* 106569 */     GIR_EraseRootFromParent_Done,
     /* 106570 */   // Label 2002: @106570
     /* 106570 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(106610), // Rule ID 4158 //
     /* 106575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106589 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106608 */     GIR_RootConstrainSelectedInstOperands,
     /* 106609 */     // GIR_Coverage, 4158,
     /* 106609 */     GIR_EraseRootFromParent_Done,
     /* 106610 */   // Label 2003: @106610
     /* 106610 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(106630), // Rule ID 6361 //
     /* 106615 */     // MIs[0] Rn
     /* 106615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106623 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 106628 */     GIR_RootConstrainSelectedInstOperands,
     /* 106629 */     // GIR_Coverage, 6361,
     /* 106629 */     GIR_Done,
     /* 106630 */   // Label 2004: @106630
     /* 106630 */   GIM_Reject,
     /* 106631 */ // Label 1999: @106631
     /* 106631 */ GIM_Reject,
     /* 106632 */ // Label 1833: @106632
     /* 106632 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(106695), // Rule ID 10887 //
     /* 106637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106640 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106651 */   // MIs[0] base
     /* 106651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106659 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106671 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 106679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106684 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106693 */   GIR_RootConstrainSelectedInstOperands,
     /* 106694 */   // GIR_Coverage, 10887,
     /* 106694 */   GIR_EraseRootFromParent_Done,
     /* 106695 */ // Label 2005: @106695
     /* 106695 */ GIM_Reject,
     /* 106696 */ // Label 1834: @106696
     /* 106696 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(106759), // Rule ID 10893 //
     /* 106701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106704 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106707 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106715 */   // MIs[0] base
     /* 106715 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106723 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106735 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106738 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 106743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106748 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106753 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106757 */   GIR_RootConstrainSelectedInstOperands,
     /* 106758 */   // GIR_Coverage, 10893,
     /* 106758 */   GIR_EraseRootFromParent_Done,
     /* 106759 */ // Label 2006: @106759
     /* 106759 */ GIM_Reject,
     /* 106760 */ // Label 1835: @106760
     /* 106760 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(106933),
     /* 106765 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106776 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106780 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(106828), // Rule ID 10878 //
     /* 106785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106792 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106817 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106826 */     GIR_RootConstrainSelectedInstOperands,
     /* 106827 */     // GIR_Coverage, 10878,
     /* 106827 */     GIR_EraseRootFromParent_Done,
     /* 106828 */   // Label 2008: @106828
     /* 106828 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106876), // Rule ID 10896 //
     /* 106833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106840 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 106847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106852 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 106860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106865 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106874 */     GIR_RootConstrainSelectedInstOperands,
     /* 106875 */     // GIR_Coverage, 10896,
     /* 106875 */     GIR_EraseRootFromParent_Done,
     /* 106876 */   // Label 2009: @106876
     /* 106876 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(106904), // Rule ID 10923 //
     /* 106881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106888 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106893 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106902 */     GIR_RootConstrainSelectedInstOperands,
     /* 106903 */     // GIR_Coverage, 10923,
     /* 106903 */     GIR_EraseRootFromParent_Done,
     /* 106904 */   // Label 2010: @106904
     /* 106904 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(106932), // Rule ID 10935 //
     /* 106909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 106912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106916 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 106919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106921 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106930 */     GIR_RootConstrainSelectedInstOperands,
     /* 106931 */     // GIR_Coverage, 10935,
     /* 106931 */     GIR_EraseRootFromParent_Done,
     /* 106932 */   // Label 2011: @106932
     /* 106932 */   GIM_Reject,
     /* 106933 */ // Label 2007: @106933
     /* 106933 */ GIM_Reject,
     /* 106934 */ // Label 1836: @106934
     /* 106934 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(106997), // Rule ID 10884 //
     /* 106939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106945 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106953 */   // MIs[0] base
     /* 106953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106961 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 106961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 106964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 106968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106973 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 106976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 106981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 106983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106986 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 106988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 106991 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106995 */   GIR_RootConstrainSelectedInstOperands,
     /* 106996 */   // GIR_Coverage, 10884,
     /* 106996 */   GIR_EraseRootFromParent_Done,
     /* 106997 */ // Label 2012: @106997
     /* 106997 */ GIM_Reject,
     /* 106998 */ // Label 1837: @106998
     /* 106998 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107171),
     /* 107003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107018 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107066), // Rule ID 10866 //
     /* 107023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107030 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107055 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107064 */     GIR_RootConstrainSelectedInstOperands,
     /* 107065 */     // GIR_Coverage, 10866,
     /* 107065 */     GIR_EraseRootFromParent_Done,
     /* 107066 */   // Label 2014: @107066
     /* 107066 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107114), // Rule ID 10890 //
     /* 107071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107078 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107103 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107112 */     GIR_RootConstrainSelectedInstOperands,
     /* 107113 */     // GIR_Coverage, 10890,
     /* 107113 */     GIR_EraseRootFromParent_Done,
     /* 107114 */   // Label 2015: @107114
     /* 107114 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107142), // Rule ID 10919 //
     /* 107119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107126 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107131 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107140 */     GIR_RootConstrainSelectedInstOperands,
     /* 107141 */     // GIR_Coverage, 10919,
     /* 107141 */     GIR_EraseRootFromParent_Done,
     /* 107142 */   // Label 2016: @107142
     /* 107142 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107170), // Rule ID 10931 //
     /* 107147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107154 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107159 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107168 */     GIR_RootConstrainSelectedInstOperands,
     /* 107169 */     // GIR_Coverage, 10931,
     /* 107169 */     GIR_EraseRootFromParent_Done,
     /* 107170 */   // Label 2017: @107170
     /* 107170 */   GIM_Reject,
     /* 107171 */ // Label 2013: @107171
     /* 107171 */ GIM_Reject,
     /* 107172 */ // Label 1838: @107172
     /* 107172 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107345),
     /* 107177 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107188 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107192 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107240), // Rule ID 10845 //
     /* 107197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107204 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107229 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107238 */     GIR_RootConstrainSelectedInstOperands,
     /* 107239 */     // GIR_Coverage, 10845,
     /* 107239 */     GIR_EraseRootFromParent_Done,
     /* 107240 */   // Label 2019: @107240
     /* 107240 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107288), // Rule ID 10881 //
     /* 107245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107252 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107264 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107277 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107286 */     GIR_RootConstrainSelectedInstOperands,
     /* 107287 */     // GIR_Coverage, 10881,
     /* 107287 */     GIR_EraseRootFromParent_Done,
     /* 107288 */   // Label 2020: @107288
     /* 107288 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107316), // Rule ID 10915 //
     /* 107293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107300 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107305 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107314 */     GIR_RootConstrainSelectedInstOperands,
     /* 107315 */     // GIR_Coverage, 10915,
     /* 107315 */     GIR_EraseRootFromParent_Done,
     /* 107316 */   // Label 2021: @107316
     /* 107316 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107344), // Rule ID 10927 //
     /* 107321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107328 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107333 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107342 */     GIR_RootConstrainSelectedInstOperands,
     /* 107343 */     // GIR_Coverage, 10927,
     /* 107343 */     GIR_EraseRootFromParent_Done,
     /* 107344 */   // Label 2022: @107344
     /* 107344 */   GIM_Reject,
     /* 107345 */ // Label 2018: @107345
     /* 107345 */ GIM_Reject,
     /* 107346 */ // Label 1839: @107346
     /* 107346 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107389), // Rule ID 2428 //
     /* 107351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 107365 */   // MIs[0] base
     /* 107365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107373 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 107376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 107378 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107387 */   GIR_RootConstrainSelectedInstOperands,
     /* 107388 */   // GIR_Coverage, 2428,
     /* 107388 */   GIR_EraseRootFromParent_Done,
     /* 107389 */ // Label 2023: @107389
     /* 107389 */ GIM_Reject,
     /* 107390 */ // Label 1840: @107390
     /* 107390 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107487),
     /* 107395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107410 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107458), // Rule ID 10813 //
     /* 107415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107422 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 107429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107434 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 107442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107447 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107456 */     GIR_RootConstrainSelectedInstOperands,
     /* 107457 */     // GIR_Coverage, 10813,
     /* 107457 */     GIR_EraseRootFromParent_Done,
     /* 107458 */   // Label 2025: @107458
     /* 107458 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107486), // Rule ID 10911 //
     /* 107463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107470 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107475 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107484 */     GIR_RootConstrainSelectedInstOperands,
     /* 107485 */     // GIR_Coverage, 10911,
     /* 107485 */     GIR_EraseRootFromParent_Done,
     /* 107486 */   // Label 2026: @107486
     /* 107486 */   GIM_Reject,
     /* 107487 */ // Label 2024: @107487
     /* 107487 */ GIM_Reject,
     /* 107488 */ // Label 1841: @107488
     /* 107488 */ GIM_Reject,
     /* 107489 */ // Label 17: @107489
     /* 107489 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2029*/ GIMT_Encode4(108538),
     /* 107500 */ /*GILLT_s32*//*Label 2027*/ GIMT_Encode4(107508),
     /* 107504 */ /*GILLT_s64*//*Label 2028*/ GIMT_Encode4(107922),
     /* 107508 */ // Label 2027: @107508
     /* 107508 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107921),
     /* 107513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107516 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107569), // Rule ID 247 //
     /* 107521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107543 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 107546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107567 */     GIR_RootConstrainSelectedInstOperands,
     /* 107568 */     // GIR_Coverage, 247,
     /* 107568 */     GIR_EraseRootFromParent_Done,
     /* 107569 */   // Label 2031: @107569
     /* 107569 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107622), // Rule ID 248 //
     /* 107574 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 107596 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 107596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 107599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107620 */     GIR_RootConstrainSelectedInstOperands,
     /* 107621 */     // GIR_Coverage, 248,
     /* 107621 */     GIR_EraseRootFromParent_Done,
     /* 107622 */   // Label 2032: @107622
     /* 107622 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107675), // Rule ID 251 //
     /* 107627 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 107649 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 107649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 107652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107673 */     GIR_RootConstrainSelectedInstOperands,
     /* 107674 */     // GIR_Coverage, 251,
     /* 107674 */     GIR_EraseRootFromParent_Done,
     /* 107675 */   // Label 2033: @107675
     /* 107675 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107728), // Rule ID 252 //
     /* 107680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 107702 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 107702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 107705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107726 */     GIR_RootConstrainSelectedInstOperands,
     /* 107727 */     // GIR_Coverage, 252,
     /* 107727 */     GIR_EraseRootFromParent_Done,
     /* 107728 */   // Label 2034: @107728
     /* 107728 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(107776), // Rule ID 268 //
     /* 107733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 107755 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 107755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 107758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107774 */     GIR_RootConstrainSelectedInstOperands,
     /* 107775 */     // GIR_Coverage, 268,
     /* 107775 */     GIR_EraseRootFromParent_Done,
     /* 107776 */   // Label 2035: @107776
     /* 107776 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(107824), // Rule ID 270 //
     /* 107781 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 107803 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 107803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 107806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107822 */     GIR_RootConstrainSelectedInstOperands,
     /* 107823 */     // GIR_Coverage, 270,
     /* 107823 */     GIR_EraseRootFromParent_Done,
     /* 107824 */   // Label 2036: @107824
     /* 107824 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(107872), // Rule ID 289 //
     /* 107829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107840 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 107851 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 107854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107870 */     GIR_RootConstrainSelectedInstOperands,
     /* 107871 */     // GIR_Coverage, 289,
     /* 107871 */     GIR_EraseRootFromParent_Done,
     /* 107872 */   // Label 2037: @107872
     /* 107872 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(107920), // Rule ID 291 //
     /* 107877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 107884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 107888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 107899 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 107899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 107902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107918 */     GIR_RootConstrainSelectedInstOperands,
     /* 107919 */     // GIR_Coverage, 291,
     /* 107919 */     GIR_EraseRootFromParent_Done,
     /* 107920 */   // Label 2038: @107920
     /* 107920 */   GIM_Reject,
     /* 107921 */ // Label 2030: @107921
     /* 107921 */ GIM_Reject,
     /* 107922 */ // Label 2028: @107922
     /* 107922 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108537),
     /* 107927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107930 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(107983), // Rule ID 249 //
     /* 107935 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 107957 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 107957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 107960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107981 */     GIR_RootConstrainSelectedInstOperands,
     /* 107982 */     // GIR_Coverage, 249,
     /* 107982 */     GIR_EraseRootFromParent_Done,
     /* 107983 */   // Label 2040: @107983
     /* 107983 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108036), // Rule ID 250 //
     /* 107988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 107995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108010 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 108013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108034 */     GIR_RootConstrainSelectedInstOperands,
     /* 108035 */     // GIR_Coverage, 250,
     /* 108035 */     GIR_EraseRootFromParent_Done,
     /* 108036 */   // Label 2041: @108036
     /* 108036 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(108089), // Rule ID 253 //
     /* 108041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108063 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 108066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108087 */     GIR_RootConstrainSelectedInstOperands,
     /* 108088 */     // GIR_Coverage, 253,
     /* 108088 */     GIR_EraseRootFromParent_Done,
     /* 108089 */   // Label 2042: @108089
     /* 108089 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(108142), // Rule ID 254 //
     /* 108094 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108116 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 108119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108140 */     GIR_RootConstrainSelectedInstOperands,
     /* 108141 */     // GIR_Coverage, 254,
     /* 108141 */     GIR_EraseRootFromParent_Done,
     /* 108142 */   // Label 2043: @108142
     /* 108142 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(108195), // Rule ID 255 //
     /* 108147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 108169 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 108169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 108172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108193 */     GIR_RootConstrainSelectedInstOperands,
     /* 108194 */     // GIR_Coverage, 255,
     /* 108194 */     GIR_EraseRootFromParent_Done,
     /* 108195 */   // Label 2044: @108195
     /* 108195 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108248), // Rule ID 256 //
     /* 108200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 108222 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 108222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 108225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108246 */     GIR_RootConstrainSelectedInstOperands,
     /* 108247 */     // GIR_Coverage, 256,
     /* 108247 */     GIR_EraseRootFromParent_Done,
     /* 108248 */   // Label 2045: @108248
     /* 108248 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(108296), // Rule ID 269 //
     /* 108253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108275 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 108278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108294 */     GIR_RootConstrainSelectedInstOperands,
     /* 108295 */     // GIR_Coverage, 269,
     /* 108295 */     GIR_EraseRootFromParent_Done,
     /* 108296 */   // Label 2046: @108296
     /* 108296 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(108344), // Rule ID 271 //
     /* 108301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108323 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 108326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108342 */     GIR_RootConstrainSelectedInstOperands,
     /* 108343 */     // GIR_Coverage, 271,
     /* 108343 */     GIR_EraseRootFromParent_Done,
     /* 108344 */   // Label 2047: @108344
     /* 108344 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(108392), // Rule ID 272 //
     /* 108349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 108371 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 108371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 108374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108390 */     GIR_RootConstrainSelectedInstOperands,
     /* 108391 */     // GIR_Coverage, 272,
     /* 108391 */     GIR_EraseRootFromParent_Done,
     /* 108392 */   // Label 2048: @108392
     /* 108392 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108440), // Rule ID 290 //
     /* 108397 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108419 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 108422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108438 */     GIR_RootConstrainSelectedInstOperands,
     /* 108439 */     // GIR_Coverage, 290,
     /* 108439 */     GIR_EraseRootFromParent_Done,
     /* 108440 */   // Label 2049: @108440
     /* 108440 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(108488), // Rule ID 292 //
     /* 108445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108467 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 108470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108486 */     GIR_RootConstrainSelectedInstOperands,
     /* 108487 */     // GIR_Coverage, 292,
     /* 108487 */     GIR_EraseRootFromParent_Done,
     /* 108488 */   // Label 2050: @108488
     /* 108488 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108536), // Rule ID 293 //
     /* 108493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 108515 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 108518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108534 */     GIR_RootConstrainSelectedInstOperands,
     /* 108535 */     // GIR_Coverage, 293,
     /* 108535 */     GIR_EraseRootFromParent_Done,
     /* 108536 */   // Label 2051: @108536
     /* 108536 */   GIM_Reject,
     /* 108537 */ // Label 2039: @108537
     /* 108537 */ GIM_Reject,
     /* 108538 */ // Label 2029: @108538
     /* 108538 */ GIM_Reject,
     /* 108539 */ // Label 18: @108539
     /* 108539 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2054*/ GIMT_Encode4(111507),
     /* 108550 */ /*GILLT_s32*//*Label 2052*/ GIMT_Encode4(108558),
     /* 108554 */ /*GILLT_s64*//*Label 2053*/ GIMT_Encode4(110017),
     /* 108558 */ // Label 2052: @108558
     /* 108558 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(108614), // Rule ID 229 //
     /* 108563 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108566 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108577 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108581 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108588 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108598 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108612 */   GIR_RootConstrainSelectedInstOperands,
     /* 108613 */   // GIR_Coverage, 229,
     /* 108613 */   GIR_EraseRootFromParent_Done,
     /* 108614 */ // Label 2055: @108614
     /* 108614 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(108670), // Rule ID 230 //
     /* 108619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108622 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108633 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108637 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108644 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108668 */   GIR_RootConstrainSelectedInstOperands,
     /* 108669 */   // GIR_Coverage, 230,
     /* 108669 */   GIR_EraseRootFromParent_Done,
     /* 108670 */ // Label 2056: @108670
     /* 108670 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(108726), // Rule ID 231 //
     /* 108675 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108678 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108700 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 108703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108724 */   GIR_RootConstrainSelectedInstOperands,
     /* 108725 */   // GIR_Coverage, 231,
     /* 108725 */   GIR_EraseRootFromParent_Done,
     /* 108726 */ // Label 2057: @108726
     /* 108726 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(108782), // Rule ID 232 //
     /* 108731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108745 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108749 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108756 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 108759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108780 */   GIR_RootConstrainSelectedInstOperands,
     /* 108781 */   // GIR_Coverage, 232,
     /* 108781 */   GIR_EraseRootFromParent_Done,
     /* 108782 */ // Label 2058: @108782
     /* 108782 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(108838), // Rule ID 4116 //
     /* 108787 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108790 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108812 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 108815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108836 */   GIR_RootConstrainSelectedInstOperands,
     /* 108837 */   // GIR_Coverage, 4116,
     /* 108837 */   GIR_EraseRootFromParent_Done,
     /* 108838 */ // Label 2059: @108838
     /* 108838 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(108894), // Rule ID 4117 //
     /* 108843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108868 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 108871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108892 */   GIR_RootConstrainSelectedInstOperands,
     /* 108893 */   // GIR_Coverage, 4117,
     /* 108893 */   GIR_EraseRootFromParent_Done,
     /* 108894 */ // Label 2060: @108894
     /* 108894 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(108945), // Rule ID 266 //
     /* 108899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108902 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108924 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 108927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108939 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108943 */   GIR_RootConstrainSelectedInstOperands,
     /* 108944 */   // GIR_Coverage, 266,
     /* 108944 */   GIR_EraseRootFromParent_Done,
     /* 108945 */ // Label 2061: @108945
     /* 108945 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(108996), // Rule ID 267 //
     /* 108950 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108953 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108968 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108975 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 108978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108990 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108994 */   GIR_RootConstrainSelectedInstOperands,
     /* 108995 */   // GIR_Coverage, 267,
     /* 108995 */   GIR_EraseRootFromParent_Done,
     /* 108996 */ // Label 2062: @108996
     /* 108996 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109055), // Rule ID 6994 //
     /* 109001 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109004 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109011 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109029 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15801>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 109029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109053 */   GIR_RootConstrainSelectedInstOperands,
     /* 109054 */   // GIR_Coverage, 6994,
     /* 109054 */   GIR_EraseRootFromParent_Done,
     /* 109055 */ // Label 2063: @109055
     /* 109055 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109114), // Rule ID 6996 //
     /* 109060 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109063 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109070 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109077 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109081 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109088 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15801>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 109088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109108 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109112 */   GIR_RootConstrainSelectedInstOperands,
     /* 109113 */   // GIR_Coverage, 6996,
     /* 109113 */   GIR_EraseRootFromParent_Done,
     /* 109114 */ // Label 2064: @109114
     /* 109114 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109173), // Rule ID 7006 //
     /* 109119 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109129 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109136 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109140 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109147 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15810>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109157 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109162 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109167 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109171 */   GIR_RootConstrainSelectedInstOperands,
     /* 109172 */   // GIR_Coverage, 7006,
     /* 109172 */   GIR_EraseRootFromParent_Done,
     /* 109173 */ // Label 2065: @109173
     /* 109173 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109232), // Rule ID 7008 //
     /* 109178 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109181 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109188 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109195 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109199 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109206 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15810>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109226 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109230 */   GIR_RootConstrainSelectedInstOperands,
     /* 109231 */   // GIR_Coverage, 7008,
     /* 109231 */   GIR_EraseRootFromParent_Done,
     /* 109232 */ // Label 2066: @109232
     /* 109232 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(109283), // Rule ID 287 //
     /* 109237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109240 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109255 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109262 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109281 */   GIR_RootConstrainSelectedInstOperands,
     /* 109282 */   // GIR_Coverage, 287,
     /* 109282 */   GIR_EraseRootFromParent_Done,
     /* 109283 */ // Label 2067: @109283
     /* 109283 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(109334), // Rule ID 288 //
     /* 109288 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109306 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109313 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109332 */   GIR_RootConstrainSelectedInstOperands,
     /* 109333 */   // GIR_Coverage, 288,
     /* 109333 */   GIR_EraseRootFromParent_Done,
     /* 109334 */ // Label 2068: @109334
     /* 109334 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(109385), // Rule ID 4135 //
     /* 109339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109342 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109353 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109357 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109364 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109379 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109383 */   GIR_RootConstrainSelectedInstOperands,
     /* 109384 */   // GIR_Coverage, 4135,
     /* 109384 */   GIR_EraseRootFromParent_Done,
     /* 109385 */ // Label 2069: @109385
     /* 109385 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(109436), // Rule ID 4167 //
     /* 109390 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109393 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109404 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109408 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109415 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109420 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109430 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109434 */   GIR_RootConstrainSelectedInstOperands,
     /* 109435 */   // GIR_Coverage, 4167,
     /* 109435 */   GIR_EraseRootFromParent_Done,
     /* 109436 */ // Label 2070: @109436
     /* 109436 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(109487), // Rule ID 4168 //
     /* 109441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109444 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109455 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109459 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109466 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109485 */   GIR_RootConstrainSelectedInstOperands,
     /* 109486 */   // GIR_Coverage, 4168,
     /* 109486 */   GIR_EraseRootFromParent_Done,
     /* 109487 */ // Label 2071: @109487
     /* 109487 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(109538), // Rule ID 4169 //
     /* 109492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109495 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109510 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109517 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109536 */   GIR_RootConstrainSelectedInstOperands,
     /* 109537 */   // GIR_Coverage, 4169,
     /* 109537 */   GIR_EraseRootFromParent_Done,
     /* 109538 */ // Label 2072: @109538
     /* 109538 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(109592), // Rule ID 6998 //
     /* 109543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109546 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109553 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109571 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15801>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109590 */   GIR_RootConstrainSelectedInstOperands,
     /* 109591 */   // GIR_Coverage, 6998,
     /* 109591 */   GIR_EraseRootFromParent_Done,
     /* 109592 */ // Label 2073: @109592
     /* 109592 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(109646), // Rule ID 7000 //
     /* 109597 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109600 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109607 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109614 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109618 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109625 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15801>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109644 */   GIR_RootConstrainSelectedInstOperands,
     /* 109645 */   // GIR_Coverage, 7000,
     /* 109645 */   GIR_EraseRootFromParent_Done,
     /* 109646 */ // Label 2074: @109646
     /* 109646 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(109700), // Rule ID 7010 //
     /* 109651 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109654 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109661 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109679 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15810>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 109682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109694 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109698 */   GIR_RootConstrainSelectedInstOperands,
     /* 109699 */   // GIR_Coverage, 7010,
     /* 109699 */   GIR_EraseRootFromParent_Done,
     /* 109700 */ // Label 2075: @109700
     /* 109700 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(109754), // Rule ID 7012 //
     /* 109705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109715 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109726 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109733 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15810>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109748 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109752 */   GIR_RootConstrainSelectedInstOperands,
     /* 109753 */   // GIR_Coverage, 7012,
     /* 109753 */   GIR_EraseRootFromParent_Done,
     /* 109754 */ // Label 2076: @109754
     /* 109754 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(109811), // Rule ID 7374 //
     /* 109759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109762 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109765 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109790 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15799>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 109793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109809 */   GIR_RootConstrainSelectedInstOperands,
     /* 109810 */   // GIR_Coverage, 7374,
     /* 109810 */   GIR_EraseRootFromParent_Done,
     /* 109811 */ // Label 2077: @109811
     /* 109811 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(109868), // Rule ID 7376 //
     /* 109816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 109819 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109822 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109836 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109840 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109847 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15808>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 109850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109862 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109866 */   GIR_RootConstrainSelectedInstOperands,
     /* 109867 */   // GIR_Coverage, 7376,
     /* 109867 */   GIR_EraseRootFromParent_Done,
     /* 109868 */ // Label 2078: @109868
     /* 109868 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(109905), // Rule ID 6990 //
     /* 109873 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109876 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 109886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109890 */   // MIs[0] ptr
     /* 109890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109898 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15797>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109903 */   GIR_RootConstrainSelectedInstOperands,
     /* 109904 */   // GIR_Coverage, 6990,
     /* 109904 */   GIR_Done,
     /* 109905 */ // Label 2079: @109905
     /* 109905 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(109942), // Rule ID 6992 //
     /* 109910 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109920 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109927 */   // MIs[0] ptr
     /* 109927 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109935 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15799>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 109940 */   GIR_RootConstrainSelectedInstOperands,
     /* 109941 */   // GIR_Coverage, 6992,
     /* 109941 */   GIR_Done,
     /* 109942 */ // Label 2080: @109942
     /* 109942 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(109979), // Rule ID 7002 //
     /* 109947 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109950 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 109960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109964 */   // MIs[0] ptr
     /* 109964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 109968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 109972 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15806>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 109972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 109977 */   GIR_RootConstrainSelectedInstOperands,
     /* 109978 */   // GIR_Coverage, 7002,
     /* 109978 */   GIR_Done,
     /* 109979 */ // Label 2081: @109979
     /* 109979 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110016), // Rule ID 7004 //
     /* 109984 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109987 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109994 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110001 */   // MIs[0] ptr
     /* 110001 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110009 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15808>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110014 */   GIR_RootConstrainSelectedInstOperands,
     /* 110015 */   // GIR_Coverage, 7004,
     /* 110015 */   GIR_Done,
     /* 110016 */ // Label 2082: @110016
     /* 110016 */ GIM_Reject,
     /* 110017 */ // Label 2053: @110017
     /* 110017 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(111506),
     /* 110022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110025 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110110), // Rule ID 4094 //
     /* 110030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110052 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110079 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110109 */     // GIR_Coverage, 4094,
     /* 110109 */     GIR_EraseRootFromParent_Done,
     /* 110110 */   // Label 2084: @110110
     /* 110110 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110195), // Rule ID 4095 //
     /* 110115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 110137 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 110144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110164 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110194 */     // GIR_Coverage, 4095,
     /* 110194 */     GIR_EraseRootFromParent_Done,
     /* 110195 */   // Label 2085: @110195
     /* 110195 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110280), // Rule ID 4096 //
     /* 110200 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 110222 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 110229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110249 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110279 */     // GIR_Coverage, 4096,
     /* 110279 */     GIR_EraseRootFromParent_Done,
     /* 110280 */   // Label 2086: @110280
     /* 110280 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110365), // Rule ID 4097 //
     /* 110285 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 110307 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 110314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110334 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110364 */     // GIR_Coverage, 4097,
     /* 110364 */     GIR_EraseRootFromParent_Done,
     /* 110365 */   // Label 2087: @110365
     /* 110365 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110450), // Rule ID 4098 //
     /* 110370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110392 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 110399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110419 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110449 */     // GIR_Coverage, 4098,
     /* 110449 */     GIR_EraseRootFromParent_Done,
     /* 110450 */   // Label 2088: @110450
     /* 110450 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110535), // Rule ID 4099 //
     /* 110455 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 110477 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 110484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110504 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110534 */     // GIR_Coverage, 4099,
     /* 110534 */     GIR_EraseRootFromParent_Done,
     /* 110535 */   // Label 2089: @110535
     /* 110535 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110620), // Rule ID 4100 //
     /* 110540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110562 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110589 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110619 */     // GIR_Coverage, 4100,
     /* 110619 */     GIR_EraseRootFromParent_Done,
     /* 110620 */   // Label 2090: @110620
     /* 110620 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110705), // Rule ID 4101 //
     /* 110625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 110647 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 110654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110674 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110704 */     // GIR_Coverage, 4101,
     /* 110704 */     GIR_EraseRootFromParent_Done,
     /* 110705 */   // Label 2091: @110705
     /* 110705 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(110785), // Rule ID 4133 //
     /* 110710 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110732 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110754 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110784 */     // GIR_Coverage, 4133,
     /* 110784 */     GIR_EraseRootFromParent_Done,
     /* 110785 */   // Label 2092: @110785
     /* 110785 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(110865), // Rule ID 4134 //
     /* 110790 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110812 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110834 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110864 */     // GIR_Coverage, 4134,
     /* 110864 */     GIR_EraseRootFromParent_Done,
     /* 110865 */   // Label 2093: @110865
     /* 110865 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(110945), // Rule ID 4136 //
     /* 110870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110892 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110914 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110944 */     // GIR_Coverage, 4136,
     /* 110944 */     GIR_EraseRootFromParent_Done,
     /* 110945 */   // Label 2094: @110945
     /* 110945 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111025), // Rule ID 4144 //
     /* 110950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 110972 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 110972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 110979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111024 */     // GIR_Coverage, 4144,
     /* 111024 */     GIR_EraseRootFromParent_Done,
     /* 111025 */   // Label 2095: @111025
     /* 111025 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111105), // Rule ID 4170 //
     /* 111030 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 111052 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 111059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111074 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111104 */     // GIR_Coverage, 4170,
     /* 111104 */     GIR_EraseRootFromParent_Done,
     /* 111105 */   // Label 2096: @111105
     /* 111105 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111185), // Rule ID 4171 //
     /* 111110 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111132 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111154 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111184 */     // GIR_Coverage, 4171,
     /* 111184 */     GIR_EraseRootFromParent_Done,
     /* 111185 */   // Label 2097: @111185
     /* 111185 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111265), // Rule ID 4172 //
     /* 111190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111212 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111264 */     // GIR_Coverage, 4172,
     /* 111264 */     GIR_EraseRootFromParent_Done,
     /* 111265 */   // Label 2098: @111265
     /* 111265 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111345), // Rule ID 4173 //
     /* 111270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111292 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111344 */     // GIR_Coverage, 4173,
     /* 111344 */     GIR_EraseRootFromParent_Done,
     /* 111345 */   // Label 2099: @111345
     /* 111345 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(111425), // Rule ID 4174 //
     /* 111350 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111372 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111394 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111424 */     // GIR_Coverage, 4174,
     /* 111424 */     GIR_EraseRootFromParent_Done,
     /* 111425 */   // Label 2100: @111425
     /* 111425 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111505), // Rule ID 4175 //
     /* 111430 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111452 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111474 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111504 */     // GIR_Coverage, 4175,
     /* 111504 */     GIR_EraseRootFromParent_Done,
     /* 111505 */   // Label 2101: @111505
     /* 111505 */   GIM_Reject,
     /* 111506 */ // Label 2083: @111506
     /* 111506 */ GIM_Reject,
     /* 111507 */ // Label 2054: @111507
     /* 111507 */ GIM_Reject,
     /* 111508 */ // Label 19: @111508
     /* 111508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2122*/ GIMT_Encode4(125033),
     /* 111519 */ /*GILLT_s8*//*Label 2102*/ GIMT_Encode4(111615),
     /* 111523 */ /*GILLT_s16*//*Label 2103*/ GIMT_Encode4(111982),
     /* 111527 */ /*GILLT_s32*//*Label 2104*/ GIMT_Encode4(113121),
     /* 111531 */ /*GILLT_s64*//*Label 2105*/ GIMT_Encode4(117716),
     /* 111535 */ /*GILLT_s128*//*Label 2106*/ GIMT_Encode4(121485),
     /* 111539 */ /*GILLT_v2s32*//*Label 2107*/ GIMT_Encode4(121691),
     /* 111543 */ /*GILLT_v2s64*//*Label 2108*/ GIMT_Encode4(122097),
     /* 111547 */ /*GILLT_v4s16*//*Label 2109*/ GIMT_Encode4(122547),
     /* 111551 */ /*GILLT_v4s32*//*Label 2110*/ GIMT_Encode4(122953),
     /* 111555 */ /*GILLT_v8s8*//*Label 2111*/ GIMT_Encode4(123359),
     /* 111559 */ /*GILLT_v8s16*//*Label 2112*/ GIMT_Encode4(123579),
     /* 111563 */ /*GILLT_v16s8*//*Label 2113*/ GIMT_Encode4(123985), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111575 */ /*GILLT_nxv2s16*//*Label 2114*/ GIMT_Encode4(124205),
     /* 111579 */ /*GILLT_nxv2s32*//*Label 2115*/ GIMT_Encode4(124265),
     /* 111583 */ /*GILLT_nxv2s64*//*Label 2116*/ GIMT_Encode4(124325), GIMT_Encode4(0),
     /* 111591 */ /*GILLT_nxv4s16*//*Label 2117*/ GIMT_Encode4(124495),
     /* 111595 */ /*GILLT_nxv4s32*//*Label 2118*/ GIMT_Encode4(124555), GIMT_Encode4(0),
     /* 111603 */ /*GILLT_nxv8s16*//*Label 2119*/ GIMT_Encode4(124725),
     /* 111607 */ /*GILLT_nxv16s1*//*Label 2120*/ GIMT_Encode4(124895),
     /* 111611 */ /*GILLT_nxv16s8*//*Label 2121*/ GIMT_Encode4(124939),
     /* 111615 */ // Label 2102: @111615
     /* 111615 */ GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111981),
     /* 111620 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111623 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111627 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111695), // Rule ID 13114 //
     /* 111632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111661 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111665 */     // MIs[2] Operand 1
     /* 111665 */     // No operand predicates
     /* 111665 */     // MIs[0] Rn
     /* 111665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111675 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111693 */     GIR_RootConstrainSelectedInstOperands,
     /* 111694 */     // GIR_Coverage, 13114,
     /* 111694 */     GIR_EraseRootFromParent_Done,
     /* 111695 */   // Label 2124: @111695
     /* 111695 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111794), // Rule ID 13115 //
     /* 111700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 111704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 111708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 111725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 111729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 111733 */     // MIs[2] Operand 1
     /* 111733 */     // No operand predicates
     /* 111733 */     // MIs[0] Rn
     /* 111733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 111737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 111741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111743 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 111743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 111758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 111762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 111765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 111778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 111784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 111786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 111792 */     GIR_RootConstrainSelectedInstOperands,
     /* 111793 */     // GIR_Coverage, 13115,
     /* 111793 */     GIR_EraseRootFromParent_Done,
     /* 111794 */   // Label 2125: @111794
     /* 111794 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(111843), // Rule ID 303 //
     /* 111799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111817 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 111817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 111820 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111841 */     GIR_RootConstrainSelectedInstOperands,
     /* 111842 */     // GIR_Coverage, 303,
     /* 111842 */     GIR_EraseRootFromParent_Done,
     /* 111843 */   // Label 2126: @111843
     /* 111843 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(111892), // Rule ID 304 //
     /* 111848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111866 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 111866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 111869 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111890 */     GIR_RootConstrainSelectedInstOperands,
     /* 111891 */     // GIR_Coverage, 304,
     /* 111891 */     GIR_EraseRootFromParent_Done,
     /* 111892 */   // Label 2127: @111892
     /* 111892 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(111936), // Rule ID 313 //
     /* 111897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111915 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 111915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 111918 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111934 */     GIR_RootConstrainSelectedInstOperands,
     /* 111935 */     // GIR_Coverage, 313,
     /* 111935 */     GIR_EraseRootFromParent_Done,
     /* 111936 */   // Label 2128: @111936
     /* 111936 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(111980), // Rule ID 321 //
     /* 111941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 111944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 111948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111959 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 111959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 111962 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 111964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111978 */     GIR_RootConstrainSelectedInstOperands,
     /* 111979 */     // GIR_Coverage, 321,
     /* 111979 */     GIR_EraseRootFromParent_Done,
     /* 111980 */   // Label 2129: @111980
     /* 111980 */   GIM_Reject,
     /* 111981 */ // Label 2123: @111981
     /* 111981 */ GIM_Reject,
     /* 111982 */ // Label 2103: @111982
     /* 111982 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(113120),
     /* 111987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 111990 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 111994 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112093), // Rule ID 4472 //
     /* 111999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112020 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112037 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112049 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112091 */     GIR_RootConstrainSelectedInstOperands,
     /* 112092 */     // GIR_Coverage, 4472,
     /* 112092 */     GIR_EraseRootFromParent_Done,
     /* 112093 */   // Label 2131: @112093
     /* 112093 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112192), // Rule ID 4473 //
     /* 112098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112136 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112148 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112190 */     GIR_RootConstrainSelectedInstOperands,
     /* 112191 */     // GIR_Coverage, 4473,
     /* 112191 */     GIR_EraseRootFromParent_Done,
     /* 112192 */   // Label 2132: @112192
     /* 112192 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112291), // Rule ID 13112 //
     /* 112197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112218 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112235 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112247 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112289 */     GIR_RootConstrainSelectedInstOperands,
     /* 112290 */     // GIR_Coverage, 13112,
     /* 112290 */     GIR_EraseRootFromParent_Done,
     /* 112291 */   // Label 2133: @112291
     /* 112291 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112390), // Rule ID 13113 //
     /* 112296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112317 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112334 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112346 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112388 */     GIR_RootConstrainSelectedInstOperands,
     /* 112389 */     // GIR_Coverage, 13113,
     /* 112389 */     GIR_EraseRootFromParent_Done,
     /* 112390 */   // Label 2134: @112390
     /* 112390 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112484), // Rule ID 4501 //
     /* 112395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112416 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112433 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 112464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112482 */     GIR_RootConstrainSelectedInstOperands,
     /* 112483 */     // GIR_Coverage, 4501,
     /* 112483 */     GIR_EraseRootFromParent_Done,
     /* 112484 */   // Label 2135: @112484
     /* 112484 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112578), // Rule ID 4526 //
     /* 112489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112510 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 112527 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 112527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112539 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112576 */     GIR_RootConstrainSelectedInstOperands,
     /* 112577 */     // GIR_Coverage, 4526,
     /* 112577 */     GIR_EraseRootFromParent_Done,
     /* 112578 */   // Label 2136: @112578
     /* 112578 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112672), // Rule ID 13111 //
     /* 112583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112604 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112621 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112633 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 112652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112670 */     GIR_RootConstrainSelectedInstOperands,
     /* 112671 */     // GIR_Coverage, 13111,
     /* 112671 */     GIR_EraseRootFromParent_Done,
     /* 112672 */   // Label 2137: @112672
     /* 112672 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(112766), // Rule ID 13117 //
     /* 112677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112698 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 112715 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 112715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112727 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 112746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112764 */     GIR_RootConstrainSelectedInstOperands,
     /* 112765 */     // GIR_Coverage, 13117,
     /* 112765 */     GIR_EraseRootFromParent_Done,
     /* 112766 */   // Label 2138: @112766
     /* 112766 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112834), // Rule ID 6428 //
     /* 112771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112800 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112804 */     // MIs[2] Operand 1
     /* 112804 */     // No operand predicates
     /* 112804 */     // MIs[0] Rn
     /* 112804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112814 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112832 */     GIR_RootConstrainSelectedInstOperands,
     /* 112833 */     // GIR_Coverage, 6428,
     /* 112833 */     GIR_EraseRootFromParent_Done,
     /* 112834 */   // Label 2139: @112834
     /* 112834 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112933), // Rule ID 6433 //
     /* 112839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 112872 */     // MIs[2] Operand 1
     /* 112872 */     // No operand predicates
     /* 112872 */     // MIs[0] Rn
     /* 112872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112882 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112894 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112897 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 112917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112931 */     GIR_RootConstrainSelectedInstOperands,
     /* 112932 */     // GIR_Coverage, 6433,
     /* 112932 */     GIR_EraseRootFromParent_Done,
     /* 112933 */   // Label 2140: @112933
     /* 112933 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112982), // Rule ID 305 //
     /* 112938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112956 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112959 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112980 */     GIR_RootConstrainSelectedInstOperands,
     /* 112981 */     // GIR_Coverage, 305,
     /* 112981 */     GIR_EraseRootFromParent_Done,
     /* 112982 */   // Label 2141: @112982
     /* 112982 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(113031), // Rule ID 306 //
     /* 112987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113005 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113008 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113029 */     GIR_RootConstrainSelectedInstOperands,
     /* 113030 */     // GIR_Coverage, 306,
     /* 113030 */     GIR_EraseRootFromParent_Done,
     /* 113031 */   // Label 2142: @113031
     /* 113031 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113075), // Rule ID 314 //
     /* 113036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113054 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113057 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113073 */     GIR_RootConstrainSelectedInstOperands,
     /* 113074 */     // GIR_Coverage, 314,
     /* 113074 */     GIR_EraseRootFromParent_Done,
     /* 113075 */   // Label 2143: @113075
     /* 113075 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113119), // Rule ID 322 //
     /* 113080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113098 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113101 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113117 */     GIR_RootConstrainSelectedInstOperands,
     /* 113118 */     // GIR_Coverage, 322,
     /* 113118 */     GIR_EraseRootFromParent_Done,
     /* 113119 */   // Label 2144: @113119
     /* 113119 */   GIM_Reject,
     /* 113120 */ // Label 2130: @113120
     /* 113120 */ GIM_Reject,
     /* 113121 */ // Label 2104: @113121
     /* 113121 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113234), // Rule ID 4470 //
     /* 113126 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113129 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113133 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113148 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113152 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113156 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113161 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113171 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113178 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113190 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113196 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113201 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113232 */   GIR_RootConstrainSelectedInstOperands,
     /* 113233 */   // GIR_Coverage, 4470,
     /* 113233 */   GIR_EraseRootFromParent_Done,
     /* 113234 */ // Label 2145: @113234
     /* 113234 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113347), // Rule ID 4471 //
     /* 113239 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113242 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113246 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113261 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113274 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113278 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113291 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113303 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113345 */   GIR_RootConstrainSelectedInstOperands,
     /* 113346 */   // GIR_Coverage, 4471,
     /* 113346 */   GIR_EraseRootFromParent_Done,
     /* 113347 */ // Label 2146: @113347
     /* 113347 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113453), // Rule ID 4474 //
     /* 113352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113355 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113371 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113375 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113380 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113384 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113388 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113397 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113409 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113446 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113451 */   GIR_RootConstrainSelectedInstOperands,
     /* 113452 */   // GIR_Coverage, 4474,
     /* 113452 */   GIR_EraseRootFromParent_Done,
     /* 113453 */ // Label 2147: @113453
     /* 113453 */ GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113559), // Rule ID 4475 //
     /* 113458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113461 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113465 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113469 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113473 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113477 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113481 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113486 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113496 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113503 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113515 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113521 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113526 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113557 */   GIR_RootConstrainSelectedInstOperands,
     /* 113558 */   // GIR_Coverage, 4475,
     /* 113558 */   GIR_EraseRootFromParent_Done,
     /* 113559 */ // Label 2148: @113559
     /* 113559 */ GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113665), // Rule ID 4476 //
     /* 113564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113567 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113579 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113583 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113587 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113592 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113609 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113621 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113632 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113663 */   GIR_RootConstrainSelectedInstOperands,
     /* 113664 */   // GIR_Coverage, 4476,
     /* 113664 */   GIR_EraseRootFromParent_Done,
     /* 113665 */ // Label 2149: @113665
     /* 113665 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113771), // Rule ID 4477 //
     /* 113670 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113673 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113685 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113698 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113702 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113708 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113715 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113727 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113738 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113769 */   GIR_RootConstrainSelectedInstOperands,
     /* 113770 */   // GIR_Coverage, 4477,
     /* 113770 */   GIR_EraseRootFromParent_Done,
     /* 113771 */ // Label 2150: @113771
     /* 113771 */ GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113877), // Rule ID 13119 //
     /* 113776 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113791 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113795 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113799 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113804 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113808 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113821 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113833 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113839 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113844 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113870 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113875 */   GIR_RootConstrainSelectedInstOperands,
     /* 113876 */   // GIR_Coverage, 13119,
     /* 113876 */   GIR_EraseRootFromParent_Done,
     /* 113877 */ // Label 2151: @113877
     /* 113877 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113983), // Rule ID 13120 //
     /* 113882 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113885 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113889 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113893 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113897 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113901 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113905 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113910 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 113927 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 113927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113939 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 113958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113981 */   GIR_RootConstrainSelectedInstOperands,
     /* 113982 */   // GIR_Coverage, 13120,
     /* 113982 */   GIR_EraseRootFromParent_Done,
     /* 113983 */ // Label 2152: @113983
     /* 113983 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(114091), // Rule ID 4500 //
     /* 113988 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113991 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113995 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114010 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114014 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114018 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114023 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114027 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114033 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 114040 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 114040 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114043 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114047 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114052 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114063 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 114071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114089 */   GIR_RootConstrainSelectedInstOperands,
     /* 114090 */   // GIR_Coverage, 4500,
     /* 114090 */   GIR_EraseRootFromParent_Done,
     /* 114091 */ // Label 2153: @114091
     /* 114091 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(114192), // Rule ID 4502 //
     /* 114096 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114099 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114111 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114115 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114119 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114124 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114134 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114141 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114153 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114164 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114180 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114185 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114190 */   GIR_RootConstrainSelectedInstOperands,
     /* 114191 */   // GIR_Coverage, 4502,
     /* 114191 */   GIR_EraseRootFromParent_Done,
     /* 114192 */ // Label 2154: @114192
     /* 114192 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(114293), // Rule ID 4503 //
     /* 114197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114200 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114212 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114216 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114220 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114225 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114229 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114235 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114242 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114254 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114260 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114265 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114276 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114291 */   GIR_RootConstrainSelectedInstOperands,
     /* 114292 */   // GIR_Coverage, 4503,
     /* 114292 */   GIR_EraseRootFromParent_Done,
     /* 114293 */ // Label 2155: @114293
     /* 114293 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114401), // Rule ID 4525 //
     /* 114298 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114301 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114305 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114320 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114324 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114333 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114350 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114362 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114368 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 114381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114399 */   GIR_RootConstrainSelectedInstOperands,
     /* 114400 */   // GIR_Coverage, 4525,
     /* 114400 */   GIR_EraseRootFromParent_Done,
     /* 114401 */ // Label 2156: @114401
     /* 114401 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(114502), // Rule ID 4527 //
     /* 114406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114429 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114434 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114438 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114451 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114463 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114469 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114474 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114500 */   GIR_RootConstrainSelectedInstOperands,
     /* 114501 */   // GIR_Coverage, 4527,
     /* 114501 */   GIR_EraseRootFromParent_Done,
     /* 114502 */ // Label 2157: @114502
     /* 114502 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114603), // Rule ID 4528 //
     /* 114507 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114510 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114522 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114526 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114530 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114535 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114552 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114552 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114555 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114559 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114564 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114570 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114575 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114601 */   GIR_RootConstrainSelectedInstOperands,
     /* 114602 */   // GIR_Coverage, 4528,
     /* 114602 */   GIR_EraseRootFromParent_Done,
     /* 114603 */ // Label 2158: @114603
     /* 114603 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(114704), // Rule ID 13116 //
     /* 114608 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114623 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114627 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114631 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114636 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114646 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114653 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114665 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114687 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114692 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114697 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114702 */   GIR_RootConstrainSelectedInstOperands,
     /* 114703 */   // GIR_Coverage, 13116,
     /* 114703 */   GIR_EraseRootFromParent_Done,
     /* 114704 */ // Label 2159: @114704
     /* 114704 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114805), // Rule ID 13118 //
     /* 114709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114712 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114728 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114737 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114747 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 114754 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114766 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114777 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 114785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114803 */   GIR_RootConstrainSelectedInstOperands,
     /* 114804 */   // GIR_Coverage, 13118,
     /* 114804 */   GIR_EraseRootFromParent_Done,
     /* 114805 */ // Label 2160: @114805
     /* 114805 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(114887), // Rule ID 6422 //
     /* 114810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114813 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114817 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 114824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114832 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114840 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114845 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114849 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114853 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 114857 */   // MIs[2] Operand 1
     /* 114857 */   // No operand predicates
     /* 114857 */   // MIs[0] Rn
     /* 114857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114865 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114867 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 114870 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114874 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114877 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114885 */   GIR_RootConstrainSelectedInstOperands,
     /* 114886 */   // GIR_Coverage, 6422,
     /* 114886 */   GIR_EraseRootFromParent_Done,
     /* 114887 */ // Label 2161: @114887
     /* 114887 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114969), // Rule ID 6423 //
     /* 114892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114895 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114914 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114918 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114922 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114927 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114931 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114935 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 114939 */   // MIs[2] Operand 1
     /* 114939 */   // No operand predicates
     /* 114939 */   // MIs[0] Rn
     /* 114939 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 114943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 114947 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114949 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 114949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 114952 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 114956 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 114959 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 114961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 114967 */   GIR_RootConstrainSelectedInstOperands,
     /* 114968 */   // GIR_Coverage, 6423,
     /* 114968 */   GIR_EraseRootFromParent_Done,
     /* 114969 */ // Label 2162: @114969
     /* 114969 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(115044), // Rule ID 6424 //
     /* 114974 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114977 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114981 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114985 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114989 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114993 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114997 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115002 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115006 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115010 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115014 */   // MIs[2] Operand 1
     /* 115014 */   // No operand predicates
     /* 115014 */   // MIs[0] Rn
     /* 115014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115022 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115024 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115027 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115031 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115034 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115042 */   GIR_RootConstrainSelectedInstOperands,
     /* 115043 */   // GIR_Coverage, 6424,
     /* 115043 */   GIR_EraseRootFromParent_Done,
     /* 115044 */ // Label 2163: @115044
     /* 115044 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(115119), // Rule ID 6425 //
     /* 115049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115052 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115064 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115068 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115072 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115077 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115081 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115085 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115089 */   // MIs[2] Operand 1
     /* 115089 */   // No operand predicates
     /* 115089 */   // MIs[0] Rn
     /* 115089 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115097 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115099 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115102 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115106 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115109 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115117 */   GIR_RootConstrainSelectedInstOperands,
     /* 115118 */   // GIR_Coverage, 6425,
     /* 115118 */   GIR_EraseRootFromParent_Done,
     /* 115119 */ // Label 2164: @115119
     /* 115119 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115232), // Rule ID 6429 //
     /* 115124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115127 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115138 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115142 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115146 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 115150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115154 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115159 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115163 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115167 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115171 */   // MIs[2] Operand 1
     /* 115171 */   // No operand predicates
     /* 115171 */   // MIs[0] Rn
     /* 115171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115179 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115181 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115193 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115196 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115200 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115203 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115208 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115219 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115222 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115224 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115230 */   GIR_RootConstrainSelectedInstOperands,
     /* 115231 */   // GIR_Coverage, 6429,
     /* 115231 */   GIR_EraseRootFromParent_Done,
     /* 115232 */ // Label 2165: @115232
     /* 115232 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115345), // Rule ID 6430 //
     /* 115237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115240 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115251 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115259 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115263 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115267 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115272 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115276 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115280 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115284 */   // MIs[2] Operand 1
     /* 115284 */   // No operand predicates
     /* 115284 */   // MIs[0] Rn
     /* 115284 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115292 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115294 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115306 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115309 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115313 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115316 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115321 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115332 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115335 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115337 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115343 */   GIR_RootConstrainSelectedInstOperands,
     /* 115344 */   // GIR_Coverage, 6430,
     /* 115344 */   GIR_EraseRootFromParent_Done,
     /* 115345 */ // Label 2166: @115345
     /* 115345 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115451), // Rule ID 6431 //
     /* 115350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115353 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115365 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115369 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115373 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115378 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115382 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115386 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115390 */   // MIs[2] Operand 1
     /* 115390 */   // No operand predicates
     /* 115390 */   // MIs[0] Rn
     /* 115390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115398 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115400 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115412 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115419 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115438 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115441 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115449 */   GIR_RootConstrainSelectedInstOperands,
     /* 115450 */   // GIR_Coverage, 6431,
     /* 115450 */   GIR_EraseRootFromParent_Done,
     /* 115451 */ // Label 2167: @115451
     /* 115451 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(115557), // Rule ID 6432 //
     /* 115456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115459 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115471 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115479 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115484 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115488 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115492 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115496 */   // MIs[2] Operand 1
     /* 115496 */   // No operand predicates
     /* 115496 */   // MIs[0] Rn
     /* 115496 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115504 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115506 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115518 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115521 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115525 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115533 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115544 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115547 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115549 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115555 */   GIR_RootConstrainSelectedInstOperands,
     /* 115556 */   // GIR_Coverage, 6432,
     /* 115556 */   GIR_EraseRootFromParent_Done,
     /* 115557 */ // Label 2168: @115557
     /* 115557 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(115617), // Rule ID 295 //
     /* 115562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115565 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 115591 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 115591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 115594 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115606 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115615 */   GIR_RootConstrainSelectedInstOperands,
     /* 115616 */   // GIR_Coverage, 295,
     /* 115616 */   GIR_EraseRootFromParent_Done,
     /* 115617 */ // Label 2169: @115617
     /* 115617 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(115677), // Rule ID 296 //
     /* 115622 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115625 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115629 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 115651 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 115651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 115654 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115675 */   GIR_RootConstrainSelectedInstOperands,
     /* 115676 */   // GIR_Coverage, 296,
     /* 115676 */   GIR_EraseRootFromParent_Done,
     /* 115677 */ // Label 2170: @115677
     /* 115677 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(115737), // Rule ID 297 //
     /* 115682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115685 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 115711 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 115711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 115714 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115721 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115731 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115735 */   GIR_RootConstrainSelectedInstOperands,
     /* 115736 */   // GIR_Coverage, 297,
     /* 115736 */   GIR_EraseRootFromParent_Done,
     /* 115737 */ // Label 2171: @115737
     /* 115737 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(115797), // Rule ID 298 //
     /* 115742 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115745 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 115771 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 115771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 115774 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115795 */   GIR_RootConstrainSelectedInstOperands,
     /* 115796 */   // GIR_Coverage, 298,
     /* 115796 */   GIR_EraseRootFromParent_Done,
     /* 115797 */ // Label 2172: @115797
     /* 115797 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(115850), // Rule ID 299 //
     /* 115802 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115805 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115813 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115817 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115824 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 115827 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115844 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115848 */   GIR_RootConstrainSelectedInstOperands,
     /* 115849 */   // GIR_Coverage, 299,
     /* 115849 */   GIR_EraseRootFromParent_Done,
     /* 115850 */ // Label 2173: @115850
     /* 115850 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(115903), // Rule ID 300 //
     /* 115855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115858 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115866 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115870 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115877 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 115880 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115901 */   GIR_RootConstrainSelectedInstOperands,
     /* 115902 */   // GIR_Coverage, 300,
     /* 115902 */   GIR_EraseRootFromParent_Done,
     /* 115903 */ // Label 2174: @115903
     /* 115903 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(115959), // Rule ID 307 //
     /* 115908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115911 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115914 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 115933 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 115933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 115936 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 115948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 115953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 115957 */   GIR_RootConstrainSelectedInstOperands,
     /* 115958 */   // GIR_Coverage, 307,
     /* 115958 */   GIR_EraseRootFromParent_Done,
     /* 115959 */ // Label 2175: @115959
     /* 115959 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(116015), // Rule ID 308 //
     /* 115964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 115989 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 115989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 115992 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 115994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116009 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116013 */   GIR_RootConstrainSelectedInstOperands,
     /* 116014 */   // GIR_Coverage, 308,
     /* 116014 */   GIR_EraseRootFromParent_Done,
     /* 116015 */ // Label 2176: @116015
     /* 116015 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(116067), // Rule ID 312 //
     /* 116020 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116023 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116031 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116035 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116042 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116045 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116065 */   GIR_RootConstrainSelectedInstOperands,
     /* 116066 */   // GIR_Coverage, 312,
     /* 116066 */   GIR_EraseRootFromParent_Done,
     /* 116067 */ // Label 2177: @116067
     /* 116067 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(116118), // Rule ID 315 //
     /* 116072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116086 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116097 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116100 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116112 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116116 */   GIR_RootConstrainSelectedInstOperands,
     /* 116117 */   // GIR_Coverage, 315,
     /* 116117 */   GIR_EraseRootFromParent_Done,
     /* 116118 */ // Label 2178: @116118
     /* 116118 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(116177), // Rule ID 317 //
     /* 116123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116126 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116141 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116145 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116152 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116155 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116171 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116175 */   GIR_RootConstrainSelectedInstOperands,
     /* 116176 */   // GIR_Coverage, 317,
     /* 116176 */   GIR_EraseRootFromParent_Done,
     /* 116177 */ // Label 2179: @116177
     /* 116177 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(116236), // Rule ID 318 //
     /* 116182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116185 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116204 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116211 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116214 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116234 */   GIR_RootConstrainSelectedInstOperands,
     /* 116235 */   // GIR_Coverage, 318,
     /* 116235 */   GIR_EraseRootFromParent_Done,
     /* 116236 */ // Label 2180: @116236
     /* 116236 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(116313), // Rule ID 7053 //
     /* 116241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116251 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116262 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116266 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116277 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116284 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116287 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116311 */   GIR_RootConstrainSelectedInstOperands,
     /* 116312 */   // GIR_Coverage, 7053,
     /* 116312 */   GIR_EraseRootFromParent_Done,
     /* 116313 */ // Label 2181: @116313
     /* 116313 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(116390), // Rule ID 7054 //
     /* 116318 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116321 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116328 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116339 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116343 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116361 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116364 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116388 */   GIR_RootConstrainSelectedInstOperands,
     /* 116389 */   // GIR_Coverage, 7054,
     /* 116389 */   GIR_EraseRootFromParent_Done,
     /* 116390 */ // Label 2182: @116390
     /* 116390 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(116449), // Rule ID 7034 //
     /* 116395 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116405 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116412 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116416 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116423 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15841>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116426 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116447 */   GIR_RootConstrainSelectedInstOperands,
     /* 116448 */   // GIR_Coverage, 7034,
     /* 116448 */   GIR_EraseRootFromParent_Done,
     /* 116449 */ // Label 2183: @116449
     /* 116449 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(116508), // Rule ID 7035 //
     /* 116454 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116457 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116464 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116475 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116482 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15841>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 116485 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116506 */   GIR_RootConstrainSelectedInstOperands,
     /* 116507 */   // GIR_Coverage, 7035,
     /* 116507 */   GIR_EraseRootFromParent_Done,
     /* 116508 */ // Label 2184: @116508
     /* 116508 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(116567), // Rule ID 7039 //
     /* 116513 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116516 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116523 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116541 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15848>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 116544 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116561 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116565 */   GIR_RootConstrainSelectedInstOperands,
     /* 116566 */   // GIR_Coverage, 7039,
     /* 116566 */   GIR_EraseRootFromParent_Done,
     /* 116567 */ // Label 2185: @116567
     /* 116567 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(116626), // Rule ID 7040 //
     /* 116572 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116575 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116582 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116593 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116600 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15848>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 116603 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116624 */   GIR_RootConstrainSelectedInstOperands,
     /* 116625 */   // GIR_Coverage, 7040,
     /* 116625 */   GIR_EraseRootFromParent_Done,
     /* 116626 */ // Label 2186: @116626
     /* 116626 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(116685), // Rule ID 7044 //
     /* 116631 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116634 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116641 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116652 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116659 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 116662 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116679 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116683 */   GIR_RootConstrainSelectedInstOperands,
     /* 116684 */   // GIR_Coverage, 7044,
     /* 116684 */   GIR_EraseRootFromParent_Done,
     /* 116685 */ // Label 2187: @116685
     /* 116685 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(116744), // Rule ID 7045 //
     /* 116690 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116700 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116711 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116718 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116721 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116728 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116738 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116742 */   GIR_RootConstrainSelectedInstOperands,
     /* 116743 */   // GIR_Coverage, 7045,
     /* 116743 */   GIR_EraseRootFromParent_Done,
     /* 116744 */ // Label 2188: @116744
     /* 116744 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(116816), // Rule ID 7055 //
     /* 116749 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116752 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116759 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116762 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116766 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116770 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116774 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116792 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116795 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116814 */   GIR_RootConstrainSelectedInstOperands,
     /* 116815 */   // GIR_Coverage, 7055,
     /* 116815 */   GIR_EraseRootFromParent_Done,
     /* 116816 */ // Label 2189: @116816
     /* 116816 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(116888), // Rule ID 7056 //
     /* 116821 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116824 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116831 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116842 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116851 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116864 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 116864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 116867 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116881 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116886 */   GIR_RootConstrainSelectedInstOperands,
     /* 116887 */   // GIR_Coverage, 7056,
     /* 116887 */   GIR_EraseRootFromParent_Done,
     /* 116888 */ // Label 2190: @116888
     /* 116888 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(116940), // Rule ID 320 //
     /* 116893 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116896 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116904 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116908 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116915 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 116918 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116938 */   GIR_RootConstrainSelectedInstOperands,
     /* 116939 */   // GIR_Coverage, 320,
     /* 116939 */   GIR_EraseRootFromParent_Done,
     /* 116940 */ // Label 2191: @116940
     /* 116940 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(116991), // Rule ID 323 //
     /* 116945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116951 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 116970 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 116973 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116989 */   GIR_RootConstrainSelectedInstOperands,
     /* 116990 */   // GIR_Coverage, 323,
     /* 116990 */   GIR_EraseRootFromParent_Done,
     /* 116991 */ // Label 2192: @116991
     /* 116991 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(117050), // Rule ID 326 //
     /* 116996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116999 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117003 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117018 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117025 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117028 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117048 */   GIR_RootConstrainSelectedInstOperands,
     /* 117049 */   // GIR_Coverage, 326,
     /* 117049 */   GIR_EraseRootFromParent_Done,
     /* 117050 */ // Label 2193: @117050
     /* 117050 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(117109), // Rule ID 327 //
     /* 117055 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117058 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117073 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117084 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117087 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117107 */   GIR_RootConstrainSelectedInstOperands,
     /* 117108 */   // GIR_Coverage, 327,
     /* 117108 */   GIR_EraseRootFromParent_Done,
     /* 117109 */ // Label 2194: @117109
     /* 117109 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(117163), // Rule ID 7036 //
     /* 117114 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117117 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117124 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117131 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117135 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 117142 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15841>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 117142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 117145 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117152 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117161 */   GIR_RootConstrainSelectedInstOperands,
     /* 117162 */   // GIR_Coverage, 7036,
     /* 117162 */   GIR_EraseRootFromParent_Done,
     /* 117163 */ // Label 2195: @117163
     /* 117163 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(117217), // Rule ID 7037 //
     /* 117168 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117178 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117196 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15841>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117199 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117215 */   GIR_RootConstrainSelectedInstOperands,
     /* 117216 */   // GIR_Coverage, 7037,
     /* 117216 */   GIR_EraseRootFromParent_Done,
     /* 117217 */ // Label 2196: @117217
     /* 117217 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(117271), // Rule ID 7041 //
     /* 117222 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117225 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117232 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117250 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15848>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 117253 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117269 */   GIR_RootConstrainSelectedInstOperands,
     /* 117270 */   // GIR_Coverage, 7041,
     /* 117270 */   GIR_EraseRootFromParent_Done,
     /* 117271 */ // Label 2197: @117271
     /* 117271 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(117325), // Rule ID 7042 //
     /* 117276 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117286 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117293 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117297 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117304 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15848>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117307 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117314 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117319 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117323 */   GIR_RootConstrainSelectedInstOperands,
     /* 117324 */   // GIR_Coverage, 7042,
     /* 117324 */   GIR_EraseRootFromParent_Done,
     /* 117325 */ // Label 2198: @117325
     /* 117325 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(117379), // Rule ID 7046 //
     /* 117330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117340 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117358 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 117361 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117373 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117377 */   GIR_RootConstrainSelectedInstOperands,
     /* 117378 */   // GIR_Coverage, 7046,
     /* 117378 */   GIR_EraseRootFromParent_Done,
     /* 117379 */ // Label 2199: @117379
     /* 117379 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(117433), // Rule ID 7047 //
     /* 117384 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117387 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117394 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117412 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15855>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117415 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117431 */   GIR_RootConstrainSelectedInstOperands,
     /* 117432 */   // GIR_Coverage, 7047,
     /* 117432 */   GIR_EraseRootFromParent_Done,
     /* 117433 */ // Label 2200: @117433
     /* 117433 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(117490), // Rule ID 7379 //
     /* 117438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117441 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117444 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117458 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117462 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117469 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15839>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 117472 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117488 */   GIR_RootConstrainSelectedInstOperands,
     /* 117489 */   // GIR_Coverage, 7379,
     /* 117489 */   GIR_EraseRootFromParent_Done,
     /* 117490 */ // Label 2201: @117490
     /* 117490 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(117547), // Rule ID 7380 //
     /* 117495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117498 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117508 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117519 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117526 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15846>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 117529 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117545 */   GIR_RootConstrainSelectedInstOperands,
     /* 117546 */   // GIR_Coverage, 7380,
     /* 117546 */   GIR_EraseRootFromParent_Done,
     /* 117547 */ // Label 2202: @117547
     /* 117547 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(117604), // Rule ID 7381 //
     /* 117552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117555 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117558 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117565 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117572 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117576 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117583 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15853>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 117586 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117593 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117602 */   GIR_RootConstrainSelectedInstOperands,
     /* 117603 */   // GIR_Coverage, 7381,
     /* 117603 */   GIR_EraseRootFromParent_Done,
     /* 117604 */ // Label 2203: @117604
     /* 117604 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(117641), // Rule ID 7033 //
     /* 117609 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117612 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117619 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117626 */   // MIs[0] ptr
     /* 117626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117634 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15839>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 117639 */   GIR_RootConstrainSelectedInstOperands,
     /* 117640 */   // GIR_Coverage, 7033,
     /* 117640 */   GIR_Done,
     /* 117641 */ // Label 2204: @117641
     /* 117641 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(117678), // Rule ID 7038 //
     /* 117646 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117649 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117656 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117663 */   // MIs[0] ptr
     /* 117663 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117671 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15846>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 117676 */   GIR_RootConstrainSelectedInstOperands,
     /* 117677 */   // GIR_Coverage, 7038,
     /* 117677 */   GIR_Done,
     /* 117678 */ // Label 2205: @117678
     /* 117678 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(117715), // Rule ID 7043 //
     /* 117683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117686 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117693 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117700 */   // MIs[0] ptr
     /* 117700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 117704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 117708 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15853>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 117708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 117713 */   GIR_RootConstrainSelectedInstOperands,
     /* 117714 */   // GIR_Coverage, 7043,
     /* 117714 */   GIR_Done,
     /* 117715 */ // Label 2206: @117715
     /* 117715 */ GIM_Reject,
     /* 117716 */ // Label 2105: @117716
     /* 117716 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(117822), // Rule ID 4478 //
     /* 117721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117728 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117736 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117740 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117744 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117749 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117753 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117757 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117759 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117766 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117778 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 117797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117810 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117820 */   GIR_RootConstrainSelectedInstOperands,
     /* 117821 */   // GIR_Coverage, 4478,
     /* 117821 */   GIR_EraseRootFromParent_Done,
     /* 117822 */ // Label 2207: @117822
     /* 117822 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(117928), // Rule ID 4479 //
     /* 117827 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117830 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117842 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117846 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117850 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117855 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 117872 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 117872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117884 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117890 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117895 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 117903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117916 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117926 */   GIR_RootConstrainSelectedInstOperands,
     /* 117927 */   // GIR_Coverage, 4479,
     /* 117927 */   GIR_EraseRootFromParent_Done,
     /* 117928 */ // Label 2208: @117928
     /* 117928 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(118034), // Rule ID 4480 //
     /* 117933 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117936 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 117948 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117952 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117956 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117961 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 117965 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 117978 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 117978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117990 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 117996 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118027 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118032 */   GIR_RootConstrainSelectedInstOperands,
     /* 118033 */   // GIR_Coverage, 4480,
     /* 118033 */   GIR_EraseRootFromParent_Done,
     /* 118034 */ // Label 2209: @118034
     /* 118034 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118140), // Rule ID 4481 //
     /* 118039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118054 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118058 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118067 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118071 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118075 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118077 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118084 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118096 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118133 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118138 */   GIR_RootConstrainSelectedInstOperands,
     /* 118139 */   // GIR_Coverage, 4481,
     /* 118139 */   GIR_EraseRootFromParent_Done,
     /* 118140 */ // Label 2210: @118140
     /* 118140 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118241), // Rule ID 4504 //
     /* 118145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118148 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118152 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118156 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118160 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118164 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118168 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118173 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118183 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118190 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118202 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118208 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118224 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118229 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118239 */   GIR_RootConstrainSelectedInstOperands,
     /* 118240 */   // GIR_Coverage, 4504,
     /* 118240 */   GIR_EraseRootFromParent_Done,
     /* 118241 */ // Label 2211: @118241
     /* 118241 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118342), // Rule ID 4505 //
     /* 118246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118261 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118265 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118274 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118278 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118282 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118291 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118303 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118309 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118314 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118340 */   GIR_RootConstrainSelectedInstOperands,
     /* 118341 */   // GIR_Coverage, 4505,
     /* 118341 */   GIR_EraseRootFromParent_Done,
     /* 118342 */ // Label 2212: @118342
     /* 118342 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(118443), // Rule ID 4529 //
     /* 118347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118362 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118370 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118375 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118385 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118392 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118404 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118441 */   GIR_RootConstrainSelectedInstOperands,
     /* 118442 */   // GIR_Coverage, 4529,
     /* 118442 */   GIR_EraseRootFromParent_Done,
     /* 118443 */ // Label 2213: @118443
     /* 118443 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(118544), // Rule ID 4530 //
     /* 118448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118451 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118455 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118463 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118467 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118471 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118476 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118486 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118493 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118505 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118511 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118516 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118542 */   GIR_RootConstrainSelectedInstOperands,
     /* 118543 */   // GIR_Coverage, 4530,
     /* 118543 */   GIR_EraseRootFromParent_Done,
     /* 118544 */ // Label 2214: @118544
     /* 118544 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(118619), // Rule ID 6426 //
     /* 118549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118552 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118564 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118568 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118572 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118577 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 118581 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118585 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 118589 */   // MIs[2] Operand 1
     /* 118589 */   // No operand predicates
     /* 118589 */   // MIs[0] Rn
     /* 118589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118597 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118599 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 118599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 118602 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 118606 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 118609 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 118611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118617 */   GIR_RootConstrainSelectedInstOperands,
     /* 118618 */   // GIR_Coverage, 6426,
     /* 118618 */   GIR_EraseRootFromParent_Done,
     /* 118619 */ // Label 2215: @118619
     /* 118619 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(118694), // Rule ID 6427 //
     /* 118624 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118627 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118639 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118643 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118647 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118652 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 118656 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118660 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 118664 */   // MIs[2] Operand 1
     /* 118664 */   // No operand predicates
     /* 118664 */   // MIs[0] Rn
     /* 118664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118672 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118674 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 118674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 118677 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 118681 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 118684 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 118686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118692 */   GIR_RootConstrainSelectedInstOperands,
     /* 118693 */   // GIR_Coverage, 6427,
     /* 118693 */   GIR_EraseRootFromParent_Done,
     /* 118694 */ // Label 2216: @118694
     /* 118694 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(118747), // Rule ID 301 //
     /* 118699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118721 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 118724 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118726 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118741 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118745 */   GIR_RootConstrainSelectedInstOperands,
     /* 118746 */   // GIR_Coverage, 301,
     /* 118746 */   GIR_EraseRootFromParent_Done,
     /* 118747 */ // Label 2217: @118747
     /* 118747 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(118800), // Rule ID 302 //
     /* 118752 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118755 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118767 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118774 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 118777 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118798 */   GIR_RootConstrainSelectedInstOperands,
     /* 118799 */   // GIR_Coverage, 302,
     /* 118799 */   GIR_EraseRootFromParent_Done,
     /* 118800 */ // Label 2218: @118800
     /* 118800 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(118856), // Rule ID 309 //
     /* 118805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118808 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118811 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118819 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118823 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118830 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118833 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118854 */   GIR_RootConstrainSelectedInstOperands,
     /* 118855 */   // GIR_Coverage, 309,
     /* 118855 */   GIR_EraseRootFromParent_Done,
     /* 118856 */ // Label 2219: @118856
     /* 118856 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(118912), // Rule ID 310 //
     /* 118861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118875 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118886 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118889 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 118891 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118906 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118910 */   GIR_RootConstrainSelectedInstOperands,
     /* 118911 */   // GIR_Coverage, 310,
     /* 118911 */   GIR_EraseRootFromParent_Done,
     /* 118912 */ // Label 2220: @118912
     /* 118912 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(119001), // Rule ID 4436 //
     /* 118917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118920 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118924 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118946 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118958 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 118964 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118969 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 118977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118985 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118995 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118999 */   GIR_RootConstrainSelectedInstOperands,
     /* 119000 */   // GIR_Coverage, 4436,
     /* 119000 */   GIR_EraseRootFromParent_Done,
     /* 119001 */ // Label 2221: @119001
     /* 119001 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(119090), // Rule ID 4437 //
     /* 119006 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119009 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119013 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119024 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119028 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119035 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 119035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119047 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 119066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119088 */   GIR_RootConstrainSelectedInstOperands,
     /* 119089 */   // GIR_Coverage, 4437,
     /* 119089 */   GIR_EraseRootFromParent_Done,
     /* 119090 */ // Label 2222: @119090
     /* 119090 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(119179), // Rule ID 4438 //
     /* 119095 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119098 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119102 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119124 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119136 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119142 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119147 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 119155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119173 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119177 */   GIR_RootConstrainSelectedInstOperands,
     /* 119178 */   // GIR_Coverage, 4438,
     /* 119178 */   GIR_EraseRootFromParent_Done,
     /* 119179 */ // Label 2223: @119179
     /* 119179 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(119268), // Rule ID 4439 //
     /* 119184 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119187 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119191 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119202 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119206 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119213 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119225 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 119244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119266 */   GIR_RootConstrainSelectedInstOperands,
     /* 119267 */   // GIR_Coverage, 4439,
     /* 119267 */   GIR_EraseRootFromParent_Done,
     /* 119268 */ // Label 2224: @119268
     /* 119268 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119357), // Rule ID 4440 //
     /* 119273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119276 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119280 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119291 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119295 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119302 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119314 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 119333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119355 */   GIR_RootConstrainSelectedInstOperands,
     /* 119356 */   // GIR_Coverage, 4440,
     /* 119356 */   GIR_EraseRootFromParent_Done,
     /* 119357 */ // Label 2225: @119357
     /* 119357 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(119446), // Rule ID 4441 //
     /* 119362 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119365 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119369 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119380 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119384 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119391 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119403 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 119422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119444 */   GIR_RootConstrainSelectedInstOperands,
     /* 119445 */   // GIR_Coverage, 4441,
     /* 119445 */   GIR_EraseRootFromParent_Done,
     /* 119446 */ // Label 2226: @119446
     /* 119446 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(119499), // Rule ID 4452 //
     /* 119451 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119462 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119473 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119476 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119493 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119497 */   GIR_RootConstrainSelectedInstOperands,
     /* 119498 */   // GIR_Coverage, 4452,
     /* 119498 */   GIR_EraseRootFromParent_Done,
     /* 119499 */ // Label 2227: @119499
     /* 119499 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(119552), // Rule ID 4453 //
     /* 119504 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119507 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119519 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119526 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119529 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119550 */   GIR_RootConstrainSelectedInstOperands,
     /* 119551 */   // GIR_Coverage, 4453,
     /* 119551 */   GIR_EraseRootFromParent_Done,
     /* 119552 */ // Label 2228: @119552
     /* 119552 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(119605), // Rule ID 4454 //
     /* 119557 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119560 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119568 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119572 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119579 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119582 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119589 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119599 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119603 */   GIR_RootConstrainSelectedInstOperands,
     /* 119604 */   // GIR_Coverage, 4454,
     /* 119604 */   GIR_EraseRootFromParent_Done,
     /* 119605 */ // Label 2229: @119605
     /* 119605 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(119658), // Rule ID 4455 //
     /* 119610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119613 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119632 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119635 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119656 */   GIR_RootConstrainSelectedInstOperands,
     /* 119657 */   // GIR_Coverage, 4455,
     /* 119657 */   GIR_EraseRootFromParent_Done,
     /* 119658 */ // Label 2230: @119658
     /* 119658 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(119710), // Rule ID 311 //
     /* 119663 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119666 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119674 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119678 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119685 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 119688 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 119694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119708 */   GIR_RootConstrainSelectedInstOperands,
     /* 119709 */   // GIR_Coverage, 311,
     /* 119709 */   GIR_EraseRootFromParent_Done,
     /* 119710 */ // Label 2231: @119710
     /* 119710 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(119761), // Rule ID 316 //
     /* 119715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119721 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119729 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119733 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119740 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119743 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119750 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119759 */   GIR_RootConstrainSelectedInstOperands,
     /* 119760 */   // GIR_Coverage, 316,
     /* 119760 */   GIR_EraseRootFromParent_Done,
     /* 119761 */ // Label 2232: @119761
     /* 119761 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(119809), // Rule ID 4482 //
     /* 119766 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119769 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119777 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119781 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119788 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119791 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119798 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119803 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119807 */   GIR_RootConstrainSelectedInstOperands,
     /* 119808 */   // GIR_Coverage, 4482,
     /* 119808 */   GIR_EraseRootFromParent_Done,
     /* 119809 */ // Label 2233: @119809
     /* 119809 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(119857), // Rule ID 4483 //
     /* 119814 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119817 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 119836 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 119836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 119839 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119841 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119855 */   GIR_RootConstrainSelectedInstOperands,
     /* 119856 */   // GIR_Coverage, 4483,
     /* 119856 */   GIR_EraseRootFromParent_Done,
     /* 119857 */ // Label 2234: @119857
     /* 119857 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(119941), // Rule ID 4497 //
     /* 119862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119865 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119891 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119903 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 119922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119930 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119935 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119939 */   GIR_RootConstrainSelectedInstOperands,
     /* 119940 */   // GIR_Coverage, 4497,
     /* 119940 */   GIR_EraseRootFromParent_Done,
     /* 119941 */ // Label 2235: @119941
     /* 119941 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(120025), // Rule ID 4498 //
     /* 119946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119949 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119953 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119968 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 119975 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 119975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119987 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 120006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120023 */   GIR_RootConstrainSelectedInstOperands,
     /* 120024 */   // GIR_Coverage, 4498,
     /* 120024 */   GIR_EraseRootFromParent_Done,
     /* 120025 */ // Label 2236: @120025
     /* 120025 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(120109), // Rule ID 4499 //
     /* 120030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120033 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120037 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120048 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120052 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120059 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120071 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120077 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120082 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 120090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120093 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120098 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120103 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120107 */   GIR_RootConstrainSelectedInstOperands,
     /* 120108 */   // GIR_Coverage, 4499,
     /* 120108 */   GIR_EraseRootFromParent_Done,
     /* 120109 */ // Label 2237: @120109
     /* 120109 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(120186), // Rule ID 7057 //
     /* 120114 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120117 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120124 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120135 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120139 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120150 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120157 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120160 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120184 */   GIR_RootConstrainSelectedInstOperands,
     /* 120185 */   // GIR_Coverage, 7057,
     /* 120185 */   GIR_EraseRootFromParent_Done,
     /* 120186 */ // Label 2238: @120186
     /* 120186 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120263), // Rule ID 7058 //
     /* 120191 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120201 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120212 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120216 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120221 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120225 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120227 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120234 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120237 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120261 */   GIR_RootConstrainSelectedInstOperands,
     /* 120262 */   // GIR_Coverage, 7058,
     /* 120262 */   GIR_EraseRootFromParent_Done,
     /* 120263 */ // Label 2239: @120263
     /* 120263 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120322), // Rule ID 7049 //
     /* 120268 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120271 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120278 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120285 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120296 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 120299 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120320 */   GIR_RootConstrainSelectedInstOperands,
     /* 120321 */   // GIR_Coverage, 7049,
     /* 120321 */   GIR_EraseRootFromParent_Done,
     /* 120322 */ // Label 2240: @120322
     /* 120322 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(120381), // Rule ID 7050 //
     /* 120327 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120330 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120337 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120355 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 120358 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120375 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120379 */   GIR_RootConstrainSelectedInstOperands,
     /* 120380 */   // GIR_Coverage, 7050,
     /* 120380 */   GIR_EraseRootFromParent_Done,
     /* 120381 */ // Label 2241: @120381
     /* 120381 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(120453), // Rule ID 7059 //
     /* 120386 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120389 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120396 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120399 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120403 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120407 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120411 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120420 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120429 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120432 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120446 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120451 */   GIR_RootConstrainSelectedInstOperands,
     /* 120452 */   // GIR_Coverage, 7059,
     /* 120452 */   GIR_EraseRootFromParent_Done,
     /* 120453 */ // Label 2242: @120453
     /* 120453 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(120525), // Rule ID 7060 //
     /* 120458 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120461 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120468 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120479 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120483 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120501 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120504 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120513 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120518 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120523 */   GIR_RootConstrainSelectedInstOperands,
     /* 120524 */   // GIR_Coverage, 7060,
     /* 120524 */   GIR_EraseRootFromParent_Done,
     /* 120525 */ // Label 2243: @120525
     /* 120525 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(120622), // Rule ID 7371 //
     /* 120530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 120533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120554 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120558 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 120562 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 120566 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 120570 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 120574 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 120579 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 120583 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120587 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 120591 */   // MIs[3] Operand 1
     /* 120591 */   // No operand predicates
     /* 120591 */   // MIs[0] Rn
     /* 120591 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120599 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 120601 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15860>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 120601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 120604 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 120608 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 120611 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 120613 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 120620 */   GIR_RootConstrainSelectedInstOperands,
     /* 120621 */   // GIR_Coverage, 7371,
     /* 120621 */   GIR_EraseRootFromParent_Done,
     /* 120622 */ // Label 2244: @120622
     /* 120622 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(120674), // Rule ID 319 //
     /* 120627 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120630 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120638 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120642 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120649 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 120652 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 120658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120663 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120672 */   GIR_RootConstrainSelectedInstOperands,
     /* 120673 */   // GIR_Coverage, 319,
     /* 120673 */   GIR_EraseRootFromParent_Done,
     /* 120674 */ // Label 2245: @120674
     /* 120674 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(120725), // Rule ID 324 //
     /* 120679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120685 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120693 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120697 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120704 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120707 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120714 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120719 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120723 */   GIR_RootConstrainSelectedInstOperands,
     /* 120724 */   // GIR_Coverage, 324,
     /* 120724 */   GIR_EraseRootFromParent_Done,
     /* 120725 */ // Label 2246: @120725
     /* 120725 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(120779), // Rule ID 7051 //
     /* 120730 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120733 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120740 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120747 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120751 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120758 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120761 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120777 */   GIR_RootConstrainSelectedInstOperands,
     /* 120778 */   // GIR_Coverage, 7051,
     /* 120778 */   GIR_EraseRootFromParent_Done,
     /* 120779 */ // Label 2247: @120779
     /* 120779 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(120833), // Rule ID 7052 //
     /* 120784 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120794 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120812 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15862>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 120815 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120831 */   GIR_RootConstrainSelectedInstOperands,
     /* 120832 */   // GIR_Coverage, 7052,
     /* 120832 */   GIR_EraseRootFromParent_Done,
     /* 120833 */ // Label 2248: @120833
     /* 120833 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(120890), // Rule ID 7382 //
     /* 120838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 120841 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120844 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120851 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120858 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120862 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120869 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15860>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 120872 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120874 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120888 */   GIR_RootConstrainSelectedInstOperands,
     /* 120889 */   // GIR_Coverage, 7382,
     /* 120889 */   GIR_EraseRootFromParent_Done,
     /* 120890 */ // Label 2249: @120890
     /* 120890 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(120938), // Rule ID 4506 //
     /* 120895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120917 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120920 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120936 */   GIR_RootConstrainSelectedInstOperands,
     /* 120937 */   // GIR_Coverage, 4506,
     /* 120937 */   GIR_EraseRootFromParent_Done,
     /* 120938 */ // Label 2250: @120938
     /* 120938 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(120986), // Rule ID 4507 //
     /* 120943 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120946 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120954 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120958 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120965 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 120968 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120970 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120980 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120984 */   GIR_RootConstrainSelectedInstOperands,
     /* 120985 */   // GIR_Coverage, 4507,
     /* 120985 */   GIR_EraseRootFromParent_Done,
     /* 120986 */ // Label 2251: @120986
     /* 120986 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(121070), // Rule ID 4522 //
     /* 120991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120994 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120998 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121009 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121013 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121020 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121032 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121038 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121043 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 121051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121068 */   GIR_RootConstrainSelectedInstOperands,
     /* 121069 */   // GIR_Coverage, 4522,
     /* 121069 */   GIR_EraseRootFromParent_Done,
     /* 121070 */ // Label 2252: @121070
     /* 121070 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(121154), // Rule ID 4523 //
     /* 121075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121078 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121093 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121104 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121116 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 121135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121138 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121152 */   GIR_RootConstrainSelectedInstOperands,
     /* 121153 */   // GIR_Coverage, 4523,
     /* 121153 */   GIR_EraseRootFromParent_Done,
     /* 121154 */ // Label 2253: @121154
     /* 121154 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(121238), // Rule ID 4524 //
     /* 121159 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121162 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121166 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121188 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121188 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121191 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121195 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121200 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121206 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121211 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 121219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121236 */   GIR_RootConstrainSelectedInstOperands,
     /* 121237 */   // GIR_Coverage, 4524,
     /* 121237 */   GIR_EraseRootFromParent_Done,
     /* 121238 */ // Label 2254: @121238
     /* 121238 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(121322), // Rule ID 7370 //
     /* 121243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121246 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121256 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121267 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121271 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121275 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121280 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 121284 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121288 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121292 */   // MIs[2] Operand 1
     /* 121292 */   // No operand predicates
     /* 121292 */   // MIs[0] Rn
     /* 121292 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121300 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121302 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15860>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121305 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121309 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 121312 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121314 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121320 */   GIR_RootConstrainSelectedInstOperands,
     /* 121321 */   // GIR_Coverage, 7370,
     /* 121321 */   GIR_EraseRootFromParent_Done,
     /* 121322 */ // Label 2255: @121322
     /* 121322 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(121420), // Rule ID 7372 //
     /* 121327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121330 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121340 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121351 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121355 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121360 */   // MIs[0] Rn
     /* 121360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121368 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121370 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15860>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 121370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 121373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121382 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 121385 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121389 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 121392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121397 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121411 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121418 */   GIR_RootConstrainSelectedInstOperands,
     /* 121419 */   // GIR_Coverage, 7372,
     /* 121419 */   GIR_EraseRootFromParent_Done,
     /* 121420 */ // Label 2256: @121420
     /* 121420 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(121457), // Rule ID 7048 //
     /* 121425 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121442 */   // MIs[0] ptr
     /* 121442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121450 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15860>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 121450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 121455 */   GIR_RootConstrainSelectedInstOperands,
     /* 121456 */   // GIR_Coverage, 7048,
     /* 121456 */   GIR_Done,
     /* 121457 */ // Label 2257: @121457
     /* 121457 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(121484), // Rule ID 6376 //
     /* 121462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121465 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121469 */   // MIs[0] Rn
     /* 121469 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121477 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 121477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 121482 */   GIR_RootConstrainSelectedInstOperands,
     /* 121483 */   // GIR_Coverage, 6376,
     /* 121483 */   GIR_Done,
     /* 121484 */ // Label 2258: @121484
     /* 121484 */ GIM_Reject,
     /* 121485 */ // Label 2106: @121485
     /* 121485 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(121690),
     /* 121490 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121493 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121501 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121505 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(121546), // Rule ID 4434 //
     /* 121510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 121513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 121520 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 121523 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121544 */     GIR_RootConstrainSelectedInstOperands,
     /* 121545 */     // GIR_Coverage, 4434,
     /* 121545 */     GIR_EraseRootFromParent_Done,
     /* 121546 */   // Label 2260: @121546
     /* 121546 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(121587), // Rule ID 4435 //
     /* 121551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 121554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 121561 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 121561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 121564 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121585 */     GIR_RootConstrainSelectedInstOperands,
     /* 121586 */     // GIR_Coverage, 4435,
     /* 121586 */     GIR_EraseRootFromParent_Done,
     /* 121587 */   // Label 2261: @121587
     /* 121587 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(121620), // Rule ID 4489 //
     /* 121592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 121599 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 121599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 121602 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121618 */     GIR_RootConstrainSelectedInstOperands,
     /* 121619 */     // GIR_Coverage, 4489,
     /* 121619 */     GIR_EraseRootFromParent_Done,
     /* 121620 */   // Label 2262: @121620
     /* 121620 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(121653), // Rule ID 4513 //
     /* 121625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121632 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121635 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121651 */     GIR_RootConstrainSelectedInstOperands,
     /* 121652 */     // GIR_Coverage, 4513,
     /* 121652 */     GIR_EraseRootFromParent_Done,
     /* 121653 */   // Label 2263: @121653
     /* 121653 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(121689), // Rule ID 325 //
     /* 121658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 121668 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 121671 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121687 */     GIR_RootConstrainSelectedInstOperands,
     /* 121688 */     // GIR_Coverage, 325,
     /* 121688 */     GIR_EraseRootFromParent_Done,
     /* 121689 */   // Label 2264: @121689
     /* 121689 */   GIM_Reject,
     /* 121690 */ // Label 2259: @121690
     /* 121690 */ GIM_Reject,
     /* 121691 */ // Label 2107: @121691
     /* 121691 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(122096),
     /* 121696 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121699 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121703 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(121752), // Rule ID 4442 //
     /* 121708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121726 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121729 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121750 */     GIR_RootConstrainSelectedInstOperands,
     /* 121751 */     // GIR_Coverage, 4442,
     /* 121751 */     GIR_EraseRootFromParent_Done,
     /* 121752 */   // Label 2266: @121752
     /* 121752 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(121801), // Rule ID 4443 //
     /* 121757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121775 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121778 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121799 */     GIR_RootConstrainSelectedInstOperands,
     /* 121800 */     // GIR_Coverage, 4443,
     /* 121800 */     GIR_EraseRootFromParent_Done,
     /* 121801 */   // Label 2267: @121801
     /* 121801 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(121850), // Rule ID 4444 //
     /* 121806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121824 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 121827 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121848 */     GIR_RootConstrainSelectedInstOperands,
     /* 121849 */     // GIR_Coverage, 4444,
     /* 121849 */     GIR_EraseRootFromParent_Done,
     /* 121850 */   // Label 2268: @121850
     /* 121850 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(121899), // Rule ID 4445 //
     /* 121855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121873 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 121876 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121897 */     GIR_RootConstrainSelectedInstOperands,
     /* 121898 */     // GIR_Coverage, 4445,
     /* 121898 */     GIR_EraseRootFromParent_Done,
     /* 121899 */   // Label 2269: @121899
     /* 121899 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(121943), // Rule ID 4484 //
     /* 121904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121922 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121925 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121941 */     GIR_RootConstrainSelectedInstOperands,
     /* 121942 */     // GIR_Coverage, 4484,
     /* 121942 */     GIR_EraseRootFromParent_Done,
     /* 121943 */   // Label 2270: @121943
     /* 121943 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(121987), // Rule ID 4487 //
     /* 121948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121966 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 121969 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121985 */     GIR_RootConstrainSelectedInstOperands,
     /* 121986 */     // GIR_Coverage, 4487,
     /* 121986 */     GIR_EraseRootFromParent_Done,
     /* 121987 */   // Label 2271: @121987
     /* 121987 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(122031), // Rule ID 4508 //
     /* 121992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 121995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122010 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122013 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122029 */     GIR_RootConstrainSelectedInstOperands,
     /* 122030 */     // GIR_Coverage, 4508,
     /* 122030 */     GIR_EraseRootFromParent_Done,
     /* 122031 */   // Label 2272: @122031
     /* 122031 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(122075), // Rule ID 4511 //
     /* 122036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122054 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122057 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122073 */     GIR_RootConstrainSelectedInstOperands,
     /* 122074 */     // GIR_Coverage, 4511,
     /* 122074 */     GIR_EraseRootFromParent_Done,
     /* 122075 */   // Label 2273: @122075
     /* 122075 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(122095), // Rule ID 6375 //
     /* 122080 */     // MIs[0] Rn
     /* 122080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122088 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 122093 */     GIR_RootConstrainSelectedInstOperands,
     /* 122094 */     // GIR_Coverage, 6375,
     /* 122094 */     GIR_Done,
     /* 122095 */   // Label 2274: @122095
     /* 122095 */   GIM_Reject,
     /* 122096 */ // Label 2265: @122096
     /* 122096 */ GIM_Reject,
     /* 122097 */ // Label 2108: @122097
     /* 122097 */ GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(122546),
     /* 122102 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122105 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122109 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(122158), // Rule ID 4456 //
     /* 122114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122132 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122135 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122156 */     GIR_RootConstrainSelectedInstOperands,
     /* 122157 */     // GIR_Coverage, 4456,
     /* 122157 */     GIR_EraseRootFromParent_Done,
     /* 122158 */   // Label 2276: @122158
     /* 122158 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(122207), // Rule ID 4457 //
     /* 122163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122181 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122184 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122205 */     GIR_RootConstrainSelectedInstOperands,
     /* 122206 */     // GIR_Coverage, 4457,
     /* 122206 */     GIR_EraseRootFromParent_Done,
     /* 122207 */   // Label 2277: @122207
     /* 122207 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(122256), // Rule ID 4458 //
     /* 122212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122230 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122233 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122254 */     GIR_RootConstrainSelectedInstOperands,
     /* 122255 */     // GIR_Coverage, 4458,
     /* 122255 */     GIR_EraseRootFromParent_Done,
     /* 122256 */   // Label 2278: @122256
     /* 122256 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(122305), // Rule ID 4459 //
     /* 122261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122279 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122282 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122303 */     GIR_RootConstrainSelectedInstOperands,
     /* 122304 */     // GIR_Coverage, 4459,
     /* 122304 */     GIR_EraseRootFromParent_Done,
     /* 122305 */   // Label 2279: @122305
     /* 122305 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(122349), // Rule ID 4491 //
     /* 122310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122328 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122331 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122347 */     GIR_RootConstrainSelectedInstOperands,
     /* 122348 */     // GIR_Coverage, 4491,
     /* 122348 */     GIR_EraseRootFromParent_Done,
     /* 122349 */   // Label 2280: @122349
     /* 122349 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(122393), // Rule ID 4495 //
     /* 122354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122372 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122375 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122391 */     GIR_RootConstrainSelectedInstOperands,
     /* 122392 */     // GIR_Coverage, 4495,
     /* 122392 */     GIR_EraseRootFromParent_Done,
     /* 122393 */   // Label 2281: @122393
     /* 122393 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(122437), // Rule ID 4515 //
     /* 122398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122416 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122419 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122435 */     GIR_RootConstrainSelectedInstOperands,
     /* 122436 */     // GIR_Coverage, 4515,
     /* 122436 */     GIR_EraseRootFromParent_Done,
     /* 122437 */   // Label 2282: @122437
     /* 122437 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(122481), // Rule ID 4519 //
     /* 122442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122460 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122463 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122479 */     GIR_RootConstrainSelectedInstOperands,
     /* 122480 */     // GIR_Coverage, 4519,
     /* 122480 */     GIR_EraseRootFromParent_Done,
     /* 122481 */   // Label 2283: @122481
     /* 122481 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(122525), // Rule ID 4520 //
     /* 122486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122504 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122507 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122523 */     GIR_RootConstrainSelectedInstOperands,
     /* 122524 */     // GIR_Coverage, 4520,
     /* 122524 */     GIR_EraseRootFromParent_Done,
     /* 122525 */   // Label 2284: @122525
     /* 122525 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(122545), // Rule ID 6372 //
     /* 122530 */     // MIs[0] Rn
     /* 122530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122538 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 122543 */     GIR_RootConstrainSelectedInstOperands,
     /* 122544 */     // GIR_Coverage, 6372,
     /* 122544 */     GIR_Done,
     /* 122545 */   // Label 2285: @122545
     /* 122545 */   GIM_Reject,
     /* 122546 */ // Label 2275: @122546
     /* 122546 */ GIM_Reject,
     /* 122547 */ // Label 2109: @122547
     /* 122547 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(122952),
     /* 122552 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122555 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122559 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(122608), // Rule ID 4446 //
     /* 122564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122582 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122585 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122606 */     GIR_RootConstrainSelectedInstOperands,
     /* 122607 */     // GIR_Coverage, 4446,
     /* 122607 */     GIR_EraseRootFromParent_Done,
     /* 122608 */   // Label 2287: @122608
     /* 122608 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(122657), // Rule ID 4447 //
     /* 122613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122631 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122634 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122655 */     GIR_RootConstrainSelectedInstOperands,
     /* 122656 */     // GIR_Coverage, 4447,
     /* 122656 */     GIR_EraseRootFromParent_Done,
     /* 122657 */   // Label 2288: @122657
     /* 122657 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(122706), // Rule ID 4450 //
     /* 122662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122680 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122683 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122704 */     GIR_RootConstrainSelectedInstOperands,
     /* 122705 */     // GIR_Coverage, 4450,
     /* 122705 */     GIR_EraseRootFromParent_Done,
     /* 122706 */   // Label 2289: @122706
     /* 122706 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(122755), // Rule ID 4451 //
     /* 122711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122729 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122732 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122753 */     GIR_RootConstrainSelectedInstOperands,
     /* 122754 */     // GIR_Coverage, 4451,
     /* 122754 */     GIR_EraseRootFromParent_Done,
     /* 122755 */   // Label 2290: @122755
     /* 122755 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(122799), // Rule ID 4486 //
     /* 122760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122778 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122781 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122797 */     GIR_RootConstrainSelectedInstOperands,
     /* 122798 */     // GIR_Coverage, 4486,
     /* 122798 */     GIR_EraseRootFromParent_Done,
     /* 122799 */   // Label 2291: @122799
     /* 122799 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(122843), // Rule ID 4488 //
     /* 122804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122822 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122825 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122841 */     GIR_RootConstrainSelectedInstOperands,
     /* 122842 */     // GIR_Coverage, 4488,
     /* 122842 */     GIR_EraseRootFromParent_Done,
     /* 122843 */   // Label 2292: @122843
     /* 122843 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(122887), // Rule ID 4510 //
     /* 122848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122866 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122869 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122885 */     GIR_RootConstrainSelectedInstOperands,
     /* 122886 */     // GIR_Coverage, 4510,
     /* 122886 */     GIR_EraseRootFromParent_Done,
     /* 122887 */   // Label 2293: @122887
     /* 122887 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(122931), // Rule ID 4512 //
     /* 122892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122910 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122929 */     GIR_RootConstrainSelectedInstOperands,
     /* 122930 */     // GIR_Coverage, 4512,
     /* 122930 */     GIR_EraseRootFromParent_Done,
     /* 122931 */   // Label 2294: @122931
     /* 122931 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(122951), // Rule ID 6374 //
     /* 122936 */     // MIs[0] Rn
     /* 122936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122944 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 122949 */     GIR_RootConstrainSelectedInstOperands,
     /* 122950 */     // GIR_Coverage, 6374,
     /* 122950 */     GIR_Done,
     /* 122951 */   // Label 2295: @122951
     /* 122951 */   GIM_Reject,
     /* 122952 */ // Label 2286: @122952
     /* 122952 */ GIM_Reject,
     /* 122953 */ // Label 2110: @122953
     /* 122953 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(123358),
     /* 122958 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122961 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122965 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(123014), // Rule ID 4460 //
     /* 122970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122988 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122991 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123012 */     GIR_RootConstrainSelectedInstOperands,
     /* 123013 */     // GIR_Coverage, 4460,
     /* 123013 */     GIR_EraseRootFromParent_Done,
     /* 123014 */   // Label 2297: @123014
     /* 123014 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(123063), // Rule ID 4461 //
     /* 123019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123026 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123037 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123040 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123061 */     GIR_RootConstrainSelectedInstOperands,
     /* 123062 */     // GIR_Coverage, 4461,
     /* 123062 */     GIR_EraseRootFromParent_Done,
     /* 123063 */   // Label 2298: @123063
     /* 123063 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(123112), // Rule ID 4462 //
     /* 123068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123086 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123089 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123110 */     GIR_RootConstrainSelectedInstOperands,
     /* 123111 */     // GIR_Coverage, 4462,
     /* 123111 */     GIR_EraseRootFromParent_Done,
     /* 123112 */   // Label 2299: @123112
     /* 123112 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(123161), // Rule ID 4463 //
     /* 123117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123135 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123138 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123159 */     GIR_RootConstrainSelectedInstOperands,
     /* 123160 */     // GIR_Coverage, 4463,
     /* 123160 */     GIR_EraseRootFromParent_Done,
     /* 123161 */   // Label 2300: @123161
     /* 123161 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(123205), // Rule ID 4490 //
     /* 123166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123184 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123187 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123203 */     GIR_RootConstrainSelectedInstOperands,
     /* 123204 */     // GIR_Coverage, 4490,
     /* 123204 */     GIR_EraseRootFromParent_Done,
     /* 123205 */   // Label 2301: @123205
     /* 123205 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(123249), // Rule ID 4494 //
     /* 123210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123228 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123231 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123247 */     GIR_RootConstrainSelectedInstOperands,
     /* 123248 */     // GIR_Coverage, 4494,
     /* 123248 */     GIR_EraseRootFromParent_Done,
     /* 123249 */   // Label 2302: @123249
     /* 123249 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(123293), // Rule ID 4514 //
     /* 123254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123272 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123275 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123291 */     GIR_RootConstrainSelectedInstOperands,
     /* 123292 */     // GIR_Coverage, 4514,
     /* 123292 */     GIR_EraseRootFromParent_Done,
     /* 123293 */   // Label 2303: @123293
     /* 123293 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(123337), // Rule ID 4518 //
     /* 123298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123316 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123319 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123335 */     GIR_RootConstrainSelectedInstOperands,
     /* 123336 */     // GIR_Coverage, 4518,
     /* 123336 */     GIR_EraseRootFromParent_Done,
     /* 123337 */   // Label 2304: @123337
     /* 123337 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(123357), // Rule ID 6371 //
     /* 123342 */     // MIs[0] Rn
     /* 123342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123350 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 123355 */     GIR_RootConstrainSelectedInstOperands,
     /* 123356 */     // GIR_Coverage, 6371,
     /* 123356 */     GIR_Done,
     /* 123357 */   // Label 2305: @123357
     /* 123357 */   GIM_Reject,
     /* 123358 */ // Label 2296: @123358
     /* 123358 */ GIM_Reject,
     /* 123359 */ // Label 2111: @123359
     /* 123359 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(123578),
     /* 123364 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123367 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123371 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(123420), // Rule ID 4448 //
     /* 123376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123394 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123397 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123418 */     GIR_RootConstrainSelectedInstOperands,
     /* 123419 */     // GIR_Coverage, 4448,
     /* 123419 */     GIR_EraseRootFromParent_Done,
     /* 123420 */   // Label 2307: @123420
     /* 123420 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(123469), // Rule ID 4449 //
     /* 123425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123443 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123446 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123467 */     GIR_RootConstrainSelectedInstOperands,
     /* 123468 */     // GIR_Coverage, 4449,
     /* 123468 */     GIR_EraseRootFromParent_Done,
     /* 123469 */   // Label 2308: @123469
     /* 123469 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(123513), // Rule ID 4485 //
     /* 123474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123492 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123495 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123511 */     GIR_RootConstrainSelectedInstOperands,
     /* 123512 */     // GIR_Coverage, 4485,
     /* 123512 */     GIR_EraseRootFromParent_Done,
     /* 123513 */   // Label 2309: @123513
     /* 123513 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(123557), // Rule ID 4509 //
     /* 123518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123536 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123539 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123555 */     GIR_RootConstrainSelectedInstOperands,
     /* 123556 */     // GIR_Coverage, 4509,
     /* 123556 */     GIR_EraseRootFromParent_Done,
     /* 123557 */   // Label 2310: @123557
     /* 123557 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(123577), // Rule ID 6373 //
     /* 123562 */     // MIs[0] Rn
     /* 123562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123570 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 123575 */     GIR_RootConstrainSelectedInstOperands,
     /* 123576 */     // GIR_Coverage, 6373,
     /* 123576 */     GIR_Done,
     /* 123577 */   // Label 2311: @123577
     /* 123577 */   GIM_Reject,
     /* 123578 */ // Label 2306: @123578
     /* 123578 */ GIM_Reject,
     /* 123579 */ // Label 2112: @123579
     /* 123579 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(123984),
     /* 123584 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123587 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123591 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(123640), // Rule ID 4464 //
     /* 123596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123614 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123617 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123638 */     GIR_RootConstrainSelectedInstOperands,
     /* 123639 */     // GIR_Coverage, 4464,
     /* 123639 */     GIR_EraseRootFromParent_Done,
     /* 123640 */   // Label 2313: @123640
     /* 123640 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(123689), // Rule ID 4465 //
     /* 123645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123663 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123666 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123687 */     GIR_RootConstrainSelectedInstOperands,
     /* 123688 */     // GIR_Coverage, 4465,
     /* 123688 */     GIR_EraseRootFromParent_Done,
     /* 123689 */   // Label 2314: @123689
     /* 123689 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(123738), // Rule ID 4468 //
     /* 123694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123712 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123715 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123736 */     GIR_RootConstrainSelectedInstOperands,
     /* 123737 */     // GIR_Coverage, 4468,
     /* 123737 */     GIR_EraseRootFromParent_Done,
     /* 123738 */   // Label 2315: @123738
     /* 123738 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(123787), // Rule ID 4469 //
     /* 123743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123761 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123764 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123785 */     GIR_RootConstrainSelectedInstOperands,
     /* 123786 */     // GIR_Coverage, 4469,
     /* 123786 */     GIR_EraseRootFromParent_Done,
     /* 123787 */   // Label 2316: @123787
     /* 123787 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(123831), // Rule ID 4493 //
     /* 123792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123810 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123813 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123829 */     GIR_RootConstrainSelectedInstOperands,
     /* 123830 */     // GIR_Coverage, 4493,
     /* 123830 */     GIR_EraseRootFromParent_Done,
     /* 123831 */   // Label 2317: @123831
     /* 123831 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(123875), // Rule ID 4496 //
     /* 123836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123854 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123857 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123873 */     GIR_RootConstrainSelectedInstOperands,
     /* 123874 */     // GIR_Coverage, 4496,
     /* 123874 */     GIR_EraseRootFromParent_Done,
     /* 123875 */   // Label 2318: @123875
     /* 123875 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(123919), // Rule ID 4517 //
     /* 123880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123898 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123901 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123917 */     GIR_RootConstrainSelectedInstOperands,
     /* 123918 */     // GIR_Coverage, 4517,
     /* 123918 */     GIR_EraseRootFromParent_Done,
     /* 123919 */   // Label 2319: @123919
     /* 123919 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(123963), // Rule ID 4521 //
     /* 123924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123942 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123945 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123961 */     GIR_RootConstrainSelectedInstOperands,
     /* 123962 */     // GIR_Coverage, 4521,
     /* 123962 */     GIR_EraseRootFromParent_Done,
     /* 123963 */   // Label 2320: @123963
     /* 123963 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(123983), // Rule ID 6370 //
     /* 123968 */     // MIs[0] Rn
     /* 123968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123976 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 123981 */     GIR_RootConstrainSelectedInstOperands,
     /* 123982 */     // GIR_Coverage, 6370,
     /* 123982 */     GIR_Done,
     /* 123983 */   // Label 2321: @123983
     /* 123983 */   GIM_Reject,
     /* 123984 */ // Label 2312: @123984
     /* 123984 */ GIM_Reject,
     /* 123985 */ // Label 2113: @123985
     /* 123985 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(124204),
     /* 123990 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123993 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123997 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(124046), // Rule ID 4466 //
     /* 124002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124020 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124023 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124044 */     GIR_RootConstrainSelectedInstOperands,
     /* 124045 */     // GIR_Coverage, 4466,
     /* 124045 */     GIR_EraseRootFromParent_Done,
     /* 124046 */   // Label 2323: @124046
     /* 124046 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(124095), // Rule ID 4467 //
     /* 124051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124069 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124072 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124093 */     GIR_RootConstrainSelectedInstOperands,
     /* 124094 */     // GIR_Coverage, 4467,
     /* 124094 */     GIR_EraseRootFromParent_Done,
     /* 124095 */   // Label 2324: @124095
     /* 124095 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(124139), // Rule ID 4492 //
     /* 124100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124118 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124121 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124137 */     GIR_RootConstrainSelectedInstOperands,
     /* 124138 */     // GIR_Coverage, 4492,
     /* 124138 */     GIR_EraseRootFromParent_Done,
     /* 124139 */   // Label 2325: @124139
     /* 124139 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(124183), // Rule ID 4516 //
     /* 124144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124162 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124165 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124181 */     GIR_RootConstrainSelectedInstOperands,
     /* 124182 */     // GIR_Coverage, 4516,
     /* 124182 */     GIR_EraseRootFromParent_Done,
     /* 124183 */   // Label 2326: @124183
     /* 124183 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(124203), // Rule ID 6369 //
     /* 124188 */     // MIs[0] Rn
     /* 124188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124196 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 124201 */     GIR_RootConstrainSelectedInstOperands,
     /* 124202 */     // GIR_Coverage, 6369,
     /* 124202 */     GIR_Done,
     /* 124203 */   // Label 2327: @124203
     /* 124203 */   GIM_Reject,
     /* 124204 */ // Label 2322: @124204
     /* 124204 */ GIM_Reject,
     /* 124205 */ // Label 2114: @124205
     /* 124205 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(124264), // Rule ID 10803 //
     /* 124210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124216 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124220 */   // MIs[0] base
     /* 124220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124228 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124240 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 124248 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124253 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124262 */   GIR_RootConstrainSelectedInstOperands,
     /* 124263 */   // GIR_Coverage, 10803,
     /* 124263 */   GIR_EraseRootFromParent_Done,
     /* 124264 */ // Label 2328: @124264
     /* 124264 */ GIM_Reject,
     /* 124265 */ // Label 2115: @124265
     /* 124265 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(124324), // Rule ID 10809 //
     /* 124270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124273 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124276 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124280 */   // MIs[0] base
     /* 124280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124288 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124300 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 124308 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124313 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124322 */   GIR_RootConstrainSelectedInstOperands,
     /* 124323 */   // GIR_Coverage, 10809,
     /* 124323 */   GIR_EraseRootFromParent_Done,
     /* 124324 */ // Label 2329: @124324
     /* 124324 */ GIM_Reject,
     /* 124325 */ // Label 2116: @124325
     /* 124325 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(124494),
     /* 124330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124341 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(124389), // Rule ID 10794 //
     /* 124346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124353 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124365 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124373 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124378 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124387 */     GIR_RootConstrainSelectedInstOperands,
     /* 124388 */     // GIR_Coverage, 10794,
     /* 124388 */     GIR_EraseRootFromParent_Done,
     /* 124389 */   // Label 2331: @124389
     /* 124389 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(124437), // Rule ID 10812 //
     /* 124394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124401 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124421 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124426 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124435 */     GIR_RootConstrainSelectedInstOperands,
     /* 124436 */     // GIR_Coverage, 10812,
     /* 124436 */     GIR_EraseRootFromParent_Done,
     /* 124437 */   // Label 2332: @124437
     /* 124437 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(124465), // Rule ID 10924 //
     /* 124442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124449 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124452 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124454 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124463 */     GIR_RootConstrainSelectedInstOperands,
     /* 124464 */     // GIR_Coverage, 10924,
     /* 124464 */     GIR_EraseRootFromParent_Done,
     /* 124465 */   // Label 2333: @124465
     /* 124465 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(124493), // Rule ID 10936 //
     /* 124470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124477 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124480 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124482 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124491 */     GIR_RootConstrainSelectedInstOperands,
     /* 124492 */     // GIR_Coverage, 10936,
     /* 124492 */     GIR_EraseRootFromParent_Done,
     /* 124493 */   // Label 2334: @124493
     /* 124493 */   GIM_Reject,
     /* 124494 */ // Label 2330: @124494
     /* 124494 */ GIM_Reject,
     /* 124495 */ // Label 2117: @124495
     /* 124495 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(124554), // Rule ID 10800 //
     /* 124500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124510 */   // MIs[0] base
     /* 124510 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124518 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 124538 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124543 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124548 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124552 */   GIR_RootConstrainSelectedInstOperands,
     /* 124553 */   // GIR_Coverage, 10800,
     /* 124553 */   GIR_EraseRootFromParent_Done,
     /* 124554 */ // Label 2335: @124554
     /* 124554 */ GIM_Reject,
     /* 124555 */ // Label 2118: @124555
     /* 124555 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(124724),
     /* 124560 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124563 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124571 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(124619), // Rule ID 10788 //
     /* 124576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124583 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 124603 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124608 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124617 */     GIR_RootConstrainSelectedInstOperands,
     /* 124618 */     // GIR_Coverage, 10788,
     /* 124618 */     GIR_EraseRootFromParent_Done,
     /* 124619 */   // Label 2337: @124619
     /* 124619 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(124667), // Rule ID 10806 //
     /* 124624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124631 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124643 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 124651 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124656 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124665 */     GIR_RootConstrainSelectedInstOperands,
     /* 124666 */     // GIR_Coverage, 10806,
     /* 124666 */     GIR_EraseRootFromParent_Done,
     /* 124667 */   // Label 2338: @124667
     /* 124667 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(124695), // Rule ID 10920 //
     /* 124672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124679 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124682 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124684 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124693 */     GIR_RootConstrainSelectedInstOperands,
     /* 124694 */     // GIR_Coverage, 10920,
     /* 124694 */     GIR_EraseRootFromParent_Done,
     /* 124695 */   // Label 2339: @124695
     /* 124695 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(124723), // Rule ID 10932 //
     /* 124700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124707 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124710 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124712 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124721 */     GIR_RootConstrainSelectedInstOperands,
     /* 124722 */     // GIR_Coverage, 10932,
     /* 124722 */     GIR_EraseRootFromParent_Done,
     /* 124723 */   // Label 2340: @124723
     /* 124723 */   GIM_Reject,
     /* 124724 */ // Label 2336: @124724
     /* 124724 */ GIM_Reject,
     /* 124725 */ // Label 2119: @124725
     /* 124725 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(124894),
     /* 124730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124733 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124737 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124741 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(124789), // Rule ID 10779 //
     /* 124746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124753 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124765 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124773 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124778 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124787 */     GIR_RootConstrainSelectedInstOperands,
     /* 124788 */     // GIR_Coverage, 10779,
     /* 124788 */     GIR_EraseRootFromParent_Done,
     /* 124789 */   // Label 2342: @124789
     /* 124789 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(124837), // Rule ID 10797 //
     /* 124794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124801 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 124808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124813 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 124821 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124826 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124835 */     GIR_RootConstrainSelectedInstOperands,
     /* 124836 */     // GIR_Coverage, 10797,
     /* 124836 */     GIR_EraseRootFromParent_Done,
     /* 124837 */   // Label 2343: @124837
     /* 124837 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(124865), // Rule ID 10916 //
     /* 124842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124849 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124852 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124854 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124863 */     GIR_RootConstrainSelectedInstOperands,
     /* 124864 */     // GIR_Coverage, 10916,
     /* 124864 */     GIR_EraseRootFromParent_Done,
     /* 124865 */   // Label 2344: @124865
     /* 124865 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(124893), // Rule ID 10928 //
     /* 124870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124877 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124880 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124882 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124891 */     GIR_RootConstrainSelectedInstOperands,
     /* 124892 */     // GIR_Coverage, 10928,
     /* 124892 */     GIR_EraseRootFromParent_Done,
     /* 124893 */   // Label 2345: @124893
     /* 124893 */   GIM_Reject,
     /* 124894 */ // Label 2341: @124894
     /* 124894 */ GIM_Reject,
     /* 124895 */ // Label 2120: @124895
     /* 124895 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(124938), // Rule ID 2430 //
     /* 124900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 124914 */   // MIs[0] base
     /* 124914 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124922 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 124925 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 124927 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124936 */   GIR_RootConstrainSelectedInstOperands,
     /* 124937 */   // GIR_Coverage, 2430,
     /* 124937 */   GIR_EraseRootFromParent_Done,
     /* 124938 */ // Label 2346: @124938
     /* 124938 */ GIM_Reject,
     /* 124939 */ // Label 2121: @124939
     /* 124939 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(125032),
     /* 124944 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124947 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124955 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(125003), // Rule ID 10765 //
     /* 124960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124967 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 124974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 124987 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124992 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125001 */     GIR_RootConstrainSelectedInstOperands,
     /* 125002 */     // GIR_Coverage, 10765,
     /* 125002 */     GIR_EraseRootFromParent_Done,
     /* 125003 */   // Label 2348: @125003
     /* 125003 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(125031), // Rule ID 10912 //
     /* 125008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125015 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125018 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125020 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125029 */     GIR_RootConstrainSelectedInstOperands,
     /* 125030 */     // GIR_Coverage, 10912,
     /* 125030 */     GIR_EraseRootFromParent_Done,
     /* 125031 */   // Label 2349: @125031
     /* 125031 */   GIM_Reject,
     /* 125032 */ // Label 2347: @125032
     /* 125032 */ GIM_Reject,
     /* 125033 */ // Label 2122: @125033
     /* 125033 */ GIM_Reject,
     /* 125034 */ // Label 20: @125034
     /* 125034 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2352*/ GIMT_Encode4(126384),
     /* 125045 */ /*GILLT_s32*//*Label 2350*/ GIMT_Encode4(125053),
     /* 125049 */ /*GILLT_s64*//*Label 2351*/ GIMT_Encode4(126071),
     /* 125053 */ // Label 2350: @125053
     /* 125053 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(126070),
     /* 125058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125064 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(125119), // Rule ID 7271 //
     /* 125069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125072 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125086 */     // MIs[0] Rn
     /* 125086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125102 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 125105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125117 */     GIR_RootConstrainSelectedInstOperands,
     /* 125118 */     // GIR_Coverage, 7271,
     /* 125118 */     GIR_EraseRootFromParent_Done,
     /* 125119 */   // Label 2354: @125119
     /* 125119 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(125174), // Rule ID 7272 //
     /* 125124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125127 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125134 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125141 */     // MIs[0] Rn
     /* 125141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125157 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 125160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125172 */     GIR_RootConstrainSelectedInstOperands,
     /* 125173 */     // GIR_Coverage, 7272,
     /* 125173 */     GIR_EraseRootFromParent_Done,
     /* 125174 */   // Label 2355: @125174
     /* 125174 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(125229), // Rule ID 7273 //
     /* 125179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125196 */     // MIs[0] Rn
     /* 125196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125212 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 125215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125227 */     GIR_RootConstrainSelectedInstOperands,
     /* 125228 */     // GIR_Coverage, 7273,
     /* 125228 */     GIR_EraseRootFromParent_Done,
     /* 125229 */   // Label 2356: @125229
     /* 125229 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(125284), // Rule ID 7274 //
     /* 125234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125251 */     // MIs[0] Rn
     /* 125251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125267 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125282 */     GIR_RootConstrainSelectedInstOperands,
     /* 125283 */     // GIR_Coverage, 7274,
     /* 125283 */     GIR_EraseRootFromParent_Done,
     /* 125284 */   // Label 2357: @125284
     /* 125284 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(125339), // Rule ID 7275 //
     /* 125289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125306 */     // MIs[0] Rn
     /* 125306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125322 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125337 */     GIR_RootConstrainSelectedInstOperands,
     /* 125338 */     // GIR_Coverage, 7275,
     /* 125338 */     GIR_EraseRootFromParent_Done,
     /* 125339 */   // Label 2358: @125339
     /* 125339 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(125394), // Rule ID 7276 //
     /* 125344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125354 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125361 */     // MIs[0] Rn
     /* 125361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125377 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 125380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125392 */     GIR_RootConstrainSelectedInstOperands,
     /* 125393 */     // GIR_Coverage, 7276,
     /* 125393 */     GIR_EraseRootFromParent_Done,
     /* 125394 */   // Label 2359: @125394
     /* 125394 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(125449), // Rule ID 7277 //
     /* 125399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125402 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125416 */     // MIs[0] Rn
     /* 125416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125432 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 125435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125447 */     GIR_RootConstrainSelectedInstOperands,
     /* 125448 */     // GIR_Coverage, 7277,
     /* 125448 */     GIR_EraseRootFromParent_Done,
     /* 125449 */   // Label 2360: @125449
     /* 125449 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(125504), // Rule ID 7278 //
     /* 125454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125457 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125464 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125471 */     // MIs[0] Rn
     /* 125471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125487 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 125490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125502 */     GIR_RootConstrainSelectedInstOperands,
     /* 125503 */     // GIR_Coverage, 7278,
     /* 125503 */     GIR_EraseRootFromParent_Done,
     /* 125504 */   // Label 2361: @125504
     /* 125504 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(125559), // Rule ID 7279 //
     /* 125509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125512 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125519 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125526 */     // MIs[0] Rn
     /* 125526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125542 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 125545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125557 */     GIR_RootConstrainSelectedInstOperands,
     /* 125558 */     // GIR_Coverage, 7279,
     /* 125558 */     GIR_EraseRootFromParent_Done,
     /* 125559 */   // Label 2362: @125559
     /* 125559 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(125614), // Rule ID 7280 //
     /* 125564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125581 */     // MIs[0] Rn
     /* 125581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125597 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 125600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125612 */     GIR_RootConstrainSelectedInstOperands,
     /* 125613 */     // GIR_Coverage, 7280,
     /* 125613 */     GIR_EraseRootFromParent_Done,
     /* 125614 */   // Label 2363: @125614
     /* 125614 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(125669), // Rule ID 7281 //
     /* 125619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125636 */     // MIs[0] Rn
     /* 125636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125652 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 125655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125667 */     GIR_RootConstrainSelectedInstOperands,
     /* 125668 */     // GIR_Coverage, 7281,
     /* 125668 */     GIR_EraseRootFromParent_Done,
     /* 125669 */   // Label 2364: @125669
     /* 125669 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(125724), // Rule ID 7282 //
     /* 125674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125677 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125684 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125691 */     // MIs[0] Rn
     /* 125691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125707 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 125710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125722 */     GIR_RootConstrainSelectedInstOperands,
     /* 125723 */     // GIR_Coverage, 7282,
     /* 125723 */     GIR_EraseRootFromParent_Done,
     /* 125724 */   // Label 2365: @125724
     /* 125724 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(125779), // Rule ID 7283 //
     /* 125729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125732 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125739 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125746 */     // MIs[0] Rn
     /* 125746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125762 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 125765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125777 */     GIR_RootConstrainSelectedInstOperands,
     /* 125778 */     // GIR_Coverage, 7283,
     /* 125778 */     GIR_EraseRootFromParent_Done,
     /* 125779 */   // Label 2366: @125779
     /* 125779 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(125834), // Rule ID 7284 //
     /* 125784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125787 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125801 */     // MIs[0] Rn
     /* 125801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125817 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125832 */     GIR_RootConstrainSelectedInstOperands,
     /* 125833 */     // GIR_Coverage, 7284,
     /* 125833 */     GIR_EraseRootFromParent_Done,
     /* 125834 */   // Label 2367: @125834
     /* 125834 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(125889), // Rule ID 7285 //
     /* 125839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125842 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125849 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125856 */     // MIs[0] Rn
     /* 125856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125872 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 125875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125887 */     GIR_RootConstrainSelectedInstOperands,
     /* 125888 */     // GIR_Coverage, 7285,
     /* 125888 */     GIR_EraseRootFromParent_Done,
     /* 125889 */   // Label 2368: @125889
     /* 125889 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(125949), // Rule ID 13043 //
     /* 125894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125908 */     // MIs[0] addr
     /* 125908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125924 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 125924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 125930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125932 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125937 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125939 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 125941 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 125943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125947 */     GIR_RootConstrainSelectedInstOperands,
     /* 125948 */     // GIR_Coverage, 13043,
     /* 125948 */     GIR_EraseRootFromParent_Done,
     /* 125949 */   // Label 2369: @125949
     /* 125949 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(126009), // Rule ID 13044 //
     /* 125954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 125957 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125968 */     // MIs[0] addr
     /* 125968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125984 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 125984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 125987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 125990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 125992 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 125997 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 125999 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126001 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126007 */     GIR_RootConstrainSelectedInstOperands,
     /* 126008 */     // GIR_Coverage, 13044,
     /* 126008 */     GIR_EraseRootFromParent_Done,
     /* 126009 */   // Label 2370: @126009
     /* 126009 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(126069), // Rule ID 13045 //
     /* 126014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126017 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126028 */     // MIs[0] addr
     /* 126028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126044 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 126050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126052 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126057 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126059 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126061 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126067 */     GIR_RootConstrainSelectedInstOperands,
     /* 126068 */     // GIR_Coverage, 13045,
     /* 126068 */     GIR_EraseRootFromParent_Done,
     /* 126069 */   // Label 2371: @126069
     /* 126069 */   GIM_Reject,
     /* 126070 */ // Label 2353: @126070
     /* 126070 */ GIM_Reject,
     /* 126071 */ // Label 2351: @126071
     /* 126071 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(126383),
     /* 126076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 126079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 126082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 126089 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(126137), // Rule ID 2589 //
     /* 126094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126104 */     // MIs[0] Rn
     /* 126104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126120 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 126123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126135 */     GIR_RootConstrainSelectedInstOperands,
     /* 126136 */     // GIR_Coverage, 2589,
     /* 126136 */     GIR_EraseRootFromParent_Done,
     /* 126137 */   // Label 2373: @126137
     /* 126137 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(126185), // Rule ID 2590 //
     /* 126142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126152 */     // MIs[0] Rn
     /* 126152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126168 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 126171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126183 */     GIR_RootConstrainSelectedInstOperands,
     /* 126184 */     // GIR_Coverage, 2590,
     /* 126184 */     GIR_EraseRootFromParent_Done,
     /* 126185 */   // Label 2374: @126185
     /* 126185 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(126233), // Rule ID 2591 //
     /* 126190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126200 */     // MIs[0] Rn
     /* 126200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126216 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 126219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126231 */     GIR_RootConstrainSelectedInstOperands,
     /* 126232 */     // GIR_Coverage, 2591,
     /* 126232 */     GIR_EraseRootFromParent_Done,
     /* 126233 */   // Label 2375: @126233
     /* 126233 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(126281), // Rule ID 2592 //
     /* 126238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126248 */     // MIs[0] Rn
     /* 126248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126264 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126279 */     GIR_RootConstrainSelectedInstOperands,
     /* 126280 */     // GIR_Coverage, 2592,
     /* 126280 */     GIR_EraseRootFromParent_Done,
     /* 126281 */   // Label 2376: @126281
     /* 126281 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(126329), // Rule ID 2593 //
     /* 126286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126289 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126296 */     // MIs[0] Rn
     /* 126296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126312 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126327 */     GIR_RootConstrainSelectedInstOperands,
     /* 126328 */     // GIR_Coverage, 2593,
     /* 126328 */     GIR_EraseRootFromParent_Done,
     /* 126329 */   // Label 2377: @126329
     /* 126329 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(126382), // Rule ID 13046 //
     /* 126334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126341 */     // MIs[0] addr
     /* 126341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126357 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 126357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 126363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126365 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126370 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126372 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126374 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126380 */     GIR_RootConstrainSelectedInstOperands,
     /* 126381 */     // GIR_Coverage, 13046,
     /* 126381 */     GIR_EraseRootFromParent_Done,
     /* 126382 */   // Label 2378: @126382
     /* 126382 */   GIM_Reject,
     /* 126383 */ // Label 2372: @126383
     /* 126383 */ GIM_Reject,
     /* 126384 */ // Label 2352: @126384
     /* 126384 */ GIM_Reject,
     /* 126385 */ // Label 21: @126385
     /* 126385 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2381*/ GIMT_Encode4(127376),
     /* 126396 */ /*GILLT_s32*//*Label 2379*/ GIMT_Encode4(126404),
     /* 126400 */ /*GILLT_s64*//*Label 2380*/ GIMT_Encode4(127149),
     /* 126404 */ // Label 2379: @126404
     /* 126404 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(127148),
     /* 126409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126412 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(126461), // Rule ID 7256 //
     /* 126417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126434 */     // MIs[0] Rn
     /* 126434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126446 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 126449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126459 */     GIR_RootConstrainSelectedInstOperands,
     /* 126460 */     // GIR_Coverage, 7256,
     /* 126460 */     GIR_EraseRootFromParent_Done,
     /* 126461 */   // Label 2383: @126461
     /* 126461 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(126510), // Rule ID 7257 //
     /* 126466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126483 */     // MIs[0] Rn
     /* 126483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126495 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 126498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126508 */     GIR_RootConstrainSelectedInstOperands,
     /* 126509 */     // GIR_Coverage, 7257,
     /* 126509 */     GIR_EraseRootFromParent_Done,
     /* 126510 */   // Label 2384: @126510
     /* 126510 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(126559), // Rule ID 7258 //
     /* 126515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126532 */     // MIs[0] Rn
     /* 126532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126544 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 126547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126557 */     GIR_RootConstrainSelectedInstOperands,
     /* 126558 */     // GIR_Coverage, 7258,
     /* 126558 */     GIR_EraseRootFromParent_Done,
     /* 126559 */   // Label 2385: @126559
     /* 126559 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(126608), // Rule ID 7259 //
     /* 126564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126581 */     // MIs[0] Rn
     /* 126581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126593 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 126596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126606 */     GIR_RootConstrainSelectedInstOperands,
     /* 126607 */     // GIR_Coverage, 7259,
     /* 126607 */     GIR_EraseRootFromParent_Done,
     /* 126608 */   // Label 2386: @126608
     /* 126608 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(126657), // Rule ID 7260 //
     /* 126613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126630 */     // MIs[0] Rn
     /* 126630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126642 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 126645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126655 */     GIR_RootConstrainSelectedInstOperands,
     /* 126656 */     // GIR_Coverage, 7260,
     /* 126656 */     GIR_EraseRootFromParent_Done,
     /* 126657 */   // Label 2387: @126657
     /* 126657 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(126706), // Rule ID 7261 //
     /* 126662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126679 */     // MIs[0] Rn
     /* 126679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126691 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 126694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126704 */     GIR_RootConstrainSelectedInstOperands,
     /* 126705 */     // GIR_Coverage, 7261,
     /* 126705 */     GIR_EraseRootFromParent_Done,
     /* 126706 */   // Label 2388: @126706
     /* 126706 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(126755), // Rule ID 7262 //
     /* 126711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126714 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126721 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126728 */     // MIs[0] Rn
     /* 126728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126740 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 126743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126753 */     GIR_RootConstrainSelectedInstOperands,
     /* 126754 */     // GIR_Coverage, 7262,
     /* 126754 */     GIR_EraseRootFromParent_Done,
     /* 126755 */   // Label 2389: @126755
     /* 126755 */   GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(126804), // Rule ID 7263 //
     /* 126760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126763 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126777 */     // MIs[0] Rn
     /* 126777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126789 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 126792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126802 */     GIR_RootConstrainSelectedInstOperands,
     /* 126803 */     // GIR_Coverage, 7263,
     /* 126803 */     GIR_EraseRootFromParent_Done,
     /* 126804 */   // Label 2390: @126804
     /* 126804 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(126853), // Rule ID 7264 //
     /* 126809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126812 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126826 */     // MIs[0] Rn
     /* 126826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126838 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126851 */     GIR_RootConstrainSelectedInstOperands,
     /* 126852 */     // GIR_Coverage, 7264,
     /* 126852 */     GIR_EraseRootFromParent_Done,
     /* 126853 */   // Label 2391: @126853
     /* 126853 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(126902), // Rule ID 7265 //
     /* 126858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126875 */     // MIs[0] Rn
     /* 126875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126887 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 126890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126900 */     GIR_RootConstrainSelectedInstOperands,
     /* 126901 */     // GIR_Coverage, 7265,
     /* 126901 */     GIR_EraseRootFromParent_Done,
     /* 126902 */   // Label 2392: @126902
     /* 126902 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(126951), // Rule ID 7266 //
     /* 126907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126910 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126917 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126924 */     // MIs[0] Rn
     /* 126924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126936 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 126939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126949 */     GIR_RootConstrainSelectedInstOperands,
     /* 126950 */     // GIR_Coverage, 7266,
     /* 126950 */     GIR_EraseRootFromParent_Done,
     /* 126951 */   // Label 2393: @126951
     /* 126951 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(127000), // Rule ID 7267 //
     /* 126956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126973 */     // MIs[0] Rn
     /* 126973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126985 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 126988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126998 */     GIR_RootConstrainSelectedInstOperands,
     /* 126999 */     // GIR_Coverage, 7267,
     /* 126999 */     GIR_EraseRootFromParent_Done,
     /* 127000 */   // Label 2394: @127000
     /* 127000 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(127049), // Rule ID 7268 //
     /* 127005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127022 */     // MIs[0] Rn
     /* 127022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127034 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 127037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127047 */     GIR_RootConstrainSelectedInstOperands,
     /* 127048 */     // GIR_Coverage, 7268,
     /* 127048 */     GIR_EraseRootFromParent_Done,
     /* 127049 */   // Label 2395: @127049
     /* 127049 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(127098), // Rule ID 7269 //
     /* 127054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127071 */     // MIs[0] Rn
     /* 127071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127083 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127096 */     GIR_RootConstrainSelectedInstOperands,
     /* 127097 */     // GIR_Coverage, 7269,
     /* 127097 */     GIR_EraseRootFromParent_Done,
     /* 127098 */   // Label 2396: @127098
     /* 127098 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(127147), // Rule ID 7270 //
     /* 127103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127120 */     // MIs[0] Rn
     /* 127120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127132 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127145 */     GIR_RootConstrainSelectedInstOperands,
     /* 127146 */     // GIR_Coverage, 7270,
     /* 127146 */     GIR_EraseRootFromParent_Done,
     /* 127147 */   // Label 2397: @127147
     /* 127147 */   GIM_Reject,
     /* 127148 */ // Label 2382: @127148
     /* 127148 */ GIM_Reject,
     /* 127149 */ // Label 2380: @127149
     /* 127149 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(127375),
     /* 127154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127157 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127164 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(127206), // Rule ID 7251 //
     /* 127169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127179 */     // MIs[0] Rn
     /* 127179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127191 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 127194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127204 */     GIR_RootConstrainSelectedInstOperands,
     /* 127205 */     // GIR_Coverage, 7251,
     /* 127205 */     GIR_EraseRootFromParent_Done,
     /* 127206 */   // Label 2399: @127206
     /* 127206 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(127248), // Rule ID 7252 //
     /* 127211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127221 */     // MIs[0] Rn
     /* 127221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127233 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 127236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127246 */     GIR_RootConstrainSelectedInstOperands,
     /* 127247 */     // GIR_Coverage, 7252,
     /* 127247 */     GIR_EraseRootFromParent_Done,
     /* 127248 */   // Label 2400: @127248
     /* 127248 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(127290), // Rule ID 7253 //
     /* 127253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127263 */     // MIs[0] Rn
     /* 127263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127275 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 127278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127288 */     GIR_RootConstrainSelectedInstOperands,
     /* 127289 */     // GIR_Coverage, 7253,
     /* 127289 */     GIR_EraseRootFromParent_Done,
     /* 127290 */   // Label 2401: @127290
     /* 127290 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(127332), // Rule ID 7254 //
     /* 127295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127305 */     // MIs[0] Rn
     /* 127305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127317 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127330 */     GIR_RootConstrainSelectedInstOperands,
     /* 127331 */     // GIR_Coverage, 7254,
     /* 127331 */     GIR_EraseRootFromParent_Done,
     /* 127332 */   // Label 2402: @127332
     /* 127332 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(127374), // Rule ID 7255 //
     /* 127337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127347 */     // MIs[0] Rn
     /* 127347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127359 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127372 */     GIR_RootConstrainSelectedInstOperands,
     /* 127373 */     // GIR_Coverage, 7255,
     /* 127373 */     GIR_EraseRootFromParent_Done,
     /* 127374 */   // Label 2403: @127374
     /* 127374 */   GIM_Reject,
     /* 127375 */ // Label 2398: @127375
     /* 127375 */ GIM_Reject,
     /* 127376 */ // Label 2381: @127376
     /* 127376 */ GIM_Reject,
     /* 127377 */ // Label 22: @127377
     /* 127377 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2406*/ GIMT_Encode4(128368),
     /* 127388 */ /*GILLT_s32*//*Label 2404*/ GIMT_Encode4(127396),
     /* 127392 */ /*GILLT_s64*//*Label 2405*/ GIMT_Encode4(128141),
     /* 127396 */ // Label 2404: @127396
     /* 127396 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(128140),
     /* 127401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127404 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(127453), // Rule ID 7096 //
     /* 127409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127426 */     // MIs[0] Rn
     /* 127426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127438 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 127441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127451 */     GIR_RootConstrainSelectedInstOperands,
     /* 127452 */     // GIR_Coverage, 7096,
     /* 127452 */     GIR_EraseRootFromParent_Done,
     /* 127453 */   // Label 2408: @127453
     /* 127453 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(127502), // Rule ID 7097 //
     /* 127458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127475 */     // MIs[0] Rn
     /* 127475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127487 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 127490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127500 */     GIR_RootConstrainSelectedInstOperands,
     /* 127501 */     // GIR_Coverage, 7097,
     /* 127501 */     GIR_EraseRootFromParent_Done,
     /* 127502 */   // Label 2409: @127502
     /* 127502 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(127551), // Rule ID 7098 //
     /* 127507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127524 */     // MIs[0] Rn
     /* 127524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127536 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 127539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127549 */     GIR_RootConstrainSelectedInstOperands,
     /* 127550 */     // GIR_Coverage, 7098,
     /* 127550 */     GIR_EraseRootFromParent_Done,
     /* 127551 */   // Label 2410: @127551
     /* 127551 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(127600), // Rule ID 7099 //
     /* 127556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127573 */     // MIs[0] Rn
     /* 127573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127585 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 127588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127598 */     GIR_RootConstrainSelectedInstOperands,
     /* 127599 */     // GIR_Coverage, 7099,
     /* 127599 */     GIR_EraseRootFromParent_Done,
     /* 127600 */   // Label 2411: @127600
     /* 127600 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(127649), // Rule ID 7100 //
     /* 127605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127622 */     // MIs[0] Rn
     /* 127622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127634 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 127637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127647 */     GIR_RootConstrainSelectedInstOperands,
     /* 127648 */     // GIR_Coverage, 7100,
     /* 127648 */     GIR_EraseRootFromParent_Done,
     /* 127649 */   // Label 2412: @127649
     /* 127649 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(127698), // Rule ID 7101 //
     /* 127654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127671 */     // MIs[0] Rn
     /* 127671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127683 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 127686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127696 */     GIR_RootConstrainSelectedInstOperands,
     /* 127697 */     // GIR_Coverage, 7101,
     /* 127697 */     GIR_EraseRootFromParent_Done,
     /* 127698 */   // Label 2413: @127698
     /* 127698 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(127747), // Rule ID 7102 //
     /* 127703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127720 */     // MIs[0] Rn
     /* 127720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127732 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 127735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127745 */     GIR_RootConstrainSelectedInstOperands,
     /* 127746 */     // GIR_Coverage, 7102,
     /* 127746 */     GIR_EraseRootFromParent_Done,
     /* 127747 */   // Label 2414: @127747
     /* 127747 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(127796), // Rule ID 7103 //
     /* 127752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127769 */     // MIs[0] Rn
     /* 127769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127781 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 127784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127794 */     GIR_RootConstrainSelectedInstOperands,
     /* 127795 */     // GIR_Coverage, 7103,
     /* 127795 */     GIR_EraseRootFromParent_Done,
     /* 127796 */   // Label 2415: @127796
     /* 127796 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(127845), // Rule ID 7104 //
     /* 127801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127818 */     // MIs[0] Rn
     /* 127818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127830 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127843 */     GIR_RootConstrainSelectedInstOperands,
     /* 127844 */     // GIR_Coverage, 7104,
     /* 127844 */     GIR_EraseRootFromParent_Done,
     /* 127845 */   // Label 2416: @127845
     /* 127845 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(127894), // Rule ID 7105 //
     /* 127850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127853 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127867 */     // MIs[0] Rn
     /* 127867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127879 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 127882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127892 */     GIR_RootConstrainSelectedInstOperands,
     /* 127893 */     // GIR_Coverage, 7105,
     /* 127893 */     GIR_EraseRootFromParent_Done,
     /* 127894 */   // Label 2417: @127894
     /* 127894 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(127943), // Rule ID 7106 //
     /* 127899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127916 */     // MIs[0] Rn
     /* 127916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127928 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 127931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127941 */     GIR_RootConstrainSelectedInstOperands,
     /* 127942 */     // GIR_Coverage, 7106,
     /* 127942 */     GIR_EraseRootFromParent_Done,
     /* 127943 */   // Label 2418: @127943
     /* 127943 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(127992), // Rule ID 7107 //
     /* 127948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127965 */     // MIs[0] Rn
     /* 127965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127977 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 127980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127990 */     GIR_RootConstrainSelectedInstOperands,
     /* 127991 */     // GIR_Coverage, 7107,
     /* 127991 */     GIR_EraseRootFromParent_Done,
     /* 127992 */   // Label 2419: @127992
     /* 127992 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(128041), // Rule ID 7108 //
     /* 127997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128014 */     // MIs[0] Rn
     /* 128014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128026 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 128029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128039 */     GIR_RootConstrainSelectedInstOperands,
     /* 128040 */     // GIR_Coverage, 7108,
     /* 128040 */     GIR_EraseRootFromParent_Done,
     /* 128041 */   // Label 2420: @128041
     /* 128041 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(128090), // Rule ID 7109 //
     /* 128046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128063 */     // MIs[0] Rn
     /* 128063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128075 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128088 */     GIR_RootConstrainSelectedInstOperands,
     /* 128089 */     // GIR_Coverage, 7109,
     /* 128089 */     GIR_EraseRootFromParent_Done,
     /* 128090 */   // Label 2421: @128090
     /* 128090 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(128139), // Rule ID 7110 //
     /* 128095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128112 */     // MIs[0] Rn
     /* 128112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128124 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128137 */     GIR_RootConstrainSelectedInstOperands,
     /* 128138 */     // GIR_Coverage, 7110,
     /* 128138 */     GIR_EraseRootFromParent_Done,
     /* 128139 */   // Label 2422: @128139
     /* 128139 */   GIM_Reject,
     /* 128140 */ // Label 2407: @128140
     /* 128140 */ GIM_Reject,
     /* 128141 */ // Label 2405: @128141
     /* 128141 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(128367),
     /* 128146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128149 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128156 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(128198), // Rule ID 2579 //
     /* 128161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128171 */     // MIs[0] Rn
     /* 128171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128183 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 128186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128196 */     GIR_RootConstrainSelectedInstOperands,
     /* 128197 */     // GIR_Coverage, 2579,
     /* 128197 */     GIR_EraseRootFromParent_Done,
     /* 128198 */   // Label 2424: @128198
     /* 128198 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(128240), // Rule ID 2580 //
     /* 128203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128213 */     // MIs[0] Rn
     /* 128213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128225 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 128228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128238 */     GIR_RootConstrainSelectedInstOperands,
     /* 128239 */     // GIR_Coverage, 2580,
     /* 128239 */     GIR_EraseRootFromParent_Done,
     /* 128240 */   // Label 2425: @128240
     /* 128240 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(128282), // Rule ID 2581 //
     /* 128245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128248 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128255 */     // MIs[0] Rn
     /* 128255 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128267 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 128270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128280 */     GIR_RootConstrainSelectedInstOperands,
     /* 128281 */     // GIR_Coverage, 2581,
     /* 128281 */     GIR_EraseRootFromParent_Done,
     /* 128282 */   // Label 2426: @128282
     /* 128282 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(128324), // Rule ID 2582 //
     /* 128287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128290 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128297 */     // MIs[0] Rn
     /* 128297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128309 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128322 */     GIR_RootConstrainSelectedInstOperands,
     /* 128323 */     // GIR_Coverage, 2582,
     /* 128323 */     GIR_EraseRootFromParent_Done,
     /* 128324 */   // Label 2427: @128324
     /* 128324 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(128366), // Rule ID 2583 //
     /* 128329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128339 */     // MIs[0] Rn
     /* 128339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128351 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128364 */     GIR_RootConstrainSelectedInstOperands,
     /* 128365 */     // GIR_Coverage, 2583,
     /* 128365 */     GIR_EraseRootFromParent_Done,
     /* 128366 */   // Label 2428: @128366
     /* 128366 */   GIM_Reject,
     /* 128367 */ // Label 2423: @128367
     /* 128367 */ GIM_Reject,
     /* 128368 */ // Label 2406: @128368
     /* 128368 */ GIM_Reject,
     /* 128369 */ // Label 23: @128369
     /* 128369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2431*/ GIMT_Encode4(129860),
     /* 128380 */ /*GILLT_s32*//*Label 2429*/ GIMT_Encode4(128388),
     /* 128384 */ /*GILLT_s64*//*Label 2430*/ GIMT_Encode4(129508),
     /* 128388 */ // Label 2429: @128388
     /* 128388 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(129507),
     /* 128393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128396 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(128470), // Rule ID 7291 //
     /* 128401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128418 */     // MIs[0] Rn
     /* 128418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128430 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128442 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 128457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128468 */     GIR_RootConstrainSelectedInstOperands,
     /* 128469 */     // GIR_Coverage, 7291,
     /* 128469 */     GIR_EraseRootFromParent_Done,
     /* 128470 */   // Label 2433: @128470
     /* 128470 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(128544), // Rule ID 7292 //
     /* 128475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128478 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128492 */     // MIs[0] Rn
     /* 128492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128504 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128516 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 128531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128542 */     GIR_RootConstrainSelectedInstOperands,
     /* 128543 */     // GIR_Coverage, 7292,
     /* 128543 */     GIR_EraseRootFromParent_Done,
     /* 128544 */   // Label 2434: @128544
     /* 128544 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(128618), // Rule ID 7293 //
     /* 128549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128552 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128566 */     // MIs[0] Rn
     /* 128566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128578 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128590 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 128605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128616 */     GIR_RootConstrainSelectedInstOperands,
     /* 128617 */     // GIR_Coverage, 7293,
     /* 128617 */     GIR_EraseRootFromParent_Done,
     /* 128618 */   // Label 2435: @128618
     /* 128618 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(128692), // Rule ID 7294 //
     /* 128623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128626 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128640 */     // MIs[0] Rn
     /* 128640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128652 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128664 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128690 */     GIR_RootConstrainSelectedInstOperands,
     /* 128691 */     // GIR_Coverage, 7294,
     /* 128691 */     GIR_EraseRootFromParent_Done,
     /* 128692 */   // Label 2436: @128692
     /* 128692 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(128766), // Rule ID 7295 //
     /* 128697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128707 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128714 */     // MIs[0] Rn
     /* 128714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128726 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128738 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128764 */     GIR_RootConstrainSelectedInstOperands,
     /* 128765 */     // GIR_Coverage, 7295,
     /* 128765 */     GIR_EraseRootFromParent_Done,
     /* 128766 */   // Label 2437: @128766
     /* 128766 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(128840), // Rule ID 7296 //
     /* 128771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128788 */     // MIs[0] Rn
     /* 128788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128800 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128812 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128838 */     GIR_RootConstrainSelectedInstOperands,
     /* 128839 */     // GIR_Coverage, 7296,
     /* 128839 */     GIR_EraseRootFromParent_Done,
     /* 128840 */   // Label 2438: @128840
     /* 128840 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(128914), // Rule ID 7297 //
     /* 128845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128862 */     // MIs[0] Rn
     /* 128862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128874 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128886 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128912 */     GIR_RootConstrainSelectedInstOperands,
     /* 128913 */     // GIR_Coverage, 7297,
     /* 128913 */     GIR_EraseRootFromParent_Done,
     /* 128914 */   // Label 2439: @128914
     /* 128914 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(128988), // Rule ID 7298 //
     /* 128919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128922 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128929 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128936 */     // MIs[0] Rn
     /* 128936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128948 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128960 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128966 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 128975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128986 */     GIR_RootConstrainSelectedInstOperands,
     /* 128987 */     // GIR_Coverage, 7298,
     /* 128987 */     GIR_EraseRootFromParent_Done,
     /* 128988 */   // Label 2440: @128988
     /* 128988 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129062), // Rule ID 7299 //
     /* 128993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129010 */     // MIs[0] Rn
     /* 129010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129022 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129034 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129060 */     GIR_RootConstrainSelectedInstOperands,
     /* 129061 */     // GIR_Coverage, 7299,
     /* 129061 */     GIR_EraseRootFromParent_Done,
     /* 129062 */   // Label 2441: @129062
     /* 129062 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(129136), // Rule ID 7300 //
     /* 129067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129084 */     // MIs[0] Rn
     /* 129084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129096 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129108 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129134 */     GIR_RootConstrainSelectedInstOperands,
     /* 129135 */     // GIR_Coverage, 7300,
     /* 129135 */     GIR_EraseRootFromParent_Done,
     /* 129136 */   // Label 2442: @129136
     /* 129136 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(129210), // Rule ID 7301 //
     /* 129141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129158 */     // MIs[0] Rn
     /* 129158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129170 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129182 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 129197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129208 */     GIR_RootConstrainSelectedInstOperands,
     /* 129209 */     // GIR_Coverage, 7301,
     /* 129209 */     GIR_EraseRootFromParent_Done,
     /* 129210 */   // Label 2443: @129210
     /* 129210 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129284), // Rule ID 7302 //
     /* 129215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129232 */     // MIs[0] Rn
     /* 129232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129244 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129256 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 129271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129282 */     GIR_RootConstrainSelectedInstOperands,
     /* 129283 */     // GIR_Coverage, 7302,
     /* 129283 */     GIR_EraseRootFromParent_Done,
     /* 129284 */   // Label 2444: @129284
     /* 129284 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(129358), // Rule ID 7303 //
     /* 129289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129306 */     // MIs[0] Rn
     /* 129306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129318 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129330 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 129345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129356 */     GIR_RootConstrainSelectedInstOperands,
     /* 129357 */     // GIR_Coverage, 7303,
     /* 129357 */     GIR_EraseRootFromParent_Done,
     /* 129358 */   // Label 2445: @129358
     /* 129358 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(129432), // Rule ID 7304 //
     /* 129363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129366 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129380 */     // MIs[0] Rn
     /* 129380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129392 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129404 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129430 */     GIR_RootConstrainSelectedInstOperands,
     /* 129431 */     // GIR_Coverage, 7304,
     /* 129431 */     GIR_EraseRootFromParent_Done,
     /* 129432 */   // Label 2446: @129432
     /* 129432 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(129506), // Rule ID 7305 //
     /* 129437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129454 */     // MIs[0] Rn
     /* 129454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129466 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129478 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129504 */     GIR_RootConstrainSelectedInstOperands,
     /* 129505 */     // GIR_Coverage, 7305,
     /* 129505 */     GIR_EraseRootFromParent_Done,
     /* 129506 */   // Label 2447: @129506
     /* 129506 */   GIM_Reject,
     /* 129507 */ // Label 2432: @129507
     /* 129507 */ GIM_Reject,
     /* 129508 */ // Label 2430: @129508
     /* 129508 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(129859),
     /* 129513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 129516 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 129523 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(129590), // Rule ID 7286 //
     /* 129528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129538 */     // MIs[0] Rn
     /* 129538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129550 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129562 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129568 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 129577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129588 */     GIR_RootConstrainSelectedInstOperands,
     /* 129589 */     // GIR_Coverage, 7286,
     /* 129589 */     GIR_EraseRootFromParent_Done,
     /* 129590 */   // Label 2449: @129590
     /* 129590 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(129657), // Rule ID 7287 //
     /* 129595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129598 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129605 */     // MIs[0] Rn
     /* 129605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129617 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129629 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 129644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129655 */     GIR_RootConstrainSelectedInstOperands,
     /* 129656 */     // GIR_Coverage, 7287,
     /* 129656 */     GIR_EraseRootFromParent_Done,
     /* 129657 */   // Label 2450: @129657
     /* 129657 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(129724), // Rule ID 7288 //
     /* 129662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129672 */     // MIs[0] Rn
     /* 129672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129684 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129696 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 129711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129722 */     GIR_RootConstrainSelectedInstOperands,
     /* 129723 */     // GIR_Coverage, 7288,
     /* 129723 */     GIR_EraseRootFromParent_Done,
     /* 129724 */   // Label 2451: @129724
     /* 129724 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(129791), // Rule ID 7289 //
     /* 129729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129739 */     // MIs[0] Rn
     /* 129739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129751 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129763 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129789 */     GIR_RootConstrainSelectedInstOperands,
     /* 129790 */     // GIR_Coverage, 7289,
     /* 129790 */     GIR_EraseRootFromParent_Done,
     /* 129791 */   // Label 2452: @129791
     /* 129791 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(129858), // Rule ID 7290 //
     /* 129796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129806 */     // MIs[0] Rn
     /* 129806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 129818 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 129821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 129825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129830 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 129845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129856 */     GIR_RootConstrainSelectedInstOperands,
     /* 129857 */     // GIR_Coverage, 7290,
     /* 129857 */     GIR_EraseRootFromParent_Done,
     /* 129858 */   // Label 2453: @129858
     /* 129858 */   GIM_Reject,
     /* 129859 */ // Label 2448: @129859
     /* 129859 */ GIM_Reject,
     /* 129860 */ // Label 2431: @129860
     /* 129860 */ GIM_Reject,
     /* 129861 */ // Label 24: @129861
     /* 129861 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2456*/ GIMT_Encode4(131352),
     /* 129872 */ /*GILLT_s32*//*Label 2454*/ GIMT_Encode4(129880),
     /* 129876 */ /*GILLT_s64*//*Label 2455*/ GIMT_Encode4(131000),
     /* 129880 */ // Label 2454: @129880
     /* 129880 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(130999),
     /* 129885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 129888 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(129962), // Rule ID 7311 //
     /* 129893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129910 */     // MIs[0] Rn
     /* 129910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129922 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 129929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129934 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129940 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 129949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129960 */     GIR_RootConstrainSelectedInstOperands,
     /* 129961 */     // GIR_Coverage, 7311,
     /* 129961 */     GIR_EraseRootFromParent_Done,
     /* 129962 */   // Label 2458: @129962
     /* 129962 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(130036), // Rule ID 7312 //
     /* 129967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129984 */     // MIs[0] Rn
     /* 129984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129996 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130008 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 130023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130034 */     GIR_RootConstrainSelectedInstOperands,
     /* 130035 */     // GIR_Coverage, 7312,
     /* 130035 */     GIR_EraseRootFromParent_Done,
     /* 130036 */   // Label 2459: @130036
     /* 130036 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(130110), // Rule ID 7313 //
     /* 130041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130058 */     // MIs[0] Rn
     /* 130058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130070 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130082 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 130097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130108 */     GIR_RootConstrainSelectedInstOperands,
     /* 130109 */     // GIR_Coverage, 7313,
     /* 130109 */     GIR_EraseRootFromParent_Done,
     /* 130110 */   // Label 2460: @130110
     /* 130110 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(130184), // Rule ID 7314 //
     /* 130115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130118 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130132 */     // MIs[0] Rn
     /* 130132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130144 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130156 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130182 */     GIR_RootConstrainSelectedInstOperands,
     /* 130183 */     // GIR_Coverage, 7314,
     /* 130183 */     GIR_EraseRootFromParent_Done,
     /* 130184 */   // Label 2461: @130184
     /* 130184 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(130258), // Rule ID 7315 //
     /* 130189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130192 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130199 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130206 */     // MIs[0] Rn
     /* 130206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130218 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130230 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130256 */     GIR_RootConstrainSelectedInstOperands,
     /* 130257 */     // GIR_Coverage, 7315,
     /* 130257 */     GIR_EraseRootFromParent_Done,
     /* 130258 */   // Label 2462: @130258
     /* 130258 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(130332), // Rule ID 7316 //
     /* 130263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130266 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130273 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130280 */     // MIs[0] Rn
     /* 130280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130292 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130304 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 130319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130330 */     GIR_RootConstrainSelectedInstOperands,
     /* 130331 */     // GIR_Coverage, 7316,
     /* 130331 */     GIR_EraseRootFromParent_Done,
     /* 130332 */   // Label 2463: @130332
     /* 130332 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(130406), // Rule ID 7317 //
     /* 130337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130340 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130347 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130354 */     // MIs[0] Rn
     /* 130354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130366 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130378 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 130393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130404 */     GIR_RootConstrainSelectedInstOperands,
     /* 130405 */     // GIR_Coverage, 7317,
     /* 130405 */     GIR_EraseRootFromParent_Done,
     /* 130406 */   // Label 2464: @130406
     /* 130406 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(130480), // Rule ID 7318 //
     /* 130411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130414 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130428 */     // MIs[0] Rn
     /* 130428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130440 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130452 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 130467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130478 */     GIR_RootConstrainSelectedInstOperands,
     /* 130479 */     // GIR_Coverage, 7318,
     /* 130479 */     GIR_EraseRootFromParent_Done,
     /* 130480 */   // Label 2465: @130480
     /* 130480 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(130554), // Rule ID 7319 //
     /* 130485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130488 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130502 */     // MIs[0] Rn
     /* 130502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130514 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130526 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130532 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 130541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130552 */     GIR_RootConstrainSelectedInstOperands,
     /* 130553 */     // GIR_Coverage, 7319,
     /* 130553 */     GIR_EraseRootFromParent_Done,
     /* 130554 */   // Label 2466: @130554
     /* 130554 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(130628), // Rule ID 7320 //
     /* 130559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130576 */     // MIs[0] Rn
     /* 130576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130588 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130600 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 130615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130626 */     GIR_RootConstrainSelectedInstOperands,
     /* 130627 */     // GIR_Coverage, 7320,
     /* 130627 */     GIR_EraseRootFromParent_Done,
     /* 130628 */   // Label 2467: @130628
     /* 130628 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(130702), // Rule ID 7321 //
     /* 130633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130650 */     // MIs[0] Rn
     /* 130650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130662 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130674 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 130689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130694 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130700 */     GIR_RootConstrainSelectedInstOperands,
     /* 130701 */     // GIR_Coverage, 7321,
     /* 130701 */     GIR_EraseRootFromParent_Done,
     /* 130702 */   // Label 2468: @130702
     /* 130702 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(130776), // Rule ID 7322 //
     /* 130707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130710 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130724 */     // MIs[0] Rn
     /* 130724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130736 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130748 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 130763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130774 */     GIR_RootConstrainSelectedInstOperands,
     /* 130775 */     // GIR_Coverage, 7322,
     /* 130775 */     GIR_EraseRootFromParent_Done,
     /* 130776 */   // Label 2469: @130776
     /* 130776 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(130850), // Rule ID 7323 //
     /* 130781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130798 */     // MIs[0] Rn
     /* 130798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130810 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130822 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130828 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 130837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130848 */     GIR_RootConstrainSelectedInstOperands,
     /* 130849 */     // GIR_Coverage, 7323,
     /* 130849 */     GIR_EraseRootFromParent_Done,
     /* 130850 */   // Label 2470: @130850
     /* 130850 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(130924), // Rule ID 7324 //
     /* 130855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130858 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130865 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130872 */     // MIs[0] Rn
     /* 130872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130884 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130896 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 130911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130922 */     GIR_RootConstrainSelectedInstOperands,
     /* 130923 */     // GIR_Coverage, 7324,
     /* 130923 */     GIR_EraseRootFromParent_Done,
     /* 130924 */   // Label 2471: @130924
     /* 130924 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(130998), // Rule ID 7325 //
     /* 130929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130932 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130939 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130946 */     // MIs[0] Rn
     /* 130946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130958 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130970 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 130985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130996 */     GIR_RootConstrainSelectedInstOperands,
     /* 130997 */     // GIR_Coverage, 7325,
     /* 130997 */     GIR_EraseRootFromParent_Done,
     /* 130998 */   // Label 2472: @130998
     /* 130998 */   GIM_Reject,
     /* 130999 */ // Label 2457: @130999
     /* 130999 */ GIM_Reject,
     /* 131000 */ // Label 2455: @131000
     /* 131000 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(131351),
     /* 131005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131008 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131015 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(131082), // Rule ID 7306 //
     /* 131020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131030 */     // MIs[0] Rn
     /* 131030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131042 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131054 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 131069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131080 */     GIR_RootConstrainSelectedInstOperands,
     /* 131081 */     // GIR_Coverage, 7306,
     /* 131081 */     GIR_EraseRootFromParent_Done,
     /* 131082 */   // Label 2474: @131082
     /* 131082 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(131149), // Rule ID 7307 //
     /* 131087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131097 */     // MIs[0] Rn
     /* 131097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131109 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131121 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 131136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131147 */     GIR_RootConstrainSelectedInstOperands,
     /* 131148 */     // GIR_Coverage, 7307,
     /* 131148 */     GIR_EraseRootFromParent_Done,
     /* 131149 */   // Label 2475: @131149
     /* 131149 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(131216), // Rule ID 7308 //
     /* 131154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131164 */     // MIs[0] Rn
     /* 131164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131176 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131188 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 131203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131214 */     GIR_RootConstrainSelectedInstOperands,
     /* 131215 */     // GIR_Coverage, 7308,
     /* 131215 */     GIR_EraseRootFromParent_Done,
     /* 131216 */   // Label 2476: @131216
     /* 131216 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(131283), // Rule ID 7309 //
     /* 131221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131224 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131231 */     // MIs[0] Rn
     /* 131231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131243 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131255 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131281 */     GIR_RootConstrainSelectedInstOperands,
     /* 131282 */     // GIR_Coverage, 7309,
     /* 131282 */     GIR_EraseRootFromParent_Done,
     /* 131283 */   // Label 2477: @131283
     /* 131283 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(131350), // Rule ID 7310 //
     /* 131288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131298 */     // MIs[0] Rn
     /* 131298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131310 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131322 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131328 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131348 */     GIR_RootConstrainSelectedInstOperands,
     /* 131349 */     // GIR_Coverage, 7310,
     /* 131349 */     GIR_EraseRootFromParent_Done,
     /* 131350 */   // Label 2478: @131350
     /* 131350 */   GIM_Reject,
     /* 131351 */ // Label 2473: @131351
     /* 131351 */ GIM_Reject,
     /* 131352 */ // Label 2456: @131352
     /* 131352 */ GIM_Reject,
     /* 131353 */ // Label 25: @131353
     /* 131353 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2481*/ GIMT_Encode4(132344),
     /* 131364 */ /*GILLT_s32*//*Label 2479*/ GIMT_Encode4(131372),
     /* 131368 */ /*GILLT_s64*//*Label 2480*/ GIMT_Encode4(132117),
     /* 131372 */ // Label 2479: @131372
     /* 131372 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(132116),
     /* 131377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131380 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(131429), // Rule ID 7116 //
     /* 131385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131388 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131402 */     // MIs[0] Rn
     /* 131402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131414 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 131417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131427 */     GIR_RootConstrainSelectedInstOperands,
     /* 131428 */     // GIR_Coverage, 7116,
     /* 131428 */     GIR_EraseRootFromParent_Done,
     /* 131429 */   // Label 2483: @131429
     /* 131429 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(131478), // Rule ID 7117 //
     /* 131434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131437 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131444 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131451 */     // MIs[0] Rn
     /* 131451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131463 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 131466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131476 */     GIR_RootConstrainSelectedInstOperands,
     /* 131477 */     // GIR_Coverage, 7117,
     /* 131477 */     GIR_EraseRootFromParent_Done,
     /* 131478 */   // Label 2484: @131478
     /* 131478 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(131527), // Rule ID 7118 //
     /* 131483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131500 */     // MIs[0] Rn
     /* 131500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131512 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 131515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131525 */     GIR_RootConstrainSelectedInstOperands,
     /* 131526 */     // GIR_Coverage, 7118,
     /* 131526 */     GIR_EraseRootFromParent_Done,
     /* 131527 */   // Label 2485: @131527
     /* 131527 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(131576), // Rule ID 7119 //
     /* 131532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131542 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131549 */     // MIs[0] Rn
     /* 131549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131561 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 131564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131574 */     GIR_RootConstrainSelectedInstOperands,
     /* 131575 */     // GIR_Coverage, 7119,
     /* 131575 */     GIR_EraseRootFromParent_Done,
     /* 131576 */   // Label 2486: @131576
     /* 131576 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(131625), // Rule ID 7120 //
     /* 131581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131598 */     // MIs[0] Rn
     /* 131598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131610 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 131613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131623 */     GIR_RootConstrainSelectedInstOperands,
     /* 131624 */     // GIR_Coverage, 7120,
     /* 131624 */     GIR_EraseRootFromParent_Done,
     /* 131625 */   // Label 2487: @131625
     /* 131625 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(131674), // Rule ID 7121 //
     /* 131630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131647 */     // MIs[0] Rn
     /* 131647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131659 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 131662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131672 */     GIR_RootConstrainSelectedInstOperands,
     /* 131673 */     // GIR_Coverage, 7121,
     /* 131673 */     GIR_EraseRootFromParent_Done,
     /* 131674 */   // Label 2488: @131674
     /* 131674 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(131723), // Rule ID 7122 //
     /* 131679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131696 */     // MIs[0] Rn
     /* 131696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131708 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 131711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131721 */     GIR_RootConstrainSelectedInstOperands,
     /* 131722 */     // GIR_Coverage, 7122,
     /* 131722 */     GIR_EraseRootFromParent_Done,
     /* 131723 */   // Label 2489: @131723
     /* 131723 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(131772), // Rule ID 7123 //
     /* 131728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131745 */     // MIs[0] Rn
     /* 131745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131757 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 131760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131770 */     GIR_RootConstrainSelectedInstOperands,
     /* 131771 */     // GIR_Coverage, 7123,
     /* 131771 */     GIR_EraseRootFromParent_Done,
     /* 131772 */   // Label 2490: @131772
     /* 131772 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(131821), // Rule ID 7124 //
     /* 131777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131794 */     // MIs[0] Rn
     /* 131794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131806 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131819 */     GIR_RootConstrainSelectedInstOperands,
     /* 131820 */     // GIR_Coverage, 7124,
     /* 131820 */     GIR_EraseRootFromParent_Done,
     /* 131821 */   // Label 2491: @131821
     /* 131821 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(131870), // Rule ID 7125 //
     /* 131826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131843 */     // MIs[0] Rn
     /* 131843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131855 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 131858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131868 */     GIR_RootConstrainSelectedInstOperands,
     /* 131869 */     // GIR_Coverage, 7125,
     /* 131869 */     GIR_EraseRootFromParent_Done,
     /* 131870 */   // Label 2492: @131870
     /* 131870 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(131919), // Rule ID 7126 //
     /* 131875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131892 */     // MIs[0] Rn
     /* 131892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131904 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 131907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131917 */     GIR_RootConstrainSelectedInstOperands,
     /* 131918 */     // GIR_Coverage, 7126,
     /* 131918 */     GIR_EraseRootFromParent_Done,
     /* 131919 */   // Label 2493: @131919
     /* 131919 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(131968), // Rule ID 7127 //
     /* 131924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131927 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131941 */     // MIs[0] Rn
     /* 131941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131953 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 131956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131966 */     GIR_RootConstrainSelectedInstOperands,
     /* 131967 */     // GIR_Coverage, 7127,
     /* 131967 */     GIR_EraseRootFromParent_Done,
     /* 131968 */   // Label 2494: @131968
     /* 131968 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(132017), // Rule ID 7128 //
     /* 131973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131990 */     // MIs[0] Rn
     /* 131990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132002 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 132005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132015 */     GIR_RootConstrainSelectedInstOperands,
     /* 132016 */     // GIR_Coverage, 7128,
     /* 132016 */     GIR_EraseRootFromParent_Done,
     /* 132017 */   // Label 2495: @132017
     /* 132017 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(132066), // Rule ID 7129 //
     /* 132022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132025 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132032 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132039 */     // MIs[0] Rn
     /* 132039 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132051 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132064 */     GIR_RootConstrainSelectedInstOperands,
     /* 132065 */     // GIR_Coverage, 7129,
     /* 132065 */     GIR_EraseRootFromParent_Done,
     /* 132066 */   // Label 2496: @132066
     /* 132066 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(132115), // Rule ID 7130 //
     /* 132071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132088 */     // MIs[0] Rn
     /* 132088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132100 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132113 */     GIR_RootConstrainSelectedInstOperands,
     /* 132114 */     // GIR_Coverage, 7130,
     /* 132114 */     GIR_EraseRootFromParent_Done,
     /* 132115 */   // Label 2497: @132115
     /* 132115 */   GIM_Reject,
     /* 132116 */ // Label 2482: @132116
     /* 132116 */ GIM_Reject,
     /* 132117 */ // Label 2480: @132117
     /* 132117 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(132343),
     /* 132122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132125 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132132 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(132174), // Rule ID 7111 //
     /* 132137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132147 */     // MIs[0] Rn
     /* 132147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132159 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 132162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132172 */     GIR_RootConstrainSelectedInstOperands,
     /* 132173 */     // GIR_Coverage, 7111,
     /* 132173 */     GIR_EraseRootFromParent_Done,
     /* 132174 */   // Label 2499: @132174
     /* 132174 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(132216), // Rule ID 7112 //
     /* 132179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132182 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132189 */     // MIs[0] Rn
     /* 132189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132201 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 132204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132214 */     GIR_RootConstrainSelectedInstOperands,
     /* 132215 */     // GIR_Coverage, 7112,
     /* 132215 */     GIR_EraseRootFromParent_Done,
     /* 132216 */   // Label 2500: @132216
     /* 132216 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(132258), // Rule ID 7113 //
     /* 132221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132224 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132231 */     // MIs[0] Rn
     /* 132231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132243 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 132246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132256 */     GIR_RootConstrainSelectedInstOperands,
     /* 132257 */     // GIR_Coverage, 7113,
     /* 132257 */     GIR_EraseRootFromParent_Done,
     /* 132258 */   // Label 2501: @132258
     /* 132258 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(132300), // Rule ID 7114 //
     /* 132263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132273 */     // MIs[0] Rn
     /* 132273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132285 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132298 */     GIR_RootConstrainSelectedInstOperands,
     /* 132299 */     // GIR_Coverage, 7114,
     /* 132299 */     GIR_EraseRootFromParent_Done,
     /* 132300 */   // Label 2502: @132300
     /* 132300 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(132342), // Rule ID 7115 //
     /* 132305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132315 */     // MIs[0] Rn
     /* 132315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132327 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132340 */     GIR_RootConstrainSelectedInstOperands,
     /* 132341 */     // GIR_Coverage, 7115,
     /* 132341 */     GIR_EraseRootFromParent_Done,
     /* 132342 */   // Label 2503: @132342
     /* 132342 */   GIM_Reject,
     /* 132343 */ // Label 2498: @132343
     /* 132343 */ GIM_Reject,
     /* 132344 */ // Label 2481: @132344
     /* 132344 */ GIM_Reject,
     /* 132345 */ // Label 26: @132345
     /* 132345 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2506*/ GIMT_Encode4(133336),
     /* 132356 */ /*GILLT_s32*//*Label 2504*/ GIMT_Encode4(132364),
     /* 132360 */ /*GILLT_s64*//*Label 2505*/ GIMT_Encode4(133109),
     /* 132364 */ // Label 2504: @132364
     /* 132364 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(133108),
     /* 132369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132372 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(132421), // Rule ID 7136 //
     /* 132377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132380 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132387 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132394 */     // MIs[0] Rn
     /* 132394 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132406 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 132409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132419 */     GIR_RootConstrainSelectedInstOperands,
     /* 132420 */     // GIR_Coverage, 7136,
     /* 132420 */     GIR_EraseRootFromParent_Done,
     /* 132421 */   // Label 2508: @132421
     /* 132421 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(132470), // Rule ID 7137 //
     /* 132426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132429 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132436 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132443 */     // MIs[0] Rn
     /* 132443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132455 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 132458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132468 */     GIR_RootConstrainSelectedInstOperands,
     /* 132469 */     // GIR_Coverage, 7137,
     /* 132469 */     GIR_EraseRootFromParent_Done,
     /* 132470 */   // Label 2509: @132470
     /* 132470 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(132519), // Rule ID 7138 //
     /* 132475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132478 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132492 */     // MIs[0] Rn
     /* 132492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132504 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 132507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132517 */     GIR_RootConstrainSelectedInstOperands,
     /* 132518 */     // GIR_Coverage, 7138,
     /* 132518 */     GIR_EraseRootFromParent_Done,
     /* 132519 */   // Label 2510: @132519
     /* 132519 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(132568), // Rule ID 7139 //
     /* 132524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132534 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132541 */     // MIs[0] Rn
     /* 132541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132553 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 132556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132566 */     GIR_RootConstrainSelectedInstOperands,
     /* 132567 */     // GIR_Coverage, 7139,
     /* 132567 */     GIR_EraseRootFromParent_Done,
     /* 132568 */   // Label 2511: @132568
     /* 132568 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(132617), // Rule ID 7140 //
     /* 132573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132590 */     // MIs[0] Rn
     /* 132590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132602 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 132605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132615 */     GIR_RootConstrainSelectedInstOperands,
     /* 132616 */     // GIR_Coverage, 7140,
     /* 132616 */     GIR_EraseRootFromParent_Done,
     /* 132617 */   // Label 2512: @132617
     /* 132617 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(132666), // Rule ID 7141 //
     /* 132622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132632 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132639 */     // MIs[0] Rn
     /* 132639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132651 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 132654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132664 */     GIR_RootConstrainSelectedInstOperands,
     /* 132665 */     // GIR_Coverage, 7141,
     /* 132665 */     GIR_EraseRootFromParent_Done,
     /* 132666 */   // Label 2513: @132666
     /* 132666 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(132715), // Rule ID 7142 //
     /* 132671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132688 */     // MIs[0] Rn
     /* 132688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132700 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 132703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132713 */     GIR_RootConstrainSelectedInstOperands,
     /* 132714 */     // GIR_Coverage, 7142,
     /* 132714 */     GIR_EraseRootFromParent_Done,
     /* 132715 */   // Label 2514: @132715
     /* 132715 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(132764), // Rule ID 7143 //
     /* 132720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132737 */     // MIs[0] Rn
     /* 132737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132749 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 132752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132762 */     GIR_RootConstrainSelectedInstOperands,
     /* 132763 */     // GIR_Coverage, 7143,
     /* 132763 */     GIR_EraseRootFromParent_Done,
     /* 132764 */   // Label 2515: @132764
     /* 132764 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(132813), // Rule ID 7144 //
     /* 132769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132786 */     // MIs[0] Rn
     /* 132786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132798 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132811 */     GIR_RootConstrainSelectedInstOperands,
     /* 132812 */     // GIR_Coverage, 7144,
     /* 132812 */     GIR_EraseRootFromParent_Done,
     /* 132813 */   // Label 2516: @132813
     /* 132813 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(132862), // Rule ID 7145 //
     /* 132818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132835 */     // MIs[0] Rn
     /* 132835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132847 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 132850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132860 */     GIR_RootConstrainSelectedInstOperands,
     /* 132861 */     // GIR_Coverage, 7145,
     /* 132861 */     GIR_EraseRootFromParent_Done,
     /* 132862 */   // Label 2517: @132862
     /* 132862 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(132911), // Rule ID 7146 //
     /* 132867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132884 */     // MIs[0] Rn
     /* 132884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132896 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 132899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132909 */     GIR_RootConstrainSelectedInstOperands,
     /* 132910 */     // GIR_Coverage, 7146,
     /* 132910 */     GIR_EraseRootFromParent_Done,
     /* 132911 */   // Label 2518: @132911
     /* 132911 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(132960), // Rule ID 7147 //
     /* 132916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132919 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132926 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132933 */     // MIs[0] Rn
     /* 132933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132945 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 132948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132958 */     GIR_RootConstrainSelectedInstOperands,
     /* 132959 */     // GIR_Coverage, 7147,
     /* 132959 */     GIR_EraseRootFromParent_Done,
     /* 132960 */   // Label 2519: @132960
     /* 132960 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(133009), // Rule ID 7148 //
     /* 132965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132968 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132975 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132982 */     // MIs[0] Rn
     /* 132982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132994 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 132997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133007 */     GIR_RootConstrainSelectedInstOperands,
     /* 133008 */     // GIR_Coverage, 7148,
     /* 133008 */     GIR_EraseRootFromParent_Done,
     /* 133009 */   // Label 2520: @133009
     /* 133009 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(133058), // Rule ID 7149 //
     /* 133014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133017 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133024 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133031 */     // MIs[0] Rn
     /* 133031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133043 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133056 */     GIR_RootConstrainSelectedInstOperands,
     /* 133057 */     // GIR_Coverage, 7149,
     /* 133057 */     GIR_EraseRootFromParent_Done,
     /* 133058 */   // Label 2521: @133058
     /* 133058 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(133107), // Rule ID 7150 //
     /* 133063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133080 */     // MIs[0] Rn
     /* 133080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133092 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133105 */     GIR_RootConstrainSelectedInstOperands,
     /* 133106 */     // GIR_Coverage, 7150,
     /* 133106 */     GIR_EraseRootFromParent_Done,
     /* 133107 */   // Label 2522: @133107
     /* 133107 */   GIM_Reject,
     /* 133108 */ // Label 2507: @133108
     /* 133108 */ GIM_Reject,
     /* 133109 */ // Label 2505: @133109
     /* 133109 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(133335),
     /* 133114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133117 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133124 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(133166), // Rule ID 7131 //
     /* 133129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133139 */     // MIs[0] Rn
     /* 133139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133151 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 133154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133164 */     GIR_RootConstrainSelectedInstOperands,
     /* 133165 */     // GIR_Coverage, 7131,
     /* 133165 */     GIR_EraseRootFromParent_Done,
     /* 133166 */   // Label 2524: @133166
     /* 133166 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(133208), // Rule ID 7132 //
     /* 133171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133174 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133181 */     // MIs[0] Rn
     /* 133181 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133193 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 133196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133206 */     GIR_RootConstrainSelectedInstOperands,
     /* 133207 */     // GIR_Coverage, 7132,
     /* 133207 */     GIR_EraseRootFromParent_Done,
     /* 133208 */   // Label 2525: @133208
     /* 133208 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(133250), // Rule ID 7133 //
     /* 133213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133216 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133223 */     // MIs[0] Rn
     /* 133223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133235 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 133238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133248 */     GIR_RootConstrainSelectedInstOperands,
     /* 133249 */     // GIR_Coverage, 7133,
     /* 133249 */     GIR_EraseRootFromParent_Done,
     /* 133250 */   // Label 2526: @133250
     /* 133250 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(133292), // Rule ID 7134 //
     /* 133255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133265 */     // MIs[0] Rn
     /* 133265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133277 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133290 */     GIR_RootConstrainSelectedInstOperands,
     /* 133291 */     // GIR_Coverage, 7134,
     /* 133291 */     GIR_EraseRootFromParent_Done,
     /* 133292 */   // Label 2527: @133292
     /* 133292 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(133334), // Rule ID 7135 //
     /* 133297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133307 */     // MIs[0] Rn
     /* 133307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133319 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133332 */     GIR_RootConstrainSelectedInstOperands,
     /* 133333 */     // GIR_Coverage, 7135,
     /* 133333 */     GIR_EraseRootFromParent_Done,
     /* 133334 */   // Label 2528: @133334
     /* 133334 */   GIM_Reject,
     /* 133335 */ // Label 2523: @133335
     /* 133335 */ GIM_Reject,
     /* 133336 */ // Label 2506: @133336
     /* 133336 */ GIM_Reject,
     /* 133337 */ // Label 27: @133337
     /* 133337 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2531*/ GIMT_Encode4(134328),
     /* 133348 */ /*GILLT_s32*//*Label 2529*/ GIMT_Encode4(133356),
     /* 133352 */ /*GILLT_s64*//*Label 2530*/ GIMT_Encode4(134101),
     /* 133356 */ // Label 2529: @133356
     /* 133356 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(134100),
     /* 133361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133364 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(133413), // Rule ID 7176 //
     /* 133369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133372 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133386 */     // MIs[0] Rn
     /* 133386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133398 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 133401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133411 */     GIR_RootConstrainSelectedInstOperands,
     /* 133412 */     // GIR_Coverage, 7176,
     /* 133412 */     GIR_EraseRootFromParent_Done,
     /* 133413 */   // Label 2533: @133413
     /* 133413 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(133462), // Rule ID 7177 //
     /* 133418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133421 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133428 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133435 */     // MIs[0] Rn
     /* 133435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133447 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 133450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133460 */     GIR_RootConstrainSelectedInstOperands,
     /* 133461 */     // GIR_Coverage, 7177,
     /* 133461 */     GIR_EraseRootFromParent_Done,
     /* 133462 */   // Label 2534: @133462
     /* 133462 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(133511), // Rule ID 7178 //
     /* 133467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133477 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133484 */     // MIs[0] Rn
     /* 133484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133496 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 133499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133509 */     GIR_RootConstrainSelectedInstOperands,
     /* 133510 */     // GIR_Coverage, 7178,
     /* 133510 */     GIR_EraseRootFromParent_Done,
     /* 133511 */   // Label 2535: @133511
     /* 133511 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(133560), // Rule ID 7179 //
     /* 133516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133519 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133526 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133533 */     // MIs[0] Rn
     /* 133533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133545 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 133548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133558 */     GIR_RootConstrainSelectedInstOperands,
     /* 133559 */     // GIR_Coverage, 7179,
     /* 133559 */     GIR_EraseRootFromParent_Done,
     /* 133560 */   // Label 2536: @133560
     /* 133560 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(133609), // Rule ID 7180 //
     /* 133565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133582 */     // MIs[0] Rn
     /* 133582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133594 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 133597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133607 */     GIR_RootConstrainSelectedInstOperands,
     /* 133608 */     // GIR_Coverage, 7180,
     /* 133608 */     GIR_EraseRootFromParent_Done,
     /* 133609 */   // Label 2537: @133609
     /* 133609 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(133658), // Rule ID 7181 //
     /* 133614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133617 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133631 */     // MIs[0] Rn
     /* 133631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133643 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 133646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133656 */     GIR_RootConstrainSelectedInstOperands,
     /* 133657 */     // GIR_Coverage, 7181,
     /* 133657 */     GIR_EraseRootFromParent_Done,
     /* 133658 */   // Label 2538: @133658
     /* 133658 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(133707), // Rule ID 7182 //
     /* 133663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133680 */     // MIs[0] Rn
     /* 133680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133692 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 133695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133705 */     GIR_RootConstrainSelectedInstOperands,
     /* 133706 */     // GIR_Coverage, 7182,
     /* 133706 */     GIR_EraseRootFromParent_Done,
     /* 133707 */   // Label 2539: @133707
     /* 133707 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(133756), // Rule ID 7183 //
     /* 133712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133729 */     // MIs[0] Rn
     /* 133729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133741 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 133744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133754 */     GIR_RootConstrainSelectedInstOperands,
     /* 133755 */     // GIR_Coverage, 7183,
     /* 133755 */     GIR_EraseRootFromParent_Done,
     /* 133756 */   // Label 2540: @133756
     /* 133756 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(133805), // Rule ID 7184 //
     /* 133761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133778 */     // MIs[0] Rn
     /* 133778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133790 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133803 */     GIR_RootConstrainSelectedInstOperands,
     /* 133804 */     // GIR_Coverage, 7184,
     /* 133804 */     GIR_EraseRootFromParent_Done,
     /* 133805 */   // Label 2541: @133805
     /* 133805 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(133854), // Rule ID 7185 //
     /* 133810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133827 */     // MIs[0] Rn
     /* 133827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133839 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 133842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133852 */     GIR_RootConstrainSelectedInstOperands,
     /* 133853 */     // GIR_Coverage, 7185,
     /* 133853 */     GIR_EraseRootFromParent_Done,
     /* 133854 */   // Label 2542: @133854
     /* 133854 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(133903), // Rule ID 7186 //
     /* 133859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133876 */     // MIs[0] Rn
     /* 133876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133888 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 133891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133901 */     GIR_RootConstrainSelectedInstOperands,
     /* 133902 */     // GIR_Coverage, 7186,
     /* 133902 */     GIR_EraseRootFromParent_Done,
     /* 133903 */   // Label 2543: @133903
     /* 133903 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(133952), // Rule ID 7187 //
     /* 133908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133925 */     // MIs[0] Rn
     /* 133925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133937 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 133940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133950 */     GIR_RootConstrainSelectedInstOperands,
     /* 133951 */     // GIR_Coverage, 7187,
     /* 133951 */     GIR_EraseRootFromParent_Done,
     /* 133952 */   // Label 2544: @133952
     /* 133952 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(134001), // Rule ID 7188 //
     /* 133957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133960 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133967 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133974 */     // MIs[0] Rn
     /* 133974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133986 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 133989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133999 */     GIR_RootConstrainSelectedInstOperands,
     /* 134000 */     // GIR_Coverage, 7188,
     /* 134000 */     GIR_EraseRootFromParent_Done,
     /* 134001 */   // Label 2545: @134001
     /* 134001 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(134050), // Rule ID 7189 //
     /* 134006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134009 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134023 */     // MIs[0] Rn
     /* 134023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134035 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134048 */     GIR_RootConstrainSelectedInstOperands,
     /* 134049 */     // GIR_Coverage, 7189,
     /* 134049 */     GIR_EraseRootFromParent_Done,
     /* 134050 */   // Label 2546: @134050
     /* 134050 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(134099), // Rule ID 7190 //
     /* 134055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134072 */     // MIs[0] Rn
     /* 134072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134084 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134097 */     GIR_RootConstrainSelectedInstOperands,
     /* 134098 */     // GIR_Coverage, 7190,
     /* 134098 */     GIR_EraseRootFromParent_Done,
     /* 134099 */   // Label 2547: @134099
     /* 134099 */   GIM_Reject,
     /* 134100 */ // Label 2532: @134100
     /* 134100 */ GIM_Reject,
     /* 134101 */ // Label 2530: @134101
     /* 134101 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(134327),
     /* 134106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134109 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134116 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(134158), // Rule ID 7171 //
     /* 134121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134131 */     // MIs[0] Rn
     /* 134131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134143 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 134146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134156 */     GIR_RootConstrainSelectedInstOperands,
     /* 134157 */     // GIR_Coverage, 7171,
     /* 134157 */     GIR_EraseRootFromParent_Done,
     /* 134158 */   // Label 2549: @134158
     /* 134158 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(134200), // Rule ID 7172 //
     /* 134163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134166 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134173 */     // MIs[0] Rn
     /* 134173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134185 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 134188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134198 */     GIR_RootConstrainSelectedInstOperands,
     /* 134199 */     // GIR_Coverage, 7172,
     /* 134199 */     GIR_EraseRootFromParent_Done,
     /* 134200 */   // Label 2550: @134200
     /* 134200 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(134242), // Rule ID 7173 //
     /* 134205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134215 */     // MIs[0] Rn
     /* 134215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134227 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 134230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134240 */     GIR_RootConstrainSelectedInstOperands,
     /* 134241 */     // GIR_Coverage, 7173,
     /* 134241 */     GIR_EraseRootFromParent_Done,
     /* 134242 */   // Label 2551: @134242
     /* 134242 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(134284), // Rule ID 7174 //
     /* 134247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134257 */     // MIs[0] Rn
     /* 134257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134269 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134282 */     GIR_RootConstrainSelectedInstOperands,
     /* 134283 */     // GIR_Coverage, 7174,
     /* 134283 */     GIR_EraseRootFromParent_Done,
     /* 134284 */   // Label 2552: @134284
     /* 134284 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(134326), // Rule ID 7175 //
     /* 134289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134292 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134299 */     // MIs[0] Rn
     /* 134299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134311 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134324 */     GIR_RootConstrainSelectedInstOperands,
     /* 134325 */     // GIR_Coverage, 7175,
     /* 134325 */     GIR_EraseRootFromParent_Done,
     /* 134326 */   // Label 2553: @134326
     /* 134326 */   GIM_Reject,
     /* 134327 */ // Label 2548: @134327
     /* 134327 */ GIM_Reject,
     /* 134328 */ // Label 2531: @134328
     /* 134328 */ GIM_Reject,
     /* 134329 */ // Label 28: @134329
     /* 134329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2556*/ GIMT_Encode4(135320),
     /* 134340 */ /*GILLT_s32*//*Label 2554*/ GIMT_Encode4(134348),
     /* 134344 */ /*GILLT_s64*//*Label 2555*/ GIMT_Encode4(135093),
     /* 134348 */ // Label 2554: @134348
     /* 134348 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(135092),
     /* 134353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134356 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(134405), // Rule ID 7196 //
     /* 134361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134364 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134371 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134378 */     // MIs[0] Rn
     /* 134378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134390 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 134393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134403 */     GIR_RootConstrainSelectedInstOperands,
     /* 134404 */     // GIR_Coverage, 7196,
     /* 134404 */     GIR_EraseRootFromParent_Done,
     /* 134405 */   // Label 2558: @134405
     /* 134405 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(134454), // Rule ID 7197 //
     /* 134410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134420 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134427 */     // MIs[0] Rn
     /* 134427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134439 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 134442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134452 */     GIR_RootConstrainSelectedInstOperands,
     /* 134453 */     // GIR_Coverage, 7197,
     /* 134453 */     GIR_EraseRootFromParent_Done,
     /* 134454 */   // Label 2559: @134454
     /* 134454 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(134503), // Rule ID 7198 //
     /* 134459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134462 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134469 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134476 */     // MIs[0] Rn
     /* 134476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134488 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 134491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134501 */     GIR_RootConstrainSelectedInstOperands,
     /* 134502 */     // GIR_Coverage, 7198,
     /* 134502 */     GIR_EraseRootFromParent_Done,
     /* 134503 */   // Label 2560: @134503
     /* 134503 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(134552), // Rule ID 7199 //
     /* 134508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134511 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134518 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134525 */     // MIs[0] Rn
     /* 134525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134537 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 134540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134550 */     GIR_RootConstrainSelectedInstOperands,
     /* 134551 */     // GIR_Coverage, 7199,
     /* 134551 */     GIR_EraseRootFromParent_Done,
     /* 134552 */   // Label 2561: @134552
     /* 134552 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(134601), // Rule ID 7200 //
     /* 134557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134560 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134567 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134574 */     // MIs[0] Rn
     /* 134574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134586 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 134589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134599 */     GIR_RootConstrainSelectedInstOperands,
     /* 134600 */     // GIR_Coverage, 7200,
     /* 134600 */     GIR_EraseRootFromParent_Done,
     /* 134601 */   // Label 2562: @134601
     /* 134601 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(134650), // Rule ID 7201 //
     /* 134606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134609 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134616 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134623 */     // MIs[0] Rn
     /* 134623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134635 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 134638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134648 */     GIR_RootConstrainSelectedInstOperands,
     /* 134649 */     // GIR_Coverage, 7201,
     /* 134649 */     GIR_EraseRootFromParent_Done,
     /* 134650 */   // Label 2563: @134650
     /* 134650 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(134699), // Rule ID 7202 //
     /* 134655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134658 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134672 */     // MIs[0] Rn
     /* 134672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134684 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 134687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134697 */     GIR_RootConstrainSelectedInstOperands,
     /* 134698 */     // GIR_Coverage, 7202,
     /* 134698 */     GIR_EraseRootFromParent_Done,
     /* 134699 */   // Label 2564: @134699
     /* 134699 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(134748), // Rule ID 7203 //
     /* 134704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134721 */     // MIs[0] Rn
     /* 134721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134733 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 134736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134746 */     GIR_RootConstrainSelectedInstOperands,
     /* 134747 */     // GIR_Coverage, 7203,
     /* 134747 */     GIR_EraseRootFromParent_Done,
     /* 134748 */   // Label 2565: @134748
     /* 134748 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(134797), // Rule ID 7204 //
     /* 134753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134770 */     // MIs[0] Rn
     /* 134770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134782 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134795 */     GIR_RootConstrainSelectedInstOperands,
     /* 134796 */     // GIR_Coverage, 7204,
     /* 134796 */     GIR_EraseRootFromParent_Done,
     /* 134797 */   // Label 2566: @134797
     /* 134797 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(134846), // Rule ID 7205 //
     /* 134802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134819 */     // MIs[0] Rn
     /* 134819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134831 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 134834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134844 */     GIR_RootConstrainSelectedInstOperands,
     /* 134845 */     // GIR_Coverage, 7205,
     /* 134845 */     GIR_EraseRootFromParent_Done,
     /* 134846 */   // Label 2567: @134846
     /* 134846 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(134895), // Rule ID 7206 //
     /* 134851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134868 */     // MIs[0] Rn
     /* 134868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134880 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 134883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134893 */     GIR_RootConstrainSelectedInstOperands,
     /* 134894 */     // GIR_Coverage, 7206,
     /* 134894 */     GIR_EraseRootFromParent_Done,
     /* 134895 */   // Label 2568: @134895
     /* 134895 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(134944), // Rule ID 7207 //
     /* 134900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134917 */     // MIs[0] Rn
     /* 134917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134929 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 134932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134942 */     GIR_RootConstrainSelectedInstOperands,
     /* 134943 */     // GIR_Coverage, 7207,
     /* 134943 */     GIR_EraseRootFromParent_Done,
     /* 134944 */   // Label 2569: @134944
     /* 134944 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(134993), // Rule ID 7208 //
     /* 134949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134966 */     // MIs[0] Rn
     /* 134966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134978 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 134981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134991 */     GIR_RootConstrainSelectedInstOperands,
     /* 134992 */     // GIR_Coverage, 7208,
     /* 134992 */     GIR_EraseRootFromParent_Done,
     /* 134993 */   // Label 2570: @134993
     /* 134993 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(135042), // Rule ID 7209 //
     /* 134998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135001 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135008 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135015 */     // MIs[0] Rn
     /* 135015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135027 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135040 */     GIR_RootConstrainSelectedInstOperands,
     /* 135041 */     // GIR_Coverage, 7209,
     /* 135041 */     GIR_EraseRootFromParent_Done,
     /* 135042 */   // Label 2571: @135042
     /* 135042 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(135091), // Rule ID 7210 //
     /* 135047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135064 */     // MIs[0] Rn
     /* 135064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135076 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135089 */     GIR_RootConstrainSelectedInstOperands,
     /* 135090 */     // GIR_Coverage, 7210,
     /* 135090 */     GIR_EraseRootFromParent_Done,
     /* 135091 */   // Label 2572: @135091
     /* 135091 */   GIM_Reject,
     /* 135092 */ // Label 2557: @135092
     /* 135092 */ GIM_Reject,
     /* 135093 */ // Label 2555: @135093
     /* 135093 */ GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(135319),
     /* 135098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135108 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(135150), // Rule ID 7191 //
     /* 135113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135123 */     // MIs[0] Rn
     /* 135123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135135 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 135138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135148 */     GIR_RootConstrainSelectedInstOperands,
     /* 135149 */     // GIR_Coverage, 7191,
     /* 135149 */     GIR_EraseRootFromParent_Done,
     /* 135150 */   // Label 2574: @135150
     /* 135150 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(135192), // Rule ID 7192 //
     /* 135155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135158 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135165 */     // MIs[0] Rn
     /* 135165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135177 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 135180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135190 */     GIR_RootConstrainSelectedInstOperands,
     /* 135191 */     // GIR_Coverage, 7192,
     /* 135191 */     GIR_EraseRootFromParent_Done,
     /* 135192 */   // Label 2575: @135192
     /* 135192 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(135234), // Rule ID 7193 //
     /* 135197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135207 */     // MIs[0] Rn
     /* 135207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135219 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 135222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135232 */     GIR_RootConstrainSelectedInstOperands,
     /* 135233 */     // GIR_Coverage, 7193,
     /* 135233 */     GIR_EraseRootFromParent_Done,
     /* 135234 */   // Label 2576: @135234
     /* 135234 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(135276), // Rule ID 7194 //
     /* 135239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135249 */     // MIs[0] Rn
     /* 135249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135261 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135274 */     GIR_RootConstrainSelectedInstOperands,
     /* 135275 */     // GIR_Coverage, 7194,
     /* 135275 */     GIR_EraseRootFromParent_Done,
     /* 135276 */   // Label 2577: @135276
     /* 135276 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(135318), // Rule ID 7195 //
     /* 135281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135291 */     // MIs[0] Rn
     /* 135291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135303 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135316 */     GIR_RootConstrainSelectedInstOperands,
     /* 135317 */     // GIR_Coverage, 7195,
     /* 135317 */     GIR_EraseRootFromParent_Done,
     /* 135318 */   // Label 2578: @135318
     /* 135318 */   GIM_Reject,
     /* 135319 */ // Label 2573: @135319
     /* 135319 */ GIM_Reject,
     /* 135320 */ // Label 2556: @135320
     /* 135320 */ GIM_Reject,
     /* 135321 */ // Label 29: @135321
     /* 135321 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2581*/ GIMT_Encode4(136312),
     /* 135332 */ /*GILLT_s32*//*Label 2579*/ GIMT_Encode4(135340),
     /* 135336 */ /*GILLT_s64*//*Label 2580*/ GIMT_Encode4(136085),
     /* 135340 */ // Label 2579: @135340
     /* 135340 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(136084),
     /* 135345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135348 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(135397), // Rule ID 7216 //
     /* 135353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135356 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135370 */     // MIs[0] Rn
     /* 135370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135382 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 135385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135395 */     GIR_RootConstrainSelectedInstOperands,
     /* 135396 */     // GIR_Coverage, 7216,
     /* 135396 */     GIR_EraseRootFromParent_Done,
     /* 135397 */   // Label 2583: @135397
     /* 135397 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(135446), // Rule ID 7217 //
     /* 135402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135405 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135412 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135419 */     // MIs[0] Rn
     /* 135419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135431 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 135434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135444 */     GIR_RootConstrainSelectedInstOperands,
     /* 135445 */     // GIR_Coverage, 7217,
     /* 135445 */     GIR_EraseRootFromParent_Done,
     /* 135446 */   // Label 2584: @135446
     /* 135446 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(135495), // Rule ID 7218 //
     /* 135451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135454 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135461 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135468 */     // MIs[0] Rn
     /* 135468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135480 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 135483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135493 */     GIR_RootConstrainSelectedInstOperands,
     /* 135494 */     // GIR_Coverage, 7218,
     /* 135494 */     GIR_EraseRootFromParent_Done,
     /* 135495 */   // Label 2585: @135495
     /* 135495 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(135544), // Rule ID 7219 //
     /* 135500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135503 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135510 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135517 */     // MIs[0] Rn
     /* 135517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135529 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 135532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135542 */     GIR_RootConstrainSelectedInstOperands,
     /* 135543 */     // GIR_Coverage, 7219,
     /* 135543 */     GIR_EraseRootFromParent_Done,
     /* 135544 */   // Label 2586: @135544
     /* 135544 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(135593), // Rule ID 7220 //
     /* 135549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135552 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135566 */     // MIs[0] Rn
     /* 135566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135578 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 135581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135591 */     GIR_RootConstrainSelectedInstOperands,
     /* 135592 */     // GIR_Coverage, 7220,
     /* 135592 */     GIR_EraseRootFromParent_Done,
     /* 135593 */   // Label 2587: @135593
     /* 135593 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(135642), // Rule ID 7221 //
     /* 135598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135601 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135615 */     // MIs[0] Rn
     /* 135615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135627 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 135630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135640 */     GIR_RootConstrainSelectedInstOperands,
     /* 135641 */     // GIR_Coverage, 7221,
     /* 135641 */     GIR_EraseRootFromParent_Done,
     /* 135642 */   // Label 2588: @135642
     /* 135642 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(135691), // Rule ID 7222 //
     /* 135647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135664 */     // MIs[0] Rn
     /* 135664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135676 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 135679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135689 */     GIR_RootConstrainSelectedInstOperands,
     /* 135690 */     // GIR_Coverage, 7222,
     /* 135690 */     GIR_EraseRootFromParent_Done,
     /* 135691 */   // Label 2589: @135691
     /* 135691 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(135740), // Rule ID 7223 //
     /* 135696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135699 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135706 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135713 */     // MIs[0] Rn
     /* 135713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135725 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 135728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135732 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135738 */     GIR_RootConstrainSelectedInstOperands,
     /* 135739 */     // GIR_Coverage, 7223,
     /* 135739 */     GIR_EraseRootFromParent_Done,
     /* 135740 */   // Label 2590: @135740
     /* 135740 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(135789), // Rule ID 7224 //
     /* 135745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135762 */     // MIs[0] Rn
     /* 135762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135774 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135787 */     GIR_RootConstrainSelectedInstOperands,
     /* 135788 */     // GIR_Coverage, 7224,
     /* 135788 */     GIR_EraseRootFromParent_Done,
     /* 135789 */   // Label 2591: @135789
     /* 135789 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(135838), // Rule ID 7225 //
     /* 135794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135811 */     // MIs[0] Rn
     /* 135811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135823 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 135826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135836 */     GIR_RootConstrainSelectedInstOperands,
     /* 135837 */     // GIR_Coverage, 7225,
     /* 135837 */     GIR_EraseRootFromParent_Done,
     /* 135838 */   // Label 2592: @135838
     /* 135838 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(135887), // Rule ID 7226 //
     /* 135843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135860 */     // MIs[0] Rn
     /* 135860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135872 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 135875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135885 */     GIR_RootConstrainSelectedInstOperands,
     /* 135886 */     // GIR_Coverage, 7226,
     /* 135886 */     GIR_EraseRootFromParent_Done,
     /* 135887 */   // Label 2593: @135887
     /* 135887 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(135936), // Rule ID 7227 //
     /* 135892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135909 */     // MIs[0] Rn
     /* 135909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135921 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 135924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135934 */     GIR_RootConstrainSelectedInstOperands,
     /* 135935 */     // GIR_Coverage, 7227,
     /* 135935 */     GIR_EraseRootFromParent_Done,
     /* 135936 */   // Label 2594: @135936
     /* 135936 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(135985), // Rule ID 7228 //
     /* 135941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135958 */     // MIs[0] Rn
     /* 135958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135970 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 135973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135983 */     GIR_RootConstrainSelectedInstOperands,
     /* 135984 */     // GIR_Coverage, 7228,
     /* 135984 */     GIR_EraseRootFromParent_Done,
     /* 135985 */   // Label 2595: @135985
     /* 135985 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(136034), // Rule ID 7229 //
     /* 135990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136007 */     // MIs[0] Rn
     /* 136007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136019 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136032 */     GIR_RootConstrainSelectedInstOperands,
     /* 136033 */     // GIR_Coverage, 7229,
     /* 136033 */     GIR_EraseRootFromParent_Done,
     /* 136034 */   // Label 2596: @136034
     /* 136034 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(136083), // Rule ID 7230 //
     /* 136039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136056 */     // MIs[0] Rn
     /* 136056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136068 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136081 */     GIR_RootConstrainSelectedInstOperands,
     /* 136082 */     // GIR_Coverage, 7230,
     /* 136082 */     GIR_EraseRootFromParent_Done,
     /* 136083 */   // Label 2597: @136083
     /* 136083 */   GIM_Reject,
     /* 136084 */ // Label 2582: @136084
     /* 136084 */ GIM_Reject,
     /* 136085 */ // Label 2580: @136085
     /* 136085 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(136311),
     /* 136090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136093 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136100 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(136142), // Rule ID 7211 //
     /* 136105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136115 */     // MIs[0] Rn
     /* 136115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136127 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 136130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136140 */     GIR_RootConstrainSelectedInstOperands,
     /* 136141 */     // GIR_Coverage, 7211,
     /* 136141 */     GIR_EraseRootFromParent_Done,
     /* 136142 */   // Label 2599: @136142
     /* 136142 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(136184), // Rule ID 7212 //
     /* 136147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136150 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136157 */     // MIs[0] Rn
     /* 136157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136169 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 136172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136182 */     GIR_RootConstrainSelectedInstOperands,
     /* 136183 */     // GIR_Coverage, 7212,
     /* 136183 */     GIR_EraseRootFromParent_Done,
     /* 136184 */   // Label 2600: @136184
     /* 136184 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(136226), // Rule ID 7213 //
     /* 136189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136199 */     // MIs[0] Rn
     /* 136199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136211 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 136214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136224 */     GIR_RootConstrainSelectedInstOperands,
     /* 136225 */     // GIR_Coverage, 7213,
     /* 136225 */     GIR_EraseRootFromParent_Done,
     /* 136226 */   // Label 2601: @136226
     /* 136226 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(136268), // Rule ID 7214 //
     /* 136231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136241 */     // MIs[0] Rn
     /* 136241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136253 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136266 */     GIR_RootConstrainSelectedInstOperands,
     /* 136267 */     // GIR_Coverage, 7214,
     /* 136267 */     GIR_EraseRootFromParent_Done,
     /* 136268 */   // Label 2602: @136268
     /* 136268 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(136310), // Rule ID 7215 //
     /* 136273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136283 */     // MIs[0] Rn
     /* 136283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136295 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136308 */     GIR_RootConstrainSelectedInstOperands,
     /* 136309 */     // GIR_Coverage, 7215,
     /* 136309 */     GIR_EraseRootFromParent_Done,
     /* 136310 */   // Label 2603: @136310
     /* 136310 */   GIM_Reject,
     /* 136311 */ // Label 2598: @136311
     /* 136311 */ GIM_Reject,
     /* 136312 */ // Label 2581: @136312
     /* 136312 */ GIM_Reject,
     /* 136313 */ // Label 30: @136313
     /* 136313 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2606*/ GIMT_Encode4(137304),
     /* 136324 */ /*GILLT_s32*//*Label 2604*/ GIMT_Encode4(136332),
     /* 136328 */ /*GILLT_s64*//*Label 2605*/ GIMT_Encode4(137077),
     /* 136332 */ // Label 2604: @136332
     /* 136332 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(137076),
     /* 136337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136340 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(136389), // Rule ID 7236 //
     /* 136345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136348 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136362 */     // MIs[0] Rn
     /* 136362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136374 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 136377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136387 */     GIR_RootConstrainSelectedInstOperands,
     /* 136388 */     // GIR_Coverage, 7236,
     /* 136388 */     GIR_EraseRootFromParent_Done,
     /* 136389 */   // Label 2608: @136389
     /* 136389 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(136438), // Rule ID 7237 //
     /* 136394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136397 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136404 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136411 */     // MIs[0] Rn
     /* 136411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136423 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 136426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136436 */     GIR_RootConstrainSelectedInstOperands,
     /* 136437 */     // GIR_Coverage, 7237,
     /* 136437 */     GIR_EraseRootFromParent_Done,
     /* 136438 */   // Label 2609: @136438
     /* 136438 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(136487), // Rule ID 7238 //
     /* 136443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136446 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136453 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136460 */     // MIs[0] Rn
     /* 136460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136472 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 136475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136485 */     GIR_RootConstrainSelectedInstOperands,
     /* 136486 */     // GIR_Coverage, 7238,
     /* 136486 */     GIR_EraseRootFromParent_Done,
     /* 136487 */   // Label 2610: @136487
     /* 136487 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(136536), // Rule ID 7239 //
     /* 136492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136509 */     // MIs[0] Rn
     /* 136509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136521 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 136524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136534 */     GIR_RootConstrainSelectedInstOperands,
     /* 136535 */     // GIR_Coverage, 7239,
     /* 136535 */     GIR_EraseRootFromParent_Done,
     /* 136536 */   // Label 2611: @136536
     /* 136536 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(136585), // Rule ID 7240 //
     /* 136541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136558 */     // MIs[0] Rn
     /* 136558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136570 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 136573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136583 */     GIR_RootConstrainSelectedInstOperands,
     /* 136584 */     // GIR_Coverage, 7240,
     /* 136584 */     GIR_EraseRootFromParent_Done,
     /* 136585 */   // Label 2612: @136585
     /* 136585 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(136634), // Rule ID 7241 //
     /* 136590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136593 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136600 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136607 */     // MIs[0] Rn
     /* 136607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136619 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 136622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136632 */     GIR_RootConstrainSelectedInstOperands,
     /* 136633 */     // GIR_Coverage, 7241,
     /* 136633 */     GIR_EraseRootFromParent_Done,
     /* 136634 */   // Label 2613: @136634
     /* 136634 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(136683), // Rule ID 7242 //
     /* 136639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136642 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136649 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136656 */     // MIs[0] Rn
     /* 136656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136668 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 136671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136681 */     GIR_RootConstrainSelectedInstOperands,
     /* 136682 */     // GIR_Coverage, 7242,
     /* 136682 */     GIR_EraseRootFromParent_Done,
     /* 136683 */   // Label 2614: @136683
     /* 136683 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(136732), // Rule ID 7243 //
     /* 136688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136691 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136698 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136705 */     // MIs[0] Rn
     /* 136705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136717 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 136720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136730 */     GIR_RootConstrainSelectedInstOperands,
     /* 136731 */     // GIR_Coverage, 7243,
     /* 136731 */     GIR_EraseRootFromParent_Done,
     /* 136732 */   // Label 2615: @136732
     /* 136732 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(136781), // Rule ID 7244 //
     /* 136737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136754 */     // MIs[0] Rn
     /* 136754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136766 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136779 */     GIR_RootConstrainSelectedInstOperands,
     /* 136780 */     // GIR_Coverage, 7244,
     /* 136780 */     GIR_EraseRootFromParent_Done,
     /* 136781 */   // Label 2616: @136781
     /* 136781 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(136830), // Rule ID 7245 //
     /* 136786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136803 */     // MIs[0] Rn
     /* 136803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136815 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 136818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136828 */     GIR_RootConstrainSelectedInstOperands,
     /* 136829 */     // GIR_Coverage, 7245,
     /* 136829 */     GIR_EraseRootFromParent_Done,
     /* 136830 */   // Label 2617: @136830
     /* 136830 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(136879), // Rule ID 7246 //
     /* 136835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136852 */     // MIs[0] Rn
     /* 136852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136864 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 136867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136877 */     GIR_RootConstrainSelectedInstOperands,
     /* 136878 */     // GIR_Coverage, 7246,
     /* 136878 */     GIR_EraseRootFromParent_Done,
     /* 136879 */   // Label 2618: @136879
     /* 136879 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(136928), // Rule ID 7247 //
     /* 136884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136901 */     // MIs[0] Rn
     /* 136901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136913 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 136916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136926 */     GIR_RootConstrainSelectedInstOperands,
     /* 136927 */     // GIR_Coverage, 7247,
     /* 136927 */     GIR_EraseRootFromParent_Done,
     /* 136928 */   // Label 2619: @136928
     /* 136928 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(136977), // Rule ID 7248 //
     /* 136933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136950 */     // MIs[0] Rn
     /* 136950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136962 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 136965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136975 */     GIR_RootConstrainSelectedInstOperands,
     /* 136976 */     // GIR_Coverage, 7248,
     /* 136976 */     GIR_EraseRootFromParent_Done,
     /* 136977 */   // Label 2620: @136977
     /* 136977 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(137026), // Rule ID 7249 //
     /* 136982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136999 */     // MIs[0] Rn
     /* 136999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137011 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137024 */     GIR_RootConstrainSelectedInstOperands,
     /* 137025 */     // GIR_Coverage, 7249,
     /* 137025 */     GIR_EraseRootFromParent_Done,
     /* 137026 */   // Label 2621: @137026
     /* 137026 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(137075), // Rule ID 7250 //
     /* 137031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137048 */     // MIs[0] Rn
     /* 137048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137060 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137073 */     GIR_RootConstrainSelectedInstOperands,
     /* 137074 */     // GIR_Coverage, 7250,
     /* 137074 */     GIR_EraseRootFromParent_Done,
     /* 137075 */   // Label 2622: @137075
     /* 137075 */   GIM_Reject,
     /* 137076 */ // Label 2607: @137076
     /* 137076 */ GIM_Reject,
     /* 137077 */ // Label 2605: @137077
     /* 137077 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(137303),
     /* 137082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137092 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(137134), // Rule ID 7231 //
     /* 137097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137107 */     // MIs[0] Rn
     /* 137107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137119 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 137122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137132 */     GIR_RootConstrainSelectedInstOperands,
     /* 137133 */     // GIR_Coverage, 7231,
     /* 137133 */     GIR_EraseRootFromParent_Done,
     /* 137134 */   // Label 2624: @137134
     /* 137134 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(137176), // Rule ID 7232 //
     /* 137139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137142 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137149 */     // MIs[0] Rn
     /* 137149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137161 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 137164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137174 */     GIR_RootConstrainSelectedInstOperands,
     /* 137175 */     // GIR_Coverage, 7232,
     /* 137175 */     GIR_EraseRootFromParent_Done,
     /* 137176 */   // Label 2625: @137176
     /* 137176 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(137218), // Rule ID 7233 //
     /* 137181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137184 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137191 */     // MIs[0] Rn
     /* 137191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137203 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 137206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137216 */     GIR_RootConstrainSelectedInstOperands,
     /* 137217 */     // GIR_Coverage, 7233,
     /* 137217 */     GIR_EraseRootFromParent_Done,
     /* 137218 */   // Label 2626: @137218
     /* 137218 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(137260), // Rule ID 7234 //
     /* 137223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137233 */     // MIs[0] Rn
     /* 137233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137245 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137258 */     GIR_RootConstrainSelectedInstOperands,
     /* 137259 */     // GIR_Coverage, 7234,
     /* 137259 */     GIR_EraseRootFromParent_Done,
     /* 137260 */   // Label 2627: @137260
     /* 137260 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(137302), // Rule ID 7235 //
     /* 137265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137275 */     // MIs[0] Rn
     /* 137275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137287 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137300 */     GIR_RootConstrainSelectedInstOperands,
     /* 137301 */     // GIR_Coverage, 7235,
     /* 137301 */     GIR_EraseRootFromParent_Done,
     /* 137302 */   // Label 2628: @137302
     /* 137302 */   GIM_Reject,
     /* 137303 */ // Label 2623: @137303
     /* 137303 */ GIM_Reject,
     /* 137304 */ // Label 2606: @137304
     /* 137304 */ GIM_Reject,
     /* 137305 */ // Label 31: @137305
     /* 137305 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2632*/ GIMT_Encode4(138009),
     /* 137316 */ /*GILLT_s16*//*Label 2629*/ GIMT_Encode4(137328),
     /* 137320 */ /*GILLT_s32*//*Label 2630*/ GIMT_Encode4(137555),
     /* 137324 */ /*GILLT_s64*//*Label 2631*/ GIMT_Encode4(137782),
     /* 137328 */ // Label 2629: @137328
     /* 137328 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(137554),
     /* 137333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137343 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(137385), // Rule ID 2584 //
     /* 137348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137358 */     // MIs[0] Rn
     /* 137358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137370 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 137373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137383 */     GIR_RootConstrainSelectedInstOperands,
     /* 137384 */     // GIR_Coverage, 2584,
     /* 137384 */     GIR_EraseRootFromParent_Done,
     /* 137385 */   // Label 2634: @137385
     /* 137385 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(137427), // Rule ID 2585 //
     /* 137390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137400 */     // MIs[0] Rn
     /* 137400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137412 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 137415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137425 */     GIR_RootConstrainSelectedInstOperands,
     /* 137426 */     // GIR_Coverage, 2585,
     /* 137426 */     GIR_EraseRootFromParent_Done,
     /* 137427 */   // Label 2635: @137427
     /* 137427 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(137469), // Rule ID 2586 //
     /* 137432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137442 */     // MIs[0] Rn
     /* 137442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137454 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 137457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137467 */     GIR_RootConstrainSelectedInstOperands,
     /* 137468 */     // GIR_Coverage, 2586,
     /* 137468 */     GIR_EraseRootFromParent_Done,
     /* 137469 */   // Label 2636: @137469
     /* 137469 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(137511), // Rule ID 2587 //
     /* 137474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137477 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137484 */     // MIs[0] Rn
     /* 137484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137496 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 137499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137509 */     GIR_RootConstrainSelectedInstOperands,
     /* 137510 */     // GIR_Coverage, 2587,
     /* 137510 */     GIR_EraseRootFromParent_Done,
     /* 137511 */   // Label 2637: @137511
     /* 137511 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(137553), // Rule ID 2588 //
     /* 137516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137519 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137526 */     // MIs[0] Rn
     /* 137526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137538 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 137541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137551 */     GIR_RootConstrainSelectedInstOperands,
     /* 137552 */     // GIR_Coverage, 2588,
     /* 137552 */     GIR_EraseRootFromParent_Done,
     /* 137553 */   // Label 2638: @137553
     /* 137553 */   GIM_Reject,
     /* 137554 */ // Label 2633: @137554
     /* 137554 */ GIM_Reject,
     /* 137555 */ // Label 2630: @137555
     /* 137555 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(137781),
     /* 137560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 137563 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137570 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(137612), // Rule ID 7326 //
     /* 137575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137578 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137585 */     // MIs[0] Rn
     /* 137585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137597 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 137600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137610 */     GIR_RootConstrainSelectedInstOperands,
     /* 137611 */     // GIR_Coverage, 7326,
     /* 137611 */     GIR_EraseRootFromParent_Done,
     /* 137612 */   // Label 2640: @137612
     /* 137612 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(137654), // Rule ID 7327 //
     /* 137617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137627 */     // MIs[0] Rn
     /* 137627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137639 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 137642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137652 */     GIR_RootConstrainSelectedInstOperands,
     /* 137653 */     // GIR_Coverage, 7327,
     /* 137653 */     GIR_EraseRootFromParent_Done,
     /* 137654 */   // Label 2641: @137654
     /* 137654 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(137696), // Rule ID 7328 //
     /* 137659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137669 */     // MIs[0] Rn
     /* 137669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137681 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 137684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137694 */     GIR_RootConstrainSelectedInstOperands,
     /* 137695 */     // GIR_Coverage, 7328,
     /* 137695 */     GIR_EraseRootFromParent_Done,
     /* 137696 */   // Label 2642: @137696
     /* 137696 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(137738), // Rule ID 7329 //
     /* 137701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137704 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137711 */     // MIs[0] Rn
     /* 137711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137723 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137736 */     GIR_RootConstrainSelectedInstOperands,
     /* 137737 */     // GIR_Coverage, 7329,
     /* 137737 */     GIR_EraseRootFromParent_Done,
     /* 137738 */   // Label 2643: @137738
     /* 137738 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(137780), // Rule ID 7330 //
     /* 137743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137753 */     // MIs[0] Rn
     /* 137753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 137765 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 137768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137778 */     GIR_RootConstrainSelectedInstOperands,
     /* 137779 */     // GIR_Coverage, 7330,
     /* 137779 */     GIR_EraseRootFromParent_Done,
     /* 137780 */   // Label 2644: @137780
     /* 137780 */   GIM_Reject,
     /* 137781 */ // Label 2639: @137781
     /* 137781 */ GIM_Reject,
     /* 137782 */ // Label 2631: @137782
     /* 137782 */ GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(138008),
     /* 137787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137790 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137797 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(137839), // Rule ID 7331 //
     /* 137802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137805 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137812 */     // MIs[0] Rn
     /* 137812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137824 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 137827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137837 */     GIR_RootConstrainSelectedInstOperands,
     /* 137838 */     // GIR_Coverage, 7331,
     /* 137838 */     GIR_EraseRootFromParent_Done,
     /* 137839 */   // Label 2646: @137839
     /* 137839 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(137881), // Rule ID 7332 //
     /* 137844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137847 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137854 */     // MIs[0] Rn
     /* 137854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137866 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 137869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137879 */     GIR_RootConstrainSelectedInstOperands,
     /* 137880 */     // GIR_Coverage, 7332,
     /* 137880 */     GIR_EraseRootFromParent_Done,
     /* 137881 */   // Label 2647: @137881
     /* 137881 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(137923), // Rule ID 7333 //
     /* 137886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137896 */     // MIs[0] Rn
     /* 137896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137908 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 137911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137921 */     GIR_RootConstrainSelectedInstOperands,
     /* 137922 */     // GIR_Coverage, 7333,
     /* 137922 */     GIR_EraseRootFromParent_Done,
     /* 137923 */   // Label 2648: @137923
     /* 137923 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(137965), // Rule ID 7334 //
     /* 137928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137938 */     // MIs[0] Rn
     /* 137938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137950 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 137953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137963 */     GIR_RootConstrainSelectedInstOperands,
     /* 137964 */     // GIR_Coverage, 7334,
     /* 137964 */     GIR_EraseRootFromParent_Done,
     /* 137965 */   // Label 2649: @137965
     /* 137965 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(138007), // Rule ID 7335 //
     /* 137970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137980 */     // MIs[0] Rn
     /* 137980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137992 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 137995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138005 */     GIR_RootConstrainSelectedInstOperands,
     /* 138006 */     // GIR_Coverage, 7335,
     /* 138006 */     GIR_EraseRootFromParent_Done,
     /* 138007 */   // Label 2650: @138007
     /* 138007 */   GIM_Reject,
     /* 138008 */ // Label 2645: @138008
     /* 138008 */ GIM_Reject,
     /* 138009 */ // Label 2632: @138009
     /* 138009 */ GIM_Reject,
     /* 138010 */ // Label 32: @138010
     /* 138010 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2654*/ GIMT_Encode4(138714),
     /* 138021 */ /*GILLT_s16*//*Label 2651*/ GIMT_Encode4(138033),
     /* 138025 */ /*GILLT_s32*//*Label 2652*/ GIMT_Encode4(138260),
     /* 138029 */ /*GILLT_s64*//*Label 2653*/ GIMT_Encode4(138487),
     /* 138033 */ // Label 2651: @138033
     /* 138033 */ GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(138259),
     /* 138038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138041 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138048 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(138090), // Rule ID 7336 //
     /* 138053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138063 */     // MIs[0] Rn
     /* 138063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138075 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 138078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138088 */     GIR_RootConstrainSelectedInstOperands,
     /* 138089 */     // GIR_Coverage, 7336,
     /* 138089 */     GIR_EraseRootFromParent_Done,
     /* 138090 */   // Label 2656: @138090
     /* 138090 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(138132), // Rule ID 7337 //
     /* 138095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138105 */     // MIs[0] Rn
     /* 138105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138117 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 138120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138130 */     GIR_RootConstrainSelectedInstOperands,
     /* 138131 */     // GIR_Coverage, 7337,
     /* 138131 */     GIR_EraseRootFromParent_Done,
     /* 138132 */   // Label 2657: @138132
     /* 138132 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(138174), // Rule ID 7338 //
     /* 138137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138147 */     // MIs[0] Rn
     /* 138147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138159 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 138162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138172 */     GIR_RootConstrainSelectedInstOperands,
     /* 138173 */     // GIR_Coverage, 7338,
     /* 138173 */     GIR_EraseRootFromParent_Done,
     /* 138174 */   // Label 2658: @138174
     /* 138174 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(138216), // Rule ID 7339 //
     /* 138179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138182 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138189 */     // MIs[0] Rn
     /* 138189 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138201 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138214 */     GIR_RootConstrainSelectedInstOperands,
     /* 138215 */     // GIR_Coverage, 7339,
     /* 138215 */     GIR_EraseRootFromParent_Done,
     /* 138216 */   // Label 2659: @138216
     /* 138216 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(138258), // Rule ID 7340 //
     /* 138221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138224 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138231 */     // MIs[0] Rn
     /* 138231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138243 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138256 */     GIR_RootConstrainSelectedInstOperands,
     /* 138257 */     // GIR_Coverage, 7340,
     /* 138257 */     GIR_EraseRootFromParent_Done,
     /* 138258 */   // Label 2660: @138258
     /* 138258 */   GIM_Reject,
     /* 138259 */ // Label 2655: @138259
     /* 138259 */ GIM_Reject,
     /* 138260 */ // Label 2652: @138260
     /* 138260 */ GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(138486),
     /* 138265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138275 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(138317), // Rule ID 7341 //
     /* 138280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138290 */     // MIs[0] Rn
     /* 138290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138302 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 138305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138315 */     GIR_RootConstrainSelectedInstOperands,
     /* 138316 */     // GIR_Coverage, 7341,
     /* 138316 */     GIR_EraseRootFromParent_Done,
     /* 138317 */   // Label 2662: @138317
     /* 138317 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(138359), // Rule ID 7342 //
     /* 138322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138332 */     // MIs[0] Rn
     /* 138332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138344 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 138347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138357 */     GIR_RootConstrainSelectedInstOperands,
     /* 138358 */     // GIR_Coverage, 7342,
     /* 138358 */     GIR_EraseRootFromParent_Done,
     /* 138359 */   // Label 2663: @138359
     /* 138359 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(138401), // Rule ID 7343 //
     /* 138364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138374 */     // MIs[0] Rn
     /* 138374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138386 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 138389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138399 */     GIR_RootConstrainSelectedInstOperands,
     /* 138400 */     // GIR_Coverage, 7343,
     /* 138400 */     GIR_EraseRootFromParent_Done,
     /* 138401 */   // Label 2664: @138401
     /* 138401 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(138443), // Rule ID 7344 //
     /* 138406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138409 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138416 */     // MIs[0] Rn
     /* 138416 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138428 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 138431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138441 */     GIR_RootConstrainSelectedInstOperands,
     /* 138442 */     // GIR_Coverage, 7344,
     /* 138442 */     GIR_EraseRootFromParent_Done,
     /* 138443 */   // Label 2665: @138443
     /* 138443 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(138485), // Rule ID 7345 //
     /* 138448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138458 */     // MIs[0] Rn
     /* 138458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138470 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 138473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138483 */     GIR_RootConstrainSelectedInstOperands,
     /* 138484 */     // GIR_Coverage, 7345,
     /* 138484 */     GIR_EraseRootFromParent_Done,
     /* 138485 */   // Label 2666: @138485
     /* 138485 */   GIM_Reject,
     /* 138486 */ // Label 2661: @138486
     /* 138486 */ GIM_Reject,
     /* 138487 */ // Label 2653: @138487
     /* 138487 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(138713),
     /* 138492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138495 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138502 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(138544), // Rule ID 7346 //
     /* 138507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138510 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138517 */     // MIs[0] Rn
     /* 138517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138529 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 138532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138542 */     GIR_RootConstrainSelectedInstOperands,
     /* 138543 */     // GIR_Coverage, 7346,
     /* 138543 */     GIR_EraseRootFromParent_Done,
     /* 138544 */   // Label 2668: @138544
     /* 138544 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(138586), // Rule ID 7347 //
     /* 138549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138552 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138559 */     // MIs[0] Rn
     /* 138559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138571 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 138574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138584 */     GIR_RootConstrainSelectedInstOperands,
     /* 138585 */     // GIR_Coverage, 7347,
     /* 138585 */     GIR_EraseRootFromParent_Done,
     /* 138586 */   // Label 2669: @138586
     /* 138586 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(138628), // Rule ID 7348 //
     /* 138591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138594 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138601 */     // MIs[0] Rn
     /* 138601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138613 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 138616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138626 */     GIR_RootConstrainSelectedInstOperands,
     /* 138627 */     // GIR_Coverage, 7348,
     /* 138627 */     GIR_EraseRootFromParent_Done,
     /* 138628 */   // Label 2670: @138628
     /* 138628 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(138670), // Rule ID 7349 //
     /* 138633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138643 */     // MIs[0] Rn
     /* 138643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138655 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 138658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138668 */     GIR_RootConstrainSelectedInstOperands,
     /* 138669 */     // GIR_Coverage, 7349,
     /* 138669 */     GIR_EraseRootFromParent_Done,
     /* 138670 */   // Label 2671: @138670
     /* 138670 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(138712), // Rule ID 7350 //
     /* 138675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138685 */     // MIs[0] Rn
     /* 138685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138697 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 138700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138710 */     GIR_RootConstrainSelectedInstOperands,
     /* 138711 */     // GIR_Coverage, 7350,
     /* 138711 */     GIR_EraseRootFromParent_Done,
     /* 138712 */   // Label 2672: @138712
     /* 138712 */   GIM_Reject,
     /* 138713 */ // Label 2667: @138713
     /* 138713 */ GIM_Reject,
     /* 138714 */ // Label 2654: @138714
     /* 138714 */ GIM_Reject,
     /* 138715 */ // Label 33: @138715
     /* 138715 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2676*/ GIMT_Encode4(139419),
     /* 138726 */ /*GILLT_s16*//*Label 2673*/ GIMT_Encode4(138738),
     /* 138730 */ /*GILLT_s32*//*Label 2674*/ GIMT_Encode4(138965),
     /* 138734 */ /*GILLT_s64*//*Label 2675*/ GIMT_Encode4(139192),
     /* 138738 */ // Label 2673: @138738
     /* 138738 */ GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(138964),
     /* 138743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138753 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(138795), // Rule ID 7351 //
     /* 138758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138768 */     // MIs[0] Rn
     /* 138768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138780 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 138783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138793 */     GIR_RootConstrainSelectedInstOperands,
     /* 138794 */     // GIR_Coverage, 7351,
     /* 138794 */     GIR_EraseRootFromParent_Done,
     /* 138795 */   // Label 2678: @138795
     /* 138795 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(138837), // Rule ID 7352 //
     /* 138800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138810 */     // MIs[0] Rn
     /* 138810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138822 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 138825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138835 */     GIR_RootConstrainSelectedInstOperands,
     /* 138836 */     // GIR_Coverage, 7352,
     /* 138836 */     GIR_EraseRootFromParent_Done,
     /* 138837 */   // Label 2679: @138837
     /* 138837 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(138879), // Rule ID 7353 //
     /* 138842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138852 */     // MIs[0] Rn
     /* 138852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138864 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 138867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138877 */     GIR_RootConstrainSelectedInstOperands,
     /* 138878 */     // GIR_Coverage, 7353,
     /* 138878 */     GIR_EraseRootFromParent_Done,
     /* 138879 */   // Label 2680: @138879
     /* 138879 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(138921), // Rule ID 7354 //
     /* 138884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138894 */     // MIs[0] Rn
     /* 138894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138906 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138919 */     GIR_RootConstrainSelectedInstOperands,
     /* 138920 */     // GIR_Coverage, 7354,
     /* 138920 */     GIR_EraseRootFromParent_Done,
     /* 138921 */   // Label 2681: @138921
     /* 138921 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(138963), // Rule ID 7355 //
     /* 138926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138929 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138936 */     // MIs[0] Rn
     /* 138936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138948 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 138951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138961 */     GIR_RootConstrainSelectedInstOperands,
     /* 138962 */     // GIR_Coverage, 7355,
     /* 138962 */     GIR_EraseRootFromParent_Done,
     /* 138963 */   // Label 2682: @138963
     /* 138963 */   GIM_Reject,
     /* 138964 */ // Label 2677: @138964
     /* 138964 */ GIM_Reject,
     /* 138965 */ // Label 2674: @138965
     /* 138965 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(139191),
     /* 138970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138980 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(139022), // Rule ID 7356 //
     /* 138985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138988 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138995 */     // MIs[0] Rn
     /* 138995 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139007 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 139010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139020 */     GIR_RootConstrainSelectedInstOperands,
     /* 139021 */     // GIR_Coverage, 7356,
     /* 139021 */     GIR_EraseRootFromParent_Done,
     /* 139022 */   // Label 2684: @139022
     /* 139022 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139064), // Rule ID 7357 //
     /* 139027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139037 */     // MIs[0] Rn
     /* 139037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139049 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 139052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139062 */     GIR_RootConstrainSelectedInstOperands,
     /* 139063 */     // GIR_Coverage, 7357,
     /* 139063 */     GIR_EraseRootFromParent_Done,
     /* 139064 */   // Label 2685: @139064
     /* 139064 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(139106), // Rule ID 7358 //
     /* 139069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139079 */     // MIs[0] Rn
     /* 139079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139091 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 139094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139104 */     GIR_RootConstrainSelectedInstOperands,
     /* 139105 */     // GIR_Coverage, 7358,
     /* 139105 */     GIR_EraseRootFromParent_Done,
     /* 139106 */   // Label 2686: @139106
     /* 139106 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139148), // Rule ID 7359 //
     /* 139111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139121 */     // MIs[0] Rn
     /* 139121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139133 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139146 */     GIR_RootConstrainSelectedInstOperands,
     /* 139147 */     // GIR_Coverage, 7359,
     /* 139147 */     GIR_EraseRootFromParent_Done,
     /* 139148 */   // Label 2687: @139148
     /* 139148 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(139190), // Rule ID 7360 //
     /* 139153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139163 */     // MIs[0] Rn
     /* 139163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139175 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139188 */     GIR_RootConstrainSelectedInstOperands,
     /* 139189 */     // GIR_Coverage, 7360,
     /* 139189 */     GIR_EraseRootFromParent_Done,
     /* 139190 */   // Label 2688: @139190
     /* 139190 */   GIM_Reject,
     /* 139191 */ // Label 2683: @139191
     /* 139191 */ GIM_Reject,
     /* 139192 */ // Label 2675: @139192
     /* 139192 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(139418),
     /* 139197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139207 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(139249), // Rule ID 7361 //
     /* 139212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139215 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139222 */     // MIs[0] Rn
     /* 139222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139234 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 139237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139247 */     GIR_RootConstrainSelectedInstOperands,
     /* 139248 */     // GIR_Coverage, 7361,
     /* 139248 */     GIR_EraseRootFromParent_Done,
     /* 139249 */   // Label 2690: @139249
     /* 139249 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(139291), // Rule ID 7362 //
     /* 139254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139264 */     // MIs[0] Rn
     /* 139264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139276 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 139279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139289 */     GIR_RootConstrainSelectedInstOperands,
     /* 139290 */     // GIR_Coverage, 7362,
     /* 139290 */     GIR_EraseRootFromParent_Done,
     /* 139291 */   // Label 2691: @139291
     /* 139291 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(139333), // Rule ID 7363 //
     /* 139296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139306 */     // MIs[0] Rn
     /* 139306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139318 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 139321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139331 */     GIR_RootConstrainSelectedInstOperands,
     /* 139332 */     // GIR_Coverage, 7363,
     /* 139332 */     GIR_EraseRootFromParent_Done,
     /* 139333 */   // Label 2692: @139333
     /* 139333 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(139375), // Rule ID 7364 //
     /* 139338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139348 */     // MIs[0] Rn
     /* 139348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139360 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139373 */     GIR_RootConstrainSelectedInstOperands,
     /* 139374 */     // GIR_Coverage, 7364,
     /* 139374 */     GIR_EraseRootFromParent_Done,
     /* 139375 */   // Label 2693: @139375
     /* 139375 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(139417), // Rule ID 7365 //
     /* 139380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139390 */     // MIs[0] Rn
     /* 139390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139402 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139415 */     GIR_RootConstrainSelectedInstOperands,
     /* 139416 */     // GIR_Coverage, 7365,
     /* 139416 */     GIR_EraseRootFromParent_Done,
     /* 139417 */   // Label 2694: @139417
     /* 139417 */   GIM_Reject,
     /* 139418 */ // Label 2689: @139418
     /* 139418 */ GIM_Reject,
     /* 139419 */ // Label 2676: @139419
     /* 139419 */ GIM_Reject,
     /* 139420 */ // Label 34: @139420
     /* 139420 */ GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(139447), // Rule ID 6983 //
     /* 139425 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139428 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 139432 */   // MIs[0] Operand 1
     /* 139432 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139435 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 139435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 139441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139445 */   GIR_RootConstrainSelectedInstOperands,
     /* 139446 */   // GIR_Coverage, 6983,
     /* 139446 */   GIR_EraseRootFromParent_Done,
     /* 139447 */ // Label 2695: @139447
     /* 139447 */ GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(139470), // Rule ID 6984 //
     /* 139452 */   // MIs[0] Operand 0
     /* 139452 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 139455 */   // MIs[0] Operand 1
     /* 139455 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139458 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 139458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 139464 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139468 */   GIR_RootConstrainSelectedInstOperands,
     /* 139469 */   // GIR_Coverage, 6984,
     /* 139469 */   GIR_EraseRootFromParent_Done,
     /* 139470 */ // Label 2696: @139470
     /* 139470 */ GIM_Reject,
     /* 139471 */ // Label 35: @139471
     /* 139471 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(151998),
     /* 139476 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 139479 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(139570), // Rule ID 6462 //
     /* 139484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 139487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 139492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 139510 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 139513 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 139518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139522 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 139526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139538 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 139538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 139541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 139545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 139554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 139558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 139563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139568 */     GIR_RootConstrainSelectedInstOperands,
     /* 139569 */     // GIR_Coverage, 6462,
     /* 139569 */     GIR_EraseRootFromParent_Done,
     /* 139570 */   // Label 2698: @139570
     /* 139570 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(139661), // Rule ID 6463 //
     /* 139575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 139578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 139583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 139586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 139601 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 139604 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 139609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 139613 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 139617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139629 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 139629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 139632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 139636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139641 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 139645 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 139649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 139654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139659 */     GIR_RootConstrainSelectedInstOperands,
     /* 139660 */     // GIR_Coverage, 6463,
     /* 139660 */     GIR_EraseRootFromParent_Done,
     /* 139661 */   // Label 2699: @139661
     /* 139661 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(139722), // Rule ID 4886 //
     /* 139666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 139671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 139674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 139677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 139689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 139693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139698 */     // MIs[1] Operand 2
     /* 139698 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 139709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139711 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 139711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 139714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 139720 */     GIR_RootConstrainSelectedInstOperands,
     /* 139721 */     // GIR_Coverage, 4886,
     /* 139721 */     GIR_EraseRootFromParent_Done,
     /* 139722 */   // Label 2700: @139722
     /* 139722 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(139762), // Rule ID 2651 //
     /* 139727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 139735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139742 */     // MIs[0] pattern
     /* 139742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139750 */     // (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 139753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139755 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139760 */     GIR_RootConstrainSelectedInstOperands,
     /* 139761 */     // GIR_Coverage, 2651,
     /* 139761 */     GIR_EraseRootFromParent_Done,
     /* 139762 */   // Label 2701: @139762
     /* 139762 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(139802), // Rule ID 9868 //
     /* 139767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 139775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139782 */     // MIs[0] pattern
     /* 139782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139790 */     // (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 139793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139795 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139800 */     GIR_RootConstrainSelectedInstOperands,
     /* 139801 */     // GIR_Coverage, 9868,
     /* 139801 */     GIR_EraseRootFromParent_Done,
     /* 139802 */   // Label 2702: @139802
     /* 139802 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(139842), // Rule ID 9871 //
     /* 139807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 139815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139822 */     // MIs[0] pattern
     /* 139822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139830 */     // (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 139833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139835 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139840 */     GIR_RootConstrainSelectedInstOperands,
     /* 139841 */     // GIR_Coverage, 9871,
     /* 139841 */     GIR_EraseRootFromParent_Done,
     /* 139842 */   // Label 2703: @139842
     /* 139842 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(139882), // Rule ID 9874 //
     /* 139847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 139850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 139855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139862 */     // MIs[0] pattern
     /* 139862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 139865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 139870 */     // (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 139870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 139873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139875 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 139877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 139880 */     GIR_RootConstrainSelectedInstOperands,
     /* 139881 */     // GIR_Coverage, 9874,
     /* 139881 */     GIR_EraseRootFromParent_Done,
     /* 139882 */   // Label 2704: @139882
     /* 139882 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(139921), // Rule ID 66 //
     /* 139887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 139890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 139895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139909 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 139909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 139912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 139919 */     GIR_RootConstrainSelectedInstOperands,
     /* 139920 */     // GIR_Coverage, 66,
     /* 139920 */     GIR_EraseRootFromParent_Done,
     /* 139921 */   // Label 2705: @139921
     /* 139921 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(139957), // Rule ID 346 //
     /* 139926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 139937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139948 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 139948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 139951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139955 */     GIR_RootConstrainSelectedInstOperands,
     /* 139956 */     // GIR_Coverage, 346,
     /* 139956 */     GIR_EraseRootFromParent_Done,
     /* 139957 */   // Label 2706: @139957
     /* 139957 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(139993), // Rule ID 347 //
     /* 139962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 139965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 139970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139984 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 139984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 139987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 139989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 139991 */     GIR_RootConstrainSelectedInstOperands,
     /* 139992 */     // GIR_Coverage, 347,
     /* 139992 */     GIR_EraseRootFromParent_Done,
     /* 139993 */   // Label 2707: @139993
     /* 139993 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140029), // Rule ID 348 //
     /* 139998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140020 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 140023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140027 */     GIR_RootConstrainSelectedInstOperands,
     /* 140028 */     // GIR_Coverage, 348,
     /* 140028 */     GIR_EraseRootFromParent_Done,
     /* 140029 */   // Label 2708: @140029
     /* 140029 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140065), // Rule ID 349 //
     /* 140034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140056 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 140059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140063 */     GIR_RootConstrainSelectedInstOperands,
     /* 140064 */     // GIR_Coverage, 349,
     /* 140064 */     GIR_EraseRootFromParent_Done,
     /* 140065 */   // Label 2709: @140065
     /* 140065 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140101), // Rule ID 350 //
     /* 140070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140092 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 140095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140099 */     GIR_RootConstrainSelectedInstOperands,
     /* 140100 */     // GIR_Coverage, 350,
     /* 140100 */     GIR_EraseRootFromParent_Done,
     /* 140101 */   // Label 2710: @140101
     /* 140101 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140137), // Rule ID 351 //
     /* 140106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140128 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 140131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140135 */     GIR_RootConstrainSelectedInstOperands,
     /* 140136 */     // GIR_Coverage, 351,
     /* 140136 */     GIR_EraseRootFromParent_Done,
     /* 140137 */   // Label 2711: @140137
     /* 140137 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140173), // Rule ID 352 //
     /* 140142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140164 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 140167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140171 */     GIR_RootConstrainSelectedInstOperands,
     /* 140172 */     // GIR_Coverage, 352,
     /* 140172 */     GIR_EraseRootFromParent_Done,
     /* 140173 */   // Label 2712: @140173
     /* 140173 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140209), // Rule ID 353 //
     /* 140178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140200 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 140203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140207 */     GIR_RootConstrainSelectedInstOperands,
     /* 140208 */     // GIR_Coverage, 353,
     /* 140208 */     GIR_EraseRootFromParent_Done,
     /* 140209 */   // Label 2713: @140209
     /* 140209 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(140245), // Rule ID 354 //
     /* 140214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140236 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 140239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140243 */     GIR_RootConstrainSelectedInstOperands,
     /* 140244 */     // GIR_Coverage, 354,
     /* 140244 */     GIR_EraseRootFromParent_Done,
     /* 140245 */   // Label 2714: @140245
     /* 140245 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(140281), // Rule ID 355 //
     /* 140250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140272 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 140275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140279 */     GIR_RootConstrainSelectedInstOperands,
     /* 140280 */     // GIR_Coverage, 355,
     /* 140280 */     GIR_EraseRootFromParent_Done,
     /* 140281 */   // Label 2715: @140281
     /* 140281 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(140317), // Rule ID 356 //
     /* 140286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140308 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 140311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140315 */     GIR_RootConstrainSelectedInstOperands,
     /* 140316 */     // GIR_Coverage, 356,
     /* 140316 */     GIR_EraseRootFromParent_Done,
     /* 140317 */   // Label 2716: @140317
     /* 140317 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(140353), // Rule ID 357 //
     /* 140322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140344 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 140347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140351 */     GIR_RootConstrainSelectedInstOperands,
     /* 140352 */     // GIR_Coverage, 357,
     /* 140352 */     GIR_EraseRootFromParent_Done,
     /* 140353 */   // Label 2717: @140353
     /* 140353 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(140389), // Rule ID 358 //
     /* 140358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140380 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 140383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140387 */     GIR_RootConstrainSelectedInstOperands,
     /* 140388 */     // GIR_Coverage, 358,
     /* 140388 */     GIR_EraseRootFromParent_Done,
     /* 140389 */   // Label 2718: @140389
     /* 140389 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(140425), // Rule ID 359 //
     /* 140394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140416 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 140419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140423 */     GIR_RootConstrainSelectedInstOperands,
     /* 140424 */     // GIR_Coverage, 359,
     /* 140424 */     GIR_EraseRootFromParent_Done,
     /* 140425 */   // Label 2719: @140425
     /* 140425 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(140461), // Rule ID 360 //
     /* 140430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140452 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 140455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140459 */     GIR_RootConstrainSelectedInstOperands,
     /* 140460 */     // GIR_Coverage, 360,
     /* 140460 */     GIR_EraseRootFromParent_Done,
     /* 140461 */   // Label 2720: @140461
     /* 140461 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(140497), // Rule ID 361 //
     /* 140466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140488 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 140491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140495 */     GIR_RootConstrainSelectedInstOperands,
     /* 140496 */     // GIR_Coverage, 361,
     /* 140496 */     GIR_EraseRootFromParent_Done,
     /* 140497 */   // Label 2721: @140497
     /* 140497 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(140533), // Rule ID 362 //
     /* 140502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140524 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 140527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140531 */     GIR_RootConstrainSelectedInstOperands,
     /* 140532 */     // GIR_Coverage, 362,
     /* 140532 */     GIR_EraseRootFromParent_Done,
     /* 140533 */   // Label 2722: @140533
     /* 140533 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(140569), // Rule ID 363 //
     /* 140538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140560 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 140563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140567 */     GIR_RootConstrainSelectedInstOperands,
     /* 140568 */     // GIR_Coverage, 363,
     /* 140568 */     GIR_EraseRootFromParent_Done,
     /* 140569 */   // Label 2723: @140569
     /* 140569 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(140605), // Rule ID 364 //
     /* 140574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140596 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 140599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140603 */     GIR_RootConstrainSelectedInstOperands,
     /* 140604 */     // GIR_Coverage, 364,
     /* 140604 */     GIR_EraseRootFromParent_Done,
     /* 140605 */   // Label 2724: @140605
     /* 140605 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(140641), // Rule ID 365 //
     /* 140610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140632 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 140635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140639 */     GIR_RootConstrainSelectedInstOperands,
     /* 140640 */     // GIR_Coverage, 365,
     /* 140640 */     GIR_EraseRootFromParent_Done,
     /* 140641 */   // Label 2725: @140641
     /* 140641 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(140677), // Rule ID 366 //
     /* 140646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140668 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 140671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140675 */     GIR_RootConstrainSelectedInstOperands,
     /* 140676 */     // GIR_Coverage, 366,
     /* 140676 */     GIR_EraseRootFromParent_Done,
     /* 140677 */   // Label 2726: @140677
     /* 140677 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(140713), // Rule ID 367 //
     /* 140682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140704 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 140707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140711 */     GIR_RootConstrainSelectedInstOperands,
     /* 140712 */     // GIR_Coverage, 367,
     /* 140712 */     GIR_EraseRootFromParent_Done,
     /* 140713 */   // Label 2727: @140713
     /* 140713 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(140749), // Rule ID 368 //
     /* 140718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140740 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 140743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140747 */     GIR_RootConstrainSelectedInstOperands,
     /* 140748 */     // GIR_Coverage, 368,
     /* 140748 */     GIR_EraseRootFromParent_Done,
     /* 140749 */   // Label 2728: @140749
     /* 140749 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(140785), // Rule ID 369 //
     /* 140754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 140762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140776 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 140779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140783 */     GIR_RootConstrainSelectedInstOperands,
     /* 140784 */     // GIR_Coverage, 369,
     /* 140784 */     GIR_EraseRootFromParent_Done,
     /* 140785 */   // Label 2729: @140785
     /* 140785 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(140821), // Rule ID 370 //
     /* 140790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140812 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 140815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140819 */     GIR_RootConstrainSelectedInstOperands,
     /* 140820 */     // GIR_Coverage, 370,
     /* 140820 */     GIR_EraseRootFromParent_Done,
     /* 140821 */   // Label 2730: @140821
     /* 140821 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(140857), // Rule ID 371 //
     /* 140826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140848 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 140851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140855 */     GIR_RootConstrainSelectedInstOperands,
     /* 140856 */     // GIR_Coverage, 371,
     /* 140856 */     GIR_EraseRootFromParent_Done,
     /* 140857 */   // Label 2731: @140857
     /* 140857 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(140893), // Rule ID 372 //
     /* 140862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140884 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 140887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140891 */     GIR_RootConstrainSelectedInstOperands,
     /* 140892 */     // GIR_Coverage, 372,
     /* 140892 */     GIR_EraseRootFromParent_Done,
     /* 140893 */   // Label 2732: @140893
     /* 140893 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(140929), // Rule ID 373 //
     /* 140898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140920 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 140923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140927 */     GIR_RootConstrainSelectedInstOperands,
     /* 140928 */     // GIR_Coverage, 373,
     /* 140928 */     GIR_EraseRootFromParent_Done,
     /* 140929 */   // Label 2733: @140929
     /* 140929 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(140965), // Rule ID 374 //
     /* 140934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140956 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 140959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140963 */     GIR_RootConstrainSelectedInstOperands,
     /* 140964 */     // GIR_Coverage, 374,
     /* 140964 */     GIR_EraseRootFromParent_Done,
     /* 140965 */   // Label 2734: @140965
     /* 140965 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141001), // Rule ID 375 //
     /* 140970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 140978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140992 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 140995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140999 */     GIR_RootConstrainSelectedInstOperands,
     /* 141000 */     // GIR_Coverage, 375,
     /* 141000 */     GIR_EraseRootFromParent_Done,
     /* 141001 */   // Label 2735: @141001
     /* 141001 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141037), // Rule ID 376 //
     /* 141006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141028 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 141031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141035 */     GIR_RootConstrainSelectedInstOperands,
     /* 141036 */     // GIR_Coverage, 376,
     /* 141036 */     GIR_EraseRootFromParent_Done,
     /* 141037 */   // Label 2736: @141037
     /* 141037 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141073), // Rule ID 377 //
     /* 141042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141064 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 141067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141071 */     GIR_RootConstrainSelectedInstOperands,
     /* 141072 */     // GIR_Coverage, 377,
     /* 141072 */     GIR_EraseRootFromParent_Done,
     /* 141073 */   // Label 2737: @141073
     /* 141073 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141109), // Rule ID 378 //
     /* 141078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141100 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 141103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141107 */     GIR_RootConstrainSelectedInstOperands,
     /* 141108 */     // GIR_Coverage, 378,
     /* 141108 */     GIR_EraseRootFromParent_Done,
     /* 141109 */   // Label 2738: @141109
     /* 141109 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141145), // Rule ID 379 //
     /* 141114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141136 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 141139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141143 */     GIR_RootConstrainSelectedInstOperands,
     /* 141144 */     // GIR_Coverage, 379,
     /* 141144 */     GIR_EraseRootFromParent_Done,
     /* 141145 */   // Label 2739: @141145
     /* 141145 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141181), // Rule ID 380 //
     /* 141150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141172 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 141175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141179 */     GIR_RootConstrainSelectedInstOperands,
     /* 141180 */     // GIR_Coverage, 380,
     /* 141180 */     GIR_EraseRootFromParent_Done,
     /* 141181 */   // Label 2740: @141181
     /* 141181 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141217), // Rule ID 381 //
     /* 141186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141208 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 141211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141215 */     GIR_RootConstrainSelectedInstOperands,
     /* 141216 */     // GIR_Coverage, 381,
     /* 141216 */     GIR_EraseRootFromParent_Done,
     /* 141217 */   // Label 2741: @141217
     /* 141217 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(141253), // Rule ID 382 //
     /* 141222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141244 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 141247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141251 */     GIR_RootConstrainSelectedInstOperands,
     /* 141252 */     // GIR_Coverage, 382,
     /* 141252 */     GIR_EraseRootFromParent_Done,
     /* 141253 */   // Label 2742: @141253
     /* 141253 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(141289), // Rule ID 383 //
     /* 141258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141280 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 141283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141287 */     GIR_RootConstrainSelectedInstOperands,
     /* 141288 */     // GIR_Coverage, 383,
     /* 141288 */     GIR_EraseRootFromParent_Done,
     /* 141289 */   // Label 2743: @141289
     /* 141289 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(141325), // Rule ID 384 //
     /* 141294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141316 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 141319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141323 */     GIR_RootConstrainSelectedInstOperands,
     /* 141324 */     // GIR_Coverage, 384,
     /* 141324 */     GIR_EraseRootFromParent_Done,
     /* 141325 */   // Label 2744: @141325
     /* 141325 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(141361), // Rule ID 385 //
     /* 141330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141352 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 141355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141359 */     GIR_RootConstrainSelectedInstOperands,
     /* 141360 */     // GIR_Coverage, 385,
     /* 141360 */     GIR_EraseRootFromParent_Done,
     /* 141361 */   // Label 2745: @141361
     /* 141361 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(141397), // Rule ID 386 //
     /* 141366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141388 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 141391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141395 */     GIR_RootConstrainSelectedInstOperands,
     /* 141396 */     // GIR_Coverage, 386,
     /* 141396 */     GIR_EraseRootFromParent_Done,
     /* 141397 */   // Label 2746: @141397
     /* 141397 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(141433), // Rule ID 387 //
     /* 141402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141424 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 141427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141431 */     GIR_RootConstrainSelectedInstOperands,
     /* 141432 */     // GIR_Coverage, 387,
     /* 141432 */     GIR_EraseRootFromParent_Done,
     /* 141433 */   // Label 2747: @141433
     /* 141433 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(141469), // Rule ID 388 //
     /* 141438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141460 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 141463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141467 */     GIR_RootConstrainSelectedInstOperands,
     /* 141468 */     // GIR_Coverage, 388,
     /* 141468 */     GIR_EraseRootFromParent_Done,
     /* 141469 */   // Label 2748: @141469
     /* 141469 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(141505), // Rule ID 389 //
     /* 141474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141496 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 141499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141503 */     GIR_RootConstrainSelectedInstOperands,
     /* 141504 */     // GIR_Coverage, 389,
     /* 141504 */     GIR_EraseRootFromParent_Done,
     /* 141505 */   // Label 2749: @141505
     /* 141505 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(141541), // Rule ID 390 //
     /* 141510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141532 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 141535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141539 */     GIR_RootConstrainSelectedInstOperands,
     /* 141540 */     // GIR_Coverage, 390,
     /* 141540 */     GIR_EraseRootFromParent_Done,
     /* 141541 */   // Label 2750: @141541
     /* 141541 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(141577), // Rule ID 391 //
     /* 141546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141568 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 141571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141575 */     GIR_RootConstrainSelectedInstOperands,
     /* 141576 */     // GIR_Coverage, 391,
     /* 141576 */     GIR_EraseRootFromParent_Done,
     /* 141577 */   // Label 2751: @141577
     /* 141577 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(141613), // Rule ID 392 //
     /* 141582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141604 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 141607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141611 */     GIR_RootConstrainSelectedInstOperands,
     /* 141612 */     // GIR_Coverage, 392,
     /* 141612 */     GIR_EraseRootFromParent_Done,
     /* 141613 */   // Label 2752: @141613
     /* 141613 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(141649), // Rule ID 393 //
     /* 141618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141640 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 141643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141647 */     GIR_RootConstrainSelectedInstOperands,
     /* 141648 */     // GIR_Coverage, 393,
     /* 141648 */     GIR_EraseRootFromParent_Done,
     /* 141649 */   // Label 2753: @141649
     /* 141649 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(141685), // Rule ID 575 //
     /* 141654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 141662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141676 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 141679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141683 */     GIR_RootConstrainSelectedInstOperands,
     /* 141684 */     // GIR_Coverage, 575,
     /* 141684 */     GIR_EraseRootFromParent_Done,
     /* 141685 */   // Label 2754: @141685
     /* 141685 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(141721), // Rule ID 576 //
     /* 141690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 141698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141712 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 141715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141719 */     GIR_RootConstrainSelectedInstOperands,
     /* 141720 */     // GIR_Coverage, 576,
     /* 141720 */     GIR_EraseRootFromParent_Done,
     /* 141721 */   // Label 2755: @141721
     /* 141721 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(141757), // Rule ID 577 //
     /* 141726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141748 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 141751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141755 */     GIR_RootConstrainSelectedInstOperands,
     /* 141756 */     // GIR_Coverage, 577,
     /* 141756 */     GIR_EraseRootFromParent_Done,
     /* 141757 */   // Label 2756: @141757
     /* 141757 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(141793), // Rule ID 578 //
     /* 141762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 141770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141784 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 141787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141791 */     GIR_RootConstrainSelectedInstOperands,
     /* 141792 */     // GIR_Coverage, 578,
     /* 141792 */     GIR_EraseRootFromParent_Done,
     /* 141793 */   // Label 2757: @141793
     /* 141793 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(141829), // Rule ID 579 //
     /* 141798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141820 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 141823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141827 */     GIR_RootConstrainSelectedInstOperands,
     /* 141828 */     // GIR_Coverage, 579,
     /* 141828 */     GIR_EraseRootFromParent_Done,
     /* 141829 */   // Label 2758: @141829
     /* 141829 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(141865), // Rule ID 580 //
     /* 141834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 141842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141856 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 141859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141863 */     GIR_RootConstrainSelectedInstOperands,
     /* 141864 */     // GIR_Coverage, 580,
     /* 141864 */     GIR_EraseRootFromParent_Done,
     /* 141865 */   // Label 2759: @141865
     /* 141865 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(141901), // Rule ID 581 //
     /* 141870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141892 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 141892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 141895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141899 */     GIR_RootConstrainSelectedInstOperands,
     /* 141900 */     // GIR_Coverage, 581,
     /* 141900 */     GIR_EraseRootFromParent_Done,
     /* 141901 */   // Label 2760: @141901
     /* 141901 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(141937), // Rule ID 582 //
     /* 141906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 141909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 141914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141928 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 141928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 141931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141935 */     GIR_RootConstrainSelectedInstOperands,
     /* 141936 */     // GIR_Coverage, 582,
     /* 141936 */     GIR_EraseRootFromParent_Done,
     /* 141937 */   // Label 2761: @141937
     /* 141937 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(141973), // Rule ID 710 //
     /* 141942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 141953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 141956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141964 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 141964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 141967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141971 */     GIR_RootConstrainSelectedInstOperands,
     /* 141972 */     // GIR_Coverage, 710,
     /* 141972 */     GIR_EraseRootFromParent_Done,
     /* 141973 */   // Label 2762: @141973
     /* 141973 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142009), // Rule ID 711 //
     /* 141978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 141981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 141986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 141989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 141992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142000 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 142003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142007 */     GIR_RootConstrainSelectedInstOperands,
     /* 142008 */     // GIR_Coverage, 711,
     /* 142008 */     GIR_EraseRootFromParent_Done,
     /* 142009 */   // Label 2763: @142009
     /* 142009 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142045), // Rule ID 712 //
     /* 142014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142036 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 142039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142043 */     GIR_RootConstrainSelectedInstOperands,
     /* 142044 */     // GIR_Coverage, 712,
     /* 142044 */     GIR_EraseRootFromParent_Done,
     /* 142045 */   // Label 2764: @142045
     /* 142045 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142081), // Rule ID 713 //
     /* 142050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142072 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 142075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142079 */     GIR_RootConstrainSelectedInstOperands,
     /* 142080 */     // GIR_Coverage, 713,
     /* 142080 */     GIR_EraseRootFromParent_Done,
     /* 142081 */   // Label 2765: @142081
     /* 142081 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142117), // Rule ID 714 //
     /* 142086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142108 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 142108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 142111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142115 */     GIR_RootConstrainSelectedInstOperands,
     /* 142116 */     // GIR_Coverage, 714,
     /* 142116 */     GIR_EraseRootFromParent_Done,
     /* 142117 */   // Label 2766: @142117
     /* 142117 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142153), // Rule ID 715 //
     /* 142122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142144 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 142144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 142147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142151 */     GIR_RootConstrainSelectedInstOperands,
     /* 142152 */     // GIR_Coverage, 715,
     /* 142152 */     GIR_EraseRootFromParent_Done,
     /* 142153 */   // Label 2767: @142153
     /* 142153 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142189), // Rule ID 796 //
     /* 142158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142180 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 142183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142187 */     GIR_RootConstrainSelectedInstOperands,
     /* 142188 */     // GIR_Coverage, 796,
     /* 142188 */     GIR_EraseRootFromParent_Done,
     /* 142189 */   // Label 2768: @142189
     /* 142189 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142225), // Rule ID 797 //
     /* 142194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142216 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 142219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142223 */     GIR_RootConstrainSelectedInstOperands,
     /* 142224 */     // GIR_Coverage, 797,
     /* 142224 */     GIR_EraseRootFromParent_Done,
     /* 142225 */   // Label 2769: @142225
     /* 142225 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(142261), // Rule ID 798 //
     /* 142230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142252 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 142255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142259 */     GIR_RootConstrainSelectedInstOperands,
     /* 142260 */     // GIR_Coverage, 798,
     /* 142260 */     GIR_EraseRootFromParent_Done,
     /* 142261 */   // Label 2770: @142261
     /* 142261 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(142297), // Rule ID 799 //
     /* 142266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142288 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 142291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142295 */     GIR_RootConstrainSelectedInstOperands,
     /* 142296 */     // GIR_Coverage, 799,
     /* 142296 */     GIR_EraseRootFromParent_Done,
     /* 142297 */   // Label 2771: @142297
     /* 142297 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(142333), // Rule ID 800 //
     /* 142302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142324 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 142327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142331 */     GIR_RootConstrainSelectedInstOperands,
     /* 142332 */     // GIR_Coverage, 800,
     /* 142332 */     GIR_EraseRootFromParent_Done,
     /* 142333 */   // Label 2772: @142333
     /* 142333 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(142369), // Rule ID 801 //
     /* 142338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142360 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 142363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142367 */     GIR_RootConstrainSelectedInstOperands,
     /* 142368 */     // GIR_Coverage, 801,
     /* 142368 */     GIR_EraseRootFromParent_Done,
     /* 142369 */   // Label 2773: @142369
     /* 142369 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(142405), // Rule ID 802 //
     /* 142374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142396 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 142399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142403 */     GIR_RootConstrainSelectedInstOperands,
     /* 142404 */     // GIR_Coverage, 802,
     /* 142404 */     GIR_EraseRootFromParent_Done,
     /* 142405 */   // Label 2774: @142405
     /* 142405 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(142441), // Rule ID 803 //
     /* 142410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142432 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 142435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142439 */     GIR_RootConstrainSelectedInstOperands,
     /* 142440 */     // GIR_Coverage, 803,
     /* 142440 */     GIR_EraseRootFromParent_Done,
     /* 142441 */   // Label 2775: @142441
     /* 142441 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(142477), // Rule ID 804 //
     /* 142446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142468 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 142471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142475 */     GIR_RootConstrainSelectedInstOperands,
     /* 142476 */     // GIR_Coverage, 804,
     /* 142476 */     GIR_EraseRootFromParent_Done,
     /* 142477 */   // Label 2776: @142477
     /* 142477 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(142513), // Rule ID 805 //
     /* 142482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142504 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 142507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142511 */     GIR_RootConstrainSelectedInstOperands,
     /* 142512 */     // GIR_Coverage, 805,
     /* 142512 */     GIR_EraseRootFromParent_Done,
     /* 142513 */   // Label 2777: @142513
     /* 142513 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(142549), // Rule ID 806 //
     /* 142518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142540 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 142543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142547 */     GIR_RootConstrainSelectedInstOperands,
     /* 142548 */     // GIR_Coverage, 806,
     /* 142548 */     GIR_EraseRootFromParent_Done,
     /* 142549 */   // Label 2778: @142549
     /* 142549 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(142585), // Rule ID 807 //
     /* 142554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142576 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 142579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142583 */     GIR_RootConstrainSelectedInstOperands,
     /* 142584 */     // GIR_Coverage, 807,
     /* 142584 */     GIR_EraseRootFromParent_Done,
     /* 142585 */   // Label 2779: @142585
     /* 142585 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(142621), // Rule ID 808 //
     /* 142590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142612 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 142615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142619 */     GIR_RootConstrainSelectedInstOperands,
     /* 142620 */     // GIR_Coverage, 808,
     /* 142620 */     GIR_EraseRootFromParent_Done,
     /* 142621 */   // Label 2780: @142621
     /* 142621 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(142657), // Rule ID 809 //
     /* 142626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 142651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142655 */     GIR_RootConstrainSelectedInstOperands,
     /* 142656 */     // GIR_Coverage, 809,
     /* 142656 */     GIR_EraseRootFromParent_Done,
     /* 142657 */   // Label 2781: @142657
     /* 142657 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(142693), // Rule ID 810 //
     /* 142662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 142670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142684 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 142687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142691 */     GIR_RootConstrainSelectedInstOperands,
     /* 142692 */     // GIR_Coverage, 810,
     /* 142692 */     GIR_EraseRootFromParent_Done,
     /* 142693 */   // Label 2782: @142693
     /* 142693 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(142729), // Rule ID 811 //
     /* 142698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142720 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 142723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142727 */     GIR_RootConstrainSelectedInstOperands,
     /* 142728 */     // GIR_Coverage, 811,
     /* 142728 */     GIR_EraseRootFromParent_Done,
     /* 142729 */   // Label 2783: @142729
     /* 142729 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(142765), // Rule ID 812 //
     /* 142734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142756 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 142759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142763 */     GIR_RootConstrainSelectedInstOperands,
     /* 142764 */     // GIR_Coverage, 812,
     /* 142764 */     GIR_EraseRootFromParent_Done,
     /* 142765 */   // Label 2784: @142765
     /* 142765 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(142801), // Rule ID 813 //
     /* 142770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142792 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 142795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142799 */     GIR_RootConstrainSelectedInstOperands,
     /* 142800 */     // GIR_Coverage, 813,
     /* 142800 */     GIR_EraseRootFromParent_Done,
     /* 142801 */   // Label 2785: @142801
     /* 142801 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(142837), // Rule ID 814 //
     /* 142806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 142831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142835 */     GIR_RootConstrainSelectedInstOperands,
     /* 142836 */     // GIR_Coverage, 814,
     /* 142836 */     GIR_EraseRootFromParent_Done,
     /* 142837 */   // Label 2786: @142837
     /* 142837 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(142873), // Rule ID 815 //
     /* 142842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 142850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142864 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 142867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142871 */     GIR_RootConstrainSelectedInstOperands,
     /* 142872 */     // GIR_Coverage, 815,
     /* 142872 */     GIR_EraseRootFromParent_Done,
     /* 142873 */   // Label 2787: @142873
     /* 142873 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(142909), // Rule ID 816 //
     /* 142878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142900 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 142903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142907 */     GIR_RootConstrainSelectedInstOperands,
     /* 142908 */     // GIR_Coverage, 816,
     /* 142908 */     GIR_EraseRootFromParent_Done,
     /* 142909 */   // Label 2788: @142909
     /* 142909 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(142945), // Rule ID 817 //
     /* 142914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142936 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 142939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142943 */     GIR_RootConstrainSelectedInstOperands,
     /* 142944 */     // GIR_Coverage, 817,
     /* 142944 */     GIR_EraseRootFromParent_Done,
     /* 142945 */   // Label 2789: @142945
     /* 142945 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(142981), // Rule ID 818 //
     /* 142950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142972 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 142975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142979 */     GIR_RootConstrainSelectedInstOperands,
     /* 142980 */     // GIR_Coverage, 818,
     /* 142980 */     GIR_EraseRootFromParent_Done,
     /* 142981 */   // Label 2790: @142981
     /* 142981 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143017), // Rule ID 819 //
     /* 142986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 142994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143008 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 143011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143015 */     GIR_RootConstrainSelectedInstOperands,
     /* 143016 */     // GIR_Coverage, 819,
     /* 143016 */     GIR_EraseRootFromParent_Done,
     /* 143017 */   // Label 2791: @143017
     /* 143017 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143053), // Rule ID 820 //
     /* 143022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143044 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 143047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143051 */     GIR_RootConstrainSelectedInstOperands,
     /* 143052 */     // GIR_Coverage, 820,
     /* 143052 */     GIR_EraseRootFromParent_Done,
     /* 143053 */   // Label 2792: @143053
     /* 143053 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143089), // Rule ID 821 //
     /* 143058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143080 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 143083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143087 */     GIR_RootConstrainSelectedInstOperands,
     /* 143088 */     // GIR_Coverage, 821,
     /* 143088 */     GIR_EraseRootFromParent_Done,
     /* 143089 */   // Label 2793: @143089
     /* 143089 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143125), // Rule ID 822 //
     /* 143094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143116 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 143119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143123 */     GIR_RootConstrainSelectedInstOperands,
     /* 143124 */     // GIR_Coverage, 822,
     /* 143124 */     GIR_EraseRootFromParent_Done,
     /* 143125 */   // Label 2794: @143125
     /* 143125 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143161), // Rule ID 823 //
     /* 143130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143152 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 143155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143159 */     GIR_RootConstrainSelectedInstOperands,
     /* 143160 */     // GIR_Coverage, 823,
     /* 143160 */     GIR_EraseRootFromParent_Done,
     /* 143161 */   // Label 2795: @143161
     /* 143161 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143197), // Rule ID 824 //
     /* 143166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143188 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 143191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143195 */     GIR_RootConstrainSelectedInstOperands,
     /* 143196 */     // GIR_Coverage, 824,
     /* 143196 */     GIR_EraseRootFromParent_Done,
     /* 143197 */   // Label 2796: @143197
     /* 143197 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(143233), // Rule ID 825 //
     /* 143202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143224 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 143227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143231 */     GIR_RootConstrainSelectedInstOperands,
     /* 143232 */     // GIR_Coverage, 825,
     /* 143232 */     GIR_EraseRootFromParent_Done,
     /* 143233 */   // Label 2797: @143233
     /* 143233 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(143269), // Rule ID 826 //
     /* 143238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143260 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 143263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143267 */     GIR_RootConstrainSelectedInstOperands,
     /* 143268 */     // GIR_Coverage, 826,
     /* 143268 */     GIR_EraseRootFromParent_Done,
     /* 143269 */   // Label 2798: @143269
     /* 143269 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(143305), // Rule ID 827 //
     /* 143274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143296 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 143299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143303 */     GIR_RootConstrainSelectedInstOperands,
     /* 143304 */     // GIR_Coverage, 827,
     /* 143304 */     GIR_EraseRootFromParent_Done,
     /* 143305 */   // Label 2799: @143305
     /* 143305 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(143341), // Rule ID 828 //
     /* 143310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143332 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 143335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143339 */     GIR_RootConstrainSelectedInstOperands,
     /* 143340 */     // GIR_Coverage, 828,
     /* 143340 */     GIR_EraseRootFromParent_Done,
     /* 143341 */   // Label 2800: @143341
     /* 143341 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(143377), // Rule ID 829 //
     /* 143346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143368 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 143371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143375 */     GIR_RootConstrainSelectedInstOperands,
     /* 143376 */     // GIR_Coverage, 829,
     /* 143376 */     GIR_EraseRootFromParent_Done,
     /* 143377 */   // Label 2801: @143377
     /* 143377 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(143413), // Rule ID 830 //
     /* 143382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143404 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 143407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143411 */     GIR_RootConstrainSelectedInstOperands,
     /* 143412 */     // GIR_Coverage, 830,
     /* 143412 */     GIR_EraseRootFromParent_Done,
     /* 143413 */   // Label 2802: @143413
     /* 143413 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(143449), // Rule ID 831 //
     /* 143418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143440 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 143443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143447 */     GIR_RootConstrainSelectedInstOperands,
     /* 143448 */     // GIR_Coverage, 831,
     /* 143448 */     GIR_EraseRootFromParent_Done,
     /* 143449 */   // Label 2803: @143449
     /* 143449 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(143485), // Rule ID 832 //
     /* 143454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 143479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143483 */     GIR_RootConstrainSelectedInstOperands,
     /* 143484 */     // GIR_Coverage, 832,
     /* 143484 */     GIR_EraseRootFromParent_Done,
     /* 143485 */   // Label 2804: @143485
     /* 143485 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(143521), // Rule ID 833 //
     /* 143490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143512 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 143515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143519 */     GIR_RootConstrainSelectedInstOperands,
     /* 143520 */     // GIR_Coverage, 833,
     /* 143520 */     GIR_EraseRootFromParent_Done,
     /* 143521 */   // Label 2805: @143521
     /* 143521 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(143557), // Rule ID 834 //
     /* 143526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143548 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 143551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143555 */     GIR_RootConstrainSelectedInstOperands,
     /* 143556 */     // GIR_Coverage, 834,
     /* 143556 */     GIR_EraseRootFromParent_Done,
     /* 143557 */   // Label 2806: @143557
     /* 143557 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(143593), // Rule ID 835 //
     /* 143562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143584 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 143587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143591 */     GIR_RootConstrainSelectedInstOperands,
     /* 143592 */     // GIR_Coverage, 835,
     /* 143592 */     GIR_EraseRootFromParent_Done,
     /* 143593 */   // Label 2807: @143593
     /* 143593 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(143629), // Rule ID 836 //
     /* 143598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 143606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143620 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 143620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 143623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143627 */     GIR_RootConstrainSelectedInstOperands,
     /* 143628 */     // GIR_Coverage, 836,
     /* 143628 */     GIR_EraseRootFromParent_Done,
     /* 143629 */   // Label 2808: @143629
     /* 143629 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(143665), // Rule ID 863 //
     /* 143634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143656 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 143656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 143659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143663 */     GIR_RootConstrainSelectedInstOperands,
     /* 143664 */     // GIR_Coverage, 863,
     /* 143664 */     GIR_EraseRootFromParent_Done,
     /* 143665 */   // Label 2809: @143665
     /* 143665 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(143701), // Rule ID 864 //
     /* 143670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143692 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 143692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 143695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143699 */     GIR_RootConstrainSelectedInstOperands,
     /* 143700 */     // GIR_Coverage, 864,
     /* 143700 */     GIR_EraseRootFromParent_Done,
     /* 143701 */   // Label 2810: @143701
     /* 143701 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(143737), // Rule ID 865 //
     /* 143706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143728 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 143731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143735 */     GIR_RootConstrainSelectedInstOperands,
     /* 143736 */     // GIR_Coverage, 865,
     /* 143736 */     GIR_EraseRootFromParent_Done,
     /* 143737 */   // Label 2811: @143737
     /* 143737 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(143773), // Rule ID 866 //
     /* 143742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143764 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 143767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143771 */     GIR_RootConstrainSelectedInstOperands,
     /* 143772 */     // GIR_Coverage, 866,
     /* 143772 */     GIR_EraseRootFromParent_Done,
     /* 143773 */   // Label 2812: @143773
     /* 143773 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(143809), // Rule ID 867 //
     /* 143778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 143786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143800 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 143803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143807 */     GIR_RootConstrainSelectedInstOperands,
     /* 143808 */     // GIR_Coverage, 867,
     /* 143808 */     GIR_EraseRootFromParent_Done,
     /* 143809 */   // Label 2813: @143809
     /* 143809 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(143845), // Rule ID 938 //
     /* 143814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143836 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 143839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143843 */     GIR_RootConstrainSelectedInstOperands,
     /* 143844 */     // GIR_Coverage, 938,
     /* 143844 */     GIR_EraseRootFromParent_Done,
     /* 143845 */   // Label 2814: @143845
     /* 143845 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(143881), // Rule ID 939 //
     /* 143850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143872 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 143875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143879 */     GIR_RootConstrainSelectedInstOperands,
     /* 143880 */     // GIR_Coverage, 939,
     /* 143880 */     GIR_EraseRootFromParent_Done,
     /* 143881 */   // Label 2815: @143881
     /* 143881 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(143917), // Rule ID 940 //
     /* 143886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 143894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143908 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 143908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 143911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143915 */     GIR_RootConstrainSelectedInstOperands,
     /* 143916 */     // GIR_Coverage, 940,
     /* 143916 */     GIR_EraseRootFromParent_Done,
     /* 143917 */   // Label 2816: @143917
     /* 143917 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(143953), // Rule ID 941 //
     /* 143922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143944 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 143944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 143947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143951 */     GIR_RootConstrainSelectedInstOperands,
     /* 143952 */     // GIR_Coverage, 941,
     /* 143952 */     GIR_EraseRootFromParent_Done,
     /* 143953 */   // Label 2817: @143953
     /* 143953 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(143989), // Rule ID 942 //
     /* 143958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 143966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143980 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 143980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 143983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143987 */     GIR_RootConstrainSelectedInstOperands,
     /* 143988 */     // GIR_Coverage, 942,
     /* 143988 */     GIR_EraseRootFromParent_Done,
     /* 143989 */   // Label 2818: @143989
     /* 143989 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144025), // Rule ID 943 //
     /* 143994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 143997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144016 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 144019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144023 */     GIR_RootConstrainSelectedInstOperands,
     /* 144024 */     // GIR_Coverage, 943,
     /* 144024 */     GIR_EraseRootFromParent_Done,
     /* 144025 */   // Label 2819: @144025
     /* 144025 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144061), // Rule ID 944 //
     /* 144030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144052 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 144055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144059 */     GIR_RootConstrainSelectedInstOperands,
     /* 144060 */     // GIR_Coverage, 944,
     /* 144060 */     GIR_EraseRootFromParent_Done,
     /* 144061 */   // Label 2820: @144061
     /* 144061 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144097), // Rule ID 945 //
     /* 144066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144088 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 144091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144095 */     GIR_RootConstrainSelectedInstOperands,
     /* 144096 */     // GIR_Coverage, 945,
     /* 144096 */     GIR_EraseRootFromParent_Done,
     /* 144097 */   // Label 2821: @144097
     /* 144097 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144133), // Rule ID 946 //
     /* 144102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144124 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 144127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144131 */     GIR_RootConstrainSelectedInstOperands,
     /* 144132 */     // GIR_Coverage, 946,
     /* 144132 */     GIR_EraseRootFromParent_Done,
     /* 144133 */   // Label 2822: @144133
     /* 144133 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144169), // Rule ID 947 //
     /* 144138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144160 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 144163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144167 */     GIR_RootConstrainSelectedInstOperands,
     /* 144168 */     // GIR_Coverage, 947,
     /* 144168 */     GIR_EraseRootFromParent_Done,
     /* 144169 */   // Label 2823: @144169
     /* 144169 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144205), // Rule ID 948 //
     /* 144174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144196 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 144199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144203 */     GIR_RootConstrainSelectedInstOperands,
     /* 144204 */     // GIR_Coverage, 948,
     /* 144204 */     GIR_EraseRootFromParent_Done,
     /* 144205 */   // Label 2824: @144205
     /* 144205 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(144241), // Rule ID 949 //
     /* 144210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144232 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 144235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144239 */     GIR_RootConstrainSelectedInstOperands,
     /* 144240 */     // GIR_Coverage, 949,
     /* 144240 */     GIR_EraseRootFromParent_Done,
     /* 144241 */   // Label 2825: @144241
     /* 144241 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(144277), // Rule ID 950 //
     /* 144246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144268 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 144268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 144271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144275 */     GIR_RootConstrainSelectedInstOperands,
     /* 144276 */     // GIR_Coverage, 950,
     /* 144276 */     GIR_EraseRootFromParent_Done,
     /* 144277 */   // Label 2826: @144277
     /* 144277 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(144313), // Rule ID 951 //
     /* 144282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144304 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 144304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 144307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144311 */     GIR_RootConstrainSelectedInstOperands,
     /* 144312 */     // GIR_Coverage, 951,
     /* 144312 */     GIR_EraseRootFromParent_Done,
     /* 144313 */   // Label 2827: @144313
     /* 144313 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(144349), // Rule ID 952 //
     /* 144318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144340 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 144343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144347 */     GIR_RootConstrainSelectedInstOperands,
     /* 144348 */     // GIR_Coverage, 952,
     /* 144348 */     GIR_EraseRootFromParent_Done,
     /* 144349 */   // Label 2828: @144349
     /* 144349 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(144385), // Rule ID 953 //
     /* 144354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144376 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 144379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144383 */     GIR_RootConstrainSelectedInstOperands,
     /* 144384 */     // GIR_Coverage, 953,
     /* 144384 */     GIR_EraseRootFromParent_Done,
     /* 144385 */   // Label 2829: @144385
     /* 144385 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(144421), // Rule ID 954 //
     /* 144390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144412 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 144415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144419 */     GIR_RootConstrainSelectedInstOperands,
     /* 144420 */     // GIR_Coverage, 954,
     /* 144420 */     GIR_EraseRootFromParent_Done,
     /* 144421 */   // Label 2830: @144421
     /* 144421 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(144457), // Rule ID 1001 //
     /* 144426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144448 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 144448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 144451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144455 */     GIR_RootConstrainSelectedInstOperands,
     /* 144456 */     // GIR_Coverage, 1001,
     /* 144456 */     GIR_EraseRootFromParent_Done,
     /* 144457 */   // Label 2831: @144457
     /* 144457 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(144493), // Rule ID 1003 //
     /* 144462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144484 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 144484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 144487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144491 */     GIR_RootConstrainSelectedInstOperands,
     /* 144492 */     // GIR_Coverage, 1003,
     /* 144492 */     GIR_EraseRootFromParent_Done,
     /* 144493 */   // Label 2832: @144493
     /* 144493 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(144529), // Rule ID 1005 //
     /* 144498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144520 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 144520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 144523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144527 */     GIR_RootConstrainSelectedInstOperands,
     /* 144528 */     // GIR_Coverage, 1005,
     /* 144528 */     GIR_EraseRootFromParent_Done,
     /* 144529 */   // Label 2833: @144529
     /* 144529 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(144565), // Rule ID 1007 //
     /* 144534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144556 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 144556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 144559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144563 */     GIR_RootConstrainSelectedInstOperands,
     /* 144564 */     // GIR_Coverage, 1007,
     /* 144564 */     GIR_EraseRootFromParent_Done,
     /* 144565 */   // Label 2834: @144565
     /* 144565 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(144601), // Rule ID 1009 //
     /* 144570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 144581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144592 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 144592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 144595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144599 */     GIR_RootConstrainSelectedInstOperands,
     /* 144600 */     // GIR_Coverage, 1009,
     /* 144600 */     GIR_EraseRootFromParent_Done,
     /* 144601 */   // Label 2835: @144601
     /* 144601 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(144637), // Rule ID 1011 //
     /* 144606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144628 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 144628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 144631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144635 */     GIR_RootConstrainSelectedInstOperands,
     /* 144636 */     // GIR_Coverage, 1011,
     /* 144636 */     GIR_EraseRootFromParent_Done,
     /* 144637 */   // Label 2836: @144637
     /* 144637 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(144673), // Rule ID 1022 //
     /* 144642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144664 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 144667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144671 */     GIR_RootConstrainSelectedInstOperands,
     /* 144672 */     // GIR_Coverage, 1022,
     /* 144672 */     GIR_EraseRootFromParent_Done,
     /* 144673 */   // Label 2837: @144673
     /* 144673 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(144709), // Rule ID 1023 //
     /* 144678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144700 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 144703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144707 */     GIR_RootConstrainSelectedInstOperands,
     /* 144708 */     // GIR_Coverage, 1023,
     /* 144708 */     GIR_EraseRootFromParent_Done,
     /* 144709 */   // Label 2838: @144709
     /* 144709 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(144745), // Rule ID 1024 //
     /* 144714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144736 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 144739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144743 */     GIR_RootConstrainSelectedInstOperands,
     /* 144744 */     // GIR_Coverage, 1024,
     /* 144744 */     GIR_EraseRootFromParent_Done,
     /* 144745 */   // Label 2839: @144745
     /* 144745 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(144781), // Rule ID 1025 //
     /* 144750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144772 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 144772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 144775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144779 */     GIR_RootConstrainSelectedInstOperands,
     /* 144780 */     // GIR_Coverage, 1025,
     /* 144780 */     GIR_EraseRootFromParent_Done,
     /* 144781 */   // Label 2840: @144781
     /* 144781 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(144817), // Rule ID 1026 //
     /* 144786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144808 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 144808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 144811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144815 */     GIR_RootConstrainSelectedInstOperands,
     /* 144816 */     // GIR_Coverage, 1026,
     /* 144816 */     GIR_EraseRootFromParent_Done,
     /* 144817 */   // Label 2841: @144817
     /* 144817 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(144853), // Rule ID 1027 //
     /* 144822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144844 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 144844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 144847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144851 */     GIR_RootConstrainSelectedInstOperands,
     /* 144852 */     // GIR_Coverage, 1027,
     /* 144852 */     GIR_EraseRootFromParent_Done,
     /* 144853 */   // Label 2842: @144853
     /* 144853 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(144889), // Rule ID 1028 //
     /* 144858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 144866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 144880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 144883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144887 */     GIR_RootConstrainSelectedInstOperands,
     /* 144888 */     // GIR_Coverage, 1028,
     /* 144888 */     GIR_EraseRootFromParent_Done,
     /* 144889 */   // Label 2843: @144889
     /* 144889 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(144925), // Rule ID 1029 //
     /* 144894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 144905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144916 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 144916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 144919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144923 */     GIR_RootConstrainSelectedInstOperands,
     /* 144924 */     // GIR_Coverage, 1029,
     /* 144924 */     GIR_EraseRootFromParent_Done,
     /* 144925 */   // Label 2844: @144925
     /* 144925 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(144961), // Rule ID 1030 //
     /* 144930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 144941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144952 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 144952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 144955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144959 */     GIR_RootConstrainSelectedInstOperands,
     /* 144960 */     // GIR_Coverage, 1030,
     /* 144960 */     GIR_EraseRootFromParent_Done,
     /* 144961 */   // Label 2845: @144961
     /* 144961 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(144997), // Rule ID 1031 //
     /* 144966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 144974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144988 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 144988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 144991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144995 */     GIR_RootConstrainSelectedInstOperands,
     /* 144996 */     // GIR_Coverage, 1031,
     /* 144996 */     GIR_EraseRootFromParent_Done,
     /* 144997 */   // Label 2846: @144997
     /* 144997 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145033), // Rule ID 1032 //
     /* 145002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145024 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 145027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145031 */     GIR_RootConstrainSelectedInstOperands,
     /* 145032 */     // GIR_Coverage, 1032,
     /* 145032 */     GIR_EraseRootFromParent_Done,
     /* 145033 */   // Label 2847: @145033
     /* 145033 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145069), // Rule ID 1033 //
     /* 145038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145060 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 145063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145067 */     GIR_RootConstrainSelectedInstOperands,
     /* 145068 */     // GIR_Coverage, 1033,
     /* 145068 */     GIR_EraseRootFromParent_Done,
     /* 145069 */   // Label 2848: @145069
     /* 145069 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145105), // Rule ID 1034 //
     /* 145074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 145099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145103 */     GIR_RootConstrainSelectedInstOperands,
     /* 145104 */     // GIR_Coverage, 1034,
     /* 145104 */     GIR_EraseRootFromParent_Done,
     /* 145105 */   // Label 2849: @145105
     /* 145105 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145141), // Rule ID 1035 //
     /* 145110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145132 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 145132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 145135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145139 */     GIR_RootConstrainSelectedInstOperands,
     /* 145140 */     // GIR_Coverage, 1035,
     /* 145140 */     GIR_EraseRootFromParent_Done,
     /* 145141 */   // Label 2850: @145141
     /* 145141 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145177), // Rule ID 1062 //
     /* 145146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145168 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 145168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 145171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145175 */     GIR_RootConstrainSelectedInstOperands,
     /* 145176 */     // GIR_Coverage, 1062,
     /* 145176 */     GIR_EraseRootFromParent_Done,
     /* 145177 */   // Label 2851: @145177
     /* 145177 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145213), // Rule ID 1064 //
     /* 145182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 145204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 145207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145211 */     GIR_RootConstrainSelectedInstOperands,
     /* 145212 */     // GIR_Coverage, 1064,
     /* 145212 */     GIR_EraseRootFromParent_Done,
     /* 145213 */   // Label 2852: @145213
     /* 145213 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(145249), // Rule ID 1066 //
     /* 145218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145240 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 145240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 145243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145247 */     GIR_RootConstrainSelectedInstOperands,
     /* 145248 */     // GIR_Coverage, 1066,
     /* 145248 */     GIR_EraseRootFromParent_Done,
     /* 145249 */   // Label 2853: @145249
     /* 145249 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(145285), // Rule ID 1068 //
     /* 145254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145276 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 145276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 145279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145283 */     GIR_RootConstrainSelectedInstOperands,
     /* 145284 */     // GIR_Coverage, 1068,
     /* 145284 */     GIR_EraseRootFromParent_Done,
     /* 145285 */   // Label 2854: @145285
     /* 145285 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(145321), // Rule ID 1070 //
     /* 145290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145312 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 145312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 145315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145319 */     GIR_RootConstrainSelectedInstOperands,
     /* 145320 */     // GIR_Coverage, 1070,
     /* 145320 */     GIR_EraseRootFromParent_Done,
     /* 145321 */   // Label 2855: @145321
     /* 145321 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(145357), // Rule ID 1072 //
     /* 145326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145348 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 145348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 145351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145355 */     GIR_RootConstrainSelectedInstOperands,
     /* 145356 */     // GIR_Coverage, 1072,
     /* 145356 */     GIR_EraseRootFromParent_Done,
     /* 145357 */   // Label 2856: @145357
     /* 145357 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(145393), // Rule ID 1086 //
     /* 145362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145384 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 145387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145391 */     GIR_RootConstrainSelectedInstOperands,
     /* 145392 */     // GIR_Coverage, 1086,
     /* 145392 */     GIR_EraseRootFromParent_Done,
     /* 145393 */   // Label 2857: @145393
     /* 145393 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(145429), // Rule ID 1087 //
     /* 145398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145420 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 145423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145427 */     GIR_RootConstrainSelectedInstOperands,
     /* 145428 */     // GIR_Coverage, 1087,
     /* 145428 */     GIR_EraseRootFromParent_Done,
     /* 145429 */   // Label 2858: @145429
     /* 145429 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(145465), // Rule ID 1088 //
     /* 145434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 145442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145456 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 145459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145463 */     GIR_RootConstrainSelectedInstOperands,
     /* 145464 */     // GIR_Coverage, 1088,
     /* 145464 */     GIR_EraseRootFromParent_Done,
     /* 145465 */   // Label 2859: @145465
     /* 145465 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(145501), // Rule ID 1089 //
     /* 145470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 145478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 145495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145499 */     GIR_RootConstrainSelectedInstOperands,
     /* 145500 */     // GIR_Coverage, 1089,
     /* 145500 */     GIR_EraseRootFromParent_Done,
     /* 145501 */   // Label 2860: @145501
     /* 145501 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(145537), // Rule ID 1653 //
     /* 145506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 145514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145528 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 145531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145535 */     GIR_RootConstrainSelectedInstOperands,
     /* 145536 */     // GIR_Coverage, 1653,
     /* 145536 */     GIR_EraseRootFromParent_Done,
     /* 145537 */   // Label 2861: @145537
     /* 145537 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(145573), // Rule ID 1659 //
     /* 145542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145564 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 145564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 145567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145571 */     GIR_RootConstrainSelectedInstOperands,
     /* 145572 */     // GIR_Coverage, 1659,
     /* 145572 */     GIR_EraseRootFromParent_Done,
     /* 145573 */   // Label 2862: @145573
     /* 145573 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(145609), // Rule ID 1660 //
     /* 145578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145600 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 145600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 145603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145607 */     GIR_RootConstrainSelectedInstOperands,
     /* 145608 */     // GIR_Coverage, 1660,
     /* 145608 */     GIR_EraseRootFromParent_Done,
     /* 145609 */   // Label 2863: @145609
     /* 145609 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(145645), // Rule ID 1661 //
     /* 145614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145636 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 145636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 145639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145643 */     GIR_RootConstrainSelectedInstOperands,
     /* 145644 */     // GIR_Coverage, 1661,
     /* 145644 */     GIR_EraseRootFromParent_Done,
     /* 145645 */   // Label 2864: @145645
     /* 145645 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(145681), // Rule ID 1662 //
     /* 145650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145672 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 145672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 145675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145679 */     GIR_RootConstrainSelectedInstOperands,
     /* 145680 */     // GIR_Coverage, 1662,
     /* 145680 */     GIR_EraseRootFromParent_Done,
     /* 145681 */   // Label 2865: @145681
     /* 145681 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(145717), // Rule ID 1663 //
     /* 145686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 145694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145708 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 145711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145715 */     GIR_RootConstrainSelectedInstOperands,
     /* 145716 */     // GIR_Coverage, 1663,
     /* 145716 */     GIR_EraseRootFromParent_Done,
     /* 145717 */   // Label 2866: @145717
     /* 145717 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(145753), // Rule ID 1664 //
     /* 145722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 145730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145744 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145751 */     GIR_RootConstrainSelectedInstOperands,
     /* 145752 */     // GIR_Coverage, 1664,
     /* 145752 */     GIR_EraseRootFromParent_Done,
     /* 145753 */   // Label 2867: @145753
     /* 145753 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(145789), // Rule ID 1670 //
     /* 145758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 145766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145780 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 145780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 145783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145787 */     GIR_RootConstrainSelectedInstOperands,
     /* 145788 */     // GIR_Coverage, 1670,
     /* 145788 */     GIR_EraseRootFromParent_Done,
     /* 145789 */   // Label 2868: @145789
     /* 145789 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(145825), // Rule ID 1943 //
     /* 145794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145816 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 145819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145823 */     GIR_RootConstrainSelectedInstOperands,
     /* 145824 */     // GIR_Coverage, 1943,
     /* 145824 */     GIR_EraseRootFromParent_Done,
     /* 145825 */   // Label 2869: @145825
     /* 145825 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(145861), // Rule ID 1945 //
     /* 145830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145852 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 145855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145859 */     GIR_RootConstrainSelectedInstOperands,
     /* 145860 */     // GIR_Coverage, 1945,
     /* 145860 */     GIR_EraseRootFromParent_Done,
     /* 145861 */   // Label 2870: @145861
     /* 145861 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(145897), // Rule ID 1947 //
     /* 145866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 145874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145888 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 145891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145895 */     GIR_RootConstrainSelectedInstOperands,
     /* 145896 */     // GIR_Coverage, 1947,
     /* 145896 */     GIR_EraseRootFromParent_Done,
     /* 145897 */   // Label 2871: @145897
     /* 145897 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(145933), // Rule ID 1949 //
     /* 145902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145924 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 145924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 145927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145931 */     GIR_RootConstrainSelectedInstOperands,
     /* 145932 */     // GIR_Coverage, 1949,
     /* 145932 */     GIR_EraseRootFromParent_Done,
     /* 145933 */   // Label 2872: @145933
     /* 145933 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(145969), // Rule ID 1951 //
     /* 145938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 145941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 145949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 145956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145960 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 145960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 145963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145967 */     GIR_RootConstrainSelectedInstOperands,
     /* 145968 */     // GIR_Coverage, 1951,
     /* 145968 */     GIR_EraseRootFromParent_Done,
     /* 145969 */   // Label 2873: @145969
     /* 145969 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146005), // Rule ID 1953 //
     /* 145974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 145982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 145985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 145992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145996 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 145996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 145999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146003 */     GIR_RootConstrainSelectedInstOperands,
     /* 146004 */     // GIR_Coverage, 1953,
     /* 146004 */     GIR_EraseRootFromParent_Done,
     /* 146005 */   // Label 2874: @146005
     /* 146005 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146041), // Rule ID 1955 //
     /* 146010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146032 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 146035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146039 */     GIR_RootConstrainSelectedInstOperands,
     /* 146040 */     // GIR_Coverage, 1955,
     /* 146040 */     GIR_EraseRootFromParent_Done,
     /* 146041 */   // Label 2875: @146041
     /* 146041 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146077), // Rule ID 1957 //
     /* 146046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146068 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 146071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146075 */     GIR_RootConstrainSelectedInstOperands,
     /* 146076 */     // GIR_Coverage, 1957,
     /* 146076 */     GIR_EraseRootFromParent_Done,
     /* 146077 */   // Label 2876: @146077
     /* 146077 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146113), // Rule ID 1959 //
     /* 146082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146104 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 146107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146111 */     GIR_RootConstrainSelectedInstOperands,
     /* 146112 */     // GIR_Coverage, 1959,
     /* 146112 */     GIR_EraseRootFromParent_Done,
     /* 146113 */   // Label 2877: @146113
     /* 146113 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146149), // Rule ID 1961 //
     /* 146118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146140 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 146143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146147 */     GIR_RootConstrainSelectedInstOperands,
     /* 146148 */     // GIR_Coverage, 1961,
     /* 146148 */     GIR_EraseRootFromParent_Done,
     /* 146149 */   // Label 2878: @146149
     /* 146149 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146185), // Rule ID 1963 //
     /* 146154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146176 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 146179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146183 */     GIR_RootConstrainSelectedInstOperands,
     /* 146184 */     // GIR_Coverage, 1963,
     /* 146184 */     GIR_EraseRootFromParent_Done,
     /* 146185 */   // Label 2879: @146185
     /* 146185 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146221), // Rule ID 1965 //
     /* 146190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146212 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 146215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146219 */     GIR_RootConstrainSelectedInstOperands,
     /* 146220 */     // GIR_Coverage, 1965,
     /* 146220 */     GIR_EraseRootFromParent_Done,
     /* 146221 */   // Label 2880: @146221
     /* 146221 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(146257), // Rule ID 2305 //
     /* 146226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 146234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146248 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 146251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146255 */     GIR_RootConstrainSelectedInstOperands,
     /* 146256 */     // GIR_Coverage, 2305,
     /* 146256 */     GIR_EraseRootFromParent_Done,
     /* 146257 */   // Label 2881: @146257
     /* 146257 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(146293), // Rule ID 2306 //
     /* 146262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 146270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146284 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 146287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146291 */     GIR_RootConstrainSelectedInstOperands,
     /* 146292 */     // GIR_Coverage, 2306,
     /* 146292 */     GIR_EraseRootFromParent_Done,
     /* 146293 */   // Label 2882: @146293
     /* 146293 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(146329), // Rule ID 2314 //
     /* 146298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 146301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 146306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146320 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 146323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146327 */     GIR_RootConstrainSelectedInstOperands,
     /* 146328 */     // GIR_Coverage, 2314,
     /* 146328 */     GIR_EraseRootFromParent_Done,
     /* 146329 */   // Label 2883: @146329
     /* 146329 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(146365), // Rule ID 2515 //
     /* 146334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146356 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 146356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 146359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146363 */     GIR_RootConstrainSelectedInstOperands,
     /* 146364 */     // GIR_Coverage, 2515,
     /* 146364 */     GIR_EraseRootFromParent_Done,
     /* 146365 */   // Label 2884: @146365
     /* 146365 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(146404), // Rule ID 3548 //
     /* 146370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 146381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 146384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 146392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 146395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146402 */     GIR_RootConstrainSelectedInstOperands,
     /* 146403 */     // GIR_Coverage, 3548,
     /* 146403 */     GIR_EraseRootFromParent_Done,
     /* 146404 */   // Label 2885: @146404
     /* 146404 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(146443), // Rule ID 3549 //
     /* 146409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 146420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 146423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146431 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 146431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 146434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146441 */     GIR_RootConstrainSelectedInstOperands,
     /* 146442 */     // GIR_Coverage, 3549,
     /* 146442 */     GIR_EraseRootFromParent_Done,
     /* 146443 */   // Label 2886: @146443
     /* 146443 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(146482), // Rule ID 3550 //
     /* 146448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 146459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 146462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 146470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 146473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146480 */     GIR_RootConstrainSelectedInstOperands,
     /* 146481 */     // GIR_Coverage, 3550,
     /* 146481 */     GIR_EraseRootFromParent_Done,
     /* 146482 */   // Label 2887: @146482
     /* 146482 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(146521), // Rule ID 3551 //
     /* 146487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 146498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 146501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 146509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 146512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146519 */     GIR_RootConstrainSelectedInstOperands,
     /* 146520 */     // GIR_Coverage, 3551,
     /* 146520 */     GIR_EraseRootFromParent_Done,
     /* 146521 */   // Label 2888: @146521
     /* 146521 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(146577), // Rule ID 3555 //
     /* 146526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 146537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 146540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1615:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 146548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 146565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146575 */     GIR_RootConstrainSelectedInstOperands,
     /* 146576 */     // GIR_Coverage, 3555,
     /* 146576 */     GIR_EraseRootFromParent_Done,
     /* 146577 */   // Label 2889: @146577
     /* 146577 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(146633), // Rule ID 3556 //
     /* 146582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 146593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 146596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1615:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 146604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 146621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146631 */     GIR_RootConstrainSelectedInstOperands,
     /* 146632 */     // GIR_Coverage, 3556,
     /* 146632 */     GIR_EraseRootFromParent_Done,
     /* 146633 */   // Label 2890: @146633
     /* 146633 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(146689), // Rule ID 3557 //
     /* 146638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 146649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 146652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146660 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1615:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 146660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 146677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146687 */     GIR_RootConstrainSelectedInstOperands,
     /* 146688 */     // GIR_Coverage, 3557,
     /* 146688 */     GIR_EraseRootFromParent_Done,
     /* 146689 */   // Label 2891: @146689
     /* 146689 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(146745), // Rule ID 3558 //
     /* 146694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 146702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 146705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 146708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1615:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 146716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 146719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 146723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 146733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 146735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 146743 */     GIR_RootConstrainSelectedInstOperands,
     /* 146744 */     // GIR_Coverage, 3558,
     /* 146744 */     GIR_EraseRootFromParent_Done,
     /* 146745 */   // Label 2892: @146745
     /* 146745 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(146778), // Rule ID 3999 //
     /* 146750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 146755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146769 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 146769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 146772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146776 */     GIR_RootConstrainSelectedInstOperands,
     /* 146777 */     // GIR_Coverage, 3999,
     /* 146777 */     GIR_EraseRootFromParent_Done,
     /* 146778 */   // Label 2893: @146778
     /* 146778 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(146843), // Rule ID 4000 //
     /* 146783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 146788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146802 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 146802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 146805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 146809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 146832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146842 */     // GIR_Coverage, 4000,
     /* 146842 */     GIR_EraseRootFromParent_Done,
     /* 146843 */   // Label 2894: @146843
     /* 146843 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(146876), // Rule ID 4768 //
     /* 146848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 146853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146867 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 146870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146874 */     GIR_RootConstrainSelectedInstOperands,
     /* 146875 */     // GIR_Coverage, 4768,
     /* 146875 */     GIR_EraseRootFromParent_Done,
     /* 146876 */   // Label 2895: @146876
     /* 146876 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(146909), // Rule ID 4769 //
     /* 146881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 146886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146900 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 146903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146907 */     GIR_RootConstrainSelectedInstOperands,
     /* 146908 */     // GIR_Coverage, 4769,
     /* 146908 */     GIR_EraseRootFromParent_Done,
     /* 146909 */   // Label 2896: @146909
     /* 146909 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(146942), // Rule ID 4770 //
     /* 146914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 146919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146933 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 146936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146940 */     GIR_RootConstrainSelectedInstOperands,
     /* 146941 */     // GIR_Coverage, 4770,
     /* 146941 */     GIR_EraseRootFromParent_Done,
     /* 146942 */   // Label 2897: @146942
     /* 146942 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(146975), // Rule ID 4771 //
     /* 146947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 146952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146966 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 146966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 146969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146973 */     GIR_RootConstrainSelectedInstOperands,
     /* 146974 */     // GIR_Coverage, 4771,
     /* 146974 */     GIR_EraseRootFromParent_Done,
     /* 146975 */   // Label 2898: @146975
     /* 146975 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147008), // Rule ID 4885 //
     /* 146980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 146985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146999 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 146999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 147002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147006 */     GIR_RootConstrainSelectedInstOperands,
     /* 147007 */     // GIR_Coverage, 4885,
     /* 147007 */     GIR_EraseRootFromParent_Done,
     /* 147008 */   // Label 2899: @147008
     /* 147008 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147041), // Rule ID 4895 //
     /* 147013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 147018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147032 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 147032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 147035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147039 */     GIR_RootConstrainSelectedInstOperands,
     /* 147040 */     // GIR_Coverage, 4895,
     /* 147040 */     GIR_EraseRootFromParent_Done,
     /* 147041 */   // Label 2900: @147041
     /* 147041 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147077), // Rule ID 5234 //
     /* 147046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147068 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 147068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 147071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147075 */     GIR_RootConstrainSelectedInstOperands,
     /* 147076 */     // GIR_Coverage, 5234,
     /* 147076 */     GIR_EraseRootFromParent_Done,
     /* 147077 */   // Label 2901: @147077
     /* 147077 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147110), // Rule ID 5237 //
     /* 147082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 147087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147101 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 147104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147108 */     GIR_RootConstrainSelectedInstOperands,
     /* 147109 */     // GIR_Coverage, 5237,
     /* 147109 */     GIR_EraseRootFromParent_Done,
     /* 147110 */   // Label 2902: @147110
     /* 147110 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147143), // Rule ID 5238 //
     /* 147115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 147120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147134 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 147137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147141 */     GIR_RootConstrainSelectedInstOperands,
     /* 147142 */     // GIR_Coverage, 5238,
     /* 147142 */     GIR_EraseRootFromParent_Done,
     /* 147143 */   // Label 2903: @147143
     /* 147143 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147176), // Rule ID 5239 //
     /* 147148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 147153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147167 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 147170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147174 */     GIR_RootConstrainSelectedInstOperands,
     /* 147175 */     // GIR_Coverage, 5239,
     /* 147175 */     GIR_EraseRootFromParent_Done,
     /* 147176 */   // Label 2904: @147176
     /* 147176 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147209), // Rule ID 5240 //
     /* 147181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 147186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147200 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 147203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147207 */     GIR_RootConstrainSelectedInstOperands,
     /* 147208 */     // GIR_Coverage, 5240,
     /* 147208 */     GIR_EraseRootFromParent_Done,
     /* 147209 */   // Label 2905: @147209
     /* 147209 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(147242), // Rule ID 5241 //
     /* 147214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 147219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147233 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 147236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147240 */     GIR_RootConstrainSelectedInstOperands,
     /* 147241 */     // GIR_Coverage, 5241,
     /* 147241 */     GIR_EraseRootFromParent_Done,
     /* 147242 */   // Label 2906: @147242
     /* 147242 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(147275), // Rule ID 5242 //
     /* 147247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 147252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147266 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 147269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147273 */     GIR_RootConstrainSelectedInstOperands,
     /* 147274 */     // GIR_Coverage, 5242,
     /* 147274 */     GIR_EraseRootFromParent_Done,
     /* 147275 */   // Label 2907: @147275
     /* 147275 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(147308), // Rule ID 5243 //
     /* 147280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 147285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147299 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 147302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147306 */     GIR_RootConstrainSelectedInstOperands,
     /* 147307 */     // GIR_Coverage, 5243,
     /* 147307 */     GIR_EraseRootFromParent_Done,
     /* 147308 */   // Label 2908: @147308
     /* 147308 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147341), // Rule ID 5244 //
     /* 147313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 147318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147332 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 147335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147339 */     GIR_RootConstrainSelectedInstOperands,
     /* 147340 */     // GIR_Coverage, 5244,
     /* 147340 */     GIR_EraseRootFromParent_Done,
     /* 147341 */   // Label 2909: @147341
     /* 147341 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147374), // Rule ID 5245 //
     /* 147346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147365 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 147368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147372 */     GIR_RootConstrainSelectedInstOperands,
     /* 147373 */     // GIR_Coverage, 5245,
     /* 147373 */     GIR_EraseRootFromParent_Done,
     /* 147374 */   // Label 2910: @147374
     /* 147374 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147407), // Rule ID 5246 //
     /* 147379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147398 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 147401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147405 */     GIR_RootConstrainSelectedInstOperands,
     /* 147406 */     // GIR_Coverage, 5246,
     /* 147406 */     GIR_EraseRootFromParent_Done,
     /* 147407 */   // Label 2911: @147407
     /* 147407 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147440), // Rule ID 5247 //
     /* 147412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147431 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 147434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147438 */     GIR_RootConstrainSelectedInstOperands,
     /* 147439 */     // GIR_Coverage, 5247,
     /* 147439 */     GIR_EraseRootFromParent_Done,
     /* 147440 */   // Label 2912: @147440
     /* 147440 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147473), // Rule ID 5248 //
     /* 147445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147464 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 147467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147471 */     GIR_RootConstrainSelectedInstOperands,
     /* 147472 */     // GIR_Coverage, 5248,
     /* 147472 */     GIR_EraseRootFromParent_Done,
     /* 147473 */   // Label 2913: @147473
     /* 147473 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147506), // Rule ID 5249 //
     /* 147478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147497 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 147500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147504 */     GIR_RootConstrainSelectedInstOperands,
     /* 147505 */     // GIR_Coverage, 5249,
     /* 147505 */     GIR_EraseRootFromParent_Done,
     /* 147506 */   // Label 2914: @147506
     /* 147506 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147539), // Rule ID 5250 //
     /* 147511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147530 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 147533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147537 */     GIR_RootConstrainSelectedInstOperands,
     /* 147538 */     // GIR_Coverage, 5250,
     /* 147538 */     GIR_EraseRootFromParent_Done,
     /* 147539 */   // Label 2915: @147539
     /* 147539 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(147572), // Rule ID 5262 //
     /* 147544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147563 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 147566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147570 */     GIR_RootConstrainSelectedInstOperands,
     /* 147571 */     // GIR_Coverage, 5262,
     /* 147571 */     GIR_EraseRootFromParent_Done,
     /* 147572 */   // Label 2916: @147572
     /* 147572 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(147605), // Rule ID 5263 //
     /* 147577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147596 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 147599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147603 */     GIR_RootConstrainSelectedInstOperands,
     /* 147604 */     // GIR_Coverage, 5263,
     /* 147604 */     GIR_EraseRootFromParent_Done,
     /* 147605 */   // Label 2917: @147605
     /* 147605 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(147638), // Rule ID 5264 //
     /* 147610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 147615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147629 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 147632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147636 */     GIR_RootConstrainSelectedInstOperands,
     /* 147637 */     // GIR_Coverage, 5264,
     /* 147637 */     GIR_EraseRootFromParent_Done,
     /* 147638 */   // Label 2918: @147638
     /* 147638 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(147671), // Rule ID 5265 //
     /* 147643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147662 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 147665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147669 */     GIR_RootConstrainSelectedInstOperands,
     /* 147670 */     // GIR_Coverage, 5265,
     /* 147670 */     GIR_EraseRootFromParent_Done,
     /* 147671 */   // Label 2919: @147671
     /* 147671 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(147704), // Rule ID 5266 //
     /* 147676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147695 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 147695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 147698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147702 */     GIR_RootConstrainSelectedInstOperands,
     /* 147703 */     // GIR_Coverage, 5266,
     /* 147703 */     GIR_EraseRootFromParent_Done,
     /* 147704 */   // Label 2920: @147704
     /* 147704 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(147737), // Rule ID 5267 //
     /* 147709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147728 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 147728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147735 */     GIR_RootConstrainSelectedInstOperands,
     /* 147736 */     // GIR_Coverage, 5267,
     /* 147736 */     GIR_EraseRootFromParent_Done,
     /* 147737 */   // Label 2921: @147737
     /* 147737 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(147770), // Rule ID 5268 //
     /* 147742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 147747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147761 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 147764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147768 */     GIR_RootConstrainSelectedInstOperands,
     /* 147769 */     // GIR_Coverage, 5268,
     /* 147769 */     GIR_EraseRootFromParent_Done,
     /* 147770 */   // Label 2922: @147770
     /* 147770 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(147803), // Rule ID 5598 //
     /* 147775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147794 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147801 */     GIR_RootConstrainSelectedInstOperands,
     /* 147802 */     // GIR_Coverage, 5598,
     /* 147802 */     GIR_EraseRootFromParent_Done,
     /* 147803 */   // Label 2923: @147803
     /* 147803 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(147888), // Rule ID 5599 //
     /* 147808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147827 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 147827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 147830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 147834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 147847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147861 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 147868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 147881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147886 */     GIR_RootConstrainSelectedInstOperands,
     /* 147887 */     // GIR_Coverage, 5599,
     /* 147887 */     GIR_EraseRootFromParent_Done,
     /* 147888 */   // Label 2924: @147888
     /* 147888 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(147921), // Rule ID 5600 //
     /* 147893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 147898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147912 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 147915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147919 */     GIR_RootConstrainSelectedInstOperands,
     /* 147920 */     // GIR_Coverage, 5600,
     /* 147920 */     GIR_EraseRootFromParent_Done,
     /* 147921 */   // Label 2925: @147921
     /* 147921 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(147954), // Rule ID 5602 //
     /* 147926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 147931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 147937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147945 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 147945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 147948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147952 */     GIR_RootConstrainSelectedInstOperands,
     /* 147953 */     // GIR_Coverage, 5602,
     /* 147953 */     GIR_EraseRootFromParent_Done,
     /* 147954 */   // Label 2926: @147954
     /* 147954 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(147987), // Rule ID 5604 //
     /* 147959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 147964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 147970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147978 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 147978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 147981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147985 */     GIR_RootConstrainSelectedInstOperands,
     /* 147986 */     // GIR_Coverage, 5604,
     /* 147986 */     GIR_EraseRootFromParent_Done,
     /* 147987 */   // Label 2927: @147987
     /* 147987 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148020), // Rule ID 5606 //
     /* 147992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 147997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148011 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 148014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148018 */     GIR_RootConstrainSelectedInstOperands,
     /* 148019 */     // GIR_Coverage, 5606,
     /* 148019 */     GIR_EraseRootFromParent_Done,
     /* 148020 */   // Label 2928: @148020
     /* 148020 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148053), // Rule ID 5608 //
     /* 148025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148044 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 148047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148051 */     GIR_RootConstrainSelectedInstOperands,
     /* 148052 */     // GIR_Coverage, 5608,
     /* 148052 */     GIR_EraseRootFromParent_Done,
     /* 148053 */   // Label 2929: @148053
     /* 148053 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148086), // Rule ID 5610 //
     /* 148058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148077 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 148080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148084 */     GIR_RootConstrainSelectedInstOperands,
     /* 148085 */     // GIR_Coverage, 5610,
     /* 148085 */     GIR_EraseRootFromParent_Done,
     /* 148086 */   // Label 2930: @148086
     /* 148086 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148119), // Rule ID 5612 //
     /* 148091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148110 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 148113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148117 */     GIR_RootConstrainSelectedInstOperands,
     /* 148118 */     // GIR_Coverage, 5612,
     /* 148118 */     GIR_EraseRootFromParent_Done,
     /* 148119 */   // Label 2931: @148119
     /* 148119 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148152), // Rule ID 5614 //
     /* 148124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148143 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 148146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148150 */     GIR_RootConstrainSelectedInstOperands,
     /* 148151 */     // GIR_Coverage, 5614,
     /* 148151 */     GIR_EraseRootFromParent_Done,
     /* 148152 */   // Label 2932: @148152
     /* 148152 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148185), // Rule ID 5616 //
     /* 148157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148176 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 148179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148183 */     GIR_RootConstrainSelectedInstOperands,
     /* 148184 */     // GIR_Coverage, 5616,
     /* 148184 */     GIR_EraseRootFromParent_Done,
     /* 148185 */   // Label 2933: @148185
     /* 148185 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148218), // Rule ID 13050 //
     /* 148190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148209 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148216 */     GIR_RootConstrainSelectedInstOperands,
     /* 148217 */     // GIR_Coverage, 13050,
     /* 148217 */     GIR_EraseRootFromParent_Done,
     /* 148218 */   // Label 2934: @148218
     /* 148218 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148251), // Rule ID 13052 //
     /* 148223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148242 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 148245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148249 */     GIR_RootConstrainSelectedInstOperands,
     /* 148250 */     // GIR_Coverage, 13052,
     /* 148250 */     GIR_EraseRootFromParent_Done,
     /* 148251 */   // Label 2935: @148251
     /* 148251 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148284), // Rule ID 13054 //
     /* 148256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148275 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 148278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148282 */     GIR_RootConstrainSelectedInstOperands,
     /* 148283 */     // GIR_Coverage, 13054,
     /* 148283 */     GIR_EraseRootFromParent_Done,
     /* 148284 */   // Label 2936: @148284
     /* 148284 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148317), // Rule ID 13056 //
     /* 148289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148308 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 148311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148315 */     GIR_RootConstrainSelectedInstOperands,
     /* 148316 */     // GIR_Coverage, 13056,
     /* 148316 */     GIR_EraseRootFromParent_Done,
     /* 148317 */   // Label 2937: @148317
     /* 148317 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148432), // Rule ID 13057 //
     /* 148322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148341 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148341 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148344 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 148348 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148353 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148362 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148366 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148385 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148391 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148414 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148431 */     // GIR_Coverage, 13057,
     /* 148431 */     GIR_EraseRootFromParent_Done,
     /* 148432 */   // Label 2938: @148432
     /* 148432 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(148465), // Rule ID 13059 //
     /* 148437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148456 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148463 */     GIR_RootConstrainSelectedInstOperands,
     /* 148464 */     // GIR_Coverage, 13059,
     /* 148464 */     GIR_EraseRootFromParent_Done,
     /* 148465 */   // Label 2939: @148465
     /* 148465 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(148498), // Rule ID 13061 //
     /* 148470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148489 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 148492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148496 */     GIR_RootConstrainSelectedInstOperands,
     /* 148497 */     // GIR_Coverage, 13061,
     /* 148497 */     GIR_EraseRootFromParent_Done,
     /* 148498 */   // Label 2940: @148498
     /* 148498 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(148531), // Rule ID 13063 //
     /* 148503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148522 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 148525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148529 */     GIR_RootConstrainSelectedInstOperands,
     /* 148530 */     // GIR_Coverage, 13063,
     /* 148530 */     GIR_EraseRootFromParent_Done,
     /* 148531 */   // Label 2941: @148531
     /* 148531 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(148564), // Rule ID 13065 //
     /* 148536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148555 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 148558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148562 */     GIR_RootConstrainSelectedInstOperands,
     /* 148563 */     // GIR_Coverage, 13065,
     /* 148563 */     GIR_EraseRootFromParent_Done,
     /* 148564 */   // Label 2942: @148564
     /* 148564 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(148679), // Rule ID 13066 //
     /* 148569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148588 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148588 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148591 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 148595 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148600 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148678 */     // GIR_Coverage, 13066,
     /* 148678 */     GIR_EraseRootFromParent_Done,
     /* 148679 */   // Label 2943: @148679
     /* 148679 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(148798), // Rule ID 13067 //
     /* 148684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148703 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148703 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148706 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 148710 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148715 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148719 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148754 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148757 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148780 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148797 */     // GIR_Coverage, 13067,
     /* 148797 */     GIR_EraseRootFromParent_Done,
     /* 148798 */   // Label 2944: @148798
     /* 148798 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(148913), // Rule ID 13068 //
     /* 148803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148822 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 148822 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148825 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 148829 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148834 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 148843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 148857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148866 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148869 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148872 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148912 */     // GIR_Coverage, 13068,
     /* 148912 */     GIR_EraseRootFromParent_Done,
     /* 148913 */   // Label 2945: @148913
     /* 148913 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(149032), // Rule ID 13069 //
     /* 148918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148937 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148937 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148940 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 148944 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148949 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148953 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148959 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148962 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148966 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148985 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148988 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148991 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 148994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149014 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149031 */     // GIR_Coverage, 13069,
     /* 149031 */     GIR_EraseRootFromParent_Done,
     /* 149032 */   // Label 2946: @149032
     /* 149032 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(149147), // Rule ID 13070 //
     /* 149037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149056 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 149056 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149059 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 149063 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149068 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 149077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 149091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149106 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149146 */     // GIR_Coverage, 13070,
     /* 149146 */     GIR_EraseRootFromParent_Done,
     /* 149147 */   // Label 2947: @149147
     /* 149147 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(149180), // Rule ID 13072 //
     /* 149152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149171 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 149174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149178 */     GIR_RootConstrainSelectedInstOperands,
     /* 149179 */     // GIR_Coverage, 13072,
     /* 149179 */     GIR_EraseRootFromParent_Done,
     /* 149180 */   // Label 2948: @149180
     /* 149180 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149213), // Rule ID 13074 //
     /* 149185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149204 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 149207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149211 */     GIR_RootConstrainSelectedInstOperands,
     /* 149212 */     // GIR_Coverage, 13074,
     /* 149212 */     GIR_EraseRootFromParent_Done,
     /* 149213 */   // Label 2949: @149213
     /* 149213 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(149246), // Rule ID 13076 //
     /* 149218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149237 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 149240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149244 */     GIR_RootConstrainSelectedInstOperands,
     /* 149245 */     // GIR_Coverage, 13076,
     /* 149245 */     GIR_EraseRootFromParent_Done,
     /* 149246 */   // Label 2950: @149246
     /* 149246 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149279), // Rule ID 13078 //
     /* 149251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149270 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 149273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149277 */     GIR_RootConstrainSelectedInstOperands,
     /* 149278 */     // GIR_Coverage, 13078,
     /* 149278 */     GIR_EraseRootFromParent_Done,
     /* 149279 */   // Label 2951: @149279
     /* 149279 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149394), // Rule ID 13079 //
     /* 149284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149303 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149303 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149306 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 149310 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149315 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149376 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149393 */     // GIR_Coverage, 13079,
     /* 149393 */     GIR_EraseRootFromParent_Done,
     /* 149394 */   // Label 2952: @149394
     /* 149394 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149513), // Rule ID 13080 //
     /* 149399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149418 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149418 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149421 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 149425 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149430 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149434 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149466 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149469 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149472 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149495 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149512 */     // GIR_Coverage, 13080,
     /* 149512 */     GIR_EraseRootFromParent_Done,
     /* 149513 */   // Label 2953: @149513
     /* 149513 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149546), // Rule ID 13082 //
     /* 149518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149537 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 149540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149544 */     GIR_RootConstrainSelectedInstOperands,
     /* 149545 */     // GIR_Coverage, 13082,
     /* 149545 */     GIR_EraseRootFromParent_Done,
     /* 149546 */   // Label 2954: @149546
     /* 149546 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149579), // Rule ID 13084 //
     /* 149551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149570 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 149573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149577 */     GIR_RootConstrainSelectedInstOperands,
     /* 149578 */     // GIR_Coverage, 13084,
     /* 149578 */     GIR_EraseRootFromParent_Done,
     /* 149579 */   // Label 2955: @149579
     /* 149579 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149612), // Rule ID 13086 //
     /* 149584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149603 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 149606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149610 */     GIR_RootConstrainSelectedInstOperands,
     /* 149611 */     // GIR_Coverage, 13086,
     /* 149611 */     GIR_EraseRootFromParent_Done,
     /* 149612 */   // Label 2956: @149612
     /* 149612 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(149645), // Rule ID 13088 //
     /* 149617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149636 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 149639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149643 */     GIR_RootConstrainSelectedInstOperands,
     /* 149644 */     // GIR_Coverage, 13088,
     /* 149644 */     GIR_EraseRootFromParent_Done,
     /* 149645 */   // Label 2957: @149645
     /* 149645 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(149760), // Rule ID 13089 //
     /* 149650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149669 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149669 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149672 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 149676 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149681 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149713 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149759 */     // GIR_Coverage, 13089,
     /* 149759 */     GIR_EraseRootFromParent_Done,
     /* 149760 */   // Label 2958: @149760
     /* 149760 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(149879), // Rule ID 13090 //
     /* 149765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 149770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149784 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149784 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149787 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 149791 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149796 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149800 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149806 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149809 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149813 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149832 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149835 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149838 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149878 */     // GIR_Coverage, 13090,
     /* 149878 */     GIR_EraseRootFromParent_Done,
     /* 149879 */   // Label 2959: @149879
     /* 149879 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(149912), // Rule ID 13092 //
     /* 149884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149903 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 149906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149910 */     GIR_RootConstrainSelectedInstOperands,
     /* 149911 */     // GIR_Coverage, 13092,
     /* 149911 */     GIR_EraseRootFromParent_Done,
     /* 149912 */   // Label 2960: @149912
     /* 149912 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(149945), // Rule ID 13094 //
     /* 149917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149936 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 149939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149943 */     GIR_RootConstrainSelectedInstOperands,
     /* 149944 */     // GIR_Coverage, 13094,
     /* 149944 */     GIR_EraseRootFromParent_Done,
     /* 149945 */   // Label 2961: @149945
     /* 149945 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(149978), // Rule ID 13096 //
     /* 149950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149969 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 149972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149976 */     GIR_RootConstrainSelectedInstOperands,
     /* 149977 */     // GIR_Coverage, 13096,
     /* 149977 */     GIR_EraseRootFromParent_Done,
     /* 149978 */   // Label 2962: @149978
     /* 149978 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(150011), // Rule ID 13098 //
     /* 149983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 149988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150002 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 150005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150009 */     GIR_RootConstrainSelectedInstOperands,
     /* 150010 */     // GIR_Coverage, 13098,
     /* 150010 */     GIR_EraseRootFromParent_Done,
     /* 150011 */   // Label 2963: @150011
     /* 150011 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(150126), // Rule ID 13099 //
     /* 150016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150035 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150035 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150038 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 150042 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150047 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150053 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150056 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150060 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150085 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150108 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150125 */     // GIR_Coverage, 13099,
     /* 150125 */     GIR_EraseRootFromParent_Done,
     /* 150126 */   // Label 2964: @150126
     /* 150126 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(150245), // Rule ID 13100 //
     /* 150131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150150 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 150157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150162 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150166 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150201 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150244 */     // GIR_Coverage, 13100,
     /* 150244 */     GIR_EraseRootFromParent_Done,
     /* 150245 */   // Label 2965: @150245
     /* 150245 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(150278), // Rule ID 13102 //
     /* 150250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150269 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 150272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150276 */     GIR_RootConstrainSelectedInstOperands,
     /* 150277 */     // GIR_Coverage, 13102,
     /* 150277 */     GIR_EraseRootFromParent_Done,
     /* 150278 */   // Label 2966: @150278
     /* 150278 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(150311), // Rule ID 13104 //
     /* 150283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150302 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 150305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150309 */     GIR_RootConstrainSelectedInstOperands,
     /* 150310 */     // GIR_Coverage, 13104,
     /* 150310 */     GIR_EraseRootFromParent_Done,
     /* 150311 */   // Label 2967: @150311
     /* 150311 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150344), // Rule ID 13106 //
     /* 150316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150335 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 150338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150342 */     GIR_RootConstrainSelectedInstOperands,
     /* 150343 */     // GIR_Coverage, 13106,
     /* 150343 */     GIR_EraseRootFromParent_Done,
     /* 150344 */   // Label 2968: @150344
     /* 150344 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150377), // Rule ID 13108 //
     /* 150349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150368 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 150371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150375 */     GIR_RootConstrainSelectedInstOperands,
     /* 150376 */     // GIR_Coverage, 13108,
     /* 150376 */     GIR_EraseRootFromParent_Done,
     /* 150377 */   // Label 2969: @150377
     /* 150377 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150492), // Rule ID 13109 //
     /* 150382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150401 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150401 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150404 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 150408 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150413 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150419 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150422 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150426 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150448 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150474 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150491 */     // GIR_Coverage, 13109,
     /* 150491 */     GIR_EraseRootFromParent_Done,
     /* 150492 */   // Label 2970: @150492
     /* 150492 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150611), // Rule ID 13110 //
     /* 150497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150516 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150516 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150519 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 150523 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150528 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150532 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150564 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150567 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150593 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150610 */     // GIR_Coverage, 13110,
     /* 150610 */     GIR_EraseRootFromParent_Done,
     /* 150611 */   // Label 2971: @150611
     /* 150611 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150643), // Rule ID 2393 //
     /* 150616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 150624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1655:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 150637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150641 */     GIR_RootConstrainSelectedInstOperands,
     /* 150642 */     // GIR_Coverage, 2393,
     /* 150642 */     GIR_EraseRootFromParent_Done,
     /* 150643 */   // Label 2972: @150643
     /* 150643 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150675), // Rule ID 2394 //
     /* 150648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 150656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1656:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 150669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150673 */     GIR_RootConstrainSelectedInstOperands,
     /* 150674 */     // GIR_Coverage, 2394,
     /* 150674 */     GIR_EraseRootFromParent_Done,
     /* 150675 */   // Label 2973: @150675
     /* 150675 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150707), // Rule ID 2395 //
     /* 150680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 150688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 150691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150698 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1657:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 150698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 150701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 150705 */     GIR_RootConstrainSelectedInstOperands,
     /* 150706 */     // GIR_Coverage, 2395,
     /* 150706 */     GIR_EraseRootFromParent_Done,
     /* 150707 */   // Label 2974: @150707
     /* 150707 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150739), // Rule ID 3093 //
     /* 150712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 150723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 150733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150737 */     GIR_RootConstrainSelectedInstOperands,
     /* 150738 */     // GIR_Coverage, 3093,
     /* 150738 */     GIR_EraseRootFromParent_Done,
     /* 150739 */   // Label 2975: @150739
     /* 150739 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150771), // Rule ID 3094 //
     /* 150744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 150765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150769 */     GIR_RootConstrainSelectedInstOperands,
     /* 150770 */     // GIR_Coverage, 3094,
     /* 150770 */     GIR_EraseRootFromParent_Done,
     /* 150771 */   // Label 2976: @150771
     /* 150771 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(150803), // Rule ID 3095 //
     /* 150776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 150779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 150784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 150790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 150794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 150797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150801 */     GIR_RootConstrainSelectedInstOperands,
     /* 150802 */     // GIR_Coverage, 3095,
     /* 150802 */     GIR_EraseRootFromParent_Done,
     /* 150803 */   // Label 2977: @150803
     /* 150803 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(150835), // Rule ID 3349 //
     /* 150808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 150819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 150822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1647:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 150826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150833 */     GIR_RootConstrainSelectedInstOperands,
     /* 150834 */     // GIR_Coverage, 3349,
     /* 150834 */     GIR_EraseRootFromParent_Done,
     /* 150835 */   // Label 2978: @150835
     /* 150835 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(150867), // Rule ID 3350 //
     /* 150840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 150851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 150854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1647:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 150858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150865 */     GIR_RootConstrainSelectedInstOperands,
     /* 150866 */     // GIR_Coverage, 3350,
     /* 150866 */     GIR_EraseRootFromParent_Done,
     /* 150867 */   // Label 2979: @150867
     /* 150867 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(150899), // Rule ID 3351 //
     /* 150872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 150875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 150880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 150883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 150886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 150890 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1647:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 150890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 150893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 150895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150897 */     GIR_RootConstrainSelectedInstOperands,
     /* 150898 */     // GIR_Coverage, 3351,
     /* 150898 */     GIR_EraseRootFromParent_Done,
     /* 150899 */   // Label 2980: @150899
     /* 150899 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(150931), // Rule ID 3430 //
     /* 150904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 150907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 150915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 150918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150922 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1408:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 150922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 150925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150929 */     GIR_RootConstrainSelectedInstOperands,
     /* 150930 */     // GIR_Coverage, 3430,
     /* 150930 */     GIR_EraseRootFromParent_Done,
     /* 150931 */   // Label 2981: @150931
     /* 150931 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(150963), // Rule ID 3431 //
     /* 150936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 150939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 150947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 150950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150954 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1408:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 150954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 150957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150961 */     GIR_RootConstrainSelectedInstOperands,
     /* 150962 */     // GIR_Coverage, 3431,
     /* 150962 */     GIR_EraseRootFromParent_Done,
     /* 150963 */   // Label 2982: @150963
     /* 150963 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(150995), // Rule ID 3432 //
     /* 150968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 150971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 150976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 150979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 150982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 150986 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1408:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 150986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 150989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 150991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 150993 */     GIR_RootConstrainSelectedInstOperands,
     /* 150994 */     // GIR_Coverage, 3432,
     /* 150994 */     GIR_EraseRootFromParent_Done,
     /* 150995 */   // Label 2983: @150995
     /* 150995 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(151027), // Rule ID 3458 //
     /* 151000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 151003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 151008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 151014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1247:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 151018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 151021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 151023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151025 */     GIR_RootConstrainSelectedInstOperands,
     /* 151026 */     // GIR_Coverage, 3458,
     /* 151026 */     GIR_EraseRootFromParent_Done,
     /* 151027 */   // Label 2984: @151027
     /* 151027 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(151059), // Rule ID 4613 //
     /* 151032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151050 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 151053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151057 */     GIR_RootConstrainSelectedInstOperands,
     /* 151058 */     // GIR_Coverage, 4613,
     /* 151058 */     GIR_EraseRootFromParent_Done,
     /* 151059 */   // Label 2985: @151059
     /* 151059 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(151091), // Rule ID 4614 //
     /* 151064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151082 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 151085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151089 */     GIR_RootConstrainSelectedInstOperands,
     /* 151090 */     // GIR_Coverage, 4614,
     /* 151090 */     GIR_EraseRootFromParent_Done,
     /* 151091 */   // Label 2986: @151091
     /* 151091 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(151120), // Rule ID 4615 //
     /* 151096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151111 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 151114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151118 */     GIR_RootConstrainSelectedInstOperands,
     /* 151119 */     // GIR_Coverage, 4615,
     /* 151119 */     GIR_EraseRootFromParent_Done,
     /* 151120 */   // Label 2987: @151120
     /* 151120 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(151149), // Rule ID 4616 //
     /* 151125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151140 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 151143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151147 */     GIR_RootConstrainSelectedInstOperands,
     /* 151148 */     // GIR_Coverage, 4616,
     /* 151148 */     GIR_EraseRootFromParent_Done,
     /* 151149 */   // Label 2988: @151149
     /* 151149 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(151178), // Rule ID 4617 //
     /* 151154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151169 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 151172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151176 */     GIR_RootConstrainSelectedInstOperands,
     /* 151177 */     // GIR_Coverage, 4617,
     /* 151177 */     GIR_EraseRootFromParent_Done,
     /* 151178 */   // Label 2989: @151178
     /* 151178 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(151207), // Rule ID 4618 //
     /* 151183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151198 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 151201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151205 */     GIR_RootConstrainSelectedInstOperands,
     /* 151206 */     // GIR_Coverage, 4618,
     /* 151206 */     GIR_EraseRootFromParent_Done,
     /* 151207 */   // Label 2990: @151207
     /* 151207 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(151239), // Rule ID 4625 //
     /* 151212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151230 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 151233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151237 */     GIR_RootConstrainSelectedInstOperands,
     /* 151238 */     // GIR_Coverage, 4625,
     /* 151238 */     GIR_EraseRootFromParent_Done,
     /* 151239 */   // Label 2991: @151239
     /* 151239 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(151271), // Rule ID 4626 //
     /* 151244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151262 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 151265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151269 */     GIR_RootConstrainSelectedInstOperands,
     /* 151270 */     // GIR_Coverage, 4626,
     /* 151270 */     GIR_EraseRootFromParent_Done,
     /* 151271 */   // Label 2992: @151271
     /* 151271 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(151300), // Rule ID 4627 //
     /* 151276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151291 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 151294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151298 */     GIR_RootConstrainSelectedInstOperands,
     /* 151299 */     // GIR_Coverage, 4627,
     /* 151299 */     GIR_EraseRootFromParent_Done,
     /* 151300 */   // Label 2993: @151300
     /* 151300 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(151329), // Rule ID 4628 //
     /* 151305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151320 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 151323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151327 */     GIR_RootConstrainSelectedInstOperands,
     /* 151328 */     // GIR_Coverage, 4628,
     /* 151328 */     GIR_EraseRootFromParent_Done,
     /* 151329 */   // Label 2994: @151329
     /* 151329 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(151358), // Rule ID 4629 //
     /* 151334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151349 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 151352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151356 */     GIR_RootConstrainSelectedInstOperands,
     /* 151357 */     // GIR_Coverage, 4629,
     /* 151357 */     GIR_EraseRootFromParent_Done,
     /* 151358 */   // Label 2995: @151358
     /* 151358 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(151387), // Rule ID 4630 //
     /* 151363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151378 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 151381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151385 */     GIR_RootConstrainSelectedInstOperands,
     /* 151386 */     // GIR_Coverage, 4630,
     /* 151386 */     GIR_EraseRootFromParent_Done,
     /* 151387 */   // Label 2996: @151387
     /* 151387 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(151416), // Rule ID 4925 //
     /* 151392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151407 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 151407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 151410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151414 */     GIR_RootConstrainSelectedInstOperands,
     /* 151415 */     // GIR_Coverage, 4925,
     /* 151415 */     GIR_EraseRootFromParent_Done,
     /* 151416 */   // Label 2997: @151416
     /* 151416 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(151445), // Rule ID 4926 //
     /* 151421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 151429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151436 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 151436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 151439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151443 */     GIR_RootConstrainSelectedInstOperands,
     /* 151444 */     // GIR_Coverage, 4926,
     /* 151444 */     GIR_EraseRootFromParent_Done,
     /* 151445 */   // Label 2998: @151445
     /* 151445 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(151474), // Rule ID 4927 //
     /* 151450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151465 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 151465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 151468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151472 */     GIR_RootConstrainSelectedInstOperands,
     /* 151473 */     // GIR_Coverage, 4927,
     /* 151473 */     GIR_EraseRootFromParent_Done,
     /* 151474 */   // Label 2999: @151474
     /* 151474 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(151503), // Rule ID 4928 //
     /* 151479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151494 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 151494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 151497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151501 */     GIR_RootConstrainSelectedInstOperands,
     /* 151502 */     // GIR_Coverage, 4928,
     /* 151502 */     GIR_EraseRootFromParent_Done,
     /* 151503 */   // Label 3000: @151503
     /* 151503 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151532), // Rule ID 4929 //
     /* 151508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151523 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 151523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 151526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151530 */     GIR_RootConstrainSelectedInstOperands,
     /* 151531 */     // GIR_Coverage, 4929,
     /* 151531 */     GIR_EraseRootFromParent_Done,
     /* 151532 */   // Label 3001: @151532
     /* 151532 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151561), // Rule ID 4930 //
     /* 151537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151552 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 151552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 151555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151559 */     GIR_RootConstrainSelectedInstOperands,
     /* 151560 */     // GIR_Coverage, 4930,
     /* 151560 */     GIR_EraseRootFromParent_Done,
     /* 151561 */   // Label 3002: @151561
     /* 151561 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151590), // Rule ID 4931 //
     /* 151566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 151574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151581 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 151581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 151584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151588 */     GIR_RootConstrainSelectedInstOperands,
     /* 151589 */     // GIR_Coverage, 4931,
     /* 151589 */     GIR_EraseRootFromParent_Done,
     /* 151590 */   // Label 3003: @151590
     /* 151590 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151619), // Rule ID 4932 //
     /* 151595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151610 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 151610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 151613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151617 */     GIR_RootConstrainSelectedInstOperands,
     /* 151618 */     // GIR_Coverage, 4932,
     /* 151618 */     GIR_EraseRootFromParent_Done,
     /* 151619 */   // Label 3004: @151619
     /* 151619 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(151648), // Rule ID 4933 //
     /* 151624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 151632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 151639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 151642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151646 */     GIR_RootConstrainSelectedInstOperands,
     /* 151647 */     // GIR_Coverage, 4933,
     /* 151647 */     GIR_EraseRootFromParent_Done,
     /* 151648 */   // Label 3005: @151648
     /* 151648 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(151677), // Rule ID 4934 //
     /* 151653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 151661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151668 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 151668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 151671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151675 */     GIR_RootConstrainSelectedInstOperands,
     /* 151676 */     // GIR_Coverage, 4934,
     /* 151676 */     GIR_EraseRootFromParent_Done,
     /* 151677 */   // Label 3006: @151677
     /* 151677 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(151709), // Rule ID 8346 //
     /* 151682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 151693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151700 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1646:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 151700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151707 */     GIR_RootConstrainSelectedInstOperands,
     /* 151708 */     // GIR_Coverage, 8346,
     /* 151708 */     GIR_EraseRootFromParent_Done,
     /* 151709 */   // Label 3007: @151709
     /* 151709 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(151741), // Rule ID 8347 //
     /* 151714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 151725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 151728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151732 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1646:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 151732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151739 */     GIR_RootConstrainSelectedInstOperands,
     /* 151740 */     // GIR_Coverage, 8347,
     /* 151740 */     GIR_EraseRootFromParent_Done,
     /* 151741 */   // Label 3008: @151741
     /* 151741 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(151773), // Rule ID 8348 //
     /* 151746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 151754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 151757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 151760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1646:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 151764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 151767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151771 */     GIR_RootConstrainSelectedInstOperands,
     /* 151772 */     // GIR_Coverage, 8348,
     /* 151772 */     GIR_EraseRootFromParent_Done,
     /* 151773 */   // Label 3009: @151773
     /* 151773 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(151805), // Rule ID 11737 //
     /* 151778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 151799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151803 */     GIR_RootConstrainSelectedInstOperands,
     /* 151804 */     // GIR_Coverage, 11737,
     /* 151804 */     GIR_EraseRootFromParent_Done,
     /* 151805 */   // Label 3010: @151805
     /* 151805 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(151837), // Rule ID 11738 //
     /* 151810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 151831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151835 */     GIR_RootConstrainSelectedInstOperands,
     /* 151836 */     // GIR_Coverage, 11738,
     /* 151836 */     GIR_EraseRootFromParent_Done,
     /* 151837 */   // Label 3011: @151837
     /* 151837 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(151869), // Rule ID 11739 //
     /* 151842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 151850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 151863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151867 */     GIR_RootConstrainSelectedInstOperands,
     /* 151868 */     // GIR_Coverage, 11739,
     /* 151868 */     GIR_EraseRootFromParent_Done,
     /* 151869 */   // Label 3012: @151869
     /* 151869 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(151901), // Rule ID 11740 //
     /* 151874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 151895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151899 */     GIR_RootConstrainSelectedInstOperands,
     /* 151900 */     // GIR_Coverage, 11740,
     /* 151900 */     GIR_EraseRootFromParent_Done,
     /* 151901 */   // Label 3013: @151901
     /* 151901 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(151933), // Rule ID 11741 //
     /* 151906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 151927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151931 */     GIR_RootConstrainSelectedInstOperands,
     /* 151932 */     // GIR_Coverage, 11741,
     /* 151932 */     GIR_EraseRootFromParent_Done,
     /* 151933 */   // Label 3014: @151933
     /* 151933 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(151965), // Rule ID 11742 //
     /* 151938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 151946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 151959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151963 */     GIR_RootConstrainSelectedInstOperands,
     /* 151964 */     // GIR_Coverage, 11742,
     /* 151964 */     GIR_EraseRootFromParent_Done,
     /* 151965 */   // Label 3015: @151965
     /* 151965 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(151997), // Rule ID 11897 //
     /* 151970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 151973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 151978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 151984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1246:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 151988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 151991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 151993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151995 */     GIR_RootConstrainSelectedInstOperands,
     /* 151996 */     // GIR_Coverage, 11897,
     /* 151996 */     GIR_EraseRootFromParent_Done,
     /* 151997 */   // Label 3016: @151997
     /* 151997 */   GIM_Reject,
     /* 151998 */ // Label 2697: @151998
     /* 151998 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(198309),
     /* 152003 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 152006 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152190), // Rule ID 2568 //
     /* 152011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152060 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152063 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152072 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152089 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152093 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152097 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152101 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152105 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152109 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152114 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152118 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152122 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152126 */     // MIs[5] Operand 1
     /* 152126 */     // No operand predicates
     /* 152126 */     // MIs[3] Operand 2
     /* 152126 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152141 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152143 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152155 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 152174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152188 */     GIR_RootConstrainSelectedInstOperands,
     /* 152189 */     // GIR_Coverage, 2568,
     /* 152189 */     GIR_EraseRootFromParent_Done,
     /* 152190 */   // Label 3018: @152190
     /* 152190 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152374), // Rule ID 6232 //
     /* 152195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152244 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152247 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152256 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152273 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152277 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152281 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152285 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152293 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152306 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152310 */     // MIs[5] Operand 1
     /* 152310 */     // No operand predicates
     /* 152310 */     // MIs[3] Operand 2
     /* 152310 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152321 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152325 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152327 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152339 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 152358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152372 */     GIR_RootConstrainSelectedInstOperands,
     /* 152373 */     // GIR_Coverage, 6232,
     /* 152373 */     GIR_EraseRootFromParent_Done,
     /* 152374 */   // Label 3019: @152374
     /* 152374 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(152514), // Rule ID 2057 //
     /* 152379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152424 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152452 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152456 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152469 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152473 */     // MIs[4] Operand 1
     /* 152473 */     // No operand predicates
     /* 152473 */     // MIs[2] Operand 2
     /* 152473 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 152484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152493 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 152496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152512 */     GIR_RootConstrainSelectedInstOperands,
     /* 152513 */     // GIR_Coverage, 2057,
     /* 152513 */     GIR_EraseRootFromParent_Done,
     /* 152514 */   // Label 3020: @152514
     /* 152514 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(152654), // Rule ID 2064 //
     /* 152519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152552 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152555 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152592 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152596 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152601 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152605 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152609 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152613 */     // MIs[4] Operand 1
     /* 152613 */     // No operand predicates
     /* 152613 */     // MIs[2] Operand 2
     /* 152613 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 152624 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 152633 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 152636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152652 */     GIR_RootConstrainSelectedInstOperands,
     /* 152653 */     // GIR_Coverage, 2064,
     /* 152653 */     GIR_EraseRootFromParent_Done,
     /* 152654 */   // Label 3021: @152654
     /* 152654 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(152794), // Rule ID 2060 //
     /* 152659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152692 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152695 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152720 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152724 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152728 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152732 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152736 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152741 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152745 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152749 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152753 */     // MIs[4] Operand 1
     /* 152753 */     // No operand predicates
     /* 152753 */     // MIs[2] Operand 2
     /* 152753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152773 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 152776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152792 */     GIR_RootConstrainSelectedInstOperands,
     /* 152793 */     // GIR_Coverage, 2060,
     /* 152793 */     GIR_EraseRootFromParent_Done,
     /* 152794 */   // Label 3022: @152794
     /* 152794 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(152934), // Rule ID 2067 //
     /* 152799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 152816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152832 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152835 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152844 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 152848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 152868 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152872 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152881 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 152885 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152889 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 152893 */     // MIs[4] Operand 1
     /* 152893 */     // No operand predicates
     /* 152893 */     // MIs[2] Operand 2
     /* 152893 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 152904 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 152906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 152913 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 152913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 152916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 152925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 152929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 152932 */     GIR_RootConstrainSelectedInstOperands,
     /* 152933 */     // GIR_Coverage, 2067,
     /* 152933 */     GIR_EraseRootFromParent_Done,
     /* 152934 */   // Label 3023: @152934
     /* 152934 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(153071), // Rule ID 2055 //
     /* 152939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152972 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152975 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153034 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153038 */     // MIs[4] Operand 1
     /* 153038 */     // No operand predicates
     /* 153038 */     // MIs[2] Operand 2
     /* 153038 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153049 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153051 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 153054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153069 */     GIR_RootConstrainSelectedInstOperands,
     /* 153070 */     // GIR_Coverage, 2055,
     /* 153070 */     GIR_EraseRootFromParent_Done,
     /* 153071 */   // Label 3024: @153071
     /* 153071 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(153208), // Rule ID 2062 //
     /* 153076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153109 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153112 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153121 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153150 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153158 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153167 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153171 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153175 */     // MIs[4] Operand 1
     /* 153175 */     // No operand predicates
     /* 153175 */     // MIs[2] Operand 2
     /* 153175 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153188 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 153191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153206 */     GIR_RootConstrainSelectedInstOperands,
     /* 153207 */     // GIR_Coverage, 2062,
     /* 153207 */     GIR_EraseRootFromParent_Done,
     /* 153208 */   // Label 3025: @153208
     /* 153208 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(153345), // Rule ID 2058 //
     /* 153213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153246 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153249 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153258 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153291 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153295 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153300 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153304 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153308 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153312 */     // MIs[4] Operand 1
     /* 153312 */     // No operand predicates
     /* 153312 */     // MIs[2] Operand 2
     /* 153312 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153323 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153325 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 153328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153343 */     GIR_RootConstrainSelectedInstOperands,
     /* 153344 */     // GIR_Coverage, 2058,
     /* 153344 */     GIR_EraseRootFromParent_Done,
     /* 153345 */   // Label 3026: @153345
     /* 153345 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(153482), // Rule ID 2065 //
     /* 153350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153383 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153386 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153395 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153424 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153428 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153432 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153437 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153441 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153445 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153449 */     // MIs[4] Operand 1
     /* 153449 */     // No operand predicates
     /* 153449 */     // MIs[2] Operand 2
     /* 153449 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153460 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153462 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 153465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153480 */     GIR_RootConstrainSelectedInstOperands,
     /* 153481 */     // GIR_Coverage, 2065,
     /* 153481 */     GIR_EraseRootFromParent_Done,
     /* 153482 */   // Label 3027: @153482
     /* 153482 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(153643), // Rule ID 2569 //
     /* 153487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153536 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 153539 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153548 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153565 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153569 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153573 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153578 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153582 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153586 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153590 */     // MIs[4] Operand 1
     /* 153590 */     // No operand predicates
     /* 153590 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153594 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153596 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153608 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 153627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153641 */     GIR_RootConstrainSelectedInstOperands,
     /* 153642 */     // GIR_Coverage, 2569,
     /* 153642 */     GIR_EraseRootFromParent_Done,
     /* 153643 */   // Label 3028: @153643
     /* 153643 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153804), // Rule ID 6233 //
     /* 153648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 153659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 153673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 153681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 153689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153697 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 153700 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153709 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 153722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153730 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153734 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153739 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153743 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153747 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153751 */     // MIs[4] Operand 1
     /* 153751 */     // No operand predicates
     /* 153751 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 153755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153757 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 153757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 153760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153769 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 153775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 153780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 153788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153802 */     GIR_RootConstrainSelectedInstOperands,
     /* 153803 */     // GIR_Coverage, 6233,
     /* 153803 */     GIR_EraseRootFromParent_Done,
     /* 153804 */   // Label 3029: @153804
     /* 153804 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(153914), // Rule ID 2085 //
     /* 153809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153863 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153867 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153871 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153875 */     // MIs[3] Operand 1
     /* 153875 */     // No operand predicates
     /* 153875 */     // MIs[1] Operand 2
     /* 153875 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 153886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153895 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 153898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 153900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 153909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 153912 */     GIR_RootConstrainSelectedInstOperands,
     /* 153913 */     // GIR_Coverage, 2085,
     /* 153913 */     GIR_EraseRootFromParent_Done,
     /* 153914 */   // Label 3030: @153914
     /* 153914 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(154024), // Rule ID 2088 //
     /* 153919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 153968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 153977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153985 */     // MIs[3] Operand 1
     /* 153985 */     // No operand predicates
     /* 153985 */     // MIs[1] Operand 2
     /* 153985 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 153996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 153998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154005 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 154008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154022 */     GIR_RootConstrainSelectedInstOperands,
     /* 154023 */     // GIR_Coverage, 2088,
     /* 154023 */     GIR_EraseRootFromParent_Done,
     /* 154024 */   // Label 3031: @154024
     /* 154024 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(154113), // Rule ID 1743 //
     /* 154029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154062 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154065 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154074 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154094 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 154097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154111 */     GIR_RootConstrainSelectedInstOperands,
     /* 154112 */     // GIR_Coverage, 1743,
     /* 154112 */     GIR_EraseRootFromParent_Done,
     /* 154113 */   // Label 3032: @154113
     /* 154113 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(154202), // Rule ID 1745 //
     /* 154118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154151 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154154 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154163 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154183 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 154186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154200 */     GIR_RootConstrainSelectedInstOperands,
     /* 154201 */     // GIR_Coverage, 1745,
     /* 154201 */     GIR_EraseRootFromParent_Done,
     /* 154202 */   // Label 3033: @154202
     /* 154202 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(154291), // Rule ID 1747 //
     /* 154207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154240 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154243 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154252 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154272 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 154275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154289 */     GIR_RootConstrainSelectedInstOperands,
     /* 154290 */     // GIR_Coverage, 1747,
     /* 154290 */     GIR_EraseRootFromParent_Done,
     /* 154291 */   // Label 3034: @154291
     /* 154291 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(154380), // Rule ID 1749 //
     /* 154296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154329 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154332 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154341 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154361 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 154364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154378 */     GIR_RootConstrainSelectedInstOperands,
     /* 154379 */     // GIR_Coverage, 1749,
     /* 154379 */     GIR_EraseRootFromParent_Done,
     /* 154380 */   // Label 3035: @154380
     /* 154380 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(154502), // Rule ID 6884 //
     /* 154385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154420 */     // MIs[1] Operand 2
     /* 154420 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154439 */     // MIs[2] Rn
     /* 154439 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154444 */     // MIs[2] Operand 2
     /* 154444 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154457 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 154457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 154464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154484 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154501 */     // GIR_Coverage, 6884,
     /* 154501 */     GIR_EraseRootFromParent_Done,
     /* 154502 */   // Label 3036: @154502
     /* 154502 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(154624), // Rule ID 6886 //
     /* 154507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154542 */     // MIs[1] Operand 2
     /* 154542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154561 */     // MIs[2] Rn
     /* 154561 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154566 */     // MIs[2] Operand 2
     /* 154566 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154579 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 154579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 154586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154606 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154623 */     // GIR_Coverage, 6886,
     /* 154623 */     GIR_EraseRootFromParent_Done,
     /* 154624 */   // Label 3037: @154624
     /* 154624 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(154746), // Rule ID 6888 //
     /* 154629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 154637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 154640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 154643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 154659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154664 */     // MIs[1] Operand 2
     /* 154664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154683 */     // MIs[2] Rn
     /* 154683 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154688 */     // MIs[2] Operand 2
     /* 154688 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 154699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154701 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 154701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 154708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154717 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154745 */     // GIR_Coverage, 6888,
     /* 154745 */     GIR_EraseRootFromParent_Done,
     /* 154746 */   // Label 3038: @154746
     /* 154746 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(154868), // Rule ID 6890 //
     /* 154751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154786 */     // MIs[1] Operand 2
     /* 154786 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154805 */     // MIs[2] Rn
     /* 154805 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154810 */     // MIs[2] Operand 2
     /* 154810 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154823 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 154823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 154830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154839 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154850 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154867 */     // GIR_Coverage, 6890,
     /* 154867 */     GIR_EraseRootFromParent_Done,
     /* 154868 */   // Label 3039: @154868
     /* 154868 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(154990), // Rule ID 6892 //
     /* 154873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 154878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 154881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154908 */     // MIs[1] Operand 2
     /* 154908 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154927 */     // MIs[2] Rn
     /* 154927 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154932 */     // MIs[2] Operand 2
     /* 154932 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 154943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154945 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 154945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 154952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 154965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154972 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 154979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154989 */     // GIR_Coverage, 6892,
     /* 154989 */     GIR_EraseRootFromParent_Done,
     /* 154990 */   // Label 3040: @154990
     /* 154990 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(155173), // Rule ID 2567 //
     /* 154995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155044 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155047 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155056 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155070 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155076 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155139 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 155158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155171 */     GIR_RootConstrainSelectedInstOperands,
     /* 155172 */     // GIR_Coverage, 2567,
     /* 155172 */     GIR_EraseRootFromParent_Done,
     /* 155173 */   // Label 3041: @155173
     /* 155173 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(155356), // Rule ID 6231 //
     /* 155178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155227 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155230 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155239 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155253 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155259 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155259 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155262 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155266 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155285 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155288 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155292 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155295 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 155341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155354 */     GIR_RootConstrainSelectedInstOperands,
     /* 155355 */     // GIR_Coverage, 6231,
     /* 155355 */     GIR_EraseRootFromParent_Done,
     /* 155356 */   // Label 3042: @155356
     /* 155356 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(155460), // Rule ID 13361 //
     /* 155361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155423 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155427 */     // MIs[3] Operand 1
     /* 155427 */     // No operand predicates
     /* 155427 */     // MIs[1] Operand 2
     /* 155427 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155444 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 155447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155458 */     GIR_RootConstrainSelectedInstOperands,
     /* 155459 */     // GIR_Coverage, 13361,
     /* 155459 */     GIR_EraseRootFromParent_Done,
     /* 155460 */   // Label 3043: @155460
     /* 155460 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(155564), // Rule ID 13364 //
     /* 155465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 155506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155527 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155531 */     // MIs[3] Operand 1
     /* 155531 */     // No operand predicates
     /* 155531 */     // MIs[1] Operand 2
     /* 155531 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155548 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 155551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155562 */     GIR_RootConstrainSelectedInstOperands,
     /* 155563 */     // GIR_Coverage, 13364,
     /* 155563 */     GIR_EraseRootFromParent_Done,
     /* 155564 */   // Label 3044: @155564
     /* 155564 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(155695), // Rule ID 2524 //
     /* 155569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155644 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155648 */     // MIs[3] Operand 1
     /* 155648 */     // No operand predicates
     /* 155648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155650 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 155650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155662 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 155681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155693 */     GIR_RootConstrainSelectedInstOperands,
     /* 155694 */     // GIR_Coverage, 2524,
     /* 155694 */     GIR_EraseRootFromParent_Done,
     /* 155695 */   // Label 3045: @155695
     /* 155695 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(155826), // Rule ID 2525 //
     /* 155700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155742 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155775 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 155779 */     // MIs[3] Operand 1
     /* 155779 */     // No operand predicates
     /* 155779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155781 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 155781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 155784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155793 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 155799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 155812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155824 */     GIR_RootConstrainSelectedInstOperands,
     /* 155825 */     // GIR_Coverage, 2525,
     /* 155825 */     GIR_EraseRootFromParent_Done,
     /* 155826 */   // Label 3046: @155826
     /* 155826 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(155957), // Rule ID 2526 //
     /* 155831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 155842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155873 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 155889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 155910 */     // MIs[3] Operand 1
     /* 155910 */     // No operand predicates
     /* 155910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155912 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 155912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 155915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155924 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 155930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 155943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155955 */     GIR_RootConstrainSelectedInstOperands,
     /* 155956 */     // GIR_Coverage, 2526,
     /* 155956 */     GIR_EraseRootFromParent_Done,
     /* 155957 */   // Label 3047: @155957
     /* 155957 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(156088), // Rule ID 13547 //
     /* 155962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 155973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 155979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156016 */     // MIs[2] Operand 1
     /* 156016 */     // No operand predicates
     /* 156016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156028 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156032 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156037 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156043 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156055 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156086 */     GIR_RootConstrainSelectedInstOperands,
     /* 156087 */     // GIR_Coverage, 13547,
     /* 156087 */     GIR_EraseRootFromParent_Done,
     /* 156088 */   // Label 3048: @156088
     /* 156088 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(156219), // Rule ID 13548 //
     /* 156093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156143 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156147 */     // MIs[2] Operand 1
     /* 156147 */     // No operand predicates
     /* 156147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156151 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156155 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156159 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156163 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156168 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156174 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 156174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156186 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 156192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 156205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156217 */     GIR_RootConstrainSelectedInstOperands,
     /* 156218 */     // GIR_Coverage, 13548,
     /* 156218 */     GIR_EraseRootFromParent_Done,
     /* 156219 */   // Label 3049: @156219
     /* 156219 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(156350), // Rule ID 13549 //
     /* 156224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156274 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 156278 */     // MIs[2] Operand 1
     /* 156278 */     // No operand predicates
     /* 156278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156286 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156290 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156294 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156299 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156305 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 156305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 156308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156317 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 156323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 156336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156348 */     GIR_RootConstrainSelectedInstOperands,
     /* 156349 */     // GIR_Coverage, 13549,
     /* 156349 */     GIR_EraseRootFromParent_Done,
     /* 156350 */   // Label 3050: @156350
     /* 156350 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(156464), // Rule ID 2056 //
     /* 156355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156388 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156391 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156400 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156442 */     // MIs[3] Operand 1
     /* 156442 */     // No operand predicates
     /* 156442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 156447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156462 */     GIR_RootConstrainSelectedInstOperands,
     /* 156463 */     // GIR_Coverage, 2056,
     /* 156463 */     GIR_EraseRootFromParent_Done,
     /* 156464 */   // Label 3051: @156464
     /* 156464 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(156578), // Rule ID 2063 //
     /* 156469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156514 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156552 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156556 */     // MIs[3] Operand 1
     /* 156556 */     // No operand predicates
     /* 156556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156558 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 156561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156576 */     GIR_RootConstrainSelectedInstOperands,
     /* 156577 */     // GIR_Coverage, 2063,
     /* 156577 */     GIR_EraseRootFromParent_Done,
     /* 156578 */   // Label 3052: @156578
     /* 156578 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(156692), // Rule ID 2059 //
     /* 156583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156616 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156619 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156628 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156666 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156670 */     // MIs[3] Operand 1
     /* 156670 */     // No operand predicates
     /* 156670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156672 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 156675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156690 */     GIR_RootConstrainSelectedInstOperands,
     /* 156691 */     // GIR_Coverage, 2059,
     /* 156691 */     GIR_EraseRootFromParent_Done,
     /* 156692 */   // Label 3053: @156692
     /* 156692 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(156806), // Rule ID 2066 //
     /* 156697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 156708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 156714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156730 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156733 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156742 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156784 */     // MIs[3] Operand 1
     /* 156784 */     // No operand predicates
     /* 156784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156786 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 156789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156804 */     GIR_RootConstrainSelectedInstOperands,
     /* 156805 */     // GIR_Coverage, 2066,
     /* 156805 */     GIR_EraseRootFromParent_Done,
     /* 156806 */   // Label 3054: @156806
     /* 156806 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(156920), // Rule ID 2061 //
     /* 156811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156844 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156847 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 156852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 156856 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 156860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156894 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156898 */     // MIs[3] Operand 1
     /* 156898 */     // No operand predicates
     /* 156898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156900 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 156903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156918 */     GIR_RootConstrainSelectedInstOperands,
     /* 156919 */     // GIR_Coverage, 2061,
     /* 156919 */     GIR_EraseRootFromParent_Done,
     /* 156920 */   // Label 3055: @156920
     /* 156920 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(157034), // Rule ID 2068 //
     /* 156925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 156933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156958 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156961 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 156966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 156970 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 156974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157008 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157012 */     // MIs[3] Operand 1
     /* 157012 */     // No operand predicates
     /* 157012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157014 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 157017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157032 */     GIR_RootConstrainSelectedInstOperands,
     /* 157033 */     // GIR_Coverage, 2068,
     /* 157033 */     GIR_EraseRootFromParent_Done,
     /* 157034 */   // Label 3056: @157034
     /* 157034 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(157138), // Rule ID 1987 //
     /* 157039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157105 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157109 */     // MIs[3] Operand 1
     /* 157109 */     // No operand predicates
     /* 157109 */     // MIs[1] Operand 2
     /* 157109 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157122 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 157125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157136 */     GIR_RootConstrainSelectedInstOperands,
     /* 157137 */     // GIR_Coverage, 1987,
     /* 157137 */     GIR_EraseRootFromParent_Done,
     /* 157138 */   // Label 3057: @157138
     /* 157138 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(157242), // Rule ID 2017 //
     /* 157143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157213 */     // MIs[3] Operand 1
     /* 157213 */     // No operand predicates
     /* 157213 */     // MIs[1] Operand 2
     /* 157213 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157226 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 157229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157240 */     GIR_RootConstrainSelectedInstOperands,
     /* 157241 */     // GIR_Coverage, 2017,
     /* 157241 */     GIR_EraseRootFromParent_Done,
     /* 157242 */   // Label 3058: @157242
     /* 157242 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(157346), // Rule ID 2024 //
     /* 157247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157313 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157317 */     // MIs[3] Operand 1
     /* 157317 */     // No operand predicates
     /* 157317 */     // MIs[1] Operand 2
     /* 157317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157328 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157330 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 157333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157344 */     GIR_RootConstrainSelectedInstOperands,
     /* 157345 */     // GIR_Coverage, 2024,
     /* 157345 */     GIR_EraseRootFromParent_Done,
     /* 157346 */   // Label 3059: @157346
     /* 157346 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(157450), // Rule ID 2083 //
     /* 157351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157417 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157421 */     // MIs[3] Operand 1
     /* 157421 */     // No operand predicates
     /* 157421 */     // MIs[1] Operand 2
     /* 157421 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157434 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 157437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157448 */     GIR_RootConstrainSelectedInstOperands,
     /* 157449 */     // GIR_Coverage, 2083,
     /* 157449 */     GIR_EraseRootFromParent_Done,
     /* 157450 */   // Label 3060: @157450
     /* 157450 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(157554), // Rule ID 1990 //
     /* 157455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157521 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157525 */     // MIs[3] Operand 1
     /* 157525 */     // No operand predicates
     /* 157525 */     // MIs[1] Operand 2
     /* 157525 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157538 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 157541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157552 */     GIR_RootConstrainSelectedInstOperands,
     /* 157553 */     // GIR_Coverage, 1990,
     /* 157553 */     GIR_EraseRootFromParent_Done,
     /* 157554 */   // Label 3061: @157554
     /* 157554 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(157658), // Rule ID 2020 //
     /* 157559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157629 */     // MIs[3] Operand 1
     /* 157629 */     // No operand predicates
     /* 157629 */     // MIs[1] Operand 2
     /* 157629 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157642 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 157645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157656 */     GIR_RootConstrainSelectedInstOperands,
     /* 157657 */     // GIR_Coverage, 2020,
     /* 157657 */     GIR_EraseRootFromParent_Done,
     /* 157658 */   // Label 3062: @157658
     /* 157658 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(157762), // Rule ID 2027 //
     /* 157663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 157674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157729 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157733 */     // MIs[3] Operand 1
     /* 157733 */     // No operand predicates
     /* 157733 */     // MIs[1] Operand 2
     /* 157733 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157746 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 157749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157760 */     GIR_RootConstrainSelectedInstOperands,
     /* 157761 */     // GIR_Coverage, 2027,
     /* 157761 */     GIR_EraseRootFromParent_Done,
     /* 157762 */   // Label 3063: @157762
     /* 157762 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(157866), // Rule ID 2086 //
     /* 157767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157833 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157837 */     // MIs[3] Operand 1
     /* 157837 */     // No operand predicates
     /* 157837 */     // MIs[1] Operand 2
     /* 157837 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157850 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 157853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157864 */     GIR_RootConstrainSelectedInstOperands,
     /* 157865 */     // GIR_Coverage, 2086,
     /* 157865 */     GIR_EraseRootFromParent_Done,
     /* 157866 */   // Label 3064: @157866
     /* 157866 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(157923), // Rule ID 1751 //
     /* 157871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 157906 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 157906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 157909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 157916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 157921 */     GIR_RootConstrainSelectedInstOperands,
     /* 157922 */     // GIR_Coverage, 1751,
     /* 157922 */     GIR_EraseRootFromParent_Done,
     /* 157923 */   // Label 3065: @157923
     /* 157923 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(157980), // Rule ID 1753 //
     /* 157928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 157956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 157963 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 157963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 157966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 157973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 157978 */     GIR_RootConstrainSelectedInstOperands,
     /* 157979 */     // GIR_Coverage, 1753,
     /* 157979 */     GIR_EraseRootFromParent_Done,
     /* 157980 */   // Label 3066: @157980
     /* 157980 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(158090), // Rule ID 6250 //
     /* 157985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 157990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 157993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 158011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158024 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 158035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 158047 */     // MIs[2] Operand 1
     /* 158047 */     // No operand predicates
     /* 158047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158049 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 158049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158061 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 158080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 158088 */     GIR_RootConstrainSelectedInstOperands,
     /* 158089 */     // GIR_Coverage, 6250,
     /* 158089 */     GIR_EraseRootFromParent_Done,
     /* 158090 */   // Label 3067: @158090
     /* 158090 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(158187), // Rule ID 13815 //
     /* 158095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158147 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158159 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 158178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158185 */     GIR_RootConstrainSelectedInstOperands,
     /* 158186 */     // GIR_Coverage, 13815,
     /* 158186 */     GIR_EraseRootFromParent_Done,
     /* 158187 */   // Label 3068: @158187
     /* 158187 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(158284), // Rule ID 13816 //
     /* 158192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158244 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 158244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158256 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 158262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 158275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158282 */     GIR_RootConstrainSelectedInstOperands,
     /* 158283 */     // GIR_Coverage, 13816,
     /* 158283 */     GIR_EraseRootFromParent_Done,
     /* 158284 */   // Label 3069: @158284
     /* 158284 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158381), // Rule ID 13817 //
     /* 158289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158341 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 158341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158353 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 158359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 158372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158379 */     GIR_RootConstrainSelectedInstOperands,
     /* 158380 */     // GIR_Coverage, 13817,
     /* 158380 */     GIR_EraseRootFromParent_Done,
     /* 158381 */   // Label 3070: @158381
     /* 158381 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(158464), // Rule ID 1742 //
     /* 158386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158419 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158422 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158431 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158447 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 158447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 158450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158462 */     GIR_RootConstrainSelectedInstOperands,
     /* 158463 */     // GIR_Coverage, 1742,
     /* 158463 */     GIR_EraseRootFromParent_Done,
     /* 158464 */   // Label 3071: @158464
     /* 158464 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(158547), // Rule ID 1744 //
     /* 158469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158514 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158530 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 158530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 158533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158545 */     GIR_RootConstrainSelectedInstOperands,
     /* 158546 */     // GIR_Coverage, 1744,
     /* 158546 */     GIR_EraseRootFromParent_Done,
     /* 158547 */   // Label 3072: @158547
     /* 158547 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(158630), // Rule ID 1746 //
     /* 158552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158585 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158588 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158597 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158613 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 158613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 158616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158628 */     GIR_RootConstrainSelectedInstOperands,
     /* 158629 */     // GIR_Coverage, 1746,
     /* 158629 */     GIR_EraseRootFromParent_Done,
     /* 158630 */   // Label 3073: @158630
     /* 158630 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(158713), // Rule ID 1748 //
     /* 158635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 158649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 158652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158668 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158671 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158680 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158696 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 158696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 158699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158711 */     GIR_RootConstrainSelectedInstOperands,
     /* 158712 */     // GIR_Coverage, 1748,
     /* 158712 */     GIR_EraseRootFromParent_Done,
     /* 158713 */   // Label 3074: @158713
     /* 158713 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(158793), // Rule ID 5222 //
     /* 158718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158748 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158751 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158776 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 158779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158791 */     GIR_RootConstrainSelectedInstOperands,
     /* 158792 */     // GIR_Coverage, 5222,
     /* 158792 */     GIR_EraseRootFromParent_Done,
     /* 158793 */   // Label 3075: @158793
     /* 158793 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(158873), // Rule ID 5223 //
     /* 158798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 158803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158828 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158831 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 158836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158840 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 158844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158856 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 158856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 158859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158871 */     GIR_RootConstrainSelectedInstOperands,
     /* 158872 */     // GIR_Coverage, 5223,
     /* 158872 */     GIR_EraseRootFromParent_Done,
     /* 158873 */   // Label 3076: @158873
     /* 158873 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(158970), // Rule ID 5219 //
     /* 158878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158924 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158930 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158942 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 158961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158968 */     GIR_RootConstrainSelectedInstOperands,
     /* 158969 */     // GIR_Coverage, 5219,
     /* 158969 */     GIR_EraseRootFromParent_Done,
     /* 158970 */   // Label 3077: @158970
     /* 158970 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(159067), // Rule ID 5220 //
     /* 158975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159027 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 159027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159039 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 159045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 159058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159065 */     GIR_RootConstrainSelectedInstOperands,
     /* 159066 */     // GIR_Coverage, 5220,
     /* 159066 */     GIR_EraseRootFromParent_Done,
     /* 159067 */   // Label 3078: @159067
     /* 159067 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159164), // Rule ID 5221 //
     /* 159072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159124 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 159124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 159127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159136 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 159142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 159155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159162 */     GIR_RootConstrainSelectedInstOperands,
     /* 159163 */     // GIR_Coverage, 5221,
     /* 159163 */     GIR_EraseRootFromParent_Done,
     /* 159164 */   // Label 3079: @159164
     /* 159164 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159245), // Rule ID 13362 //
     /* 159169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159223 */     // MIs[2] Operand 1
     /* 159223 */     // No operand predicates
     /* 159223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159229 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159243 */     GIR_RootConstrainSelectedInstOperands,
     /* 159244 */     // GIR_Coverage, 13362,
     /* 159244 */     GIR_EraseRootFromParent_Done,
     /* 159245 */   // Label 3080: @159245
     /* 159245 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159326), // Rule ID 13363 //
     /* 159250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159300 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159304 */     // MIs[2] Operand 1
     /* 159304 */     // No operand predicates
     /* 159304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159310 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 159313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159324 */     GIR_RootConstrainSelectedInstOperands,
     /* 159325 */     // GIR_Coverage, 13363,
     /* 159325 */     GIR_EraseRootFromParent_Done,
     /* 159326 */   // Label 3081: @159326
     /* 159326 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(159407), // Rule ID 13365 //
     /* 159331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159381 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159385 */     // MIs[2] Operand 1
     /* 159385 */     // No operand predicates
     /* 159385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159391 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 159394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159405 */     GIR_RootConstrainSelectedInstOperands,
     /* 159406 */     // GIR_Coverage, 13365,
     /* 159406 */     GIR_EraseRootFromParent_Done,
     /* 159407 */   // Label 3082: @159407
     /* 159407 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(159488), // Rule ID 13366 //
     /* 159412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159462 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159466 */     // MIs[2] Operand 1
     /* 159466 */     // No operand predicates
     /* 159466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159472 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 159475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159486 */     GIR_RootConstrainSelectedInstOperands,
     /* 159487 */     // GIR_Coverage, 13366,
     /* 159487 */     GIR_EraseRootFromParent_Done,
     /* 159488 */   // Label 3083: @159488
     /* 159488 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(159569), // Rule ID 13367 //
     /* 159493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 159522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159543 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 159547 */     // MIs[2] Operand 1
     /* 159547 */     // No operand predicates
     /* 159547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159553 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 159556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159567 */     GIR_RootConstrainSelectedInstOperands,
     /* 159568 */     // GIR_Coverage, 13367,
     /* 159568 */     GIR_EraseRootFromParent_Done,
     /* 159569 */   // Label 3084: @159569
     /* 159569 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(159650), // Rule ID 13368 //
     /* 159574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 159591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159624 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159628 */     // MIs[2] Operand 1
     /* 159628 */     // No operand predicates
     /* 159628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159634 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 159637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159648 */     GIR_RootConstrainSelectedInstOperands,
     /* 159649 */     // GIR_Coverage, 13368,
     /* 159649 */     GIR_EraseRootFromParent_Done,
     /* 159650 */   // Label 3085: @159650
     /* 159650 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(159731), // Rule ID 13369 //
     /* 159655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159705 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159709 */     // MIs[2] Operand 1
     /* 159709 */     // No operand predicates
     /* 159709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159715 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 159718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159729 */     GIR_RootConstrainSelectedInstOperands,
     /* 159730 */     // GIR_Coverage, 13369,
     /* 159730 */     GIR_EraseRootFromParent_Done,
     /* 159731 */   // Label 3086: @159731
     /* 159731 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(159812), // Rule ID 13370 //
     /* 159736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159786 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 159790 */     // MIs[2] Operand 1
     /* 159790 */     // No operand predicates
     /* 159790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159796 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 159799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159810 */     GIR_RootConstrainSelectedInstOperands,
     /* 159811 */     // GIR_Coverage, 13370,
     /* 159811 */     GIR_EraseRootFromParent_Done,
     /* 159812 */   // Label 3087: @159812
     /* 159812 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(159918), // Rule ID 6247 //
     /* 159817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 159822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 159843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 159847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159852 */     // MIs[1] Operand 2
     /* 159852 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 159863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 159867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 159875 */     // MIs[2] Operand 1
     /* 159875 */     // No operand predicates
     /* 159875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159877 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 159877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 159895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 159908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 159916 */     GIR_RootConstrainSelectedInstOperands,
     /* 159917 */     // GIR_Coverage, 6247,
     /* 159917 */     GIR_EraseRootFromParent_Done,
     /* 159918 */   // Label 3088: @159918
     /* 159918 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(159999), // Rule ID 1988 //
     /* 159923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159981 */     // MIs[2] Operand 1
     /* 159981 */     // No operand predicates
     /* 159981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159983 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159997 */     GIR_RootConstrainSelectedInstOperands,
     /* 159998 */     // GIR_Coverage, 1988,
     /* 159998 */     GIR_EraseRootFromParent_Done,
     /* 159999 */   // Label 3089: @159999
     /* 159999 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(160080), // Rule ID 1989 //
     /* 160004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160062 */     // MIs[2] Operand 1
     /* 160062 */     // No operand predicates
     /* 160062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160064 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 160067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160078 */     GIR_RootConstrainSelectedInstOperands,
     /* 160079 */     // GIR_Coverage, 1989,
     /* 160079 */     GIR_EraseRootFromParent_Done,
     /* 160080 */   // Label 3090: @160080
     /* 160080 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160161), // Rule ID 2018 //
     /* 160085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160139 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160143 */     // MIs[2] Operand 1
     /* 160143 */     // No operand predicates
     /* 160143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160145 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 160148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160159 */     GIR_RootConstrainSelectedInstOperands,
     /* 160160 */     // GIR_Coverage, 2018,
     /* 160160 */     GIR_EraseRootFromParent_Done,
     /* 160161 */   // Label 3091: @160161
     /* 160161 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160242), // Rule ID 2019 //
     /* 160166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160224 */     // MIs[2] Operand 1
     /* 160224 */     // No operand predicates
     /* 160224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160226 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 160229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160240 */     GIR_RootConstrainSelectedInstOperands,
     /* 160241 */     // GIR_Coverage, 2019,
     /* 160241 */     GIR_EraseRootFromParent_Done,
     /* 160242 */   // Label 3092: @160242
     /* 160242 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160323), // Rule ID 2025 //
     /* 160247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160305 */     // MIs[2] Operand 1
     /* 160305 */     // No operand predicates
     /* 160305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160307 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 160310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160321 */     GIR_RootConstrainSelectedInstOperands,
     /* 160322 */     // GIR_Coverage, 2025,
     /* 160322 */     GIR_EraseRootFromParent_Done,
     /* 160323 */   // Label 3093: @160323
     /* 160323 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160404), // Rule ID 2026 //
     /* 160328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160382 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160386 */     // MIs[2] Operand 1
     /* 160386 */     // No operand predicates
     /* 160386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160388 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 160391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160402 */     GIR_RootConstrainSelectedInstOperands,
     /* 160403 */     // GIR_Coverage, 2026,
     /* 160403 */     GIR_EraseRootFromParent_Done,
     /* 160404 */   // Label 3094: @160404
     /* 160404 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160485), // Rule ID 2084 //
     /* 160409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160467 */     // MIs[2] Operand 1
     /* 160467 */     // No operand predicates
     /* 160467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160469 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 160472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160483 */     GIR_RootConstrainSelectedInstOperands,
     /* 160484 */     // GIR_Coverage, 2084,
     /* 160484 */     GIR_EraseRootFromParent_Done,
     /* 160485 */   // Label 3095: @160485
     /* 160485 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160566), // Rule ID 1991 //
     /* 160490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160544 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160548 */     // MIs[2] Operand 1
     /* 160548 */     // No operand predicates
     /* 160548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160550 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 160553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160564 */     GIR_RootConstrainSelectedInstOperands,
     /* 160565 */     // GIR_Coverage, 1991,
     /* 160565 */     GIR_EraseRootFromParent_Done,
     /* 160566 */   // Label 3096: @160566
     /* 160566 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160647), // Rule ID 1992 //
     /* 160571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160629 */     // MIs[2] Operand 1
     /* 160629 */     // No operand predicates
     /* 160629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160631 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 160634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160645 */     GIR_RootConstrainSelectedInstOperands,
     /* 160646 */     // GIR_Coverage, 1992,
     /* 160646 */     GIR_EraseRootFromParent_Done,
     /* 160647 */   // Label 3097: @160647
     /* 160647 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160728), // Rule ID 2021 //
     /* 160652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160710 */     // MIs[2] Operand 1
     /* 160710 */     // No operand predicates
     /* 160710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160712 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 160715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160726 */     GIR_RootConstrainSelectedInstOperands,
     /* 160727 */     // GIR_Coverage, 2021,
     /* 160727 */     GIR_EraseRootFromParent_Done,
     /* 160728 */   // Label 3098: @160728
     /* 160728 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160809), // Rule ID 2022 //
     /* 160733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160787 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160791 */     // MIs[2] Operand 1
     /* 160791 */     // No operand predicates
     /* 160791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160793 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 160796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160807 */     GIR_RootConstrainSelectedInstOperands,
     /* 160808 */     // GIR_Coverage, 2022,
     /* 160808 */     GIR_EraseRootFromParent_Done,
     /* 160809 */   // Label 3099: @160809
     /* 160809 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(160890), // Rule ID 2028 //
     /* 160814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 160825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160872 */     // MIs[2] Operand 1
     /* 160872 */     // No operand predicates
     /* 160872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160874 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 160877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160888 */     GIR_RootConstrainSelectedInstOperands,
     /* 160889 */     // GIR_Coverage, 2028,
     /* 160889 */     GIR_EraseRootFromParent_Done,
     /* 160890 */   // Label 3100: @160890
     /* 160890 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(160971), // Rule ID 2029 //
     /* 160895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 160909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 160912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 160928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160953 */     // MIs[2] Operand 1
     /* 160953 */     // No operand predicates
     /* 160953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160955 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 160958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160969 */     GIR_RootConstrainSelectedInstOperands,
     /* 160970 */     // GIR_Coverage, 2029,
     /* 160970 */     GIR_EraseRootFromParent_Done,
     /* 160971 */   // Label 3101: @160971
     /* 160971 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(161052), // Rule ID 2087 //
     /* 160976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 160990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 160993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161030 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161034 */     // MIs[2] Operand 1
     /* 161034 */     // No operand predicates
     /* 161034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161036 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 161039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161050 */     GIR_RootConstrainSelectedInstOperands,
     /* 161051 */     // GIR_Coverage, 2087,
     /* 161051 */     GIR_EraseRootFromParent_Done,
     /* 161052 */   // Label 3102: @161052
     /* 161052 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(161133), // Rule ID 1993 //
     /* 161057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 161090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161111 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161115 */     // MIs[2] Operand 1
     /* 161115 */     // No operand predicates
     /* 161115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161117 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 161120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161131 */     GIR_RootConstrainSelectedInstOperands,
     /* 161132 */     // GIR_Coverage, 1993,
     /* 161132 */     GIR_EraseRootFromParent_Done,
     /* 161133 */   // Label 3103: @161133
     /* 161133 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161214), // Rule ID 1994 //
     /* 161138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161196 */     // MIs[2] Operand 1
     /* 161196 */     // No operand predicates
     /* 161196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161198 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 161201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161212 */     GIR_RootConstrainSelectedInstOperands,
     /* 161213 */     // GIR_Coverage, 1994,
     /* 161213 */     GIR_EraseRootFromParent_Done,
     /* 161214 */   // Label 3104: @161214
     /* 161214 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161295), // Rule ID 1995 //
     /* 161219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161277 */     // MIs[2] Operand 1
     /* 161277 */     // No operand predicates
     /* 161277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161279 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 161282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161293 */     GIR_RootConstrainSelectedInstOperands,
     /* 161294 */     // GIR_Coverage, 1995,
     /* 161294 */     GIR_EraseRootFromParent_Done,
     /* 161295 */   // Label 3105: @161295
     /* 161295 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161376), // Rule ID 1996 //
     /* 161300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161358 */     // MIs[2] Operand 1
     /* 161358 */     // No operand predicates
     /* 161358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161360 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 161363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161374 */     GIR_RootConstrainSelectedInstOperands,
     /* 161375 */     // GIR_Coverage, 1996,
     /* 161375 */     GIR_EraseRootFromParent_Done,
     /* 161376 */   // Label 3106: @161376
     /* 161376 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161457), // Rule ID 2023 //
     /* 161381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161435 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161439 */     // MIs[2] Operand 1
     /* 161439 */     // No operand predicates
     /* 161439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161441 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 161444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161455 */     GIR_RootConstrainSelectedInstOperands,
     /* 161456 */     // GIR_Coverage, 2023,
     /* 161456 */     GIR_EraseRootFromParent_Done,
     /* 161457 */   // Label 3107: @161457
     /* 161457 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161538), // Rule ID 2030 //
     /* 161462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161516 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161520 */     // MIs[2] Operand 1
     /* 161520 */     // No operand predicates
     /* 161520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161522 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 161525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161536 */     GIR_RootConstrainSelectedInstOperands,
     /* 161537 */     // GIR_Coverage, 2030,
     /* 161537 */     GIR_EraseRootFromParent_Done,
     /* 161538 */   // Label 3108: @161538
     /* 161538 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161616), // Rule ID 6234 //
     /* 161543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 161548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161594 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161598 */     // MIs[2] Operand 1
     /* 161598 */     // No operand predicates
     /* 161598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161600 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 161600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 161603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 161611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161614 */     GIR_RootConstrainSelectedInstOperands,
     /* 161615 */     // GIR_Coverage, 6234,
     /* 161615 */     GIR_EraseRootFromParent_Done,
     /* 161616 */   // Label 3109: @161616
     /* 161616 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161676), // Rule ID 6300 //
     /* 161621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 161647 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 161647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 161650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161659 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 161667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161674 */     GIR_RootConstrainSelectedInstOperands,
     /* 161675 */     // GIR_Coverage, 6300,
     /* 161675 */     GIR_EraseRootFromParent_Done,
     /* 161676 */   // Label 3110: @161676
     /* 161676 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161736), // Rule ID 6301 //
     /* 161681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 161707 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 161707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 161727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161734 */     GIR_RootConstrainSelectedInstOperands,
     /* 161735 */     // GIR_Coverage, 6301,
     /* 161735 */     GIR_EraseRootFromParent_Done,
     /* 161736 */   // Label 3111: @161736
     /* 161736 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161796), // Rule ID 6302 //
     /* 161741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 161746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 161767 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 161767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 161770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 161774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161779 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 161782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 161787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 161791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161794 */     GIR_RootConstrainSelectedInstOperands,
     /* 161795 */     // GIR_Coverage, 6302,
     /* 161795 */     GIR_EraseRootFromParent_Done,
     /* 161796 */   // Label 3112: @161796
     /* 161796 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161843), // Rule ID 3887 //
     /* 161801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161823 */     // MIs[0] Operand 3
     /* 161823 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 161834 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161841 */     GIR_RootConstrainSelectedInstOperands,
     /* 161842 */     // GIR_Coverage, 3887,
     /* 161842 */     GIR_EraseRootFromParent_Done,
     /* 161843 */   // Label 3113: @161843
     /* 161843 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161890), // Rule ID 3888 //
     /* 161848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161870 */     // MIs[0] Operand 3
     /* 161870 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 161881 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 161884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161888 */     GIR_RootConstrainSelectedInstOperands,
     /* 161889 */     // GIR_Coverage, 3888,
     /* 161889 */     GIR_EraseRootFromParent_Done,
     /* 161890 */   // Label 3114: @161890
     /* 161890 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161937), // Rule ID 3889 //
     /* 161895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161917 */     // MIs[0] Operand 3
     /* 161917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 161928 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 161931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161935 */     GIR_RootConstrainSelectedInstOperands,
     /* 161936 */     // GIR_Coverage, 3889,
     /* 161936 */     GIR_EraseRootFromParent_Done,
     /* 161937 */   // Label 3115: @161937
     /* 161937 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(161984), // Rule ID 3890 //
     /* 161942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 161945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 161950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161964 */     // MIs[0] Operand 3
     /* 161964 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 161975 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 161975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 161978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 161982 */     GIR_RootConstrainSelectedInstOperands,
     /* 161983 */     // GIR_Coverage, 3890,
     /* 161983 */     GIR_EraseRootFromParent_Done,
     /* 161984 */   // Label 3116: @161984
     /* 161984 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(162030), // Rule ID 3544 //
     /* 161989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 161992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 161997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 162000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162011 */     // MIs[0] Idx
     /* 162011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 162019 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 162019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 162022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162028 */     GIR_RootConstrainSelectedInstOperands,
     /* 162029 */     // GIR_Coverage, 3544,
     /* 162029 */     GIR_EraseRootFromParent_Done,
     /* 162030 */   // Label 3117: @162030
     /* 162030 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(162076), // Rule ID 3545 //
     /* 162035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 162046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162057 */     // MIs[0] Idx
     /* 162057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 162065 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 162065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 162068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162074 */     GIR_RootConstrainSelectedInstOperands,
     /* 162075 */     // GIR_Coverage, 3545,
     /* 162075 */     GIR_EraseRootFromParent_Done,
     /* 162076 */   // Label 3118: @162076
     /* 162076 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(162122), // Rule ID 3546 //
     /* 162081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 162092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162103 */     // MIs[0] Idx
     /* 162103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 162111 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 162111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 162114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162120 */     GIR_RootConstrainSelectedInstOperands,
     /* 162121 */     // GIR_Coverage, 3546,
     /* 162121 */     GIR_EraseRootFromParent_Done,
     /* 162122 */   // Label 3119: @162122
     /* 162122 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(162168), // Rule ID 3547 //
     /* 162127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 162138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 162141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162149 */     // MIs[0] Idx
     /* 162149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 162157 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 162157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 162160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162166 */     GIR_RootConstrainSelectedInstOperands,
     /* 162167 */     // GIR_Coverage, 3547,
     /* 162167 */     GIR_EraseRootFromParent_Done,
     /* 162168 */   // Label 3120: @162168
     /* 162168 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(162224), // Rule ID 2109 //
     /* 162173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 162181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162210 */     // MIs[1] Operand 1
     /* 162210 */     // No operand predicates
     /* 162210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162212 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 162215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162222 */     GIR_RootConstrainSelectedInstOperands,
     /* 162223 */     // GIR_Coverage, 2109,
     /* 162223 */     GIR_EraseRootFromParent_Done,
     /* 162224 */   // Label 3121: @162224
     /* 162224 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(162280), // Rule ID 2110 //
     /* 162229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 162237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162266 */     // MIs[1] Operand 1
     /* 162266 */     // No operand predicates
     /* 162266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162268 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 162271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162278 */     GIR_RootConstrainSelectedInstOperands,
     /* 162279 */     // GIR_Coverage, 2110,
     /* 162279 */     GIR_EraseRootFromParent_Done,
     /* 162280 */   // Label 3122: @162280
     /* 162280 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162336), // Rule ID 2115 //
     /* 162285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 162293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162322 */     // MIs[1] Operand 1
     /* 162322 */     // No operand predicates
     /* 162322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162324 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 162327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162334 */     GIR_RootConstrainSelectedInstOperands,
     /* 162335 */     // GIR_Coverage, 2115,
     /* 162335 */     GIR_EraseRootFromParent_Done,
     /* 162336 */   // Label 3123: @162336
     /* 162336 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162392), // Rule ID 2116 //
     /* 162341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 162349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162378 */     // MIs[1] Operand 1
     /* 162378 */     // No operand predicates
     /* 162378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162380 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 162383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162390 */     GIR_RootConstrainSelectedInstOperands,
     /* 162391 */     // GIR_Coverage, 2116,
     /* 162391 */     GIR_EraseRootFromParent_Done,
     /* 162392 */   // Label 3124: @162392
     /* 162392 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162448), // Rule ID 2123 //
     /* 162397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 162405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162434 */     // MIs[1] Operand 1
     /* 162434 */     // No operand predicates
     /* 162434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162436 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 162439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162446 */     GIR_RootConstrainSelectedInstOperands,
     /* 162447 */     // GIR_Coverage, 2123,
     /* 162447 */     GIR_EraseRootFromParent_Done,
     /* 162448 */   // Label 3125: @162448
     /* 162448 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162504), // Rule ID 2126 //
     /* 162453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 162461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162490 */     // MIs[1] Operand 1
     /* 162490 */     // No operand predicates
     /* 162490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162492 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 162495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162502 */     GIR_RootConstrainSelectedInstOperands,
     /* 162503 */     // GIR_Coverage, 2126,
     /* 162503 */     GIR_EraseRootFromParent_Done,
     /* 162504 */   // Label 3126: @162504
     /* 162504 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162560), // Rule ID 2148 //
     /* 162509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 162520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 162546 */     // MIs[1] Operand 1
     /* 162546 */     // No operand predicates
     /* 162546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162548 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 162551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162558 */     GIR_RootConstrainSelectedInstOperands,
     /* 162559 */     // GIR_Coverage, 2148,
     /* 162559 */     GIR_EraseRootFromParent_Done,
     /* 162560 */   // Label 3127: @162560
     /* 162560 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162616), // Rule ID 2150 //
     /* 162565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 162602 */     // MIs[1] Operand 1
     /* 162602 */     // No operand predicates
     /* 162602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162604 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 162607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162614 */     GIR_RootConstrainSelectedInstOperands,
     /* 162615 */     // GIR_Coverage, 2150,
     /* 162615 */     GIR_EraseRootFromParent_Done,
     /* 162616 */   // Label 3128: @162616
     /* 162616 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162672), // Rule ID 2152 //
     /* 162621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 162658 */     // MIs[1] Operand 1
     /* 162658 */     // No operand predicates
     /* 162658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162660 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 162663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162670 */     GIR_RootConstrainSelectedInstOperands,
     /* 162671 */     // GIR_Coverage, 2152,
     /* 162671 */     GIR_EraseRootFromParent_Done,
     /* 162672 */   // Label 3129: @162672
     /* 162672 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162725), // Rule ID 6235 //
     /* 162677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162711 */     // MIs[1] Operand 1
     /* 162711 */     // No operand predicates
     /* 162711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162713 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 162716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162723 */     GIR_RootConstrainSelectedInstOperands,
     /* 162724 */     // GIR_Coverage, 6235,
     /* 162724 */     GIR_EraseRootFromParent_Done,
     /* 162725 */   // Label 3130: @162725
     /* 162725 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162778), // Rule ID 6236 //
     /* 162730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162764 */     // MIs[1] Operand 1
     /* 162764 */     // No operand predicates
     /* 162764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162766 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 162766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 162769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162776 */     GIR_RootConstrainSelectedInstOperands,
     /* 162777 */     // GIR_Coverage, 6236,
     /* 162777 */     GIR_EraseRootFromParent_Done,
     /* 162778 */   // Label 3131: @162778
     /* 162778 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162831), // Rule ID 6237 //
     /* 162783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162817 */     // MIs[1] Operand 1
     /* 162817 */     // No operand predicates
     /* 162817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162819 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162829 */     GIR_RootConstrainSelectedInstOperands,
     /* 162830 */     // GIR_Coverage, 6237,
     /* 162830 */     GIR_EraseRootFromParent_Done,
     /* 162831 */   // Label 3132: @162831
     /* 162831 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162884), // Rule ID 6238 //
     /* 162836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162870 */     // MIs[1] Operand 1
     /* 162870 */     // No operand predicates
     /* 162870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162872 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 162875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162882 */     GIR_RootConstrainSelectedInstOperands,
     /* 162883 */     // GIR_Coverage, 6238,
     /* 162883 */     GIR_EraseRootFromParent_Done,
     /* 162884 */   // Label 3133: @162884
     /* 162884 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(162937), // Rule ID 6239 //
     /* 162889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 162894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162923 */     // MIs[1] Operand 1
     /* 162923 */     // No operand predicates
     /* 162923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162925 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 162928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162935 */     GIR_RootConstrainSelectedInstOperands,
     /* 162936 */     // GIR_Coverage, 6239,
     /* 162936 */     GIR_EraseRootFromParent_Done,
     /* 162937 */   // Label 3134: @162937
     /* 162937 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(162990), // Rule ID 6240 //
     /* 162942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 162947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 162976 */     // MIs[1] Operand 1
     /* 162976 */     // No operand predicates
     /* 162976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162978 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 162978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 162981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162988 */     GIR_RootConstrainSelectedInstOperands,
     /* 162989 */     // GIR_Coverage, 6240,
     /* 162989 */     GIR_EraseRootFromParent_Done,
     /* 162990 */   // Label 3135: @162990
     /* 162990 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(163043), // Rule ID 6241 //
     /* 162995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163029 */     // MIs[1] Operand 1
     /* 163029 */     // No operand predicates
     /* 163029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163031 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 163034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163041 */     GIR_RootConstrainSelectedInstOperands,
     /* 163042 */     // GIR_Coverage, 6241,
     /* 163042 */     GIR_EraseRootFromParent_Done,
     /* 163043 */   // Label 3136: @163043
     /* 163043 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(163096), // Rule ID 6242 //
     /* 163048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163082 */     // MIs[1] Operand 1
     /* 163082 */     // No operand predicates
     /* 163082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163084 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163094 */     GIR_RootConstrainSelectedInstOperands,
     /* 163095 */     // GIR_Coverage, 6242,
     /* 163095 */     GIR_EraseRootFromParent_Done,
     /* 163096 */   // Label 3137: @163096
     /* 163096 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(163149), // Rule ID 6243 //
     /* 163101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163135 */     // MIs[1] Operand 1
     /* 163135 */     // No operand predicates
     /* 163135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163137 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163147 */     GIR_RootConstrainSelectedInstOperands,
     /* 163148 */     // GIR_Coverage, 6243,
     /* 163148 */     GIR_EraseRootFromParent_Done,
     /* 163149 */   // Label 3138: @163149
     /* 163149 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(163202), // Rule ID 6244 //
     /* 163154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163188 */     // MIs[1] Operand 1
     /* 163188 */     // No operand predicates
     /* 163188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163190 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163200 */     GIR_RootConstrainSelectedInstOperands,
     /* 163201 */     // GIR_Coverage, 6244,
     /* 163201 */     GIR_EraseRootFromParent_Done,
     /* 163202 */   // Label 3139: @163202
     /* 163202 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(163255), // Rule ID 6245 //
     /* 163207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163241 */     // MIs[1] Operand 1
     /* 163241 */     // No operand predicates
     /* 163241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163243 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163253 */     GIR_RootConstrainSelectedInstOperands,
     /* 163254 */     // GIR_Coverage, 6245,
     /* 163254 */     GIR_EraseRootFromParent_Done,
     /* 163255 */   // Label 3140: @163255
     /* 163255 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(163308), // Rule ID 6246 //
     /* 163260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163294 */     // MIs[1] Operand 1
     /* 163294 */     // No operand predicates
     /* 163294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163296 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 163299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163306 */     GIR_RootConstrainSelectedInstOperands,
     /* 163307 */     // GIR_Coverage, 6246,
     /* 163307 */     GIR_EraseRootFromParent_Done,
     /* 163308 */   // Label 3141: @163308
     /* 163308 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(163390), // Rule ID 6248 //
     /* 163313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163347 */     // MIs[1] Operand 1
     /* 163347 */     // No operand predicates
     /* 163347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163349 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163361 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163388 */     GIR_RootConstrainSelectedInstOperands,
     /* 163389 */     // GIR_Coverage, 6248,
     /* 163389 */     GIR_EraseRootFromParent_Done,
     /* 163390 */   // Label 3142: @163390
     /* 163390 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(163472), // Rule ID 6249 //
     /* 163395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163429 */     // MIs[1] Operand 1
     /* 163429 */     // No operand predicates
     /* 163429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163431 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163443 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163470 */     GIR_RootConstrainSelectedInstOperands,
     /* 163471 */     // GIR_Coverage, 6249,
     /* 163471 */     GIR_EraseRootFromParent_Done,
     /* 163472 */   // Label 3143: @163472
     /* 163472 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(163554), // Rule ID 6251 //
     /* 163477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163511 */     // MIs[1] Operand 1
     /* 163511 */     // No operand predicates
     /* 163511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163513 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163525 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 163544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163552 */     GIR_RootConstrainSelectedInstOperands,
     /* 163553 */     // GIR_Coverage, 6251,
     /* 163553 */     GIR_EraseRootFromParent_Done,
     /* 163554 */   // Label 3144: @163554
     /* 163554 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(163636), // Rule ID 6252 //
     /* 163559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163593 */     // MIs[1] Operand 1
     /* 163593 */     // No operand predicates
     /* 163593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163595 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163607 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 163626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163634 */     GIR_RootConstrainSelectedInstOperands,
     /* 163635 */     // GIR_Coverage, 6252,
     /* 163635 */     GIR_EraseRootFromParent_Done,
     /* 163636 */   // Label 3145: @163636
     /* 163636 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163742), // Rule ID 6253 //
     /* 163641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163675 */     // MIs[1] Operand 1
     /* 163675 */     // No operand predicates
     /* 163675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163677 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 163677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 163684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163689 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 163701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163726 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163741 */     // GIR_Coverage, 6253,
     /* 163741 */     GIR_EraseRootFromParent_Done,
     /* 163742 */   // Label 3146: @163742
     /* 163742 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163848), // Rule ID 6254 //
     /* 163747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163781 */     // MIs[1] Operand 1
     /* 163781 */     // No operand predicates
     /* 163781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163783 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 163783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 163790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 163807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163847 */     // GIR_Coverage, 6254,
     /* 163847 */     GIR_EraseRootFromParent_Done,
     /* 163848 */   // Label 3147: @163848
     /* 163848 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163954), // Rule ID 6255 //
     /* 163853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163887 */     // MIs[1] Operand 1
     /* 163887 */     // No operand predicates
     /* 163887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163889 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 163889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 163896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163901 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 163905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 163908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 163913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 163917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 163927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 163935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 163938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163953 */     // GIR_Coverage, 6255,
     /* 163953 */     GIR_EraseRootFromParent_Done,
     /* 163954 */   // Label 3148: @163954
     /* 163954 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(164060), // Rule ID 6256 //
     /* 163959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163993 */     // MIs[1] Operand 1
     /* 163993 */     // No operand predicates
     /* 163993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163995 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 163995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 163998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 164002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164059 */     // GIR_Coverage, 6256,
     /* 164059 */     GIR_EraseRootFromParent_Done,
     /* 164060 */   // Label 3149: @164060
     /* 164060 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(164115), // Rule ID 6945 //
     /* 164065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 164070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 164099 */     // MIs[1] Operand 1
     /* 164099 */     // No operand predicates
     /* 164099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164101 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
     /* 164101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
     /* 164104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
     /* 164106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164108 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 164113 */     GIR_RootConstrainSelectedInstOperands,
     /* 164114 */     // GIR_Coverage, 6945,
     /* 164114 */     GIR_EraseRootFromParent_Done,
     /* 164115 */   // Label 3150: @164115
     /* 164115 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(164157), // Rule ID 3045 //
     /* 164120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164138 */     // MIs[0] Op2
     /* 164138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 164146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 164146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 164149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164155 */     GIR_RootConstrainSelectedInstOperands,
     /* 164156 */     // GIR_Coverage, 3045,
     /* 164156 */     GIR_EraseRootFromParent_Done,
     /* 164157 */   // Label 3151: @164157
     /* 164157 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(164199), // Rule ID 3046 //
     /* 164162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164180 */     // MIs[0] Op2
     /* 164180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 164188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 164188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 164191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164197 */     GIR_RootConstrainSelectedInstOperands,
     /* 164198 */     // GIR_Coverage, 3046,
     /* 164198 */     GIR_EraseRootFromParent_Done,
     /* 164199 */   // Label 3152: @164199
     /* 164199 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(164241), // Rule ID 3047 //
     /* 164204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164222 */     // MIs[0] Op2
     /* 164222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 164230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 164230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 164233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164239 */     GIR_RootConstrainSelectedInstOperands,
     /* 164240 */     // GIR_Coverage, 3047,
     /* 164240 */     GIR_EraseRootFromParent_Done,
     /* 164241 */   // Label 3153: @164241
     /* 164241 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(164283), // Rule ID 3081 //
     /* 164246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164264 */     // MIs[0] Op2
     /* 164264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164272 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 164275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164281 */     GIR_RootConstrainSelectedInstOperands,
     /* 164282 */     // GIR_Coverage, 3081,
     /* 164282 */     GIR_EraseRootFromParent_Done,
     /* 164283 */   // Label 3154: @164283
     /* 164283 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(164325), // Rule ID 3082 //
     /* 164288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164306 */     // MIs[0] Op2
     /* 164306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 164317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164323 */     GIR_RootConstrainSelectedInstOperands,
     /* 164324 */     // GIR_Coverage, 3082,
     /* 164324 */     GIR_EraseRootFromParent_Done,
     /* 164325 */   // Label 3155: @164325
     /* 164325 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(164367), // Rule ID 3083 //
     /* 164330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164348 */     // MIs[0] Op2
     /* 164348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 164359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164365 */     GIR_RootConstrainSelectedInstOperands,
     /* 164366 */     // GIR_Coverage, 3083,
     /* 164366 */     GIR_EraseRootFromParent_Done,
     /* 164367 */   // Label 3156: @164367
     /* 164367 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(164409), // Rule ID 3530 //
     /* 164372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164390 */     // MIs[0] Op2
     /* 164390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 164398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1331:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 164398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 164401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164407 */     GIR_RootConstrainSelectedInstOperands,
     /* 164408 */     // GIR_Coverage, 3530,
     /* 164408 */     GIR_EraseRootFromParent_Done,
     /* 164409 */   // Label 3157: @164409
     /* 164409 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164451), // Rule ID 3531 //
     /* 164414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164432 */     // MIs[0] Op2
     /* 164432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 164440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1331:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 164440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 164443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164449 */     GIR_RootConstrainSelectedInstOperands,
     /* 164450 */     // GIR_Coverage, 3531,
     /* 164450 */     GIR_EraseRootFromParent_Done,
     /* 164451 */   // Label 3158: @164451
     /* 164451 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164493), // Rule ID 3532 //
     /* 164456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164474 */     // MIs[0] Op2
     /* 164474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 164482 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1331:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 164482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 164485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164491 */     GIR_RootConstrainSelectedInstOperands,
     /* 164492 */     // GIR_Coverage, 3532,
     /* 164492 */     GIR_EraseRootFromParent_Done,
     /* 164493 */   // Label 3159: @164493
     /* 164493 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164535), // Rule ID 3533 //
     /* 164498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164516 */     // MIs[0] Op2
     /* 164516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 164524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1331:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 164524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 164527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164533 */     GIR_RootConstrainSelectedInstOperands,
     /* 164534 */     // GIR_Coverage, 3533,
     /* 164534 */     GIR_EraseRootFromParent_Done,
     /* 164535 */   // Label 3160: @164535
     /* 164535 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164577), // Rule ID 3534 //
     /* 164540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164558 */     // MIs[0] Op2
     /* 164558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 164566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 164566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 164569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164575 */     GIR_RootConstrainSelectedInstOperands,
     /* 164576 */     // GIR_Coverage, 3534,
     /* 164576 */     GIR_EraseRootFromParent_Done,
     /* 164577 */   // Label 3161: @164577
     /* 164577 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164619), // Rule ID 3535 //
     /* 164582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164600 */     // MIs[0] Op2
     /* 164600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 164608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 164608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 164611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164617 */     GIR_RootConstrainSelectedInstOperands,
     /* 164618 */     // GIR_Coverage, 3535,
     /* 164618 */     GIR_EraseRootFromParent_Done,
     /* 164619 */   // Label 3162: @164619
     /* 164619 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164661), // Rule ID 3536 //
     /* 164624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164642 */     // MIs[0] Op2
     /* 164642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 164650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 164650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 164653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164659 */     GIR_RootConstrainSelectedInstOperands,
     /* 164660 */     // GIR_Coverage, 3536,
     /* 164660 */     GIR_EraseRootFromParent_Done,
     /* 164661 */   // Label 3163: @164661
     /* 164661 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164703), // Rule ID 11674 //
     /* 164666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164684 */     // MIs[0] Op2
     /* 164684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 164695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164701 */     GIR_RootConstrainSelectedInstOperands,
     /* 164702 */     // GIR_Coverage, 11674,
     /* 164702 */     GIR_EraseRootFromParent_Done,
     /* 164703 */   // Label 3164: @164703
     /* 164703 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164745), // Rule ID 11675 //
     /* 164708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164726 */     // MIs[0] Op2
     /* 164726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 164737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164743 */     GIR_RootConstrainSelectedInstOperands,
     /* 164744 */     // GIR_Coverage, 11675,
     /* 164744 */     GIR_EraseRootFromParent_Done,
     /* 164745 */   // Label 3165: @164745
     /* 164745 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(164787), // Rule ID 11676 //
     /* 164750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 164758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164768 */     // MIs[0] Op2
     /* 164768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164776 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 164779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164785 */     GIR_RootConstrainSelectedInstOperands,
     /* 164786 */     // GIR_Coverage, 11676,
     /* 164786 */     GIR_EraseRootFromParent_Done,
     /* 164787 */   // Label 3166: @164787
     /* 164787 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(164829), // Rule ID 11677 //
     /* 164792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164810 */     // MIs[0] Op2
     /* 164810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1704:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 164821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164827 */     GIR_RootConstrainSelectedInstOperands,
     /* 164828 */     // GIR_Coverage, 11677,
     /* 164828 */     GIR_EraseRootFromParent_Done,
     /* 164829 */   // Label 3167: @164829
     /* 164829 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(164871), // Rule ID 11678 //
     /* 164834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164852 */     // MIs[0] Op2
     /* 164852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 164863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164869 */     GIR_RootConstrainSelectedInstOperands,
     /* 164870 */     // GIR_Coverage, 11678,
     /* 164870 */     GIR_EraseRootFromParent_Done,
     /* 164871 */   // Label 3168: @164871
     /* 164871 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(164913), // Rule ID 11679 //
     /* 164876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 164884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164894 */     // MIs[0] Op2
     /* 164894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164897 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 164905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164911 */     GIR_RootConstrainSelectedInstOperands,
     /* 164912 */     // GIR_Coverage, 11679,
     /* 164912 */     GIR_EraseRootFromParent_Done,
     /* 164913 */   // Label 3169: @164913
     /* 164913 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(164955), // Rule ID 11681 //
     /* 164918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164936 */     // MIs[0] Op2
     /* 164936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 164947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164953 */     GIR_RootConstrainSelectedInstOperands,
     /* 164954 */     // GIR_Coverage, 11681,
     /* 164954 */     GIR_EraseRootFromParent_Done,
     /* 164955 */   // Label 3170: @164955
     /* 164955 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(164997), // Rule ID 11683 //
     /* 164960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 164968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164978 */     // MIs[0] Op2
     /* 164978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164981 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 164989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164995 */     GIR_RootConstrainSelectedInstOperands,
     /* 164996 */     // GIR_Coverage, 11683,
     /* 164996 */     GIR_EraseRootFromParent_Done,
     /* 164997 */   // Label 3171: @164997
     /* 164997 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(165039), // Rule ID 11685 //
     /* 165002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165020 */     // MIs[0] Op2
     /* 165020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 165031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165037 */     GIR_RootConstrainSelectedInstOperands,
     /* 165038 */     // GIR_Coverage, 11685,
     /* 165038 */     GIR_EraseRootFromParent_Done,
     /* 165039 */   // Label 3172: @165039
     /* 165039 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(165081), // Rule ID 11686 //
     /* 165044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165062 */     // MIs[0] Op2
     /* 165062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165070 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 165073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165079 */     GIR_RootConstrainSelectedInstOperands,
     /* 165080 */     // GIR_Coverage, 11686,
     /* 165080 */     GIR_EraseRootFromParent_Done,
     /* 165081 */   // Label 3173: @165081
     /* 165081 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(165123), // Rule ID 11687 //
     /* 165086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165104 */     // MIs[0] Op2
     /* 165104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 165115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165121 */     GIR_RootConstrainSelectedInstOperands,
     /* 165122 */     // GIR_Coverage, 11687,
     /* 165122 */     GIR_EraseRootFromParent_Done,
     /* 165123 */   // Label 3174: @165123
     /* 165123 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(165165), // Rule ID 11688 //
     /* 165128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165146 */     // MIs[0] Op2
     /* 165146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 165157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165163 */     GIR_RootConstrainSelectedInstOperands,
     /* 165164 */     // GIR_Coverage, 11688,
     /* 165164 */     GIR_EraseRootFromParent_Done,
     /* 165165 */   // Label 3175: @165165
     /* 165165 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(165207), // Rule ID 11689 //
     /* 165170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165188 */     // MIs[0] Op2
     /* 165188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 165199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165205 */     GIR_RootConstrainSelectedInstOperands,
     /* 165206 */     // GIR_Coverage, 11689,
     /* 165206 */     GIR_EraseRootFromParent_Done,
     /* 165207 */   // Label 3176: @165207
     /* 165207 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(165249), // Rule ID 11690 //
     /* 165212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165230 */     // MIs[0] Op2
     /* 165230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 165241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165247 */     GIR_RootConstrainSelectedInstOperands,
     /* 165248 */     // GIR_Coverage, 11690,
     /* 165248 */     GIR_EraseRootFromParent_Done,
     /* 165249 */   // Label 3177: @165249
     /* 165249 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(165291), // Rule ID 11691 //
     /* 165254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165272 */     // MIs[0] Op2
     /* 165272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 165283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165289 */     GIR_RootConstrainSelectedInstOperands,
     /* 165290 */     // GIR_Coverage, 11691,
     /* 165290 */     GIR_EraseRootFromParent_Done,
     /* 165291 */   // Label 3178: @165291
     /* 165291 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(165333), // Rule ID 11692 //
     /* 165296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165314 */     // MIs[0] Op2
     /* 165314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 165325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165331 */     GIR_RootConstrainSelectedInstOperands,
     /* 165332 */     // GIR_Coverage, 11692,
     /* 165332 */     GIR_EraseRootFromParent_Done,
     /* 165333 */   // Label 3179: @165333
     /* 165333 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(165375), // Rule ID 11693 //
     /* 165338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165356 */     // MIs[0] Op2
     /* 165356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 165367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165373 */     GIR_RootConstrainSelectedInstOperands,
     /* 165374 */     // GIR_Coverage, 11693,
     /* 165374 */     GIR_EraseRootFromParent_Done,
     /* 165375 */   // Label 3180: @165375
     /* 165375 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(165417), // Rule ID 11694 //
     /* 165380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165398 */     // MIs[0] Op2
     /* 165398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 165409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165415 */     GIR_RootConstrainSelectedInstOperands,
     /* 165416 */     // GIR_Coverage, 11694,
     /* 165416 */     GIR_EraseRootFromParent_Done,
     /* 165417 */   // Label 3181: @165417
     /* 165417 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165459), // Rule ID 11695 //
     /* 165422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165440 */     // MIs[0] Op2
     /* 165440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165448 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2021:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 165451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165457 */     GIR_RootConstrainSelectedInstOperands,
     /* 165458 */     // GIR_Coverage, 11695,
     /* 165458 */     GIR_EraseRootFromParent_Done,
     /* 165459 */   // Label 3182: @165459
     /* 165459 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165501), // Rule ID 11696 //
     /* 165464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165482 */     // MIs[0] Op2
     /* 165482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 165493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165499 */     GIR_RootConstrainSelectedInstOperands,
     /* 165500 */     // GIR_Coverage, 11696,
     /* 165500 */     GIR_EraseRootFromParent_Done,
     /* 165501 */   // Label 3183: @165501
     /* 165501 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165543), // Rule ID 11697 //
     /* 165506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165524 */     // MIs[0] Op2
     /* 165524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2021:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 165535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165541 */     GIR_RootConstrainSelectedInstOperands,
     /* 165542 */     // GIR_Coverage, 11697,
     /* 165542 */     GIR_EraseRootFromParent_Done,
     /* 165543 */   // Label 3184: @165543
     /* 165543 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165585), // Rule ID 11755 //
     /* 165548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165566 */     // MIs[0] Op2
     /* 165566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 165577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165583 */     GIR_RootConstrainSelectedInstOperands,
     /* 165584 */     // GIR_Coverage, 11755,
     /* 165584 */     GIR_EraseRootFromParent_Done,
     /* 165585 */   // Label 3185: @165585
     /* 165585 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165627), // Rule ID 11756 //
     /* 165590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165608 */     // MIs[0] Op2
     /* 165608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 165619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165625 */     GIR_RootConstrainSelectedInstOperands,
     /* 165626 */     // GIR_Coverage, 11756,
     /* 165626 */     GIR_EraseRootFromParent_Done,
     /* 165627 */   // Label 3186: @165627
     /* 165627 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165669), // Rule ID 11757 //
     /* 165632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 165640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165650 */     // MIs[0] Op2
     /* 165650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 165661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165667 */     GIR_RootConstrainSelectedInstOperands,
     /* 165668 */     // GIR_Coverage, 11757,
     /* 165668 */     GIR_EraseRootFromParent_Done,
     /* 165669 */   // Label 3187: @165669
     /* 165669 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165711), // Rule ID 11758 //
     /* 165674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165692 */     // MIs[0] Op2
     /* 165692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 165703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165709 */     GIR_RootConstrainSelectedInstOperands,
     /* 165710 */     // GIR_Coverage, 11758,
     /* 165710 */     GIR_EraseRootFromParent_Done,
     /* 165711 */   // Label 3188: @165711
     /* 165711 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165753), // Rule ID 11759 //
     /* 165716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165734 */     // MIs[0] Op2
     /* 165734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165737 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 165745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165751 */     GIR_RootConstrainSelectedInstOperands,
     /* 165752 */     // GIR_Coverage, 11759,
     /* 165752 */     GIR_EraseRootFromParent_Done,
     /* 165753 */   // Label 3189: @165753
     /* 165753 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165795), // Rule ID 11760 //
     /* 165758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 165766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165776 */     // MIs[0] Op2
     /* 165776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 165787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165793 */     GIR_RootConstrainSelectedInstOperands,
     /* 165794 */     // GIR_Coverage, 11760,
     /* 165794 */     GIR_EraseRootFromParent_Done,
     /* 165795 */   // Label 3190: @165795
     /* 165795 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(165837), // Rule ID 11761 //
     /* 165800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165818 */     // MIs[0] Op2
     /* 165818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165821 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 165826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 165826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 165829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165835 */     GIR_RootConstrainSelectedInstOperands,
     /* 165836 */     // GIR_Coverage, 11761,
     /* 165836 */     GIR_EraseRootFromParent_Done,
     /* 165837 */   // Label 3191: @165837
     /* 165837 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(165879), // Rule ID 11762 //
     /* 165842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165860 */     // MIs[0] Op2
     /* 165860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 165868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 165868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165877 */     GIR_RootConstrainSelectedInstOperands,
     /* 165878 */     // GIR_Coverage, 11762,
     /* 165878 */     GIR_EraseRootFromParent_Done,
     /* 165879 */   // Label 3192: @165879
     /* 165879 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(165921), // Rule ID 11763 //
     /* 165884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 165892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165902 */     // MIs[0] Op2
     /* 165902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 165910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 165910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 165913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165919 */     GIR_RootConstrainSelectedInstOperands,
     /* 165920 */     // GIR_Coverage, 11763,
     /* 165920 */     GIR_EraseRootFromParent_Done,
     /* 165921 */   // Label 3193: @165921
     /* 165921 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(165973), // Rule ID 2132 //
     /* 165926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 165959 */     // MIs[1] Operand 1
     /* 165959 */     // No operand predicates
     /* 165959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165961 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 165961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 165964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 165971 */     GIR_RootConstrainSelectedInstOperands,
     /* 165972 */     // GIR_Coverage, 2132,
     /* 165972 */     GIR_EraseRootFromParent_Done,
     /* 165973 */   // Label 3194: @165973
     /* 165973 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166025), // Rule ID 2133 //
     /* 165978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 165986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 165995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166011 */     // MIs[1] Operand 1
     /* 166011 */     // No operand predicates
     /* 166011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166013 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 166016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166023 */     GIR_RootConstrainSelectedInstOperands,
     /* 166024 */     // GIR_Coverage, 2133,
     /* 166024 */     GIR_EraseRootFromParent_Done,
     /* 166025 */   // Label 3195: @166025
     /* 166025 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166077), // Rule ID 2134 //
     /* 166030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166063 */     // MIs[1] Operand 1
     /* 166063 */     // No operand predicates
     /* 166063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166065 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 166068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166075 */     GIR_RootConstrainSelectedInstOperands,
     /* 166076 */     // GIR_Coverage, 2134,
     /* 166076 */     GIR_EraseRootFromParent_Done,
     /* 166077 */   // Label 3196: @166077
     /* 166077 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166129), // Rule ID 2135 //
     /* 166082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166115 */     // MIs[1] Operand 1
     /* 166115 */     // No operand predicates
     /* 166115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166117 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 166120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166127 */     GIR_RootConstrainSelectedInstOperands,
     /* 166128 */     // GIR_Coverage, 2135,
     /* 166128 */     GIR_EraseRootFromParent_Done,
     /* 166129 */   // Label 3197: @166129
     /* 166129 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166181), // Rule ID 2136 //
     /* 166134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166167 */     // MIs[1] Operand 1
     /* 166167 */     // No operand predicates
     /* 166167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166169 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 166172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166179 */     GIR_RootConstrainSelectedInstOperands,
     /* 166180 */     // GIR_Coverage, 2136,
     /* 166180 */     GIR_EraseRootFromParent_Done,
     /* 166181 */   // Label 3198: @166181
     /* 166181 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166233), // Rule ID 2137 //
     /* 166186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166219 */     // MIs[1] Operand 1
     /* 166219 */     // No operand predicates
     /* 166219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166221 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 166224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166231 */     GIR_RootConstrainSelectedInstOperands,
     /* 166232 */     // GIR_Coverage, 2137,
     /* 166232 */     GIR_EraseRootFromParent_Done,
     /* 166233 */   // Label 3199: @166233
     /* 166233 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(166285), // Rule ID 2138 //
     /* 166238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166271 */     // MIs[1] Operand 1
     /* 166271 */     // No operand predicates
     /* 166271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166273 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 166276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166283 */     GIR_RootConstrainSelectedInstOperands,
     /* 166284 */     // GIR_Coverage, 2138,
     /* 166284 */     GIR_EraseRootFromParent_Done,
     /* 166285 */   // Label 3200: @166285
     /* 166285 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(166337), // Rule ID 2139 //
     /* 166290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166323 */     // MIs[1] Operand 1
     /* 166323 */     // No operand predicates
     /* 166323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166325 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 166328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166335 */     GIR_RootConstrainSelectedInstOperands,
     /* 166336 */     // GIR_Coverage, 2139,
     /* 166336 */     GIR_EraseRootFromParent_Done,
     /* 166337 */   // Label 3201: @166337
     /* 166337 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166389), // Rule ID 2140 //
     /* 166342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166375 */     // MIs[1] Operand 1
     /* 166375 */     // No operand predicates
     /* 166375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166377 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 166380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166387 */     GIR_RootConstrainSelectedInstOperands,
     /* 166388 */     // GIR_Coverage, 2140,
     /* 166388 */     GIR_EraseRootFromParent_Done,
     /* 166389 */   // Label 3202: @166389
     /* 166389 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166441), // Rule ID 2141 //
     /* 166394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166427 */     // MIs[1] Operand 1
     /* 166427 */     // No operand predicates
     /* 166427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166429 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 166432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166439 */     GIR_RootConstrainSelectedInstOperands,
     /* 166440 */     // GIR_Coverage, 2141,
     /* 166440 */     GIR_EraseRootFromParent_Done,
     /* 166441 */   // Label 3203: @166441
     /* 166441 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166493), // Rule ID 2142 //
     /* 166446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166479 */     // MIs[1] Operand 1
     /* 166479 */     // No operand predicates
     /* 166479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166481 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 166484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166491 */     GIR_RootConstrainSelectedInstOperands,
     /* 166492 */     // GIR_Coverage, 2142,
     /* 166492 */     GIR_EraseRootFromParent_Done,
     /* 166493 */   // Label 3204: @166493
     /* 166493 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166545), // Rule ID 2143 //
     /* 166498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166531 */     // MIs[1] Operand 1
     /* 166531 */     // No operand predicates
     /* 166531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166533 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 166536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166543 */     GIR_RootConstrainSelectedInstOperands,
     /* 166544 */     // GIR_Coverage, 2143,
     /* 166544 */     GIR_EraseRootFromParent_Done,
     /* 166545 */   // Label 3205: @166545
     /* 166545 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166597), // Rule ID 2144 //
     /* 166550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166583 */     // MIs[1] Operand 1
     /* 166583 */     // No operand predicates
     /* 166583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166585 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 166588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166595 */     GIR_RootConstrainSelectedInstOperands,
     /* 166596 */     // GIR_Coverage, 2144,
     /* 166596 */     GIR_EraseRootFromParent_Done,
     /* 166597 */   // Label 3206: @166597
     /* 166597 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166649), // Rule ID 2145 //
     /* 166602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166635 */     // MIs[1] Operand 1
     /* 166635 */     // No operand predicates
     /* 166635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166637 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 166640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166647 */     GIR_RootConstrainSelectedInstOperands,
     /* 166648 */     // GIR_Coverage, 2145,
     /* 166648 */     GIR_EraseRootFromParent_Done,
     /* 166649 */   // Label 3207: @166649
     /* 166649 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(166701), // Rule ID 2146 //
     /* 166654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166687 */     // MIs[1] Operand 1
     /* 166687 */     // No operand predicates
     /* 166687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166689 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 166692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166699 */     GIR_RootConstrainSelectedInstOperands,
     /* 166700 */     // GIR_Coverage, 2146,
     /* 166700 */     GIR_EraseRootFromParent_Done,
     /* 166701 */   // Label 3208: @166701
     /* 166701 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(166753), // Rule ID 2244 //
     /* 166706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166739 */     // MIs[1] Operand 1
     /* 166739 */     // No operand predicates
     /* 166739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166741 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 166744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166751 */     GIR_RootConstrainSelectedInstOperands,
     /* 166752 */     // GIR_Coverage, 2244,
     /* 166752 */     GIR_EraseRootFromParent_Done,
     /* 166753 */   // Label 3209: @166753
     /* 166753 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(166805), // Rule ID 2245 //
     /* 166758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166791 */     // MIs[1] Operand 1
     /* 166791 */     // No operand predicates
     /* 166791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166793 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 166796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166803 */     GIR_RootConstrainSelectedInstOperands,
     /* 166804 */     // GIR_Coverage, 2245,
     /* 166804 */     GIR_EraseRootFromParent_Done,
     /* 166805 */   // Label 3210: @166805
     /* 166805 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(166857), // Rule ID 2246 //
     /* 166810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166843 */     // MIs[1] Operand 1
     /* 166843 */     // No operand predicates
     /* 166843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166845 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 166848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166855 */     GIR_RootConstrainSelectedInstOperands,
     /* 166856 */     // GIR_Coverage, 2246,
     /* 166856 */     GIR_EraseRootFromParent_Done,
     /* 166857 */   // Label 3211: @166857
     /* 166857 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(166909), // Rule ID 2247 //
     /* 166862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166895 */     // MIs[1] Operand 1
     /* 166895 */     // No operand predicates
     /* 166895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166897 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 166900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166907 */     GIR_RootConstrainSelectedInstOperands,
     /* 166908 */     // GIR_Coverage, 2247,
     /* 166908 */     GIR_EraseRootFromParent_Done,
     /* 166909 */   // Label 3212: @166909
     /* 166909 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(166961), // Rule ID 2248 //
     /* 166914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 166922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166947 */     // MIs[1] Operand 1
     /* 166947 */     // No operand predicates
     /* 166947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166949 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 166952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166959 */     GIR_RootConstrainSelectedInstOperands,
     /* 166960 */     // GIR_Coverage, 2248,
     /* 166960 */     GIR_EraseRootFromParent_Done,
     /* 166961 */   // Label 3213: @166961
     /* 166961 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167006), // Rule ID 63 //
     /* 166966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 166969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 166974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 166983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 166995 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 166995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 166998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167004 */     GIR_RootConstrainSelectedInstOperands,
     /* 167005 */     // GIR_Coverage, 63,
     /* 167005 */     GIR_EraseRootFromParent_Done,
     /* 167006 */   // Label 3214: @167006
     /* 167006 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167051), // Rule ID 129 //
     /* 167011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 167019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167040 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 167043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167049 */     GIR_RootConstrainSelectedInstOperands,
     /* 167050 */     // GIR_Coverage, 129,
     /* 167050 */     GIR_EraseRootFromParent_Done,
     /* 167051 */   // Label 3215: @167051
     /* 167051 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167096), // Rule ID 130 //
     /* 167056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 167064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167085 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 167088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167094 */     GIR_RootConstrainSelectedInstOperands,
     /* 167095 */     // GIR_Coverage, 130,
     /* 167095 */     GIR_EraseRootFromParent_Done,
     /* 167096 */   // Label 3216: @167096
     /* 167096 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167141), // Rule ID 131 //
     /* 167101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 167109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167130 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 167133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167139 */     GIR_RootConstrainSelectedInstOperands,
     /* 167140 */     // GIR_Coverage, 131,
     /* 167140 */     GIR_EraseRootFromParent_Done,
     /* 167141 */   // Label 3217: @167141
     /* 167141 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167186), // Rule ID 132 //
     /* 167146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 167154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167175 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 167178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167184 */     GIR_RootConstrainSelectedInstOperands,
     /* 167185 */     // GIR_Coverage, 132,
     /* 167185 */     GIR_EraseRootFromParent_Done,
     /* 167186 */   // Label 3218: @167186
     /* 167186 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167231), // Rule ID 133 //
     /* 167191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 167199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167220 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 167223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167229 */     GIR_RootConstrainSelectedInstOperands,
     /* 167230 */     // GIR_Coverage, 133,
     /* 167230 */     GIR_EraseRootFromParent_Done,
     /* 167231 */   // Label 3219: @167231
     /* 167231 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(167276), // Rule ID 134 //
     /* 167236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 167244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167265 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 167268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167274 */     GIR_RootConstrainSelectedInstOperands,
     /* 167275 */     // GIR_Coverage, 134,
     /* 167275 */     GIR_EraseRootFromParent_Done,
     /* 167276 */   // Label 3220: @167276
     /* 167276 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(167321), // Rule ID 135 //
     /* 167281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 167289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167310 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 167313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167319 */     GIR_RootConstrainSelectedInstOperands,
     /* 167320 */     // GIR_Coverage, 135,
     /* 167320 */     GIR_EraseRootFromParent_Done,
     /* 167321 */   // Label 3221: @167321
     /* 167321 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(167366), // Rule ID 136 //
     /* 167326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 167334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167355 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 167358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167364 */     GIR_RootConstrainSelectedInstOperands,
     /* 167365 */     // GIR_Coverage, 136,
     /* 167365 */     GIR_EraseRootFromParent_Done,
     /* 167366 */   // Label 3222: @167366
     /* 167366 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167411), // Rule ID 1042 //
     /* 167371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167400 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 167400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 167403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167409 */     GIR_RootConstrainSelectedInstOperands,
     /* 167410 */     // GIR_Coverage, 1042,
     /* 167410 */     GIR_EraseRootFromParent_Done,
     /* 167411 */   // Label 3223: @167411
     /* 167411 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167456), // Rule ID 1043 //
     /* 167416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167445 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 167448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167454 */     GIR_RootConstrainSelectedInstOperands,
     /* 167455 */     // GIR_Coverage, 1043,
     /* 167455 */     GIR_EraseRootFromParent_Done,
     /* 167456 */   // Label 3224: @167456
     /* 167456 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167501), // Rule ID 1044 //
     /* 167461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167490 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 167490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 167493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167499 */     GIR_RootConstrainSelectedInstOperands,
     /* 167500 */     // GIR_Coverage, 1044,
     /* 167500 */     GIR_EraseRootFromParent_Done,
     /* 167501 */   // Label 3225: @167501
     /* 167501 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167546), // Rule ID 1045 //
     /* 167506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167535 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 167535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 167538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167544 */     GIR_RootConstrainSelectedInstOperands,
     /* 167545 */     // GIR_Coverage, 1045,
     /* 167545 */     GIR_EraseRootFromParent_Done,
     /* 167546 */   // Label 3226: @167546
     /* 167546 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167591), // Rule ID 1046 //
     /* 167551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167580 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 167580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 167583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167589 */     GIR_RootConstrainSelectedInstOperands,
     /* 167590 */     // GIR_Coverage, 1046,
     /* 167590 */     GIR_EraseRootFromParent_Done,
     /* 167591 */   // Label 3227: @167591
     /* 167591 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167636), // Rule ID 1047 //
     /* 167596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167625 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 167625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 167628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167634 */     GIR_RootConstrainSelectedInstOperands,
     /* 167635 */     // GIR_Coverage, 1047,
     /* 167635 */     GIR_EraseRootFromParent_Done,
     /* 167636 */   // Label 3228: @167636
     /* 167636 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167681), // Rule ID 1048 //
     /* 167641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167670 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 167670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 167673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167679 */     GIR_RootConstrainSelectedInstOperands,
     /* 167680 */     // GIR_Coverage, 1048,
     /* 167680 */     GIR_EraseRootFromParent_Done,
     /* 167681 */   // Label 3229: @167681
     /* 167681 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167726), // Rule ID 1090 //
     /* 167686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167715 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 167715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 167718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167724 */     GIR_RootConstrainSelectedInstOperands,
     /* 167725 */     // GIR_Coverage, 1090,
     /* 167725 */     GIR_EraseRootFromParent_Done,
     /* 167726 */   // Label 3230: @167726
     /* 167726 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(167771), // Rule ID 1091 //
     /* 167731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167760 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 167763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167769 */     GIR_RootConstrainSelectedInstOperands,
     /* 167770 */     // GIR_Coverage, 1091,
     /* 167770 */     GIR_EraseRootFromParent_Done,
     /* 167771 */   // Label 3231: @167771
     /* 167771 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(167816), // Rule ID 1092 //
     /* 167776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 167793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167805 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 167805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 167808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167814 */     GIR_RootConstrainSelectedInstOperands,
     /* 167815 */     // GIR_Coverage, 1092,
     /* 167815 */     GIR_EraseRootFromParent_Done,
     /* 167816 */   // Label 3232: @167816
     /* 167816 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(167861), // Rule ID 1093 //
     /* 167821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167850 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 167850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 167853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167859 */     GIR_RootConstrainSelectedInstOperands,
     /* 167860 */     // GIR_Coverage, 1093,
     /* 167860 */     GIR_EraseRootFromParent_Done,
     /* 167861 */   // Label 3233: @167861
     /* 167861 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(167906), // Rule ID 1094 //
     /* 167866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 167883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167895 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 167895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 167898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167904 */     GIR_RootConstrainSelectedInstOperands,
     /* 167905 */     // GIR_Coverage, 1094,
     /* 167905 */     GIR_EraseRootFromParent_Done,
     /* 167906 */   // Label 3234: @167906
     /* 167906 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(167951), // Rule ID 1095 //
     /* 167911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 167928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167940 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 167940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 167943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167949 */     GIR_RootConstrainSelectedInstOperands,
     /* 167950 */     // GIR_Coverage, 1095,
     /* 167950 */     GIR_EraseRootFromParent_Done,
     /* 167951 */   // Label 3235: @167951
     /* 167951 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(167996), // Rule ID 1096 //
     /* 167956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 167964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 167973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167985 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 167985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 167988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167994 */     GIR_RootConstrainSelectedInstOperands,
     /* 167995 */     // GIR_Coverage, 1096,
     /* 167995 */     GIR_EraseRootFromParent_Done,
     /* 167996 */   // Label 3236: @167996
     /* 167996 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168041), // Rule ID 1108 //
     /* 168001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168030 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 168033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168039 */     GIR_RootConstrainSelectedInstOperands,
     /* 168040 */     // GIR_Coverage, 1108,
     /* 168040 */     GIR_EraseRootFromParent_Done,
     /* 168041 */   // Label 3237: @168041
     /* 168041 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168086), // Rule ID 1110 //
     /* 168046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168075 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 168078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168084 */     GIR_RootConstrainSelectedInstOperands,
     /* 168085 */     // GIR_Coverage, 1110,
     /* 168085 */     GIR_EraseRootFromParent_Done,
     /* 168086 */   // Label 3238: @168086
     /* 168086 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168131), // Rule ID 1112 //
     /* 168091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168120 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 168123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168129 */     GIR_RootConstrainSelectedInstOperands,
     /* 168130 */     // GIR_Coverage, 1112,
     /* 168130 */     GIR_EraseRootFromParent_Done,
     /* 168131 */   // Label 3239: @168131
     /* 168131 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168176), // Rule ID 1114 //
     /* 168136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168165 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 168168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168174 */     GIR_RootConstrainSelectedInstOperands,
     /* 168175 */     // GIR_Coverage, 1114,
     /* 168175 */     GIR_EraseRootFromParent_Done,
     /* 168176 */   // Label 3240: @168176
     /* 168176 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168221), // Rule ID 1116 //
     /* 168181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168210 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168219 */     GIR_RootConstrainSelectedInstOperands,
     /* 168220 */     // GIR_Coverage, 1116,
     /* 168220 */     GIR_EraseRootFromParent_Done,
     /* 168221 */   // Label 3241: @168221
     /* 168221 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(168266), // Rule ID 1118 //
     /* 168226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168255 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 168258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168264 */     GIR_RootConstrainSelectedInstOperands,
     /* 168265 */     // GIR_Coverage, 1118,
     /* 168265 */     GIR_EraseRootFromParent_Done,
     /* 168266 */   // Label 3242: @168266
     /* 168266 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(168311), // Rule ID 1120 //
     /* 168271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168300 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 168303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168309 */     GIR_RootConstrainSelectedInstOperands,
     /* 168310 */     // GIR_Coverage, 1120,
     /* 168310 */     GIR_EraseRootFromParent_Done,
     /* 168311 */   // Label 3243: @168311
     /* 168311 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(168356), // Rule ID 1163 //
     /* 168316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168345 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 168348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168354 */     GIR_RootConstrainSelectedInstOperands,
     /* 168355 */     // GIR_Coverage, 1163,
     /* 168355 */     GIR_EraseRootFromParent_Done,
     /* 168356 */   // Label 3244: @168356
     /* 168356 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(168401), // Rule ID 1164 //
     /* 168361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168390 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 168393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168399 */     GIR_RootConstrainSelectedInstOperands,
     /* 168400 */     // GIR_Coverage, 1164,
     /* 168400 */     GIR_EraseRootFromParent_Done,
     /* 168401 */   // Label 3245: @168401
     /* 168401 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168446), // Rule ID 1165 //
     /* 168406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168435 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 168438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168444 */     GIR_RootConstrainSelectedInstOperands,
     /* 168445 */     // GIR_Coverage, 1165,
     /* 168445 */     GIR_EraseRootFromParent_Done,
     /* 168446 */   // Label 3246: @168446
     /* 168446 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168491), // Rule ID 1166 //
     /* 168451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168480 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 168483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168489 */     GIR_RootConstrainSelectedInstOperands,
     /* 168490 */     // GIR_Coverage, 1166,
     /* 168490 */     GIR_EraseRootFromParent_Done,
     /* 168491 */   // Label 3247: @168491
     /* 168491 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168536), // Rule ID 1167 //
     /* 168496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168525 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 168528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168534 */     GIR_RootConstrainSelectedInstOperands,
     /* 168535 */     // GIR_Coverage, 1167,
     /* 168535 */     GIR_EraseRootFromParent_Done,
     /* 168536 */   // Label 3248: @168536
     /* 168536 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168581), // Rule ID 1169 //
     /* 168541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168570 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 168573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168579 */     GIR_RootConstrainSelectedInstOperands,
     /* 168580 */     // GIR_Coverage, 1169,
     /* 168580 */     GIR_EraseRootFromParent_Done,
     /* 168581 */   // Label 3249: @168581
     /* 168581 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168626), // Rule ID 1171 //
     /* 168586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168615 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 168618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168624 */     GIR_RootConstrainSelectedInstOperands,
     /* 168625 */     // GIR_Coverage, 1171,
     /* 168625 */     GIR_EraseRootFromParent_Done,
     /* 168626 */   // Label 3250: @168626
     /* 168626 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168671), // Rule ID 1173 //
     /* 168631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168660 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 168663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168669 */     GIR_RootConstrainSelectedInstOperands,
     /* 168670 */     // GIR_Coverage, 1173,
     /* 168670 */     GIR_EraseRootFromParent_Done,
     /* 168671 */   // Label 3251: @168671
     /* 168671 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168716), // Rule ID 1175 //
     /* 168676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168705 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 168708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168714 */     GIR_RootConstrainSelectedInstOperands,
     /* 168715 */     // GIR_Coverage, 1175,
     /* 168715 */     GIR_EraseRootFromParent_Done,
     /* 168716 */   // Label 3252: @168716
     /* 168716 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(168761), // Rule ID 1177 //
     /* 168721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 168729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168750 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 168753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168759 */     GIR_RootConstrainSelectedInstOperands,
     /* 168760 */     // GIR_Coverage, 1177,
     /* 168760 */     GIR_EraseRootFromParent_Done,
     /* 168761 */   // Label 3253: @168761
     /* 168761 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(168806), // Rule ID 1179 //
     /* 168766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168795 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 168798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168804 */     GIR_RootConstrainSelectedInstOperands,
     /* 168805 */     // GIR_Coverage, 1179,
     /* 168805 */     GIR_EraseRootFromParent_Done,
     /* 168806 */   // Label 3254: @168806
     /* 168806 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(168851), // Rule ID 1181 //
     /* 168811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168840 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 168843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168849 */     GIR_RootConstrainSelectedInstOperands,
     /* 168850 */     // GIR_Coverage, 1181,
     /* 168850 */     GIR_EraseRootFromParent_Done,
     /* 168851 */   // Label 3255: @168851
     /* 168851 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(168896), // Rule ID 1183 //
     /* 168856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168885 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 168888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168894 */     GIR_RootConstrainSelectedInstOperands,
     /* 168895 */     // GIR_Coverage, 1183,
     /* 168895 */     GIR_EraseRootFromParent_Done,
     /* 168896 */   // Label 3256: @168896
     /* 168896 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(168941), // Rule ID 1185 //
     /* 168901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168930 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 168930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 168933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168939 */     GIR_RootConstrainSelectedInstOperands,
     /* 168940 */     // GIR_Coverage, 1185,
     /* 168940 */     GIR_EraseRootFromParent_Done,
     /* 168941 */   // Label 3257: @168941
     /* 168941 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(168986), // Rule ID 1187 //
     /* 168946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 168954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168975 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 168975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 168978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168984 */     GIR_RootConstrainSelectedInstOperands,
     /* 168985 */     // GIR_Coverage, 1187,
     /* 168985 */     GIR_EraseRootFromParent_Done,
     /* 168986 */   // Label 3258: @168986
     /* 168986 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169031), // Rule ID 1189 //
     /* 168991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 168999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169020 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 169023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169029 */     GIR_RootConstrainSelectedInstOperands,
     /* 169030 */     // GIR_Coverage, 1189,
     /* 169030 */     GIR_EraseRootFromParent_Done,
     /* 169031 */   // Label 3259: @169031
     /* 169031 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169076), // Rule ID 1191 //
     /* 169036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169065 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 169068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169074 */     GIR_RootConstrainSelectedInstOperands,
     /* 169075 */     // GIR_Coverage, 1191,
     /* 169075 */     GIR_EraseRootFromParent_Done,
     /* 169076 */   // Label 3260: @169076
     /* 169076 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169121), // Rule ID 1193 //
     /* 169081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169110 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 169113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169119 */     GIR_RootConstrainSelectedInstOperands,
     /* 169120 */     // GIR_Coverage, 1193,
     /* 169120 */     GIR_EraseRootFromParent_Done,
     /* 169121 */   // Label 3261: @169121
     /* 169121 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169166), // Rule ID 1195 //
     /* 169126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169155 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 169158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169164 */     GIR_RootConstrainSelectedInstOperands,
     /* 169165 */     // GIR_Coverage, 1195,
     /* 169165 */     GIR_EraseRootFromParent_Done,
     /* 169166 */   // Label 3262: @169166
     /* 169166 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169211), // Rule ID 1197 //
     /* 169171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169200 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 169203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169209 */     GIR_RootConstrainSelectedInstOperands,
     /* 169210 */     // GIR_Coverage, 1197,
     /* 169210 */     GIR_EraseRootFromParent_Done,
     /* 169211 */   // Label 3263: @169211
     /* 169211 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(169256), // Rule ID 1233 //
     /* 169216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169245 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 169248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169254 */     GIR_RootConstrainSelectedInstOperands,
     /* 169255 */     // GIR_Coverage, 1233,
     /* 169255 */     GIR_EraseRootFromParent_Done,
     /* 169256 */   // Label 3264: @169256
     /* 169256 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(169301), // Rule ID 1234 //
     /* 169261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169290 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 169293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169299 */     GIR_RootConstrainSelectedInstOperands,
     /* 169300 */     // GIR_Coverage, 1234,
     /* 169300 */     GIR_EraseRootFromParent_Done,
     /* 169301 */   // Label 3265: @169301
     /* 169301 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(169346), // Rule ID 1235 //
     /* 169306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169335 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 169338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169344 */     GIR_RootConstrainSelectedInstOperands,
     /* 169345 */     // GIR_Coverage, 1235,
     /* 169345 */     GIR_EraseRootFromParent_Done,
     /* 169346 */   // Label 3266: @169346
     /* 169346 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(169391), // Rule ID 1236 //
     /* 169351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169380 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 169383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169389 */     GIR_RootConstrainSelectedInstOperands,
     /* 169390 */     // GIR_Coverage, 1236,
     /* 169390 */     GIR_EraseRootFromParent_Done,
     /* 169391 */   // Label 3267: @169391
     /* 169391 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169436), // Rule ID 1237 //
     /* 169396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169425 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 169428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169434 */     GIR_RootConstrainSelectedInstOperands,
     /* 169435 */     // GIR_Coverage, 1237,
     /* 169435 */     GIR_EraseRootFromParent_Done,
     /* 169436 */   // Label 3268: @169436
     /* 169436 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169481), // Rule ID 1248 //
     /* 169441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169470 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 169473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169479 */     GIR_RootConstrainSelectedInstOperands,
     /* 169480 */     // GIR_Coverage, 1248,
     /* 169480 */     GIR_EraseRootFromParent_Done,
     /* 169481 */   // Label 3269: @169481
     /* 169481 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169526), // Rule ID 1249 //
     /* 169486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169515 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 169518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169524 */     GIR_RootConstrainSelectedInstOperands,
     /* 169525 */     // GIR_Coverage, 1249,
     /* 169525 */     GIR_EraseRootFromParent_Done,
     /* 169526 */   // Label 3270: @169526
     /* 169526 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169571), // Rule ID 1250 //
     /* 169531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169560 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 169563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169569 */     GIR_RootConstrainSelectedInstOperands,
     /* 169570 */     // GIR_Coverage, 1250,
     /* 169570 */     GIR_EraseRootFromParent_Done,
     /* 169571 */   // Label 3271: @169571
     /* 169571 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169616), // Rule ID 1251 //
     /* 169576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169605 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 169608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169614 */     GIR_RootConstrainSelectedInstOperands,
     /* 169615 */     // GIR_Coverage, 1251,
     /* 169615 */     GIR_EraseRootFromParent_Done,
     /* 169616 */   // Label 3272: @169616
     /* 169616 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169661), // Rule ID 1252 //
     /* 169621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169650 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 169653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169659 */     GIR_RootConstrainSelectedInstOperands,
     /* 169660 */     // GIR_Coverage, 1252,
     /* 169660 */     GIR_EraseRootFromParent_Done,
     /* 169661 */   // Label 3273: @169661
     /* 169661 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169706), // Rule ID 1263 //
     /* 169666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169695 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 169698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169704 */     GIR_RootConstrainSelectedInstOperands,
     /* 169705 */     // GIR_Coverage, 1263,
     /* 169705 */     GIR_EraseRootFromParent_Done,
     /* 169706 */   // Label 3274: @169706
     /* 169706 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(169751), // Rule ID 1264 //
     /* 169711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169740 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 169743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169749 */     GIR_RootConstrainSelectedInstOperands,
     /* 169750 */     // GIR_Coverage, 1264,
     /* 169750 */     GIR_EraseRootFromParent_Done,
     /* 169751 */   // Label 3275: @169751
     /* 169751 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(169796), // Rule ID 1265 //
     /* 169756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169785 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 169788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169794 */     GIR_RootConstrainSelectedInstOperands,
     /* 169795 */     // GIR_Coverage, 1265,
     /* 169795 */     GIR_EraseRootFromParent_Done,
     /* 169796 */   // Label 3276: @169796
     /* 169796 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(169841), // Rule ID 1266 //
     /* 169801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169830 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 169833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169839 */     GIR_RootConstrainSelectedInstOperands,
     /* 169840 */     // GIR_Coverage, 1266,
     /* 169840 */     GIR_EraseRootFromParent_Done,
     /* 169841 */   // Label 3277: @169841
     /* 169841 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(169886), // Rule ID 1267 //
     /* 169846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 169854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169875 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 169878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169884 */     GIR_RootConstrainSelectedInstOperands,
     /* 169885 */     // GIR_Coverage, 1267,
     /* 169885 */     GIR_EraseRootFromParent_Done,
     /* 169886 */   // Label 3278: @169886
     /* 169886 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(169931), // Rule ID 1278 //
     /* 169891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169920 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 169923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169929 */     GIR_RootConstrainSelectedInstOperands,
     /* 169930 */     // GIR_Coverage, 1278,
     /* 169930 */     GIR_EraseRootFromParent_Done,
     /* 169931 */   // Label 3279: @169931
     /* 169931 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(169976), // Rule ID 1279 //
     /* 169936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169965 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 169968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169974 */     GIR_RootConstrainSelectedInstOperands,
     /* 169975 */     // GIR_Coverage, 1279,
     /* 169975 */     GIR_EraseRootFromParent_Done,
     /* 169976 */   // Label 3280: @169976
     /* 169976 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170021), // Rule ID 1280 //
     /* 169981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 169989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170010 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 170013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170019 */     GIR_RootConstrainSelectedInstOperands,
     /* 170020 */     // GIR_Coverage, 1280,
     /* 170020 */     GIR_EraseRootFromParent_Done,
     /* 170021 */   // Label 3281: @170021
     /* 170021 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170066), // Rule ID 1281 //
     /* 170026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170055 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 170058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170064 */     GIR_RootConstrainSelectedInstOperands,
     /* 170065 */     // GIR_Coverage, 1281,
     /* 170065 */     GIR_EraseRootFromParent_Done,
     /* 170066 */   // Label 3282: @170066
     /* 170066 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170111), // Rule ID 1282 //
     /* 170071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170100 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 170103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170109 */     GIR_RootConstrainSelectedInstOperands,
     /* 170110 */     // GIR_Coverage, 1282,
     /* 170110 */     GIR_EraseRootFromParent_Done,
     /* 170111 */   // Label 3283: @170111
     /* 170111 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170156), // Rule ID 1313 //
     /* 170116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170145 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 170148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170154 */     GIR_RootConstrainSelectedInstOperands,
     /* 170155 */     // GIR_Coverage, 1313,
     /* 170155 */     GIR_EraseRootFromParent_Done,
     /* 170156 */   // Label 3284: @170156
     /* 170156 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170201), // Rule ID 1314 //
     /* 170161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170190 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 170193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170199 */     GIR_RootConstrainSelectedInstOperands,
     /* 170200 */     // GIR_Coverage, 1314,
     /* 170200 */     GIR_EraseRootFromParent_Done,
     /* 170201 */   // Label 3285: @170201
     /* 170201 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170246), // Rule ID 1315 //
     /* 170206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170235 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 170238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170244 */     GIR_RootConstrainSelectedInstOperands,
     /* 170245 */     // GIR_Coverage, 1315,
     /* 170245 */     GIR_EraseRootFromParent_Done,
     /* 170246 */   // Label 3286: @170246
     /* 170246 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(170291), // Rule ID 1316 //
     /* 170251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170280 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 170283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170289 */     GIR_RootConstrainSelectedInstOperands,
     /* 170290 */     // GIR_Coverage, 1316,
     /* 170290 */     GIR_EraseRootFromParent_Done,
     /* 170291 */   // Label 3287: @170291
     /* 170291 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(170336), // Rule ID 1317 //
     /* 170296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170325 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 170328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170334 */     GIR_RootConstrainSelectedInstOperands,
     /* 170335 */     // GIR_Coverage, 1317,
     /* 170335 */     GIR_EraseRootFromParent_Done,
     /* 170336 */   // Label 3288: @170336
     /* 170336 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(170381), // Rule ID 1328 //
     /* 170341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170370 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 170373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170379 */     GIR_RootConstrainSelectedInstOperands,
     /* 170380 */     // GIR_Coverage, 1328,
     /* 170380 */     GIR_EraseRootFromParent_Done,
     /* 170381 */   // Label 3289: @170381
     /* 170381 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170426), // Rule ID 1329 //
     /* 170386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170415 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 170418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170424 */     GIR_RootConstrainSelectedInstOperands,
     /* 170425 */     // GIR_Coverage, 1329,
     /* 170425 */     GIR_EraseRootFromParent_Done,
     /* 170426 */   // Label 3290: @170426
     /* 170426 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170471), // Rule ID 1330 //
     /* 170431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170460 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 170463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170469 */     GIR_RootConstrainSelectedInstOperands,
     /* 170470 */     // GIR_Coverage, 1330,
     /* 170470 */     GIR_EraseRootFromParent_Done,
     /* 170471 */   // Label 3291: @170471
     /* 170471 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170516), // Rule ID 1331 //
     /* 170476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170505 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 170508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170514 */     GIR_RootConstrainSelectedInstOperands,
     /* 170515 */     // GIR_Coverage, 1331,
     /* 170515 */     GIR_EraseRootFromParent_Done,
     /* 170516 */   // Label 3292: @170516
     /* 170516 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170561), // Rule ID 1332 //
     /* 170521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170550 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 170553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170559 */     GIR_RootConstrainSelectedInstOperands,
     /* 170560 */     // GIR_Coverage, 1332,
     /* 170560 */     GIR_EraseRootFromParent_Done,
     /* 170561 */   // Label 3293: @170561
     /* 170561 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170606), // Rule ID 1333 //
     /* 170566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170595 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 170598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170604 */     GIR_RootConstrainSelectedInstOperands,
     /* 170605 */     // GIR_Coverage, 1333,
     /* 170605 */     GIR_EraseRootFromParent_Done,
     /* 170606 */   // Label 3294: @170606
     /* 170606 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170651), // Rule ID 1334 //
     /* 170611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170640 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 170643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170649 */     GIR_RootConstrainSelectedInstOperands,
     /* 170650 */     // GIR_Coverage, 1334,
     /* 170650 */     GIR_EraseRootFromParent_Done,
     /* 170651 */   // Label 3295: @170651
     /* 170651 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170696), // Rule ID 1335 //
     /* 170656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170685 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 170688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170694 */     GIR_RootConstrainSelectedInstOperands,
     /* 170695 */     // GIR_Coverage, 1335,
     /* 170695 */     GIR_EraseRootFromParent_Done,
     /* 170696 */   // Label 3296: @170696
     /* 170696 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(170741), // Rule ID 1336 //
     /* 170701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170730 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 170733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170739 */     GIR_RootConstrainSelectedInstOperands,
     /* 170740 */     // GIR_Coverage, 1336,
     /* 170740 */     GIR_EraseRootFromParent_Done,
     /* 170741 */   // Label 3297: @170741
     /* 170741 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(170786), // Rule ID 1337 //
     /* 170746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 170754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170775 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 170778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170784 */     GIR_RootConstrainSelectedInstOperands,
     /* 170785 */     // GIR_Coverage, 1337,
     /* 170785 */     GIR_EraseRootFromParent_Done,
     /* 170786 */   // Label 3298: @170786
     /* 170786 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(170831), // Rule ID 1354 //
     /* 170791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170820 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 170823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170829 */     GIR_RootConstrainSelectedInstOperands,
     /* 170830 */     // GIR_Coverage, 1354,
     /* 170830 */     GIR_EraseRootFromParent_Done,
     /* 170831 */   // Label 3299: @170831
     /* 170831 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(170876), // Rule ID 1355 //
     /* 170836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 170844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170865 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 170868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170874 */     GIR_RootConstrainSelectedInstOperands,
     /* 170875 */     // GIR_Coverage, 1355,
     /* 170875 */     GIR_EraseRootFromParent_Done,
     /* 170876 */   // Label 3300: @170876
     /* 170876 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(170921), // Rule ID 1369 //
     /* 170881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 170892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 170898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170910 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 170910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 170913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170919 */     GIR_RootConstrainSelectedInstOperands,
     /* 170920 */     // GIR_Coverage, 1369,
     /* 170920 */     GIR_EraseRootFromParent_Done,
     /* 170921 */   // Label 3301: @170921
     /* 170921 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(170966), // Rule ID 1371 //
     /* 170926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 170937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 170943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170955 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 170955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 170958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170964 */     GIR_RootConstrainSelectedInstOperands,
     /* 170965 */     // GIR_Coverage, 1371,
     /* 170965 */     GIR_EraseRootFromParent_Done,
     /* 170966 */   // Label 3302: @170966
     /* 170966 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171011), // Rule ID 1373 //
     /* 170971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 170979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171000 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 171003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171009 */     GIR_RootConstrainSelectedInstOperands,
     /* 171010 */     // GIR_Coverage, 1373,
     /* 171010 */     GIR_EraseRootFromParent_Done,
     /* 171011 */   // Label 3303: @171011
     /* 171011 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171056), // Rule ID 1375 //
     /* 171016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171045 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 171048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171054 */     GIR_RootConstrainSelectedInstOperands,
     /* 171055 */     // GIR_Coverage, 1375,
     /* 171055 */     GIR_EraseRootFromParent_Done,
     /* 171056 */   // Label 3304: @171056
     /* 171056 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171101), // Rule ID 1377 //
     /* 171061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171090 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 171093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171099 */     GIR_RootConstrainSelectedInstOperands,
     /* 171100 */     // GIR_Coverage, 1377,
     /* 171100 */     GIR_EraseRootFromParent_Done,
     /* 171101 */   // Label 3305: @171101
     /* 171101 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171146), // Rule ID 1379 //
     /* 171106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171135 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 171138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171144 */     GIR_RootConstrainSelectedInstOperands,
     /* 171145 */     // GIR_Coverage, 1379,
     /* 171145 */     GIR_EraseRootFromParent_Done,
     /* 171146 */   // Label 3306: @171146
     /* 171146 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171191), // Rule ID 1386 //
     /* 171151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171180 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 171183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171189 */     GIR_RootConstrainSelectedInstOperands,
     /* 171190 */     // GIR_Coverage, 1386,
     /* 171190 */     GIR_EraseRootFromParent_Done,
     /* 171191 */   // Label 3307: @171191
     /* 171191 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171236), // Rule ID 1387 //
     /* 171196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171225 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 171228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171234 */     GIR_RootConstrainSelectedInstOperands,
     /* 171235 */     // GIR_Coverage, 1387,
     /* 171235 */     GIR_EraseRootFromParent_Done,
     /* 171236 */   // Label 3308: @171236
     /* 171236 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(171281), // Rule ID 1388 //
     /* 171241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171270 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 171273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171279 */     GIR_RootConstrainSelectedInstOperands,
     /* 171280 */     // GIR_Coverage, 1388,
     /* 171280 */     GIR_EraseRootFromParent_Done,
     /* 171281 */   // Label 3309: @171281
     /* 171281 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(171326), // Rule ID 1389 //
     /* 171286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171315 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 171318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171324 */     GIR_RootConstrainSelectedInstOperands,
     /* 171325 */     // GIR_Coverage, 1389,
     /* 171325 */     GIR_EraseRootFromParent_Done,
     /* 171326 */   // Label 3310: @171326
     /* 171326 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(171371), // Rule ID 1390 //
     /* 171331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171360 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 171363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171369 */     GIR_RootConstrainSelectedInstOperands,
     /* 171370 */     // GIR_Coverage, 1390,
     /* 171370 */     GIR_EraseRootFromParent_Done,
     /* 171371 */   // Label 3311: @171371
     /* 171371 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171416), // Rule ID 1391 //
     /* 171376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171405 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 171408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171414 */     GIR_RootConstrainSelectedInstOperands,
     /* 171415 */     // GIR_Coverage, 1391,
     /* 171415 */     GIR_EraseRootFromParent_Done,
     /* 171416 */   // Label 3312: @171416
     /* 171416 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171461), // Rule ID 1392 //
     /* 171421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171450 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 171453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171459 */     GIR_RootConstrainSelectedInstOperands,
     /* 171460 */     // GIR_Coverage, 1392,
     /* 171460 */     GIR_EraseRootFromParent_Done,
     /* 171461 */   // Label 3313: @171461
     /* 171461 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171506), // Rule ID 1393 //
     /* 171466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171495 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 171498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171504 */     GIR_RootConstrainSelectedInstOperands,
     /* 171505 */     // GIR_Coverage, 1393,
     /* 171505 */     GIR_EraseRootFromParent_Done,
     /* 171506 */   // Label 3314: @171506
     /* 171506 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171551), // Rule ID 1394 //
     /* 171511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171540 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 171543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171549 */     GIR_RootConstrainSelectedInstOperands,
     /* 171550 */     // GIR_Coverage, 1394,
     /* 171550 */     GIR_EraseRootFromParent_Done,
     /* 171551 */   // Label 3315: @171551
     /* 171551 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171596), // Rule ID 1395 //
     /* 171556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171585 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 171588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171594 */     GIR_RootConstrainSelectedInstOperands,
     /* 171595 */     // GIR_Coverage, 1395,
     /* 171595 */     GIR_EraseRootFromParent_Done,
     /* 171596 */   // Label 3316: @171596
     /* 171596 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171641), // Rule ID 1396 //
     /* 171601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171630 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 171633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171639 */     GIR_RootConstrainSelectedInstOperands,
     /* 171640 */     // GIR_Coverage, 1396,
     /* 171640 */     GIR_EraseRootFromParent_Done,
     /* 171641 */   // Label 3317: @171641
     /* 171641 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171686), // Rule ID 1397 //
     /* 171646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171675 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 171678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171684 */     GIR_RootConstrainSelectedInstOperands,
     /* 171685 */     // GIR_Coverage, 1397,
     /* 171685 */     GIR_EraseRootFromParent_Done,
     /* 171686 */   // Label 3318: @171686
     /* 171686 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171731), // Rule ID 1404 //
     /* 171691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171720 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 171723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171729 */     GIR_RootConstrainSelectedInstOperands,
     /* 171730 */     // GIR_Coverage, 1404,
     /* 171730 */     GIR_EraseRootFromParent_Done,
     /* 171731 */   // Label 3319: @171731
     /* 171731 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(171776), // Rule ID 1405 //
     /* 171736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171765 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 171768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171774 */     GIR_RootConstrainSelectedInstOperands,
     /* 171775 */     // GIR_Coverage, 1405,
     /* 171775 */     GIR_EraseRootFromParent_Done,
     /* 171776 */   // Label 3320: @171776
     /* 171776 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(171821), // Rule ID 1406 //
     /* 171781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171810 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 171813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171819 */     GIR_RootConstrainSelectedInstOperands,
     /* 171820 */     // GIR_Coverage, 1406,
     /* 171820 */     GIR_EraseRootFromParent_Done,
     /* 171821 */   // Label 3321: @171821
     /* 171821 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(171866), // Rule ID 1407 //
     /* 171826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171855 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 171858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171864 */     GIR_RootConstrainSelectedInstOperands,
     /* 171865 */     // GIR_Coverage, 1407,
     /* 171865 */     GIR_EraseRootFromParent_Done,
     /* 171866 */   // Label 3322: @171866
     /* 171866 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(171911), // Rule ID 1408 //
     /* 171871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171900 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 171903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171909 */     GIR_RootConstrainSelectedInstOperands,
     /* 171910 */     // GIR_Coverage, 1408,
     /* 171910 */     GIR_EraseRootFromParent_Done,
     /* 171911 */   // Label 3323: @171911
     /* 171911 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(171956), // Rule ID 1409 //
     /* 171916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 171924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 171948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171954 */     GIR_RootConstrainSelectedInstOperands,
     /* 171955 */     // GIR_Coverage, 1409,
     /* 171955 */     GIR_EraseRootFromParent_Done,
     /* 171956 */   // Label 3324: @171956
     /* 171956 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172001), // Rule ID 1416 //
     /* 171961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171990 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 171993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171999 */     GIR_RootConstrainSelectedInstOperands,
     /* 172000 */     // GIR_Coverage, 1416,
     /* 172000 */     GIR_EraseRootFromParent_Done,
     /* 172001 */   // Label 3325: @172001
     /* 172001 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172046), // Rule ID 1417 //
     /* 172006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172035 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 172038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172044 */     GIR_RootConstrainSelectedInstOperands,
     /* 172045 */     // GIR_Coverage, 1417,
     /* 172045 */     GIR_EraseRootFromParent_Done,
     /* 172046 */   // Label 3326: @172046
     /* 172046 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172091), // Rule ID 1418 //
     /* 172051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172080 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 172083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172089 */     GIR_RootConstrainSelectedInstOperands,
     /* 172090 */     // GIR_Coverage, 1418,
     /* 172090 */     GIR_EraseRootFromParent_Done,
     /* 172091 */   // Label 3327: @172091
     /* 172091 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172136), // Rule ID 1419 //
     /* 172096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172125 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 172128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172134 */     GIR_RootConstrainSelectedInstOperands,
     /* 172135 */     // GIR_Coverage, 1419,
     /* 172135 */     GIR_EraseRootFromParent_Done,
     /* 172136 */   // Label 3328: @172136
     /* 172136 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172181), // Rule ID 1420 //
     /* 172141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172170 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 172173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172179 */     GIR_RootConstrainSelectedInstOperands,
     /* 172180 */     // GIR_Coverage, 1420,
     /* 172180 */     GIR_EraseRootFromParent_Done,
     /* 172181 */   // Label 3329: @172181
     /* 172181 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172226), // Rule ID 1421 //
     /* 172186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 172218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172224 */     GIR_RootConstrainSelectedInstOperands,
     /* 172225 */     // GIR_Coverage, 1421,
     /* 172225 */     GIR_EraseRootFromParent_Done,
     /* 172226 */   // Label 3330: @172226
     /* 172226 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(172271), // Rule ID 1422 //
     /* 172231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172260 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 172263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172269 */     GIR_RootConstrainSelectedInstOperands,
     /* 172270 */     // GIR_Coverage, 1422,
     /* 172270 */     GIR_EraseRootFromParent_Done,
     /* 172271 */   // Label 3331: @172271
     /* 172271 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(172316), // Rule ID 1423 //
     /* 172276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172305 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 172308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172314 */     GIR_RootConstrainSelectedInstOperands,
     /* 172315 */     // GIR_Coverage, 1423,
     /* 172315 */     GIR_EraseRootFromParent_Done,
     /* 172316 */   // Label 3332: @172316
     /* 172316 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(172361), // Rule ID 1424 //
     /* 172321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172350 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 172353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172359 */     GIR_RootConstrainSelectedInstOperands,
     /* 172360 */     // GIR_Coverage, 1424,
     /* 172360 */     GIR_EraseRootFromParent_Done,
     /* 172361 */   // Label 3333: @172361
     /* 172361 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172406), // Rule ID 1425 //
     /* 172366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172395 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 172398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172404 */     GIR_RootConstrainSelectedInstOperands,
     /* 172405 */     // GIR_Coverage, 1425,
     /* 172405 */     GIR_EraseRootFromParent_Done,
     /* 172406 */   // Label 3334: @172406
     /* 172406 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172451), // Rule ID 1426 //
     /* 172411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172440 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 172443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172449 */     GIR_RootConstrainSelectedInstOperands,
     /* 172450 */     // GIR_Coverage, 1426,
     /* 172450 */     GIR_EraseRootFromParent_Done,
     /* 172451 */   // Label 3335: @172451
     /* 172451 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172496), // Rule ID 1427 //
     /* 172456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172485 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 172488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172494 */     GIR_RootConstrainSelectedInstOperands,
     /* 172495 */     // GIR_Coverage, 1427,
     /* 172495 */     GIR_EraseRootFromParent_Done,
     /* 172496 */   // Label 3336: @172496
     /* 172496 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172541), // Rule ID 1428 //
     /* 172501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172530 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 172533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172539 */     GIR_RootConstrainSelectedInstOperands,
     /* 172540 */     // GIR_Coverage, 1428,
     /* 172540 */     GIR_EraseRootFromParent_Done,
     /* 172541 */   // Label 3337: @172541
     /* 172541 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172586), // Rule ID 1429 //
     /* 172546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172575 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 172578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172584 */     GIR_RootConstrainSelectedInstOperands,
     /* 172585 */     // GIR_Coverage, 1429,
     /* 172585 */     GIR_EraseRootFromParent_Done,
     /* 172586 */   // Label 3338: @172586
     /* 172586 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172631), // Rule ID 1430 //
     /* 172591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 172599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172620 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 172623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172629 */     GIR_RootConstrainSelectedInstOperands,
     /* 172630 */     // GIR_Coverage, 1430,
     /* 172630 */     GIR_EraseRootFromParent_Done,
     /* 172631 */   // Label 3339: @172631
     /* 172631 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172676), // Rule ID 1431 //
     /* 172636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172665 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 172668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172674 */     GIR_RootConstrainSelectedInstOperands,
     /* 172675 */     // GIR_Coverage, 1431,
     /* 172675 */     GIR_EraseRootFromParent_Done,
     /* 172676 */   // Label 3340: @172676
     /* 172676 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172721), // Rule ID 1432 //
     /* 172681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172710 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 172713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172719 */     GIR_RootConstrainSelectedInstOperands,
     /* 172720 */     // GIR_Coverage, 1432,
     /* 172720 */     GIR_EraseRootFromParent_Done,
     /* 172721 */   // Label 3341: @172721
     /* 172721 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(172766), // Rule ID 1433 //
     /* 172726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172755 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 172758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172764 */     GIR_RootConstrainSelectedInstOperands,
     /* 172765 */     // GIR_Coverage, 1433,
     /* 172765 */     GIR_EraseRootFromParent_Done,
     /* 172766 */   // Label 3342: @172766
     /* 172766 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(172811), // Rule ID 1434 //
     /* 172771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172800 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 172803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172809 */     GIR_RootConstrainSelectedInstOperands,
     /* 172810 */     // GIR_Coverage, 1434,
     /* 172810 */     GIR_EraseRootFromParent_Done,
     /* 172811 */   // Label 3343: @172811
     /* 172811 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(172856), // Rule ID 1435 //
     /* 172816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172845 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 172848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172854 */     GIR_RootConstrainSelectedInstOperands,
     /* 172855 */     // GIR_Coverage, 1435,
     /* 172855 */     GIR_EraseRootFromParent_Done,
     /* 172856 */   // Label 3344: @172856
     /* 172856 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(172901), // Rule ID 1436 //
     /* 172861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172890 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 172893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172899 */     GIR_RootConstrainSelectedInstOperands,
     /* 172900 */     // GIR_Coverage, 1436,
     /* 172900 */     GIR_EraseRootFromParent_Done,
     /* 172901 */   // Label 3345: @172901
     /* 172901 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(172946), // Rule ID 1437 //
     /* 172906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 172914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172935 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 172938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172944 */     GIR_RootConstrainSelectedInstOperands,
     /* 172945 */     // GIR_Coverage, 1437,
     /* 172945 */     GIR_EraseRootFromParent_Done,
     /* 172946 */   // Label 3346: @172946
     /* 172946 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(172991), // Rule ID 1438 //
     /* 172951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 172959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172980 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 172983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172989 */     GIR_RootConstrainSelectedInstOperands,
     /* 172990 */     // GIR_Coverage, 1438,
     /* 172990 */     GIR_EraseRootFromParent_Done,
     /* 172991 */   // Label 3347: @172991
     /* 172991 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173036), // Rule ID 1439 //
     /* 172996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173025 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 173028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173034 */     GIR_RootConstrainSelectedInstOperands,
     /* 173035 */     // GIR_Coverage, 1439,
     /* 173035 */     GIR_EraseRootFromParent_Done,
     /* 173036 */   // Label 3348: @173036
     /* 173036 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173081), // Rule ID 1440 //
     /* 173041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173070 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 173073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173079 */     GIR_RootConstrainSelectedInstOperands,
     /* 173080 */     // GIR_Coverage, 1440,
     /* 173080 */     GIR_EraseRootFromParent_Done,
     /* 173081 */   // Label 3349: @173081
     /* 173081 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173126), // Rule ID 1441 //
     /* 173086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173115 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 173118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173124 */     GIR_RootConstrainSelectedInstOperands,
     /* 173125 */     // GIR_Coverage, 1441,
     /* 173125 */     GIR_EraseRootFromParent_Done,
     /* 173126 */   // Label 3350: @173126
     /* 173126 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173171), // Rule ID 1442 //
     /* 173131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173160 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 173163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173169 */     GIR_RootConstrainSelectedInstOperands,
     /* 173170 */     // GIR_Coverage, 1442,
     /* 173170 */     GIR_EraseRootFromParent_Done,
     /* 173171 */   // Label 3351: @173171
     /* 173171 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173216), // Rule ID 1443 //
     /* 173176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173205 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 173208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173214 */     GIR_RootConstrainSelectedInstOperands,
     /* 173215 */     // GIR_Coverage, 1443,
     /* 173215 */     GIR_EraseRootFromParent_Done,
     /* 173216 */   // Label 3352: @173216
     /* 173216 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(173261), // Rule ID 1444 //
     /* 173221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173250 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 173253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173259 */     GIR_RootConstrainSelectedInstOperands,
     /* 173260 */     // GIR_Coverage, 1444,
     /* 173260 */     GIR_EraseRootFromParent_Done,
     /* 173261 */   // Label 3353: @173261
     /* 173261 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(173306), // Rule ID 1445 //
     /* 173266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173295 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 173298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173304 */     GIR_RootConstrainSelectedInstOperands,
     /* 173305 */     // GIR_Coverage, 1445,
     /* 173305 */     GIR_EraseRootFromParent_Done,
     /* 173306 */   // Label 3354: @173306
     /* 173306 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(173351), // Rule ID 1446 //
     /* 173311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173340 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 173343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173349 */     GIR_RootConstrainSelectedInstOperands,
     /* 173350 */     // GIR_Coverage, 1446,
     /* 173350 */     GIR_EraseRootFromParent_Done,
     /* 173351 */   // Label 3355: @173351
     /* 173351 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(173396), // Rule ID 1447 //
     /* 173356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173385 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 173388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173394 */     GIR_RootConstrainSelectedInstOperands,
     /* 173395 */     // GIR_Coverage, 1447,
     /* 173395 */     GIR_EraseRootFromParent_Done,
     /* 173396 */   // Label 3356: @173396
     /* 173396 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173441), // Rule ID 1448 //
     /* 173401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173430 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 173433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173439 */     GIR_RootConstrainSelectedInstOperands,
     /* 173440 */     // GIR_Coverage, 1448,
     /* 173440 */     GIR_EraseRootFromParent_Done,
     /* 173441 */   // Label 3357: @173441
     /* 173441 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173486), // Rule ID 1449 //
     /* 173446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173475 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 173478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173484 */     GIR_RootConstrainSelectedInstOperands,
     /* 173485 */     // GIR_Coverage, 1449,
     /* 173485 */     GIR_EraseRootFromParent_Done,
     /* 173486 */   // Label 3358: @173486
     /* 173486 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173531), // Rule ID 1450 //
     /* 173491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173520 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 173523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173529 */     GIR_RootConstrainSelectedInstOperands,
     /* 173530 */     // GIR_Coverage, 1450,
     /* 173530 */     GIR_EraseRootFromParent_Done,
     /* 173531 */   // Label 3359: @173531
     /* 173531 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173576), // Rule ID 1451 //
     /* 173536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173565 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 173568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173574 */     GIR_RootConstrainSelectedInstOperands,
     /* 173575 */     // GIR_Coverage, 1451,
     /* 173575 */     GIR_EraseRootFromParent_Done,
     /* 173576 */   // Label 3360: @173576
     /* 173576 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173621), // Rule ID 1458 //
     /* 173581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173610 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 173613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173619 */     GIR_RootConstrainSelectedInstOperands,
     /* 173620 */     // GIR_Coverage, 1458,
     /* 173620 */     GIR_EraseRootFromParent_Done,
     /* 173621 */   // Label 3361: @173621
     /* 173621 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173666), // Rule ID 1459 //
     /* 173626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173655 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 173658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173664 */     GIR_RootConstrainSelectedInstOperands,
     /* 173665 */     // GIR_Coverage, 1459,
     /* 173665 */     GIR_EraseRootFromParent_Done,
     /* 173666 */   // Label 3362: @173666
     /* 173666 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173711), // Rule ID 1460 //
     /* 173671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173700 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 173703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173709 */     GIR_RootConstrainSelectedInstOperands,
     /* 173710 */     // GIR_Coverage, 1460,
     /* 173710 */     GIR_EraseRootFromParent_Done,
     /* 173711 */   // Label 3363: @173711
     /* 173711 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(173756), // Rule ID 1461 //
     /* 173716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173745 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 173748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173754 */     GIR_RootConstrainSelectedInstOperands,
     /* 173755 */     // GIR_Coverage, 1461,
     /* 173755 */     GIR_EraseRootFromParent_Done,
     /* 173756 */   // Label 3364: @173756
     /* 173756 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(173801), // Rule ID 1462 //
     /* 173761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173790 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 173793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173799 */     GIR_RootConstrainSelectedInstOperands,
     /* 173800 */     // GIR_Coverage, 1462,
     /* 173800 */     GIR_EraseRootFromParent_Done,
     /* 173801 */   // Label 3365: @173801
     /* 173801 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(173846), // Rule ID 1463 //
     /* 173806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173835 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 173838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173844 */     GIR_RootConstrainSelectedInstOperands,
     /* 173845 */     // GIR_Coverage, 1463,
     /* 173845 */     GIR_EraseRootFromParent_Done,
     /* 173846 */   // Label 3366: @173846
     /* 173846 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(173891), // Rule ID 1464 //
     /* 173851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 173859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 173883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173889 */     GIR_RootConstrainSelectedInstOperands,
     /* 173890 */     // GIR_Coverage, 1464,
     /* 173890 */     GIR_EraseRootFromParent_Done,
     /* 173891 */   // Label 3367: @173891
     /* 173891 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(173936), // Rule ID 1465 //
     /* 173896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173925 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 173928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173934 */     GIR_RootConstrainSelectedInstOperands,
     /* 173935 */     // GIR_Coverage, 1465,
     /* 173935 */     GIR_EraseRootFromParent_Done,
     /* 173936 */   // Label 3368: @173936
     /* 173936 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(173981), // Rule ID 1466 //
     /* 173941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173970 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 173973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173979 */     GIR_RootConstrainSelectedInstOperands,
     /* 173980 */     // GIR_Coverage, 1466,
     /* 173980 */     GIR_EraseRootFromParent_Done,
     /* 173981 */   // Label 3369: @173981
     /* 173981 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174026), // Rule ID 1467 //
     /* 173986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 173994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174015 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 174018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174024 */     GIR_RootConstrainSelectedInstOperands,
     /* 174025 */     // GIR_Coverage, 1467,
     /* 174025 */     GIR_EraseRootFromParent_Done,
     /* 174026 */   // Label 3370: @174026
     /* 174026 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174071), // Rule ID 1468 //
     /* 174031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174060 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 174063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174069 */     GIR_RootConstrainSelectedInstOperands,
     /* 174070 */     // GIR_Coverage, 1468,
     /* 174070 */     GIR_EraseRootFromParent_Done,
     /* 174071 */   // Label 3371: @174071
     /* 174071 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174116), // Rule ID 1469 //
     /* 174076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174105 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 174108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174114 */     GIR_RootConstrainSelectedInstOperands,
     /* 174115 */     // GIR_Coverage, 1469,
     /* 174115 */     GIR_EraseRootFromParent_Done,
     /* 174116 */   // Label 3372: @174116
     /* 174116 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174161), // Rule ID 1470 //
     /* 174121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174150 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 174153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174159 */     GIR_RootConstrainSelectedInstOperands,
     /* 174160 */     // GIR_Coverage, 1470,
     /* 174160 */     GIR_EraseRootFromParent_Done,
     /* 174161 */   // Label 3373: @174161
     /* 174161 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174206), // Rule ID 1471 //
     /* 174166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174195 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 174198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174204 */     GIR_RootConstrainSelectedInstOperands,
     /* 174205 */     // GIR_Coverage, 1471,
     /* 174205 */     GIR_EraseRootFromParent_Done,
     /* 174206 */   // Label 3374: @174206
     /* 174206 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174251), // Rule ID 1492 //
     /* 174211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174240 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 174243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174249 */     GIR_RootConstrainSelectedInstOperands,
     /* 174250 */     // GIR_Coverage, 1492,
     /* 174250 */     GIR_EraseRootFromParent_Done,
     /* 174251 */   // Label 3375: @174251
     /* 174251 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(174296), // Rule ID 1494 //
     /* 174256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174285 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 174288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174294 */     GIR_RootConstrainSelectedInstOperands,
     /* 174295 */     // GIR_Coverage, 1494,
     /* 174295 */     GIR_EraseRootFromParent_Done,
     /* 174296 */   // Label 3376: @174296
     /* 174296 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(174341), // Rule ID 1496 //
     /* 174301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174330 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 174333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174339 */     GIR_RootConstrainSelectedInstOperands,
     /* 174340 */     // GIR_Coverage, 1496,
     /* 174340 */     GIR_EraseRootFromParent_Done,
     /* 174341 */   // Label 3377: @174341
     /* 174341 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(174386), // Rule ID 1498 //
     /* 174346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174375 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 174378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174384 */     GIR_RootConstrainSelectedInstOperands,
     /* 174385 */     // GIR_Coverage, 1498,
     /* 174385 */     GIR_EraseRootFromParent_Done,
     /* 174386 */   // Label 3378: @174386
     /* 174386 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174431), // Rule ID 1500 //
     /* 174391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174420 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 174423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174429 */     GIR_RootConstrainSelectedInstOperands,
     /* 174430 */     // GIR_Coverage, 1500,
     /* 174430 */     GIR_EraseRootFromParent_Done,
     /* 174431 */   // Label 3379: @174431
     /* 174431 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174476), // Rule ID 1502 //
     /* 174436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174465 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 174468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174474 */     GIR_RootConstrainSelectedInstOperands,
     /* 174475 */     // GIR_Coverage, 1502,
     /* 174475 */     GIR_EraseRootFromParent_Done,
     /* 174476 */   // Label 3380: @174476
     /* 174476 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174521), // Rule ID 1509 //
     /* 174481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174510 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 174513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174519 */     GIR_RootConstrainSelectedInstOperands,
     /* 174520 */     // GIR_Coverage, 1509,
     /* 174520 */     GIR_EraseRootFromParent_Done,
     /* 174521 */   // Label 3381: @174521
     /* 174521 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174566), // Rule ID 1510 //
     /* 174526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174555 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 174558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174564 */     GIR_RootConstrainSelectedInstOperands,
     /* 174565 */     // GIR_Coverage, 1510,
     /* 174565 */     GIR_EraseRootFromParent_Done,
     /* 174566 */   // Label 3382: @174566
     /* 174566 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174611), // Rule ID 1511 //
     /* 174571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174600 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 174603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174609 */     GIR_RootConstrainSelectedInstOperands,
     /* 174610 */     // GIR_Coverage, 1511,
     /* 174610 */     GIR_EraseRootFromParent_Done,
     /* 174611 */   // Label 3383: @174611
     /* 174611 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174656), // Rule ID 1512 //
     /* 174616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174645 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 174648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174654 */     GIR_RootConstrainSelectedInstOperands,
     /* 174655 */     // GIR_Coverage, 1512,
     /* 174655 */     GIR_EraseRootFromParent_Done,
     /* 174656 */   // Label 3384: @174656
     /* 174656 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174701), // Rule ID 1513 //
     /* 174661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174690 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 174693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174699 */     GIR_RootConstrainSelectedInstOperands,
     /* 174700 */     // GIR_Coverage, 1513,
     /* 174700 */     GIR_EraseRootFromParent_Done,
     /* 174701 */   // Label 3385: @174701
     /* 174701 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(174746), // Rule ID 1514 //
     /* 174706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 174714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 174738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174744 */     GIR_RootConstrainSelectedInstOperands,
     /* 174745 */     // GIR_Coverage, 1514,
     /* 174745 */     GIR_EraseRootFromParent_Done,
     /* 174746 */   // Label 3386: @174746
     /* 174746 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(174791), // Rule ID 1515 //
     /* 174751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174780 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 174783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174789 */     GIR_RootConstrainSelectedInstOperands,
     /* 174790 */     // GIR_Coverage, 1515,
     /* 174790 */     GIR_EraseRootFromParent_Done,
     /* 174791 */   // Label 3387: @174791
     /* 174791 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(174836), // Rule ID 1516 //
     /* 174796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174825 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 174828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174834 */     GIR_RootConstrainSelectedInstOperands,
     /* 174835 */     // GIR_Coverage, 1516,
     /* 174835 */     GIR_EraseRootFromParent_Done,
     /* 174836 */   // Label 3388: @174836
     /* 174836 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(174881), // Rule ID 1517 //
     /* 174841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174870 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 174873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174879 */     GIR_RootConstrainSelectedInstOperands,
     /* 174880 */     // GIR_Coverage, 1517,
     /* 174880 */     GIR_EraseRootFromParent_Done,
     /* 174881 */   // Label 3389: @174881
     /* 174881 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(174926), // Rule ID 1518 //
     /* 174886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174915 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 174918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174924 */     GIR_RootConstrainSelectedInstOperands,
     /* 174925 */     // GIR_Coverage, 1518,
     /* 174925 */     GIR_EraseRootFromParent_Done,
     /* 174926 */   // Label 3390: @174926
     /* 174926 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(174971), // Rule ID 1519 //
     /* 174931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174960 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 174963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174969 */     GIR_RootConstrainSelectedInstOperands,
     /* 174970 */     // GIR_Coverage, 1519,
     /* 174970 */     GIR_EraseRootFromParent_Done,
     /* 174971 */   // Label 3391: @174971
     /* 174971 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175016), // Rule ID 1520 //
     /* 174976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 174984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175005 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 175008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175014 */     GIR_RootConstrainSelectedInstOperands,
     /* 175015 */     // GIR_Coverage, 1520,
     /* 175015 */     GIR_EraseRootFromParent_Done,
     /* 175016 */   // Label 3392: @175016
     /* 175016 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175061), // Rule ID 1527 //
     /* 175021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175050 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 175053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175059 */     GIR_RootConstrainSelectedInstOperands,
     /* 175060 */     // GIR_Coverage, 1527,
     /* 175060 */     GIR_EraseRootFromParent_Done,
     /* 175061 */   // Label 3393: @175061
     /* 175061 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175106), // Rule ID 1528 //
     /* 175066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175095 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 175098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175104 */     GIR_RootConstrainSelectedInstOperands,
     /* 175105 */     // GIR_Coverage, 1528,
     /* 175105 */     GIR_EraseRootFromParent_Done,
     /* 175106 */   // Label 3394: @175106
     /* 175106 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175151), // Rule ID 1529 //
     /* 175111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175140 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 175143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175149 */     GIR_RootConstrainSelectedInstOperands,
     /* 175150 */     // GIR_Coverage, 1529,
     /* 175150 */     GIR_EraseRootFromParent_Done,
     /* 175151 */   // Label 3395: @175151
     /* 175151 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175196), // Rule ID 1530 //
     /* 175156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175185 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 175188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175194 */     GIR_RootConstrainSelectedInstOperands,
     /* 175195 */     // GIR_Coverage, 1530,
     /* 175195 */     GIR_EraseRootFromParent_Done,
     /* 175196 */   // Label 3396: @175196
     /* 175196 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175241), // Rule ID 1531 //
     /* 175201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175230 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 175233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175239 */     GIR_RootConstrainSelectedInstOperands,
     /* 175240 */     // GIR_Coverage, 1531,
     /* 175240 */     GIR_EraseRootFromParent_Done,
     /* 175241 */   // Label 3397: @175241
     /* 175241 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(175286), // Rule ID 1532 //
     /* 175246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175275 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 175278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175284 */     GIR_RootConstrainSelectedInstOperands,
     /* 175285 */     // GIR_Coverage, 1532,
     /* 175285 */     GIR_EraseRootFromParent_Done,
     /* 175286 */   // Label 3398: @175286
     /* 175286 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(175331), // Rule ID 1539 //
     /* 175291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175320 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 175323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175329 */     GIR_RootConstrainSelectedInstOperands,
     /* 175330 */     // GIR_Coverage, 1539,
     /* 175330 */     GIR_EraseRootFromParent_Done,
     /* 175331 */   // Label 3399: @175331
     /* 175331 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(175376), // Rule ID 1540 //
     /* 175336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175365 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 175368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175374 */     GIR_RootConstrainSelectedInstOperands,
     /* 175375 */     // GIR_Coverage, 1540,
     /* 175375 */     GIR_EraseRootFromParent_Done,
     /* 175376 */   // Label 3400: @175376
     /* 175376 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175421), // Rule ID 1541 //
     /* 175381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175410 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 175413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175419 */     GIR_RootConstrainSelectedInstOperands,
     /* 175420 */     // GIR_Coverage, 1541,
     /* 175420 */     GIR_EraseRootFromParent_Done,
     /* 175421 */   // Label 3401: @175421
     /* 175421 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175466), // Rule ID 1542 //
     /* 175426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175455 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 175458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175464 */     GIR_RootConstrainSelectedInstOperands,
     /* 175465 */     // GIR_Coverage, 1542,
     /* 175465 */     GIR_EraseRootFromParent_Done,
     /* 175466 */   // Label 3402: @175466
     /* 175466 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175511), // Rule ID 1543 //
     /* 175471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175500 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 175503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175509 */     GIR_RootConstrainSelectedInstOperands,
     /* 175510 */     // GIR_Coverage, 1543,
     /* 175510 */     GIR_EraseRootFromParent_Done,
     /* 175511 */   // Label 3403: @175511
     /* 175511 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175556), // Rule ID 1544 //
     /* 175516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175545 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 175548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175554 */     GIR_RootConstrainSelectedInstOperands,
     /* 175555 */     // GIR_Coverage, 1544,
     /* 175555 */     GIR_EraseRootFromParent_Done,
     /* 175556 */   // Label 3404: @175556
     /* 175556 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175601), // Rule ID 1545 //
     /* 175561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175590 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 175593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175599 */     GIR_RootConstrainSelectedInstOperands,
     /* 175600 */     // GIR_Coverage, 1545,
     /* 175600 */     GIR_EraseRootFromParent_Done,
     /* 175601 */   // Label 3405: @175601
     /* 175601 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175646), // Rule ID 1546 //
     /* 175606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175635 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 175638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175644 */     GIR_RootConstrainSelectedInstOperands,
     /* 175645 */     // GIR_Coverage, 1546,
     /* 175645 */     GIR_EraseRootFromParent_Done,
     /* 175646 */   // Label 3406: @175646
     /* 175646 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175691), // Rule ID 1547 //
     /* 175651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175680 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 175683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175689 */     GIR_RootConstrainSelectedInstOperands,
     /* 175690 */     // GIR_Coverage, 1547,
     /* 175690 */     GIR_EraseRootFromParent_Done,
     /* 175691 */   // Label 3407: @175691
     /* 175691 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(175736), // Rule ID 1548 //
     /* 175696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175725 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 175728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175734 */     GIR_RootConstrainSelectedInstOperands,
     /* 175735 */     // GIR_Coverage, 1548,
     /* 175735 */     GIR_EraseRootFromParent_Done,
     /* 175736 */   // Label 3408: @175736
     /* 175736 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(175781), // Rule ID 1549 //
     /* 175741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175770 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 175773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175779 */     GIR_RootConstrainSelectedInstOperands,
     /* 175780 */     // GIR_Coverage, 1549,
     /* 175780 */     GIR_EraseRootFromParent_Done,
     /* 175781 */   // Label 3409: @175781
     /* 175781 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(175826), // Rule ID 1550 //
     /* 175786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175815 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 175818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175824 */     GIR_RootConstrainSelectedInstOperands,
     /* 175825 */     // GIR_Coverage, 1550,
     /* 175825 */     GIR_EraseRootFromParent_Done,
     /* 175826 */   // Label 3410: @175826
     /* 175826 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(175871), // Rule ID 1551 //
     /* 175831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175860 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 175863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175869 */     GIR_RootConstrainSelectedInstOperands,
     /* 175870 */     // GIR_Coverage, 1551,
     /* 175870 */     GIR_EraseRootFromParent_Done,
     /* 175871 */   // Label 3411: @175871
     /* 175871 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(175916), // Rule ID 1552 //
     /* 175876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 175884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 175887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 175890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 175893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175905 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 175905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 175908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175914 */     GIR_RootConstrainSelectedInstOperands,
     /* 175915 */     // GIR_Coverage, 1552,
     /* 175915 */     GIR_EraseRootFromParent_Done,
     /* 175916 */   // Label 3412: @175916
     /* 175916 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(175961), // Rule ID 1553 //
     /* 175921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175950 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 175953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175959 */     GIR_RootConstrainSelectedInstOperands,
     /* 175960 */     // GIR_Coverage, 1553,
     /* 175960 */     GIR_EraseRootFromParent_Done,
     /* 175961 */   // Label 3413: @175961
     /* 175961 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176006), // Rule ID 1554 //
     /* 175966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 175974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175995 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 175998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176004 */     GIR_RootConstrainSelectedInstOperands,
     /* 176005 */     // GIR_Coverage, 1554,
     /* 176005 */     GIR_EraseRootFromParent_Done,
     /* 176006 */   // Label 3414: @176006
     /* 176006 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176051), // Rule ID 1555 //
     /* 176011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176040 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 176043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176049 */     GIR_RootConstrainSelectedInstOperands,
     /* 176050 */     // GIR_Coverage, 1555,
     /* 176050 */     GIR_EraseRootFromParent_Done,
     /* 176051 */   // Label 3415: @176051
     /* 176051 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176096), // Rule ID 1556 //
     /* 176056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176085 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 176088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176094 */     GIR_RootConstrainSelectedInstOperands,
     /* 176095 */     // GIR_Coverage, 1556,
     /* 176095 */     GIR_EraseRootFromParent_Done,
     /* 176096 */   // Label 3416: @176096
     /* 176096 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176141), // Rule ID 1557 //
     /* 176101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176130 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 176133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176139 */     GIR_RootConstrainSelectedInstOperands,
     /* 176140 */     // GIR_Coverage, 1557,
     /* 176140 */     GIR_EraseRootFromParent_Done,
     /* 176141 */   // Label 3417: @176141
     /* 176141 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176186), // Rule ID 1558 //
     /* 176146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176175 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 176178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176184 */     GIR_RootConstrainSelectedInstOperands,
     /* 176185 */     // GIR_Coverage, 1558,
     /* 176185 */     GIR_EraseRootFromParent_Done,
     /* 176186 */   // Label 3418: @176186
     /* 176186 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176231), // Rule ID 1559 //
     /* 176191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176220 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 176223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176229 */     GIR_RootConstrainSelectedInstOperands,
     /* 176230 */     // GIR_Coverage, 1559,
     /* 176230 */     GIR_EraseRootFromParent_Done,
     /* 176231 */   // Label 3419: @176231
     /* 176231 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(176276), // Rule ID 1560 //
     /* 176236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176265 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 176268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176274 */     GIR_RootConstrainSelectedInstOperands,
     /* 176275 */     // GIR_Coverage, 1560,
     /* 176275 */     GIR_EraseRootFromParent_Done,
     /* 176276 */   // Label 3420: @176276
     /* 176276 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(176321), // Rule ID 1561 //
     /* 176281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176310 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 176313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176319 */     GIR_RootConstrainSelectedInstOperands,
     /* 176320 */     // GIR_Coverage, 1561,
     /* 176320 */     GIR_EraseRootFromParent_Done,
     /* 176321 */   // Label 3421: @176321
     /* 176321 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(176366), // Rule ID 1562 //
     /* 176326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176355 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 176358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176364 */     GIR_RootConstrainSelectedInstOperands,
     /* 176365 */     // GIR_Coverage, 1562,
     /* 176365 */     GIR_EraseRootFromParent_Done,
     /* 176366 */   // Label 3422: @176366
     /* 176366 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176411), // Rule ID 1563 //
     /* 176371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176400 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 176403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176409 */     GIR_RootConstrainSelectedInstOperands,
     /* 176410 */     // GIR_Coverage, 1563,
     /* 176410 */     GIR_EraseRootFromParent_Done,
     /* 176411 */   // Label 3423: @176411
     /* 176411 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176456), // Rule ID 1564 //
     /* 176416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176445 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 176448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176454 */     GIR_RootConstrainSelectedInstOperands,
     /* 176455 */     // GIR_Coverage, 1564,
     /* 176455 */     GIR_EraseRootFromParent_Done,
     /* 176456 */   // Label 3424: @176456
     /* 176456 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176501), // Rule ID 1565 //
     /* 176461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176490 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 176493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176499 */     GIR_RootConstrainSelectedInstOperands,
     /* 176500 */     // GIR_Coverage, 1565,
     /* 176500 */     GIR_EraseRootFromParent_Done,
     /* 176501 */   // Label 3425: @176501
     /* 176501 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176546), // Rule ID 1566 //
     /* 176506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176535 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 176538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176544 */     GIR_RootConstrainSelectedInstOperands,
     /* 176545 */     // GIR_Coverage, 1566,
     /* 176545 */     GIR_EraseRootFromParent_Done,
     /* 176546 */   // Label 3426: @176546
     /* 176546 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176591), // Rule ID 1573 //
     /* 176551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176580 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 176583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176589 */     GIR_RootConstrainSelectedInstOperands,
     /* 176590 */     // GIR_Coverage, 1573,
     /* 176590 */     GIR_EraseRootFromParent_Done,
     /* 176591 */   // Label 3427: @176591
     /* 176591 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176636), // Rule ID 1574 //
     /* 176596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176625 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 176628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176634 */     GIR_RootConstrainSelectedInstOperands,
     /* 176635 */     // GIR_Coverage, 1574,
     /* 176635 */     GIR_EraseRootFromParent_Done,
     /* 176636 */   // Label 3428: @176636
     /* 176636 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176681), // Rule ID 1575 //
     /* 176641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176670 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 176673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176679 */     GIR_RootConstrainSelectedInstOperands,
     /* 176680 */     // GIR_Coverage, 1575,
     /* 176680 */     GIR_EraseRootFromParent_Done,
     /* 176681 */   // Label 3429: @176681
     /* 176681 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176726), // Rule ID 1576 //
     /* 176686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176715 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 176718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176724 */     GIR_RootConstrainSelectedInstOperands,
     /* 176725 */     // GIR_Coverage, 1576,
     /* 176725 */     GIR_EraseRootFromParent_Done,
     /* 176726 */   // Label 3430: @176726
     /* 176726 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(176771), // Rule ID 1577 //
     /* 176731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176760 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 176763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176769 */     GIR_RootConstrainSelectedInstOperands,
     /* 176770 */     // GIR_Coverage, 1577,
     /* 176770 */     GIR_EraseRootFromParent_Done,
     /* 176771 */   // Label 3431: @176771
     /* 176771 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(176816), // Rule ID 1578 //
     /* 176776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176805 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 176808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176814 */     GIR_RootConstrainSelectedInstOperands,
     /* 176815 */     // GIR_Coverage, 1578,
     /* 176815 */     GIR_EraseRootFromParent_Done,
     /* 176816 */   // Label 3432: @176816
     /* 176816 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(176861), // Rule ID 1579 //
     /* 176821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 176829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176850 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 176853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176859 */     GIR_RootConstrainSelectedInstOperands,
     /* 176860 */     // GIR_Coverage, 1579,
     /* 176860 */     GIR_EraseRootFromParent_Done,
     /* 176861 */   // Label 3433: @176861
     /* 176861 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(176906), // Rule ID 1580 //
     /* 176866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176895 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 176898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176904 */     GIR_RootConstrainSelectedInstOperands,
     /* 176905 */     // GIR_Coverage, 1580,
     /* 176905 */     GIR_EraseRootFromParent_Done,
     /* 176906 */   // Label 3434: @176906
     /* 176906 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(176951), // Rule ID 1581 //
     /* 176911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176940 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 176943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176949 */     GIR_RootConstrainSelectedInstOperands,
     /* 176950 */     // GIR_Coverage, 1581,
     /* 176950 */     GIR_EraseRootFromParent_Done,
     /* 176951 */   // Label 3435: @176951
     /* 176951 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(176996), // Rule ID 1582 //
     /* 176956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 176964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176985 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 176988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176994 */     GIR_RootConstrainSelectedInstOperands,
     /* 176995 */     // GIR_Coverage, 1582,
     /* 176995 */     GIR_EraseRootFromParent_Done,
     /* 176996 */   // Label 3436: @176996
     /* 176996 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177041), // Rule ID 1583 //
     /* 177001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177030 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 177033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177039 */     GIR_RootConstrainSelectedInstOperands,
     /* 177040 */     // GIR_Coverage, 1583,
     /* 177040 */     GIR_EraseRootFromParent_Done,
     /* 177041 */   // Label 3437: @177041
     /* 177041 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177086), // Rule ID 1584 //
     /* 177046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177075 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 177078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177084 */     GIR_RootConstrainSelectedInstOperands,
     /* 177085 */     // GIR_Coverage, 1584,
     /* 177085 */     GIR_EraseRootFromParent_Done,
     /* 177086 */   // Label 3438: @177086
     /* 177086 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177131), // Rule ID 1585 //
     /* 177091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177120 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 177123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177129 */     GIR_RootConstrainSelectedInstOperands,
     /* 177130 */     // GIR_Coverage, 1585,
     /* 177130 */     GIR_EraseRootFromParent_Done,
     /* 177131 */   // Label 3439: @177131
     /* 177131 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177176), // Rule ID 1586 //
     /* 177136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177165 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 177168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177174 */     GIR_RootConstrainSelectedInstOperands,
     /* 177175 */     // GIR_Coverage, 1586,
     /* 177175 */     GIR_EraseRootFromParent_Done,
     /* 177176 */   // Label 3440: @177176
     /* 177176 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177221), // Rule ID 1614 //
     /* 177181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177210 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 177213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177219 */     GIR_RootConstrainSelectedInstOperands,
     /* 177220 */     // GIR_Coverage, 1614,
     /* 177220 */     GIR_EraseRootFromParent_Done,
     /* 177221 */   // Label 3441: @177221
     /* 177221 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(177266), // Rule ID 1615 //
     /* 177226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177255 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 177258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177264 */     GIR_RootConstrainSelectedInstOperands,
     /* 177265 */     // GIR_Coverage, 1615,
     /* 177265 */     GIR_EraseRootFromParent_Done,
     /* 177266 */   // Label 3442: @177266
     /* 177266 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(177311), // Rule ID 1616 //
     /* 177271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177300 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 177303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177309 */     GIR_RootConstrainSelectedInstOperands,
     /* 177310 */     // GIR_Coverage, 1616,
     /* 177310 */     GIR_EraseRootFromParent_Done,
     /* 177311 */   // Label 3443: @177311
     /* 177311 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(177356), // Rule ID 1617 //
     /* 177316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177345 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 177348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177354 */     GIR_RootConstrainSelectedInstOperands,
     /* 177355 */     // GIR_Coverage, 1617,
     /* 177355 */     GIR_EraseRootFromParent_Done,
     /* 177356 */   // Label 3444: @177356
     /* 177356 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(177401), // Rule ID 1618 //
     /* 177361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177390 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 177393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177399 */     GIR_RootConstrainSelectedInstOperands,
     /* 177400 */     // GIR_Coverage, 1618,
     /* 177400 */     GIR_EraseRootFromParent_Done,
     /* 177401 */   // Label 3445: @177401
     /* 177401 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177446), // Rule ID 1619 //
     /* 177406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177435 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 177438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177444 */     GIR_RootConstrainSelectedInstOperands,
     /* 177445 */     // GIR_Coverage, 1619,
     /* 177445 */     GIR_EraseRootFromParent_Done,
     /* 177446 */   // Label 3446: @177446
     /* 177446 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177491), // Rule ID 1620 //
     /* 177451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177480 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 177483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177489 */     GIR_RootConstrainSelectedInstOperands,
     /* 177490 */     // GIR_Coverage, 1620,
     /* 177490 */     GIR_EraseRootFromParent_Done,
     /* 177491 */   // Label 3447: @177491
     /* 177491 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177536), // Rule ID 1627 //
     /* 177496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177525 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177534 */     GIR_RootConstrainSelectedInstOperands,
     /* 177535 */     // GIR_Coverage, 1627,
     /* 177535 */     GIR_EraseRootFromParent_Done,
     /* 177536 */   // Label 3448: @177536
     /* 177536 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177581), // Rule ID 1628 //
     /* 177541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177570 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177579 */     GIR_RootConstrainSelectedInstOperands,
     /* 177580 */     // GIR_Coverage, 1628,
     /* 177580 */     GIR_EraseRootFromParent_Done,
     /* 177581 */   // Label 3449: @177581
     /* 177581 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177626), // Rule ID 1629 //
     /* 177586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177615 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177624 */     GIR_RootConstrainSelectedInstOperands,
     /* 177625 */     // GIR_Coverage, 1629,
     /* 177625 */     GIR_EraseRootFromParent_Done,
     /* 177626 */   // Label 3450: @177626
     /* 177626 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177671), // Rule ID 1630 //
     /* 177631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177660 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 177663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177669 */     GIR_RootConstrainSelectedInstOperands,
     /* 177670 */     // GIR_Coverage, 1630,
     /* 177670 */     GIR_EraseRootFromParent_Done,
     /* 177671 */   // Label 3451: @177671
     /* 177671 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177716), // Rule ID 1631 //
     /* 177676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177705 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 177708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177714 */     GIR_RootConstrainSelectedInstOperands,
     /* 177715 */     // GIR_Coverage, 1631,
     /* 177715 */     GIR_EraseRootFromParent_Done,
     /* 177716 */   // Label 3452: @177716
     /* 177716 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(177761), // Rule ID 1632 //
     /* 177721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 177729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177750 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 177753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177759 */     GIR_RootConstrainSelectedInstOperands,
     /* 177760 */     // GIR_Coverage, 1632,
     /* 177760 */     GIR_EraseRootFromParent_Done,
     /* 177761 */   // Label 3453: @177761
     /* 177761 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177806), // Rule ID 1633 //
     /* 177766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177795 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 177798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177804 */     GIR_RootConstrainSelectedInstOperands,
     /* 177805 */     // GIR_Coverage, 1633,
     /* 177805 */     GIR_EraseRootFromParent_Done,
     /* 177806 */   // Label 3454: @177806
     /* 177806 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(177851), // Rule ID 1634 //
     /* 177811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177840 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 177843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177849 */     GIR_RootConstrainSelectedInstOperands,
     /* 177850 */     // GIR_Coverage, 1634,
     /* 177850 */     GIR_EraseRootFromParent_Done,
     /* 177851 */   // Label 3455: @177851
     /* 177851 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(177896), // Rule ID 1635 //
     /* 177856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 177864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177885 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 177888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177894 */     GIR_RootConstrainSelectedInstOperands,
     /* 177895 */     // GIR_Coverage, 1635,
     /* 177895 */     GIR_EraseRootFromParent_Done,
     /* 177896 */   // Label 3456: @177896
     /* 177896 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(177941), // Rule ID 1636 //
     /* 177901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177930 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 177930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 177933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177939 */     GIR_RootConstrainSelectedInstOperands,
     /* 177940 */     // GIR_Coverage, 1636,
     /* 177940 */     GIR_EraseRootFromParent_Done,
     /* 177941 */   // Label 3457: @177941
     /* 177941 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(177986), // Rule ID 1637 //
     /* 177946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177975 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 177978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177984 */     GIR_RootConstrainSelectedInstOperands,
     /* 177985 */     // GIR_Coverage, 1637,
     /* 177985 */     GIR_EraseRootFromParent_Done,
     /* 177986 */   // Label 3458: @177986
     /* 177986 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178031), // Rule ID 1638 //
     /* 177991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178020 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 178023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178029 */     GIR_RootConstrainSelectedInstOperands,
     /* 178030 */     // GIR_Coverage, 1638,
     /* 178030 */     GIR_EraseRootFromParent_Done,
     /* 178031 */   // Label 3459: @178031
     /* 178031 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178076), // Rule ID 1639 //
     /* 178036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 178044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178065 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 178068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178074 */     GIR_RootConstrainSelectedInstOperands,
     /* 178075 */     // GIR_Coverage, 1639,
     /* 178075 */     GIR_EraseRootFromParent_Done,
     /* 178076 */   // Label 3460: @178076
     /* 178076 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178121), // Rule ID 1640 //
     /* 178081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 178089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178110 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 178113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178119 */     GIR_RootConstrainSelectedInstOperands,
     /* 178120 */     // GIR_Coverage, 1640,
     /* 178120 */     GIR_EraseRootFromParent_Done,
     /* 178121 */   // Label 3461: @178121
     /* 178121 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178166), // Rule ID 1641 //
     /* 178126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178155 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 178158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178164 */     GIR_RootConstrainSelectedInstOperands,
     /* 178165 */     // GIR_Coverage, 1641,
     /* 178165 */     GIR_EraseRootFromParent_Done,
     /* 178166 */   // Label 3462: @178166
     /* 178166 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178211), // Rule ID 1642 //
     /* 178171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 178179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178200 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 178203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178209 */     GIR_RootConstrainSelectedInstOperands,
     /* 178210 */     // GIR_Coverage, 1642,
     /* 178210 */     GIR_EraseRootFromParent_Done,
     /* 178211 */   // Label 3463: @178211
     /* 178211 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(178256), // Rule ID 1643 //
     /* 178216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 178224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178245 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 178248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178254 */     GIR_RootConstrainSelectedInstOperands,
     /* 178255 */     // GIR_Coverage, 1643,
     /* 178255 */     GIR_EraseRootFromParent_Done,
     /* 178256 */   // Label 3464: @178256
     /* 178256 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(178301), // Rule ID 1645 //
     /* 178261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 178269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178290 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 178293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178299 */     GIR_RootConstrainSelectedInstOperands,
     /* 178300 */     // GIR_Coverage, 1645,
     /* 178300 */     GIR_EraseRootFromParent_Done,
     /* 178301 */   // Label 3465: @178301
     /* 178301 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(178346), // Rule ID 1646 //
     /* 178306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178335 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 178338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178344 */     GIR_RootConstrainSelectedInstOperands,
     /* 178345 */     // GIR_Coverage, 1646,
     /* 178345 */     GIR_EraseRootFromParent_Done,
     /* 178346 */   // Label 3466: @178346
     /* 178346 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(178391), // Rule ID 1647 //
     /* 178351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178380 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 178383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178389 */     GIR_RootConstrainSelectedInstOperands,
     /* 178390 */     // GIR_Coverage, 1647,
     /* 178390 */     GIR_EraseRootFromParent_Done,
     /* 178391 */   // Label 3467: @178391
     /* 178391 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178436), // Rule ID 1648 //
     /* 178396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178425 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 178428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178434 */     GIR_RootConstrainSelectedInstOperands,
     /* 178435 */     // GIR_Coverage, 1648,
     /* 178435 */     GIR_EraseRootFromParent_Done,
     /* 178436 */   // Label 3468: @178436
     /* 178436 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178481), // Rule ID 1649 //
     /* 178441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 178449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178470 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 178473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178479 */     GIR_RootConstrainSelectedInstOperands,
     /* 178480 */     // GIR_Coverage, 1649,
     /* 178480 */     GIR_EraseRootFromParent_Done,
     /* 178481 */   // Label 3469: @178481
     /* 178481 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178526), // Rule ID 1650 //
     /* 178486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 178494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178515 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 178518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178524 */     GIR_RootConstrainSelectedInstOperands,
     /* 178525 */     // GIR_Coverage, 1650,
     /* 178525 */     GIR_EraseRootFromParent_Done,
     /* 178526 */   // Label 3470: @178526
     /* 178526 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178571), // Rule ID 1651 //
     /* 178531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178560 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 178563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178569 */     GIR_RootConstrainSelectedInstOperands,
     /* 178570 */     // GIR_Coverage, 1651,
     /* 178570 */     GIR_EraseRootFromParent_Done,
     /* 178571 */   // Label 3471: @178571
     /* 178571 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178616), // Rule ID 1665 //
     /* 178576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 178584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178605 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 178605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 178608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178614 */     GIR_RootConstrainSelectedInstOperands,
     /* 178615 */     // GIR_Coverage, 1665,
     /* 178615 */     GIR_EraseRootFromParent_Done,
     /* 178616 */   // Label 3472: @178616
     /* 178616 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178661), // Rule ID 1666 //
     /* 178621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 178629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178650 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 178650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 178653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178659 */     GIR_RootConstrainSelectedInstOperands,
     /* 178660 */     // GIR_Coverage, 1666,
     /* 178660 */     GIR_EraseRootFromParent_Done,
     /* 178661 */   // Label 3473: @178661
     /* 178661 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178706), // Rule ID 1671 //
     /* 178666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178695 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 178695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 178698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178704 */     GIR_RootConstrainSelectedInstOperands,
     /* 178705 */     // GIR_Coverage, 1671,
     /* 178705 */     GIR_EraseRootFromParent_Done,
     /* 178706 */   // Label 3474: @178706
     /* 178706 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(178751), // Rule ID 1672 //
     /* 178711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 178719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178740 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 178740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 178743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178749 */     GIR_RootConstrainSelectedInstOperands,
     /* 178750 */     // GIR_Coverage, 1672,
     /* 178750 */     GIR_EraseRootFromParent_Done,
     /* 178751 */   // Label 3475: @178751
     /* 178751 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(178796), // Rule ID 1673 //
     /* 178756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178785 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 178788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178794 */     GIR_RootConstrainSelectedInstOperands,
     /* 178795 */     // GIR_Coverage, 1673,
     /* 178795 */     GIR_EraseRootFromParent_Done,
     /* 178796 */   // Label 3476: @178796
     /* 178796 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(178841), // Rule ID 1674 //
     /* 178801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178830 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 178833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178839 */     GIR_RootConstrainSelectedInstOperands,
     /* 178840 */     // GIR_Coverage, 1674,
     /* 178840 */     GIR_EraseRootFromParent_Done,
     /* 178841 */   // Label 3477: @178841
     /* 178841 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(178886), // Rule ID 1675 //
     /* 178846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 178854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178875 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 178875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 178878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178884 */     GIR_RootConstrainSelectedInstOperands,
     /* 178885 */     // GIR_Coverage, 1675,
     /* 178885 */     GIR_EraseRootFromParent_Done,
     /* 178886 */   // Label 3478: @178886
     /* 178886 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(178931), // Rule ID 1676 //
     /* 178891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 178902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178920 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 178920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 178923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178929 */     GIR_RootConstrainSelectedInstOperands,
     /* 178930 */     // GIR_Coverage, 1676,
     /* 178930 */     GIR_EraseRootFromParent_Done,
     /* 178931 */   // Label 3479: @178931
     /* 178931 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(178976), // Rule ID 1677 //
     /* 178936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178965 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 178965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 178968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178974 */     GIR_RootConstrainSelectedInstOperands,
     /* 178975 */     // GIR_Coverage, 1677,
     /* 178975 */     GIR_EraseRootFromParent_Done,
     /* 178976 */   // Label 3480: @178976
     /* 178976 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179021), // Rule ID 1678 //
     /* 178981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 178989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179010 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 179013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179019 */     GIR_RootConstrainSelectedInstOperands,
     /* 179020 */     // GIR_Coverage, 1678,
     /* 179020 */     GIR_EraseRootFromParent_Done,
     /* 179021 */   // Label 3481: @179021
     /* 179021 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179066), // Rule ID 1679 //
     /* 179026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179055 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 179058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179064 */     GIR_RootConstrainSelectedInstOperands,
     /* 179065 */     // GIR_Coverage, 1679,
     /* 179065 */     GIR_EraseRootFromParent_Done,
     /* 179066 */   // Label 3482: @179066
     /* 179066 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179111), // Rule ID 1680 //
     /* 179071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179100 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 179103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179109 */     GIR_RootConstrainSelectedInstOperands,
     /* 179110 */     // GIR_Coverage, 1680,
     /* 179110 */     GIR_EraseRootFromParent_Done,
     /* 179111 */   // Label 3483: @179111
     /* 179111 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179156), // Rule ID 1681 //
     /* 179116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179145 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 179148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179154 */     GIR_RootConstrainSelectedInstOperands,
     /* 179155 */     // GIR_Coverage, 1681,
     /* 179155 */     GIR_EraseRootFromParent_Done,
     /* 179156 */   // Label 3484: @179156
     /* 179156 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179201), // Rule ID 1682 //
     /* 179161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179190 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 179193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179199 */     GIR_RootConstrainSelectedInstOperands,
     /* 179200 */     // GIR_Coverage, 1682,
     /* 179200 */     GIR_EraseRootFromParent_Done,
     /* 179201 */   // Label 3485: @179201
     /* 179201 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179246), // Rule ID 1683 //
     /* 179206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179235 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 179238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179244 */     GIR_RootConstrainSelectedInstOperands,
     /* 179245 */     // GIR_Coverage, 1683,
     /* 179245 */     GIR_EraseRootFromParent_Done,
     /* 179246 */   // Label 3486: @179246
     /* 179246 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(179291), // Rule ID 1684 //
     /* 179251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179280 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 179283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179289 */     GIR_RootConstrainSelectedInstOperands,
     /* 179290 */     // GIR_Coverage, 1684,
     /* 179290 */     GIR_EraseRootFromParent_Done,
     /* 179291 */   // Label 3487: @179291
     /* 179291 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(179336), // Rule ID 1750 //
     /* 179296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179325 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 179328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179334 */     GIR_RootConstrainSelectedInstOperands,
     /* 179335 */     // GIR_Coverage, 1750,
     /* 179335 */     GIR_EraseRootFromParent_Done,
     /* 179336 */   // Label 3488: @179336
     /* 179336 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(179381), // Rule ID 1752 //
     /* 179341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179370 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 179373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179379 */     GIR_RootConstrainSelectedInstOperands,
     /* 179380 */     // GIR_Coverage, 1752,
     /* 179380 */     GIR_EraseRootFromParent_Done,
     /* 179381 */   // Label 3489: @179381
     /* 179381 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179426), // Rule ID 2303 //
     /* 179386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 179394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179415 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 179418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179424 */     GIR_RootConstrainSelectedInstOperands,
     /* 179425 */     // GIR_Coverage, 2303,
     /* 179425 */     GIR_EraseRootFromParent_Done,
     /* 179426 */   // Label 3490: @179426
     /* 179426 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179471), // Rule ID 2304 //
     /* 179431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 179439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179460 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 179463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179469 */     GIR_RootConstrainSelectedInstOperands,
     /* 179470 */     // GIR_Coverage, 2304,
     /* 179470 */     GIR_EraseRootFromParent_Done,
     /* 179471 */   // Label 3491: @179471
     /* 179471 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179516), // Rule ID 2315 //
     /* 179476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 179479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 179484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179505 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 179505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 179508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179514 */     GIR_RootConstrainSelectedInstOperands,
     /* 179515 */     // GIR_Coverage, 2315,
     /* 179515 */     GIR_EraseRootFromParent_Done,
     /* 179516 */   // Label 3492: @179516
     /* 179516 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179561), // Rule ID 2316 //
     /* 179521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 179524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 179529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179550 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 179550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 179553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179559 */     GIR_RootConstrainSelectedInstOperands,
     /* 179560 */     // GIR_Coverage, 2316,
     /* 179560 */     GIR_EraseRootFromParent_Done,
     /* 179561 */   // Label 3493: @179561
     /* 179561 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179606), // Rule ID 2339 //
     /* 179566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179595 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 179598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179604 */     GIR_RootConstrainSelectedInstOperands,
     /* 179605 */     // GIR_Coverage, 2339,
     /* 179605 */     GIR_EraseRootFromParent_Done,
     /* 179606 */   // Label 3494: @179606
     /* 179606 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179651), // Rule ID 2340 //
     /* 179611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179640 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 179643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179649 */     GIR_RootConstrainSelectedInstOperands,
     /* 179650 */     // GIR_Coverage, 2340,
     /* 179650 */     GIR_EraseRootFromParent_Done,
     /* 179651 */   // Label 3495: @179651
     /* 179651 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179696), // Rule ID 2341 //
     /* 179656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179685 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 179688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179694 */     GIR_RootConstrainSelectedInstOperands,
     /* 179695 */     // GIR_Coverage, 2341,
     /* 179695 */     GIR_EraseRootFromParent_Done,
     /* 179696 */   // Label 3496: @179696
     /* 179696 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(179741), // Rule ID 2342 //
     /* 179701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179730 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 179733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179739 */     GIR_RootConstrainSelectedInstOperands,
     /* 179740 */     // GIR_Coverage, 2342,
     /* 179740 */     GIR_EraseRootFromParent_Done,
     /* 179741 */   // Label 3497: @179741
     /* 179741 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(179786), // Rule ID 2343 //
     /* 179746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 179749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 179754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179775 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 179778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179784 */     GIR_RootConstrainSelectedInstOperands,
     /* 179785 */     // GIR_Coverage, 2343,
     /* 179785 */     GIR_EraseRootFromParent_Done,
     /* 179786 */   // Label 3498: @179786
     /* 179786 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(179831), // Rule ID 2344 //
     /* 179791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179820 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 179820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 179823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179829 */     GIR_RootConstrainSelectedInstOperands,
     /* 179830 */     // GIR_Coverage, 2344,
     /* 179830 */     GIR_EraseRootFromParent_Done,
     /* 179831 */   // Label 3499: @179831
     /* 179831 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(179876), // Rule ID 2347 //
     /* 179836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179865 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 179865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 179868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179874 */     GIR_RootConstrainSelectedInstOperands,
     /* 179875 */     // GIR_Coverage, 2347,
     /* 179875 */     GIR_EraseRootFromParent_Done,
     /* 179876 */   // Label 3500: @179876
     /* 179876 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(179921), // Rule ID 2350 //
     /* 179881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179910 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 179910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 179913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179919 */     GIR_RootConstrainSelectedInstOperands,
     /* 179920 */     // GIR_Coverage, 2350,
     /* 179920 */     GIR_EraseRootFromParent_Done,
     /* 179921 */   // Label 3501: @179921
     /* 179921 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(179966), // Rule ID 2353 //
     /* 179926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179955 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 179955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 179958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179964 */     GIR_RootConstrainSelectedInstOperands,
     /* 179965 */     // GIR_Coverage, 2353,
     /* 179965 */     GIR_EraseRootFromParent_Done,
     /* 179966 */   // Label 3502: @179966
     /* 179966 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180011), // Rule ID 2356 //
     /* 179971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 179974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 179979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180000 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 180003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180009 */     GIR_RootConstrainSelectedInstOperands,
     /* 180010 */     // GIR_Coverage, 2356,
     /* 180010 */     GIR_EraseRootFromParent_Done,
     /* 180011 */   // Label 3503: @180011
     /* 180011 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180056), // Rule ID 2359 //
     /* 180016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180045 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 180045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 180048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180054 */     GIR_RootConstrainSelectedInstOperands,
     /* 180055 */     // GIR_Coverage, 2359,
     /* 180055 */     GIR_EraseRootFromParent_Done,
     /* 180056 */   // Label 3504: @180056
     /* 180056 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180101), // Rule ID 2362 //
     /* 180061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180090 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 180090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 180093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180099 */     GIR_RootConstrainSelectedInstOperands,
     /* 180100 */     // GIR_Coverage, 2362,
     /* 180100 */     GIR_EraseRootFromParent_Done,
     /* 180101 */   // Label 3505: @180101
     /* 180101 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180146), // Rule ID 2365 //
     /* 180106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180135 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 180135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 180138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180144 */     GIR_RootConstrainSelectedInstOperands,
     /* 180145 */     // GIR_Coverage, 2365,
     /* 180145 */     GIR_EraseRootFromParent_Done,
     /* 180146 */   // Label 3506: @180146
     /* 180146 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180191), // Rule ID 2368 //
     /* 180151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180180 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 180180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 180183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180189 */     GIR_RootConstrainSelectedInstOperands,
     /* 180190 */     // GIR_Coverage, 2368,
     /* 180190 */     GIR_EraseRootFromParent_Done,
     /* 180191 */   // Label 3507: @180191
     /* 180191 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180236), // Rule ID 2371 //
     /* 180196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180225 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 180228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180234 */     GIR_RootConstrainSelectedInstOperands,
     /* 180235 */     // GIR_Coverage, 2371,
     /* 180235 */     GIR_EraseRootFromParent_Done,
     /* 180236 */   // Label 3508: @180236
     /* 180236 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(180281), // Rule ID 2508 //
     /* 180241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180270 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 180270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 180273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180279 */     GIR_RootConstrainSelectedInstOperands,
     /* 180280 */     // GIR_Coverage, 2508,
     /* 180280 */     GIR_EraseRootFromParent_Done,
     /* 180281 */   // Label 3509: @180281
     /* 180281 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(180326), // Rule ID 2509 //
     /* 180286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180315 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 180318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180324 */     GIR_RootConstrainSelectedInstOperands,
     /* 180325 */     // GIR_Coverage, 2509,
     /* 180325 */     GIR_EraseRootFromParent_Done,
     /* 180326 */   // Label 3510: @180326
     /* 180326 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(180371), // Rule ID 2510 //
     /* 180331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 180339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180360 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 180363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180369 */     GIR_RootConstrainSelectedInstOperands,
     /* 180370 */     // GIR_Coverage, 2510,
     /* 180370 */     GIR_EraseRootFromParent_Done,
     /* 180371 */   // Label 3511: @180371
     /* 180371 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180416), // Rule ID 2511 //
     /* 180376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 180384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180405 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 180408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180414 */     GIR_RootConstrainSelectedInstOperands,
     /* 180415 */     // GIR_Coverage, 2511,
     /* 180415 */     GIR_EraseRootFromParent_Done,
     /* 180416 */   // Label 3512: @180416
     /* 180416 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180461), // Rule ID 2516 //
     /* 180421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 180429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180450 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 180450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 180453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180459 */     GIR_RootConstrainSelectedInstOperands,
     /* 180460 */     // GIR_Coverage, 2516,
     /* 180460 */     GIR_EraseRootFromParent_Done,
     /* 180461 */   // Label 3513: @180461
     /* 180461 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180506), // Rule ID 2634 //
     /* 180466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180495 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 180498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180504 */     GIR_RootConstrainSelectedInstOperands,
     /* 180505 */     // GIR_Coverage, 2634,
     /* 180505 */     GIR_EraseRootFromParent_Done,
     /* 180506 */   // Label 3514: @180506
     /* 180506 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180551), // Rule ID 2635 //
     /* 180511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 180528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180540 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 180543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180549 */     GIR_RootConstrainSelectedInstOperands,
     /* 180550 */     // GIR_Coverage, 2635,
     /* 180550 */     GIR_EraseRootFromParent_Done,
     /* 180551 */   // Label 3515: @180551
     /* 180551 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180596), // Rule ID 2636 //
     /* 180556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180585 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 180588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180594 */     GIR_RootConstrainSelectedInstOperands,
     /* 180595 */     // GIR_Coverage, 2636,
     /* 180595 */     GIR_EraseRootFromParent_Done,
     /* 180596 */   // Label 3516: @180596
     /* 180596 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180641), // Rule ID 2637 //
     /* 180601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 180609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 180626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180630 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 180630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 180633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180639 */     GIR_RootConstrainSelectedInstOperands,
     /* 180640 */     // GIR_Coverage, 2637,
     /* 180640 */     GIR_EraseRootFromParent_Done,
     /* 180641 */   // Label 3517: @180641
     /* 180641 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180686), // Rule ID 2638 //
     /* 180646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 180663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180675 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 180678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180684 */     GIR_RootConstrainSelectedInstOperands,
     /* 180685 */     // GIR_Coverage, 2638,
     /* 180685 */     GIR_EraseRootFromParent_Done,
     /* 180686 */   // Label 3518: @180686
     /* 180686 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180731), // Rule ID 2639 //
     /* 180691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 180708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180720 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 180723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180729 */     GIR_RootConstrainSelectedInstOperands,
     /* 180730 */     // GIR_Coverage, 2639,
     /* 180730 */     GIR_EraseRootFromParent_Done,
     /* 180731 */   // Label 3519: @180731
     /* 180731 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(180776), // Rule ID 2640 //
     /* 180736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 180753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180765 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 180768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180774 */     GIR_RootConstrainSelectedInstOperands,
     /* 180775 */     // GIR_Coverage, 2640,
     /* 180775 */     GIR_EraseRootFromParent_Done,
     /* 180776 */   // Label 3520: @180776
     /* 180776 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(180821), // Rule ID 2641 //
     /* 180781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 180784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 180789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 180798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180810 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 180810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 180813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 180815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 180817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180819 */     GIR_RootConstrainSelectedInstOperands,
     /* 180820 */     // GIR_Coverage, 2641,
     /* 180820 */     GIR_EraseRootFromParent_Done,
     /* 180821 */   // Label 3521: @180821
     /* 180821 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(180866), // Rule ID 3805 //
     /* 180826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 180834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180855 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 180858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 180860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180864 */     GIR_RootConstrainSelectedInstOperands,
     /* 180865 */     // GIR_Coverage, 3805,
     /* 180865 */     GIR_EraseRootFromParent_Done,
     /* 180866 */   // Label 3522: @180866
     /* 180866 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(180911), // Rule ID 3833 //
     /* 180871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 180874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 180879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180900 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 180900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 180903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180909 */     GIR_RootConstrainSelectedInstOperands,
     /* 180910 */     // GIR_Coverage, 3833,
     /* 180910 */     GIR_EraseRootFromParent_Done,
     /* 180911 */   // Label 3523: @180911
     /* 180911 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(180956), // Rule ID 3843 //
     /* 180916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 180919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 180924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180945 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 180945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 180948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 180950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180954 */     GIR_RootConstrainSelectedInstOperands,
     /* 180955 */     // GIR_Coverage, 3843,
     /* 180955 */     GIR_EraseRootFromParent_Done,
     /* 180956 */   // Label 3524: @180956
     /* 180956 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181001), // Rule ID 3844 //
     /* 180961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 180964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 180969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180990 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 180990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 180993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 180995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 180999 */     GIR_RootConstrainSelectedInstOperands,
     /* 181000 */     // GIR_Coverage, 3844,
     /* 181000 */     GIR_EraseRootFromParent_Done,
     /* 181001 */   // Label 3525: @181001
     /* 181001 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181049), // Rule ID 3845 //
     /* 181006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181035 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 181035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181047 */     GIR_RootConstrainSelectedInstOperands,
     /* 181048 */     // GIR_Coverage, 3845,
     /* 181048 */     GIR_EraseRootFromParent_Done,
     /* 181049 */   // Label 3526: @181049
     /* 181049 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181097), // Rule ID 3846 //
     /* 181054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181083 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 181083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181095 */     GIR_RootConstrainSelectedInstOperands,
     /* 181096 */     // GIR_Coverage, 3846,
     /* 181096 */     GIR_EraseRootFromParent_Done,
     /* 181097 */   // Label 3527: @181097
     /* 181097 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181145), // Rule ID 3847 //
     /* 181102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181131 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 181131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181143 */     GIR_RootConstrainSelectedInstOperands,
     /* 181144 */     // GIR_Coverage, 3847,
     /* 181144 */     GIR_EraseRootFromParent_Done,
     /* 181145 */   // Label 3528: @181145
     /* 181145 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181193), // Rule ID 3848 //
     /* 181150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181179 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 181179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181191 */     GIR_RootConstrainSelectedInstOperands,
     /* 181192 */     // GIR_Coverage, 3848,
     /* 181192 */     GIR_EraseRootFromParent_Done,
     /* 181193 */   // Label 3529: @181193
     /* 181193 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181241), // Rule ID 3849 //
     /* 181198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181227 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 181227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181239 */     GIR_RootConstrainSelectedInstOperands,
     /* 181240 */     // GIR_Coverage, 3849,
     /* 181240 */     GIR_EraseRootFromParent_Done,
     /* 181241 */   // Label 3530: @181241
     /* 181241 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(181289), // Rule ID 3850 //
     /* 181246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181275 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 181275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181287 */     GIR_RootConstrainSelectedInstOperands,
     /* 181288 */     // GIR_Coverage, 3850,
     /* 181288 */     GIR_EraseRootFromParent_Done,
     /* 181289 */   // Label 3531: @181289
     /* 181289 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(181337), // Rule ID 3851 //
     /* 181294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181323 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 181323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181335 */     GIR_RootConstrainSelectedInstOperands,
     /* 181336 */     // GIR_Coverage, 3851,
     /* 181336 */     GIR_EraseRootFromParent_Done,
     /* 181337 */   // Label 3532: @181337
     /* 181337 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(181385), // Rule ID 3852 //
     /* 181342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181371 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 181371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181383 */     GIR_RootConstrainSelectedInstOperands,
     /* 181384 */     // GIR_Coverage, 3852,
     /* 181384 */     GIR_EraseRootFromParent_Done,
     /* 181385 */   // Label 3533: @181385
     /* 181385 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181433), // Rule ID 3853 //
     /* 181390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181419 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 181419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 181422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181431 */     GIR_RootConstrainSelectedInstOperands,
     /* 181432 */     // GIR_Coverage, 3853,
     /* 181432 */     GIR_EraseRootFromParent_Done,
     /* 181433 */   // Label 3534: @181433
     /* 181433 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181481), // Rule ID 3854 //
     /* 181438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181467 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 181467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 181470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181479 */     GIR_RootConstrainSelectedInstOperands,
     /* 181480 */     // GIR_Coverage, 3854,
     /* 181480 */     GIR_EraseRootFromParent_Done,
     /* 181481 */   // Label 3535: @181481
     /* 181481 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181523), // Rule ID 3919 //
     /* 181486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 181491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181512 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 181512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 181515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181521 */     GIR_RootConstrainSelectedInstOperands,
     /* 181522 */     // GIR_Coverage, 3919,
     /* 181522 */     GIR_EraseRootFromParent_Done,
     /* 181523 */   // Label 3536: @181523
     /* 181523 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181565), // Rule ID 3920 //
     /* 181528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 181533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181554 */     // (intrinsic_wo_chain:{ *:[i64] } 2155:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 181554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 181557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181563 */     GIR_RootConstrainSelectedInstOperands,
     /* 181564 */     // GIR_Coverage, 3920,
     /* 181564 */     GIR_EraseRootFromParent_Done,
     /* 181565 */   // Label 3537: @181565
     /* 181565 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181607), // Rule ID 3921 //
     /* 181570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 181575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181596 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 181596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 181599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181605 */     GIR_RootConstrainSelectedInstOperands,
     /* 181606 */     // GIR_Coverage, 3921,
     /* 181606 */     GIR_EraseRootFromParent_Done,
     /* 181607 */   // Label 3538: @181607
     /* 181607 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181649), // Rule ID 3922 //
     /* 181612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 181617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181638 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 181638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 181641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181647 */     GIR_RootConstrainSelectedInstOperands,
     /* 181648 */     // GIR_Coverage, 3922,
     /* 181648 */     GIR_EraseRootFromParent_Done,
     /* 181649 */   // Label 3539: @181649
     /* 181649 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181691), // Rule ID 5192 //
     /* 181654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 181659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181680 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 181683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181689 */     GIR_RootConstrainSelectedInstOperands,
     /* 181690 */     // GIR_Coverage, 5192,
     /* 181690 */     GIR_EraseRootFromParent_Done,
     /* 181691 */   // Label 3540: @181691
     /* 181691 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(181736), // Rule ID 5196 //
     /* 181696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 181704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181725 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 181728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181734 */     GIR_RootConstrainSelectedInstOperands,
     /* 181735 */     // GIR_Coverage, 5196,
     /* 181735 */     GIR_EraseRootFromParent_Done,
     /* 181736 */   // Label 3541: @181736
     /* 181736 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(181781), // Rule ID 5200 //
     /* 181741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 181749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181770 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 181773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181779 */     GIR_RootConstrainSelectedInstOperands,
     /* 181780 */     // GIR_Coverage, 5200,
     /* 181780 */     GIR_EraseRootFromParent_Done,
     /* 181781 */   // Label 3542: @181781
     /* 181781 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(181826), // Rule ID 5201 //
     /* 181786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 181794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181815 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 181818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181824 */     GIR_RootConstrainSelectedInstOperands,
     /* 181825 */     // GIR_Coverage, 5201,
     /* 181825 */     GIR_EraseRootFromParent_Done,
     /* 181826 */   // Label 3543: @181826
     /* 181826 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(181871), // Rule ID 5202 //
     /* 181831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 181839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181860 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 181860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 181863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181869 */     GIR_RootConstrainSelectedInstOperands,
     /* 181870 */     // GIR_Coverage, 5202,
     /* 181870 */     GIR_EraseRootFromParent_Done,
     /* 181871 */   // Label 3544: @181871
     /* 181871 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(181916), // Rule ID 5203 //
     /* 181876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181905 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 181908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181914 */     GIR_RootConstrainSelectedInstOperands,
     /* 181915 */     // GIR_Coverage, 5203,
     /* 181915 */     GIR_EraseRootFromParent_Done,
     /* 181916 */   // Label 3545: @181916
     /* 181916 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(181961), // Rule ID 5204 //
     /* 181921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 181929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181950 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 181950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 181953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181959 */     GIR_RootConstrainSelectedInstOperands,
     /* 181960 */     // GIR_Coverage, 5204,
     /* 181960 */     GIR_EraseRootFromParent_Done,
     /* 181961 */   // Label 3546: @181961
     /* 181961 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182006), // Rule ID 5205 //
     /* 181966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 181974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 181983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181995 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 181995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 181998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182004 */     GIR_RootConstrainSelectedInstOperands,
     /* 182005 */     // GIR_Coverage, 5205,
     /* 182005 */     GIR_EraseRootFromParent_Done,
     /* 182006 */   // Label 3547: @182006
     /* 182006 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182051), // Rule ID 5206 //
     /* 182011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182040 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 182043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182049 */     GIR_RootConstrainSelectedInstOperands,
     /* 182050 */     // GIR_Coverage, 5206,
     /* 182050 */     GIR_EraseRootFromParent_Done,
     /* 182051 */   // Label 3548: @182051
     /* 182051 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182096), // Rule ID 5207 //
     /* 182056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182085 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 182088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182094 */     GIR_RootConstrainSelectedInstOperands,
     /* 182095 */     // GIR_Coverage, 5207,
     /* 182095 */     GIR_EraseRootFromParent_Done,
     /* 182096 */   // Label 3549: @182096
     /* 182096 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182141), // Rule ID 5208 //
     /* 182101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182130 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 182133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182139 */     GIR_RootConstrainSelectedInstOperands,
     /* 182140 */     // GIR_Coverage, 5208,
     /* 182140 */     GIR_EraseRootFromParent_Done,
     /* 182141 */   // Label 3550: @182141
     /* 182141 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182186), // Rule ID 5209 //
     /* 182146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182175 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 182178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182184 */     GIR_RootConstrainSelectedInstOperands,
     /* 182185 */     // GIR_Coverage, 5209,
     /* 182185 */     GIR_EraseRootFromParent_Done,
     /* 182186 */   // Label 3551: @182186
     /* 182186 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182231), // Rule ID 5210 //
     /* 182191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182220 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 182223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182229 */     GIR_RootConstrainSelectedInstOperands,
     /* 182230 */     // GIR_Coverage, 5210,
     /* 182230 */     GIR_EraseRootFromParent_Done,
     /* 182231 */   // Label 3552: @182231
     /* 182231 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(182276), // Rule ID 5211 //
     /* 182236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182265 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 182268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182274 */     GIR_RootConstrainSelectedInstOperands,
     /* 182275 */     // GIR_Coverage, 5211,
     /* 182275 */     GIR_EraseRootFromParent_Done,
     /* 182276 */   // Label 3553: @182276
     /* 182276 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(182321), // Rule ID 5212 //
     /* 182281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182310 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 182313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182319 */     GIR_RootConstrainSelectedInstOperands,
     /* 182320 */     // GIR_Coverage, 5212,
     /* 182320 */     GIR_EraseRootFromParent_Done,
     /* 182321 */   // Label 3554: @182321
     /* 182321 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182366), // Rule ID 5213 //
     /* 182326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182355 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 182358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182364 */     GIR_RootConstrainSelectedInstOperands,
     /* 182365 */     // GIR_Coverage, 5213,
     /* 182365 */     GIR_EraseRootFromParent_Done,
     /* 182366 */   // Label 3555: @182366
     /* 182366 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182411), // Rule ID 5214 //
     /* 182371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182400 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 182403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182409 */     GIR_RootConstrainSelectedInstOperands,
     /* 182410 */     // GIR_Coverage, 5214,
     /* 182410 */     GIR_EraseRootFromParent_Done,
     /* 182411 */   // Label 3556: @182411
     /* 182411 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182456), // Rule ID 5215 //
     /* 182416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 182424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182445 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 182448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182454 */     GIR_RootConstrainSelectedInstOperands,
     /* 182455 */     // GIR_Coverage, 5215,
     /* 182455 */     GIR_EraseRootFromParent_Done,
     /* 182456 */   // Label 3557: @182456
     /* 182456 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182501), // Rule ID 5216 //
     /* 182461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 182469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182490 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 182493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182499 */     GIR_RootConstrainSelectedInstOperands,
     /* 182500 */     // GIR_Coverage, 5216,
     /* 182500 */     GIR_EraseRootFromParent_Done,
     /* 182501 */   // Label 3558: @182501
     /* 182501 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182546), // Rule ID 5235 //
     /* 182506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 182514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182535 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 182535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 182538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182544 */     GIR_RootConstrainSelectedInstOperands,
     /* 182545 */     // GIR_Coverage, 5235,
     /* 182545 */     GIR_EraseRootFromParent_Done,
     /* 182546 */   // Label 3559: @182546
     /* 182546 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182588), // Rule ID 5569 //
     /* 182551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 182556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 182559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 182562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 182565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182577 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 182577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 182580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 182582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 182586 */     GIR_RootConstrainSelectedInstOperands,
     /* 182587 */     // GIR_Coverage, 5569,
     /* 182587 */     GIR_EraseRootFromParent_Done,
     /* 182588 */   // Label 3560: @182588
     /* 182588 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182630), // Rule ID 5570 //
     /* 182593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 182598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 182601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 182604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 182607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182619 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 182619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 182622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 182624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 182626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 182628 */     GIR_RootConstrainSelectedInstOperands,
     /* 182629 */     // GIR_Coverage, 5570,
     /* 182629 */     GIR_EraseRootFromParent_Done,
     /* 182630 */   // Label 3561: @182630
     /* 182630 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(182727), // Rule ID 6257 //
     /* 182635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 182640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 182649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182661 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 182661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 182668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182673 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182677 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 182681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182726 */     // GIR_Coverage, 6257,
     /* 182726 */     GIR_EraseRootFromParent_Done,
     /* 182727 */   // Label 3562: @182727
     /* 182727 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(182824), // Rule ID 6258 //
     /* 182732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 182737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 182746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182758 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 182758 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182761 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 182765 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182770 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182774 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 182778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182823 */     // GIR_Coverage, 6258,
     /* 182823 */     GIR_EraseRootFromParent_Done,
     /* 182824 */   // Label 3563: @182824
     /* 182824 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(182866), // Rule ID 6903 //
     /* 182829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 182834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182855 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 182858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182864 */     GIR_RootConstrainSelectedInstOperands,
     /* 182865 */     // GIR_Coverage, 6903,
     /* 182865 */     GIR_EraseRootFromParent_Done,
     /* 182866 */   // Label 3564: @182866
     /* 182866 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(182908), // Rule ID 6904 //
     /* 182871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 182876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182897 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 182900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182906 */     GIR_RootConstrainSelectedInstOperands,
     /* 182907 */     // GIR_Coverage, 6904,
     /* 182907 */     GIR_EraseRootFromParent_Done,
     /* 182908 */   // Label 3565: @182908
     /* 182908 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(182950), // Rule ID 6905 //
     /* 182913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 182918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182939 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 182942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182948 */     GIR_RootConstrainSelectedInstOperands,
     /* 182949 */     // GIR_Coverage, 6905,
     /* 182949 */     GIR_EraseRootFromParent_Done,
     /* 182950 */   // Label 3566: @182950
     /* 182950 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(182992), // Rule ID 6906 //
     /* 182955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 182960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182981 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 182984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182990 */     GIR_RootConstrainSelectedInstOperands,
     /* 182991 */     // GIR_Coverage, 6906,
     /* 182991 */     GIR_EraseRootFromParent_Done,
     /* 182992 */   // Label 3567: @182992
     /* 182992 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183040), // Rule ID 6946 //
     /* 182997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183023 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 183023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 183026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 183035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 183038 */     GIR_RootConstrainSelectedInstOperands,
     /* 183039 */     // GIR_Coverage, 6946,
     /* 183039 */     GIR_EraseRootFromParent_Done,
     /* 183040 */   // Label 3568: @183040
     /* 183040 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183085), // Rule ID 9968 //
     /* 183045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183074 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 183077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183083 */     GIR_RootConstrainSelectedInstOperands,
     /* 183084 */     // GIR_Coverage, 9968,
     /* 183084 */     GIR_EraseRootFromParent_Done,
     /* 183085 */   // Label 3569: @183085
     /* 183085 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183130), // Rule ID 9969 //
     /* 183090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183119 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 183122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183128 */     GIR_RootConstrainSelectedInstOperands,
     /* 183129 */     // GIR_Coverage, 9969,
     /* 183129 */     GIR_EraseRootFromParent_Done,
     /* 183130 */   // Label 3570: @183130
     /* 183130 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183175), // Rule ID 9970 //
     /* 183135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183164 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 183167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183173 */     GIR_RootConstrainSelectedInstOperands,
     /* 183174 */     // GIR_Coverage, 9970,
     /* 183174 */     GIR_EraseRootFromParent_Done,
     /* 183175 */   // Label 3571: @183175
     /* 183175 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183220), // Rule ID 9971 //
     /* 183180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183209 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 183212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183218 */     GIR_RootConstrainSelectedInstOperands,
     /* 183219 */     // GIR_Coverage, 9971,
     /* 183219 */     GIR_EraseRootFromParent_Done,
     /* 183220 */   // Label 3572: @183220
     /* 183220 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(183265), // Rule ID 9980 //
     /* 183225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183254 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 183257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183263 */     GIR_RootConstrainSelectedInstOperands,
     /* 183264 */     // GIR_Coverage, 9980,
     /* 183264 */     GIR_EraseRootFromParent_Done,
     /* 183265 */   // Label 3573: @183265
     /* 183265 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(183310), // Rule ID 9981 //
     /* 183270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183299 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 183302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183308 */     GIR_RootConstrainSelectedInstOperands,
     /* 183309 */     // GIR_Coverage, 9981,
     /* 183309 */     GIR_EraseRootFromParent_Done,
     /* 183310 */   // Label 3574: @183310
     /* 183310 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(183355), // Rule ID 9982 //
     /* 183315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183344 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 183347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183353 */     GIR_RootConstrainSelectedInstOperands,
     /* 183354 */     // GIR_Coverage, 9982,
     /* 183354 */     GIR_EraseRootFromParent_Done,
     /* 183355 */   // Label 3575: @183355
     /* 183355 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(183400), // Rule ID 9983 //
     /* 183360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183389 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 183392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183398 */     GIR_RootConstrainSelectedInstOperands,
     /* 183399 */     // GIR_Coverage, 9983,
     /* 183399 */     GIR_EraseRootFromParent_Done,
     /* 183400 */   // Label 3576: @183400
     /* 183400 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183445), // Rule ID 9984 //
     /* 183405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183434 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183443 */     GIR_RootConstrainSelectedInstOperands,
     /* 183444 */     // GIR_Coverage, 9984,
     /* 183444 */     GIR_EraseRootFromParent_Done,
     /* 183445 */   // Label 3577: @183445
     /* 183445 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183490), // Rule ID 9985 //
     /* 183450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183479 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 183482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183488 */     GIR_RootConstrainSelectedInstOperands,
     /* 183489 */     // GIR_Coverage, 9985,
     /* 183489 */     GIR_EraseRootFromParent_Done,
     /* 183490 */   // Label 3578: @183490
     /* 183490 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183535), // Rule ID 9986 //
     /* 183495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183524 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 183527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183533 */     GIR_RootConstrainSelectedInstOperands,
     /* 183534 */     // GIR_Coverage, 9986,
     /* 183534 */     GIR_EraseRootFromParent_Done,
     /* 183535 */   // Label 3579: @183535
     /* 183535 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183580), // Rule ID 9987 //
     /* 183540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183569 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 183572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183578 */     GIR_RootConstrainSelectedInstOperands,
     /* 183579 */     // GIR_Coverage, 9987,
     /* 183579 */     GIR_EraseRootFromParent_Done,
     /* 183580 */   // Label 3580: @183580
     /* 183580 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183625), // Rule ID 9988 //
     /* 183585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183614 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 183617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183623 */     GIR_RootConstrainSelectedInstOperands,
     /* 183624 */     // GIR_Coverage, 9988,
     /* 183624 */     GIR_EraseRootFromParent_Done,
     /* 183625 */   // Label 3581: @183625
     /* 183625 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183670), // Rule ID 9989 //
     /* 183630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183659 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 183662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183668 */     GIR_RootConstrainSelectedInstOperands,
     /* 183669 */     // GIR_Coverage, 9989,
     /* 183669 */     GIR_EraseRootFromParent_Done,
     /* 183670 */   // Label 3582: @183670
     /* 183670 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183715), // Rule ID 9990 //
     /* 183675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183704 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 183707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183713 */     GIR_RootConstrainSelectedInstOperands,
     /* 183714 */     // GIR_Coverage, 9990,
     /* 183714 */     GIR_EraseRootFromParent_Done,
     /* 183715 */   // Label 3583: @183715
     /* 183715 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(183760), // Rule ID 9991 //
     /* 183720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 183728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183749 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 183752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183758 */     GIR_RootConstrainSelectedInstOperands,
     /* 183759 */     // GIR_Coverage, 9991,
     /* 183759 */     GIR_EraseRootFromParent_Done,
     /* 183760 */   // Label 3584: @183760
     /* 183760 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(183806), // Rule ID 138 //
     /* 183765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 183773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183783 */     // MIs[0] Rn
     /* 183783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183795 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 183795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 183798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183804 */     GIR_RootConstrainSelectedInstOperands,
     /* 183805 */     // GIR_Coverage, 138,
     /* 183805 */     GIR_EraseRootFromParent_Done,
     /* 183806 */   // Label 3585: @183806
     /* 183806 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(183853), // Rule ID 139 //
     /* 183811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 183814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 183819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183826 */     // MIs[0] Rn
     /* 183826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 183830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183834 */     // MIs[0] Rm
     /* 183834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 183838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 183842 */     // (intrinsic_wo_chain:{ *:[i64] } 1228:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 183842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 183845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183851 */     GIR_RootConstrainSelectedInstOperands,
     /* 183852 */     // GIR_Coverage, 139,
     /* 183852 */     GIR_EraseRootFromParent_Done,
     /* 183853 */   // Label 3586: @183853
     /* 183853 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(183890), // Rule ID 2399 //
     /* 183858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 183866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183879 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2137:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 183882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183888 */     GIR_RootConstrainSelectedInstOperands,
     /* 183889 */     // GIR_Coverage, 2399,
     /* 183889 */     GIR_EraseRootFromParent_Done,
     /* 183890 */   // Label 3587: @183890
     /* 183890 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(183927), // Rule ID 2400 //
     /* 183895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 183903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183916 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 183919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183925 */     GIR_RootConstrainSelectedInstOperands,
     /* 183926 */     // GIR_Coverage, 2400,
     /* 183926 */     GIR_EraseRootFromParent_Done,
     /* 183927 */   // Label 3588: @183927
     /* 183927 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(183964), // Rule ID 2401 //
     /* 183932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 183940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183953 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 183956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183962 */     GIR_RootConstrainSelectedInstOperands,
     /* 183963 */     // GIR_Coverage, 2401,
     /* 183963 */     GIR_EraseRootFromParent_Done,
     /* 183964 */   // Label 3589: @183964
     /* 183964 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184001), // Rule ID 2403 //
     /* 183969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 183977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 183980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 183983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183990 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 183990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 183993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 183995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 183997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 183999 */     GIR_RootConstrainSelectedInstOperands,
     /* 184000 */     // GIR_Coverage, 2403,
     /* 184000 */     GIR_EraseRootFromParent_Done,
     /* 184001 */   // Label 3590: @184001
     /* 184001 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184038), // Rule ID 2404 //
     /* 184006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 184014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184027 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2143:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 184030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184036 */     GIR_RootConstrainSelectedInstOperands,
     /* 184037 */     // GIR_Coverage, 2404,
     /* 184037 */     GIR_EraseRootFromParent_Done,
     /* 184038 */   // Label 3591: @184038
     /* 184038 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184075), // Rule ID 2405 //
     /* 184043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 184051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184064 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2144:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 184067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184073 */     GIR_RootConstrainSelectedInstOperands,
     /* 184074 */     // GIR_Coverage, 2405,
     /* 184074 */     GIR_EraseRootFromParent_Done,
     /* 184075 */   // Label 3592: @184075
     /* 184075 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184112), // Rule ID 2407 //
     /* 184080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 184088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184101 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 184104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184110 */     GIR_RootConstrainSelectedInstOperands,
     /* 184111 */     // GIR_Coverage, 2407,
     /* 184111 */     GIR_EraseRootFromParent_Done,
     /* 184112 */   // Label 3593: @184112
     /* 184112 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184149), // Rule ID 2408 //
     /* 184117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 184125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184138 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2064:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 184141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184147 */     GIR_RootConstrainSelectedInstOperands,
     /* 184148 */     // GIR_Coverage, 2408,
     /* 184148 */     GIR_EraseRootFromParent_Done,
     /* 184149 */   // Label 3594: @184149
     /* 184149 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184186), // Rule ID 2409 //
     /* 184154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 184162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184175 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2065:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 184178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184184 */     GIR_RootConstrainSelectedInstOperands,
     /* 184185 */     // GIR_Coverage, 2409,
     /* 184185 */     GIR_EraseRootFromParent_Done,
     /* 184186 */   // Label 3595: @184186
     /* 184186 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184223), // Rule ID 2411 //
     /* 184191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 184199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2068:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 184215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184221 */     GIR_RootConstrainSelectedInstOperands,
     /* 184222 */     // GIR_Coverage, 2411,
     /* 184222 */     GIR_EraseRootFromParent_Done,
     /* 184223 */   // Label 3596: @184223
     /* 184223 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(184260), // Rule ID 2412 //
     /* 184228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 184236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184249 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2069:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 184252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184258 */     GIR_RootConstrainSelectedInstOperands,
     /* 184259 */     // GIR_Coverage, 2412,
     /* 184259 */     GIR_EraseRootFromParent_Done,
     /* 184260 */   // Label 3597: @184260
     /* 184260 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(184297), // Rule ID 2413 //
     /* 184265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 184273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184286 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2070:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 184289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184295 */     GIR_RootConstrainSelectedInstOperands,
     /* 184296 */     // GIR_Coverage, 2413,
     /* 184296 */     GIR_EraseRootFromParent_Done,
     /* 184297 */   // Label 3598: @184297
     /* 184297 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(184334), // Rule ID 2415 //
     /* 184302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 184310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184323 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1907:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 184326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184332 */     GIR_RootConstrainSelectedInstOperands,
     /* 184333 */     // GIR_Coverage, 2415,
     /* 184333 */     GIR_EraseRootFromParent_Done,
     /* 184334 */   // Label 3599: @184334
     /* 184334 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(184371), // Rule ID 2416 //
     /* 184339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 184347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184360 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1908:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 184363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184369 */     GIR_RootConstrainSelectedInstOperands,
     /* 184370 */     // GIR_Coverage, 2416,
     /* 184370 */     GIR_EraseRootFromParent_Done,
     /* 184371 */   // Label 3600: @184371
     /* 184371 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(184408), // Rule ID 2417 //
     /* 184376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 184384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184397 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1909:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 184400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184406 */     GIR_RootConstrainSelectedInstOperands,
     /* 184407 */     // GIR_Coverage, 2417,
     /* 184407 */     GIR_EraseRootFromParent_Done,
     /* 184408 */   // Label 3601: @184408
     /* 184408 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(184445), // Rule ID 2419 //
     /* 184413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 184421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184434 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1912:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 184437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184443 */     GIR_RootConstrainSelectedInstOperands,
     /* 184444 */     // GIR_Coverage, 2419,
     /* 184444 */     GIR_EraseRootFromParent_Done,
     /* 184445 */   // Label 3602: @184445
     /* 184445 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184482), // Rule ID 2420 //
     /* 184450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 184458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184471 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1913:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 184474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184480 */     GIR_RootConstrainSelectedInstOperands,
     /* 184481 */     // GIR_Coverage, 2420,
     /* 184481 */     GIR_EraseRootFromParent_Done,
     /* 184482 */   // Label 3603: @184482
     /* 184482 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184519), // Rule ID 2421 //
     /* 184487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 184495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184508 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1914:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 184511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184517 */     GIR_RootConstrainSelectedInstOperands,
     /* 184518 */     // GIR_Coverage, 2421,
     /* 184518 */     GIR_EraseRootFromParent_Done,
     /* 184519 */   // Label 3604: @184519
     /* 184519 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184556), // Rule ID 2422 //
     /* 184524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 184527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 184532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 184541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184545 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1532:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 184545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 184548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 184552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 184554 */     GIR_RootConstrainSelectedInstOperands,
     /* 184555 */     // GIR_Coverage, 2422,
     /* 184555 */     GIR_EraseRootFromParent_Done,
     /* 184556 */   // Label 3605: @184556
     /* 184556 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184596), // Rule ID 2621 //
     /* 184561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 184569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 184585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184594 */     GIR_RootConstrainSelectedInstOperands,
     /* 184595 */     // GIR_Coverage, 2621,
     /* 184595 */     GIR_EraseRootFromParent_Done,
     /* 184596 */   // Label 3606: @184596
     /* 184596 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184636), // Rule ID 2622 //
     /* 184601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1619:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 184625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184634 */     GIR_RootConstrainSelectedInstOperands,
     /* 184635 */     // GIR_Coverage, 2622,
     /* 184635 */     GIR_EraseRootFromParent_Done,
     /* 184636 */   // Label 3607: @184636
     /* 184636 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184676), // Rule ID 2623 //
     /* 184641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 184652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 184655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1619:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 184665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184674 */     GIR_RootConstrainSelectedInstOperands,
     /* 184675 */     // GIR_Coverage, 2623,
     /* 184675 */     GIR_EraseRootFromParent_Done,
     /* 184676 */   // Label 3608: @184676
     /* 184676 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184716), // Rule ID 2624 //
     /* 184681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 184692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 184695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184702 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1619:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 184705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184714 */     GIR_RootConstrainSelectedInstOperands,
     /* 184715 */     // GIR_Coverage, 2624,
     /* 184715 */     GIR_EraseRootFromParent_Done,
     /* 184716 */   // Label 3609: @184716
     /* 184716 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(184756), // Rule ID 2625 //
     /* 184721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 184729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 184732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 184735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1619:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 184745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 184747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 184754 */     GIR_RootConstrainSelectedInstOperands,
     /* 184755 */     // GIR_Coverage, 2625,
     /* 184755 */     GIR_EraseRootFromParent_Done,
     /* 184756 */   // Label 3610: @184756
     /* 184756 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(184793), // Rule ID 2642 //
     /* 184761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 184785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184791 */     GIR_RootConstrainSelectedInstOperands,
     /* 184792 */     // GIR_Coverage, 2642,
     /* 184792 */     GIR_EraseRootFromParent_Done,
     /* 184793 */   // Label 3611: @184793
     /* 184793 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(184830), // Rule ID 2643 //
     /* 184798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 184822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184828 */     GIR_RootConstrainSelectedInstOperands,
     /* 184829 */     // GIR_Coverage, 2643,
     /* 184829 */     GIR_EraseRootFromParent_Done,
     /* 184830 */   // Label 3612: @184830
     /* 184830 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(184867), // Rule ID 2644 //
     /* 184835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 184843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184856 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 184856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 184859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 184861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184865 */     GIR_RootConstrainSelectedInstOperands,
     /* 184866 */     // GIR_Coverage, 2644,
     /* 184866 */     GIR_EraseRootFromParent_Done,
     /* 184867 */   // Label 3613: @184867
     /* 184867 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(184904), // Rule ID 2645 //
     /* 184872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184893 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 184893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 184896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184902 */     GIR_RootConstrainSelectedInstOperands,
     /* 184903 */     // GIR_Coverage, 2645,
     /* 184903 */     GIR_EraseRootFromParent_Done,
     /* 184904 */   // Label 3614: @184904
     /* 184904 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(184941), // Rule ID 2646 //
     /* 184909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 184923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184930 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 184930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 184933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184939 */     GIR_RootConstrainSelectedInstOperands,
     /* 184940 */     // GIR_Coverage, 2646,
     /* 184940 */     GIR_EraseRootFromParent_Done,
     /* 184941 */   // Label 3615: @184941
     /* 184941 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(184978), // Rule ID 2647 //
     /* 184946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 184960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184967 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 184967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 184970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184976 */     GIR_RootConstrainSelectedInstOperands,
     /* 184977 */     // GIR_Coverage, 2647,
     /* 184977 */     GIR_EraseRootFromParent_Done,
     /* 184978 */   // Label 3616: @184978
     /* 184978 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185015), // Rule ID 2648 //
     /* 184983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 184991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 184997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185004 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 185007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185013 */     GIR_RootConstrainSelectedInstOperands,
     /* 185014 */     // GIR_Coverage, 2648,
     /* 185014 */     GIR_EraseRootFromParent_Done,
     /* 185015 */   // Label 3617: @185015
     /* 185015 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185052), // Rule ID 2826 //
     /* 185020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185041 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1529:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 185044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185050 */     GIR_RootConstrainSelectedInstOperands,
     /* 185051 */     // GIR_Coverage, 2826,
     /* 185051 */     GIR_EraseRootFromParent_Done,
     /* 185052 */   // Label 3618: @185052
     /* 185052 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185089), // Rule ID 2827 //
     /* 185057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185078 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1529:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 185081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185087 */     GIR_RootConstrainSelectedInstOperands,
     /* 185088 */     // GIR_Coverage, 2827,
     /* 185088 */     GIR_EraseRootFromParent_Done,
     /* 185089 */   // Label 3619: @185089
     /* 185089 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185126), // Rule ID 2828 //
     /* 185094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185115 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1529:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 185118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185124 */     GIR_RootConstrainSelectedInstOperands,
     /* 185125 */     // GIR_Coverage, 2828,
     /* 185125 */     GIR_EraseRootFromParent_Done,
     /* 185126 */   // Label 3620: @185126
     /* 185126 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185163), // Rule ID 2999 //
     /* 185131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1781:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 185155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185161 */     GIR_RootConstrainSelectedInstOperands,
     /* 185162 */     // GIR_Coverage, 2999,
     /* 185162 */     GIR_EraseRootFromParent_Done,
     /* 185163 */   // Label 3621: @185163
     /* 185163 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185200), // Rule ID 3000 //
     /* 185168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1781:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 185192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185198 */     GIR_RootConstrainSelectedInstOperands,
     /* 185199 */     // GIR_Coverage, 3000,
     /* 185199 */     GIR_EraseRootFromParent_Done,
     /* 185200 */   // Label 3622: @185200
     /* 185200 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(185237), // Rule ID 3001 //
     /* 185205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1781:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 185229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185235 */     GIR_RootConstrainSelectedInstOperands,
     /* 185236 */     // GIR_Coverage, 3001,
     /* 185236 */     GIR_EraseRootFromParent_Done,
     /* 185237 */   // Label 3623: @185237
     /* 185237 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(185274), // Rule ID 3002 //
     /* 185242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185263 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1781:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 185266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185272 */     GIR_RootConstrainSelectedInstOperands,
     /* 185273 */     // GIR_Coverage, 3002,
     /* 185273 */     GIR_EraseRootFromParent_Done,
     /* 185274 */   // Label 3624: @185274
     /* 185274 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(185311), // Rule ID 3003 //
     /* 185279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 185287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185300 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 185303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185309 */     GIR_RootConstrainSelectedInstOperands,
     /* 185310 */     // GIR_Coverage, 3003,
     /* 185310 */     GIR_EraseRootFromParent_Done,
     /* 185311 */   // Label 3625: @185311
     /* 185311 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(185348), // Rule ID 3025 //
     /* 185316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1674:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 185340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185346 */     GIR_RootConstrainSelectedInstOperands,
     /* 185347 */     // GIR_Coverage, 3025,
     /* 185347 */     GIR_EraseRootFromParent_Done,
     /* 185348 */   // Label 3626: @185348
     /* 185348 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(185385), // Rule ID 3026 //
     /* 185353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1674:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 185377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185383 */     GIR_RootConstrainSelectedInstOperands,
     /* 185384 */     // GIR_Coverage, 3026,
     /* 185384 */     GIR_EraseRootFromParent_Done,
     /* 185385 */   // Label 3627: @185385
     /* 185385 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(185422), // Rule ID 3027 //
     /* 185390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 185414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185420 */     GIR_RootConstrainSelectedInstOperands,
     /* 185421 */     // GIR_Coverage, 3027,
     /* 185421 */     GIR_EraseRootFromParent_Done,
     /* 185422 */   // Label 3628: @185422
     /* 185422 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185459), // Rule ID 3031 //
     /* 185427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 185430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 185451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185457 */     GIR_RootConstrainSelectedInstOperands,
     /* 185458 */     // GIR_Coverage, 3031,
     /* 185458 */     GIR_EraseRootFromParent_Done,
     /* 185459 */   // Label 3629: @185459
     /* 185459 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(185496), // Rule ID 3032 //
     /* 185464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185485 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 185488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185494 */     GIR_RootConstrainSelectedInstOperands,
     /* 185495 */     // GIR_Coverage, 3032,
     /* 185495 */     GIR_EraseRootFromParent_Done,
     /* 185496 */   // Label 3630: @185496
     /* 185496 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(185533), // Rule ID 3033 //
     /* 185501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 185525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185531 */     GIR_RootConstrainSelectedInstOperands,
     /* 185532 */     // GIR_Coverage, 3033,
     /* 185532 */     GIR_EraseRootFromParent_Done,
     /* 185533 */   // Label 3631: @185533
     /* 185533 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(185570), // Rule ID 3034 //
     /* 185538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 185562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185568 */     GIR_RootConstrainSelectedInstOperands,
     /* 185569 */     // GIR_Coverage, 3034,
     /* 185569 */     GIR_EraseRootFromParent_Done,
     /* 185570 */   // Label 3632: @185570
     /* 185570 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(185607), // Rule ID 3035 //
     /* 185575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185596 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1259:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 185599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185605 */     GIR_RootConstrainSelectedInstOperands,
     /* 185606 */     // GIR_Coverage, 3035,
     /* 185606 */     GIR_EraseRootFromParent_Done,
     /* 185607 */   // Label 3633: @185607
     /* 185607 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(185644), // Rule ID 3036 //
     /* 185612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185633 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 185636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185642 */     GIR_RootConstrainSelectedInstOperands,
     /* 185643 */     // GIR_Coverage, 3036,
     /* 185643 */     GIR_EraseRootFromParent_Done,
     /* 185644 */   // Label 3634: @185644
     /* 185644 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(185681), // Rule ID 3037 //
     /* 185649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 185652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 185657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1259:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 185673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185679 */     GIR_RootConstrainSelectedInstOperands,
     /* 185680 */     // GIR_Coverage, 3037,
     /* 185680 */     GIR_EraseRootFromParent_Done,
     /* 185681 */   // Label 3635: @185681
     /* 185681 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(185718), // Rule ID 3038 //
     /* 185686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1675:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 185710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185716 */     GIR_RootConstrainSelectedInstOperands,
     /* 185717 */     // GIR_Coverage, 3038,
     /* 185717 */     GIR_EraseRootFromParent_Done,
     /* 185718 */   // Label 3636: @185718
     /* 185718 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(185755), // Rule ID 3039 //
     /* 185723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1675:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 185747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185753 */     GIR_RootConstrainSelectedInstOperands,
     /* 185754 */     // GIR_Coverage, 3039,
     /* 185754 */     GIR_EraseRootFromParent_Done,
     /* 185755 */   // Label 3637: @185755
     /* 185755 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(185792), // Rule ID 3040 //
     /* 185760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 185768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185781 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1675:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 185784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185790 */     GIR_RootConstrainSelectedInstOperands,
     /* 185791 */     // GIR_Coverage, 3040,
     /* 185791 */     GIR_EraseRootFromParent_Done,
     /* 185792 */   // Label 3638: @185792
     /* 185792 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(185829), // Rule ID 3087 //
     /* 185797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 185821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185827 */     GIR_RootConstrainSelectedInstOperands,
     /* 185828 */     // GIR_Coverage, 3087,
     /* 185828 */     GIR_EraseRootFromParent_Done,
     /* 185829 */   // Label 3639: @185829
     /* 185829 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(185866), // Rule ID 3088 //
     /* 185834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 185858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185864 */     GIR_RootConstrainSelectedInstOperands,
     /* 185865 */     // GIR_Coverage, 3088,
     /* 185865 */     GIR_EraseRootFromParent_Done,
     /* 185866 */   // Label 3640: @185866
     /* 185866 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(185903), // Rule ID 3089 //
     /* 185871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 185879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 185895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185901 */     GIR_RootConstrainSelectedInstOperands,
     /* 185902 */     // GIR_Coverage, 3089,
     /* 185902 */     GIR_EraseRootFromParent_Done,
     /* 185903 */   // Label 3641: @185903
     /* 185903 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(185940), // Rule ID 3096 //
     /* 185908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185929 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1838:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 185932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185938 */     GIR_RootConstrainSelectedInstOperands,
     /* 185939 */     // GIR_Coverage, 3096,
     /* 185939 */     GIR_EraseRootFromParent_Done,
     /* 185940 */   // Label 3642: @185940
     /* 185940 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(185977), // Rule ID 3097 //
     /* 185945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 185969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185975 */     GIR_RootConstrainSelectedInstOperands,
     /* 185976 */     // GIR_Coverage, 3097,
     /* 185976 */     GIR_EraseRootFromParent_Done,
     /* 185977 */   // Label 3643: @185977
     /* 185977 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186014), // Rule ID 3098 //
     /* 185982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 185990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186003 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 186006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186012 */     GIR_RootConstrainSelectedInstOperands,
     /* 186013 */     // GIR_Coverage, 3098,
     /* 186013 */     GIR_EraseRootFromParent_Done,
     /* 186014 */   // Label 3644: @186014
     /* 186014 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186054), // Rule ID 3202 //
     /* 186019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 186043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186052 */     GIR_RootConstrainSelectedInstOperands,
     /* 186053 */     // GIR_Coverage, 3202,
     /* 186053 */     GIR_EraseRootFromParent_Done,
     /* 186054 */   // Label 3645: @186054
     /* 186054 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186094), // Rule ID 3203 //
     /* 186059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 186083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186092 */     GIR_RootConstrainSelectedInstOperands,
     /* 186093 */     // GIR_Coverage, 3203,
     /* 186093 */     GIR_EraseRootFromParent_Done,
     /* 186094 */   // Label 3646: @186094
     /* 186094 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186134), // Rule ID 3204 //
     /* 186099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186120 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 186123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186132 */     GIR_RootConstrainSelectedInstOperands,
     /* 186133 */     // GIR_Coverage, 3204,
     /* 186133 */     GIR_EraseRootFromParent_Done,
     /* 186134 */   // Label 3647: @186134
     /* 186134 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186174), // Rule ID 3205 //
     /* 186139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186160 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 186163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186172 */     GIR_RootConstrainSelectedInstOperands,
     /* 186173 */     // GIR_Coverage, 3205,
     /* 186173 */     GIR_EraseRootFromParent_Done,
     /* 186174 */   // Label 3648: @186174
     /* 186174 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186214), // Rule ID 3210 //
     /* 186179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 186203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186212 */     GIR_RootConstrainSelectedInstOperands,
     /* 186213 */     // GIR_Coverage, 3210,
     /* 186213 */     GIR_EraseRootFromParent_Done,
     /* 186214 */   // Label 3649: @186214
     /* 186214 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(186254), // Rule ID 3211 //
     /* 186219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 186243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186252 */     GIR_RootConstrainSelectedInstOperands,
     /* 186253 */     // GIR_Coverage, 3211,
     /* 186253 */     GIR_EraseRootFromParent_Done,
     /* 186254 */   // Label 3650: @186254
     /* 186254 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(186294), // Rule ID 3212 //
     /* 186259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 186283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186292 */     GIR_RootConstrainSelectedInstOperands,
     /* 186293 */     // GIR_Coverage, 3212,
     /* 186293 */     GIR_EraseRootFromParent_Done,
     /* 186294 */   // Label 3651: @186294
     /* 186294 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(186334), // Rule ID 3213 //
     /* 186299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186320 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 186323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186332 */     GIR_RootConstrainSelectedInstOperands,
     /* 186333 */     // GIR_Coverage, 3213,
     /* 186333 */     GIR_EraseRootFromParent_Done,
     /* 186334 */   // Label 3652: @186334
     /* 186334 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(186371), // Rule ID 3402 //
     /* 186339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186369 */     GIR_RootConstrainSelectedInstOperands,
     /* 186370 */     // GIR_Coverage, 3402,
     /* 186370 */     GIR_EraseRootFromParent_Done,
     /* 186371 */   // Label 3653: @186371
     /* 186371 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(186408), // Rule ID 3403 //
     /* 186376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186397 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186406 */     GIR_RootConstrainSelectedInstOperands,
     /* 186407 */     // GIR_Coverage, 3403,
     /* 186407 */     GIR_EraseRootFromParent_Done,
     /* 186408 */   // Label 3654: @186408
     /* 186408 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(186445), // Rule ID 3404 //
     /* 186413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 186437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186443 */     GIR_RootConstrainSelectedInstOperands,
     /* 186444 */     // GIR_Coverage, 3404,
     /* 186444 */     GIR_EraseRootFromParent_Done,
     /* 186445 */   // Label 3655: @186445
     /* 186445 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(186482), // Rule ID 3405 //
     /* 186450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186471 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 186474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186480 */     GIR_RootConstrainSelectedInstOperands,
     /* 186481 */     // GIR_Coverage, 3405,
     /* 186481 */     GIR_EraseRootFromParent_Done,
     /* 186482 */   // Label 3656: @186482
     /* 186482 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(186519), // Rule ID 3427 //
     /* 186487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1530:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 186511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186517 */     GIR_RootConstrainSelectedInstOperands,
     /* 186518 */     // GIR_Coverage, 3427,
     /* 186518 */     GIR_EraseRootFromParent_Done,
     /* 186519 */   // Label 3657: @186519
     /* 186519 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(186556), // Rule ID 3428 //
     /* 186524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186545 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1530:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 186548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186554 */     GIR_RootConstrainSelectedInstOperands,
     /* 186555 */     // GIR_Coverage, 3428,
     /* 186555 */     GIR_EraseRootFromParent_Done,
     /* 186556 */   // Label 3658: @186556
     /* 186556 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(186593), // Rule ID 3429 //
     /* 186561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 186564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 186569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186582 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1530:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 186585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186591 */     GIR_RootConstrainSelectedInstOperands,
     /* 186592 */     // GIR_Coverage, 3429,
     /* 186592 */     GIR_EraseRootFromParent_Done,
     /* 186593 */   // Label 3659: @186593
     /* 186593 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(186630), // Rule ID 3451 //
     /* 186598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 186606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 186612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 186615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186619 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1280:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 186619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 186622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186628 */     GIR_RootConstrainSelectedInstOperands,
     /* 186629 */     // GIR_Coverage, 3451,
     /* 186629 */     GIR_EraseRootFromParent_Done,
     /* 186630 */   // Label 3660: @186630
     /* 186630 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(186667), // Rule ID 3456 //
     /* 186635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 186638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 186643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 186659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186665 */     GIR_RootConstrainSelectedInstOperands,
     /* 186666 */     // GIR_Coverage, 3456,
     /* 186666 */     GIR_EraseRootFromParent_Done,
     /* 186667 */   // Label 3661: @186667
     /* 186667 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(186704), // Rule ID 3457 //
     /* 186672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 186675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 186680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1245:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 186696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 186698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186702 */     GIR_RootConstrainSelectedInstOperands,
     /* 186703 */     // GIR_Coverage, 3457,
     /* 186703 */     GIR_EraseRootFromParent_Done,
     /* 186704 */   // Label 3662: @186704
     /* 186704 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(186741), // Rule ID 3466 //
     /* 186709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2140:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186739 */     GIR_RootConstrainSelectedInstOperands,
     /* 186740 */     // GIR_Coverage, 3466,
     /* 186740 */     GIR_EraseRootFromParent_Done,
     /* 186741 */   // Label 3663: @186741
     /* 186741 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(186778), // Rule ID 3467 //
     /* 186746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186767 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2140:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186776 */     GIR_RootConstrainSelectedInstOperands,
     /* 186777 */     // GIR_Coverage, 3467,
     /* 186777 */     GIR_EraseRootFromParent_Done,
     /* 186778 */   // Label 3664: @186778
     /* 186778 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(186815), // Rule ID 3468 //
     /* 186783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186804 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2140:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186813 */     GIR_RootConstrainSelectedInstOperands,
     /* 186814 */     // GIR_Coverage, 3468,
     /* 186814 */     GIR_EraseRootFromParent_Done,
     /* 186815 */   // Label 3665: @186815
     /* 186815 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(186852), // Rule ID 3469 //
     /* 186820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186841 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2140:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186850 */     GIR_RootConstrainSelectedInstOperands,
     /* 186851 */     // GIR_Coverage, 3469,
     /* 186851 */     GIR_EraseRootFromParent_Done,
     /* 186852 */   // Label 3666: @186852
     /* 186852 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(186889), // Rule ID 3470 //
     /* 186857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2140:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186887 */     GIR_RootConstrainSelectedInstOperands,
     /* 186888 */     // GIR_Coverage, 3470,
     /* 186888 */     GIR_EraseRootFromParent_Done,
     /* 186889 */   // Label 3667: @186889
     /* 186889 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(186926), // Rule ID 3471 //
     /* 186894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2140:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186924 */     GIR_RootConstrainSelectedInstOperands,
     /* 186925 */     // GIR_Coverage, 3471,
     /* 186925 */     GIR_EraseRootFromParent_Done,
     /* 186926 */   // Label 3668: @186926
     /* 186926 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(186963), // Rule ID 3472 //
     /* 186931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 186934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 186939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2140:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 186952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 186955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186961 */     GIR_RootConstrainSelectedInstOperands,
     /* 186962 */     // GIR_Coverage, 3472,
     /* 186962 */     GIR_EraseRootFromParent_Done,
     /* 186963 */   // Label 3669: @186963
     /* 186963 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187000), // Rule ID 3527 //
     /* 186968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 186971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 186976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 186982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186989 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 186989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 186992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 186994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186998 */     GIR_RootConstrainSelectedInstOperands,
     /* 186999 */     // GIR_Coverage, 3527,
     /* 186999 */     GIR_EraseRootFromParent_Done,
     /* 187000 */   // Label 3670: @187000
     /* 187000 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187037), // Rule ID 3528 //
     /* 187005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187026 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 187029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187035 */     GIR_RootConstrainSelectedInstOperands,
     /* 187036 */     // GIR_Coverage, 3528,
     /* 187036 */     GIR_EraseRootFromParent_Done,
     /* 187037 */   // Label 3671: @187037
     /* 187037 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187074), // Rule ID 3529 //
     /* 187042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187063 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 187066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187072 */     GIR_RootConstrainSelectedInstOperands,
     /* 187073 */     // GIR_Coverage, 3529,
     /* 187073 */     GIR_EraseRootFromParent_Done,
     /* 187074 */   // Label 3672: @187074
     /* 187074 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187111), // Rule ID 3559 //
     /* 187079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187100 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 187103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187109 */     GIR_RootConstrainSelectedInstOperands,
     /* 187110 */     // GIR_Coverage, 3559,
     /* 187110 */     GIR_EraseRootFromParent_Done,
     /* 187111 */   // Label 3673: @187111
     /* 187111 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187148), // Rule ID 3560 //
     /* 187116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187137 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 187140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187146 */     GIR_RootConstrainSelectedInstOperands,
     /* 187147 */     // GIR_Coverage, 3560,
     /* 187147 */     GIR_EraseRootFromParent_Done,
     /* 187148 */   // Label 3674: @187148
     /* 187148 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187185), // Rule ID 3561 //
     /* 187153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187174 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 187177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187183 */     GIR_RootConstrainSelectedInstOperands,
     /* 187184 */     // GIR_Coverage, 3561,
     /* 187184 */     GIR_EraseRootFromParent_Done,
     /* 187185 */   // Label 3675: @187185
     /* 187185 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187222), // Rule ID 3562 //
     /* 187190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187211 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 187214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187220 */     GIR_RootConstrainSelectedInstOperands,
     /* 187221 */     // GIR_Coverage, 3562,
     /* 187221 */     GIR_EraseRootFromParent_Done,
     /* 187222 */   // Label 3676: @187222
     /* 187222 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(187259), // Rule ID 3563 //
     /* 187227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2148:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 187251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187257 */     GIR_RootConstrainSelectedInstOperands,
     /* 187258 */     // GIR_Coverage, 3563,
     /* 187258 */     GIR_EraseRootFromParent_Done,
     /* 187259 */   // Label 3677: @187259
     /* 187259 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(187296), // Rule ID 3564 //
     /* 187264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187285 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2148:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187294 */     GIR_RootConstrainSelectedInstOperands,
     /* 187295 */     // GIR_Coverage, 3564,
     /* 187295 */     GIR_EraseRootFromParent_Done,
     /* 187296 */   // Label 3678: @187296
     /* 187296 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(187333), // Rule ID 3565 //
     /* 187301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2148:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187331 */     GIR_RootConstrainSelectedInstOperands,
     /* 187332 */     // GIR_Coverage, 3565,
     /* 187332 */     GIR_EraseRootFromParent_Done,
     /* 187333 */   // Label 3679: @187333
     /* 187333 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(187370), // Rule ID 3566 //
     /* 187338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2148:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 187362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187368 */     GIR_RootConstrainSelectedInstOperands,
     /* 187369 */     // GIR_Coverage, 3566,
     /* 187369 */     GIR_EraseRootFromParent_Done,
     /* 187370 */   // Label 3680: @187370
     /* 187370 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(187407), // Rule ID 3567 //
     /* 187375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187396 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2148:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187405 */     GIR_RootConstrainSelectedInstOperands,
     /* 187406 */     // GIR_Coverage, 3567,
     /* 187406 */     GIR_EraseRootFromParent_Done,
     /* 187407 */   // Label 3681: @187407
     /* 187407 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(187444), // Rule ID 3568 //
     /* 187412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187433 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2148:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187442 */     GIR_RootConstrainSelectedInstOperands,
     /* 187443 */     // GIR_Coverage, 3568,
     /* 187443 */     GIR_EraseRootFromParent_Done,
     /* 187444 */   // Label 3682: @187444
     /* 187444 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(187481), // Rule ID 3569 //
     /* 187449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2148:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 187473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187479 */     GIR_RootConstrainSelectedInstOperands,
     /* 187480 */     // GIR_Coverage, 3569,
     /* 187480 */     GIR_EraseRootFromParent_Done,
     /* 187481 */   // Label 3683: @187481
     /* 187481 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(187518), // Rule ID 3570 //
     /* 187486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187507 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 187510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187516 */     GIR_RootConstrainSelectedInstOperands,
     /* 187517 */     // GIR_Coverage, 3570,
     /* 187517 */     GIR_EraseRootFromParent_Done,
     /* 187518 */   // Label 3684: @187518
     /* 187518 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(187555), // Rule ID 3571 //
     /* 187523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 187547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187553 */     GIR_RootConstrainSelectedInstOperands,
     /* 187554 */     // GIR_Coverage, 3571,
     /* 187554 */     GIR_EraseRootFromParent_Done,
     /* 187555 */   // Label 3685: @187555
     /* 187555 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(187592), // Rule ID 3572 //
     /* 187560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187581 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 187584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187590 */     GIR_RootConstrainSelectedInstOperands,
     /* 187591 */     // GIR_Coverage, 3572,
     /* 187591 */     GIR_EraseRootFromParent_Done,
     /* 187592 */   // Label 3686: @187592
     /* 187592 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(187629), // Rule ID 3573 //
     /* 187597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 187621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187627 */     GIR_RootConstrainSelectedInstOperands,
     /* 187628 */     // GIR_Coverage, 3573,
     /* 187628 */     GIR_EraseRootFromParent_Done,
     /* 187629 */   // Label 3687: @187629
     /* 187629 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(187666), // Rule ID 3574 //
     /* 187634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187655 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1903:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 187658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187664 */     GIR_RootConstrainSelectedInstOperands,
     /* 187665 */     // GIR_Coverage, 3574,
     /* 187665 */     GIR_EraseRootFromParent_Done,
     /* 187666 */   // Label 3688: @187666
     /* 187666 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(187703), // Rule ID 3575 //
     /* 187671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187692 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1903:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 187695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187701 */     GIR_RootConstrainSelectedInstOperands,
     /* 187702 */     // GIR_Coverage, 3575,
     /* 187702 */     GIR_EraseRootFromParent_Done,
     /* 187703 */   // Label 3689: @187703
     /* 187703 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(187740), // Rule ID 3576 //
     /* 187708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 187716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1903:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 187732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187738 */     GIR_RootConstrainSelectedInstOperands,
     /* 187739 */     // GIR_Coverage, 3576,
     /* 187739 */     GIR_EraseRootFromParent_Done,
     /* 187740 */   // Label 3690: @187740
     /* 187740 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(187777), // Rule ID 8351 //
     /* 187745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 187753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187766 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1282:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 187769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187775 */     GIR_RootConstrainSelectedInstOperands,
     /* 187776 */     // GIR_Coverage, 8351,
     /* 187776 */     GIR_EraseRootFromParent_Done,
     /* 187777 */   // Label 3691: @187777
     /* 187777 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(187814), // Rule ID 8827 //
     /* 187782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1240:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 187806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187812 */     GIR_RootConstrainSelectedInstOperands,
     /* 187813 */     // GIR_Coverage, 8827,
     /* 187813 */     GIR_EraseRootFromParent_Done,
     /* 187814 */   // Label 3692: @187814
     /* 187814 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(187851), // Rule ID 8828 //
     /* 187819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 187827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1242:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 187843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187849 */     GIR_RootConstrainSelectedInstOperands,
     /* 187850 */     // GIR_Coverage, 8828,
     /* 187850 */     GIR_EraseRootFromParent_Done,
     /* 187851 */   // Label 3693: @187851
     /* 187851 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(187888), // Rule ID 8829 //
     /* 187856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 187864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1243:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 187880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187886 */     GIR_RootConstrainSelectedInstOperands,
     /* 187887 */     // GIR_Coverage, 8829,
     /* 187887 */     GIR_EraseRootFromParent_Done,
     /* 187888 */   // Label 3694: @187888
     /* 187888 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(187925), // Rule ID 8830 //
     /* 187893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 187901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1241:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 187917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187923 */     GIR_RootConstrainSelectedInstOperands,
     /* 187924 */     // GIR_Coverage, 8830,
     /* 187924 */     GIR_EraseRootFromParent_Done,
     /* 187925 */   // Label 3695: @187925
     /* 187925 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(187962), // Rule ID 8831 //
     /* 187930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 187938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1240:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 187954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187960 */     GIR_RootConstrainSelectedInstOperands,
     /* 187961 */     // GIR_Coverage, 8831,
     /* 187961 */     GIR_EraseRootFromParent_Done,
     /* 187962 */   // Label 3696: @187962
     /* 187962 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(187999), // Rule ID 8832 //
     /* 187967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 187975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1242:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 187991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187997 */     GIR_RootConstrainSelectedInstOperands,
     /* 187998 */     // GIR_Coverage, 8832,
     /* 187998 */     GIR_EraseRootFromParent_Done,
     /* 187999 */   // Label 3697: @187999
     /* 187999 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188036), // Rule ID 8833 //
     /* 188004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 188012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188025 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1243:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 188028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188034 */     GIR_RootConstrainSelectedInstOperands,
     /* 188035 */     // GIR_Coverage, 8833,
     /* 188035 */     GIR_EraseRootFromParent_Done,
     /* 188036 */   // Label 3698: @188036
     /* 188036 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188073), // Rule ID 8834 //
     /* 188041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 188049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1241:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 188065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188071 */     GIR_RootConstrainSelectedInstOperands,
     /* 188072 */     // GIR_Coverage, 8834,
     /* 188072 */     GIR_EraseRootFromParent_Done,
     /* 188073 */   // Label 3699: @188073
     /* 188073 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188113), // Rule ID 9834 //
     /* 188078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188099 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 188102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188111 */     GIR_RootConstrainSelectedInstOperands,
     /* 188112 */     // GIR_Coverage, 9834,
     /* 188112 */     GIR_EraseRootFromParent_Done,
     /* 188113 */   // Label 3700: @188113
     /* 188113 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188153), // Rule ID 9835 //
     /* 188118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188139 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 188142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188151 */     GIR_RootConstrainSelectedInstOperands,
     /* 188152 */     // GIR_Coverage, 9835,
     /* 188152 */     GIR_EraseRootFromParent_Done,
     /* 188153 */   // Label 3701: @188153
     /* 188153 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188193), // Rule ID 9836 //
     /* 188158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188179 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 188182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188191 */     GIR_RootConstrainSelectedInstOperands,
     /* 188192 */     // GIR_Coverage, 9836,
     /* 188192 */     GIR_EraseRootFromParent_Done,
     /* 188193 */   // Label 3702: @188193
     /* 188193 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188233), // Rule ID 9837 //
     /* 188198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188219 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 188222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188231 */     GIR_RootConstrainSelectedInstOperands,
     /* 188232 */     // GIR_Coverage, 9837,
     /* 188232 */     GIR_EraseRootFromParent_Done,
     /* 188233 */   // Label 3703: @188233
     /* 188233 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(188273), // Rule ID 9838 //
     /* 188238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188259 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 188262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188271 */     GIR_RootConstrainSelectedInstOperands,
     /* 188272 */     // GIR_Coverage, 9838,
     /* 188272 */     GIR_EraseRootFromParent_Done,
     /* 188273 */   // Label 3704: @188273
     /* 188273 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(188313), // Rule ID 9839 //
     /* 188278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188299 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 188302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188311 */     GIR_RootConstrainSelectedInstOperands,
     /* 188312 */     // GIR_Coverage, 9839,
     /* 188312 */     GIR_EraseRootFromParent_Done,
     /* 188313 */   // Label 3705: @188313
     /* 188313 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(188353), // Rule ID 9840 //
     /* 188318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188339 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 188342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188351 */     GIR_RootConstrainSelectedInstOperands,
     /* 188352 */     // GIR_Coverage, 9840,
     /* 188352 */     GIR_EraseRootFromParent_Done,
     /* 188353 */   // Label 3706: @188353
     /* 188353 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(188393), // Rule ID 9841 //
     /* 188358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188379 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 188382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188391 */     GIR_RootConstrainSelectedInstOperands,
     /* 188392 */     // GIR_Coverage, 9841,
     /* 188392 */     GIR_EraseRootFromParent_Done,
     /* 188393 */   // Label 3707: @188393
     /* 188393 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(188433), // Rule ID 9846 //
     /* 188398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188419 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 188422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188431 */     GIR_RootConstrainSelectedInstOperands,
     /* 188432 */     // GIR_Coverage, 9846,
     /* 188432 */     GIR_EraseRootFromParent_Done,
     /* 188433 */   // Label 3708: @188433
     /* 188433 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(188473), // Rule ID 9847 //
     /* 188438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188459 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 188462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188471 */     GIR_RootConstrainSelectedInstOperands,
     /* 188472 */     // GIR_Coverage, 9847,
     /* 188472 */     GIR_EraseRootFromParent_Done,
     /* 188473 */   // Label 3709: @188473
     /* 188473 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(188513), // Rule ID 9848 //
     /* 188478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188499 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 188502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188511 */     GIR_RootConstrainSelectedInstOperands,
     /* 188512 */     // GIR_Coverage, 9848,
     /* 188512 */     GIR_EraseRootFromParent_Done,
     /* 188513 */   // Label 3710: @188513
     /* 188513 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(188553), // Rule ID 9849 //
     /* 188518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188539 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 188542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188551 */     GIR_RootConstrainSelectedInstOperands,
     /* 188552 */     // GIR_Coverage, 9849,
     /* 188552 */     GIR_EraseRootFromParent_Done,
     /* 188553 */   // Label 3711: @188553
     /* 188553 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(188593), // Rule ID 9850 //
     /* 188558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188579 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 188582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188591 */     GIR_RootConstrainSelectedInstOperands,
     /* 188592 */     // GIR_Coverage, 9850,
     /* 188592 */     GIR_EraseRootFromParent_Done,
     /* 188593 */   // Label 3712: @188593
     /* 188593 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(188633), // Rule ID 9851 //
     /* 188598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188619 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 188622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188631 */     GIR_RootConstrainSelectedInstOperands,
     /* 188632 */     // GIR_Coverage, 9851,
     /* 188632 */     GIR_EraseRootFromParent_Done,
     /* 188633 */   // Label 3713: @188633
     /* 188633 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(188673), // Rule ID 9852 //
     /* 188638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188659 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 188662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188671 */     GIR_RootConstrainSelectedInstOperands,
     /* 188672 */     // GIR_Coverage, 9852,
     /* 188672 */     GIR_EraseRootFromParent_Done,
     /* 188673 */   // Label 3714: @188673
     /* 188673 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(188713), // Rule ID 9853 //
     /* 188678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188699 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 188702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188711 */     GIR_RootConstrainSelectedInstOperands,
     /* 188712 */     // GIR_Coverage, 9853,
     /* 188712 */     GIR_EraseRootFromParent_Done,
     /* 188713 */   // Label 3715: @188713
     /* 188713 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(188753), // Rule ID 9854 //
     /* 188718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188739 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 188742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188751 */     GIR_RootConstrainSelectedInstOperands,
     /* 188752 */     // GIR_Coverage, 9854,
     /* 188752 */     GIR_EraseRootFromParent_Done,
     /* 188753 */   // Label 3716: @188753
     /* 188753 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(188793), // Rule ID 9855 //
     /* 188758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 188782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188791 */     GIR_RootConstrainSelectedInstOperands,
     /* 188792 */     // GIR_Coverage, 9855,
     /* 188792 */     GIR_EraseRootFromParent_Done,
     /* 188793 */   // Label 3717: @188793
     /* 188793 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(188833), // Rule ID 9856 //
     /* 188798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188819 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 188822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188831 */     GIR_RootConstrainSelectedInstOperands,
     /* 188832 */     // GIR_Coverage, 9856,
     /* 188832 */     GIR_EraseRootFromParent_Done,
     /* 188833 */   // Label 3718: @188833
     /* 188833 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(188873), // Rule ID 9857 //
     /* 188838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188859 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 188862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188871 */     GIR_RootConstrainSelectedInstOperands,
     /* 188872 */     // GIR_Coverage, 9857,
     /* 188872 */     GIR_EraseRootFromParent_Done,
     /* 188873 */   // Label 3719: @188873
     /* 188873 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(188913), // Rule ID 9862 //
     /* 188878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188899 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 188902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188911 */     GIR_RootConstrainSelectedInstOperands,
     /* 188912 */     // GIR_Coverage, 9862,
     /* 188912 */     GIR_EraseRootFromParent_Done,
     /* 188913 */   // Label 3720: @188913
     /* 188913 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(188953), // Rule ID 9863 //
     /* 188918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188939 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 188942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188951 */     GIR_RootConstrainSelectedInstOperands,
     /* 188952 */     // GIR_Coverage, 9863,
     /* 188952 */     GIR_EraseRootFromParent_Done,
     /* 188953 */   // Label 3721: @188953
     /* 188953 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(188993), // Rule ID 9864 //
     /* 188958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 188972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 188975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188979 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 188979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 188982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188991 */     GIR_RootConstrainSelectedInstOperands,
     /* 188992 */     // GIR_Coverage, 9864,
     /* 188992 */     GIR_EraseRootFromParent_Done,
     /* 188993 */   // Label 3722: @188993
     /* 188993 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189033), // Rule ID 9865 //
     /* 188998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189019 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 189022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189031 */     GIR_RootConstrainSelectedInstOperands,
     /* 189032 */     // GIR_Coverage, 9865,
     /* 189032 */     GIR_EraseRootFromParent_Done,
     /* 189033 */   // Label 3723: @189033
     /* 189033 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189070), // Rule ID 10024 //
     /* 189038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 189062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189068 */     GIR_RootConstrainSelectedInstOperands,
     /* 189069 */     // GIR_Coverage, 10024,
     /* 189069 */     GIR_EraseRootFromParent_Done,
     /* 189070 */   // Label 3724: @189070
     /* 189070 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189107), // Rule ID 10025 //
     /* 189075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 189099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189105 */     GIR_RootConstrainSelectedInstOperands,
     /* 189106 */     // GIR_Coverage, 10025,
     /* 189106 */     GIR_EraseRootFromParent_Done,
     /* 189107 */   // Label 3725: @189107
     /* 189107 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189144), // Rule ID 10026 //
     /* 189112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 189136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189142 */     GIR_RootConstrainSelectedInstOperands,
     /* 189143 */     // GIR_Coverage, 10026,
     /* 189143 */     GIR_EraseRootFromParent_Done,
     /* 189144 */   // Label 3726: @189144
     /* 189144 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189181), // Rule ID 10027 //
     /* 189149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1765:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 189173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189179 */     GIR_RootConstrainSelectedInstOperands,
     /* 189180 */     // GIR_Coverage, 10027,
     /* 189180 */     GIR_EraseRootFromParent_Done,
     /* 189181 */   // Label 3727: @189181
     /* 189181 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189218), // Rule ID 10028 //
     /* 189186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1765:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 189210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189216 */     GIR_RootConstrainSelectedInstOperands,
     /* 189217 */     // GIR_Coverage, 10028,
     /* 189217 */     GIR_EraseRootFromParent_Done,
     /* 189218 */   // Label 3728: @189218
     /* 189218 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(189255), // Rule ID 10029 //
     /* 189223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1765:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 189247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189253 */     GIR_RootConstrainSelectedInstOperands,
     /* 189254 */     // GIR_Coverage, 10029,
     /* 189254 */     GIR_EraseRootFromParent_Done,
     /* 189255 */   // Label 3729: @189255
     /* 189255 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(189292), // Rule ID 10030 //
     /* 189260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189281 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 189284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189290 */     GIR_RootConstrainSelectedInstOperands,
     /* 189291 */     // GIR_Coverage, 10030,
     /* 189291 */     GIR_EraseRootFromParent_Done,
     /* 189292 */   // Label 3730: @189292
     /* 189292 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(189329), // Rule ID 10031 //
     /* 189297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 189321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189327 */     GIR_RootConstrainSelectedInstOperands,
     /* 189328 */     // GIR_Coverage, 10031,
     /* 189328 */     GIR_EraseRootFromParent_Done,
     /* 189329 */   // Label 3731: @189329
     /* 189329 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(189366), // Rule ID 10032 //
     /* 189334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189355 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 189358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189364 */     GIR_RootConstrainSelectedInstOperands,
     /* 189365 */     // GIR_Coverage, 10032,
     /* 189365 */     GIR_EraseRootFromParent_Done,
     /* 189366 */   // Label 3732: @189366
     /* 189366 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(189403), // Rule ID 11200 //
     /* 189371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2145:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189401 */     GIR_RootConstrainSelectedInstOperands,
     /* 189402 */     // GIR_Coverage, 11200,
     /* 189402 */     GIR_EraseRootFromParent_Done,
     /* 189403 */   // Label 3733: @189403
     /* 189403 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(189440), // Rule ID 11201 //
     /* 189408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2145:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189438 */     GIR_RootConstrainSelectedInstOperands,
     /* 189439 */     // GIR_Coverage, 11201,
     /* 189439 */     GIR_EraseRootFromParent_Done,
     /* 189440 */   // Label 3734: @189440
     /* 189440 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189477), // Rule ID 11202 //
     /* 189445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189466 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2145:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189475 */     GIR_RootConstrainSelectedInstOperands,
     /* 189476 */     // GIR_Coverage, 11202,
     /* 189476 */     GIR_EraseRootFromParent_Done,
     /* 189477 */   // Label 3735: @189477
     /* 189477 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(189514), // Rule ID 11203 //
     /* 189482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2145:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189512 */     GIR_RootConstrainSelectedInstOperands,
     /* 189513 */     // GIR_Coverage, 11203,
     /* 189513 */     GIR_EraseRootFromParent_Done,
     /* 189514 */   // Label 3736: @189514
     /* 189514 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(189551), // Rule ID 11204 //
     /* 189519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189540 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2145:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189549 */     GIR_RootConstrainSelectedInstOperands,
     /* 189550 */     // GIR_Coverage, 11204,
     /* 189550 */     GIR_EraseRootFromParent_Done,
     /* 189551 */   // Label 3737: @189551
     /* 189551 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(189588), // Rule ID 11205 //
     /* 189556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2145:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189586 */     GIR_RootConstrainSelectedInstOperands,
     /* 189587 */     // GIR_Coverage, 11205,
     /* 189587 */     GIR_EraseRootFromParent_Done,
     /* 189588 */   // Label 3738: @189588
     /* 189588 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(189625), // Rule ID 11206 //
     /* 189593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189614 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2145:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189623 */     GIR_RootConstrainSelectedInstOperands,
     /* 189624 */     // GIR_Coverage, 11206,
     /* 189624 */     GIR_EraseRootFromParent_Done,
     /* 189625 */   // Label 3739: @189625
     /* 189625 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(189662), // Rule ID 11207 //
     /* 189630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189651 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2066:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189660 */     GIR_RootConstrainSelectedInstOperands,
     /* 189661 */     // GIR_Coverage, 11207,
     /* 189661 */     GIR_EraseRootFromParent_Done,
     /* 189662 */   // Label 3740: @189662
     /* 189662 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(189699), // Rule ID 11208 //
     /* 189667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189688 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189697 */     GIR_RootConstrainSelectedInstOperands,
     /* 189698 */     // GIR_Coverage, 11208,
     /* 189698 */     GIR_EraseRootFromParent_Done,
     /* 189699 */   // Label 3741: @189699
     /* 189699 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(189736), // Rule ID 11209 //
     /* 189704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189725 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2066:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189734 */     GIR_RootConstrainSelectedInstOperands,
     /* 189735 */     // GIR_Coverage, 11209,
     /* 189735 */     GIR_EraseRootFromParent_Done,
     /* 189736 */   // Label 3742: @189736
     /* 189736 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(189773), // Rule ID 11210 //
     /* 189741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 189762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189771 */     GIR_RootConstrainSelectedInstOperands,
     /* 189772 */     // GIR_Coverage, 11210,
     /* 189772 */     GIR_EraseRootFromParent_Done,
     /* 189773 */   // Label 3743: @189773
     /* 189773 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(189810), // Rule ID 11211 //
     /* 189778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 189795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189799 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2066:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 189799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189808 */     GIR_RootConstrainSelectedInstOperands,
     /* 189809 */     // GIR_Coverage, 11211,
     /* 189809 */     GIR_EraseRootFromParent_Done,
     /* 189810 */   // Label 3744: @189810
     /* 189810 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(189847), // Rule ID 11212 //
     /* 189815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 189836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189845 */     GIR_RootConstrainSelectedInstOperands,
     /* 189846 */     // GIR_Coverage, 11212,
     /* 189846 */     GIR_EraseRootFromParent_Done,
     /* 189847 */   // Label 3745: @189847
     /* 189847 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(189884), // Rule ID 11213 //
     /* 189852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 189860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 189869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189873 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2066:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 189873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 189876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189882 */     GIR_RootConstrainSelectedInstOperands,
     /* 189883 */     // GIR_Coverage, 11213,
     /* 189883 */     GIR_EraseRootFromParent_Done,
     /* 189884 */   // Label 3746: @189884
     /* 189884 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(189921), // Rule ID 11214 //
     /* 189889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189910 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2071:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189919 */     GIR_RootConstrainSelectedInstOperands,
     /* 189920 */     // GIR_Coverage, 11214,
     /* 189920 */     GIR_EraseRootFromParent_Done,
     /* 189921 */   // Label 3747: @189921
     /* 189921 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(189958), // Rule ID 11215 //
     /* 189926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189956 */     GIR_RootConstrainSelectedInstOperands,
     /* 189957 */     // GIR_Coverage, 11215,
     /* 189957 */     GIR_EraseRootFromParent_Done,
     /* 189958 */   // Label 3748: @189958
     /* 189958 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(189995), // Rule ID 11216 //
     /* 189963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 189971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189984 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2071:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 189984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 189987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189993 */     GIR_RootConstrainSelectedInstOperands,
     /* 189994 */     // GIR_Coverage, 11216,
     /* 189994 */     GIR_EraseRootFromParent_Done,
     /* 189995 */   // Label 3749: @189995
     /* 189995 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190032), // Rule ID 11217 //
     /* 190000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190030 */     GIR_RootConstrainSelectedInstOperands,
     /* 190031 */     // GIR_Coverage, 11217,
     /* 190031 */     GIR_EraseRootFromParent_Done,
     /* 190032 */   // Label 3750: @190032
     /* 190032 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190069), // Rule ID 11218 //
     /* 190037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2071:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190067 */     GIR_RootConstrainSelectedInstOperands,
     /* 190068 */     // GIR_Coverage, 11218,
     /* 190068 */     GIR_EraseRootFromParent_Done,
     /* 190069 */   // Label 3751: @190069
     /* 190069 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190106), // Rule ID 11219 //
     /* 190074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190104 */     GIR_RootConstrainSelectedInstOperands,
     /* 190105 */     // GIR_Coverage, 11219,
     /* 190105 */     GIR_EraseRootFromParent_Done,
     /* 190106 */   // Label 3752: @190106
     /* 190106 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190143), // Rule ID 11220 //
     /* 190111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190132 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2071:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190141 */     GIR_RootConstrainSelectedInstOperands,
     /* 190142 */     // GIR_Coverage, 11220,
     /* 190142 */     GIR_EraseRootFromParent_Done,
     /* 190143 */   // Label 3753: @190143
     /* 190143 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190180), // Rule ID 11221 //
     /* 190148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190178 */     GIR_RootConstrainSelectedInstOperands,
     /* 190179 */     // GIR_Coverage, 11221,
     /* 190179 */     GIR_EraseRootFromParent_Done,
     /* 190180 */   // Label 3754: @190180
     /* 190180 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190217), // Rule ID 11222 //
     /* 190185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190215 */     GIR_RootConstrainSelectedInstOperands,
     /* 190216 */     // GIR_Coverage, 11222,
     /* 190216 */     GIR_EraseRootFromParent_Done,
     /* 190217 */   // Label 3755: @190217
     /* 190217 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(190254), // Rule ID 11223 //
     /* 190222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1910:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190252 */     GIR_RootConstrainSelectedInstOperands,
     /* 190253 */     // GIR_Coverage, 11223,
     /* 190253 */     GIR_EraseRootFromParent_Done,
     /* 190254 */   // Label 3756: @190254
     /* 190254 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(190291), // Rule ID 11224 //
     /* 190259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190289 */     GIR_RootConstrainSelectedInstOperands,
     /* 190290 */     // GIR_Coverage, 11224,
     /* 190290 */     GIR_EraseRootFromParent_Done,
     /* 190291 */   // Label 3757: @190291
     /* 190291 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(190328), // Rule ID 11225 //
     /* 190296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190317 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1910:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190326 */     GIR_RootConstrainSelectedInstOperands,
     /* 190327 */     // GIR_Coverage, 11225,
     /* 190327 */     GIR_EraseRootFromParent_Done,
     /* 190328 */   // Label 3758: @190328
     /* 190328 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(190365), // Rule ID 11226 //
     /* 190333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190354 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190363 */     GIR_RootConstrainSelectedInstOperands,
     /* 190364 */     // GIR_Coverage, 11226,
     /* 190364 */     GIR_EraseRootFromParent_Done,
     /* 190365 */   // Label 3759: @190365
     /* 190365 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(190402), // Rule ID 11227 //
     /* 190370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190391 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1910:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190400 */     GIR_RootConstrainSelectedInstOperands,
     /* 190401 */     // GIR_Coverage, 11227,
     /* 190401 */     GIR_EraseRootFromParent_Done,
     /* 190402 */   // Label 3760: @190402
     /* 190402 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(190439), // Rule ID 11228 //
     /* 190407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1915:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190437 */     GIR_RootConstrainSelectedInstOperands,
     /* 190438 */     // GIR_Coverage, 11228,
     /* 190438 */     GIR_EraseRootFromParent_Done,
     /* 190439 */   // Label 3761: @190439
     /* 190439 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(190476), // Rule ID 11229 //
     /* 190444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190465 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1915:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190474 */     GIR_RootConstrainSelectedInstOperands,
     /* 190475 */     // GIR_Coverage, 11229,
     /* 190475 */     GIR_EraseRootFromParent_Done,
     /* 190476 */   // Label 3762: @190476
     /* 190476 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(190513), // Rule ID 11230 //
     /* 190481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1915:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190511 */     GIR_RootConstrainSelectedInstOperands,
     /* 190512 */     // GIR_Coverage, 11230,
     /* 190512 */     GIR_EraseRootFromParent_Done,
     /* 190513 */   // Label 3763: @190513
     /* 190513 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(190550), // Rule ID 11231 //
     /* 190518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1915:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190548 */     GIR_RootConstrainSelectedInstOperands,
     /* 190549 */     // GIR_Coverage, 11231,
     /* 190549 */     GIR_EraseRootFromParent_Done,
     /* 190550 */   // Label 3764: @190550
     /* 190550 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(190587), // Rule ID 11232 //
     /* 190555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1915:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190585 */     GIR_RootConstrainSelectedInstOperands,
     /* 190586 */     // GIR_Coverage, 11232,
     /* 190586 */     GIR_EraseRootFromParent_Done,
     /* 190587 */   // Label 3765: @190587
     /* 190587 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(190624), // Rule ID 11233 //
     /* 190592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1915:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190622 */     GIR_RootConstrainSelectedInstOperands,
     /* 190623 */     // GIR_Coverage, 11233,
     /* 190623 */     GIR_EraseRootFromParent_Done,
     /* 190624 */   // Label 3766: @190624
     /* 190624 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(190661), // Rule ID 11234 //
     /* 190629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1915:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190659 */     GIR_RootConstrainSelectedInstOperands,
     /* 190660 */     // GIR_Coverage, 11234,
     /* 190660 */     GIR_EraseRootFromParent_Done,
     /* 190661 */   // Label 3767: @190661
     /* 190661 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(190698), // Rule ID 11254 //
     /* 190666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190687 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1812:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 190690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190696 */     GIR_RootConstrainSelectedInstOperands,
     /* 190697 */     // GIR_Coverage, 11254,
     /* 190697 */     GIR_EraseRootFromParent_Done,
     /* 190698 */   // Label 3768: @190698
     /* 190698 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(190735), // Rule ID 11255 //
     /* 190703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1812:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 190727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190733 */     GIR_RootConstrainSelectedInstOperands,
     /* 190734 */     // GIR_Coverage, 11255,
     /* 190734 */     GIR_EraseRootFromParent_Done,
     /* 190735 */   // Label 3769: @190735
     /* 190735 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(190772), // Rule ID 11256 //
     /* 190740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190761 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 190764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190770 */     GIR_RootConstrainSelectedInstOperands,
     /* 190771 */     // GIR_Coverage, 11256,
     /* 190771 */     GIR_EraseRootFromParent_Done,
     /* 190772 */   // Label 3770: @190772
     /* 190772 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(190809), // Rule ID 11257 //
     /* 190777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 190785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1812:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 190801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190807 */     GIR_RootConstrainSelectedInstOperands,
     /* 190808 */     // GIR_Coverage, 11257,
     /* 190808 */     GIR_EraseRootFromParent_Done,
     /* 190809 */   // Label 3771: @190809
     /* 190809 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(190846), // Rule ID 11545 //
     /* 190814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 190838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190844 */     GIR_RootConstrainSelectedInstOperands,
     /* 190845 */     // GIR_Coverage, 11545,
     /* 190845 */     GIR_EraseRootFromParent_Done,
     /* 190846 */   // Label 3772: @190846
     /* 190846 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(190883), // Rule ID 11546 //
     /* 190851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 190875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190881 */     GIR_RootConstrainSelectedInstOperands,
     /* 190882 */     // GIR_Coverage, 11546,
     /* 190882 */     GIR_EraseRootFromParent_Done,
     /* 190883 */   // Label 3773: @190883
     /* 190883 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(190920), // Rule ID 11547 //
     /* 190888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 190896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 190912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190918 */     GIR_RootConstrainSelectedInstOperands,
     /* 190919 */     // GIR_Coverage, 11547,
     /* 190919 */     GIR_EraseRootFromParent_Done,
     /* 190920 */   // Label 3774: @190920
     /* 190920 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(190957), // Rule ID 11548 //
     /* 190925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 190933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 190949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190955 */     GIR_RootConstrainSelectedInstOperands,
     /* 190956 */     // GIR_Coverage, 11548,
     /* 190956 */     GIR_EraseRootFromParent_Done,
     /* 190957 */   // Label 3775: @190957
     /* 190957 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(190994), // Rule ID 11549 //
     /* 190962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 190965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 190970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 190986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190992 */     GIR_RootConstrainSelectedInstOperands,
     /* 190993 */     // GIR_Coverage, 11549,
     /* 190993 */     GIR_EraseRootFromParent_Done,
     /* 190994 */   // Label 3776: @190994
     /* 190994 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191031), // Rule ID 11550 //
     /* 190999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 191023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191029 */     GIR_RootConstrainSelectedInstOperands,
     /* 191030 */     // GIR_Coverage, 11550,
     /* 191030 */     GIR_EraseRootFromParent_Done,
     /* 191031 */   // Label 3777: @191031
     /* 191031 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191068), // Rule ID 11551 //
     /* 191036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191057 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 191060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191066 */     GIR_RootConstrainSelectedInstOperands,
     /* 191067 */     // GIR_Coverage, 11551,
     /* 191067 */     GIR_EraseRootFromParent_Done,
     /* 191068 */   // Label 3778: @191068
     /* 191068 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191105), // Rule ID 11552 //
     /* 191073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 191097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191103 */     GIR_RootConstrainSelectedInstOperands,
     /* 191104 */     // GIR_Coverage, 11552,
     /* 191104 */     GIR_EraseRootFromParent_Done,
     /* 191105 */   // Label 3779: @191105
     /* 191105 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191142), // Rule ID 11553 //
     /* 191110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191131 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 191134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191140 */     GIR_RootConstrainSelectedInstOperands,
     /* 191141 */     // GIR_Coverage, 11553,
     /* 191141 */     GIR_EraseRootFromParent_Done,
     /* 191142 */   // Label 3780: @191142
     /* 191142 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191179), // Rule ID 11554 //
     /* 191147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 191171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191177 */     GIR_RootConstrainSelectedInstOperands,
     /* 191178 */     // GIR_Coverage, 11554,
     /* 191178 */     GIR_EraseRootFromParent_Done,
     /* 191179 */   // Label 3781: @191179
     /* 191179 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191216), // Rule ID 11555 //
     /* 191184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191205 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 191208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191214 */     GIR_RootConstrainSelectedInstOperands,
     /* 191215 */     // GIR_Coverage, 11555,
     /* 191215 */     GIR_EraseRootFromParent_Done,
     /* 191216 */   // Label 3782: @191216
     /* 191216 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(191253), // Rule ID 11556 //
     /* 191221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 191245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191251 */     GIR_RootConstrainSelectedInstOperands,
     /* 191252 */     // GIR_Coverage, 11556,
     /* 191252 */     GIR_EraseRootFromParent_Done,
     /* 191253 */   // Label 3783: @191253
     /* 191253 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(191290), // Rule ID 11557 //
     /* 191258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 191282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191288 */     GIR_RootConstrainSelectedInstOperands,
     /* 191289 */     // GIR_Coverage, 11557,
     /* 191289 */     GIR_EraseRootFromParent_Done,
     /* 191290 */   // Label 3784: @191290
     /* 191290 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(191327), // Rule ID 11558 //
     /* 191295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 191319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191325 */     GIR_RootConstrainSelectedInstOperands,
     /* 191326 */     // GIR_Coverage, 11558,
     /* 191326 */     GIR_EraseRootFromParent_Done,
     /* 191327 */   // Label 3785: @191327
     /* 191327 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(191364), // Rule ID 11559 //
     /* 191332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 191356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191362 */     GIR_RootConstrainSelectedInstOperands,
     /* 191363 */     // GIR_Coverage, 11559,
     /* 191363 */     GIR_EraseRootFromParent_Done,
     /* 191364 */   // Label 3786: @191364
     /* 191364 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(191401), // Rule ID 11560 //
     /* 191369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2049:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 191393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191399 */     GIR_RootConstrainSelectedInstOperands,
     /* 191400 */     // GIR_Coverage, 11560,
     /* 191400 */     GIR_EraseRootFromParent_Done,
     /* 191401 */   // Label 3787: @191401
     /* 191401 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(191438), // Rule ID 11561 //
     /* 191406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 191430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191436 */     GIR_RootConstrainSelectedInstOperands,
     /* 191437 */     // GIR_Coverage, 11561,
     /* 191437 */     GIR_EraseRootFromParent_Done,
     /* 191438 */   // Label 3788: @191438
     /* 191438 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(191475), // Rule ID 11562 //
     /* 191443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2049:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 191467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191473 */     GIR_RootConstrainSelectedInstOperands,
     /* 191474 */     // GIR_Coverage, 11562,
     /* 191474 */     GIR_EraseRootFromParent_Done,
     /* 191475 */   // Label 3789: @191475
     /* 191475 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(191512), // Rule ID 11563 //
     /* 191480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 191504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191510 */     GIR_RootConstrainSelectedInstOperands,
     /* 191511 */     // GIR_Coverage, 11563,
     /* 191511 */     GIR_EraseRootFromParent_Done,
     /* 191512 */   // Label 3790: @191512
     /* 191512 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(191549), // Rule ID 11564 //
     /* 191517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 191541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191547 */     GIR_RootConstrainSelectedInstOperands,
     /* 191548 */     // GIR_Coverage, 11564,
     /* 191548 */     GIR_EraseRootFromParent_Done,
     /* 191549 */   // Label 3791: @191549
     /* 191549 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(191586), // Rule ID 11565 //
     /* 191554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 191562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191575 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 191578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191584 */     GIR_RootConstrainSelectedInstOperands,
     /* 191585 */     // GIR_Coverage, 11565,
     /* 191585 */     GIR_EraseRootFromParent_Done,
     /* 191586 */   // Label 3792: @191586
     /* 191586 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(191623), // Rule ID 11566 //
     /* 191591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191612 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1671:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 191615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191621 */     GIR_RootConstrainSelectedInstOperands,
     /* 191622 */     // GIR_Coverage, 11566,
     /* 191622 */     GIR_EraseRootFromParent_Done,
     /* 191623 */   // Label 3793: @191623
     /* 191623 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(191660), // Rule ID 11567 //
     /* 191628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1671:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 191652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191658 */     GIR_RootConstrainSelectedInstOperands,
     /* 191659 */     // GIR_Coverage, 11567,
     /* 191659 */     GIR_EraseRootFromParent_Done,
     /* 191660 */   // Label 3794: @191660
     /* 191660 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(191697), // Rule ID 11568 //
     /* 191665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 191673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191686 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 191689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191695 */     GIR_RootConstrainSelectedInstOperands,
     /* 191696 */     // GIR_Coverage, 11568,
     /* 191696 */     GIR_EraseRootFromParent_Done,
     /* 191697 */   // Label 3795: @191697
     /* 191697 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(191734), // Rule ID 11569 //
     /* 191702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191723 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 191726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191732 */     GIR_RootConstrainSelectedInstOperands,
     /* 191733 */     // GIR_Coverage, 11569,
     /* 191733 */     GIR_EraseRootFromParent_Done,
     /* 191734 */   // Label 3796: @191734
     /* 191734 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(191771), // Rule ID 11570 //
     /* 191739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 191763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191769 */     GIR_RootConstrainSelectedInstOperands,
     /* 191770 */     // GIR_Coverage, 11570,
     /* 191770 */     GIR_EraseRootFromParent_Done,
     /* 191771 */   // Label 3797: @191771
     /* 191771 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(191808), // Rule ID 11571 //
     /* 191776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 191784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191797 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 191800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191806 */     GIR_RootConstrainSelectedInstOperands,
     /* 191807 */     // GIR_Coverage, 11571,
     /* 191807 */     GIR_EraseRootFromParent_Done,
     /* 191808 */   // Label 3798: @191808
     /* 191808 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(191845), // Rule ID 11572 //
     /* 191813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1921:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 191837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191843 */     GIR_RootConstrainSelectedInstOperands,
     /* 191844 */     // GIR_Coverage, 11572,
     /* 191844 */     GIR_EraseRootFromParent_Done,
     /* 191845 */   // Label 3799: @191845
     /* 191845 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(191882), // Rule ID 11573 //
     /* 191850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1921:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 191874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191880 */     GIR_RootConstrainSelectedInstOperands,
     /* 191881 */     // GIR_Coverage, 11573,
     /* 191881 */     GIR_EraseRootFromParent_Done,
     /* 191882 */   // Label 3800: @191882
     /* 191882 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(191919), // Rule ID 11574 //
     /* 191887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 191895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1921:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 191911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191917 */     GIR_RootConstrainSelectedInstOperands,
     /* 191918 */     // GIR_Coverage, 11574,
     /* 191918 */     GIR_EraseRootFromParent_Done,
     /* 191919 */   // Label 3801: @191919
     /* 191919 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(191956), // Rule ID 11575 //
     /* 191924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 191932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191945 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1922:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 191948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191954 */     GIR_RootConstrainSelectedInstOperands,
     /* 191955 */     // GIR_Coverage, 11575,
     /* 191955 */     GIR_EraseRootFromParent_Done,
     /* 191956 */   // Label 3802: @191956
     /* 191956 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(191993), // Rule ID 11576 //
     /* 191961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 191969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191982 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1922:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 191985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191991 */     GIR_RootConstrainSelectedInstOperands,
     /* 191992 */     // GIR_Coverage, 11576,
     /* 191992 */     GIR_EraseRootFromParent_Done,
     /* 191993 */   // Label 3803: @191993
     /* 191993 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192030), // Rule ID 11577 //
     /* 191998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192019 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1922:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 192022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192028 */     GIR_RootConstrainSelectedInstOperands,
     /* 192029 */     // GIR_Coverage, 11577,
     /* 192029 */     GIR_EraseRootFromParent_Done,
     /* 192030 */   // Label 3804: @192030
     /* 192030 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192067), // Rule ID 11587 //
     /* 192035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 192059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192065 */     GIR_RootConstrainSelectedInstOperands,
     /* 192066 */     // GIR_Coverage, 11587,
     /* 192066 */     GIR_EraseRootFromParent_Done,
     /* 192067 */   // Label 3805: @192067
     /* 192067 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192104), // Rule ID 11588 //
     /* 192072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 192096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192102 */     GIR_RootConstrainSelectedInstOperands,
     /* 192103 */     // GIR_Coverage, 11588,
     /* 192103 */     GIR_EraseRootFromParent_Done,
     /* 192104 */   // Label 3806: @192104
     /* 192104 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192141), // Rule ID 11589 //
     /* 192109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 192133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192139 */     GIR_RootConstrainSelectedInstOperands,
     /* 192140 */     // GIR_Coverage, 11589,
     /* 192140 */     GIR_EraseRootFromParent_Done,
     /* 192141 */   // Label 3807: @192141
     /* 192141 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192178), // Rule ID 11590 //
     /* 192146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 192170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192176 */     GIR_RootConstrainSelectedInstOperands,
     /* 192177 */     // GIR_Coverage, 11590,
     /* 192177 */     GIR_EraseRootFromParent_Done,
     /* 192178 */   // Label 3808: @192178
     /* 192178 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192215), // Rule ID 11591 //
     /* 192183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 192207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192213 */     GIR_RootConstrainSelectedInstOperands,
     /* 192214 */     // GIR_Coverage, 11591,
     /* 192214 */     GIR_EraseRootFromParent_Done,
     /* 192215 */   // Label 3809: @192215
     /* 192215 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(192252), // Rule ID 11592 //
     /* 192220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192241 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1858:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 192244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192250 */     GIR_RootConstrainSelectedInstOperands,
     /* 192251 */     // GIR_Coverage, 11592,
     /* 192251 */     GIR_EraseRootFromParent_Done,
     /* 192252 */   // Label 3810: @192252
     /* 192252 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(192289), // Rule ID 11593 //
     /* 192257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2051:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 192281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192287 */     GIR_RootConstrainSelectedInstOperands,
     /* 192288 */     // GIR_Coverage, 11593,
     /* 192288 */     GIR_EraseRootFromParent_Done,
     /* 192289 */   // Label 3811: @192289
     /* 192289 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(192326), // Rule ID 11594 //
     /* 192294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192315 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2051:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 192318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192324 */     GIR_RootConstrainSelectedInstOperands,
     /* 192325 */     // GIR_Coverage, 11594,
     /* 192325 */     GIR_EraseRootFromParent_Done,
     /* 192326 */   // Label 3812: @192326
     /* 192326 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(192363), // Rule ID 11595 //
     /* 192331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192352 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2051:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 192355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192361 */     GIR_RootConstrainSelectedInstOperands,
     /* 192362 */     // GIR_Coverage, 11595,
     /* 192362 */     GIR_EraseRootFromParent_Done,
     /* 192363 */   // Label 3813: @192363
     /* 192363 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(192400), // Rule ID 11596 //
     /* 192368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2052:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 192392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192398 */     GIR_RootConstrainSelectedInstOperands,
     /* 192399 */     // GIR_Coverage, 11596,
     /* 192399 */     GIR_EraseRootFromParent_Done,
     /* 192400 */   // Label 3814: @192400
     /* 192400 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(192437), // Rule ID 11597 //
     /* 192405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2052:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 192429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192435 */     GIR_RootConstrainSelectedInstOperands,
     /* 192436 */     // GIR_Coverage, 11597,
     /* 192436 */     GIR_EraseRootFromParent_Done,
     /* 192437 */   // Label 3815: @192437
     /* 192437 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(192474), // Rule ID 11598 //
     /* 192442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2052:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 192466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192472 */     GIR_RootConstrainSelectedInstOperands,
     /* 192473 */     // GIR_Coverage, 11598,
     /* 192473 */     GIR_EraseRootFromParent_Done,
     /* 192474 */   // Label 3816: @192474
     /* 192474 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(192511), // Rule ID 11599 //
     /* 192479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192500 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 192503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192509 */     GIR_RootConstrainSelectedInstOperands,
     /* 192510 */     // GIR_Coverage, 11599,
     /* 192510 */     GIR_EraseRootFromParent_Done,
     /* 192511 */   // Label 3817: @192511
     /* 192511 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(192548), // Rule ID 11600 //
     /* 192516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 192540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192546 */     GIR_RootConstrainSelectedInstOperands,
     /* 192547 */     // GIR_Coverage, 11600,
     /* 192547 */     GIR_EraseRootFromParent_Done,
     /* 192548 */   // Label 3818: @192548
     /* 192548 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(192585), // Rule ID 11601 //
     /* 192553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 192561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 192577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192583 */     GIR_RootConstrainSelectedInstOperands,
     /* 192584 */     // GIR_Coverage, 11601,
     /* 192584 */     GIR_EraseRootFromParent_Done,
     /* 192585 */   // Label 3819: @192585
     /* 192585 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(192622), // Rule ID 11602 //
     /* 192590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192611 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1789:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 192614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192620 */     GIR_RootConstrainSelectedInstOperands,
     /* 192621 */     // GIR_Coverage, 11602,
     /* 192621 */     GIR_EraseRootFromParent_Done,
     /* 192622 */   // Label 3820: @192622
     /* 192622 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(192659), // Rule ID 11603 //
     /* 192627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 192651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192657 */     GIR_RootConstrainSelectedInstOperands,
     /* 192658 */     // GIR_Coverage, 11603,
     /* 192658 */     GIR_EraseRootFromParent_Done,
     /* 192659 */   // Label 3821: @192659
     /* 192659 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(192696), // Rule ID 11604 //
     /* 192664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 192672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192685 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 192688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192694 */     GIR_RootConstrainSelectedInstOperands,
     /* 192695 */     // GIR_Coverage, 11604,
     /* 192695 */     GIR_EraseRootFromParent_Done,
     /* 192696 */   // Label 3822: @192696
     /* 192696 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(192733), // Rule ID 11605 //
     /* 192701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192722 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 192725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192731 */     GIR_RootConstrainSelectedInstOperands,
     /* 192732 */     // GIR_Coverage, 11605,
     /* 192732 */     GIR_EraseRootFromParent_Done,
     /* 192733 */   // Label 3823: @192733
     /* 192733 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(192770), // Rule ID 11606 //
     /* 192738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 192762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192768 */     GIR_RootConstrainSelectedInstOperands,
     /* 192769 */     // GIR_Coverage, 11606,
     /* 192769 */     GIR_EraseRootFromParent_Done,
     /* 192770 */   // Label 3824: @192770
     /* 192770 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(192807), // Rule ID 11607 //
     /* 192775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 192783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 192799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192805 */     GIR_RootConstrainSelectedInstOperands,
     /* 192806 */     // GIR_Coverage, 11607,
     /* 192806 */     GIR_EraseRootFromParent_Done,
     /* 192807 */   // Label 3825: @192807
     /* 192807 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(192844), // Rule ID 11608 //
     /* 192812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192833 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1742:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 192836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192842 */     GIR_RootConstrainSelectedInstOperands,
     /* 192843 */     // GIR_Coverage, 11608,
     /* 192843 */     GIR_EraseRootFromParent_Done,
     /* 192844 */   // Label 3826: @192844
     /* 192844 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(192881), // Rule ID 11609 //
     /* 192849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1742:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 192873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192879 */     GIR_RootConstrainSelectedInstOperands,
     /* 192880 */     // GIR_Coverage, 11609,
     /* 192880 */     GIR_EraseRootFromParent_Done,
     /* 192881 */   // Label 3827: @192881
     /* 192881 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(192918), // Rule ID 11610 //
     /* 192886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 192894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1742:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 192910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192916 */     GIR_RootConstrainSelectedInstOperands,
     /* 192917 */     // GIR_Coverage, 11610,
     /* 192917 */     GIR_EraseRootFromParent_Done,
     /* 192918 */   // Label 3828: @192918
     /* 192918 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(192955), // Rule ID 11611 //
     /* 192923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 192947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192953 */     GIR_RootConstrainSelectedInstOperands,
     /* 192954 */     // GIR_Coverage, 11611,
     /* 192954 */     GIR_EraseRootFromParent_Done,
     /* 192955 */   // Label 3829: @192955
     /* 192955 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(192992), // Rule ID 11612 //
     /* 192960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 192968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 192984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192990 */     GIR_RootConstrainSelectedInstOperands,
     /* 192991 */     // GIR_Coverage, 11612,
     /* 192991 */     GIR_EraseRootFromParent_Done,
     /* 192992 */   // Label 3830: @192992
     /* 192992 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193029), // Rule ID 11613 //
     /* 192997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 193021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193027 */     GIR_RootConstrainSelectedInstOperands,
     /* 193028 */     // GIR_Coverage, 11613,
     /* 193028 */     GIR_EraseRootFromParent_Done,
     /* 193029 */   // Label 3831: @193029
     /* 193029 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193066), // Rule ID 11614 //
     /* 193034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193055 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1980:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 193058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193064 */     GIR_RootConstrainSelectedInstOperands,
     /* 193065 */     // GIR_Coverage, 11614,
     /* 193065 */     GIR_EraseRootFromParent_Done,
     /* 193066 */   // Label 3832: @193066
     /* 193066 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193103), // Rule ID 11615 //
     /* 193071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1980:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 193095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193101 */     GIR_RootConstrainSelectedInstOperands,
     /* 193102 */     // GIR_Coverage, 11615,
     /* 193102 */     GIR_EraseRootFromParent_Done,
     /* 193103 */   // Label 3833: @193103
     /* 193103 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193140), // Rule ID 11616 //
     /* 193108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193129 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1980:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 193132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193138 */     GIR_RootConstrainSelectedInstOperands,
     /* 193139 */     // GIR_Coverage, 11616,
     /* 193139 */     GIR_EraseRootFromParent_Done,
     /* 193140 */   // Label 3834: @193140
     /* 193140 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193177), // Rule ID 11617 //
     /* 193145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193166 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1618:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 193169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193175 */     GIR_RootConstrainSelectedInstOperands,
     /* 193176 */     // GIR_Coverage, 11617,
     /* 193176 */     GIR_EraseRootFromParent_Done,
     /* 193177 */   // Label 3835: @193177
     /* 193177 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193214), // Rule ID 11618 //
     /* 193182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1618:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 193206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193212 */     GIR_RootConstrainSelectedInstOperands,
     /* 193213 */     // GIR_Coverage, 11618,
     /* 193213 */     GIR_EraseRootFromParent_Done,
     /* 193214 */   // Label 3836: @193214
     /* 193214 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(193251), // Rule ID 11719 //
     /* 193219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1648:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 193243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193249 */     GIR_RootConstrainSelectedInstOperands,
     /* 193250 */     // GIR_Coverage, 11719,
     /* 193250 */     GIR_EraseRootFromParent_Done,
     /* 193251 */   // Label 3837: @193251
     /* 193251 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(193288), // Rule ID 11720 //
     /* 193256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1648:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 193280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193286 */     GIR_RootConstrainSelectedInstOperands,
     /* 193287 */     // GIR_Coverage, 11720,
     /* 193287 */     GIR_EraseRootFromParent_Done,
     /* 193288 */   // Label 3838: @193288
     /* 193288 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(193325), // Rule ID 11721 //
     /* 193293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1648:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 193317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193323 */     GIR_RootConstrainSelectedInstOperands,
     /* 193324 */     // GIR_Coverage, 11721,
     /* 193324 */     GIR_EraseRootFromParent_Done,
     /* 193325 */   // Label 3839: @193325
     /* 193325 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(193362), // Rule ID 11722 //
     /* 193330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193351 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1889:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 193354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193360 */     GIR_RootConstrainSelectedInstOperands,
     /* 193361 */     // GIR_Coverage, 11722,
     /* 193361 */     GIR_EraseRootFromParent_Done,
     /* 193362 */   // Label 3840: @193362
     /* 193362 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(193399), // Rule ID 11723 //
     /* 193367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193388 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1889:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 193391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193397 */     GIR_RootConstrainSelectedInstOperands,
     /* 193398 */     // GIR_Coverage, 11723,
     /* 193398 */     GIR_EraseRootFromParent_Done,
     /* 193399 */   // Label 3841: @193399
     /* 193399 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(193436), // Rule ID 11724 //
     /* 193404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1889:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 193428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193434 */     GIR_RootConstrainSelectedInstOperands,
     /* 193435 */     // GIR_Coverage, 11724,
     /* 193435 */     GIR_EraseRootFromParent_Done,
     /* 193436 */   // Label 3842: @193436
     /* 193436 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(193473), // Rule ID 11725 //
     /* 193441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193462 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1664:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 193465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193471 */     GIR_RootConstrainSelectedInstOperands,
     /* 193472 */     // GIR_Coverage, 11725,
     /* 193472 */     GIR_EraseRootFromParent_Done,
     /* 193473 */   // Label 3843: @193473
     /* 193473 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(193510), // Rule ID 11726 //
     /* 193478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1664:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 193502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193508 */     GIR_RootConstrainSelectedInstOperands,
     /* 193509 */     // GIR_Coverage, 11726,
     /* 193509 */     GIR_EraseRootFromParent_Done,
     /* 193510 */   // Label 3844: @193510
     /* 193510 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(193547), // Rule ID 11727 //
     /* 193515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 193539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193545 */     GIR_RootConstrainSelectedInstOperands,
     /* 193546 */     // GIR_Coverage, 11727,
     /* 193546 */     GIR_EraseRootFromParent_Done,
     /* 193547 */   // Label 3845: @193547
     /* 193547 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(193584), // Rule ID 11743 //
     /* 193552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193573 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2031:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 193576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193582 */     GIR_RootConstrainSelectedInstOperands,
     /* 193583 */     // GIR_Coverage, 11743,
     /* 193583 */     GIR_EraseRootFromParent_Done,
     /* 193584 */   // Label 3846: @193584
     /* 193584 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(193621), // Rule ID 11744 //
     /* 193589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193610 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 193613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193619 */     GIR_RootConstrainSelectedInstOperands,
     /* 193620 */     // GIR_Coverage, 11744,
     /* 193620 */     GIR_EraseRootFromParent_Done,
     /* 193621 */   // Label 3847: @193621
     /* 193621 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(193658), // Rule ID 11745 //
     /* 193626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 193634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 193650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193656 */     GIR_RootConstrainSelectedInstOperands,
     /* 193657 */     // GIR_Coverage, 11745,
     /* 193657 */     GIR_EraseRootFromParent_Done,
     /* 193658 */   // Label 3848: @193658
     /* 193658 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(193695), // Rule ID 11746 //
     /* 193663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 193687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193693 */     GIR_RootConstrainSelectedInstOperands,
     /* 193694 */     // GIR_Coverage, 11746,
     /* 193694 */     GIR_EraseRootFromParent_Done,
     /* 193695 */   // Label 3849: @193695
     /* 193695 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(193732), // Rule ID 11747 //
     /* 193700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193721 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 193724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193730 */     GIR_RootConstrainSelectedInstOperands,
     /* 193731 */     // GIR_Coverage, 11747,
     /* 193731 */     GIR_EraseRootFromParent_Done,
     /* 193732 */   // Label 3850: @193732
     /* 193732 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(193769), // Rule ID 11748 //
     /* 193737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 193745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 193761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193767 */     GIR_RootConstrainSelectedInstOperands,
     /* 193768 */     // GIR_Coverage, 11748,
     /* 193768 */     GIR_EraseRootFromParent_Done,
     /* 193769 */   // Label 3851: @193769
     /* 193769 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(193806), // Rule ID 11764 //
     /* 193774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 193798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193804 */     GIR_RootConstrainSelectedInstOperands,
     /* 193805 */     // GIR_Coverage, 11764,
     /* 193805 */     GIR_EraseRootFromParent_Done,
     /* 193806 */   // Label 3852: @193806
     /* 193806 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(193843), // Rule ID 11765 //
     /* 193811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 193835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193841 */     GIR_RootConstrainSelectedInstOperands,
     /* 193842 */     // GIR_Coverage, 11765,
     /* 193842 */     GIR_EraseRootFromParent_Done,
     /* 193843 */   // Label 3853: @193843
     /* 193843 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(193880), // Rule ID 11766 //
     /* 193848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 193856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 193872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193878 */     GIR_RootConstrainSelectedInstOperands,
     /* 193879 */     // GIR_Coverage, 11766,
     /* 193879 */     GIR_EraseRootFromParent_Done,
     /* 193880 */   // Label 3854: @193880
     /* 193880 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(193917), // Rule ID 11767 //
     /* 193885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 193909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193915 */     GIR_RootConstrainSelectedInstOperands,
     /* 193916 */     // GIR_Coverage, 11767,
     /* 193916 */     GIR_EraseRootFromParent_Done,
     /* 193917 */   // Label 3855: @193917
     /* 193917 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(193954), // Rule ID 11768 //
     /* 193922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 193946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193952 */     GIR_RootConstrainSelectedInstOperands,
     /* 193953 */     // GIR_Coverage, 11768,
     /* 193953 */     GIR_EraseRootFromParent_Done,
     /* 193954 */   // Label 3856: @193954
     /* 193954 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(193991), // Rule ID 11769 //
     /* 193959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 193967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193980 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 193983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193989 */     GIR_RootConstrainSelectedInstOperands,
     /* 193990 */     // GIR_Coverage, 11769,
     /* 193990 */     GIR_EraseRootFromParent_Done,
     /* 193991 */   // Label 3857: @193991
     /* 193991 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194031), // Rule ID 11844 //
     /* 193996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194017 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 194020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194029 */     GIR_RootConstrainSelectedInstOperands,
     /* 194030 */     // GIR_Coverage, 11844,
     /* 194030 */     GIR_EraseRootFromParent_Done,
     /* 194031 */   // Label 3858: @194031
     /* 194031 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194071), // Rule ID 11845 //
     /* 194036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194057 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 194060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194069 */     GIR_RootConstrainSelectedInstOperands,
     /* 194070 */     // GIR_Coverage, 11845,
     /* 194070 */     GIR_EraseRootFromParent_Done,
     /* 194071 */   // Label 3859: @194071
     /* 194071 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194111), // Rule ID 11846 //
     /* 194076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194097 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 194100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194109 */     GIR_RootConstrainSelectedInstOperands,
     /* 194110 */     // GIR_Coverage, 11846,
     /* 194110 */     GIR_EraseRootFromParent_Done,
     /* 194111 */   // Label 3860: @194111
     /* 194111 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194151), // Rule ID 11847 //
     /* 194116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194137 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 194140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194149 */     GIR_RootConstrainSelectedInstOperands,
     /* 194150 */     // GIR_Coverage, 11847,
     /* 194150 */     GIR_EraseRootFromParent_Done,
     /* 194151 */   // Label 3861: @194151
     /* 194151 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194191), // Rule ID 11848 //
     /* 194156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194177 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 194180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194189 */     GIR_RootConstrainSelectedInstOperands,
     /* 194190 */     // GIR_Coverage, 11848,
     /* 194190 */     GIR_EraseRootFromParent_Done,
     /* 194191 */   // Label 3862: @194191
     /* 194191 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194231), // Rule ID 11849 //
     /* 194196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194217 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 194220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194229 */     GIR_RootConstrainSelectedInstOperands,
     /* 194230 */     // GIR_Coverage, 11849,
     /* 194230 */     GIR_EraseRootFromParent_Done,
     /* 194231 */   // Label 3863: @194231
     /* 194231 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(194271), // Rule ID 11850 //
     /* 194236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 194260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194269 */     GIR_RootConstrainSelectedInstOperands,
     /* 194270 */     // GIR_Coverage, 11850,
     /* 194270 */     GIR_EraseRootFromParent_Done,
     /* 194271 */   // Label 3864: @194271
     /* 194271 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(194311), // Rule ID 11851 //
     /* 194276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194297 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 194300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194309 */     GIR_RootConstrainSelectedInstOperands,
     /* 194310 */     // GIR_Coverage, 11851,
     /* 194310 */     GIR_EraseRootFromParent_Done,
     /* 194311 */   // Label 3865: @194311
     /* 194311 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(194351), // Rule ID 11856 //
     /* 194316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194337 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 194340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194349 */     GIR_RootConstrainSelectedInstOperands,
     /* 194350 */     // GIR_Coverage, 11856,
     /* 194350 */     GIR_EraseRootFromParent_Done,
     /* 194351 */   // Label 3866: @194351
     /* 194351 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(194391), // Rule ID 11857 //
     /* 194356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194377 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 194380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194389 */     GIR_RootConstrainSelectedInstOperands,
     /* 194390 */     // GIR_Coverage, 11857,
     /* 194390 */     GIR_EraseRootFromParent_Done,
     /* 194391 */   // Label 3867: @194391
     /* 194391 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(194431), // Rule ID 11858 //
     /* 194396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194417 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 194420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194429 */     GIR_RootConstrainSelectedInstOperands,
     /* 194430 */     // GIR_Coverage, 11858,
     /* 194430 */     GIR_EraseRootFromParent_Done,
     /* 194431 */   // Label 3868: @194431
     /* 194431 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(194471), // Rule ID 11859 //
     /* 194436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194457 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 194460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194469 */     GIR_RootConstrainSelectedInstOperands,
     /* 194470 */     // GIR_Coverage, 11859,
     /* 194470 */     GIR_EraseRootFromParent_Done,
     /* 194471 */   // Label 3869: @194471
     /* 194471 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(194511), // Rule ID 11860 //
     /* 194476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194497 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 194500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194509 */     GIR_RootConstrainSelectedInstOperands,
     /* 194510 */     // GIR_Coverage, 11860,
     /* 194510 */     GIR_EraseRootFromParent_Done,
     /* 194511 */   // Label 3870: @194511
     /* 194511 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(194551), // Rule ID 11861 //
     /* 194516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194537 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 194540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194549 */     GIR_RootConstrainSelectedInstOperands,
     /* 194550 */     // GIR_Coverage, 11861,
     /* 194550 */     GIR_EraseRootFromParent_Done,
     /* 194551 */   // Label 3871: @194551
     /* 194551 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(194591), // Rule ID 11862 //
     /* 194556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194577 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 194580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194589 */     GIR_RootConstrainSelectedInstOperands,
     /* 194590 */     // GIR_Coverage, 11862,
     /* 194590 */     GIR_EraseRootFromParent_Done,
     /* 194591 */   // Label 3872: @194591
     /* 194591 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194631), // Rule ID 11863 //
     /* 194596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 194604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194617 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 194620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194629 */     GIR_RootConstrainSelectedInstOperands,
     /* 194630 */     // GIR_Coverage, 11863,
     /* 194630 */     GIR_EraseRootFromParent_Done,
     /* 194631 */   // Label 3873: @194631
     /* 194631 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194671), // Rule ID 11868 //
     /* 194636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194657 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 194660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194669 */     GIR_RootConstrainSelectedInstOperands,
     /* 194670 */     // GIR_Coverage, 11868,
     /* 194670 */     GIR_EraseRootFromParent_Done,
     /* 194671 */   // Label 3874: @194671
     /* 194671 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194711), // Rule ID 11869 //
     /* 194676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194697 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 194700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194709 */     GIR_RootConstrainSelectedInstOperands,
     /* 194710 */     // GIR_Coverage, 11869,
     /* 194710 */     GIR_EraseRootFromParent_Done,
     /* 194711 */   // Label 3875: @194711
     /* 194711 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194751), // Rule ID 11870 //
     /* 194716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194737 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 194740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194749 */     GIR_RootConstrainSelectedInstOperands,
     /* 194750 */     // GIR_Coverage, 11870,
     /* 194750 */     GIR_EraseRootFromParent_Done,
     /* 194751 */   // Label 3876: @194751
     /* 194751 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(194791), // Rule ID 11871 //
     /* 194756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194777 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 194780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194789 */     GIR_RootConstrainSelectedInstOperands,
     /* 194790 */     // GIR_Coverage, 11871,
     /* 194790 */     GIR_EraseRootFromParent_Done,
     /* 194791 */   // Label 3877: @194791
     /* 194791 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(194831), // Rule ID 11872 //
     /* 194796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194817 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 194820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194829 */     GIR_RootConstrainSelectedInstOperands,
     /* 194830 */     // GIR_Coverage, 11872,
     /* 194830 */     GIR_EraseRootFromParent_Done,
     /* 194831 */   // Label 3878: @194831
     /* 194831 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(194871), // Rule ID 11873 //
     /* 194836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 194860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194869 */     GIR_RootConstrainSelectedInstOperands,
     /* 194870 */     // GIR_Coverage, 11873,
     /* 194870 */     GIR_EraseRootFromParent_Done,
     /* 194871 */   // Label 3879: @194871
     /* 194871 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(194911), // Rule ID 11874 //
     /* 194876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194897 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 194900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194909 */     GIR_RootConstrainSelectedInstOperands,
     /* 194910 */     // GIR_Coverage, 11874,
     /* 194910 */     GIR_EraseRootFromParent_Done,
     /* 194911 */   // Label 3880: @194911
     /* 194911 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(194951), // Rule ID 11875 //
     /* 194916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194937 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 194940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194949 */     GIR_RootConstrainSelectedInstOperands,
     /* 194950 */     // GIR_Coverage, 11875,
     /* 194950 */     GIR_EraseRootFromParent_Done,
     /* 194951 */   // Label 3881: @194951
     /* 194951 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(194991), // Rule ID 11880 //
     /* 194956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194977 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 194977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 194980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194989 */     GIR_RootConstrainSelectedInstOperands,
     /* 194990 */     // GIR_Coverage, 11880,
     /* 194990 */     GIR_EraseRootFromParent_Done,
     /* 194991 */   // Label 3882: @194991
     /* 194991 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195031), // Rule ID 11881 //
     /* 194996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195017 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 195020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195029 */     GIR_RootConstrainSelectedInstOperands,
     /* 195030 */     // GIR_Coverage, 11881,
     /* 195030 */     GIR_EraseRootFromParent_Done,
     /* 195031 */   // Label 3883: @195031
     /* 195031 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195071), // Rule ID 11882 //
     /* 195036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195057 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 195060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195069 */     GIR_RootConstrainSelectedInstOperands,
     /* 195070 */     // GIR_Coverage, 11882,
     /* 195070 */     GIR_EraseRootFromParent_Done,
     /* 195071 */   // Label 3884: @195071
     /* 195071 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195111), // Rule ID 11883 //
     /* 195076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195097 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 195100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195109 */     GIR_RootConstrainSelectedInstOperands,
     /* 195110 */     // GIR_Coverage, 11883,
     /* 195110 */     GIR_EraseRootFromParent_Done,
     /* 195111 */   // Label 3885: @195111
     /* 195111 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195151), // Rule ID 11884 //
     /* 195116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195137 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 195140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195149 */     GIR_RootConstrainSelectedInstOperands,
     /* 195150 */     // GIR_Coverage, 11884,
     /* 195150 */     GIR_EraseRootFromParent_Done,
     /* 195151 */   // Label 3886: @195151
     /* 195151 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195191), // Rule ID 11885 //
     /* 195156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195177 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 195180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195189 */     GIR_RootConstrainSelectedInstOperands,
     /* 195190 */     // GIR_Coverage, 11885,
     /* 195190 */     GIR_EraseRootFromParent_Done,
     /* 195191 */   // Label 3887: @195191
     /* 195191 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195231), // Rule ID 11886 //
     /* 195196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195217 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 195220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195229 */     GIR_RootConstrainSelectedInstOperands,
     /* 195230 */     // GIR_Coverage, 11886,
     /* 195230 */     GIR_EraseRootFromParent_Done,
     /* 195231 */   // Label 3888: @195231
     /* 195231 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(195271), // Rule ID 11887 //
     /* 195236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195257 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 195260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195269 */     GIR_RootConstrainSelectedInstOperands,
     /* 195270 */     // GIR_Coverage, 11887,
     /* 195270 */     GIR_EraseRootFromParent_Done,
     /* 195271 */   // Label 3889: @195271
     /* 195271 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(195308), // Rule ID 11896 //
     /* 195276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 195284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1244:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 195300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195306 */     GIR_RootConstrainSelectedInstOperands,
     /* 195307 */     // GIR_Coverage, 11896,
     /* 195307 */     GIR_EraseRootFromParent_Done,
     /* 195308 */   // Label 3890: @195308
     /* 195308 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195345), // Rule ID 11898 //
     /* 195313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1618:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 195337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195343 */     GIR_RootConstrainSelectedInstOperands,
     /* 195344 */     // GIR_Coverage, 11898,
     /* 195344 */     GIR_EraseRootFromParent_Done,
     /* 195345 */   // Label 3891: @195345
     /* 195345 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195382), // Rule ID 11899 //
     /* 195350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 195353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 195358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 195374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195380 */     GIR_RootConstrainSelectedInstOperands,
     /* 195381 */     // GIR_Coverage, 11899,
     /* 195381 */     GIR_EraseRootFromParent_Done,
     /* 195382 */   // Label 3892: @195382
     /* 195382 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195419), // Rule ID 11900 //
     /* 195387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 195390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 195395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1650:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 195411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195417 */     GIR_RootConstrainSelectedInstOperands,
     /* 195418 */     // GIR_Coverage, 11900,
     /* 195418 */     GIR_EraseRootFromParent_Done,
     /* 195419 */   // Label 3893: @195419
     /* 195419 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195456), // Rule ID 11901 //
     /* 195424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195445 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 195448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195454 */     GIR_RootConstrainSelectedInstOperands,
     /* 195455 */     // GIR_Coverage, 11901,
     /* 195455 */     GIR_EraseRootFromParent_Done,
     /* 195456 */   // Label 3894: @195456
     /* 195456 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195493), // Rule ID 11902 //
     /* 195461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 195485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195491 */     GIR_RootConstrainSelectedInstOperands,
     /* 195492 */     // GIR_Coverage, 11902,
     /* 195492 */     GIR_EraseRootFromParent_Done,
     /* 195493 */   // Label 3895: @195493
     /* 195493 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195530), // Rule ID 11903 //
     /* 195498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 195522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195528 */     GIR_RootConstrainSelectedInstOperands,
     /* 195529 */     // GIR_Coverage, 11903,
     /* 195529 */     GIR_EraseRootFromParent_Done,
     /* 195530 */   // Label 3896: @195530
     /* 195530 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195567), // Rule ID 11904 //
     /* 195535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 195559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195565 */     GIR_RootConstrainSelectedInstOperands,
     /* 195566 */     // GIR_Coverage, 11904,
     /* 195566 */     GIR_EraseRootFromParent_Done,
     /* 195567 */   // Label 3897: @195567
     /* 195567 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195604), // Rule ID 11905 //
     /* 195572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195593 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1275:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 195596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195602 */     GIR_RootConstrainSelectedInstOperands,
     /* 195603 */     // GIR_Coverage, 11905,
     /* 195603 */     GIR_EraseRootFromParent_Done,
     /* 195604 */   // Label 3898: @195604
     /* 195604 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195641), // Rule ID 11906 //
     /* 195609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 195620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 195623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1275:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 195630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 195633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195639 */     GIR_RootConstrainSelectedInstOperands,
     /* 195640 */     // GIR_Coverage, 11906,
     /* 195640 */     GIR_EraseRootFromParent_Done,
     /* 195641 */   // Label 3899: @195641
     /* 195641 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195678), // Rule ID 11907 //
     /* 195646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1275:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 195670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195676 */     GIR_RootConstrainSelectedInstOperands,
     /* 195677 */     // GIR_Coverage, 11907,
     /* 195677 */     GIR_EraseRootFromParent_Done,
     /* 195678 */   // Label 3900: @195678
     /* 195678 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195715), // Rule ID 11908 //
     /* 195683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 195691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1275:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 195707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195713 */     GIR_RootConstrainSelectedInstOperands,
     /* 195714 */     // GIR_Coverage, 11908,
     /* 195714 */     GIR_EraseRootFromParent_Done,
     /* 195715 */   // Label 3901: @195715
     /* 195715 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195752), // Rule ID 12021 //
     /* 195720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195741 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 195744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195750 */     GIR_RootConstrainSelectedInstOperands,
     /* 195751 */     // GIR_Coverage, 12021,
     /* 195751 */     GIR_EraseRootFromParent_Done,
     /* 195752 */   // Label 3902: @195752
     /* 195752 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(195789), // Rule ID 12022 //
     /* 195757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195778 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 195781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195787 */     GIR_RootConstrainSelectedInstOperands,
     /* 195788 */     // GIR_Coverage, 12022,
     /* 195788 */     GIR_EraseRootFromParent_Done,
     /* 195789 */   // Label 3903: @195789
     /* 195789 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(195826), // Rule ID 12023 //
     /* 195794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 195802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195815 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 195818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195824 */     GIR_RootConstrainSelectedInstOperands,
     /* 195825 */     // GIR_Coverage, 12023,
     /* 195825 */     GIR_EraseRootFromParent_Done,
     /* 195826 */   // Label 3904: @195826
     /* 195826 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(195863), // Rule ID 12024 //
     /* 195831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195852 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1442:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 195855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195861 */     GIR_RootConstrainSelectedInstOperands,
     /* 195862 */     // GIR_Coverage, 12024,
     /* 195862 */     GIR_EraseRootFromParent_Done,
     /* 195863 */   // Label 3905: @195863
     /* 195863 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(195900), // Rule ID 12025 //
     /* 195868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195889 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1442:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 195889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 195892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195898 */     GIR_RootConstrainSelectedInstOperands,
     /* 195899 */     // GIR_Coverage, 12025,
     /* 195899 */     GIR_EraseRootFromParent_Done,
     /* 195900 */   // Label 3906: @195900
     /* 195900 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(195937), // Rule ID 12026 //
     /* 195905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 195913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 195919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195926 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1442:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 195926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 195929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195935 */     GIR_RootConstrainSelectedInstOperands,
     /* 195936 */     // GIR_Coverage, 12026,
     /* 195936 */     GIR_EraseRootFromParent_Done,
     /* 195937 */   // Label 3907: @195937
     /* 195937 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(195974), // Rule ID 12027 //
     /* 195942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 195950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 195956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 195959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195963 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1427:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 195963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 195966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 195968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195972 */     GIR_RootConstrainSelectedInstOperands,
     /* 195973 */     // GIR_Coverage, 12027,
     /* 195973 */     GIR_EraseRootFromParent_Done,
     /* 195974 */   // Label 3908: @195974
     /* 195974 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196011), // Rule ID 12028 //
     /* 195979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 195982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 195987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 195993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196000 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1427:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 196003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196009 */     GIR_RootConstrainSelectedInstOperands,
     /* 196010 */     // GIR_Coverage, 12028,
     /* 196010 */     GIR_EraseRootFromParent_Done,
     /* 196011 */   // Label 3909: @196011
     /* 196011 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196048), // Rule ID 12029 //
     /* 196016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196037 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1427:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 196040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196046 */     GIR_RootConstrainSelectedInstOperands,
     /* 196047 */     // GIR_Coverage, 12029,
     /* 196047 */     GIR_EraseRootFromParent_Done,
     /* 196048 */   // Label 3910: @196048
     /* 196048 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196085), // Rule ID 12030 //
     /* 196053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196074 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 196077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196083 */     GIR_RootConstrainSelectedInstOperands,
     /* 196084 */     // GIR_Coverage, 12030,
     /* 196084 */     GIR_EraseRootFromParent_Done,
     /* 196085 */   // Label 3911: @196085
     /* 196085 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196122), // Rule ID 12031 //
     /* 196090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196111 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 196114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196120 */     GIR_RootConstrainSelectedInstOperands,
     /* 196121 */     // GIR_Coverage, 12031,
     /* 196121 */     GIR_EraseRootFromParent_Done,
     /* 196122 */   // Label 3912: @196122
     /* 196122 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196159), // Rule ID 12032 //
     /* 196127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196148 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 196151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196157 */     GIR_RootConstrainSelectedInstOperands,
     /* 196158 */     // GIR_Coverage, 12032,
     /* 196158 */     GIR_EraseRootFromParent_Done,
     /* 196159 */   // Label 3913: @196159
     /* 196159 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196196), // Rule ID 12033 //
     /* 196164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196185 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1339:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 196188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196194 */     GIR_RootConstrainSelectedInstOperands,
     /* 196195 */     // GIR_Coverage, 12033,
     /* 196195 */     GIR_EraseRootFromParent_Done,
     /* 196196 */   // Label 3914: @196196
     /* 196196 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196233), // Rule ID 12034 //
     /* 196201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196222 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1339:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 196225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196231 */     GIR_RootConstrainSelectedInstOperands,
     /* 196232 */     // GIR_Coverage, 12034,
     /* 196232 */     GIR_EraseRootFromParent_Done,
     /* 196233 */   // Label 3915: @196233
     /* 196233 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196270), // Rule ID 12035 //
     /* 196238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196259 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1339:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 196262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196268 */     GIR_RootConstrainSelectedInstOperands,
     /* 196269 */     // GIR_Coverage, 12035,
     /* 196269 */     GIR_EraseRootFromParent_Done,
     /* 196270 */   // Label 3916: @196270
     /* 196270 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196307), // Rule ID 12036 //
     /* 196275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196296 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1339:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 196299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196305 */     GIR_RootConstrainSelectedInstOperands,
     /* 196306 */     // GIR_Coverage, 12036,
     /* 196306 */     GIR_EraseRootFromParent_Done,
     /* 196307 */   // Label 3917: @196307
     /* 196307 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196344), // Rule ID 12037 //
     /* 196312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196333 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1251:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 196336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196342 */     GIR_RootConstrainSelectedInstOperands,
     /* 196343 */     // GIR_Coverage, 12037,
     /* 196343 */     GIR_EraseRootFromParent_Done,
     /* 196344 */   // Label 3918: @196344
     /* 196344 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196381), // Rule ID 12038 //
     /* 196349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196370 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1251:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 196373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196379 */     GIR_RootConstrainSelectedInstOperands,
     /* 196380 */     // GIR_Coverage, 12038,
     /* 196380 */     GIR_EraseRootFromParent_Done,
     /* 196381 */   // Label 3919: @196381
     /* 196381 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196418), // Rule ID 12039 //
     /* 196386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196407 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1251:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 196410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196416 */     GIR_RootConstrainSelectedInstOperands,
     /* 196417 */     // GIR_Coverage, 12039,
     /* 196417 */     GIR_EraseRootFromParent_Done,
     /* 196418 */   // Label 3920: @196418
     /* 196418 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196455), // Rule ID 12040 //
     /* 196423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1251:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 196447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196453 */     GIR_RootConstrainSelectedInstOperands,
     /* 196454 */     // GIR_Coverage, 12040,
     /* 196454 */     GIR_EraseRootFromParent_Done,
     /* 196455 */   // Label 3921: @196455
     /* 196455 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(196492), // Rule ID 12041 //
     /* 196460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196481 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1239:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 196484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196490 */     GIR_RootConstrainSelectedInstOperands,
     /* 196491 */     // GIR_Coverage, 12041,
     /* 196491 */     GIR_EraseRootFromParent_Done,
     /* 196492 */   // Label 3922: @196492
     /* 196492 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(196529), // Rule ID 12042 //
     /* 196497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196518 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1239:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 196521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196527 */     GIR_RootConstrainSelectedInstOperands,
     /* 196528 */     // GIR_Coverage, 12042,
     /* 196528 */     GIR_EraseRootFromParent_Done,
     /* 196529 */   // Label 3923: @196529
     /* 196529 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(196566), // Rule ID 12043 //
     /* 196534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196555 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1239:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 196558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196564 */     GIR_RootConstrainSelectedInstOperands,
     /* 196565 */     // GIR_Coverage, 12043,
     /* 196565 */     GIR_EraseRootFromParent_Done,
     /* 196566 */   // Label 3924: @196566
     /* 196566 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(196603), // Rule ID 12044 //
     /* 196571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 196579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196592 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1239:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 196595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196601 */     GIR_RootConstrainSelectedInstOperands,
     /* 196602 */     // GIR_Coverage, 12044,
     /* 196602 */     GIR_EraseRootFromParent_Done,
     /* 196603 */   // Label 3925: @196603
     /* 196603 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(196640), // Rule ID 12045 //
     /* 196608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196629 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1718:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 196632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196638 */     GIR_RootConstrainSelectedInstOperands,
     /* 196639 */     // GIR_Coverage, 12045,
     /* 196639 */     GIR_EraseRootFromParent_Done,
     /* 196640 */   // Label 3926: @196640
     /* 196640 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(196677), // Rule ID 12046 //
     /* 196645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196666 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1718:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 196669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196675 */     GIR_RootConstrainSelectedInstOperands,
     /* 196676 */     // GIR_Coverage, 12046,
     /* 196676 */     GIR_EraseRootFromParent_Done,
     /* 196677 */   // Label 3927: @196677
     /* 196677 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196714), // Rule ID 12047 //
     /* 196682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196703 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1718:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 196706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196712 */     GIR_RootConstrainSelectedInstOperands,
     /* 196713 */     // GIR_Coverage, 12047,
     /* 196713 */     GIR_EraseRootFromParent_Done,
     /* 196714 */   // Label 3928: @196714
     /* 196714 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196751), // Rule ID 12048 //
     /* 196719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 196727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196740 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1718:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 196743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196749 */     GIR_RootConstrainSelectedInstOperands,
     /* 196750 */     // GIR_Coverage, 12048,
     /* 196750 */     GIR_EraseRootFromParent_Done,
     /* 196751 */   // Label 3929: @196751
     /* 196751 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(196788), // Rule ID 12049 //
     /* 196756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196777 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1956:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 196780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196786 */     GIR_RootConstrainSelectedInstOperands,
     /* 196787 */     // GIR_Coverage, 12049,
     /* 196787 */     GIR_EraseRootFromParent_Done,
     /* 196788 */   // Label 3930: @196788
     /* 196788 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(196825), // Rule ID 12050 //
     /* 196793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196814 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1956:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 196817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196823 */     GIR_RootConstrainSelectedInstOperands,
     /* 196824 */     // GIR_Coverage, 12050,
     /* 196824 */     GIR_EraseRootFromParent_Done,
     /* 196825 */   // Label 3931: @196825
     /* 196825 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(196862), // Rule ID 12051 //
     /* 196830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196851 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1956:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 196854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196860 */     GIR_RootConstrainSelectedInstOperands,
     /* 196861 */     // GIR_Coverage, 12051,
     /* 196861 */     GIR_EraseRootFromParent_Done,
     /* 196862 */   // Label 3932: @196862
     /* 196862 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(196899), // Rule ID 12052 //
     /* 196867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 196875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196888 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1956:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 196891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196897 */     GIR_RootConstrainSelectedInstOperands,
     /* 196898 */     // GIR_Coverage, 12052,
     /* 196898 */     GIR_EraseRootFromParent_Done,
     /* 196899 */   // Label 3933: @196899
     /* 196899 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(196936), // Rule ID 12053 //
     /* 196904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196925 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 196928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196934 */     GIR_RootConstrainSelectedInstOperands,
     /* 196935 */     // GIR_Coverage, 12053,
     /* 196935 */     GIR_EraseRootFromParent_Done,
     /* 196936 */   // Label 3934: @196936
     /* 196936 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(196973), // Rule ID 12054 //
     /* 196941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196962 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 196965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196971 */     GIR_RootConstrainSelectedInstOperands,
     /* 196972 */     // GIR_Coverage, 12054,
     /* 196972 */     GIR_EraseRootFromParent_Done,
     /* 196973 */   // Label 3935: @196973
     /* 196973 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197010), // Rule ID 12055 //
     /* 196978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 196986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196999 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 197002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197008 */     GIR_RootConstrainSelectedInstOperands,
     /* 197009 */     // GIR_Coverage, 12055,
     /* 197009 */     GIR_EraseRootFromParent_Done,
     /* 197010 */   // Label 3936: @197010
     /* 197010 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197047), // Rule ID 12056 //
     /* 197015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197036 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 197039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197045 */     GIR_RootConstrainSelectedInstOperands,
     /* 197046 */     // GIR_Coverage, 12056,
     /* 197046 */     GIR_EraseRootFromParent_Done,
     /* 197047 */   // Label 3937: @197047
     /* 197047 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197084), // Rule ID 12057 //
     /* 197052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197073 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1965:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 197076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197082 */     GIR_RootConstrainSelectedInstOperands,
     /* 197083 */     // GIR_Coverage, 12057,
     /* 197083 */     GIR_EraseRootFromParent_Done,
     /* 197084 */   // Label 3938: @197084
     /* 197084 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197121), // Rule ID 12058 //
     /* 197089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197110 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1965:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 197113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197119 */     GIR_RootConstrainSelectedInstOperands,
     /* 197120 */     // GIR_Coverage, 12058,
     /* 197120 */     GIR_EraseRootFromParent_Done,
     /* 197121 */   // Label 3939: @197121
     /* 197121 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197158), // Rule ID 12059 //
     /* 197126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197147 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1965:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 197150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197156 */     GIR_RootConstrainSelectedInstOperands,
     /* 197157 */     // GIR_Coverage, 12059,
     /* 197157 */     GIR_EraseRootFromParent_Done,
     /* 197158 */   // Label 3940: @197158
     /* 197158 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197195), // Rule ID 12060 //
     /* 197163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197184 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1965:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 197187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197193 */     GIR_RootConstrainSelectedInstOperands,
     /* 197194 */     // GIR_Coverage, 12060,
     /* 197194 */     GIR_EraseRootFromParent_Done,
     /* 197195 */   // Label 3941: @197195
     /* 197195 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197232), // Rule ID 12061 //
     /* 197200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197221 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2149:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 197224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197230 */     GIR_RootConstrainSelectedInstOperands,
     /* 197231 */     // GIR_Coverage, 12061,
     /* 197231 */     GIR_EraseRootFromParent_Done,
     /* 197232 */   // Label 3942: @197232
     /* 197232 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197269), // Rule ID 12062 //
     /* 197237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2149:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197267 */     GIR_RootConstrainSelectedInstOperands,
     /* 197268 */     // GIR_Coverage, 12062,
     /* 197268 */     GIR_EraseRootFromParent_Done,
     /* 197269 */   // Label 3943: @197269
     /* 197269 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197306), // Rule ID 12063 //
     /* 197274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2149:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197304 */     GIR_RootConstrainSelectedInstOperands,
     /* 197305 */     // GIR_Coverage, 12063,
     /* 197305 */     GIR_EraseRootFromParent_Done,
     /* 197306 */   // Label 3944: @197306
     /* 197306 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197343), // Rule ID 12064 //
     /* 197311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2149:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197341 */     GIR_RootConstrainSelectedInstOperands,
     /* 197342 */     // GIR_Coverage, 12064,
     /* 197342 */     GIR_EraseRootFromParent_Done,
     /* 197343 */   // Label 3945: @197343
     /* 197343 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197380), // Rule ID 12065 //
     /* 197348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197369 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2149:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197378 */     GIR_RootConstrainSelectedInstOperands,
     /* 197379 */     // GIR_Coverage, 12065,
     /* 197379 */     GIR_EraseRootFromParent_Done,
     /* 197380 */   // Label 3946: @197380
     /* 197380 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(197417), // Rule ID 12066 //
     /* 197385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2149:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197415 */     GIR_RootConstrainSelectedInstOperands,
     /* 197416 */     // GIR_Coverage, 12066,
     /* 197416 */     GIR_EraseRootFromParent_Done,
     /* 197417 */   // Label 3947: @197417
     /* 197417 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(197454), // Rule ID 12067 //
     /* 197422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197443 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2149:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197452 */     GIR_RootConstrainSelectedInstOperands,
     /* 197453 */     // GIR_Coverage, 12067,
     /* 197453 */     GIR_EraseRootFromParent_Done,
     /* 197454 */   // Label 3948: @197454
     /* 197454 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(197491), // Rule ID 12068 //
     /* 197459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2074:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 197483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197489 */     GIR_RootConstrainSelectedInstOperands,
     /* 197490 */     // GIR_Coverage, 12068,
     /* 197490 */     GIR_EraseRootFromParent_Done,
     /* 197491 */   // Label 3949: @197491
     /* 197491 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(197528), // Rule ID 12069 //
     /* 197496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2074:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 197520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197526 */     GIR_RootConstrainSelectedInstOperands,
     /* 197527 */     // GIR_Coverage, 12069,
     /* 197527 */     GIR_EraseRootFromParent_Done,
     /* 197528 */   // Label 3950: @197528
     /* 197528 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(197565), // Rule ID 12070 //
     /* 197533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2074:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 197557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197563 */     GIR_RootConstrainSelectedInstOperands,
     /* 197564 */     // GIR_Coverage, 12070,
     /* 197564 */     GIR_EraseRootFromParent_Done,
     /* 197565 */   // Label 3951: @197565
     /* 197565 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(197602), // Rule ID 12071 //
     /* 197570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2074:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 197594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197600 */     GIR_RootConstrainSelectedInstOperands,
     /* 197601 */     // GIR_Coverage, 12071,
     /* 197601 */     GIR_EraseRootFromParent_Done,
     /* 197602 */   // Label 3952: @197602
     /* 197602 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(197639), // Rule ID 12072 //
     /* 197607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197628 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2074:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 197631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197637 */     GIR_RootConstrainSelectedInstOperands,
     /* 197638 */     // GIR_Coverage, 12072,
     /* 197638 */     GIR_EraseRootFromParent_Done,
     /* 197639 */   // Label 3953: @197639
     /* 197639 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(197676), // Rule ID 12073 //
     /* 197644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197665 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2074:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 197668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197674 */     GIR_RootConstrainSelectedInstOperands,
     /* 197675 */     // GIR_Coverage, 12073,
     /* 197675 */     GIR_EraseRootFromParent_Done,
     /* 197676 */   // Label 3954: @197676
     /* 197676 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(197713), // Rule ID 12074 //
     /* 197681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 197689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197702 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2074:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 197705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197711 */     GIR_RootConstrainSelectedInstOperands,
     /* 197712 */     // GIR_Coverage, 12074,
     /* 197712 */     GIR_EraseRootFromParent_Done,
     /* 197713 */   // Label 3955: @197713
     /* 197713 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(197750), // Rule ID 12075 //
     /* 197718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197739 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2075:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 197742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197748 */     GIR_RootConstrainSelectedInstOperands,
     /* 197749 */     // GIR_Coverage, 12075,
     /* 197749 */     GIR_EraseRootFromParent_Done,
     /* 197750 */   // Label 3956: @197750
     /* 197750 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(197787), // Rule ID 12076 //
     /* 197755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2075:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197785 */     GIR_RootConstrainSelectedInstOperands,
     /* 197786 */     // GIR_Coverage, 12076,
     /* 197786 */     GIR_EraseRootFromParent_Done,
     /* 197787 */   // Label 3957: @197787
     /* 197787 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(197824), // Rule ID 12077 //
     /* 197792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197813 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2075:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197822 */     GIR_RootConstrainSelectedInstOperands,
     /* 197823 */     // GIR_Coverage, 12077,
     /* 197823 */     GIR_EraseRootFromParent_Done,
     /* 197824 */   // Label 3958: @197824
     /* 197824 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(197861), // Rule ID 12078 //
     /* 197829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2075:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 197853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197859 */     GIR_RootConstrainSelectedInstOperands,
     /* 197860 */     // GIR_Coverage, 12078,
     /* 197860 */     GIR_EraseRootFromParent_Done,
     /* 197861 */   // Label 3959: @197861
     /* 197861 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(197898), // Rule ID 12079 //
     /* 197866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197887 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2075:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 197890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197896 */     GIR_RootConstrainSelectedInstOperands,
     /* 197897 */     // GIR_Coverage, 12079,
     /* 197897 */     GIR_EraseRootFromParent_Done,
     /* 197898 */   // Label 3960: @197898
     /* 197898 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(197935), // Rule ID 12080 //
     /* 197903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2075:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 197927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197933 */     GIR_RootConstrainSelectedInstOperands,
     /* 197934 */     // GIR_Coverage, 12080,
     /* 197934 */     GIR_EraseRootFromParent_Done,
     /* 197935 */   // Label 3961: @197935
     /* 197935 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(197972), // Rule ID 12081 //
     /* 197940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 197948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197961 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2075:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 197964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197970 */     GIR_RootConstrainSelectedInstOperands,
     /* 197971 */     // GIR_Coverage, 12081,
     /* 197971 */     GIR_EraseRootFromParent_Done,
     /* 197972 */   // Label 3962: @197972
     /* 197972 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198014), // Rule ID 3218 //
     /* 197977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 197980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 197985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 197988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 197992 */     // MIs[0] Op1
     /* 197992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 197996 */     // MIs[0] Op2
     /* 197996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2128:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 198003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198012 */     GIR_RootConstrainSelectedInstOperands,
     /* 198013 */     // GIR_Coverage, 3218,
     /* 198013 */     GIR_EraseRootFromParent_Done,
     /* 198014 */   // Label 3963: @198014
     /* 198014 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198056), // Rule ID 3219 //
     /* 198019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 198027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198034 */     // MIs[0] Op1
     /* 198034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198038 */     // MIs[0] Op2
     /* 198038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198042 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2130:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 198045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198054 */     GIR_RootConstrainSelectedInstOperands,
     /* 198055 */     // GIR_Coverage, 3219,
     /* 198055 */     GIR_EraseRootFromParent_Done,
     /* 198056 */   // Label 3964: @198056
     /* 198056 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198098), // Rule ID 3220 //
     /* 198061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 198069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198076 */     // MIs[0] Op1
     /* 198076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198080 */     // MIs[0] Op2
     /* 198080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2131:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 198087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198096 */     GIR_RootConstrainSelectedInstOperands,
     /* 198097 */     // GIR_Coverage, 3220,
     /* 198097 */     GIR_EraseRootFromParent_Done,
     /* 198098 */   // Label 3965: @198098
     /* 198098 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198140), // Rule ID 3221 //
     /* 198103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 198111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198118 */     // MIs[0] Op1
     /* 198118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198122 */     // MIs[0] Op2
     /* 198122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2129:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 198129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198138 */     GIR_RootConstrainSelectedInstOperands,
     /* 198139 */     // GIR_Coverage, 3221,
     /* 198139 */     GIR_EraseRootFromParent_Done,
     /* 198140 */   // Label 3966: @198140
     /* 198140 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198182), // Rule ID 11892 //
     /* 198145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 198153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198160 */     // MIs[0] Op1
     /* 198160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198164 */     // MIs[0] Op2
     /* 198164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 198171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198180 */     GIR_RootConstrainSelectedInstOperands,
     /* 198181 */     // GIR_Coverage, 11892,
     /* 198181 */     GIR_EraseRootFromParent_Done,
     /* 198182 */   // Label 3967: @198182
     /* 198182 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198224), // Rule ID 11893 //
     /* 198187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 198195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198202 */     // MIs[0] Op1
     /* 198202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198206 */     // MIs[0] Op2
     /* 198206 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 198213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198222 */     GIR_RootConstrainSelectedInstOperands,
     /* 198223 */     // GIR_Coverage, 11893,
     /* 198223 */     GIR_EraseRootFromParent_Done,
     /* 198224 */   // Label 3968: @198224
     /* 198224 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198266), // Rule ID 11894 //
     /* 198229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 198237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198244 */     // MIs[0] Op1
     /* 198244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198248 */     // MIs[0] Op2
     /* 198248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198252 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2127:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 198255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198264 */     GIR_RootConstrainSelectedInstOperands,
     /* 198265 */     // GIR_Coverage, 11894,
     /* 198265 */     GIR_EraseRootFromParent_Done,
     /* 198266 */   // Label 3969: @198266
     /* 198266 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198308), // Rule ID 11895 //
     /* 198271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 198279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198286 */     // MIs[0] Op1
     /* 198286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198290 */     // MIs[0] Op2
     /* 198290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198294 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2125:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 198297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198306 */     GIR_RootConstrainSelectedInstOperands,
     /* 198307 */     // GIR_Coverage, 11895,
     /* 198307 */     GIR_EraseRootFromParent_Done,
     /* 198308 */   // Label 3970: @198308
     /* 198308 */   GIM_Reject,
     /* 198309 */ // Label 3017: @198309
     /* 198309 */ GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(242092),
     /* 198314 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 198317 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(198430), // Rule ID 2069 //
     /* 198322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198395 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198399 */     // MIs[3] Operand 1
     /* 198399 */     // No operand predicates
     /* 198399 */     // MIs[1] Operand 2
     /* 198399 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198412 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 198415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198428 */     GIR_RootConstrainSelectedInstOperands,
     /* 198429 */     // GIR_Coverage, 2069,
     /* 198429 */     GIR_EraseRootFromParent_Done,
     /* 198430 */   // Label 3972: @198430
     /* 198430 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(198543), // Rule ID 2076 //
     /* 198435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198508 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198512 */     // MIs[3] Operand 1
     /* 198512 */     // No operand predicates
     /* 198512 */     // MIs[1] Operand 2
     /* 198512 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198525 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 198528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198541 */     GIR_RootConstrainSelectedInstOperands,
     /* 198542 */     // GIR_Coverage, 2076,
     /* 198542 */     GIR_EraseRootFromParent_Done,
     /* 198543 */   // Label 3973: @198543
     /* 198543 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(198656), // Rule ID 2072 //
     /* 198548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 198568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198621 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198625 */     // MIs[3] Operand 1
     /* 198625 */     // No operand predicates
     /* 198625 */     // MIs[1] Operand 2
     /* 198625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198638 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 198641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198654 */     GIR_RootConstrainSelectedInstOperands,
     /* 198655 */     // GIR_Coverage, 2072,
     /* 198655 */     GIR_EraseRootFromParent_Done,
     /* 198656 */   // Label 3974: @198656
     /* 198656 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(198769), // Rule ID 2079 //
     /* 198661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 198681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 198738 */     // MIs[3] Operand 1
     /* 198738 */     // No operand predicates
     /* 198738 */     // MIs[1] Operand 2
     /* 198738 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198751 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 198754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198767 */     GIR_RootConstrainSelectedInstOperands,
     /* 198768 */     // GIR_Coverage, 2079,
     /* 198768 */     GIR_EraseRootFromParent_Done,
     /* 198769 */   // Label 3975: @198769
     /* 198769 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(198874), // Rule ID 3859 //
     /* 198774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 198782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198847 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198851 */     // MIs[3] Operand 1
     /* 198851 */     // No operand predicates
     /* 198851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198853 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 198853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198872 */     GIR_RootConstrainSelectedInstOperands,
     /* 198873 */     // GIR_Coverage, 3859,
     /* 198873 */     GIR_EraseRootFromParent_Done,
     /* 198874 */   // Label 3976: @198874
     /* 198874 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(198979), // Rule ID 3860 //
     /* 198879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 198887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 198919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 198923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 198931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 198935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198952 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 198956 */     // MIs[3] Operand 1
     /* 198956 */     // No operand predicates
     /* 198956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198958 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 198958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 198961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198977 */     GIR_RootConstrainSelectedInstOperands,
     /* 198978 */     // GIR_Coverage, 3860,
     /* 198978 */     GIR_EraseRootFromParent_Done,
     /* 198979 */   // Label 3977: @198979
     /* 198979 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(199084), // Rule ID 3861 //
     /* 198984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 198992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199057 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199061 */     // MIs[3] Operand 1
     /* 199061 */     // No operand predicates
     /* 199061 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199063 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199082 */     GIR_RootConstrainSelectedInstOperands,
     /* 199083 */     // GIR_Coverage, 3861,
     /* 199083 */     GIR_EraseRootFromParent_Done,
     /* 199084 */   // Label 3978: @199084
     /* 199084 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(199189), // Rule ID 3862 //
     /* 199089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199145 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199149 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199162 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199166 */     // MIs[3] Operand 1
     /* 199166 */     // No operand predicates
     /* 199166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199168 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199187 */     GIR_RootConstrainSelectedInstOperands,
     /* 199188 */     // GIR_Coverage, 3862,
     /* 199188 */     GIR_EraseRootFromParent_Done,
     /* 199189 */   // Label 3979: @199189
     /* 199189 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(199294), // Rule ID 3867 //
     /* 199194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199271 */     // MIs[3] Operand 1
     /* 199271 */     // No operand predicates
     /* 199271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199273 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199292 */     GIR_RootConstrainSelectedInstOperands,
     /* 199293 */     // GIR_Coverage, 3867,
     /* 199293 */     GIR_EraseRootFromParent_Done,
     /* 199294 */   // Label 3980: @199294
     /* 199294 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199399), // Rule ID 3868 //
     /* 199299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199372 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199376 */     // MIs[3] Operand 1
     /* 199376 */     // No operand predicates
     /* 199376 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199378 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199397 */     GIR_RootConstrainSelectedInstOperands,
     /* 199398 */     // GIR_Coverage, 3868,
     /* 199398 */     GIR_EraseRootFromParent_Done,
     /* 199399 */   // Label 3981: @199399
     /* 199399 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(199504), // Rule ID 3869 //
     /* 199404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199477 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199481 */     // MIs[3] Operand 1
     /* 199481 */     // No operand predicates
     /* 199481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199483 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199502 */     GIR_RootConstrainSelectedInstOperands,
     /* 199503 */     // GIR_Coverage, 3869,
     /* 199503 */     GIR_EraseRootFromParent_Done,
     /* 199504 */   // Label 3982: @199504
     /* 199504 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(199609), // Rule ID 3870 //
     /* 199509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199582 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199586 */     // MIs[3] Operand 1
     /* 199586 */     // No operand predicates
     /* 199586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199588 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199607 */     GIR_RootConstrainSelectedInstOperands,
     /* 199608 */     // GIR_Coverage, 3870,
     /* 199608 */     GIR_EraseRootFromParent_Done,
     /* 199609 */   // Label 3983: @199609
     /* 199609 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(199714), // Rule ID 3883 //
     /* 199614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199691 */     // MIs[3] Operand 1
     /* 199691 */     // No operand predicates
     /* 199691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199693 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199712 */     GIR_RootConstrainSelectedInstOperands,
     /* 199713 */     // GIR_Coverage, 3883,
     /* 199713 */     GIR_EraseRootFromParent_Done,
     /* 199714 */   // Label 3984: @199714
     /* 199714 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(199819), // Rule ID 3884 //
     /* 199719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199792 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199796 */     // MIs[3] Operand 1
     /* 199796 */     // No operand predicates
     /* 199796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199798 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199817 */     GIR_RootConstrainSelectedInstOperands,
     /* 199818 */     // GIR_Coverage, 3884,
     /* 199818 */     GIR_EraseRootFromParent_Done,
     /* 199819 */   // Label 3985: @199819
     /* 199819 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(199924), // Rule ID 3885 //
     /* 199824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199897 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199901 */     // MIs[3] Operand 1
     /* 199901 */     // No operand predicates
     /* 199901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199903 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 199906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199922 */     GIR_RootConstrainSelectedInstOperands,
     /* 199923 */     // GIR_Coverage, 3885,
     /* 199923 */     GIR_EraseRootFromParent_Done,
     /* 199924 */   // Label 3986: @199924
     /* 199924 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200029), // Rule ID 3886 //
     /* 199929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 199932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 199949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 199981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 199985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200002 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200006 */     // MIs[3] Operand 1
     /* 200006 */     // No operand predicates
     /* 200006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200008 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200027 */     GIR_RootConstrainSelectedInstOperands,
     /* 200028 */     // GIR_Coverage, 3886,
     /* 200028 */     GIR_EraseRootFromParent_Done,
     /* 200029 */   // Label 3987: @200029
     /* 200029 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200083), // Rule ID 59 //
     /* 200034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200059 */     // MIs[0] Operand 3
     /* 200059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 200070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200074 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 200077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200081 */     GIR_RootConstrainSelectedInstOperands,
     /* 200082 */     // GIR_Coverage, 59,
     /* 200082 */     GIR_EraseRootFromParent_Done,
     /* 200083 */   // Label 3988: @200083
     /* 200083 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200137), // Rule ID 60 //
     /* 200088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200113 */     // MIs[0] Operand 3
     /* 200113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 200124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200128 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 200131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200135 */     GIR_RootConstrainSelectedInstOperands,
     /* 200136 */     // GIR_Coverage, 60,
     /* 200136 */     GIR_EraseRootFromParent_Done,
     /* 200137 */   // Label 3989: @200137
     /* 200137 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200191), // Rule ID 61 //
     /* 200142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200167 */     // MIs[0] Operand 3
     /* 200167 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 200178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200182 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 200185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200189 */     GIR_RootConstrainSelectedInstOperands,
     /* 200190 */     // GIR_Coverage, 61,
     /* 200190 */     GIR_EraseRootFromParent_Done,
     /* 200191 */   // Label 3990: @200191
     /* 200191 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200245), // Rule ID 62 //
     /* 200196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200221 */     // MIs[0] Operand 3
     /* 200221 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 200232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200236 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 200239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200243 */     GIR_RootConstrainSelectedInstOperands,
     /* 200244 */     // GIR_Coverage, 62,
     /* 200244 */     GIR_EraseRootFromParent_Done,
     /* 200245 */   // Label 3991: @200245
     /* 200245 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200301), // Rule ID 2652 //
     /* 200250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 200258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200272 */     // MIs[0] pattern
     /* 200272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200280 */     // MIs[0] imm4
     /* 200280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 200291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 200295 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200297 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200299 */     GIR_RootConstrainSelectedInstOperands,
     /* 200300 */     // GIR_Coverage, 2652,
     /* 200300 */     GIR_EraseRootFromParent_Done,
     /* 200301 */   // Label 3992: @200301
     /* 200301 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200357), // Rule ID 2661 //
     /* 200306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 200314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200328 */     // MIs[0] pattern
     /* 200328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200336 */     // MIs[0] imm4
     /* 200336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200344 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 200347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200351 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200353 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200355 */     GIR_RootConstrainSelectedInstOperands,
     /* 200356 */     // GIR_Coverage, 2661,
     /* 200356 */     GIR_EraseRootFromParent_Done,
     /* 200357 */   // Label 3993: @200357
     /* 200357 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200413), // Rule ID 2662 //
     /* 200362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 200370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200384 */     // MIs[0] pattern
     /* 200384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200392 */     // MIs[0] imm4
     /* 200392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200400 */     // (intrinsic_wo_chain:{ *:[i64] } 1792:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 200403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200407 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200409 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200411 */     GIR_RootConstrainSelectedInstOperands,
     /* 200412 */     // GIR_Coverage, 2662,
     /* 200412 */     GIR_EraseRootFromParent_Done,
     /* 200413 */   // Label 3994: @200413
     /* 200413 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200469), // Rule ID 9923 //
     /* 200418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 200426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200440 */     // MIs[0] pattern
     /* 200440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200448 */     // MIs[0] imm4
     /* 200448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200456 */     // (intrinsic_wo_chain:{ *:[i32] } 1988:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 200459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200463 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200465 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200467 */     GIR_RootConstrainSelectedInstOperands,
     /* 200468 */     // GIR_Coverage, 9923,
     /* 200468 */     GIR_EraseRootFromParent_Done,
     /* 200469 */   // Label 3995: @200469
     /* 200469 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200525), // Rule ID 9924 //
     /* 200474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 200482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200496 */     // MIs[0] pattern
     /* 200496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200504 */     // MIs[0] imm4
     /* 200504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200512 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 200515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200519 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200521 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200523 */     GIR_RootConstrainSelectedInstOperands,
     /* 200524 */     // GIR_Coverage, 9924,
     /* 200524 */     GIR_EraseRootFromParent_Done,
     /* 200525 */   // Label 3996: @200525
     /* 200525 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200581), // Rule ID 9925 //
     /* 200530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 200538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200552 */     // MIs[0] pattern
     /* 200552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200560 */     // MIs[0] imm4
     /* 200560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200568 */     // (intrinsic_wo_chain:{ *:[i64] } 1758:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 200571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200575 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200577 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200579 */     GIR_RootConstrainSelectedInstOperands,
     /* 200580 */     // GIR_Coverage, 9925,
     /* 200580 */     GIR_EraseRootFromParent_Done,
     /* 200581 */   // Label 3997: @200581
     /* 200581 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200637), // Rule ID 9926 //
     /* 200586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 200594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200608 */     // MIs[0] pattern
     /* 200608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200616 */     // MIs[0] imm4
     /* 200616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200624 */     // (intrinsic_wo_chain:{ *:[i64] } 1989:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 200627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200631 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200633 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200635 */     GIR_RootConstrainSelectedInstOperands,
     /* 200636 */     // GIR_Coverage, 9926,
     /* 200636 */     GIR_EraseRootFromParent_Done,
     /* 200637 */   // Label 3998: @200637
     /* 200637 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(200693), // Rule ID 9929 //
     /* 200642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 200650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200664 */     // MIs[0] pattern
     /* 200664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200672 */     // MIs[0] imm4
     /* 200672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200680 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 200683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200687 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200689 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200691 */     GIR_RootConstrainSelectedInstOperands,
     /* 200692 */     // GIR_Coverage, 9929,
     /* 200692 */     GIR_EraseRootFromParent_Done,
     /* 200693 */   // Label 3999: @200693
     /* 200693 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200749), // Rule ID 9932 //
     /* 200698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 200706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200720 */     // MIs[0] pattern
     /* 200720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200728 */     // MIs[0] imm4
     /* 200728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200736 */     // (intrinsic_wo_chain:{ *:[i32] } 1994:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 200739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200743 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200745 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200747 */     GIR_RootConstrainSelectedInstOperands,
     /* 200748 */     // GIR_Coverage, 9932,
     /* 200748 */     GIR_EraseRootFromParent_Done,
     /* 200749 */   // Label 4000: @200749
     /* 200749 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200805), // Rule ID 9933 //
     /* 200754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 200762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200776 */     // MIs[0] pattern
     /* 200776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200784 */     // MIs[0] imm4
     /* 200784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200792 */     // (intrinsic_wo_chain:{ *:[i64] } 1798:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 200795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200799 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200801 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200803 */     GIR_RootConstrainSelectedInstOperands,
     /* 200804 */     // GIR_Coverage, 9933,
     /* 200804 */     GIR_EraseRootFromParent_Done,
     /* 200805 */   // Label 4001: @200805
     /* 200805 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200861), // Rule ID 9934 //
     /* 200810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 200818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200832 */     // MIs[0] pattern
     /* 200832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200840 */     // MIs[0] imm4
     /* 200840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200848 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 200851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200855 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200857 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200859 */     GIR_RootConstrainSelectedInstOperands,
     /* 200860 */     // GIR_Coverage, 9934,
     /* 200860 */     GIR_EraseRootFromParent_Done,
     /* 200861 */   // Label 4002: @200861
     /* 200861 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(200917), // Rule ID 9935 //
     /* 200866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 200874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200888 */     // MIs[0] pattern
     /* 200888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200896 */     // MIs[0] imm4
     /* 200896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200904 */     // (intrinsic_wo_chain:{ *:[i64] } 1764:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 200907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200911 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200913 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200915 */     GIR_RootConstrainSelectedInstOperands,
     /* 200916 */     // GIR_Coverage, 9935,
     /* 200916 */     GIR_EraseRootFromParent_Done,
     /* 200917 */   // Label 4003: @200917
     /* 200917 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(200973), // Rule ID 9936 //
     /* 200922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 200930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200944 */     // MIs[0] pattern
     /* 200944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200952 */     // MIs[0] imm4
     /* 200952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200960 */     // (intrinsic_wo_chain:{ *:[i64] } 1995:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 200963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200967 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200969 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200971 */     GIR_RootConstrainSelectedInstOperands,
     /* 200972 */     // GIR_Coverage, 9936,
     /* 200972 */     GIR_EraseRootFromParent_Done,
     /* 200973 */   // Label 4004: @200973
     /* 200973 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201029), // Rule ID 9939 //
     /* 200978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 200986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201000 */     // MIs[0] pattern
     /* 201000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201008 */     // MIs[0] imm4
     /* 201008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201016 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 201019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201023 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201025 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201027 */     GIR_RootConstrainSelectedInstOperands,
     /* 201028 */     // GIR_Coverage, 9939,
     /* 201028 */     GIR_EraseRootFromParent_Done,
     /* 201029 */   // Label 4005: @201029
     /* 201029 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201085), // Rule ID 9942 //
     /* 201034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 201042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201056 */     // MIs[0] pattern
     /* 201056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201064 */     // MIs[0] imm4
     /* 201064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201072 */     // (intrinsic_wo_chain:{ *:[i32] } 2000:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 201075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201079 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201081 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201083 */     GIR_RootConstrainSelectedInstOperands,
     /* 201084 */     // GIR_Coverage, 9942,
     /* 201084 */     GIR_EraseRootFromParent_Done,
     /* 201085 */   // Label 4006: @201085
     /* 201085 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201141), // Rule ID 9943 //
     /* 201090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 201098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201112 */     // MIs[0] pattern
     /* 201112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201120 */     // MIs[0] imm4
     /* 201120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201128 */     // (intrinsic_wo_chain:{ *:[i64] } 1804:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 201131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201135 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201137 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201139 */     GIR_RootConstrainSelectedInstOperands,
     /* 201140 */     // GIR_Coverage, 9943,
     /* 201140 */     GIR_EraseRootFromParent_Done,
     /* 201141 */   // Label 4007: @201141
     /* 201141 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201197), // Rule ID 9944 //
     /* 201146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 201154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201168 */     // MIs[0] pattern
     /* 201168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201176 */     // MIs[0] imm4
     /* 201176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201184 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 201187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201191 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201193 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201195 */     GIR_RootConstrainSelectedInstOperands,
     /* 201196 */     // GIR_Coverage, 9944,
     /* 201196 */     GIR_EraseRootFromParent_Done,
     /* 201197 */   // Label 4008: @201197
     /* 201197 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201253), // Rule ID 9945 //
     /* 201202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 201210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201224 */     // MIs[0] pattern
     /* 201224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201232 */     // MIs[0] imm4
     /* 201232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201240 */     // (intrinsic_wo_chain:{ *:[i64] } 1770:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 201243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201247 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201249 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201251 */     GIR_RootConstrainSelectedInstOperands,
     /* 201252 */     // GIR_Coverage, 9945,
     /* 201252 */     GIR_EraseRootFromParent_Done,
     /* 201253 */   // Label 4009: @201253
     /* 201253 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201309), // Rule ID 9946 //
     /* 201258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 201266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201280 */     // MIs[0] pattern
     /* 201280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201288 */     // MIs[0] imm4
     /* 201288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201296 */     // (intrinsic_wo_chain:{ *:[i64] } 2001:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 201299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201303 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201305 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201307 */     GIR_RootConstrainSelectedInstOperands,
     /* 201308 */     // GIR_Coverage, 9946,
     /* 201308 */     GIR_EraseRootFromParent_Done,
     /* 201309 */   // Label 4010: @201309
     /* 201309 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201365), // Rule ID 9949 //
     /* 201314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 201322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201336 */     // MIs[0] pattern
     /* 201336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201344 */     // MIs[0] imm4
     /* 201344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201352 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 201355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201359 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201361 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201363 */     GIR_RootConstrainSelectedInstOperands,
     /* 201364 */     // GIR_Coverage, 9949,
     /* 201364 */     GIR_EraseRootFromParent_Done,
     /* 201365 */   // Label 4011: @201365
     /* 201365 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201421), // Rule ID 9952 //
     /* 201370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 201378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201392 */     // MIs[0] pattern
     /* 201392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201400 */     // MIs[0] imm4
     /* 201400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201408 */     // (intrinsic_wo_chain:{ *:[i32] } 1991:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 201411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201415 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201417 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201419 */     GIR_RootConstrainSelectedInstOperands,
     /* 201420 */     // GIR_Coverage, 9952,
     /* 201420 */     GIR_EraseRootFromParent_Done,
     /* 201421 */   // Label 4012: @201421
     /* 201421 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201477), // Rule ID 9953 //
     /* 201426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 201434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201448 */     // MIs[0] pattern
     /* 201448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201456 */     // MIs[0] imm4
     /* 201456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201464 */     // (intrinsic_wo_chain:{ *:[i64] } 1795:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 201467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201471 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201473 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201475 */     GIR_RootConstrainSelectedInstOperands,
     /* 201476 */     // GIR_Coverage, 9953,
     /* 201476 */     GIR_EraseRootFromParent_Done,
     /* 201477 */   // Label 4013: @201477
     /* 201477 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201533), // Rule ID 9954 //
     /* 201482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 201490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201504 */     // MIs[0] pattern
     /* 201504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201507 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201512 */     // MIs[0] imm4
     /* 201512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201520 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 201523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201527 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201529 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201531 */     GIR_RootConstrainSelectedInstOperands,
     /* 201532 */     // GIR_Coverage, 9954,
     /* 201532 */     GIR_EraseRootFromParent_Done,
     /* 201533 */   // Label 4014: @201533
     /* 201533 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201589), // Rule ID 9955 //
     /* 201538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 201546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201560 */     // MIs[0] pattern
     /* 201560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201568 */     // MIs[0] imm4
     /* 201568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201576 */     // (intrinsic_wo_chain:{ *:[i64] } 1761:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 201579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201583 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201585 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201587 */     GIR_RootConstrainSelectedInstOperands,
     /* 201588 */     // GIR_Coverage, 9955,
     /* 201588 */     GIR_EraseRootFromParent_Done,
     /* 201589 */   // Label 4015: @201589
     /* 201589 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201645), // Rule ID 9956 //
     /* 201594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 201602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201616 */     // MIs[0] pattern
     /* 201616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201624 */     // MIs[0] imm4
     /* 201624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201632 */     // (intrinsic_wo_chain:{ *:[i64] } 1992:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 201635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201639 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201641 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201643 */     GIR_RootConstrainSelectedInstOperands,
     /* 201644 */     // GIR_Coverage, 9956,
     /* 201644 */     GIR_EraseRootFromParent_Done,
     /* 201645 */   // Label 4016: @201645
     /* 201645 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201701), // Rule ID 9957 //
     /* 201650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 201658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201672 */     // MIs[0] pattern
     /* 201672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201680 */     // MIs[0] imm4
     /* 201680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201683 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201688 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 201691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201695 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201697 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201699 */     GIR_RootConstrainSelectedInstOperands,
     /* 201700 */     // GIR_Coverage, 9957,
     /* 201700 */     GIR_EraseRootFromParent_Done,
     /* 201701 */   // Label 4017: @201701
     /* 201701 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201757), // Rule ID 9958 //
     /* 201706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 201714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201728 */     // MIs[0] pattern
     /* 201728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201736 */     // MIs[0] imm4
     /* 201736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1762:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 201747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201751 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201753 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201755 */     GIR_RootConstrainSelectedInstOperands,
     /* 201756 */     // GIR_Coverage, 9958,
     /* 201756 */     GIR_EraseRootFromParent_Done,
     /* 201757 */   // Label 4018: @201757
     /* 201757 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201813), // Rule ID 9959 //
     /* 201762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 201770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 201773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 201776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201784 */     // MIs[0] pattern
     /* 201784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201792 */     // MIs[0] imm4
     /* 201792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1993:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 201803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201807 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201809 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201811 */     GIR_RootConstrainSelectedInstOperands,
     /* 201812 */     // GIR_Coverage, 9959,
     /* 201812 */     GIR_EraseRootFromParent_Done,
     /* 201813 */   // Label 4019: @201813
     /* 201813 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201869), // Rule ID 9960 //
     /* 201818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 201826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201840 */     // MIs[0] pattern
     /* 201840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201848 */     // MIs[0] imm4
     /* 201848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 201859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201863 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201865 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201867 */     GIR_RootConstrainSelectedInstOperands,
     /* 201868 */     // GIR_Coverage, 9960,
     /* 201868 */     GIR_EraseRootFromParent_Done,
     /* 201869 */   // Label 4020: @201869
     /* 201869 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(201925), // Rule ID 9961 //
     /* 201874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 201882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201896 */     // MIs[0] pattern
     /* 201896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201904 */     // MIs[0] imm4
     /* 201904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 201915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201919 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201921 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201923 */     GIR_RootConstrainSelectedInstOperands,
     /* 201924 */     // GIR_Coverage, 9961,
     /* 201924 */     GIR_EraseRootFromParent_Done,
     /* 201925 */   // Label 4021: @201925
     /* 201925 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(201981), // Rule ID 9962 //
     /* 201930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 201938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 201944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 201952 */     // MIs[0] pattern
     /* 201952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201960 */     // MIs[0] imm4
     /* 201960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1768:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 201971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 201973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 201975 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201977 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201979 */     GIR_RootConstrainSelectedInstOperands,
     /* 201980 */     // GIR_Coverage, 9962,
     /* 201980 */     GIR_EraseRootFromParent_Done,
     /* 201981 */   // Label 4022: @201981
     /* 201981 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202037), // Rule ID 9963 //
     /* 201986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 201994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 201997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202008 */     // MIs[0] pattern
     /* 202008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202016 */     // MIs[0] imm4
     /* 202016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 202027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202031 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202033 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202035 */     GIR_RootConstrainSelectedInstOperands,
     /* 202036 */     // GIR_Coverage, 9963,
     /* 202036 */     GIR_EraseRootFromParent_Done,
     /* 202037 */   // Label 4023: @202037
     /* 202037 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202093), // Rule ID 9964 //
     /* 202042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 202050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202064 */     // MIs[0] pattern
     /* 202064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202072 */     // MIs[0] imm4
     /* 202072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 202083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202087 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202089 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202091 */     GIR_RootConstrainSelectedInstOperands,
     /* 202092 */     // GIR_Coverage, 9964,
     /* 202092 */     GIR_EraseRootFromParent_Done,
     /* 202093 */   // Label 4024: @202093
     /* 202093 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202149), // Rule ID 9965 //
     /* 202098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 202106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202120 */     // MIs[0] pattern
     /* 202120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202128 */     // MIs[0] imm4
     /* 202128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 202139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202143 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202145 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202147 */     GIR_RootConstrainSelectedInstOperands,
     /* 202148 */     // GIR_Coverage, 9965,
     /* 202148 */     GIR_EraseRootFromParent_Done,
     /* 202149 */   // Label 4025: @202149
     /* 202149 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202205), // Rule ID 9966 //
     /* 202154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 202162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202176 */     // MIs[0] pattern
     /* 202176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202184 */     // MIs[0] imm4
     /* 202184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 202195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202199 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202201 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202203 */     GIR_RootConstrainSelectedInstOperands,
     /* 202204 */     // GIR_Coverage, 9966,
     /* 202204 */     GIR_EraseRootFromParent_Done,
     /* 202205 */   // Label 4026: @202205
     /* 202205 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202261), // Rule ID 9967 //
     /* 202210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 202218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202232 */     // MIs[0] pattern
     /* 202232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202240 */     // MIs[0] imm4
     /* 202240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 202251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202255 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202257 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202259 */     GIR_RootConstrainSelectedInstOperands,
     /* 202260 */     // GIR_Coverage, 9967,
     /* 202260 */     GIR_EraseRootFromParent_Done,
     /* 202261 */   // Label 4027: @202261
     /* 202261 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202351), // Rule ID 47 //
     /* 202266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202327 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202331 */     // MIs[2] Operand 1
     /* 202331 */     // No operand predicates
     /* 202331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202333 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 202336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202349 */     GIR_RootConstrainSelectedInstOperands,
     /* 202350 */     // GIR_Coverage, 47,
     /* 202350 */     GIR_EraseRootFromParent_Done,
     /* 202351 */   // Label 4028: @202351
     /* 202351 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202441), // Rule ID 48 //
     /* 202356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202417 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202421 */     // MIs[2] Operand 1
     /* 202421 */     // No operand predicates
     /* 202421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202423 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 202426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202439 */     GIR_RootConstrainSelectedInstOperands,
     /* 202440 */     // GIR_Coverage, 48,
     /* 202440 */     GIR_EraseRootFromParent_Done,
     /* 202441 */   // Label 4029: @202441
     /* 202441 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202531), // Rule ID 49 //
     /* 202446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 202454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202511 */     // MIs[2] Operand 1
     /* 202511 */     // No operand predicates
     /* 202511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202513 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 202516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202529 */     GIR_RootConstrainSelectedInstOperands,
     /* 202530 */     // GIR_Coverage, 49,
     /* 202530 */     GIR_EraseRootFromParent_Done,
     /* 202531 */   // Label 4030: @202531
     /* 202531 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202621), // Rule ID 50 //
     /* 202536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 202544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202601 */     // MIs[2] Operand 1
     /* 202601 */     // No operand predicates
     /* 202601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202603 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 202606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202619 */     GIR_RootConstrainSelectedInstOperands,
     /* 202620 */     // GIR_Coverage, 50,
     /* 202620 */     GIR_EraseRootFromParent_Done,
     /* 202621 */   // Label 4031: @202621
     /* 202621 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202711), // Rule ID 51 //
     /* 202626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 202634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202687 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202691 */     // MIs[2] Operand 1
     /* 202691 */     // No operand predicates
     /* 202691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202693 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 202696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202709 */     GIR_RootConstrainSelectedInstOperands,
     /* 202710 */     // GIR_Coverage, 51,
     /* 202710 */     GIR_EraseRootFromParent_Done,
     /* 202711 */   // Label 4032: @202711
     /* 202711 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202801), // Rule ID 52 //
     /* 202716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 202724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202781 */     // MIs[2] Operand 1
     /* 202781 */     // No operand predicates
     /* 202781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202783 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 202786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202799 */     GIR_RootConstrainSelectedInstOperands,
     /* 202800 */     // GIR_Coverage, 52,
     /* 202800 */     GIR_EraseRootFromParent_Done,
     /* 202801 */   // Label 4033: @202801
     /* 202801 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202891), // Rule ID 53 //
     /* 202806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202867 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202871 */     // MIs[2] Operand 1
     /* 202871 */     // No operand predicates
     /* 202871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202873 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 202876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202889 */     GIR_RootConstrainSelectedInstOperands,
     /* 202890 */     // GIR_Coverage, 53,
     /* 202890 */     GIR_EraseRootFromParent_Done,
     /* 202891 */   // Label 4034: @202891
     /* 202891 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202981), // Rule ID 54 //
     /* 202896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 202904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202961 */     // MIs[2] Operand 1
     /* 202961 */     // No operand predicates
     /* 202961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202963 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 202966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202979 */     GIR_RootConstrainSelectedInstOperands,
     /* 202980 */     // GIR_Coverage, 54,
     /* 202980 */     GIR_EraseRootFromParent_Done,
     /* 202981 */   // Label 4035: @202981
     /* 202981 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(203071), // Rule ID 2070 //
     /* 202986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 202989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 202994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 202997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203047 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203051 */     // MIs[2] Operand 1
     /* 203051 */     // No operand predicates
     /* 203051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203053 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 203056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203069 */     GIR_RootConstrainSelectedInstOperands,
     /* 203070 */     // GIR_Coverage, 2070,
     /* 203070 */     GIR_EraseRootFromParent_Done,
     /* 203071 */   // Label 4036: @203071
     /* 203071 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(203161), // Rule ID 2071 //
     /* 203076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203141 */     // MIs[2] Operand 1
     /* 203141 */     // No operand predicates
     /* 203141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203143 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 203146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203159 */     GIR_RootConstrainSelectedInstOperands,
     /* 203160 */     // GIR_Coverage, 2071,
     /* 203160 */     GIR_EraseRootFromParent_Done,
     /* 203161 */   // Label 4037: @203161
     /* 203161 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(203251), // Rule ID 2077 //
     /* 203166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203227 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203231 */     // MIs[2] Operand 1
     /* 203231 */     // No operand predicates
     /* 203231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203233 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 203236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203249 */     GIR_RootConstrainSelectedInstOperands,
     /* 203250 */     // GIR_Coverage, 2077,
     /* 203250 */     GIR_EraseRootFromParent_Done,
     /* 203251 */   // Label 4038: @203251
     /* 203251 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(203341), // Rule ID 2078 //
     /* 203256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203321 */     // MIs[2] Operand 1
     /* 203321 */     // No operand predicates
     /* 203321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203323 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203339 */     GIR_RootConstrainSelectedInstOperands,
     /* 203340 */     // GIR_Coverage, 2078,
     /* 203340 */     GIR_EraseRootFromParent_Done,
     /* 203341 */   // Label 4039: @203341
     /* 203341 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(203431), // Rule ID 2073 //
     /* 203346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 203363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 203366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203407 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203411 */     // MIs[2] Operand 1
     /* 203411 */     // No operand predicates
     /* 203411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203413 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 203416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203429 */     GIR_RootConstrainSelectedInstOperands,
     /* 203430 */     // GIR_Coverage, 2073,
     /* 203430 */     GIR_EraseRootFromParent_Done,
     /* 203431 */   // Label 4040: @203431
     /* 203431 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(203521), // Rule ID 2074 //
     /* 203436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 203453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 203456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203497 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203501 */     // MIs[2] Operand 1
     /* 203501 */     // No operand predicates
     /* 203501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203503 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 203506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203519 */     GIR_RootConstrainSelectedInstOperands,
     /* 203520 */     // GIR_Coverage, 2074,
     /* 203520 */     GIR_EraseRootFromParent_Done,
     /* 203521 */   // Label 4041: @203521
     /* 203521 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(203611), // Rule ID 2080 //
     /* 203526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 203543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 203546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203591 */     // MIs[2] Operand 1
     /* 203591 */     // No operand predicates
     /* 203591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203593 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 203596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203609 */     GIR_RootConstrainSelectedInstOperands,
     /* 203610 */     // GIR_Coverage, 2080,
     /* 203610 */     GIR_EraseRootFromParent_Done,
     /* 203611 */   // Label 4042: @203611
     /* 203611 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(203701), // Rule ID 2081 //
     /* 203616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 203633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 203636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203681 */     // MIs[2] Operand 1
     /* 203681 */     // No operand predicates
     /* 203681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203683 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 203686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203699 */     GIR_RootConstrainSelectedInstOperands,
     /* 203700 */     // GIR_Coverage, 2081,
     /* 203700 */     GIR_EraseRootFromParent_Done,
     /* 203701 */   // Label 4043: @203701
     /* 203701 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(203791), // Rule ID 2075 //
     /* 203706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203771 */     // MIs[2] Operand 1
     /* 203771 */     // No operand predicates
     /* 203771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203773 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 203776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203789 */     GIR_RootConstrainSelectedInstOperands,
     /* 203790 */     // GIR_Coverage, 2075,
     /* 203790 */     GIR_EraseRootFromParent_Done,
     /* 203791 */   // Label 4044: @203791
     /* 203791 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(203881), // Rule ID 2082 //
     /* 203796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 203816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 203828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 203836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203857 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203861 */     // MIs[2] Operand 1
     /* 203861 */     // No operand predicates
     /* 203861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203863 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 203866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203879 */     GIR_RootConstrainSelectedInstOperands,
     /* 203880 */     // GIR_Coverage, 2082,
     /* 203880 */     GIR_EraseRootFromParent_Done,
     /* 203881 */   // Label 4045: @203881
     /* 203881 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(203958), // Rule ID 2781 //
     /* 203886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 203926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 203930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 203934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 203938 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 203942 */     // MIs[2] Operand 1
     /* 203942 */     // No operand predicates
     /* 203942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203944 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 203944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 203947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 203949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 203951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 203953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 203956 */     GIR_RootConstrainSelectedInstOperands,
     /* 203957 */     // GIR_Coverage, 2781,
     /* 203957 */     GIR_EraseRootFromParent_Done,
     /* 203958 */   // Label 4046: @203958
     /* 203958 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(204035), // Rule ID 2782 //
     /* 203963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 203971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 203977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 203983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 203991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204015 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204019 */     // MIs[2] Operand 1
     /* 204019 */     // No operand predicates
     /* 204019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 204024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204033 */     GIR_RootConstrainSelectedInstOperands,
     /* 204034 */     // GIR_Coverage, 2782,
     /* 204034 */     GIR_EraseRootFromParent_Done,
     /* 204035 */   // Label 4047: @204035
     /* 204035 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(204112), // Rule ID 2783 //
     /* 204040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204092 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204096 */     // MIs[2] Operand 1
     /* 204096 */     // No operand predicates
     /* 204096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204098 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204110 */     GIR_RootConstrainSelectedInstOperands,
     /* 204111 */     // GIR_Coverage, 2783,
     /* 204111 */     GIR_EraseRootFromParent_Done,
     /* 204112 */   // Label 4048: @204112
     /* 204112 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204189), // Rule ID 2784 //
     /* 204117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204169 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204173 */     // MIs[2] Operand 1
     /* 204173 */     // No operand predicates
     /* 204173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204175 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204187 */     GIR_RootConstrainSelectedInstOperands,
     /* 204188 */     // GIR_Coverage, 2784,
     /* 204188 */     GIR_EraseRootFromParent_Done,
     /* 204189 */   // Label 4049: @204189
     /* 204189 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204266), // Rule ID 2785 //
     /* 204194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204246 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204250 */     // MIs[2] Operand 1
     /* 204250 */     // No operand predicates
     /* 204250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204252 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204264 */     GIR_RootConstrainSelectedInstOperands,
     /* 204265 */     // GIR_Coverage, 2785,
     /* 204265 */     GIR_EraseRootFromParent_Done,
     /* 204266 */   // Label 4050: @204266
     /* 204266 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(204343), // Rule ID 2786 //
     /* 204271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204323 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204327 */     // MIs[2] Operand 1
     /* 204327 */     // No operand predicates
     /* 204327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204329 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204341 */     GIR_RootConstrainSelectedInstOperands,
     /* 204342 */     // GIR_Coverage, 2786,
     /* 204342 */     GIR_EraseRootFromParent_Done,
     /* 204343 */   // Label 4051: @204343
     /* 204343 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(204420), // Rule ID 7810 //
     /* 204348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204400 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204404 */     // MIs[2] Operand 1
     /* 204404 */     // No operand predicates
     /* 204404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 204409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204418 */     GIR_RootConstrainSelectedInstOperands,
     /* 204419 */     // GIR_Coverage, 7810,
     /* 204419 */     GIR_EraseRootFromParent_Done,
     /* 204420 */   // Label 4052: @204420
     /* 204420 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204497), // Rule ID 7811 //
     /* 204425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204477 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204481 */     // MIs[2] Operand 1
     /* 204481 */     // No operand predicates
     /* 204481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204483 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 204486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204495 */     GIR_RootConstrainSelectedInstOperands,
     /* 204496 */     // GIR_Coverage, 7811,
     /* 204496 */     GIR_EraseRootFromParent_Done,
     /* 204497 */   // Label 4053: @204497
     /* 204497 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(204574), // Rule ID 7812 //
     /* 204502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204554 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204558 */     // MIs[2] Operand 1
     /* 204558 */     // No operand predicates
     /* 204558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204560 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 204563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204572 */     GIR_RootConstrainSelectedInstOperands,
     /* 204573 */     // GIR_Coverage, 7812,
     /* 204573 */     GIR_EraseRootFromParent_Done,
     /* 204574 */   // Label 4054: @204574
     /* 204574 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(204651), // Rule ID 7813 //
     /* 204579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204631 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204635 */     // MIs[2] Operand 1
     /* 204635 */     // No operand predicates
     /* 204635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204637 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 204640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204649 */     GIR_RootConstrainSelectedInstOperands,
     /* 204650 */     // GIR_Coverage, 7813,
     /* 204650 */     GIR_EraseRootFromParent_Done,
     /* 204651 */   // Label 4055: @204651
     /* 204651 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(204728), // Rule ID 7814 //
     /* 204656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204708 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204712 */     // MIs[2] Operand 1
     /* 204712 */     // No operand predicates
     /* 204712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204714 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204726 */     GIR_RootConstrainSelectedInstOperands,
     /* 204727 */     // GIR_Coverage, 7814,
     /* 204727 */     GIR_EraseRootFromParent_Done,
     /* 204728 */   // Label 4056: @204728
     /* 204728 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(204805), // Rule ID 7815 //
     /* 204733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204785 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204789 */     // MIs[2] Operand 1
     /* 204789 */     // No operand predicates
     /* 204789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204791 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 204794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204803 */     GIR_RootConstrainSelectedInstOperands,
     /* 204804 */     // GIR_Coverage, 7815,
     /* 204804 */     GIR_EraseRootFromParent_Done,
     /* 204805 */   // Label 4057: @204805
     /* 204805 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(204882), // Rule ID 7816 //
     /* 204810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204862 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204866 */     // MIs[2] Operand 1
     /* 204866 */     // No operand predicates
     /* 204866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204868 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204880 */     GIR_RootConstrainSelectedInstOperands,
     /* 204881 */     // GIR_Coverage, 7816,
     /* 204881 */     GIR_EraseRootFromParent_Done,
     /* 204882 */   // Label 4058: @204882
     /* 204882 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(204959), // Rule ID 7817 //
     /* 204887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204939 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 204943 */     // MIs[2] Operand 1
     /* 204943 */     // No operand predicates
     /* 204943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204945 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 204948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204957 */     GIR_RootConstrainSelectedInstOperands,
     /* 204958 */     // GIR_Coverage, 7817,
     /* 204958 */     GIR_EraseRootFromParent_Done,
     /* 204959 */   // Label 4059: @204959
     /* 204959 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(205036), // Rule ID 7818 //
     /* 204964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 204972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205016 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205020 */     // MIs[2] Operand 1
     /* 205020 */     // No operand predicates
     /* 205020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205022 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205034 */     GIR_RootConstrainSelectedInstOperands,
     /* 205035 */     // GIR_Coverage, 7818,
     /* 205035 */     GIR_EraseRootFromParent_Done,
     /* 205036 */   // Label 4060: @205036
     /* 205036 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205113), // Rule ID 7819 //
     /* 205041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205093 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205097 */     // MIs[2] Operand 1
     /* 205097 */     // No operand predicates
     /* 205097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205099 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205111 */     GIR_RootConstrainSelectedInstOperands,
     /* 205112 */     // GIR_Coverage, 7819,
     /* 205112 */     GIR_EraseRootFromParent_Done,
     /* 205113 */   // Label 4061: @205113
     /* 205113 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205190), // Rule ID 7820 //
     /* 205118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205170 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205174 */     // MIs[2] Operand 1
     /* 205174 */     // No operand predicates
     /* 205174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205176 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205188 */     GIR_RootConstrainSelectedInstOperands,
     /* 205189 */     // GIR_Coverage, 7820,
     /* 205189 */     GIR_EraseRootFromParent_Done,
     /* 205190 */   // Label 4062: @205190
     /* 205190 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205267), // Rule ID 7821 //
     /* 205195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205247 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205251 */     // MIs[2] Operand 1
     /* 205251 */     // No operand predicates
     /* 205251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205253 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205265 */     GIR_RootConstrainSelectedInstOperands,
     /* 205266 */     // GIR_Coverage, 7821,
     /* 205266 */     GIR_EraseRootFromParent_Done,
     /* 205267 */   // Label 4063: @205267
     /* 205267 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205344), // Rule ID 7822 //
     /* 205272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205324 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205328 */     // MIs[2] Operand 1
     /* 205328 */     // No operand predicates
     /* 205328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205330 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205342 */     GIR_RootConstrainSelectedInstOperands,
     /* 205343 */     // GIR_Coverage, 7822,
     /* 205343 */     GIR_EraseRootFromParent_Done,
     /* 205344 */   // Label 4064: @205344
     /* 205344 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205421), // Rule ID 7823 //
     /* 205349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205401 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205405 */     // MIs[2] Operand 1
     /* 205405 */     // No operand predicates
     /* 205405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205407 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205419 */     GIR_RootConstrainSelectedInstOperands,
     /* 205420 */     // GIR_Coverage, 7823,
     /* 205420 */     GIR_EraseRootFromParent_Done,
     /* 205421 */   // Label 4065: @205421
     /* 205421 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205498), // Rule ID 7824 //
     /* 205426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205478 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205482 */     // MIs[2] Operand 1
     /* 205482 */     // No operand predicates
     /* 205482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205484 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 205487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205496 */     GIR_RootConstrainSelectedInstOperands,
     /* 205497 */     // GIR_Coverage, 7824,
     /* 205497 */     GIR_EraseRootFromParent_Done,
     /* 205498 */   // Label 4066: @205498
     /* 205498 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(205575), // Rule ID 7825 //
     /* 205503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205555 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205559 */     // MIs[2] Operand 1
     /* 205559 */     // No operand predicates
     /* 205559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205561 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 205564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205573 */     GIR_RootConstrainSelectedInstOperands,
     /* 205574 */     // GIR_Coverage, 7825,
     /* 205574 */     GIR_EraseRootFromParent_Done,
     /* 205575 */   // Label 4067: @205575
     /* 205575 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(205652), // Rule ID 7826 //
     /* 205580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205632 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205636 */     // MIs[2] Operand 1
     /* 205636 */     // No operand predicates
     /* 205636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 205641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205650 */     GIR_RootConstrainSelectedInstOperands,
     /* 205651 */     // GIR_Coverage, 7826,
     /* 205651 */     GIR_EraseRootFromParent_Done,
     /* 205652 */   // Label 4068: @205652
     /* 205652 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205729), // Rule ID 7827 //
     /* 205657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205709 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205713 */     // MIs[2] Operand 1
     /* 205713 */     // No operand predicates
     /* 205713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 205718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205727 */     GIR_RootConstrainSelectedInstOperands,
     /* 205728 */     // GIR_Coverage, 7827,
     /* 205728 */     GIR_EraseRootFromParent_Done,
     /* 205729 */   // Label 4069: @205729
     /* 205729 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205806), // Rule ID 7828 //
     /* 205734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205786 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205790 */     // MIs[2] Operand 1
     /* 205790 */     // No operand predicates
     /* 205790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205792 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205804 */     GIR_RootConstrainSelectedInstOperands,
     /* 205805 */     // GIR_Coverage, 7828,
     /* 205805 */     GIR_EraseRootFromParent_Done,
     /* 205806 */   // Label 4070: @205806
     /* 205806 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205883), // Rule ID 7829 //
     /* 205811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205863 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205867 */     // MIs[2] Operand 1
     /* 205867 */     // No operand predicates
     /* 205867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205869 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 205872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205881 */     GIR_RootConstrainSelectedInstOperands,
     /* 205882 */     // GIR_Coverage, 7829,
     /* 205882 */     GIR_EraseRootFromParent_Done,
     /* 205883 */   // Label 4071: @205883
     /* 205883 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(205960), // Rule ID 7830 //
     /* 205888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205940 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 205944 */     // MIs[2] Operand 1
     /* 205944 */     // No operand predicates
     /* 205944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205946 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 205949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205958 */     GIR_RootConstrainSelectedInstOperands,
     /* 205959 */     // GIR_Coverage, 7830,
     /* 205959 */     GIR_EraseRootFromParent_Done,
     /* 205960 */   // Label 4072: @205960
     /* 205960 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(206037), // Rule ID 7831 //
     /* 205965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 205973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206017 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206021 */     // MIs[2] Operand 1
     /* 206021 */     // No operand predicates
     /* 206021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206023 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 206026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206035 */     GIR_RootConstrainSelectedInstOperands,
     /* 206036 */     // GIR_Coverage, 7831,
     /* 206036 */     GIR_EraseRootFromParent_Done,
     /* 206037 */   // Label 4073: @206037
     /* 206037 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206114), // Rule ID 7832 //
     /* 206042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206094 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206098 */     // MIs[2] Operand 1
     /* 206098 */     // No operand predicates
     /* 206098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206112 */     GIR_RootConstrainSelectedInstOperands,
     /* 206113 */     // GIR_Coverage, 7832,
     /* 206113 */     GIR_EraseRootFromParent_Done,
     /* 206114 */   // Label 4074: @206114
     /* 206114 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206191), // Rule ID 7833 //
     /* 206119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206171 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206175 */     // MIs[2] Operand 1
     /* 206175 */     // No operand predicates
     /* 206175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206177 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206189 */     GIR_RootConstrainSelectedInstOperands,
     /* 206190 */     // GIR_Coverage, 7833,
     /* 206190 */     GIR_EraseRootFromParent_Done,
     /* 206191 */   // Label 4075: @206191
     /* 206191 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206268), // Rule ID 7834 //
     /* 206196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206248 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206252 */     // MIs[2] Operand 1
     /* 206252 */     // No operand predicates
     /* 206252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206254 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206266 */     GIR_RootConstrainSelectedInstOperands,
     /* 206267 */     // GIR_Coverage, 7834,
     /* 206267 */     GIR_EraseRootFromParent_Done,
     /* 206268 */   // Label 4076: @206268
     /* 206268 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206345), // Rule ID 7835 //
     /* 206273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206325 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206329 */     // MIs[2] Operand 1
     /* 206329 */     // No operand predicates
     /* 206329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206331 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206343 */     GIR_RootConstrainSelectedInstOperands,
     /* 206344 */     // GIR_Coverage, 7835,
     /* 206344 */     GIR_EraseRootFromParent_Done,
     /* 206345 */   // Label 4077: @206345
     /* 206345 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206422), // Rule ID 7836 //
     /* 206350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206402 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206406 */     // MIs[2] Operand 1
     /* 206406 */     // No operand predicates
     /* 206406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 206411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206420 */     GIR_RootConstrainSelectedInstOperands,
     /* 206421 */     // GIR_Coverage, 7836,
     /* 206421 */     GIR_EraseRootFromParent_Done,
     /* 206422 */   // Label 4078: @206422
     /* 206422 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206499), // Rule ID 7837 //
     /* 206427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206479 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206483 */     // MIs[2] Operand 1
     /* 206483 */     // No operand predicates
     /* 206483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206485 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 206488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206497 */     GIR_RootConstrainSelectedInstOperands,
     /* 206498 */     // GIR_Coverage, 7837,
     /* 206498 */     GIR_EraseRootFromParent_Done,
     /* 206499 */   // Label 4079: @206499
     /* 206499 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206576), // Rule ID 7838 //
     /* 206504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206556 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206560 */     // MIs[2] Operand 1
     /* 206560 */     // No operand predicates
     /* 206560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206562 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 206565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206574 */     GIR_RootConstrainSelectedInstOperands,
     /* 206575 */     // GIR_Coverage, 7838,
     /* 206575 */     GIR_EraseRootFromParent_Done,
     /* 206576 */   // Label 4080: @206576
     /* 206576 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206653), // Rule ID 7839 //
     /* 206581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206633 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206637 */     // MIs[2] Operand 1
     /* 206637 */     // No operand predicates
     /* 206637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206639 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 206642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206651 */     GIR_RootConstrainSelectedInstOperands,
     /* 206652 */     // GIR_Coverage, 7839,
     /* 206652 */     GIR_EraseRootFromParent_Done,
     /* 206653 */   // Label 4081: @206653
     /* 206653 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206730), // Rule ID 7840 //
     /* 206658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206710 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206714 */     // MIs[2] Operand 1
     /* 206714 */     // No operand predicates
     /* 206714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206716 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206728 */     GIR_RootConstrainSelectedInstOperands,
     /* 206729 */     // GIR_Coverage, 7840,
     /* 206729 */     GIR_EraseRootFromParent_Done,
     /* 206730 */   // Label 4082: @206730
     /* 206730 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206807), // Rule ID 7841 //
     /* 206735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206787 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206791 */     // MIs[2] Operand 1
     /* 206791 */     // No operand predicates
     /* 206791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206793 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 206796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206805 */     GIR_RootConstrainSelectedInstOperands,
     /* 206806 */     // GIR_Coverage, 7841,
     /* 206806 */     GIR_EraseRootFromParent_Done,
     /* 206807 */   // Label 4083: @206807
     /* 206807 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206884), // Rule ID 7842 //
     /* 206812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206864 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206868 */     // MIs[2] Operand 1
     /* 206868 */     // No operand predicates
     /* 206868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206870 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206882 */     GIR_RootConstrainSelectedInstOperands,
     /* 206883 */     // GIR_Coverage, 7842,
     /* 206883 */     GIR_EraseRootFromParent_Done,
     /* 206884 */   // Label 4084: @206884
     /* 206884 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206961), // Rule ID 7843 //
     /* 206889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206941 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206945 */     // MIs[2] Operand 1
     /* 206945 */     // No operand predicates
     /* 206945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206947 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 206950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206959 */     GIR_RootConstrainSelectedInstOperands,
     /* 206960 */     // GIR_Coverage, 7843,
     /* 206960 */     GIR_EraseRootFromParent_Done,
     /* 206961 */   // Label 4085: @206961
     /* 206961 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(207038), // Rule ID 7844 //
     /* 206966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 206974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207018 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207022 */     // MIs[2] Operand 1
     /* 207022 */     // No operand predicates
     /* 207022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207036 */     GIR_RootConstrainSelectedInstOperands,
     /* 207037 */     // GIR_Coverage, 7844,
     /* 207037 */     GIR_EraseRootFromParent_Done,
     /* 207038 */   // Label 4086: @207038
     /* 207038 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(207115), // Rule ID 7845 //
     /* 207043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207095 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207099 */     // MIs[2] Operand 1
     /* 207099 */     // No operand predicates
     /* 207099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207113 */     GIR_RootConstrainSelectedInstOperands,
     /* 207114 */     // GIR_Coverage, 7845,
     /* 207114 */     GIR_EraseRootFromParent_Done,
     /* 207115 */   // Label 4087: @207115
     /* 207115 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207192), // Rule ID 7846 //
     /* 207120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207172 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207176 */     // MIs[2] Operand 1
     /* 207176 */     // No operand predicates
     /* 207176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207178 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207190 */     GIR_RootConstrainSelectedInstOperands,
     /* 207191 */     // GIR_Coverage, 7846,
     /* 207191 */     GIR_EraseRootFromParent_Done,
     /* 207192 */   // Label 4088: @207192
     /* 207192 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207269), // Rule ID 7847 //
     /* 207197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207249 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207253 */     // MIs[2] Operand 1
     /* 207253 */     // No operand predicates
     /* 207253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207255 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207267 */     GIR_RootConstrainSelectedInstOperands,
     /* 207268 */     // GIR_Coverage, 7847,
     /* 207268 */     GIR_EraseRootFromParent_Done,
     /* 207269 */   // Label 4089: @207269
     /* 207269 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207346), // Rule ID 7848 //
     /* 207274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207326 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207330 */     // MIs[2] Operand 1
     /* 207330 */     // No operand predicates
     /* 207330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207332 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207344 */     GIR_RootConstrainSelectedInstOperands,
     /* 207345 */     // GIR_Coverage, 7848,
     /* 207345 */     GIR_EraseRootFromParent_Done,
     /* 207346 */   // Label 4090: @207346
     /* 207346 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207423), // Rule ID 7849 //
     /* 207351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207403 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207407 */     // MIs[2] Operand 1
     /* 207407 */     // No operand predicates
     /* 207407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207409 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207421 */     GIR_RootConstrainSelectedInstOperands,
     /* 207422 */     // GIR_Coverage, 7849,
     /* 207422 */     GIR_EraseRootFromParent_Done,
     /* 207423 */   // Label 4091: @207423
     /* 207423 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207500), // Rule ID 7850 //
     /* 207428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207480 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207484 */     // MIs[2] Operand 1
     /* 207484 */     // No operand predicates
     /* 207484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207486 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 207489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207498 */     GIR_RootConstrainSelectedInstOperands,
     /* 207499 */     // GIR_Coverage, 7850,
     /* 207499 */     GIR_EraseRootFromParent_Done,
     /* 207500 */   // Label 4092: @207500
     /* 207500 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207577), // Rule ID 7851 //
     /* 207505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207557 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207561 */     // MIs[2] Operand 1
     /* 207561 */     // No operand predicates
     /* 207561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207563 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 207566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207575 */     GIR_RootConstrainSelectedInstOperands,
     /* 207576 */     // GIR_Coverage, 7851,
     /* 207576 */     GIR_EraseRootFromParent_Done,
     /* 207577 */   // Label 4093: @207577
     /* 207577 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207633), // Rule ID 55 //
     /* 207582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207607 */     // MIs[0] Operand 3
     /* 207607 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 207618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207622 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 207625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207631 */     GIR_RootConstrainSelectedInstOperands,
     /* 207632 */     // GIR_Coverage, 55,
     /* 207632 */     GIR_EraseRootFromParent_Done,
     /* 207633 */   // Label 4094: @207633
     /* 207633 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207689), // Rule ID 56 //
     /* 207638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207663 */     // MIs[0] Operand 3
     /* 207663 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 207674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207678 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 207681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207687 */     GIR_RootConstrainSelectedInstOperands,
     /* 207688 */     // GIR_Coverage, 56,
     /* 207688 */     GIR_EraseRootFromParent_Done,
     /* 207689 */   // Label 4095: @207689
     /* 207689 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207745), // Rule ID 57 //
     /* 207694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207719 */     // MIs[0] Operand 3
     /* 207719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 207730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207734 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 207737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207743 */     GIR_RootConstrainSelectedInstOperands,
     /* 207744 */     // GIR_Coverage, 57,
     /* 207744 */     GIR_EraseRootFromParent_Done,
     /* 207745 */   // Label 4096: @207745
     /* 207745 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207801), // Rule ID 58 //
     /* 207750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 207753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 207758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 207761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 207764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 207767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 207775 */     // MIs[0] Operand 3
     /* 207775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 207786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 207790 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 207790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 207793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 207797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 207799 */     GIR_RootConstrainSelectedInstOperands,
     /* 207800 */     // GIR_Coverage, 58,
     /* 207800 */     GIR_EraseRootFromParent_Done,
     /* 207801 */   // Label 4097: @207801
     /* 207801 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207856), // Rule ID 2799 //
     /* 207806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207835 */     // MIs[0] imm
     /* 207835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207843 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1528:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 207846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207852 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207854 */     GIR_RootConstrainSelectedInstOperands,
     /* 207855 */     // GIR_Coverage, 2799,
     /* 207855 */     GIR_EraseRootFromParent_Done,
     /* 207856 */   // Label 4098: @207856
     /* 207856 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207911), // Rule ID 2800 //
     /* 207861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207890 */     // MIs[0] imm
     /* 207890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207898 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1528:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 207901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207907 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207909 */     GIR_RootConstrainSelectedInstOperands,
     /* 207910 */     // GIR_Coverage, 2800,
     /* 207910 */     GIR_EraseRootFromParent_Done,
     /* 207911 */   // Label 4099: @207911
     /* 207911 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(207966), // Rule ID 2801 //
     /* 207916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 207924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207945 */     // MIs[0] imm
     /* 207945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 207948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 207953 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1528:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 207953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 207956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 207960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 207962 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 207964 */     GIR_RootConstrainSelectedInstOperands,
     /* 207965 */     // GIR_Coverage, 2801,
     /* 207965 */     GIR_EraseRootFromParent_Done,
     /* 207966 */   // Label 4100: @207966
     /* 207966 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(208021), // Rule ID 3552 //
     /* 207971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 207979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 207988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208000 */     // MIs[0] Idx
     /* 208000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 208008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 208008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 208011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208019 */     GIR_RootConstrainSelectedInstOperands,
     /* 208020 */     // GIR_Coverage, 3552,
     /* 208020 */     GIR_EraseRootFromParent_Done,
     /* 208021 */   // Label 4101: @208021
     /* 208021 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(208076), // Rule ID 3553 //
     /* 208026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208055 */     // MIs[0] Idx
     /* 208055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 208063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 208063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 208066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208070 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208074 */     GIR_RootConstrainSelectedInstOperands,
     /* 208075 */     // GIR_Coverage, 3553,
     /* 208075 */     GIR_EraseRootFromParent_Done,
     /* 208076 */   // Label 4102: @208076
     /* 208076 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(208131), // Rule ID 3554 //
     /* 208081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208110 */     // MIs[0] Idx
     /* 208110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 208118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 208118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 208121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208129 */     GIR_RootConstrainSelectedInstOperands,
     /* 208130 */     // GIR_Coverage, 3554,
     /* 208130 */     GIR_EraseRootFromParent_Done,
     /* 208131 */   // Label 4103: @208131
     /* 208131 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(208186), // Rule ID 3834 //
     /* 208136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 208139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 208144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 208147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 208153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208165 */     // MIs[0] imm
     /* 208165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 208173 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 208173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 208176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 208178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 208180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 208182 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208184 */     GIR_RootConstrainSelectedInstOperands,
     /* 208185 */     // GIR_Coverage, 3834,
     /* 208185 */     GIR_EraseRootFromParent_Done,
     /* 208186 */   // Label 4104: @208186
     /* 208186 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(208233), // Rule ID 2853 //
     /* 208191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208212 */     // MIs[0] idx
     /* 208212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1464:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 208220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 208223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208229 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208231 */     GIR_RootConstrainSelectedInstOperands,
     /* 208232 */     // GIR_Coverage, 2853,
     /* 208232 */     GIR_EraseRootFromParent_Done,
     /* 208233 */   // Label 4105: @208233
     /* 208233 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(208280), // Rule ID 2854 //
     /* 208238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208259 */     // MIs[0] idx
     /* 208259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208267 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 208267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 208270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208276 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208278 */     GIR_RootConstrainSelectedInstOperands,
     /* 208279 */     // GIR_Coverage, 2854,
     /* 208279 */     GIR_EraseRootFromParent_Done,
     /* 208280 */   // Label 4106: @208280
     /* 208280 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(208327), // Rule ID 2855 //
     /* 208285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208306 */     // MIs[0] idx
     /* 208306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1464:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 208314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 208317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208323 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208325 */     GIR_RootConstrainSelectedInstOperands,
     /* 208326 */     // GIR_Coverage, 2855,
     /* 208326 */     GIR_EraseRootFromParent_Done,
     /* 208327 */   // Label 4107: @208327
     /* 208327 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(208374), // Rule ID 3004 //
     /* 208332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208353 */     // MIs[0] Op3
     /* 208353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 208364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208372 */     GIR_RootConstrainSelectedInstOperands,
     /* 208373 */     // GIR_Coverage, 3004,
     /* 208373 */     GIR_EraseRootFromParent_Done,
     /* 208374 */   // Label 4108: @208374
     /* 208374 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208421), // Rule ID 3005 //
     /* 208379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208400 */     // MIs[0] Op3
     /* 208400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 208411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208419 */     GIR_RootConstrainSelectedInstOperands,
     /* 208420 */     // GIR_Coverage, 3005,
     /* 208420 */     GIR_EraseRootFromParent_Done,
     /* 208421 */   // Label 4109: @208421
     /* 208421 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208468), // Rule ID 3006 //
     /* 208426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208447 */     // MIs[0] Op3
     /* 208447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208455 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 208455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 208458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208466 */     GIR_RootConstrainSelectedInstOperands,
     /* 208467 */     // GIR_Coverage, 3006,
     /* 208467 */     GIR_EraseRootFromParent_Done,
     /* 208468 */   // Label 4110: @208468
     /* 208468 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208515), // Rule ID 3007 //
     /* 208473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 208481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208494 */     // MIs[0] Op3
     /* 208494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 208505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208513 */     GIR_RootConstrainSelectedInstOperands,
     /* 208514 */     // GIR_Coverage, 3007,
     /* 208514 */     GIR_EraseRootFromParent_Done,
     /* 208515 */   // Label 4111: @208515
     /* 208515 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208562), // Rule ID 3008 //
     /* 208520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 208528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208541 */     // MIs[0] Op3
     /* 208541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 208552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208560 */     GIR_RootConstrainSelectedInstOperands,
     /* 208561 */     // GIR_Coverage, 3008,
     /* 208561 */     GIR_EraseRootFromParent_Done,
     /* 208562 */   // Label 4112: @208562
     /* 208562 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208609), // Rule ID 3056 //
     /* 208567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208588 */     // MIs[0] Op3
     /* 208588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 208599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208607 */     GIR_RootConstrainSelectedInstOperands,
     /* 208608 */     // GIR_Coverage, 3056,
     /* 208608 */     GIR_EraseRootFromParent_Done,
     /* 208609 */   // Label 4113: @208609
     /* 208609 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208656), // Rule ID 3058 //
     /* 208614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208635 */     // MIs[0] Op3
     /* 208635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 208646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208654 */     GIR_RootConstrainSelectedInstOperands,
     /* 208655 */     // GIR_Coverage, 3058,
     /* 208655 */     GIR_EraseRootFromParent_Done,
     /* 208656 */   // Label 4114: @208656
     /* 208656 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208703), // Rule ID 3060 //
     /* 208661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208682 */     // MIs[0] Op3
     /* 208682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 208693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208701 */     GIR_RootConstrainSelectedInstOperands,
     /* 208702 */     // GIR_Coverage, 3060,
     /* 208702 */     GIR_EraseRootFromParent_Done,
     /* 208703 */   // Label 4115: @208703
     /* 208703 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208750), // Rule ID 3062 //
     /* 208708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 208716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208729 */     // MIs[0] Op3
     /* 208729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 208737 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1852:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 208737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 208740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 208742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208748 */     GIR_RootConstrainSelectedInstOperands,
     /* 208749 */     // GIR_Coverage, 3062,
     /* 208749 */     GIR_EraseRootFromParent_Done,
     /* 208750 */   // Label 4116: @208750
     /* 208750 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208797), // Rule ID 3084 //
     /* 208755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208776 */     // MIs[0] Op3
     /* 208776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1832:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 208787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208795 */     GIR_RootConstrainSelectedInstOperands,
     /* 208796 */     // GIR_Coverage, 3084,
     /* 208796 */     GIR_EraseRootFromParent_Done,
     /* 208797 */   // Label 4117: @208797
     /* 208797 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(208844), // Rule ID 3085 //
     /* 208802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208823 */     // MIs[0] Op3
     /* 208823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 208834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208842 */     GIR_RootConstrainSelectedInstOperands,
     /* 208843 */     // GIR_Coverage, 3085,
     /* 208843 */     GIR_EraseRootFromParent_Done,
     /* 208844 */   // Label 4118: @208844
     /* 208844 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(208891), // Rule ID 3086 //
     /* 208849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 208857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208870 */     // MIs[0] Op3
     /* 208870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 208878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 208878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 208881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208889 */     GIR_RootConstrainSelectedInstOperands,
     /* 208890 */     // GIR_Coverage, 3086,
     /* 208890 */     GIR_EraseRootFromParent_Done,
     /* 208891 */   // Label 4119: @208891
     /* 208891 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(208938), // Rule ID 3155 //
     /* 208896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208917 */     // MIs[0] Op3
     /* 208917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 208925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2133:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 208925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 208928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208936 */     GIR_RootConstrainSelectedInstOperands,
     /* 208937 */     // GIR_Coverage, 3155,
     /* 208937 */     GIR_EraseRootFromParent_Done,
     /* 208938 */   // Label 4120: @208938
     /* 208938 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(208985), // Rule ID 3156 //
     /* 208943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208964 */     // MIs[0] Op3
     /* 208964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 208972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2133:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 208972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 208975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208983 */     GIR_RootConstrainSelectedInstOperands,
     /* 208984 */     // GIR_Coverage, 3156,
     /* 208984 */     GIR_EraseRootFromParent_Done,
     /* 208985 */   // Label 4121: @208985
     /* 208985 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(209032), // Rule ID 3157 //
     /* 208990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 208998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209011 */     // MIs[0] Op3
     /* 209011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2133:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 209022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209030 */     GIR_RootConstrainSelectedInstOperands,
     /* 209031 */     // GIR_Coverage, 3157,
     /* 209031 */     GIR_EraseRootFromParent_Done,
     /* 209032 */   // Label 4122: @209032
     /* 209032 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209079), // Rule ID 3158 //
     /* 209037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209058 */     // MIs[0] Op3
     /* 209058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2133:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 209069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209077 */     GIR_RootConstrainSelectedInstOperands,
     /* 209078 */     // GIR_Coverage, 3158,
     /* 209078 */     GIR_EraseRootFromParent_Done,
     /* 209079 */   // Label 4123: @209079
     /* 209079 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209126), // Rule ID 3537 //
     /* 209084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 209087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 209092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209105 */     // MIs[0] Op3
     /* 209105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 209113 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1343:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 209113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 209116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209124 */     GIR_RootConstrainSelectedInstOperands,
     /* 209125 */     // GIR_Coverage, 3537,
     /* 209125 */     GIR_EraseRootFromParent_Done,
     /* 209126 */   // Label 4124: @209126
     /* 209126 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209173), // Rule ID 3585 //
     /* 209131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209152 */     // MIs[0] Op3
     /* 209152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 209163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209171 */     GIR_RootConstrainSelectedInstOperands,
     /* 209172 */     // GIR_Coverage, 3585,
     /* 209172 */     GIR_EraseRootFromParent_Done,
     /* 209173 */   // Label 4125: @209173
     /* 209173 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209220), // Rule ID 3586 //
     /* 209178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209199 */     // MIs[0] Op3
     /* 209199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209207 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209218 */     GIR_RootConstrainSelectedInstOperands,
     /* 209219 */     // GIR_Coverage, 3586,
     /* 209219 */     GIR_EraseRootFromParent_Done,
     /* 209220 */   // Label 4126: @209220
     /* 209220 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(209267), // Rule ID 3587 //
     /* 209225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209246 */     // MIs[0] Op3
     /* 209246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209254 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1582:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209265 */     GIR_RootConstrainSelectedInstOperands,
     /* 209266 */     // GIR_Coverage, 3587,
     /* 209266 */     GIR_EraseRootFromParent_Done,
     /* 209267 */   // Label 4127: @209267
     /* 209267 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(209314), // Rule ID 3588 //
     /* 209272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209293 */     // MIs[0] Op3
     /* 209293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 209301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1583:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 209301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 209304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209312 */     GIR_RootConstrainSelectedInstOperands,
     /* 209313 */     // GIR_Coverage, 3588,
     /* 209313 */     GIR_EraseRootFromParent_Done,
     /* 209314 */   // Label 4128: @209314
     /* 209314 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(209361), // Rule ID 3589 //
     /* 209319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209340 */     // MIs[0] Op3
     /* 209340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1583:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209359 */     GIR_RootConstrainSelectedInstOperands,
     /* 209360 */     // GIR_Coverage, 3589,
     /* 209360 */     GIR_EraseRootFromParent_Done,
     /* 209361 */   // Label 4129: @209361
     /* 209361 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209408), // Rule ID 3590 //
     /* 209366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209387 */     // MIs[0] Op3
     /* 209387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209395 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1583:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209406 */     GIR_RootConstrainSelectedInstOperands,
     /* 209407 */     // GIR_Coverage, 3590,
     /* 209407 */     GIR_EraseRootFromParent_Done,
     /* 209408 */   // Label 4130: @209408
     /* 209408 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209455), // Rule ID 11248 //
     /* 209413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209434 */     // MIs[0] Op3
     /* 209434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1782:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 209445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209453 */     GIR_RootConstrainSelectedInstOperands,
     /* 209454 */     // GIR_Coverage, 11248,
     /* 209454 */     GIR_EraseRootFromParent_Done,
     /* 209455 */   // Label 4131: @209455
     /* 209455 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209502), // Rule ID 11249 //
     /* 209460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209481 */     // MIs[0] Op3
     /* 209481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209489 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 209492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209500 */     GIR_RootConstrainSelectedInstOperands,
     /* 209501 */     // GIR_Coverage, 11249,
     /* 209501 */     GIR_EraseRootFromParent_Done,
     /* 209502 */   // Label 4132: @209502
     /* 209502 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209549), // Rule ID 11250 //
     /* 209507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209528 */     // MIs[0] Op3
     /* 209528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1782:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 209536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 209539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209547 */     GIR_RootConstrainSelectedInstOperands,
     /* 209548 */     // GIR_Coverage, 11250,
     /* 209548 */     GIR_EraseRootFromParent_Done,
     /* 209549 */   // Label 4133: @209549
     /* 209549 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209596), // Rule ID 11251 //
     /* 209554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209575 */     // MIs[0] Op3
     /* 209575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 209586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209594 */     GIR_RootConstrainSelectedInstOperands,
     /* 209595 */     // GIR_Coverage, 11251,
     /* 209595 */     GIR_EraseRootFromParent_Done,
     /* 209596 */   // Label 4134: @209596
     /* 209596 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209643), // Rule ID 11252 //
     /* 209601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209622 */     // MIs[0] Op3
     /* 209622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 209633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209641 */     GIR_RootConstrainSelectedInstOperands,
     /* 209642 */     // GIR_Coverage, 11252,
     /* 209642 */     GIR_EraseRootFromParent_Done,
     /* 209643 */   // Label 4135: @209643
     /* 209643 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209690), // Rule ID 11253 //
     /* 209648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 209656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209669 */     // MIs[0] Op3
     /* 209669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 209677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 209677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 209680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209688 */     GIR_RootConstrainSelectedInstOperands,
     /* 209689 */     // GIR_Coverage, 11253,
     /* 209689 */     GIR_EraseRootFromParent_Done,
     /* 209690 */   // Label 4136: @209690
     /* 209690 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209737), // Rule ID 11276 //
     /* 209695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 209703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209716 */     // MIs[0] Op3
     /* 209716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 209727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209735 */     GIR_RootConstrainSelectedInstOperands,
     /* 209736 */     // GIR_Coverage, 11276,
     /* 209736 */     GIR_EraseRootFromParent_Done,
     /* 209737 */   // Label 4137: @209737
     /* 209737 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209784), // Rule ID 11277 //
     /* 209742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 209750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209763 */     // MIs[0] Op3
     /* 209763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209771 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 209774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209782 */     GIR_RootConstrainSelectedInstOperands,
     /* 209783 */     // GIR_Coverage, 11277,
     /* 209783 */     GIR_EraseRootFromParent_Done,
     /* 209784 */   // Label 4138: @209784
     /* 209784 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209831), // Rule ID 11278 //
     /* 209789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209810 */     // MIs[0] Op3
     /* 209810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 209821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209829 */     GIR_RootConstrainSelectedInstOperands,
     /* 209830 */     // GIR_Coverage, 11278,
     /* 209830 */     GIR_EraseRootFromParent_Done,
     /* 209831 */   // Label 4139: @209831
     /* 209831 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(209878), // Rule ID 11279 //
     /* 209836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 209844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209857 */     // MIs[0] Op3
     /* 209857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 209868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209876 */     GIR_RootConstrainSelectedInstOperands,
     /* 209877 */     // GIR_Coverage, 11279,
     /* 209877 */     GIR_EraseRootFromParent_Done,
     /* 209878 */   // Label 4140: @209878
     /* 209878 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(209925), // Rule ID 11280 //
     /* 209883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209904 */     // MIs[0] Op3
     /* 209904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 209915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209923 */     GIR_RootConstrainSelectedInstOperands,
     /* 209924 */     // GIR_Coverage, 11280,
     /* 209924 */     GIR_EraseRootFromParent_Done,
     /* 209925 */   // Label 4141: @209925
     /* 209925 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(209972), // Rule ID 11281 //
     /* 209930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 209938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209951 */     // MIs[0] Op3
     /* 209951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209959 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 209962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209970 */     GIR_RootConstrainSelectedInstOperands,
     /* 209971 */     // GIR_Coverage, 11281,
     /* 209971 */     GIR_EraseRootFromParent_Done,
     /* 209972 */   // Label 4142: @209972
     /* 209972 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210019), // Rule ID 11282 //
     /* 209977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 209985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209998 */     // MIs[0] Op3
     /* 209998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 210009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210017 */     GIR_RootConstrainSelectedInstOperands,
     /* 210018 */     // GIR_Coverage, 11282,
     /* 210018 */     GIR_EraseRootFromParent_Done,
     /* 210019 */   // Label 4143: @210019
     /* 210019 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210066), // Rule ID 11283 //
     /* 210024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210045 */     // MIs[0] Op3
     /* 210045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 210056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210064 */     GIR_RootConstrainSelectedInstOperands,
     /* 210065 */     // GIR_Coverage, 11283,
     /* 210065 */     GIR_EraseRootFromParent_Done,
     /* 210066 */   // Label 4144: @210066
     /* 210066 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210113), // Rule ID 11284 //
     /* 210071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210092 */     // MIs[0] Op3
     /* 210092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 210103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210111 */     GIR_RootConstrainSelectedInstOperands,
     /* 210112 */     // GIR_Coverage, 11284,
     /* 210112 */     GIR_EraseRootFromParent_Done,
     /* 210113 */   // Label 4145: @210113
     /* 210113 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210160), // Rule ID 11285 //
     /* 210118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210139 */     // MIs[0] Op3
     /* 210139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210147 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 210150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210158 */     GIR_RootConstrainSelectedInstOperands,
     /* 210159 */     // GIR_Coverage, 11285,
     /* 210159 */     GIR_EraseRootFromParent_Done,
     /* 210160 */   // Label 4146: @210160
     /* 210160 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210207), // Rule ID 11529 //
     /* 210165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210186 */     // MIs[0] Op3
     /* 210186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210194 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1848:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 210197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210205 */     GIR_RootConstrainSelectedInstOperands,
     /* 210206 */     // GIR_Coverage, 11529,
     /* 210206 */     GIR_EraseRootFromParent_Done,
     /* 210207 */   // Label 4147: @210207
     /* 210207 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210254), // Rule ID 11530 //
     /* 210212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210233 */     // MIs[0] Op3
     /* 210233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1848:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 210244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210252 */     GIR_RootConstrainSelectedInstOperands,
     /* 210253 */     // GIR_Coverage, 11530,
     /* 210253 */     GIR_EraseRootFromParent_Done,
     /* 210254 */   // Label 4148: @210254
     /* 210254 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210301), // Rule ID 11531 //
     /* 210259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210280 */     // MIs[0] Op3
     /* 210280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 210291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210299 */     GIR_RootConstrainSelectedInstOperands,
     /* 210300 */     // GIR_Coverage, 11531,
     /* 210300 */     GIR_EraseRootFromParent_Done,
     /* 210301 */   // Label 4149: @210301
     /* 210301 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210348), // Rule ID 11532 //
     /* 210306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210327 */     // MIs[0] Op3
     /* 210327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210335 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1848:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 210338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210346 */     GIR_RootConstrainSelectedInstOperands,
     /* 210347 */     // GIR_Coverage, 11532,
     /* 210347 */     GIR_EraseRootFromParent_Done,
     /* 210348 */   // Label 4150: @210348
     /* 210348 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210395), // Rule ID 11533 //
     /* 210353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210374 */     // MIs[0] Op3
     /* 210374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 210385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210393 */     GIR_RootConstrainSelectedInstOperands,
     /* 210394 */     // GIR_Coverage, 11533,
     /* 210394 */     GIR_EraseRootFromParent_Done,
     /* 210395 */   // Label 4151: @210395
     /* 210395 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210442), // Rule ID 11535 //
     /* 210400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210421 */     // MIs[0] Op3
     /* 210421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210429 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 210432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210440 */     GIR_RootConstrainSelectedInstOperands,
     /* 210441 */     // GIR_Coverage, 11535,
     /* 210441 */     GIR_EraseRootFromParent_Done,
     /* 210442 */   // Label 4152: @210442
     /* 210442 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210489), // Rule ID 11537 //
     /* 210447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210468 */     // MIs[0] Op3
     /* 210468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 210479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210487 */     GIR_RootConstrainSelectedInstOperands,
     /* 210488 */     // GIR_Coverage, 11537,
     /* 210488 */     GIR_EraseRootFromParent_Done,
     /* 210489 */   // Label 4153: @210489
     /* 210489 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210536), // Rule ID 11539 //
     /* 210494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210515 */     // MIs[0] Op3
     /* 210515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2039:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 210526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210534 */     GIR_RootConstrainSelectedInstOperands,
     /* 210535 */     // GIR_Coverage, 11539,
     /* 210535 */     GIR_EraseRootFromParent_Done,
     /* 210536 */   // Label 4154: @210536
     /* 210536 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210583), // Rule ID 11541 //
     /* 210541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210562 */     // MIs[0] Op3
     /* 210562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 210570 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 210570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 210573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210579 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210581 */     GIR_RootConstrainSelectedInstOperands,
     /* 210582 */     // GIR_Coverage, 11541,
     /* 210582 */     GIR_EraseRootFromParent_Done,
     /* 210583 */   // Label 4155: @210583
     /* 210583 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210630), // Rule ID 11542 //
     /* 210588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210609 */     // MIs[0] Op3
     /* 210609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 210617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 210617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 210620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210628 */     GIR_RootConstrainSelectedInstOperands,
     /* 210629 */     // GIR_Coverage, 11542,
     /* 210629 */     GIR_EraseRootFromParent_Done,
     /* 210630 */   // Label 4156: @210630
     /* 210630 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210677), // Rule ID 11543 //
     /* 210635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210656 */     // MIs[0] Op3
     /* 210656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 210664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 210664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 210667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210675 */     GIR_RootConstrainSelectedInstOperands,
     /* 210676 */     // GIR_Coverage, 11543,
     /* 210676 */     GIR_EraseRootFromParent_Done,
     /* 210677 */   // Label 4157: @210677
     /* 210677 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210724), // Rule ID 11544 //
     /* 210682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 210690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210703 */     // MIs[0] Op3
     /* 210703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 210711 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 210711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 210714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210722 */     GIR_RootConstrainSelectedInstOperands,
     /* 210723 */     // GIR_Coverage, 11544,
     /* 210723 */     GIR_EraseRootFromParent_Done,
     /* 210724 */   // Label 4158: @210724
     /* 210724 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210771), // Rule ID 11619 //
     /* 210729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210750 */     // MIs[0] Op3
     /* 210750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 210761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210769 */     GIR_RootConstrainSelectedInstOperands,
     /* 210770 */     // GIR_Coverage, 11619,
     /* 210770 */     GIR_EraseRootFromParent_Done,
     /* 210771 */   // Label 4159: @210771
     /* 210771 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210818), // Rule ID 11621 //
     /* 210776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210797 */     // MIs[0] Op3
     /* 210797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 210808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210816 */     GIR_RootConstrainSelectedInstOperands,
     /* 210817 */     // GIR_Coverage, 11621,
     /* 210817 */     GIR_EraseRootFromParent_Done,
     /* 210818 */   // Label 4160: @210818
     /* 210818 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(210865), // Rule ID 11623 //
     /* 210823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210844 */     // MIs[0] Op3
     /* 210844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 210855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210863 */     GIR_RootConstrainSelectedInstOperands,
     /* 210864 */     // GIR_Coverage, 11623,
     /* 210864 */     GIR_EraseRootFromParent_Done,
     /* 210865 */   // Label 4161: @210865
     /* 210865 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(210912), // Rule ID 11625 //
     /* 210870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 210878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210891 */     // MIs[0] Op3
     /* 210891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 210902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210910 */     GIR_RootConstrainSelectedInstOperands,
     /* 210911 */     // GIR_Coverage, 11625,
     /* 210911 */     GIR_EraseRootFromParent_Done,
     /* 210912 */   // Label 4162: @210912
     /* 210912 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(210959), // Rule ID 11627 //
     /* 210917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210938 */     // MIs[0] Op3
     /* 210938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 210949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210957 */     GIR_RootConstrainSelectedInstOperands,
     /* 210958 */     // GIR_Coverage, 11627,
     /* 210958 */     GIR_EraseRootFromParent_Done,
     /* 210959 */   // Label 4163: @210959
     /* 210959 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211006), // Rule ID 11628 //
     /* 210964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 210972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210985 */     // MIs[0] Op3
     /* 210985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 210996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 210998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211004 */     GIR_RootConstrainSelectedInstOperands,
     /* 211005 */     // GIR_Coverage, 11628,
     /* 211005 */     GIR_EraseRootFromParent_Done,
     /* 211006 */   // Label 4164: @211006
     /* 211006 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211053), // Rule ID 11629 //
     /* 211011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211032 */     // MIs[0] Op3
     /* 211032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 211043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211051 */     GIR_RootConstrainSelectedInstOperands,
     /* 211052 */     // GIR_Coverage, 11629,
     /* 211052 */     GIR_EraseRootFromParent_Done,
     /* 211053 */   // Label 4165: @211053
     /* 211053 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211100), // Rule ID 11630 //
     /* 211058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211079 */     // MIs[0] Op3
     /* 211079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 211090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211098 */     GIR_RootConstrainSelectedInstOperands,
     /* 211099 */     // GIR_Coverage, 11630,
     /* 211099 */     GIR_EraseRootFromParent_Done,
     /* 211100 */   // Label 4166: @211100
     /* 211100 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211147), // Rule ID 11635 //
     /* 211105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211126 */     // MIs[0] Op3
     /* 211126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211129 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211134 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2041:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 211137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211145 */     GIR_RootConstrainSelectedInstOperands,
     /* 211146 */     // GIR_Coverage, 11635,
     /* 211146 */     GIR_EraseRootFromParent_Done,
     /* 211147 */   // Label 4167: @211147
     /* 211147 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211194), // Rule ID 11636 //
     /* 211152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211173 */     // MIs[0] Op3
     /* 211173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211181 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2041:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 211184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211192 */     GIR_RootConstrainSelectedInstOperands,
     /* 211193 */     // GIR_Coverage, 11636,
     /* 211193 */     GIR_EraseRootFromParent_Done,
     /* 211194 */   // Label 4168: @211194
     /* 211194 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211241), // Rule ID 11637 //
     /* 211199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211220 */     // MIs[0] Op3
     /* 211220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2041:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 211231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211239 */     GIR_RootConstrainSelectedInstOperands,
     /* 211240 */     // GIR_Coverage, 11637,
     /* 211240 */     GIR_EraseRootFromParent_Done,
     /* 211241 */   // Label 4169: @211241
     /* 211241 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211288), // Rule ID 11638 //
     /* 211246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211267 */     // MIs[0] Op3
     /* 211267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2041:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 211278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211286 */     GIR_RootConstrainSelectedInstOperands,
     /* 211287 */     // GIR_Coverage, 11638,
     /* 211287 */     GIR_EraseRootFromParent_Done,
     /* 211288 */   // Label 4170: @211288
     /* 211288 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211335), // Rule ID 11698 //
     /* 211293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211314 */     // MIs[0] Op3
     /* 211314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 211325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211333 */     GIR_RootConstrainSelectedInstOperands,
     /* 211334 */     // GIR_Coverage, 11698,
     /* 211334 */     GIR_EraseRootFromParent_Done,
     /* 211335 */   // Label 4171: @211335
     /* 211335 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211382), // Rule ID 11699 //
     /* 211340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211361 */     // MIs[0] Op3
     /* 211361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 211372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211380 */     GIR_RootConstrainSelectedInstOperands,
     /* 211381 */     // GIR_Coverage, 11699,
     /* 211381 */     GIR_EraseRootFromParent_Done,
     /* 211382 */   // Label 4172: @211382
     /* 211382 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211429), // Rule ID 11700 //
     /* 211387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211408 */     // MIs[0] Op3
     /* 211408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 211419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211427 */     GIR_RootConstrainSelectedInstOperands,
     /* 211428 */     // GIR_Coverage, 11700,
     /* 211428 */     GIR_EraseRootFromParent_Done,
     /* 211429 */   // Label 4173: @211429
     /* 211429 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211476), // Rule ID 11701 //
     /* 211434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211455 */     // MIs[0] Op3
     /* 211455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1705:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 211466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211474 */     GIR_RootConstrainSelectedInstOperands,
     /* 211475 */     // GIR_Coverage, 11701,
     /* 211475 */     GIR_EraseRootFromParent_Done,
     /* 211476 */   // Label 4174: @211476
     /* 211476 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211523), // Rule ID 11702 //
     /* 211481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211502 */     // MIs[0] Op3
     /* 211502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1705:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 211513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211521 */     GIR_RootConstrainSelectedInstOperands,
     /* 211522 */     // GIR_Coverage, 11702,
     /* 211522 */     GIR_EraseRootFromParent_Done,
     /* 211523 */   // Label 4175: @211523
     /* 211523 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211570), // Rule ID 11703 //
     /* 211528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211549 */     // MIs[0] Op3
     /* 211549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1705:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 211560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211568 */     GIR_RootConstrainSelectedInstOperands,
     /* 211569 */     // GIR_Coverage, 11703,
     /* 211569 */     GIR_EraseRootFromParent_Done,
     /* 211570 */   // Label 4176: @211570
     /* 211570 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211617), // Rule ID 11704 //
     /* 211575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211596 */     // MIs[0] Op3
     /* 211596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211604 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 211607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211615 */     GIR_RootConstrainSelectedInstOperands,
     /* 211616 */     // GIR_Coverage, 11704,
     /* 211616 */     GIR_EraseRootFromParent_Done,
     /* 211617 */   // Label 4177: @211617
     /* 211617 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211664), // Rule ID 11705 //
     /* 211622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211643 */     // MIs[0] Op3
     /* 211643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211651 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 211654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211662 */     GIR_RootConstrainSelectedInstOperands,
     /* 211663 */     // GIR_Coverage, 11705,
     /* 211663 */     GIR_EraseRootFromParent_Done,
     /* 211664 */   // Label 4178: @211664
     /* 211664 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211711), // Rule ID 11706 //
     /* 211669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 211677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211690 */     // MIs[0] Op3
     /* 211690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 211701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211709 */     GIR_RootConstrainSelectedInstOperands,
     /* 211710 */     // GIR_Coverage, 11706,
     /* 211710 */     GIR_EraseRootFromParent_Done,
     /* 211711 */   // Label 4179: @211711
     /* 211711 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211758), // Rule ID 11707 //
     /* 211716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211737 */     // MIs[0] Op3
     /* 211737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211745 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1830:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 211748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211756 */     GIR_RootConstrainSelectedInstOperands,
     /* 211757 */     // GIR_Coverage, 11707,
     /* 211757 */     GIR_EraseRootFromParent_Done,
     /* 211758 */   // Label 4180: @211758
     /* 211758 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211805), // Rule ID 11708 //
     /* 211763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211784 */     // MIs[0] Op3
     /* 211784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211792 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 211795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211803 */     GIR_RootConstrainSelectedInstOperands,
     /* 211804 */     // GIR_Coverage, 11708,
     /* 211804 */     GIR_EraseRootFromParent_Done,
     /* 211805 */   // Label 4181: @211805
     /* 211805 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(211852), // Rule ID 11709 //
     /* 211810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 211818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211831 */     // MIs[0] Op3
     /* 211831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 211842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211850 */     GIR_RootConstrainSelectedInstOperands,
     /* 211851 */     // GIR_Coverage, 11709,
     /* 211851 */     GIR_EraseRootFromParent_Done,
     /* 211852 */   // Label 4182: @211852
     /* 211852 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(211899), // Rule ID 11710 //
     /* 211857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211878 */     // MIs[0] Op3
     /* 211878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1820:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 211889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211897 */     GIR_RootConstrainSelectedInstOperands,
     /* 211898 */     // GIR_Coverage, 11710,
     /* 211898 */     GIR_EraseRootFromParent_Done,
     /* 211899 */   // Label 4183: @211899
     /* 211899 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(211946), // Rule ID 11711 //
     /* 211904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211925 */     // MIs[0] Op3
     /* 211925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 211936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211944 */     GIR_RootConstrainSelectedInstOperands,
     /* 211945 */     // GIR_Coverage, 11711,
     /* 211945 */     GIR_EraseRootFromParent_Done,
     /* 211946 */   // Label 4184: @211946
     /* 211946 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(211993), // Rule ID 11712 //
     /* 211951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 211959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211972 */     // MIs[0] Op3
     /* 211972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 211983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211991 */     GIR_RootConstrainSelectedInstOperands,
     /* 211992 */     // GIR_Coverage, 11712,
     /* 211992 */     GIR_EraseRootFromParent_Done,
     /* 211993 */   // Label 4185: @211993
     /* 211993 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212040), // Rule ID 11713 //
     /* 211998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212019 */     // MIs[0] Op3
     /* 212019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2025:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 212030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212038 */     GIR_RootConstrainSelectedInstOperands,
     /* 212039 */     // GIR_Coverage, 11713,
     /* 212039 */     GIR_EraseRootFromParent_Done,
     /* 212040 */   // Label 4186: @212040
     /* 212040 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212087), // Rule ID 11714 //
     /* 212045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212066 */     // MIs[0] Op3
     /* 212066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212074 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2025:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 212077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212085 */     GIR_RootConstrainSelectedInstOperands,
     /* 212086 */     // GIR_Coverage, 11714,
     /* 212086 */     GIR_EraseRootFromParent_Done,
     /* 212087 */   // Label 4187: @212087
     /* 212087 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212134), // Rule ID 11715 //
     /* 212092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212113 */     // MIs[0] Op3
     /* 212113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2025:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 212124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212132 */     GIR_RootConstrainSelectedInstOperands,
     /* 212133 */     // GIR_Coverage, 11715,
     /* 212133 */     GIR_EraseRootFromParent_Done,
     /* 212134 */   // Label 4188: @212134
     /* 212134 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212181), // Rule ID 11716 //
     /* 212139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212160 */     // MIs[0] Op3
     /* 212160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2022:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 212171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212179 */     GIR_RootConstrainSelectedInstOperands,
     /* 212180 */     // GIR_Coverage, 11716,
     /* 212180 */     GIR_EraseRootFromParent_Done,
     /* 212181 */   // Label 4189: @212181
     /* 212181 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212228), // Rule ID 11717 //
     /* 212186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212207 */     // MIs[0] Op3
     /* 212207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212215 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2022:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 212218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212226 */     GIR_RootConstrainSelectedInstOperands,
     /* 212227 */     // GIR_Coverage, 11717,
     /* 212227 */     GIR_EraseRootFromParent_Done,
     /* 212228 */   // Label 4190: @212228
     /* 212228 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212275), // Rule ID 11718 //
     /* 212233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212254 */     // MIs[0] Op3
     /* 212254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2022:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 212265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212273 */     GIR_RootConstrainSelectedInstOperands,
     /* 212274 */     // GIR_Coverage, 11718,
     /* 212274 */     GIR_EraseRootFromParent_Done,
     /* 212275 */   // Label 4191: @212275
     /* 212275 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212342), // Rule ID 2604 //
     /* 212280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 212288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2032:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 212331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212340 */     GIR_RootConstrainSelectedInstOperands,
     /* 212341 */     // GIR_Coverage, 2604,
     /* 212341 */     GIR_EraseRootFromParent_Done,
     /* 212342 */   // Label 4192: @212342
     /* 212342 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212409), // Rule ID 7649 //
     /* 212347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212381 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 212398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212407 */     GIR_RootConstrainSelectedInstOperands,
     /* 212408 */     // GIR_Coverage, 7649,
     /* 212408 */     GIR_EraseRootFromParent_Done,
     /* 212409 */   // Label 4193: @212409
     /* 212409 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212476), // Rule ID 7651 //
     /* 212414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 212465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212474 */     GIR_RootConstrainSelectedInstOperands,
     /* 212475 */     // GIR_Coverage, 7651,
     /* 212475 */     GIR_EraseRootFromParent_Done,
     /* 212476 */   // Label 4194: @212476
     /* 212476 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212543), // Rule ID 7653 //
     /* 212481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 212532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212541 */     GIR_RootConstrainSelectedInstOperands,
     /* 212542 */     // GIR_Coverage, 7653,
     /* 212542 */     GIR_EraseRootFromParent_Done,
     /* 212543 */   // Label 4195: @212543
     /* 212543 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212610), // Rule ID 7655 //
     /* 212548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 212599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212608 */     GIR_RootConstrainSelectedInstOperands,
     /* 212609 */     // GIR_Coverage, 7655,
     /* 212609 */     GIR_EraseRootFromParent_Done,
     /* 212610 */   // Label 4196: @212610
     /* 212610 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212677), // Rule ID 7685 //
     /* 212615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 212666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212675 */     GIR_RootConstrainSelectedInstOperands,
     /* 212676 */     // GIR_Coverage, 7685,
     /* 212676 */     GIR_EraseRootFromParent_Done,
     /* 212677 */   // Label 4197: @212677
     /* 212677 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212744), // Rule ID 7687 //
     /* 212682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 212733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212742 */     GIR_RootConstrainSelectedInstOperands,
     /* 212743 */     // GIR_Coverage, 7687,
     /* 212743 */     GIR_EraseRootFromParent_Done,
     /* 212744 */   // Label 4198: @212744
     /* 212744 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212811), // Rule ID 7689 //
     /* 212749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212783 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 212800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212809 */     GIR_RootConstrainSelectedInstOperands,
     /* 212810 */     // GIR_Coverage, 7689,
     /* 212810 */     GIR_EraseRootFromParent_Done,
     /* 212811 */   // Label 4199: @212811
     /* 212811 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212878), // Rule ID 7691 //
     /* 212816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 212824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 212833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 212836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 212867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212876 */     GIR_RootConstrainSelectedInstOperands,
     /* 212877 */     // GIR_Coverage, 7691,
     /* 212877 */     GIR_EraseRootFromParent_Done,
     /* 212878 */   // Label 4200: @212878
     /* 212878 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212945), // Rule ID 7697 //
     /* 212883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 212934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212943 */     GIR_RootConstrainSelectedInstOperands,
     /* 212944 */     // GIR_Coverage, 7697,
     /* 212944 */     GIR_EraseRootFromParent_Done,
     /* 212945 */   // Label 4201: @212945
     /* 212945 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(213012), // Rule ID 7699 //
     /* 212950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 212958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 213001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213010 */     GIR_RootConstrainSelectedInstOperands,
     /* 213011 */     // GIR_Coverage, 7699,
     /* 213011 */     GIR_EraseRootFromParent_Done,
     /* 213012 */   // Label 4202: @213012
     /* 213012 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213079), // Rule ID 7701 //
     /* 213017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 213068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213077 */     GIR_RootConstrainSelectedInstOperands,
     /* 213078 */     // GIR_Coverage, 7701,
     /* 213078 */     GIR_EraseRootFromParent_Done,
     /* 213079 */   // Label 4203: @213079
     /* 213079 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213146), // Rule ID 7703 //
     /* 213084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 213135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213144 */     GIR_RootConstrainSelectedInstOperands,
     /* 213145 */     // GIR_Coverage, 7703,
     /* 213145 */     GIR_EraseRootFromParent_Done,
     /* 213146 */   // Label 4204: @213146
     /* 213146 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213213), // Rule ID 11411 //
     /* 213151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 213159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 213202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213211 */     GIR_RootConstrainSelectedInstOperands,
     /* 213212 */     // GIR_Coverage, 11411,
     /* 213212 */     GIR_EraseRootFromParent_Done,
     /* 213213 */   // Label 4205: @213213
     /* 213213 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213280), // Rule ID 11413 //
     /* 213218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 213269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213278 */     GIR_RootConstrainSelectedInstOperands,
     /* 213279 */     // GIR_Coverage, 11413,
     /* 213279 */     GIR_EraseRootFromParent_Done,
     /* 213280 */   // Label 4206: @213280
     /* 213280 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213347), // Rule ID 11415 //
     /* 213285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 213336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213345 */     GIR_RootConstrainSelectedInstOperands,
     /* 213346 */     // GIR_Coverage, 11415,
     /* 213346 */     GIR_EraseRootFromParent_Done,
     /* 213347 */   // Label 4207: @213347
     /* 213347 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213414), // Rule ID 11417 //
     /* 213352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 213403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213412 */     GIR_RootConstrainSelectedInstOperands,
     /* 213413 */     // GIR_Coverage, 11417,
     /* 213413 */     GIR_EraseRootFromParent_Done,
     /* 213414 */   // Label 4208: @213414
     /* 213414 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213481), // Rule ID 11419 //
     /* 213419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 213470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213479 */     GIR_RootConstrainSelectedInstOperands,
     /* 213480 */     // GIR_Coverage, 11419,
     /* 213480 */     GIR_EraseRootFromParent_Done,
     /* 213481 */   // Label 4209: @213481
     /* 213481 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213548), // Rule ID 11425 //
     /* 213486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213520 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 213537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213546 */     GIR_RootConstrainSelectedInstOperands,
     /* 213547 */     // GIR_Coverage, 11425,
     /* 213547 */     GIR_EraseRootFromParent_Done,
     /* 213548 */   // Label 4210: @213548
     /* 213548 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213615), // Rule ID 11427 //
     /* 213553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 213604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213613 */     GIR_RootConstrainSelectedInstOperands,
     /* 213614 */     // GIR_Coverage, 11427,
     /* 213614 */     GIR_EraseRootFromParent_Done,
     /* 213615 */   // Label 4211: @213615
     /* 213615 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213682), // Rule ID 11429 //
     /* 213620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 213671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213680 */     GIR_RootConstrainSelectedInstOperands,
     /* 213681 */     // GIR_Coverage, 11429,
     /* 213681 */     GIR_EraseRootFromParent_Done,
     /* 213682 */   // Label 4212: @213682
     /* 213682 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213749), // Rule ID 11431 //
     /* 213687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 213695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 213738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213747 */     GIR_RootConstrainSelectedInstOperands,
     /* 213748 */     // GIR_Coverage, 11431,
     /* 213748 */     GIR_EraseRootFromParent_Done,
     /* 213749 */   // Label 4213: @213749
     /* 213749 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213803), // Rule ID 30 //
     /* 213754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 213762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213790 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 213793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213801 */     GIR_RootConstrainSelectedInstOperands,
     /* 213802 */     // GIR_Coverage, 30,
     /* 213802 */     GIR_EraseRootFromParent_Done,
     /* 213803 */   // Label 4214: @213803
     /* 213803 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213857), // Rule ID 31 //
     /* 213808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 213816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213844 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 213847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213855 */     GIR_RootConstrainSelectedInstOperands,
     /* 213856 */     // GIR_Coverage, 31,
     /* 213856 */     GIR_EraseRootFromParent_Done,
     /* 213857 */   // Label 4215: @213857
     /* 213857 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213911), // Rule ID 32 //
     /* 213862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 213865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 213870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 213879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 213882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213898 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 213898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 213901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213909 */     GIR_RootConstrainSelectedInstOperands,
     /* 213910 */     // GIR_Coverage, 32,
     /* 213910 */     GIR_EraseRootFromParent_Done,
     /* 213911 */   // Label 4216: @213911
     /* 213911 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(213965), // Rule ID 39 //
     /* 213916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 213924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 213927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 213930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 213933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 213936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 213952 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 213952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 213955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 213959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 213961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 213963 */     GIR_RootConstrainSelectedInstOperands,
     /* 213964 */     // GIR_Coverage, 39,
     /* 213964 */     GIR_EraseRootFromParent_Done,
     /* 213965 */   // Label 4217: @213965
     /* 213965 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(214019), // Rule ID 40 //
     /* 213970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 213973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 213978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 213987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 213990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214006 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 214009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214017 */     GIR_RootConstrainSelectedInstOperands,
     /* 214018 */     // GIR_Coverage, 40,
     /* 214018 */     GIR_EraseRootFromParent_Done,
     /* 214019 */   // Label 4218: @214019
     /* 214019 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(214073), // Rule ID 41 //
     /* 214024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214060 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 214063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214071 */     GIR_RootConstrainSelectedInstOperands,
     /* 214072 */     // GIR_Coverage, 41,
     /* 214072 */     GIR_EraseRootFromParent_Done,
     /* 214073 */   // Label 4219: @214073
     /* 214073 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(214127), // Rule ID 42 //
     /* 214078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214114 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 214117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214125 */     GIR_RootConstrainSelectedInstOperands,
     /* 214126 */     // GIR_Coverage, 42,
     /* 214126 */     GIR_EraseRootFromParent_Done,
     /* 214127 */   // Label 4220: @214127
     /* 214127 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(214181), // Rule ID 43 //
     /* 214132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214168 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 214171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214179 */     GIR_RootConstrainSelectedInstOperands,
     /* 214180 */     // GIR_Coverage, 43,
     /* 214180 */     GIR_EraseRootFromParent_Done,
     /* 214181 */   // Label 4221: @214181
     /* 214181 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(214235), // Rule ID 44 //
     /* 214186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214222 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 214225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214233 */     GIR_RootConstrainSelectedInstOperands,
     /* 214234 */     // GIR_Coverage, 44,
     /* 214234 */     GIR_EraseRootFromParent_Done,
     /* 214235 */   // Label 4222: @214235
     /* 214235 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(214289), // Rule ID 45 //
     /* 214240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214276 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 214279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214287 */     GIR_RootConstrainSelectedInstOperands,
     /* 214288 */     // GIR_Coverage, 45,
     /* 214288 */     GIR_EraseRootFromParent_Done,
     /* 214289 */   // Label 4223: @214289
     /* 214289 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(214343), // Rule ID 46 //
     /* 214294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214330 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 214333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214341 */     GIR_RootConstrainSelectedInstOperands,
     /* 214342 */     // GIR_Coverage, 46,
     /* 214342 */     GIR_EraseRootFromParent_Done,
     /* 214343 */   // Label 4224: @214343
     /* 214343 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(214397), // Rule ID 1587 //
     /* 214348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214384 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 214384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 214387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214395 */     GIR_RootConstrainSelectedInstOperands,
     /* 214396 */     // GIR_Coverage, 1587,
     /* 214396 */     GIR_EraseRootFromParent_Done,
     /* 214397 */   // Label 4225: @214397
     /* 214397 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214451), // Rule ID 1588 //
     /* 214402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214438 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 214438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 214441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214449 */     GIR_RootConstrainSelectedInstOperands,
     /* 214450 */     // GIR_Coverage, 1588,
     /* 214450 */     GIR_EraseRootFromParent_Done,
     /* 214451 */   // Label 4226: @214451
     /* 214451 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214505), // Rule ID 1589 //
     /* 214456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214492 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 214492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 214495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214503 */     GIR_RootConstrainSelectedInstOperands,
     /* 214504 */     // GIR_Coverage, 1589,
     /* 214504 */     GIR_EraseRootFromParent_Done,
     /* 214505 */   // Label 4227: @214505
     /* 214505 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214559), // Rule ID 1590 //
     /* 214510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214546 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 214549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214557 */     GIR_RootConstrainSelectedInstOperands,
     /* 214558 */     // GIR_Coverage, 1590,
     /* 214558 */     GIR_EraseRootFromParent_Done,
     /* 214559 */   // Label 4228: @214559
     /* 214559 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214613), // Rule ID 1591 //
     /* 214564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214600 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 214600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 214603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214611 */     GIR_RootConstrainSelectedInstOperands,
     /* 214612 */     // GIR_Coverage, 1591,
     /* 214612 */     GIR_EraseRootFromParent_Done,
     /* 214613 */   // Label 4229: @214613
     /* 214613 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214667), // Rule ID 1592 //
     /* 214618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214654 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 214654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 214657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214663 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214665 */     GIR_RootConstrainSelectedInstOperands,
     /* 214666 */     // GIR_Coverage, 1592,
     /* 214666 */     GIR_EraseRootFromParent_Done,
     /* 214667 */   // Label 4230: @214667
     /* 214667 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214721), // Rule ID 1593 //
     /* 214672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 214689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 214692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214708 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 214708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 214711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214719 */     GIR_RootConstrainSelectedInstOperands,
     /* 214720 */     // GIR_Coverage, 1593,
     /* 214720 */     GIR_EraseRootFromParent_Done,
     /* 214721 */   // Label 4231: @214721
     /* 214721 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214775), // Rule ID 1594 //
     /* 214726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 214734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214762 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 214765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214773 */     GIR_RootConstrainSelectedInstOperands,
     /* 214774 */     // GIR_Coverage, 1594,
     /* 214774 */     GIR_EraseRootFromParent_Done,
     /* 214775 */   // Label 4232: @214775
     /* 214775 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214829), // Rule ID 2307 //
     /* 214780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 214788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214816 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 214819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214827 */     GIR_RootConstrainSelectedInstOperands,
     /* 214828 */     // GIR_Coverage, 2307,
     /* 214828 */     GIR_EraseRootFromParent_Done,
     /* 214829 */   // Label 4233: @214829
     /* 214829 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214883), // Rule ID 2308 //
     /* 214834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 214842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214870 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 214873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214881 */     GIR_RootConstrainSelectedInstOperands,
     /* 214882 */     // GIR_Coverage, 2308,
     /* 214882 */     GIR_EraseRootFromParent_Done,
     /* 214883 */   // Label 4234: @214883
     /* 214883 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(214937), // Rule ID 2309 //
     /* 214888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 214896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 214920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 214927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214935 */     GIR_RootConstrainSelectedInstOperands,
     /* 214936 */     // GIR_Coverage, 2309,
     /* 214936 */     GIR_EraseRootFromParent_Done,
     /* 214937 */   // Label 4235: @214937
     /* 214937 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(214991), // Rule ID 2310 //
     /* 214942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 214950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 214959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 214962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 214978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 214981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214989 */     GIR_RootConstrainSelectedInstOperands,
     /* 214990 */     // GIR_Coverage, 2310,
     /* 214990 */     GIR_EraseRootFromParent_Done,
     /* 214991 */   // Label 4236: @214991
     /* 214991 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(215045), // Rule ID 2311 //
     /* 214996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 214999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 215004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215032 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 215035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215043 */     GIR_RootConstrainSelectedInstOperands,
     /* 215044 */     // GIR_Coverage, 2311,
     /* 215044 */     GIR_EraseRootFromParent_Done,
     /* 215045 */   // Label 4237: @215045
     /* 215045 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(215099), // Rule ID 2312 //
     /* 215050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 215058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 215089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215097 */     GIR_RootConstrainSelectedInstOperands,
     /* 215098 */     // GIR_Coverage, 2312,
     /* 215098 */     GIR_EraseRootFromParent_Done,
     /* 215099 */   // Label 4238: @215099
     /* 215099 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(215153), // Rule ID 2313 //
     /* 215104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 215112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215140 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 215143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215151 */     GIR_RootConstrainSelectedInstOperands,
     /* 215152 */     // GIR_Coverage, 2313,
     /* 215152 */     GIR_EraseRootFromParent_Done,
     /* 215153 */   // Label 4239: @215153
     /* 215153 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(215210), // Rule ID 3640 //
     /* 215158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 215197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215203 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215208 */     GIR_RootConstrainSelectedInstOperands,
     /* 215209 */     // GIR_Coverage, 3640,
     /* 215209 */     GIR_EraseRootFromParent_Done,
     /* 215210 */   // Label 4240: @215210
     /* 215210 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(215267), // Rule ID 3641 //
     /* 215215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215251 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 215254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215260 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215265 */     GIR_RootConstrainSelectedInstOperands,
     /* 215266 */     // GIR_Coverage, 3641,
     /* 215266 */     GIR_EraseRootFromParent_Done,
     /* 215267 */   // Label 4241: @215267
     /* 215267 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(215324), // Rule ID 3642 //
     /* 215272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 215311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215317 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215322 */     GIR_RootConstrainSelectedInstOperands,
     /* 215323 */     // GIR_Coverage, 3642,
     /* 215323 */     GIR_EraseRootFromParent_Done,
     /* 215324 */   // Label 4242: @215324
     /* 215324 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(215381), // Rule ID 3643 //
     /* 215329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215365 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 215368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215374 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215379 */     GIR_RootConstrainSelectedInstOperands,
     /* 215380 */     // GIR_Coverage, 3643,
     /* 215380 */     GIR_EraseRootFromParent_Done,
     /* 215381 */   // Label 4243: @215381
     /* 215381 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(215435), // Rule ID 3806 //
     /* 215386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 215394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215422 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 215425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215433 */     GIR_RootConstrainSelectedInstOperands,
     /* 215434 */     // GIR_Coverage, 3806,
     /* 215434 */     GIR_EraseRootFromParent_Done,
     /* 215435 */   // Label 4244: @215435
     /* 215435 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215489), // Rule ID 3807 //
     /* 215440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 215448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215476 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 215479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215487 */     GIR_RootConstrainSelectedInstOperands,
     /* 215488 */     // GIR_Coverage, 3807,
     /* 215488 */     GIR_EraseRootFromParent_Done,
     /* 215489 */   // Label 4245: @215489
     /* 215489 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215543), // Rule ID 3808 //
     /* 215494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 215502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215530 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 215533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215541 */     GIR_RootConstrainSelectedInstOperands,
     /* 215542 */     // GIR_Coverage, 3808,
     /* 215542 */     GIR_EraseRootFromParent_Done,
     /* 215543 */   // Label 4246: @215543
     /* 215543 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215597), // Rule ID 3809 //
     /* 215548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215584 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215595 */     GIR_RootConstrainSelectedInstOperands,
     /* 215596 */     // GIR_Coverage, 3809,
     /* 215596 */     GIR_EraseRootFromParent_Done,
     /* 215597 */   // Label 4247: @215597
     /* 215597 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215651), // Rule ID 3810 //
     /* 215602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215638 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215649 */     GIR_RootConstrainSelectedInstOperands,
     /* 215650 */     // GIR_Coverage, 3810,
     /* 215650 */     GIR_EraseRootFromParent_Done,
     /* 215651 */   // Label 4248: @215651
     /* 215651 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215705), // Rule ID 3811 //
     /* 215656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215703 */     GIR_RootConstrainSelectedInstOperands,
     /* 215704 */     // GIR_Coverage, 3811,
     /* 215704 */     GIR_EraseRootFromParent_Done,
     /* 215705 */   // Label 4249: @215705
     /* 215705 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215759), // Rule ID 3812 //
     /* 215710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 215718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215746 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 215749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215757 */     GIR_RootConstrainSelectedInstOperands,
     /* 215758 */     // GIR_Coverage, 3812,
     /* 215758 */     GIR_EraseRootFromParent_Done,
     /* 215759 */   // Label 4250: @215759
     /* 215759 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215813), // Rule ID 3821 //
     /* 215764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 215784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215800 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 215800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215811 */     GIR_RootConstrainSelectedInstOperands,
     /* 215812 */     // GIR_Coverage, 3821,
     /* 215812 */     GIR_EraseRootFromParent_Done,
     /* 215813 */   // Label 4251: @215813
     /* 215813 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215867), // Rule ID 3822 //
     /* 215818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215854 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 215854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215865 */     GIR_RootConstrainSelectedInstOperands,
     /* 215866 */     // GIR_Coverage, 3822,
     /* 215866 */     GIR_EraseRootFromParent_Done,
     /* 215867 */   // Label 4252: @215867
     /* 215867 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(215921), // Rule ID 3823 //
     /* 215872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215908 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 215908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215919 */     GIR_RootConstrainSelectedInstOperands,
     /* 215920 */     // GIR_Coverage, 3823,
     /* 215920 */     GIR_EraseRootFromParent_Done,
     /* 215921 */   // Label 4253: @215921
     /* 215921 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(215975), // Rule ID 3824 //
     /* 215926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 215934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215962 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 215965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215973 */     GIR_RootConstrainSelectedInstOperands,
     /* 215974 */     // GIR_Coverage, 3824,
     /* 215974 */     GIR_EraseRootFromParent_Done,
     /* 215975 */   // Label 4254: @215975
     /* 215975 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(216029), // Rule ID 3825 //
     /* 215980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 215988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 215994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 215997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216016 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216027 */     GIR_RootConstrainSelectedInstOperands,
     /* 216028 */     // GIR_Coverage, 3825,
     /* 216028 */     GIR_EraseRootFromParent_Done,
     /* 216029 */   // Label 4255: @216029
     /* 216029 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(216083), // Rule ID 3826 //
     /* 216034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216070 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216081 */     GIR_RootConstrainSelectedInstOperands,
     /* 216082 */     // GIR_Coverage, 3826,
     /* 216082 */     GIR_EraseRootFromParent_Done,
     /* 216083 */   // Label 4256: @216083
     /* 216083 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(216137), // Rule ID 3827 //
     /* 216088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216124 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216135 */     GIR_RootConstrainSelectedInstOperands,
     /* 216136 */     // GIR_Coverage, 3827,
     /* 216136 */     GIR_EraseRootFromParent_Done,
     /* 216137 */   // Label 4257: @216137
     /* 216137 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(216191), // Rule ID 3828 //
     /* 216142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216178 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216189 */     GIR_RootConstrainSelectedInstOperands,
     /* 216190 */     // GIR_Coverage, 3828,
     /* 216190 */     GIR_EraseRootFromParent_Done,
     /* 216191 */   // Label 4258: @216191
     /* 216191 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(216245), // Rule ID 3829 //
     /* 216196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216232 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216243 */     GIR_RootConstrainSelectedInstOperands,
     /* 216244 */     // GIR_Coverage, 3829,
     /* 216244 */     GIR_EraseRootFromParent_Done,
     /* 216245 */   // Label 4259: @216245
     /* 216245 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(216299), // Rule ID 3830 //
     /* 216250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216286 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216297 */     GIR_RootConstrainSelectedInstOperands,
     /* 216298 */     // GIR_Coverage, 3830,
     /* 216298 */     GIR_EraseRootFromParent_Done,
     /* 216299 */   // Label 4260: @216299
     /* 216299 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216353), // Rule ID 3831 //
     /* 216304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216340 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216351 */     GIR_RootConstrainSelectedInstOperands,
     /* 216352 */     // GIR_Coverage, 3831,
     /* 216352 */     GIR_EraseRootFromParent_Done,
     /* 216353 */   // Label 4261: @216353
     /* 216353 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216407), // Rule ID 3832 //
     /* 216358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216394 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216405 */     GIR_RootConstrainSelectedInstOperands,
     /* 216406 */     // GIR_Coverage, 3832,
     /* 216406 */     GIR_EraseRootFromParent_Done,
     /* 216407 */   // Label 4262: @216407
     /* 216407 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216461), // Rule ID 3836 //
     /* 216412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 216420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216448 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 216448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 216451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 216455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 216457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 216459 */     GIR_RootConstrainSelectedInstOperands,
     /* 216460 */     // GIR_Coverage, 3836,
     /* 216460 */     GIR_EraseRootFromParent_Done,
     /* 216461 */   // Label 4263: @216461
     /* 216461 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216515), // Rule ID 3837 //
     /* 216466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 216474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216502 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 216505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216513 */     GIR_RootConstrainSelectedInstOperands,
     /* 216514 */     // GIR_Coverage, 3837,
     /* 216514 */     GIR_EraseRootFromParent_Done,
     /* 216515 */   // Label 4264: @216515
     /* 216515 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216569), // Rule ID 3838 //
     /* 216520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 216528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216556 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 216559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216567 */     GIR_RootConstrainSelectedInstOperands,
     /* 216568 */     // GIR_Coverage, 3838,
     /* 216568 */     GIR_EraseRootFromParent_Done,
     /* 216569 */   // Label 4265: @216569
     /* 216569 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216626), // Rule ID 3855 //
     /* 216574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216610 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 216610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216624 */     GIR_RootConstrainSelectedInstOperands,
     /* 216625 */     // GIR_Coverage, 3855,
     /* 216625 */     GIR_EraseRootFromParent_Done,
     /* 216626 */   // Label 4266: @216626
     /* 216626 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(216683), // Rule ID 3856 //
     /* 216631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216667 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 216667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216681 */     GIR_RootConstrainSelectedInstOperands,
     /* 216682 */     // GIR_Coverage, 3856,
     /* 216682 */     GIR_EraseRootFromParent_Done,
     /* 216683 */   // Label 4267: @216683
     /* 216683 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(216740), // Rule ID 3857 //
     /* 216688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216724 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 216724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216738 */     GIR_RootConstrainSelectedInstOperands,
     /* 216739 */     // GIR_Coverage, 3857,
     /* 216739 */     GIR_EraseRootFromParent_Done,
     /* 216740 */   // Label 4268: @216740
     /* 216740 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(216797), // Rule ID 3858 //
     /* 216745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216781 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 216781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 216784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216795 */     GIR_RootConstrainSelectedInstOperands,
     /* 216796 */     // GIR_Coverage, 3858,
     /* 216796 */     GIR_EraseRootFromParent_Done,
     /* 216797 */   // Label 4269: @216797
     /* 216797 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(216854), // Rule ID 3863 //
     /* 216802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216838 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 216838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216852 */     GIR_RootConstrainSelectedInstOperands,
     /* 216853 */     // GIR_Coverage, 3863,
     /* 216853 */     GIR_EraseRootFromParent_Done,
     /* 216854 */   // Label 4270: @216854
     /* 216854 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(216911), // Rule ID 3864 //
     /* 216859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216895 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 216895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216909 */     GIR_RootConstrainSelectedInstOperands,
     /* 216910 */     // GIR_Coverage, 3864,
     /* 216910 */     GIR_EraseRootFromParent_Done,
     /* 216911 */   // Label 4271: @216911
     /* 216911 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(216968), // Rule ID 3865 //
     /* 216916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216952 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 216952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 216955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 216963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216966 */     GIR_RootConstrainSelectedInstOperands,
     /* 216967 */     // GIR_Coverage, 3865,
     /* 216967 */     GIR_EraseRootFromParent_Done,
     /* 216968 */   // Label 4272: @216968
     /* 216968 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(217025), // Rule ID 3866 //
     /* 216973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217009 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 217009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217023 */     GIR_RootConstrainSelectedInstOperands,
     /* 217024 */     // GIR_Coverage, 3866,
     /* 217024 */     GIR_EraseRootFromParent_Done,
     /* 217025 */   // Label 4273: @217025
     /* 217025 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(217082), // Rule ID 3871 //
     /* 217030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217066 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 217066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217080 */     GIR_RootConstrainSelectedInstOperands,
     /* 217081 */     // GIR_Coverage, 3871,
     /* 217081 */     GIR_EraseRootFromParent_Done,
     /* 217082 */   // Label 4274: @217082
     /* 217082 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(217139), // Rule ID 3872 //
     /* 217087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217123 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 217123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217137 */     GIR_RootConstrainSelectedInstOperands,
     /* 217138 */     // GIR_Coverage, 3872,
     /* 217138 */     GIR_EraseRootFromParent_Done,
     /* 217139 */   // Label 4275: @217139
     /* 217139 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(217196), // Rule ID 3873 //
     /* 217144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217180 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 217180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217194 */     GIR_RootConstrainSelectedInstOperands,
     /* 217195 */     // GIR_Coverage, 3873,
     /* 217195 */     GIR_EraseRootFromParent_Done,
     /* 217196 */   // Label 4276: @217196
     /* 217196 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(217253), // Rule ID 3874 //
     /* 217201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217237 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 217237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217251 */     GIR_RootConstrainSelectedInstOperands,
     /* 217252 */     // GIR_Coverage, 3874,
     /* 217252 */     GIR_EraseRootFromParent_Done,
     /* 217253 */   // Label 4277: @217253
     /* 217253 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(217310), // Rule ID 3875 //
     /* 217258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217294 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 217294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217308 */     GIR_RootConstrainSelectedInstOperands,
     /* 217309 */     // GIR_Coverage, 3875,
     /* 217309 */     GIR_EraseRootFromParent_Done,
     /* 217310 */   // Label 4278: @217310
     /* 217310 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217367), // Rule ID 3876 //
     /* 217315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217351 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 217351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217365 */     GIR_RootConstrainSelectedInstOperands,
     /* 217366 */     // GIR_Coverage, 3876,
     /* 217366 */     GIR_EraseRootFromParent_Done,
     /* 217367 */   // Label 4279: @217367
     /* 217367 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217424), // Rule ID 3877 //
     /* 217372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217408 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 217408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217422 */     GIR_RootConstrainSelectedInstOperands,
     /* 217423 */     // GIR_Coverage, 3877,
     /* 217423 */     GIR_EraseRootFromParent_Done,
     /* 217424 */   // Label 4280: @217424
     /* 217424 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217481), // Rule ID 3878 //
     /* 217429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217465 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 217465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217479 */     GIR_RootConstrainSelectedInstOperands,
     /* 217480 */     // GIR_Coverage, 3878,
     /* 217480 */     GIR_EraseRootFromParent_Done,
     /* 217481 */   // Label 4281: @217481
     /* 217481 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217538), // Rule ID 3879 //
     /* 217486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217522 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 217522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217536 */     GIR_RootConstrainSelectedInstOperands,
     /* 217537 */     // GIR_Coverage, 3879,
     /* 217537 */     GIR_EraseRootFromParent_Done,
     /* 217538 */   // Label 4282: @217538
     /* 217538 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217595), // Rule ID 3880 //
     /* 217543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217579 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 217579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217593 */     GIR_RootConstrainSelectedInstOperands,
     /* 217594 */     // GIR_Coverage, 3880,
     /* 217594 */     GIR_EraseRootFromParent_Done,
     /* 217595 */   // Label 4283: @217595
     /* 217595 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217652), // Rule ID 3881 //
     /* 217600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217636 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 217636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217650 */     GIR_RootConstrainSelectedInstOperands,
     /* 217651 */     // GIR_Coverage, 3881,
     /* 217651 */     GIR_EraseRootFromParent_Done,
     /* 217652 */   // Label 4284: @217652
     /* 217652 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(217709), // Rule ID 3882 //
     /* 217657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 217668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 217674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 217677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217693 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 217693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 217696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217707 */     GIR_RootConstrainSelectedInstOperands,
     /* 217708 */     // GIR_Coverage, 3882,
     /* 217708 */     GIR_EraseRootFromParent_Done,
     /* 217709 */   // Label 4285: @217709
     /* 217709 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(217763), // Rule ID 5217 //
     /* 217714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 217722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217750 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 217753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217761 */     GIR_RootConstrainSelectedInstOperands,
     /* 217762 */     // GIR_Coverage, 5217,
     /* 217762 */     GIR_EraseRootFromParent_Done,
     /* 217763 */   // Label 4286: @217763
     /* 217763 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(217817), // Rule ID 5218 //
     /* 217768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 217771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 217785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 217788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 217804 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 217804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 217807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217815 */     GIR_RootConstrainSelectedInstOperands,
     /* 217816 */     // GIR_Coverage, 5218,
     /* 217816 */     GIR_EraseRootFromParent_Done,
     /* 217817 */   // Label 4287: @217817
     /* 217817 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(217868), // Rule ID 5571 //
     /* 217822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 217830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 217833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 217839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217855 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 217855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 217858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 217866 */     GIR_RootConstrainSelectedInstOperands,
     /* 217867 */     // GIR_Coverage, 5571,
     /* 217867 */     GIR_EraseRootFromParent_Done,
     /* 217868 */   // Label 4288: @217868
     /* 217868 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(217919), // Rule ID 5572 //
     /* 217873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 217878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 217881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 217884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 217887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 217890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217906 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 217906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 217909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 217915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 217917 */     GIR_RootConstrainSelectedInstOperands,
     /* 217918 */     // GIR_Coverage, 5572,
     /* 217918 */     GIR_EraseRootFromParent_Done,
     /* 217919 */   // Label 4289: @217919
     /* 217919 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(217961), // Rule ID 2699 //
     /* 217924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 217944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 217948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 217951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217957 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 217959 */     GIR_RootConstrainSelectedInstOperands,
     /* 217960 */     // GIR_Coverage, 2699,
     /* 217960 */     GIR_EraseRootFromParent_Done,
     /* 217961 */   // Label 4290: @217961
     /* 217961 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(218003), // Rule ID 2700 //
     /* 217966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 217974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 217986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 217990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 217993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217999 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218001 */     GIR_RootConstrainSelectedInstOperands,
     /* 218002 */     // GIR_Coverage, 2700,
     /* 218002 */     GIR_EraseRootFromParent_Done,
     /* 218003 */   // Label 4291: @218003
     /* 218003 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(218045), // Rule ID 2701 //
     /* 218008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218043 */     GIR_RootConstrainSelectedInstOperands,
     /* 218044 */     // GIR_Coverage, 2701,
     /* 218044 */     GIR_EraseRootFromParent_Done,
     /* 218045 */   // Label 4292: @218045
     /* 218045 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(218087), // Rule ID 2702 //
     /* 218050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1904:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218085 */     GIR_RootConstrainSelectedInstOperands,
     /* 218086 */     // GIR_Coverage, 2702,
     /* 218086 */     GIR_EraseRootFromParent_Done,
     /* 218087 */   // Label 4293: @218087
     /* 218087 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(218129), // Rule ID 2703 //
     /* 218092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218116 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1904:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218125 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218127 */     GIR_RootConstrainSelectedInstOperands,
     /* 218128 */     // GIR_Coverage, 2703,
     /* 218128 */     GIR_EraseRootFromParent_Done,
     /* 218129 */   // Label 4294: @218129
     /* 218129 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(218171), // Rule ID 2704 //
     /* 218134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218158 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1904:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218167 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218169 */     GIR_RootConstrainSelectedInstOperands,
     /* 218170 */     // GIR_Coverage, 2704,
     /* 218170 */     GIR_EraseRootFromParent_Done,
     /* 218171 */   // Label 4295: @218171
     /* 218171 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(218213), // Rule ID 2705 //
     /* 218176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218200 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1904:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218211 */     GIR_RootConstrainSelectedInstOperands,
     /* 218212 */     // GIR_Coverage, 2705,
     /* 218212 */     GIR_EraseRootFromParent_Done,
     /* 218213 */   // Label 4296: @218213
     /* 218213 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(218255), // Rule ID 2744 //
     /* 218218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 218238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218242 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1250:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 218242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218253 */     GIR_RootConstrainSelectedInstOperands,
     /* 218254 */     // GIR_Coverage, 2744,
     /* 218254 */     GIR_EraseRootFromParent_Done,
     /* 218255 */   // Label 4297: @218255
     /* 218255 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(218297), // Rule ID 2745 //
     /* 218260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 218271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 218277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 218280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1250:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 218284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218295 */     GIR_RootConstrainSelectedInstOperands,
     /* 218296 */     // GIR_Coverage, 2745,
     /* 218296 */     GIR_EraseRootFromParent_Done,
     /* 218297 */   // Label 4298: @218297
     /* 218297 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(218339), // Rule ID 2746 //
     /* 218302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 218313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 218322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1250:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 218326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218337 */     GIR_RootConstrainSelectedInstOperands,
     /* 218338 */     // GIR_Coverage, 2746,
     /* 218338 */     GIR_EraseRootFromParent_Done,
     /* 218339 */   // Label 4299: @218339
     /* 218339 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(218381), // Rule ID 2747 //
     /* 218344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 218355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 218364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1250:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 218368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218379 */     GIR_RootConstrainSelectedInstOperands,
     /* 218380 */     // GIR_Coverage, 2747,
     /* 218380 */     GIR_EraseRootFromParent_Done,
     /* 218381 */   // Label 4300: @218381
     /* 218381 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218423), // Rule ID 2748 //
     /* 218386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 218397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 218400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 218403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 218406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218410 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1250:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 218410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218419 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218421 */     GIR_RootConstrainSelectedInstOperands,
     /* 218422 */     // GIR_Coverage, 2748,
     /* 218422 */     GIR_EraseRootFromParent_Done,
     /* 218423 */   // Label 4301: @218423
     /* 218423 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218465), // Rule ID 2787 //
     /* 218428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218452 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 218455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218463 */     GIR_RootConstrainSelectedInstOperands,
     /* 218464 */     // GIR_Coverage, 2787,
     /* 218464 */     GIR_EraseRootFromParent_Done,
     /* 218465 */   // Label 4302: @218465
     /* 218465 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218507), // Rule ID 2789 //
     /* 218470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218494 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 218497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218505 */     GIR_RootConstrainSelectedInstOperands,
     /* 218506 */     // GIR_Coverage, 2789,
     /* 218506 */     GIR_EraseRootFromParent_Done,
     /* 218507 */   // Label 4303: @218507
     /* 218507 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218549), // Rule ID 2791 //
     /* 218512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 218539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218547 */     GIR_RootConstrainSelectedInstOperands,
     /* 218548 */     // GIR_Coverage, 2791,
     /* 218548 */     GIR_EraseRootFromParent_Done,
     /* 218549 */   // Label 4304: @218549
     /* 218549 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218591), // Rule ID 2793 //
     /* 218554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218578 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1523:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 218581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218589 */     GIR_RootConstrainSelectedInstOperands,
     /* 218590 */     // GIR_Coverage, 2793,
     /* 218590 */     GIR_EraseRootFromParent_Done,
     /* 218591 */   // Label 4305: @218591
     /* 218591 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218633), // Rule ID 2794 //
     /* 218596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1523:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 218623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218631 */     GIR_RootConstrainSelectedInstOperands,
     /* 218632 */     // GIR_Coverage, 2794,
     /* 218632 */     GIR_EraseRootFromParent_Done,
     /* 218633 */   // Label 4306: @218633
     /* 218633 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218675), // Rule ID 2795 //
     /* 218638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 218646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218662 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1523:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 218665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218673 */     GIR_RootConstrainSelectedInstOperands,
     /* 218674 */     // GIR_Coverage, 2795,
     /* 218674 */     GIR_EraseRootFromParent_Done,
     /* 218675 */   // Label 4307: @218675
     /* 218675 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218717), // Rule ID 2864 //
     /* 218680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 218688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218704 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1385:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 218707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218715 */     GIR_RootConstrainSelectedInstOperands,
     /* 218716 */     // GIR_Coverage, 2864,
     /* 218716 */     GIR_EraseRootFromParent_Done,
     /* 218717 */   // Label 4308: @218717
     /* 218717 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(218759), // Rule ID 2865 //
     /* 218722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 218730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218746 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1386:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 218749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218757 */     GIR_RootConstrainSelectedInstOperands,
     /* 218758 */     // GIR_Coverage, 2865,
     /* 218758 */     GIR_EraseRootFromParent_Done,
     /* 218759 */   // Label 4309: @218759
     /* 218759 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(218801), // Rule ID 2866 //
     /* 218764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 218772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218788 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 218791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218799 */     GIR_RootConstrainSelectedInstOperands,
     /* 218800 */     // GIR_Coverage, 2866,
     /* 218800 */     GIR_EraseRootFromParent_Done,
     /* 218801 */   // Label 4310: @218801
     /* 218801 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(218843), // Rule ID 2867 //
     /* 218806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 218814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218830 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 218833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218841 */     GIR_RootConstrainSelectedInstOperands,
     /* 218842 */     // GIR_Coverage, 2867,
     /* 218842 */     GIR_EraseRootFromParent_Done,
     /* 218843 */   // Label 4311: @218843
     /* 218843 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(218885), // Rule ID 2868 //
     /* 218848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 218856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218872 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 218875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218883 */     GIR_RootConstrainSelectedInstOperands,
     /* 218884 */     // GIR_Coverage, 2868,
     /* 218884 */     GIR_EraseRootFromParent_Done,
     /* 218885 */   // Label 4312: @218885
     /* 218885 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(218927), // Rule ID 2869 //
     /* 218890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218914 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1352:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 218917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218925 */     GIR_RootConstrainSelectedInstOperands,
     /* 218926 */     // GIR_Coverage, 2869,
     /* 218926 */     GIR_EraseRootFromParent_Done,
     /* 218927 */   // Label 4313: @218927
     /* 218927 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(218969), // Rule ID 2870 //
     /* 218932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218956 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1352:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 218956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 218959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218967 */     GIR_RootConstrainSelectedInstOperands,
     /* 218968 */     // GIR_Coverage, 2870,
     /* 218968 */     GIR_EraseRootFromParent_Done,
     /* 218969 */   // Label 4314: @218969
     /* 218969 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219011), // Rule ID 2871 //
     /* 218974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 218982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1352:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 218998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 219001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219009 */     GIR_RootConstrainSelectedInstOperands,
     /* 219010 */     // GIR_Coverage, 2871,
     /* 219010 */     GIR_EraseRootFromParent_Done,
     /* 219011 */   // Label 4315: @219011
     /* 219011 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219053), // Rule ID 2882 //
     /* 219016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 219024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219040 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 219043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219051 */     GIR_RootConstrainSelectedInstOperands,
     /* 219052 */     // GIR_Coverage, 2882,
     /* 219052 */     GIR_EraseRootFromParent_Done,
     /* 219053 */   // Label 4316: @219053
     /* 219053 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219095), // Rule ID 2884 //
     /* 219058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 219066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219082 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 219085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219093 */     GIR_RootConstrainSelectedInstOperands,
     /* 219094 */     // GIR_Coverage, 2884,
     /* 219094 */     GIR_EraseRootFromParent_Done,
     /* 219095 */   // Label 4317: @219095
     /* 219095 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219137), // Rule ID 2892 //
     /* 219100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1409:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 219127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219135 */     GIR_RootConstrainSelectedInstOperands,
     /* 219136 */     // GIR_Coverage, 2892,
     /* 219136 */     GIR_EraseRootFromParent_Done,
     /* 219137 */   // Label 4318: @219137
     /* 219137 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219179), // Rule ID 2893 //
     /* 219142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1409:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 219169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219177 */     GIR_RootConstrainSelectedInstOperands,
     /* 219178 */     // GIR_Coverage, 2893,
     /* 219178 */     GIR_EraseRootFromParent_Done,
     /* 219179 */   // Label 4319: @219179
     /* 219179 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219221), // Rule ID 2894 //
     /* 219184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1409:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 219211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219219 */     GIR_RootConstrainSelectedInstOperands,
     /* 219220 */     // GIR_Coverage, 2894,
     /* 219220 */     GIR_EraseRootFromParent_Done,
     /* 219221 */   // Label 4320: @219221
     /* 219221 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(219263), // Rule ID 2898 //
     /* 219226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 219234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219250 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 219253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219261 */     GIR_RootConstrainSelectedInstOperands,
     /* 219262 */     // GIR_Coverage, 2898,
     /* 219262 */     GIR_EraseRootFromParent_Done,
     /* 219263 */   // Label 4321: @219263
     /* 219263 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(219305), // Rule ID 2943 //
     /* 219268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 219295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219303 */     GIR_RootConstrainSelectedInstOperands,
     /* 219304 */     // GIR_Coverage, 2943,
     /* 219304 */     GIR_EraseRootFromParent_Done,
     /* 219305 */   // Label 4322: @219305
     /* 219305 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(219347), // Rule ID 2944 //
     /* 219310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 219337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219345 */     GIR_RootConstrainSelectedInstOperands,
     /* 219346 */     // GIR_Coverage, 2944,
     /* 219346 */     GIR_EraseRootFromParent_Done,
     /* 219347 */   // Label 4323: @219347
     /* 219347 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(219389), // Rule ID 2973 //
     /* 219352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219376 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1808:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 219379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219387 */     GIR_RootConstrainSelectedInstOperands,
     /* 219388 */     // GIR_Coverage, 2973,
     /* 219388 */     GIR_EraseRootFromParent_Done,
     /* 219389 */   // Label 4324: @219389
     /* 219389 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219431), // Rule ID 2974 //
     /* 219394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1808:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 219421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219429 */     GIR_RootConstrainSelectedInstOperands,
     /* 219430 */     // GIR_Coverage, 2974,
     /* 219430 */     GIR_EraseRootFromParent_Done,
     /* 219431 */   // Label 4325: @219431
     /* 219431 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219473), // Rule ID 2975 //
     /* 219436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 219463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219471 */     GIR_RootConstrainSelectedInstOperands,
     /* 219472 */     // GIR_Coverage, 2975,
     /* 219472 */     GIR_EraseRootFromParent_Done,
     /* 219473 */   // Label 4326: @219473
     /* 219473 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219515), // Rule ID 2976 //
     /* 219478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 219505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219513 */     GIR_RootConstrainSelectedInstOperands,
     /* 219514 */     // GIR_Coverage, 2976,
     /* 219514 */     GIR_EraseRootFromParent_Done,
     /* 219515 */   // Label 4327: @219515
     /* 219515 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219557), // Rule ID 2977 //
     /* 219520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 219547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219555 */     GIR_RootConstrainSelectedInstOperands,
     /* 219556 */     // GIR_Coverage, 2977,
     /* 219556 */     GIR_EraseRootFromParent_Done,
     /* 219557 */   // Label 4328: @219557
     /* 219557 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219599), // Rule ID 2978 //
     /* 219562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 219589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219597 */     GIR_RootConstrainSelectedInstOperands,
     /* 219598 */     // GIR_Coverage, 2978,
     /* 219598 */     GIR_EraseRootFromParent_Done,
     /* 219599 */   // Label 4329: @219599
     /* 219599 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(219641), // Rule ID 2979 //
     /* 219604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 219612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1729:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 219631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219639 */     GIR_RootConstrainSelectedInstOperands,
     /* 219640 */     // GIR_Coverage, 2979,
     /* 219640 */     GIR_EraseRootFromParent_Done,
     /* 219641 */   // Label 4330: @219641
     /* 219641 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(219683), // Rule ID 3009 //
     /* 219646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 219660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1703:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 219673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219681 */     GIR_RootConstrainSelectedInstOperands,
     /* 219682 */     // GIR_Coverage, 3009,
     /* 219682 */     GIR_EraseRootFromParent_Done,
     /* 219683 */   // Label 4331: @219683
     /* 219683 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(219725), // Rule ID 3011 //
     /* 219688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1703:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 219715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219723 */     GIR_RootConstrainSelectedInstOperands,
     /* 219724 */     // GIR_Coverage, 3011,
     /* 219724 */     GIR_EraseRootFromParent_Done,
     /* 219725 */   // Label 4332: @219725
     /* 219725 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(219767), // Rule ID 3013 //
     /* 219730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 219757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219765 */     GIR_RootConstrainSelectedInstOperands,
     /* 219766 */     // GIR_Coverage, 3013,
     /* 219766 */     GIR_EraseRootFromParent_Done,
     /* 219767 */   // Label 4333: @219767
     /* 219767 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(219809), // Rule ID 3015 //
     /* 219772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 219780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1703:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 219799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219807 */     GIR_RootConstrainSelectedInstOperands,
     /* 219808 */     // GIR_Coverage, 3015,
     /* 219808 */     GIR_EraseRootFromParent_Done,
     /* 219809 */   // Label 4334: @219809
     /* 219809 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(219851), // Rule ID 3017 //
     /* 219814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 219841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219849 */     GIR_RootConstrainSelectedInstOperands,
     /* 219850 */     // GIR_Coverage, 3017,
     /* 219850 */     GIR_EraseRootFromParent_Done,
     /* 219851 */   // Label 4335: @219851
     /* 219851 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(219893), // Rule ID 3018 //
     /* 219856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 219883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219891 */     GIR_RootConstrainSelectedInstOperands,
     /* 219892 */     // GIR_Coverage, 3018,
     /* 219892 */     GIR_EraseRootFromParent_Done,
     /* 219893 */   // Label 4336: @219893
     /* 219893 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(219935), // Rule ID 3019 //
     /* 219898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 219906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1673:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 219925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219933 */     GIR_RootConstrainSelectedInstOperands,
     /* 219934 */     // GIR_Coverage, 3019,
     /* 219934 */     GIR_EraseRootFromParent_Done,
     /* 219935 */   // Label 4337: @219935
     /* 219935 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(219977), // Rule ID 3020 //
     /* 219940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 219948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2032:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 219967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219975 */     GIR_RootConstrainSelectedInstOperands,
     /* 219976 */     // GIR_Coverage, 3020,
     /* 219976 */     GIR_EraseRootFromParent_Done,
     /* 219977 */   // Label 4338: @219977
     /* 219977 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220019), // Rule ID 3021 //
     /* 219982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 219990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 219999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 220009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220017 */     GIR_RootConstrainSelectedInstOperands,
     /* 220018 */     // GIR_Coverage, 3021,
     /* 220018 */     GIR_EraseRootFromParent_Done,
     /* 220019 */   // Label 4339: @220019
     /* 220019 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220061), // Rule ID 3022 //
     /* 220024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 220051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220059 */     GIR_RootConstrainSelectedInstOperands,
     /* 220060 */     // GIR_Coverage, 3022,
     /* 220060 */     GIR_EraseRootFromParent_Done,
     /* 220061 */   // Label 4340: @220061
     /* 220061 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220103), // Rule ID 3023 //
     /* 220066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 220093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220101 */     GIR_RootConstrainSelectedInstOperands,
     /* 220102 */     // GIR_Coverage, 3023,
     /* 220102 */     GIR_EraseRootFromParent_Done,
     /* 220103 */   // Label 4341: @220103
     /* 220103 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220145), // Rule ID 3024 //
     /* 220108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 220135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220143 */     GIR_RootConstrainSelectedInstOperands,
     /* 220144 */     // GIR_Coverage, 3024,
     /* 220144 */     GIR_EraseRootFromParent_Done,
     /* 220145 */   // Label 4342: @220145
     /* 220145 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220187), // Rule ID 3041 //
     /* 220150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1338:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 220177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220185 */     GIR_RootConstrainSelectedInstOperands,
     /* 220186 */     // GIR_Coverage, 3041,
     /* 220186 */     GIR_EraseRootFromParent_Done,
     /* 220187 */   // Label 4343: @220187
     /* 220187 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220229), // Rule ID 3042 //
     /* 220192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1338:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 220219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220227 */     GIR_RootConstrainSelectedInstOperands,
     /* 220228 */     // GIR_Coverage, 3042,
     /* 220228 */     GIR_EraseRootFromParent_Done,
     /* 220229 */   // Label 4344: @220229
     /* 220229 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(220271), // Rule ID 3043 //
     /* 220234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1338:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 220261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220269 */     GIR_RootConstrainSelectedInstOperands,
     /* 220270 */     // GIR_Coverage, 3043,
     /* 220270 */     GIR_EraseRootFromParent_Done,
     /* 220271 */   // Label 4345: @220271
     /* 220271 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(220313), // Rule ID 3044 //
     /* 220276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1338:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 220303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220311 */     GIR_RootConstrainSelectedInstOperands,
     /* 220312 */     // GIR_Coverage, 3044,
     /* 220312 */     GIR_EraseRootFromParent_Done,
     /* 220313 */   // Label 4346: @220313
     /* 220313 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(220355), // Rule ID 3068 //
     /* 220318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 220345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220353 */     GIR_RootConstrainSelectedInstOperands,
     /* 220354 */     // GIR_Coverage, 3068,
     /* 220354 */     GIR_EraseRootFromParent_Done,
     /* 220355 */   // Label 4347: @220355
     /* 220355 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(220397), // Rule ID 3070 //
     /* 220360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 220387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220395 */     GIR_RootConstrainSelectedInstOperands,
     /* 220396 */     // GIR_Coverage, 3070,
     /* 220396 */     GIR_EraseRootFromParent_Done,
     /* 220397 */   // Label 4348: @220397
     /* 220397 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220439), // Rule ID 3072 //
     /* 220402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 220429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220437 */     GIR_RootConstrainSelectedInstOperands,
     /* 220438 */     // GIR_Coverage, 3072,
     /* 220438 */     GIR_EraseRootFromParent_Done,
     /* 220439 */   // Label 4349: @220439
     /* 220439 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220481), // Rule ID 3074 //
     /* 220444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 220471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220479 */     GIR_RootConstrainSelectedInstOperands,
     /* 220480 */     // GIR_Coverage, 3074,
     /* 220480 */     GIR_EraseRootFromParent_Done,
     /* 220481 */   // Label 4350: @220481
     /* 220481 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220523), // Rule ID 3076 //
     /* 220486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1667:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 220513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220521 */     GIR_RootConstrainSelectedInstOperands,
     /* 220522 */     // GIR_Coverage, 3076,
     /* 220522 */     GIR_EraseRootFromParent_Done,
     /* 220523 */   // Label 4351: @220523
     /* 220523 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220565), // Rule ID 3077 //
     /* 220528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1667:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 220555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220563 */     GIR_RootConstrainSelectedInstOperands,
     /* 220564 */     // GIR_Coverage, 3077,
     /* 220564 */     GIR_EraseRootFromParent_Done,
     /* 220565 */   // Label 4352: @220565
     /* 220565 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220607), // Rule ID 3078 //
     /* 220570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 220578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1667:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 220597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220605 */     GIR_RootConstrainSelectedInstOperands,
     /* 220606 */     // GIR_Coverage, 3078,
     /* 220606 */     GIR_EraseRootFromParent_Done,
     /* 220607 */   // Label 4353: @220607
     /* 220607 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(220649), // Rule ID 3079 //
     /* 220612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 220620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1230:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 220639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220647 */     GIR_RootConstrainSelectedInstOperands,
     /* 220648 */     // GIR_Coverage, 3079,
     /* 220648 */     GIR_EraseRootFromParent_Done,
     /* 220649 */   // Label 4354: @220649
     /* 220649 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(220691), // Rule ID 3080 //
     /* 220654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 220662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1230:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 220681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220689 */     GIR_RootConstrainSelectedInstOperands,
     /* 220690 */     // GIR_Coverage, 3080,
     /* 220690 */     GIR_EraseRootFromParent_Done,
     /* 220691 */   // Label 4355: @220691
     /* 220691 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(220733), // Rule ID 3090 //
     /* 220696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1237:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 220723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220731 */     GIR_RootConstrainSelectedInstOperands,
     /* 220732 */     // GIR_Coverage, 3090,
     /* 220732 */     GIR_EraseRootFromParent_Done,
     /* 220733 */   // Label 4356: @220733
     /* 220733 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(220775), // Rule ID 3091 //
     /* 220738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1237:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 220765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220773 */     GIR_RootConstrainSelectedInstOperands,
     /* 220774 */     // GIR_Coverage, 3091,
     /* 220774 */     GIR_EraseRootFromParent_Done,
     /* 220775 */   // Label 4357: @220775
     /* 220775 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(220817), // Rule ID 3092 //
     /* 220780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 220788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1237:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 220807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220815 */     GIR_RootConstrainSelectedInstOperands,
     /* 220816 */     // GIR_Coverage, 3092,
     /* 220816 */     GIR_EraseRootFromParent_Done,
     /* 220817 */   // Label 4358: @220817
     /* 220817 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(220859), // Rule ID 3109 //
     /* 220822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 220846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 220849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220857 */     GIR_RootConstrainSelectedInstOperands,
     /* 220858 */     // GIR_Coverage, 3109,
     /* 220858 */     GIR_EraseRootFromParent_Done,
     /* 220859 */   // Label 4359: @220859
     /* 220859 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(220901), // Rule ID 3110 //
     /* 220864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220888 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 220888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 220891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220899 */     GIR_RootConstrainSelectedInstOperands,
     /* 220900 */     // GIR_Coverage, 3110,
     /* 220900 */     GIR_EraseRootFromParent_Done,
     /* 220901 */   // Label 4360: @220901
     /* 220901 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(220943), // Rule ID 3111 //
     /* 220906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 220930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 220933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220941 */     GIR_RootConstrainSelectedInstOperands,
     /* 220942 */     // GIR_Coverage, 3111,
     /* 220942 */     GIR_EraseRootFromParent_Done,
     /* 220943 */   // Label 4361: @220943
     /* 220943 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(220985), // Rule ID 3112 //
     /* 220948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 220956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220972 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 220972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 220975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 220979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 220981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 220983 */     GIR_RootConstrainSelectedInstOperands,
     /* 220984 */     // GIR_Coverage, 3112,
     /* 220984 */     GIR_EraseRootFromParent_Done,
     /* 220985 */   // Label 4362: @220985
     /* 220985 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221027), // Rule ID 3147 //
     /* 220990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 220998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221025 */     GIR_RootConstrainSelectedInstOperands,
     /* 221026 */     // GIR_Coverage, 3147,
     /* 221026 */     GIR_EraseRootFromParent_Done,
     /* 221027 */   // Label 4363: @221027
     /* 221027 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221069), // Rule ID 3149 //
     /* 221032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221067 */     GIR_RootConstrainSelectedInstOperands,
     /* 221068 */     // GIR_Coverage, 3149,
     /* 221068 */     GIR_EraseRootFromParent_Done,
     /* 221069 */   // Label 4364: @221069
     /* 221069 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221111), // Rule ID 3151 //
     /* 221074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221109 */     GIR_RootConstrainSelectedInstOperands,
     /* 221110 */     // GIR_Coverage, 3151,
     /* 221110 */     GIR_EraseRootFromParent_Done,
     /* 221111 */   // Label 4365: @221111
     /* 221111 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221153), // Rule ID 3153 //
     /* 221116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221140 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221151 */     GIR_RootConstrainSelectedInstOperands,
     /* 221152 */     // GIR_Coverage, 3153,
     /* 221152 */     GIR_EraseRootFromParent_Done,
     /* 221153 */   // Label 4366: @221153
     /* 221153 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221198), // Rule ID 3192 //
     /* 221158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221182 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1301:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 221185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221196 */     GIR_RootConstrainSelectedInstOperands,
     /* 221197 */     // GIR_Coverage, 3192,
     /* 221197 */     GIR_EraseRootFromParent_Done,
     /* 221198 */   // Label 4367: @221198
     /* 221198 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221243), // Rule ID 3193 //
     /* 221203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221227 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1301:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 221230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221241 */     GIR_RootConstrainSelectedInstOperands,
     /* 221242 */     // GIR_Coverage, 3193,
     /* 221242 */     GIR_EraseRootFromParent_Done,
     /* 221243 */   // Label 4368: @221243
     /* 221243 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(221288), // Rule ID 3194 //
     /* 221248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1301:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 221275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221286 */     GIR_RootConstrainSelectedInstOperands,
     /* 221287 */     // GIR_Coverage, 3194,
     /* 221287 */     GIR_EraseRootFromParent_Done,
     /* 221288 */   // Label 4369: @221288
     /* 221288 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(221333), // Rule ID 3195 //
     /* 221293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221317 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 221320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221331 */     GIR_RootConstrainSelectedInstOperands,
     /* 221332 */     // GIR_Coverage, 3195,
     /* 221332 */     GIR_EraseRootFromParent_Done,
     /* 221333 */   // Label 4370: @221333
     /* 221333 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(221378), // Rule ID 3196 //
     /* 221338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1303:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 221365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221376 */     GIR_RootConstrainSelectedInstOperands,
     /* 221377 */     // GIR_Coverage, 3196,
     /* 221377 */     GIR_EraseRootFromParent_Done,
     /* 221378 */   // Label 4371: @221378
     /* 221378 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221423), // Rule ID 3197 //
     /* 221383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221407 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1303:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 221410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221421 */     GIR_RootConstrainSelectedInstOperands,
     /* 221422 */     // GIR_Coverage, 3197,
     /* 221422 */     GIR_EraseRootFromParent_Done,
     /* 221423 */   // Label 4372: @221423
     /* 221423 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221465), // Rule ID 3252 //
     /* 221428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1347:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 221455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221463 */     GIR_RootConstrainSelectedInstOperands,
     /* 221464 */     // GIR_Coverage, 3252,
     /* 221464 */     GIR_EraseRootFromParent_Done,
     /* 221465 */   // Label 4373: @221465
     /* 221465 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221507), // Rule ID 3253 //
     /* 221470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1347:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 221494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 221497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221505 */     GIR_RootConstrainSelectedInstOperands,
     /* 221506 */     // GIR_Coverage, 3253,
     /* 221506 */     GIR_EraseRootFromParent_Done,
     /* 221507 */   // Label 4374: @221507
     /* 221507 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221549), // Rule ID 3254 //
     /* 221512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 221523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1347:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 221536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 221539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221547 */     GIR_RootConstrainSelectedInstOperands,
     /* 221548 */     // GIR_Coverage, 3254,
     /* 221548 */     GIR_EraseRootFromParent_Done,
     /* 221549 */   // Label 4375: @221549
     /* 221549 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221591), // Rule ID 3306 //
     /* 221554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221578 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 221581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221589 */     GIR_RootConstrainSelectedInstOperands,
     /* 221590 */     // GIR_Coverage, 3306,
     /* 221590 */     GIR_EraseRootFromParent_Done,
     /* 221591 */   // Label 4376: @221591
     /* 221591 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221633), // Rule ID 3307 //
     /* 221596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 221623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221631 */     GIR_RootConstrainSelectedInstOperands,
     /* 221632 */     // GIR_Coverage, 3307,
     /* 221632 */     GIR_EraseRootFromParent_Done,
     /* 221633 */   // Label 4377: @221633
     /* 221633 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(221675), // Rule ID 3308 //
     /* 221638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 221665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221673 */     GIR_RootConstrainSelectedInstOperands,
     /* 221674 */     // GIR_Coverage, 3308,
     /* 221674 */     GIR_EraseRootFromParent_Done,
     /* 221675 */   // Label 4378: @221675
     /* 221675 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(221717), // Rule ID 3309 //
     /* 221680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 221688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 221707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221715 */     GIR_RootConstrainSelectedInstOperands,
     /* 221716 */     // GIR_Coverage, 3309,
     /* 221716 */     GIR_EraseRootFromParent_Done,
     /* 221717 */   // Label 4379: @221717
     /* 221717 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(221759), // Rule ID 3318 //
     /* 221722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1255:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 221749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221757 */     GIR_RootConstrainSelectedInstOperands,
     /* 221758 */     // GIR_Coverage, 3318,
     /* 221758 */     GIR_EraseRootFromParent_Done,
     /* 221759 */   // Label 4380: @221759
     /* 221759 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(221801), // Rule ID 3319 //
     /* 221764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221788 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1255:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 221791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221799 */     GIR_RootConstrainSelectedInstOperands,
     /* 221800 */     // GIR_Coverage, 3319,
     /* 221800 */     GIR_EraseRootFromParent_Done,
     /* 221801 */   // Label 4381: @221801
     /* 221801 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(221843), // Rule ID 3320 //
     /* 221806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 221814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 221833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221841 */     GIR_RootConstrainSelectedInstOperands,
     /* 221842 */     // GIR_Coverage, 3320,
     /* 221842 */     GIR_EraseRootFromParent_Done,
     /* 221843 */   // Label 4382: @221843
     /* 221843 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(221885), // Rule ID 3359 //
     /* 221848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 221875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221883 */     GIR_RootConstrainSelectedInstOperands,
     /* 221884 */     // GIR_Coverage, 3359,
     /* 221884 */     GIR_EraseRootFromParent_Done,
     /* 221885 */   // Label 4383: @221885
     /* 221885 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(221927), // Rule ID 3360 //
     /* 221890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221914 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 221917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221925 */     GIR_RootConstrainSelectedInstOperands,
     /* 221926 */     // GIR_Coverage, 3360,
     /* 221926 */     GIR_EraseRootFromParent_Done,
     /* 221927 */   // Label 4384: @221927
     /* 221927 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(221969), // Rule ID 3361 //
     /* 221932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 221959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221967 */     GIR_RootConstrainSelectedInstOperands,
     /* 221968 */     // GIR_Coverage, 3361,
     /* 221968 */     GIR_EraseRootFromParent_Done,
     /* 221969 */   // Label 4385: @221969
     /* 221969 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222011), // Rule ID 3362 //
     /* 221974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 221982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222009 */     GIR_RootConstrainSelectedInstOperands,
     /* 222010 */     // GIR_Coverage, 3362,
     /* 222010 */     GIR_EraseRootFromParent_Done,
     /* 222011 */   // Label 4386: @222011
     /* 222011 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222053), // Rule ID 3363 //
     /* 222016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 222043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222051 */     GIR_RootConstrainSelectedInstOperands,
     /* 222052 */     // GIR_Coverage, 3363,
     /* 222052 */     GIR_EraseRootFromParent_Done,
     /* 222053 */   // Label 4387: @222053
     /* 222053 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222095), // Rule ID 3364 //
     /* 222058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222093 */     GIR_RootConstrainSelectedInstOperands,
     /* 222094 */     // GIR_Coverage, 3364,
     /* 222094 */     GIR_EraseRootFromParent_Done,
     /* 222095 */   // Label 4388: @222095
     /* 222095 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222137), // Rule ID 3365 //
     /* 222100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222135 */     GIR_RootConstrainSelectedInstOperands,
     /* 222136 */     // GIR_Coverage, 3365,
     /* 222136 */     GIR_EraseRootFromParent_Done,
     /* 222137 */   // Label 4389: @222137
     /* 222137 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222179), // Rule ID 3448 //
     /* 222142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 222150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222166 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1284:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 222169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222177 */     GIR_RootConstrainSelectedInstOperands,
     /* 222178 */     // GIR_Coverage, 3448,
     /* 222178 */     GIR_EraseRootFromParent_Done,
     /* 222179 */   // Label 4390: @222179
     /* 222179 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222221), // Rule ID 3449 //
     /* 222184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 222192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1283:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 222211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 222213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222219 */     GIR_RootConstrainSelectedInstOperands,
     /* 222220 */     // GIR_Coverage, 3449,
     /* 222220 */     GIR_EraseRootFromParent_Done,
     /* 222221 */   // Label 4391: @222221
     /* 222221 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(222263), // Rule ID 3450 //
     /* 222226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 222234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1279:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 222253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222261 */     GIR_RootConstrainSelectedInstOperands,
     /* 222262 */     // GIR_Coverage, 3450,
     /* 222262 */     GIR_EraseRootFromParent_Done,
     /* 222263 */   // Label 4392: @222263
     /* 222263 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(222308), // Rule ID 3452 //
     /* 222268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1586:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 222295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222306 */     GIR_RootConstrainSelectedInstOperands,
     /* 222307 */     // GIR_Coverage, 3452,
     /* 222307 */     GIR_EraseRootFromParent_Done,
     /* 222308 */   // Label 4393: @222308
     /* 222308 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(222353), // Rule ID 3453 //
     /* 222313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222337 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1586:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 222340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222351 */     GIR_RootConstrainSelectedInstOperands,
     /* 222352 */     // GIR_Coverage, 3453,
     /* 222352 */     GIR_EraseRootFromParent_Done,
     /* 222353 */   // Label 4394: @222353
     /* 222353 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(222395), // Rule ID 3454 //
     /* 222358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1531:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 222385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222393 */     GIR_RootConstrainSelectedInstOperands,
     /* 222394 */     // GIR_Coverage, 3454,
     /* 222394 */     GIR_EraseRootFromParent_Done,
     /* 222395 */   // Label 4395: @222395
     /* 222395 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222437), // Rule ID 3455 //
     /* 222400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1531:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 222427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222435 */     GIR_RootConstrainSelectedInstOperands,
     /* 222436 */     // GIR_Coverage, 3455,
     /* 222436 */     GIR_EraseRootFromParent_Done,
     /* 222437 */   // Label 4396: @222437
     /* 222437 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222479), // Rule ID 3460 //
     /* 222442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 222445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 222450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1737:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 222469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222477 */     GIR_RootConstrainSelectedInstOperands,
     /* 222478 */     // GIR_Coverage, 3460,
     /* 222478 */     GIR_EraseRootFromParent_Done,
     /* 222479 */   // Label 4397: @222479
     /* 222479 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222521), // Rule ID 3499 //
     /* 222484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 222511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222519 */     GIR_RootConstrainSelectedInstOperands,
     /* 222520 */     // GIR_Coverage, 3499,
     /* 222520 */     GIR_EraseRootFromParent_Done,
     /* 222521 */   // Label 4398: @222521
     /* 222521 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222563), // Rule ID 3501 //
     /* 222526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222550 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 222553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222561 */     GIR_RootConstrainSelectedInstOperands,
     /* 222562 */     // GIR_Coverage, 3501,
     /* 222562 */     GIR_EraseRootFromParent_Done,
     /* 222563 */   // Label 4399: @222563
     /* 222563 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222605), // Rule ID 3503 //
     /* 222568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 222576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222592 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 222595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222603 */     GIR_RootConstrainSelectedInstOperands,
     /* 222604 */     // GIR_Coverage, 3503,
     /* 222604 */     GIR_EraseRootFromParent_Done,
     /* 222605 */   // Label 4400: @222605
     /* 222605 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222647), // Rule ID 3505 //
     /* 222610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 222613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 222618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 222637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 222639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222645 */     GIR_RootConstrainSelectedInstOperands,
     /* 222646 */     // GIR_Coverage, 3505,
     /* 222646 */     GIR_EraseRootFromParent_Done,
     /* 222647 */   // Label 4401: @222647
     /* 222647 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(222689), // Rule ID 3632 //
     /* 222652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 222666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1682:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 222679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222687 */     GIR_RootConstrainSelectedInstOperands,
     /* 222688 */     // GIR_Coverage, 3632,
     /* 222688 */     GIR_EraseRootFromParent_Done,
     /* 222689 */   // Label 4402: @222689
     /* 222689 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222731), // Rule ID 3634 //
     /* 222694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 222708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 222721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222729 */     GIR_RootConstrainSelectedInstOperands,
     /* 222730 */     // GIR_Coverage, 3634,
     /* 222730 */     GIR_EraseRootFromParent_Done,
     /* 222731 */   // Label 4403: @222731
     /* 222731 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(222773), // Rule ID 3636 //
     /* 222736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 222763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222771 */     GIR_RootConstrainSelectedInstOperands,
     /* 222772 */     // GIR_Coverage, 3636,
     /* 222772 */     GIR_EraseRootFromParent_Done,
     /* 222773 */   // Label 4404: @222773
     /* 222773 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(222815), // Rule ID 3638 //
     /* 222778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 222781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 222786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 222792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 222805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222813 */     GIR_RootConstrainSelectedInstOperands,
     /* 222814 */     // GIR_Coverage, 3638,
     /* 222814 */     GIR_EraseRootFromParent_Done,
     /* 222815 */   // Label 4405: @222815
     /* 222815 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(222857), // Rule ID 7435 //
     /* 222820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1891:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 222847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222855 */     GIR_RootConstrainSelectedInstOperands,
     /* 222856 */     // GIR_Coverage, 7435,
     /* 222856 */     GIR_EraseRootFromParent_Done,
     /* 222857 */   // Label 4406: @222857
     /* 222857 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(222899), // Rule ID 7437 //
     /* 222862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1891:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 222889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222897 */     GIR_RootConstrainSelectedInstOperands,
     /* 222898 */     // GIR_Coverage, 7437,
     /* 222898 */     GIR_EraseRootFromParent_Done,
     /* 222899 */   // Label 4407: @222899
     /* 222899 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(222941), // Rule ID 7439 //
     /* 222904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1891:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 222931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222939 */     GIR_RootConstrainSelectedInstOperands,
     /* 222940 */     // GIR_Coverage, 7439,
     /* 222940 */     GIR_EraseRootFromParent_Done,
     /* 222941 */   // Label 4408: @222941
     /* 222941 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(222983), // Rule ID 7441 //
     /* 222946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 222954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1891:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 222973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222981 */     GIR_RootConstrainSelectedInstOperands,
     /* 222982 */     // GIR_Coverage, 7441,
     /* 222982 */     GIR_EraseRootFromParent_Done,
     /* 222983 */   // Label 4409: @222983
     /* 222983 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223025), // Rule ID 7459 //
     /* 222988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 222996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1276:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 223015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223023 */     GIR_RootConstrainSelectedInstOperands,
     /* 223024 */     // GIR_Coverage, 7459,
     /* 223024 */     GIR_EraseRootFromParent_Done,
     /* 223025 */   // Label 4410: @223025
     /* 223025 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223067), // Rule ID 7460 //
     /* 223030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 223057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223065 */     GIR_RootConstrainSelectedInstOperands,
     /* 223066 */     // GIR_Coverage, 7460,
     /* 223066 */     GIR_EraseRootFromParent_Done,
     /* 223067 */   // Label 4411: @223067
     /* 223067 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223109), // Rule ID 7461 //
     /* 223072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 223099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223107 */     GIR_RootConstrainSelectedInstOperands,
     /* 223108 */     // GIR_Coverage, 7461,
     /* 223108 */     GIR_EraseRootFromParent_Done,
     /* 223109 */   // Label 4412: @223109
     /* 223109 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223151), // Rule ID 7462 //
     /* 223114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223138 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 223141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223149 */     GIR_RootConstrainSelectedInstOperands,
     /* 223150 */     // GIR_Coverage, 7462,
     /* 223150 */     GIR_EraseRootFromParent_Done,
     /* 223151 */   // Label 4413: @223151
     /* 223151 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223193), // Rule ID 7575 //
     /* 223156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1738:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 223183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223191 */     GIR_RootConstrainSelectedInstOperands,
     /* 223192 */     // GIR_Coverage, 7575,
     /* 223192 */     GIR_EraseRootFromParent_Done,
     /* 223193 */   // Label 4414: @223193
     /* 223193 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223235), // Rule ID 7576 //
     /* 223198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1738:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 223225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223233 */     GIR_RootConstrainSelectedInstOperands,
     /* 223234 */     // GIR_Coverage, 7576,
     /* 223234 */     GIR_EraseRootFromParent_Done,
     /* 223235 */   // Label 4415: @223235
     /* 223235 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223277), // Rule ID 7577 //
     /* 223240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 223267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223275 */     GIR_RootConstrainSelectedInstOperands,
     /* 223276 */     // GIR_Coverage, 7577,
     /* 223276 */     GIR_EraseRootFromParent_Done,
     /* 223277 */   // Label 4416: @223277
     /* 223277 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223319), // Rule ID 7578 //
     /* 223282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 223309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223317 */     GIR_RootConstrainSelectedInstOperands,
     /* 223318 */     // GIR_Coverage, 7578,
     /* 223318 */     GIR_EraseRootFromParent_Done,
     /* 223319 */   // Label 4417: @223319
     /* 223319 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223361), // Rule ID 7579 //
     /* 223324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223348 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1976:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 223351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223359 */     GIR_RootConstrainSelectedInstOperands,
     /* 223360 */     // GIR_Coverage, 7579,
     /* 223360 */     GIR_EraseRootFromParent_Done,
     /* 223361 */   // Label 4418: @223361
     /* 223361 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223403), // Rule ID 7580 //
     /* 223366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1976:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 223393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223401 */     GIR_RootConstrainSelectedInstOperands,
     /* 223402 */     // GIR_Coverage, 7580,
     /* 223402 */     GIR_EraseRootFromParent_Done,
     /* 223403 */   // Label 4419: @223403
     /* 223403 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223445), // Rule ID 7581 //
     /* 223408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1976:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 223435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223443 */     GIR_RootConstrainSelectedInstOperands,
     /* 223444 */     // GIR_Coverage, 7581,
     /* 223444 */     GIR_EraseRootFromParent_Done,
     /* 223445 */   // Label 4420: @223445
     /* 223445 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223487), // Rule ID 7582 //
     /* 223450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1976:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 223477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223485 */     GIR_RootConstrainSelectedInstOperands,
     /* 223486 */     // GIR_Coverage, 7582,
     /* 223486 */     GIR_EraseRootFromParent_Done,
     /* 223487 */   // Label 4421: @223487
     /* 223487 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223529), // Rule ID 7591 //
     /* 223492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 223500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 223519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223527 */     GIR_RootConstrainSelectedInstOperands,
     /* 223528 */     // GIR_Coverage, 7591,
     /* 223528 */     GIR_EraseRootFromParent_Done,
     /* 223529 */   // Label 4422: @223529
     /* 223529 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223571), // Rule ID 7592 //
     /* 223534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 223542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223558 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 223561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223569 */     GIR_RootConstrainSelectedInstOperands,
     /* 223570 */     // GIR_Coverage, 7592,
     /* 223570 */     GIR_EraseRootFromParent_Done,
     /* 223571 */   // Label 4423: @223571
     /* 223571 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223613), // Rule ID 7593 //
     /* 223576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 223584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 223603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223611 */     GIR_RootConstrainSelectedInstOperands,
     /* 223612 */     // GIR_Coverage, 7593,
     /* 223612 */     GIR_EraseRootFromParent_Done,
     /* 223613 */   // Label 4424: @223613
     /* 223613 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223655), // Rule ID 7594 //
     /* 223618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 223626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 223645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223653 */     GIR_RootConstrainSelectedInstOperands,
     /* 223654 */     // GIR_Coverage, 7594,
     /* 223654 */     GIR_EraseRootFromParent_Done,
     /* 223655 */   // Label 4425: @223655
     /* 223655 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223697), // Rule ID 7595 //
     /* 223660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 223668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 223687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223695 */     GIR_RootConstrainSelectedInstOperands,
     /* 223696 */     // GIR_Coverage, 7595,
     /* 223696 */     GIR_EraseRootFromParent_Done,
     /* 223697 */   // Label 4426: @223697
     /* 223697 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223739), // Rule ID 7596 //
     /* 223702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 223710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1941:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 223729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223737 */     GIR_RootConstrainSelectedInstOperands,
     /* 223738 */     // GIR_Coverage, 7596,
     /* 223738 */     GIR_EraseRootFromParent_Done,
     /* 223739 */   // Label 4427: @223739
     /* 223739 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(223781), // Rule ID 7681 //
     /* 223744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223768 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 223771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223779 */     GIR_RootConstrainSelectedInstOperands,
     /* 223780 */     // GIR_Coverage, 7681,
     /* 223780 */     GIR_EraseRootFromParent_Done,
     /* 223781 */   // Label 4428: @223781
     /* 223781 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(223823), // Rule ID 7682 //
     /* 223786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 223813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223821 */     GIR_RootConstrainSelectedInstOperands,
     /* 223822 */     // GIR_Coverage, 7682,
     /* 223822 */     GIR_EraseRootFromParent_Done,
     /* 223823 */   // Label 4429: @223823
     /* 223823 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(223865), // Rule ID 7683 //
     /* 223828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 223845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 223852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 223855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223863 */     GIR_RootConstrainSelectedInstOperands,
     /* 223864 */     // GIR_Coverage, 7683,
     /* 223864 */     GIR_EraseRootFromParent_Done,
     /* 223865 */   // Label 4430: @223865
     /* 223865 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(223907), // Rule ID 7684 //
     /* 223870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 223878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 223887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 223894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 223897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223905 */     GIR_RootConstrainSelectedInstOperands,
     /* 223906 */     // GIR_Coverage, 7684,
     /* 223906 */     GIR_EraseRootFromParent_Done,
     /* 223907 */   // Label 4431: @223907
     /* 223907 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(223949), // Rule ID 7693 //
     /* 223912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 223929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 223936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 223939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223947 */     GIR_RootConstrainSelectedInstOperands,
     /* 223948 */     // GIR_Coverage, 7693,
     /* 223948 */     GIR_EraseRootFromParent_Done,
     /* 223949 */   // Label 4432: @223949
     /* 223949 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(223991), // Rule ID 7694 //
     /* 223954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 223962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 223971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 223978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 223981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 223985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 223987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 223989 */     GIR_RootConstrainSelectedInstOperands,
     /* 223990 */     // GIR_Coverage, 7694,
     /* 223990 */     GIR_EraseRootFromParent_Done,
     /* 223991 */   // Label 4433: @223991
     /* 223991 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224033), // Rule ID 7695 //
     /* 223996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 224020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 224023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224031 */     GIR_RootConstrainSelectedInstOperands,
     /* 224032 */     // GIR_Coverage, 7695,
     /* 224032 */     GIR_EraseRootFromParent_Done,
     /* 224033 */   // Label 4434: @224033
     /* 224033 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224075), // Rule ID 7696 //
     /* 224038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 224062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 224065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224073 */     GIR_RootConstrainSelectedInstOperands,
     /* 224074 */     // GIR_Coverage, 7696,
     /* 224074 */     GIR_EraseRootFromParent_Done,
     /* 224075 */   // Label 4435: @224075
     /* 224075 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224117), // Rule ID 7775 //
     /* 224080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 224107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224115 */     GIR_RootConstrainSelectedInstOperands,
     /* 224116 */     // GIR_Coverage, 7775,
     /* 224116 */     GIR_EraseRootFromParent_Done,
     /* 224117 */   // Label 4436: @224117
     /* 224117 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224159), // Rule ID 7776 //
     /* 224122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1669:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 224149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224157 */     GIR_RootConstrainSelectedInstOperands,
     /* 224158 */     // GIR_Coverage, 7776,
     /* 224158 */     GIR_EraseRootFromParent_Done,
     /* 224159 */   // Label 4437: @224159
     /* 224159 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224201), // Rule ID 7777 //
     /* 224164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 224191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224199 */     GIR_RootConstrainSelectedInstOperands,
     /* 224200 */     // GIR_Coverage, 7777,
     /* 224200 */     GIR_EraseRootFromParent_Done,
     /* 224201 */   // Label 4438: @224201
     /* 224201 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224243), // Rule ID 7778 //
     /* 224206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1669:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 224233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224241 */     GIR_RootConstrainSelectedInstOperands,
     /* 224242 */     // GIR_Coverage, 7778,
     /* 224242 */     GIR_EraseRootFromParent_Done,
     /* 224243 */   // Label 4439: @224243
     /* 224243 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224285), // Rule ID 7779 //
     /* 224248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224272 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 224275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224283 */     GIR_RootConstrainSelectedInstOperands,
     /* 224284 */     // GIR_Coverage, 7779,
     /* 224284 */     GIR_EraseRootFromParent_Done,
     /* 224285 */   // Label 4440: @224285
     /* 224285 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224327), // Rule ID 7780 //
     /* 224290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 224317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224325 */     GIR_RootConstrainSelectedInstOperands,
     /* 224326 */     // GIR_Coverage, 7780,
     /* 224326 */     GIR_EraseRootFromParent_Done,
     /* 224327 */   // Label 4441: @224327
     /* 224327 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224369), // Rule ID 7781 //
     /* 224332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 224359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224367 */     GIR_RootConstrainSelectedInstOperands,
     /* 224368 */     // GIR_Coverage, 7781,
     /* 224368 */     GIR_EraseRootFromParent_Done,
     /* 224369 */   // Label 4442: @224369
     /* 224369 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224411), // Rule ID 7782 //
     /* 224374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 224401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224409 */     GIR_RootConstrainSelectedInstOperands,
     /* 224410 */     // GIR_Coverage, 7782,
     /* 224410 */     GIR_EraseRootFromParent_Done,
     /* 224411 */   // Label 4443: @224411
     /* 224411 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224453), // Rule ID 7978 //
     /* 224416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224440 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 224443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224451 */     GIR_RootConstrainSelectedInstOperands,
     /* 224452 */     // GIR_Coverage, 7978,
     /* 224452 */     GIR_EraseRootFromParent_Done,
     /* 224453 */   // Label 4444: @224453
     /* 224453 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224495), // Rule ID 7980 //
     /* 224458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224482 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 224485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224493 */     GIR_RootConstrainSelectedInstOperands,
     /* 224494 */     // GIR_Coverage, 7980,
     /* 224494 */     GIR_EraseRootFromParent_Done,
     /* 224495 */   // Label 4445: @224495
     /* 224495 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224537), // Rule ID 7982 //
     /* 224500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224524 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 224527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224535 */     GIR_RootConstrainSelectedInstOperands,
     /* 224536 */     // GIR_Coverage, 7982,
     /* 224536 */     GIR_EraseRootFromParent_Done,
     /* 224537 */   // Label 4446: @224537
     /* 224537 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224579), // Rule ID 7990 //
     /* 224542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 224569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224577 */     GIR_RootConstrainSelectedInstOperands,
     /* 224578 */     // GIR_Coverage, 7990,
     /* 224578 */     GIR_EraseRootFromParent_Done,
     /* 224579 */   // Label 4447: @224579
     /* 224579 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224621), // Rule ID 7992 //
     /* 224584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 224611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224619 */     GIR_RootConstrainSelectedInstOperands,
     /* 224620 */     // GIR_Coverage, 7992,
     /* 224620 */     GIR_EraseRootFromParent_Done,
     /* 224621 */   // Label 4448: @224621
     /* 224621 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(224663), // Rule ID 7994 //
     /* 224626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 224653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224661 */     GIR_RootConstrainSelectedInstOperands,
     /* 224662 */     // GIR_Coverage, 7994,
     /* 224662 */     GIR_EraseRootFromParent_Done,
     /* 224663 */   // Label 4449: @224663
     /* 224663 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(224705), // Rule ID 8032 //
     /* 224668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224692 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1344:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 224695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224703 */     GIR_RootConstrainSelectedInstOperands,
     /* 224704 */     // GIR_Coverage, 8032,
     /* 224704 */     GIR_EraseRootFromParent_Done,
     /* 224705 */   // Label 4450: @224705
     /* 224705 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(224747), // Rule ID 8033 //
     /* 224710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1344:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 224737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224745 */     GIR_RootConstrainSelectedInstOperands,
     /* 224746 */     // GIR_Coverage, 8033,
     /* 224746 */     GIR_EraseRootFromParent_Done,
     /* 224747 */   // Label 4451: @224747
     /* 224747 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(224789), // Rule ID 8034 //
     /* 224752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 224760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224776 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1344:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 224779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224787 */     GIR_RootConstrainSelectedInstOperands,
     /* 224788 */     // GIR_Coverage, 8034,
     /* 224788 */     GIR_EraseRootFromParent_Done,
     /* 224789 */   // Label 4452: @224789
     /* 224789 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(224831), // Rule ID 8035 //
     /* 224794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224818 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 224821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224829 */     GIR_RootConstrainSelectedInstOperands,
     /* 224830 */     // GIR_Coverage, 8035,
     /* 224830 */     GIR_EraseRootFromParent_Done,
     /* 224831 */   // Label 4453: @224831
     /* 224831 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(224873), // Rule ID 8036 //
     /* 224836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224860 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 224863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224871 */     GIR_RootConstrainSelectedInstOperands,
     /* 224872 */     // GIR_Coverage, 8036,
     /* 224872 */     GIR_EraseRootFromParent_Done,
     /* 224873 */   // Label 4454: @224873
     /* 224873 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(224915), // Rule ID 8037 //
     /* 224878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 224886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 224902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 224905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224913 */     GIR_RootConstrainSelectedInstOperands,
     /* 224914 */     // GIR_Coverage, 8037,
     /* 224914 */     GIR_EraseRootFromParent_Done,
     /* 224915 */   // Label 4455: @224915
     /* 224915 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(224957), // Rule ID 8038 //
     /* 224920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 224928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224944 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1405:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 224947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224955 */     GIR_RootConstrainSelectedInstOperands,
     /* 224956 */     // GIR_Coverage, 8038,
     /* 224956 */     GIR_EraseRootFromParent_Done,
     /* 224957 */   // Label 4456: @224957
     /* 224957 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(224999), // Rule ID 8039 //
     /* 224962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 224970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224986 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1405:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 224986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 224989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224997 */     GIR_RootConstrainSelectedInstOperands,
     /* 224998 */     // GIR_Coverage, 8039,
     /* 224998 */     GIR_EraseRootFromParent_Done,
     /* 224999 */   // Label 4457: @224999
     /* 224999 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225041), // Rule ID 8040 //
     /* 225004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225028 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1405:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 225031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225039 */     GIR_RootConstrainSelectedInstOperands,
     /* 225040 */     // GIR_Coverage, 8040,
     /* 225040 */     GIR_EraseRootFromParent_Done,
     /* 225041 */   // Label 4458: @225041
     /* 225041 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225083), // Rule ID 8041 //
     /* 225046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225070 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1403:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 225073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225081 */     GIR_RootConstrainSelectedInstOperands,
     /* 225082 */     // GIR_Coverage, 8041,
     /* 225082 */     GIR_EraseRootFromParent_Done,
     /* 225083 */   // Label 4459: @225083
     /* 225083 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225125), // Rule ID 8042 //
     /* 225088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225112 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1403:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 225115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225123 */     GIR_RootConstrainSelectedInstOperands,
     /* 225124 */     // GIR_Coverage, 8042,
     /* 225124 */     GIR_EraseRootFromParent_Done,
     /* 225125 */   // Label 4460: @225125
     /* 225125 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225167), // Rule ID 8043 //
     /* 225130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225154 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1403:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 225157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225165 */     GIR_RootConstrainSelectedInstOperands,
     /* 225166 */     // GIR_Coverage, 8043,
     /* 225166 */     GIR_EraseRootFromParent_Done,
     /* 225167 */   // Label 4461: @225167
     /* 225167 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225209), // Rule ID 8080 //
     /* 225172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225196 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225207 */     GIR_RootConstrainSelectedInstOperands,
     /* 225208 */     // GIR_Coverage, 8080,
     /* 225208 */     GIR_EraseRootFromParent_Done,
     /* 225209 */   // Label 4462: @225209
     /* 225209 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(225251), // Rule ID 8082 //
     /* 225214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 225225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 225231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 225234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225238 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 225238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225249 */     GIR_RootConstrainSelectedInstOperands,
     /* 225250 */     // GIR_Coverage, 8082,
     /* 225250 */     GIR_EraseRootFromParent_Done,
     /* 225251 */   // Label 4463: @225251
     /* 225251 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(225293), // Rule ID 8084 //
     /* 225256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 225267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 225273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 225276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225280 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 225280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225291 */     GIR_RootConstrainSelectedInstOperands,
     /* 225292 */     // GIR_Coverage, 8084,
     /* 225292 */     GIR_EraseRootFromParent_Done,
     /* 225293 */   // Label 4464: @225293
     /* 225293 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(225335), // Rule ID 8086 //
     /* 225298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225322 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225333 */     GIR_RootConstrainSelectedInstOperands,
     /* 225334 */     // GIR_Coverage, 8086,
     /* 225334 */     GIR_EraseRootFromParent_Done,
     /* 225335 */   // Label 4465: @225335
     /* 225335 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(225377), // Rule ID 8088 //
     /* 225340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 225351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 225357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 225360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 225364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225375 */     GIR_RootConstrainSelectedInstOperands,
     /* 225376 */     // GIR_Coverage, 8088,
     /* 225376 */     GIR_EraseRootFromParent_Done,
     /* 225377 */   // Label 4466: @225377
     /* 225377 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225419), // Rule ID 8090 //
     /* 225382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225406 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 225409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225417 */     GIR_RootConstrainSelectedInstOperands,
     /* 225418 */     // GIR_Coverage, 8090,
     /* 225418 */     GIR_EraseRootFromParent_Done,
     /* 225419 */   // Label 4467: @225419
     /* 225419 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225461), // Rule ID 8092 //
     /* 225424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225448 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1467:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225459 */     GIR_RootConstrainSelectedInstOperands,
     /* 225460 */     // GIR_Coverage, 8092,
     /* 225460 */     GIR_EraseRootFromParent_Done,
     /* 225461 */   // Label 4468: @225461
     /* 225461 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225503), // Rule ID 8093 //
     /* 225466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 225477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 225483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 225486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225490 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1467:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 225490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225501 */     GIR_RootConstrainSelectedInstOperands,
     /* 225502 */     // GIR_Coverage, 8093,
     /* 225502 */     GIR_EraseRootFromParent_Done,
     /* 225503 */   // Label 4469: @225503
     /* 225503 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225545), // Rule ID 8094 //
     /* 225508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 225519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 225525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 225528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225532 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 225532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225543 */     GIR_RootConstrainSelectedInstOperands,
     /* 225544 */     // GIR_Coverage, 8094,
     /* 225544 */     GIR_EraseRootFromParent_Done,
     /* 225545 */   // Label 4470: @225545
     /* 225545 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225587), // Rule ID 8095 //
     /* 225550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225574 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 225577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225585 */     GIR_RootConstrainSelectedInstOperands,
     /* 225586 */     // GIR_Coverage, 8095,
     /* 225586 */     GIR_EraseRootFromParent_Done,
     /* 225587 */   // Label 4471: @225587
     /* 225587 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225629), // Rule ID 8096 //
     /* 225592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 225603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 225609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 225612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225616 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 225616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 225619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225627 */     GIR_RootConstrainSelectedInstOperands,
     /* 225628 */     // GIR_Coverage, 8096,
     /* 225628 */     GIR_EraseRootFromParent_Done,
     /* 225629 */   // Label 4472: @225629
     /* 225629 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225671), // Rule ID 8097 //
     /* 225634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225658 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 225661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225669 */     GIR_RootConstrainSelectedInstOperands,
     /* 225670 */     // GIR_Coverage, 8097,
     /* 225670 */     GIR_EraseRootFromParent_Done,
     /* 225671 */   // Label 4473: @225671
     /* 225671 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225713), // Rule ID 8350 //
     /* 225676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 225684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1285:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 225703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225711 */     GIR_RootConstrainSelectedInstOperands,
     /* 225712 */     // GIR_Coverage, 8350,
     /* 225712 */     GIR_EraseRootFromParent_Done,
     /* 225713 */   // Label 4474: @225713
     /* 225713 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225755), // Rule ID 8352 //
     /* 225718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 225726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1281:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 225745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225753 */     GIR_RootConstrainSelectedInstOperands,
     /* 225754 */     // GIR_Coverage, 8352,
     /* 225754 */     GIR_EraseRootFromParent_Done,
     /* 225755 */   // Label 4475: @225755
     /* 225755 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225797), // Rule ID 8353 //
     /* 225760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225784 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1278:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225795 */     GIR_RootConstrainSelectedInstOperands,
     /* 225796 */     // GIR_Coverage, 8353,
     /* 225796 */     GIR_EraseRootFromParent_Done,
     /* 225797 */   // Label 4476: @225797
     /* 225797 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(225839), // Rule ID 8354 //
     /* 225802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 225813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 225822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 225826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225837 */     GIR_RootConstrainSelectedInstOperands,
     /* 225838 */     // GIR_Coverage, 8354,
     /* 225838 */     GIR_EraseRootFromParent_Done,
     /* 225839 */   // Label 4477: @225839
     /* 225839 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(225881), // Rule ID 8355 //
     /* 225844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 225855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 225864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225868 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 225868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225879 */     GIR_RootConstrainSelectedInstOperands,
     /* 225880 */     // GIR_Coverage, 8355,
     /* 225880 */     GIR_EraseRootFromParent_Done,
     /* 225881 */   // Label 4478: @225881
     /* 225881 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(225923), // Rule ID 8356 //
     /* 225886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 225897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 225906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 225910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225921 */     GIR_RootConstrainSelectedInstOperands,
     /* 225922 */     // GIR_Coverage, 8356,
     /* 225922 */     GIR_EraseRootFromParent_Done,
     /* 225923 */   // Label 4479: @225923
     /* 225923 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(225965), // Rule ID 8357 //
     /* 225928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 225936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 225939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 225942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 225945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 225948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1278:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 225952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 225955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225963 */     GIR_RootConstrainSelectedInstOperands,
     /* 225964 */     // GIR_Coverage, 8357,
     /* 225964 */     GIR_EraseRootFromParent_Done,
     /* 225965 */   // Label 4480: @225965
     /* 225965 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226007), // Rule ID 8378 //
     /* 225970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 225978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 225981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 225984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 225987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 225990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 225994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 225994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 225997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 225999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226005 */     GIR_RootConstrainSelectedInstOperands,
     /* 226006 */     // GIR_Coverage, 8378,
     /* 226006 */     GIR_EraseRootFromParent_Done,
     /* 226007 */   // Label 4481: @226007
     /* 226007 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226049), // Rule ID 8379 //
     /* 226012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226047 */     GIR_RootConstrainSelectedInstOperands,
     /* 226048 */     // GIR_Coverage, 8379,
     /* 226048 */     GIR_EraseRootFromParent_Done,
     /* 226049 */   // Label 4482: @226049
     /* 226049 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226091), // Rule ID 8380 //
     /* 226054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226078 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226087 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226089 */     GIR_RootConstrainSelectedInstOperands,
     /* 226090 */     // GIR_Coverage, 8380,
     /* 226090 */     GIR_EraseRootFromParent_Done,
     /* 226091 */   // Label 4483: @226091
     /* 226091 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226133), // Rule ID 8381 //
     /* 226096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226120 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1336:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226131 */     GIR_RootConstrainSelectedInstOperands,
     /* 226132 */     // GIR_Coverage, 8381,
     /* 226132 */     GIR_EraseRootFromParent_Done,
     /* 226133 */   // Label 4484: @226133
     /* 226133 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226175), // Rule ID 8382 //
     /* 226138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1336:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226173 */     GIR_RootConstrainSelectedInstOperands,
     /* 226174 */     // GIR_Coverage, 8382,
     /* 226174 */     GIR_EraseRootFromParent_Done,
     /* 226175 */   // Label 4485: @226175
     /* 226175 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226217), // Rule ID 8398 //
     /* 226180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226204 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226215 */     GIR_RootConstrainSelectedInstOperands,
     /* 226216 */     // GIR_Coverage, 8398,
     /* 226216 */     GIR_EraseRootFromParent_Done,
     /* 226217 */   // Label 4486: @226217
     /* 226217 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226259), // Rule ID 8399 //
     /* 226222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226246 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226257 */     GIR_RootConstrainSelectedInstOperands,
     /* 226258 */     // GIR_Coverage, 8399,
     /* 226258 */     GIR_EraseRootFromParent_Done,
     /* 226259 */   // Label 4487: @226259
     /* 226259 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226301), // Rule ID 8400 //
     /* 226264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226299 */     GIR_RootConstrainSelectedInstOperands,
     /* 226300 */     // GIR_Coverage, 8400,
     /* 226300 */     GIR_EraseRootFromParent_Done,
     /* 226301 */   // Label 4488: @226301
     /* 226301 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226343), // Rule ID 8401 //
     /* 226306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226341 */     GIR_RootConstrainSelectedInstOperands,
     /* 226342 */     // GIR_Coverage, 8401,
     /* 226342 */     GIR_EraseRootFromParent_Done,
     /* 226343 */   // Label 4489: @226343
     /* 226343 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226385), // Rule ID 8402 //
     /* 226348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226372 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1607:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226383 */     GIR_RootConstrainSelectedInstOperands,
     /* 226384 */     // GIR_Coverage, 8402,
     /* 226384 */     GIR_EraseRootFromParent_Done,
     /* 226385 */   // Label 4490: @226385
     /* 226385 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226427), // Rule ID 8403 //
     /* 226390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226425 */     GIR_RootConstrainSelectedInstOperands,
     /* 226426 */     // GIR_Coverage, 8403,
     /* 226426 */     GIR_EraseRootFromParent_Done,
     /* 226427 */   // Label 4491: @226427
     /* 226427 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226469), // Rule ID 8404 //
     /* 226432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226465 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226467 */     GIR_RootConstrainSelectedInstOperands,
     /* 226468 */     // GIR_Coverage, 8404,
     /* 226468 */     GIR_EraseRootFromParent_Done,
     /* 226469 */   // Label 4492: @226469
     /* 226469 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226511), // Rule ID 8405 //
     /* 226474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226498 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226509 */     GIR_RootConstrainSelectedInstOperands,
     /* 226510 */     // GIR_Coverage, 8405,
     /* 226510 */     GIR_EraseRootFromParent_Done,
     /* 226511 */   // Label 4493: @226511
     /* 226511 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226553), // Rule ID 8406 //
     /* 226516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226551 */     GIR_RootConstrainSelectedInstOperands,
     /* 226552 */     // GIR_Coverage, 8406,
     /* 226552 */     GIR_EraseRootFromParent_Done,
     /* 226553 */   // Label 4494: @226553
     /* 226553 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226595), // Rule ID 8407 //
     /* 226558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1603:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226593 */     GIR_RootConstrainSelectedInstOperands,
     /* 226594 */     // GIR_Coverage, 8407,
     /* 226594 */     GIR_EraseRootFromParent_Done,
     /* 226595 */   // Label 4495: @226595
     /* 226595 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(226637), // Rule ID 8408 //
     /* 226600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226624 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226635 */     GIR_RootConstrainSelectedInstOperands,
     /* 226636 */     // GIR_Coverage, 8408,
     /* 226636 */     GIR_EraseRootFromParent_Done,
     /* 226637 */   // Label 4496: @226637
     /* 226637 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(226679), // Rule ID 8409 //
     /* 226642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226666 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226677 */     GIR_RootConstrainSelectedInstOperands,
     /* 226678 */     // GIR_Coverage, 8409,
     /* 226678 */     GIR_EraseRootFromParent_Done,
     /* 226679 */   // Label 4497: @226679
     /* 226679 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(226721), // Rule ID 8410 //
     /* 226684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226719 */     GIR_RootConstrainSelectedInstOperands,
     /* 226720 */     // GIR_Coverage, 8410,
     /* 226720 */     GIR_EraseRootFromParent_Done,
     /* 226721 */   // Label 4498: @226721
     /* 226721 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(226763), // Rule ID 8411 //
     /* 226726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226761 */     GIR_RootConstrainSelectedInstOperands,
     /* 226762 */     // GIR_Coverage, 8411,
     /* 226762 */     GIR_EraseRootFromParent_Done,
     /* 226763 */   // Label 4499: @226763
     /* 226763 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(226805), // Rule ID 8412 //
     /* 226768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 226776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226792 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1601:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 226795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226803 */     GIR_RootConstrainSelectedInstOperands,
     /* 226804 */     // GIR_Coverage, 8412,
     /* 226804 */     GIR_EraseRootFromParent_Done,
     /* 226805 */   // Label 4500: @226805
     /* 226805 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(226847), // Rule ID 8413 //
     /* 226810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226834 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1597:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226845 */     GIR_RootConstrainSelectedInstOperands,
     /* 226846 */     // GIR_Coverage, 8413,
     /* 226846 */     GIR_EraseRootFromParent_Done,
     /* 226847 */   // Label 4501: @226847
     /* 226847 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(226889), // Rule ID 8414 //
     /* 226852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226876 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1597:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226887 */     GIR_RootConstrainSelectedInstOperands,
     /* 226888 */     // GIR_Coverage, 8414,
     /* 226888 */     GIR_EraseRootFromParent_Done,
     /* 226889 */   // Label 4502: @226889
     /* 226889 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(226931), // Rule ID 8415 //
     /* 226894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1597:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226929 */     GIR_RootConstrainSelectedInstOperands,
     /* 226930 */     // GIR_Coverage, 8415,
     /* 226930 */     GIR_EraseRootFromParent_Done,
     /* 226931 */   // Label 4503: @226931
     /* 226931 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(226973), // Rule ID 8416 //
     /* 226936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1597:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 226963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226971 */     GIR_RootConstrainSelectedInstOperands,
     /* 226972 */     // GIR_Coverage, 8416,
     /* 226972 */     GIR_EraseRootFromParent_Done,
     /* 226973 */   // Label 4504: @226973
     /* 226973 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227015), // Rule ID 8417 //
     /* 226978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 226986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227002 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1597:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227013 */     GIR_RootConstrainSelectedInstOperands,
     /* 227014 */     // GIR_Coverage, 8417,
     /* 227014 */     GIR_EraseRootFromParent_Done,
     /* 227015 */   // Label 4505: @227015
     /* 227015 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227057), // Rule ID 8425 //
     /* 227020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 227047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227055 */     GIR_RootConstrainSelectedInstOperands,
     /* 227056 */     // GIR_Coverage, 8425,
     /* 227056 */     GIR_EraseRootFromParent_Done,
     /* 227057 */   // Label 4506: @227057
     /* 227057 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227099), // Rule ID 8426 //
     /* 227062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1294:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227097 */     GIR_RootConstrainSelectedInstOperands,
     /* 227098 */     // GIR_Coverage, 8426,
     /* 227098 */     GIR_EraseRootFromParent_Done,
     /* 227099 */   // Label 4507: @227099
     /* 227099 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227141), // Rule ID 8427 //
     /* 227104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1294:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227139 */     GIR_RootConstrainSelectedInstOperands,
     /* 227140 */     // GIR_Coverage, 8427,
     /* 227140 */     GIR_EraseRootFromParent_Done,
     /* 227141 */   // Label 4508: @227141
     /* 227141 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227183), // Rule ID 8428 //
     /* 227146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1294:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227181 */     GIR_RootConstrainSelectedInstOperands,
     /* 227182 */     // GIR_Coverage, 8428,
     /* 227182 */     GIR_EraseRootFromParent_Done,
     /* 227183 */   // Label 4509: @227183
     /* 227183 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227225), // Rule ID 8429 //
     /* 227188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227212 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1294:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227223 */     GIR_RootConstrainSelectedInstOperands,
     /* 227224 */     // GIR_Coverage, 8429,
     /* 227224 */     GIR_EraseRootFromParent_Done,
     /* 227225 */   // Label 4510: @227225
     /* 227225 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(227267), // Rule ID 8430 //
     /* 227230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227254 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1294:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227265 */     GIR_RootConstrainSelectedInstOperands,
     /* 227266 */     // GIR_Coverage, 8430,
     /* 227266 */     GIR_EraseRootFromParent_Done,
     /* 227267 */   // Label 4511: @227267
     /* 227267 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(227309), // Rule ID 8431 //
     /* 227272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227296 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1294:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227307 */     GIR_RootConstrainSelectedInstOperands,
     /* 227308 */     // GIR_Coverage, 8431,
     /* 227308 */     GIR_EraseRootFromParent_Done,
     /* 227309 */   // Label 4512: @227309
     /* 227309 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(227354), // Rule ID 9127 //
     /* 227314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227338 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 227341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227352 */     GIR_RootConstrainSelectedInstOperands,
     /* 227353 */     // GIR_Coverage, 9127,
     /* 227353 */     GIR_EraseRootFromParent_Done,
     /* 227354 */   // Label 4513: @227354
     /* 227354 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(227399), // Rule ID 9128 //
     /* 227359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227383 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 227386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227397 */     GIR_RootConstrainSelectedInstOperands,
     /* 227398 */     // GIR_Coverage, 9128,
     /* 227398 */     GIR_EraseRootFromParent_Done,
     /* 227399 */   // Label 4514: @227399
     /* 227399 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227444), // Rule ID 9129 //
     /* 227404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 227431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227442 */     GIR_RootConstrainSelectedInstOperands,
     /* 227443 */     // GIR_Coverage, 9129,
     /* 227443 */     GIR_EraseRootFromParent_Done,
     /* 227444 */   // Label 4515: @227444
     /* 227444 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227489), // Rule ID 9130 //
     /* 227449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227473 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 227476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227487 */     GIR_RootConstrainSelectedInstOperands,
     /* 227488 */     // GIR_Coverage, 9130,
     /* 227488 */     GIR_EraseRootFromParent_Done,
     /* 227489 */   // Label 4516: @227489
     /* 227489 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227534), // Rule ID 9131 //
     /* 227494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1305:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 227521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227532 */     GIR_RootConstrainSelectedInstOperands,
     /* 227533 */     // GIR_Coverage, 9131,
     /* 227533 */     GIR_EraseRootFromParent_Done,
     /* 227534 */   // Label 4517: @227534
     /* 227534 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227579), // Rule ID 9132 //
     /* 227539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1305:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 227566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227577 */     GIR_RootConstrainSelectedInstOperands,
     /* 227578 */     // GIR_Coverage, 9132,
     /* 227578 */     GIR_EraseRootFromParent_Done,
     /* 227579 */   // Label 4518: @227579
     /* 227579 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227624), // Rule ID 9133 //
     /* 227584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227608 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1313:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 227611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227622 */     GIR_RootConstrainSelectedInstOperands,
     /* 227623 */     // GIR_Coverage, 9133,
     /* 227623 */     GIR_EraseRootFromParent_Done,
     /* 227624 */   // Label 4519: @227624
     /* 227624 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(227669), // Rule ID 9134 //
     /* 227629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227653 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 227656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227667 */     GIR_RootConstrainSelectedInstOperands,
     /* 227668 */     // GIR_Coverage, 9134,
     /* 227668 */     GIR_EraseRootFromParent_Done,
     /* 227669 */   // Label 4520: @227669
     /* 227669 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(227714), // Rule ID 9135 //
     /* 227674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 227682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 227701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227712 */     GIR_RootConstrainSelectedInstOperands,
     /* 227713 */     // GIR_Coverage, 9135,
     /* 227713 */     GIR_EraseRootFromParent_Done,
     /* 227714 */   // Label 4521: @227714
     /* 227714 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(227759), // Rule ID 9136 //
     /* 227719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227743 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1310:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 227746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227757 */     GIR_RootConstrainSelectedInstOperands,
     /* 227758 */     // GIR_Coverage, 9136,
     /* 227758 */     GIR_EraseRootFromParent_Done,
     /* 227759 */   // Label 4522: @227759
     /* 227759 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(227804), // Rule ID 9137 //
     /* 227764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1310:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 227791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227802 */     GIR_RootConstrainSelectedInstOperands,
     /* 227803 */     // GIR_Coverage, 9137,
     /* 227803 */     GIR_EraseRootFromParent_Done,
     /* 227804 */   // Label 4523: @227804
     /* 227804 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(227849), // Rule ID 9138 //
     /* 227809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 227817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227833 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1310:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 227836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227847 */     GIR_RootConstrainSelectedInstOperands,
     /* 227848 */     // GIR_Coverage, 9138,
     /* 227848 */     GIR_EraseRootFromParent_Done,
     /* 227849 */   // Label 4524: @227849
     /* 227849 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(227894), // Rule ID 9139 //
     /* 227854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227878 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 227881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227892 */     GIR_RootConstrainSelectedInstOperands,
     /* 227893 */     // GIR_Coverage, 9139,
     /* 227893 */     GIR_EraseRootFromParent_Done,
     /* 227894 */   // Label 4525: @227894
     /* 227894 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(227939), // Rule ID 9140 //
     /* 227899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227923 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1309:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 227926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227937 */     GIR_RootConstrainSelectedInstOperands,
     /* 227938 */     // GIR_Coverage, 9140,
     /* 227938 */     GIR_EraseRootFromParent_Done,
     /* 227939 */   // Label 4526: @227939
     /* 227939 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(227984), // Rule ID 9141 //
     /* 227944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 227952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227968 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1309:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 227971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227982 */     GIR_RootConstrainSelectedInstOperands,
     /* 227983 */     // GIR_Coverage, 9141,
     /* 227983 */     GIR_EraseRootFromParent_Done,
     /* 227984 */   // Label 4527: @227984
     /* 227984 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228029), // Rule ID 9142 //
     /* 227989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 227997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228013 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 228016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228027 */     GIR_RootConstrainSelectedInstOperands,
     /* 228028 */     // GIR_Coverage, 9142,
     /* 228028 */     GIR_EraseRootFromParent_Done,
     /* 228029 */   // Label 4528: @228029
     /* 228029 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228074), // Rule ID 9143 //
     /* 228034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1307:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 228061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228072 */     GIR_RootConstrainSelectedInstOperands,
     /* 228073 */     // GIR_Coverage, 9143,
     /* 228073 */     GIR_EraseRootFromParent_Done,
     /* 228074 */   // Label 4529: @228074
     /* 228074 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228119), // Rule ID 9144 //
     /* 228079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228103 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1307:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 228106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228117 */     GIR_RootConstrainSelectedInstOperands,
     /* 228118 */     // GIR_Coverage, 9144,
     /* 228118 */     GIR_EraseRootFromParent_Done,
     /* 228119 */   // Label 4530: @228119
     /* 228119 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228164), // Rule ID 9145 //
     /* 228124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228148 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1311:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 228151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228162 */     GIR_RootConstrainSelectedInstOperands,
     /* 228163 */     // GIR_Coverage, 9145,
     /* 228163 */     GIR_EraseRootFromParent_Done,
     /* 228164 */   // Label 4531: @228164
     /* 228164 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228209), // Rule ID 9146 //
     /* 228169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228193 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1311:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 228196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228207 */     GIR_RootConstrainSelectedInstOperands,
     /* 228208 */     // GIR_Coverage, 9146,
     /* 228208 */     GIR_EraseRootFromParent_Done,
     /* 228209 */   // Label 4532: @228209
     /* 228209 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228254), // Rule ID 9147 //
     /* 228214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228238 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1311:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 228241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228252 */     GIR_RootConstrainSelectedInstOperands,
     /* 228253 */     // GIR_Coverage, 9147,
     /* 228253 */     GIR_EraseRootFromParent_Done,
     /* 228254 */   // Label 4533: @228254
     /* 228254 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(228299), // Rule ID 9148 //
     /* 228259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228283 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1312:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 228286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228297 */     GIR_RootConstrainSelectedInstOperands,
     /* 228298 */     // GIR_Coverage, 9148,
     /* 228298 */     GIR_EraseRootFromParent_Done,
     /* 228299 */   // Label 4534: @228299
     /* 228299 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(228344), // Rule ID 9149 //
     /* 228304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1312:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 228331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228342 */     GIR_RootConstrainSelectedInstOperands,
     /* 228343 */     // GIR_Coverage, 9149,
     /* 228343 */     GIR_EraseRootFromParent_Done,
     /* 228344 */   // Label 4535: @228344
     /* 228344 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(228389), // Rule ID 9150 //
     /* 228349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228373 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1312:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 228376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228387 */     GIR_RootConstrainSelectedInstOperands,
     /* 228388 */     // GIR_Coverage, 9150,
     /* 228388 */     GIR_EraseRootFromParent_Done,
     /* 228389 */   // Label 4536: @228389
     /* 228389 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228431), // Rule ID 9547 //
     /* 228394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228418 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1348:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 228418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 228421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228429 */     GIR_RootConstrainSelectedInstOperands,
     /* 228430 */     // GIR_Coverage, 9547,
     /* 228430 */     GIR_EraseRootFromParent_Done,
     /* 228431 */   // Label 4537: @228431
     /* 228431 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228473), // Rule ID 9548 //
     /* 228436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 228460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 228463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228471 */     GIR_RootConstrainSelectedInstOperands,
     /* 228472 */     // GIR_Coverage, 9548,
     /* 228472 */     GIR_EraseRootFromParent_Done,
     /* 228473 */   // Label 4538: @228473
     /* 228473 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228515), // Rule ID 9549 //
     /* 228478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 228489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 228502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 228505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228513 */     GIR_RootConstrainSelectedInstOperands,
     /* 228514 */     // GIR_Coverage, 9549,
     /* 228514 */     GIR_EraseRootFromParent_Done,
     /* 228515 */   // Label 4539: @228515
     /* 228515 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228557), // Rule ID 10087 //
     /* 228520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1579:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 228547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228555 */     GIR_RootConstrainSelectedInstOperands,
     /* 228556 */     // GIR_Coverage, 10087,
     /* 228556 */     GIR_EraseRootFromParent_Done,
     /* 228557 */   // Label 4540: @228557
     /* 228557 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228599), // Rule ID 10088 //
     /* 228562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228586 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1579:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 228589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228597 */     GIR_RootConstrainSelectedInstOperands,
     /* 228598 */     // GIR_Coverage, 10088,
     /* 228598 */     GIR_EraseRootFromParent_Done,
     /* 228599 */   // Label 4541: @228599
     /* 228599 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228641), // Rule ID 10089 //
     /* 228604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1579:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 228631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228639 */     GIR_RootConstrainSelectedInstOperands,
     /* 228640 */     // GIR_Coverage, 10089,
     /* 228640 */     GIR_EraseRootFromParent_Done,
     /* 228641 */   // Label 4542: @228641
     /* 228641 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228683), // Rule ID 10090 //
     /* 228646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 228654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228670 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1579:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 228673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228681 */     GIR_RootConstrainSelectedInstOperands,
     /* 228682 */     // GIR_Coverage, 10090,
     /* 228682 */     GIR_EraseRootFromParent_Done,
     /* 228683 */   // Label 4543: @228683
     /* 228683 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(228725), // Rule ID 10091 //
     /* 228688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 228708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1576:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 228712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 228715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228723 */     GIR_RootConstrainSelectedInstOperands,
     /* 228724 */     // GIR_Coverage, 10091,
     /* 228724 */     GIR_EraseRootFromParent_Done,
     /* 228725 */   // Label 4544: @228725
     /* 228725 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(228767), // Rule ID 10092 //
     /* 228730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1576:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 228754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 228757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228765 */     GIR_RootConstrainSelectedInstOperands,
     /* 228766 */     // GIR_Coverage, 10092,
     /* 228766 */     GIR_EraseRootFromParent_Done,
     /* 228767 */   // Label 4545: @228767
     /* 228767 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(228809), // Rule ID 10093 //
     /* 228772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1576:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 228796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 228799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228807 */     GIR_RootConstrainSelectedInstOperands,
     /* 228808 */     // GIR_Coverage, 10093,
     /* 228808 */     GIR_EraseRootFromParent_Done,
     /* 228809 */   // Label 4546: @228809
     /* 228809 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(228851), // Rule ID 10094 //
     /* 228814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 228822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 228828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 228841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228849 */     GIR_RootConstrainSelectedInstOperands,
     /* 228850 */     // GIR_Coverage, 10094,
     /* 228850 */     GIR_EraseRootFromParent_Done,
     /* 228851 */   // Label 4547: @228851
     /* 228851 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(228893), // Rule ID 10107 //
     /* 228856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228880 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1581:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 228883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228891 */     GIR_RootConstrainSelectedInstOperands,
     /* 228892 */     // GIR_Coverage, 10107,
     /* 228892 */     GIR_EraseRootFromParent_Done,
     /* 228893 */   // Label 4548: @228893
     /* 228893 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(228935), // Rule ID 10108 //
     /* 228898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1581:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 228925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228933 */     GIR_RootConstrainSelectedInstOperands,
     /* 228934 */     // GIR_Coverage, 10108,
     /* 228934 */     GIR_EraseRootFromParent_Done,
     /* 228935 */   // Label 4549: @228935
     /* 228935 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(228977), // Rule ID 10109 //
     /* 228940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 228948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1581:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 228967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228975 */     GIR_RootConstrainSelectedInstOperands,
     /* 228976 */     // GIR_Coverage, 10109,
     /* 228976 */     GIR_EraseRootFromParent_Done,
     /* 228977 */   // Label 4550: @228977
     /* 228977 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229019), // Rule ID 10110 //
     /* 228982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 228990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1578:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 229009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229017 */     GIR_RootConstrainSelectedInstOperands,
     /* 229018 */     // GIR_Coverage, 10110,
     /* 229018 */     GIR_EraseRootFromParent_Done,
     /* 229019 */   // Label 4551: @229019
     /* 229019 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229061), // Rule ID 10111 //
     /* 229024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1578:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 229051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229059 */     GIR_RootConstrainSelectedInstOperands,
     /* 229060 */     // GIR_Coverage, 10111,
     /* 229060 */     GIR_EraseRootFromParent_Done,
     /* 229061 */   // Label 4552: @229061
     /* 229061 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229103), // Rule ID 10112 //
     /* 229066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1578:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 229093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229101 */     GIR_RootConstrainSelectedInstOperands,
     /* 229102 */     // GIR_Coverage, 10112,
     /* 229102 */     GIR_EraseRootFromParent_Done,
     /* 229103 */   // Label 4553: @229103
     /* 229103 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229145), // Rule ID 10139 //
     /* 229108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 229116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229132 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 229135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229143 */     GIR_RootConstrainSelectedInstOperands,
     /* 229144 */     // GIR_Coverage, 10139,
     /* 229144 */     GIR_EraseRootFromParent_Done,
     /* 229145 */   // Label 4554: @229145
     /* 229145 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229187), // Rule ID 10143 //
     /* 229150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 229158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 229177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229185 */     GIR_RootConstrainSelectedInstOperands,
     /* 229186 */     // GIR_Coverage, 10143,
     /* 229186 */     GIR_EraseRootFromParent_Done,
     /* 229187 */   // Label 4555: @229187
     /* 229187 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229229), // Rule ID 10147 //
     /* 229192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 229200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229216 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 229219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229227 */     GIR_RootConstrainSelectedInstOperands,
     /* 229228 */     // GIR_Coverage, 10147,
     /* 229228 */     GIR_EraseRootFromParent_Done,
     /* 229229 */   // Label 4556: @229229
     /* 229229 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(229271), // Rule ID 10151 //
     /* 229234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 229242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229258 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1377:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 229261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229269 */     GIR_RootConstrainSelectedInstOperands,
     /* 229270 */     // GIR_Coverage, 10151,
     /* 229270 */     GIR_EraseRootFromParent_Done,
     /* 229271 */   // Label 4557: @229271
     /* 229271 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(229313), // Rule ID 10155 //
     /* 229276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 229284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229300 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1689:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 229303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229311 */     GIR_RootConstrainSelectedInstOperands,
     /* 229312 */     // GIR_Coverage, 10155,
     /* 229312 */     GIR_EraseRootFromParent_Done,
     /* 229313 */   // Label 4558: @229313
     /* 229313 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(229355), // Rule ID 10156 //
     /* 229318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 229326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229342 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1936:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 229345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229353 */     GIR_RootConstrainSelectedInstOperands,
     /* 229354 */     // GIR_Coverage, 10156,
     /* 229354 */     GIR_EraseRootFromParent_Done,
     /* 229355 */   // Label 4559: @229355
     /* 229355 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(229397), // Rule ID 10157 //
     /* 229360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 229368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229384 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1933:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 229387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229395 */     GIR_RootConstrainSelectedInstOperands,
     /* 229396 */     // GIR_Coverage, 10157,
     /* 229396 */     GIR_EraseRootFromParent_Done,
     /* 229397 */   // Label 4560: @229397
     /* 229397 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229439), // Rule ID 10161 //
     /* 229402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 229410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229426 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1688:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 229429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229437 */     GIR_RootConstrainSelectedInstOperands,
     /* 229438 */     // GIR_Coverage, 10161,
     /* 229438 */     GIR_EraseRootFromParent_Done,
     /* 229439 */   // Label 4561: @229439
     /* 229439 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229481), // Rule ID 10165 //
     /* 229444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 229452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229468 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1686:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 229471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229479 */     GIR_RootConstrainSelectedInstOperands,
     /* 229480 */     // GIR_Coverage, 10165,
     /* 229480 */     GIR_EraseRootFromParent_Done,
     /* 229481 */   // Label 4562: @229481
     /* 229481 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229523), // Rule ID 10169 //
     /* 229486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 229494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229510 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1687:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 229513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229521 */     GIR_RootConstrainSelectedInstOperands,
     /* 229522 */     // GIR_Coverage, 10169,
     /* 229522 */     GIR_EraseRootFromParent_Done,
     /* 229523 */   // Label 4563: @229523
     /* 229523 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229565), // Rule ID 10173 //
     /* 229528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 229536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229552 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1935:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 229555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229563 */     GIR_RootConstrainSelectedInstOperands,
     /* 229564 */     // GIR_Coverage, 10173,
     /* 229564 */     GIR_EraseRootFromParent_Done,
     /* 229565 */   // Label 4564: @229565
     /* 229565 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229607), // Rule ID 10177 //
     /* 229570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 229578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229594 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1934:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 229597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229605 */     GIR_RootConstrainSelectedInstOperands,
     /* 229606 */     // GIR_Coverage, 10177,
     /* 229606 */     GIR_EraseRootFromParent_Done,
     /* 229607 */   // Label 4565: @229607
     /* 229607 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229649), // Rule ID 10187 //
     /* 229612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 229620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1391:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 229639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229647 */     GIR_RootConstrainSelectedInstOperands,
     /* 229648 */     // GIR_Coverage, 10187,
     /* 229648 */     GIR_EraseRootFromParent_Done,
     /* 229649 */   // Label 4566: @229649
     /* 229649 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(229691), // Rule ID 10188 //
     /* 229654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 229662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229678 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1398:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 229681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229689 */     GIR_RootConstrainSelectedInstOperands,
     /* 229690 */     // GIR_Coverage, 10188,
     /* 229690 */     GIR_EraseRootFromParent_Done,
     /* 229691 */   // Label 4567: @229691
     /* 229691 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(229733), // Rule ID 10189 //
     /* 229696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 229704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1393:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 229723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229731 */     GIR_RootConstrainSelectedInstOperands,
     /* 229732 */     // GIR_Coverage, 10189,
     /* 229732 */     GIR_EraseRootFromParent_Done,
     /* 229733 */   // Label 4568: @229733
     /* 229733 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(229775), // Rule ID 10193 //
     /* 229738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 229746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1390:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 229765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229773 */     GIR_RootConstrainSelectedInstOperands,
     /* 229774 */     // GIR_Coverage, 10193,
     /* 229774 */     GIR_EraseRootFromParent_Done,
     /* 229775 */   // Label 4569: @229775
     /* 229775 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(229817), // Rule ID 10197 //
     /* 229780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 229788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1392:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 229807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229815 */     GIR_RootConstrainSelectedInstOperands,
     /* 229816 */     // GIR_Coverage, 10197,
     /* 229816 */     GIR_EraseRootFromParent_Done,
     /* 229817 */   // Label 4570: @229817
     /* 229817 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(229859), // Rule ID 10201 //
     /* 229822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 229830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1397:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 229849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229857 */     GIR_RootConstrainSelectedInstOperands,
     /* 229858 */     // GIR_Coverage, 10201,
     /* 229858 */     GIR_EraseRootFromParent_Done,
     /* 229859 */   // Label 4571: @229859
     /* 229859 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(229901), // Rule ID 10205 //
     /* 229864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 229872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1399:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 229891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229899 */     GIR_RootConstrainSelectedInstOperands,
     /* 229900 */     // GIR_Coverage, 10205,
     /* 229900 */     GIR_EraseRootFromParent_Done,
     /* 229901 */   // Label 4572: @229901
     /* 229901 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(229943), // Rule ID 10209 //
     /* 229906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 229914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1400:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 229933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229941 */     GIR_RootConstrainSelectedInstOperands,
     /* 229942 */     // GIR_Coverage, 10209,
     /* 229942 */     GIR_EraseRootFromParent_Done,
     /* 229943 */   // Label 4573: @229943
     /* 229943 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(229985), // Rule ID 11186 //
     /* 229948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 229951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 229956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1975:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 229975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 229977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229983 */     GIR_RootConstrainSelectedInstOperands,
     /* 229984 */     // GIR_Coverage, 11186,
     /* 229984 */     GIR_EraseRootFromParent_Done,
     /* 229985 */   // Label 4574: @229985
     /* 229985 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230027), // Rule ID 11187 //
     /* 229990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 229993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 229998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 230017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230025 */     GIR_RootConstrainSelectedInstOperands,
     /* 230026 */     // GIR_Coverage, 11187,
     /* 230026 */     GIR_EraseRootFromParent_Done,
     /* 230027 */   // Label 4575: @230027
     /* 230027 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230069), // Rule ID 11189 //
     /* 230032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 230035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 230059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230067 */     GIR_RootConstrainSelectedInstOperands,
     /* 230068 */     // GIR_Coverage, 11189,
     /* 230068 */     GIR_EraseRootFromParent_Done,
     /* 230069 */   // Label 4576: @230069
     /* 230069 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230111), // Rule ID 11190 //
     /* 230074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 230077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230098 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 230101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230109 */     GIR_RootConstrainSelectedInstOperands,
     /* 230110 */     // GIR_Coverage, 11190,
     /* 230110 */     GIR_EraseRootFromParent_Done,
     /* 230111 */   // Label 4577: @230111
     /* 230111 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230153), // Rule ID 11244 //
     /* 230116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 230143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230151 */     GIR_RootConstrainSelectedInstOperands,
     /* 230152 */     // GIR_Coverage, 11244,
     /* 230152 */     GIR_EraseRootFromParent_Done,
     /* 230153 */   // Label 4578: @230153
     /* 230153 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230195), // Rule ID 11245 //
     /* 230158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 230185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230193 */     GIR_RootConstrainSelectedInstOperands,
     /* 230194 */     // GIR_Coverage, 11245,
     /* 230194 */     GIR_EraseRootFromParent_Done,
     /* 230195 */   // Label 4579: @230195
     /* 230195 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230237), // Rule ID 11246 //
     /* 230200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 230227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230235 */     GIR_RootConstrainSelectedInstOperands,
     /* 230236 */     // GIR_Coverage, 11246,
     /* 230236 */     GIR_EraseRootFromParent_Done,
     /* 230237 */   // Label 4580: @230237
     /* 230237 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(230279), // Rule ID 11247 //
     /* 230242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1810:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 230269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230277 */     GIR_RootConstrainSelectedInstOperands,
     /* 230278 */     // GIR_Coverage, 11247,
     /* 230278 */     GIR_EraseRootFromParent_Done,
     /* 230279 */   // Label 4581: @230279
     /* 230279 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(230321), // Rule ID 11300 //
     /* 230284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 230311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230319 */     GIR_RootConstrainSelectedInstOperands,
     /* 230320 */     // GIR_Coverage, 11300,
     /* 230320 */     GIR_EraseRootFromParent_Done,
     /* 230321 */   // Label 4582: @230321
     /* 230321 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(230363), // Rule ID 11301 //
     /* 230326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 230353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230361 */     GIR_RootConstrainSelectedInstOperands,
     /* 230362 */     // GIR_Coverage, 11301,
     /* 230362 */     GIR_EraseRootFromParent_Done,
     /* 230363 */   // Label 4583: @230363
     /* 230363 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(230405), // Rule ID 11302 //
     /* 230368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 230395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230403 */     GIR_RootConstrainSelectedInstOperands,
     /* 230404 */     // GIR_Coverage, 11302,
     /* 230404 */     GIR_EraseRootFromParent_Done,
     /* 230405 */   // Label 4584: @230405
     /* 230405 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230447), // Rule ID 11303 //
     /* 230410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230434 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 230437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230445 */     GIR_RootConstrainSelectedInstOperands,
     /* 230446 */     // GIR_Coverage, 11303,
     /* 230446 */     GIR_EraseRootFromParent_Done,
     /* 230447 */   // Label 4585: @230447
     /* 230447 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230489), // Rule ID 11304 //
     /* 230452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 230479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230487 */     GIR_RootConstrainSelectedInstOperands,
     /* 230488 */     // GIR_Coverage, 11304,
     /* 230488 */     GIR_EraseRootFromParent_Done,
     /* 230489 */   // Label 4586: @230489
     /* 230489 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230531), // Rule ID 11305 //
     /* 230494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 230521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230529 */     GIR_RootConstrainSelectedInstOperands,
     /* 230530 */     // GIR_Coverage, 11305,
     /* 230530 */     GIR_EraseRootFromParent_Done,
     /* 230531 */   // Label 4587: @230531
     /* 230531 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230573), // Rule ID 11306 //
     /* 230536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 230563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230569 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230571 */     GIR_RootConstrainSelectedInstOperands,
     /* 230572 */     // GIR_Coverage, 11306,
     /* 230572 */     GIR_EraseRootFromParent_Done,
     /* 230573 */   // Label 4588: @230573
     /* 230573 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230615), // Rule ID 11307 //
     /* 230578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 230605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230613 */     GIR_RootConstrainSelectedInstOperands,
     /* 230614 */     // GIR_Coverage, 11307,
     /* 230614 */     GIR_EraseRootFromParent_Done,
     /* 230615 */   // Label 4589: @230615
     /* 230615 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(230657), // Rule ID 11308 //
     /* 230620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 230628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 230647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230653 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230655 */     GIR_RootConstrainSelectedInstOperands,
     /* 230656 */     // GIR_Coverage, 11308,
     /* 230656 */     GIR_EraseRootFromParent_Done,
     /* 230657 */   // Label 4590: @230657
     /* 230657 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(230699), // Rule ID 11309 //
     /* 230662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 230689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230697 */     GIR_RootConstrainSelectedInstOperands,
     /* 230698 */     // GIR_Coverage, 11309,
     /* 230698 */     GIR_EraseRootFromParent_Done,
     /* 230699 */   // Label 4591: @230699
     /* 230699 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(230741), // Rule ID 11310 //
     /* 230704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230728 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 230731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230739 */     GIR_RootConstrainSelectedInstOperands,
     /* 230740 */     // GIR_Coverage, 11310,
     /* 230740 */     GIR_EraseRootFromParent_Done,
     /* 230741 */   // Label 4592: @230741
     /* 230741 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(230783), // Rule ID 11311 //
     /* 230746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 230754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 230773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230779 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230781 */     GIR_RootConstrainSelectedInstOperands,
     /* 230782 */     // GIR_Coverage, 11311,
     /* 230782 */     GIR_EraseRootFromParent_Done,
     /* 230783 */   // Label 4593: @230783
     /* 230783 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(230825), // Rule ID 11312 //
     /* 230788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1735:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 230815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230823 */     GIR_RootConstrainSelectedInstOperands,
     /* 230824 */     // GIR_Coverage, 11312,
     /* 230824 */     GIR_EraseRootFromParent_Done,
     /* 230825 */   // Label 4594: @230825
     /* 230825 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(230867), // Rule ID 11313 //
     /* 230830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1735:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 230857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230865 */     GIR_RootConstrainSelectedInstOperands,
     /* 230866 */     // GIR_Coverage, 11313,
     /* 230866 */     GIR_EraseRootFromParent_Done,
     /* 230867 */   // Label 4595: @230867
     /* 230867 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(230909), // Rule ID 11314 //
     /* 230872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 230880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1735:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 230899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230907 */     GIR_RootConstrainSelectedInstOperands,
     /* 230908 */     // GIR_Coverage, 11314,
     /* 230908 */     GIR_EraseRootFromParent_Done,
     /* 230909 */   // Label 4596: @230909
     /* 230909 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(230951), // Rule ID 11315 //
     /* 230914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 230941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230947 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230949 */     GIR_RootConstrainSelectedInstOperands,
     /* 230950 */     // GIR_Coverage, 11315,
     /* 230950 */     GIR_EraseRootFromParent_Done,
     /* 230951 */   // Label 4597: @230951
     /* 230951 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(230993), // Rule ID 11316 //
     /* 230956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 230964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 230983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230989 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230991 */     GIR_RootConstrainSelectedInstOperands,
     /* 230992 */     // GIR_Coverage, 11316,
     /* 230992 */     GIR_EraseRootFromParent_Done,
     /* 230993 */   // Label 4598: @230993
     /* 230993 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231035), // Rule ID 11317 //
     /* 230998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 231025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231033 */     GIR_RootConstrainSelectedInstOperands,
     /* 231034 */     // GIR_Coverage, 11317,
     /* 231034 */     GIR_EraseRootFromParent_Done,
     /* 231035 */   // Label 4599: @231035
     /* 231035 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231077), // Rule ID 11318 //
     /* 231040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1973:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 231067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231073 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231075 */     GIR_RootConstrainSelectedInstOperands,
     /* 231076 */     // GIR_Coverage, 11318,
     /* 231076 */     GIR_EraseRootFromParent_Done,
     /* 231077 */   // Label 4600: @231077
     /* 231077 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231119), // Rule ID 11319 //
     /* 231082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1973:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 231109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231117 */     GIR_RootConstrainSelectedInstOperands,
     /* 231118 */     // GIR_Coverage, 11319,
     /* 231118 */     GIR_EraseRootFromParent_Done,
     /* 231119 */   // Label 4601: @231119
     /* 231119 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231161), // Rule ID 11320 //
     /* 231124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1973:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 231151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231159 */     GIR_RootConstrainSelectedInstOperands,
     /* 231160 */     // GIR_Coverage, 11320,
     /* 231160 */     GIR_EraseRootFromParent_Done,
     /* 231161 */   // Label 4602: @231161
     /* 231161 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231203), // Rule ID 11329 //
     /* 231166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231190 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 231193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231201 */     GIR_RootConstrainSelectedInstOperands,
     /* 231202 */     // GIR_Coverage, 11329,
     /* 231202 */     GIR_EraseRootFromParent_Done,
     /* 231203 */   // Label 4603: @231203
     /* 231203 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231245), // Rule ID 11330 //
     /* 231208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 231235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231243 */     GIR_RootConstrainSelectedInstOperands,
     /* 231244 */     // GIR_Coverage, 11330,
     /* 231244 */     GIR_EraseRootFromParent_Done,
     /* 231245 */   // Label 4604: @231245
     /* 231245 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(231287), // Rule ID 11331 //
     /* 231250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 231277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231285 */     GIR_RootConstrainSelectedInstOperands,
     /* 231286 */     // GIR_Coverage, 11331,
     /* 231286 */     GIR_EraseRootFromParent_Done,
     /* 231287 */   // Label 4605: @231287
     /* 231287 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(231329), // Rule ID 11332 //
     /* 231292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1774:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 231319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231327 */     GIR_RootConstrainSelectedInstOperands,
     /* 231328 */     // GIR_Coverage, 11332,
     /* 231328 */     GIR_EraseRootFromParent_Done,
     /* 231329 */   // Label 4606: @231329
     /* 231329 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(231371), // Rule ID 11333 //
     /* 231334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 231361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231369 */     GIR_RootConstrainSelectedInstOperands,
     /* 231370 */     // GIR_Coverage, 11333,
     /* 231370 */     GIR_EraseRootFromParent_Done,
     /* 231371 */   // Label 4607: @231371
     /* 231371 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(231413), // Rule ID 11334 //
     /* 231376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 231403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231411 */     GIR_RootConstrainSelectedInstOperands,
     /* 231412 */     // GIR_Coverage, 11334,
     /* 231412 */     GIR_EraseRootFromParent_Done,
     /* 231413 */   // Label 4608: @231413
     /* 231413 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231455), // Rule ID 11335 //
     /* 231418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 231445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231453 */     GIR_RootConstrainSelectedInstOperands,
     /* 231454 */     // GIR_Coverage, 11335,
     /* 231454 */     GIR_EraseRootFromParent_Done,
     /* 231455 */   // Label 4609: @231455
     /* 231455 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231497), // Rule ID 11336 //
     /* 231460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 231487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231495 */     GIR_RootConstrainSelectedInstOperands,
     /* 231496 */     // GIR_Coverage, 11336,
     /* 231496 */     GIR_EraseRootFromParent_Done,
     /* 231497 */   // Label 4610: @231497
     /* 231497 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231539), // Rule ID 11337 //
     /* 231502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231526 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 231529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231537 */     GIR_RootConstrainSelectedInstOperands,
     /* 231538 */     // GIR_Coverage, 11337,
     /* 231538 */     GIR_EraseRootFromParent_Done,
     /* 231539 */   // Label 4611: @231539
     /* 231539 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231581), // Rule ID 11338 //
     /* 231544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 231571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231579 */     GIR_RootConstrainSelectedInstOperands,
     /* 231580 */     // GIR_Coverage, 11338,
     /* 231580 */     GIR_EraseRootFromParent_Done,
     /* 231581 */   // Label 4612: @231581
     /* 231581 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231623), // Rule ID 11339 //
     /* 231586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 231613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231621 */     GIR_RootConstrainSelectedInstOperands,
     /* 231622 */     // GIR_Coverage, 11339,
     /* 231622 */     GIR_EraseRootFromParent_Done,
     /* 231623 */   // Label 4613: @231623
     /* 231623 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(231665), // Rule ID 11340 //
     /* 231628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 231636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 231655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231663 */     GIR_RootConstrainSelectedInstOperands,
     /* 231664 */     // GIR_Coverage, 11340,
     /* 231664 */     GIR_EraseRootFromParent_Done,
     /* 231665 */   // Label 4614: @231665
     /* 231665 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(231707), // Rule ID 11341 //
     /* 231670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1773:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 231697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231705 */     GIR_RootConstrainSelectedInstOperands,
     /* 231706 */     // GIR_Coverage, 11341,
     /* 231706 */     GIR_EraseRootFromParent_Done,
     /* 231707 */   // Label 4615: @231707
     /* 231707 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(231749), // Rule ID 11342 //
     /* 231712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1773:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 231739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231747 */     GIR_RootConstrainSelectedInstOperands,
     /* 231748 */     // GIR_Coverage, 11342,
     /* 231748 */     GIR_EraseRootFromParent_Done,
     /* 231749 */   // Label 4616: @231749
     /* 231749 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(231791), // Rule ID 11343 //
     /* 231754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 231762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 231781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231789 */     GIR_RootConstrainSelectedInstOperands,
     /* 231790 */     // GIR_Coverage, 11343,
     /* 231790 */     GIR_EraseRootFromParent_Done,
     /* 231791 */   // Label 4617: @231791
     /* 231791 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(231833), // Rule ID 11344 //
     /* 231796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1778:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 231823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231831 */     GIR_RootConstrainSelectedInstOperands,
     /* 231832 */     // GIR_Coverage, 11344,
     /* 231832 */     GIR_EraseRootFromParent_Done,
     /* 231833 */   // Label 4618: @231833
     /* 231833 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(231875), // Rule ID 11345 //
     /* 231838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 231865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231873 */     GIR_RootConstrainSelectedInstOperands,
     /* 231874 */     // GIR_Coverage, 11345,
     /* 231874 */     GIR_EraseRootFromParent_Done,
     /* 231875 */   // Label 4619: @231875
     /* 231875 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(231917), // Rule ID 11346 //
     /* 231880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 231888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 231907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231915 */     GIR_RootConstrainSelectedInstOperands,
     /* 231916 */     // GIR_Coverage, 11346,
     /* 231916 */     GIR_EraseRootFromParent_Done,
     /* 231917 */   // Label 4620: @231917
     /* 231917 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(231959), // Rule ID 11347 //
     /* 231922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 231936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1946:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 231949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231957 */     GIR_RootConstrainSelectedInstOperands,
     /* 231958 */     // GIR_Coverage, 11347,
     /* 231958 */     GIR_EraseRootFromParent_Done,
     /* 231959 */   // Label 4621: @231959
     /* 231959 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232001), // Rule ID 11349 //
     /* 231964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 231972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 231978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 231991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 231993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231999 */     GIR_RootConstrainSelectedInstOperands,
     /* 232000 */     // GIR_Coverage, 11349,
     /* 232000 */     GIR_EraseRootFromParent_Done,
     /* 232001 */   // Label 4622: @232001
     /* 232001 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232043), // Rule ID 11351 //
     /* 232006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232030 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 232033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232041 */     GIR_RootConstrainSelectedInstOperands,
     /* 232042 */     // GIR_Coverage, 11351,
     /* 232042 */     GIR_EraseRootFromParent_Done,
     /* 232043 */   // Label 4623: @232043
     /* 232043 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232085), // Rule ID 11353 //
     /* 232048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 232075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232083 */     GIR_RootConstrainSelectedInstOperands,
     /* 232084 */     // GIR_Coverage, 11353,
     /* 232084 */     GIR_EraseRootFromParent_Done,
     /* 232085 */   // Label 4624: @232085
     /* 232085 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232127), // Rule ID 11355 //
     /* 232090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1706:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 232117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232125 */     GIR_RootConstrainSelectedInstOperands,
     /* 232126 */     // GIR_Coverage, 11355,
     /* 232126 */     GIR_EraseRootFromParent_Done,
     /* 232127 */   // Label 4625: @232127
     /* 232127 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232169), // Rule ID 11356 //
     /* 232132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1706:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 232159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232167 */     GIR_RootConstrainSelectedInstOperands,
     /* 232168 */     // GIR_Coverage, 11356,
     /* 232168 */     GIR_EraseRootFromParent_Done,
     /* 232169 */   // Label 4626: @232169
     /* 232169 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232211), // Rule ID 11357 //
     /* 232174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 232201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232209 */     GIR_RootConstrainSelectedInstOperands,
     /* 232210 */     // GIR_Coverage, 11357,
     /* 232210 */     GIR_EraseRootFromParent_Done,
     /* 232211 */   // Label 4627: @232211
     /* 232211 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(232253), // Rule ID 11358 //
     /* 232216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 232243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232251 */     GIR_RootConstrainSelectedInstOperands,
     /* 232252 */     // GIR_Coverage, 11358,
     /* 232252 */     GIR_EraseRootFromParent_Done,
     /* 232253 */   // Label 4628: @232253
     /* 232253 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(232295), // Rule ID 11359 //
     /* 232258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232282 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1947:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 232285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232293 */     GIR_RootConstrainSelectedInstOperands,
     /* 232294 */     // GIR_Coverage, 11359,
     /* 232294 */     GIR_EraseRootFromParent_Done,
     /* 232295 */   // Label 4629: @232295
     /* 232295 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(232337), // Rule ID 11360 //
     /* 232300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1947:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 232327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232335 */     GIR_RootConstrainSelectedInstOperands,
     /* 232336 */     // GIR_Coverage, 11360,
     /* 232336 */     GIR_EraseRootFromParent_Done,
     /* 232337 */   // Label 4630: @232337
     /* 232337 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(232379), // Rule ID 11361 //
     /* 232342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1947:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 232369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232377 */     GIR_RootConstrainSelectedInstOperands,
     /* 232378 */     // GIR_Coverage, 11361,
     /* 232378 */     GIR_EraseRootFromParent_Done,
     /* 232379 */   // Label 4631: @232379
     /* 232379 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(232421), // Rule ID 11362 //
     /* 232384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1947:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 232411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232419 */     GIR_RootConstrainSelectedInstOperands,
     /* 232420 */     // GIR_Coverage, 11362,
     /* 232420 */     GIR_EraseRootFromParent_Done,
     /* 232421 */   // Label 4632: @232421
     /* 232421 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232463), // Rule ID 11363 //
     /* 232426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 232453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232461 */     GIR_RootConstrainSelectedInstOperands,
     /* 232462 */     // GIR_Coverage, 11363,
     /* 232462 */     GIR_EraseRootFromParent_Done,
     /* 232463 */   // Label 4633: @232463
     /* 232463 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232505), // Rule ID 11365 //
     /* 232468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232492 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 232495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232503 */     GIR_RootConstrainSelectedInstOperands,
     /* 232504 */     // GIR_Coverage, 11365,
     /* 232504 */     GIR_EraseRootFromParent_Done,
     /* 232505 */   // Label 4634: @232505
     /* 232505 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232547), // Rule ID 11367 //
     /* 232510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 232537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232545 */     GIR_RootConstrainSelectedInstOperands,
     /* 232546 */     // GIR_Coverage, 11367,
     /* 232546 */     GIR_EraseRootFromParent_Done,
     /* 232547 */   // Label 4635: @232547
     /* 232547 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232589), // Rule ID 11369 //
     /* 232552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 232579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232587 */     GIR_RootConstrainSelectedInstOperands,
     /* 232588 */     // GIR_Coverage, 11369,
     /* 232588 */     GIR_EraseRootFromParent_Done,
     /* 232589 */   // Label 4636: @232589
     /* 232589 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232631), // Rule ID 11371 //
     /* 232594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2033:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 232621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232629 */     GIR_RootConstrainSelectedInstOperands,
     /* 232630 */     // GIR_Coverage, 11371,
     /* 232630 */     GIR_EraseRootFromParent_Done,
     /* 232631 */   // Label 4637: @232631
     /* 232631 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(232673), // Rule ID 11373 //
     /* 232636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2033:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 232663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232671 */     GIR_RootConstrainSelectedInstOperands,
     /* 232672 */     // GIR_Coverage, 11373,
     /* 232672 */     GIR_EraseRootFromParent_Done,
     /* 232673 */   // Label 4638: @232673
     /* 232673 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(232715), // Rule ID 11375 //
     /* 232678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2033:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 232705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232713 */     GIR_RootConstrainSelectedInstOperands,
     /* 232714 */     // GIR_Coverage, 11375,
     /* 232714 */     GIR_EraseRootFromParent_Done,
     /* 232715 */   // Label 4639: @232715
     /* 232715 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(232757), // Rule ID 11377 //
     /* 232720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 232728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2033:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 232747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232755 */     GIR_RootConstrainSelectedInstOperands,
     /* 232756 */     // GIR_Coverage, 11377,
     /* 232756 */     GIR_EraseRootFromParent_Done,
     /* 232757 */   // Label 4640: @232757
     /* 232757 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(232799), // Rule ID 11379 //
     /* 232762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1707:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 232789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232797 */     GIR_RootConstrainSelectedInstOperands,
     /* 232798 */     // GIR_Coverage, 11379,
     /* 232798 */     GIR_EraseRootFromParent_Done,
     /* 232799 */   // Label 4641: @232799
     /* 232799 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(232841), // Rule ID 11380 //
     /* 232804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 232831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232839 */     GIR_RootConstrainSelectedInstOperands,
     /* 232840 */     // GIR_Coverage, 11380,
     /* 232840 */     GIR_EraseRootFromParent_Done,
     /* 232841 */   // Label 4642: @232841
     /* 232841 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(232883), // Rule ID 11381 //
     /* 232846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 232873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232881 */     GIR_RootConstrainSelectedInstOperands,
     /* 232882 */     // GIR_Coverage, 11381,
     /* 232882 */     GIR_EraseRootFromParent_Done,
     /* 232883 */   // Label 4643: @232883
     /* 232883 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(232925), // Rule ID 11382 //
     /* 232888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 232896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 232915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232923 */     GIR_RootConstrainSelectedInstOperands,
     /* 232924 */     // GIR_Coverage, 11382,
     /* 232924 */     GIR_EraseRootFromParent_Done,
     /* 232925 */   // Label 4644: @232925
     /* 232925 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(232967), // Rule ID 11383 //
     /* 232930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1948:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 232957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232965 */     GIR_RootConstrainSelectedInstOperands,
     /* 232966 */     // GIR_Coverage, 11383,
     /* 232966 */     GIR_EraseRootFromParent_Done,
     /* 232967 */   // Label 4645: @232967
     /* 232967 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233009), // Rule ID 11384 //
     /* 232972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 232980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1948:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 232999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233007 */     GIR_RootConstrainSelectedInstOperands,
     /* 233008 */     // GIR_Coverage, 11384,
     /* 233008 */     GIR_EraseRootFromParent_Done,
     /* 233009 */   // Label 4646: @233009
     /* 233009 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233051), // Rule ID 11385 //
     /* 233014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1948:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 233041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233049 */     GIR_RootConstrainSelectedInstOperands,
     /* 233050 */     // GIR_Coverage, 11385,
     /* 233050 */     GIR_EraseRootFromParent_Done,
     /* 233051 */   // Label 4647: @233051
     /* 233051 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233093), // Rule ID 11386 //
     /* 233056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1948:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 233083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233091 */     GIR_RootConstrainSelectedInstOperands,
     /* 233092 */     // GIR_Coverage, 11386,
     /* 233092 */     GIR_EraseRootFromParent_Done,
     /* 233093 */   // Label 4648: @233093
     /* 233093 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233135), // Rule ID 11387 //
     /* 233098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1923:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 233125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233133 */     GIR_RootConstrainSelectedInstOperands,
     /* 233134 */     // GIR_Coverage, 11387,
     /* 233134 */     GIR_EraseRootFromParent_Done,
     /* 233135 */   // Label 4649: @233135
     /* 233135 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233177), // Rule ID 11388 //
     /* 233140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1923:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 233167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233175 */     GIR_RootConstrainSelectedInstOperands,
     /* 233176 */     // GIR_Coverage, 11388,
     /* 233176 */     GIR_EraseRootFromParent_Done,
     /* 233177 */   // Label 4650: @233177
     /* 233177 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233219), // Rule ID 11389 //
     /* 233182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1923:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 233209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233217 */     GIR_RootConstrainSelectedInstOperands,
     /* 233218 */     // GIR_Coverage, 11389,
     /* 233218 */     GIR_EraseRootFromParent_Done,
     /* 233219 */   // Label 4651: @233219
     /* 233219 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(233261), // Rule ID 11390 //
     /* 233224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1238:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 233251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233259 */     GIR_RootConstrainSelectedInstOperands,
     /* 233260 */     // GIR_Coverage, 11390,
     /* 233260 */     GIR_EraseRootFromParent_Done,
     /* 233261 */   // Label 4652: @233261
     /* 233261 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(233303), // Rule ID 11391 //
     /* 233266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1238:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 233293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233301 */     GIR_RootConstrainSelectedInstOperands,
     /* 233302 */     // GIR_Coverage, 11391,
     /* 233302 */     GIR_EraseRootFromParent_Done,
     /* 233303 */   // Label 4653: @233303
     /* 233303 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(233345), // Rule ID 11392 //
     /* 233308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1238:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 233335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233343 */     GIR_RootConstrainSelectedInstOperands,
     /* 233344 */     // GIR_Coverage, 11392,
     /* 233344 */     GIR_EraseRootFromParent_Done,
     /* 233345 */   // Label 4654: @233345
     /* 233345 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(233387), // Rule ID 11393 //
     /* 233350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1238:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 233377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233385 */     GIR_RootConstrainSelectedInstOperands,
     /* 233386 */     // GIR_Coverage, 11393,
     /* 233386 */     GIR_EraseRootFromParent_Done,
     /* 233387 */   // Label 4655: @233387
     /* 233387 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233429), // Rule ID 11394 //
     /* 233392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 233419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233427 */     GIR_RootConstrainSelectedInstOperands,
     /* 233428 */     // GIR_Coverage, 11394,
     /* 233428 */     GIR_EraseRootFromParent_Done,
     /* 233429 */   // Label 4656: @233429
     /* 233429 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233471), // Rule ID 11395 //
     /* 233434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 233461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233469 */     GIR_RootConstrainSelectedInstOperands,
     /* 233470 */     // GIR_Coverage, 11395,
     /* 233470 */     GIR_EraseRootFromParent_Done,
     /* 233471 */   // Label 4657: @233471
     /* 233471 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233513), // Rule ID 11396 //
     /* 233476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 233503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233511 */     GIR_RootConstrainSelectedInstOperands,
     /* 233512 */     // GIR_Coverage, 11396,
     /* 233512 */     GIR_EraseRootFromParent_Done,
     /* 233513 */   // Label 4658: @233513
     /* 233513 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233555), // Rule ID 11397 //
     /* 233518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 233545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233553 */     GIR_RootConstrainSelectedInstOperands,
     /* 233554 */     // GIR_Coverage, 11397,
     /* 233554 */     GIR_EraseRootFromParent_Done,
     /* 233555 */   // Label 4659: @233555
     /* 233555 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233597), // Rule ID 11398 //
     /* 233560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1955:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 233587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233595 */     GIR_RootConstrainSelectedInstOperands,
     /* 233596 */     // GIR_Coverage, 11398,
     /* 233596 */     GIR_EraseRootFromParent_Done,
     /* 233597 */   // Label 4660: @233597
     /* 233597 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(233639), // Rule ID 11399 //
     /* 233602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1955:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 233629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233637 */     GIR_RootConstrainSelectedInstOperands,
     /* 233638 */     // GIR_Coverage, 11399,
     /* 233638 */     GIR_EraseRootFromParent_Done,
     /* 233639 */   // Label 4661: @233639
     /* 233639 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(233681), // Rule ID 11400 //
     /* 233644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 233671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233679 */     GIR_RootConstrainSelectedInstOperands,
     /* 233680 */     // GIR_Coverage, 11400,
     /* 233680 */     GIR_EraseRootFromParent_Done,
     /* 233681 */   // Label 4662: @233681
     /* 233681 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(233723), // Rule ID 11401 //
     /* 233686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 233694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 233713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233721 */     GIR_RootConstrainSelectedInstOperands,
     /* 233722 */     // GIR_Coverage, 11401,
     /* 233722 */     GIR_EraseRootFromParent_Done,
     /* 233723 */   // Label 4663: @233723
     /* 233723 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(233765), // Rule ID 11402 //
     /* 233728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 233755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233763 */     GIR_RootConstrainSelectedInstOperands,
     /* 233764 */     // GIR_Coverage, 11402,
     /* 233764 */     GIR_EraseRootFromParent_Done,
     /* 233765 */   // Label 4664: @233765
     /* 233765 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(233807), // Rule ID 11403 //
     /* 233770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 233797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233805 */     GIR_RootConstrainSelectedInstOperands,
     /* 233806 */     // GIR_Coverage, 11403,
     /* 233806 */     GIR_EraseRootFromParent_Done,
     /* 233807 */   // Label 4665: @233807
     /* 233807 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(233849), // Rule ID 11404 //
     /* 233812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 233839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233847 */     GIR_RootConstrainSelectedInstOperands,
     /* 233848 */     // GIR_Coverage, 11404,
     /* 233848 */     GIR_EraseRootFromParent_Done,
     /* 233849 */   // Label 4666: @233849
     /* 233849 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(233891), // Rule ID 11405 //
     /* 233854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 233862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1726:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 233881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233889 */     GIR_RootConstrainSelectedInstOperands,
     /* 233890 */     // GIR_Coverage, 11405,
     /* 233890 */     GIR_EraseRootFromParent_Done,
     /* 233891 */   // Label 4667: @233891
     /* 233891 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(233933), // Rule ID 11406 //
     /* 233896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1964:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 233923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233931 */     GIR_RootConstrainSelectedInstOperands,
     /* 233932 */     // GIR_Coverage, 11406,
     /* 233932 */     GIR_EraseRootFromParent_Done,
     /* 233933 */   // Label 4668: @233933
     /* 233933 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(233975), // Rule ID 11407 //
     /* 233938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1964:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 233965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233973 */     GIR_RootConstrainSelectedInstOperands,
     /* 233974 */     // GIR_Coverage, 11407,
     /* 233974 */     GIR_EraseRootFromParent_Done,
     /* 233975 */   // Label 4669: @233975
     /* 233975 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234017), // Rule ID 11408 //
     /* 233980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 233988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234004 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 234007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234015 */     GIR_RootConstrainSelectedInstOperands,
     /* 234016 */     // GIR_Coverage, 11408,
     /* 234016 */     GIR_EraseRootFromParent_Done,
     /* 234017 */   // Label 4670: @234017
     /* 234017 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234059), // Rule ID 11409 //
     /* 234022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 234049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234057 */     GIR_RootConstrainSelectedInstOperands,
     /* 234058 */     // GIR_Coverage, 11409,
     /* 234058 */     GIR_EraseRootFromParent_Done,
     /* 234059 */   // Label 4671: @234059
     /* 234059 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234101), // Rule ID 11410 //
     /* 234064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 234072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 234091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234099 */     GIR_RootConstrainSelectedInstOperands,
     /* 234100 */     // GIR_Coverage, 11410,
     /* 234100 */     GIR_EraseRootFromParent_Done,
     /* 234101 */   // Label 4672: @234101
     /* 234101 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234143), // Rule ID 11421 //
     /* 234106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 234123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 234133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234141 */     GIR_RootConstrainSelectedInstOperands,
     /* 234142 */     // GIR_Coverage, 11421,
     /* 234142 */     GIR_EraseRootFromParent_Done,
     /* 234143 */   // Label 4673: @234143
     /* 234143 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234185), // Rule ID 11422 //
     /* 234148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234172 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 234175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234183 */     GIR_RootConstrainSelectedInstOperands,
     /* 234184 */     // GIR_Coverage, 11422,
     /* 234184 */     GIR_EraseRootFromParent_Done,
     /* 234185 */   // Label 4674: @234185
     /* 234185 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234227), // Rule ID 11423 //
     /* 234190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 234217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234225 */     GIR_RootConstrainSelectedInstOperands,
     /* 234226 */     // GIR_Coverage, 11423,
     /* 234226 */     GIR_EraseRootFromParent_Done,
     /* 234227 */   // Label 4675: @234227
     /* 234227 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(234269), // Rule ID 11424 //
     /* 234232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 234259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234267 */     GIR_RootConstrainSelectedInstOperands,
     /* 234268 */     // GIR_Coverage, 11424,
     /* 234268 */     GIR_EraseRootFromParent_Done,
     /* 234269 */   // Label 4676: @234269
     /* 234269 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(234311), // Rule ID 11433 //
     /* 234274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234298 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 234301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234309 */     GIR_RootConstrainSelectedInstOperands,
     /* 234310 */     // GIR_Coverage, 11433,
     /* 234310 */     GIR_EraseRootFromParent_Done,
     /* 234311 */   // Label 4677: @234311
     /* 234311 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(234353), // Rule ID 11434 //
     /* 234316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 234343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234351 */     GIR_RootConstrainSelectedInstOperands,
     /* 234352 */     // GIR_Coverage, 11434,
     /* 234352 */     GIR_EraseRootFromParent_Done,
     /* 234353 */   // Label 4678: @234353
     /* 234353 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(234395), // Rule ID 11435 //
     /* 234358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 234385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234393 */     GIR_RootConstrainSelectedInstOperands,
     /* 234394 */     // GIR_Coverage, 11435,
     /* 234394 */     GIR_EraseRootFromParent_Done,
     /* 234395 */   // Label 4679: @234395
     /* 234395 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234437), // Rule ID 11436 //
     /* 234400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 234427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234435 */     GIR_RootConstrainSelectedInstOperands,
     /* 234436 */     // GIR_Coverage, 11436,
     /* 234436 */     GIR_EraseRootFromParent_Done,
     /* 234437 */   // Label 4680: @234437
     /* 234437 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234479), // Rule ID 11437 //
     /* 234442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1982:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 234469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234477 */     GIR_RootConstrainSelectedInstOperands,
     /* 234478 */     // GIR_Coverage, 11437,
     /* 234478 */     GIR_EraseRootFromParent_Done,
     /* 234479 */   // Label 4681: @234479
     /* 234479 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234521), // Rule ID 11438 //
     /* 234484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1982:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 234511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234519 */     GIR_RootConstrainSelectedInstOperands,
     /* 234520 */     // GIR_Coverage, 11438,
     /* 234520 */     GIR_EraseRootFromParent_Done,
     /* 234521 */   // Label 4682: @234521
     /* 234521 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234563), // Rule ID 11439 //
     /* 234526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 234553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234561 */     GIR_RootConstrainSelectedInstOperands,
     /* 234562 */     // GIR_Coverage, 11439,
     /* 234562 */     GIR_EraseRootFromParent_Done,
     /* 234563 */   // Label 4683: @234563
     /* 234563 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234605), // Rule ID 11440 //
     /* 234568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 234595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234603 */     GIR_RootConstrainSelectedInstOperands,
     /* 234604 */     // GIR_Coverage, 11440,
     /* 234604 */     GIR_EraseRootFromParent_Done,
     /* 234605 */   // Label 4684: @234605
     /* 234605 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(234647), // Rule ID 11441 //
     /* 234610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234634 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 234637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234645 */     GIR_RootConstrainSelectedInstOperands,
     /* 234646 */     // GIR_Coverage, 11441,
     /* 234646 */     GIR_EraseRootFromParent_Done,
     /* 234647 */   // Label 4685: @234647
     /* 234647 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(234689), // Rule ID 11442 //
     /* 234652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 234679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234687 */     GIR_RootConstrainSelectedInstOperands,
     /* 234688 */     // GIR_Coverage, 11442,
     /* 234688 */     GIR_EraseRootFromParent_Done,
     /* 234689 */   // Label 4686: @234689
     /* 234689 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(234731), // Rule ID 11443 //
     /* 234694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 234721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234729 */     GIR_RootConstrainSelectedInstOperands,
     /* 234730 */     // GIR_Coverage, 11443,
     /* 234730 */     GIR_EraseRootFromParent_Done,
     /* 234731 */   // Label 4687: @234731
     /* 234731 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(234773), // Rule ID 11444 //
     /* 234736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 234744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 234763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234771 */     GIR_RootConstrainSelectedInstOperands,
     /* 234772 */     // GIR_Coverage, 11444,
     /* 234772 */     GIR_EraseRootFromParent_Done,
     /* 234773 */   // Label 4688: @234773
     /* 234773 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(234815), // Rule ID 11445 //
     /* 234778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2026:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 234805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234813 */     GIR_RootConstrainSelectedInstOperands,
     /* 234814 */     // GIR_Coverage, 11445,
     /* 234814 */     GIR_EraseRootFromParent_Done,
     /* 234815 */   // Label 4689: @234815
     /* 234815 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(234857), // Rule ID 11446 //
     /* 234820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2026:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 234847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234855 */     GIR_RootConstrainSelectedInstOperands,
     /* 234856 */     // GIR_Coverage, 11446,
     /* 234856 */     GIR_EraseRootFromParent_Done,
     /* 234857 */   // Label 4690: @234857
     /* 234857 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(234899), // Rule ID 11447 //
     /* 234862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2026:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 234889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234897 */     GIR_RootConstrainSelectedInstOperands,
     /* 234898 */     // GIR_Coverage, 11447,
     /* 234898 */     GIR_EraseRootFromParent_Done,
     /* 234899 */   // Label 4691: @234899
     /* 234899 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(234941), // Rule ID 11448 //
     /* 234904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 234912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2026:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 234931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234939 */     GIR_RootConstrainSelectedInstOperands,
     /* 234940 */     // GIR_Coverage, 11448,
     /* 234940 */     GIR_EraseRootFromParent_Done,
     /* 234941 */   // Label 4692: @234941
     /* 234941 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(234983), // Rule ID 11449 //
     /* 234946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1897:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 234973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234981 */     GIR_RootConstrainSelectedInstOperands,
     /* 234982 */     // GIR_Coverage, 11449,
     /* 234982 */     GIR_EraseRootFromParent_Done,
     /* 234983 */   // Label 4693: @234983
     /* 234983 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235025), // Rule ID 11450 //
     /* 234988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 234996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1897:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 235015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235023 */     GIR_RootConstrainSelectedInstOperands,
     /* 235024 */     // GIR_Coverage, 11450,
     /* 235024 */     GIR_EraseRootFromParent_Done,
     /* 235025 */   // Label 4694: @235025
     /* 235025 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235067), // Rule ID 11451 //
     /* 235030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235054 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1897:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 235057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235065 */     GIR_RootConstrainSelectedInstOperands,
     /* 235066 */     // GIR_Coverage, 11451,
     /* 235066 */     GIR_EraseRootFromParent_Done,
     /* 235067 */   // Label 4695: @235067
     /* 235067 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235109), // Rule ID 11452 //
     /* 235072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1897:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 235099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235107 */     GIR_RootConstrainSelectedInstOperands,
     /* 235108 */     // GIR_Coverage, 11452,
     /* 235108 */     GIR_EraseRootFromParent_Done,
     /* 235109 */   // Label 4696: @235109
     /* 235109 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235151), // Rule ID 11453 //
     /* 235114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 235141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235149 */     GIR_RootConstrainSelectedInstOperands,
     /* 235150 */     // GIR_Coverage, 11453,
     /* 235150 */     GIR_EraseRootFromParent_Done,
     /* 235151 */   // Label 4697: @235151
     /* 235151 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235193), // Rule ID 11454 //
     /* 235156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 235183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235191 */     GIR_RootConstrainSelectedInstOperands,
     /* 235192 */     // GIR_Coverage, 11454,
     /* 235192 */     GIR_EraseRootFromParent_Done,
     /* 235193 */   // Label 4698: @235193
     /* 235193 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235235), // Rule ID 11455 //
     /* 235198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 235225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235233 */     GIR_RootConstrainSelectedInstOperands,
     /* 235234 */     // GIR_Coverage, 11455,
     /* 235234 */     GIR_EraseRootFromParent_Done,
     /* 235235 */   // Label 4699: @235235
     /* 235235 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(235277), // Rule ID 11456 //
     /* 235240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 235267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235275 */     GIR_RootConstrainSelectedInstOperands,
     /* 235276 */     // GIR_Coverage, 11456,
     /* 235276 */     GIR_EraseRootFromParent_Done,
     /* 235277 */   // Label 4700: @235277
     /* 235277 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(235319), // Rule ID 11457 //
     /* 235282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 235309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235317 */     GIR_RootConstrainSelectedInstOperands,
     /* 235318 */     // GIR_Coverage, 11457,
     /* 235318 */     GIR_EraseRootFromParent_Done,
     /* 235319 */   // Label 4701: @235319
     /* 235319 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(235361), // Rule ID 11458 //
     /* 235324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 235351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235359 */     GIR_RootConstrainSelectedInstOperands,
     /* 235360 */     // GIR_Coverage, 11458,
     /* 235360 */     GIR_EraseRootFromParent_Done,
     /* 235361 */   // Label 4702: @235361
     /* 235361 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(235403), // Rule ID 11459 //
     /* 235366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 235393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235401 */     GIR_RootConstrainSelectedInstOperands,
     /* 235402 */     // GIR_Coverage, 11459,
     /* 235402 */     GIR_EraseRootFromParent_Done,
     /* 235403 */   // Label 4703: @235403
     /* 235403 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235445), // Rule ID 11460 //
     /* 235408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 235435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235443 */     GIR_RootConstrainSelectedInstOperands,
     /* 235444 */     // GIR_Coverage, 11460,
     /* 235444 */     GIR_EraseRootFromParent_Done,
     /* 235445 */   // Label 4704: @235445
     /* 235445 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235487), // Rule ID 11461 //
     /* 235450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2029:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 235477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235485 */     GIR_RootConstrainSelectedInstOperands,
     /* 235486 */     // GIR_Coverage, 11461,
     /* 235486 */     GIR_EraseRootFromParent_Done,
     /* 235487 */   // Label 4705: @235487
     /* 235487 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235529), // Rule ID 11462 //
     /* 235492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2029:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 235519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235527 */     GIR_RootConstrainSelectedInstOperands,
     /* 235528 */     // GIR_Coverage, 11462,
     /* 235528 */     GIR_EraseRootFromParent_Done,
     /* 235529 */   // Label 4706: @235529
     /* 235529 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235571), // Rule ID 11463 //
     /* 235534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235558 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2029:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 235561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235569 */     GIR_RootConstrainSelectedInstOperands,
     /* 235570 */     // GIR_Coverage, 11463,
     /* 235570 */     GIR_EraseRootFromParent_Done,
     /* 235571 */   // Label 4707: @235571
     /* 235571 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235613), // Rule ID 11464 //
     /* 235576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235600 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2029:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 235603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235611 */     GIR_RootConstrainSelectedInstOperands,
     /* 235612 */     // GIR_Coverage, 11464,
     /* 235612 */     GIR_EraseRootFromParent_Done,
     /* 235613 */   // Label 4708: @235613
     /* 235613 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(235655), // Rule ID 11465 //
     /* 235618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 235645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235653 */     GIR_RootConstrainSelectedInstOperands,
     /* 235654 */     // GIR_Coverage, 11465,
     /* 235654 */     GIR_EraseRootFromParent_Done,
     /* 235655 */   // Label 4709: @235655
     /* 235655 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(235697), // Rule ID 11466 //
     /* 235660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 235687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235695 */     GIR_RootConstrainSelectedInstOperands,
     /* 235696 */     // GIR_Coverage, 11466,
     /* 235696 */     GIR_EraseRootFromParent_Done,
     /* 235697 */   // Label 4710: @235697
     /* 235697 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(235739), // Rule ID 11467 //
     /* 235702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 235729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235737 */     GIR_RootConstrainSelectedInstOperands,
     /* 235738 */     // GIR_Coverage, 11467,
     /* 235738 */     GIR_EraseRootFromParent_Done,
     /* 235739 */   // Label 4711: @235739
     /* 235739 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(235781), // Rule ID 11468 //
     /* 235744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 235752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 235771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235779 */     GIR_RootConstrainSelectedInstOperands,
     /* 235780 */     // GIR_Coverage, 11468,
     /* 235780 */     GIR_EraseRootFromParent_Done,
     /* 235781 */   // Label 4712: @235781
     /* 235781 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(235823), // Rule ID 11469 //
     /* 235786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2034:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 235813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235821 */     GIR_RootConstrainSelectedInstOperands,
     /* 235822 */     // GIR_Coverage, 11469,
     /* 235822 */     GIR_EraseRootFromParent_Done,
     /* 235823 */   // Label 4713: @235823
     /* 235823 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(235865), // Rule ID 11470 //
     /* 235828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2034:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 235855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235863 */     GIR_RootConstrainSelectedInstOperands,
     /* 235864 */     // GIR_Coverage, 11470,
     /* 235864 */     GIR_EraseRootFromParent_Done,
     /* 235865 */   // Label 4714: @235865
     /* 235865 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(235907), // Rule ID 11471 //
     /* 235870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 235897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235905 */     GIR_RootConstrainSelectedInstOperands,
     /* 235906 */     // GIR_Coverage, 11471,
     /* 235906 */     GIR_EraseRootFromParent_Done,
     /* 235907 */   // Label 4715: @235907
     /* 235907 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(235949), // Rule ID 11472 //
     /* 235912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 235920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2034:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 235939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235947 */     GIR_RootConstrainSelectedInstOperands,
     /* 235948 */     // GIR_Coverage, 11472,
     /* 235948 */     GIR_EraseRootFromParent_Done,
     /* 235949 */   // Label 4716: @235949
     /* 235949 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(235991), // Rule ID 11473 //
     /* 235954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 235962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235978 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1827:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 235981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235989 */     GIR_RootConstrainSelectedInstOperands,
     /* 235990 */     // GIR_Coverage, 11473,
     /* 235990 */     GIR_EraseRootFromParent_Done,
     /* 235991 */   // Label 4717: @235991
     /* 235991 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236033), // Rule ID 11474 //
     /* 235996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 236023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236031 */     GIR_RootConstrainSelectedInstOperands,
     /* 236032 */     // GIR_Coverage, 11474,
     /* 236032 */     GIR_EraseRootFromParent_Done,
     /* 236033 */   // Label 4718: @236033
     /* 236033 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236075), // Rule ID 11475 //
     /* 236038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 236065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236073 */     GIR_RootConstrainSelectedInstOperands,
     /* 236074 */     // GIR_Coverage, 11475,
     /* 236074 */     GIR_EraseRootFromParent_Done,
     /* 236075 */   // Label 4719: @236075
     /* 236075 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236117), // Rule ID 11476 //
     /* 236080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 236107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236115 */     GIR_RootConstrainSelectedInstOperands,
     /* 236116 */     // GIR_Coverage, 11476,
     /* 236116 */     GIR_EraseRootFromParent_Done,
     /* 236117 */   // Label 4720: @236117
     /* 236117 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236159), // Rule ID 11477 //
     /* 236122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236146 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2023:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 236149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236157 */     GIR_RootConstrainSelectedInstOperands,
     /* 236158 */     // GIR_Coverage, 11477,
     /* 236158 */     GIR_EraseRootFromParent_Done,
     /* 236159 */   // Label 4721: @236159
     /* 236159 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236201), // Rule ID 11478 //
     /* 236164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236188 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2023:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 236191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236199 */     GIR_RootConstrainSelectedInstOperands,
     /* 236200 */     // GIR_Coverage, 11478,
     /* 236200 */     GIR_EraseRootFromParent_Done,
     /* 236201 */   // Label 4722: @236201
     /* 236201 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236243), // Rule ID 11479 //
     /* 236206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2023:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 236233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236241 */     GIR_RootConstrainSelectedInstOperands,
     /* 236242 */     // GIR_Coverage, 11479,
     /* 236242 */     GIR_EraseRootFromParent_Done,
     /* 236243 */   // Label 4723: @236243
     /* 236243 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(236285), // Rule ID 11480 //
     /* 236248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2023:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 236275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236283 */     GIR_RootConstrainSelectedInstOperands,
     /* 236284 */     // GIR_Coverage, 11480,
     /* 236284 */     GIR_EraseRootFromParent_Done,
     /* 236285 */   // Label 4724: @236285
     /* 236285 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(236327), // Rule ID 11481 //
     /* 236290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236314 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1814:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 236317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236325 */     GIR_RootConstrainSelectedInstOperands,
     /* 236326 */     // GIR_Coverage, 11481,
     /* 236326 */     GIR_EraseRootFromParent_Done,
     /* 236327 */   // Label 4725: @236327
     /* 236327 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(236369), // Rule ID 11482 //
     /* 236332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1814:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 236359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236367 */     GIR_RootConstrainSelectedInstOperands,
     /* 236368 */     // GIR_Coverage, 11482,
     /* 236368 */     GIR_EraseRootFromParent_Done,
     /* 236369 */   // Label 4726: @236369
     /* 236369 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(236411), // Rule ID 11483 //
     /* 236374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 236401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236409 */     GIR_RootConstrainSelectedInstOperands,
     /* 236410 */     // GIR_Coverage, 11483,
     /* 236410 */     GIR_EraseRootFromParent_Done,
     /* 236411 */   // Label 4727: @236411
     /* 236411 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236453), // Rule ID 11484 //
     /* 236416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 236443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236451 */     GIR_RootConstrainSelectedInstOperands,
     /* 236452 */     // GIR_Coverage, 11484,
     /* 236452 */     GIR_EraseRootFromParent_Done,
     /* 236453 */   // Label 4728: @236453
     /* 236453 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236495), // Rule ID 11485 //
     /* 236458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2016:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 236485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236493 */     GIR_RootConstrainSelectedInstOperands,
     /* 236494 */     // GIR_Coverage, 11485,
     /* 236494 */     GIR_EraseRootFromParent_Done,
     /* 236495 */   // Label 4729: @236495
     /* 236495 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236537), // Rule ID 11486 //
     /* 236500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2016:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 236527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236535 */     GIR_RootConstrainSelectedInstOperands,
     /* 236536 */     // GIR_Coverage, 11486,
     /* 236536 */     GIR_EraseRootFromParent_Done,
     /* 236537 */   // Label 4730: @236537
     /* 236537 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236579), // Rule ID 11487 //
     /* 236542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2016:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 236569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236577 */     GIR_RootConstrainSelectedInstOperands,
     /* 236578 */     // GIR_Coverage, 11487,
     /* 236578 */     GIR_EraseRootFromParent_Done,
     /* 236579 */   // Label 4731: @236579
     /* 236579 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236621), // Rule ID 11488 //
     /* 236584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 236592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2016:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 236611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236619 */     GIR_RootConstrainSelectedInstOperands,
     /* 236620 */     // GIR_Coverage, 11488,
     /* 236620 */     GIR_EraseRootFromParent_Done,
     /* 236621 */   // Label 4732: @236621
     /* 236621 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236663), // Rule ID 11651 //
     /* 236626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1916:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 236653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236661 */     GIR_RootConstrainSelectedInstOperands,
     /* 236662 */     // GIR_Coverage, 11651,
     /* 236662 */     GIR_EraseRootFromParent_Done,
     /* 236663 */   // Label 4733: @236663
     /* 236663 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(236705), // Rule ID 11653 //
     /* 236668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 236695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236703 */     GIR_RootConstrainSelectedInstOperands,
     /* 236704 */     // GIR_Coverage, 11653,
     /* 236704 */     GIR_EraseRootFromParent_Done,
     /* 236705 */   // Label 4734: @236705
     /* 236705 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(236747), // Rule ID 11655 //
     /* 236710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 236737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236745 */     GIR_RootConstrainSelectedInstOperands,
     /* 236746 */     // GIR_Coverage, 11655,
     /* 236746 */     GIR_EraseRootFromParent_Done,
     /* 236747 */   // Label 4735: @236747
     /* 236747 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(236789), // Rule ID 11657 //
     /* 236752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 236760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 236779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236787 */     GIR_RootConstrainSelectedInstOperands,
     /* 236788 */     // GIR_Coverage, 11657,
     /* 236788 */     GIR_EraseRootFromParent_Done,
     /* 236789 */   // Label 4736: @236789
     /* 236789 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(236831), // Rule ID 11659 //
     /* 236794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1668:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 236821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236829 */     GIR_RootConstrainSelectedInstOperands,
     /* 236830 */     // GIR_Coverage, 11659,
     /* 236830 */     GIR_EraseRootFromParent_Done,
     /* 236831 */   // Label 4737: @236831
     /* 236831 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(236873), // Rule ID 11660 //
     /* 236836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1668:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 236863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236871 */     GIR_RootConstrainSelectedInstOperands,
     /* 236872 */     // GIR_Coverage, 11660,
     /* 236872 */     GIR_EraseRootFromParent_Done,
     /* 236873 */   // Label 4738: @236873
     /* 236873 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(236915), // Rule ID 11661 //
     /* 236878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 236886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1668:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 236905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236913 */     GIR_RootConstrainSelectedInstOperands,
     /* 236914 */     // GIR_Coverage, 11661,
     /* 236914 */     GIR_EraseRootFromParent_Done,
     /* 236915 */   // Label 4739: @236915
     /* 236915 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(236957), // Rule ID 11662 //
     /* 236920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 236928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 236947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236955 */     GIR_RootConstrainSelectedInstOperands,
     /* 236956 */     // GIR_Coverage, 11662,
     /* 236956 */     GIR_EraseRootFromParent_Done,
     /* 236957 */   // Label 4740: @236957
     /* 236957 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(236999), // Rule ID 11663 //
     /* 236962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 236970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 236989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236997 */     GIR_RootConstrainSelectedInstOperands,
     /* 236998 */     // GIR_Coverage, 11663,
     /* 236998 */     GIR_EraseRootFromParent_Done,
     /* 236999 */   // Label 4741: @236999
     /* 236999 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237041), // Rule ID 11664 //
     /* 237004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237028 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 237031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237039 */     GIR_RootConstrainSelectedInstOperands,
     /* 237040 */     // GIR_Coverage, 11664,
     /* 237040 */     GIR_EraseRootFromParent_Done,
     /* 237041 */   // Label 4742: @237041
     /* 237041 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237083), // Rule ID 11665 //
     /* 237046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 237073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237081 */     GIR_RootConstrainSelectedInstOperands,
     /* 237082 */     // GIR_Coverage, 11665,
     /* 237082 */     GIR_EraseRootFromParent_Done,
     /* 237083 */   // Label 4743: @237083
     /* 237083 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237125), // Rule ID 11666 //
     /* 237088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 237115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237123 */     GIR_RootConstrainSelectedInstOperands,
     /* 237124 */     // GIR_Coverage, 11666,
     /* 237124 */     GIR_EraseRootFromParent_Done,
     /* 237125 */   // Label 4744: @237125
     /* 237125 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237167), // Rule ID 11667 //
     /* 237130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 237157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237165 */     GIR_RootConstrainSelectedInstOperands,
     /* 237166 */     // GIR_Coverage, 11667,
     /* 237166 */     GIR_EraseRootFromParent_Done,
     /* 237167 */   // Label 4745: @237167
     /* 237167 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237209), // Rule ID 11668 //
     /* 237172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1231:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 237199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237207 */     GIR_RootConstrainSelectedInstOperands,
     /* 237208 */     // GIR_Coverage, 11668,
     /* 237208 */     GIR_EraseRootFromParent_Done,
     /* 237209 */   // Label 4746: @237209
     /* 237209 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(237251), // Rule ID 11669 //
     /* 237214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1231:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 237241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237249 */     GIR_RootConstrainSelectedInstOperands,
     /* 237250 */     // GIR_Coverage, 11669,
     /* 237250 */     GIR_EraseRootFromParent_Done,
     /* 237251 */   // Label 4747: @237251
     /* 237251 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(237293), // Rule ID 11670 //
     /* 237256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 237283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237291 */     GIR_RootConstrainSelectedInstOperands,
     /* 237292 */     // GIR_Coverage, 11670,
     /* 237292 */     GIR_EraseRootFromParent_Done,
     /* 237293 */   // Label 4748: @237293
     /* 237293 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237335), // Rule ID 11671 //
     /* 237298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237322 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 237325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237333 */     GIR_RootConstrainSelectedInstOperands,
     /* 237334 */     // GIR_Coverage, 11671,
     /* 237334 */     GIR_EraseRootFromParent_Done,
     /* 237335 */   // Label 4749: @237335
     /* 237335 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237377), // Rule ID 11672 //
     /* 237340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 237367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237375 */     GIR_RootConstrainSelectedInstOperands,
     /* 237376 */     // GIR_Coverage, 11672,
     /* 237376 */     GIR_EraseRootFromParent_Done,
     /* 237377 */   // Label 4750: @237377
     /* 237377 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237419), // Rule ID 11673 //
     /* 237382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 237409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237417 */     GIR_RootConstrainSelectedInstOperands,
     /* 237418 */     // GIR_Coverage, 11673,
     /* 237418 */     GIR_EraseRootFromParent_Done,
     /* 237419 */   // Label 4751: @237419
     /* 237419 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237461), // Rule ID 11728 //
     /* 237424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237448 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1649:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 237451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237459 */     GIR_RootConstrainSelectedInstOperands,
     /* 237460 */     // GIR_Coverage, 11728,
     /* 237460 */     GIR_EraseRootFromParent_Done,
     /* 237461 */   // Label 4752: @237461
     /* 237461 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237503), // Rule ID 11729 //
     /* 237466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 237493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237501 */     GIR_RootConstrainSelectedInstOperands,
     /* 237502 */     // GIR_Coverage, 11729,
     /* 237502 */     GIR_EraseRootFromParent_Done,
     /* 237503 */   // Label 4753: @237503
     /* 237503 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237545), // Rule ID 11730 //
     /* 237508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 237535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237543 */     GIR_RootConstrainSelectedInstOperands,
     /* 237544 */     // GIR_Coverage, 11730,
     /* 237544 */     GIR_EraseRootFromParent_Done,
     /* 237545 */   // Label 4754: @237545
     /* 237545 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237587), // Rule ID 11731 //
     /* 237550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237574 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1890:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 237577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237585 */     GIR_RootConstrainSelectedInstOperands,
     /* 237586 */     // GIR_Coverage, 11731,
     /* 237586 */     GIR_EraseRootFromParent_Done,
     /* 237587 */   // Label 4755: @237587
     /* 237587 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237629), // Rule ID 11732 //
     /* 237592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1890:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 237619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237627 */     GIR_RootConstrainSelectedInstOperands,
     /* 237628 */     // GIR_Coverage, 11732,
     /* 237628 */     GIR_EraseRootFromParent_Done,
     /* 237629 */   // Label 4756: @237629
     /* 237629 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(237671), // Rule ID 11733 //
     /* 237634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 237642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 237661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237669 */     GIR_RootConstrainSelectedInstOperands,
     /* 237670 */     // GIR_Coverage, 11733,
     /* 237670 */     GIR_EraseRootFromParent_Done,
     /* 237671 */   // Label 4757: @237671
     /* 237671 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(237713), // Rule ID 11734 //
     /* 237676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237700 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 237703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237711 */     GIR_RootConstrainSelectedInstOperands,
     /* 237712 */     // GIR_Coverage, 11734,
     /* 237712 */     GIR_EraseRootFromParent_Done,
     /* 237713 */   // Label 4758: @237713
     /* 237713 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(237755), // Rule ID 11735 //
     /* 237718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 237745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237753 */     GIR_RootConstrainSelectedInstOperands,
     /* 237754 */     // GIR_Coverage, 11735,
     /* 237754 */     GIR_EraseRootFromParent_Done,
     /* 237755 */   // Label 4759: @237755
     /* 237755 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(237797), // Rule ID 11736 //
     /* 237760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 237768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 237787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237795 */     GIR_RootConstrainSelectedInstOperands,
     /* 237796 */     // GIR_Coverage, 11736,
     /* 237796 */     GIR_EraseRootFromParent_Done,
     /* 237797 */   // Label 4760: @237797
     /* 237797 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(237842), // Rule ID 11749 //
     /* 237802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237826 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 237829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237840 */     GIR_RootConstrainSelectedInstOperands,
     /* 237841 */     // GIR_Coverage, 11749,
     /* 237841 */     GIR_EraseRootFromParent_Done,
     /* 237842 */   // Label 4761: @237842
     /* 237842 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(237887), // Rule ID 11750 //
     /* 237847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 237850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 237855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 237871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 237874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 237885 */     GIR_RootConstrainSelectedInstOperands,
     /* 237886 */     // GIR_Coverage, 11750,
     /* 237886 */     GIR_EraseRootFromParent_Done,
     /* 237887 */   // Label 4762: @237887
     /* 237887 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(237929), // Rule ID 11751 //
     /* 237892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237916 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 237919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237927 */     GIR_RootConstrainSelectedInstOperands,
     /* 237928 */     // GIR_Coverage, 11751,
     /* 237928 */     GIR_EraseRootFromParent_Done,
     /* 237929 */   // Label 4763: @237929
     /* 237929 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(237971), // Rule ID 11752 //
     /* 237934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237958 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 237961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237969 */     GIR_RootConstrainSelectedInstOperands,
     /* 237970 */     // GIR_Coverage, 11752,
     /* 237970 */     GIR_EraseRootFromParent_Done,
     /* 237971 */   // Label 4764: @237971
     /* 237971 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238013), // Rule ID 11753 //
     /* 237976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 237984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 238003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238009 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238011 */     GIR_RootConstrainSelectedInstOperands,
     /* 238012 */     // GIR_Coverage, 11753,
     /* 238012 */     GIR_EraseRootFromParent_Done,
     /* 238013 */   // Label 4765: @238013
     /* 238013 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238055), // Rule ID 11754 //
     /* 238018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 238045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238053 */     GIR_RootConstrainSelectedInstOperands,
     /* 238054 */     // GIR_Coverage, 11754,
     /* 238054 */     GIR_EraseRootFromParent_Done,
     /* 238055 */   // Label 4766: @238055
     /* 238055 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238097), // Rule ID 11770 //
     /* 238060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238084 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1423:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 238087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238093 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238095 */     GIR_RootConstrainSelectedInstOperands,
     /* 238096 */     // GIR_Coverage, 11770,
     /* 238096 */     GIR_EraseRootFromParent_Done,
     /* 238097 */   // Label 4767: @238097
     /* 238097 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238139), // Rule ID 11771 //
     /* 238102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238126 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1423:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 238129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238137 */     GIR_RootConstrainSelectedInstOperands,
     /* 238138 */     // GIR_Coverage, 11771,
     /* 238138 */     GIR_EraseRootFromParent_Done,
     /* 238139 */   // Label 4768: @238139
     /* 238139 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238181), // Rule ID 11772 //
     /* 238144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238168 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1423:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 238171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238179 */     GIR_RootConstrainSelectedInstOperands,
     /* 238180 */     // GIR_Coverage, 11772,
     /* 238180 */     GIR_EraseRootFromParent_Done,
     /* 238181 */   // Label 4769: @238181
     /* 238181 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238223), // Rule ID 11773 //
     /* 238186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238210 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 238213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238219 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238221 */     GIR_RootConstrainSelectedInstOperands,
     /* 238222 */     // GIR_Coverage, 11773,
     /* 238222 */     GIR_EraseRootFromParent_Done,
     /* 238223 */   // Label 4770: @238223
     /* 238223 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238265), // Rule ID 11774 //
     /* 238228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 238255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238263 */     GIR_RootConstrainSelectedInstOperands,
     /* 238264 */     // GIR_Coverage, 11774,
     /* 238264 */     GIR_EraseRootFromParent_Done,
     /* 238265 */   // Label 4771: @238265
     /* 238265 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238307), // Rule ID 11775 //
     /* 238270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238294 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 238297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238305 */     GIR_RootConstrainSelectedInstOperands,
     /* 238306 */     // GIR_Coverage, 11775,
     /* 238306 */     GIR_EraseRootFromParent_Done,
     /* 238307 */   // Label 4772: @238307
     /* 238307 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238349), // Rule ID 11776 //
     /* 238312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238336 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 238339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238347 */     GIR_RootConstrainSelectedInstOperands,
     /* 238348 */     // GIR_Coverage, 11776,
     /* 238348 */     GIR_EraseRootFromParent_Done,
     /* 238349 */   // Label 4773: @238349
     /* 238349 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238391), // Rule ID 11777 //
     /* 238354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238378 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 238381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238389 */     GIR_RootConstrainSelectedInstOperands,
     /* 238390 */     // GIR_Coverage, 11777,
     /* 238390 */     GIR_EraseRootFromParent_Done,
     /* 238391 */   // Label 4774: @238391
     /* 238391 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238433), // Rule ID 11778 //
     /* 238396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238420 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 238423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238431 */     GIR_RootConstrainSelectedInstOperands,
     /* 238432 */     // GIR_Coverage, 11778,
     /* 238432 */     GIR_EraseRootFromParent_Done,
     /* 238433 */   // Label 4775: @238433
     /* 238433 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238475), // Rule ID 11779 //
     /* 238438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238462 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 238465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238473 */     GIR_RootConstrainSelectedInstOperands,
     /* 238474 */     // GIR_Coverage, 11779,
     /* 238474 */     GIR_EraseRootFromParent_Done,
     /* 238475 */   // Label 4776: @238475
     /* 238475 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238517), // Rule ID 11780 //
     /* 238480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238504 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 238507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238515 */     GIR_RootConstrainSelectedInstOperands,
     /* 238516 */     // GIR_Coverage, 11780,
     /* 238516 */     GIR_EraseRootFromParent_Done,
     /* 238517 */   // Label 4777: @238517
     /* 238517 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238559), // Rule ID 11781 //
     /* 238522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238546 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 238549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238555 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238557 */     GIR_RootConstrainSelectedInstOperands,
     /* 238558 */     // GIR_Coverage, 11781,
     /* 238558 */     GIR_EraseRootFromParent_Done,
     /* 238559 */   // Label 4778: @238559
     /* 238559 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238601), // Rule ID 11786 //
     /* 238564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 238572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238588 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 238591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238597 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238599 */     GIR_RootConstrainSelectedInstOperands,
     /* 238600 */     // GIR_Coverage, 11786,
     /* 238600 */     GIR_EraseRootFromParent_Done,
     /* 238601 */   // Label 4779: @238601
     /* 238601 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238643), // Rule ID 11787 //
     /* 238606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 238614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238630 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1452:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 238633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238641 */     GIR_RootConstrainSelectedInstOperands,
     /* 238642 */     // GIR_Coverage, 11787,
     /* 238642 */     GIR_EraseRootFromParent_Done,
     /* 238643 */   // Label 4780: @238643
     /* 238643 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238685), // Rule ID 11788 //
     /* 238648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 238656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238672 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1457:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 238675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238683 */     GIR_RootConstrainSelectedInstOperands,
     /* 238684 */     // GIR_Coverage, 11788,
     /* 238684 */     GIR_EraseRootFromParent_Done,
     /* 238685 */   // Label 4781: @238685
     /* 238685 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238727), // Rule ID 11789 //
     /* 238690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 238698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238714 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 238717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238725 */     GIR_RootConstrainSelectedInstOperands,
     /* 238726 */     // GIR_Coverage, 11789,
     /* 238726 */     GIR_EraseRootFromParent_Done,
     /* 238727 */   // Label 4782: @238727
     /* 238727 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(238769), // Rule ID 11790 //
     /* 238732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238765 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238767 */     GIR_RootConstrainSelectedInstOperands,
     /* 238768 */     // GIR_Coverage, 11790,
     /* 238768 */     GIR_EraseRootFromParent_Done,
     /* 238769 */   // Label 4783: @238769
     /* 238769 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(238811), // Rule ID 11792 //
     /* 238774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238809 */     GIR_RootConstrainSelectedInstOperands,
     /* 238810 */     // GIR_Coverage, 11792,
     /* 238810 */     GIR_EraseRootFromParent_Done,
     /* 238811 */   // Label 4784: @238811
     /* 238811 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(238853), // Rule ID 11794 //
     /* 238816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238851 */     GIR_RootConstrainSelectedInstOperands,
     /* 238852 */     // GIR_Coverage, 11794,
     /* 238852 */     GIR_EraseRootFromParent_Done,
     /* 238853 */   // Label 4785: @238853
     /* 238853 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(238895), // Rule ID 11796 //
     /* 238858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 238866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 238885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238893 */     GIR_RootConstrainSelectedInstOperands,
     /* 238894 */     // GIR_Coverage, 11796,
     /* 238894 */     GIR_EraseRootFromParent_Done,
     /* 238895 */   // Label 4786: @238895
     /* 238895 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(238937), // Rule ID 11798 //
     /* 238900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238924 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1286:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238935 */     GIR_RootConstrainSelectedInstOperands,
     /* 238936 */     // GIR_Coverage, 11798,
     /* 238936 */     GIR_EraseRootFromParent_Done,
     /* 238937 */   // Label 4787: @238937
     /* 238937 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(238979), // Rule ID 11800 //
     /* 238942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1286:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 238969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238977 */     GIR_RootConstrainSelectedInstOperands,
     /* 238978 */     // GIR_Coverage, 11800,
     /* 238978 */     GIR_EraseRootFromParent_Done,
     /* 238979 */   // Label 4788: @238979
     /* 238979 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239021), // Rule ID 11802 //
     /* 238984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 238992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239008 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1286:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239017 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239019 */     GIR_RootConstrainSelectedInstOperands,
     /* 239020 */     // GIR_Coverage, 11802,
     /* 239020 */     GIR_EraseRootFromParent_Done,
     /* 239021 */   // Label 4789: @239021
     /* 239021 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239063), // Rule ID 11804 //
     /* 239026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1286:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239059 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239061 */     GIR_RootConstrainSelectedInstOperands,
     /* 239062 */     // GIR_Coverage, 11804,
     /* 239062 */     GIR_EraseRootFromParent_Done,
     /* 239063 */   // Label 4790: @239063
     /* 239063 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239105), // Rule ID 11806 //
     /* 239068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239092 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1287:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239103 */     GIR_RootConstrainSelectedInstOperands,
     /* 239104 */     // GIR_Coverage, 11806,
     /* 239104 */     GIR_EraseRootFromParent_Done,
     /* 239105 */   // Label 4791: @239105
     /* 239105 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239147), // Rule ID 11807 //
     /* 239110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1287:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239145 */     GIR_RootConstrainSelectedInstOperands,
     /* 239146 */     // GIR_Coverage, 11807,
     /* 239146 */     GIR_EraseRootFromParent_Done,
     /* 239147 */   // Label 4792: @239147
     /* 239147 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239189), // Rule ID 11808 //
     /* 239152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1287:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239185 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239187 */     GIR_RootConstrainSelectedInstOperands,
     /* 239188 */     // GIR_Coverage, 11808,
     /* 239188 */     GIR_EraseRootFromParent_Done,
     /* 239189 */   // Label 4793: @239189
     /* 239189 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239231), // Rule ID 11809 //
     /* 239194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1287:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239229 */     GIR_RootConstrainSelectedInstOperands,
     /* 239230 */     // GIR_Coverage, 11809,
     /* 239230 */     GIR_EraseRootFromParent_Done,
     /* 239231 */   // Label 4794: @239231
     /* 239231 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239273), // Rule ID 11810 //
     /* 239236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1288:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239271 */     GIR_RootConstrainSelectedInstOperands,
     /* 239272 */     // GIR_Coverage, 11810,
     /* 239272 */     GIR_EraseRootFromParent_Done,
     /* 239273 */   // Label 4795: @239273
     /* 239273 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239315), // Rule ID 11811 //
     /* 239278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1288:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239313 */     GIR_RootConstrainSelectedInstOperands,
     /* 239314 */     // GIR_Coverage, 11811,
     /* 239314 */     GIR_EraseRootFromParent_Done,
     /* 239315 */   // Label 4796: @239315
     /* 239315 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239357), // Rule ID 11812 //
     /* 239320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1288:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239355 */     GIR_RootConstrainSelectedInstOperands,
     /* 239356 */     // GIR_Coverage, 11812,
     /* 239356 */     GIR_EraseRootFromParent_Done,
     /* 239357 */   // Label 4797: @239357
     /* 239357 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239399), // Rule ID 11813 //
     /* 239362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1288:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239397 */     GIR_RootConstrainSelectedInstOperands,
     /* 239398 */     // GIR_Coverage, 11813,
     /* 239398 */     GIR_EraseRootFromParent_Done,
     /* 239399 */   // Label 4798: @239399
     /* 239399 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239441), // Rule ID 11814 //
     /* 239404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1598:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239439 */     GIR_RootConstrainSelectedInstOperands,
     /* 239440 */     // GIR_Coverage, 11814,
     /* 239440 */     GIR_EraseRootFromParent_Done,
     /* 239441 */   // Label 4799: @239441
     /* 239441 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239483), // Rule ID 11816 //
     /* 239446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1598:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239479 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239481 */     GIR_RootConstrainSelectedInstOperands,
     /* 239482 */     // GIR_Coverage, 11816,
     /* 239482 */     GIR_EraseRootFromParent_Done,
     /* 239483 */   // Label 4800: @239483
     /* 239483 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239525), // Rule ID 11818 //
     /* 239488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1598:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239523 */     GIR_RootConstrainSelectedInstOperands,
     /* 239524 */     // GIR_Coverage, 11818,
     /* 239524 */     GIR_EraseRootFromParent_Done,
     /* 239525 */   // Label 4801: @239525
     /* 239525 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239567), // Rule ID 11820 //
     /* 239530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1598:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239565 */     GIR_RootConstrainSelectedInstOperands,
     /* 239566 */     // GIR_Coverage, 11820,
     /* 239566 */     GIR_EraseRootFromParent_Done,
     /* 239567 */   // Label 4802: @239567
     /* 239567 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239609), // Rule ID 11909 //
     /* 239572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239596 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 239599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239607 */     GIR_RootConstrainSelectedInstOperands,
     /* 239608 */     // GIR_Coverage, 11909,
     /* 239608 */     GIR_EraseRootFromParent_Done,
     /* 239609 */   // Label 4803: @239609
     /* 239609 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239651), // Rule ID 11911 //
     /* 239614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 239641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239647 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239649 */     GIR_RootConstrainSelectedInstOperands,
     /* 239650 */     // GIR_Coverage, 11911,
     /* 239650 */     GIR_EraseRootFromParent_Done,
     /* 239651 */   // Label 4804: @239651
     /* 239651 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239693), // Rule ID 11913 //
     /* 239656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 239683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239689 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239691 */     GIR_RootConstrainSelectedInstOperands,
     /* 239692 */     // GIR_Coverage, 11913,
     /* 239692 */     GIR_EraseRootFromParent_Done,
     /* 239693 */   // Label 4805: @239693
     /* 239693 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239735), // Rule ID 11915 //
     /* 239698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 239706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 239725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239731 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239733 */     GIR_RootConstrainSelectedInstOperands,
     /* 239734 */     // GIR_Coverage, 11915,
     /* 239734 */     GIR_EraseRootFromParent_Done,
     /* 239735 */   // Label 4806: @239735
     /* 239735 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(239777), // Rule ID 11917 //
     /* 239740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 239748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239764 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1407:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 239767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239775 */     GIR_RootConstrainSelectedInstOperands,
     /* 239776 */     // GIR_Coverage, 11917,
     /* 239776 */     GIR_EraseRootFromParent_Done,
     /* 239777 */   // Label 4807: @239777
     /* 239777 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(239819), // Rule ID 11919 //
     /* 239782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 239790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 239809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239817 */     GIR_RootConstrainSelectedInstOperands,
     /* 239818 */     // GIR_Coverage, 11919,
     /* 239818 */     GIR_EraseRootFromParent_Done,
     /* 239819 */   // Label 4808: @239819
     /* 239819 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(239861), // Rule ID 12082 //
     /* 239824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239848 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 239851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239859 */     GIR_RootConstrainSelectedInstOperands,
     /* 239860 */     // GIR_Coverage, 12082,
     /* 239860 */     GIR_EraseRootFromParent_Done,
     /* 239861 */   // Label 4809: @239861
     /* 239861 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(239903), // Rule ID 12083 //
     /* 239866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 239893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239901 */     GIR_RootConstrainSelectedInstOperands,
     /* 239902 */     // GIR_Coverage, 12083,
     /* 239902 */     GIR_EraseRootFromParent_Done,
     /* 239903 */   // Label 4810: @239903
     /* 239903 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(239945), // Rule ID 12084 //
     /* 239908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 239935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239943 */     GIR_RootConstrainSelectedInstOperands,
     /* 239944 */     // GIR_Coverage, 12084,
     /* 239944 */     GIR_EraseRootFromParent_Done,
     /* 239945 */   // Label 4811: @239945
     /* 239945 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(239987), // Rule ID 12085 //
     /* 239950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 239958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 239977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239985 */     GIR_RootConstrainSelectedInstOperands,
     /* 239986 */     // GIR_Coverage, 12085,
     /* 239986 */     GIR_EraseRootFromParent_Done,
     /* 239987 */   // Label 4812: @239987
     /* 239987 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240029), // Rule ID 12086 //
     /* 239992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 239995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240016 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1905:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 240019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240027 */     GIR_RootConstrainSelectedInstOperands,
     /* 240028 */     // GIR_Coverage, 12086,
     /* 240028 */     GIR_EraseRootFromParent_Done,
     /* 240029 */   // Label 4813: @240029
     /* 240029 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240071), // Rule ID 12087 //
     /* 240034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1905:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 240061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240069 */     GIR_RootConstrainSelectedInstOperands,
     /* 240070 */     // GIR_Coverage, 12087,
     /* 240070 */     GIR_EraseRootFromParent_Done,
     /* 240071 */   // Label 4814: @240071
     /* 240071 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240113), // Rule ID 12088 //
     /* 240076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1905:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240111 */     GIR_RootConstrainSelectedInstOperands,
     /* 240112 */     // GIR_Coverage, 12088,
     /* 240112 */     GIR_EraseRootFromParent_Done,
     /* 240113 */   // Label 4815: @240113
     /* 240113 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240155), // Rule ID 12433 //
     /* 240118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240142 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1357:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 240145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240151 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240153 */     GIR_RootConstrainSelectedInstOperands,
     /* 240154 */     // GIR_Coverage, 12433,
     /* 240154 */     GIR_EraseRootFromParent_Done,
     /* 240155 */   // Label 4816: @240155
     /* 240155 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240197), // Rule ID 12434 //
     /* 240160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240184 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1357:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 240187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240193 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240195 */     GIR_RootConstrainSelectedInstOperands,
     /* 240196 */     // GIR_Coverage, 12434,
     /* 240196 */     GIR_EraseRootFromParent_Done,
     /* 240197 */   // Label 4817: @240197
     /* 240197 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240239), // Rule ID 12435 //
     /* 240202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240226 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1357:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 240229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240237 */     GIR_RootConstrainSelectedInstOperands,
     /* 240238 */     // GIR_Coverage, 12435,
     /* 240238 */     GIR_EraseRootFromParent_Done,
     /* 240239 */   // Label 4818: @240239
     /* 240239 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240281), // Rule ID 12436 //
     /* 240244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240268 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 240271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240279 */     GIR_RootConstrainSelectedInstOperands,
     /* 240280 */     // GIR_Coverage, 12436,
     /* 240280 */     GIR_EraseRootFromParent_Done,
     /* 240281 */   // Label 4819: @240281
     /* 240281 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240323), // Rule ID 12437 //
     /* 240286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240310 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 240313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240321 */     GIR_RootConstrainSelectedInstOperands,
     /* 240322 */     // GIR_Coverage, 12437,
     /* 240322 */     GIR_EraseRootFromParent_Done,
     /* 240323 */   // Label 4820: @240323
     /* 240323 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240365), // Rule ID 12438 //
     /* 240328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240352 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 240355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240363 */     GIR_RootConstrainSelectedInstOperands,
     /* 240364 */     // GIR_Coverage, 12438,
     /* 240364 */     GIR_EraseRootFromParent_Done,
     /* 240365 */   // Label 4821: @240365
     /* 240365 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240407), // Rule ID 12439 //
     /* 240370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240394 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1356:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240405 */     GIR_RootConstrainSelectedInstOperands,
     /* 240406 */     // GIR_Coverage, 12439,
     /* 240406 */     GIR_EraseRootFromParent_Done,
     /* 240407 */   // Label 4822: @240407
     /* 240407 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240449), // Rule ID 12442 //
     /* 240412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240436 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1356:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240447 */     GIR_RootConstrainSelectedInstOperands,
     /* 240448 */     // GIR_Coverage, 12442,
     /* 240448 */     GIR_EraseRootFromParent_Done,
     /* 240449 */   // Label 4823: @240449
     /* 240449 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240491), // Rule ID 12445 //
     /* 240454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240478 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240489 */     GIR_RootConstrainSelectedInstOperands,
     /* 240490 */     // GIR_Coverage, 12445,
     /* 240490 */     GIR_EraseRootFromParent_Done,
     /* 240491 */   // Label 4824: @240491
     /* 240491 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240533), // Rule ID 12448 //
     /* 240496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240520 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1356:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 240523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240531 */     GIR_RootConstrainSelectedInstOperands,
     /* 240532 */     // GIR_Coverage, 12448,
     /* 240532 */     GIR_EraseRootFromParent_Done,
     /* 240533 */   // Label 4825: @240533
     /* 240533 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240575), // Rule ID 12451 //
     /* 240538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240562 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 240565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240573 */     GIR_RootConstrainSelectedInstOperands,
     /* 240574 */     // GIR_Coverage, 12451,
     /* 240574 */     GIR_EraseRootFromParent_Done,
     /* 240575 */   // Label 4826: @240575
     /* 240575 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240617), // Rule ID 12454 //
     /* 240580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 240607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240613 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240615 */     GIR_RootConstrainSelectedInstOperands,
     /* 240616 */     // GIR_Coverage, 12454,
     /* 240616 */     GIR_EraseRootFromParent_Done,
     /* 240617 */   // Label 4827: @240617
     /* 240617 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240659), // Rule ID 12457 //
     /* 240622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240646 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240657 */     GIR_RootConstrainSelectedInstOperands,
     /* 240658 */     // GIR_Coverage, 12457,
     /* 240658 */     GIR_EraseRootFromParent_Done,
     /* 240659 */   // Label 4828: @240659
     /* 240659 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(240701), // Rule ID 12460 //
     /* 240664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240688 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240697 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240699 */     GIR_RootConstrainSelectedInstOperands,
     /* 240700 */     // GIR_Coverage, 12460,
     /* 240700 */     GIR_EraseRootFromParent_Done,
     /* 240701 */   // Label 4829: @240701
     /* 240701 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(240743), // Rule ID 12463 //
     /* 240706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 240717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 240723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 240726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240730 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 240730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 240733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240741 */     GIR_RootConstrainSelectedInstOperands,
     /* 240742 */     // GIR_Coverage, 12463,
     /* 240742 */     GIR_EraseRootFromParent_Done,
     /* 240743 */   // Label 4830: @240743
     /* 240743 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(240785), // Rule ID 12466 //
     /* 240748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240783 */     GIR_RootConstrainSelectedInstOperands,
     /* 240784 */     // GIR_Coverage, 12466,
     /* 240784 */     GIR_EraseRootFromParent_Done,
     /* 240785 */   // Label 4831: @240785
     /* 240785 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(240827), // Rule ID 12469 //
     /* 240790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 240801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 240807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 240810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 240814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 240817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240825 */     GIR_RootConstrainSelectedInstOperands,
     /* 240826 */     // GIR_Coverage, 12469,
     /* 240826 */     GIR_EraseRootFromParent_Done,
     /* 240827 */   // Label 4832: @240827
     /* 240827 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(240869), // Rule ID 12472 //
     /* 240832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 240840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 240859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240867 */     GIR_RootConstrainSelectedInstOperands,
     /* 240868 */     // GIR_Coverage, 12472,
     /* 240868 */     GIR_EraseRootFromParent_Done,
     /* 240869 */   // Label 4833: @240869
     /* 240869 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241012), // Rule ID 5573 //
     /* 240874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 240877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 240882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 240885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 240888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 240891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240895 */     // MIs[0] idx
     /* 240895 */     // No operand predicates
     /* 240895 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 240895 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 240898 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240902 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 240909 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 240912 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240916 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240921 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 240924 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 240928 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 240931 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240936 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240941 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 240949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 240953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 240960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 240963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 240967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 240972 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 240975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 240979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 240982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 240992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 240997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241008 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241010 */     GIR_RootConstrainSelectedInstOperands,
     /* 241011 */     // GIR_Coverage, 5573,
     /* 241011 */     GIR_EraseRootFromParent_Done,
     /* 241012 */   // Label 4834: @241012
     /* 241012 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241103), // Rule ID 5574 //
     /* 241017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 241031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241038 */     // MIs[0] idx
     /* 241038 */     // No operand predicates
     /* 241038 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241064 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241071 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241099 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241101 */     GIR_RootConstrainSelectedInstOperands,
     /* 241102 */     // GIR_Coverage, 5574,
     /* 241102 */     GIR_EraseRootFromParent_Done,
     /* 241103 */   // Label 4835: @241103
     /* 241103 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241194), // Rule ID 5575 //
     /* 241108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241129 */     // MIs[0] idx
     /* 241129 */     // No operand predicates
     /* 241129 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241129 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241132 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241136 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241155 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241158 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241162 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241190 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241192 */     GIR_RootConstrainSelectedInstOperands,
     /* 241193 */     // GIR_Coverage, 5575,
     /* 241193 */     GIR_EraseRootFromParent_Done,
     /* 241194 */   // Label 4836: @241194
     /* 241194 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241233), // Rule ID 5576 //
     /* 241199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241220 */     // MIs[0] idx
     /* 241220 */     // No operand predicates
     /* 241220 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241229 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241231 */     GIR_RootConstrainSelectedInstOperands,
     /* 241232 */     // GIR_Coverage, 5576,
     /* 241232 */     GIR_EraseRootFromParent_Done,
     /* 241233 */   // Label 4837: @241233
     /* 241233 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241376), // Rule ID 5577 //
     /* 241238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241259 */     // MIs[0] idx
     /* 241259 */     // No operand predicates
     /* 241259 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241259 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241262 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241266 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241273 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241276 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241280 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241285 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241288 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241292 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241295 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241300 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241305 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241310 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241313 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241317 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241336 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241372 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241374 */     GIR_RootConstrainSelectedInstOperands,
     /* 241375 */     // GIR_Coverage, 5577,
     /* 241375 */     GIR_EraseRootFromParent_Done,
     /* 241376 */   // Label 4838: @241376
     /* 241376 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241467), // Rule ID 5578 //
     /* 241381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241402 */     // MIs[0] idx
     /* 241402 */     // No operand predicates
     /* 241402 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241431 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241435 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241463 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241465 */     GIR_RootConstrainSelectedInstOperands,
     /* 241466 */     // GIR_Coverage, 5578,
     /* 241466 */     GIR_EraseRootFromParent_Done,
     /* 241467 */   // Label 4839: @241467
     /* 241467 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241558), // Rule ID 5579 //
     /* 241472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241493 */     // MIs[0] idx
     /* 241493 */     // No operand predicates
     /* 241493 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241493 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241496 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241500 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241554 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241556 */     GIR_RootConstrainSelectedInstOperands,
     /* 241557 */     // GIR_Coverage, 5579,
     /* 241557 */     GIR_EraseRootFromParent_Done,
     /* 241558 */   // Label 4840: @241558
     /* 241558 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241597), // Rule ID 5580 //
     /* 241563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241584 */     // MIs[0] idx
     /* 241584 */     // No operand predicates
     /* 241584 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241593 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241595 */     GIR_RootConstrainSelectedInstOperands,
     /* 241596 */     // GIR_Coverage, 5580,
     /* 241596 */     GIR_EraseRootFromParent_Done,
     /* 241597 */   // Label 4841: @241597
     /* 241597 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241740), // Rule ID 5581 //
     /* 241602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241623 */     // MIs[0] idx
     /* 241623 */     // No operand predicates
     /* 241623 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241623 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241626 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241630 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241637 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241640 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241644 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241649 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241652 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241656 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241659 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241664 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241669 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241736 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241738 */     GIR_RootConstrainSelectedInstOperands,
     /* 241739 */     // GIR_Coverage, 5581,
     /* 241739 */     GIR_EraseRootFromParent_Done,
     /* 241740 */   // Label 4842: @241740
     /* 241740 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241831), // Rule ID 5582 //
     /* 241745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241766 */     // MIs[0] idx
     /* 241766 */     // No operand predicates
     /* 241766 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241799 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241802 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241827 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241829 */     GIR_RootConstrainSelectedInstOperands,
     /* 241830 */     // GIR_Coverage, 5582,
     /* 241830 */     GIR_EraseRootFromParent_Done,
     /* 241831 */   // Label 4843: @241831
     /* 241831 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241922), // Rule ID 5583 //
     /* 241836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241857 */     // MIs[0] idx
     /* 241857 */     // No operand predicates
     /* 241857 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241890 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241918 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241920 */     GIR_RootConstrainSelectedInstOperands,
     /* 241921 */     // GIR_Coverage, 5583,
     /* 241921 */     GIR_EraseRootFromParent_Done,
     /* 241922 */   // Label 4844: @241922
     /* 241922 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241961), // Rule ID 5584 //
     /* 241927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 241941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241948 */     // MIs[0] idx
     /* 241948 */     // No operand predicates
     /* 241948 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241957 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241959 */     GIR_RootConstrainSelectedInstOperands,
     /* 241960 */     // GIR_Coverage, 5584,
     /* 241960 */     GIR_EraseRootFromParent_Done,
     /* 241961 */   // Label 4845: @241961
     /* 241961 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(242000), // Rule ID 5585 //
     /* 241966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 241974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241987 */     // MIs[0] idx
     /* 241987 */     // No operand predicates
     /* 241987 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 241987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 241990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241996 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241998 */     GIR_RootConstrainSelectedInstOperands,
     /* 241999 */     // GIR_Coverage, 5585,
     /* 241999 */     GIR_EraseRootFromParent_Done,
     /* 242000 */   // Label 4846: @242000
     /* 242000 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(242091), // Rule ID 5586 //
     /* 242005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 242013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242026 */     // MIs[0] idx
     /* 242026 */     // No operand predicates
     /* 242026 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242052 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242059 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242087 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242089 */     GIR_RootConstrainSelectedInstOperands,
     /* 242090 */     // GIR_Coverage, 5586,
     /* 242090 */     GIR_EraseRootFromParent_Done,
     /* 242091 */   // Label 4847: @242091
     /* 242091 */   GIM_Reject,
     /* 242092 */ // Label 3971: @242092
     /* 242092 */ GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(249203),
     /* 242097 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 242100 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(242147), // Rule ID 2965 //
     /* 242105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 242135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242143 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242145 */     GIR_RootConstrainSelectedInstOperands,
     /* 242146 */     // GIR_Coverage, 2965,
     /* 242146 */     GIR_EraseRootFromParent_Done,
     /* 242147 */   // Label 4849: @242147
     /* 242147 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(242194), // Rule ID 2967 //
     /* 242152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242179 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 242182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242190 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242192 */     GIR_RootConstrainSelectedInstOperands,
     /* 242193 */     // GIR_Coverage, 2967,
     /* 242193 */     GIR_EraseRootFromParent_Done,
     /* 242194 */   // Label 4850: @242194
     /* 242194 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(242241), // Rule ID 2969 //
     /* 242199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1589:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 242229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242237 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242239 */     GIR_RootConstrainSelectedInstOperands,
     /* 242240 */     // GIR_Coverage, 2969,
     /* 242240 */     GIR_EraseRootFromParent_Done,
     /* 242241 */   // Label 4851: @242241
     /* 242241 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242288), // Rule ID 2971 //
     /* 242246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1589:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 242276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242284 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242286 */     GIR_RootConstrainSelectedInstOperands,
     /* 242287 */     // GIR_Coverage, 2971,
     /* 242287 */     GIR_EraseRootFromParent_Done,
     /* 242288 */   // Label 4852: @242288
     /* 242288 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242335), // Rule ID 7531 //
     /* 242293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 242323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242331 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242333 */     GIR_RootConstrainSelectedInstOperands,
     /* 242334 */     // GIR_Coverage, 7531,
     /* 242334 */     GIR_EraseRootFromParent_Done,
     /* 242335 */   // Label 4853: @242335
     /* 242335 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242382), // Rule ID 7533 //
     /* 242340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242367 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 242370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242378 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242380 */     GIR_RootConstrainSelectedInstOperands,
     /* 242381 */     // GIR_Coverage, 7533,
     /* 242381 */     GIR_EraseRootFromParent_Done,
     /* 242382 */   // Label 4854: @242382
     /* 242382 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242429), // Rule ID 7535 //
     /* 242387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 242417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242425 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242427 */     GIR_RootConstrainSelectedInstOperands,
     /* 242428 */     // GIR_Coverage, 7535,
     /* 242428 */     GIR_EraseRootFromParent_Done,
     /* 242429 */   // Label 4855: @242429
     /* 242429 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(242476), // Rule ID 7537 //
     /* 242434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242461 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1592:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 242464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242472 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242474 */     GIR_RootConstrainSelectedInstOperands,
     /* 242475 */     // GIR_Coverage, 7537,
     /* 242475 */     GIR_EraseRootFromParent_Done,
     /* 242476 */   // Label 4856: @242476
     /* 242476 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242556), // Rule ID 5693 //
     /* 242481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 242498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 242521 */     // MIs[1] Operand 1
     /* 242521 */     // No operand predicates
     /* 242521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 242537 */     // MIs[2] Operand 1
     /* 242537 */     // No operand predicates
     /* 242537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242539 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 242539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 242542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242554 */     GIR_RootConstrainSelectedInstOperands,
     /* 242555 */     // GIR_Coverage, 5693,
     /* 242555 */     GIR_EraseRootFromParent_Done,
     /* 242556 */   // Label 4857: @242556
     /* 242556 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242636), // Rule ID 5694 //
     /* 242561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 242578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 242601 */     // MIs[1] Operand 1
     /* 242601 */     // No operand predicates
     /* 242601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242613 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 242617 */     // MIs[2] Operand 1
     /* 242617 */     // No operand predicates
     /* 242617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242619 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 242619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 242622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242634 */     GIR_RootConstrainSelectedInstOperands,
     /* 242635 */     // GIR_Coverage, 5694,
     /* 242635 */     GIR_EraseRootFromParent_Done,
     /* 242636 */   // Label 4858: @242636
     /* 242636 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242716), // Rule ID 5695 //
     /* 242641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 242681 */     // MIs[1] Operand 1
     /* 242681 */     // No operand predicates
     /* 242681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 242697 */     // MIs[2] Operand 1
     /* 242697 */     // No operand predicates
     /* 242697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242699 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 242699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 242702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242714 */     GIR_RootConstrainSelectedInstOperands,
     /* 242715 */     // GIR_Coverage, 5695,
     /* 242715 */     GIR_EraseRootFromParent_Done,
     /* 242716 */   // Label 4859: @242716
     /* 242716 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242796), // Rule ID 5696 //
     /* 242721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 242726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 242729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 242732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 242735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 242738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 242741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 242753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242761 */     // MIs[1] Operand 1
     /* 242761 */     // No operand predicates
     /* 242761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 242769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 242773 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 242777 */     // MIs[2] Operand 1
     /* 242777 */     // No operand predicates
     /* 242777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 242779 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 242779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 242782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 242784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 242789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 242791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 242794 */     GIR_RootConstrainSelectedInstOperands,
     /* 242795 */     // GIR_Coverage, 5696,
     /* 242795 */     GIR_EraseRootFromParent_Done,
     /* 242796 */   // Label 4860: @242796
     /* 242796 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242860), // Rule ID 3839 //
     /* 242801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 242809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242837 */     // MIs[0] imm
     /* 242837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 242848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242856 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242858 */     GIR_RootConstrainSelectedInstOperands,
     /* 242859 */     // GIR_Coverage, 3839,
     /* 242859 */     GIR_EraseRootFromParent_Done,
     /* 242860 */   // Label 4861: @242860
     /* 242860 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242924), // Rule ID 3840 //
     /* 242865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 242873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242901 */     // MIs[0] imm
     /* 242901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242909 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 242912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242920 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242922 */     GIR_RootConstrainSelectedInstOperands,
     /* 242923 */     // GIR_Coverage, 3840,
     /* 242923 */     GIR_EraseRootFromParent_Done,
     /* 242924 */   // Label 4862: @242924
     /* 242924 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242988), // Rule ID 3841 //
     /* 242929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 242937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 242940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 242943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 242946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 242949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242965 */     // MIs[0] imm
     /* 242965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 242968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 242973 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 242973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 242976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 242978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 242980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 242982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 242984 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 242986 */     GIR_RootConstrainSelectedInstOperands,
     /* 242987 */     // GIR_Coverage, 3841,
     /* 242987 */     GIR_EraseRootFromParent_Done,
     /* 242988 */   // Label 4863: @242988
     /* 242988 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(243052), // Rule ID 3842 //
     /* 242993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 242996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 243001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243029 */     // MIs[0] imm
     /* 243029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243037 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 243040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243048 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243050 */     GIR_RootConstrainSelectedInstOperands,
     /* 243051 */     // GIR_Coverage, 3842,
     /* 243051 */     GIR_EraseRootFromParent_Done,
     /* 243052 */   // Label 4864: @243052
     /* 243052 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(243104), // Rule ID 2850 //
     /* 243057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243081 */     // MIs[0] idx
     /* 243081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243089 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1448:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 243092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243100 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243102 */     GIR_RootConstrainSelectedInstOperands,
     /* 243103 */     // GIR_Coverage, 2850,
     /* 243103 */     GIR_EraseRootFromParent_Done,
     /* 243104 */   // Label 4865: @243104
     /* 243104 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(243156), // Rule ID 2851 //
     /* 243109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243133 */     // MIs[0] idx
     /* 243133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243141 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1448:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 243144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243152 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243154 */     GIR_RootConstrainSelectedInstOperands,
     /* 243155 */     // GIR_Coverage, 2851,
     /* 243155 */     GIR_EraseRootFromParent_Done,
     /* 243156 */   // Label 4866: @243156
     /* 243156 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(243208), // Rule ID 2852 //
     /* 243161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243185 */     // MIs[0] idx
     /* 243185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243193 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1448:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 243196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243204 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243206 */     GIR_RootConstrainSelectedInstOperands,
     /* 243207 */     // GIR_Coverage, 2852,
     /* 243207 */     GIR_EraseRootFromParent_Done,
     /* 243208 */   // Label 4867: @243208
     /* 243208 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(243260), // Rule ID 2980 //
     /* 243213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243237 */     // MIs[0] Op4
     /* 243237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 243248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243256 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243258 */     GIR_RootConstrainSelectedInstOperands,
     /* 243259 */     // GIR_Coverage, 2980,
     /* 243259 */     GIR_EraseRootFromParent_Done,
     /* 243260 */   // Label 4868: @243260
     /* 243260 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(243312), // Rule ID 2981 //
     /* 243265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243289 */     // MIs[0] Op4
     /* 243289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 243300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243308 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243310 */     GIR_RootConstrainSelectedInstOperands,
     /* 243311 */     // GIR_Coverage, 2981,
     /* 243311 */     GIR_EraseRootFromParent_Done,
     /* 243312 */   // Label 4869: @243312
     /* 243312 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(243364), // Rule ID 2982 //
     /* 243317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243341 */     // MIs[0] Op4
     /* 243341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 243352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243360 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243362 */     GIR_RootConstrainSelectedInstOperands,
     /* 243363 */     // GIR_Coverage, 2982,
     /* 243363 */     GIR_EraseRootFromParent_Done,
     /* 243364 */   // Label 4870: @243364
     /* 243364 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(243416), // Rule ID 2983 //
     /* 243369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243393 */     // MIs[0] Op4
     /* 243393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 243404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243412 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243414 */     GIR_RootConstrainSelectedInstOperands,
     /* 243415 */     // GIR_Coverage, 2983,
     /* 243415 */     GIR_EraseRootFromParent_Done,
     /* 243416 */   // Label 4871: @243416
     /* 243416 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(243468), // Rule ID 2984 //
     /* 243421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243445 */     // MIs[0] Op4
     /* 243445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243448 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 243456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243464 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243466 */     GIR_RootConstrainSelectedInstOperands,
     /* 243467 */     // GIR_Coverage, 2984,
     /* 243467 */     GIR_EraseRootFromParent_Done,
     /* 243468 */   // Label 4872: @243468
     /* 243468 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(243520), // Rule ID 2987 //
     /* 243473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 243481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243497 */     // MIs[0] Op4
     /* 243497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243505 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 243508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243516 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243518 */     GIR_RootConstrainSelectedInstOperands,
     /* 243519 */     // GIR_Coverage, 2987,
     /* 243519 */     GIR_EraseRootFromParent_Done,
     /* 243520 */   // Label 4873: @243520
     /* 243520 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(243572), // Rule ID 2988 //
     /* 243525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 243533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243549 */     // MIs[0] Op4
     /* 243549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 243560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243568 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243570 */     GIR_RootConstrainSelectedInstOperands,
     /* 243571 */     // GIR_Coverage, 2988,
     /* 243571 */     GIR_EraseRootFromParent_Done,
     /* 243572 */   // Label 4874: @243572
     /* 243572 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243624), // Rule ID 3462 //
     /* 243577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 243580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 243585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243601 */     // MIs[0] Op4
     /* 243601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243609 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 243612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243620 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243622 */     GIR_RootConstrainSelectedInstOperands,
     /* 243623 */     // GIR_Coverage, 3462,
     /* 243623 */     GIR_EraseRootFromParent_Done,
     /* 243624 */   // Label 4875: @243624
     /* 243624 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243676), // Rule ID 3506 //
     /* 243629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 243632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 243637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243653 */     // MIs[0] Op4
     /* 243653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 243664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243672 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243674 */     GIR_RootConstrainSelectedInstOperands,
     /* 243675 */     // GIR_Coverage, 3506,
     /* 243675 */     GIR_EraseRootFromParent_Done,
     /* 243676 */   // Label 4876: @243676
     /* 243676 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243728), // Rule ID 7601 //
     /* 243681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 243689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243705 */     // MIs[0] Op4
     /* 243705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 243716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243724 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243726 */     GIR_RootConstrainSelectedInstOperands,
     /* 243727 */     // GIR_Coverage, 7601,
     /* 243727 */     GIR_EraseRootFromParent_Done,
     /* 243728 */   // Label 4877: @243728
     /* 243728 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243780), // Rule ID 7602 //
     /* 243733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 243741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243757 */     // MIs[0] Op4
     /* 243757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243765 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 243768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243776 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243778 */     GIR_RootConstrainSelectedInstOperands,
     /* 243779 */     // GIR_Coverage, 7602,
     /* 243779 */     GIR_EraseRootFromParent_Done,
     /* 243780 */   // Label 4878: @243780
     /* 243780 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243832), // Rule ID 8242 //
     /* 243785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243809 */     // MIs[0] idx
     /* 243809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243817 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 243820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243828 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243830 */     GIR_RootConstrainSelectedInstOperands,
     /* 243831 */     // GIR_Coverage, 8242,
     /* 243831 */     GIR_EraseRootFromParent_Done,
     /* 243832 */   // Label 4879: @243832
     /* 243832 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(243884), // Rule ID 8243 //
     /* 243837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243861 */     // MIs[0] idx
     /* 243861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243869 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 243872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243880 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243882 */     GIR_RootConstrainSelectedInstOperands,
     /* 243883 */     // GIR_Coverage, 8243,
     /* 243883 */     GIR_EraseRootFromParent_Done,
     /* 243884 */   // Label 4880: @243884
     /* 243884 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(243936), // Rule ID 8244 //
     /* 243889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 243897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243913 */     // MIs[0] idx
     /* 243913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243921 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 243924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243932 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243934 */     GIR_RootConstrainSelectedInstOperands,
     /* 243935 */     // GIR_Coverage, 8244,
     /* 243935 */     GIR_EraseRootFromParent_Done,
     /* 243936 */   // Label 4881: @243936
     /* 243936 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(243988), // Rule ID 11188 //
     /* 243941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 243944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 243949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243965 */     // MIs[0] Op4
     /* 243965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1892:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 243976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243984 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243986 */     GIR_RootConstrainSelectedInstOperands,
     /* 243987 */     // GIR_Coverage, 11188,
     /* 243987 */     GIR_EraseRootFromParent_Done,
     /* 243988 */   // Label 4882: @243988
     /* 243988 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(244040), // Rule ID 11235 //
     /* 243993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244017 */     // MIs[0] Op4
     /* 244017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 244028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244036 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244038 */     GIR_RootConstrainSelectedInstOperands,
     /* 244039 */     // GIR_Coverage, 11235,
     /* 244039 */     GIR_EraseRootFromParent_Done,
     /* 244040 */   // Label 4883: @244040
     /* 244040 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(244092), // Rule ID 11236 //
     /* 244045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244069 */     // MIs[0] Op4
     /* 244069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 244080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244088 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244090 */     GIR_RootConstrainSelectedInstOperands,
     /* 244091 */     // GIR_Coverage, 11236,
     /* 244091 */     GIR_EraseRootFromParent_Done,
     /* 244092 */   // Label 4884: @244092
     /* 244092 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(244144), // Rule ID 11237 //
     /* 244097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244121 */     // MIs[0] Op4
     /* 244121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244129 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 244132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244140 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244142 */     GIR_RootConstrainSelectedInstOperands,
     /* 244143 */     // GIR_Coverage, 11237,
     /* 244143 */     GIR_EraseRootFromParent_Done,
     /* 244144 */   // Label 4885: @244144
     /* 244144 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(244196), // Rule ID 11238 //
     /* 244149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244173 */     // MIs[0] Op4
     /* 244173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244181 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 244184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244192 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244194 */     GIR_RootConstrainSelectedInstOperands,
     /* 244195 */     // GIR_Coverage, 11238,
     /* 244195 */     GIR_EraseRootFromParent_Done,
     /* 244196 */   // Label 4886: @244196
     /* 244196 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(244248), // Rule ID 11239 //
     /* 244201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244225 */     // MIs[0] Op4
     /* 244225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 244236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244244 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244246 */     GIR_RootConstrainSelectedInstOperands,
     /* 244247 */     // GIR_Coverage, 11239,
     /* 244247 */     GIR_EraseRootFromParent_Done,
     /* 244248 */   // Label 4887: @244248
     /* 244248 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(244300), // Rule ID 11240 //
     /* 244253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244277 */     // MIs[0] Op4
     /* 244277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244285 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 244288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244296 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244298 */     GIR_RootConstrainSelectedInstOperands,
     /* 244299 */     // GIR_Coverage, 11240,
     /* 244299 */     GIR_EraseRootFromParent_Done,
     /* 244300 */   // Label 4888: @244300
     /* 244300 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(244352), // Rule ID 11241 //
     /* 244305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244329 */     // MIs[0] Op4
     /* 244329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 244340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244348 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244350 */     GIR_RootConstrainSelectedInstOperands,
     /* 244351 */     // GIR_Coverage, 11241,
     /* 244351 */     GIR_EraseRootFromParent_Done,
     /* 244352 */   // Label 4889: @244352
     /* 244352 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(244404), // Rule ID 11242 //
     /* 244357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244381 */     // MIs[0] Op4
     /* 244381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 244392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244400 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244402 */     GIR_RootConstrainSelectedInstOperands,
     /* 244403 */     // GIR_Coverage, 11242,
     /* 244403 */     GIR_EraseRootFromParent_Done,
     /* 244404 */   // Label 4890: @244404
     /* 244404 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(244456), // Rule ID 11243 //
     /* 244409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244433 */     // MIs[0] Op4
     /* 244433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 244444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244452 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244454 */     GIR_RootConstrainSelectedInstOperands,
     /* 244455 */     // GIR_Coverage, 11243,
     /* 244455 */     GIR_EraseRootFromParent_Done,
     /* 244456 */   // Label 4891: @244456
     /* 244456 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244508), // Rule ID 11286 //
     /* 244461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 244469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244485 */     // MIs[0] Op4
     /* 244485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 244496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244504 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244506 */     GIR_RootConstrainSelectedInstOperands,
     /* 244507 */     // GIR_Coverage, 11286,
     /* 244507 */     GIR_EraseRootFromParent_Done,
     /* 244508 */   // Label 4892: @244508
     /* 244508 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244560), // Rule ID 11287 //
     /* 244513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 244521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244537 */     // MIs[0] Op4
     /* 244537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244545 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 244548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244556 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244558 */     GIR_RootConstrainSelectedInstOperands,
     /* 244559 */     // GIR_Coverage, 11287,
     /* 244559 */     GIR_EraseRootFromParent_Done,
     /* 244560 */   // Label 4893: @244560
     /* 244560 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244612), // Rule ID 11288 //
     /* 244565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 244573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244589 */     // MIs[0] Op4
     /* 244589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 244600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244608 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244610 */     GIR_RootConstrainSelectedInstOperands,
     /* 244611 */     // GIR_Coverage, 11288,
     /* 244611 */     GIR_EraseRootFromParent_Done,
     /* 244612 */   // Label 4894: @244612
     /* 244612 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244664), // Rule ID 11289 //
     /* 244617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 244625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244641 */     // MIs[0] Op4
     /* 244641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 244652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244660 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244662 */     GIR_RootConstrainSelectedInstOperands,
     /* 244663 */     // GIR_Coverage, 11289,
     /* 244663 */     GIR_EraseRootFromParent_Done,
     /* 244664 */   // Label 4895: @244664
     /* 244664 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(244716), // Rule ID 11290 //
     /* 244669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 244677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244693 */     // MIs[0] Op4
     /* 244693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 244704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244712 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244714 */     GIR_RootConstrainSelectedInstOperands,
     /* 244715 */     // GIR_Coverage, 11290,
     /* 244715 */     GIR_EraseRootFromParent_Done,
     /* 244716 */   // Label 4896: @244716
     /* 244716 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(244768), // Rule ID 11291 //
     /* 244721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 244729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244745 */     // MIs[0] Op4
     /* 244745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 244756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244764 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244766 */     GIR_RootConstrainSelectedInstOperands,
     /* 244767 */     // GIR_Coverage, 11291,
     /* 244767 */     GIR_EraseRootFromParent_Done,
     /* 244768 */   // Label 4897: @244768
     /* 244768 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244820), // Rule ID 11292 //
     /* 244773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244797 */     // MIs[0] Op4
     /* 244797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 244808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244816 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244818 */     GIR_RootConstrainSelectedInstOperands,
     /* 244819 */     // GIR_Coverage, 11292,
     /* 244819 */     GIR_EraseRootFromParent_Done,
     /* 244820 */   // Label 4898: @244820
     /* 244820 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(244872), // Rule ID 11293 //
     /* 244825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 244833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244849 */     // MIs[0] Op4
     /* 244849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244857 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1734:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 244860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244868 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244870 */     GIR_RootConstrainSelectedInstOperands,
     /* 244871 */     // GIR_Coverage, 11293,
     /* 244871 */     GIR_EraseRootFromParent_Done,
     /* 244872 */   // Label 4899: @244872
     /* 244872 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(244924), // Rule ID 11294 //
     /* 244877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244901 */     // MIs[0] Op4
     /* 244901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1736:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 244912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244920 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244922 */     GIR_RootConstrainSelectedInstOperands,
     /* 244923 */     // GIR_Coverage, 11294,
     /* 244923 */     GIR_EraseRootFromParent_Done,
     /* 244924 */   // Label 4900: @244924
     /* 244924 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(244976), // Rule ID 11295 //
     /* 244929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 244937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244953 */     // MIs[0] Op4
     /* 244953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1736:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 244964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244972 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244974 */     GIR_RootConstrainSelectedInstOperands,
     /* 244975 */     // GIR_Coverage, 11295,
     /* 244975 */     GIR_EraseRootFromParent_Done,
     /* 244976 */   // Label 4901: @244976
     /* 244976 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(245028), // Rule ID 11296 //
     /* 244981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 244989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245005 */     // MIs[0] Op4
     /* 245005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 245016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245024 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245026 */     GIR_RootConstrainSelectedInstOperands,
     /* 245027 */     // GIR_Coverage, 11296,
     /* 245027 */     GIR_EraseRootFromParent_Done,
     /* 245028 */   // Label 4902: @245028
     /* 245028 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(245080), // Rule ID 11297 //
     /* 245033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245057 */     // MIs[0] Op4
     /* 245057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245065 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 245068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245076 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245078 */     GIR_RootConstrainSelectedInstOperands,
     /* 245079 */     // GIR_Coverage, 11297,
     /* 245079 */     GIR_EraseRootFromParent_Done,
     /* 245080 */   // Label 4903: @245080
     /* 245080 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(245132), // Rule ID 11298 //
     /* 245085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245109 */     // MIs[0] Op4
     /* 245109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1974:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 245120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245128 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245130 */     GIR_RootConstrainSelectedInstOperands,
     /* 245131 */     // GIR_Coverage, 11298,
     /* 245131 */     GIR_EraseRootFromParent_Done,
     /* 245132 */   // Label 4904: @245132
     /* 245132 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(245184), // Rule ID 11299 //
     /* 245137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245161 */     // MIs[0] Op4
     /* 245161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1974:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 245172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245180 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245182 */     GIR_RootConstrainSelectedInstOperands,
     /* 245183 */     // GIR_Coverage, 11299,
     /* 245183 */     GIR_EraseRootFromParent_Done,
     /* 245184 */   // Label 4905: @245184
     /* 245184 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(245236), // Rule ID 11321 //
     /* 245189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245213 */     // MIs[0] Op4
     /* 245213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1772:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 245224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245232 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245234 */     GIR_RootConstrainSelectedInstOperands,
     /* 245235 */     // GIR_Coverage, 11321,
     /* 245235 */     GIR_EraseRootFromParent_Done,
     /* 245236 */   // Label 4906: @245236
     /* 245236 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(245288), // Rule ID 11322 //
     /* 245241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245265 */     // MIs[0] Op4
     /* 245265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1772:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 245276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245284 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245286 */     GIR_RootConstrainSelectedInstOperands,
     /* 245287 */     // GIR_Coverage, 11322,
     /* 245287 */     GIR_EraseRootFromParent_Done,
     /* 245288 */   // Label 4907: @245288
     /* 245288 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(245340), // Rule ID 11323 //
     /* 245293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245317 */     // MIs[0] Op4
     /* 245317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245320 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1775:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 245328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245336 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245338 */     GIR_RootConstrainSelectedInstOperands,
     /* 245339 */     // GIR_Coverage, 11323,
     /* 245339 */     GIR_EraseRootFromParent_Done,
     /* 245340 */   // Label 4908: @245340
     /* 245340 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245392), // Rule ID 11324 //
     /* 245345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245369 */     // MIs[0] Op4
     /* 245369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1775:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 245380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245388 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245390 */     GIR_RootConstrainSelectedInstOperands,
     /* 245391 */     // GIR_Coverage, 11324,
     /* 245391 */     GIR_EraseRootFromParent_Done,
     /* 245392 */   // Label 4909: @245392
     /* 245392 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245444), // Rule ID 11325 //
     /* 245397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245421 */     // MIs[0] Op4
     /* 245421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245429 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 245432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245440 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245442 */     GIR_RootConstrainSelectedInstOperands,
     /* 245443 */     // GIR_Coverage, 11325,
     /* 245443 */     GIR_EraseRootFromParent_Done,
     /* 245444 */   // Label 4910: @245444
     /* 245444 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245496), // Rule ID 11326 //
     /* 245449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245473 */     // MIs[0] Op4
     /* 245473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245481 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 245484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245492 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245494 */     GIR_RootConstrainSelectedInstOperands,
     /* 245495 */     // GIR_Coverage, 11326,
     /* 245495 */     GIR_EraseRootFromParent_Done,
     /* 245496 */   // Label 4911: @245496
     /* 245496 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245548), // Rule ID 11327 //
     /* 245501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 245509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245525 */     // MIs[0] Op4
     /* 245525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245533 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1780:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 245536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245544 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245546 */     GIR_RootConstrainSelectedInstOperands,
     /* 245547 */     // GIR_Coverage, 11327,
     /* 245547 */     GIR_EraseRootFromParent_Done,
     /* 245548 */   // Label 4912: @245548
     /* 245548 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245600), // Rule ID 11328 //
     /* 245553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 245561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245577 */     // MIs[0] Op4
     /* 245577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 245588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245596 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245598 */     GIR_RootConstrainSelectedInstOperands,
     /* 245599 */     // GIR_Coverage, 11328,
     /* 245599 */     GIR_EraseRootFromParent_Done,
     /* 245600 */   // Label 4913: @245600
     /* 245600 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245652), // Rule ID 11782 //
     /* 245605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 245613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245629 */     // MIs[0] Op4
     /* 245629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245637 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1451:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 245640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245648 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245650 */     GIR_RootConstrainSelectedInstOperands,
     /* 245651 */     // GIR_Coverage, 11782,
     /* 245651 */     GIR_EraseRootFromParent_Done,
     /* 245652 */   // Label 4914: @245652
     /* 245652 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(245704), // Rule ID 11783 //
     /* 245657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 245665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245681 */     // MIs[0] Op4
     /* 245681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245689 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 245692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245700 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245702 */     GIR_RootConstrainSelectedInstOperands,
     /* 245703 */     // GIR_Coverage, 11783,
     /* 245703 */     GIR_EraseRootFromParent_Done,
     /* 245704 */   // Label 4915: @245704
     /* 245704 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(245756), // Rule ID 11784 //
     /* 245709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 245717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245733 */     // MIs[0] Op4
     /* 245733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245741 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 245744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245752 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245754 */     GIR_RootConstrainSelectedInstOperands,
     /* 245755 */     // GIR_Coverage, 11784,
     /* 245755 */     GIR_EraseRootFromParent_Done,
     /* 245756 */   // Label 4916: @245756
     /* 245756 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(245808), // Rule ID 11785 //
     /* 245761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 245769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245785 */     // MIs[0] Op4
     /* 245785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245793 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1460:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 245796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245804 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245806 */     GIR_RootConstrainSelectedInstOperands,
     /* 245807 */     // GIR_Coverage, 11785,
     /* 245807 */     GIR_EraseRootFromParent_Done,
     /* 245808 */   // Label 4917: @245808
     /* 245808 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(245860), // Rule ID 11918 //
     /* 245813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 245821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245837 */     // MIs[0] Op4
     /* 245837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245845 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1406:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 245848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245856 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245858 */     GIR_RootConstrainSelectedInstOperands,
     /* 245859 */     // GIR_Coverage, 11918,
     /* 245859 */     GIR_EraseRootFromParent_Done,
     /* 245860 */   // Label 4918: @245860
     /* 245860 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(245912), // Rule ID 11920 //
     /* 245865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 245868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 245873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245889 */     // MIs[0] Op4
     /* 245889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245897 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 245900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245908 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245910 */     GIR_RootConstrainSelectedInstOperands,
     /* 245911 */     // GIR_Coverage, 11920,
     /* 245911 */     GIR_EraseRootFromParent_Done,
     /* 245912 */   // Label 4919: @245912
     /* 245912 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(245959), // Rule ID 2829 //
     /* 245917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 245940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245944 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 245944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 245947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245955 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245957 */     GIR_RootConstrainSelectedInstOperands,
     /* 245958 */     // GIR_Coverage, 2829,
     /* 245958 */     GIR_EraseRootFromParent_Done,
     /* 245959 */   // Label 4920: @245959
     /* 245959 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(246006), // Rule ID 2832 //
     /* 245964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 245972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 245975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 245981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 245984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 245987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245991 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 245991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 245994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246002 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246004 */     GIR_RootConstrainSelectedInstOperands,
     /* 246005 */     // GIR_Coverage, 2832,
     /* 246005 */     GIR_EraseRootFromParent_Done,
     /* 246006 */   // Label 4921: @246006
     /* 246006 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(246053), // Rule ID 2835 //
     /* 246011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 246022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 246028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 246031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 246034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246038 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 246038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246049 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246051 */     GIR_RootConstrainSelectedInstOperands,
     /* 246052 */     // GIR_Coverage, 2835,
     /* 246052 */     GIR_EraseRootFromParent_Done,
     /* 246053 */   // Label 4922: @246053
     /* 246053 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(246100), // Rule ID 2838 //
     /* 246058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246085 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246096 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246098 */     GIR_RootConstrainSelectedInstOperands,
     /* 246099 */     // GIR_Coverage, 2838,
     /* 246099 */     GIR_EraseRootFromParent_Done,
     /* 246100 */   // Label 4923: @246100
     /* 246100 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246147), // Rule ID 2841 //
     /* 246105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 246116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 246122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 246125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 246128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246132 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 246132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246143 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246145 */     GIR_RootConstrainSelectedInstOperands,
     /* 246146 */     // GIR_Coverage, 2841,
     /* 246146 */     GIR_EraseRootFromParent_Done,
     /* 246147 */   // Label 4924: @246147
     /* 246147 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246194), // Rule ID 2844 //
     /* 246152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246179 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 246182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246190 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246192 */     GIR_RootConstrainSelectedInstOperands,
     /* 246193 */     // GIR_Coverage, 2844,
     /* 246193 */     GIR_EraseRootFromParent_Done,
     /* 246194 */   // Label 4925: @246194
     /* 246194 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246241), // Rule ID 2847 //
     /* 246199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246226 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1410:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 246229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246237 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246239 */     GIR_RootConstrainSelectedInstOperands,
     /* 246240 */     // GIR_Coverage, 2847,
     /* 246240 */     GIR_EraseRootFromParent_Done,
     /* 246241 */   // Label 4926: @246241
     /* 246241 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(246288), // Rule ID 2848 //
     /* 246246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246273 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 246276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246284 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246286 */     GIR_RootConstrainSelectedInstOperands,
     /* 246287 */     // GIR_Coverage, 2848,
     /* 246287 */     GIR_EraseRootFromParent_Done,
     /* 246288 */   // Label 4927: @246288
     /* 246288 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(246335), // Rule ID 2849 //
     /* 246293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246320 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1410:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 246323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246331 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246333 */     GIR_RootConstrainSelectedInstOperands,
     /* 246334 */     // GIR_Coverage, 2849,
     /* 246334 */     GIR_EraseRootFromParent_Done,
     /* 246335 */   // Label 4928: @246335
     /* 246335 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(246382), // Rule ID 2945 //
     /* 246340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246367 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 246370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246378 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246380 */     GIR_RootConstrainSelectedInstOperands,
     /* 246381 */     // GIR_Coverage, 2945,
     /* 246381 */     GIR_EraseRootFromParent_Done,
     /* 246382 */   // Label 4929: @246382
     /* 246382 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246429), // Rule ID 2948 //
     /* 246387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246414 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 246417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246425 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246427 */     GIR_RootConstrainSelectedInstOperands,
     /* 246428 */     // GIR_Coverage, 2948,
     /* 246428 */     GIR_EraseRootFromParent_Done,
     /* 246429 */   // Label 4930: @246429
     /* 246429 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246476), // Rule ID 2951 //
     /* 246434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 246464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246472 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246474 */     GIR_RootConstrainSelectedInstOperands,
     /* 246475 */     // GIR_Coverage, 2951,
     /* 246475 */     GIR_EraseRootFromParent_Done,
     /* 246476 */   // Label 4931: @246476
     /* 246476 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246523), // Rule ID 2954 //
     /* 246481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1585:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 246511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246519 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246521 */     GIR_RootConstrainSelectedInstOperands,
     /* 246522 */     // GIR_Coverage, 2954,
     /* 246522 */     GIR_EraseRootFromParent_Done,
     /* 246523 */   // Label 4932: @246523
     /* 246523 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246570), // Rule ID 2957 //
     /* 246528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246555 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1587:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 246558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246566 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246568 */     GIR_RootConstrainSelectedInstOperands,
     /* 246569 */     // GIR_Coverage, 2957,
     /* 246569 */     GIR_EraseRootFromParent_Done,
     /* 246570 */   // Label 4933: @246570
     /* 246570 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246617), // Rule ID 2959 //
     /* 246575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 246605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246613 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246615 */     GIR_RootConstrainSelectedInstOperands,
     /* 246616 */     // GIR_Coverage, 2959,
     /* 246616 */     GIR_EraseRootFromParent_Done,
     /* 246617 */   // Label 4934: @246617
     /* 246617 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246664), // Rule ID 2961 //
     /* 246622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 246652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246660 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246662 */     GIR_RootConstrainSelectedInstOperands,
     /* 246663 */     // GIR_Coverage, 2961,
     /* 246663 */     GIR_EraseRootFromParent_Done,
     /* 246664 */   // Label 4935: @246664
     /* 246664 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246711), // Rule ID 2963 //
     /* 246669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 246677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1587:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 246699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246707 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246709 */     GIR_RootConstrainSelectedInstOperands,
     /* 246710 */     // GIR_Coverage, 2963,
     /* 246710 */     GIR_EraseRootFromParent_Done,
     /* 246711 */   // Label 4936: @246711
     /* 246711 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246758), // Rule ID 7511 //
     /* 246716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246743 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 246746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246754 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246756 */     GIR_RootConstrainSelectedInstOperands,
     /* 246757 */     // GIR_Coverage, 7511,
     /* 246757 */     GIR_EraseRootFromParent_Done,
     /* 246758 */   // Label 4937: @246758
     /* 246758 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246805), // Rule ID 7514 //
     /* 246763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 246793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246801 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246803 */     GIR_RootConstrainSelectedInstOperands,
     /* 246804 */     // GIR_Coverage, 7514,
     /* 246804 */     GIR_EraseRootFromParent_Done,
     /* 246805 */   // Label 4938: @246805
     /* 246805 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(246852), // Rule ID 7517 //
     /* 246810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 246840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246848 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246850 */     GIR_RootConstrainSelectedInstOperands,
     /* 246851 */     // GIR_Coverage, 7517,
     /* 246851 */     GIR_EraseRootFromParent_Done,
     /* 246852 */   // Label 4939: @246852
     /* 246852 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(246899), // Rule ID 7520 //
     /* 246857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 246865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 246884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 246887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246895 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246897 */     GIR_RootConstrainSelectedInstOperands,
     /* 246898 */     // GIR_Coverage, 7520,
     /* 246898 */     GIR_EraseRootFromParent_Done,
     /* 246899 */   // Label 4940: @246899
     /* 246899 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(246946), // Rule ID 7523 //
     /* 246904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246931 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 246934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246942 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246944 */     GIR_RootConstrainSelectedInstOperands,
     /* 246945 */     // GIR_Coverage, 7523,
     /* 246945 */     GIR_EraseRootFromParent_Done,
     /* 246946 */   // Label 4941: @246946
     /* 246946 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(246993), // Rule ID 7525 //
     /* 246951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 246959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 246981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246989 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246991 */     GIR_RootConstrainSelectedInstOperands,
     /* 246992 */     // GIR_Coverage, 7525,
     /* 246992 */     GIR_EraseRootFromParent_Done,
     /* 246993 */   // Label 4942: @246993
     /* 246993 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247040), // Rule ID 7527 //
     /* 246998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 247028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247036 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247038 */     GIR_RootConstrainSelectedInstOperands,
     /* 247039 */     // GIR_Coverage, 7527,
     /* 247039 */     GIR_EraseRootFromParent_Done,
     /* 247040 */   // Label 4943: @247040
     /* 247040 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247087), // Rule ID 7529 //
     /* 247045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 247075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247083 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247085 */     GIR_RootConstrainSelectedInstOperands,
     /* 247086 */     // GIR_Coverage, 7529,
     /* 247086 */     GIR_EraseRootFromParent_Done,
     /* 247087 */   // Label 4944: @247087
     /* 247087 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247134), // Rule ID 8155 //
     /* 247092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247119 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1454:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247130 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247132 */     GIR_RootConstrainSelectedInstOperands,
     /* 247133 */     // GIR_Coverage, 8155,
     /* 247133 */     GIR_EraseRootFromParent_Done,
     /* 247134 */   // Label 4945: @247134
     /* 247134 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247181), // Rule ID 8158 //
     /* 247139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247166 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1454:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247177 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247179 */     GIR_RootConstrainSelectedInstOperands,
     /* 247180 */     // GIR_Coverage, 8158,
     /* 247180 */     GIR_EraseRootFromParent_Done,
     /* 247181 */   // Label 4946: @247181
     /* 247181 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247228), // Rule ID 8161 //
     /* 247186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247213 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247224 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247226 */     GIR_RootConstrainSelectedInstOperands,
     /* 247227 */     // GIR_Coverage, 8161,
     /* 247227 */     GIR_EraseRootFromParent_Done,
     /* 247228 */   // Label 4947: @247228
     /* 247228 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247275), // Rule ID 8164 //
     /* 247233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247260 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1454:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247271 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247273 */     GIR_RootConstrainSelectedInstOperands,
     /* 247274 */     // GIR_Coverage, 8164,
     /* 247274 */     GIR_EraseRootFromParent_Done,
     /* 247275 */   // Label 4948: @247275
     /* 247275 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247322), // Rule ID 8167 //
     /* 247280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247307 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247318 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247320 */     GIR_RootConstrainSelectedInstOperands,
     /* 247321 */     // GIR_Coverage, 8167,
     /* 247321 */     GIR_EraseRootFromParent_Done,
     /* 247322 */   // Label 4949: @247322
     /* 247322 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247369), // Rule ID 8170 //
     /* 247327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247354 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 247357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247365 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247367 */     GIR_RootConstrainSelectedInstOperands,
     /* 247368 */     // GIR_Coverage, 8170,
     /* 247368 */     GIR_EraseRootFromParent_Done,
     /* 247369 */   // Label 4950: @247369
     /* 247369 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247416), // Rule ID 8173 //
     /* 247374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247401 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247412 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247414 */     GIR_RootConstrainSelectedInstOperands,
     /* 247415 */     // GIR_Coverage, 8173,
     /* 247415 */     GIR_EraseRootFromParent_Done,
     /* 247416 */   // Label 4951: @247416
     /* 247416 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247463), // Rule ID 8174 //
     /* 247421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247448 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247459 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247461 */     GIR_RootConstrainSelectedInstOperands,
     /* 247462 */     // GIR_Coverage, 8174,
     /* 247462 */     GIR_EraseRootFromParent_Done,
     /* 247463 */   // Label 4952: @247463
     /* 247463 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247510), // Rule ID 8175 //
     /* 247468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247495 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247506 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247508 */     GIR_RootConstrainSelectedInstOperands,
     /* 247509 */     // GIR_Coverage, 8175,
     /* 247509 */     GIR_EraseRootFromParent_Done,
     /* 247510 */   // Label 4953: @247510
     /* 247510 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247557), // Rule ID 8176 //
     /* 247515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 247545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247553 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247555 */     GIR_RootConstrainSelectedInstOperands,
     /* 247556 */     // GIR_Coverage, 8176,
     /* 247556 */     GIR_EraseRootFromParent_Done,
     /* 247557 */   // Label 4954: @247557
     /* 247557 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247604), // Rule ID 8177 //
     /* 247562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247589 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 247592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247600 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247602 */     GIR_RootConstrainSelectedInstOperands,
     /* 247603 */     // GIR_Coverage, 8177,
     /* 247603 */     GIR_EraseRootFromParent_Done,
     /* 247604 */   // Label 4955: @247604
     /* 247604 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247651), // Rule ID 8178 //
     /* 247609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 247639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247647 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247649 */     GIR_RootConstrainSelectedInstOperands,
     /* 247650 */     // GIR_Coverage, 8178,
     /* 247650 */     GIR_EraseRootFromParent_Done,
     /* 247651 */   // Label 4956: @247651
     /* 247651 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247698), // Rule ID 8179 //
     /* 247656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247683 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1472:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247694 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247696 */     GIR_RootConstrainSelectedInstOperands,
     /* 247697 */     // GIR_Coverage, 8179,
     /* 247697 */     GIR_EraseRootFromParent_Done,
     /* 247698 */   // Label 4957: @247698
     /* 247698 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247745), // Rule ID 8180 //
     /* 247703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247741 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247743 */     GIR_RootConstrainSelectedInstOperands,
     /* 247744 */     // GIR_Coverage, 8180,
     /* 247744 */     GIR_EraseRootFromParent_Done,
     /* 247745 */   // Label 4958: @247745
     /* 247745 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247792), // Rule ID 8181 //
     /* 247750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247777 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 247780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247788 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247790 */     GIR_RootConstrainSelectedInstOperands,
     /* 247791 */     // GIR_Coverage, 8181,
     /* 247791 */     GIR_EraseRootFromParent_Done,
     /* 247792 */   // Label 4959: @247792
     /* 247792 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(247839), // Rule ID 8182 //
     /* 247797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247835 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247837 */     GIR_RootConstrainSelectedInstOperands,
     /* 247838 */     // GIR_Coverage, 8182,
     /* 247838 */     GIR_EraseRootFromParent_Done,
     /* 247839 */   // Label 4960: @247839
     /* 247839 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(247886), // Rule ID 8183 //
     /* 247844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247871 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 247874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247882 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247884 */     GIR_RootConstrainSelectedInstOperands,
     /* 247885 */     // GIR_Coverage, 8183,
     /* 247885 */     GIR_EraseRootFromParent_Done,
     /* 247886 */   // Label 4961: @247886
     /* 247886 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(247933), // Rule ID 8184 //
     /* 247891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 247899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247918 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 247921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247929 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247931 */     GIR_RootConstrainSelectedInstOperands,
     /* 247932 */     // GIR_Coverage, 8184,
     /* 247932 */     GIR_EraseRootFromParent_Done,
     /* 247933 */   // Label 4962: @247933
     /* 247933 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(247980), // Rule ID 8185 //
     /* 247938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 247946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247965 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 247968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247976 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247978 */     GIR_RootConstrainSelectedInstOperands,
     /* 247979 */     // GIR_Coverage, 8185,
     /* 247979 */     GIR_EraseRootFromParent_Done,
     /* 247980 */   // Label 4963: @247980
     /* 247980 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248027), // Rule ID 8186 //
     /* 247985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 247993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 248015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248023 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248025 */     GIR_RootConstrainSelectedInstOperands,
     /* 248026 */     // GIR_Coverage, 8186,
     /* 248026 */     GIR_EraseRootFromParent_Done,
     /* 248027 */   // Label 4964: @248027
     /* 248027 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248074), // Rule ID 8187 //
     /* 248032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 248062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248070 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248072 */     GIR_RootConstrainSelectedInstOperands,
     /* 248073 */     // GIR_Coverage, 8187,
     /* 248073 */     GIR_EraseRootFromParent_Done,
     /* 248074 */   // Label 4965: @248074
     /* 248074 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248121), // Rule ID 8188 //
     /* 248079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248106 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 248109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248117 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248119 */     GIR_RootConstrainSelectedInstOperands,
     /* 248120 */     // GIR_Coverage, 8188,
     /* 248120 */     GIR_EraseRootFromParent_Done,
     /* 248121 */   // Label 4966: @248121
     /* 248121 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248168), // Rule ID 8189 //
     /* 248126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248153 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 248156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248164 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248166 */     GIR_RootConstrainSelectedInstOperands,
     /* 248167 */     // GIR_Coverage, 8189,
     /* 248167 */     GIR_EraseRootFromParent_Done,
     /* 248168 */   // Label 4967: @248168
     /* 248168 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248215), // Rule ID 8190 //
     /* 248173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248200 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 248203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248211 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248213 */     GIR_RootConstrainSelectedInstOperands,
     /* 248214 */     // GIR_Coverage, 8190,
     /* 248214 */     GIR_EraseRootFromParent_Done,
     /* 248215 */   // Label 4968: @248215
     /* 248215 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248262), // Rule ID 8191 //
     /* 248220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248247 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1474:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 248250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248258 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248260 */     GIR_RootConstrainSelectedInstOperands,
     /* 248261 */     // GIR_Coverage, 8191,
     /* 248261 */     GIR_EraseRootFromParent_Done,
     /* 248262 */   // Label 4969: @248262
     /* 248262 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248309), // Rule ID 8192 //
     /* 248267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248294 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 248297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248305 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248307 */     GIR_RootConstrainSelectedInstOperands,
     /* 248308 */     // GIR_Coverage, 8192,
     /* 248308 */     GIR_EraseRootFromParent_Done,
     /* 248309 */   // Label 4970: @248309
     /* 248309 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248356), // Rule ID 8193 //
     /* 248314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248341 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1474:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 248344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248352 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248354 */     GIR_RootConstrainSelectedInstOperands,
     /* 248355 */     // GIR_Coverage, 8193,
     /* 248355 */     GIR_EraseRootFromParent_Done,
     /* 248356 */   // Label 4971: @248356
     /* 248356 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248403), // Rule ID 8194 //
     /* 248361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248388 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248399 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248401 */     GIR_RootConstrainSelectedInstOperands,
     /* 248402 */     // GIR_Coverage, 8194,
     /* 248402 */     GIR_EraseRootFromParent_Done,
     /* 248403 */   // Label 4972: @248403
     /* 248403 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248450), // Rule ID 8197 //
     /* 248408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248435 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248446 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248448 */     GIR_RootConstrainSelectedInstOperands,
     /* 248449 */     // GIR_Coverage, 8197,
     /* 248449 */     GIR_EraseRootFromParent_Done,
     /* 248450 */   // Label 4973: @248450
     /* 248450 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248497), // Rule ID 8200 //
     /* 248455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248482 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248493 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248495 */     GIR_RootConstrainSelectedInstOperands,
     /* 248496 */     // GIR_Coverage, 8200,
     /* 248496 */     GIR_EraseRootFromParent_Done,
     /* 248497 */   // Label 4974: @248497
     /* 248497 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248544), // Rule ID 8203 //
     /* 248502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248529 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 248532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248540 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248542 */     GIR_RootConstrainSelectedInstOperands,
     /* 248543 */     // GIR_Coverage, 8203,
     /* 248543 */     GIR_EraseRootFromParent_Done,
     /* 248544 */   // Label 4975: @248544
     /* 248544 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248591), // Rule ID 8206 //
     /* 248549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 248579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248587 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248589 */     GIR_RootConstrainSelectedInstOperands,
     /* 248590 */     // GIR_Coverage, 8206,
     /* 248590 */     GIR_EraseRootFromParent_Done,
     /* 248591 */   // Label 4976: @248591
     /* 248591 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248638), // Rule ID 8209 //
     /* 248596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248623 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 248626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248634 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248636 */     GIR_RootConstrainSelectedInstOperands,
     /* 248637 */     // GIR_Coverage, 8209,
     /* 248637 */     GIR_EraseRootFromParent_Done,
     /* 248638 */   // Label 4977: @248638
     /* 248638 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248685), // Rule ID 8212 //
     /* 248643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248670 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1471:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248681 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248683 */     GIR_RootConstrainSelectedInstOperands,
     /* 248684 */     // GIR_Coverage, 8212,
     /* 248684 */     GIR_EraseRootFromParent_Done,
     /* 248685 */   // Label 4978: @248685
     /* 248685 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248732), // Rule ID 8215 //
     /* 248690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248717 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248728 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248730 */     GIR_RootConstrainSelectedInstOperands,
     /* 248731 */     // GIR_Coverage, 8215,
     /* 248731 */     GIR_EraseRootFromParent_Done,
     /* 248732 */   // Label 4979: @248732
     /* 248732 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248779), // Rule ID 8218 //
     /* 248737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248764 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 248767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248775 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248777 */     GIR_RootConstrainSelectedInstOperands,
     /* 248778 */     // GIR_Coverage, 8218,
     /* 248778 */     GIR_EraseRootFromParent_Done,
     /* 248779 */   // Label 4980: @248779
     /* 248779 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248826), // Rule ID 8221 //
     /* 248784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248811 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248822 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248824 */     GIR_RootConstrainSelectedInstOperands,
     /* 248825 */     // GIR_Coverage, 8221,
     /* 248825 */     GIR_EraseRootFromParent_Done,
     /* 248826 */   // Label 4981: @248826
     /* 248826 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(248873), // Rule ID 8224 //
     /* 248831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248858 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 248861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248869 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248871 */     GIR_RootConstrainSelectedInstOperands,
     /* 248872 */     // GIR_Coverage, 8224,
     /* 248872 */     GIR_EraseRootFromParent_Done,
     /* 248873 */   // Label 4982: @248873
     /* 248873 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(248920), // Rule ID 8227 //
     /* 248878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 248886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248905 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 248908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248916 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248918 */     GIR_RootConstrainSelectedInstOperands,
     /* 248919 */     // GIR_Coverage, 8227,
     /* 248919 */     GIR_EraseRootFromParent_Done,
     /* 248920 */   // Label 4983: @248920
     /* 248920 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(248967), // Rule ID 8230 //
     /* 248925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248952 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1473:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 248955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248963 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248965 */     GIR_RootConstrainSelectedInstOperands,
     /* 248966 */     // GIR_Coverage, 8230,
     /* 248966 */     GIR_EraseRootFromParent_Done,
     /* 248967 */   // Label 4984: @248967
     /* 248967 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249014), // Rule ID 8232 //
     /* 248972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 248980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248999 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249010 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249012 */     GIR_RootConstrainSelectedInstOperands,
     /* 249013 */     // GIR_Coverage, 8232,
     /* 249013 */     GIR_EraseRootFromParent_Done,
     /* 249014 */   // Label 4985: @249014
     /* 249014 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249061), // Rule ID 8234 //
     /* 249019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249046 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249057 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249059 */     GIR_RootConstrainSelectedInstOperands,
     /* 249060 */     // GIR_Coverage, 8234,
     /* 249060 */     GIR_EraseRootFromParent_Done,
     /* 249061 */   // Label 4986: @249061
     /* 249061 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249108), // Rule ID 8236 //
     /* 249066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249093 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249104 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249106 */     GIR_RootConstrainSelectedInstOperands,
     /* 249107 */     // GIR_Coverage, 8236,
     /* 249107 */     GIR_EraseRootFromParent_Done,
     /* 249108 */   // Label 4987: @249108
     /* 249108 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249155), // Rule ID 8238 //
     /* 249113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249140 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249151 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249153 */     GIR_RootConstrainSelectedInstOperands,
     /* 249154 */     // GIR_Coverage, 8238,
     /* 249154 */     GIR_EraseRootFromParent_Done,
     /* 249155 */   // Label 4988: @249155
     /* 249155 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249202), // Rule ID 8240 //
     /* 249160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249187 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 249190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249198 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249200 */     GIR_RootConstrainSelectedInstOperands,
     /* 249201 */     // GIR_Coverage, 8240,
     /* 249201 */     GIR_EraseRootFromParent_Done,
     /* 249202 */   // Label 4989: @249202
     /* 249202 */   GIM_Reject,
     /* 249203 */ // Label 4848: @249203
     /* 249203 */ GIM_Reject,
     /* 249204 */ // Label 36: @249204
     /* 249204 */ GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249282),
     /* 249209 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 249212 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249234), // Rule ID 78 //
     /* 249217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 249225 */     // (intrinsic_void 2152:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 249225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 249228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249232 */     GIR_RootConstrainSelectedInstOperands,
     /* 249233 */     // GIR_Coverage, 78,
     /* 249233 */     GIR_EraseRootFromParent_Done,
     /* 249234 */   // Label 4991: @249234
     /* 249234 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249259), // Rule ID 2386 //
     /* 249239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 249247 */     // (intrinsic_void 1702:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 249247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 249250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249257 */     GIR_RootConstrainSelectedInstOperands,
     /* 249258 */     // GIR_Coverage, 2386,
     /* 249258 */     GIR_EraseRootFromParent_Done,
     /* 249259 */   // Label 4992: @249259
     /* 249259 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249281), // Rule ID 7095 //
     /* 249264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 249269 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 249269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 249272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 249275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249279 */     GIR_RootConstrainSelectedInstOperands,
     /* 249280 */     // GIR_Coverage, 7095,
     /* 249280 */     GIR_EraseRootFromParent_Done,
     /* 249281 */   // Label 4993: @249281
     /* 249281 */   GIM_Reject,
     /* 249282 */ // Label 4990: @249282
     /* 249282 */ GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249882),
     /* 249287 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 249290 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249322), // Rule ID 79 //
     /* 249295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 249303 */     // MIs[0] imm
     /* 249303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 249311 */     // (intrinsic_void 2151:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 249311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 249314 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249320 */     GIR_RootConstrainSelectedInstOperands,
     /* 249321 */     // GIR_Coverage, 79,
     /* 249321 */     GIR_EraseRootFromParent_Done,
     /* 249322 */   // Label 4995: @249322
     /* 249322 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249347), // Rule ID 227 //
     /* 249327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 249332 */     // MIs[0] imm
     /* 249332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249340 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 249340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 249343 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249345 */     GIR_RootConstrainSelectedInstOperands,
     /* 249346 */     // GIR_Coverage, 227,
     /* 249346 */     GIR_EraseRootFromParent_Done,
     /* 249347 */   // Label 4996: @249347
     /* 249347 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249372), // Rule ID 228 //
     /* 249352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 249357 */     // MIs[0] imm
     /* 249357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249365 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 249365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 249368 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249370 */     GIR_RootConstrainSelectedInstOperands,
     /* 249371 */     // GIR_Coverage, 228,
     /* 249371 */     GIR_EraseRootFromParent_Done,
     /* 249372 */   // Label 4997: @249372
     /* 249372 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249404), // Rule ID 3624 //
     /* 249377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 249385 */     // MIs[0] imm
     /* 249385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 249393 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 249393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 249396 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249402 */     GIR_RootConstrainSelectedInstOperands,
     /* 249403 */     // GIR_Coverage, 3624,
     /* 249403 */     GIR_EraseRootFromParent_Done,
     /* 249404 */   // Label 4998: @249404
     /* 249404 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249444), // Rule ID 16 //
     /* 249409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 249414 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 249429 */     // MIs[1] Operand 1
     /* 249429 */     // No operand predicates
     /* 249429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249431 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 249431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 249434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 249437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249442 */     GIR_RootConstrainSelectedInstOperands,
     /* 249443 */     // GIR_Coverage, 16,
     /* 249443 */     GIR_EraseRootFromParent_Done,
     /* 249444 */   // Label 4999: @249444
     /* 249444 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(249484), // Rule ID 17 //
     /* 249449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 249454 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249469 */     // MIs[1] Operand 1
     /* 249469 */     // No operand predicates
     /* 249469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249471 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 249471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 249474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249482 */     GIR_RootConstrainSelectedInstOperands,
     /* 249483 */     // GIR_Coverage, 17,
     /* 249483 */     GIR_EraseRootFromParent_Done,
     /* 249484 */   // Label 5000: @249484
     /* 249484 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249524), // Rule ID 18 //
     /* 249489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 249494 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249509 */     // MIs[1] Operand 1
     /* 249509 */     // No operand predicates
     /* 249509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249511 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 249511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 249514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249522 */     GIR_RootConstrainSelectedInstOperands,
     /* 249523 */     // GIR_Coverage, 18,
     /* 249523 */     GIR_EraseRootFromParent_Done,
     /* 249524 */   // Label 5001: @249524
     /* 249524 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(249564), // Rule ID 19 //
     /* 249529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 249534 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 249549 */     // MIs[1] Operand 1
     /* 249549 */     // No operand predicates
     /* 249549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249551 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 249551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 249554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 249557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249562 */     GIR_RootConstrainSelectedInstOperands,
     /* 249563 */     // GIR_Coverage, 19,
     /* 249563 */     GIR_EraseRootFromParent_Done,
     /* 249564 */   // Label 5002: @249564
     /* 249564 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249588), // Rule ID 72 //
     /* 249569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 249574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249581 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 249581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 249584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249586 */     GIR_RootConstrainSelectedInstOperands,
     /* 249587 */     // GIR_Coverage, 72,
     /* 249587 */     GIR_EraseRootFromParent_Done,
     /* 249588 */   // Label 5003: @249588
     /* 249588 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(249612), // Rule ID 74 //
     /* 249593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 249598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249605 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 249605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 249608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249610 */     GIR_RootConstrainSelectedInstOperands,
     /* 249611 */     // GIR_Coverage, 74,
     /* 249611 */     GIR_EraseRootFromParent_Done,
     /* 249612 */   // Label 5004: @249612
     /* 249612 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(249643), // Rule ID 77 //
     /* 249617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 249625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249632 */     // (intrinsic_w_chain:{ *:[i64] } 2153:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 249632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 249635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249641 */     GIR_RootConstrainSelectedInstOperands,
     /* 249642 */     // GIR_Coverage, 77,
     /* 249642 */     GIR_EraseRootFromParent_Done,
     /* 249643 */   // Label 5005: @249643
     /* 249643 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(249670), // Rule ID 80 //
     /* 249648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 249656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249663 */     // (intrinsic_w_chain:{ *:[i64] } 2154:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 249663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 249666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249668 */     GIR_RootConstrainSelectedInstOperands,
     /* 249669 */     // GIR_Coverage, 80,
     /* 249669 */     GIR_EraseRootFromParent_Done,
     /* 249670 */   // Label 5006: @249670
     /* 249670 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(249701), // Rule ID 2385 //
     /* 249675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 249683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 249686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249690 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1652:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 249690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 249693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 249695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249699 */     GIR_RootConstrainSelectedInstOperands,
     /* 249700 */     // GIR_Coverage, 2385,
     /* 249700 */     GIR_EraseRootFromParent_Done,
     /* 249701 */   // Label 5007: @249701
     /* 249701 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(249741), // Rule ID 12695 //
     /* 249706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 249714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 249721 */     // (intrinsic_w_chain:{ *:[i64] } 881:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 249721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 249724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 249726 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 249739 */     GIR_RootConstrainSelectedInstOperands,
     /* 249740 */     // GIR_Coverage, 12695,
     /* 249740 */     GIR_EraseRootFromParent_Done,
     /* 249741 */   // Label 5008: @249741
     /* 249741 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(249775), // Rule ID 2387 //
     /* 249746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 249754 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 249757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 249761 */     // (intrinsic_void 2132:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 249761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 249764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 249766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249773 */     GIR_RootConstrainSelectedInstOperands,
     /* 249774 */     // GIR_Coverage, 2387,
     /* 249774 */     GIR_EraseRootFromParent_Done,
     /* 249775 */   // Label 5009: @249775
     /* 249775 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(249798), // Rule ID 73 //
     /* 249780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 249785 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249788 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 249788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 249791 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 249796 */     GIR_RootConstrainSelectedInstOperands,
     /* 249797 */     // GIR_Coverage, 73,
     /* 249797 */     GIR_EraseRootFromParent_Done,
     /* 249798 */   // Label 5010: @249798
     /* 249798 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(249821), // Rule ID 75 //
     /* 249803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 249808 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249811 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 249811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 249814 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 249819 */     GIR_RootConstrainSelectedInstOperands,
     /* 249820 */     // GIR_Coverage, 75,
     /* 249820 */     GIR_EraseRootFromParent_Done,
     /* 249821 */   // Label 5011: @249821
     /* 249821 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(249848), // Rule ID 76 //
     /* 249826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 249831 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249834 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 249834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 249837 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 249842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249846 */     GIR_RootConstrainSelectedInstOperands,
     /* 249847 */     // GIR_Coverage, 76,
     /* 249847 */     GIR_EraseRootFromParent_Done,
     /* 249848 */   // Label 5012: @249848
     /* 249848 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(249881), // Rule ID 12694 //
     /* 249853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 249861 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 249864 */     // (intrinsic_void 956:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 249864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 249867 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 249877 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 249879 */     GIR_RootConstrainSelectedInstOperands,
     /* 249880 */     // GIR_Coverage, 12694,
     /* 249880 */     GIR_EraseRootFromParent_Done,
     /* 249881 */   // Label 5013: @249881
     /* 249881 */   GIM_Reject,
     /* 249882 */ // Label 4994: @249882
     /* 249882 */ GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250853),
     /* 249887 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 249890 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(249966), // Rule ID 7061 //
     /* 249895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249907 */     // MIs[0] addr
     /* 249907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249915 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 249919 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 249926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 249931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 249935 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 249941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 249944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 249946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 249949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 249952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 249955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 249965 */     // GIR_Coverage, 7061,
     /* 249965 */     GIR_EraseRootFromParent_Done,
     /* 249966 */   // Label 5015: @249966
     /* 249966 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250042), // Rule ID 7062 //
     /* 249971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 249976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 249979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 249983 */     // MIs[0] addr
     /* 249983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 249987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 249991 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 249995 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 249995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 249998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 250002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250007 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250011 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250041 */     // GIR_Coverage, 7062,
     /* 250041 */     GIR_EraseRootFromParent_Done,
     /* 250042 */   // Label 5016: @250042
     /* 250042 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250118), // Rule ID 7063 //
     /* 250047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250059 */     // MIs[0] addr
     /* 250059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 250071 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 250078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250083 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250087 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250117 */     // GIR_Coverage, 7063,
     /* 250117 */     GIR_EraseRootFromParent_Done,
     /* 250118 */   // Label 5017: @250118
     /* 250118 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250160), // Rule ID 7064 //
     /* 250123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250135 */     // MIs[0] addr
     /* 250135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250143 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 250147 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 250150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250152 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250158 */     GIR_RootConstrainSelectedInstOperands,
     /* 250159 */     // GIR_Coverage, 7064,
     /* 250159 */     GIR_EraseRootFromParent_Done,
     /* 250160 */   // Label 5018: @250160
     /* 250160 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250236), // Rule ID 7068 //
     /* 250165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250177 */     // MIs[0] addr
     /* 250177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250185 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 250189 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 250196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250235 */     // GIR_Coverage, 7068,
     /* 250235 */     GIR_EraseRootFromParent_Done,
     /* 250236 */   // Label 5019: @250236
     /* 250236 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250312), // Rule ID 7069 //
     /* 250241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250253 */     // MIs[0] addr
     /* 250253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 250265 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 250272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250281 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250311 */     // GIR_Coverage, 7069,
     /* 250311 */     GIR_EraseRootFromParent_Done,
     /* 250312 */   // Label 5020: @250312
     /* 250312 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(250388), // Rule ID 7070 //
     /* 250317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250329 */     // MIs[0] addr
     /* 250329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250337 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 250341 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 250348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250357 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250387 */     // GIR_Coverage, 7070,
     /* 250387 */     GIR_EraseRootFromParent_Done,
     /* 250388 */   // Label 5021: @250388
     /* 250388 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(250430), // Rule ID 7071 //
     /* 250393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250405 */     // MIs[0] addr
     /* 250405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250413 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 250417 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 250420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250422 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250428 */     GIR_RootConstrainSelectedInstOperands,
     /* 250429 */     // GIR_Coverage, 7071,
     /* 250429 */     GIR_EraseRootFromParent_Done,
     /* 250430 */   // Label 5022: @250430
     /* 250430 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250470), // Rule ID 20 //
     /* 250435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 250438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 250443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250457 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 250457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 250460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250462 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 250464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250468 */     GIR_RootConstrainSelectedInstOperands,
     /* 250469 */     // GIR_Coverage, 20,
     /* 250469 */     GIR_EraseRootFromParent_Done,
     /* 250470 */   // Label 5023: @250470
     /* 250470 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(250510), // Rule ID 2384 //
     /* 250475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 250483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 250486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250497 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1653:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 250497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 250500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 250502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 250504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250508 */     GIR_RootConstrainSelectedInstOperands,
     /* 250509 */     // GIR_Coverage, 2384,
     /* 250509 */     GIR_EraseRootFromParent_Done,
     /* 250510 */   // Label 5024: @250510
     /* 250510 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250550), // Rule ID 2495 //
     /* 250515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 250523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 250529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250537 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 250537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 250540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250548 */     GIR_RootConstrainSelectedInstOperands,
     /* 250549 */     // GIR_Coverage, 2495,
     /* 250549 */     GIR_EraseRootFromParent_Done,
     /* 250550 */   // Label 5025: @250550
     /* 250550 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(250590), // Rule ID 2496 //
     /* 250555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 250563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 250569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250577 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 250577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 250580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250588 */     GIR_RootConstrainSelectedInstOperands,
     /* 250589 */     // GIR_Coverage, 2496,
     /* 250589 */     GIR_EraseRootFromParent_Done,
     /* 250590 */   // Label 5026: @250590
     /* 250590 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(250630), // Rule ID 6950 //
     /* 250595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 250603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 250609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 250617 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 250617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 250620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250628 */     GIR_RootConstrainSelectedInstOperands,
     /* 250629 */     // GIR_Coverage, 6950,
     /* 250629 */     GIR_EraseRootFromParent_Done,
     /* 250630 */   // Label 5027: @250630
     /* 250630 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(250670), // Rule ID 6951 //
     /* 250635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 250638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 250643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 250646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 250649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 250657 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 250657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 250660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 250664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250668 */     GIR_RootConstrainSelectedInstOperands,
     /* 250669 */     // GIR_Coverage, 6951,
     /* 250669 */     GIR_EraseRootFromParent_Done,
     /* 250670 */   // Label 5028: @250670
     /* 250670 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(250706), // Rule ID 3577 //
     /* 250675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 250683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250693 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 250696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250704 */     GIR_RootConstrainSelectedInstOperands,
     /* 250705 */     // GIR_Coverage, 3577,
     /* 250705 */     GIR_EraseRootFromParent_Done,
     /* 250706 */   // Label 5029: @250706
     /* 250706 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(250744), // Rule ID 3991 //
     /* 250711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 250714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 250719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250729 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 250729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 250732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 250734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 250740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 250742 */     GIR_RootConstrainSelectedInstOperands,
     /* 250743 */     // GIR_Coverage, 3991,
     /* 250743 */     GIR_EraseRootFromParent_Done,
     /* 250744 */   // Label 5030: @250744
     /* 250744 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(250780), // Rule ID 12429 //
     /* 250749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 250757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250767 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 250770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250778 */     GIR_RootConstrainSelectedInstOperands,
     /* 250779 */     // GIR_Coverage, 12429,
     /* 250779 */     GIR_EraseRootFromParent_Done,
     /* 250780 */   // Label 5031: @250780
     /* 250780 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(250816), // Rule ID 12430 //
     /* 250785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 250793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250803 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 250806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250814 */     GIR_RootConstrainSelectedInstOperands,
     /* 250815 */     // GIR_Coverage, 12430,
     /* 250815 */     GIR_EraseRootFromParent_Done,
     /* 250816 */   // Label 5032: @250816
     /* 250816 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(250852), // Rule ID 12431 //
     /* 250821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 250824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 250829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 250835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250839 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 250839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 250842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 250844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250850 */     GIR_RootConstrainSelectedInstOperands,
     /* 250851 */     // GIR_Coverage, 12431,
     /* 250851 */     GIR_EraseRootFromParent_Done,
     /* 250852 */   // Label 5033: @250852
     /* 250852 */   GIM_Reject,
     /* 250853 */ // Label 5014: @250853
     /* 250853 */ GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(254825),
     /* 250858 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 250861 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(250958), // Rule ID 7079 //
     /* 250866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 250905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 250909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250914 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 250925 */     // MIs[0] addr
     /* 250925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 250929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 250937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 250939 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 250939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 250942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 250944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 250948 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 250950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 250956 */     GIR_RootConstrainSelectedInstOperands,
     /* 250957 */     // GIR_Coverage, 7079,
     /* 250957 */     GIR_EraseRootFromParent_Done,
     /* 250958 */   // Label 5035: @250958
     /* 250958 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251055), // Rule ID 7080 //
     /* 250963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 250968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 250971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 250982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 250986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 250990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 250994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 250998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251011 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251022 */     // MIs[0] addr
     /* 251022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251036 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251045 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251053 */     GIR_RootConstrainSelectedInstOperands,
     /* 251054 */     // GIR_Coverage, 7080,
     /* 251054 */     GIR_EraseRootFromParent_Done,
     /* 251055 */   // Label 5036: @251055
     /* 251055 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251152), // Rule ID 7089 //
     /* 251060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251108 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 251119 */     // MIs[0] addr
     /* 251119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251127 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 251131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251133 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 251136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251142 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251150 */     GIR_RootConstrainSelectedInstOperands,
     /* 251151 */     // GIR_Coverage, 7089,
     /* 251151 */     GIR_EraseRootFromParent_Done,
     /* 251152 */   // Label 5037: @251152
     /* 251152 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251249), // Rule ID 7090 //
     /* 251157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251205 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251216 */     // MIs[0] addr
     /* 251216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251224 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251230 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251239 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251247 */     GIR_RootConstrainSelectedInstOperands,
     /* 251248 */     // GIR_Coverage, 7090,
     /* 251248 */     GIR_EraseRootFromParent_Done,
     /* 251249 */   // Label 5038: @251249
     /* 251249 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251360), // Rule ID 7082 //
     /* 251254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251290 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 251301 */     // MIs[0] addr
     /* 251301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251309 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 251313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251315 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251327 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 251346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251351 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251358 */     GIR_RootConstrainSelectedInstOperands,
     /* 251359 */     // GIR_Coverage, 7082,
     /* 251359 */     GIR_EraseRootFromParent_Done,
     /* 251360 */   // Label 5039: @251360
     /* 251360 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251471), // Rule ID 7083 //
     /* 251365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251401 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251412 */     // MIs[0] addr
     /* 251412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251420 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251426 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251438 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251462 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251469 */     GIR_RootConstrainSelectedInstOperands,
     /* 251470 */     // GIR_Coverage, 7083,
     /* 251470 */     GIR_EraseRootFromParent_Done,
     /* 251471 */   // Label 5040: @251471
     /* 251471 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251582), // Rule ID 7084 //
     /* 251476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251512 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 251523 */     // MIs[0] addr
     /* 251523 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251531 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 251535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251537 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251549 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 251568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251573 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251580 */     GIR_RootConstrainSelectedInstOperands,
     /* 251581 */     // GIR_Coverage, 7084,
     /* 251581 */     GIR_EraseRootFromParent_Done,
     /* 251582 */   // Label 5041: @251582
     /* 251582 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(251693), // Rule ID 7092 //
     /* 251587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251623 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 251634 */     // MIs[0] addr
     /* 251634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 251646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251648 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251660 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 251679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251684 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251691 */     GIR_RootConstrainSelectedInstOperands,
     /* 251692 */     // GIR_Coverage, 7092,
     /* 251692 */     GIR_EraseRootFromParent_Done,
     /* 251693 */   // Label 5042: @251693
     /* 251693 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(251804), // Rule ID 7093 //
     /* 251698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251734 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251745 */     // MIs[0] addr
     /* 251745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251759 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251795 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251802 */     GIR_RootConstrainSelectedInstOperands,
     /* 251803 */     // GIR_Coverage, 7093,
     /* 251803 */     GIR_EraseRootFromParent_Done,
     /* 251804 */   // Label 5043: @251804
     /* 251804 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(251915), // Rule ID 7094 //
     /* 251809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251845 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 251856 */     // MIs[0] addr
     /* 251856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251864 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 251868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251870 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251882 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 251901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251906 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251913 */     GIR_RootConstrainSelectedInstOperands,
     /* 251914 */     // GIR_Coverage, 7094,
     /* 251914 */     GIR_EraseRootFromParent_Done,
     /* 251915 */   // Label 5044: @251915
     /* 251915 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(251966), // Rule ID 70 //
     /* 251920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 251925 */     // MIs[0] ptr
     /* 251925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 251929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 251933 */     // MIs[0] accessinfo
     /* 251933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 251936 */     // MIs[0] fixed_shadow
     /* 251936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251939 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 251939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 251942 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 251944 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 251946 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 251948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 251951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 251954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 251957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 251960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251964 */     GIR_RootConstrainSelectedInstOperands,
     /* 251965 */     // GIR_Coverage, 70,
     /* 251965 */     GIR_EraseRootFromParent_Done,
     /* 251966 */   // Label 5045: @251966
     /* 251966 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(252017), // Rule ID 71 //
     /* 251971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 251976 */     // MIs[0] ptr
     /* 251976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 251980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 251984 */     // MIs[0] accessinfo
     /* 251984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 251987 */     // MIs[0] fixed_shadow
     /* 251987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 251990 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 251990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 251993 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 251995 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 251997 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 251999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252015 */     GIR_RootConstrainSelectedInstOperands,
     /* 252016 */     // GIR_Coverage, 71,
     /* 252016 */     GIR_EraseRootFromParent_Done,
     /* 252017 */   // Label 5046: @252017
     /* 252017 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(252086), // Rule ID 7081 //
     /* 252022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252054 */     // MIs[0] addr
     /* 252054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 252066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252068 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 252071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252077 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252084 */     GIR_RootConstrainSelectedInstOperands,
     /* 252085 */     // GIR_Coverage, 7081,
     /* 252085 */     GIR_EraseRootFromParent_Done,
     /* 252086 */   // Label 5047: @252086
     /* 252086 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252155), // Rule ID 7091 //
     /* 252091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252123 */     // MIs[0] addr
     /* 252123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252131 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 252135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252137 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 252140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252146 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252153 */     GIR_RootConstrainSelectedInstOperands,
     /* 252154 */     // GIR_Coverage, 7091,
     /* 252154 */     GIR_EraseRootFromParent_Done,
     /* 252155 */   // Label 5048: @252155
     /* 252155 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252193), // Rule ID 3601 //
     /* 252160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252174 */     // MIs[0] tile
     /* 252174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252182 */     // (intrinsic_void 1005:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 252185 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252191 */     GIR_RootConstrainSelectedInstOperands,
     /* 252192 */     // GIR_Coverage, 3601,
     /* 252192 */     GIR_EraseRootFromParent_Done,
     /* 252193 */   // Label 5049: @252193
     /* 252193 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252231), // Rule ID 3605 //
     /* 252198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252212 */     // MIs[0] tile
     /* 252212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252215 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252220 */     // (intrinsic_void 1005:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 252223 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252229 */     GIR_RootConstrainSelectedInstOperands,
     /* 252230 */     // GIR_Coverage, 3605,
     /* 252230 */     GIR_EraseRootFromParent_Done,
     /* 252231 */   // Label 5050: @252231
     /* 252231 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(252269), // Rule ID 3609 //
     /* 252236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 252244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252250 */     // MIs[0] tile
     /* 252250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252258 */     // (intrinsic_void 1009:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 252261 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252267 */     GIR_RootConstrainSelectedInstOperands,
     /* 252268 */     // GIR_Coverage, 3609,
     /* 252268 */     GIR_EraseRootFromParent_Done,
     /* 252269 */   // Label 5051: @252269
     /* 252269 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(252307), // Rule ID 3777 //
     /* 252274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 252277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252288 */     // MIs[0] tile
     /* 252288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252296 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 252299 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252305 */     GIR_RootConstrainSelectedInstOperands,
     /* 252306 */     // GIR_Coverage, 3777,
     /* 252306 */     GIR_EraseRootFromParent_Done,
     /* 252307 */   // Label 5052: @252307
     /* 252307 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252345), // Rule ID 3781 //
     /* 252312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252326 */     // MIs[0] tile
     /* 252326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252334 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 252334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 252337 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252343 */     GIR_RootConstrainSelectedInstOperands,
     /* 252344 */     // GIR_Coverage, 3781,
     /* 252344 */     GIR_EraseRootFromParent_Done,
     /* 252345 */   // Label 5053: @252345
     /* 252345 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252383), // Rule ID 3785 //
     /* 252350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 252353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252364 */     // MIs[0] tile
     /* 252364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252372 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 252372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 252375 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252381 */     GIR_RootConstrainSelectedInstOperands,
     /* 252382 */     // GIR_Coverage, 3785,
     /* 252382 */     GIR_EraseRootFromParent_Done,
     /* 252383 */   // Label 5054: @252383
     /* 252383 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252421), // Rule ID 3789 //
     /* 252388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 252396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252402 */     // MIs[0] tile
     /* 252402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252405 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252410 */     // (intrinsic_void 906:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 252413 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252419 */     GIR_RootConstrainSelectedInstOperands,
     /* 252420 */     // GIR_Coverage, 3789,
     /* 252420 */     GIR_EraseRootFromParent_Done,
     /* 252421 */   // Label 5055: @252421
     /* 252421 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252459), // Rule ID 12508 //
     /* 252426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 252434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252440 */     // MIs[0] tile
     /* 252440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252448 */     // (intrinsic_void 1013:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 252451 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252457 */     GIR_RootConstrainSelectedInstOperands,
     /* 252458 */     // GIR_Coverage, 12508,
     /* 252458 */     GIR_EraseRootFromParent_Done,
     /* 252459 */   // Label 5056: @252459
     /* 252459 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252497), // Rule ID 12512 //
     /* 252464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 252472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252478 */     // MIs[0] tile
     /* 252478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252486 */     // (intrinsic_void 1056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 252489 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252495 */     GIR_RootConstrainSelectedInstOperands,
     /* 252496 */     // GIR_Coverage, 12512,
     /* 252496 */     GIR_EraseRootFromParent_Done,
     /* 252497 */   // Label 5057: @252497
     /* 252497 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252535), // Rule ID 12516 //
     /* 252502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 252510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252516 */     // MIs[0] tile
     /* 252516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252524 */     // (intrinsic_void 1064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 252527 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252533 */     GIR_RootConstrainSelectedInstOperands,
     /* 252534 */     // GIR_Coverage, 12516,
     /* 252534 */     GIR_EraseRootFromParent_Done,
     /* 252535 */   // Label 5058: @252535
     /* 252535 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252573), // Rule ID 12520 //
     /* 252540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 252548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252554 */     // MIs[0] tile
     /* 252554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252562 */     // (intrinsic_void 1172:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 252565 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252571 */     GIR_RootConstrainSelectedInstOperands,
     /* 252572 */     // GIR_Coverage, 12520,
     /* 252572 */     GIR_EraseRootFromParent_Done,
     /* 252573 */   // Label 5059: @252573
     /* 252573 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252611), // Rule ID 12524 //
     /* 252578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 252586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252592 */     // MIs[0] tile
     /* 252592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252600 */     // (intrinsic_void 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 252603 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252609 */     GIR_RootConstrainSelectedInstOperands,
     /* 252610 */     // GIR_Coverage, 12524,
     /* 252610 */     GIR_EraseRootFromParent_Done,
     /* 252611 */   // Label 5060: @252611
     /* 252611 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252649), // Rule ID 12528 //
     /* 252616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 252624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252630 */     // MIs[0] tile
     /* 252630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252638 */     // (intrinsic_void 1138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 252641 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252647 */     GIR_RootConstrainSelectedInstOperands,
     /* 252648 */     // GIR_Coverage, 12528,
     /* 252648 */     GIR_EraseRootFromParent_Done,
     /* 252649 */   // Label 5061: @252649
     /* 252649 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252687), // Rule ID 12532 //
     /* 252654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 252662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252668 */     // MIs[0] tile
     /* 252668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252671 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252676 */     // (intrinsic_void 1146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 252679 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252685 */     GIR_RootConstrainSelectedInstOperands,
     /* 252686 */     // GIR_Coverage, 12532,
     /* 252686 */     GIR_EraseRootFromParent_Done,
     /* 252687 */   // Label 5062: @252687
     /* 252687 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(252725), // Rule ID 12536 //
     /* 252692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 252700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252706 */     // MIs[0] tile
     /* 252706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252709 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252714 */     // (intrinsic_void 1013:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 252717 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252723 */     GIR_RootConstrainSelectedInstOperands,
     /* 252724 */     // GIR_Coverage, 12536,
     /* 252724 */     GIR_EraseRootFromParent_Done,
     /* 252725 */   // Label 5063: @252725
     /* 252725 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(252763), // Rule ID 12540 //
     /* 252730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 252738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252744 */     // MIs[0] tile
     /* 252744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252752 */     // (intrinsic_void 1138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 252755 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252761 */     GIR_RootConstrainSelectedInstOperands,
     /* 252762 */     // GIR_Coverage, 12540,
     /* 252762 */     GIR_EraseRootFromParent_Done,
     /* 252763 */   // Label 5064: @252763
     /* 252763 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(252801), // Rule ID 12544 //
     /* 252768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 252776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252782 */     // MIs[0] tile
     /* 252782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252790 */     // (intrinsic_void 1146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 252793 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252799 */     GIR_RootConstrainSelectedInstOperands,
     /* 252800 */     // GIR_Coverage, 12544,
     /* 252800 */     GIR_EraseRootFromParent_Done,
     /* 252801 */   // Label 5065: @252801
     /* 252801 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(252839), // Rule ID 12548 //
     /* 252806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 252814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252820 */     // MIs[0] tile
     /* 252820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252828 */     // (intrinsic_void 1017:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 252831 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252837 */     GIR_RootConstrainSelectedInstOperands,
     /* 252838 */     // GIR_Coverage, 12548,
     /* 252838 */     GIR_EraseRootFromParent_Done,
     /* 252839 */   // Label 5066: @252839
     /* 252839 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(252877), // Rule ID 12552 //
     /* 252844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 252852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252858 */     // MIs[0] tile
     /* 252858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252866 */     // (intrinsic_void 1060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 252869 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252875 */     GIR_RootConstrainSelectedInstOperands,
     /* 252876 */     // GIR_Coverage, 12552,
     /* 252876 */     GIR_EraseRootFromParent_Done,
     /* 252877 */   // Label 5067: @252877
     /* 252877 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(252915), // Rule ID 12556 //
     /* 252882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 252890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252896 */     // MIs[0] tile
     /* 252896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252904 */     // (intrinsic_void 1068:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 252907 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252913 */     GIR_RootConstrainSelectedInstOperands,
     /* 252914 */     // GIR_Coverage, 12556,
     /* 252914 */     GIR_EraseRootFromParent_Done,
     /* 252915 */   // Label 5068: @252915
     /* 252915 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(252953), // Rule ID 12560 //
     /* 252920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 252928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252934 */     // MIs[0] tile
     /* 252934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252942 */     // (intrinsic_void 1142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 252945 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252951 */     GIR_RootConstrainSelectedInstOperands,
     /* 252952 */     // GIR_Coverage, 12560,
     /* 252952 */     GIR_EraseRootFromParent_Done,
     /* 252953 */   // Label 5069: @252953
     /* 252953 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(252991), // Rule ID 12564 //
     /* 252958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 252966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252972 */     // MIs[0] tile
     /* 252972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252980 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 252983 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252989 */     GIR_RootConstrainSelectedInstOperands,
     /* 252990 */     // GIR_Coverage, 12564,
     /* 252990 */     GIR_EraseRootFromParent_Done,
     /* 252991 */   // Label 5070: @252991
     /* 252991 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253029), // Rule ID 12568 //
     /* 252996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 253004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253010 */     // MIs[0] tile
     /* 253010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253018 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 253021 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253027 */     GIR_RootConstrainSelectedInstOperands,
     /* 253028 */     // GIR_Coverage, 12568,
     /* 253028 */     GIR_EraseRootFromParent_Done,
     /* 253029 */   // Label 5071: @253029
     /* 253029 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253067), // Rule ID 12572 //
     /* 253034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 253042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253048 */     // MIs[0] tile
     /* 253048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253056 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 253059 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253065 */     GIR_RootConstrainSelectedInstOperands,
     /* 253066 */     // GIR_Coverage, 12572,
     /* 253066 */     GIR_EraseRootFromParent_Done,
     /* 253067 */   // Label 5072: @253067
     /* 253067 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253105), // Rule ID 13018 //
     /* 253072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 253080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253086 */     // MIs[0] tile
     /* 253086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253094 */     // (intrinsic_void 914:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 253097 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253103 */     GIR_RootConstrainSelectedInstOperands,
     /* 253104 */     // GIR_Coverage, 13018,
     /* 253104 */     GIR_EraseRootFromParent_Done,
     /* 253105 */   // Label 5073: @253105
     /* 253105 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(253143), // Rule ID 13022 //
     /* 253110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253124 */     // MIs[0] tile
     /* 253124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253132 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 253132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 253135 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253141 */     GIR_RootConstrainSelectedInstOperands,
     /* 253142 */     // GIR_Coverage, 13022,
     /* 253142 */     GIR_EraseRootFromParent_Done,
     /* 253143 */   // Label 5074: @253143
     /* 253143 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(253181), // Rule ID 13026 //
     /* 253148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 253151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253162 */     // MIs[0] tile
     /* 253162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253170 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 253173 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253179 */     GIR_RootConstrainSelectedInstOperands,
     /* 253180 */     // GIR_Coverage, 13026,
     /* 253180 */     GIR_EraseRootFromParent_Done,
     /* 253181 */   // Label 5075: @253181
     /* 253181 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(253219), // Rule ID 13030 //
     /* 253186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 253189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253200 */     // MIs[0] tile
     /* 253200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253208 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 253208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 253211 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253217 */     GIR_RootConstrainSelectedInstOperands,
     /* 253218 */     // GIR_Coverage, 13030,
     /* 253218 */     GIR_EraseRootFromParent_Done,
     /* 253219 */   // Label 5076: @253219
     /* 253219 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(253273), // Rule ID 8794 //
     /* 253224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253232 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 253235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253239 */     // MIs[0] base
     /* 253239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253247 */     // MIs[0] prfop
     /* 253247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253255 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 253258 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253260 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253262 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253271 */     GIR_RootConstrainSelectedInstOperands,
     /* 253272 */     // GIR_Coverage, 8794,
     /* 253272 */     GIR_EraseRootFromParent_Done,
     /* 253273 */   // Label 5077: @253273
     /* 253273 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253327), // Rule ID 8797 //
     /* 253278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253286 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 253289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253293 */     // MIs[0] base
     /* 253293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253301 */     // MIs[0] prfop
     /* 253301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253309 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 253312 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253314 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253316 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253325 */     GIR_RootConstrainSelectedInstOperands,
     /* 253326 */     // GIR_Coverage, 8797,
     /* 253326 */     GIR_EraseRootFromParent_Done,
     /* 253327 */   // Label 5078: @253327
     /* 253327 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253381), // Rule ID 8800 //
     /* 253332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253340 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 253343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253347 */     // MIs[0] base
     /* 253347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253355 */     // MIs[0] prfop
     /* 253355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253363 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 253366 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253368 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253370 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253379 */     GIR_RootConstrainSelectedInstOperands,
     /* 253380 */     // GIR_Coverage, 8800,
     /* 253380 */     GIR_EraseRootFromParent_Done,
     /* 253381 */   // Label 5079: @253381
     /* 253381 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253435), // Rule ID 8803 //
     /* 253386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253394 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 253397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253401 */     // MIs[0] base
     /* 253401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253409 */     // MIs[0] prfop
     /* 253409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253417 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 253420 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253422 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253424 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253433 */     GIR_RootConstrainSelectedInstOperands,
     /* 253434 */     // GIR_Coverage, 8803,
     /* 253434 */     GIR_EraseRootFromParent_Done,
     /* 253435 */   // Label 5080: @253435
     /* 253435 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253489), // Rule ID 15 //
     /* 253440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 253445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 253454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 253466 */     // MIs[1] Operand 1
     /* 253466 */     // No operand predicates
     /* 253466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 253472 */     // (intrinsic_w_chain:{ *:[i64] } 1218:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 253472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 253475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 253477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 253480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 253482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 253487 */     GIR_RootConstrainSelectedInstOperands,
     /* 253488 */     // GIR_Coverage, 15,
     /* 253488 */     GIR_EraseRootFromParent_Done,
     /* 253489 */   // Label 5081: @253489
     /* 253489 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253557), // Rule ID 68 //
     /* 253494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 253499 */     // MIs[0] Operand 1
     /* 253499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 253503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 253507 */     // MIs[0] ptr
     /* 253507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 253515 */     // MIs[0] accessinfo
     /* 253515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253518 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 253518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253522 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 253532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 253535 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 253537 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 253539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 253542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 253545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 253548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 253551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253555 */     GIR_RootConstrainSelectedInstOperands,
     /* 253556 */     // GIR_Coverage, 68,
     /* 253556 */     GIR_EraseRootFromParent_Done,
     /* 253557 */   // Label 5082: @253557
     /* 253557 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(253625), // Rule ID 69 //
     /* 253562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 253567 */     // MIs[0] Operand 1
     /* 253567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 253571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 253575 */     // MIs[0] ptr
     /* 253575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 253583 */     // MIs[0] accessinfo
     /* 253583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253586 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 253586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253590 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 253600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 253603 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 253605 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 253607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 253610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 253613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 253616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 253619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253623 */     GIR_RootConstrainSelectedInstOperands,
     /* 253624 */     // GIR_Coverage, 69,
     /* 253624 */     GIR_EraseRootFromParent_Done,
     /* 253625 */   // Label 5083: @253625
     /* 253625 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(253705), // Rule ID 7075 //
     /* 253630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253649 */     // MIs[0] addr
     /* 253649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 253661 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253673 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 253692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253697 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253703 */     GIR_RootConstrainSelectedInstOperands,
     /* 253704 */     // GIR_Coverage, 7075,
     /* 253704 */     GIR_EraseRootFromParent_Done,
     /* 253705 */   // Label 5084: @253705
     /* 253705 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(253785), // Rule ID 7076 //
     /* 253710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253729 */     // MIs[0] addr
     /* 253729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253737 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 253741 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253753 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 253772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253777 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253783 */     GIR_RootConstrainSelectedInstOperands,
     /* 253784 */     // GIR_Coverage, 7076,
     /* 253784 */     GIR_EraseRootFromParent_Done,
     /* 253785 */   // Label 5085: @253785
     /* 253785 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(253865), // Rule ID 7077 //
     /* 253790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253809 */     // MIs[0] addr
     /* 253809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253817 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 253821 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 253852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253857 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253863 */     GIR_RootConstrainSelectedInstOperands,
     /* 253864 */     // GIR_Coverage, 7077,
     /* 253864 */     GIR_EraseRootFromParent_Done,
     /* 253865 */   // Label 5086: @253865
     /* 253865 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(253916), // Rule ID 7078 //
     /* 253870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 253875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253889 */     // MIs[0] addr
     /* 253889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 253901 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 253901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 253904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253906 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 253908 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253914 */     GIR_RootConstrainSelectedInstOperands,
     /* 253915 */     // GIR_Coverage, 7078,
     /* 253915 */     GIR_EraseRootFromParent_Done,
     /* 253916 */   // Label 5087: @253916
     /* 253916 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(253996), // Rule ID 7085 //
     /* 253921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 253926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 253929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 253932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253940 */     // MIs[0] addr
     /* 253940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 253944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 253948 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 253952 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 253952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 253955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 253959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 253964 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 253970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 253975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 253983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 253985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 253988 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 253990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253994 */     GIR_RootConstrainSelectedInstOperands,
     /* 253995 */     // GIR_Coverage, 7085,
     /* 253995 */     GIR_EraseRootFromParent_Done,
     /* 253996 */   // Label 5088: @253996
     /* 253996 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254076), // Rule ID 7086 //
     /* 254001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254020 */     // MIs[0] addr
     /* 254020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254028 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 254032 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254044 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 254063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254068 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254074 */     GIR_RootConstrainSelectedInstOperands,
     /* 254075 */     // GIR_Coverage, 7086,
     /* 254075 */     GIR_EraseRootFromParent_Done,
     /* 254076 */   // Label 5089: @254076
     /* 254076 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(254156), // Rule ID 7087 //
     /* 254081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254100 */     // MIs[0] addr
     /* 254100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254112 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254124 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254148 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254154 */     GIR_RootConstrainSelectedInstOperands,
     /* 254155 */     // GIR_Coverage, 7087,
     /* 254155 */     GIR_EraseRootFromParent_Done,
     /* 254156 */   // Label 5090: @254156
     /* 254156 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254207), // Rule ID 7088 //
     /* 254161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254180 */     // MIs[0] addr
     /* 254180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 254192 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 254195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254197 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 254199 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254205 */     GIR_RootConstrainSelectedInstOperands,
     /* 254206 */     // GIR_Coverage, 7088,
     /* 254206 */     GIR_EraseRootFromParent_Done,
     /* 254207 */   // Label 5091: @254207
     /* 254207 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254256), // Rule ID 2488 //
     /* 254212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254241 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 254241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 254244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254254 */     GIR_RootConstrainSelectedInstOperands,
     /* 254255 */     // GIR_Coverage, 2488,
     /* 254255 */     GIR_EraseRootFromParent_Done,
     /* 254256 */   // Label 5092: @254256
     /* 254256 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254305), // Rule ID 2489 //
     /* 254261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 254272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254290 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 254290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 254293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254303 */     GIR_RootConstrainSelectedInstOperands,
     /* 254304 */     // GIR_Coverage, 2489,
     /* 254304 */     GIR_EraseRootFromParent_Done,
     /* 254305 */   // Label 5093: @254305
     /* 254305 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254354), // Rule ID 2490 //
     /* 254310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 254327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254339 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 254339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 254342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254352 */     GIR_RootConstrainSelectedInstOperands,
     /* 254353 */     // GIR_Coverage, 2490,
     /* 254353 */     GIR_EraseRootFromParent_Done,
     /* 254354 */   // Label 5094: @254354
     /* 254354 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254407), // Rule ID 8680 //
     /* 254359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254381 */     // MIs[0] base
     /* 254381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254389 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254396 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254405 */     GIR_RootConstrainSelectedInstOperands,
     /* 254406 */     // GIR_Coverage, 8680,
     /* 254406 */     GIR_EraseRootFromParent_Done,
     /* 254407 */   // Label 5095: @254407
     /* 254407 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254460), // Rule ID 8683 //
     /* 254412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254434 */     // MIs[0] base
     /* 254434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254442 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254449 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254458 */     GIR_RootConstrainSelectedInstOperands,
     /* 254459 */     // GIR_Coverage, 8683,
     /* 254459 */     GIR_EraseRootFromParent_Done,
     /* 254460 */   // Label 5096: @254460
     /* 254460 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254513), // Rule ID 8692 //
     /* 254465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 254473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254487 */     // MIs[0] base
     /* 254487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254495 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 254498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254502 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254511 */     GIR_RootConstrainSelectedInstOperands,
     /* 254512 */     // GIR_Coverage, 8692,
     /* 254512 */     GIR_EraseRootFromParent_Done,
     /* 254513 */   // Label 5097: @254513
     /* 254513 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254566), // Rule ID 8695 //
     /* 254518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 254526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254540 */     // MIs[0] base
     /* 254540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254548 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 254551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254555 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254564 */     GIR_RootConstrainSelectedInstOperands,
     /* 254565 */     // GIR_Coverage, 8695,
     /* 254565 */     GIR_EraseRootFromParent_Done,
     /* 254566 */   // Label 5098: @254566
     /* 254566 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254612), // Rule ID 137 //
     /* 254571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 254574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 254579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 254582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254589 */     // MIs[0] Rn
     /* 254589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254601 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 254601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 254604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254610 */     GIR_RootConstrainSelectedInstOperands,
     /* 254611 */     // GIR_Coverage, 137,
     /* 254611 */     GIR_EraseRootFromParent_Done,
     /* 254612 */   // Label 5099: @254612
     /* 254612 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254665), // Rule ID 8686 //
     /* 254617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 254625 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 254628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254639 */     // MIs[0] base
     /* 254639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254647 */     // (intrinsic_void 1873:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 254650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254654 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254663 */     GIR_RootConstrainSelectedInstOperands,
     /* 254664 */     // GIR_Coverage, 8686,
     /* 254664 */     GIR_EraseRootFromParent_Done,
     /* 254665 */   // Label 5100: @254665
     /* 254665 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254718), // Rule ID 8689 //
     /* 254670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 254678 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 254681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254692 */     // MIs[0] base
     /* 254692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254700 */     // (intrinsic_void 1873:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 254703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254707 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254716 */     GIR_RootConstrainSelectedInstOperands,
     /* 254717 */     // GIR_Coverage, 8689,
     /* 254717 */     GIR_EraseRootFromParent_Done,
     /* 254718 */   // Label 5101: @254718
     /* 254718 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254771), // Rule ID 8698 //
     /* 254723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 254731 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 254734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254745 */     // MIs[0] base
     /* 254745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254753 */     // (intrinsic_void 1869:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 254756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254760 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254769 */     GIR_RootConstrainSelectedInstOperands,
     /* 254770 */     // GIR_Coverage, 8698,
     /* 254770 */     GIR_EraseRootFromParent_Done,
     /* 254771 */   // Label 5102: @254771
     /* 254771 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(254824), // Rule ID 8701 //
     /* 254776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 254784 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 254787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254798 */     // MIs[0] base
     /* 254798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254806 */     // (intrinsic_void 1869:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 254809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 254811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254813 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254822 */     GIR_RootConstrainSelectedInstOperands,
     /* 254823 */     // GIR_Coverage, 8701,
     /* 254823 */     GIR_EraseRootFromParent_Done,
     /* 254824 */   // Label 5103: @254824
     /* 254824 */   GIM_Reject,
     /* 254825 */ // Label 5034: @254825
     /* 254825 */ GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(257530),
     /* 254830 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 254833 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(254904), // Rule ID 3413 //
     /* 254838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 254846 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 254849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 254867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 254875 */     // MIs[1] Operand 1
     /* 254875 */     // No operand predicates
     /* 254875 */     // MIs[0] prfop
     /* 254875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254885 */     // (intrinsic_void 1622:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 254885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 254888 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 254897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254902 */     GIR_RootConstrainSelectedInstOperands,
     /* 254903 */     // GIR_Coverage, 3413,
     /* 254903 */     GIR_EraseRootFromParent_Done,
     /* 254904 */   // Label 5105: @254904
     /* 254904 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(254975), // Rule ID 3426 //
     /* 254909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 254912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 254917 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 254920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 254926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 254938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 254946 */     // MIs[1] Operand 1
     /* 254946 */     // No operand predicates
     /* 254946 */     // MIs[0] prfop
     /* 254946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 254949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 254954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254956 */     // (intrinsic_void 1622:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 254956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 254959 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 254961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 254963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 254965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 254968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254973 */     GIR_RootConstrainSelectedInstOperands,
     /* 254974 */     // GIR_Coverage, 3426,
     /* 254974 */     GIR_EraseRootFromParent_Done,
     /* 254975 */   // Label 5106: @254975
     /* 254975 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(255034), // Rule ID 3613 //
     /* 254980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 254983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 254988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 254994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254997 */     // MIs[0] tile
     /* 254997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255000 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255017 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 255020 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255022 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255024 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255026 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255028 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255032 */     GIR_RootConstrainSelectedInstOperands,
     /* 255033 */     // GIR_Coverage, 3613,
     /* 255033 */     GIR_EraseRootFromParent_Done,
     /* 255034 */   // Label 5107: @255034
     /* 255034 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255093), // Rule ID 3614 //
     /* 255039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 255047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255056 */     // MIs[0] tile
     /* 255056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255076 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 255079 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255081 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255083 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255085 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255091 */     GIR_RootConstrainSelectedInstOperands,
     /* 255092 */     // GIR_Coverage, 3614,
     /* 255092 */     GIR_EraseRootFromParent_Done,
     /* 255093 */   // Label 5108: @255093
     /* 255093 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255152), // Rule ID 12489 //
     /* 255098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 255101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255115 */     // MIs[0] tile
     /* 255115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255135 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 255138 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255140 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255142 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255144 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255150 */     GIR_RootConstrainSelectedInstOperands,
     /* 255151 */     // GIR_Coverage, 12489,
     /* 255151 */     GIR_EraseRootFromParent_Done,
     /* 255152 */   // Label 5109: @255152
     /* 255152 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255211), // Rule ID 12490 //
     /* 255157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255174 */     // MIs[0] tile
     /* 255174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255194 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 255197 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255199 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255201 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255203 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255209 */     GIR_RootConstrainSelectedInstOperands,
     /* 255210 */     // GIR_Coverage, 12490,
     /* 255210 */     GIR_EraseRootFromParent_Done,
     /* 255211 */   // Label 5110: @255211
     /* 255211 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255271), // Rule ID 3411 //
     /* 255216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255224 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255234 */     // MIs[0] Rn
     /* 255234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255246 */     // MIs[0] prfop
     /* 255246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255249 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255254 */     // (intrinsic_void 1624:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 255257 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255269 */     GIR_RootConstrainSelectedInstOperands,
     /* 255270 */     // GIR_Coverage, 3411,
     /* 255270 */     GIR_EraseRootFromParent_Done,
     /* 255271 */   // Label 5111: @255271
     /* 255271 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(255331), // Rule ID 3412 //
     /* 255276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255284 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255294 */     // MIs[0] Rn
     /* 255294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255306 */     // MIs[0] prfop
     /* 255306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255309 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255314 */     // (intrinsic_void 1623:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 255317 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255329 */     GIR_RootConstrainSelectedInstOperands,
     /* 255330 */     // GIR_Coverage, 3412,
     /* 255330 */     GIR_EraseRootFromParent_Done,
     /* 255331 */   // Label 5112: @255331
     /* 255331 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255391), // Rule ID 3423 //
     /* 255336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255344 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255354 */     // MIs[0] Rn
     /* 255354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255366 */     // MIs[0] prfop
     /* 255366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255374 */     // (intrinsic_void 1624:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 255377 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255389 */     GIR_RootConstrainSelectedInstOperands,
     /* 255390 */     // GIR_Coverage, 3423,
     /* 255390 */     GIR_EraseRootFromParent_Done,
     /* 255391 */   // Label 5113: @255391
     /* 255391 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255451), // Rule ID 3424 //
     /* 255396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255404 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255414 */     // MIs[0] Rn
     /* 255414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255426 */     // MIs[0] prfop
     /* 255426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255434 */     // (intrinsic_void 1623:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 255437 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255449 */     GIR_RootConstrainSelectedInstOperands,
     /* 255450 */     // GIR_Coverage, 3424,
     /* 255450 */     GIR_EraseRootFromParent_Done,
     /* 255451 */   // Label 5114: @255451
     /* 255451 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255511), // Rule ID 3425 //
     /* 255456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 255464 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255474 */     // MIs[0] Rn
     /* 255474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255486 */     // MIs[0] prfop
     /* 255486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255494 */     // (intrinsic_void 1621:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 255494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 255497 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255509 */     GIR_RootConstrainSelectedInstOperands,
     /* 255510 */     // GIR_Coverage, 3425,
     /* 255510 */     GIR_EraseRootFromParent_Done,
     /* 255511 */   // Label 5115: @255511
     /* 255511 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255571), // Rule ID 8806 //
     /* 255516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 255524 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255534 */     // MIs[0] Rn
     /* 255534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255546 */     // MIs[0] prfop
     /* 255546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255554 */     // (intrinsic_void 1632:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 255554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 255557 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255569 */     GIR_RootConstrainSelectedInstOperands,
     /* 255570 */     // GIR_Coverage, 8806,
     /* 255570 */     GIR_EraseRootFromParent_Done,
     /* 255571 */   // Label 5116: @255571
     /* 255571 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255631), // Rule ID 8807 //
     /* 255576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 255584 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255594 */     // MIs[0] Rn
     /* 255594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255606 */     // MIs[0] prfop
     /* 255606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255614 */     // (intrinsic_void 1631:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 255614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 255617 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255629 */     GIR_RootConstrainSelectedInstOperands,
     /* 255630 */     // GIR_Coverage, 8807,
     /* 255630 */     GIR_EraseRootFromParent_Done,
     /* 255631 */   // Label 5117: @255631
     /* 255631 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255691), // Rule ID 8808 //
     /* 255636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 255644 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255654 */     // MIs[0] Rn
     /* 255654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255666 */     // MIs[0] prfop
     /* 255666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255674 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 255674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 255677 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255689 */     GIR_RootConstrainSelectedInstOperands,
     /* 255690 */     // GIR_Coverage, 8808,
     /* 255690 */     GIR_EraseRootFromParent_Done,
     /* 255691 */   // Label 5118: @255691
     /* 255691 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255751), // Rule ID 8809 //
     /* 255696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 255704 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255714 */     // MIs[0] Rn
     /* 255714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255726 */     // MIs[0] prfop
     /* 255726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255734 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 255734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 255737 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255749 */     GIR_RootConstrainSelectedInstOperands,
     /* 255750 */     // GIR_Coverage, 8809,
     /* 255750 */     GIR_EraseRootFromParent_Done,
     /* 255751 */   // Label 5119: @255751
     /* 255751 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255811), // Rule ID 8810 //
     /* 255756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 255764 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255774 */     // MIs[0] Rn
     /* 255774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255786 */     // MIs[0] prfop
     /* 255786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255794 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 255794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 255797 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255809 */     GIR_RootConstrainSelectedInstOperands,
     /* 255810 */     // GIR_Coverage, 8810,
     /* 255810 */     GIR_EraseRootFromParent_Done,
     /* 255811 */   // Label 5120: @255811
     /* 255811 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255871), // Rule ID 8811 //
     /* 255816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 255824 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255834 */     // MIs[0] Rn
     /* 255834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255846 */     // MIs[0] prfop
     /* 255846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255854 */     // (intrinsic_void 1627:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 255854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 255857 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255869 */     GIR_RootConstrainSelectedInstOperands,
     /* 255870 */     // GIR_Coverage, 8811,
     /* 255870 */     GIR_EraseRootFromParent_Done,
     /* 255871 */   // Label 5121: @255871
     /* 255871 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(255931), // Rule ID 8812 //
     /* 255876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 255884 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255894 */     // MIs[0] Rn
     /* 255894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255906 */     // MIs[0] prfop
     /* 255906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255914 */     // (intrinsic_void 1632:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 255914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 255917 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255929 */     GIR_RootConstrainSelectedInstOperands,
     /* 255930 */     // GIR_Coverage, 8812,
     /* 255930 */     GIR_EraseRootFromParent_Done,
     /* 255931 */   // Label 5122: @255931
     /* 255931 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(255991), // Rule ID 8813 //
     /* 255936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 255944 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255954 */     // MIs[0] Rn
     /* 255954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255966 */     // MIs[0] prfop
     /* 255966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255974 */     // (intrinsic_void 1631:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 255974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 255977 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255989 */     GIR_RootConstrainSelectedInstOperands,
     /* 255990 */     // GIR_Coverage, 8813,
     /* 255990 */     GIR_EraseRootFromParent_Done,
     /* 255991 */   // Label 5123: @255991
     /* 255991 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(256051), // Rule ID 8814 //
     /* 255996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 256004 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256014 */     // MIs[0] Rn
     /* 256014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256026 */     // MIs[0] prfop
     /* 256026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256034 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 256037 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256049 */     GIR_RootConstrainSelectedInstOperands,
     /* 256050 */     // GIR_Coverage, 8814,
     /* 256050 */     GIR_EraseRootFromParent_Done,
     /* 256051 */   // Label 5124: @256051
     /* 256051 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(256111), // Rule ID 8815 //
     /* 256056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 256064 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256074 */     // MIs[0] Rn
     /* 256074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256086 */     // MIs[0] prfop
     /* 256086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256094 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 256097 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256109 */     GIR_RootConstrainSelectedInstOperands,
     /* 256110 */     // GIR_Coverage, 8815,
     /* 256110 */     GIR_EraseRootFromParent_Done,
     /* 256111 */   // Label 5125: @256111
     /* 256111 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(256171), // Rule ID 8816 //
     /* 256116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 256124 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256134 */     // MIs[0] Rn
     /* 256134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256146 */     // MIs[0] prfop
     /* 256146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256149 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256154 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 256157 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256169 */     GIR_RootConstrainSelectedInstOperands,
     /* 256170 */     // GIR_Coverage, 8816,
     /* 256170 */     GIR_EraseRootFromParent_Done,
     /* 256171 */   // Label 5126: @256171
     /* 256171 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(256231), // Rule ID 8817 //
     /* 256176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 256184 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256194 */     // MIs[0] Rn
     /* 256194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256206 */     // MIs[0] prfop
     /* 256206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256214 */     // (intrinsic_void 1627:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 256217 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256229 */     GIR_RootConstrainSelectedInstOperands,
     /* 256230 */     // GIR_Coverage, 8817,
     /* 256230 */     GIR_EraseRootFromParent_Done,
     /* 256231 */   // Label 5127: @256231
     /* 256231 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(256291), // Rule ID 8818 //
     /* 256236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 256244 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256254 */     // MIs[0] Rn
     /* 256254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256266 */     // MIs[0] prfop
     /* 256266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256274 */     // (intrinsic_void 1629:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 256274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 256277 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256289 */     GIR_RootConstrainSelectedInstOperands,
     /* 256290 */     // GIR_Coverage, 8818,
     /* 256290 */     GIR_EraseRootFromParent_Done,
     /* 256291 */   // Label 5128: @256291
     /* 256291 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(256351), // Rule ID 8819 //
     /* 256296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 256304 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256314 */     // MIs[0] Rn
     /* 256314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256326 */     // MIs[0] prfop
     /* 256326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256334 */     // (intrinsic_void 1633:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 256334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 256337 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256349 */     GIR_RootConstrainSelectedInstOperands,
     /* 256350 */     // GIR_Coverage, 8819,
     /* 256350 */     GIR_EraseRootFromParent_Done,
     /* 256351 */   // Label 5129: @256351
     /* 256351 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(256411), // Rule ID 8820 //
     /* 256356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 256364 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256374 */     // MIs[0] Rn
     /* 256374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256386 */     // MIs[0] prfop
     /* 256386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256389 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256394 */     // (intrinsic_void 1625:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 256394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 256397 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256409 */     GIR_RootConstrainSelectedInstOperands,
     /* 256410 */     // GIR_Coverage, 8820,
     /* 256410 */     GIR_EraseRootFromParent_Done,
     /* 256411 */   // Label 5130: @256411
     /* 256411 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256469), // Rule ID 2374 //
     /* 256416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 256424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256452 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 256455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256467 */     GIR_RootConstrainSelectedInstOperands,
     /* 256468 */     // GIR_Coverage, 2374,
     /* 256468 */     GIR_EraseRootFromParent_Done,
     /* 256469 */   // Label 5131: @256469
     /* 256469 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256527), // Rule ID 2375 //
     /* 256474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 256482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256510 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 256513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256525 */     GIR_RootConstrainSelectedInstOperands,
     /* 256526 */     // GIR_Coverage, 2375,
     /* 256526 */     GIR_EraseRootFromParent_Done,
     /* 256527 */   // Label 5132: @256527
     /* 256527 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256585), // Rule ID 2376 //
     /* 256532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 256540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256568 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 256571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256583 */     GIR_RootConstrainSelectedInstOperands,
     /* 256584 */     // GIR_Coverage, 2376,
     /* 256584 */     GIR_EraseRootFromParent_Done,
     /* 256585 */   // Label 5133: @256585
     /* 256585 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256643), // Rule ID 2377 //
     /* 256590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 256598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256626 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 256629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256641 */     GIR_RootConstrainSelectedInstOperands,
     /* 256642 */     // GIR_Coverage, 2377,
     /* 256642 */     GIR_EraseRootFromParent_Done,
     /* 256643 */   // Label 5134: @256643
     /* 256643 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256701), // Rule ID 2378 //
     /* 256648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 256656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256684 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 256687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256699 */     GIR_RootConstrainSelectedInstOperands,
     /* 256700 */     // GIR_Coverage, 2378,
     /* 256700 */     GIR_EraseRootFromParent_Done,
     /* 256701 */   // Label 5135: @256701
     /* 256701 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256759), // Rule ID 2379 //
     /* 256706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 256714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256742 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 256745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256757 */     GIR_RootConstrainSelectedInstOperands,
     /* 256758 */     // GIR_Coverage, 2379,
     /* 256758 */     GIR_EraseRootFromParent_Done,
     /* 256759 */   // Label 5136: @256759
     /* 256759 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256817), // Rule ID 2380 //
     /* 256764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 256767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 256772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 256775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 256778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 256784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256800 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 256800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 256803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256815 */     GIR_RootConstrainSelectedInstOperands,
     /* 256816 */     // GIR_Coverage, 2380,
     /* 256816 */     GIR_EraseRootFromParent_Done,
     /* 256817 */   // Label 5137: @256817
     /* 256817 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256875), // Rule ID 2381 //
     /* 256822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 256825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 256830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256858 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 256861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256873 */     GIR_RootConstrainSelectedInstOperands,
     /* 256874 */     // GIR_Coverage, 2381,
     /* 256874 */     GIR_EraseRootFromParent_Done,
     /* 256875 */   // Label 5138: @256875
     /* 256875 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(256933), // Rule ID 2382 //
     /* 256880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 256883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 256888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 256891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 256894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 256897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 256900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 256916 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 256916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 256919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256931 */     GIR_RootConstrainSelectedInstOperands,
     /* 256932 */     // GIR_Coverage, 2382,
     /* 256932 */     GIR_EraseRootFromParent_Done,
     /* 256933 */   // Label 5139: @256933
     /* 256933 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(256991), // Rule ID 2383 //
     /* 256938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 256941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 256946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 256949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 256952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256974 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 256977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256989 */     GIR_RootConstrainSelectedInstOperands,
     /* 256990 */     // GIR_Coverage, 2383,
     /* 256990 */     GIR_EraseRootFromParent_Done,
     /* 256991 */   // Label 5140: @256991
     /* 256991 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(257049), // Rule ID 2491 //
     /* 256996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 256999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 257004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257032 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 257032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 257035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257037 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 257039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257047 */     GIR_RootConstrainSelectedInstOperands,
     /* 257048 */     // GIR_Coverage, 2491,
     /* 257048 */     GIR_EraseRootFromParent_Done,
     /* 257049 */   // Label 5141: @257049
     /* 257049 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(257105), // Rule ID 13047 //
     /* 257054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 257059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257080 */     // MIs[0] addr
     /* 257080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257088 */     // (intrinsic_w_chain:{ *:[i32] } 1224:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 257091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257093 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257095 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257097 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257103 */     GIR_RootConstrainSelectedInstOperands,
     /* 257104 */     // GIR_Coverage, 13047,
     /* 257104 */     GIR_EraseRootFromParent_Done,
     /* 257105 */   // Label 5142: @257105
     /* 257105 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257161), // Rule ID 13048 //
     /* 257110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 257115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257136 */     // MIs[0] addr
     /* 257136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257144 */     // (intrinsic_w_chain:{ *:[i32] } 1226:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 257147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257149 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257151 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257153 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257159 */     GIR_RootConstrainSelectedInstOperands,
     /* 257160 */     // GIR_Coverage, 13048,
     /* 257160 */     GIR_EraseRootFromParent_Done,
     /* 257161 */   // Label 5143: @257161
     /* 257161 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(257207), // Rule ID 3459 //
     /* 257166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 257169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 257174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257190 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1489:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 257193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257205 */     GIR_RootConstrainSelectedInstOperands,
     /* 257206 */     // GIR_Coverage, 3459,
     /* 257206 */     GIR_EraseRootFromParent_Done,
     /* 257207 */   // Label 5144: @257207
     /* 257207 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(257253), // Rule ID 3581 //
     /* 257212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 257220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257236 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 257239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257251 */     GIR_RootConstrainSelectedInstOperands,
     /* 257252 */     // GIR_Coverage, 3581,
     /* 257252 */     GIR_EraseRootFromParent_Done,
     /* 257253 */   // Label 5145: @257253
     /* 257253 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257299), // Rule ID 12476 //
     /* 257258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 257266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257282 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1501:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 257285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257297 */     GIR_RootConstrainSelectedInstOperands,
     /* 257298 */     // GIR_Coverage, 12476,
     /* 257298 */     GIR_EraseRootFromParent_Done,
     /* 257299 */   // Label 5146: @257299
     /* 257299 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257345), // Rule ID 12480 //
     /* 257304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 257312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257328 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 257331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257343 */     GIR_RootConstrainSelectedInstOperands,
     /* 257344 */     // GIR_Coverage, 12480,
     /* 257344 */     GIR_EraseRootFromParent_Done,
     /* 257345 */   // Label 5147: @257345
     /* 257345 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257391), // Rule ID 12481 //
     /* 257350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 257358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257374 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 257377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257389 */     GIR_RootConstrainSelectedInstOperands,
     /* 257390 */     // GIR_Coverage, 12481,
     /* 257390 */     GIR_EraseRootFromParent_Done,
     /* 257391 */   // Label 5148: @257391
     /* 257391 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257437), // Rule ID 12482 //
     /* 257396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 257404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257420 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1497:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 257423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257435 */     GIR_RootConstrainSelectedInstOperands,
     /* 257436 */     // GIR_Coverage, 12482,
     /* 257436 */     GIR_EraseRootFromParent_Done,
     /* 257437 */   // Label 5149: @257437
     /* 257437 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257483), // Rule ID 12483 //
     /* 257442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 257450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257466 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1499:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 257469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257481 */     GIR_RootConstrainSelectedInstOperands,
     /* 257482 */     // GIR_Coverage, 12483,
     /* 257482 */     GIR_EraseRootFromParent_Done,
     /* 257483 */   // Label 5150: @257483
     /* 257483 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257529), // Rule ID 12484 //
     /* 257488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 257491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 257496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257512 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1489:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 257515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257527 */     GIR_RootConstrainSelectedInstOperands,
     /* 257528 */     // GIR_Coverage, 12484,
     /* 257528 */     GIR_EraseRootFromParent_Done,
     /* 257529 */   // Label 5151: @257529
     /* 257529 */   GIM_Reject,
     /* 257530 */ // Label 5104: @257530
     /* 257530 */ GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(260523),
     /* 257535 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 257538 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257606), // Rule ID 2518 //
     /* 257543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 257551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257579 */     // MIs[0] Idx
     /* 257579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257587 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 257590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257598 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257604 */     GIR_RootConstrainSelectedInstOperands,
     /* 257605 */     // GIR_Coverage, 2518,
     /* 257605 */     GIR_EraseRootFromParent_Done,
     /* 257606 */   // Label 5153: @257606
     /* 257606 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257674), // Rule ID 2519 //
     /* 257611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 257619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257647 */     // MIs[0] Idx
     /* 257647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257655 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 257658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257666 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257672 */     GIR_RootConstrainSelectedInstOperands,
     /* 257673 */     // GIR_Coverage, 2519,
     /* 257673 */     GIR_EraseRootFromParent_Done,
     /* 257674 */   // Label 5154: @257674
     /* 257674 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(257742), // Rule ID 2520 //
     /* 257679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 257687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 257690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257715 */     // MIs[0] Idx
     /* 257715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257718 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 257723 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 257726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257734 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257740 */     GIR_RootConstrainSelectedInstOperands,
     /* 257741 */     // GIR_Coverage, 2520,
     /* 257741 */     GIR_EraseRootFromParent_Done,
     /* 257742 */   // Label 5155: @257742
     /* 257742 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(257810), // Rule ID 2521 //
     /* 257747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 257755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257783 */     // MIs[0] Idx
     /* 257783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 257791 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 257794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257802 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257808 */     GIR_RootConstrainSelectedInstOperands,
     /* 257809 */     // GIR_Coverage, 2521,
     /* 257809 */     GIR_EraseRootFromParent_Done,
     /* 257810 */   // Label 5156: @257810
     /* 257810 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(257878), // Rule ID 2522 //
     /* 257815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 257823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 257826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 257851 */     // MIs[0] Idx
     /* 257851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 257859 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 257862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257870 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257876 */     GIR_RootConstrainSelectedInstOperands,
     /* 257877 */     // GIR_Coverage, 2522,
     /* 257877 */     GIR_EraseRootFromParent_Done,
     /* 257878 */   // Label 5157: @257878
     /* 257878 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(257946), // Rule ID 2523 //
     /* 257883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 257891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 257919 */     // MIs[0] Idx
     /* 257919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 257927 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 257930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257938 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 257940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257944 */     GIR_RootConstrainSelectedInstOperands,
     /* 257945 */     // GIR_Coverage, 2523,
     /* 257945 */     GIR_EraseRootFromParent_Done,
     /* 257946 */   // Label 5158: @257946
     /* 257946 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(258014), // Rule ID 6952 //
     /* 257951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 257959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 257987 */     // MIs[0] Idx
     /* 257987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 257990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 257995 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 257995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 257998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258006 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258012 */     GIR_RootConstrainSelectedInstOperands,
     /* 258013 */     // GIR_Coverage, 6952,
     /* 258013 */     GIR_EraseRootFromParent_Done,
     /* 258014 */   // Label 5159: @258014
     /* 258014 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(258082), // Rule ID 6953 //
     /* 258019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 258027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258055 */     // MIs[0] Idx
     /* 258055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258063 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 258066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258074 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258080 */     GIR_RootConstrainSelectedInstOperands,
     /* 258081 */     // GIR_Coverage, 6953,
     /* 258081 */     GIR_EraseRootFromParent_Done,
     /* 258082 */   // Label 5160: @258082
     /* 258082 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(258150), // Rule ID 6954 //
     /* 258087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 258095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258123 */     // MIs[0] Idx
     /* 258123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258131 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 258134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258142 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258148 */     GIR_RootConstrainSelectedInstOperands,
     /* 258149 */     // GIR_Coverage, 6954,
     /* 258149 */     GIR_EraseRootFromParent_Done,
     /* 258150 */   // Label 5161: @258150
     /* 258150 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(258218), // Rule ID 6955 //
     /* 258155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 258163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258191 */     // MIs[0] Idx
     /* 258191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258199 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 258202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258210 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258216 */     GIR_RootConstrainSelectedInstOperands,
     /* 258217 */     // GIR_Coverage, 6955,
     /* 258217 */     GIR_EraseRootFromParent_Done,
     /* 258218 */   // Label 5162: @258218
     /* 258218 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(258278), // Rule ID 3593 //
     /* 258223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258243 */     // MIs[0] tile
     /* 258243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258259 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 258259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 258262 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258270 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258276 */     GIR_RootConstrainSelectedInstOperands,
     /* 258277 */     // GIR_Coverage, 3593,
     /* 258277 */     GIR_EraseRootFromParent_Done,
     /* 258278 */   // Label 5163: @258278
     /* 258278 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(258338), // Rule ID 3594 //
     /* 258283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 258286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 258291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258303 */     // MIs[0] tile
     /* 258303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258319 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 258322 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258330 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258336 */     GIR_RootConstrainSelectedInstOperands,
     /* 258337 */     // GIR_Coverage, 3594,
     /* 258337 */     GIR_EraseRootFromParent_Done,
     /* 258338 */   // Label 5164: @258338
     /* 258338 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258398), // Rule ID 3595 //
     /* 258343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 258346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 258357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258363 */     // MIs[0] tile
     /* 258363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258379 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 258379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 258382 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258388 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258390 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258396 */     GIR_RootConstrainSelectedInstOperands,
     /* 258397 */     // GIR_Coverage, 3595,
     /* 258397 */     GIR_EraseRootFromParent_Done,
     /* 258398 */   // Label 5165: @258398
     /* 258398 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258458), // Rule ID 3596 //
     /* 258403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 258406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 258411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258423 */     // MIs[0] tile
     /* 258423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 258431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258439 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 258442 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258450 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258456 */     GIR_RootConstrainSelectedInstOperands,
     /* 258457 */     // GIR_Coverage, 3596,
     /* 258457 */     GIR_EraseRootFromParent_Done,
     /* 258458 */   // Label 5166: @258458
     /* 258458 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258518), // Rule ID 3597 //
     /* 258463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 258466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258483 */     // MIs[0] tile
     /* 258483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 258491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258499 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 258502 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258510 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258516 */     GIR_RootConstrainSelectedInstOperands,
     /* 258517 */     // GIR_Coverage, 3597,
     /* 258517 */     GIR_EraseRootFromParent_Done,
     /* 258518 */   // Label 5167: @258518
     /* 258518 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258578), // Rule ID 3598 //
     /* 258523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 258531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258543 */     // MIs[0] tile
     /* 258543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258559 */     // (intrinsic_void 1021:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 258562 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258570 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258576 */     GIR_RootConstrainSelectedInstOperands,
     /* 258577 */     // GIR_Coverage, 3598,
     /* 258577 */     GIR_EraseRootFromParent_Done,
     /* 258578 */   // Label 5168: @258578
     /* 258578 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258638), // Rule ID 3599 //
     /* 258583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 258586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 258591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258603 */     // MIs[0] tile
     /* 258603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258619 */     // (intrinsic_void 1021:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 258622 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258630 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258636 */     GIR_RootConstrainSelectedInstOperands,
     /* 258637 */     // GIR_Coverage, 3599,
     /* 258637 */     GIR_EraseRootFromParent_Done,
     /* 258638 */   // Label 5169: @258638
     /* 258638 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258698), // Rule ID 3600 //
     /* 258643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 258651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258663 */     // MIs[0] tile
     /* 258663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258679 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 258682 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258690 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258696 */     GIR_RootConstrainSelectedInstOperands,
     /* 258697 */     // GIR_Coverage, 3600,
     /* 258697 */     GIR_EraseRootFromParent_Done,
     /* 258698 */   // Label 5170: @258698
     /* 258698 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258758), // Rule ID 3694 //
     /* 258703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 258706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 258711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258723 */     // MIs[0] tile
     /* 258723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258726 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258739 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 258739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 258742 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258750 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258756 */     GIR_RootConstrainSelectedInstOperands,
     /* 258757 */     // GIR_Coverage, 3694,
     /* 258757 */     GIR_EraseRootFromParent_Done,
     /* 258758 */   // Label 5171: @258758
     /* 258758 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258818), // Rule ID 3695 //
     /* 258763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 258766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 258771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258783 */     // MIs[0] tile
     /* 258783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258799 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 258799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 258802 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258810 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258816 */     GIR_RootConstrainSelectedInstOperands,
     /* 258817 */     // GIR_Coverage, 3695,
     /* 258817 */     GIR_EraseRootFromParent_Done,
     /* 258818 */   // Label 5172: @258818
     /* 258818 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258878), // Rule ID 12491 //
     /* 258823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 258831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258843 */     // MIs[0] tile
     /* 258843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258859 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 258859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 258862 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258868 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258870 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258876 */     GIR_RootConstrainSelectedInstOperands,
     /* 258877 */     // GIR_Coverage, 12491,
     /* 258877 */     GIR_EraseRootFromParent_Done,
     /* 258878 */   // Label 5173: @258878
     /* 258878 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258938), // Rule ID 12492 //
     /* 258883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 258886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 258891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 258897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258903 */     // MIs[0] tile
     /* 258903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258919 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 258919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 258922 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258930 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258936 */     GIR_RootConstrainSelectedInstOperands,
     /* 258937 */     // GIR_Coverage, 12492,
     /* 258937 */     GIR_EraseRootFromParent_Done,
     /* 258938 */   // Label 5174: @258938
     /* 258938 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(258998), // Rule ID 12493 //
     /* 258943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 258951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 258957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258963 */     // MIs[0] tile
     /* 258963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258966 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258979 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 258979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 258982 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258990 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258996 */     GIR_RootConstrainSelectedInstOperands,
     /* 258997 */     // GIR_Coverage, 12493,
     /* 258997 */     GIR_EraseRootFromParent_Done,
     /* 258998 */   // Label 5175: @258998
     /* 258998 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(259058), // Rule ID 12494 //
     /* 259003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259023 */     // MIs[0] tile
     /* 259023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259039 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 259042 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259050 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259056 */     GIR_RootConstrainSelectedInstOperands,
     /* 259057 */     // GIR_Coverage, 12494,
     /* 259057 */     GIR_EraseRootFromParent_Done,
     /* 259058 */   // Label 5176: @259058
     /* 259058 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(259118), // Rule ID 12495 //
     /* 259063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 259071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259083 */     // MIs[0] tile
     /* 259083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259099 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 259102 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259110 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259116 */     GIR_RootConstrainSelectedInstOperands,
     /* 259117 */     // GIR_Coverage, 12495,
     /* 259117 */     GIR_EraseRootFromParent_Done,
     /* 259118 */   // Label 5177: @259118
     /* 259118 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(259178), // Rule ID 12496 //
     /* 259123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 259131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259143 */     // MIs[0] tile
     /* 259143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259159 */     // (intrinsic_void 1156:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 259162 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259170 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259176 */     GIR_RootConstrainSelectedInstOperands,
     /* 259177 */     // GIR_Coverage, 12496,
     /* 259177 */     GIR_EraseRootFromParent_Done,
     /* 259178 */   // Label 5178: @259178
     /* 259178 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(259238), // Rule ID 12497 //
     /* 259183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 259191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259203 */     // MIs[0] tile
     /* 259203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259219 */     // (intrinsic_void 1072:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 259222 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259230 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259236 */     GIR_RootConstrainSelectedInstOperands,
     /* 259237 */     // GIR_Coverage, 12497,
     /* 259237 */     GIR_EraseRootFromParent_Done,
     /* 259238 */   // Label 5179: @259238
     /* 259238 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(259298), // Rule ID 12498 //
     /* 259243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 259251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259263 */     // MIs[0] tile
     /* 259263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259279 */     // (intrinsic_void 1073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 259282 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259290 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259296 */     GIR_RootConstrainSelectedInstOperands,
     /* 259297 */     // GIR_Coverage, 12498,
     /* 259297 */     GIR_EraseRootFromParent_Done,
     /* 259298 */   // Label 5180: @259298
     /* 259298 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259358), // Rule ID 12499 //
     /* 259303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259323 */     // MIs[0] tile
     /* 259323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259339 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 259342 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259350 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259356 */     GIR_RootConstrainSelectedInstOperands,
     /* 259357 */     // GIR_Coverage, 12499,
     /* 259357 */     GIR_EraseRootFromParent_Done,
     /* 259358 */   // Label 5181: @259358
     /* 259358 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259418), // Rule ID 12500 //
     /* 259363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 259371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259383 */     // MIs[0] tile
     /* 259383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259399 */     // (intrinsic_void 1189:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 259402 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259410 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259416 */     GIR_RootConstrainSelectedInstOperands,
     /* 259417 */     // GIR_Coverage, 12500,
     /* 259417 */     GIR_EraseRootFromParent_Done,
     /* 259418 */   // Label 5182: @259418
     /* 259418 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259478), // Rule ID 12501 //
     /* 259423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259443 */     // MIs[0] tile
     /* 259443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259446 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259459 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 259462 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259470 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259476 */     GIR_RootConstrainSelectedInstOperands,
     /* 259477 */     // GIR_Coverage, 12501,
     /* 259477 */     GIR_EraseRootFromParent_Done,
     /* 259478 */   // Label 5183: @259478
     /* 259478 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259538), // Rule ID 12502 //
     /* 259483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 259491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259503 */     // MIs[0] tile
     /* 259503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259519 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 259522 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259530 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259536 */     GIR_RootConstrainSelectedInstOperands,
     /* 259537 */     // GIR_Coverage, 12502,
     /* 259537 */     GIR_EraseRootFromParent_Done,
     /* 259538 */   // Label 5184: @259538
     /* 259538 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(259598), // Rule ID 12503 //
     /* 259543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 259551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259563 */     // MIs[0] tile
     /* 259563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259579 */     // (intrinsic_void 1156:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 259582 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259590 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259596 */     GIR_RootConstrainSelectedInstOperands,
     /* 259597 */     // GIR_Coverage, 12503,
     /* 259597 */     GIR_EraseRootFromParent_Done,
     /* 259598 */   // Label 5185: @259598
     /* 259598 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259658), // Rule ID 12504 //
     /* 259603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 259611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259623 */     // MIs[0] tile
     /* 259623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259639 */     // (intrinsic_void 1072:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 259642 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259650 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259656 */     GIR_RootConstrainSelectedInstOperands,
     /* 259657 */     // GIR_Coverage, 12504,
     /* 259657 */     GIR_EraseRootFromParent_Done,
     /* 259658 */   // Label 5186: @259658
     /* 259658 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(259718), // Rule ID 12505 //
     /* 259663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 259671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259683 */     // MIs[0] tile
     /* 259683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259699 */     // (intrinsic_void 1073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 259702 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259710 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259716 */     GIR_RootConstrainSelectedInstOperands,
     /* 259717 */     // GIR_Coverage, 12505,
     /* 259717 */     GIR_EraseRootFromParent_Done,
     /* 259718 */   // Label 5187: @259718
     /* 259718 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(259778), // Rule ID 12506 //
     /* 259723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259743 */     // MIs[0] tile
     /* 259743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259759 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 259762 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259770 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259776 */     GIR_RootConstrainSelectedInstOperands,
     /* 259777 */     // GIR_Coverage, 12506,
     /* 259777 */     GIR_EraseRootFromParent_Done,
     /* 259778 */   // Label 5188: @259778
     /* 259778 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(259838), // Rule ID 12507 //
     /* 259783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 259791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259803 */     // MIs[0] tile
     /* 259803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259819 */     // (intrinsic_void 1189:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 259822 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259830 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259836 */     GIR_RootConstrainSelectedInstOperands,
     /* 259837 */     // GIR_Coverage, 12507,
     /* 259837 */     GIR_EraseRootFromParent_Done,
     /* 259838 */   // Label 5189: @259838
     /* 259838 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(259898), // Rule ID 12872 //
     /* 259843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 259851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259863 */     // MIs[0] tile
     /* 259863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259879 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 259879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 259882 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259890 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259896 */     GIR_RootConstrainSelectedInstOperands,
     /* 259897 */     // GIR_Coverage, 12872,
     /* 259897 */     GIR_EraseRootFromParent_Done,
     /* 259898 */   // Label 5190: @259898
     /* 259898 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(259958), // Rule ID 12873 //
     /* 259903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 259911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259923 */     // MIs[0] tile
     /* 259923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259939 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 259942 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259950 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259956 */     GIR_RootConstrainSelectedInstOperands,
     /* 259957 */     // GIR_Coverage, 12873,
     /* 259957 */     GIR_EraseRootFromParent_Done,
     /* 259958 */   // Label 5191: @259958
     /* 259958 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(260018), // Rule ID 12874 //
     /* 259963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 259971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259983 */     // MIs[0] tile
     /* 259983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259999 */     // (intrinsic_void 1155:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 260002 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260010 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260016 */     GIR_RootConstrainSelectedInstOperands,
     /* 260017 */     // GIR_Coverage, 12874,
     /* 260017 */     GIR_EraseRootFromParent_Done,
     /* 260018 */   // Label 5192: @260018
     /* 260018 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(260078), // Rule ID 12875 //
     /* 260023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 260031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260043 */     // MIs[0] tile
     /* 260043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260059 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 260062 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260070 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260076 */     GIR_RootConstrainSelectedInstOperands,
     /* 260077 */     // GIR_Coverage, 12875,
     /* 260077 */     GIR_EraseRootFromParent_Done,
     /* 260078 */   // Label 5193: @260078
     /* 260078 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(260138), // Rule ID 12986 //
     /* 260083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 260086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 260091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260103 */     // MIs[0] tile
     /* 260103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 260111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260119 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 260119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 260122 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260130 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260136 */     GIR_RootConstrainSelectedInstOperands,
     /* 260137 */     // GIR_Coverage, 12986,
     /* 260137 */     GIR_EraseRootFromParent_Done,
     /* 260138 */   // Label 5194: @260138
     /* 260138 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(260186), // Rule ID 3580 //
     /* 260143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 260151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260167 */     // MIs[0] Op4
     /* 260167 */     // No operand predicates
     /* 260167 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1492:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 260170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260178 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260184 */     GIR_RootConstrainSelectedInstOperands,
     /* 260185 */     // GIR_Coverage, 3580,
     /* 260185 */     GIR_EraseRootFromParent_Done,
     /* 260186 */   // Label 5195: @260186
     /* 260186 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(260234), // Rule ID 3582 //
     /* 260191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 260199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260215 */     // MIs[0] Op4
     /* 260215 */     // No operand predicates
     /* 260215 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 260218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260226 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260232 */     GIR_RootConstrainSelectedInstOperands,
     /* 260233 */     // GIR_Coverage, 3582,
     /* 260233 */     GIR_EraseRootFromParent_Done,
     /* 260234 */   // Label 5196: @260234
     /* 260234 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(260282), // Rule ID 3583 //
     /* 260239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 260242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260263 */     // MIs[0] Op4
     /* 260263 */     // No operand predicates
     /* 260263 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 260266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260274 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260280 */     GIR_RootConstrainSelectedInstOperands,
     /* 260281 */     // GIR_Coverage, 3583,
     /* 260281 */     GIR_EraseRootFromParent_Done,
     /* 260282 */   // Label 5197: @260282
     /* 260282 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(260330), // Rule ID 3584 //
     /* 260287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 260290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260311 */     // MIs[0] Op4
     /* 260311 */     // No operand predicates
     /* 260311 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 260314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260322 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260328 */     GIR_RootConstrainSelectedInstOperands,
     /* 260329 */     // GIR_Coverage, 3584,
     /* 260329 */     GIR_EraseRootFromParent_Done,
     /* 260330 */   // Label 5198: @260330
     /* 260330 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(260378), // Rule ID 12475 //
     /* 260335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 260343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260359 */     // MIs[0] Op4
     /* 260359 */     // No operand predicates
     /* 260359 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1502:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 260362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260370 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260376 */     GIR_RootConstrainSelectedInstOperands,
     /* 260377 */     // GIR_Coverage, 12475,
     /* 260377 */     GIR_EraseRootFromParent_Done,
     /* 260378 */   // Label 5199: @260378
     /* 260378 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260426), // Rule ID 12477 //
     /* 260383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 260391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260407 */     // MIs[0] Op4
     /* 260407 */     // No operand predicates
     /* 260407 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1496:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 260410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260418 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260424 */     GIR_RootConstrainSelectedInstOperands,
     /* 260425 */     // GIR_Coverage, 12477,
     /* 260425 */     GIR_EraseRootFromParent_Done,
     /* 260426 */   // Label 5200: @260426
     /* 260426 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260474), // Rule ID 12478 //
     /* 260431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 260439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260455 */     // MIs[0] Op4
     /* 260455 */     // No operand predicates
     /* 260455 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1498:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 260458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260466 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260472 */     GIR_RootConstrainSelectedInstOperands,
     /* 260473 */     // GIR_Coverage, 12478,
     /* 260473 */     GIR_EraseRootFromParent_Done,
     /* 260474 */   // Label 5201: @260474
     /* 260474 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260522), // Rule ID 12479 //
     /* 260479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 260487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260503 */     // MIs[0] Op4
     /* 260503 */     // No operand predicates
     /* 260503 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1500:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 260506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260514 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260520 */     GIR_RootConstrainSelectedInstOperands,
     /* 260521 */     // GIR_Coverage, 12479,
     /* 260521 */     GIR_EraseRootFromParent_Done,
     /* 260522 */   // Label 5202: @260522
     /* 260522 */   GIM_Reject,
     /* 260523 */ // Label 5152: @260523
     /* 260523 */ GIM_Reject,
     /* 260524 */ // Label 37: @260524
     /* 260524 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5207*/ GIMT_Encode4(260813),
     /* 260535 */ /*GILLT_s64*//*Label 5203*/ GIMT_Encode4(260567), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 260547 */ /*GILLT_v2s64*//*Label 5204*/ GIMT_Encode4(260627), GIMT_Encode4(0),
     /* 260555 */ /*GILLT_v4s32*//*Label 5205*/ GIMT_Encode4(260689), GIMT_Encode4(0),
     /* 260563 */ /*GILLT_v8s16*//*Label 5206*/ GIMT_Encode4(260751),
     /* 260567 */ // Label 5203: @260567
     /* 260567 */ GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260626), // Rule ID 6464 //
     /* 260572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 260575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260583 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 260583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 260586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 260597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 260607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 260610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 260620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 260625 */   // GIR_Coverage, 6464,
     /* 260625 */   GIR_EraseRootFromParent_Done,
     /* 260626 */ // Label 5208: @260626
     /* 260626 */ GIM_Reject,
     /* 260627 */ // Label 5204: @260627
     /* 260627 */ GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(260688),
     /* 260632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 260635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260639 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(260666), // Rule ID 6336 //
     /* 260644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 260651 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 260651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 260654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260664 */     GIR_RootConstrainSelectedInstOperands,
     /* 260665 */     // GIR_Coverage, 6336,
     /* 260665 */     GIR_EraseRootFromParent_Done,
     /* 260666 */   // Label 5210: @260666
     /* 260666 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(260687), // Rule ID 6329 //
     /* 260671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260675 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 260675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 260678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260685 */     GIR_RootConstrainSelectedInstOperands,
     /* 260686 */     // GIR_Coverage, 6329,
     /* 260686 */     GIR_EraseRootFromParent_Done,
     /* 260687 */   // Label 5211: @260687
     /* 260687 */   GIM_Reject,
     /* 260688 */ // Label 5209: @260688
     /* 260688 */ GIM_Reject,
     /* 260689 */ // Label 5205: @260689
     /* 260689 */ GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(260750),
     /* 260694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 260697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260701 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(260728), // Rule ID 6333 //
     /* 260706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 260713 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 260713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 260716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260726 */     GIR_RootConstrainSelectedInstOperands,
     /* 260727 */     // GIR_Coverage, 6333,
     /* 260727 */     GIR_EraseRootFromParent_Done,
     /* 260728 */   // Label 5213: @260728
     /* 260728 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(260749), // Rule ID 6326 //
     /* 260733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260737 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 260737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 260740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260747 */     GIR_RootConstrainSelectedInstOperands,
     /* 260748 */     // GIR_Coverage, 6326,
     /* 260748 */     GIR_EraseRootFromParent_Done,
     /* 260749 */   // Label 5214: @260749
     /* 260749 */   GIM_Reject,
     /* 260750 */ // Label 5212: @260750
     /* 260750 */ GIM_Reject,
     /* 260751 */ // Label 5206: @260751
     /* 260751 */ GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(260812),
     /* 260756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 260759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260763 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(260790), // Rule ID 6330 //
     /* 260768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 260775 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 260775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 260778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 260785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260788 */     GIR_RootConstrainSelectedInstOperands,
     /* 260789 */     // GIR_Coverage, 6330,
     /* 260789 */     GIR_EraseRootFromParent_Done,
     /* 260790 */   // Label 5216: @260790
     /* 260790 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(260811), // Rule ID 6323 //
     /* 260795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260799 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 260799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 260802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 260806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 260809 */     GIR_RootConstrainSelectedInstOperands,
     /* 260810 */     // GIR_Coverage, 6323,
     /* 260810 */     GIR_EraseRootFromParent_Done,
     /* 260811 */   // Label 5217: @260811
     /* 260811 */   GIM_Reject,
     /* 260812 */ // Label 5215: @260812
     /* 260812 */ GIM_Reject,
     /* 260813 */ // Label 5207: @260813
     /* 260813 */ GIM_Reject,
     /* 260814 */ // Label 38: @260814
     /* 260814 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5222*/ GIMT_Encode4(262250),
     /* 260825 */ /*GILLT_s32*//*Label 5218*/ GIMT_Encode4(260857), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 260837 */ /*GILLT_v2s32*//*Label 5219*/ GIMT_Encode4(260896), GIMT_Encode4(0),
     /* 260845 */ /*GILLT_v4s16*//*Label 5220*/ GIMT_Encode4(261252), GIMT_Encode4(0),
     /* 260853 */ /*GILLT_v8s8*//*Label 5221*/ GIMT_Encode4(261751),
     /* 260857 */ // Label 5218: @260857
     /* 260857 */ GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(260895), // Rule ID 6485 //
     /* 260862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 260865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 260869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 260873 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 260873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 260876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 260878 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 260884 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 260889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 260894 */   // GIR_Coverage, 6485,
     /* 260894 */   GIR_EraseRootFromParent_Done,
     /* 260895 */ // Label 5223: @260895
     /* 260895 */ GIM_Reject,
     /* 260896 */ // Label 5219: @260896
     /* 260896 */ GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261251),
     /* 260901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260908 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(260986), // Rule ID 5415 //
     /* 260913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 260929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 260933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 260937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 260941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 260950 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 260956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 260958 */     // MIs[1] Operand 2
     /* 260958 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 260969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 260971 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 260971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 260974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 260980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 260984 */     GIR_RootConstrainSelectedInstOperands,
     /* 260985 */     // GIR_Coverage, 5415,
     /* 260985 */     GIR_EraseRootFromParent_Done,
     /* 260986 */   // Label 5225: @260986
     /* 260986 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(261057), // Rule ID 5411 //
     /* 260991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 260995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 260999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261029 */     // MIs[1] Operand 2
     /* 261029 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261042 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 261045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261055 */     GIR_RootConstrainSelectedInstOperands,
     /* 261056 */     // GIR_Coverage, 5411,
     /* 261056 */     GIR_EraseRootFromParent_Done,
     /* 261057 */   // Label 5226: @261057
     /* 261057 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(261128), // Rule ID 5413 //
     /* 261062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261100 */     // MIs[1] Operand 2
     /* 261100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261113 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 261116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261126 */     GIR_RootConstrainSelectedInstOperands,
     /* 261127 */     // GIR_Coverage, 5413,
     /* 261127 */     GIR_EraseRootFromParent_Done,
     /* 261128 */   // Label 5227: @261128
     /* 261128 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(261181), // Rule ID 2162 //
     /* 261133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261153 */     // MIs[1] imm
     /* 261153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261165 */     // MIs[2] Operand 1
     /* 261165 */     // No operand predicates
     /* 261165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261167 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261179 */     GIR_RootConstrainSelectedInstOperands,
     /* 261180 */     // GIR_Coverage, 2162,
     /* 261180 */     GIR_EraseRootFromParent_Done,
     /* 261181 */   // Label 5228: @261181
     /* 261181 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(261231), // Rule ID 6311 //
     /* 261186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261203 */     // MIs[1] imm
     /* 261203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261211 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261215 */     // MIs[2] Operand 1
     /* 261215 */     // No operand predicates
     /* 261215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261217 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 261217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261229 */     GIR_RootConstrainSelectedInstOperands,
     /* 261230 */     // GIR_Coverage, 6311,
     /* 261230 */     GIR_EraseRootFromParent_Done,
     /* 261231 */   // Label 5229: @261231
     /* 261231 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(261250), // Rule ID 1099 //
     /* 261236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261243 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 261243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 261248 */     GIR_RootConstrainSelectedInstOperands,
     /* 261249 */     // GIR_Coverage, 1099,
     /* 261249 */     GIR_Done,
     /* 261250 */   // Label 5230: @261250
     /* 261250 */   GIM_Reject,
     /* 261251 */ // Label 5224: @261251
     /* 261251 */ GIM_Reject,
     /* 261252 */ // Label 5220: @261252
     /* 261252 */ GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261750),
     /* 261257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261264 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261342), // Rule ID 5409 //
     /* 261269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261306 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261312 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261314 */     // MIs[1] Operand 2
     /* 261314 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261327 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 261327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 261330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261340 */     GIR_RootConstrainSelectedInstOperands,
     /* 261341 */     // GIR_Coverage, 5409,
     /* 261341 */     GIR_EraseRootFromParent_Done,
     /* 261342 */   // Label 5232: @261342
     /* 261342 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261413), // Rule ID 5405 //
     /* 261347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261385 */     // MIs[1] Operand 2
     /* 261385 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261398 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 261401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261411 */     GIR_RootConstrainSelectedInstOperands,
     /* 261412 */     // GIR_Coverage, 5405,
     /* 261412 */     GIR_EraseRootFromParent_Done,
     /* 261413 */   // Label 5233: @261413
     /* 261413 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261484), // Rule ID 5407 //
     /* 261418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261456 */     // MIs[1] Operand 2
     /* 261456 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261469 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 261472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261482 */     GIR_RootConstrainSelectedInstOperands,
     /* 261483 */     // GIR_Coverage, 5407,
     /* 261483 */     GIR_EraseRootFromParent_Done,
     /* 261484 */   // Label 5234: @261484
     /* 261484 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(261576), // Rule ID 5531 //
     /* 261489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261497 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 261529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 261533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261537 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261544 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 261544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 261547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 261551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 261560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 261564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 261569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261574 */     GIR_RootConstrainSelectedInstOperands,
     /* 261575 */     // GIR_Coverage, 5531,
     /* 261575 */     GIR_EraseRootFromParent_Done,
     /* 261576 */   // Label 5235: @261576
     /* 261576 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(261629), // Rule ID 2161 //
     /* 261581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261601 */     // MIs[1] imm
     /* 261601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261609 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 261613 */     // MIs[2] Operand 1
     /* 261613 */     // No operand predicates
     /* 261613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261615 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 261618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261627 */     GIR_RootConstrainSelectedInstOperands,
     /* 261628 */     // GIR_Coverage, 2161,
     /* 261628 */     GIR_EraseRootFromParent_Done,
     /* 261629 */   // Label 5236: @261629
     /* 261629 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(261679), // Rule ID 6310 //
     /* 261634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261651 */     // MIs[1] imm
     /* 261651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 261663 */     // MIs[2] Operand 1
     /* 261663 */     // No operand predicates
     /* 261663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261665 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 261665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 261668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261677 */     GIR_RootConstrainSelectedInstOperands,
     /* 261678 */     // GIR_Coverage, 6310,
     /* 261678 */     GIR_EraseRootFromParent_Done,
     /* 261679 */   // Label 5237: @261679
     /* 261679 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(261730), // Rule ID 5559 //
     /* 261684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261692 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 261703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 261715 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 261715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 261718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 261724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 261728 */     GIR_RootConstrainSelectedInstOperands,
     /* 261729 */     // GIR_Coverage, 5559,
     /* 261729 */     GIR_EraseRootFromParent_Done,
     /* 261730 */   // Label 5238: @261730
     /* 261730 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(261749), // Rule ID 1098 //
     /* 261735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261742 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 261742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 261747 */     GIR_RootConstrainSelectedInstOperands,
     /* 261748 */     // GIR_Coverage, 1098,
     /* 261748 */     GIR_Done,
     /* 261749 */   // Label 5239: @261749
     /* 261749 */   GIM_Reject,
     /* 261750 */ // Label 5231: @261750
     /* 261750 */ GIM_Reject,
     /* 261751 */ // Label 5221: @261751
     /* 261751 */ GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(262249),
     /* 261756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261763 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(261841), // Rule ID 5403 //
     /* 261768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261805 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261813 */     // MIs[1] Operand 2
     /* 261813 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261824 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261826 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 261826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 261829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261839 */     GIR_RootConstrainSelectedInstOperands,
     /* 261840 */     // GIR_Coverage, 5403,
     /* 261840 */     GIR_EraseRootFromParent_Done,
     /* 261841 */   // Label 5241: @261841
     /* 261841 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(261912), // Rule ID 5399 //
     /* 261846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261884 */     // MIs[1] Operand 2
     /* 261884 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261897 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 261900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261910 */     GIR_RootConstrainSelectedInstOperands,
     /* 261911 */     // GIR_Coverage, 5399,
     /* 261911 */     GIR_EraseRootFromParent_Done,
     /* 261912 */   // Label 5242: @261912
     /* 261912 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(261983), // Rule ID 5401 //
     /* 261917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 261941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261955 */     // MIs[1] Operand 2
     /* 261955 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 261966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261968 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 261968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 261971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261981 */     GIR_RootConstrainSelectedInstOperands,
     /* 261982 */     // GIR_Coverage, 5401,
     /* 261982 */     GIR_EraseRootFromParent_Done,
     /* 261983 */   // Label 5243: @261983
     /* 261983 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262075), // Rule ID 5504 //
     /* 261988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 261996 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 261999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 262028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262036 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262043 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 262043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 262046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 262050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 262059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 262063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262073 */     GIR_RootConstrainSelectedInstOperands,
     /* 262074 */     // GIR_Coverage, 5504,
     /* 262074 */     GIR_EraseRootFromParent_Done,
     /* 262075 */   // Label 5244: @262075
     /* 262075 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262128), // Rule ID 2160 //
     /* 262080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 262091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262100 */     // MIs[1] imm
     /* 262100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262108 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262112 */     // MIs[2] Operand 1
     /* 262112 */     // No operand predicates
     /* 262112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262114 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 262114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262126 */     GIR_RootConstrainSelectedInstOperands,
     /* 262127 */     // GIR_Coverage, 2160,
     /* 262127 */     GIR_EraseRootFromParent_Done,
     /* 262128 */   // Label 5245: @262128
     /* 262128 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262178), // Rule ID 6309 //
     /* 262133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262150 */     // MIs[1] imm
     /* 262150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262158 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262162 */     // MIs[2] Operand 1
     /* 262162 */     // No operand predicates
     /* 262162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262164 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 262164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262176 */     GIR_RootConstrainSelectedInstOperands,
     /* 262177 */     // GIR_Coverage, 6309,
     /* 262177 */     GIR_EraseRootFromParent_Done,
     /* 262178 */   // Label 5246: @262178
     /* 262178 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262229), // Rule ID 5558 //
     /* 262183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262191 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262214 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 262214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 262217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 262223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 262227 */     GIR_RootConstrainSelectedInstOperands,
     /* 262228 */     // GIR_Coverage, 5558,
     /* 262228 */     GIR_EraseRootFromParent_Done,
     /* 262229 */   // Label 5247: @262229
     /* 262229 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(262248), // Rule ID 1097 //
     /* 262234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262241 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 262241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262246 */     GIR_RootConstrainSelectedInstOperands,
     /* 262247 */     // GIR_Coverage, 1097,
     /* 262247 */     GIR_Done,
     /* 262248 */   // Label 5248: @262248
     /* 262248 */   GIM_Reject,
     /* 262249 */ // Label 5240: @262249
     /* 262249 */ GIM_Reject,
     /* 262250 */ // Label 5222: @262250
     /* 262250 */ GIM_Reject,
     /* 262251 */ // Label 39: @262251
     /* 262251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5251*/ GIMT_Encode4(262370),
     /* 262262 */ /*GILLT_s32*//*Label 5249*/ GIMT_Encode4(262270),
     /* 262266 */ /*GILLT_s64*//*Label 5250*/ GIMT_Encode4(262290),
     /* 262270 */ // Label 5249: @262270
     /* 262270 */ GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(262289), // Rule ID 81 //
     /* 262275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262279 */   // MIs[0] Operand 1
     /* 262279 */   // No operand predicates
     /* 262279 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 262279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262284 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262287 */   GIR_RootConstrainSelectedInstOperands,
     /* 262288 */   // GIR_Coverage, 81,
     /* 262288 */   GIR_EraseRootFromParent_Done,
     /* 262289 */ // Label 5252: @262289
     /* 262289 */ GIM_Reject,
     /* 262290 */ // Label 5250: @262290
     /* 262290 */ GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(262350), // Rule ID 3895 //
     /* 262295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 262298 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 262302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262306 */   // MIs[0] Operand 1
     /* 262306 */   // No operand predicates
     /* 262306 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 262306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262318 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 262323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 262339 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262344 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262349 */   // GIR_Coverage, 3895,
     /* 262349 */   GIR_EraseRootFromParent_Done,
     /* 262350 */ // Label 5253: @262350
     /* 262350 */ GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(262369), // Rule ID 82 //
     /* 262355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262359 */   // MIs[0] Operand 1
     /* 262359 */   // No operand predicates
     /* 262359 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 262359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 262362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262364 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262367 */   GIR_RootConstrainSelectedInstOperands,
     /* 262368 */   // GIR_Coverage, 82,
     /* 262368 */   GIR_EraseRootFromParent_Done,
     /* 262369 */ // Label 5254: @262369
     /* 262369 */ GIM_Reject,
     /* 262370 */ // Label 5251: @262370
     /* 262370 */ GIM_Reject,
     /* 262371 */ // Label 40: @262371
     /* 262371 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5258*/ GIMT_Encode4(262611),
     /* 262382 */ /*GILLT_s16*//*Label 5255*/ GIMT_Encode4(262394),
     /* 262386 */ /*GILLT_s32*//*Label 5256*/ GIMT_Encode4(262446),
     /* 262390 */ /*GILLT_s64*//*Label 5257*/ GIMT_Encode4(262559),
     /* 262394 */ // Label 5255: @262394
     /* 262394 */ GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(262417), // Rule ID 506 //
     /* 262399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262402 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262410 */   // MIs[0] Operand 1
     /* 262410 */   // No operand predicates
     /* 262410 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 262410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 262413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262415 */   GIR_RootConstrainSelectedInstOperands,
     /* 262416 */   // GIR_Coverage, 506,
     /* 262416 */   GIR_EraseRootFromParent_Done,
     /* 262417 */ // Label 5259: @262417
     /* 262417 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262445), // Rule ID 688 //
     /* 262422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 262425 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 262429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262433 */   // MIs[0] Operand 1
     /* 262433 */   // No operand predicates
     /* 262433 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 262433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 262436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262438 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 262443 */   GIR_RootConstrainSelectedInstOperands,
     /* 262444 */   // GIR_Coverage, 688,
     /* 262444 */   GIR_EraseRootFromParent_Done,
     /* 262445 */ // Label 5260: @262445
     /* 262445 */ GIM_Reject,
     /* 262446 */ // Label 5256: @262446
     /* 262446 */ GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(262469), // Rule ID 507 //
     /* 262451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262454 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262462 */   // MIs[0] Operand 1
     /* 262462 */   // No operand predicates
     /* 262462 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 262462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 262465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262467 */   GIR_RootConstrainSelectedInstOperands,
     /* 262468 */   // GIR_Coverage, 507,
     /* 262468 */   GIR_EraseRootFromParent_Done,
     /* 262469 */ // Label 5261: @262469
     /* 262469 */ GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(262497), // Rule ID 689 //
     /* 262474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262477 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 262481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262485 */   // MIs[0] Operand 1
     /* 262485 */   // No operand predicates
     /* 262485 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 262485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 262488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262490 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 262495 */   GIR_RootConstrainSelectedInstOperands,
     /* 262496 */   // GIR_Coverage, 689,
     /* 262496 */   GIR_EraseRootFromParent_Done,
     /* 262497 */ // Label 5262: @262497
     /* 262497 */ GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(262558), // Rule ID 5998 //
     /* 262502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262505 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 262509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262513 */   // MIs[0] Operand 1
     /* 262513 */   // No operand predicates
     /* 262513 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 262513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 262516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 262520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262525 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 262530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 262533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 262538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262540 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 262547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262557 */   // GIR_Coverage, 5998,
     /* 262557 */   GIR_EraseRootFromParent_Done,
     /* 262558 */ // Label 5263: @262558
     /* 262558 */ GIM_Reject,
     /* 262559 */ // Label 5257: @262559
     /* 262559 */ GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(262582), // Rule ID 508 //
     /* 262564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262567 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262575 */   // MIs[0] Operand 1
     /* 262575 */   // No operand predicates
     /* 262575 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 262575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 262578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262580 */   GIR_RootConstrainSelectedInstOperands,
     /* 262581 */   // GIR_Coverage, 508,
     /* 262581 */   GIR_EraseRootFromParent_Done,
     /* 262582 */ // Label 5264: @262582
     /* 262582 */ GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(262610), // Rule ID 690 //
     /* 262587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262590 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 262594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262598 */   // MIs[0] Operand 1
     /* 262598 */   // No operand predicates
     /* 262598 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 262598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 262601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262603 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 262608 */   GIR_RootConstrainSelectedInstOperands,
     /* 262609 */   // GIR_Coverage, 690,
     /* 262609 */   GIR_EraseRootFromParent_Done,
     /* 262610 */ // Label 5265: @262610
     /* 262610 */ GIM_Reject,
     /* 262611 */ // Label 5258: @262611
     /* 262611 */ GIM_Reject,
     /* 262612 */ // Label 41: @262612
     /* 262612 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5271*/ GIMT_Encode4(264509),
     /* 262623 */ /*GILLT_s32*//*Label 5266*/ GIMT_Encode4(262659),
     /* 262627 */ /*GILLT_s64*//*Label 5267*/ GIMT_Encode4(264100), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 262639 */ /*GILLT_v2s64*//*Label 5268*/ GIMT_Encode4(264323), GIMT_Encode4(0),
     /* 262647 */ /*GILLT_v4s32*//*Label 5269*/ GIMT_Encode4(264385), GIMT_Encode4(0),
     /* 262655 */ /*GILLT_v8s16*//*Label 5270*/ GIMT_Encode4(264447),
     /* 262659 */ // Label 5266: @262659
     /* 262659 */ GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(262779), // Rule ID 13049 //
     /* 262664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262671 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262679 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262682 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262687 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 262691 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262698 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 262705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262710 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262742 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262748 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262777 */   GIR_RootConstrainSelectedInstOperands,
     /* 262778 */   // GIR_Coverage, 13049,
     /* 262778 */   GIR_EraseRootFromParent_Done,
     /* 262779 */ // Label 5272: @262779
     /* 262779 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(262899), // Rule ID 13051 //
     /* 262784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 262787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262791 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262799 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262802 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262807 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 262811 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262818 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262818 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 262821 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 262825 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262830 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262836 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262839 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262843 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262862 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262865 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262868 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 262871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262876 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 262886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 262889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262897 */   GIR_RootConstrainSelectedInstOperands,
     /* 262898 */   // GIR_Coverage, 13051,
     /* 262898 */   GIR_EraseRootFromParent_Done,
     /* 262899 */ // Label 5273: @262899
     /* 262899 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(263019), // Rule ID 13053 //
     /* 262904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 262907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262911 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 262919 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262922 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 262927 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262931 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262938 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 262938 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 262941 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 262945 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262950 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 262954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 262956 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 262959 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 262963 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 262970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 262973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 262977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262982 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 262985 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 262988 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 262991 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262996 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263001 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263017 */   GIR_RootConstrainSelectedInstOperands,
     /* 263018 */   // GIR_Coverage, 13053,
     /* 263018 */   GIR_EraseRootFromParent_Done,
     /* 263019 */ // Label 5274: @263019
     /* 263019 */ GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(263139), // Rule ID 13055 //
     /* 263024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263031 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263035 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263039 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263042 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263047 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263051 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263058 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263058 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263061 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 263065 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263070 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263076 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263079 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263083 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263102 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263105 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263108 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263131 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263137 */   GIR_RootConstrainSelectedInstOperands,
     /* 263138 */   // GIR_Coverage, 13055,
     /* 263138 */   GIR_EraseRootFromParent_Done,
     /* 263139 */ // Label 5275: @263139
     /* 263139 */ GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(263259), // Rule ID 13071 //
     /* 263144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263151 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263159 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263162 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263167 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263171 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263178 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263178 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263181 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 263185 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263190 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263196 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263199 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263203 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263222 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263225 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263228 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263241 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263257 */   GIR_RootConstrainSelectedInstOperands,
     /* 263258 */   // GIR_Coverage, 13071,
     /* 263258 */   GIR_EraseRootFromParent_Done,
     /* 263259 */ // Label 5276: @263259
     /* 263259 */ GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(263379), // Rule ID 13073 //
     /* 263264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263271 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263279 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263282 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263287 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263291 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263298 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263298 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263301 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 263305 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263310 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263316 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263319 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263323 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263330 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263333 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263337 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263342 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263345 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263348 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263351 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263356 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263361 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263377 */   GIR_RootConstrainSelectedInstOperands,
     /* 263378 */   // GIR_Coverage, 13073,
     /* 263378 */   GIR_EraseRootFromParent_Done,
     /* 263379 */ // Label 5277: @263379
     /* 263379 */ GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(263499), // Rule ID 13075 //
     /* 263384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263391 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263399 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263402 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263407 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263411 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263418 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263418 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263421 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 263425 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263430 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263436 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263439 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263443 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263462 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263465 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263468 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263497 */   GIR_RootConstrainSelectedInstOperands,
     /* 263498 */   // GIR_Coverage, 13075,
     /* 263498 */   GIR_EraseRootFromParent_Done,
     /* 263499 */ // Label 5278: @263499
     /* 263499 */ GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(263619), // Rule ID 13077 //
     /* 263504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263511 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263515 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263519 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263522 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263527 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263531 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263536 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263538 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263538 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263541 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 263545 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263550 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263556 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263559 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263563 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263582 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263585 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263588 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263596 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263617 */   GIR_RootConstrainSelectedInstOperands,
     /* 263618 */   // GIR_Coverage, 13077,
     /* 263618 */   GIR_EraseRootFromParent_Done,
     /* 263619 */ // Label 5279: @263619
     /* 263619 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263739), // Rule ID 13081 //
     /* 263624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263631 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263639 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263642 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263647 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263651 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263658 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263658 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263661 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 263665 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263670 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263676 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263679 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263683 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263702 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263705 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263708 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263737 */   GIR_RootConstrainSelectedInstOperands,
     /* 263738 */   // GIR_Coverage, 13081,
     /* 263738 */   GIR_EraseRootFromParent_Done,
     /* 263739 */ // Label 5280: @263739
     /* 263739 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263859), // Rule ID 13083 //
     /* 263744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263751 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263759 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263762 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263767 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263771 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263778 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263778 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263781 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 263785 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263790 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263796 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263799 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263803 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263822 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263825 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263828 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263831 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263841 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263857 */   GIR_RootConstrainSelectedInstOperands,
     /* 263858 */   // GIR_Coverage, 13083,
     /* 263858 */   GIR_EraseRootFromParent_Done,
     /* 263859 */ // Label 5281: @263859
     /* 263859 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(263979), // Rule ID 13085 //
     /* 263864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263871 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263879 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263882 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 263887 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263898 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263898 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263901 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 263905 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263910 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263916 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263919 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263923 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263942 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263945 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263948 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263961 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263977 */   GIR_RootConstrainSelectedInstOperands,
     /* 263978 */   // GIR_Coverage, 13085,
     /* 263978 */   GIR_EraseRootFromParent_Done,
     /* 263979 */ // Label 5282: @263979
     /* 263979 */ GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(264099), // Rule ID 13087 //
     /* 263984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263991 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263999 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264002 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264007 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264011 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264018 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264018 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264021 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 264025 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264030 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264036 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264039 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264043 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264062 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264065 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264068 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264071 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264076 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264081 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264097 */   GIR_RootConstrainSelectedInstOperands,
     /* 264098 */   // GIR_Coverage, 13087,
     /* 264098 */   GIR_EraseRootFromParent_Done,
     /* 264099 */ // Label 5283: @264099
     /* 264099 */ GIM_Reject,
     /* 264100 */ // Label 5267: @264100
     /* 264100 */ GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(264322),
     /* 264105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264112 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(264166), // Rule ID 5642 //
     /* 264117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264150 */     // MIs[2] Operand 1
     /* 264150 */     // No operand predicates
     /* 264150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264152 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 264152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264164 */     GIR_RootConstrainSelectedInstOperands,
     /* 264165 */     // GIR_Coverage, 5642,
     /* 264165 */     GIR_EraseRootFromParent_Done,
     /* 264166 */   // Label 5285: @264166
     /* 264166 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(264245), // Rule ID 11163 //
     /* 264171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 264186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264202 */     // MIs[2] Operand 1
     /* 264202 */     // No operand predicates
     /* 264202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264204 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 264204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 264207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264216 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264243 */     GIR_RootConstrainSelectedInstOperands,
     /* 264244 */     // GIR_Coverage, 11163,
     /* 264244 */     GIR_EraseRootFromParent_Done,
     /* 264245 */   // Label 5286: @264245
     /* 264245 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264321), // Rule ID 6466 //
     /* 264250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264254 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 264254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 264257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264280 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 264287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 264308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 264319 */     GIR_RootConstrainSelectedInstOperands,
     /* 264320 */     // GIR_Coverage, 6466,
     /* 264320 */     GIR_EraseRootFromParent_Done,
     /* 264321 */   // Label 5287: @264321
     /* 264321 */   GIM_Reject,
     /* 264322 */ // Label 5284: @264322
     /* 264322 */ GIM_Reject,
     /* 264323 */ // Label 5268: @264323
     /* 264323 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(264384),
     /* 264328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264335 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(264362), // Rule ID 6338 //
     /* 264340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 264347 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 264347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 264350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264360 */     GIR_RootConstrainSelectedInstOperands,
     /* 264361 */     // GIR_Coverage, 6338,
     /* 264361 */     GIR_EraseRootFromParent_Done,
     /* 264362 */   // Label 5289: @264362
     /* 264362 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264383), // Rule ID 6327 //
     /* 264367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264371 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 264371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 264374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264381 */     GIR_RootConstrainSelectedInstOperands,
     /* 264382 */     // GIR_Coverage, 6327,
     /* 264382 */     GIR_EraseRootFromParent_Done,
     /* 264383 */   // Label 5290: @264383
     /* 264383 */   GIM_Reject,
     /* 264384 */ // Label 5288: @264384
     /* 264384 */ GIM_Reject,
     /* 264385 */ // Label 5269: @264385
     /* 264385 */ GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264446),
     /* 264390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264397 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264424), // Rule ID 6335 //
     /* 264402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 264409 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 264409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 264412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264422 */     GIR_RootConstrainSelectedInstOperands,
     /* 264423 */     // GIR_Coverage, 6335,
     /* 264423 */     GIR_EraseRootFromParent_Done,
     /* 264424 */   // Label 5292: @264424
     /* 264424 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264445), // Rule ID 6324 //
     /* 264429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264433 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 264433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 264436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264443 */     GIR_RootConstrainSelectedInstOperands,
     /* 264444 */     // GIR_Coverage, 6324,
     /* 264444 */     GIR_EraseRootFromParent_Done,
     /* 264445 */   // Label 5293: @264445
     /* 264445 */   GIM_Reject,
     /* 264446 */ // Label 5291: @264446
     /* 264446 */ GIM_Reject,
     /* 264447 */ // Label 5270: @264447
     /* 264447 */ GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264508),
     /* 264452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 264455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264459 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264486), // Rule ID 6332 //
     /* 264464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 264471 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 264471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 264474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264484 */     GIR_RootConstrainSelectedInstOperands,
     /* 264485 */     // GIR_Coverage, 6332,
     /* 264485 */     GIR_EraseRootFromParent_Done,
     /* 264486 */   // Label 5295: @264486
     /* 264486 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264507), // Rule ID 6321 //
     /* 264491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264495 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 264495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 264498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264505 */     GIR_RootConstrainSelectedInstOperands,
     /* 264506 */     // GIR_Coverage, 6321,
     /* 264506 */     GIR_EraseRootFromParent_Done,
     /* 264507 */   // Label 5296: @264507
     /* 264507 */   GIM_Reject,
     /* 264508 */ // Label 5294: @264508
     /* 264508 */ GIM_Reject,
     /* 264509 */ // Label 5271: @264509
     /* 264509 */ GIM_Reject,
     /* 264510 */ // Label 42: @264510
     /* 264510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5302*/ GIMT_Encode4(266163),
     /* 264521 */ /*GILLT_s32*//*Label 5297*/ GIMT_Encode4(264601),
     /* 264525 */ /*GILLT_s64*//*Label 5298*/ GIMT_Encode4(265095), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 264577 */ /*GILLT_nxv2s64*//*Label 5299*/ GIMT_Encode4(265737), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 264589 */ /*GILLT_nxv4s32*//*Label 5300*/ GIMT_Encode4(265946), GIMT_Encode4(0),
     /* 264597 */ /*GILLT_nxv8s16*//*Label 5301*/ GIMT_Encode4(266090),
     /* 264601 */ // Label 5297: @264601
     /* 264601 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(265094),
     /* 264606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264613 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(264678), // Rule ID 5637 //
     /* 264618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 264630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264651 */     // MIs[2] Operand 1
     /* 264651 */     // No operand predicates
     /* 264651 */     // MIs[0] Operand 2
     /* 264651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264664 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 264664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264676 */     GIR_RootConstrainSelectedInstOperands,
     /* 264677 */     // GIR_Coverage, 5637,
     /* 264677 */     GIR_EraseRootFromParent_Done,
     /* 264678 */   // Label 5304: @264678
     /* 264678 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(264743), // Rule ID 5639 //
     /* 264683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264716 */     // MIs[2] Operand 1
     /* 264716 */     // No operand predicates
     /* 264716 */     // MIs[0] Operand 2
     /* 264716 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264729 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264741 */     GIR_RootConstrainSelectedInstOperands,
     /* 264742 */     // GIR_Coverage, 5639,
     /* 264742 */     GIR_EraseRootFromParent_Done,
     /* 264743 */   // Label 5305: @264743
     /* 264743 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(264808), // Rule ID 5641 //
     /* 264748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 264760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264781 */     // MIs[2] Operand 1
     /* 264781 */     // No operand predicates
     /* 264781 */     // MIs[0] Operand 2
     /* 264781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264794 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 264794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264806 */     GIR_RootConstrainSelectedInstOperands,
     /* 264807 */     // GIR_Coverage, 5641,
     /* 264807 */     GIR_EraseRootFromParent_Done,
     /* 264808 */   // Label 5306: @264808
     /* 264808 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(264898), // Rule ID 11159 //
     /* 264813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 264828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264840 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 264844 */     // MIs[2] Operand 1
     /* 264844 */     // No operand predicates
     /* 264844 */     // MIs[0] Operand 2
     /* 264844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 264855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264857 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 264857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264869 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264896 */     GIR_RootConstrainSelectedInstOperands,
     /* 264897 */     // GIR_Coverage, 11159,
     /* 264897 */     GIR_EraseRootFromParent_Done,
     /* 264898 */   // Label 5307: @264898
     /* 264898 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(264988), // Rule ID 11161 //
     /* 264903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 264918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 264934 */     // MIs[2] Operand 1
     /* 264934 */     // No operand predicates
     /* 264934 */     // MIs[0] Operand 2
     /* 264934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 264945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264947 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 264947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 264950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264986 */     GIR_RootConstrainSelectedInstOperands,
     /* 264987 */     // GIR_Coverage, 11161,
     /* 264987 */     GIR_EraseRootFromParent_Done,
     /* 264988 */   // Label 5308: @264988
     /* 264988 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(265023), // Rule ID 6471 //
     /* 264993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264997 */     // MIs[0] Operand 2
     /* 264997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265008 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 265008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265021 */     GIR_RootConstrainSelectedInstOperands,
     /* 265022 */     // GIR_Coverage, 6471,
     /* 265022 */     GIR_EraseRootFromParent_Done,
     /* 265023 */   // Label 5309: @265023
     /* 265023 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(265058), // Rule ID 6472 //
     /* 265028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265032 */     // MIs[0] Operand 2
     /* 265032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265043 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 265043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265048 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265056 */     GIR_RootConstrainSelectedInstOperands,
     /* 265057 */     // GIR_Coverage, 6472,
     /* 265057 */     GIR_EraseRootFromParent_Done,
     /* 265058 */   // Label 5310: @265058
     /* 265058 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265093), // Rule ID 6473 //
     /* 265063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265067 */     // MIs[0] Operand 2
     /* 265067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265078 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265083 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265091 */     GIR_RootConstrainSelectedInstOperands,
     /* 265092 */     // GIR_Coverage, 6473,
     /* 265092 */     GIR_EraseRootFromParent_Done,
     /* 265093 */   // Label 5311: @265093
     /* 265093 */   GIM_Reject,
     /* 265094 */ // Label 5303: @265094
     /* 265094 */ GIM_Reject,
     /* 265095 */ // Label 5298: @265095
     /* 265095 */ GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265736),
     /* 265100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 265103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265107 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(265184), // Rule ID 5643 //
     /* 265112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265157 */     // MIs[3] Operand 1
     /* 265157 */     // No operand predicates
     /* 265157 */     // MIs[0] Operand 2
     /* 265157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265170 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265182 */     GIR_RootConstrainSelectedInstOperands,
     /* 265183 */     // GIR_Coverage, 5643,
     /* 265183 */     GIR_EraseRootFromParent_Done,
     /* 265184 */   // Label 5313: @265184
     /* 265184 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(265261), // Rule ID 5644 //
     /* 265189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265234 */     // MIs[3] Operand 1
     /* 265234 */     // No operand predicates
     /* 265234 */     // MIs[0] Operand 2
     /* 265234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265247 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265259 */     GIR_RootConstrainSelectedInstOperands,
     /* 265260 */     // GIR_Coverage, 5644,
     /* 265260 */     GIR_EraseRootFromParent_Done,
     /* 265261 */   // Label 5314: @265261
     /* 265261 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265363), // Rule ID 11160 //
     /* 265266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 265293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265305 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265309 */     // MIs[3] Operand 1
     /* 265309 */     // No operand predicates
     /* 265309 */     // MIs[0] Operand 2
     /* 265309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265322 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 265322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265361 */     GIR_RootConstrainSelectedInstOperands,
     /* 265362 */     // GIR_Coverage, 11160,
     /* 265362 */     GIR_EraseRootFromParent_Done,
     /* 265363 */   // Label 5315: @265363
     /* 265363 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265465), // Rule ID 11162 //
     /* 265368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265407 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265411 */     // MIs[3] Operand 1
     /* 265411 */     // No operand predicates
     /* 265411 */     // MIs[0] Operand 2
     /* 265411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265424 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 265424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 265427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265436 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265463 */     GIR_RootConstrainSelectedInstOperands,
     /* 265464 */     // GIR_Coverage, 11162,
     /* 265464 */     GIR_EraseRootFromParent_Done,
     /* 265465 */   // Label 5316: @265465
     /* 265465 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(265530), // Rule ID 5638 //
     /* 265470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265499 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265503 */     // MIs[2] Operand 1
     /* 265503 */     // No operand predicates
     /* 265503 */     // MIs[0] Operand 2
     /* 265503 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265516 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265528 */     GIR_RootConstrainSelectedInstOperands,
     /* 265529 */     // GIR_Coverage, 5638,
     /* 265529 */     GIR_EraseRootFromParent_Done,
     /* 265530 */   // Label 5317: @265530
     /* 265530 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(265595), // Rule ID 5640 //
     /* 265535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265568 */     // MIs[2] Operand 1
     /* 265568 */     // No operand predicates
     /* 265568 */     // MIs[0] Operand 2
     /* 265568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265581 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265593 */     GIR_RootConstrainSelectedInstOperands,
     /* 265594 */     // GIR_Coverage, 5640,
     /* 265594 */     GIR_EraseRootFromParent_Done,
     /* 265595 */   // Label 5318: @265595
     /* 265595 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(265630), // Rule ID 6467 //
     /* 265600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265604 */     // MIs[0] Operand 2
     /* 265604 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 265615 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 265615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 265628 */     GIR_RootConstrainSelectedInstOperands,
     /* 265629 */     // GIR_Coverage, 6467,
     /* 265629 */     GIR_EraseRootFromParent_Done,
     /* 265630 */   // Label 5319: @265630
     /* 265630 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(265665), // Rule ID 6468 //
     /* 265635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265639 */     // MIs[0] Operand 2
     /* 265639 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265650 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 265650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265655 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265663 */     GIR_RootConstrainSelectedInstOperands,
     /* 265664 */     // GIR_Coverage, 6468,
     /* 265664 */     GIR_EraseRootFromParent_Done,
     /* 265665 */   // Label 5320: @265665
     /* 265665 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(265700), // Rule ID 6469 //
     /* 265670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265674 */     // MIs[0] Operand 2
     /* 265674 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265685 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 265685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265698 */     GIR_RootConstrainSelectedInstOperands,
     /* 265699 */     // GIR_Coverage, 6469,
     /* 265699 */     GIR_EraseRootFromParent_Done,
     /* 265700 */   // Label 5321: @265700
     /* 265700 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(265735), // Rule ID 6470 //
     /* 265705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265709 */     // MIs[0] Operand 2
     /* 265709 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265720 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 265723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265733 */     GIR_RootConstrainSelectedInstOperands,
     /* 265734 */     // GIR_Coverage, 6470,
     /* 265734 */     GIR_EraseRootFromParent_Done,
     /* 265735 */   // Label 5322: @265735
     /* 265735 */   GIM_Reject,
     /* 265736 */ // Label 5312: @265736
     /* 265736 */ GIM_Reject,
     /* 265737 */ // Label 5299: @265737
     /* 265737 */ GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(265945),
     /* 265742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 265745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265749 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(265814), // Rule ID 10443 //
     /* 265754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265757 */     // MIs[0] Operand 2
     /* 265757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 265768 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265780 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 265802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265812 */     GIR_RootConstrainSelectedInstOperands,
     /* 265813 */     // GIR_Coverage, 10443,
     /* 265813 */     GIR_EraseRootFromParent_Done,
     /* 265814 */   // Label 5324: @265814
     /* 265814 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(265879), // Rule ID 10444 //
     /* 265819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265822 */     // MIs[0] Operand 2
     /* 265822 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265833 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265833 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265836 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265840 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265845 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 265867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265877 */     GIR_RootConstrainSelectedInstOperands,
     /* 265878 */     // GIR_Coverage, 10444,
     /* 265878 */     GIR_EraseRootFromParent_Done,
     /* 265879 */   // Label 5325: @265879
     /* 265879 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(265944), // Rule ID 10445 //
     /* 265884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265887 */     // MIs[0] Operand 2
     /* 265887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265898 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 265898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 265905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265910 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 265922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 265929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 265932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 265940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 265942 */     GIR_RootConstrainSelectedInstOperands,
     /* 265943 */     // GIR_Coverage, 10445,
     /* 265943 */     GIR_EraseRootFromParent_Done,
     /* 265944 */   // Label 5326: @265944
     /* 265944 */   GIM_Reject,
     /* 265945 */ // Label 5323: @265945
     /* 265945 */ GIM_Reject,
     /* 265946 */ // Label 5300: @265946
     /* 265946 */ GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(266089),
     /* 265951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 265954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265958 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(266023), // Rule ID 10446 //
     /* 265963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265966 */     // MIs[0] Operand 2
     /* 265966 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265977 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 265977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 265980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 265984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265989 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 265992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 265994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 265997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 266011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266021 */     GIR_RootConstrainSelectedInstOperands,
     /* 266022 */     // GIR_Coverage, 10446,
     /* 266022 */     GIR_EraseRootFromParent_Done,
     /* 266023 */   // Label 5328: @266023
     /* 266023 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(266088), // Rule ID 10447 //
     /* 266028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266031 */     // MIs[0] Operand 2
     /* 266031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266042 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 266042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 266049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 266076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266086 */     GIR_RootConstrainSelectedInstOperands,
     /* 266087 */     // GIR_Coverage, 10447,
     /* 266087 */     GIR_EraseRootFromParent_Done,
     /* 266088 */   // Label 5329: @266088
     /* 266088 */   GIM_Reject,
     /* 266089 */ // Label 5327: @266089
     /* 266089 */ GIM_Reject,
     /* 266090 */ // Label 5301: @266090
     /* 266090 */ GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(266162), // Rule ID 10448 //
     /* 266095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 266101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266105 */   // MIs[0] Operand 2
     /* 266105 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266116 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 266116 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266119 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 266123 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266128 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 266150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266158 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266160 */   GIR_RootConstrainSelectedInstOperands,
     /* 266161 */   // GIR_Coverage, 10448,
     /* 266161 */   GIR_EraseRootFromParent_Done,
     /* 266162 */ // Label 5330: @266162
     /* 266162 */ GIM_Reject,
     /* 266163 */ // Label 5302: @266163
     /* 266163 */ GIM_Reject,
     /* 266164 */ // Label 43: @266164
     /* 266164 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5335*/ GIMT_Encode4(268942),
     /* 266175 */ /*GILLT_s32*//*Label 5331*/ GIMT_Encode4(266211), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 266191 */ /*GILLT_v2s64*//*Label 5332*/ GIMT_Encode4(268012), GIMT_Encode4(0),
     /* 266199 */ /*GILLT_v4s32*//*Label 5333*/ GIMT_Encode4(268322), GIMT_Encode4(0),
     /* 266207 */ /*GILLT_v8s16*//*Label 5334*/ GIMT_Encode4(268632),
     /* 266211 */ // Label 5331: @266211
     /* 266211 */ GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(266361), // Rule ID 13058 //
     /* 266216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266223 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266231 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266234 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266239 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266243 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266250 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266250 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266253 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 266257 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266262 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266268 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266271 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266275 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266282 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266285 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266289 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266294 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266297 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266300 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266303 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266308 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266313 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266330 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266342 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266360 */   // GIR_Coverage, 13058,
     /* 266360 */   GIR_EraseRootFromParent_Done,
     /* 266361 */ // Label 5336: @266361
     /* 266361 */ GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(266511), // Rule ID 13060 //
     /* 266366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266373 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266381 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266384 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266389 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266393 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266398 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266400 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266400 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266403 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 266407 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266412 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266418 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266421 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266425 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266432 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266435 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266439 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266444 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266447 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266450 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266458 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266463 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266480 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266487 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266510 */   // GIR_Coverage, 13060,
     /* 266510 */   GIR_EraseRootFromParent_Done,
     /* 266511 */ // Label 5337: @266511
     /* 266511 */ GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(266661), // Rule ID 13062 //
     /* 266516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266523 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266527 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266531 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266534 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266539 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 266543 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266548 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266550 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266550 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266553 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 266557 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266562 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266568 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266571 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266575 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266594 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266597 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266600 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266603 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266608 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266613 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266630 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266637 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266642 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266655 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266660 */   // GIR_Coverage, 13062,
     /* 266660 */   GIR_EraseRootFromParent_Done,
     /* 266661 */ // Label 5338: @266661
     /* 266661 */ GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(266811), // Rule ID 13064 //
     /* 266666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 266669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266673 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266681 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266684 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266689 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 266693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266700 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266700 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 266703 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 266707 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266712 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266718 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266721 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266725 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266732 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266735 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266739 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266744 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266747 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266750 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 266753 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266763 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 266768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266780 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266787 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266792 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266810 */   // GIR_Coverage, 13064,
     /* 266810 */   GIR_EraseRootFromParent_Done,
     /* 266811 */ // Label 5339: @266811
     /* 266811 */ GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(266961), // Rule ID 13091 //
     /* 266816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266823 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266827 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266831 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266834 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 266839 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266843 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266850 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266850 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266853 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 266857 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266862 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266868 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266871 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266875 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266882 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266885 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266889 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266894 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266897 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266900 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266903 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266908 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266913 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266930 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266942 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266960 */   // GIR_Coverage, 13091,
     /* 266960 */   GIR_EraseRootFromParent_Done,
     /* 266961 */ // Label 5340: @266961
     /* 266961 */ GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(267111), // Rule ID 13093 //
     /* 266966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266973 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266981 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266984 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 266989 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266993 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266998 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267000 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267000 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267003 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 267007 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267012 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267018 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267021 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267025 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267032 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267035 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267039 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267044 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267047 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267050 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267053 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267058 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267063 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267080 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267092 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267110 */   // GIR_Coverage, 13093,
     /* 267110 */   GIR_EraseRootFromParent_Done,
     /* 267111 */ // Label 5341: @267111
     /* 267111 */ GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(267261), // Rule ID 13095 //
     /* 267116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267123 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267131 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267134 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267139 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267143 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267150 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267150 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267153 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 267157 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267162 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267168 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267171 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267175 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267182 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267185 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267189 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267194 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267197 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267200 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267203 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267208 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267213 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267230 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267260 */   // GIR_Coverage, 13095,
     /* 267260 */   GIR_EraseRootFromParent_Done,
     /* 267261 */ // Label 5342: @267261
     /* 267261 */ GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(267411), // Rule ID 13097 //
     /* 267266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267273 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267281 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267284 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267289 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267293 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267298 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267300 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267300 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267303 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 267307 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267312 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267318 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267321 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267325 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267332 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267335 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267339 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267344 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267347 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267350 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267353 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267358 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267363 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267380 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267410 */   // GIR_Coverage, 13097,
     /* 267410 */   GIR_EraseRootFromParent_Done,
     /* 267411 */ // Label 5343: @267411
     /* 267411 */ GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(267561), // Rule ID 13101 //
     /* 267416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267423 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267431 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267434 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267439 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267450 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267450 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267453 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 267457 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267462 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267468 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267471 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267475 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267482 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267485 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267489 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267494 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267497 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267500 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267503 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267508 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267513 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267530 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267542 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267560 */   // GIR_Coverage, 13101,
     /* 267560 */   GIR_EraseRootFromParent_Done,
     /* 267561 */ // Label 5344: @267561
     /* 267561 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(267711), // Rule ID 13103 //
     /* 267566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267573 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267581 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267584 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267589 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267593 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267598 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267600 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267600 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267603 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 267607 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267612 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267618 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267621 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267625 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267632 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267635 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267639 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267644 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267647 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267650 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267653 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267658 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267663 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267680 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267692 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267710 */   // GIR_Coverage, 13103,
     /* 267710 */   GIR_EraseRootFromParent_Done,
     /* 267711 */ // Label 5345: @267711
     /* 267711 */ GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(267861), // Rule ID 13105 //
     /* 267716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267723 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267731 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267734 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267750 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267750 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267753 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 267757 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267762 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267768 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267771 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267775 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267782 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267785 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267789 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267794 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267797 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267800 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267803 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267808 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267813 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267830 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267837 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267842 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267860 */   // GIR_Coverage, 13105,
     /* 267860 */   GIR_EraseRootFromParent_Done,
     /* 267861 */ // Label 5346: @267861
     /* 267861 */ GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(268011), // Rule ID 13107 //
     /* 267866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267873 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267877 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267881 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267884 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267889 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267893 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267898 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267900 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267900 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267903 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 267907 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267912 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267918 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267921 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267925 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267932 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267935 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267939 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267944 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267947 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267950 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267953 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267958 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267963 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267980 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267992 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268010 */   // GIR_Coverage, 13107,
     /* 268010 */   GIR_EraseRootFromParent_Done,
     /* 268011 */ // Label 5347: @268011
     /* 268011 */ GIM_Reject,
     /* 268012 */ // Label 5332: @268012
     /* 268012 */ GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(268321),
     /* 268017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 268020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268024 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(268089), // Rule ID 702 //
     /* 268029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268052 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268072 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 268075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268087 */     GIR_RootConstrainSelectedInstOperands,
     /* 268088 */     // GIR_Coverage, 702,
     /* 268088 */     GIR_EraseRootFromParent_Done,
     /* 268089 */   // Label 5349: @268089
     /* 268089 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(268154), // Rule ID 1711 //
     /* 268094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268105 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268108 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268117 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268137 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 268140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268152 */     GIR_RootConstrainSelectedInstOperands,
     /* 268153 */     // GIR_Coverage, 1711,
     /* 268153 */     GIR_EraseRootFromParent_Done,
     /* 268154 */   // Label 5350: @268154
     /* 268154 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(268213), // Rule ID 700 //
     /* 268159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268170 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268173 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268182 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268198 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 268201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268211 */     GIR_RootConstrainSelectedInstOperands,
     /* 268212 */     // GIR_Coverage, 700,
     /* 268212 */     GIR_EraseRootFromParent_Done,
     /* 268213 */   // Label 5351: @268213
     /* 268213 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(268272), // Rule ID 1709 //
     /* 268218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268229 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268232 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268241 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268257 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 268260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268270 */     GIR_RootConstrainSelectedInstOperands,
     /* 268271 */     // GIR_Coverage, 1709,
     /* 268271 */     GIR_EraseRootFromParent_Done,
     /* 268272 */   // Label 5352: @268272
     /* 268272 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(268299), // Rule ID 6337 //
     /* 268277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268284 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 268284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 268287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268297 */     GIR_RootConstrainSelectedInstOperands,
     /* 268298 */     // GIR_Coverage, 6337,
     /* 268298 */     GIR_EraseRootFromParent_Done,
     /* 268299 */   // Label 5353: @268299
     /* 268299 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(268320), // Rule ID 6328 //
     /* 268304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268308 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 268308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 268311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268318 */     GIR_RootConstrainSelectedInstOperands,
     /* 268319 */     // GIR_Coverage, 6328,
     /* 268319 */     GIR_EraseRootFromParent_Done,
     /* 268320 */   // Label 5354: @268320
     /* 268320 */   GIM_Reject,
     /* 268321 */ // Label 5348: @268321
     /* 268321 */ GIM_Reject,
     /* 268322 */ // Label 5333: @268322
     /* 268322 */ GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(268631),
     /* 268327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 268330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268334 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(268399), // Rule ID 698 //
     /* 268339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268350 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268353 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268362 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268368 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268382 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 268385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268397 */     GIR_RootConstrainSelectedInstOperands,
     /* 268398 */     // GIR_Coverage, 698,
     /* 268398 */     GIR_EraseRootFromParent_Done,
     /* 268399 */   // Label 5356: @268399
     /* 268399 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(268464), // Rule ID 1707 //
     /* 268404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268415 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268418 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268427 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268447 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 268450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268462 */     GIR_RootConstrainSelectedInstOperands,
     /* 268463 */     // GIR_Coverage, 1707,
     /* 268463 */     GIR_EraseRootFromParent_Done,
     /* 268464 */   // Label 5357: @268464
     /* 268464 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(268523), // Rule ID 696 //
     /* 268469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268480 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268483 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268492 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268508 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 268511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268521 */     GIR_RootConstrainSelectedInstOperands,
     /* 268522 */     // GIR_Coverage, 696,
     /* 268522 */     GIR_EraseRootFromParent_Done,
     /* 268523 */   // Label 5358: @268523
     /* 268523 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(268582), // Rule ID 1705 //
     /* 268528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268539 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268542 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268567 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 268567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 268570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268580 */     GIR_RootConstrainSelectedInstOperands,
     /* 268581 */     // GIR_Coverage, 1705,
     /* 268581 */     GIR_EraseRootFromParent_Done,
     /* 268582 */   // Label 5359: @268582
     /* 268582 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(268609), // Rule ID 6334 //
     /* 268587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268594 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 268594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 268597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268607 */     GIR_RootConstrainSelectedInstOperands,
     /* 268608 */     // GIR_Coverage, 6334,
     /* 268608 */     GIR_EraseRootFromParent_Done,
     /* 268609 */   // Label 5360: @268609
     /* 268609 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(268630), // Rule ID 6325 //
     /* 268614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268618 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 268618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 268621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268628 */     GIR_RootConstrainSelectedInstOperands,
     /* 268629 */     // GIR_Coverage, 6325,
     /* 268629 */     GIR_EraseRootFromParent_Done,
     /* 268630 */   // Label 5361: @268630
     /* 268630 */   GIM_Reject,
     /* 268631 */ // Label 5355: @268631
     /* 268631 */ GIM_Reject,
     /* 268632 */ // Label 5334: @268632
     /* 268632 */ GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(268941),
     /* 268637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 268640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268644 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(268709), // Rule ID 694 //
     /* 268649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268660 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268663 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268672 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268692 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 268695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268707 */     GIR_RootConstrainSelectedInstOperands,
     /* 268708 */     // GIR_Coverage, 694,
     /* 268708 */     GIR_EraseRootFromParent_Done,
     /* 268709 */   // Label 5363: @268709
     /* 268709 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(268774), // Rule ID 1703 //
     /* 268714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268725 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268728 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268737 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268750 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268757 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 268757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 268760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268772 */     GIR_RootConstrainSelectedInstOperands,
     /* 268773 */     // GIR_Coverage, 1703,
     /* 268773 */     GIR_EraseRootFromParent_Done,
     /* 268774 */   // Label 5364: @268774
     /* 268774 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(268833), // Rule ID 692 //
     /* 268779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268790 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268793 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268802 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268818 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 268818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 268821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268831 */     GIR_RootConstrainSelectedInstOperands,
     /* 268832 */     // GIR_Coverage, 692,
     /* 268832 */     GIR_EraseRootFromParent_Done,
     /* 268833 */   // Label 5365: @268833
     /* 268833 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(268892), // Rule ID 1701 //
     /* 268838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 268861 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 268865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268877 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 268877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 268880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268890 */     GIR_RootConstrainSelectedInstOperands,
     /* 268891 */     // GIR_Coverage, 1701,
     /* 268891 */     GIR_EraseRootFromParent_Done,
     /* 268892 */   // Label 5366: @268892
     /* 268892 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(268919), // Rule ID 6331 //
     /* 268897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 268904 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 268904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 268907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268917 */     GIR_RootConstrainSelectedInstOperands,
     /* 268918 */     // GIR_Coverage, 6331,
     /* 268918 */     GIR_EraseRootFromParent_Done,
     /* 268919 */   // Label 5367: @268919
     /* 268919 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(268940), // Rule ID 6322 //
     /* 268924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268928 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 268928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 268931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268938 */     GIR_RootConstrainSelectedInstOperands,
     /* 268939 */     // GIR_Coverage, 6322,
     /* 268939 */     GIR_EraseRootFromParent_Done,
     /* 268940 */   // Label 5368: @268940
     /* 268940 */   GIM_Reject,
     /* 268941 */ // Label 5362: @268941
     /* 268941 */ GIM_Reject,
     /* 268942 */ // Label 5335: @268942
     /* 268942 */ GIM_Reject,
     /* 268943 */ // Label 44: @268943
     /* 268943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5374*/ GIMT_Encode4(269722),
     /* 268954 */ /*GILLT_s32*//*Label 5369*/ GIMT_Encode4(268990),
     /* 268958 */ /*GILLT_s64*//*Label 5370*/ GIMT_Encode4(269122), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 268970 */ /*GILLT_v2s64*//*Label 5371*/ GIMT_Encode4(269295), GIMT_Encode4(0),
     /* 268978 */ /*GILLT_v4s32*//*Label 5372*/ GIMT_Encode4(269440), GIMT_Encode4(0),
     /* 268986 */ /*GILLT_v8s16*//*Label 5373*/ GIMT_Encode4(269581),
     /* 268990 */ // Label 5369: @268990
     /* 268990 */ GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(269121),
     /* 268995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269009 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(269046), // Rule ID 3925 //
     /* 269014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269033 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269044 */     GIR_RootConstrainSelectedInstOperands,
     /* 269045 */     // GIR_Coverage, 3925,
     /* 269045 */     GIR_EraseRootFromParent_Done,
     /* 269046 */   // Label 5376: @269046
     /* 269046 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(269083), // Rule ID 3926 //
     /* 269051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269070 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269081 */     GIR_RootConstrainSelectedInstOperands,
     /* 269082 */     // GIR_Coverage, 3926,
     /* 269082 */     GIR_EraseRootFromParent_Done,
     /* 269083 */   // Label 5377: @269083
     /* 269083 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(269120), // Rule ID 3924 //
     /* 269088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269107 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269118 */     GIR_RootConstrainSelectedInstOperands,
     /* 269119 */     // GIR_Coverage, 3924,
     /* 269119 */     GIR_EraseRootFromParent_Done,
     /* 269120 */   // Label 5378: @269120
     /* 269120 */   GIM_Reject,
     /* 269121 */ // Label 5375: @269121
     /* 269121 */ GIM_Reject,
     /* 269122 */ // Label 5370: @269122
     /* 269122 */ GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(269294),
     /* 269127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269141 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(269209), // Rule ID 3927 //
     /* 269146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269165 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269177 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269207 */     GIR_RootConstrainSelectedInstOperands,
     /* 269208 */     // GIR_Coverage, 3927,
     /* 269208 */     GIR_EraseRootFromParent_Done,
     /* 269209 */   // Label 5380: @269209
     /* 269209 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(269277), // Rule ID 3928 //
     /* 269214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269233 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269245 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269275 */     GIR_RootConstrainSelectedInstOperands,
     /* 269276 */     // GIR_Coverage, 3928,
     /* 269276 */     GIR_EraseRootFromParent_Done,
     /* 269277 */   // Label 5381: @269277
     /* 269277 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(269293), // Rule ID 120 //
     /* 269282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269286 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269291 */     GIR_RootConstrainSelectedInstOperands,
     /* 269292 */     // GIR_Coverage, 120,
     /* 269292 */     GIR_Done,
     /* 269293 */   // Label 5382: @269293
     /* 269293 */   GIM_Reject,
     /* 269294 */ // Label 5379: @269294
     /* 269294 */ GIM_Reject,
     /* 269295 */ // Label 5371: @269295
     /* 269295 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(269439),
     /* 269300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 269303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 269306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269310 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(269374), // Rule ID 6320 //
     /* 269315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269352 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269356 */     // MIs[3] Operand 1
     /* 269356 */     // No operand predicates
     /* 269356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269358 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 269361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269367 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269372 */     GIR_RootConstrainSelectedInstOperands,
     /* 269373 */     // GIR_Coverage, 6320,
     /* 269373 */     GIR_EraseRootFromParent_Done,
     /* 269374 */   // Label 5384: @269374
     /* 269374 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(269438), // Rule ID 6317 //
     /* 269379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269416 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269420 */     // MIs[3] Operand 1
     /* 269420 */     // No operand predicates
     /* 269420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269422 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 269425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269431 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269436 */     GIR_RootConstrainSelectedInstOperands,
     /* 269437 */     // GIR_Coverage, 6317,
     /* 269437 */     GIR_EraseRootFromParent_Done,
     /* 269438 */   // Label 5385: @269438
     /* 269438 */   GIM_Reject,
     /* 269439 */ // Label 5383: @269439
     /* 269439 */ GIM_Reject,
     /* 269440 */ // Label 5372: @269440
     /* 269440 */ GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(269580),
     /* 269445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 269448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269455 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(269517), // Rule ID 6319 //
     /* 269460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 269472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269489 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269493 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269497 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 269501 */     // MIs[3] Operand 1
     /* 269501 */     // No operand predicates
     /* 269501 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269503 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 269503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 269506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269515 */     GIR_RootConstrainSelectedInstOperands,
     /* 269516 */     // GIR_Coverage, 6319,
     /* 269516 */     GIR_EraseRootFromParent_Done,
     /* 269517 */   // Label 5387: @269517
     /* 269517 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(269579), // Rule ID 6316 //
     /* 269522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 269534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269555 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269559 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 269563 */     // MIs[3] Operand 1
     /* 269563 */     // No operand predicates
     /* 269563 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269565 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 269565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 269568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269577 */     GIR_RootConstrainSelectedInstOperands,
     /* 269578 */     // GIR_Coverage, 6316,
     /* 269578 */     GIR_EraseRootFromParent_Done,
     /* 269579 */   // Label 5388: @269579
     /* 269579 */   GIM_Reject,
     /* 269580 */ // Label 5386: @269580
     /* 269580 */ GIM_Reject,
     /* 269581 */ // Label 5373: @269581
     /* 269581 */ GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(269721),
     /* 269586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 269589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 269592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269596 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(269658), // Rule ID 6318 //
     /* 269601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269638 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 269642 */     // MIs[3] Operand 1
     /* 269642 */     // No operand predicates
     /* 269642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269644 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 269644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 269647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269656 */     GIR_RootConstrainSelectedInstOperands,
     /* 269657 */     // GIR_Coverage, 6318,
     /* 269657 */     GIR_EraseRootFromParent_Done,
     /* 269658 */   // Label 5390: @269658
     /* 269658 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(269720), // Rule ID 6315 //
     /* 269663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269700 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 269704 */     // MIs[3] Operand 1
     /* 269704 */     // No operand predicates
     /* 269704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269706 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 269706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 269709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 269718 */     GIR_RootConstrainSelectedInstOperands,
     /* 269719 */     // GIR_Coverage, 6315,
     /* 269719 */     GIR_EraseRootFromParent_Done,
     /* 269720 */   // Label 5391: @269720
     /* 269720 */   GIM_Reject,
     /* 269721 */ // Label 5389: @269721
     /* 269721 */ GIM_Reject,
     /* 269722 */ // Label 5374: @269722
     /* 269722 */ GIM_Reject,
     /* 269723 */ // Label 45: @269723
     /* 269723 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5394*/ GIMT_Encode4(270115),
     /* 269734 */ /*GILLT_s32*//*Label 5392*/ GIMT_Encode4(269742),
     /* 269738 */ /*GILLT_s64*//*Label 5393*/ GIMT_Encode4(269908),
     /* 269742 */ // Label 5392: @269742
     /* 269742 */ GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(269907),
     /* 269747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269761 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(269795), // Rule ID 4014 //
     /* 269766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269778 */     // MIs[1] Operand 1
     /* 269778 */     // No operand predicates
     /* 269778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269780 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 269780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 269783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 269790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 269793 */     GIR_RootConstrainSelectedInstOperands,
     /* 269794 */     // GIR_Coverage, 4014,
     /* 269794 */     GIR_EraseRootFromParent_Done,
     /* 269795 */   // Label 5396: @269795
     /* 269795 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(269832), // Rule ID 3931 //
     /* 269800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269819 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269830 */     GIR_RootConstrainSelectedInstOperands,
     /* 269831 */     // GIR_Coverage, 3931,
     /* 269831 */     GIR_EraseRootFromParent_Done,
     /* 269832 */   // Label 5397: @269832
     /* 269832 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(269869), // Rule ID 3932 //
     /* 269837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269856 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269867 */     GIR_RootConstrainSelectedInstOperands,
     /* 269868 */     // GIR_Coverage, 3932,
     /* 269868 */     GIR_EraseRootFromParent_Done,
     /* 269869 */   // Label 5398: @269869
     /* 269869 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(269906), // Rule ID 3930 //
     /* 269874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269893 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 269896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269898 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269904 */     GIR_RootConstrainSelectedInstOperands,
     /* 269905 */     // GIR_Coverage, 3930,
     /* 269905 */     GIR_EraseRootFromParent_Done,
     /* 269906 */   // Label 5399: @269906
     /* 269906 */   GIM_Reject,
     /* 269907 */ // Label 5395: @269907
     /* 269907 */ GIM_Reject,
     /* 269908 */ // Label 5393: @269908
     /* 269908 */ GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(270114),
     /* 269913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269927 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(269961), // Rule ID 4015 //
     /* 269932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 269944 */     // MIs[1] Operand 1
     /* 269944 */     // No operand predicates
     /* 269944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269946 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 269946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 269949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 269956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 269959 */     GIR_RootConstrainSelectedInstOperands,
     /* 269960 */     // GIR_Coverage, 4015,
     /* 269960 */     GIR_EraseRootFromParent_Done,
     /* 269961 */   // Label 5401: @269961
     /* 269961 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(270029), // Rule ID 3933 //
     /* 269966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269985 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269997 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270004 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270027 */     GIR_RootConstrainSelectedInstOperands,
     /* 270028 */     // GIR_Coverage, 3933,
     /* 270028 */     GIR_EraseRootFromParent_Done,
     /* 270029 */   // Label 5402: @270029
     /* 270029 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(270097), // Rule ID 3934 //
     /* 270034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270053 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270065 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270095 */     GIR_RootConstrainSelectedInstOperands,
     /* 270096 */     // GIR_Coverage, 3934,
     /* 270096 */     GIR_EraseRootFromParent_Done,
     /* 270097 */   // Label 5403: @270097
     /* 270097 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(270113), // Rule ID 121 //
     /* 270102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270106 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270111 */     GIR_RootConstrainSelectedInstOperands,
     /* 270112 */     // GIR_Coverage, 121,
     /* 270112 */     GIR_Done,
     /* 270113 */   // Label 5404: @270113
     /* 270113 */   GIM_Reject,
     /* 270114 */ // Label 5400: @270114
     /* 270114 */ GIM_Reject,
     /* 270115 */ // Label 5394: @270115
     /* 270115 */ GIM_Reject,
     /* 270116 */ // Label 46: @270116
     /* 270116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5407*/ GIMT_Encode4(270891),
     /* 270127 */ /*GILLT_s32*//*Label 5405*/ GIMT_Encode4(270135),
     /* 270131 */ /*GILLT_s64*//*Label 5406*/ GIMT_Encode4(270441),
     /* 270135 */ // Label 5405: @270135
     /* 270135 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(270440),
     /* 270140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270150 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(270214), // Rule ID 6480 //
     /* 270155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270172 */     // MIs[1] Operand 2
     /* 270172 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 270183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270191 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 270195 */     // MIs[2] Operand 1
     /* 270195 */     // No operand predicates
     /* 270195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270197 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 270197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 270212 */     GIR_RootConstrainSelectedInstOperands,
     /* 270213 */     // GIR_Coverage, 6480,
     /* 270213 */     GIR_EraseRootFromParent_Done,
     /* 270214 */   // Label 5409: @270214
     /* 270214 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(270278), // Rule ID 6482 //
     /* 270219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270236 */     // MIs[1] Operand 2
     /* 270236 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 270247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270255 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 270259 */     // MIs[2] Operand 1
     /* 270259 */     // No operand predicates
     /* 270259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270261 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 270261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 270276 */     GIR_RootConstrainSelectedInstOperands,
     /* 270277 */     // GIR_Coverage, 6482,
     /* 270277 */     GIR_EraseRootFromParent_Done,
     /* 270278 */   // Label 5410: @270278
     /* 270278 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(270316), // Rule ID 4012 //
     /* 270283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270299 */     // MIs[1] Operand 1
     /* 270299 */     // No operand predicates
     /* 270299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270301 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270314 */     GIR_RootConstrainSelectedInstOperands,
     /* 270315 */     // GIR_Coverage, 4012,
     /* 270315 */     GIR_EraseRootFromParent_Done,
     /* 270316 */   // Label 5411: @270316
     /* 270316 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(270357), // Rule ID 2435 //
     /* 270321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270344 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270355 */     GIR_RootConstrainSelectedInstOperands,
     /* 270356 */     // GIR_Coverage, 2435,
     /* 270356 */     GIR_EraseRootFromParent_Done,
     /* 270357 */   // Label 5412: @270357
     /* 270357 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(270398), // Rule ID 2436 //
     /* 270362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270385 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270396 */     GIR_RootConstrainSelectedInstOperands,
     /* 270397 */     // GIR_Coverage, 2436,
     /* 270397 */     GIR_EraseRootFromParent_Done,
     /* 270398 */   // Label 5413: @270398
     /* 270398 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(270439), // Rule ID 2434 //
     /* 270403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270426 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270437 */     GIR_RootConstrainSelectedInstOperands,
     /* 270438 */     // GIR_Coverage, 2434,
     /* 270438 */     GIR_EraseRootFromParent_Done,
     /* 270439 */   // Label 5414: @270439
     /* 270439 */   GIM_Reject,
     /* 270440 */ // Label 5408: @270440
     /* 270440 */ GIM_Reject,
     /* 270441 */ // Label 5406: @270441
     /* 270441 */ GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(270890),
     /* 270446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270456 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(270520), // Rule ID 6481 //
     /* 270461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270478 */     // MIs[1] Operand 2
     /* 270478 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 270489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270497 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 270501 */     // MIs[2] Operand 1
     /* 270501 */     // No operand predicates
     /* 270501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270503 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 270503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 270518 */     GIR_RootConstrainSelectedInstOperands,
     /* 270519 */     // GIR_Coverage, 6481,
     /* 270519 */     GIR_EraseRootFromParent_Done,
     /* 270520 */   // Label 5416: @270520
     /* 270520 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(270584), // Rule ID 6483 //
     /* 270525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270542 */     // MIs[1] Operand 2
     /* 270542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 270553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270561 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 270565 */     // MIs[2] Operand 1
     /* 270565 */     // No operand predicates
     /* 270565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270567 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 270567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 270582 */     GIR_RootConstrainSelectedInstOperands,
     /* 270583 */     // GIR_Coverage, 6483,
     /* 270583 */     GIR_EraseRootFromParent_Done,
     /* 270584 */   // Label 5417: @270584
     /* 270584 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(270687), // Rule ID 6484 //
     /* 270589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270614 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270618 */     // MIs[2] Operand 1
     /* 270618 */     // No operand predicates
     /* 270618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270620 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270620 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 270623 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 270627 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 270634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 270641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270646 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 270649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270685 */     GIR_RootConstrainSelectedInstOperands,
     /* 270686 */     // GIR_Coverage, 6484,
     /* 270686 */     GIR_EraseRootFromParent_Done,
     /* 270687 */   // Label 5418: @270687
     /* 270687 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(270725), // Rule ID 4013 //
     /* 270692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 270708 */     // MIs[1] Operand 1
     /* 270708 */     // No operand predicates
     /* 270708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270710 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 270710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 270713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 270723 */     GIR_RootConstrainSelectedInstOperands,
     /* 270724 */     // GIR_Coverage, 4013,
     /* 270724 */     GIR_EraseRootFromParent_Done,
     /* 270725 */   // Label 5419: @270725
     /* 270725 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(270797), // Rule ID 2437 //
     /* 270730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270753 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270765 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270795 */     GIR_RootConstrainSelectedInstOperands,
     /* 270796 */     // GIR_Coverage, 2437,
     /* 270796 */     GIR_EraseRootFromParent_Done,
     /* 270797 */   // Label 5420: @270797
     /* 270797 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(270869), // Rule ID 2438 //
     /* 270802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270825 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270828 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270832 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270837 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270844 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270867 */     GIR_RootConstrainSelectedInstOperands,
     /* 270868 */     // GIR_Coverage, 2438,
     /* 270868 */     GIR_EraseRootFromParent_Done,
     /* 270869 */   // Label 5421: @270869
     /* 270869 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(270889), // Rule ID 119 //
     /* 270874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270882 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 270887 */     GIR_RootConstrainSelectedInstOperands,
     /* 270888 */     // GIR_Coverage, 119,
     /* 270888 */     GIR_Done,
     /* 270889 */   // Label 5422: @270889
     /* 270889 */   GIM_Reject,
     /* 270890 */ // Label 5415: @270890
     /* 270890 */ GIM_Reject,
     /* 270891 */ // Label 5407: @270891
     /* 270891 */ GIM_Reject,
     /* 270892 */ // Label 47: @270892
     /* 270892 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5425*/ GIMT_Encode4(271021),
     /* 270903 */ /*GILLT_s32*//*Label 5423*/ GIMT_Encode4(270911),
     /* 270907 */ /*GILLT_s64*//*Label 5424*/ GIMT_Encode4(270966),
     /* 270911 */ // Label 5423: @270911
     /* 270911 */ GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(270965), // Rule ID 188 //
     /* 270916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 270922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270945 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270949 */   // MIs[1] Operand 1
     /* 270949 */   // No operand predicates
     /* 270949 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270951 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 270951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 270954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270956 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270958 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 270960 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270963 */   GIR_RootConstrainSelectedInstOperands,
     /* 270964 */   // GIR_Coverage, 188,
     /* 270964 */   GIR_EraseRootFromParent_Done,
     /* 270965 */ // Label 5426: @270965
     /* 270965 */ GIM_Reject,
     /* 270966 */ // Label 5424: @270966
     /* 270966 */ GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(271020), // Rule ID 189 //
     /* 270971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 270996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271000 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271004 */   // MIs[1] Operand 1
     /* 271004 */   // No operand predicates
     /* 271004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271006 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 271006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271011 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271013 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 271015 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271018 */   GIR_RootConstrainSelectedInstOperands,
     /* 271019 */   // GIR_Coverage, 189,
     /* 271019 */   GIR_EraseRootFromParent_Done,
     /* 271020 */ // Label 5427: @271020
     /* 271020 */ GIM_Reject,
     /* 271021 */ // Label 5425: @271021
     /* 271021 */ GIM_Reject,
     /* 271022 */ // Label 48: @271022
     /* 271022 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5430*/ GIMT_Encode4(271514),
     /* 271033 */ /*GILLT_s32*//*Label 5428*/ GIMT_Encode4(271041),
     /* 271037 */ /*GILLT_s64*//*Label 5429*/ GIMT_Encode4(271257),
     /* 271041 */ // Label 5428: @271041
     /* 271041 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(271256),
     /* 271046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271056 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(271095), // Rule ID 184 //
     /* 271061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 271082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271084 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 271084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 271087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271093 */     GIR_RootConstrainSelectedInstOperands,
     /* 271094 */     // GIR_Coverage, 184,
     /* 271094 */     GIR_EraseRootFromParent_Done,
     /* 271095 */   // Label 5432: @271095
     /* 271095 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(271132), // Rule ID 4008 //
     /* 271100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271116 */     // MIs[1] Operand 1
     /* 271116 */     // No operand predicates
     /* 271116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271118 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 271121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271130 */     GIR_RootConstrainSelectedInstOperands,
     /* 271131 */     // GIR_Coverage, 4008,
     /* 271131 */     GIR_EraseRootFromParent_Done,
     /* 271132 */   // Label 5433: @271132
     /* 271132 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271173), // Rule ID 3937 //
     /* 271137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 271149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271160 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271171 */     GIR_RootConstrainSelectedInstOperands,
     /* 271172 */     // GIR_Coverage, 3937,
     /* 271172 */     GIR_EraseRootFromParent_Done,
     /* 271173 */   // Label 5434: @271173
     /* 271173 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(271214), // Rule ID 3938 //
     /* 271178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271201 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271212 */     GIR_RootConstrainSelectedInstOperands,
     /* 271213 */     // GIR_Coverage, 3938,
     /* 271213 */     GIR_EraseRootFromParent_Done,
     /* 271214 */   // Label 5435: @271214
     /* 271214 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(271255), // Rule ID 3936 //
     /* 271219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271242 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271253 */     GIR_RootConstrainSelectedInstOperands,
     /* 271254 */     // GIR_Coverage, 3936,
     /* 271254 */     GIR_EraseRootFromParent_Done,
     /* 271255 */   // Label 5436: @271255
     /* 271255 */   GIM_Reject,
     /* 271256 */ // Label 5431: @271256
     /* 271256 */ GIM_Reject,
     /* 271257 */ // Label 5429: @271257
     /* 271257 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(271513),
     /* 271262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271272 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(271311), // Rule ID 187 //
     /* 271277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 271298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271300 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 271300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 271303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271309 */     GIR_RootConstrainSelectedInstOperands,
     /* 271310 */     // GIR_Coverage, 187,
     /* 271310 */     GIR_EraseRootFromParent_Done,
     /* 271311 */   // Label 5438: @271311
     /* 271311 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(271348), // Rule ID 4009 //
     /* 271316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271332 */     // MIs[1] Operand 1
     /* 271332 */     // No operand predicates
     /* 271332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271334 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 271334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271346 */     GIR_RootConstrainSelectedInstOperands,
     /* 271347 */     // GIR_Coverage, 4009,
     /* 271347 */     GIR_EraseRootFromParent_Done,
     /* 271348 */   // Label 5439: @271348
     /* 271348 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(271420), // Rule ID 3939 //
     /* 271353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271376 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271418 */     GIR_RootConstrainSelectedInstOperands,
     /* 271419 */     // GIR_Coverage, 3939,
     /* 271419 */     GIR_EraseRootFromParent_Done,
     /* 271420 */   // Label 5440: @271420
     /* 271420 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(271492), // Rule ID 3940 //
     /* 271425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271448 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271467 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271490 */     GIR_RootConstrainSelectedInstOperands,
     /* 271491 */     // GIR_Coverage, 3940,
     /* 271491 */     GIR_EraseRootFromParent_Done,
     /* 271492 */   // Label 5441: @271492
     /* 271492 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(271512), // Rule ID 122 //
     /* 271497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271505 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271510 */     GIR_RootConstrainSelectedInstOperands,
     /* 271511 */     // GIR_Coverage, 122,
     /* 271511 */     GIR_Done,
     /* 271512 */   // Label 5442: @271512
     /* 271512 */   GIM_Reject,
     /* 271513 */ // Label 5437: @271513
     /* 271513 */ GIM_Reject,
     /* 271514 */ // Label 5430: @271514
     /* 271514 */ GIM_Reject,
     /* 271515 */ // Label 49: @271515
     /* 271515 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5451*/ GIMT_Encode4(279291),
     /* 271526 */ /*GILLT_s64*//*Label 5443*/ GIMT_Encode4(271562), GIMT_Encode4(0),
     /* 271534 */ /*GILLT_v2s32*//*Label 5444*/ GIMT_Encode4(271955),
     /* 271538 */ /*GILLT_v2s64*//*Label 5445*/ GIMT_Encode4(273003),
     /* 271542 */ /*GILLT_v4s16*//*Label 5446*/ GIMT_Encode4(274051),
     /* 271546 */ /*GILLT_v4s32*//*Label 5447*/ GIMT_Encode4(275099),
     /* 271550 */ /*GILLT_v8s8*//*Label 5448*/ GIMT_Encode4(276147),
     /* 271554 */ /*GILLT_v8s16*//*Label 5449*/ GIMT_Encode4(277195),
     /* 271558 */ /*GILLT_v16s8*//*Label 5450*/ GIMT_Encode4(278243),
     /* 271562 */ // Label 5443: @271562
     /* 271562 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(271954),
     /* 271567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271577 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(271613), // Rule ID 5227 //
     /* 271582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271585 */     // MIs[0] Operand 1
     /* 271585 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271604 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 271607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271611 */     GIR_RootConstrainSelectedInstOperands,
     /* 271612 */     // GIR_Coverage, 5227,
     /* 271612 */     GIR_EraseRootFromParent_Done,
     /* 271613 */   // Label 5453: @271613
     /* 271613 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(271649), // Rule ID 5228 //
     /* 271618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271621 */     // MIs[0] Operand 1
     /* 271621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271640 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 271643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 271647 */     GIR_RootConstrainSelectedInstOperands,
     /* 271648 */     // GIR_Coverage, 5228,
     /* 271648 */     GIR_EraseRootFromParent_Done,
     /* 271649 */   // Label 5454: @271649
     /* 271649 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(271685), // Rule ID 2512 //
     /* 271654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271657 */     // MIs[0] Operand 1
     /* 271657 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271666 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271672 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271676 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 271679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271683 */     GIR_RootConstrainSelectedInstOperands,
     /* 271684 */     // GIR_Coverage, 2512,
     /* 271684 */     GIR_EraseRootFromParent_Done,
     /* 271685 */   // Label 5455: @271685
     /* 271685 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(271721), // Rule ID 5224 //
     /* 271690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271693 */     // MIs[0] Operand 1
     /* 271693 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271702 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271708 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271712 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 271715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271719 */     GIR_RootConstrainSelectedInstOperands,
     /* 271720 */     // GIR_Coverage, 5224,
     /* 271720 */     GIR_EraseRootFromParent_Done,
     /* 271721 */   // Label 5456: @271721
     /* 271721 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(271757), // Rule ID 5225 //
     /* 271726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271729 */     // MIs[0] Operand 1
     /* 271729 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271738 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 271746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271748 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 271751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271755 */     GIR_RootConstrainSelectedInstOperands,
     /* 271756 */     // GIR_Coverage, 5225,
     /* 271756 */     GIR_EraseRootFromParent_Done,
     /* 271757 */   // Label 5457: @271757
     /* 271757 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(271793), // Rule ID 5226 //
     /* 271762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271765 */     // MIs[0] Operand 1
     /* 271765 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271784 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 271784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 271787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271791 */     GIR_RootConstrainSelectedInstOperands,
     /* 271792 */     // GIR_Coverage, 5226,
     /* 271792 */     GIR_EraseRootFromParent_Done,
     /* 271793 */   // Label 5458: @271793
     /* 271793 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(271825), // Rule ID 1608 //
     /* 271798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271801 */     // MIs[0] Operand 1
     /* 271801 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 271806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271814 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 271817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271823 */     GIR_RootConstrainSelectedInstOperands,
     /* 271824 */     // GIR_Coverage, 1608,
     /* 271824 */     GIR_EraseRootFromParent_Done,
     /* 271825 */   // Label 5459: @271825
     /* 271825 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(271857), // Rule ID 1609 //
     /* 271830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271833 */     // MIs[0] Operand 1
     /* 271833 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271846 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 271849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271855 */     GIR_RootConstrainSelectedInstOperands,
     /* 271856 */     // GIR_Coverage, 1609,
     /* 271856 */     GIR_EraseRootFromParent_Done,
     /* 271857 */   // Label 5460: @271857
     /* 271857 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(271889), // Rule ID 1610 //
     /* 271862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271865 */     // MIs[0] Operand 1
     /* 271865 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 271870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271878 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 271881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271887 */     GIR_RootConstrainSelectedInstOperands,
     /* 271888 */     // GIR_Coverage, 1610,
     /* 271888 */     GIR_EraseRootFromParent_Done,
     /* 271889 */   // Label 5461: @271889
     /* 271889 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(271921), // Rule ID 1611 //
     /* 271894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271897 */     // MIs[0] Operand 1
     /* 271897 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 271902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271910 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 271913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271919 */     GIR_RootConstrainSelectedInstOperands,
     /* 271920 */     // GIR_Coverage, 1611,
     /* 271920 */     GIR_EraseRootFromParent_Done,
     /* 271921 */   // Label 5462: @271921
     /* 271921 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(271953), // Rule ID 1612 //
     /* 271926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271929 */     // MIs[0] Operand 1
     /* 271929 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 271934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271942 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 271942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 271945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271951 */     GIR_RootConstrainSelectedInstOperands,
     /* 271952 */     // GIR_Coverage, 1612,
     /* 271952 */     GIR_EraseRootFromParent_Done,
     /* 271953 */   // Label 5463: @271953
     /* 271953 */   GIM_Reject,
     /* 271954 */ // Label 5452: @271954
     /* 271954 */ GIM_Reject,
     /* 271955 */ // Label 5444: @271955
     /* 271955 */ GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(273002),
     /* 271960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 271963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 271966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271970 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(272010), // Rule ID 754 //
     /* 271975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 271978 */     // MIs[0] Operand 1
     /* 271978 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 271983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271987 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 271993 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 271995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 271999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272001 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272008 */     GIR_RootConstrainSelectedInstOperands,
     /* 272009 */     // GIR_Coverage, 754,
     /* 272009 */     GIR_EraseRootFromParent_Done,
     /* 272010 */   // Label 5465: @272010
     /* 272010 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(272050), // Rule ID 761 //
     /* 272015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272018 */     // MIs[0] Operand 1
     /* 272018 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272027 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272033 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272041 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272048 */     GIR_RootConstrainSelectedInstOperands,
     /* 272049 */     // GIR_Coverage, 761,
     /* 272049 */     GIR_EraseRootFromParent_Done,
     /* 272050 */   // Label 5466: @272050
     /* 272050 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(272087), // Rule ID 5161 //
     /* 272055 */     // MIs[0] Operand 1
     /* 272055 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272064 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272070 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272078 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272085 */     GIR_RootConstrainSelectedInstOperands,
     /* 272086 */     // GIR_Coverage, 5161,
     /* 272086 */     GIR_EraseRootFromParent_Done,
     /* 272087 */   // Label 5467: @272087
     /* 272087 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(272124), // Rule ID 5168 //
     /* 272092 */     // MIs[0] Operand 1
     /* 272092 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272101 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272107 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272115 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272122 */     GIR_RootConstrainSelectedInstOperands,
     /* 272123 */     // GIR_Coverage, 5168,
     /* 272123 */     GIR_EraseRootFromParent_Done,
     /* 272124 */   // Label 5468: @272124
     /* 272124 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(272161), // Rule ID 5175 //
     /* 272129 */     // MIs[0] Operand 1
     /* 272129 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272138 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272144 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272152 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272159 */     GIR_RootConstrainSelectedInstOperands,
     /* 272160 */     // GIR_Coverage, 5175,
     /* 272160 */     GIR_EraseRootFromParent_Done,
     /* 272161 */   // Label 5469: @272161
     /* 272161 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(272198), // Rule ID 5182 //
     /* 272166 */     // MIs[0] Operand 1
     /* 272166 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272175 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272181 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272189 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272196 */     GIR_RootConstrainSelectedInstOperands,
     /* 272197 */     // GIR_Coverage, 5182,
     /* 272197 */     GIR_EraseRootFromParent_Done,
     /* 272198 */   // Label 5470: @272198
     /* 272198 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(272235), // Rule ID 5189 //
     /* 272203 */     // MIs[0] Operand 1
     /* 272203 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272212 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272218 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272226 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272233 */     GIR_RootConstrainSelectedInstOperands,
     /* 272234 */     // GIR_Coverage, 5189,
     /* 272234 */     GIR_EraseRootFromParent_Done,
     /* 272235 */   // Label 5471: @272235
     /* 272235 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(272275), // Rule ID 726 //
     /* 272240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272243 */     // MIs[0] Operand 1
     /* 272243 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272256 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272262 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272266 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272273 */     GIR_RootConstrainSelectedInstOperands,
     /* 272274 */     // GIR_Coverage, 726,
     /* 272274 */     GIR_EraseRootFromParent_Done,
     /* 272275 */   // Label 5472: @272275
     /* 272275 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(272315), // Rule ID 737 //
     /* 272280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272283 */     // MIs[0] Operand 1
     /* 272283 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272296 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272302 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272306 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272313 */     GIR_RootConstrainSelectedInstOperands,
     /* 272314 */     // GIR_Coverage, 737,
     /* 272314 */     GIR_EraseRootFromParent_Done,
     /* 272315 */   // Label 5473: @272315
     /* 272315 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(272355), // Rule ID 738 //
     /* 272320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272323 */     // MIs[0] Operand 1
     /* 272323 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272336 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272342 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 272344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272346 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272353 */     GIR_RootConstrainSelectedInstOperands,
     /* 272354 */     // GIR_Coverage, 738,
     /* 272354 */     GIR_EraseRootFromParent_Done,
     /* 272355 */   // Label 5474: @272355
     /* 272355 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(272395), // Rule ID 747 //
     /* 272360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272363 */     // MIs[0] Operand 1
     /* 272363 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272376 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272382 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272386 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272393 */     GIR_RootConstrainSelectedInstOperands,
     /* 272394 */     // GIR_Coverage, 747,
     /* 272394 */     GIR_EraseRootFromParent_Done,
     /* 272395 */   // Label 5475: @272395
     /* 272395 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(272432), // Rule ID 5126 //
     /* 272400 */     // MIs[0] Operand 1
     /* 272400 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272413 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272419 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272423 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272430 */     GIR_RootConstrainSelectedInstOperands,
     /* 272431 */     // GIR_Coverage, 5126,
     /* 272431 */     GIR_EraseRootFromParent_Done,
     /* 272432 */   // Label 5476: @272432
     /* 272432 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(272469), // Rule ID 5133 //
     /* 272437 */     // MIs[0] Operand 1
     /* 272437 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272450 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272456 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272460 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272467 */     GIR_RootConstrainSelectedInstOperands,
     /* 272468 */     // GIR_Coverage, 5133,
     /* 272468 */     GIR_EraseRootFromParent_Done,
     /* 272469 */   // Label 5477: @272469
     /* 272469 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(272506), // Rule ID 5140 //
     /* 272474 */     // MIs[0] Operand 1
     /* 272474 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272487 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272493 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272497 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272504 */     GIR_RootConstrainSelectedInstOperands,
     /* 272505 */     // GIR_Coverage, 5140,
     /* 272505 */     GIR_EraseRootFromParent_Done,
     /* 272506 */   // Label 5478: @272506
     /* 272506 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(272543), // Rule ID 5147 //
     /* 272511 */     // MIs[0] Operand 1
     /* 272511 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272524 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272530 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272534 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272541 */     GIR_RootConstrainSelectedInstOperands,
     /* 272542 */     // GIR_Coverage, 5147,
     /* 272542 */     GIR_EraseRootFromParent_Done,
     /* 272543 */   // Label 5479: @272543
     /* 272543 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(272580), // Rule ID 5154 //
     /* 272548 */     // MIs[0] Operand 1
     /* 272548 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272561 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272567 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272571 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272578 */     GIR_RootConstrainSelectedInstOperands,
     /* 272579 */     // GIR_Coverage, 5154,
     /* 272579 */     GIR_EraseRootFromParent_Done,
     /* 272580 */   // Label 5480: @272580
     /* 272580 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(272612), // Rule ID 1125 //
     /* 272585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272588 */     // MIs[0] Operand 1
     /* 272588 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272601 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 272604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272610 */     GIR_RootConstrainSelectedInstOperands,
     /* 272611 */     // GIR_Coverage, 1125,
     /* 272611 */     GIR_EraseRootFromParent_Done,
     /* 272612 */   // Label 5481: @272612
     /* 272612 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(272644), // Rule ID 1132 //
     /* 272617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272620 */     // MIs[0] Operand 1
     /* 272620 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272633 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 272636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272642 */     GIR_RootConstrainSelectedInstOperands,
     /* 272643 */     // GIR_Coverage, 1132,
     /* 272643 */     GIR_EraseRootFromParent_Done,
     /* 272644 */   // Label 5482: @272644
     /* 272644 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(272676), // Rule ID 1139 //
     /* 272649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272652 */     // MIs[0] Operand 1
     /* 272652 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272665 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 272668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272674 */     GIR_RootConstrainSelectedInstOperands,
     /* 272675 */     // GIR_Coverage, 1139,
     /* 272675 */     GIR_EraseRootFromParent_Done,
     /* 272676 */   // Label 5483: @272676
     /* 272676 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(272708), // Rule ID 1146 //
     /* 272681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272684 */     // MIs[0] Operand 1
     /* 272684 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272697 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 272700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272706 */     GIR_RootConstrainSelectedInstOperands,
     /* 272707 */     // GIR_Coverage, 1146,
     /* 272707 */     GIR_EraseRootFromParent_Done,
     /* 272708 */   // Label 5484: @272708
     /* 272708 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(272740), // Rule ID 1153 //
     /* 272713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272716 */     // MIs[0] Operand 1
     /* 272716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272729 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 272732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272738 */     GIR_RootConstrainSelectedInstOperands,
     /* 272739 */     // GIR_Coverage, 1153,
     /* 272739 */     GIR_EraseRootFromParent_Done,
     /* 272740 */   // Label 5485: @272740
     /* 272740 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(272769), // Rule ID 5063 //
     /* 272745 */     // MIs[0] Operand 1
     /* 272745 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272758 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 272761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272767 */     GIR_RootConstrainSelectedInstOperands,
     /* 272768 */     // GIR_Coverage, 5063,
     /* 272768 */     GIR_EraseRootFromParent_Done,
     /* 272769 */   // Label 5486: @272769
     /* 272769 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(272798), // Rule ID 5070 //
     /* 272774 */     // MIs[0] Operand 1
     /* 272774 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272787 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 272790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272796 */     GIR_RootConstrainSelectedInstOperands,
     /* 272797 */     // GIR_Coverage, 5070,
     /* 272797 */     GIR_EraseRootFromParent_Done,
     /* 272798 */   // Label 5487: @272798
     /* 272798 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(272827), // Rule ID 5077 //
     /* 272803 */     // MIs[0] Operand 1
     /* 272803 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272816 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 272819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272825 */     GIR_RootConstrainSelectedInstOperands,
     /* 272826 */     // GIR_Coverage, 5077,
     /* 272826 */     GIR_EraseRootFromParent_Done,
     /* 272827 */   // Label 5488: @272827
     /* 272827 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(272856), // Rule ID 5084 //
     /* 272832 */     // MIs[0] Operand 1
     /* 272832 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272845 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 272848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272854 */     GIR_RootConstrainSelectedInstOperands,
     /* 272855 */     // GIR_Coverage, 5084,
     /* 272855 */     GIR_EraseRootFromParent_Done,
     /* 272856 */   // Label 5489: @272856
     /* 272856 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(272885), // Rule ID 5091 //
     /* 272861 */     // MIs[0] Operand 1
     /* 272861 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272874 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 272874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 272877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272883 */     GIR_RootConstrainSelectedInstOperands,
     /* 272884 */     // GIR_Coverage, 5091,
     /* 272884 */     GIR_EraseRootFromParent_Done,
     /* 272885 */   // Label 5490: @272885
     /* 272885 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(272914), // Rule ID 5098 //
     /* 272890 */     // MIs[0] Operand 1
     /* 272890 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272903 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 272903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 272906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272912 */     GIR_RootConstrainSelectedInstOperands,
     /* 272913 */     // GIR_Coverage, 5098,
     /* 272913 */     GIR_EraseRootFromParent_Done,
     /* 272914 */   // Label 5491: @272914
     /* 272914 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(272943), // Rule ID 5105 //
     /* 272919 */     // MIs[0] Operand 1
     /* 272919 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272932 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 272932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 272935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272941 */     GIR_RootConstrainSelectedInstOperands,
     /* 272942 */     // GIR_Coverage, 5105,
     /* 272942 */     GIR_EraseRootFromParent_Done,
     /* 272943 */   // Label 5492: @272943
     /* 272943 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(272972), // Rule ID 5112 //
     /* 272948 */     // MIs[0] Operand 1
     /* 272948 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 272953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272961 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 272961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 272964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272970 */     GIR_RootConstrainSelectedInstOperands,
     /* 272971 */     // GIR_Coverage, 5112,
     /* 272971 */     GIR_EraseRootFromParent_Done,
     /* 272972 */   // Label 5493: @272972
     /* 272972 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(273001), // Rule ID 5119 //
     /* 272977 */     // MIs[0] Operand 1
     /* 272977 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 272982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272990 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 272990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 272993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272999 */     GIR_RootConstrainSelectedInstOperands,
     /* 273000 */     // GIR_Coverage, 5119,
     /* 273000 */     GIR_EraseRootFromParent_Done,
     /* 273001 */   // Label 5494: @273001
     /* 273001 */   GIM_Reject,
     /* 273002 */ // Label 5464: @273002
     /* 273002 */ GIM_Reject,
     /* 273003 */ // Label 5445: @273003
     /* 273003 */ GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(274050),
     /* 273008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 273014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273018 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(273058), // Rule ID 756 //
     /* 273023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273026 */     // MIs[0] Operand 1
     /* 273026 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273035 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273041 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273049 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273056 */     GIR_RootConstrainSelectedInstOperands,
     /* 273057 */     // GIR_Coverage, 756,
     /* 273057 */     GIR_EraseRootFromParent_Done,
     /* 273058 */   // Label 5496: @273058
     /* 273058 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(273098), // Rule ID 763 //
     /* 273063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273066 */     // MIs[0] Operand 1
     /* 273066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273089 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273096 */     GIR_RootConstrainSelectedInstOperands,
     /* 273097 */     // GIR_Coverage, 763,
     /* 273097 */     GIR_EraseRootFromParent_Done,
     /* 273098 */   // Label 5497: @273098
     /* 273098 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(273135), // Rule ID 5163 //
     /* 273103 */     // MIs[0] Operand 1
     /* 273103 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273118 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273126 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273133 */     GIR_RootConstrainSelectedInstOperands,
     /* 273134 */     // GIR_Coverage, 5163,
     /* 273134 */     GIR_EraseRootFromParent_Done,
     /* 273135 */   // Label 5498: @273135
     /* 273135 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(273172), // Rule ID 5170 //
     /* 273140 */     // MIs[0] Operand 1
     /* 273140 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273149 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273155 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273163 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273170 */     GIR_RootConstrainSelectedInstOperands,
     /* 273171 */     // GIR_Coverage, 5170,
     /* 273171 */     GIR_EraseRootFromParent_Done,
     /* 273172 */   // Label 5499: @273172
     /* 273172 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(273209), // Rule ID 5177 //
     /* 273177 */     // MIs[0] Operand 1
     /* 273177 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273200 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273207 */     GIR_RootConstrainSelectedInstOperands,
     /* 273208 */     // GIR_Coverage, 5177,
     /* 273208 */     GIR_EraseRootFromParent_Done,
     /* 273209 */   // Label 5500: @273209
     /* 273209 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(273246), // Rule ID 5184 //
     /* 273214 */     // MIs[0] Operand 1
     /* 273214 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273223 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273229 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273237 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273244 */     GIR_RootConstrainSelectedInstOperands,
     /* 273245 */     // GIR_Coverage, 5184,
     /* 273245 */     GIR_EraseRootFromParent_Done,
     /* 273246 */   // Label 5501: @273246
     /* 273246 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(273283), // Rule ID 5191 //
     /* 273251 */     // MIs[0] Operand 1
     /* 273251 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273260 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273266 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273274 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273281 */     GIR_RootConstrainSelectedInstOperands,
     /* 273282 */     // GIR_Coverage, 5191,
     /* 273282 */     GIR_EraseRootFromParent_Done,
     /* 273283 */   // Label 5502: @273283
     /* 273283 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(273323), // Rule ID 728 //
     /* 273288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273291 */     // MIs[0] Operand 1
     /* 273291 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273314 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273321 */     GIR_RootConstrainSelectedInstOperands,
     /* 273322 */     // GIR_Coverage, 728,
     /* 273322 */     GIR_EraseRootFromParent_Done,
     /* 273323 */   // Label 5503: @273323
     /* 273323 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(273363), // Rule ID 741 //
     /* 273328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273331 */     // MIs[0] Operand 1
     /* 273331 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273354 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273361 */     GIR_RootConstrainSelectedInstOperands,
     /* 273362 */     // GIR_Coverage, 741,
     /* 273362 */     GIR_EraseRootFromParent_Done,
     /* 273363 */   // Label 5504: @273363
     /* 273363 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(273403), // Rule ID 742 //
     /* 273368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273371 */     // MIs[0] Operand 1
     /* 273371 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273384 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273390 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 273392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273394 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273401 */     GIR_RootConstrainSelectedInstOperands,
     /* 273402 */     // GIR_Coverage, 742,
     /* 273402 */     GIR_EraseRootFromParent_Done,
     /* 273403 */   // Label 5505: @273403
     /* 273403 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(273443), // Rule ID 749 //
     /* 273408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273411 */     // MIs[0] Operand 1
     /* 273411 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273424 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273430 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273434 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273441 */     GIR_RootConstrainSelectedInstOperands,
     /* 273442 */     // GIR_Coverage, 749,
     /* 273442 */     GIR_EraseRootFromParent_Done,
     /* 273443 */   // Label 5506: @273443
     /* 273443 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(273480), // Rule ID 5128 //
     /* 273448 */     // MIs[0] Operand 1
     /* 273448 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273461 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273467 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273471 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273478 */     GIR_RootConstrainSelectedInstOperands,
     /* 273479 */     // GIR_Coverage, 5128,
     /* 273479 */     GIR_EraseRootFromParent_Done,
     /* 273480 */   // Label 5507: @273480
     /* 273480 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(273517), // Rule ID 5135 //
     /* 273485 */     // MIs[0] Operand 1
     /* 273485 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273498 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273504 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273508 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273515 */     GIR_RootConstrainSelectedInstOperands,
     /* 273516 */     // GIR_Coverage, 5135,
     /* 273516 */     GIR_EraseRootFromParent_Done,
     /* 273517 */   // Label 5508: @273517
     /* 273517 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(273554), // Rule ID 5142 //
     /* 273522 */     // MIs[0] Operand 1
     /* 273522 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273535 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273541 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273545 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273552 */     GIR_RootConstrainSelectedInstOperands,
     /* 273553 */     // GIR_Coverage, 5142,
     /* 273553 */     GIR_EraseRootFromParent_Done,
     /* 273554 */   // Label 5509: @273554
     /* 273554 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(273591), // Rule ID 5149 //
     /* 273559 */     // MIs[0] Operand 1
     /* 273559 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273572 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273578 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273582 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273589 */     GIR_RootConstrainSelectedInstOperands,
     /* 273590 */     // GIR_Coverage, 5149,
     /* 273590 */     GIR_EraseRootFromParent_Done,
     /* 273591 */   // Label 5510: @273591
     /* 273591 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(273628), // Rule ID 5156 //
     /* 273596 */     // MIs[0] Operand 1
     /* 273596 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273609 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273615 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273619 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273626 */     GIR_RootConstrainSelectedInstOperands,
     /* 273627 */     // GIR_Coverage, 5156,
     /* 273627 */     GIR_EraseRootFromParent_Done,
     /* 273628 */   // Label 5511: @273628
     /* 273628 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(273660), // Rule ID 1127 //
     /* 273633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273636 */     // MIs[0] Operand 1
     /* 273636 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273649 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 273652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273658 */     GIR_RootConstrainSelectedInstOperands,
     /* 273659 */     // GIR_Coverage, 1127,
     /* 273659 */     GIR_EraseRootFromParent_Done,
     /* 273660 */   // Label 5512: @273660
     /* 273660 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(273692), // Rule ID 1134 //
     /* 273665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273668 */     // MIs[0] Operand 1
     /* 273668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273681 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 273684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273690 */     GIR_RootConstrainSelectedInstOperands,
     /* 273691 */     // GIR_Coverage, 1134,
     /* 273691 */     GIR_EraseRootFromParent_Done,
     /* 273692 */   // Label 5513: @273692
     /* 273692 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(273724), // Rule ID 1141 //
     /* 273697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273700 */     // MIs[0] Operand 1
     /* 273700 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273713 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 273716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273722 */     GIR_RootConstrainSelectedInstOperands,
     /* 273723 */     // GIR_Coverage, 1141,
     /* 273723 */     GIR_EraseRootFromParent_Done,
     /* 273724 */   // Label 5514: @273724
     /* 273724 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(273756), // Rule ID 1148 //
     /* 273729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273732 */     // MIs[0] Operand 1
     /* 273732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273745 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 273748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273754 */     GIR_RootConstrainSelectedInstOperands,
     /* 273755 */     // GIR_Coverage, 1148,
     /* 273755 */     GIR_EraseRootFromParent_Done,
     /* 273756 */   // Label 5515: @273756
     /* 273756 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(273788), // Rule ID 1155 //
     /* 273761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273764 */     // MIs[0] Operand 1
     /* 273764 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273777 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 273780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273786 */     GIR_RootConstrainSelectedInstOperands,
     /* 273787 */     // GIR_Coverage, 1155,
     /* 273787 */     GIR_EraseRootFromParent_Done,
     /* 273788 */   // Label 5516: @273788
     /* 273788 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(273817), // Rule ID 5065 //
     /* 273793 */     // MIs[0] Operand 1
     /* 273793 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273806 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 273809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273815 */     GIR_RootConstrainSelectedInstOperands,
     /* 273816 */     // GIR_Coverage, 5065,
     /* 273816 */     GIR_EraseRootFromParent_Done,
     /* 273817 */   // Label 5517: @273817
     /* 273817 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(273846), // Rule ID 5072 //
     /* 273822 */     // MIs[0] Operand 1
     /* 273822 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273835 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 273838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273844 */     GIR_RootConstrainSelectedInstOperands,
     /* 273845 */     // GIR_Coverage, 5072,
     /* 273845 */     GIR_EraseRootFromParent_Done,
     /* 273846 */   // Label 5518: @273846
     /* 273846 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(273875), // Rule ID 5079 //
     /* 273851 */     // MIs[0] Operand 1
     /* 273851 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273864 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 273867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273873 */     GIR_RootConstrainSelectedInstOperands,
     /* 273874 */     // GIR_Coverage, 5079,
     /* 273874 */     GIR_EraseRootFromParent_Done,
     /* 273875 */   // Label 5519: @273875
     /* 273875 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(273904), // Rule ID 5086 //
     /* 273880 */     // MIs[0] Operand 1
     /* 273880 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273893 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 273896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273902 */     GIR_RootConstrainSelectedInstOperands,
     /* 273903 */     // GIR_Coverage, 5086,
     /* 273903 */     GIR_EraseRootFromParent_Done,
     /* 273904 */   // Label 5520: @273904
     /* 273904 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(273933), // Rule ID 5093 //
     /* 273909 */     // MIs[0] Operand 1
     /* 273909 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273922 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 273922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 273925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273931 */     GIR_RootConstrainSelectedInstOperands,
     /* 273932 */     // GIR_Coverage, 5093,
     /* 273932 */     GIR_EraseRootFromParent_Done,
     /* 273933 */   // Label 5521: @273933
     /* 273933 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(273962), // Rule ID 5100 //
     /* 273938 */     // MIs[0] Operand 1
     /* 273938 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273951 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 273951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 273954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273960 */     GIR_RootConstrainSelectedInstOperands,
     /* 273961 */     // GIR_Coverage, 5100,
     /* 273961 */     GIR_EraseRootFromParent_Done,
     /* 273962 */   // Label 5522: @273962
     /* 273962 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(273991), // Rule ID 5107 //
     /* 273967 */     // MIs[0] Operand 1
     /* 273967 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273980 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 273980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 273983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273989 */     GIR_RootConstrainSelectedInstOperands,
     /* 273990 */     // GIR_Coverage, 5107,
     /* 273990 */     GIR_EraseRootFromParent_Done,
     /* 273991 */   // Label 5523: @273991
     /* 273991 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274020), // Rule ID 5114 //
     /* 273996 */     // MIs[0] Operand 1
     /* 273996 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 274001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274009 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 274012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274018 */     GIR_RootConstrainSelectedInstOperands,
     /* 274019 */     // GIR_Coverage, 5114,
     /* 274019 */     GIR_EraseRootFromParent_Done,
     /* 274020 */   // Label 5524: @274020
     /* 274020 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(274049), // Rule ID 5121 //
     /* 274025 */     // MIs[0] Operand 1
     /* 274025 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 274030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274038 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274047 */     GIR_RootConstrainSelectedInstOperands,
     /* 274048 */     // GIR_Coverage, 5121,
     /* 274048 */     GIR_EraseRootFromParent_Done,
     /* 274049 */   // Label 5525: @274049
     /* 274049 */   GIM_Reject,
     /* 274050 */ // Label 5495: @274050
     /* 274050 */ GIM_Reject,
     /* 274051 */ // Label 5446: @274051
     /* 274051 */ GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(275098),
     /* 274056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 274062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274066 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(274106), // Rule ID 752 //
     /* 274071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274074 */     // MIs[0] Operand 1
     /* 274074 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274083 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274089 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274097 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274104 */     GIR_RootConstrainSelectedInstOperands,
     /* 274105 */     // GIR_Coverage, 752,
     /* 274105 */     GIR_EraseRootFromParent_Done,
     /* 274106 */   // Label 5527: @274106
     /* 274106 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(274146), // Rule ID 759 //
     /* 274111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274114 */     // MIs[0] Operand 1
     /* 274114 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274123 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274129 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274137 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274144 */     GIR_RootConstrainSelectedInstOperands,
     /* 274145 */     // GIR_Coverage, 759,
     /* 274145 */     GIR_EraseRootFromParent_Done,
     /* 274146 */   // Label 5528: @274146
     /* 274146 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(274183), // Rule ID 5159 //
     /* 274151 */     // MIs[0] Operand 1
     /* 274151 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274166 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274174 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274181 */     GIR_RootConstrainSelectedInstOperands,
     /* 274182 */     // GIR_Coverage, 5159,
     /* 274182 */     GIR_EraseRootFromParent_Done,
     /* 274183 */   // Label 5529: @274183
     /* 274183 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(274220), // Rule ID 5166 //
     /* 274188 */     // MIs[0] Operand 1
     /* 274188 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274211 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274218 */     GIR_RootConstrainSelectedInstOperands,
     /* 274219 */     // GIR_Coverage, 5166,
     /* 274219 */     GIR_EraseRootFromParent_Done,
     /* 274220 */   // Label 5530: @274220
     /* 274220 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(274257), // Rule ID 5173 //
     /* 274225 */     // MIs[0] Operand 1
     /* 274225 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274234 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274240 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274248 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274255 */     GIR_RootConstrainSelectedInstOperands,
     /* 274256 */     // GIR_Coverage, 5173,
     /* 274256 */     GIR_EraseRootFromParent_Done,
     /* 274257 */   // Label 5531: @274257
     /* 274257 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(274294), // Rule ID 5180 //
     /* 274262 */     // MIs[0] Operand 1
     /* 274262 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274271 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274277 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274285 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274292 */     GIR_RootConstrainSelectedInstOperands,
     /* 274293 */     // GIR_Coverage, 5180,
     /* 274293 */     GIR_EraseRootFromParent_Done,
     /* 274294 */   // Label 5532: @274294
     /* 274294 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(274331), // Rule ID 5187 //
     /* 274299 */     // MIs[0] Operand 1
     /* 274299 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274308 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274314 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274322 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274329 */     GIR_RootConstrainSelectedInstOperands,
     /* 274330 */     // GIR_Coverage, 5187,
     /* 274330 */     GIR_EraseRootFromParent_Done,
     /* 274331 */   // Label 5533: @274331
     /* 274331 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(274371), // Rule ID 724 //
     /* 274336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274339 */     // MIs[0] Operand 1
     /* 274339 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274362 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274369 */     GIR_RootConstrainSelectedInstOperands,
     /* 274370 */     // GIR_Coverage, 724,
     /* 274370 */     GIR_EraseRootFromParent_Done,
     /* 274371 */   // Label 5534: @274371
     /* 274371 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(274411), // Rule ID 733 //
     /* 274376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274379 */     // MIs[0] Operand 1
     /* 274379 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274402 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274409 */     GIR_RootConstrainSelectedInstOperands,
     /* 274410 */     // GIR_Coverage, 733,
     /* 274410 */     GIR_EraseRootFromParent_Done,
     /* 274411 */   // Label 5535: @274411
     /* 274411 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(274451), // Rule ID 734 //
     /* 274416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274419 */     // MIs[0] Operand 1
     /* 274419 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274432 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274438 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 274440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274442 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274449 */     GIR_RootConstrainSelectedInstOperands,
     /* 274450 */     // GIR_Coverage, 734,
     /* 274450 */     GIR_EraseRootFromParent_Done,
     /* 274451 */   // Label 5536: @274451
     /* 274451 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(274491), // Rule ID 745 //
     /* 274456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274459 */     // MIs[0] Operand 1
     /* 274459 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274478 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274482 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274489 */     GIR_RootConstrainSelectedInstOperands,
     /* 274490 */     // GIR_Coverage, 745,
     /* 274490 */     GIR_EraseRootFromParent_Done,
     /* 274491 */   // Label 5537: @274491
     /* 274491 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(274528), // Rule ID 5124 //
     /* 274496 */     // MIs[0] Operand 1
     /* 274496 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274509 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274515 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274519 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274526 */     GIR_RootConstrainSelectedInstOperands,
     /* 274527 */     // GIR_Coverage, 5124,
     /* 274527 */     GIR_EraseRootFromParent_Done,
     /* 274528 */   // Label 5538: @274528
     /* 274528 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(274565), // Rule ID 5131 //
     /* 274533 */     // MIs[0] Operand 1
     /* 274533 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274546 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274552 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274556 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274563 */     GIR_RootConstrainSelectedInstOperands,
     /* 274564 */     // GIR_Coverage, 5131,
     /* 274564 */     GIR_EraseRootFromParent_Done,
     /* 274565 */   // Label 5539: @274565
     /* 274565 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(274602), // Rule ID 5138 //
     /* 274570 */     // MIs[0] Operand 1
     /* 274570 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274583 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274589 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274593 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274600 */     GIR_RootConstrainSelectedInstOperands,
     /* 274601 */     // GIR_Coverage, 5138,
     /* 274601 */     GIR_EraseRootFromParent_Done,
     /* 274602 */   // Label 5540: @274602
     /* 274602 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(274639), // Rule ID 5145 //
     /* 274607 */     // MIs[0] Operand 1
     /* 274607 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274620 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274626 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274630 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274637 */     GIR_RootConstrainSelectedInstOperands,
     /* 274638 */     // GIR_Coverage, 5145,
     /* 274638 */     GIR_EraseRootFromParent_Done,
     /* 274639 */   // Label 5541: @274639
     /* 274639 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(274676), // Rule ID 5152 //
     /* 274644 */     // MIs[0] Operand 1
     /* 274644 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274657 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274663 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274667 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274674 */     GIR_RootConstrainSelectedInstOperands,
     /* 274675 */     // GIR_Coverage, 5152,
     /* 274675 */     GIR_EraseRootFromParent_Done,
     /* 274676 */   // Label 5542: @274676
     /* 274676 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(274708), // Rule ID 1123 //
     /* 274681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274684 */     // MIs[0] Operand 1
     /* 274684 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274697 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 274700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274706 */     GIR_RootConstrainSelectedInstOperands,
     /* 274707 */     // GIR_Coverage, 1123,
     /* 274707 */     GIR_EraseRootFromParent_Done,
     /* 274708 */   // Label 5543: @274708
     /* 274708 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(274740), // Rule ID 1130 //
     /* 274713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274716 */     // MIs[0] Operand 1
     /* 274716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274729 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 274732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274738 */     GIR_RootConstrainSelectedInstOperands,
     /* 274739 */     // GIR_Coverage, 1130,
     /* 274739 */     GIR_EraseRootFromParent_Done,
     /* 274740 */   // Label 5544: @274740
     /* 274740 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(274772), // Rule ID 1137 //
     /* 274745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274748 */     // MIs[0] Operand 1
     /* 274748 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274761 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 274764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274770 */     GIR_RootConstrainSelectedInstOperands,
     /* 274771 */     // GIR_Coverage, 1137,
     /* 274771 */     GIR_EraseRootFromParent_Done,
     /* 274772 */   // Label 5545: @274772
     /* 274772 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(274804), // Rule ID 1144 //
     /* 274777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274780 */     // MIs[0] Operand 1
     /* 274780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274793 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 274796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274802 */     GIR_RootConstrainSelectedInstOperands,
     /* 274803 */     // GIR_Coverage, 1144,
     /* 274803 */     GIR_EraseRootFromParent_Done,
     /* 274804 */   // Label 5546: @274804
     /* 274804 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(274836), // Rule ID 1151 //
     /* 274809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274812 */     // MIs[0] Operand 1
     /* 274812 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274825 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 274828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274834 */     GIR_RootConstrainSelectedInstOperands,
     /* 274835 */     // GIR_Coverage, 1151,
     /* 274835 */     GIR_EraseRootFromParent_Done,
     /* 274836 */   // Label 5547: @274836
     /* 274836 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(274865), // Rule ID 5061 //
     /* 274841 */     // MIs[0] Operand 1
     /* 274841 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274854 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 274857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274863 */     GIR_RootConstrainSelectedInstOperands,
     /* 274864 */     // GIR_Coverage, 5061,
     /* 274864 */     GIR_EraseRootFromParent_Done,
     /* 274865 */   // Label 5548: @274865
     /* 274865 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(274894), // Rule ID 5068 //
     /* 274870 */     // MIs[0] Operand 1
     /* 274870 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274883 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 274886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274892 */     GIR_RootConstrainSelectedInstOperands,
     /* 274893 */     // GIR_Coverage, 5068,
     /* 274893 */     GIR_EraseRootFromParent_Done,
     /* 274894 */   // Label 5549: @274894
     /* 274894 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(274923), // Rule ID 5075 //
     /* 274899 */     // MIs[0] Operand 1
     /* 274899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274912 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 274915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274921 */     GIR_RootConstrainSelectedInstOperands,
     /* 274922 */     // GIR_Coverage, 5075,
     /* 274922 */     GIR_EraseRootFromParent_Done,
     /* 274923 */   // Label 5550: @274923
     /* 274923 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(274952), // Rule ID 5082 //
     /* 274928 */     // MIs[0] Operand 1
     /* 274928 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274941 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 274944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274950 */     GIR_RootConstrainSelectedInstOperands,
     /* 274951 */     // GIR_Coverage, 5082,
     /* 274951 */     GIR_EraseRootFromParent_Done,
     /* 274952 */   // Label 5551: @274952
     /* 274952 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(274981), // Rule ID 5089 //
     /* 274957 */     // MIs[0] Operand 1
     /* 274957 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274970 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 274970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 274973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274979 */     GIR_RootConstrainSelectedInstOperands,
     /* 274980 */     // GIR_Coverage, 5089,
     /* 274980 */     GIR_EraseRootFromParent_Done,
     /* 274981 */   // Label 5552: @274981
     /* 274981 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(275010), // Rule ID 5096 //
     /* 274986 */     // MIs[0] Operand 1
     /* 274986 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274999 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 274999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275008 */     GIR_RootConstrainSelectedInstOperands,
     /* 275009 */     // GIR_Coverage, 5096,
     /* 275009 */     GIR_EraseRootFromParent_Done,
     /* 275010 */   // Label 5553: @275010
     /* 275010 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(275039), // Rule ID 5103 //
     /* 275015 */     // MIs[0] Operand 1
     /* 275015 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275028 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275037 */     GIR_RootConstrainSelectedInstOperands,
     /* 275038 */     // GIR_Coverage, 5103,
     /* 275038 */     GIR_EraseRootFromParent_Done,
     /* 275039 */   // Label 5554: @275039
     /* 275039 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(275068), // Rule ID 5110 //
     /* 275044 */     // MIs[0] Operand 1
     /* 275044 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275057 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275066 */     GIR_RootConstrainSelectedInstOperands,
     /* 275067 */     // GIR_Coverage, 5110,
     /* 275067 */     GIR_EraseRootFromParent_Done,
     /* 275068 */   // Label 5555: @275068
     /* 275068 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(275097), // Rule ID 5117 //
     /* 275073 */     // MIs[0] Operand 1
     /* 275073 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275086 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275095 */     GIR_RootConstrainSelectedInstOperands,
     /* 275096 */     // GIR_Coverage, 5117,
     /* 275096 */     GIR_EraseRootFromParent_Done,
     /* 275097 */   // Label 5556: @275097
     /* 275097 */   GIM_Reject,
     /* 275098 */ // Label 5526: @275098
     /* 275098 */ GIM_Reject,
     /* 275099 */ // Label 5447: @275099
     /* 275099 */ GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(276146),
     /* 275104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275114 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(275154), // Rule ID 755 //
     /* 275119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275122 */     // MIs[0] Operand 1
     /* 275122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275131 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275137 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275145 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275152 */     GIR_RootConstrainSelectedInstOperands,
     /* 275153 */     // GIR_Coverage, 755,
     /* 275153 */     GIR_EraseRootFromParent_Done,
     /* 275154 */   // Label 5558: @275154
     /* 275154 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(275194), // Rule ID 762 //
     /* 275159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275162 */     // MIs[0] Operand 1
     /* 275162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275171 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275177 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275185 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275192 */     GIR_RootConstrainSelectedInstOperands,
     /* 275193 */     // GIR_Coverage, 762,
     /* 275193 */     GIR_EraseRootFromParent_Done,
     /* 275194 */   // Label 5559: @275194
     /* 275194 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(275231), // Rule ID 5162 //
     /* 275199 */     // MIs[0] Operand 1
     /* 275199 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275208 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275214 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275222 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275229 */     GIR_RootConstrainSelectedInstOperands,
     /* 275230 */     // GIR_Coverage, 5162,
     /* 275230 */     GIR_EraseRootFromParent_Done,
     /* 275231 */   // Label 5560: @275231
     /* 275231 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(275268), // Rule ID 5169 //
     /* 275236 */     // MIs[0] Operand 1
     /* 275236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275245 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275251 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275259 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275266 */     GIR_RootConstrainSelectedInstOperands,
     /* 275267 */     // GIR_Coverage, 5169,
     /* 275267 */     GIR_EraseRootFromParent_Done,
     /* 275268 */   // Label 5561: @275268
     /* 275268 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(275305), // Rule ID 5176 //
     /* 275273 */     // MIs[0] Operand 1
     /* 275273 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275282 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275288 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275296 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275303 */     GIR_RootConstrainSelectedInstOperands,
     /* 275304 */     // GIR_Coverage, 5176,
     /* 275304 */     GIR_EraseRootFromParent_Done,
     /* 275305 */   // Label 5562: @275305
     /* 275305 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(275342), // Rule ID 5183 //
     /* 275310 */     // MIs[0] Operand 1
     /* 275310 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275319 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275325 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275333 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275340 */     GIR_RootConstrainSelectedInstOperands,
     /* 275341 */     // GIR_Coverage, 5183,
     /* 275341 */     GIR_EraseRootFromParent_Done,
     /* 275342 */   // Label 5563: @275342
     /* 275342 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(275379), // Rule ID 5190 //
     /* 275347 */     // MIs[0] Operand 1
     /* 275347 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275370 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275377 */     GIR_RootConstrainSelectedInstOperands,
     /* 275378 */     // GIR_Coverage, 5190,
     /* 275378 */     GIR_EraseRootFromParent_Done,
     /* 275379 */   // Label 5564: @275379
     /* 275379 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(275419), // Rule ID 727 //
     /* 275384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275387 */     // MIs[0] Operand 1
     /* 275387 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275400 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275406 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275410 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275417 */     GIR_RootConstrainSelectedInstOperands,
     /* 275418 */     // GIR_Coverage, 727,
     /* 275418 */     GIR_EraseRootFromParent_Done,
     /* 275419 */   // Label 5565: @275419
     /* 275419 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(275459), // Rule ID 739 //
     /* 275424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275427 */     // MIs[0] Operand 1
     /* 275427 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275440 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275446 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275450 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275457 */     GIR_RootConstrainSelectedInstOperands,
     /* 275458 */     // GIR_Coverage, 739,
     /* 275458 */     GIR_EraseRootFromParent_Done,
     /* 275459 */   // Label 5566: @275459
     /* 275459 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(275499), // Rule ID 740 //
     /* 275464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275467 */     // MIs[0] Operand 1
     /* 275467 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275486 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 275488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275490 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275497 */     GIR_RootConstrainSelectedInstOperands,
     /* 275498 */     // GIR_Coverage, 740,
     /* 275498 */     GIR_EraseRootFromParent_Done,
     /* 275499 */   // Label 5567: @275499
     /* 275499 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(275539), // Rule ID 748 //
     /* 275504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275507 */     // MIs[0] Operand 1
     /* 275507 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275526 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275530 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275537 */     GIR_RootConstrainSelectedInstOperands,
     /* 275538 */     // GIR_Coverage, 748,
     /* 275538 */     GIR_EraseRootFromParent_Done,
     /* 275539 */   // Label 5568: @275539
     /* 275539 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(275576), // Rule ID 5127 //
     /* 275544 */     // MIs[0] Operand 1
     /* 275544 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275557 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275563 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275567 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275574 */     GIR_RootConstrainSelectedInstOperands,
     /* 275575 */     // GIR_Coverage, 5127,
     /* 275575 */     GIR_EraseRootFromParent_Done,
     /* 275576 */   // Label 5569: @275576
     /* 275576 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(275613), // Rule ID 5134 //
     /* 275581 */     // MIs[0] Operand 1
     /* 275581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275604 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275611 */     GIR_RootConstrainSelectedInstOperands,
     /* 275612 */     // GIR_Coverage, 5134,
     /* 275612 */     GIR_EraseRootFromParent_Done,
     /* 275613 */   // Label 5570: @275613
     /* 275613 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(275650), // Rule ID 5141 //
     /* 275618 */     // MIs[0] Operand 1
     /* 275618 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275631 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275637 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275641 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275648 */     GIR_RootConstrainSelectedInstOperands,
     /* 275649 */     // GIR_Coverage, 5141,
     /* 275649 */     GIR_EraseRootFromParent_Done,
     /* 275650 */   // Label 5571: @275650
     /* 275650 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(275687), // Rule ID 5148 //
     /* 275655 */     // MIs[0] Operand 1
     /* 275655 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275668 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275674 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275678 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275685 */     GIR_RootConstrainSelectedInstOperands,
     /* 275686 */     // GIR_Coverage, 5148,
     /* 275686 */     GIR_EraseRootFromParent_Done,
     /* 275687 */   // Label 5572: @275687
     /* 275687 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(275724), // Rule ID 5155 //
     /* 275692 */     // MIs[0] Operand 1
     /* 275692 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275705 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275711 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275715 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275722 */     GIR_RootConstrainSelectedInstOperands,
     /* 275723 */     // GIR_Coverage, 5155,
     /* 275723 */     GIR_EraseRootFromParent_Done,
     /* 275724 */   // Label 5573: @275724
     /* 275724 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(275756), // Rule ID 1126 //
     /* 275729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275732 */     // MIs[0] Operand 1
     /* 275732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275745 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 275748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275754 */     GIR_RootConstrainSelectedInstOperands,
     /* 275755 */     // GIR_Coverage, 1126,
     /* 275755 */     GIR_EraseRootFromParent_Done,
     /* 275756 */   // Label 5574: @275756
     /* 275756 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(275788), // Rule ID 1133 //
     /* 275761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275764 */     // MIs[0] Operand 1
     /* 275764 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275777 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 275780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275786 */     GIR_RootConstrainSelectedInstOperands,
     /* 275787 */     // GIR_Coverage, 1133,
     /* 275787 */     GIR_EraseRootFromParent_Done,
     /* 275788 */   // Label 5575: @275788
     /* 275788 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(275820), // Rule ID 1140 //
     /* 275793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275796 */     // MIs[0] Operand 1
     /* 275796 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275809 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 275812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275818 */     GIR_RootConstrainSelectedInstOperands,
     /* 275819 */     // GIR_Coverage, 1140,
     /* 275819 */     GIR_EraseRootFromParent_Done,
     /* 275820 */   // Label 5576: @275820
     /* 275820 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(275852), // Rule ID 1147 //
     /* 275825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275828 */     // MIs[0] Operand 1
     /* 275828 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275841 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 275844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275850 */     GIR_RootConstrainSelectedInstOperands,
     /* 275851 */     // GIR_Coverage, 1147,
     /* 275851 */     GIR_EraseRootFromParent_Done,
     /* 275852 */   // Label 5577: @275852
     /* 275852 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(275884), // Rule ID 1154 //
     /* 275857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275860 */     // MIs[0] Operand 1
     /* 275860 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275873 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 275876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275882 */     GIR_RootConstrainSelectedInstOperands,
     /* 275883 */     // GIR_Coverage, 1154,
     /* 275883 */     GIR_EraseRootFromParent_Done,
     /* 275884 */   // Label 5578: @275884
     /* 275884 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(275913), // Rule ID 5064 //
     /* 275889 */     // MIs[0] Operand 1
     /* 275889 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275902 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 275905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275911 */     GIR_RootConstrainSelectedInstOperands,
     /* 275912 */     // GIR_Coverage, 5064,
     /* 275912 */     GIR_EraseRootFromParent_Done,
     /* 275913 */   // Label 5579: @275913
     /* 275913 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(275942), // Rule ID 5071 //
     /* 275918 */     // MIs[0] Operand 1
     /* 275918 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275931 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 275934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275940 */     GIR_RootConstrainSelectedInstOperands,
     /* 275941 */     // GIR_Coverage, 5071,
     /* 275941 */     GIR_EraseRootFromParent_Done,
     /* 275942 */   // Label 5580: @275942
     /* 275942 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(275971), // Rule ID 5078 //
     /* 275947 */     // MIs[0] Operand 1
     /* 275947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275960 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 275963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275969 */     GIR_RootConstrainSelectedInstOperands,
     /* 275970 */     // GIR_Coverage, 5078,
     /* 275970 */     GIR_EraseRootFromParent_Done,
     /* 275971 */   // Label 5581: @275971
     /* 275971 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276000), // Rule ID 5085 //
     /* 275976 */     // MIs[0] Operand 1
     /* 275976 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275989 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 275989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 275992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275998 */     GIR_RootConstrainSelectedInstOperands,
     /* 275999 */     // GIR_Coverage, 5085,
     /* 275999 */     GIR_EraseRootFromParent_Done,
     /* 276000 */   // Label 5582: @276000
     /* 276000 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(276029), // Rule ID 5092 //
     /* 276005 */     // MIs[0] Operand 1
     /* 276005 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276018 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276027 */     GIR_RootConstrainSelectedInstOperands,
     /* 276028 */     // GIR_Coverage, 5092,
     /* 276028 */     GIR_EraseRootFromParent_Done,
     /* 276029 */   // Label 5583: @276029
     /* 276029 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(276058), // Rule ID 5099 //
     /* 276034 */     // MIs[0] Operand 1
     /* 276034 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276047 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276056 */     GIR_RootConstrainSelectedInstOperands,
     /* 276057 */     // GIR_Coverage, 5099,
     /* 276057 */     GIR_EraseRootFromParent_Done,
     /* 276058 */   // Label 5584: @276058
     /* 276058 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(276087), // Rule ID 5106 //
     /* 276063 */     // MIs[0] Operand 1
     /* 276063 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276076 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276085 */     GIR_RootConstrainSelectedInstOperands,
     /* 276086 */     // GIR_Coverage, 5106,
     /* 276086 */     GIR_EraseRootFromParent_Done,
     /* 276087 */   // Label 5585: @276087
     /* 276087 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(276116), // Rule ID 5113 //
     /* 276092 */     // MIs[0] Operand 1
     /* 276092 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 276097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276105 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276114 */     GIR_RootConstrainSelectedInstOperands,
     /* 276115 */     // GIR_Coverage, 5113,
     /* 276115 */     GIR_EraseRootFromParent_Done,
     /* 276116 */   // Label 5586: @276116
     /* 276116 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(276145), // Rule ID 5120 //
     /* 276121 */     // MIs[0] Operand 1
     /* 276121 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 276126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276134 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276143 */     GIR_RootConstrainSelectedInstOperands,
     /* 276144 */     // GIR_Coverage, 5120,
     /* 276144 */     GIR_EraseRootFromParent_Done,
     /* 276145 */   // Label 5587: @276145
     /* 276145 */   GIM_Reject,
     /* 276146 */ // Label 5557: @276146
     /* 276146 */ GIM_Reject,
     /* 276147 */ // Label 5448: @276147
     /* 276147 */ GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(277194),
     /* 276152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 276155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276162 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(276202), // Rule ID 750 //
     /* 276167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276170 */     // MIs[0] Operand 1
     /* 276170 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276179 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276185 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276193 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276200 */     GIR_RootConstrainSelectedInstOperands,
     /* 276201 */     // GIR_Coverage, 750,
     /* 276201 */     GIR_EraseRootFromParent_Done,
     /* 276202 */   // Label 5589: @276202
     /* 276202 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(276242), // Rule ID 757 //
     /* 276207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276210 */     // MIs[0] Operand 1
     /* 276210 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276219 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276225 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276233 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276240 */     GIR_RootConstrainSelectedInstOperands,
     /* 276241 */     // GIR_Coverage, 757,
     /* 276241 */     GIR_EraseRootFromParent_Done,
     /* 276242 */   // Label 5590: @276242
     /* 276242 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(276279), // Rule ID 5157 //
     /* 276247 */     // MIs[0] Operand 1
     /* 276247 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276256 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276262 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276270 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276277 */     GIR_RootConstrainSelectedInstOperands,
     /* 276278 */     // GIR_Coverage, 5157,
     /* 276278 */     GIR_EraseRootFromParent_Done,
     /* 276279 */   // Label 5591: @276279
     /* 276279 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(276316), // Rule ID 5164 //
     /* 276284 */     // MIs[0] Operand 1
     /* 276284 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276293 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276299 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276307 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276314 */     GIR_RootConstrainSelectedInstOperands,
     /* 276315 */     // GIR_Coverage, 5164,
     /* 276315 */     GIR_EraseRootFromParent_Done,
     /* 276316 */   // Label 5592: @276316
     /* 276316 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(276353), // Rule ID 5171 //
     /* 276321 */     // MIs[0] Operand 1
     /* 276321 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276330 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276336 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276344 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276351 */     GIR_RootConstrainSelectedInstOperands,
     /* 276352 */     // GIR_Coverage, 5171,
     /* 276352 */     GIR_EraseRootFromParent_Done,
     /* 276353 */   // Label 5593: @276353
     /* 276353 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(276390), // Rule ID 5178 //
     /* 276358 */     // MIs[0] Operand 1
     /* 276358 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276367 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276373 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276381 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276388 */     GIR_RootConstrainSelectedInstOperands,
     /* 276389 */     // GIR_Coverage, 5178,
     /* 276389 */     GIR_EraseRootFromParent_Done,
     /* 276390 */   // Label 5594: @276390
     /* 276390 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(276427), // Rule ID 5185 //
     /* 276395 */     // MIs[0] Operand 1
     /* 276395 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276404 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276410 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276418 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276425 */     GIR_RootConstrainSelectedInstOperands,
     /* 276426 */     // GIR_Coverage, 5185,
     /* 276426 */     GIR_EraseRootFromParent_Done,
     /* 276427 */   // Label 5595: @276427
     /* 276427 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(276467), // Rule ID 722 //
     /* 276432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276435 */     // MIs[0] Operand 1
     /* 276435 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276448 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276454 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276458 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276465 */     GIR_RootConstrainSelectedInstOperands,
     /* 276466 */     // GIR_Coverage, 722,
     /* 276466 */     GIR_EraseRootFromParent_Done,
     /* 276467 */   // Label 5596: @276467
     /* 276467 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(276507), // Rule ID 729 //
     /* 276472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276475 */     // MIs[0] Operand 1
     /* 276475 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276488 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276494 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276498 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276505 */     GIR_RootConstrainSelectedInstOperands,
     /* 276506 */     // GIR_Coverage, 729,
     /* 276506 */     GIR_EraseRootFromParent_Done,
     /* 276507 */   // Label 5597: @276507
     /* 276507 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(276547), // Rule ID 730 //
     /* 276512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276515 */     // MIs[0] Operand 1
     /* 276515 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276528 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276534 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 276536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276538 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276545 */     GIR_RootConstrainSelectedInstOperands,
     /* 276546 */     // GIR_Coverage, 730,
     /* 276546 */     GIR_EraseRootFromParent_Done,
     /* 276547 */   // Label 5598: @276547
     /* 276547 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(276587), // Rule ID 743 //
     /* 276552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276555 */     // MIs[0] Operand 1
     /* 276555 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276568 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276574 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276578 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276585 */     GIR_RootConstrainSelectedInstOperands,
     /* 276586 */     // GIR_Coverage, 743,
     /* 276586 */     GIR_EraseRootFromParent_Done,
     /* 276587 */   // Label 5599: @276587
     /* 276587 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(276624), // Rule ID 5122 //
     /* 276592 */     // MIs[0] Operand 1
     /* 276592 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276605 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276611 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276615 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276622 */     GIR_RootConstrainSelectedInstOperands,
     /* 276623 */     // GIR_Coverage, 5122,
     /* 276623 */     GIR_EraseRootFromParent_Done,
     /* 276624 */   // Label 5600: @276624
     /* 276624 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(276661), // Rule ID 5129 //
     /* 276629 */     // MIs[0] Operand 1
     /* 276629 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276642 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276648 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276652 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276659 */     GIR_RootConstrainSelectedInstOperands,
     /* 276660 */     // GIR_Coverage, 5129,
     /* 276660 */     GIR_EraseRootFromParent_Done,
     /* 276661 */   // Label 5601: @276661
     /* 276661 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(276698), // Rule ID 5136 //
     /* 276666 */     // MIs[0] Operand 1
     /* 276666 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276679 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276685 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276689 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276696 */     GIR_RootConstrainSelectedInstOperands,
     /* 276697 */     // GIR_Coverage, 5136,
     /* 276697 */     GIR_EraseRootFromParent_Done,
     /* 276698 */   // Label 5602: @276698
     /* 276698 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(276735), // Rule ID 5143 //
     /* 276703 */     // MIs[0] Operand 1
     /* 276703 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276726 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276733 */     GIR_RootConstrainSelectedInstOperands,
     /* 276734 */     // GIR_Coverage, 5143,
     /* 276734 */     GIR_EraseRootFromParent_Done,
     /* 276735 */   // Label 5603: @276735
     /* 276735 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(276772), // Rule ID 5150 //
     /* 276740 */     // MIs[0] Operand 1
     /* 276740 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276753 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276759 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276763 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276770 */     GIR_RootConstrainSelectedInstOperands,
     /* 276771 */     // GIR_Coverage, 5150,
     /* 276771 */     GIR_EraseRootFromParent_Done,
     /* 276772 */   // Label 5604: @276772
     /* 276772 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(276804), // Rule ID 1121 //
     /* 276777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276780 */     // MIs[0] Operand 1
     /* 276780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276793 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 276796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276802 */     GIR_RootConstrainSelectedInstOperands,
     /* 276803 */     // GIR_Coverage, 1121,
     /* 276803 */     GIR_EraseRootFromParent_Done,
     /* 276804 */   // Label 5605: @276804
     /* 276804 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(276836), // Rule ID 1128 //
     /* 276809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276812 */     // MIs[0] Operand 1
     /* 276812 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276825 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 276828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276834 */     GIR_RootConstrainSelectedInstOperands,
     /* 276835 */     // GIR_Coverage, 1128,
     /* 276835 */     GIR_EraseRootFromParent_Done,
     /* 276836 */   // Label 5606: @276836
     /* 276836 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(276868), // Rule ID 1135 //
     /* 276841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276844 */     // MIs[0] Operand 1
     /* 276844 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276857 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 276860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276866 */     GIR_RootConstrainSelectedInstOperands,
     /* 276867 */     // GIR_Coverage, 1135,
     /* 276867 */     GIR_EraseRootFromParent_Done,
     /* 276868 */   // Label 5607: @276868
     /* 276868 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(276900), // Rule ID 1142 //
     /* 276873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276876 */     // MIs[0] Operand 1
     /* 276876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276889 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 276892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276898 */     GIR_RootConstrainSelectedInstOperands,
     /* 276899 */     // GIR_Coverage, 1142,
     /* 276899 */     GIR_EraseRootFromParent_Done,
     /* 276900 */   // Label 5608: @276900
     /* 276900 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(276932), // Rule ID 1149 //
     /* 276905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276908 */     // MIs[0] Operand 1
     /* 276908 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276921 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 276924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276930 */     GIR_RootConstrainSelectedInstOperands,
     /* 276931 */     // GIR_Coverage, 1149,
     /* 276931 */     GIR_EraseRootFromParent_Done,
     /* 276932 */   // Label 5609: @276932
     /* 276932 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(276961), // Rule ID 5059 //
     /* 276937 */     // MIs[0] Operand 1
     /* 276937 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276950 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 276953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276959 */     GIR_RootConstrainSelectedInstOperands,
     /* 276960 */     // GIR_Coverage, 5059,
     /* 276960 */     GIR_EraseRootFromParent_Done,
     /* 276961 */   // Label 5610: @276961
     /* 276961 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(276990), // Rule ID 5066 //
     /* 276966 */     // MIs[0] Operand 1
     /* 276966 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276979 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 276979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 276982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276988 */     GIR_RootConstrainSelectedInstOperands,
     /* 276989 */     // GIR_Coverage, 5066,
     /* 276989 */     GIR_EraseRootFromParent_Done,
     /* 276990 */   // Label 5611: @276990
     /* 276990 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(277019), // Rule ID 5073 //
     /* 276995 */     // MIs[0] Operand 1
     /* 276995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277008 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277017 */     GIR_RootConstrainSelectedInstOperands,
     /* 277018 */     // GIR_Coverage, 5073,
     /* 277018 */     GIR_EraseRootFromParent_Done,
     /* 277019 */   // Label 5612: @277019
     /* 277019 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(277048), // Rule ID 5080 //
     /* 277024 */     // MIs[0] Operand 1
     /* 277024 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277037 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277046 */     GIR_RootConstrainSelectedInstOperands,
     /* 277047 */     // GIR_Coverage, 5080,
     /* 277047 */     GIR_EraseRootFromParent_Done,
     /* 277048 */   // Label 5613: @277048
     /* 277048 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(277077), // Rule ID 5087 //
     /* 277053 */     // MIs[0] Operand 1
     /* 277053 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277066 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277075 */     GIR_RootConstrainSelectedInstOperands,
     /* 277076 */     // GIR_Coverage, 5087,
     /* 277076 */     GIR_EraseRootFromParent_Done,
     /* 277077 */   // Label 5614: @277077
     /* 277077 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(277106), // Rule ID 5094 //
     /* 277082 */     // MIs[0] Operand 1
     /* 277082 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277095 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277104 */     GIR_RootConstrainSelectedInstOperands,
     /* 277105 */     // GIR_Coverage, 5094,
     /* 277105 */     GIR_EraseRootFromParent_Done,
     /* 277106 */   // Label 5615: @277106
     /* 277106 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(277135), // Rule ID 5101 //
     /* 277111 */     // MIs[0] Operand 1
     /* 277111 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277124 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277133 */     GIR_RootConstrainSelectedInstOperands,
     /* 277134 */     // GIR_Coverage, 5101,
     /* 277134 */     GIR_EraseRootFromParent_Done,
     /* 277135 */   // Label 5616: @277135
     /* 277135 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(277164), // Rule ID 5108 //
     /* 277140 */     // MIs[0] Operand 1
     /* 277140 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 277145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277153 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277162 */     GIR_RootConstrainSelectedInstOperands,
     /* 277163 */     // GIR_Coverage, 5108,
     /* 277163 */     GIR_EraseRootFromParent_Done,
     /* 277164 */   // Label 5617: @277164
     /* 277164 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(277193), // Rule ID 5115 //
     /* 277169 */     // MIs[0] Operand 1
     /* 277169 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 277174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277182 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277191 */     GIR_RootConstrainSelectedInstOperands,
     /* 277192 */     // GIR_Coverage, 5115,
     /* 277192 */     GIR_EraseRootFromParent_Done,
     /* 277193 */   // Label 5618: @277193
     /* 277193 */   GIM_Reject,
     /* 277194 */ // Label 5588: @277194
     /* 277194 */ GIM_Reject,
     /* 277195 */ // Label 5449: @277195
     /* 277195 */ GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(278242),
     /* 277200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 277206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277210 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(277250), // Rule ID 753 //
     /* 277215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277218 */     // MIs[0] Operand 1
     /* 277218 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277227 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277233 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277241 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277248 */     GIR_RootConstrainSelectedInstOperands,
     /* 277249 */     // GIR_Coverage, 753,
     /* 277249 */     GIR_EraseRootFromParent_Done,
     /* 277250 */   // Label 5620: @277250
     /* 277250 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(277290), // Rule ID 760 //
     /* 277255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277258 */     // MIs[0] Operand 1
     /* 277258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277281 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277288 */     GIR_RootConstrainSelectedInstOperands,
     /* 277289 */     // GIR_Coverage, 760,
     /* 277289 */     GIR_EraseRootFromParent_Done,
     /* 277290 */   // Label 5621: @277290
     /* 277290 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(277327), // Rule ID 5160 //
     /* 277295 */     // MIs[0] Operand 1
     /* 277295 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277318 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277325 */     GIR_RootConstrainSelectedInstOperands,
     /* 277326 */     // GIR_Coverage, 5160,
     /* 277326 */     GIR_EraseRootFromParent_Done,
     /* 277327 */   // Label 5622: @277327
     /* 277327 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(277364), // Rule ID 5167 //
     /* 277332 */     // MIs[0] Operand 1
     /* 277332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277341 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277347 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277355 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277362 */     GIR_RootConstrainSelectedInstOperands,
     /* 277363 */     // GIR_Coverage, 5167,
     /* 277363 */     GIR_EraseRootFromParent_Done,
     /* 277364 */   // Label 5623: @277364
     /* 277364 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(277401), // Rule ID 5174 //
     /* 277369 */     // MIs[0] Operand 1
     /* 277369 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277378 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277384 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277392 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277399 */     GIR_RootConstrainSelectedInstOperands,
     /* 277400 */     // GIR_Coverage, 5174,
     /* 277400 */     GIR_EraseRootFromParent_Done,
     /* 277401 */   // Label 5624: @277401
     /* 277401 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(277438), // Rule ID 5181 //
     /* 277406 */     // MIs[0] Operand 1
     /* 277406 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277415 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277421 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277429 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277436 */     GIR_RootConstrainSelectedInstOperands,
     /* 277437 */     // GIR_Coverage, 5181,
     /* 277437 */     GIR_EraseRootFromParent_Done,
     /* 277438 */   // Label 5625: @277438
     /* 277438 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(277475), // Rule ID 5188 //
     /* 277443 */     // MIs[0] Operand 1
     /* 277443 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277452 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277458 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277466 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277473 */     GIR_RootConstrainSelectedInstOperands,
     /* 277474 */     // GIR_Coverage, 5188,
     /* 277474 */     GIR_EraseRootFromParent_Done,
     /* 277475 */   // Label 5626: @277475
     /* 277475 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(277515), // Rule ID 725 //
     /* 277480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277483 */     // MIs[0] Operand 1
     /* 277483 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277496 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277502 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277506 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277513 */     GIR_RootConstrainSelectedInstOperands,
     /* 277514 */     // GIR_Coverage, 725,
     /* 277514 */     GIR_EraseRootFromParent_Done,
     /* 277515 */   // Label 5627: @277515
     /* 277515 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(277555), // Rule ID 735 //
     /* 277520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277523 */     // MIs[0] Operand 1
     /* 277523 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277536 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277542 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277546 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277553 */     GIR_RootConstrainSelectedInstOperands,
     /* 277554 */     // GIR_Coverage, 735,
     /* 277554 */     GIR_EraseRootFromParent_Done,
     /* 277555 */   // Label 5628: @277555
     /* 277555 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(277595), // Rule ID 736 //
     /* 277560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277563 */     // MIs[0] Operand 1
     /* 277563 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277576 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277582 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 277584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277586 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277593 */     GIR_RootConstrainSelectedInstOperands,
     /* 277594 */     // GIR_Coverage, 736,
     /* 277594 */     GIR_EraseRootFromParent_Done,
     /* 277595 */   // Label 5629: @277595
     /* 277595 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(277635), // Rule ID 746 //
     /* 277600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277603 */     // MIs[0] Operand 1
     /* 277603 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277616 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277622 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277626 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277633 */     GIR_RootConstrainSelectedInstOperands,
     /* 277634 */     // GIR_Coverage, 746,
     /* 277634 */     GIR_EraseRootFromParent_Done,
     /* 277635 */   // Label 5630: @277635
     /* 277635 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(277672), // Rule ID 5125 //
     /* 277640 */     // MIs[0] Operand 1
     /* 277640 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277653 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277659 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277663 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277670 */     GIR_RootConstrainSelectedInstOperands,
     /* 277671 */     // GIR_Coverage, 5125,
     /* 277671 */     GIR_EraseRootFromParent_Done,
     /* 277672 */   // Label 5631: @277672
     /* 277672 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(277709), // Rule ID 5132 //
     /* 277677 */     // MIs[0] Operand 1
     /* 277677 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277690 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277696 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277700 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277707 */     GIR_RootConstrainSelectedInstOperands,
     /* 277708 */     // GIR_Coverage, 5132,
     /* 277708 */     GIR_EraseRootFromParent_Done,
     /* 277709 */   // Label 5632: @277709
     /* 277709 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(277746), // Rule ID 5139 //
     /* 277714 */     // MIs[0] Operand 1
     /* 277714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277727 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277733 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277737 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 277740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277744 */     GIR_RootConstrainSelectedInstOperands,
     /* 277745 */     // GIR_Coverage, 5139,
     /* 277745 */     GIR_EraseRootFromParent_Done,
     /* 277746 */   // Label 5633: @277746
     /* 277746 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(277783), // Rule ID 5146 //
     /* 277751 */     // MIs[0] Operand 1
     /* 277751 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277764 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277770 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277774 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277781 */     GIR_RootConstrainSelectedInstOperands,
     /* 277782 */     // GIR_Coverage, 5146,
     /* 277782 */     GIR_EraseRootFromParent_Done,
     /* 277783 */   // Label 5634: @277783
     /* 277783 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(277820), // Rule ID 5153 //
     /* 277788 */     // MIs[0] Operand 1
     /* 277788 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277801 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277807 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277811 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277818 */     GIR_RootConstrainSelectedInstOperands,
     /* 277819 */     // GIR_Coverage, 5153,
     /* 277819 */     GIR_EraseRootFromParent_Done,
     /* 277820 */   // Label 5635: @277820
     /* 277820 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(277852), // Rule ID 1124 //
     /* 277825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277828 */     // MIs[0] Operand 1
     /* 277828 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277841 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 277844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277850 */     GIR_RootConstrainSelectedInstOperands,
     /* 277851 */     // GIR_Coverage, 1124,
     /* 277851 */     GIR_EraseRootFromParent_Done,
     /* 277852 */   // Label 5636: @277852
     /* 277852 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(277884), // Rule ID 1131 //
     /* 277857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277860 */     // MIs[0] Operand 1
     /* 277860 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277873 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 277876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277882 */     GIR_RootConstrainSelectedInstOperands,
     /* 277883 */     // GIR_Coverage, 1131,
     /* 277883 */     GIR_EraseRootFromParent_Done,
     /* 277884 */   // Label 5637: @277884
     /* 277884 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(277916), // Rule ID 1138 //
     /* 277889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277892 */     // MIs[0] Operand 1
     /* 277892 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277905 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 277908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277914 */     GIR_RootConstrainSelectedInstOperands,
     /* 277915 */     // GIR_Coverage, 1138,
     /* 277915 */     GIR_EraseRootFromParent_Done,
     /* 277916 */   // Label 5638: @277916
     /* 277916 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(277948), // Rule ID 1145 //
     /* 277921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277924 */     // MIs[0] Operand 1
     /* 277924 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277937 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 277940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277946 */     GIR_RootConstrainSelectedInstOperands,
     /* 277947 */     // GIR_Coverage, 1145,
     /* 277947 */     GIR_EraseRootFromParent_Done,
     /* 277948 */   // Label 5639: @277948
     /* 277948 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(277980), // Rule ID 1152 //
     /* 277953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277956 */     // MIs[0] Operand 1
     /* 277956 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277969 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 277972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277978 */     GIR_RootConstrainSelectedInstOperands,
     /* 277979 */     // GIR_Coverage, 1152,
     /* 277979 */     GIR_EraseRootFromParent_Done,
     /* 277980 */   // Label 5640: @277980
     /* 277980 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(278009), // Rule ID 5062 //
     /* 277985 */     // MIs[0] Operand 1
     /* 277985 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277998 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 277998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 278001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278007 */     GIR_RootConstrainSelectedInstOperands,
     /* 278008 */     // GIR_Coverage, 5062,
     /* 278008 */     GIR_EraseRootFromParent_Done,
     /* 278009 */   // Label 5641: @278009
     /* 278009 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(278038), // Rule ID 5069 //
     /* 278014 */     // MIs[0] Operand 1
     /* 278014 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278027 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278036 */     GIR_RootConstrainSelectedInstOperands,
     /* 278037 */     // GIR_Coverage, 5069,
     /* 278037 */     GIR_EraseRootFromParent_Done,
     /* 278038 */   // Label 5642: @278038
     /* 278038 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(278067), // Rule ID 5076 //
     /* 278043 */     // MIs[0] Operand 1
     /* 278043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278056 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278065 */     GIR_RootConstrainSelectedInstOperands,
     /* 278066 */     // GIR_Coverage, 5076,
     /* 278066 */     GIR_EraseRootFromParent_Done,
     /* 278067 */   // Label 5643: @278067
     /* 278067 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(278096), // Rule ID 5083 //
     /* 278072 */     // MIs[0] Operand 1
     /* 278072 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278085 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278094 */     GIR_RootConstrainSelectedInstOperands,
     /* 278095 */     // GIR_Coverage, 5083,
     /* 278095 */     GIR_EraseRootFromParent_Done,
     /* 278096 */   // Label 5644: @278096
     /* 278096 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(278125), // Rule ID 5090 //
     /* 278101 */     // MIs[0] Operand 1
     /* 278101 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278114 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278123 */     GIR_RootConstrainSelectedInstOperands,
     /* 278124 */     // GIR_Coverage, 5090,
     /* 278124 */     GIR_EraseRootFromParent_Done,
     /* 278125 */   // Label 5645: @278125
     /* 278125 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(278154), // Rule ID 5097 //
     /* 278130 */     // MIs[0] Operand 1
     /* 278130 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278143 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278152 */     GIR_RootConstrainSelectedInstOperands,
     /* 278153 */     // GIR_Coverage, 5097,
     /* 278153 */     GIR_EraseRootFromParent_Done,
     /* 278154 */   // Label 5646: @278154
     /* 278154 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(278183), // Rule ID 5104 //
     /* 278159 */     // MIs[0] Operand 1
     /* 278159 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278172 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278181 */     GIR_RootConstrainSelectedInstOperands,
     /* 278182 */     // GIR_Coverage, 5104,
     /* 278182 */     GIR_EraseRootFromParent_Done,
     /* 278183 */   // Label 5647: @278183
     /* 278183 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(278212), // Rule ID 5111 //
     /* 278188 */     // MIs[0] Operand 1
     /* 278188 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 278193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278201 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278210 */     GIR_RootConstrainSelectedInstOperands,
     /* 278211 */     // GIR_Coverage, 5111,
     /* 278211 */     GIR_EraseRootFromParent_Done,
     /* 278212 */   // Label 5648: @278212
     /* 278212 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(278241), // Rule ID 5118 //
     /* 278217 */     // MIs[0] Operand 1
     /* 278217 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 278222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278230 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278239 */     GIR_RootConstrainSelectedInstOperands,
     /* 278240 */     // GIR_Coverage, 5118,
     /* 278240 */     GIR_EraseRootFromParent_Done,
     /* 278241 */   // Label 5649: @278241
     /* 278241 */   GIM_Reject,
     /* 278242 */ // Label 5619: @278242
     /* 278242 */ GIM_Reject,
     /* 278243 */ // Label 5450: @278243
     /* 278243 */ GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(279290),
     /* 278248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 278254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278258 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(278298), // Rule ID 751 //
     /* 278263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278266 */     // MIs[0] Operand 1
     /* 278266 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278275 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278281 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278289 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278296 */     GIR_RootConstrainSelectedInstOperands,
     /* 278297 */     // GIR_Coverage, 751,
     /* 278297 */     GIR_EraseRootFromParent_Done,
     /* 278298 */   // Label 5651: @278298
     /* 278298 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(278338), // Rule ID 758 //
     /* 278303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278306 */     // MIs[0] Operand 1
     /* 278306 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278315 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278321 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278329 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278336 */     GIR_RootConstrainSelectedInstOperands,
     /* 278337 */     // GIR_Coverage, 758,
     /* 278337 */     GIR_EraseRootFromParent_Done,
     /* 278338 */   // Label 5652: @278338
     /* 278338 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(278375), // Rule ID 5158 //
     /* 278343 */     // MIs[0] Operand 1
     /* 278343 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278366 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278373 */     GIR_RootConstrainSelectedInstOperands,
     /* 278374 */     // GIR_Coverage, 5158,
     /* 278374 */     GIR_EraseRootFromParent_Done,
     /* 278375 */   // Label 5653: @278375
     /* 278375 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(278412), // Rule ID 5165 //
     /* 278380 */     // MIs[0] Operand 1
     /* 278380 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278389 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278395 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278403 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278410 */     GIR_RootConstrainSelectedInstOperands,
     /* 278411 */     // GIR_Coverage, 5165,
     /* 278411 */     GIR_EraseRootFromParent_Done,
     /* 278412 */   // Label 5654: @278412
     /* 278412 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(278449), // Rule ID 5172 //
     /* 278417 */     // MIs[0] Operand 1
     /* 278417 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278426 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278432 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278440 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278447 */     GIR_RootConstrainSelectedInstOperands,
     /* 278448 */     // GIR_Coverage, 5172,
     /* 278448 */     GIR_EraseRootFromParent_Done,
     /* 278449 */   // Label 5655: @278449
     /* 278449 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(278486), // Rule ID 5179 //
     /* 278454 */     // MIs[0] Operand 1
     /* 278454 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278463 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278469 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278477 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278484 */     GIR_RootConstrainSelectedInstOperands,
     /* 278485 */     // GIR_Coverage, 5179,
     /* 278485 */     GIR_EraseRootFromParent_Done,
     /* 278486 */   // Label 5656: @278486
     /* 278486 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(278523), // Rule ID 5186 //
     /* 278491 */     // MIs[0] Operand 1
     /* 278491 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278500 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278506 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278514 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278521 */     GIR_RootConstrainSelectedInstOperands,
     /* 278522 */     // GIR_Coverage, 5186,
     /* 278522 */     GIR_EraseRootFromParent_Done,
     /* 278523 */   // Label 5657: @278523
     /* 278523 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(278563), // Rule ID 723 //
     /* 278528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278531 */     // MIs[0] Operand 1
     /* 278531 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278554 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278561 */     GIR_RootConstrainSelectedInstOperands,
     /* 278562 */     // GIR_Coverage, 723,
     /* 278562 */     GIR_EraseRootFromParent_Done,
     /* 278563 */   // Label 5658: @278563
     /* 278563 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(278603), // Rule ID 731 //
     /* 278568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278571 */     // MIs[0] Operand 1
     /* 278571 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278584 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278590 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278594 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278601 */     GIR_RootConstrainSelectedInstOperands,
     /* 278602 */     // GIR_Coverage, 731,
     /* 278602 */     GIR_EraseRootFromParent_Done,
     /* 278603 */   // Label 5659: @278603
     /* 278603 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(278643), // Rule ID 732 //
     /* 278608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278611 */     // MIs[0] Operand 1
     /* 278611 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278624 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278630 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 278632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278634 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278641 */     GIR_RootConstrainSelectedInstOperands,
     /* 278642 */     // GIR_Coverage, 732,
     /* 278642 */     GIR_EraseRootFromParent_Done,
     /* 278643 */   // Label 5660: @278643
     /* 278643 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(278683), // Rule ID 744 //
     /* 278648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278651 */     // MIs[0] Operand 1
     /* 278651 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278670 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278674 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278681 */     GIR_RootConstrainSelectedInstOperands,
     /* 278682 */     // GIR_Coverage, 744,
     /* 278682 */     GIR_EraseRootFromParent_Done,
     /* 278683 */   // Label 5661: @278683
     /* 278683 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(278720), // Rule ID 5123 //
     /* 278688 */     // MIs[0] Operand 1
     /* 278688 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278701 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278707 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278711 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278718 */     GIR_RootConstrainSelectedInstOperands,
     /* 278719 */     // GIR_Coverage, 5123,
     /* 278719 */     GIR_EraseRootFromParent_Done,
     /* 278720 */   // Label 5662: @278720
     /* 278720 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(278757), // Rule ID 5130 //
     /* 278725 */     // MIs[0] Operand 1
     /* 278725 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278738 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278744 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278748 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 278751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278755 */     GIR_RootConstrainSelectedInstOperands,
     /* 278756 */     // GIR_Coverage, 5130,
     /* 278756 */     GIR_EraseRootFromParent_Done,
     /* 278757 */   // Label 5663: @278757
     /* 278757 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(278794), // Rule ID 5137 //
     /* 278762 */     // MIs[0] Operand 1
     /* 278762 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278775 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278781 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278785 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 278788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278792 */     GIR_RootConstrainSelectedInstOperands,
     /* 278793 */     // GIR_Coverage, 5137,
     /* 278793 */     GIR_EraseRootFromParent_Done,
     /* 278794 */   // Label 5664: @278794
     /* 278794 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(278831), // Rule ID 5144 //
     /* 278799 */     // MIs[0] Operand 1
     /* 278799 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278812 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278818 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278822 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278829 */     GIR_RootConstrainSelectedInstOperands,
     /* 278830 */     // GIR_Coverage, 5144,
     /* 278830 */     GIR_EraseRootFromParent_Done,
     /* 278831 */   // Label 5665: @278831
     /* 278831 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(278868), // Rule ID 5151 //
     /* 278836 */     // MIs[0] Operand 1
     /* 278836 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278849 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278855 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278859 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278866 */     GIR_RootConstrainSelectedInstOperands,
     /* 278867 */     // GIR_Coverage, 5151,
     /* 278867 */     GIR_EraseRootFromParent_Done,
     /* 278868 */   // Label 5666: @278868
     /* 278868 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(278900), // Rule ID 1122 //
     /* 278873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278876 */     // MIs[0] Operand 1
     /* 278876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278889 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 278889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 278892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278898 */     GIR_RootConstrainSelectedInstOperands,
     /* 278899 */     // GIR_Coverage, 1122,
     /* 278899 */     GIR_EraseRootFromParent_Done,
     /* 278900 */   // Label 5667: @278900
     /* 278900 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(278932), // Rule ID 1129 //
     /* 278905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278908 */     // MIs[0] Operand 1
     /* 278908 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278921 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 278921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 278924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278930 */     GIR_RootConstrainSelectedInstOperands,
     /* 278931 */     // GIR_Coverage, 1129,
     /* 278931 */     GIR_EraseRootFromParent_Done,
     /* 278932 */   // Label 5668: @278932
     /* 278932 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(278964), // Rule ID 1136 //
     /* 278937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278940 */     // MIs[0] Operand 1
     /* 278940 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278953 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 278953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 278956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278962 */     GIR_RootConstrainSelectedInstOperands,
     /* 278963 */     // GIR_Coverage, 1136,
     /* 278963 */     GIR_EraseRootFromParent_Done,
     /* 278964 */   // Label 5669: @278964
     /* 278964 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(278996), // Rule ID 1143 //
     /* 278969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278972 */     // MIs[0] Operand 1
     /* 278972 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278985 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 278985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 278988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278994 */     GIR_RootConstrainSelectedInstOperands,
     /* 278995 */     // GIR_Coverage, 1143,
     /* 278995 */     GIR_EraseRootFromParent_Done,
     /* 278996 */   // Label 5670: @278996
     /* 278996 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(279028), // Rule ID 1150 //
     /* 279001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279004 */     // MIs[0] Operand 1
     /* 279004 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279017 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279026 */     GIR_RootConstrainSelectedInstOperands,
     /* 279027 */     // GIR_Coverage, 1150,
     /* 279027 */     GIR_EraseRootFromParent_Done,
     /* 279028 */   // Label 5671: @279028
     /* 279028 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(279057), // Rule ID 5060 //
     /* 279033 */     // MIs[0] Operand 1
     /* 279033 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279046 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 279049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279055 */     GIR_RootConstrainSelectedInstOperands,
     /* 279056 */     // GIR_Coverage, 5060,
     /* 279056 */     GIR_EraseRootFromParent_Done,
     /* 279057 */   // Label 5672: @279057
     /* 279057 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(279086), // Rule ID 5067 //
     /* 279062 */     // MIs[0] Operand 1
     /* 279062 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279075 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279084 */     GIR_RootConstrainSelectedInstOperands,
     /* 279085 */     // GIR_Coverage, 5067,
     /* 279085 */     GIR_EraseRootFromParent_Done,
     /* 279086 */   // Label 5673: @279086
     /* 279086 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(279115), // Rule ID 5074 //
     /* 279091 */     // MIs[0] Operand 1
     /* 279091 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279104 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279113 */     GIR_RootConstrainSelectedInstOperands,
     /* 279114 */     // GIR_Coverage, 5074,
     /* 279114 */     GIR_EraseRootFromParent_Done,
     /* 279115 */   // Label 5674: @279115
     /* 279115 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(279144), // Rule ID 5081 //
     /* 279120 */     // MIs[0] Operand 1
     /* 279120 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279133 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279142 */     GIR_RootConstrainSelectedInstOperands,
     /* 279143 */     // GIR_Coverage, 5081,
     /* 279143 */     GIR_EraseRootFromParent_Done,
     /* 279144 */   // Label 5675: @279144
     /* 279144 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(279173), // Rule ID 5088 //
     /* 279149 */     // MIs[0] Operand 1
     /* 279149 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279162 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279171 */     GIR_RootConstrainSelectedInstOperands,
     /* 279172 */     // GIR_Coverage, 5088,
     /* 279172 */     GIR_EraseRootFromParent_Done,
     /* 279173 */   // Label 5676: @279173
     /* 279173 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(279202), // Rule ID 5095 //
     /* 279178 */     // MIs[0] Operand 1
     /* 279178 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279191 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279200 */     GIR_RootConstrainSelectedInstOperands,
     /* 279201 */     // GIR_Coverage, 5095,
     /* 279201 */     GIR_EraseRootFromParent_Done,
     /* 279202 */   // Label 5677: @279202
     /* 279202 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(279231), // Rule ID 5102 //
     /* 279207 */     // MIs[0] Operand 1
     /* 279207 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279220 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279229 */     GIR_RootConstrainSelectedInstOperands,
     /* 279230 */     // GIR_Coverage, 5102,
     /* 279230 */     GIR_EraseRootFromParent_Done,
     /* 279231 */   // Label 5678: @279231
     /* 279231 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(279260), // Rule ID 5109 //
     /* 279236 */     // MIs[0] Operand 1
     /* 279236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 279241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279249 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279258 */     GIR_RootConstrainSelectedInstOperands,
     /* 279259 */     // GIR_Coverage, 5109,
     /* 279259 */     GIR_EraseRootFromParent_Done,
     /* 279260 */   // Label 5679: @279260
     /* 279260 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(279289), // Rule ID 5116 //
     /* 279265 */     // MIs[0] Operand 1
     /* 279265 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 279270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279278 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279287 */     GIR_RootConstrainSelectedInstOperands,
     /* 279288 */     // GIR_Coverage, 5116,
     /* 279288 */     GIR_EraseRootFromParent_Done,
     /* 279289 */   // Label 5680: @279289
     /* 279289 */   GIM_Reject,
     /* 279290 */ // Label 5650: @279290
     /* 279290 */ GIM_Reject,
     /* 279291 */ // Label 5451: @279291
     /* 279291 */ GIM_Reject,
     /* 279292 */ // Label 50: @279292
     /* 279292 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5693*/ GIMT_Encode4(280336),
     /* 279303 */ /*GILLT_nxv1s1*//*Label 5681*/ GIMT_Encode4(279351),
     /* 279307 */ /*GILLT_nxv2s1*//*Label 5682*/ GIMT_Encode4(279380),
     /* 279311 */ /*GILLT_nxv2s16*//*Label 5683*/ GIMT_Encode4(279409),
     /* 279315 */ /*GILLT_nxv2s32*//*Label 5684*/ GIMT_Encode4(279494),
     /* 279319 */ /*GILLT_nxv2s64*//*Label 5685*/ GIMT_Encode4(279579),
     /* 279323 */ /*GILLT_nxv4s1*//*Label 5686*/ GIMT_Encode4(279745),
     /* 279327 */ /*GILLT_nxv4s16*//*Label 5687*/ GIMT_Encode4(279774),
     /* 279331 */ /*GILLT_nxv4s32*//*Label 5688*/ GIMT_Encode4(279859),
     /* 279335 */ /*GILLT_nxv8s1*//*Label 5689*/ GIMT_Encode4(280025),
     /* 279339 */ /*GILLT_nxv8s16*//*Label 5690*/ GIMT_Encode4(280054),
     /* 279343 */ /*GILLT_nxv16s1*//*Label 5691*/ GIMT_Encode4(280220),
     /* 279347 */ /*GILLT_nxv16s8*//*Label 5692*/ GIMT_Encode4(280249),
     /* 279351 */ // Label 5681: @279351
     /* 279351 */ GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(279379), // Rule ID 8392 //
     /* 279356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 279362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 279365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 279368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279372 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 279372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279377 */   GIR_RootConstrainSelectedInstOperands,
     /* 279378 */   // GIR_Coverage, 8392,
     /* 279378 */   GIR_Done,
     /* 279379 */ // Label 5694: @279379
     /* 279379 */ GIM_Reject,
     /* 279380 */ // Label 5682: @279380
     /* 279380 */ GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(279408), // Rule ID 8391 //
     /* 279385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 279394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 279397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279401 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 279401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279406 */   GIR_RootConstrainSelectedInstOperands,
     /* 279407 */   // GIR_Coverage, 8391,
     /* 279407 */   GIR_Done,
     /* 279408 */ // Label 5695: @279408
     /* 279408 */ GIM_Reject,
     /* 279409 */ // Label 5683: @279409
     /* 279409 */ GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(279493),
     /* 279414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 279420 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 279423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279427 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(279477), // Rule ID 3161 //
     /* 279432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279455 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279459 */     // MIs[2] Operand 1
     /* 279459 */     // No operand predicates
     /* 279459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279461 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 279461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 279464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279466 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279468 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279470 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 279475 */     GIR_RootConstrainSelectedInstOperands,
     /* 279476 */     // GIR_Coverage, 3161,
     /* 279476 */     GIR_EraseRootFromParent_Done,
     /* 279477 */   // Label 5697: @279477
     /* 279477 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(279492), // Rule ID 2741 //
     /* 279482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279485 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 279485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279490 */     GIR_RootConstrainSelectedInstOperands,
     /* 279491 */     // GIR_Coverage, 2741,
     /* 279491 */     GIR_Done,
     /* 279492 */   // Label 5698: @279492
     /* 279492 */   GIM_Reject,
     /* 279493 */ // Label 5696: @279493
     /* 279493 */ GIM_Reject,
     /* 279494 */ // Label 5684: @279494
     /* 279494 */ GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(279578),
     /* 279499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 279505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 279508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279512 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(279562), // Rule ID 3163 //
     /* 279517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 279532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279540 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279544 */     // MIs[2] Operand 1
     /* 279544 */     // No operand predicates
     /* 279544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279546 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 279546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 279549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279551 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279553 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279555 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 279560 */     GIR_RootConstrainSelectedInstOperands,
     /* 279561 */     // GIR_Coverage, 3163,
     /* 279561 */     GIR_EraseRootFromParent_Done,
     /* 279562 */   // Label 5700: @279562
     /* 279562 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(279577), // Rule ID 2742 //
     /* 279567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279570 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 279570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279575 */     GIR_RootConstrainSelectedInstOperands,
     /* 279576 */     // GIR_Coverage, 2742,
     /* 279576 */     GIR_Done,
     /* 279577 */   // Label 5701: @279577
     /* 279577 */   GIM_Reject,
     /* 279578 */ // Label 5699: @279578
     /* 279578 */ GIM_Reject,
     /* 279579 */ // Label 5685: @279579
     /* 279579 */ GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(279744),
     /* 279584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279590 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(279647), // Rule ID 3164 //
     /* 279595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 279617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279625 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 279629 */     // MIs[2] Operand 1
     /* 279629 */     // No operand predicates
     /* 279629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279631 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 279631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 279634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279636 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279638 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279640 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 279645 */     GIR_RootConstrainSelectedInstOperands,
     /* 279646 */     // GIR_Coverage, 3164,
     /* 279646 */     GIR_EraseRootFromParent_Done,
     /* 279647 */   // Label 5703: @279647
     /* 279647 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(279699), // Rule ID 7442 //
     /* 279652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 279671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 279675 */     // MIs[0] Op2
     /* 279675 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 279680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279682 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 279682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 279685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 279687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 279689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 279693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 279697 */     GIR_RootConstrainSelectedInstOperands,
     /* 279698 */     // GIR_Coverage, 7442,
     /* 279698 */     GIR_EraseRootFromParent_Done,
     /* 279699 */   // Label 5704: @279699
     /* 279699 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(279721), // Rule ID 2737 //
     /* 279704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279714 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 279714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279719 */     GIR_RootConstrainSelectedInstOperands,
     /* 279720 */     // GIR_Coverage, 2737,
     /* 279720 */     GIR_Done,
     /* 279721 */   // Label 5705: @279721
     /* 279721 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(279743), // Rule ID 2743 //
     /* 279726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 279732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279736 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 279736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 279741 */     GIR_RootConstrainSelectedInstOperands,
     /* 279742 */     // GIR_Coverage, 2743,
     /* 279742 */     GIR_Done,
     /* 279743 */   // Label 5706: @279743
     /* 279743 */   GIM_Reject,
     /* 279744 */ // Label 5702: @279744
     /* 279744 */ GIM_Reject,
     /* 279745 */ // Label 5686: @279745
     /* 279745 */ GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(279773), // Rule ID 8390 //
     /* 279750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 279756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 279759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 279762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279766 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 279766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279771 */   GIR_RootConstrainSelectedInstOperands,
     /* 279772 */   // GIR_Coverage, 8390,
     /* 279772 */   GIR_Done,
     /* 279773 */ // Label 5707: @279773
     /* 279773 */ GIM_Reject,
     /* 279774 */ // Label 5687: @279774
     /* 279774 */ GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(279858),
     /* 279779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 279782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 279785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 279788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279792 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(279842), // Rule ID 3160 //
     /* 279797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279820 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279824 */     // MIs[2] Operand 1
     /* 279824 */     // No operand predicates
     /* 279824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279826 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 279826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 279829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279831 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279833 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279835 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 279840 */     GIR_RootConstrainSelectedInstOperands,
     /* 279841 */     // GIR_Coverage, 3160,
     /* 279841 */     GIR_EraseRootFromParent_Done,
     /* 279842 */   // Label 5709: @279842
     /* 279842 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(279857), // Rule ID 2739 //
     /* 279847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279850 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 279850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 279855 */     GIR_RootConstrainSelectedInstOperands,
     /* 279856 */     // GIR_Coverage, 2739,
     /* 279856 */     GIR_Done,
     /* 279857 */   // Label 5710: @279857
     /* 279857 */   GIM_Reject,
     /* 279858 */ // Label 5708: @279858
     /* 279858 */ GIM_Reject,
     /* 279859 */ // Label 5688: @279859
     /* 279859 */ GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(280024),
     /* 279864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 279867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279870 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(279927), // Rule ID 3162 //
     /* 279875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 279881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 279897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279905 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279909 */     // MIs[2] Operand 1
     /* 279909 */     // No operand predicates
     /* 279909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279911 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 279911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 279914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 279916 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 279918 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 279920 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 279925 */     GIR_RootConstrainSelectedInstOperands,
     /* 279926 */     // GIR_Coverage, 3162,
     /* 279926 */     GIR_EraseRootFromParent_Done,
     /* 279927 */   // Label 5712: @279927
     /* 279927 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(279979), // Rule ID 7440 //
     /* 279932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 279947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 279951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279955 */     // MIs[0] Op2
     /* 279955 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 279960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279962 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 279962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 279965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 279967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 279969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 279973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 279977 */     GIR_RootConstrainSelectedInstOperands,
     /* 279978 */     // GIR_Coverage, 7440,
     /* 279978 */     GIR_EraseRootFromParent_Done,
     /* 279979 */   // Label 5713: @279979
     /* 279979 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(280001), // Rule ID 2736 //
     /* 279984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 279990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279994 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 279994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 279999 */     GIR_RootConstrainSelectedInstOperands,
     /* 280000 */     // GIR_Coverage, 2736,
     /* 280000 */     GIR_Done,
     /* 280001 */   // Label 5714: @280001
     /* 280001 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(280023), // Rule ID 2740 //
     /* 280006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280016 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 280016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280021 */     GIR_RootConstrainSelectedInstOperands,
     /* 280022 */     // GIR_Coverage, 2740,
     /* 280022 */     GIR_Done,
     /* 280023 */   // Label 5715: @280023
     /* 280023 */   GIM_Reject,
     /* 280024 */ // Label 5711: @280024
     /* 280024 */ GIM_Reject,
     /* 280025 */ // Label 5689: @280025
     /* 280025 */ GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(280053), // Rule ID 8389 //
     /* 280030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 280039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 280042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280046 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 280046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280051 */   GIR_RootConstrainSelectedInstOperands,
     /* 280052 */   // GIR_Coverage, 8389,
     /* 280052 */   GIR_Done,
     /* 280053 */ // Label 5716: @280053
     /* 280053 */ GIM_Reject,
     /* 280054 */ // Label 5690: @280054
     /* 280054 */ GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(280219),
     /* 280059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280065 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(280122), // Rule ID 3159 //
     /* 280070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280100 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 280104 */     // MIs[2] Operand 1
     /* 280104 */     // No operand predicates
     /* 280104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280106 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 280106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280111 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280113 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280115 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280120 */     GIR_RootConstrainSelectedInstOperands,
     /* 280121 */     // GIR_Coverage, 3159,
     /* 280121 */     GIR_EraseRootFromParent_Done,
     /* 280122 */   // Label 5718: @280122
     /* 280122 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(280174), // Rule ID 7438 //
     /* 280127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280150 */     // MIs[0] Op2
     /* 280150 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280157 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 280160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280172 */     GIR_RootConstrainSelectedInstOperands,
     /* 280173 */     // GIR_Coverage, 7438,
     /* 280173 */     GIR_EraseRootFromParent_Done,
     /* 280174 */   // Label 5719: @280174
     /* 280174 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(280196), // Rule ID 2735 //
     /* 280179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280189 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280194 */     GIR_RootConstrainSelectedInstOperands,
     /* 280195 */     // GIR_Coverage, 2735,
     /* 280195 */     GIR_Done,
     /* 280196 */   // Label 5720: @280196
     /* 280196 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(280218), // Rule ID 2738 //
     /* 280201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280211 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 280211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280216 */     GIR_RootConstrainSelectedInstOperands,
     /* 280217 */     // GIR_Coverage, 2738,
     /* 280217 */     GIR_Done,
     /* 280218 */   // Label 5721: @280218
     /* 280218 */   GIM_Reject,
     /* 280219 */ // Label 5717: @280219
     /* 280219 */ GIM_Reject,
     /* 280220 */ // Label 5691: @280220
     /* 280220 */ GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(280248), // Rule ID 8388 //
     /* 280225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 280234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 280237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280241 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 280241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280246 */   GIR_RootConstrainSelectedInstOperands,
     /* 280247 */   // GIR_Coverage, 8388,
     /* 280247 */   GIR_Done,
     /* 280248 */ // Label 5722: @280248
     /* 280248 */ GIM_Reject,
     /* 280249 */ // Label 5692: @280249
     /* 280249 */ GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(280335),
     /* 280254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280260 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(280312), // Rule ID 7436 //
     /* 280265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 280284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280288 */     // MIs[0] Op2
     /* 280288 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280295 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 280298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280310 */     GIR_RootConstrainSelectedInstOperands,
     /* 280311 */     // GIR_Coverage, 7436,
     /* 280311 */     GIR_EraseRootFromParent_Done,
     /* 280312 */   // Label 5724: @280312
     /* 280312 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(280334), // Rule ID 2734 //
     /* 280317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 280323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280327 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 280332 */     GIR_RootConstrainSelectedInstOperands,
     /* 280333 */     // GIR_Coverage, 2734,
     /* 280333 */     GIR_Done,
     /* 280334 */   // Label 5725: @280334
     /* 280334 */   GIM_Reject,
     /* 280335 */ // Label 5723: @280335
     /* 280335 */ GIM_Reject,
     /* 280336 */ // Label 5693: @280336
     /* 280336 */ GIM_Reject,
     /* 280337 */ // Label 51: @280337
     /* 280337 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5730*/ GIMT_Encode4(280820),
     /* 280348 */ /*GILLT_s64*//*Label 5726*/ GIMT_Encode4(280384), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280368 */ /*GILLT_v4s32*//*Label 5727*/ GIMT_Encode4(280415), GIMT_Encode4(0),
     /* 280376 */ /*GILLT_v8s16*//*Label 5728*/ GIMT_Encode4(280550),
     /* 280380 */ /*GILLT_v16s8*//*Label 5729*/ GIMT_Encode4(280685),
     /* 280384 */ // Label 5726: @280384
     /* 280384 */ GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(280414), // Rule ID 128 //
     /* 280389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 280395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280407 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 280407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 280412 */   GIR_RootConstrainSelectedInstOperands,
     /* 280413 */   // GIR_Coverage, 128,
     /* 280413 */   GIR_Done,
     /* 280414 */ // Label 5731: @280414
     /* 280414 */ GIM_Reject,
     /* 280415 */ // Label 5727: @280415
     /* 280415 */ GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(280549), // Rule ID 6494 //
     /* 280420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280438 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 280438 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280441 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 280445 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280450 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280454 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280460 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280463 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280467 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280472 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280478 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280483 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280488 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280491 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280495 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280500 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280506 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280511 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 280523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280528 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280531 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 280539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280547 */   GIR_RootConstrainSelectedInstOperands,
     /* 280548 */   // GIR_Coverage, 6494,
     /* 280548 */   GIR_EraseRootFromParent_Done,
     /* 280549 */ // Label 5732: @280549
     /* 280549 */ GIM_Reject,
     /* 280550 */ // Label 5728: @280550
     /* 280550 */ GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(280684), // Rule ID 6493 //
     /* 280555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280573 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 280573 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280576 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 280580 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280585 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280589 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280595 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280598 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280602 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280607 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280613 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280618 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280623 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280626 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280630 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280635 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280641 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280646 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 280658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280663 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280666 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 280674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280679 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280682 */   GIR_RootConstrainSelectedInstOperands,
     /* 280683 */   // GIR_Coverage, 6493,
     /* 280683 */   GIR_EraseRootFromParent_Done,
     /* 280684 */ // Label 5733: @280684
     /* 280684 */ GIM_Reject,
     /* 280685 */ // Label 5729: @280685
     /* 280685 */ GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(280819), // Rule ID 6492 //
     /* 280690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 280693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280708 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 280708 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280711 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 280715 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280720 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280724 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280730 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280733 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280737 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280742 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280748 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280753 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280758 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280761 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280765 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280770 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280776 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280781 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 280793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280798 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280801 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 280809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 280817 */   GIR_RootConstrainSelectedInstOperands,
     /* 280818 */   // GIR_Coverage, 6492,
     /* 280818 */   GIR_EraseRootFromParent_Done,
     /* 280819 */ // Label 5734: @280819
     /* 280819 */ GIM_Reject,
     /* 280820 */ // Label 5730: @280820
     /* 280820 */ GIM_Reject,
     /* 280821 */ // Label 52: @280821
     /* 280821 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5739*/ GIMT_Encode4(281304),
     /* 280832 */ /*GILLT_s64*//*Label 5735*/ GIMT_Encode4(280868), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280852 */ /*GILLT_v4s32*//*Label 5736*/ GIMT_Encode4(280899), GIMT_Encode4(0),
     /* 280860 */ /*GILLT_v8s16*//*Label 5737*/ GIMT_Encode4(281034),
     /* 280864 */ /*GILLT_v16s8*//*Label 5738*/ GIMT_Encode4(281169),
     /* 280868 */ // Label 5735: @280868
     /* 280868 */ GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(280898), // Rule ID 127 //
     /* 280873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 280879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280891 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 280891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 280896 */   GIR_RootConstrainSelectedInstOperands,
     /* 280897 */   // GIR_Coverage, 127,
     /* 280897 */   GIR_Done,
     /* 280898 */ // Label 5740: @280898
     /* 280898 */ GIM_Reject,
     /* 280899 */ // Label 5736: @280899
     /* 280899 */ GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(281033), // Rule ID 6491 //
     /* 280904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280922 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 280922 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280925 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 280929 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280934 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280938 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280944 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280947 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280951 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280956 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 280962 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280967 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280972 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280975 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280979 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280984 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 280990 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280995 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 281007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 281023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281031 */   GIR_RootConstrainSelectedInstOperands,
     /* 281032 */   // GIR_Coverage, 6491,
     /* 281032 */   GIR_EraseRootFromParent_Done,
     /* 281033 */ // Label 5741: @281033
     /* 281033 */ GIM_Reject,
     /* 281034 */ // Label 5737: @281034
     /* 281034 */ GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(281168), // Rule ID 6490 //
     /* 281039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281057 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 281057 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281060 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 281064 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281069 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281073 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281079 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281082 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281086 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281091 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281097 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281102 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281107 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281110 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281114 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281119 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281125 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281130 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 281142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281147 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281150 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 281158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281166 */   GIR_RootConstrainSelectedInstOperands,
     /* 281167 */   // GIR_Coverage, 6490,
     /* 281167 */   GIR_EraseRootFromParent_Done,
     /* 281168 */ // Label 5742: @281168
     /* 281168 */ GIM_Reject,
     /* 281169 */ // Label 5738: @281169
     /* 281169 */ GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(281303), // Rule ID 6489 //
     /* 281174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281192 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 281192 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281195 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 281199 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281204 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281208 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281214 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281217 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281221 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281226 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281232 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281237 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281242 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281245 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281249 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281254 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281260 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281265 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 281277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281282 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281285 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 281293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281301 */   GIR_RootConstrainSelectedInstOperands,
     /* 281302 */   // GIR_Coverage, 6489,
     /* 281302 */   GIR_EraseRootFromParent_Done,
     /* 281303 */ // Label 5743: @281303
     /* 281303 */ GIM_Reject,
     /* 281304 */ // Label 5739: @281304
     /* 281304 */ GIM_Reject,
     /* 281305 */ // Label 53: @281305
     /* 281305 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5755*/ GIMT_Encode4(281734),
     /* 281316 */ /*GILLT_v2s32*//*Label 5744*/ GIMT_Encode4(281392),
     /* 281320 */ /*GILLT_v2s64*//*Label 5745*/ GIMT_Encode4(281426),
     /* 281324 */ /*GILLT_v4s16*//*Label 5746*/ GIMT_Encode4(281460),
     /* 281328 */ /*GILLT_v4s32*//*Label 5747*/ GIMT_Encode4(281494),
     /* 281332 */ /*GILLT_v8s8*//*Label 5748*/ GIMT_Encode4(281528),
     /* 281336 */ /*GILLT_v8s16*//*Label 5749*/ GIMT_Encode4(281562),
     /* 281340 */ /*GILLT_v16s8*//*Label 5750*/ GIMT_Encode4(281596), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281360 */ /*GILLT_nxv2s64*//*Label 5751*/ GIMT_Encode4(281630), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281372 */ /*GILLT_nxv4s32*//*Label 5752*/ GIMT_Encode4(281656), GIMT_Encode4(0),
     /* 281380 */ /*GILLT_nxv8s16*//*Label 5753*/ GIMT_Encode4(281682), GIMT_Encode4(0),
     /* 281388 */ /*GILLT_nxv16s8*//*Label 5754*/ GIMT_Encode4(281708),
     /* 281392 */ // Label 5744: @281392
     /* 281392 */ GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(281425), // Rule ID 5008 //
     /* 281397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 281406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281418 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 281418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 281423 */   GIR_RootConstrainSelectedInstOperands,
     /* 281424 */   // GIR_Coverage, 5008,
     /* 281424 */   GIR_Done,
     /* 281425 */ // Label 5756: @281425
     /* 281425 */ GIM_Reject,
     /* 281426 */ // Label 5745: @281426
     /* 281426 */ GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(281459), // Rule ID 5012 //
     /* 281431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 281437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 281440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281452 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 281452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 281457 */   GIR_RootConstrainSelectedInstOperands,
     /* 281458 */   // GIR_Coverage, 5012,
     /* 281458 */   GIR_Done,
     /* 281459 */ // Label 5757: @281459
     /* 281459 */ GIM_Reject,
     /* 281460 */ // Label 5746: @281460
     /* 281460 */ GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(281493), // Rule ID 5007 //
     /* 281465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281486 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 281486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 281491 */   GIR_RootConstrainSelectedInstOperands,
     /* 281492 */   // GIR_Coverage, 5007,
     /* 281492 */   GIR_Done,
     /* 281493 */ // Label 5758: @281493
     /* 281493 */ GIM_Reject,
     /* 281494 */ // Label 5747: @281494
     /* 281494 */ GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(281527), // Rule ID 5011 //
     /* 281499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281520 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 281520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 281525 */   GIR_RootConstrainSelectedInstOperands,
     /* 281526 */   // GIR_Coverage, 5011,
     /* 281526 */   GIR_Done,
     /* 281527 */ // Label 5759: @281527
     /* 281527 */ GIM_Reject,
     /* 281528 */ // Label 5748: @281528
     /* 281528 */ GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(281561), // Rule ID 5006 //
     /* 281533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281554 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 281554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 281559 */   GIR_RootConstrainSelectedInstOperands,
     /* 281560 */   // GIR_Coverage, 5006,
     /* 281560 */   GIR_Done,
     /* 281561 */ // Label 5760: @281561
     /* 281561 */ GIM_Reject,
     /* 281562 */ // Label 5749: @281562
     /* 281562 */ GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(281595), // Rule ID 5010 //
     /* 281567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281588 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 281588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 281593 */   GIR_RootConstrainSelectedInstOperands,
     /* 281594 */   // GIR_Coverage, 5010,
     /* 281594 */   GIR_Done,
     /* 281595 */ // Label 5761: @281595
     /* 281595 */ GIM_Reject,
     /* 281596 */ // Label 5750: @281596
     /* 281596 */ GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(281629), // Rule ID 5009 //
     /* 281601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281622 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 281622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 281627 */   GIR_RootConstrainSelectedInstOperands,
     /* 281628 */   // GIR_Coverage, 5009,
     /* 281628 */   GIR_Done,
     /* 281629 */ // Label 5762: @281629
     /* 281629 */ GIM_Reject,
     /* 281630 */ // Label 5751: @281630
     /* 281630 */ GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(281655), // Rule ID 7394 //
     /* 281635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 281641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 281644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281648 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 281648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 281653 */   GIR_RootConstrainSelectedInstOperands,
     /* 281654 */   // GIR_Coverage, 7394,
     /* 281654 */   GIR_Done,
     /* 281655 */ // Label 5763: @281655
     /* 281655 */ GIM_Reject,
     /* 281656 */ // Label 5752: @281656
     /* 281656 */ GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(281681), // Rule ID 7393 //
     /* 281661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 281667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 281670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281674 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 281674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 281679 */   GIR_RootConstrainSelectedInstOperands,
     /* 281680 */   // GIR_Coverage, 7393,
     /* 281680 */   GIR_Done,
     /* 281681 */ // Label 5764: @281681
     /* 281681 */ GIM_Reject,
     /* 281682 */ // Label 5753: @281682
     /* 281682 */ GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(281707), // Rule ID 7392 //
     /* 281687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 281696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281700 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 281700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 281705 */   GIR_RootConstrainSelectedInstOperands,
     /* 281706 */   // GIR_Coverage, 7392,
     /* 281706 */   GIR_Done,
     /* 281707 */ // Label 5765: @281707
     /* 281707 */ GIM_Reject,
     /* 281708 */ // Label 5754: @281708
     /* 281708 */ GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(281733), // Rule ID 7391 //
     /* 281713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 281716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 281722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281726 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 281726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 281731 */   GIR_RootConstrainSelectedInstOperands,
     /* 281732 */   // GIR_Coverage, 7391,
     /* 281732 */   GIR_Done,
     /* 281733 */ // Label 5766: @281733
     /* 281733 */ GIM_Reject,
     /* 281734 */ // Label 5755: @281734
     /* 281734 */ GIM_Reject,
     /* 281735 */ // Label 54: @281735
     /* 281735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5778*/ GIMT_Encode4(282164),
     /* 281746 */ /*GILLT_v2s32*//*Label 5767*/ GIMT_Encode4(281822),
     /* 281750 */ /*GILLT_v2s64*//*Label 5768*/ GIMT_Encode4(281856),
     /* 281754 */ /*GILLT_v4s16*//*Label 5769*/ GIMT_Encode4(281890),
     /* 281758 */ /*GILLT_v4s32*//*Label 5770*/ GIMT_Encode4(281924),
     /* 281762 */ /*GILLT_v8s8*//*Label 5771*/ GIMT_Encode4(281958),
     /* 281766 */ /*GILLT_v8s16*//*Label 5772*/ GIMT_Encode4(281992),
     /* 281770 */ /*GILLT_v16s8*//*Label 5773*/ GIMT_Encode4(282026), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281790 */ /*GILLT_nxv2s64*//*Label 5774*/ GIMT_Encode4(282060), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281802 */ /*GILLT_nxv4s32*//*Label 5775*/ GIMT_Encode4(282086), GIMT_Encode4(0),
     /* 281810 */ /*GILLT_nxv8s16*//*Label 5776*/ GIMT_Encode4(282112), GIMT_Encode4(0),
     /* 281818 */ /*GILLT_nxv16s8*//*Label 5777*/ GIMT_Encode4(282138),
     /* 281822 */ // Label 5767: @281822
     /* 281822 */ GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(281855), // Rule ID 2477 //
     /* 281827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 281836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281848 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 281848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 281853 */   GIR_RootConstrainSelectedInstOperands,
     /* 281854 */   // GIR_Coverage, 2477,
     /* 281854 */   GIR_Done,
     /* 281855 */ // Label 5779: @281855
     /* 281855 */ GIM_Reject,
     /* 281856 */ // Label 5768: @281856
     /* 281856 */ GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(281889), // Rule ID 2481 //
     /* 281861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 281867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 281870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281882 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 281882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 281887 */   GIR_RootConstrainSelectedInstOperands,
     /* 281888 */   // GIR_Coverage, 2481,
     /* 281888 */   GIR_Done,
     /* 281889 */ // Label 5780: @281889
     /* 281889 */ GIM_Reject,
     /* 281890 */ // Label 5769: @281890
     /* 281890 */ GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(281923), // Rule ID 2476 //
     /* 281895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281916 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 281916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 281921 */   GIR_RootConstrainSelectedInstOperands,
     /* 281922 */   // GIR_Coverage, 2476,
     /* 281922 */   GIR_Done,
     /* 281923 */ // Label 5781: @281923
     /* 281923 */ GIM_Reject,
     /* 281924 */ // Label 5770: @281924
     /* 281924 */ GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(281957), // Rule ID 2480 //
     /* 281929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281950 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 281950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 281955 */   GIR_RootConstrainSelectedInstOperands,
     /* 281956 */   // GIR_Coverage, 2480,
     /* 281956 */   GIR_Done,
     /* 281957 */ // Label 5782: @281957
     /* 281957 */ GIM_Reject,
     /* 281958 */ // Label 5771: @281958
     /* 281958 */ GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(281991), // Rule ID 2475 //
     /* 281963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281984 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 281984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 281989 */   GIR_RootConstrainSelectedInstOperands,
     /* 281990 */   // GIR_Coverage, 2475,
     /* 281990 */   GIR_Done,
     /* 281991 */ // Label 5783: @281991
     /* 281991 */ GIM_Reject,
     /* 281992 */ // Label 5772: @281992
     /* 281992 */ GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(282025), // Rule ID 2479 //
     /* 281997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282018 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 282023 */   GIR_RootConstrainSelectedInstOperands,
     /* 282024 */   // GIR_Coverage, 2479,
     /* 282024 */   GIR_Done,
     /* 282025 */ // Label 5784: @282025
     /* 282025 */ GIM_Reject,
     /* 282026 */ // Label 5773: @282026
     /* 282026 */ GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(282059), // Rule ID 2478 //
     /* 282031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282052 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282052 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 282057 */   GIR_RootConstrainSelectedInstOperands,
     /* 282058 */   // GIR_Coverage, 2478,
     /* 282058 */   GIR_Done,
     /* 282059 */ // Label 5785: @282059
     /* 282059 */ GIM_Reject,
     /* 282060 */ // Label 5774: @282060
     /* 282060 */ GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(282085), // Rule ID 7390 //
     /* 282065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282078 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 282083 */   GIR_RootConstrainSelectedInstOperands,
     /* 282084 */   // GIR_Coverage, 7390,
     /* 282084 */   GIR_Done,
     /* 282085 */ // Label 5786: @282085
     /* 282085 */ GIM_Reject,
     /* 282086 */ // Label 5775: @282086
     /* 282086 */ GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(282111), // Rule ID 7389 //
     /* 282091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282104 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 282109 */   GIR_RootConstrainSelectedInstOperands,
     /* 282110 */   // GIR_Coverage, 7389,
     /* 282110 */   GIR_Done,
     /* 282111 */ // Label 5787: @282111
     /* 282111 */ GIM_Reject,
     /* 282112 */ // Label 5776: @282112
     /* 282112 */ GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(282137), // Rule ID 7388 //
     /* 282117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282130 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 282135 */   GIR_RootConstrainSelectedInstOperands,
     /* 282136 */   // GIR_Coverage, 7388,
     /* 282136 */   GIR_Done,
     /* 282137 */ // Label 5788: @282137
     /* 282137 */ GIM_Reject,
     /* 282138 */ // Label 5777: @282138
     /* 282138 */ GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(282163), // Rule ID 7387 //
     /* 282143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282156 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 282161 */   GIR_RootConstrainSelectedInstOperands,
     /* 282162 */   // GIR_Coverage, 7387,
     /* 282162 */   GIR_Done,
     /* 282163 */ // Label 5789: @282163
     /* 282163 */ GIM_Reject,
     /* 282164 */ // Label 5778: @282164
     /* 282164 */ GIM_Reject,
     /* 282165 */ // Label 55: @282165
     /* 282165 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5801*/ GIMT_Encode4(282594),
     /* 282176 */ /*GILLT_v2s32*//*Label 5790*/ GIMT_Encode4(282252),
     /* 282180 */ /*GILLT_v2s64*//*Label 5791*/ GIMT_Encode4(282286),
     /* 282184 */ /*GILLT_v4s16*//*Label 5792*/ GIMT_Encode4(282320),
     /* 282188 */ /*GILLT_v4s32*//*Label 5793*/ GIMT_Encode4(282354),
     /* 282192 */ /*GILLT_v8s8*//*Label 5794*/ GIMT_Encode4(282388),
     /* 282196 */ /*GILLT_v8s16*//*Label 5795*/ GIMT_Encode4(282422),
     /* 282200 */ /*GILLT_v16s8*//*Label 5796*/ GIMT_Encode4(282456), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282220 */ /*GILLT_nxv2s64*//*Label 5797*/ GIMT_Encode4(282490), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282232 */ /*GILLT_nxv4s32*//*Label 5798*/ GIMT_Encode4(282516), GIMT_Encode4(0),
     /* 282240 */ /*GILLT_nxv8s16*//*Label 5799*/ GIMT_Encode4(282542), GIMT_Encode4(0),
     /* 282248 */ /*GILLT_nxv16s8*//*Label 5800*/ GIMT_Encode4(282568),
     /* 282252 */ // Label 5790: @282252
     /* 282252 */ GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(282285), // Rule ID 5022 //
     /* 282257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282278 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 282283 */   GIR_RootConstrainSelectedInstOperands,
     /* 282284 */   // GIR_Coverage, 5022,
     /* 282284 */   GIR_Done,
     /* 282285 */ // Label 5802: @282285
     /* 282285 */ GIM_Reject,
     /* 282286 */ // Label 5791: @282286
     /* 282286 */ GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(282319), // Rule ID 5026 //
     /* 282291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282312 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 282317 */   GIR_RootConstrainSelectedInstOperands,
     /* 282318 */   // GIR_Coverage, 5026,
     /* 282318 */   GIR_Done,
     /* 282319 */ // Label 5803: @282319
     /* 282319 */ GIM_Reject,
     /* 282320 */ // Label 5792: @282320
     /* 282320 */ GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(282353), // Rule ID 5021 //
     /* 282325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282346 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 282351 */   GIR_RootConstrainSelectedInstOperands,
     /* 282352 */   // GIR_Coverage, 5021,
     /* 282352 */   GIR_Done,
     /* 282353 */ // Label 5804: @282353
     /* 282353 */ GIM_Reject,
     /* 282354 */ // Label 5793: @282354
     /* 282354 */ GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(282387), // Rule ID 5025 //
     /* 282359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282380 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 282385 */   GIR_RootConstrainSelectedInstOperands,
     /* 282386 */   // GIR_Coverage, 5025,
     /* 282386 */   GIR_Done,
     /* 282387 */ // Label 5805: @282387
     /* 282387 */ GIM_Reject,
     /* 282388 */ // Label 5794: @282388
     /* 282388 */ GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(282421), // Rule ID 5020 //
     /* 282393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282414 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 282419 */   GIR_RootConstrainSelectedInstOperands,
     /* 282420 */   // GIR_Coverage, 5020,
     /* 282420 */   GIR_Done,
     /* 282421 */ // Label 5806: @282421
     /* 282421 */ GIM_Reject,
     /* 282422 */ // Label 5795: @282422
     /* 282422 */ GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(282455), // Rule ID 5024 //
     /* 282427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282448 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 282453 */   GIR_RootConstrainSelectedInstOperands,
     /* 282454 */   // GIR_Coverage, 5024,
     /* 282454 */   GIR_Done,
     /* 282455 */ // Label 5807: @282455
     /* 282455 */ GIM_Reject,
     /* 282456 */ // Label 5796: @282456
     /* 282456 */ GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(282489), // Rule ID 5023 //
     /* 282461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282482 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 282487 */   GIR_RootConstrainSelectedInstOperands,
     /* 282488 */   // GIR_Coverage, 5023,
     /* 282488 */   GIR_Done,
     /* 282489 */ // Label 5808: @282489
     /* 282489 */ GIM_Reject,
     /* 282490 */ // Label 5797: @282490
     /* 282490 */ GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(282515), // Rule ID 7402 //
     /* 282495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282508 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 282513 */   GIR_RootConstrainSelectedInstOperands,
     /* 282514 */   // GIR_Coverage, 7402,
     /* 282514 */   GIR_Done,
     /* 282515 */ // Label 5809: @282515
     /* 282515 */ GIM_Reject,
     /* 282516 */ // Label 5798: @282516
     /* 282516 */ GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(282541), // Rule ID 7401 //
     /* 282521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282534 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 282539 */   GIR_RootConstrainSelectedInstOperands,
     /* 282540 */   // GIR_Coverage, 7401,
     /* 282540 */   GIR_Done,
     /* 282541 */ // Label 5810: @282541
     /* 282541 */ GIM_Reject,
     /* 282542 */ // Label 5799: @282542
     /* 282542 */ GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(282567), // Rule ID 7400 //
     /* 282547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282560 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 282565 */   GIR_RootConstrainSelectedInstOperands,
     /* 282566 */   // GIR_Coverage, 7400,
     /* 282566 */   GIR_Done,
     /* 282567 */ // Label 5811: @282567
     /* 282567 */ GIM_Reject,
     /* 282568 */ // Label 5800: @282568
     /* 282568 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(282593), // Rule ID 7399 //
     /* 282573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282586 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 282591 */   GIR_RootConstrainSelectedInstOperands,
     /* 282592 */   // GIR_Coverage, 7399,
     /* 282592 */   GIR_Done,
     /* 282593 */ // Label 5812: @282593
     /* 282593 */ GIM_Reject,
     /* 282594 */ // Label 5801: @282594
     /* 282594 */ GIM_Reject,
     /* 282595 */ // Label 56: @282595
     /* 282595 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5824*/ GIMT_Encode4(283024),
     /* 282606 */ /*GILLT_v2s32*//*Label 5813*/ GIMT_Encode4(282682),
     /* 282610 */ /*GILLT_v2s64*//*Label 5814*/ GIMT_Encode4(282716),
     /* 282614 */ /*GILLT_v4s16*//*Label 5815*/ GIMT_Encode4(282750),
     /* 282618 */ /*GILLT_v4s32*//*Label 5816*/ GIMT_Encode4(282784),
     /* 282622 */ /*GILLT_v8s8*//*Label 5817*/ GIMT_Encode4(282818),
     /* 282626 */ /*GILLT_v8s16*//*Label 5818*/ GIMT_Encode4(282852),
     /* 282630 */ /*GILLT_v16s8*//*Label 5819*/ GIMT_Encode4(282886), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282650 */ /*GILLT_nxv2s64*//*Label 5820*/ GIMT_Encode4(282920), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282662 */ /*GILLT_nxv4s32*//*Label 5821*/ GIMT_Encode4(282946), GIMT_Encode4(0),
     /* 282670 */ /*GILLT_nxv8s16*//*Label 5822*/ GIMT_Encode4(282972), GIMT_Encode4(0),
     /* 282678 */ /*GILLT_nxv16s8*//*Label 5823*/ GIMT_Encode4(282998),
     /* 282682 */ // Label 5813: @282682
     /* 282682 */ GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(282715), // Rule ID 5015 //
     /* 282687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282708 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 282713 */   GIR_RootConstrainSelectedInstOperands,
     /* 282714 */   // GIR_Coverage, 5015,
     /* 282714 */   GIR_Done,
     /* 282715 */ // Label 5825: @282715
     /* 282715 */ GIM_Reject,
     /* 282716 */ // Label 5814: @282716
     /* 282716 */ GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(282749), // Rule ID 5019 //
     /* 282721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282742 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 282747 */   GIR_RootConstrainSelectedInstOperands,
     /* 282748 */   // GIR_Coverage, 5019,
     /* 282748 */   GIR_Done,
     /* 282749 */ // Label 5826: @282749
     /* 282749 */ GIM_Reject,
     /* 282750 */ // Label 5815: @282750
     /* 282750 */ GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(282783), // Rule ID 5014 //
     /* 282755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282776 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 282781 */   GIR_RootConstrainSelectedInstOperands,
     /* 282782 */   // GIR_Coverage, 5014,
     /* 282782 */   GIR_Done,
     /* 282783 */ // Label 5827: @282783
     /* 282783 */ GIM_Reject,
     /* 282784 */ // Label 5816: @282784
     /* 282784 */ GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(282817), // Rule ID 5018 //
     /* 282789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282810 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 282815 */   GIR_RootConstrainSelectedInstOperands,
     /* 282816 */   // GIR_Coverage, 5018,
     /* 282816 */   GIR_Done,
     /* 282817 */ // Label 5828: @282817
     /* 282817 */ GIM_Reject,
     /* 282818 */ // Label 5817: @282818
     /* 282818 */ GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(282851), // Rule ID 5013 //
     /* 282823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282844 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 282849 */   GIR_RootConstrainSelectedInstOperands,
     /* 282850 */   // GIR_Coverage, 5013,
     /* 282850 */   GIR_Done,
     /* 282851 */ // Label 5829: @282851
     /* 282851 */ GIM_Reject,
     /* 282852 */ // Label 5818: @282852
     /* 282852 */ GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(282885), // Rule ID 5017 //
     /* 282857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282878 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 282883 */   GIR_RootConstrainSelectedInstOperands,
     /* 282884 */   // GIR_Coverage, 5017,
     /* 282884 */   GIR_Done,
     /* 282885 */ // Label 5830: @282885
     /* 282885 */ GIM_Reject,
     /* 282886 */ // Label 5819: @282886
     /* 282886 */ GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(282919), // Rule ID 5016 //
     /* 282891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282912 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 282917 */   GIR_RootConstrainSelectedInstOperands,
     /* 282918 */   // GIR_Coverage, 5016,
     /* 282918 */   GIR_Done,
     /* 282919 */ // Label 5831: @282919
     /* 282919 */ GIM_Reject,
     /* 282920 */ // Label 5820: @282920
     /* 282920 */ GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(282945), // Rule ID 7398 //
     /* 282925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282938 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 282943 */   GIR_RootConstrainSelectedInstOperands,
     /* 282944 */   // GIR_Coverage, 7398,
     /* 282944 */   GIR_Done,
     /* 282945 */ // Label 5832: @282945
     /* 282945 */ GIM_Reject,
     /* 282946 */ // Label 5821: @282946
     /* 282946 */ GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(282971), // Rule ID 7397 //
     /* 282951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282964 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 282969 */   GIR_RootConstrainSelectedInstOperands,
     /* 282970 */   // GIR_Coverage, 7397,
     /* 282970 */   GIR_Done,
     /* 282971 */ // Label 5833: @282971
     /* 282971 */ GIM_Reject,
     /* 282972 */ // Label 5822: @282972
     /* 282972 */ GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(282997), // Rule ID 7396 //
     /* 282977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282990 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282990 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 282995 */   GIR_RootConstrainSelectedInstOperands,
     /* 282996 */   // GIR_Coverage, 7396,
     /* 282996 */   GIR_Done,
     /* 282997 */ // Label 5834: @282997
     /* 282997 */ GIM_Reject,
     /* 282998 */ // Label 5823: @282998
     /* 282998 */ GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(283023), // Rule ID 7395 //
     /* 283003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283016 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 283016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 283021 */   GIR_RootConstrainSelectedInstOperands,
     /* 283022 */   // GIR_Coverage, 7395,
     /* 283022 */   GIR_Done,
     /* 283023 */ // Label 5835: @283023
     /* 283023 */ GIM_Reject,
     /* 283024 */ // Label 5824: @283024
     /* 283024 */ GIM_Reject,
     /* 283025 */ // Label 57: @283025
     /* 283025 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5847*/ GIMT_Encode4(284822),
     /* 283036 */ /*GILLT_s16*//*Label 5836*/ GIMT_Encode4(283120),
     /* 283040 */ /*GILLT_s32*//*Label 5837*/ GIMT_Encode4(283346),
     /* 283044 */ /*GILLT_s64*//*Label 5838*/ GIMT_Encode4(283700), GIMT_Encode4(0),
     /* 283052 */ /*GILLT_v2s32*//*Label 5839*/ GIMT_Encode4(283872),
     /* 283056 */ /*GILLT_v2s64*//*Label 5840*/ GIMT_Encode4(283910),
     /* 283060 */ /*GILLT_v4s16*//*Label 5841*/ GIMT_Encode4(284086),
     /* 283064 */ /*GILLT_v4s32*//*Label 5842*/ GIMT_Encode4(284124), GIMT_Encode4(0),
     /* 283072 */ /*GILLT_v8s16*//*Label 5843*/ GIMT_Encode4(284300), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283096 */ /*GILLT_nxv2s64*//*Label 5844*/ GIMT_Encode4(284744), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283108 */ /*GILLT_nxv4s32*//*Label 5845*/ GIMT_Encode4(284770), GIMT_Encode4(0),
     /* 283116 */ /*GILLT_nxv8s16*//*Label 5846*/ GIMT_Encode4(284796),
     /* 283120 */ // Label 5836: @283120
     /* 283120 */ GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(283345),
     /* 283125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 283131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283135 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(283226), // Rule ID 6882 //
     /* 283140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283161 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283177 */     // MIs[2] Rn
     /* 283177 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283182 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283188 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283200 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283224 */     GIR_RootConstrainSelectedInstOperands,
     /* 283225 */     // GIR_Coverage, 6882,
     /* 283225 */     GIR_EraseRootFromParent_Done,
     /* 283226 */   // Label 5849: @283226
     /* 283226 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(283317), // Rule ID 13857 //
     /* 283231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283252 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283268 */     // MIs[2] Rn
     /* 283268 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283279 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283315 */     GIR_RootConstrainSelectedInstOperands,
     /* 283316 */     // GIR_Coverage, 13857,
     /* 283316 */     GIR_EraseRootFromParent_Done,
     /* 283317 */   // Label 5850: @283317
     /* 283317 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(283344), // Rule ID 584 //
     /* 283322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283333 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 283333 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 283338 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283342 */     GIR_RootConstrainSelectedInstOperands,
     /* 283343 */     // GIR_Coverage, 584,
     /* 283343 */     GIR_Done,
     /* 283344 */   // Label 5851: @283344
     /* 283344 */   GIM_Reject,
     /* 283345 */ // Label 5848: @283345
     /* 283345 */ GIM_Reject,
     /* 283346 */ // Label 5837: @283346
     /* 283346 */ GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(283699),
     /* 283351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 283357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283361 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(283452), // Rule ID 6880 //
     /* 283366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283387 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283403 */     // MIs[2] Rn
     /* 283403 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283408 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283414 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 283414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283426 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283450 */     GIR_RootConstrainSelectedInstOperands,
     /* 283451 */     // GIR_Coverage, 6880,
     /* 283451 */     GIR_EraseRootFromParent_Done,
     /* 283452 */   // Label 5853: @283452
     /* 283452 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(283516), // Rule ID 13034 //
     /* 283457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283494 */     // MIs[2] Rn
     /* 283494 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283499 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283505 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 283505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283514 */     GIR_RootConstrainSelectedInstOperands,
     /* 283515 */     // GIR_Coverage, 13034,
     /* 283515 */     GIR_EraseRootFromParent_Done,
     /* 283516 */   // Label 5854: @283516
     /* 283516 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(283607), // Rule ID 13855 //
     /* 283521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283542 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283558 */     // MIs[2] Rn
     /* 283558 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283563 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283569 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 283569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283581 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283605 */     GIR_RootConstrainSelectedInstOperands,
     /* 283606 */     // GIR_Coverage, 13855,
     /* 283606 */     GIR_EraseRootFromParent_Done,
     /* 283607 */   // Label 5855: @283607
     /* 283607 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(283671), // Rule ID 15530 //
     /* 283612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283633 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283649 */     // MIs[2] Rn
     /* 283649 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283654 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283660 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 283660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283669 */     GIR_RootConstrainSelectedInstOperands,
     /* 283670 */     // GIR_Coverage, 15530,
     /* 283670 */     GIR_EraseRootFromParent_Done,
     /* 283671 */   // Label 5856: @283671
     /* 283671 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(283698), // Rule ID 586 //
     /* 283676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283687 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 283687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 283692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283696 */     GIR_RootConstrainSelectedInstOperands,
     /* 283697 */     // GIR_Coverage, 586,
     /* 283697 */     GIR_Done,
     /* 283698 */   // Label 5857: @283698
     /* 283698 */   GIM_Reject,
     /* 283699 */ // Label 5852: @283699
     /* 283699 */ GIM_Reject,
     /* 283700 */ // Label 5838: @283700
     /* 283700 */ GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(283871),
     /* 283705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 283708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 283711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283715 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(283779), // Rule ID 6878 //
     /* 283720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283757 */     // MIs[2] Rn
     /* 283757 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283762 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283768 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 283768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 283771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283777 */     GIR_RootConstrainSelectedInstOperands,
     /* 283778 */     // GIR_Coverage, 6878,
     /* 283778 */     GIR_EraseRootFromParent_Done,
     /* 283779 */   // Label 5859: @283779
     /* 283779 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(283843), // Rule ID 13853 //
     /* 283784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283821 */     // MIs[2] Rn
     /* 283821 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283832 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 283832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 283835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283841 */     GIR_RootConstrainSelectedInstOperands,
     /* 283842 */     // GIR_Coverage, 13853,
     /* 283842 */     GIR_EraseRootFromParent_Done,
     /* 283843 */   // Label 5860: @283843
     /* 283843 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(283870), // Rule ID 588 //
     /* 283848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 283851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283859 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 283859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 283864 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283868 */     GIR_RootConstrainSelectedInstOperands,
     /* 283869 */     // GIR_Coverage, 588,
     /* 283869 */     GIR_Done,
     /* 283870 */   // Label 5861: @283870
     /* 283870 */   GIM_Reject,
     /* 283871 */ // Label 5858: @283871
     /* 283871 */ GIM_Reject,
     /* 283872 */ // Label 5839: @283872
     /* 283872 */ GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(283909), // Rule ID 1203 //
     /* 283877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283898 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 283898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 283903 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283907 */   GIR_RootConstrainSelectedInstOperands,
     /* 283908 */   // GIR_Coverage, 1203,
     /* 283908 */   GIR_Done,
     /* 283909 */ // Label 5862: @283909
     /* 283909 */ GIM_Reject,
     /* 283910 */ // Label 5840: @283910
     /* 283910 */ GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(284085),
     /* 283915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283925 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(283991), // Rule ID 6900 //
     /* 283930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 283938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 283964 */     // MIs[2] Rn
     /* 283964 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283969 */     // MIs[2] Rm
     /* 283969 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 283974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283976 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 283976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 283979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 283989 */     GIR_RootConstrainSelectedInstOperands,
     /* 283990 */     // GIR_Coverage, 6900,
     /* 283990 */     GIR_EraseRootFromParent_Done,
     /* 283991 */   // Label 5864: @283991
     /* 283991 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(284057), // Rule ID 13865 //
     /* 283996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 284004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 284030 */     // MIs[2] Rn
     /* 284030 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284035 */     // MIs[2] Rm
     /* 284035 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284042 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 284042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 284045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284055 */     GIR_RootConstrainSelectedInstOperands,
     /* 284056 */     // GIR_Coverage, 13865,
     /* 284056 */     GIR_EraseRootFromParent_Done,
     /* 284057 */   // Label 5865: @284057
     /* 284057 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(284084), // Rule ID 1207 //
     /* 284062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284073 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 284073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 284078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284082 */     GIR_RootConstrainSelectedInstOperands,
     /* 284083 */     // GIR_Coverage, 1207,
     /* 284083 */     GIR_Done,
     /* 284084 */   // Label 5866: @284084
     /* 284084 */   GIM_Reject,
     /* 284085 */ // Label 5863: @284085
     /* 284085 */ GIM_Reject,
     /* 284086 */ // Label 5841: @284086
     /* 284086 */ GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(284123), // Rule ID 1199 //
     /* 284091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284112 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 284112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 284117 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284121 */   GIR_RootConstrainSelectedInstOperands,
     /* 284122 */   // GIR_Coverage, 1199,
     /* 284122 */   GIR_Done,
     /* 284123 */ // Label 5867: @284123
     /* 284123 */ GIM_Reject,
     /* 284124 */ // Label 5842: @284124
     /* 284124 */ GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(284299),
     /* 284129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284139 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(284205), // Rule ID 6901 //
     /* 284144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284178 */     // MIs[2] Rn
     /* 284178 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284183 */     // MIs[2] Rm
     /* 284183 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284190 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284203 */     GIR_RootConstrainSelectedInstOperands,
     /* 284204 */     // GIR_Coverage, 6901,
     /* 284204 */     GIR_EraseRootFromParent_Done,
     /* 284205 */   // Label 5869: @284205
     /* 284205 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(284271), // Rule ID 13866 //
     /* 284210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284244 */     // MIs[2] Rn
     /* 284244 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284249 */     // MIs[2] Rm
     /* 284249 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284256 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284269 */     GIR_RootConstrainSelectedInstOperands,
     /* 284270 */     // GIR_Coverage, 13866,
     /* 284270 */     GIR_EraseRootFromParent_Done,
     /* 284271 */   // Label 5870: @284271
     /* 284271 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(284298), // Rule ID 1205 //
     /* 284276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284287 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 284287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284292 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284296 */     GIR_RootConstrainSelectedInstOperands,
     /* 284297 */     // GIR_Coverage, 1205,
     /* 284297 */     GIR_Done,
     /* 284298 */   // Label 5871: @284298
     /* 284298 */   GIM_Reject,
     /* 284299 */ // Label 5868: @284299
     /* 284299 */ GIM_Reject,
     /* 284300 */ // Label 5843: @284300
     /* 284300 */ GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(284743),
     /* 284305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284315 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(284384), // Rule ID 6902 //
     /* 284320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284357 */     // MIs[2] Rn
     /* 284357 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284362 */     // MIs[2] Rm
     /* 284362 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284369 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284382 */     GIR_RootConstrainSelectedInstOperands,
     /* 284383 */     // GIR_Coverage, 6902,
     /* 284383 */     GIR_EraseRootFromParent_Done,
     /* 284384 */   // Label 5873: @284384
     /* 284384 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(284453), // Rule ID 13867 //
     /* 284389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284426 */     // MIs[2] Rn
     /* 284426 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284431 */     // MIs[2] Rm
     /* 284431 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284438 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284451 */     GIR_RootConstrainSelectedInstOperands,
     /* 284452 */     // GIR_Coverage, 13867,
     /* 284452 */     GIR_EraseRootFromParent_Done,
     /* 284453 */   // Label 5874: @284453
     /* 284453 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(284480), // Rule ID 1201 //
     /* 284458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284469 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 284469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 284474 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284478 */     GIR_RootConstrainSelectedInstOperands,
     /* 284479 */     // GIR_Coverage, 1201,
     /* 284479 */     GIR_Done,
     /* 284480 */   // Label 5875: @284480
     /* 284480 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(284742), // Rule ID 6971 //
     /* 284485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 284488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284496 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 284496 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 284499 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 284503 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284508 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 284512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 284514 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 284517 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 284521 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284526 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 284530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 284532 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 284535 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284539 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284544 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 284547 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 284550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 284552 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 284555 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284559 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284564 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 284570 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284575 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284580 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 284583 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 284587 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284592 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 284595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 284597 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 284600 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284604 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284609 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284615 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284620 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284625 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 284628 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 284632 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284637 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 284640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 284642 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 284645 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284649 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284654 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 284657 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 284660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 284665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 284669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284674 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 284677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 284682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 284696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284705 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 284708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 284711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 284714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 284732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 284740 */     GIR_RootConstrainSelectedInstOperands,
     /* 284741 */     // GIR_Coverage, 6971,
     /* 284741 */     GIR_EraseRootFromParent_Done,
     /* 284742 */   // Label 5876: @284742
     /* 284742 */   GIM_Reject,
     /* 284743 */ // Label 5872: @284743
     /* 284743 */ GIM_Reject,
     /* 284744 */ // Label 5844: @284744
     /* 284744 */ GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(284769), // Rule ID 2824 //
     /* 284749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 284758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284762 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 284762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 284767 */   GIR_RootConstrainSelectedInstOperands,
     /* 284768 */   // GIR_Coverage, 2824,
     /* 284768 */   GIR_Done,
     /* 284769 */ // Label 5877: @284769
     /* 284769 */ GIM_Reject,
     /* 284770 */ // Label 5845: @284770
     /* 284770 */ GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(284795), // Rule ID 2822 //
     /* 284775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 284784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284788 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 284788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 284793 */   GIR_RootConstrainSelectedInstOperands,
     /* 284794 */   // GIR_Coverage, 2822,
     /* 284794 */   GIR_Done,
     /* 284795 */ // Label 5878: @284795
     /* 284795 */ GIM_Reject,
     /* 284796 */ // Label 5846: @284796
     /* 284796 */ GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(284821), // Rule ID 2820 //
     /* 284801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 284810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284814 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 284814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 284819 */   GIR_RootConstrainSelectedInstOperands,
     /* 284820 */   // GIR_Coverage, 2820,
     /* 284820 */   GIR_Done,
     /* 284821 */ // Label 5879: @284821
     /* 284821 */ GIM_Reject,
     /* 284822 */ // Label 5847: @284822
     /* 284822 */ GIM_Reject,
     /* 284823 */ // Label 58: @284823
     /* 284823 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5891*/ GIMT_Encode4(285560),
     /* 284834 */ /*GILLT_s16*//*Label 5880*/ GIMT_Encode4(284918),
     /* 284838 */ /*GILLT_s32*//*Label 5881*/ GIMT_Encode4(284956),
     /* 284842 */ /*GILLT_s64*//*Label 5882*/ GIMT_Encode4(284994), GIMT_Encode4(0),
     /* 284850 */ /*GILLT_v2s32*//*Label 5883*/ GIMT_Encode4(285032),
     /* 284854 */ /*GILLT_v2s64*//*Label 5884*/ GIMT_Encode4(285070),
     /* 284858 */ /*GILLT_v4s16*//*Label 5885*/ GIMT_Encode4(285108),
     /* 284862 */ /*GILLT_v4s32*//*Label 5886*/ GIMT_Encode4(285146), GIMT_Encode4(0),
     /* 284870 */ /*GILLT_v8s16*//*Label 5887*/ GIMT_Encode4(285184), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284894 */ /*GILLT_nxv2s64*//*Label 5888*/ GIMT_Encode4(285482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 284906 */ /*GILLT_nxv4s32*//*Label 5889*/ GIMT_Encode4(285508), GIMT_Encode4(0),
     /* 284914 */ /*GILLT_nxv8s16*//*Label 5890*/ GIMT_Encode4(285534),
     /* 284918 */ // Label 5880: @284918
     /* 284918 */ GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(284955), // Rule ID 632 //
     /* 284923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 284932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284944 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 284944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 284949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284953 */   GIR_RootConstrainSelectedInstOperands,
     /* 284954 */   // GIR_Coverage, 632,
     /* 284954 */   GIR_Done,
     /* 284955 */ // Label 5892: @284955
     /* 284955 */ GIM_Reject,
     /* 284956 */ // Label 5881: @284956
     /* 284956 */ GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(284993), // Rule ID 634 //
     /* 284961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 284967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 284970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284982 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 284982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 284987 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284991 */   GIR_RootConstrainSelectedInstOperands,
     /* 284992 */   // GIR_Coverage, 634,
     /* 284992 */   GIR_Done,
     /* 284993 */ // Label 5893: @284993
     /* 284993 */ GIM_Reject,
     /* 284994 */ // Label 5882: @284994
     /* 284994 */ GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(285031), // Rule ID 636 //
     /* 284999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285020 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 285020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 285025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285029 */   GIR_RootConstrainSelectedInstOperands,
     /* 285030 */   // GIR_Coverage, 636,
     /* 285030 */   GIR_Done,
     /* 285031 */ // Label 5894: @285031
     /* 285031 */ GIM_Reject,
     /* 285032 */ // Label 5883: @285032
     /* 285032 */ GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(285069), // Rule ID 1343 //
     /* 285037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285058 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 285058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 285063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285067 */   GIR_RootConstrainSelectedInstOperands,
     /* 285068 */   // GIR_Coverage, 1343,
     /* 285068 */   GIR_Done,
     /* 285069 */ // Label 5895: @285069
     /* 285069 */ GIM_Reject,
     /* 285070 */ // Label 5884: @285070
     /* 285070 */ GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(285107), // Rule ID 1347 //
     /* 285075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285096 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 285096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 285101 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285105 */   GIR_RootConstrainSelectedInstOperands,
     /* 285106 */   // GIR_Coverage, 1347,
     /* 285106 */   GIR_Done,
     /* 285107 */ // Label 5896: @285107
     /* 285107 */ GIM_Reject,
     /* 285108 */ // Label 5885: @285108
     /* 285108 */ GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(285145), // Rule ID 1339 //
     /* 285113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285134 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 285134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 285139 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285143 */   GIR_RootConstrainSelectedInstOperands,
     /* 285144 */   // GIR_Coverage, 1339,
     /* 285144 */   GIR_Done,
     /* 285145 */ // Label 5897: @285145
     /* 285145 */ GIM_Reject,
     /* 285146 */ // Label 5886: @285146
     /* 285146 */ GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(285183), // Rule ID 1345 //
     /* 285151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285172 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 285172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285181 */   GIR_RootConstrainSelectedInstOperands,
     /* 285182 */   // GIR_Coverage, 1345,
     /* 285182 */   GIR_Done,
     /* 285183 */ // Label 5898: @285183
     /* 285183 */ GIM_Reject,
     /* 285184 */ // Label 5887: @285184
     /* 285184 */ GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(285481),
     /* 285189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285207 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(285226), // Rule ID 1341 //
     /* 285212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285215 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 285215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 285220 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285224 */     GIR_RootConstrainSelectedInstOperands,
     /* 285225 */     // GIR_Coverage, 1341,
     /* 285225 */     GIR_Done,
     /* 285226 */   // Label 5900: @285226
     /* 285226 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(285480), // Rule ID 6977 //
     /* 285231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 285234 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 285234 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 285237 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285241 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285246 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 285250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 285252 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 285255 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285259 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285264 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 285268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 285270 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 285273 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285277 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285282 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 285285 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 285288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 285290 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 285293 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285297 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285302 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285308 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285313 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285318 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 285321 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285325 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285330 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 285333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 285335 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 285338 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285342 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285347 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285353 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285358 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285363 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 285366 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285370 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285375 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 285378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 285380 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 285383 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285387 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285392 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 285395 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 285398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 285403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 285407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285412 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 285415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 285420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 285434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 285449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 285452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 285470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 285478 */     GIR_RootConstrainSelectedInstOperands,
     /* 285479 */     // GIR_Coverage, 6977,
     /* 285479 */     GIR_EraseRootFromParent_Done,
     /* 285480 */   // Label 5901: @285480
     /* 285480 */   GIM_Reject,
     /* 285481 */ // Label 5899: @285481
     /* 285481 */ GIM_Reject,
     /* 285482 */ // Label 5888: @285482
     /* 285482 */ GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(285507), // Rule ID 8141 //
     /* 285487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285500 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 285500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 285505 */   GIR_RootConstrainSelectedInstOperands,
     /* 285506 */   // GIR_Coverage, 8141,
     /* 285506 */   GIR_Done,
     /* 285507 */ // Label 5902: @285507
     /* 285507 */ GIM_Reject,
     /* 285508 */ // Label 5889: @285508
     /* 285508 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(285533), // Rule ID 8139 //
     /* 285513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285526 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 285526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 285531 */   GIR_RootConstrainSelectedInstOperands,
     /* 285532 */   // GIR_Coverage, 8139,
     /* 285532 */   GIR_Done,
     /* 285533 */ // Label 5903: @285533
     /* 285533 */ GIM_Reject,
     /* 285534 */ // Label 5890: @285534
     /* 285534 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(285559), // Rule ID 8137 //
     /* 285539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285552 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 285552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 285557 */   GIR_RootConstrainSelectedInstOperands,
     /* 285558 */   // GIR_Coverage, 8137,
     /* 285558 */   GIR_Done,
     /* 285559 */ // Label 5904: @285559
     /* 285559 */ GIM_Reject,
     /* 285560 */ // Label 5891: @285560
     /* 285560 */ GIM_Reject,
     /* 285561 */ // Label 59: @285561
     /* 285561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5916*/ GIMT_Encode4(289656),
     /* 285572 */ /*GILLT_s16*//*Label 5905*/ GIMT_Encode4(285656),
     /* 285576 */ /*GILLT_s32*//*Label 5906*/ GIMT_Encode4(286298),
     /* 285580 */ /*GILLT_s64*//*Label 5907*/ GIMT_Encode4(286928), GIMT_Encode4(0),
     /* 285588 */ /*GILLT_v2s32*//*Label 5908*/ GIMT_Encode4(287558),
     /* 285592 */ /*GILLT_v2s64*//*Label 5909*/ GIMT_Encode4(288088),
     /* 285596 */ /*GILLT_v4s16*//*Label 5910*/ GIMT_Encode4(288446),
     /* 285600 */ /*GILLT_v4s32*//*Label 5911*/ GIMT_Encode4(288788), GIMT_Encode4(0),
     /* 285608 */ /*GILLT_v8s16*//*Label 5912*/ GIMT_Encode4(289146), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285632 */ /*GILLT_nxv2s64*//*Label 5913*/ GIMT_Encode4(289578), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285644 */ /*GILLT_nxv4s32*//*Label 5914*/ GIMT_Encode4(289604), GIMT_Encode4(0),
     /* 285652 */ /*GILLT_nxv8s16*//*Label 5915*/ GIMT_Encode4(289630),
     /* 285656 */ // Label 5905: @285656
     /* 285656 */ GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(286297),
     /* 285661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285671 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(285784), // Rule ID 6212 //
     /* 285676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285700 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 285708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 285720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 285729 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285733 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 285737 */     // MIs[3] Operand 1
     /* 285737 */     // No operand predicates
     /* 285737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285739 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 285739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285751 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 285757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 285770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 285779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 285782 */     GIR_RootConstrainSelectedInstOperands,
     /* 285783 */     // GIR_Coverage, 6212,
     /* 285783 */     GIR_EraseRootFromParent_Done,
     /* 285784 */   // Label 5918: @285784
     /* 285784 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(285897), // Rule ID 13834 //
     /* 285789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 285817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 285821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 285825 */     // MIs[2] Operand 1
     /* 285825 */     // No operand predicates
     /* 285825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 285829 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285833 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285837 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 285841 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285846 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 285850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 285852 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 285852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285864 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 285870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 285883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 285895 */     GIR_RootConstrainSelectedInstOperands,
     /* 285896 */     // GIR_Coverage, 13834,
     /* 285896 */     GIR_EraseRootFromParent_Done,
     /* 285897 */   // Label 5919: @285897
     /* 285897 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(285976), // Rule ID 13771 //
     /* 285902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 285921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285926 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 285930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285936 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 285936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 285939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285948 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 285954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 285967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 285971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285974 */     GIR_RootConstrainSelectedInstOperands,
     /* 285975 */     // GIR_Coverage, 13771,
     /* 285975 */     GIR_EraseRootFromParent_Done,
     /* 285976 */   // Label 5920: @285976
     /* 285976 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(286055), // Rule ID 4791 //
     /* 285981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 285996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286015 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 286015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286027 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286053 */     GIR_RootConstrainSelectedInstOperands,
     /* 286054 */     // GIR_Coverage, 4791,
     /* 286054 */     GIR_EraseRootFromParent_Done,
     /* 286055 */   // Label 5921: @286055
     /* 286055 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(286118), // Rule ID 13386 //
     /* 286060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286092 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286096 */     // MIs[2] Operand 1
     /* 286096 */     // No operand predicates
     /* 286096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286102 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286116 */     GIR_RootConstrainSelectedInstOperands,
     /* 286117 */     // GIR_Coverage, 13386,
     /* 286117 */     GIR_EraseRootFromParent_Done,
     /* 286118 */   // Label 5922: @286118
     /* 286118 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(286181), // Rule ID 2012 //
     /* 286123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286159 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286163 */     // MIs[2] Operand 1
     /* 286163 */     // No operand predicates
     /* 286163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286165 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286179 */     GIR_RootConstrainSelectedInstOperands,
     /* 286180 */     // GIR_Coverage, 2012,
     /* 286180 */     GIR_EraseRootFromParent_Done,
     /* 286181 */   // Label 5923: @286181
     /* 286181 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(286225), // Rule ID 4796 //
     /* 286186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286212 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286221 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 286223 */     GIR_RootConstrainSelectedInstOperands,
     /* 286224 */     // GIR_Coverage, 4796,
     /* 286224 */     GIR_EraseRootFromParent_Done,
     /* 286225 */   // Label 5924: @286225
     /* 286225 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(286269), // Rule ID 13776 //
     /* 286230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286256 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286265 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 286267 */     GIR_RootConstrainSelectedInstOperands,
     /* 286268 */     // GIR_Coverage, 13776,
     /* 286268 */     GIR_EraseRootFromParent_Done,
     /* 286269 */   // Label 5925: @286269
     /* 286269 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(286296), // Rule ID 620 //
     /* 286274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286285 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 286285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286290 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286294 */     GIR_RootConstrainSelectedInstOperands,
     /* 286295 */     // GIR_Coverage, 620,
     /* 286295 */     GIR_Done,
     /* 286296 */   // Label 5926: @286296
     /* 286296 */   GIM_Reject,
     /* 286297 */ // Label 5917: @286297
     /* 286297 */ GIM_Reject,
     /* 286298 */ // Label 5906: @286298
     /* 286298 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(286927),
     /* 286303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286313 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(286426), // Rule ID 6214 //
     /* 286318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286379 */     // MIs[3] Operand 1
     /* 286379 */     // No operand predicates
     /* 286379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286381 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286393 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286424 */     GIR_RootConstrainSelectedInstOperands,
     /* 286425 */     // GIR_Coverage, 6214,
     /* 286425 */     GIR_EraseRootFromParent_Done,
     /* 286426 */   // Label 5928: @286426
     /* 286426 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(286539), // Rule ID 13836 //
     /* 286431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286467 */     // MIs[2] Operand 1
     /* 286467 */     // No operand predicates
     /* 286467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286483 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286488 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286494 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286506 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286537 */     GIR_RootConstrainSelectedInstOperands,
     /* 286538 */     // GIR_Coverage, 13836,
     /* 286538 */     GIR_EraseRootFromParent_Done,
     /* 286539 */   // Label 5929: @286539
     /* 286539 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(286615), // Rule ID 13773 //
     /* 286544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286565 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286575 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 286575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286587 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286613 */     GIR_RootConstrainSelectedInstOperands,
     /* 286614 */     // GIR_Coverage, 13773,
     /* 286614 */     GIR_EraseRootFromParent_Done,
     /* 286615 */   // Label 5930: @286615
     /* 286615 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(286691), // Rule ID 4793 //
     /* 286620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286645 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286651 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 286651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 286669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286689 */     GIR_RootConstrainSelectedInstOperands,
     /* 286690 */     // GIR_Coverage, 4793,
     /* 286690 */     GIR_EraseRootFromParent_Done,
     /* 286691 */   // Label 5931: @286691
     /* 286691 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(286754), // Rule ID 13388 //
     /* 286696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286732 */     // MIs[2] Operand 1
     /* 286732 */     // No operand predicates
     /* 286732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286738 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286752 */     GIR_RootConstrainSelectedInstOperands,
     /* 286753 */     // GIR_Coverage, 13388,
     /* 286753 */     GIR_EraseRootFromParent_Done,
     /* 286754 */   // Label 5932: @286754
     /* 286754 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(286817), // Rule ID 2014 //
     /* 286759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286795 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286799 */     // MIs[2] Operand 1
     /* 286799 */     // No operand predicates
     /* 286799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286801 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286815 */     GIR_RootConstrainSelectedInstOperands,
     /* 286816 */     // GIR_Coverage, 2014,
     /* 286816 */     GIR_EraseRootFromParent_Done,
     /* 286817 */   // Label 5933: @286817
     /* 286817 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(286858), // Rule ID 4797 //
     /* 286822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286845 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 286845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 286848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286854 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 286856 */     GIR_RootConstrainSelectedInstOperands,
     /* 286857 */     // GIR_Coverage, 4797,
     /* 286857 */     GIR_EraseRootFromParent_Done,
     /* 286858 */   // Label 5934: @286858
     /* 286858 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(286899), // Rule ID 13777 //
     /* 286863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286886 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 286886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 286889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286895 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 286897 */     GIR_RootConstrainSelectedInstOperands,
     /* 286898 */     // GIR_Coverage, 13777,
     /* 286898 */     GIR_EraseRootFromParent_Done,
     /* 286899 */   // Label 5935: @286899
     /* 286899 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(286926), // Rule ID 622 //
     /* 286904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 286907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286915 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 286915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 286920 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286924 */     GIR_RootConstrainSelectedInstOperands,
     /* 286925 */     // GIR_Coverage, 622,
     /* 286925 */     GIR_Done,
     /* 286926 */   // Label 5936: @286926
     /* 286926 */   GIM_Reject,
     /* 286927 */ // Label 5927: @286927
     /* 286927 */ GIM_Reject,
     /* 286928 */ // Label 5907: @286928
     /* 286928 */ GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(287557),
     /* 286933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286943 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(287056), // Rule ID 6216 //
     /* 286948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 286988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287005 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287009 */     // MIs[3] Operand 1
     /* 287009 */     // No operand predicates
     /* 287009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287011 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287054 */     GIR_RootConstrainSelectedInstOperands,
     /* 287055 */     // GIR_Coverage, 6216,
     /* 287055 */     GIR_EraseRootFromParent_Done,
     /* 287056 */   // Label 5938: @287056
     /* 287056 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(287169), // Rule ID 13838 //
     /* 287061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287093 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287097 */     // MIs[2] Operand 1
     /* 287097 */     // No operand predicates
     /* 287097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287109 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287118 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287124 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287136 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287167 */     GIR_RootConstrainSelectedInstOperands,
     /* 287168 */     // GIR_Coverage, 13838,
     /* 287168 */     GIR_EraseRootFromParent_Done,
     /* 287169 */   // Label 5939: @287169
     /* 287169 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(287245), // Rule ID 13775 //
     /* 287174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287205 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287243 */     GIR_RootConstrainSelectedInstOperands,
     /* 287244 */     // GIR_Coverage, 13775,
     /* 287244 */     GIR_EraseRootFromParent_Done,
     /* 287245 */   // Label 5940: @287245
     /* 287245 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(287321), // Rule ID 4795 //
     /* 287250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287275 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287281 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287293 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287319 */     GIR_RootConstrainSelectedInstOperands,
     /* 287320 */     // GIR_Coverage, 4795,
     /* 287320 */     GIR_EraseRootFromParent_Done,
     /* 287321 */   // Label 5941: @287321
     /* 287321 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(287384), // Rule ID 13390 //
     /* 287326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287362 */     // MIs[2] Operand 1
     /* 287362 */     // No operand predicates
     /* 287362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287368 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287382 */     GIR_RootConstrainSelectedInstOperands,
     /* 287383 */     // GIR_Coverage, 13390,
     /* 287383 */     GIR_EraseRootFromParent_Done,
     /* 287384 */   // Label 5942: @287384
     /* 287384 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(287447), // Rule ID 2016 //
     /* 287389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287425 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287429 */     // MIs[2] Operand 1
     /* 287429 */     // No operand predicates
     /* 287429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287431 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287445 */     GIR_RootConstrainSelectedInstOperands,
     /* 287446 */     // GIR_Coverage, 2016,
     /* 287446 */     GIR_EraseRootFromParent_Done,
     /* 287447 */   // Label 5943: @287447
     /* 287447 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(287488), // Rule ID 4798 //
     /* 287452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287475 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 287475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 287478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287484 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 287486 */     GIR_RootConstrainSelectedInstOperands,
     /* 287487 */     // GIR_Coverage, 4798,
     /* 287487 */     GIR_EraseRootFromParent_Done,
     /* 287488 */   // Label 5944: @287488
     /* 287488 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(287529), // Rule ID 13778 //
     /* 287493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287516 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 287516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 287519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287525 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 287527 */     GIR_RootConstrainSelectedInstOperands,
     /* 287528 */     // GIR_Coverage, 13778,
     /* 287528 */     GIR_EraseRootFromParent_Done,
     /* 287529 */   // Label 5945: @287529
     /* 287529 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(287556), // Rule ID 624 //
     /* 287534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287545 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 287545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287550 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287554 */     GIR_RootConstrainSelectedInstOperands,
     /* 287555 */     // GIR_Coverage, 624,
     /* 287555 */     GIR_Done,
     /* 287556 */   // Label 5946: @287556
     /* 287556 */   GIM_Reject,
     /* 287557 */ // Label 5937: @287557
     /* 287557 */ GIM_Reject,
     /* 287558 */ // Label 5908: @287558
     /* 287558 */ GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(288087),
     /* 287563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 287566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287573 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(287659), // Rule ID 13379 //
     /* 287578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 287589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287622 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287626 */     // MIs[3] Operand 1
     /* 287626 */     // No operand predicates
     /* 287626 */     // MIs[1] Operand 2
     /* 287626 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 287637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287641 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287643 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287657 */     GIR_RootConstrainSelectedInstOperands,
     /* 287658 */     // GIR_Coverage, 13379,
     /* 287658 */     GIR_EraseRootFromParent_Done,
     /* 287659 */   // Label 5948: @287659
     /* 287659 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(287745), // Rule ID 2005 //
     /* 287664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 287679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 287687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287712 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287716 */     // MIs[3] Operand 1
     /* 287716 */     // No operand predicates
     /* 287716 */     // MIs[1] Operand 2
     /* 287716 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 287727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287729 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287743 */     GIR_RootConstrainSelectedInstOperands,
     /* 287744 */     // GIR_Coverage, 2005,
     /* 287744 */     GIR_EraseRootFromParent_Done,
     /* 287745 */   // Label 5949: @287745
     /* 287745 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(287808), // Rule ID 13380 //
     /* 287750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287786 */     // MIs[2] Operand 1
     /* 287786 */     // No operand predicates
     /* 287786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287792 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287806 */     GIR_RootConstrainSelectedInstOperands,
     /* 287807 */     // GIR_Coverage, 13380,
     /* 287807 */     GIR_EraseRootFromParent_Done,
     /* 287808 */   // Label 5950: @287808
     /* 287808 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(287871), // Rule ID 2006 //
     /* 287813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 287828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287849 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287853 */     // MIs[2] Operand 1
     /* 287853 */     // No operand predicates
     /* 287853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287855 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287869 */     GIR_RootConstrainSelectedInstOperands,
     /* 287870 */     // GIR_Coverage, 2006,
     /* 287870 */     GIR_EraseRootFromParent_Done,
     /* 287871 */   // Label 5951: @287871
     /* 287871 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(287965), // Rule ID 13840 //
     /* 287876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 287884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287899 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 287899 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 287902 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 287906 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 287913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 287916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 287920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287925 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 287928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 287935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 287953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287963 */     GIR_RootConstrainSelectedInstOperands,
     /* 287964 */     // GIR_Coverage, 13840,
     /* 287964 */     GIR_EraseRootFromParent_Done,
     /* 287965 */   // Label 5952: @287965
     /* 287965 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(288059), // Rule ID 6218 //
     /* 287970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 287982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287993 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 287993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 287996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288019 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288026 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 288029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288057 */     GIR_RootConstrainSelectedInstOperands,
     /* 288058 */     // GIR_Coverage, 6218,
     /* 288058 */     GIR_EraseRootFromParent_Done,
     /* 288059 */   // Label 5953: @288059
     /* 288059 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(288086), // Rule ID 1323 //
     /* 288064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288075 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 288075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 288080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288084 */     GIR_RootConstrainSelectedInstOperands,
     /* 288085 */     // GIR_Coverage, 1323,
     /* 288085 */     GIR_Done,
     /* 288086 */   // Label 5954: @288086
     /* 288086 */   GIM_Reject,
     /* 288087 */ // Label 5947: @288087
     /* 288087 */ GIM_Reject,
     /* 288088 */ // Label 5909: @288088
     /* 288088 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(288445),
     /* 288093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288103 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(288166), // Rule ID 13384 //
     /* 288108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288140 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288144 */     // MIs[2] Operand 1
     /* 288144 */     // No operand predicates
     /* 288144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288150 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288164 */     GIR_RootConstrainSelectedInstOperands,
     /* 288165 */     // GIR_Coverage, 13384,
     /* 288165 */     GIR_EraseRootFromParent_Done,
     /* 288166 */   // Label 5956: @288166
     /* 288166 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(288229), // Rule ID 2010 //
     /* 288171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288207 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288211 */     // MIs[2] Operand 1
     /* 288211 */     // No operand predicates
     /* 288211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288213 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288227 */     GIR_RootConstrainSelectedInstOperands,
     /* 288228 */     // GIR_Coverage, 2010,
     /* 288228 */     GIR_EraseRootFromParent_Done,
     /* 288229 */   // Label 5957: @288229
     /* 288229 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(288323), // Rule ID 13844 //
     /* 288234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288257 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288264 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288321 */     GIR_RootConstrainSelectedInstOperands,
     /* 288322 */     // GIR_Coverage, 13844,
     /* 288322 */     GIR_EraseRootFromParent_Done,
     /* 288323 */   // Label 5958: @288323
     /* 288323 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(288417), // Rule ID 6222 //
     /* 288328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288351 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288351 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288354 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288358 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288415 */     GIR_RootConstrainSelectedInstOperands,
     /* 288416 */     // GIR_Coverage, 6222,
     /* 288416 */     GIR_EraseRootFromParent_Done,
     /* 288417 */   // Label 5959: @288417
     /* 288417 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(288444), // Rule ID 1327 //
     /* 288422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288433 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 288433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 288438 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288442 */     GIR_RootConstrainSelectedInstOperands,
     /* 288443 */     // GIR_Coverage, 1327,
     /* 288443 */     GIR_Done,
     /* 288444 */   // Label 5960: @288444
     /* 288444 */   GIM_Reject,
     /* 288445 */ // Label 5955: @288445
     /* 288445 */ GIM_Reject,
     /* 288446 */ // Label 5910: @288446
     /* 288446 */ GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(288787),
     /* 288451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 288457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288461 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(288547), // Rule ID 13373 //
     /* 288466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288510 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288514 */     // MIs[3] Operand 1
     /* 288514 */     // No operand predicates
     /* 288514 */     // MIs[1] Operand 2
     /* 288514 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288531 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288545 */     GIR_RootConstrainSelectedInstOperands,
     /* 288546 */     // GIR_Coverage, 13373,
     /* 288546 */     GIR_EraseRootFromParent_Done,
     /* 288547 */   // Label 5962: @288547
     /* 288547 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(288633), // Rule ID 1999 //
     /* 288552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288600 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288604 */     // MIs[3] Operand 1
     /* 288604 */     // No operand predicates
     /* 288604 */     // MIs[1] Operand 2
     /* 288604 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288617 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288631 */     GIR_RootConstrainSelectedInstOperands,
     /* 288632 */     // GIR_Coverage, 1999,
     /* 288632 */     GIR_EraseRootFromParent_Done,
     /* 288633 */   // Label 5963: @288633
     /* 288633 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(288696), // Rule ID 13374 //
     /* 288638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288674 */     // MIs[2] Operand 1
     /* 288674 */     // No operand predicates
     /* 288674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288680 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288694 */     GIR_RootConstrainSelectedInstOperands,
     /* 288695 */     // GIR_Coverage, 13374,
     /* 288695 */     GIR_EraseRootFromParent_Done,
     /* 288696 */   // Label 5964: @288696
     /* 288696 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(288759), // Rule ID 2000 //
     /* 288701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 288716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 288729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 288741 */     // MIs[2] Operand 1
     /* 288741 */     // No operand predicates
     /* 288741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288743 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 288746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288757 */     GIR_RootConstrainSelectedInstOperands,
     /* 288758 */     // GIR_Coverage, 2000,
     /* 288758 */     GIR_EraseRootFromParent_Done,
     /* 288759 */   // Label 5965: @288759
     /* 288759 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(288786), // Rule ID 1319 //
     /* 288764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 288767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288775 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 288775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 288780 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288784 */     GIR_RootConstrainSelectedInstOperands,
     /* 288785 */     // GIR_Coverage, 1319,
     /* 288785 */     GIR_Done,
     /* 288786 */   // Label 5966: @288786
     /* 288786 */   GIM_Reject,
     /* 288787 */ // Label 5961: @288787
     /* 288787 */ GIM_Reject,
     /* 288788 */ // Label 5911: @288788
     /* 288788 */ GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(289145),
     /* 288793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 288799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288803 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(288866), // Rule ID 13382 //
     /* 288808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288840 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288844 */     // MIs[2] Operand 1
     /* 288844 */     // No operand predicates
     /* 288844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288850 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 288853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288864 */     GIR_RootConstrainSelectedInstOperands,
     /* 288865 */     // GIR_Coverage, 13382,
     /* 288865 */     GIR_EraseRootFromParent_Done,
     /* 288866 */   // Label 5968: @288866
     /* 288866 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(288929), // Rule ID 2008 //
     /* 288871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288911 */     // MIs[2] Operand 1
     /* 288911 */     // No operand predicates
     /* 288911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288913 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 288916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288927 */     GIR_RootConstrainSelectedInstOperands,
     /* 288928 */     // GIR_Coverage, 2008,
     /* 288928 */     GIR_EraseRootFromParent_Done,
     /* 288929 */   // Label 5969: @288929
     /* 288929 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(289023), // Rule ID 13842 //
     /* 288934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288957 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288957 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288960 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288964 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 288993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289021 */     GIR_RootConstrainSelectedInstOperands,
     /* 289022 */     // GIR_Coverage, 13842,
     /* 289022 */     GIR_EraseRootFromParent_Done,
     /* 289023 */   // Label 5970: @289023
     /* 289023 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(289117), // Rule ID 6220 //
     /* 289028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289051 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289084 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289115 */     GIR_RootConstrainSelectedInstOperands,
     /* 289116 */     // GIR_Coverage, 6220,
     /* 289116 */     GIR_EraseRootFromParent_Done,
     /* 289117 */   // Label 5971: @289117
     /* 289117 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(289144), // Rule ID 1325 //
     /* 289122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289133 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 289133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289138 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289142 */     GIR_RootConstrainSelectedInstOperands,
     /* 289143 */     // GIR_Coverage, 1325,
     /* 289143 */     GIR_Done,
     /* 289144 */   // Label 5972: @289144
     /* 289144 */   GIM_Reject,
     /* 289145 */ // Label 5967: @289145
     /* 289145 */ GIM_Reject,
     /* 289146 */ // Label 5912: @289146
     /* 289146 */ GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(289577),
     /* 289151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 289157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289161 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(289224), // Rule ID 13376 //
     /* 289166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289202 */     // MIs[2] Operand 1
     /* 289202 */     // No operand predicates
     /* 289202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289208 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289222 */     GIR_RootConstrainSelectedInstOperands,
     /* 289223 */     // GIR_Coverage, 13376,
     /* 289223 */     GIR_EraseRootFromParent_Done,
     /* 289224 */   // Label 5974: @289224
     /* 289224 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(289287), // Rule ID 2002 //
     /* 289229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289265 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289269 */     // MIs[2] Operand 1
     /* 289269 */     // No operand predicates
     /* 289269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289271 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289285 */     GIR_RootConstrainSelectedInstOperands,
     /* 289286 */     // GIR_Coverage, 2002,
     /* 289286 */     GIR_EraseRootFromParent_Done,
     /* 289287 */   // Label 5975: @289287
     /* 289287 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(289314), // Rule ID 1321 //
     /* 289292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289303 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 289303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 289308 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289312 */     GIR_RootConstrainSelectedInstOperands,
     /* 289313 */     // GIR_Coverage, 1321,
     /* 289313 */     GIR_Done,
     /* 289314 */   // Label 5976: @289314
     /* 289314 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(289576), // Rule ID 6975 //
     /* 289319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 289322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289330 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 289330 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 289333 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289337 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289342 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 289346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 289348 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 289351 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289355 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289360 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 289364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 289366 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 289369 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289373 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289378 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 289381 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 289384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 289386 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 289389 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289393 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289398 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289404 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289409 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289414 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 289417 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 289421 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289426 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 289429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 289431 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 289434 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289438 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289443 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289449 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289454 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289459 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 289462 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 289466 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289471 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 289474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 289476 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 289479 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289483 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289488 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 289491 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 289494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 289496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 289499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 289503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289508 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 289511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 289513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 289516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 289530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289539 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289542 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 289545 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 289548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 289566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 289568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 289574 */     GIR_RootConstrainSelectedInstOperands,
     /* 289575 */     // GIR_Coverage, 6975,
     /* 289575 */     GIR_EraseRootFromParent_Done,
     /* 289576 */   // Label 5977: @289576
     /* 289576 */   GIM_Reject,
     /* 289577 */ // Label 5973: @289577
     /* 289577 */ GIM_Reject,
     /* 289578 */ // Label 5913: @289578
     /* 289578 */ GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(289603), // Rule ID 8147 //
     /* 289583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 289589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 289592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289596 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 289596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 289601 */   GIR_RootConstrainSelectedInstOperands,
     /* 289602 */   // GIR_Coverage, 8147,
     /* 289602 */   GIR_Done,
     /* 289603 */ // Label 5978: @289603
     /* 289603 */ GIM_Reject,
     /* 289604 */ // Label 5914: @289604
     /* 289604 */ GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(289629), // Rule ID 8145 //
     /* 289609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 289615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 289618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289622 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 289622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 289627 */   GIR_RootConstrainSelectedInstOperands,
     /* 289628 */   // GIR_Coverage, 8145,
     /* 289628 */   GIR_Done,
     /* 289629 */ // Label 5979: @289629
     /* 289629 */ GIM_Reject,
     /* 289630 */ // Label 5915: @289630
     /* 289630 */ GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(289655), // Rule ID 8143 //
     /* 289635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 289638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 289641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 289644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 289648 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 289648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 289653 */   GIR_RootConstrainSelectedInstOperands,
     /* 289654 */   // GIR_Coverage, 8143,
     /* 289654 */   GIR_Done,
     /* 289655 */ // Label 5980: @289655
     /* 289655 */ GIM_Reject,
     /* 289656 */ // Label 5916: @289656
     /* 289656 */ GIM_Reject,
     /* 289657 */ // Label 60: @289657
     /* 289657 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5989*/ GIMT_Encode4(305929),
     /* 289668 */ /*GILLT_s16*//*Label 5981*/ GIMT_Encode4(289708),
     /* 289672 */ /*GILLT_s32*//*Label 5982*/ GIMT_Encode4(292712),
     /* 289676 */ /*GILLT_s64*//*Label 5983*/ GIMT_Encode4(295860), GIMT_Encode4(0),
     /* 289684 */ /*GILLT_v2s32*//*Label 5984*/ GIMT_Encode4(299008),
     /* 289688 */ /*GILLT_v2s64*//*Label 5985*/ GIMT_Encode4(300529),
     /* 289692 */ /*GILLT_v4s16*//*Label 5986*/ GIMT_Encode4(302050),
     /* 289696 */ /*GILLT_v4s32*//*Label 5987*/ GIMT_Encode4(303229), GIMT_Encode4(0),
     /* 289704 */ /*GILLT_v8s16*//*Label 5988*/ GIMT_Encode4(304750),
     /* 289708 */ // Label 5981: @289708
     /* 289708 */ GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(292711),
     /* 289713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 289716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 289719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 289722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289726 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(289876), // Rule ID 4853 //
     /* 289731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289755 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289780 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 289784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 289788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 289796 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289803 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 289803 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 289806 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289810 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289815 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 289821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 289834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289843 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 289849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 289862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 289870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 289874 */     GIR_RootConstrainSelectedInstOperands,
     /* 289875 */     // GIR_Coverage, 4853,
     /* 289875 */     GIR_EraseRootFromParent_Done,
     /* 289876 */   // Label 5991: @289876
     /* 289876 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(290023), // Rule ID 4817 //
     /* 289881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 289884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289905 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 289909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 289917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 289921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 289925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 289929 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289933 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 289937 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289942 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 289946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289952 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 289952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 289955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289964 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 289970 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 289975 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 289983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289992 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 289998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290021 */     GIR_RootConstrainSelectedInstOperands,
     /* 290022 */     // GIR_Coverage, 4817,
     /* 290022 */     GIR_EraseRootFromParent_Done,
     /* 290023 */   // Label 5992: @290023
     /* 290023 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(290170), // Rule ID 13784 //
     /* 290028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290055 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290064 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290080 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290089 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 290093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290099 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290111 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290139 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290168 */     GIR_RootConstrainSelectedInstOperands,
     /* 290169 */     // GIR_Coverage, 13784,
     /* 290169 */     GIR_EraseRootFromParent_Done,
     /* 290170 */   // Label 5993: @290170
     /* 290170 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(290301), // Rule ID 6050 //
     /* 290175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 290215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 290219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290223 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290227 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290236 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 290240 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290244 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290248 */     // MIs[4] Operand 1
     /* 290248 */     // No operand predicates
     /* 290248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290252 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290254 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290266 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 290296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 290299 */     GIR_RootConstrainSelectedInstOperands,
     /* 290300 */     // GIR_Coverage, 6050,
     /* 290300 */     GIR_EraseRootFromParent_Done,
     /* 290301 */   // Label 5994: @290301
     /* 290301 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(290432), // Rule ID 6082 //
     /* 290306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290338 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290342 */     // MIs[2] Operand 1
     /* 290342 */     // No operand predicates
     /* 290342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 290354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 290358 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290362 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290366 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 290370 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290375 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 290379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290383 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290385 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290397 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290430 */     GIR_RootConstrainSelectedInstOperands,
     /* 290431 */     // GIR_Coverage, 6082,
     /* 290431 */     GIR_EraseRootFromParent_Done,
     /* 290432 */   // Label 5995: @290432
     /* 290432 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(290563), // Rule ID 6146 //
     /* 290437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290473 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290481 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290485 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290489 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290493 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 290502 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290506 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290510 */     // MIs[4] Operand 1
     /* 290510 */     // No operand predicates
     /* 290510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290514 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290516 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290528 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 290558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 290561 */     GIR_RootConstrainSelectedInstOperands,
     /* 290562 */     // GIR_Coverage, 6146,
     /* 290562 */     GIR_EraseRootFromParent_Done,
     /* 290563 */   // Label 5996: @290563
     /* 290563 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(290694), // Rule ID 6114 //
     /* 290568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290612 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290616 */     // MIs[3] Operand 1
     /* 290616 */     // No operand predicates
     /* 290616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 290620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290624 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290628 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 290632 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290637 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 290641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290645 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290647 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290659 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290692 */     GIR_RootConstrainSelectedInstOperands,
     /* 290693 */     // GIR_Coverage, 6114,
     /* 290693 */     GIR_EraseRootFromParent_Done,
     /* 290694 */   // Label 5997: @290694
     /* 290694 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(290829), // Rule ID 2456 //
     /* 290699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290723 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290739 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290748 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 290758 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290758 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290761 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290765 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290770 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290781 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290798 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 290817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290827 */     GIR_RootConstrainSelectedInstOperands,
     /* 290828 */     // GIR_Coverage, 2456,
     /* 290828 */     GIR_EraseRootFromParent_Done,
     /* 290829 */   // Label 5998: @290829
     /* 290829 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(290948), // Rule ID 6018 //
     /* 290834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290858 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290883 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 290887 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290891 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290895 */     // MIs[3] Operand 1
     /* 290895 */     // No operand predicates
     /* 290895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290901 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290913 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 290932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 290943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 290946 */     GIR_RootConstrainSelectedInstOperands,
     /* 290947 */     // GIR_Coverage, 6018,
     /* 290947 */     GIR_EraseRootFromParent_Done,
     /* 290948 */   // Label 5999: @290948
     /* 290948 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(291067), // Rule ID 2538 //
     /* 290953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290985 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290989 */     // MIs[2] Operand 1
     /* 290989 */     // No operand predicates
     /* 290989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290997 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291001 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291005 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291010 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 291014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291020 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 291051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291065 */     GIR_RootConstrainSelectedInstOperands,
     /* 291066 */     // GIR_Coverage, 2538,
     /* 291066 */     GIR_EraseRootFromParent_Done,
     /* 291067 */   // Label 6000: @291067
     /* 291067 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(291167), // Rule ID 4815 //
     /* 291072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291096 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291123 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291135 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291165 */     GIR_RootConstrainSelectedInstOperands,
     /* 291166 */     // GIR_Coverage, 4815,
     /* 291166 */     GIR_EraseRootFromParent_Done,
     /* 291167 */   // Label 6001: @291167
     /* 291167 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(291267), // Rule ID 4851 //
     /* 291172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291223 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291265 */     GIR_RootConstrainSelectedInstOperands,
     /* 291266 */     // GIR_Coverage, 4851,
     /* 291266 */     GIR_EraseRootFromParent_Done,
     /* 291267 */   // Label 6002: @291267
     /* 291267 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(291364), // Rule ID 13780 //
     /* 291272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291308 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291322 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291362 */     GIR_RootConstrainSelectedInstOperands,
     /* 291363 */     // GIR_Coverage, 13780,
     /* 291363 */     GIR_EraseRootFromParent_Done,
     /* 291364 */   // Label 6003: @291364
     /* 291364 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(291464), // Rule ID 13782 //
     /* 291369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291410 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291420 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291462 */     GIR_RootConstrainSelectedInstOperands,
     /* 291463 */     // GIR_Coverage, 13782,
     /* 291463 */     GIR_EraseRootFromParent_Done,
     /* 291464 */   // Label 6004: @291464
     /* 291464 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(291564), // Rule ID 4849 //
     /* 291469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291497 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291520 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291532 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291562 */     GIR_RootConstrainSelectedInstOperands,
     /* 291563 */     // GIR_Coverage, 4849,
     /* 291563 */     GIR_EraseRootFromParent_Done,
     /* 291564 */   // Label 6005: @291564
     /* 291564 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(291661), // Rule ID 4813 //
     /* 291569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291609 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291619 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291631 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291659 */     GIR_RootConstrainSelectedInstOperands,
     /* 291660 */     // GIR_Coverage, 4813,
     /* 291660 */     GIR_EraseRootFromParent_Done,
     /* 291661 */   // Label 6006: @291661
     /* 291661 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(291745), // Rule ID 6080 //
     /* 291666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291702 */     // MIs[2] Operand 1
     /* 291702 */     // No operand predicates
     /* 291702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 291714 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291725 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 291736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291743 */     GIR_RootConstrainSelectedInstOperands,
     /* 291744 */     // GIR_Coverage, 6080,
     /* 291744 */     GIR_EraseRootFromParent_Done,
     /* 291745 */   // Label 6007: @291745
     /* 291745 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(291826), // Rule ID 6112 //
     /* 291750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291794 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291798 */     // MIs[3] Operand 1
     /* 291798 */     // No operand predicates
     /* 291798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291808 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291824 */     GIR_RootConstrainSelectedInstOperands,
     /* 291825 */     // GIR_Coverage, 6112,
     /* 291825 */     GIR_EraseRootFromParent_Done,
     /* 291826 */   // Label 6008: @291826
     /* 291826 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(291910), // Rule ID 6144 //
     /* 291831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291880 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291884 */     // MIs[3] Operand 1
     /* 291884 */     // No operand predicates
     /* 291884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291890 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 291901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291908 */     GIR_RootConstrainSelectedInstOperands,
     /* 291909 */     // GIR_Coverage, 6144,
     /* 291909 */     GIR_EraseRootFromParent_Done,
     /* 291910 */   // Label 6009: @291910
     /* 291910 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(291991), // Rule ID 6048 //
     /* 291915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291963 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291967 */     // MIs[3] Operand 1
     /* 291967 */     // No operand predicates
     /* 291967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291973 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 291982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291989 */     GIR_RootConstrainSelectedInstOperands,
     /* 291990 */     // GIR_Coverage, 6048,
     /* 291990 */     GIR_EraseRootFromParent_Done,
     /* 291991 */   // Label 6010: @291991
     /* 291991 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(292076), // Rule ID 2454 //
     /* 291996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292020 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292034 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292046 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292074 */     GIR_RootConstrainSelectedInstOperands,
     /* 292075 */     // GIR_Coverage, 2454,
     /* 292075 */     GIR_EraseRootFromParent_Done,
     /* 292076 */   // Label 6011: @292076
     /* 292076 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(292161), // Rule ID 2452 //
     /* 292081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292109 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292119 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292159 */     GIR_RootConstrainSelectedInstOperands,
     /* 292160 */     // GIR_Coverage, 2452,
     /* 292160 */     GIR_EraseRootFromParent_Done,
     /* 292161 */   // Label 6012: @292161
     /* 292161 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(292230), // Rule ID 2536 //
     /* 292166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292202 */     // MIs[2] Operand 1
     /* 292202 */     // No operand predicates
     /* 292202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292212 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292228 */     GIR_RootConstrainSelectedInstOperands,
     /* 292229 */     // GIR_Coverage, 2536,
     /* 292229 */     GIR_EraseRootFromParent_Done,
     /* 292230 */   // Label 6013: @292230
     /* 292230 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(292299), // Rule ID 6016 //
     /* 292235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292271 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292275 */     // MIs[2] Operand 1
     /* 292275 */     // No operand predicates
     /* 292275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292281 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292297 */     GIR_RootConstrainSelectedInstOperands,
     /* 292298 */     // GIR_Coverage, 6016,
     /* 292298 */     GIR_EraseRootFromParent_Done,
     /* 292299 */   // Label 6014: @292299
     /* 292299 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(292364), // Rule ID 4869 //
     /* 292304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292347 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292362 */     GIR_RootConstrainSelectedInstOperands,
     /* 292363 */     // GIR_Coverage, 4869,
     /* 292363 */     GIR_EraseRootFromParent_Done,
     /* 292364 */   // Label 6015: @292364
     /* 292364 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(292429), // Rule ID 13800 //
     /* 292369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292412 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292427 */     GIR_RootConstrainSelectedInstOperands,
     /* 292428 */     // GIR_Coverage, 13800,
     /* 292428 */     GIR_EraseRootFromParent_Done,
     /* 292429 */   // Label 6016: @292429
     /* 292429 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(292479), // Rule ID 4866 //
     /* 292434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292464 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292477 */     GIR_RootConstrainSelectedInstOperands,
     /* 292478 */     // GIR_Coverage, 4866,
     /* 292478 */     GIR_EraseRootFromParent_Done,
     /* 292479 */   // Label 6017: @292479
     /* 292479 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(292529), // Rule ID 13226 //
     /* 292484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292514 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292527 */     GIR_RootConstrainSelectedInstOperands,
     /* 292528 */     // GIR_Coverage, 13226,
     /* 292528 */     GIR_EraseRootFromParent_Done,
     /* 292529 */   // Label 6018: @292529
     /* 292529 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(292579), // Rule ID 644 //
     /* 292534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292564 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292577 */     GIR_RootConstrainSelectedInstOperands,
     /* 292578 */     // GIR_Coverage, 644,
     /* 292578 */     GIR_EraseRootFromParent_Done,
     /* 292579 */   // Label 6019: @292579
     /* 292579 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(292629), // Rule ID 13797 //
     /* 292584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292614 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292627 */     GIR_RootConstrainSelectedInstOperands,
     /* 292628 */     // GIR_Coverage, 13797,
     /* 292628 */     GIR_EraseRootFromParent_Done,
     /* 292629 */   // Label 6020: @292629
     /* 292629 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(292679), // Rule ID 656 //
     /* 292634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292664 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 292677 */     GIR_RootConstrainSelectedInstOperands,
     /* 292678 */     // GIR_Coverage, 656,
     /* 292678 */     GIR_EraseRootFromParent_Done,
     /* 292679 */   // Label 6021: @292679
     /* 292679 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(292710), // Rule ID 638 //
     /* 292684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292699 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292704 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 292708 */     GIR_RootConstrainSelectedInstOperands,
     /* 292709 */     // GIR_Coverage, 638,
     /* 292709 */     GIR_Done,
     /* 292710 */   // Label 6022: @292710
     /* 292710 */   GIM_Reject,
     /* 292711 */ // Label 5990: @292711
     /* 292711 */ GIM_Reject,
     /* 292712 */ // Label 5982: @292712
     /* 292712 */ GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(295859),
     /* 292717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 292720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 292723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 292726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292730 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(292880), // Rule ID 4859 //
     /* 292735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292759 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 292792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 292800 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292807 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 292807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 292810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292819 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 292825 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292830 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 292838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292847 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 292853 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 292866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 292874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 292878 */     GIR_RootConstrainSelectedInstOperands,
     /* 292879 */     // GIR_Coverage, 4859,
     /* 292879 */     GIR_EraseRootFromParent_Done,
     /* 292880 */   // Label 6024: @292880
     /* 292880 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(293027), // Rule ID 4823 //
     /* 292885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 292888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292909 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 292925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 292929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 292937 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 292941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292946 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 292950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292956 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 292956 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 292959 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292963 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292968 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 292974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 292979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 292987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292996 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293025 */     GIR_RootConstrainSelectedInstOperands,
     /* 293026 */     // GIR_Coverage, 4823,
     /* 293026 */     GIR_EraseRootFromParent_Done,
     /* 293027 */   // Label 6025: @293027
     /* 293027 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(293174), // Rule ID 13790 //
     /* 293032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293068 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293084 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293088 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293093 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293103 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293115 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293143 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293172 */     GIR_RootConstrainSelectedInstOperands,
     /* 293173 */     // GIR_Coverage, 13790,
     /* 293173 */     GIR_EraseRootFromParent_Done,
     /* 293174 */   // Label 6026: @293174
     /* 293174 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(293305), // Rule ID 6066 //
     /* 293179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293203 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 293223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293227 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293231 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293235 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293240 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293244 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293248 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293252 */     // MIs[4] Operand 1
     /* 293252 */     // No operand predicates
     /* 293252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293256 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293258 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293303 */     GIR_RootConstrainSelectedInstOperands,
     /* 293304 */     // GIR_Coverage, 6066,
     /* 293304 */     GIR_EraseRootFromParent_Done,
     /* 293305 */   // Label 6027: @293305
     /* 293305 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(293436), // Rule ID 6098 //
     /* 293310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293346 */     // MIs[2] Operand 1
     /* 293346 */     // No operand predicates
     /* 293346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293354 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 293358 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 293362 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293366 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293370 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293374 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293379 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293387 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293389 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293401 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293434 */     GIR_RootConstrainSelectedInstOperands,
     /* 293435 */     // GIR_Coverage, 6098,
     /* 293435 */     GIR_EraseRootFromParent_Done,
     /* 293436 */   // Label 6028: @293436
     /* 293436 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(293567), // Rule ID 6162 //
     /* 293441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293477 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293493 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293510 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293514 */     // MIs[4] Operand 1
     /* 293514 */     // No operand predicates
     /* 293514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293518 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293520 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293532 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293565 */     GIR_RootConstrainSelectedInstOperands,
     /* 293566 */     // GIR_Coverage, 6162,
     /* 293566 */     GIR_EraseRootFromParent_Done,
     /* 293567 */   // Label 6029: @293567
     /* 293567 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(293698), // Rule ID 6130 //
     /* 293572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293616 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293620 */     // MIs[3] Operand 1
     /* 293620 */     // No operand predicates
     /* 293620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 293624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293628 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293632 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293636 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293641 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293649 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293651 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293696 */     GIR_RootConstrainSelectedInstOperands,
     /* 293697 */     // GIR_Coverage, 6130,
     /* 293697 */     GIR_EraseRootFromParent_Done,
     /* 293698 */   // Label 6030: @293698
     /* 293698 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(293833), // Rule ID 2462 //
     /* 293703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293727 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 293762 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293774 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293780 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293785 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293802 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 293821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293831 */     GIR_RootConstrainSelectedInstOperands,
     /* 293832 */     // GIR_Coverage, 2462,
     /* 293832 */     GIR_EraseRootFromParent_Done,
     /* 293833 */   // Label 6031: @293833
     /* 293833 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(293952), // Rule ID 6034 //
     /* 293838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293862 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 293891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293895 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293899 */     // MIs[3] Operand 1
     /* 293899 */     // No operand predicates
     /* 293899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293905 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293917 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 293936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 293947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 293950 */     GIR_RootConstrainSelectedInstOperands,
     /* 293951 */     // GIR_Coverage, 6034,
     /* 293951 */     GIR_EraseRootFromParent_Done,
     /* 293952 */   // Label 6032: @293952
     /* 293952 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(294071), // Rule ID 2554 //
     /* 293957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293993 */     // MIs[2] Operand 1
     /* 293993 */     // No operand predicates
     /* 293993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294009 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294014 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 294018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294024 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294036 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 294055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294069 */     GIR_RootConstrainSelectedInstOperands,
     /* 294070 */     // GIR_Coverage, 2554,
     /* 294070 */     GIR_EraseRootFromParent_Done,
     /* 294071 */   // Label 6033: @294071
     /* 294071 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(294171), // Rule ID 4821 //
     /* 294076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294127 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294139 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294169 */     GIR_RootConstrainSelectedInstOperands,
     /* 294170 */     // GIR_Coverage, 4821,
     /* 294170 */     GIR_EraseRootFromParent_Done,
     /* 294171 */   // Label 6034: @294171
     /* 294171 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(294271), // Rule ID 4857 //
     /* 294176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294200 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294227 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294239 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294269 */     GIR_RootConstrainSelectedInstOperands,
     /* 294270 */     // GIR_Coverage, 4857,
     /* 294270 */     GIR_EraseRootFromParent_Done,
     /* 294271 */   // Label 6035: @294271
     /* 294271 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(294368), // Rule ID 13786 //
     /* 294276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294312 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294326 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294366 */     GIR_RootConstrainSelectedInstOperands,
     /* 294367 */     // GIR_Coverage, 13786,
     /* 294367 */     GIR_EraseRootFromParent_Done,
     /* 294368 */   // Label 6036: @294368
     /* 294368 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(294468), // Rule ID 13788 //
     /* 294373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294405 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294414 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294424 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294436 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294466 */     GIR_RootConstrainSelectedInstOperands,
     /* 294467 */     // GIR_Coverage, 13788,
     /* 294467 */     GIR_EraseRootFromParent_Done,
     /* 294468 */   // Label 6037: @294468
     /* 294468 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(294568), // Rule ID 4855 //
     /* 294473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294501 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294524 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294536 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294566 */     GIR_RootConstrainSelectedInstOperands,
     /* 294567 */     // GIR_Coverage, 4855,
     /* 294567 */     GIR_EraseRootFromParent_Done,
     /* 294568 */   // Label 6038: @294568
     /* 294568 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(294665), // Rule ID 4819 //
     /* 294573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294623 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294635 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 294658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294663 */     GIR_RootConstrainSelectedInstOperands,
     /* 294664 */     // GIR_Coverage, 4819,
     /* 294664 */     GIR_EraseRootFromParent_Done,
     /* 294665 */   // Label 6039: @294665
     /* 294665 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(294743), // Rule ID 6184 //
     /* 294670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 294707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294715 */     // MIs[3] Operand 1
     /* 294715 */     // No operand predicates
     /* 294715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294725 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294741 */     GIR_RootConstrainSelectedInstOperands,
     /* 294742 */     // GIR_Coverage, 6184,
     /* 294742 */     GIR_EraseRootFromParent_Done,
     /* 294743 */   // Label 6040: @294743
     /* 294743 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(294827), // Rule ID 6096 //
     /* 294748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294784 */     // MIs[2] Operand 1
     /* 294784 */     // No operand predicates
     /* 294784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 294796 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294805 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294807 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 294818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294825 */     GIR_RootConstrainSelectedInstOperands,
     /* 294826 */     // GIR_Coverage, 6096,
     /* 294826 */     GIR_EraseRootFromParent_Done,
     /* 294827 */   // Label 6041: @294827
     /* 294827 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(294908), // Rule ID 6128 //
     /* 294832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294880 */     // MIs[3] Operand 1
     /* 294880 */     // No operand predicates
     /* 294880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294890 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294906 */     GIR_RootConstrainSelectedInstOperands,
     /* 294907 */     // GIR_Coverage, 6128,
     /* 294907 */     GIR_EraseRootFromParent_Done,
     /* 294908 */   // Label 6042: @294908
     /* 294908 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(294992), // Rule ID 6160 //
     /* 294913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294962 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294966 */     // MIs[3] Operand 1
     /* 294966 */     // No operand predicates
     /* 294966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294972 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 294983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294990 */     GIR_RootConstrainSelectedInstOperands,
     /* 294991 */     // GIR_Coverage, 6160,
     /* 294991 */     GIR_EraseRootFromParent_Done,
     /* 294992 */   // Label 6043: @294992
     /* 294992 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(295070), // Rule ID 6206 //
     /* 294997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295042 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295046 */     // MIs[3] Operand 1
     /* 295046 */     // No operand predicates
     /* 295046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295052 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295068 */     GIR_RootConstrainSelectedInstOperands,
     /* 295069 */     // GIR_Coverage, 6206,
     /* 295069 */     GIR_EraseRootFromParent_Done,
     /* 295070 */   // Label 6044: @295070
     /* 295070 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(295151), // Rule ID 6064 //
     /* 295075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295123 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295127 */     // MIs[3] Operand 1
     /* 295127 */     // No operand predicates
     /* 295127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295133 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295149 */     GIR_RootConstrainSelectedInstOperands,
     /* 295150 */     // GIR_Coverage, 6064,
     /* 295150 */     GIR_EraseRootFromParent_Done,
     /* 295151 */   // Label 6045: @295151
     /* 295151 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(295236), // Rule ID 2460 //
     /* 295156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295180 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295194 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295206 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295234 */     GIR_RootConstrainSelectedInstOperands,
     /* 295235 */     // GIR_Coverage, 2460,
     /* 295235 */     GIR_EraseRootFromParent_Done,
     /* 295236 */   // Label 6046: @295236
     /* 295236 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(295321), // Rule ID 2458 //
     /* 295241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295269 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295279 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295319 */     GIR_RootConstrainSelectedInstOperands,
     /* 295320 */     // GIR_Coverage, 2458,
     /* 295320 */     GIR_EraseRootFromParent_Done,
     /* 295321 */   // Label 6047: @295321
     /* 295321 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(295390), // Rule ID 2552 //
     /* 295326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295358 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295362 */     // MIs[2] Operand 1
     /* 295362 */     // No operand predicates
     /* 295362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295372 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295388 */     GIR_RootConstrainSelectedInstOperands,
     /* 295389 */     // GIR_Coverage, 2552,
     /* 295389 */     GIR_EraseRootFromParent_Done,
     /* 295390 */   // Label 6048: @295390
     /* 295390 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(295459), // Rule ID 6032 //
     /* 295395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295431 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295435 */     // MIs[2] Operand 1
     /* 295435 */     // No operand predicates
     /* 295435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295441 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295457 */     GIR_RootConstrainSelectedInstOperands,
     /* 295458 */     // GIR_Coverage, 6032,
     /* 295458 */     GIR_EraseRootFromParent_Done,
     /* 295459 */   // Label 6049: @295459
     /* 295459 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(295521), // Rule ID 4870 //
     /* 295464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295504 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 295507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295519 */     GIR_RootConstrainSelectedInstOperands,
     /* 295520 */     // GIR_Coverage, 4870,
     /* 295520 */     GIR_EraseRootFromParent_Done,
     /* 295521 */   // Label 6050: @295521
     /* 295521 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(295583), // Rule ID 13801 //
     /* 295526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295555 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295559 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295566 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 295569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295581 */     GIR_RootConstrainSelectedInstOperands,
     /* 295582 */     // GIR_Coverage, 13801,
     /* 295582 */     GIR_EraseRootFromParent_Done,
     /* 295583 */   // Label 6051: @295583
     /* 295583 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(295630), // Rule ID 4867 //
     /* 295588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295615 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295628 */     GIR_RootConstrainSelectedInstOperands,
     /* 295629 */     // GIR_Coverage, 4867,
     /* 295629 */     GIR_EraseRootFromParent_Done,
     /* 295630 */   // Label 6052: @295630
     /* 295630 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(295680), // Rule ID 13228 //
     /* 295635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295665 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295678 */     GIR_RootConstrainSelectedInstOperands,
     /* 295679 */     // GIR_Coverage, 13228,
     /* 295679 */     GIR_EraseRootFromParent_Done,
     /* 295680 */   // Label 6053: @295680
     /* 295680 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(295730), // Rule ID 646 //
     /* 295685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295715 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295728 */     GIR_RootConstrainSelectedInstOperands,
     /* 295729 */     // GIR_Coverage, 646,
     /* 295729 */     GIR_EraseRootFromParent_Done,
     /* 295730 */   // Label 6054: @295730
     /* 295730 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(295777), // Rule ID 13798 //
     /* 295735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295762 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295771 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 295773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295775 */     GIR_RootConstrainSelectedInstOperands,
     /* 295776 */     // GIR_Coverage, 13798,
     /* 295776 */     GIR_EraseRootFromParent_Done,
     /* 295777 */   // Label 6055: @295777
     /* 295777 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(295827), // Rule ID 658 //
     /* 295782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295812 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 295815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 295825 */     GIR_RootConstrainSelectedInstOperands,
     /* 295826 */     // GIR_Coverage, 658,
     /* 295826 */     GIR_EraseRootFromParent_Done,
     /* 295827 */   // Label 6056: @295827
     /* 295827 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(295858), // Rule ID 640 //
     /* 295832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295847 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295852 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 295856 */     GIR_RootConstrainSelectedInstOperands,
     /* 295857 */     // GIR_Coverage, 640,
     /* 295857 */     GIR_Done,
     /* 295858 */   // Label 6057: @295858
     /* 295858 */   GIM_Reject,
     /* 295859 */ // Label 6023: @295859
     /* 295859 */ GIM_Reject,
     /* 295860 */ // Label 5983: @295860
     /* 295860 */ GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(299007),
     /* 295865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 295868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 295871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 295874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295878 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(296028), // Rule ID 4865 //
     /* 295883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 295898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295907 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 295923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295932 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 295940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 295948 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295955 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 295955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 295958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295967 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 295973 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 295986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295995 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 296014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 296026 */     GIR_RootConstrainSelectedInstOperands,
     /* 296027 */     // GIR_Coverage, 4865,
     /* 296027 */     GIR_EraseRootFromParent_Done,
     /* 296028 */   // Label 6059: @296028
     /* 296028 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(296175), // Rule ID 4829 //
     /* 296033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296057 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296081 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296085 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296089 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296094 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296104 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296104 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296107 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296111 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296116 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296144 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296173 */     GIR_RootConstrainSelectedInstOperands,
     /* 296174 */     // GIR_Coverage, 4829,
     /* 296174 */     GIR_EraseRootFromParent_Done,
     /* 296175 */   // Label 6060: @296175
     /* 296175 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(296322), // Rule ID 13796 //
     /* 296180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296216 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296232 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296236 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296241 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296251 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296263 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296269 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296274 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296320 */     GIR_RootConstrainSelectedInstOperands,
     /* 296321 */     // GIR_Coverage, 13796,
     /* 296321 */     GIR_EraseRootFromParent_Done,
     /* 296322 */   // Label 6061: @296322
     /* 296322 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(296453), // Rule ID 6070 //
     /* 296327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296351 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296375 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296379 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296383 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296388 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296392 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296396 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296400 */     // MIs[4] Operand 1
     /* 296400 */     // No operand predicates
     /* 296400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296404 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296406 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296418 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296451 */     GIR_RootConstrainSelectedInstOperands,
     /* 296452 */     // GIR_Coverage, 6070,
     /* 296452 */     GIR_EraseRootFromParent_Done,
     /* 296453 */   // Label 6062: @296453
     /* 296453 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(296584), // Rule ID 6102 //
     /* 296458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 296486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296494 */     // MIs[2] Operand 1
     /* 296494 */     // No operand predicates
     /* 296494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 296506 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 296510 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296514 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296518 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296522 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296527 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296535 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296537 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296549 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 296582 */     GIR_RootConstrainSelectedInstOperands,
     /* 296583 */     // GIR_Coverage, 6102,
     /* 296583 */     GIR_EraseRootFromParent_Done,
     /* 296584 */   // Label 6063: @296584
     /* 296584 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(296715), // Rule ID 6166 //
     /* 296589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296641 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296658 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296662 */     // MIs[4] Operand 1
     /* 296662 */     // No operand predicates
     /* 296662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296666 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296668 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296680 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296713 */     GIR_RootConstrainSelectedInstOperands,
     /* 296714 */     // GIR_Coverage, 6166,
     /* 296714 */     GIR_EraseRootFromParent_Done,
     /* 296715 */   // Label 6064: @296715
     /* 296715 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(296846), // Rule ID 6134 //
     /* 296720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 296760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296764 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296768 */     // MIs[3] Operand 1
     /* 296768 */     // No operand predicates
     /* 296768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 296772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296780 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 296784 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296789 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 296793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296797 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296799 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296811 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 296841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 296844 */     GIR_RootConstrainSelectedInstOperands,
     /* 296845 */     // GIR_Coverage, 6134,
     /* 296845 */     GIR_EraseRootFromParent_Done,
     /* 296846 */   // Label 6065: @296846
     /* 296846 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(296981), // Rule ID 2468 //
     /* 296851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296875 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296900 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296910 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296922 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296950 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 296969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296979 */     GIR_RootConstrainSelectedInstOperands,
     /* 296980 */     // GIR_Coverage, 2468,
     /* 296980 */     GIR_EraseRootFromParent_Done,
     /* 296981 */   // Label 6066: @296981
     /* 296981 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(297100), // Rule ID 6038 //
     /* 296986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297043 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297047 */     // MIs[3] Operand 1
     /* 297047 */     // No operand predicates
     /* 297047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297053 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297065 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297098 */     GIR_RootConstrainSelectedInstOperands,
     /* 297099 */     // GIR_Coverage, 6038,
     /* 297099 */     GIR_EraseRootFromParent_Done,
     /* 297100 */   // Label 6067: @297100
     /* 297100 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(297219), // Rule ID 2558 //
     /* 297105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297141 */     // MIs[2] Operand 1
     /* 297141 */     // No operand predicates
     /* 297141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297153 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297162 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297172 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297184 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297217 */     GIR_RootConstrainSelectedInstOperands,
     /* 297218 */     // GIR_Coverage, 2558,
     /* 297218 */     GIR_EraseRootFromParent_Done,
     /* 297219 */   // Label 6068: @297219
     /* 297219 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(297319), // Rule ID 4827 //
     /* 297224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297248 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297275 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297317 */     GIR_RootConstrainSelectedInstOperands,
     /* 297318 */     // GIR_Coverage, 4827,
     /* 297318 */     GIR_EraseRootFromParent_Done,
     /* 297319 */   // Label 6069: @297319
     /* 297319 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(297419), // Rule ID 4863 //
     /* 297324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297348 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297375 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297387 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 297413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297417 */     GIR_RootConstrainSelectedInstOperands,
     /* 297418 */     // GIR_Coverage, 4863,
     /* 297418 */     GIR_EraseRootFromParent_Done,
     /* 297419 */   // Label 6070: @297419
     /* 297419 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(297516), // Rule ID 13792 //
     /* 297424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297460 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297474 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297486 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297514 */     GIR_RootConstrainSelectedInstOperands,
     /* 297515 */     // GIR_Coverage, 13792,
     /* 297515 */     GIR_EraseRootFromParent_Done,
     /* 297516 */   // Label 6071: @297516
     /* 297516 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(297616), // Rule ID 13794 //
     /* 297521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297562 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297572 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297584 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297614 */     GIR_RootConstrainSelectedInstOperands,
     /* 297615 */     // GIR_Coverage, 13794,
     /* 297615 */     GIR_EraseRootFromParent_Done,
     /* 297616 */   // Label 6072: @297616
     /* 297616 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(297716), // Rule ID 4861 //
     /* 297621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297649 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297672 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297684 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297714 */     GIR_RootConstrainSelectedInstOperands,
     /* 297715 */     // GIR_Coverage, 4861,
     /* 297715 */     GIR_EraseRootFromParent_Done,
     /* 297716 */   // Label 6073: @297716
     /* 297716 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(297813), // Rule ID 4825 //
     /* 297721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297761 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297771 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297783 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 297806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297811 */     GIR_RootConstrainSelectedInstOperands,
     /* 297812 */     // GIR_Coverage, 4825,
     /* 297812 */     GIR_EraseRootFromParent_Done,
     /* 297813 */   // Label 6074: @297813
     /* 297813 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(297891), // Rule ID 6188 //
     /* 297818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 297855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 297863 */     // MIs[3] Operand 1
     /* 297863 */     // No operand predicates
     /* 297863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297873 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 297873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297889 */     GIR_RootConstrainSelectedInstOperands,
     /* 297890 */     // GIR_Coverage, 6188,
     /* 297890 */     GIR_EraseRootFromParent_Done,
     /* 297891 */   // Label 6075: @297891
     /* 297891 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(297975), // Rule ID 6100 //
     /* 297896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297928 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297932 */     // MIs[2] Operand 1
     /* 297932 */     // No operand predicates
     /* 297932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297940 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 297944 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297955 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 297966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297973 */     GIR_RootConstrainSelectedInstOperands,
     /* 297974 */     // GIR_Coverage, 6100,
     /* 297974 */     GIR_EraseRootFromParent_Done,
     /* 297975 */   // Label 6076: @297975
     /* 297975 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(298056), // Rule ID 6132 //
     /* 297980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298024 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298028 */     // MIs[3] Operand 1
     /* 298028 */     // No operand predicates
     /* 298028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298038 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298054 */     GIR_RootConstrainSelectedInstOperands,
     /* 298055 */     // GIR_Coverage, 6132,
     /* 298055 */     GIR_EraseRootFromParent_Done,
     /* 298056 */   // Label 6077: @298056
     /* 298056 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(298140), // Rule ID 6164 //
     /* 298061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298110 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298114 */     // MIs[3] Operand 1
     /* 298114 */     // No operand predicates
     /* 298114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298120 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298138 */     GIR_RootConstrainSelectedInstOperands,
     /* 298139 */     // GIR_Coverage, 6164,
     /* 298139 */     GIR_EraseRootFromParent_Done,
     /* 298140 */   // Label 6078: @298140
     /* 298140 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(298218), // Rule ID 6210 //
     /* 298145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298190 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298194 */     // MIs[3] Operand 1
     /* 298194 */     // No operand predicates
     /* 298194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298200 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298216 */     GIR_RootConstrainSelectedInstOperands,
     /* 298217 */     // GIR_Coverage, 6210,
     /* 298217 */     GIR_EraseRootFromParent_Done,
     /* 298218 */   // Label 6079: @298218
     /* 298218 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(298299), // Rule ID 6068 //
     /* 298223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298271 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298275 */     // MIs[3] Operand 1
     /* 298275 */     // No operand predicates
     /* 298275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298281 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298297 */     GIR_RootConstrainSelectedInstOperands,
     /* 298298 */     // GIR_Coverage, 6068,
     /* 298298 */     GIR_EraseRootFromParent_Done,
     /* 298299 */   // Label 6080: @298299
     /* 298299 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(298384), // Rule ID 2466 //
     /* 298304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298328 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298342 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298354 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298382 */     GIR_RootConstrainSelectedInstOperands,
     /* 298383 */     // GIR_Coverage, 2466,
     /* 298383 */     GIR_EraseRootFromParent_Done,
     /* 298384 */   // Label 6081: @298384
     /* 298384 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(298469), // Rule ID 2464 //
     /* 298389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298427 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298439 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298467 */     GIR_RootConstrainSelectedInstOperands,
     /* 298468 */     // GIR_Coverage, 2464,
     /* 298468 */     GIR_EraseRootFromParent_Done,
     /* 298469 */   // Label 6082: @298469
     /* 298469 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(298538), // Rule ID 2556 //
     /* 298474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298506 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298510 */     // MIs[2] Operand 1
     /* 298510 */     // No operand predicates
     /* 298510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298520 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298536 */     GIR_RootConstrainSelectedInstOperands,
     /* 298537 */     // GIR_Coverage, 2556,
     /* 298537 */     GIR_EraseRootFromParent_Done,
     /* 298538 */   // Label 6083: @298538
     /* 298538 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(298607), // Rule ID 6036 //
     /* 298543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298583 */     // MIs[2] Operand 1
     /* 298583 */     // No operand predicates
     /* 298583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298589 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 298592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298605 */     GIR_RootConstrainSelectedInstOperands,
     /* 298606 */     // GIR_Coverage, 6036,
     /* 298606 */     GIR_EraseRootFromParent_Done,
     /* 298607 */   // Label 6084: @298607
     /* 298607 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(298669), // Rule ID 4871 //
     /* 298612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298645 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298652 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298667 */     GIR_RootConstrainSelectedInstOperands,
     /* 298668 */     // GIR_Coverage, 4871,
     /* 298668 */     GIR_EraseRootFromParent_Done,
     /* 298669 */   // Label 6085: @298669
     /* 298669 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(298731), // Rule ID 13802 //
     /* 298674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298714 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 298717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298729 */     GIR_RootConstrainSelectedInstOperands,
     /* 298730 */     // GIR_Coverage, 13802,
     /* 298730 */     GIR_EraseRootFromParent_Done,
     /* 298731 */   // Label 6086: @298731
     /* 298731 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(298778), // Rule ID 4868 //
     /* 298736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298763 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298776 */     GIR_RootConstrainSelectedInstOperands,
     /* 298777 */     // GIR_Coverage, 4868,
     /* 298777 */     GIR_EraseRootFromParent_Done,
     /* 298778 */   // Label 6087: @298778
     /* 298778 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(298828), // Rule ID 13230 //
     /* 298783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298813 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298826 */     GIR_RootConstrainSelectedInstOperands,
     /* 298827 */     // GIR_Coverage, 13230,
     /* 298827 */     GIR_EraseRootFromParent_Done,
     /* 298828 */   // Label 6088: @298828
     /* 298828 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(298878), // Rule ID 648 //
     /* 298833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298863 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298876 */     GIR_RootConstrainSelectedInstOperands,
     /* 298877 */     // GIR_Coverage, 648,
     /* 298877 */     GIR_EraseRootFromParent_Done,
     /* 298878 */   // Label 6089: @298878
     /* 298878 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(298925), // Rule ID 13799 //
     /* 298883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298910 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 298921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298923 */     GIR_RootConstrainSelectedInstOperands,
     /* 298924 */     // GIR_Coverage, 13799,
     /* 298924 */     GIR_EraseRootFromParent_Done,
     /* 298925 */   // Label 6090: @298925
     /* 298925 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(298975), // Rule ID 660 //
     /* 298930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 298945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298960 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 298963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 298973 */     GIR_RootConstrainSelectedInstOperands,
     /* 298974 */     // GIR_Coverage, 660,
     /* 298974 */     GIR_EraseRootFromParent_Done,
     /* 298975 */   // Label 6091: @298975
     /* 298975 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(299006), // Rule ID 642 //
     /* 298980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298995 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299000 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299004 */     GIR_RootConstrainSelectedInstOperands,
     /* 299005 */     // GIR_Coverage, 642,
     /* 299005 */     GIR_Done,
     /* 299006 */   // Label 6092: @299006
     /* 299006 */   GIM_Reject,
     /* 299007 */ // Label 6058: @299007
     /* 299007 */ GIM_Reject,
     /* 299008 */ // Label 5984: @299008
     /* 299008 */ GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(300528),
     /* 299013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299026 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(299104), // Rule ID 6168 //
     /* 299031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299072 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299076 */     // MIs[3] Operand 1
     /* 299076 */     // No operand predicates
     /* 299076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299086 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299102 */     GIR_RootConstrainSelectedInstOperands,
     /* 299103 */     // GIR_Coverage, 6168,
     /* 299103 */     GIR_EraseRootFromParent_Done,
     /* 299104 */   // Label 6094: @299104
     /* 299104 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(299188), // Rule ID 6084 //
     /* 299109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299141 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299145 */     // MIs[2] Operand 1
     /* 299145 */     // No operand predicates
     /* 299145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299153 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299168 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 299179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299186 */     GIR_RootConstrainSelectedInstOperands,
     /* 299187 */     // GIR_Coverage, 6084,
     /* 299187 */     GIR_EraseRootFromParent_Done,
     /* 299188 */   // Label 6095: @299188
     /* 299188 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(299269), // Rule ID 6116 //
     /* 299193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299241 */     // MIs[3] Operand 1
     /* 299241 */     // No operand predicates
     /* 299241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299251 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299267 */     GIR_RootConstrainSelectedInstOperands,
     /* 299268 */     // GIR_Coverage, 6116,
     /* 299268 */     GIR_EraseRootFromParent_Done,
     /* 299269 */   // Label 6096: @299269
     /* 299269 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(299353), // Rule ID 6148 //
     /* 299274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299323 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299327 */     // MIs[3] Operand 1
     /* 299327 */     // No operand predicates
     /* 299327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299331 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299333 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299351 */     GIR_RootConstrainSelectedInstOperands,
     /* 299352 */     // GIR_Coverage, 6148,
     /* 299352 */     GIR_EraseRootFromParent_Done,
     /* 299353 */   // Label 6097: @299353
     /* 299353 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(299431), // Rule ID 6190 //
     /* 299358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299407 */     // MIs[3] Operand 1
     /* 299407 */     // No operand predicates
     /* 299407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299413 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299429 */     GIR_RootConstrainSelectedInstOperands,
     /* 299430 */     // GIR_Coverage, 6190,
     /* 299430 */     GIR_EraseRootFromParent_Done,
     /* 299431 */   // Label 6098: @299431
     /* 299431 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(299512), // Rule ID 6052 //
     /* 299436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299484 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299488 */     // MIs[3] Operand 1
     /* 299488 */     // No operand predicates
     /* 299488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299494 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299510 */     GIR_RootConstrainSelectedInstOperands,
     /* 299511 */     // GIR_Coverage, 6052,
     /* 299511 */     GIR_EraseRootFromParent_Done,
     /* 299512 */   // Label 6099: @299512
     /* 299512 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(299581), // Rule ID 2540 //
     /* 299517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299549 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299553 */     // MIs[2] Operand 1
     /* 299553 */     // No operand predicates
     /* 299553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299563 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 299566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299579 */     GIR_RootConstrainSelectedInstOperands,
     /* 299580 */     // GIR_Coverage, 2540,
     /* 299580 */     GIR_EraseRootFromParent_Done,
     /* 299581 */   // Label 6100: @299581
     /* 299581 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(299650), // Rule ID 6020 //
     /* 299586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299622 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299626 */     // MIs[2] Operand 1
     /* 299626 */     // No operand predicates
     /* 299626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299632 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 299635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299648 */     GIR_RootConstrainSelectedInstOperands,
     /* 299649 */     // GIR_Coverage, 6020,
     /* 299649 */     GIR_EraseRootFromParent_Done,
     /* 299650 */   // Label 6101: @299650
     /* 299650 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(299743), // Rule ID 6172 //
     /* 299655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 299679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299694 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299706 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299709 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 299716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299741 */     GIR_RootConstrainSelectedInstOperands,
     /* 299742 */     // GIR_Coverage, 6172,
     /* 299742 */     GIR_EraseRootFromParent_Done,
     /* 299743 */   // Label 6102: @299743
     /* 299743 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(299842), // Rule ID 6086 //
     /* 299748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 299759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299791 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299806 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299810 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 299813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 299834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299840 */     GIR_RootConstrainSelectedInstOperands,
     /* 299841 */     // GIR_Coverage, 6086,
     /* 299841 */     GIR_EraseRootFromParent_Done,
     /* 299842 */   // Label 6103: @299842
     /* 299842 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(299938), // Rule ID 6118 //
     /* 299847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 299870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 299874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299889 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 299904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299908 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 299911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 299936 */     GIR_RootConstrainSelectedInstOperands,
     /* 299937 */     // GIR_Coverage, 6118,
     /* 299937 */     GIR_EraseRootFromParent_Done,
     /* 299938 */   // Label 6104: @299938
     /* 299938 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(300037), // Rule ID 6150 //
     /* 299943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 299971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 299975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 299980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299986 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 299986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 299993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300005 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300035 */     GIR_RootConstrainSelectedInstOperands,
     /* 300036 */     // GIR_Coverage, 6150,
     /* 300036 */     GIR_EraseRootFromParent_Done,
     /* 300037 */   // Label 6105: @300037
     /* 300037 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(300130), // Rule ID 6194 //
     /* 300042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300081 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300093 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300100 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300128 */     GIR_RootConstrainSelectedInstOperands,
     /* 300129 */     // GIR_Coverage, 6194,
     /* 300129 */     GIR_EraseRootFromParent_Done,
     /* 300130 */   // Label 6106: @300130
     /* 300130 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(300226), // Rule ID 6054 //
     /* 300135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300177 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300196 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300224 */     GIR_RootConstrainSelectedInstOperands,
     /* 300225 */     // GIR_Coverage, 6054,
     /* 300225 */     GIR_EraseRootFromParent_Done,
     /* 300226 */   // Label 6107: @300226
     /* 300226 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(300310), // Rule ID 2542 //
     /* 300231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300261 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300273 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300276 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300280 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300288 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300308 */     GIR_RootConstrainSelectedInstOperands,
     /* 300309 */     // GIR_Coverage, 2542,
     /* 300309 */     GIR_EraseRootFromParent_Done,
     /* 300310 */   // Label 6108: @300310
     /* 300310 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(300360), // Rule ID 13260 //
     /* 300315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300345 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 300348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300358 */     GIR_RootConstrainSelectedInstOperands,
     /* 300359 */     // GIR_Coverage, 13260,
     /* 300359 */     GIR_EraseRootFromParent_Done,
     /* 300360 */   // Label 6109: @300360
     /* 300360 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(300444), // Rule ID 6022 //
     /* 300365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300395 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300407 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300442 */     GIR_RootConstrainSelectedInstOperands,
     /* 300443 */     // GIR_Coverage, 6022,
     /* 300443 */     GIR_EraseRootFromParent_Done,
     /* 300444 */   // Label 6110: @300444
     /* 300444 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(300494), // Rule ID 1308 //
     /* 300449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300479 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 300482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300492 */     GIR_RootConstrainSelectedInstOperands,
     /* 300493 */     // GIR_Coverage, 1308,
     /* 300493 */     GIR_EraseRootFromParent_Done,
     /* 300494 */   // Label 6111: @300494
     /* 300494 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(300527), // Rule ID 1298 //
     /* 300499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300514 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 300517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 300525 */     GIR_RootConstrainSelectedInstOperands,
     /* 300526 */     // GIR_Coverage, 1298,
     /* 300526 */     GIR_EraseRootFromParent_Done,
     /* 300527 */   // Label 6112: @300527
     /* 300527 */   GIM_Reject,
     /* 300528 */ // Label 6093: @300528
     /* 300528 */ GIM_Reject,
     /* 300529 */ // Label 5985: @300529
     /* 300529 */ GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(302049),
     /* 300534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 300543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300547 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(300625), // Rule ID 6180 //
     /* 300552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300593 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300597 */     // MIs[3] Operand 1
     /* 300597 */     // No operand predicates
     /* 300597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300607 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300623 */     GIR_RootConstrainSelectedInstOperands,
     /* 300624 */     // GIR_Coverage, 6180,
     /* 300624 */     GIR_EraseRootFromParent_Done,
     /* 300625 */   // Label 6114: @300625
     /* 300625 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(300709), // Rule ID 6092 //
     /* 300630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300662 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300666 */     // MIs[2] Operand 1
     /* 300666 */     // No operand predicates
     /* 300666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 300670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300689 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 300700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300707 */     GIR_RootConstrainSelectedInstOperands,
     /* 300708 */     // GIR_Coverage, 6092,
     /* 300708 */     GIR_EraseRootFromParent_Done,
     /* 300709 */   // Label 6115: @300709
     /* 300709 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(300790), // Rule ID 6124 //
     /* 300714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300741 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300758 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300762 */     // MIs[3] Operand 1
     /* 300762 */     // No operand predicates
     /* 300762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300770 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300772 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300788 */     GIR_RootConstrainSelectedInstOperands,
     /* 300789 */     // GIR_Coverage, 6124,
     /* 300789 */     GIR_EraseRootFromParent_Done,
     /* 300790 */   // Label 6116: @300790
     /* 300790 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(300874), // Rule ID 6156 //
     /* 300795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300844 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300848 */     // MIs[3] Operand 1
     /* 300848 */     // No operand predicates
     /* 300848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300854 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300872 */     GIR_RootConstrainSelectedInstOperands,
     /* 300873 */     // GIR_Coverage, 6156,
     /* 300873 */     GIR_EraseRootFromParent_Done,
     /* 300874 */   // Label 6117: @300874
     /* 300874 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(300952), // Rule ID 6202 //
     /* 300879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 300920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300924 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 300928 */     // MIs[3] Operand 1
     /* 300928 */     // No operand predicates
     /* 300928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300934 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 300937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300950 */     GIR_RootConstrainSelectedInstOperands,
     /* 300951 */     // GIR_Coverage, 6202,
     /* 300951 */     GIR_EraseRootFromParent_Done,
     /* 300952 */   // Label 6118: @300952
     /* 300952 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(301033), // Rule ID 6060 //
     /* 300957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 300984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301005 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301009 */     // MIs[3] Operand 1
     /* 301009 */     // No operand predicates
     /* 301009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301015 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301031 */     GIR_RootConstrainSelectedInstOperands,
     /* 301032 */     // GIR_Coverage, 6060,
     /* 301032 */     GIR_EraseRootFromParent_Done,
     /* 301033 */   // Label 6119: @301033
     /* 301033 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(301102), // Rule ID 2548 //
     /* 301038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301070 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301074 */     // MIs[2] Operand 1
     /* 301074 */     // No operand predicates
     /* 301074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301084 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301100 */     GIR_RootConstrainSelectedInstOperands,
     /* 301101 */     // GIR_Coverage, 2548,
     /* 301101 */     GIR_EraseRootFromParent_Done,
     /* 301102 */   // Label 6120: @301102
     /* 301102 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(301171), // Rule ID 6028 //
     /* 301107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301143 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301147 */     // MIs[2] Operand 1
     /* 301147 */     // No operand predicates
     /* 301147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301153 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301169 */     GIR_RootConstrainSelectedInstOperands,
     /* 301170 */     // GIR_Coverage, 6028,
     /* 301170 */     GIR_EraseRootFromParent_Done,
     /* 301171 */   // Label 6121: @301171
     /* 301171 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(301264), // Rule ID 6182 //
     /* 301176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301215 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301227 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301234 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301262 */     GIR_RootConstrainSelectedInstOperands,
     /* 301263 */     // GIR_Coverage, 6182,
     /* 301263 */     GIR_EraseRootFromParent_Done,
     /* 301264 */   // Label 6122: @301264
     /* 301264 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(301363), // Rule ID 6094 //
     /* 301269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301312 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301327 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301331 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 301355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301361 */     GIR_RootConstrainSelectedInstOperands,
     /* 301362 */     // GIR_Coverage, 6094,
     /* 301362 */     GIR_EraseRootFromParent_Done,
     /* 301363 */   // Label 6123: @301363
     /* 301363 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(301459), // Rule ID 6126 //
     /* 301368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301410 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301422 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301432 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301457 */     GIR_RootConstrainSelectedInstOperands,
     /* 301458 */     // GIR_Coverage, 6126,
     /* 301458 */     GIR_EraseRootFromParent_Done,
     /* 301459 */   // Label 6124: @301459
     /* 301459 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(301558), // Rule ID 6158 //
     /* 301464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301507 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301556 */     GIR_RootConstrainSelectedInstOperands,
     /* 301557 */     // GIR_Coverage, 6158,
     /* 301557 */     GIR_EraseRootFromParent_Done,
     /* 301558 */   // Label 6125: @301558
     /* 301558 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(301651), // Rule ID 6204 //
     /* 301563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301602 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301614 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301649 */     GIR_RootConstrainSelectedInstOperands,
     /* 301650 */     // GIR_Coverage, 6204,
     /* 301650 */     GIR_EraseRootFromParent_Done,
     /* 301651 */   // Label 6126: @301651
     /* 301651 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(301747), // Rule ID 6062 //
     /* 301656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301698 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301745 */     GIR_RootConstrainSelectedInstOperands,
     /* 301746 */     // GIR_Coverage, 6062,
     /* 301746 */     GIR_EraseRootFromParent_Done,
     /* 301747 */   // Label 6127: @301747
     /* 301747 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(301831), // Rule ID 2550 //
     /* 301752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301782 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301829 */     GIR_RootConstrainSelectedInstOperands,
     /* 301830 */     // GIR_Coverage, 2550,
     /* 301830 */     GIR_EraseRootFromParent_Done,
     /* 301831 */   // Label 6128: @301831
     /* 301831 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(301881), // Rule ID 13264 //
     /* 301836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301866 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 301866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 301869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301879 */     GIR_RootConstrainSelectedInstOperands,
     /* 301880 */     // GIR_Coverage, 13264,
     /* 301880 */     GIR_EraseRootFromParent_Done,
     /* 301881 */   // Label 6129: @301881
     /* 301881 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(301965), // Rule ID 6030 //
     /* 301886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301916 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301928 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301963 */     GIR_RootConstrainSelectedInstOperands,
     /* 301964 */     // GIR_Coverage, 6030,
     /* 301964 */     GIR_EraseRootFromParent_Done,
     /* 301965 */   // Label 6130: @301965
     /* 301965 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(302015), // Rule ID 1312 //
     /* 301970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302000 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 302003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302013 */     GIR_RootConstrainSelectedInstOperands,
     /* 302014 */     // GIR_Coverage, 1312,
     /* 302014 */     GIR_EraseRootFromParent_Done,
     /* 302015 */   // Label 6131: @302015
     /* 302015 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(302048), // Rule ID 1302 //
     /* 302020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302035 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 302038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 302046 */     GIR_RootConstrainSelectedInstOperands,
     /* 302047 */     // GIR_Coverage, 1302,
     /* 302047 */     GIR_EraseRootFromParent_Done,
     /* 302048 */   // Label 6132: @302048
     /* 302048 */   GIM_Reject,
     /* 302049 */ // Label 6113: @302049
     /* 302049 */ GIM_Reject,
     /* 302050 */ // Label 5986: @302050
     /* 302050 */ GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(303228),
     /* 302055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302068 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(302152), // Rule ID 6076 //
     /* 302073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302105 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302109 */     // MIs[2] Operand 1
     /* 302109 */     // No operand predicates
     /* 302109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 302113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302117 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302132 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 302143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302150 */     GIR_RootConstrainSelectedInstOperands,
     /* 302151 */     // GIR_Coverage, 6076,
     /* 302151 */     GIR_EraseRootFromParent_Done,
     /* 302152 */   // Label 6134: @302152
     /* 302152 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(302233), // Rule ID 6108 //
     /* 302157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302201 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302205 */     // MIs[3] Operand 1
     /* 302205 */     // No operand predicates
     /* 302205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302215 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302231 */     GIR_RootConstrainSelectedInstOperands,
     /* 302232 */     // GIR_Coverage, 6108,
     /* 302232 */     GIR_EraseRootFromParent_Done,
     /* 302233 */   // Label 6135: @302233
     /* 302233 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(302317), // Rule ID 6140 //
     /* 302238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302287 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302291 */     // MIs[3] Operand 1
     /* 302291 */     // No operand predicates
     /* 302291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302297 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302315 */     GIR_RootConstrainSelectedInstOperands,
     /* 302316 */     // GIR_Coverage, 6140,
     /* 302316 */     GIR_EraseRootFromParent_Done,
     /* 302317 */   // Label 6136: @302317
     /* 302317 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(302398), // Rule ID 6044 //
     /* 302322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302374 */     // MIs[3] Operand 1
     /* 302374 */     // No operand predicates
     /* 302374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302380 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302396 */     GIR_RootConstrainSelectedInstOperands,
     /* 302397 */     // GIR_Coverage, 6044,
     /* 302397 */     GIR_EraseRootFromParent_Done,
     /* 302398 */   // Label 6137: @302398
     /* 302398 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(302467), // Rule ID 2532 //
     /* 302403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302435 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302439 */     // MIs[2] Operand 1
     /* 302439 */     // No operand predicates
     /* 302439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302449 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302465 */     GIR_RootConstrainSelectedInstOperands,
     /* 302466 */     // GIR_Coverage, 2532,
     /* 302466 */     GIR_EraseRootFromParent_Done,
     /* 302467 */   // Label 6138: @302467
     /* 302467 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(302536), // Rule ID 6012 //
     /* 302472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302508 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302512 */     // MIs[2] Operand 1
     /* 302512 */     // No operand predicates
     /* 302512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302518 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302534 */     GIR_RootConstrainSelectedInstOperands,
     /* 302535 */     // GIR_Coverage, 6012,
     /* 302535 */     GIR_EraseRootFromParent_Done,
     /* 302536 */   // Label 6139: @302536
     /* 302536 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(302635), // Rule ID 6078 //
     /* 302541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302584 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302599 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302603 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 302627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302633 */     GIR_RootConstrainSelectedInstOperands,
     /* 302634 */     // GIR_Coverage, 6078,
     /* 302634 */     GIR_EraseRootFromParent_Done,
     /* 302635 */   // Label 6140: @302635
     /* 302635 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(302731), // Rule ID 6110 //
     /* 302640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 302667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302682 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302701 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302729 */     GIR_RootConstrainSelectedInstOperands,
     /* 302730 */     // GIR_Coverage, 6110,
     /* 302730 */     GIR_EraseRootFromParent_Done,
     /* 302731 */   // Label 6141: @302731
     /* 302731 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(302830), // Rule ID 6142 //
     /* 302736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 302768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302779 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302828 */     GIR_RootConstrainSelectedInstOperands,
     /* 302829 */     // GIR_Coverage, 6142,
     /* 302829 */     GIR_EraseRootFromParent_Done,
     /* 302830 */   // Label 6142: @302830
     /* 302830 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(302926), // Rule ID 6046 //
     /* 302835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 302866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302877 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302896 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302916 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302924 */     GIR_RootConstrainSelectedInstOperands,
     /* 302925 */     // GIR_Coverage, 6046,
     /* 302925 */     GIR_EraseRootFromParent_Done,
     /* 302926 */   // Label 6143: @302926
     /* 302926 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(303010), // Rule ID 2534 //
     /* 302931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 302946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302961 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 302964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302973 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302980 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 302983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 302993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303008 */     GIR_RootConstrainSelectedInstOperands,
     /* 303009 */     // GIR_Coverage, 2534,
     /* 303009 */     GIR_EraseRootFromParent_Done,
     /* 303010 */   // Label 6144: @303010
     /* 303010 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(303060), // Rule ID 13256 //
     /* 303015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303045 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303058 */     GIR_RootConstrainSelectedInstOperands,
     /* 303059 */     // GIR_Coverage, 13256,
     /* 303059 */     GIR_EraseRootFromParent_Done,
     /* 303060 */   // Label 6145: @303060
     /* 303060 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(303144), // Rule ID 6014 //
     /* 303065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303095 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303142 */     GIR_RootConstrainSelectedInstOperands,
     /* 303143 */     // GIR_Coverage, 6014,
     /* 303143 */     GIR_EraseRootFromParent_Done,
     /* 303144 */   // Label 6146: @303144
     /* 303144 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(303194), // Rule ID 1304 //
     /* 303149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303179 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303192 */     GIR_RootConstrainSelectedInstOperands,
     /* 303193 */     // GIR_Coverage, 1304,
     /* 303193 */     GIR_EraseRootFromParent_Done,
     /* 303194 */   // Label 6147: @303194
     /* 303194 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303227), // Rule ID 1294 //
     /* 303199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303214 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 303217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 303225 */     GIR_RootConstrainSelectedInstOperands,
     /* 303226 */     // GIR_Coverage, 1294,
     /* 303226 */     GIR_EraseRootFromParent_Done,
     /* 303227 */   // Label 6148: @303227
     /* 303227 */   GIM_Reject,
     /* 303228 */ // Label 6133: @303228
     /* 303228 */ GIM_Reject,
     /* 303229 */ // Label 5987: @303229
     /* 303229 */ GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(304749),
     /* 303234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 303243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303247 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(303325), // Rule ID 6174 //
     /* 303252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303293 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303297 */     // MIs[3] Operand 1
     /* 303297 */     // No operand predicates
     /* 303297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303307 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303323 */     GIR_RootConstrainSelectedInstOperands,
     /* 303324 */     // GIR_Coverage, 6174,
     /* 303324 */     GIR_EraseRootFromParent_Done,
     /* 303325 */   // Label 6150: @303325
     /* 303325 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(303409), // Rule ID 6088 //
     /* 303330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303366 */     // MIs[2] Operand 1
     /* 303366 */     // No operand predicates
     /* 303366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 303370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303378 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303389 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 303400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303407 */     GIR_RootConstrainSelectedInstOperands,
     /* 303408 */     // GIR_Coverage, 6088,
     /* 303408 */     GIR_EraseRootFromParent_Done,
     /* 303409 */   // Label 6151: @303409
     /* 303409 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(303490), // Rule ID 6120 //
     /* 303414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303454 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303458 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303462 */     // MIs[3] Operand 1
     /* 303462 */     // No operand predicates
     /* 303462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303472 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303488 */     GIR_RootConstrainSelectedInstOperands,
     /* 303489 */     // GIR_Coverage, 6120,
     /* 303489 */     GIR_EraseRootFromParent_Done,
     /* 303490 */   // Label 6152: @303490
     /* 303490 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(303574), // Rule ID 6152 //
     /* 303495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303544 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303548 */     // MIs[3] Operand 1
     /* 303548 */     // No operand predicates
     /* 303548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303554 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303572 */     GIR_RootConstrainSelectedInstOperands,
     /* 303573 */     // GIR_Coverage, 6152,
     /* 303573 */     GIR_EraseRootFromParent_Done,
     /* 303574 */   // Label 6153: @303574
     /* 303574 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(303652), // Rule ID 6196 //
     /* 303579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303624 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303628 */     // MIs[3] Operand 1
     /* 303628 */     // No operand predicates
     /* 303628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303634 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303650 */     GIR_RootConstrainSelectedInstOperands,
     /* 303651 */     // GIR_Coverage, 6196,
     /* 303651 */     GIR_EraseRootFromParent_Done,
     /* 303652 */   // Label 6154: @303652
     /* 303652 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(303733), // Rule ID 6056 //
     /* 303657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303688 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303705 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303709 */     // MIs[3] Operand 1
     /* 303709 */     // No operand predicates
     /* 303709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303715 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303731 */     GIR_RootConstrainSelectedInstOperands,
     /* 303732 */     // GIR_Coverage, 6056,
     /* 303732 */     GIR_EraseRootFromParent_Done,
     /* 303733 */   // Label 6155: @303733
     /* 303733 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(303802), // Rule ID 2544 //
     /* 303738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303770 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303774 */     // MIs[2] Operand 1
     /* 303774 */     // No operand predicates
     /* 303774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303784 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 303787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303800 */     GIR_RootConstrainSelectedInstOperands,
     /* 303801 */     // GIR_Coverage, 2544,
     /* 303801 */     GIR_EraseRootFromParent_Done,
     /* 303802 */   // Label 6156: @303802
     /* 303802 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(303871), // Rule ID 6024 //
     /* 303807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303843 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303847 */     // MIs[2] Operand 1
     /* 303847 */     // No operand predicates
     /* 303847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303853 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 303856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303869 */     GIR_RootConstrainSelectedInstOperands,
     /* 303870 */     // GIR_Coverage, 6024,
     /* 303870 */     GIR_EraseRootFromParent_Done,
     /* 303871 */   // Label 6157: @303871
     /* 303871 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(303964), // Rule ID 6178 //
     /* 303876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 303900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303915 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303930 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 303937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303962 */     GIR_RootConstrainSelectedInstOperands,
     /* 303963 */     // GIR_Coverage, 6178,
     /* 303963 */     GIR_EraseRootFromParent_Done,
     /* 303964 */   // Label 6158: @303964
     /* 303964 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(304063), // Rule ID 6090 //
     /* 303969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 303984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304001 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304012 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304024 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304027 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304031 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 304055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304061 */     GIR_RootConstrainSelectedInstOperands,
     /* 304062 */     // GIR_Coverage, 6090,
     /* 304062 */     GIR_EraseRootFromParent_Done,
     /* 304063 */   // Label 6159: @304063
     /* 304063 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(304159), // Rule ID 6122 //
     /* 304068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304110 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304122 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304129 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304157 */     GIR_RootConstrainSelectedInstOperands,
     /* 304158 */     // GIR_Coverage, 6122,
     /* 304158 */     GIR_EraseRootFromParent_Done,
     /* 304159 */   // Label 6160: @304159
     /* 304159 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(304258), // Rule ID 6154 //
     /* 304164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304207 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304226 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304256 */     GIR_RootConstrainSelectedInstOperands,
     /* 304257 */     // GIR_Coverage, 6154,
     /* 304257 */     GIR_EraseRootFromParent_Done,
     /* 304258 */   // Label 6161: @304258
     /* 304258 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(304351), // Rule ID 6200 //
     /* 304263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304302 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304321 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304349 */     GIR_RootConstrainSelectedInstOperands,
     /* 304350 */     // GIR_Coverage, 6200,
     /* 304350 */     GIR_EraseRootFromParent_Done,
     /* 304351 */   // Label 6162: @304351
     /* 304351 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(304447), // Rule ID 6058 //
     /* 304356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304398 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304445 */     GIR_RootConstrainSelectedInstOperands,
     /* 304446 */     // GIR_Coverage, 6058,
     /* 304446 */     GIR_EraseRootFromParent_Done,
     /* 304447 */   // Label 6163: @304447
     /* 304447 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(304531), // Rule ID 2546 //
     /* 304452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304482 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304494 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304529 */     GIR_RootConstrainSelectedInstOperands,
     /* 304530 */     // GIR_Coverage, 2546,
     /* 304530 */     GIR_EraseRootFromParent_Done,
     /* 304531 */   // Label 6164: @304531
     /* 304531 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(304581), // Rule ID 13262 //
     /* 304536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304566 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 304569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304579 */     GIR_RootConstrainSelectedInstOperands,
     /* 304580 */     // GIR_Coverage, 13262,
     /* 304580 */     GIR_EraseRootFromParent_Done,
     /* 304581 */   // Label 6165: @304581
     /* 304581 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(304665), // Rule ID 6026 //
     /* 304586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304616 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304628 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304663 */     GIR_RootConstrainSelectedInstOperands,
     /* 304664 */     // GIR_Coverage, 6026,
     /* 304664 */     GIR_EraseRootFromParent_Done,
     /* 304665 */   // Label 6166: @304665
     /* 304665 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(304715), // Rule ID 1310 //
     /* 304670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 304700 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 304703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304713 */     GIR_RootConstrainSelectedInstOperands,
     /* 304714 */     // GIR_Coverage, 1310,
     /* 304714 */     GIR_EraseRootFromParent_Done,
     /* 304715 */   // Label 6167: @304715
     /* 304715 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(304748), // Rule ID 1300 //
     /* 304720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304735 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 304738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 304746 */     GIR_RootConstrainSelectedInstOperands,
     /* 304747 */     // GIR_Coverage, 1300,
     /* 304747 */     GIR_EraseRootFromParent_Done,
     /* 304748 */   // Label 6168: @304748
     /* 304748 */   GIM_Reject,
     /* 304749 */ // Label 6149: @304749
     /* 304749 */ GIM_Reject,
     /* 304750 */ // Label 5988: @304750
     /* 304750 */ GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(305928),
     /* 304755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 304764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304768 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(304852), // Rule ID 6072 //
     /* 304773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304809 */     // MIs[2] Operand 1
     /* 304809 */     // No operand predicates
     /* 304809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 304813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304821 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304832 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 304835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 304843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304850 */     GIR_RootConstrainSelectedInstOperands,
     /* 304851 */     // GIR_Coverage, 6072,
     /* 304851 */     GIR_EraseRootFromParent_Done,
     /* 304852 */   // Label 6170: @304852
     /* 304852 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(304933), // Rule ID 6104 //
     /* 304857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304901 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304905 */     // MIs[3] Operand 1
     /* 304905 */     // No operand predicates
     /* 304905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304915 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 304918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304931 */     GIR_RootConstrainSelectedInstOperands,
     /* 304932 */     // GIR_Coverage, 6104,
     /* 304932 */     GIR_EraseRootFromParent_Done,
     /* 304933 */   // Label 6171: @304933
     /* 304933 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(305017), // Rule ID 6136 //
     /* 304938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 304966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304974 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 304979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304987 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304991 */     // MIs[3] Operand 1
     /* 304991 */     // No operand predicates
     /* 304991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304997 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305015 */     GIR_RootConstrainSelectedInstOperands,
     /* 305016 */     // GIR_Coverage, 6136,
     /* 305016 */     GIR_EraseRootFromParent_Done,
     /* 305017 */   // Label 6172: @305017
     /* 305017 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(305098), // Rule ID 6040 //
     /* 305022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305074 */     // MIs[3] Operand 1
     /* 305074 */     // No operand predicates
     /* 305074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305080 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305096 */     GIR_RootConstrainSelectedInstOperands,
     /* 305097 */     // GIR_Coverage, 6040,
     /* 305097 */     GIR_EraseRootFromParent_Done,
     /* 305098 */   // Label 6173: @305098
     /* 305098 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(305167), // Rule ID 2528 //
     /* 305103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305139 */     // MIs[2] Operand 1
     /* 305139 */     // No operand predicates
     /* 305139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305149 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305165 */     GIR_RootConstrainSelectedInstOperands,
     /* 305166 */     // GIR_Coverage, 2528,
     /* 305166 */     GIR_EraseRootFromParent_Done,
     /* 305167 */   // Label 6174: @305167
     /* 305167 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(305236), // Rule ID 6008 //
     /* 305172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305212 */     // MIs[2] Operand 1
     /* 305212 */     // No operand predicates
     /* 305212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305218 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305234 */     GIR_RootConstrainSelectedInstOperands,
     /* 305235 */     // GIR_Coverage, 6008,
     /* 305235 */     GIR_EraseRootFromParent_Done,
     /* 305236 */   // Label 6175: @305236
     /* 305236 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(305335), // Rule ID 6074 //
     /* 305241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305284 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 305327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305333 */     GIR_RootConstrainSelectedInstOperands,
     /* 305334 */     // GIR_Coverage, 6074,
     /* 305334 */     GIR_EraseRootFromParent_Done,
     /* 305335 */   // Label 6176: @305335
     /* 305335 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(305431), // Rule ID 6106 //
     /* 305340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305382 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305394 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305397 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305401 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305429 */     GIR_RootConstrainSelectedInstOperands,
     /* 305430 */     // GIR_Coverage, 6106,
     /* 305430 */     GIR_EraseRootFromParent_Done,
     /* 305431 */   // Label 6177: @305431
     /* 305431 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(305530), // Rule ID 6138 //
     /* 305436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305479 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305491 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305528 */     GIR_RootConstrainSelectedInstOperands,
     /* 305529 */     // GIR_Coverage, 6138,
     /* 305529 */     GIR_EraseRootFromParent_Done,
     /* 305530 */   // Label 6178: @305530
     /* 305530 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(305626), // Rule ID 6042 //
     /* 305535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305577 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305624 */     GIR_RootConstrainSelectedInstOperands,
     /* 305625 */     // GIR_Coverage, 6042,
     /* 305625 */     GIR_EraseRootFromParent_Done,
     /* 305626 */   // Label 6179: @305626
     /* 305626 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(305710), // Rule ID 2530 //
     /* 305631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305661 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305673 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305688 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305708 */     GIR_RootConstrainSelectedInstOperands,
     /* 305709 */     // GIR_Coverage, 2530,
     /* 305709 */     GIR_EraseRootFromParent_Done,
     /* 305710 */   // Label 6180: @305710
     /* 305710 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(305760), // Rule ID 13258 //
     /* 305715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305745 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 305748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305758 */     GIR_RootConstrainSelectedInstOperands,
     /* 305759 */     // GIR_Coverage, 13258,
     /* 305759 */     GIR_EraseRootFromParent_Done,
     /* 305760 */   // Label 6181: @305760
     /* 305760 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(305844), // Rule ID 6010 //
     /* 305765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305795 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305807 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305842 */     GIR_RootConstrainSelectedInstOperands,
     /* 305843 */     // GIR_Coverage, 6010,
     /* 305843 */     GIR_EraseRootFromParent_Done,
     /* 305844 */   // Label 6182: @305844
     /* 305844 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(305894), // Rule ID 1306 //
     /* 305849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305879 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 305882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305892 */     GIR_RootConstrainSelectedInstOperands,
     /* 305893 */     // GIR_Coverage, 1306,
     /* 305893 */     GIR_EraseRootFromParent_Done,
     /* 305894 */   // Label 6183: @305894
     /* 305894 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(305927), // Rule ID 1296 //
     /* 305899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305914 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 305917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 305925 */     GIR_RootConstrainSelectedInstOperands,
     /* 305926 */     // GIR_Coverage, 1296,
     /* 305926 */     GIR_EraseRootFromParent_Done,
     /* 305927 */   // Label 6184: @305927
     /* 305927 */   GIM_Reject,
     /* 305928 */ // Label 6169: @305928
     /* 305928 */ GIM_Reject,
     /* 305929 */ // Label 5989: @305929
     /* 305929 */ GIM_Reject,
     /* 305930 */ // Label 61: @305930
     /* 305930 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6193*/ GIMT_Encode4(306545),
     /* 305941 */ /*GILLT_s16*//*Label 6185*/ GIMT_Encode4(305981),
     /* 305945 */ /*GILLT_s32*//*Label 6186*/ GIMT_Encode4(306019),
     /* 305949 */ /*GILLT_s64*//*Label 6187*/ GIMT_Encode4(306057), GIMT_Encode4(0),
     /* 305957 */ /*GILLT_v2s32*//*Label 6188*/ GIMT_Encode4(306095),
     /* 305961 */ /*GILLT_v2s64*//*Label 6189*/ GIMT_Encode4(306133),
     /* 305965 */ /*GILLT_v4s16*//*Label 6190*/ GIMT_Encode4(306171),
     /* 305969 */ /*GILLT_v4s32*//*Label 6191*/ GIMT_Encode4(306209), GIMT_Encode4(0),
     /* 305977 */ /*GILLT_v8s16*//*Label 6192*/ GIMT_Encode4(306247),
     /* 305981 */ // Label 6185: @305981
     /* 305981 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(306018), // Rule ID 590 //
     /* 305986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 305995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306007 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 306012 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306016 */   GIR_RootConstrainSelectedInstOperands,
     /* 306017 */   // GIR_Coverage, 590,
     /* 306017 */   GIR_Done,
     /* 306018 */ // Label 6194: @306018
     /* 306018 */ GIM_Reject,
     /* 306019 */ // Label 6186: @306019
     /* 306019 */ GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(306056), // Rule ID 592 //
     /* 306024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306045 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306045 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 306050 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306054 */   GIR_RootConstrainSelectedInstOperands,
     /* 306055 */   // GIR_Coverage, 592,
     /* 306055 */   GIR_Done,
     /* 306056 */ // Label 6195: @306056
     /* 306056 */ GIM_Reject,
     /* 306057 */ // Label 6187: @306057
     /* 306057 */ GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(306094), // Rule ID 594 //
     /* 306062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306083 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 306083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 306088 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306092 */   GIR_RootConstrainSelectedInstOperands,
     /* 306093 */   // GIR_Coverage, 594,
     /* 306093 */   GIR_Done,
     /* 306094 */ // Label 6196: @306094
     /* 306094 */ GIM_Reject,
     /* 306095 */ // Label 6188: @306095
     /* 306095 */ GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(306132), // Rule ID 1228 //
     /* 306100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 306109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306121 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 306121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 306126 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306130 */   GIR_RootConstrainSelectedInstOperands,
     /* 306131 */   // GIR_Coverage, 1228,
     /* 306131 */   GIR_Done,
     /* 306132 */ // Label 6197: @306132
     /* 306132 */ GIM_Reject,
     /* 306133 */ // Label 6189: @306133
     /* 306133 */ GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(306170), // Rule ID 1232 //
     /* 306138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 306147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306159 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 306159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 306164 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306168 */   GIR_RootConstrainSelectedInstOperands,
     /* 306169 */   // GIR_Coverage, 1232,
     /* 306169 */   GIR_Done,
     /* 306170 */ // Label 6198: @306170
     /* 306170 */ GIM_Reject,
     /* 306171 */ // Label 6190: @306171
     /* 306171 */ GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(306208), // Rule ID 1224 //
     /* 306176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 306185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306197 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 306197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 306202 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306206 */   GIR_RootConstrainSelectedInstOperands,
     /* 306207 */   // GIR_Coverage, 1224,
     /* 306207 */   GIR_Done,
     /* 306208 */ // Label 6199: @306208
     /* 306208 */ GIM_Reject,
     /* 306209 */ // Label 6191: @306209
     /* 306209 */ GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(306246), // Rule ID 1230 //
     /* 306214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 306223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306235 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 306235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306240 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306244 */   GIR_RootConstrainSelectedInstOperands,
     /* 306245 */   // GIR_Coverage, 1230,
     /* 306245 */   GIR_Done,
     /* 306246 */ // Label 6200: @306246
     /* 306246 */ GIM_Reject,
     /* 306247 */ // Label 6192: @306247
     /* 306247 */ GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(306544),
     /* 306252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 306258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306270 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(306289), // Rule ID 1226 //
     /* 306275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306278 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 306283 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306287 */     GIR_RootConstrainSelectedInstOperands,
     /* 306288 */     // GIR_Coverage, 1226,
     /* 306288 */     GIR_Done,
     /* 306289 */   // Label 6202: @306289
     /* 306289 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(306543), // Rule ID 6973 //
     /* 306294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 306297 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 306297 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 306300 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306304 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306309 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 306313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 306315 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 306318 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306322 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306327 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 306331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 306333 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 306336 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306340 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306345 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 306348 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 306351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 306353 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 306356 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306360 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306365 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306371 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306376 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306381 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 306384 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306388 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306393 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 306396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 306398 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 306401 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306405 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306410 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306416 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306421 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306426 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 306429 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306433 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306438 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 306441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 306443 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 306446 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306450 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306455 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 306458 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 306461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306463 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 306466 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 306470 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306475 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 306478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 306480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 306483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 306487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 306494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 306497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 306501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 306509 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 306512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 306515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 306533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 306541 */     GIR_RootConstrainSelectedInstOperands,
     /* 306542 */     // GIR_Coverage, 6973,
     /* 306542 */     GIR_EraseRootFromParent_Done,
     /* 306543 */   // Label 6203: @306543
     /* 306543 */   GIM_Reject,
     /* 306544 */ // Label 6201: @306544
     /* 306544 */ GIM_Reject,
     /* 306545 */ // Label 6193: @306545
     /* 306545 */ GIM_Reject,
     /* 306546 */ // Label 62: @306546
     /* 306546 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6212*/ GIMT_Encode4(310052),
     /* 306557 */ /*GILLT_s16*//*Label 6204*/ GIMT_Encode4(306597),
     /* 306561 */ /*GILLT_s32*//*Label 6205*/ GIMT_Encode4(307765),
     /* 306565 */ /*GILLT_s64*//*Label 6206*/ GIMT_Encode4(308788), GIMT_Encode4(0),
     /* 306573 */ /*GILLT_v2s32*//*Label 6207*/ GIMT_Encode4(309811),
     /* 306577 */ /*GILLT_v2s64*//*Label 6208*/ GIMT_Encode4(309838),
     /* 306581 */ /*GILLT_v4s16*//*Label 6209*/ GIMT_Encode4(309865),
     /* 306585 */ /*GILLT_v4s32*//*Label 6210*/ GIMT_Encode4(309945), GIMT_Encode4(0),
     /* 306593 */ /*GILLT_v8s16*//*Label 6211*/ GIMT_Encode4(309972),
     /* 306597 */ // Label 6204: @306597
     /* 306597 */ GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(307764),
     /* 306602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306609 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(306767), // Rule ID 4835 //
     /* 306614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 306625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 306633 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 306637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306658 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306683 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306694 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 306694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306706 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306734 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 306753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 306765 */     GIR_RootConstrainSelectedInstOperands,
     /* 306766 */     // GIR_Coverage, 4835,
     /* 306766 */     GIR_EraseRootFromParent_Done,
     /* 306767 */   // Label 6214: @306767
     /* 306767 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(306925), // Rule ID 4834 //
     /* 306772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 306783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 306791 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 306795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306807 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306816 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 306824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306836 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306841 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306852 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 306852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 306855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306864 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 306870 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306892 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 306898 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 306911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 306919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 306923 */     GIR_RootConstrainSelectedInstOperands,
     /* 306924 */     // GIR_Coverage, 4834,
     /* 306924 */     GIR_EraseRootFromParent_Done,
     /* 306925 */   // Label 6215: @306925
     /* 306925 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(307036), // Rule ID 4833 //
     /* 306930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 306941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 306949 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 306953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306974 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 306978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306990 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 306990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 306993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307002 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307034 */     GIR_RootConstrainSelectedInstOperands,
     /* 307035 */     // GIR_Coverage, 4833,
     /* 307035 */     GIR_EraseRootFromParent_Done,
     /* 307036 */   // Label 6216: @307036
     /* 307036 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(307147), // Rule ID 4831 //
     /* 307041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307060 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307090 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307101 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307113 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307145 */     GIR_RootConstrainSelectedInstOperands,
     /* 307146 */     // GIR_Coverage, 4831,
     /* 307146 */     GIR_EraseRootFromParent_Done,
     /* 307147 */   // Label 6217: @307147
     /* 307147 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(307258), // Rule ID 4832 //
     /* 307152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307171 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307196 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307212 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307224 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307256 */     GIR_RootConstrainSelectedInstOperands,
     /* 307257 */     // GIR_Coverage, 4832,
     /* 307257 */     GIR_EraseRootFromParent_Done,
     /* 307258 */   // Label 6218: @307258
     /* 307258 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(307369), // Rule ID 4830 //
     /* 307263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307282 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307312 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307323 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307367 */     GIR_RootConstrainSelectedInstOperands,
     /* 307368 */     // GIR_Coverage, 4830,
     /* 307368 */     GIR_EraseRootFromParent_Done,
     /* 307369 */   // Label 6219: @307369
     /* 307369 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(307433), // Rule ID 650 //
     /* 307374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307393 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307414 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307431 */     GIR_RootConstrainSelectedInstOperands,
     /* 307432 */     // GIR_Coverage, 650,
     /* 307432 */     GIR_EraseRootFromParent_Done,
     /* 307433 */   // Label 6220: @307433
     /* 307433 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(307497), // Rule ID 649 //
     /* 307438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307457 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307478 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307495 */     GIR_RootConstrainSelectedInstOperands,
     /* 307496 */     // GIR_Coverage, 649,
     /* 307496 */     GIR_EraseRootFromParent_Done,
     /* 307497 */   // Label 6221: @307497
     /* 307497 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(307548), // Rule ID 626 //
     /* 307502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 307513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307533 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 307533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 307536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307546 */     GIR_RootConstrainSelectedInstOperands,
     /* 307547 */     // GIR_Coverage, 626,
     /* 307547 */     GIR_EraseRootFromParent_Done,
     /* 307548 */   // Label 6222: @307548
     /* 307548 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(307599), // Rule ID 625 //
     /* 307553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 307564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307584 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 307584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 307587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307597 */     GIR_RootConstrainSelectedInstOperands,
     /* 307598 */     // GIR_Coverage, 625,
     /* 307598 */     GIR_EraseRootFromParent_Done,
     /* 307599 */   // Label 6223: @307599
     /* 307599 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(307618), // Rule ID 524 //
     /* 307604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307611 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 307611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 307616 */     GIR_RootConstrainSelectedInstOperands,
     /* 307617 */     // GIR_Coverage, 524,
     /* 307617 */     GIR_Done,
     /* 307618 */   // Label 6224: @307618
     /* 307618 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(307763), // Rule ID 6340 //
     /* 307623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307627 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 307627 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 307630 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307634 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 307641 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 307644 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307648 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307653 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 307656 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 307660 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 307663 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307668 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307673 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307678 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 307681 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307685 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307690 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307693 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 307698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 307705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307710 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 307713 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 307718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 307752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307762 */     // GIR_Coverage, 6340,
     /* 307762 */     GIR_EraseRootFromParent_Done,
     /* 307763 */   // Label 6225: @307763
     /* 307763 */   GIM_Reject,
     /* 307764 */ // Label 6213: @307764
     /* 307764 */ GIM_Reject,
     /* 307765 */ // Label 6205: @307765
     /* 307765 */ GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(308787),
     /* 307770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 307773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307777 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(307935), // Rule ID 4841 //
     /* 307782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 307801 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 307805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 307834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307842 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307846 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307851 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307862 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 307862 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 307865 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307869 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307874 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 307880 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307885 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 307893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307902 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 307908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 307921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 307929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307933 */     GIR_RootConstrainSelectedInstOperands,
     /* 307934 */     // GIR_Coverage, 4841,
     /* 307934 */     GIR_EraseRootFromParent_Done,
     /* 307935 */   // Label 6227: @307935
     /* 307935 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(308093), // Rule ID 4840 //
     /* 307940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 307959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 307963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307984 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 307992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308004 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308009 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308020 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308020 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308023 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308027 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308032 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308091 */     GIR_RootConstrainSelectedInstOperands,
     /* 308092 */     // GIR_Coverage, 4840,
     /* 308092 */     GIR_EraseRootFromParent_Done,
     /* 308093 */   // Label 6228: @308093
     /* 308093 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(308204), // Rule ID 4839 //
     /* 308098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308117 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308142 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308158 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308170 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308202 */     GIR_RootConstrainSelectedInstOperands,
     /* 308203 */     // GIR_Coverage, 4839,
     /* 308203 */     GIR_EraseRootFromParent_Done,
     /* 308204 */   // Label 6229: @308204
     /* 308204 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(308315), // Rule ID 4837 //
     /* 308209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308228 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308258 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308269 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308281 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308313 */     GIR_RootConstrainSelectedInstOperands,
     /* 308314 */     // GIR_Coverage, 4837,
     /* 308314 */     GIR_EraseRootFromParent_Done,
     /* 308315 */   // Label 6230: @308315
     /* 308315 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(308426), // Rule ID 4838 //
     /* 308320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308364 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308380 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308392 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308424 */     GIR_RootConstrainSelectedInstOperands,
     /* 308425 */     // GIR_Coverage, 4838,
     /* 308425 */     GIR_EraseRootFromParent_Done,
     /* 308426 */   // Label 6231: @308426
     /* 308426 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(308537), // Rule ID 4836 //
     /* 308431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308450 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308480 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308491 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308503 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308535 */     GIR_RootConstrainSelectedInstOperands,
     /* 308536 */     // GIR_Coverage, 4836,
     /* 308536 */     GIR_EraseRootFromParent_Done,
     /* 308537 */   // Label 6232: @308537
     /* 308537 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(308601), // Rule ID 652 //
     /* 308542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308561 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308582 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308599 */     GIR_RootConstrainSelectedInstOperands,
     /* 308600 */     // GIR_Coverage, 652,
     /* 308600 */     GIR_EraseRootFromParent_Done,
     /* 308601 */   // Label 6233: @308601
     /* 308601 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(308665), // Rule ID 651 //
     /* 308606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308625 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308646 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308663 */     GIR_RootConstrainSelectedInstOperands,
     /* 308664 */     // GIR_Coverage, 651,
     /* 308664 */     GIR_EraseRootFromParent_Done,
     /* 308665 */   // Label 6234: @308665
     /* 308665 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(308716), // Rule ID 628 //
     /* 308670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 308681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308701 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 308704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308714 */     GIR_RootConstrainSelectedInstOperands,
     /* 308715 */     // GIR_Coverage, 628,
     /* 308715 */     GIR_EraseRootFromParent_Done,
     /* 308716 */   // Label 6235: @308716
     /* 308716 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(308767), // Rule ID 627 //
     /* 308721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 308732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308752 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 308752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 308755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308765 */     GIR_RootConstrainSelectedInstOperands,
     /* 308766 */     // GIR_Coverage, 627,
     /* 308766 */     GIR_EraseRootFromParent_Done,
     /* 308767 */   // Label 6236: @308767
     /* 308767 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(308786), // Rule ID 525 //
     /* 308772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308779 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 308779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 308784 */     GIR_RootConstrainSelectedInstOperands,
     /* 308785 */     // GIR_Coverage, 525,
     /* 308785 */     GIR_Done,
     /* 308786 */   // Label 6237: @308786
     /* 308786 */   GIM_Reject,
     /* 308787 */ // Label 6226: @308787
     /* 308787 */ GIM_Reject,
     /* 308788 */ // Label 6206: @308788
     /* 308788 */ GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(309810),
     /* 308793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 308796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308800 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(308958), // Rule ID 4847 //
     /* 308805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308824 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 308828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308865 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308874 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308885 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 308885 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 308888 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308892 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308897 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 308903 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308908 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 308916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308925 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 308931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 308944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308956 */     GIR_RootConstrainSelectedInstOperands,
     /* 308957 */     // GIR_Coverage, 4847,
     /* 308957 */     GIR_EraseRootFromParent_Done,
     /* 308958 */   // Label 6239: @308958
     /* 308958 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(309116), // Rule ID 4846 //
     /* 308963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308982 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 308986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309007 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309032 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309043 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309055 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309083 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309114 */     GIR_RootConstrainSelectedInstOperands,
     /* 309115 */     // GIR_Coverage, 4846,
     /* 309115 */     GIR_EraseRootFromParent_Done,
     /* 309116 */   // Label 6240: @309116
     /* 309116 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(309227), // Rule ID 4845 //
     /* 309121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309140 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309165 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309181 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309193 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309225 */     GIR_RootConstrainSelectedInstOperands,
     /* 309226 */     // GIR_Coverage, 4845,
     /* 309226 */     GIR_EraseRootFromParent_Done,
     /* 309227 */   // Label 6241: @309227
     /* 309227 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(309338), // Rule ID 4843 //
     /* 309232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309281 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309292 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309336 */     GIR_RootConstrainSelectedInstOperands,
     /* 309337 */     // GIR_Coverage, 4843,
     /* 309337 */     GIR_EraseRootFromParent_Done,
     /* 309338 */   // Label 6242: @309338
     /* 309338 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(309449), // Rule ID 4844 //
     /* 309343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309362 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309387 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309403 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309415 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309447 */     GIR_RootConstrainSelectedInstOperands,
     /* 309448 */     // GIR_Coverage, 4844,
     /* 309448 */     GIR_EraseRootFromParent_Done,
     /* 309449 */   // Label 6243: @309449
     /* 309449 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(309560), // Rule ID 4842 //
     /* 309454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309473 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309503 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309514 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309526 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309558 */     GIR_RootConstrainSelectedInstOperands,
     /* 309559 */     // GIR_Coverage, 4842,
     /* 309559 */     GIR_EraseRootFromParent_Done,
     /* 309560 */   // Label 6244: @309560
     /* 309560 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(309624), // Rule ID 654 //
     /* 309565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309584 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309605 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309622 */     GIR_RootConstrainSelectedInstOperands,
     /* 309623 */     // GIR_Coverage, 654,
     /* 309623 */     GIR_EraseRootFromParent_Done,
     /* 309624 */   // Label 6245: @309624
     /* 309624 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(309688), // Rule ID 653 //
     /* 309629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309648 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309669 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309686 */     GIR_RootConstrainSelectedInstOperands,
     /* 309687 */     // GIR_Coverage, 653,
     /* 309687 */     GIR_EraseRootFromParent_Done,
     /* 309688 */   // Label 6246: @309688
     /* 309688 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(309739), // Rule ID 630 //
     /* 309693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 309704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309724 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 309724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 309727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309737 */     GIR_RootConstrainSelectedInstOperands,
     /* 309738 */     // GIR_Coverage, 630,
     /* 309738 */     GIR_EraseRootFromParent_Done,
     /* 309739 */   // Label 6247: @309739
     /* 309739 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(309790), // Rule ID 629 //
     /* 309744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 309755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309775 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 309775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 309778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309788 */     GIR_RootConstrainSelectedInstOperands,
     /* 309789 */     // GIR_Coverage, 629,
     /* 309789 */     GIR_EraseRootFromParent_Done,
     /* 309790 */   // Label 6248: @309790
     /* 309790 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(309809), // Rule ID 526 //
     /* 309795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309802 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 309802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 309807 */     GIR_RootConstrainSelectedInstOperands,
     /* 309808 */     // GIR_Coverage, 526,
     /* 309808 */     GIR_Done,
     /* 309809 */   // Label 6249: @309809
     /* 309809 */   GIM_Reject,
     /* 309810 */ // Label 6238: @309810
     /* 309810 */ GIM_Reject,
     /* 309811 */ // Label 6207: @309811
     /* 309811 */ GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(309837), // Rule ID 860 //
     /* 309816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 309822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309830 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 309830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 309835 */   GIR_RootConstrainSelectedInstOperands,
     /* 309836 */   // GIR_Coverage, 860,
     /* 309836 */   GIR_Done,
     /* 309837 */ // Label 6250: @309837
     /* 309837 */ GIM_Reject,
     /* 309838 */ // Label 6208: @309838
     /* 309838 */ GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(309864), // Rule ID 862 //
     /* 309843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309857 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 309857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 309862 */   GIR_RootConstrainSelectedInstOperands,
     /* 309863 */   // GIR_Coverage, 862,
     /* 309863 */   GIR_Done,
     /* 309864 */ // Label 6251: @309864
     /* 309864 */ GIM_Reject,
     /* 309865 */ // Label 6209: @309865
     /* 309865 */ GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(309944),
     /* 309870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 309873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309881 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(309896), // Rule ID 858 //
     /* 309886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309889 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 309889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 309894 */     GIR_RootConstrainSelectedInstOperands,
     /* 309895 */     // GIR_Coverage, 858,
     /* 309895 */     GIR_Done,
     /* 309896 */   // Label 6253: @309896
     /* 309896 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(309943), // Rule ID 6343 //
     /* 309901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309904 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 309904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 309911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309916 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 309926 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 309929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 309931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 309934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309941 */     GIR_RootConstrainSelectedInstOperands,
     /* 309942 */     // GIR_Coverage, 6343,
     /* 309942 */     GIR_EraseRootFromParent_Done,
     /* 309943 */   // Label 6254: @309943
     /* 309943 */   GIM_Reject,
     /* 309944 */ // Label 6252: @309944
     /* 309944 */ GIM_Reject,
     /* 309945 */ // Label 6210: @309945
     /* 309945 */ GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(309971), // Rule ID 861 //
     /* 309950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309964 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 309964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 309969 */   GIR_RootConstrainSelectedInstOperands,
     /* 309970 */   // GIR_Coverage, 861,
     /* 309970 */   GIR_Done,
     /* 309971 */ // Label 6255: @309971
     /* 309971 */ GIM_Reject,
     /* 309972 */ // Label 6211: @309972
     /* 309972 */ GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(310051),
     /* 309977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309988 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(310003), // Rule ID 859 //
     /* 309993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309996 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 309996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 310001 */     GIR_RootConstrainSelectedInstOperands,
     /* 310002 */     // GIR_Coverage, 859,
     /* 310002 */     GIR_Done,
     /* 310003 */   // Label 6257: @310003
     /* 310003 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(310050), // Rule ID 6344 //
     /* 310008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310011 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 310011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 310014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 310018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310023 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 310033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 310036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 310041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310048 */     GIR_RootConstrainSelectedInstOperands,
     /* 310049 */     // GIR_Coverage, 6344,
     /* 310049 */     GIR_EraseRootFromParent_Done,
     /* 310050 */   // Label 6258: @310050
     /* 310050 */   GIM_Reject,
     /* 310051 */ // Label 6256: @310051
     /* 310051 */ GIM_Reject,
     /* 310052 */ // Label 6212: @310052
     /* 310052 */ GIM_Reject,
     /* 310053 */ // Label 63: @310053
     /* 310053 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6263*/ GIMT_Encode4(310300),
     /* 310064 */ /*GILLT_s32*//*Label 6259*/ GIMT_Encode4(310092),
     /* 310068 */ /*GILLT_s64*//*Label 6260*/ GIMT_Encode4(310123), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310080 */ /*GILLT_v2s64*//*Label 6261*/ GIMT_Encode4(310184), GIMT_Encode4(0),
     /* 310088 */ /*GILLT_v4s32*//*Label 6262*/ GIMT_Encode4(310242),
     /* 310092 */ // Label 6259: @310092
     /* 310092 */ GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(310122), // Rule ID 516 //
     /* 310097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310111 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 310111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 310116 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310120 */   GIR_RootConstrainSelectedInstOperands,
     /* 310121 */   // GIR_Coverage, 516,
     /* 310121 */   GIR_Done,
     /* 310122 */ // Label 6264: @310122
     /* 310122 */ GIM_Reject,
     /* 310123 */ // Label 6260: @310123
     /* 310123 */ GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(310153), // Rule ID 514 //
     /* 310128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310142 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 310142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 310147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310151 */   GIR_RootConstrainSelectedInstOperands,
     /* 310152 */   // GIR_Coverage, 514,
     /* 310152 */   GIR_Done,
     /* 310153 */ // Label 6265: @310153
     /* 310153 */ GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(310183), // Rule ID 518 //
     /* 310158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310172 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 310172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 310177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310181 */   GIR_RootConstrainSelectedInstOperands,
     /* 310182 */   // GIR_Coverage, 518,
     /* 310182 */   GIR_Done,
     /* 310183 */ // Label 6266: @310183
     /* 310183 */ GIM_Reject,
     /* 310184 */ // Label 6261: @310184
     /* 310184 */ GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(310241),
     /* 310189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310196 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(310220), // Rule ID 4890 //
     /* 310201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 310208 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 310208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 310211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310218 */     GIR_RootConstrainSelectedInstOperands,
     /* 310219 */     // GIR_Coverage, 4890,
     /* 310219 */     GIR_EraseRootFromParent_Done,
     /* 310220 */   // Label 6268: @310220
     /* 310220 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(310240), // Rule ID 4888 //
     /* 310225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310229 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 310229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 310234 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310238 */     GIR_RootConstrainSelectedInstOperands,
     /* 310239 */     // GIR_Coverage, 4888,
     /* 310239 */     GIR_Done,
     /* 310240 */   // Label 6269: @310240
     /* 310240 */   GIM_Reject,
     /* 310241 */ // Label 6267: @310241
     /* 310241 */ GIM_Reject,
     /* 310242 */ // Label 6262: @310242
     /* 310242 */ GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(310299),
     /* 310247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310254 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(310278), // Rule ID 4894 //
     /* 310259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 310266 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 310266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 310269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310276 */     GIR_RootConstrainSelectedInstOperands,
     /* 310277 */     // GIR_Coverage, 4894,
     /* 310277 */     GIR_EraseRootFromParent_Done,
     /* 310278 */   // Label 6271: @310278
     /* 310278 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(310298), // Rule ID 4892 //
     /* 310283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310287 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 310287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 310292 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310296 */     GIR_RootConstrainSelectedInstOperands,
     /* 310297 */     // GIR_Coverage, 4892,
     /* 310297 */     GIR_Done,
     /* 310298 */   // Label 6272: @310298
     /* 310298 */   GIM_Reject,
     /* 310299 */ // Label 6270: @310299
     /* 310299 */ GIM_Reject,
     /* 310300 */ // Label 6263: @310300
     /* 310300 */ GIM_Reject,
     /* 310301 */ // Label 64: @310301
     /* 310301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6277*/ GIMT_Encode4(310488),
     /* 310312 */ /*GILLT_s16*//*Label 6273*/ GIMT_Encode4(310340),
     /* 310316 */ /*GILLT_s32*//*Label 6274*/ GIMT_Encode4(310401), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310328 */ /*GILLT_v2s32*//*Label 6275*/ GIMT_Encode4(310432), GIMT_Encode4(0),
     /* 310336 */ /*GILLT_v4s16*//*Label 6276*/ GIMT_Encode4(310460),
     /* 310340 */ // Label 6273: @310340
     /* 310340 */ GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(310370), // Rule ID 510 //
     /* 310345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310359 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 310359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 310364 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310368 */   GIR_RootConstrainSelectedInstOperands,
     /* 310369 */   // GIR_Coverage, 510,
     /* 310369 */   GIR_Done,
     /* 310370 */ // Label 6278: @310370
     /* 310370 */ GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310400), // Rule ID 520 //
     /* 310375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310389 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 310389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 310394 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310398 */   GIR_RootConstrainSelectedInstOperands,
     /* 310399 */   // GIR_Coverage, 520,
     /* 310399 */   GIR_Done,
     /* 310400 */ // Label 6279: @310400
     /* 310400 */ GIM_Reject,
     /* 310401 */ // Label 6274: @310401
     /* 310401 */ GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(310431), // Rule ID 512 //
     /* 310406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310420 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 310420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 310425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310429 */   GIR_RootConstrainSelectedInstOperands,
     /* 310430 */   // GIR_Coverage, 512,
     /* 310430 */   GIR_Done,
     /* 310431 */ // Label 6280: @310431
     /* 310431 */ GIM_Reject,
     /* 310432 */ // Label 6275: @310432
     /* 310432 */ GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(310459), // Rule ID 4898 //
     /* 310437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310448 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 310448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 310453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310457 */   GIR_RootConstrainSelectedInstOperands,
     /* 310458 */   // GIR_Coverage, 4898,
     /* 310458 */   GIR_Done,
     /* 310459 */ // Label 6281: @310459
     /* 310459 */ GIM_Reject,
     /* 310460 */ // Label 6276: @310460
     /* 310460 */ GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(310487), // Rule ID 4900 //
     /* 310465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310476 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 310476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 310481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310485 */   GIR_RootConstrainSelectedInstOperands,
     /* 310486 */   // GIR_Coverage, 4900,
     /* 310486 */   GIR_Done,
     /* 310487 */ // Label 6282: @310487
     /* 310487 */ GIM_Reject,
     /* 310488 */ // Label 6277: @310488
     /* 310488 */ GIM_Reject,
     /* 310489 */ // Label 65: @310489
     /* 310489 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6290*/ GIMT_Encode4(311551),
     /* 310500 */ /*GILLT_s32*//*Label 6283*/ GIMT_Encode4(310536),
     /* 310504 */ /*GILLT_s64*//*Label 6284*/ GIMT_Encode4(310923), GIMT_Encode4(0),
     /* 310512 */ /*GILLT_v2s32*//*Label 6285*/ GIMT_Encode4(311310),
     /* 310516 */ /*GILLT_v2s64*//*Label 6286*/ GIMT_Encode4(311384),
     /* 310520 */ /*GILLT_v4s16*//*Label 6287*/ GIMT_Encode4(311458),
     /* 310524 */ /*GILLT_v4s32*//*Label 6288*/ GIMT_Encode4(311489), GIMT_Encode4(0),
     /* 310532 */ /*GILLT_v8s16*//*Label 6289*/ GIMT_Encode4(311520),
     /* 310536 */ // Label 6283: @310536
     /* 310536 */ GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(310573), // Rule ID 4637 //
     /* 310541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310556 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310562 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 310565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310567 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310571 */   GIR_RootConstrainSelectedInstOperands,
     /* 310572 */   // GIR_Coverage, 4637,
     /* 310572 */   GIR_EraseRootFromParent_Done,
     /* 310573 */ // Label 6291: @310573
     /* 310573 */ GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(310610), // Rule ID 4639 //
     /* 310578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310593 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310597 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310599 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 310602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310604 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310608 */   GIR_RootConstrainSelectedInstOperands,
     /* 310609 */   // GIR_Coverage, 4639,
     /* 310609 */   GIR_EraseRootFromParent_Done,
     /* 310610 */ // Label 6292: @310610
     /* 310610 */ GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(310647), // Rule ID 4657 //
     /* 310615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310622 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310626 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 310630 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310636 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 310639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310641 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310645 */   GIR_RootConstrainSelectedInstOperands,
     /* 310646 */   // GIR_Coverage, 4657,
     /* 310646 */   GIR_EraseRootFromParent_Done,
     /* 310647 */ // Label 6293: @310647
     /* 310647 */ GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(310684), // Rule ID 4659 //
     /* 310652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310659 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 310667 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310673 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 310676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310678 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310682 */   GIR_RootConstrainSelectedInstOperands,
     /* 310683 */   // GIR_Coverage, 4659,
     /* 310683 */   GIR_EraseRootFromParent_Done,
     /* 310684 */ // Label 6294: @310684
     /* 310684 */ GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(310721), // Rule ID 4697 //
     /* 310689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 310704 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310708 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310710 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 310713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310715 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310719 */   GIR_RootConstrainSelectedInstOperands,
     /* 310720 */   // GIR_Coverage, 4697,
     /* 310720 */   GIR_EraseRootFromParent_Done,
     /* 310721 */ // Label 6295: @310721
     /* 310721 */ GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(310758), // Rule ID 4699 //
     /* 310726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310733 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 310741 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310747 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 310750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310752 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310756 */   GIR_RootConstrainSelectedInstOperands,
     /* 310757 */   // GIR_Coverage, 4699,
     /* 310757 */   GIR_EraseRootFromParent_Done,
     /* 310758 */ // Label 6296: @310758
     /* 310758 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(310795), // Rule ID 4677 //
     /* 310763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 310778 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310782 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310784 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 310784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 310787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310789 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310793 */   GIR_RootConstrainSelectedInstOperands,
     /* 310794 */   // GIR_Coverage, 4677,
     /* 310794 */   GIR_EraseRootFromParent_Done,
     /* 310795 */ // Label 6297: @310795
     /* 310795 */ GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(310832), // Rule ID 4679 //
     /* 310800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 310815 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310819 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310821 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 310821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 310824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310826 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310830 */   GIR_RootConstrainSelectedInstOperands,
     /* 310831 */   // GIR_Coverage, 4679,
     /* 310831 */   GIR_EraseRootFromParent_Done,
     /* 310832 */ // Label 6298: @310832
     /* 310832 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(310862), // Rule ID 395 //
     /* 310837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310851 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 310851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 310856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310860 */   GIR_RootConstrainSelectedInstOperands,
     /* 310861 */   // GIR_Coverage, 395,
     /* 310861 */   GIR_Done,
     /* 310862 */ // Label 6299: @310862
     /* 310862 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(310892), // Rule ID 399 //
     /* 310867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310881 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 310881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 310886 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310890 */   GIR_RootConstrainSelectedInstOperands,
     /* 310891 */   // GIR_Coverage, 399,
     /* 310891 */   GIR_Done,
     /* 310892 */ // Label 6300: @310892
     /* 310892 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(310922), // Rule ID 403 //
     /* 310897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 310907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310911 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 310911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 310916 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310920 */   GIR_RootConstrainSelectedInstOperands,
     /* 310921 */   // GIR_Coverage, 403,
     /* 310921 */   GIR_Done,
     /* 310922 */ // Label 6301: @310922
     /* 310922 */ GIM_Reject,
     /* 310923 */ // Label 6284: @310923
     /* 310923 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(310960), // Rule ID 4638 //
     /* 310928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310943 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 310947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310949 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 310949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 310952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310954 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310958 */   GIR_RootConstrainSelectedInstOperands,
     /* 310959 */   // GIR_Coverage, 4638,
     /* 310959 */   GIR_EraseRootFromParent_Done,
     /* 310960 */ // Label 6302: @310960
     /* 310960 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(310997), // Rule ID 4640 //
     /* 310965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 310972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 310980 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310986 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 310986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 310989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310991 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310995 */   GIR_RootConstrainSelectedInstOperands,
     /* 310996 */   // GIR_Coverage, 4640,
     /* 310996 */   GIR_EraseRootFromParent_Done,
     /* 310997 */ // Label 6303: @310997
     /* 310997 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(311034), // Rule ID 4658 //
     /* 311002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311023 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 311026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311028 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311032 */   GIR_RootConstrainSelectedInstOperands,
     /* 311033 */   // GIR_Coverage, 4658,
     /* 311033 */   GIR_EraseRootFromParent_Done,
     /* 311034 */ // Label 6304: @311034
     /* 311034 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(311071), // Rule ID 4660 //
     /* 311039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311054 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311058 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311060 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 311063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311065 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311069 */   GIR_RootConstrainSelectedInstOperands,
     /* 311070 */   // GIR_Coverage, 4660,
     /* 311070 */   GIR_EraseRootFromParent_Done,
     /* 311071 */ // Label 6305: @311071
     /* 311071 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(311108), // Rule ID 4698 //
     /* 311076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311091 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311095 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311097 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 311100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311102 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311106 */   GIR_RootConstrainSelectedInstOperands,
     /* 311107 */   // GIR_Coverage, 4698,
     /* 311107 */   GIR_EraseRootFromParent_Done,
     /* 311108 */ // Label 6306: @311108
     /* 311108 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(311145), // Rule ID 4700 //
     /* 311113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311120 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311124 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311128 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311132 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311134 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 311137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311139 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311143 */   GIR_RootConstrainSelectedInstOperands,
     /* 311144 */   // GIR_Coverage, 4700,
     /* 311144 */   GIR_EraseRootFromParent_Done,
     /* 311145 */ // Label 6307: @311145
     /* 311145 */ GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(311182), // Rule ID 4678 //
     /* 311150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311165 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311171 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311176 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311180 */   GIR_RootConstrainSelectedInstOperands,
     /* 311181 */   // GIR_Coverage, 4678,
     /* 311181 */   GIR_EraseRootFromParent_Done,
     /* 311182 */ // Label 6308: @311182
     /* 311182 */ GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(311219), // Rule ID 4680 //
     /* 311187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311194 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311202 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311206 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311208 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311213 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311217 */   GIR_RootConstrainSelectedInstOperands,
     /* 311218 */   // GIR_Coverage, 4680,
     /* 311218 */   GIR_EraseRootFromParent_Done,
     /* 311219 */ // Label 6309: @311219
     /* 311219 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(311249), // Rule ID 397 //
     /* 311224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311238 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 311238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 311243 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311247 */   GIR_RootConstrainSelectedInstOperands,
     /* 311248 */   // GIR_Coverage, 397,
     /* 311248 */   GIR_Done,
     /* 311249 */ // Label 6310: @311249
     /* 311249 */ GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(311279), // Rule ID 401 //
     /* 311254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311268 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 311268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311273 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311277 */   GIR_RootConstrainSelectedInstOperands,
     /* 311278 */   // GIR_Coverage, 401,
     /* 311278 */   GIR_Done,
     /* 311279 */ // Label 6311: @311279
     /* 311279 */ GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(311309), // Rule ID 405 //
     /* 311284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311298 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 311298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311307 */   GIR_RootConstrainSelectedInstOperands,
     /* 311308 */   // GIR_Coverage, 405,
     /* 311308 */   GIR_Done,
     /* 311309 */ // Label 6312: @311309
     /* 311309 */ GIM_Reject,
     /* 311310 */ // Label 6285: @311310
     /* 311310 */ GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(311340), // Rule ID 843 //
     /* 311315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311329 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 311329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 311334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311338 */   GIR_RootConstrainSelectedInstOperands,
     /* 311339 */   // GIR_Coverage, 843,
     /* 311339 */   GIR_Done,
     /* 311340 */ // Label 6313: @311340
     /* 311340 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(311383), // Rule ID 13041 //
     /* 311345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311355 */   // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 311355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 311358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 311371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 311376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311381 */   GIR_RootConstrainSelectedInstOperands,
     /* 311382 */   // GIR_Coverage, 13041,
     /* 311382 */   GIR_EraseRootFromParent_Done,
     /* 311383 */ // Label 6314: @311383
     /* 311383 */ GIM_Reject,
     /* 311384 */ // Label 6286: @311384
     /* 311384 */ GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(311414), // Rule ID 847 //
     /* 311389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311403 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 311403 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311408 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311412 */   GIR_RootConstrainSelectedInstOperands,
     /* 311413 */   // GIR_Coverage, 847,
     /* 311413 */   GIR_Done,
     /* 311414 */ // Label 6315: @311414
     /* 311414 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(311457), // Rule ID 13039 //
     /* 311419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311429 */   // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 311429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 311432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 311436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 311445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311455 */   GIR_RootConstrainSelectedInstOperands,
     /* 311456 */   // GIR_Coverage, 13039,
     /* 311456 */   GIR_EraseRootFromParent_Done,
     /* 311457 */ // Label 6316: @311457
     /* 311457 */ GIM_Reject,
     /* 311458 */ // Label 6287: @311458
     /* 311458 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(311488), // Rule ID 839 //
     /* 311463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 311469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311477 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 311477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 311482 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311486 */   GIR_RootConstrainSelectedInstOperands,
     /* 311487 */   // GIR_Coverage, 839,
     /* 311487 */   GIR_Done,
     /* 311488 */ // Label 6317: @311488
     /* 311488 */ GIM_Reject,
     /* 311489 */ // Label 6288: @311489
     /* 311489 */ GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(311519), // Rule ID 845 //
     /* 311494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311508 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 311508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 311513 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311517 */   GIR_RootConstrainSelectedInstOperands,
     /* 311518 */   // GIR_Coverage, 845,
     /* 311518 */   GIR_Done,
     /* 311519 */ // Label 6318: @311519
     /* 311519 */ GIM_Reject,
     /* 311520 */ // Label 6289: @311520
     /* 311520 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(311550), // Rule ID 841 //
     /* 311525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311539 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 311539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 311544 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311548 */   GIR_RootConstrainSelectedInstOperands,
     /* 311549 */   // GIR_Coverage, 841,
     /* 311549 */   GIR_Done,
     /* 311550 */ // Label 6319: @311550
     /* 311550 */ GIM_Reject,
     /* 311551 */ // Label 6290: @311551
     /* 311551 */ GIM_Reject,
     /* 311552 */ // Label 66: @311552
     /* 311552 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6327*/ GIMT_Encode4(312614),
     /* 311563 */ /*GILLT_s32*//*Label 6320*/ GIMT_Encode4(311599),
     /* 311567 */ /*GILLT_s64*//*Label 6321*/ GIMT_Encode4(311986), GIMT_Encode4(0),
     /* 311575 */ /*GILLT_v2s32*//*Label 6322*/ GIMT_Encode4(312373),
     /* 311579 */ /*GILLT_v2s64*//*Label 6323*/ GIMT_Encode4(312447),
     /* 311583 */ /*GILLT_v4s16*//*Label 6324*/ GIMT_Encode4(312521),
     /* 311587 */ /*GILLT_v4s32*//*Label 6325*/ GIMT_Encode4(312552), GIMT_Encode4(0),
     /* 311595 */ /*GILLT_v8s16*//*Label 6326*/ GIMT_Encode4(312583),
     /* 311599 */ // Label 6320: @311599
     /* 311599 */ GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(311636), // Rule ID 4647 //
     /* 311604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311625 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 311628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311630 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311634 */   GIR_RootConstrainSelectedInstOperands,
     /* 311635 */   // GIR_Coverage, 4647,
     /* 311635 */   GIR_EraseRootFromParent_Done,
     /* 311636 */ // Label 6328: @311636
     /* 311636 */ GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(311673), // Rule ID 4649 //
     /* 311641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311648 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311652 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311656 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311662 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 311665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311667 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311671 */   GIR_RootConstrainSelectedInstOperands,
     /* 311672 */   // GIR_Coverage, 4649,
     /* 311672 */   GIR_EraseRootFromParent_Done,
     /* 311673 */ // Label 6329: @311673
     /* 311673 */ GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(311710), // Rule ID 4667 //
     /* 311678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311693 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311699 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 311702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311704 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311708 */   GIR_RootConstrainSelectedInstOperands,
     /* 311709 */   // GIR_Coverage, 4667,
     /* 311709 */   GIR_EraseRootFromParent_Done,
     /* 311710 */ // Label 6330: @311710
     /* 311710 */ GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(311747), // Rule ID 4669 //
     /* 311715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311730 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311734 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311736 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 311739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311741 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311745 */   GIR_RootConstrainSelectedInstOperands,
     /* 311746 */   // GIR_Coverage, 4669,
     /* 311746 */   GIR_EraseRootFromParent_Done,
     /* 311747 */ // Label 6331: @311747
     /* 311747 */ GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(311784), // Rule ID 4707 //
     /* 311752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311773 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 311776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311778 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311782 */   GIR_RootConstrainSelectedInstOperands,
     /* 311783 */   // GIR_Coverage, 4707,
     /* 311783 */   GIR_EraseRootFromParent_Done,
     /* 311784 */ // Label 6332: @311784
     /* 311784 */ GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(311821), // Rule ID 4709 //
     /* 311789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311804 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311810 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 311813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311815 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311819 */   GIR_RootConstrainSelectedInstOperands,
     /* 311820 */   // GIR_Coverage, 4709,
     /* 311820 */   GIR_EraseRootFromParent_Done,
     /* 311821 */ // Label 6333: @311821
     /* 311821 */ GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(311858), // Rule ID 4687 //
     /* 311826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311833 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311837 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311841 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311847 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 311850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311852 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311856 */   GIR_RootConstrainSelectedInstOperands,
     /* 311857 */   // GIR_Coverage, 4687,
     /* 311857 */   GIR_EraseRootFromParent_Done,
     /* 311858 */ // Label 6334: @311858
     /* 311858 */ GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(311895), // Rule ID 4689 //
     /* 311863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311870 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311874 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311878 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311882 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311884 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 311887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311889 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311893 */   GIR_RootConstrainSelectedInstOperands,
     /* 311894 */   // GIR_Coverage, 4689,
     /* 311894 */   GIR_EraseRootFromParent_Done,
     /* 311895 */ // Label 6335: @311895
     /* 311895 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(311925), // Rule ID 407 //
     /* 311900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311914 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 311914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 311919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311923 */   GIR_RootConstrainSelectedInstOperands,
     /* 311924 */   // GIR_Coverage, 407,
     /* 311924 */   GIR_Done,
     /* 311925 */ // Label 6336: @311925
     /* 311925 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(311955), // Rule ID 411 //
     /* 311930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311944 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 311944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 311949 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311953 */   GIR_RootConstrainSelectedInstOperands,
     /* 311954 */   // GIR_Coverage, 411,
     /* 311954 */   GIR_Done,
     /* 311955 */ // Label 6337: @311955
     /* 311955 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(311985), // Rule ID 415 //
     /* 311960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311974 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 311974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 311979 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311983 */   GIR_RootConstrainSelectedInstOperands,
     /* 311984 */   // GIR_Coverage, 415,
     /* 311984 */   GIR_Done,
     /* 311985 */ // Label 6338: @311985
     /* 311985 */ GIM_Reject,
     /* 311986 */ // Label 6321: @311986
     /* 311986 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312023), // Rule ID 4648 //
     /* 311991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312006 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312010 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312012 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 312015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312017 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312021 */   GIR_RootConstrainSelectedInstOperands,
     /* 312022 */   // GIR_Coverage, 4648,
     /* 312022 */   GIR_EraseRootFromParent_Done,
     /* 312023 */ // Label 6339: @312023
     /* 312023 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(312060), // Rule ID 4650 //
     /* 312028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312035 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312039 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312043 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312047 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312049 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 312052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312054 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312058 */   GIR_RootConstrainSelectedInstOperands,
     /* 312059 */   // GIR_Coverage, 4650,
     /* 312059 */   GIR_EraseRootFromParent_Done,
     /* 312060 */ // Label 6340: @312060
     /* 312060 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(312097), // Rule ID 4668 //
     /* 312065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312080 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312086 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 312089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312091 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312095 */   GIR_RootConstrainSelectedInstOperands,
     /* 312096 */   // GIR_Coverage, 4668,
     /* 312096 */   GIR_EraseRootFromParent_Done,
     /* 312097 */ // Label 6341: @312097
     /* 312097 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(312134), // Rule ID 4670 //
     /* 312102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312109 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312117 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312121 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312123 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 312126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312128 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312132 */   GIR_RootConstrainSelectedInstOperands,
     /* 312133 */   // GIR_Coverage, 4670,
     /* 312133 */   GIR_EraseRootFromParent_Done,
     /* 312134 */ // Label 6342: @312134
     /* 312134 */ GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(312171), // Rule ID 4708 //
     /* 312139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312158 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312160 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 312163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312165 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312169 */   GIR_RootConstrainSelectedInstOperands,
     /* 312170 */   // GIR_Coverage, 4708,
     /* 312170 */   GIR_EraseRootFromParent_Done,
     /* 312171 */ // Label 6343: @312171
     /* 312171 */ GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(312208), // Rule ID 4710 //
     /* 312176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312183 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312191 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312195 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312197 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 312200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312206 */   GIR_RootConstrainSelectedInstOperands,
     /* 312207 */   // GIR_Coverage, 4710,
     /* 312207 */   GIR_EraseRootFromParent_Done,
     /* 312208 */ // Label 6344: @312208
     /* 312208 */ GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(312245), // Rule ID 4688 //
     /* 312213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312228 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312232 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312234 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312239 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312243 */   GIR_RootConstrainSelectedInstOperands,
     /* 312244 */   // GIR_Coverage, 4688,
     /* 312244 */   GIR_EraseRootFromParent_Done,
     /* 312245 */ // Label 6345: @312245
     /* 312245 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(312282), // Rule ID 4690 //
     /* 312250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312265 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312271 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312276 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312280 */   GIR_RootConstrainSelectedInstOperands,
     /* 312281 */   // GIR_Coverage, 4690,
     /* 312281 */   GIR_EraseRootFromParent_Done,
     /* 312282 */ // Label 6346: @312282
     /* 312282 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(312312), // Rule ID 409 //
     /* 312287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312301 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 312301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 312306 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312310 */   GIR_RootConstrainSelectedInstOperands,
     /* 312311 */   // GIR_Coverage, 409,
     /* 312311 */   GIR_Done,
     /* 312312 */ // Label 6347: @312312
     /* 312312 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(312342), // Rule ID 413 //
     /* 312317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312331 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 312331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312336 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312340 */   GIR_RootConstrainSelectedInstOperands,
     /* 312341 */   // GIR_Coverage, 413,
     /* 312341 */   GIR_Done,
     /* 312342 */ // Label 6348: @312342
     /* 312342 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(312372), // Rule ID 417 //
     /* 312347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312361 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 312361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312370 */   GIR_RootConstrainSelectedInstOperands,
     /* 312371 */   // GIR_Coverage, 417,
     /* 312371 */   GIR_Done,
     /* 312372 */ // Label 6349: @312372
     /* 312372 */ GIM_Reject,
     /* 312373 */ // Label 6322: @312373
     /* 312373 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(312403), // Rule ID 853 //
     /* 312378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312392 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 312392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 312397 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312401 */   GIR_RootConstrainSelectedInstOperands,
     /* 312402 */   // GIR_Coverage, 853,
     /* 312402 */   GIR_Done,
     /* 312403 */ // Label 6350: @312403
     /* 312403 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(312446), // Rule ID 13042 //
     /* 312408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312418 */   // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 312418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 312425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312430 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 312434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 312439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312444 */   GIR_RootConstrainSelectedInstOperands,
     /* 312445 */   // GIR_Coverage, 13042,
     /* 312445 */   GIR_EraseRootFromParent_Done,
     /* 312446 */ // Label 6351: @312446
     /* 312446 */ GIM_Reject,
     /* 312447 */ // Label 6323: @312447
     /* 312447 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(312477), // Rule ID 857 //
     /* 312452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312466 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 312466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 312471 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312475 */   GIR_RootConstrainSelectedInstOperands,
     /* 312476 */   // GIR_Coverage, 857,
     /* 312476 */   GIR_Done,
     /* 312477 */ // Label 6352: @312477
     /* 312477 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(312520), // Rule ID 13040 //
     /* 312482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312492 */   // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 312492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 312499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312504 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 312508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 312513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312518 */   GIR_RootConstrainSelectedInstOperands,
     /* 312519 */   // GIR_Coverage, 13040,
     /* 312519 */   GIR_EraseRootFromParent_Done,
     /* 312520 */ // Label 6353: @312520
     /* 312520 */ GIM_Reject,
     /* 312521 */ // Label 6324: @312521
     /* 312521 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(312551), // Rule ID 849 //
     /* 312526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312540 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 312540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 312545 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312549 */   GIR_RootConstrainSelectedInstOperands,
     /* 312550 */   // GIR_Coverage, 849,
     /* 312550 */   GIR_Done,
     /* 312551 */ // Label 6354: @312551
     /* 312551 */ GIM_Reject,
     /* 312552 */ // Label 6325: @312552
     /* 312552 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(312582), // Rule ID 855 //
     /* 312557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312571 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 312571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 312576 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312580 */   GIR_RootConstrainSelectedInstOperands,
     /* 312581 */   // GIR_Coverage, 855,
     /* 312581 */   GIR_Done,
     /* 312582 */ // Label 6355: @312582
     /* 312582 */ GIM_Reject,
     /* 312583 */ // Label 6326: @312583
     /* 312583 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(312613), // Rule ID 851 //
     /* 312588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312602 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 312602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 312607 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312611 */   GIR_RootConstrainSelectedInstOperands,
     /* 312612 */   // GIR_Coverage, 851,
     /* 312612 */   GIR_Done,
     /* 312613 */ // Label 6356: @312613
     /* 312613 */ GIM_Reject,
     /* 312614 */ // Label 6327: @312614
     /* 312614 */ GIM_Reject,
     /* 312615 */ // Label 67: @312615
     /* 312615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6365*/ GIMT_Encode4(317011),
     /* 312626 */ /*GILLT_s16*//*Label 6357*/ GIMT_Encode4(312666),
     /* 312630 */ /*GILLT_s32*//*Label 6358*/ GIMT_Encode4(312947),
     /* 312634 */ /*GILLT_s64*//*Label 6359*/ GIMT_Encode4(314863), GIMT_Encode4(0),
     /* 312642 */ /*GILLT_v2s32*//*Label 6360*/ GIMT_Encode4(316767),
     /* 312646 */ /*GILLT_v2s64*//*Label 6361*/ GIMT_Encode4(316841),
     /* 312650 */ /*GILLT_v4s16*//*Label 6362*/ GIMT_Encode4(316918),
     /* 312654 */ /*GILLT_v4s32*//*Label 6363*/ GIMT_Encode4(316949), GIMT_Encode4(0),
     /* 312662 */ /*GILLT_v8s16*//*Label 6364*/ GIMT_Encode4(316980),
     /* 312666 */ // Label 6357: @312666
     /* 312666 */ GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(312769), // Rule ID 5308 //
     /* 312671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 312674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 312689 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312693 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312697 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312701 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312705 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312709 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312714 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312718 */   // MIs[1] Operand 2
     /* 312718 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 312729 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312731 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 312731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312743 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 312749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312754 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 312762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312767 */   GIR_RootConstrainSelectedInstOperands,
     /* 312768 */   // GIR_Coverage, 5308,
     /* 312768 */   GIR_EraseRootFromParent_Done,
     /* 312769 */ // Label 6366: @312769
     /* 312769 */ GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(312826), // Rule ID 5299 //
     /* 312774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 312777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312784 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312788 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 312792 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312798 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 312798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 312805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312810 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 312819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312824 */   GIR_RootConstrainSelectedInstOperands,
     /* 312825 */   // GIR_Coverage, 5299,
     /* 312825 */   GIR_EraseRootFromParent_Done,
     /* 312826 */ // Label 6367: @312826
     /* 312826 */ GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(312856), // Rule ID 443 //
     /* 312831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312845 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 312845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 312850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312854 */   GIR_RootConstrainSelectedInstOperands,
     /* 312855 */   // GIR_Coverage, 443,
     /* 312855 */   GIR_Done,
     /* 312856 */ // Label 6368: @312856
     /* 312856 */ GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(312886), // Rule ID 449 //
     /* 312861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312875 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 312875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 312880 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312884 */   GIR_RootConstrainSelectedInstOperands,
     /* 312885 */   // GIR_Coverage, 449,
     /* 312885 */   GIR_Done,
     /* 312886 */ // Label 6369: @312886
     /* 312886 */ GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(312916), // Rule ID 491 //
     /* 312891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312905 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 312905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 312910 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312914 */   GIR_RootConstrainSelectedInstOperands,
     /* 312915 */   // GIR_Coverage, 491,
     /* 312915 */   GIR_Done,
     /* 312916 */ // Label 6370: @312916
     /* 312916 */ GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(312946), // Rule ID 495 //
     /* 312921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 312924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312935 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 312935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 312940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312944 */   GIR_RootConstrainSelectedInstOperands,
     /* 312945 */   // GIR_Coverage, 495,
     /* 312945 */   GIR_Done,
     /* 312946 */ // Label 6371: @312946
     /* 312946 */ GIM_Reject,
     /* 312947 */ // Label 6358: @312947
     /* 312947 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(313185), // Rule ID 6345 //
     /* 312952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 312955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312962 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 312970 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 312973 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 312980 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 312984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312986 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 312993 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 312993 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 312996 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 313000 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313020 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313027 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313030 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313034 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313041 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313044 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313048 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313053 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313056 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313059 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313062 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313067 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313072 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313077 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313080 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313084 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313089 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313092 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313097 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313100 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313104 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313109 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313116 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313121 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313138 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313141 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313158 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313165 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313183 */   GIR_RootConstrainSelectedInstOperands,
     /* 313184 */   // GIR_Coverage, 6345,
     /* 313184 */   GIR_EraseRootFromParent_Done,
     /* 313185 */ // Label 6372: @313185
     /* 313185 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(313423), // Rule ID 6346 //
     /* 313190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313208 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313211 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313218 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313222 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313224 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 313231 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313231 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313234 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 313238 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313248 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313253 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313258 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313265 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313268 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313272 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313279 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313282 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313286 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313291 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313294 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313297 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313300 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313305 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313310 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313315 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313318 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313322 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313327 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313330 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313335 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313338 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313342 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313347 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313354 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313359 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313364 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313367 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313371 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313376 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313379 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313396 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313403 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313421 */   GIR_RootConstrainSelectedInstOperands,
     /* 313422 */   // GIR_Coverage, 6346,
     /* 313422 */   GIR_EraseRootFromParent_Done,
     /* 313423 */ // Label 6373: @313423
     /* 313423 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(313612), // Rule ID 6349 //
     /* 313428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313438 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313446 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313449 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313456 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313462 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 313469 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313469 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 313472 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 313476 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313496 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 313503 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 313506 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313510 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313517 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313520 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313524 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313529 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 313532 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 313535 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 313538 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313543 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313548 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313553 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313556 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313560 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313565 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313568 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313585 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313610 */   GIR_RootConstrainSelectedInstOperands,
     /* 313611 */   // GIR_Coverage, 6349,
     /* 313611 */   GIR_EraseRootFromParent_Done,
     /* 313612 */ // Label 6374: @313612
     /* 313612 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(313801), // Rule ID 6350 //
     /* 313617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313627 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313635 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313638 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313645 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313651 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 313658 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313658 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 313661 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 313665 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313685 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 313692 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 313695 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313699 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313706 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313709 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313713 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313718 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 313721 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 313724 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 313727 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313732 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313754 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313757 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313774 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313781 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313786 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313799 */   GIR_RootConstrainSelectedInstOperands,
     /* 313800 */   // GIR_Coverage, 6350,
     /* 313800 */   GIR_EraseRootFromParent_Done,
     /* 313801 */ // Label 6375: @313801
     /* 313801 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(314034), // Rule ID 6347 //
     /* 313806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313824 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313827 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313834 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313838 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313840 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 313847 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313847 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313850 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 313854 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 313869 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313876 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313879 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313883 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313890 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313893 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313897 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313902 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313905 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313908 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313911 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313916 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313921 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313926 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313929 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313933 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313938 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313941 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313946 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313949 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313953 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313958 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313965 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313970 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313975 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313978 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313982 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313987 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313990 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314007 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314019 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314032 */   GIR_RootConstrainSelectedInstOperands,
     /* 314033 */   // GIR_Coverage, 6347,
     /* 314033 */   GIR_EraseRootFromParent_Done,
     /* 314034 */ // Label 6376: @314034
     /* 314034 */ GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(314267), // Rule ID 6348 //
     /* 314039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314049 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314053 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314057 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314060 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314067 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314073 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 314080 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314080 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 314083 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 314087 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314102 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 314109 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 314112 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314116 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 314123 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 314126 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314130 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314135 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 314138 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 314141 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 314144 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314149 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314154 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314159 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 314162 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314166 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314171 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314174 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314179 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314182 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314186 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314191 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314198 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314203 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314208 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314211 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314215 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314220 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314223 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314240 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314265 */   GIR_RootConstrainSelectedInstOperands,
     /* 314266 */   // GIR_Coverage, 6348,
     /* 314266 */   GIR_EraseRootFromParent_Done,
     /* 314267 */ // Label 6377: @314267
     /* 314267 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(314451), // Rule ID 6351 //
     /* 314272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314290 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314293 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314300 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314306 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 314313 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314313 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314316 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 314320 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314330 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314335 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314342 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314345 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314349 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314356 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314359 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314363 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314368 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314371 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314374 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314377 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314382 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314387 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314392 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314395 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314399 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314404 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314407 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314424 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314436 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314449 */   GIR_RootConstrainSelectedInstOperands,
     /* 314450 */   // GIR_Coverage, 6351,
     /* 314450 */   GIR_EraseRootFromParent_Done,
     /* 314451 */ // Label 6378: @314451
     /* 314451 */ GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(314635), // Rule ID 6352 //
     /* 314456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314474 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314477 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314484 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314490 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 314497 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314497 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314500 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 314504 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314519 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314526 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314529 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314533 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314540 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314543 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314547 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314552 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314555 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314558 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314561 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314566 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314571 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314576 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314579 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314583 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314588 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314591 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314608 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314615 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314620 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314633 */   GIR_RootConstrainSelectedInstOperands,
     /* 314634 */   // GIR_Coverage, 6352,
     /* 314634 */   GIR_EraseRootFromParent_Done,
     /* 314635 */ // Label 6379: @314635
     /* 314635 */ GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(314715), // Rule ID 5304 //
     /* 314640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314658 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314662 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314666 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314671 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314675 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314677 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 314677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314689 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314700 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314713 */   GIR_RootConstrainSelectedInstOperands,
     /* 314714 */   // GIR_Coverage, 5304,
     /* 314714 */   GIR_EraseRootFromParent_Done,
     /* 314715 */ // Label 6380: @314715
     /* 314715 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(314772), // Rule ID 5287 //
     /* 314720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 314723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 314738 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314744 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 314744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 314751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314756 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314760 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 314762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314767 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314770 */   GIR_RootConstrainSelectedInstOperands,
     /* 314771 */   // GIR_Coverage, 5287,
     /* 314771 */   GIR_EraseRootFromParent_Done,
     /* 314772 */ // Label 6381: @314772
     /* 314772 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(314802), // Rule ID 445 //
     /* 314777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 314791 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 314791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 314796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314800 */   GIR_RootConstrainSelectedInstOperands,
     /* 314801 */   // GIR_Coverage, 445,
     /* 314801 */   GIR_Done,
     /* 314802 */ // Label 6382: @314802
     /* 314802 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(314832), // Rule ID 451 //
     /* 314807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 314821 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 314821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 314826 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314830 */   GIR_RootConstrainSelectedInstOperands,
     /* 314831 */   // GIR_Coverage, 451,
     /* 314831 */   GIR_Done,
     /* 314832 */ // Label 6383: @314832
     /* 314832 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(314862), // Rule ID 497 //
     /* 314837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 314840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 314843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314851 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 314851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 314856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 314860 */   GIR_RootConstrainSelectedInstOperands,
     /* 314861 */   // GIR_Coverage, 497,
     /* 314861 */   GIR_Done,
     /* 314862 */ // Label 6384: @314862
     /* 314862 */ GIM_Reject,
     /* 314863 */ // Label 6359: @314863
     /* 314863 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(315049), // Rule ID 6357 //
     /* 314868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 314886 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314889 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 314893 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314899 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 314906 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 314906 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 314909 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 314913 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314923 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314933 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314940 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314943 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314947 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314966 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314969 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314972 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 314975 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314980 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314985 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314990 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314993 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 314997 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315002 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315005 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315022 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315034 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315047 */   GIR_RootConstrainSelectedInstOperands,
     /* 315048 */   // GIR_Coverage, 6357,
     /* 315048 */   GIR_EraseRootFromParent_Done,
     /* 315049 */ // Label 6385: @315049
     /* 315049 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(315235), // Rule ID 6358 //
     /* 315054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315072 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315079 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315085 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 315092 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315092 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315095 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 315099 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315119 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315126 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315129 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315133 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315140 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315143 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315147 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315152 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315155 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315158 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315161 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315166 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315171 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315176 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315179 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315183 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315188 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315191 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315196 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315199 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315203 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315208 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315220 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315233 */   GIR_RootConstrainSelectedInstOperands,
     /* 315234 */   // GIR_Coverage, 6358,
     /* 315234 */   GIR_EraseRootFromParent_Done,
     /* 315235 */ // Label 6386: @315235
     /* 315235 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(315473), // Rule ID 6353 //
     /* 315240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315258 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315261 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315268 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315274 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 315281 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315281 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315284 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 315288 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315308 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315315 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315318 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315322 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315329 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315332 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315336 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315341 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315344 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315347 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 315350 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315355 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315360 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315365 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315368 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315372 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315377 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315380 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315385 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315388 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315392 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315397 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315404 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315409 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315414 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315417 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315421 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315426 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315429 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315446 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315453 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315471 */   GIR_RootConstrainSelectedInstOperands,
     /* 315472 */   // GIR_Coverage, 6353,
     /* 315472 */   GIR_EraseRootFromParent_Done,
     /* 315473 */ // Label 6387: @315473
     /* 315473 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(315711), // Rule ID 6354 //
     /* 315478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315488 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315492 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315496 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315499 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315506 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315510 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315512 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 315519 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315519 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315522 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 315526 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315546 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315553 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315556 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315560 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315567 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315570 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315574 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315579 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315582 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315585 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 315588 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315593 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315598 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315603 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315606 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315610 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315615 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315618 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315621 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315623 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315626 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315630 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315635 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315642 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315647 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315652 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315655 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315659 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315664 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315667 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315684 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315691 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315696 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315709 */   GIR_RootConstrainSelectedInstOperands,
     /* 315710 */   // GIR_Coverage, 6354,
     /* 315710 */   GIR_EraseRootFromParent_Done,
     /* 315711 */ // Label 6388: @315711
     /* 315711 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(315892), // Rule ID 6359 //
     /* 315716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315734 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315737 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315741 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315747 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 315754 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315754 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315757 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 315761 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315776 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315783 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315786 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315790 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315797 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315800 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315804 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315809 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315812 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315815 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315818 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315823 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315828 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315845 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315848 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315865 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315890 */   GIR_RootConstrainSelectedInstOperands,
     /* 315891 */   // GIR_Coverage, 6359,
     /* 315891 */   GIR_EraseRootFromParent_Done,
     /* 315892 */ // Label 6389: @315892
     /* 315892 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(316073), // Rule ID 6360 //
     /* 315897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315915 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315922 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315926 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315928 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 315935 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315935 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315938 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 315942 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315957 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315964 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315967 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315971 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315978 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315981 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315985 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315990 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315993 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315996 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315999 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316004 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316009 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316014 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316017 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316021 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316026 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316029 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316046 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316071 */   GIR_RootConstrainSelectedInstOperands,
     /* 316072 */   // GIR_Coverage, 6360,
     /* 316072 */   GIR_EraseRootFromParent_Done,
     /* 316073 */ // Label 6390: @316073
     /* 316073 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(316306), // Rule ID 6355 //
     /* 316078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316096 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316099 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316106 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316112 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 316119 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316119 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316122 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 316126 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316131 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316141 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316148 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316151 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316155 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316162 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316165 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316169 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316174 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316177 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316180 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316183 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316188 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316193 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316198 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316201 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316205 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316210 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316213 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316218 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316221 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316225 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316230 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316237 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316242 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316247 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316250 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316254 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316259 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316262 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316279 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316286 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316291 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316304 */   GIR_RootConstrainSelectedInstOperands,
     /* 316305 */   // GIR_Coverage, 6355,
     /* 316305 */   GIR_EraseRootFromParent_Done,
     /* 316306 */ // Label 6391: @316306
     /* 316306 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(316539), // Rule ID 6356 //
     /* 316311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316321 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316325 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316329 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316332 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316339 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316345 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 316352 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316352 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316355 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 316359 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316374 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316381 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316384 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316388 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316395 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316398 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316402 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316407 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316410 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316413 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316416 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316421 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316426 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316431 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316434 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316438 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316443 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316446 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316451 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316454 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316458 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316463 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316470 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316475 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316480 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316483 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316487 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316492 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316495 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316512 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316537 */   GIR_RootConstrainSelectedInstOperands,
     /* 316538 */   // GIR_Coverage, 6356,
     /* 316538 */   GIR_EraseRootFromParent_Done,
     /* 316539 */ // Label 6392: @316539
     /* 316539 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(316619), // Rule ID 5306 //
     /* 316544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316562 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316566 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316570 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316575 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316581 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 316581 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316584 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316588 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316593 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316599 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316617 */   GIR_RootConstrainSelectedInstOperands,
     /* 316618 */   // GIR_Coverage, 5306,
     /* 316618 */   GIR_EraseRootFromParent_Done,
     /* 316619 */ // Label 6393: @316619
     /* 316619 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(316676), // Rule ID 5283 //
     /* 316624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 316627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316634 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316638 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 316642 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316648 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 316648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 316655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316660 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 316664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316674 */   GIR_RootConstrainSelectedInstOperands,
     /* 316675 */   // GIR_Coverage, 5283,
     /* 316675 */   GIR_EraseRootFromParent_Done,
     /* 316676 */ // Label 6394: @316676
     /* 316676 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(316706), // Rule ID 447 //
     /* 316681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 316695 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 316695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 316700 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316704 */   GIR_RootConstrainSelectedInstOperands,
     /* 316705 */   // GIR_Coverage, 447,
     /* 316705 */   GIR_Done,
     /* 316706 */ // Label 6395: @316706
     /* 316706 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(316736), // Rule ID 453 //
     /* 316711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 316717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 316725 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 316725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 316730 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316734 */   GIR_RootConstrainSelectedInstOperands,
     /* 316735 */   // GIR_Coverage, 453,
     /* 316735 */   GIR_Done,
     /* 316736 */ // Label 6396: @316736
     /* 316736 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(316766), // Rule ID 493 //
     /* 316741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 316744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316755 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 316755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 316760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316764 */   GIR_RootConstrainSelectedInstOperands,
     /* 316765 */   // GIR_Coverage, 493,
     /* 316765 */   GIR_Done,
     /* 316766 */ // Label 6397: @316766
     /* 316766 */ GIM_Reject,
     /* 316767 */ // Label 6360: @316767
     /* 316767 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(316797), // Rule ID 1017 //
     /* 316772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316786 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 316786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 316791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316795 */   GIR_RootConstrainSelectedInstOperands,
     /* 316796 */   // GIR_Coverage, 1017,
     /* 316796 */   GIR_Done,
     /* 316797 */ // Label 6398: @316797
     /* 316797 */ GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(316840), // Rule ID 13037 //
     /* 316802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316812 */   // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 316812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 316815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 316819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316824 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 316828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 316833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316838 */   GIR_RootConstrainSelectedInstOperands,
     /* 316839 */   // GIR_Coverage, 13037,
     /* 316839 */   GIR_EraseRootFromParent_Done,
     /* 316840 */ // Label 6399: @316840
     /* 316840 */ GIM_Reject,
     /* 316841 */ // Label 6361: @316841
     /* 316841 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(316871), // Rule ID 1021 //
     /* 316846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316860 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 316860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 316865 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316869 */   GIR_RootConstrainSelectedInstOperands,
     /* 316870 */   // GIR_Coverage, 1021,
     /* 316870 */   GIR_Done,
     /* 316871 */ // Label 6400: @316871
     /* 316871 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(316917), // Rule ID 13035 //
     /* 316876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 316882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316886 */   // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 316886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 316889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316898 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 316902 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 316905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 316907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 316910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316915 */   GIR_RootConstrainSelectedInstOperands,
     /* 316916 */   // GIR_Coverage, 13035,
     /* 316916 */   GIR_EraseRootFromParent_Done,
     /* 316917 */ // Label 6401: @316917
     /* 316917 */ GIM_Reject,
     /* 316918 */ // Label 6362: @316918
     /* 316918 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(316948), // Rule ID 1013 //
     /* 316923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 316929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316937 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 316937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 316942 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316946 */   GIR_RootConstrainSelectedInstOperands,
     /* 316947 */   // GIR_Coverage, 1013,
     /* 316947 */   GIR_Done,
     /* 316948 */ // Label 6402: @316948
     /* 316948 */ GIM_Reject,
     /* 316949 */ // Label 6363: @316949
     /* 316949 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(316979), // Rule ID 1019 //
     /* 316954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 316960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316968 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 316968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 316973 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 316977 */   GIR_RootConstrainSelectedInstOperands,
     /* 316978 */   // GIR_Coverage, 1019,
     /* 316978 */   GIR_Done,
     /* 316979 */ // Label 6403: @316979
     /* 316979 */ GIM_Reject,
     /* 316980 */ // Label 6364: @316980
     /* 316980 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(317010), // Rule ID 1015 //
     /* 316985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 316988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 316991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316999 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 316999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 317004 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317008 */   GIR_RootConstrainSelectedInstOperands,
     /* 317009 */   // GIR_Coverage, 1015,
     /* 317009 */   GIR_Done,
     /* 317010 */ // Label 6404: @317010
     /* 317010 */ GIM_Reject,
     /* 317011 */ // Label 6365: @317011
     /* 317011 */ GIM_Reject,
     /* 317012 */ // Label 68: @317012
     /* 317012 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6413*/ GIMT_Encode4(320786),
     /* 317023 */ /*GILLT_s16*//*Label 6405*/ GIMT_Encode4(317063),
     /* 317027 */ /*GILLT_s32*//*Label 6406*/ GIMT_Encode4(317348),
     /* 317031 */ /*GILLT_s64*//*Label 6407*/ GIMT_Encode4(318676), GIMT_Encode4(0),
     /* 317039 */ /*GILLT_v2s32*//*Label 6408*/ GIMT_Encode4(320542),
     /* 317043 */ /*GILLT_v2s64*//*Label 6409*/ GIMT_Encode4(320616),
     /* 317047 */ /*GILLT_v4s16*//*Label 6410*/ GIMT_Encode4(320693),
     /* 317051 */ /*GILLT_v4s32*//*Label 6411*/ GIMT_Encode4(320724), GIMT_Encode4(0),
     /* 317059 */ /*GILLT_v8s16*//*Label 6412*/ GIMT_Encode4(320755),
     /* 317063 */ // Label 6405: @317063
     /* 317063 */ GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(317170), // Rule ID 5309 //
     /* 317068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 317071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317078 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317082 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 317086 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317090 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 317094 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317098 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317102 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317106 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317110 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317115 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317119 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 317130 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317132 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 317132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 317135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317144 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 317150 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 317163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317168 */   GIR_RootConstrainSelectedInstOperands,
     /* 317169 */   // GIR_Coverage, 5309,
     /* 317169 */   GIR_EraseRootFromParent_Done,
     /* 317170 */ // Label 6414: @317170
     /* 317170 */ GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(317227), // Rule ID 5303 //
     /* 317175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 317178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 317193 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317199 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 317199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 317202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 317206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317211 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 317220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317225 */   GIR_RootConstrainSelectedInstOperands,
     /* 317226 */   // GIR_Coverage, 5303,
     /* 317226 */   GIR_EraseRootFromParent_Done,
     /* 317227 */ // Label 6415: @317227
     /* 317227 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(317257), // Rule ID 467 //
     /* 317232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317246 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 317246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 317251 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317255 */   GIR_RootConstrainSelectedInstOperands,
     /* 317256 */   // GIR_Coverage, 467,
     /* 317256 */   GIR_Done,
     /* 317257 */ // Label 6416: @317257
     /* 317257 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(317287), // Rule ID 473 //
     /* 317262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317276 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 317276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 317281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317285 */   GIR_RootConstrainSelectedInstOperands,
     /* 317286 */   // GIR_Coverage, 473,
     /* 317286 */   GIR_Done,
     /* 317287 */ // Label 6417: @317287
     /* 317287 */ GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(317317), // Rule ID 499 //
     /* 317292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317306 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 317306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 317311 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317315 */   GIR_RootConstrainSelectedInstOperands,
     /* 317316 */   // GIR_Coverage, 499,
     /* 317316 */   GIR_Done,
     /* 317317 */ // Label 6418: @317317
     /* 317317 */ GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(317347), // Rule ID 503 //
     /* 317322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317336 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 317336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 317341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317345 */   GIR_RootConstrainSelectedInstOperands,
     /* 317346 */   // GIR_Coverage, 503,
     /* 317346 */   GIR_Done,
     /* 317347 */ // Label 6419: @317347
     /* 317347 */ GIM_Reject,
     /* 317348 */ // Label 6406: @317348
     /* 317348 */ GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(317488), // Rule ID 5310 //
     /* 317353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317371 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317374 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317381 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317385 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317387 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 317394 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 317394 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317397 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 317401 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317421 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317454 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317457 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317460 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317486 */   GIR_RootConstrainSelectedInstOperands,
     /* 317487 */   // GIR_Coverage, 5310,
     /* 317487 */   GIR_EraseRootFromParent_Done,
     /* 317488 */ // Label 6420: @317488
     /* 317488 */ GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(317628), // Rule ID 5311 //
     /* 317493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317503 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317507 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317511 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317514 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317521 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317525 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317527 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 317534 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 317534 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317537 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 317541 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317561 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317568 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317571 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317575 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317594 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317597 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317600 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317608 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317613 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 317618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317623 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317626 */   GIR_RootConstrainSelectedInstOperands,
     /* 317627 */   // GIR_Coverage, 5311,
     /* 317627 */   GIR_EraseRootFromParent_Done,
     /* 317628 */ // Label 6421: @317628
     /* 317628 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(317768), // Rule ID 5314 //
     /* 317633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317651 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317654 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317661 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317665 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317667 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 317674 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 317674 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 317677 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 317681 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317701 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317708 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317711 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317715 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317734 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317737 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317740 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 317743 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317753 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317766 */   GIR_RootConstrainSelectedInstOperands,
     /* 317767 */   // GIR_Coverage, 5314,
     /* 317767 */   GIR_EraseRootFromParent_Done,
     /* 317768 */ // Label 6422: @317768
     /* 317768 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(317908), // Rule ID 5315 //
     /* 317773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317791 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317794 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 317801 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317807 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 317814 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 317814 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 317817 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 317821 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317841 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317848 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317851 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317855 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317874 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317877 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317880 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 317883 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317888 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317893 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 317901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317906 */   GIR_RootConstrainSelectedInstOperands,
     /* 317907 */   // GIR_Coverage, 5315,
     /* 317907 */   GIR_EraseRootFromParent_Done,
     /* 317908 */ // Label 6423: @317908
     /* 317908 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(318043), // Rule ID 5312 //
     /* 317913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317923 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317927 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317931 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317934 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317941 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317947 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 317954 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 317954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 317961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 317976 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317983 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317986 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317990 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318009 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318015 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318028 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318041 */   GIR_RootConstrainSelectedInstOperands,
     /* 318042 */   // GIR_Coverage, 5312,
     /* 318042 */   GIR_EraseRootFromParent_Done,
     /* 318043 */ // Label 6424: @318043
     /* 318043 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(318178), // Rule ID 5313 //
     /* 318048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318058 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318066 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318069 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318076 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318082 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 318089 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 318089 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318092 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 318096 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318111 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318118 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318121 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318125 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318144 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318147 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318150 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318158 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318163 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318176 */   GIR_RootConstrainSelectedInstOperands,
     /* 318177 */   // GIR_Coverage, 5313,
     /* 318177 */   GIR_EraseRootFromParent_Done,
     /* 318178 */ // Label 6425: @318178
     /* 318178 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(318313), // Rule ID 5316 //
     /* 318183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318193 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318201 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318204 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318211 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318215 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318217 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 318224 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 318224 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318227 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 318231 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318246 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318253 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318256 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318260 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318279 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318282 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318285 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318311 */   GIR_RootConstrainSelectedInstOperands,
     /* 318312 */   // GIR_Coverage, 5316,
     /* 318312 */   GIR_EraseRootFromParent_Done,
     /* 318313 */ // Label 6426: @318313
     /* 318313 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(318448), // Rule ID 5317 //
     /* 318318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318336 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318339 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318346 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318350 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318352 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 318359 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 318359 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318362 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 318366 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318381 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318388 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318391 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318395 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318414 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318417 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318420 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318428 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318446 */   GIR_RootConstrainSelectedInstOperands,
     /* 318447 */   // GIR_Coverage, 5317,
     /* 318447 */   GIR_EraseRootFromParent_Done,
     /* 318448 */ // Label 6427: @318448
     /* 318448 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(318528), // Rule ID 5305 //
     /* 318453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318471 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318479 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318484 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318490 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 318490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318502 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 318508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318526 */   GIR_RootConstrainSelectedInstOperands,
     /* 318527 */   // GIR_Coverage, 5305,
     /* 318527 */   GIR_EraseRootFromParent_Done,
     /* 318528 */ // Label 6428: @318528
     /* 318528 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(318585), // Rule ID 5295 //
     /* 318533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 318551 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318555 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318557 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 318557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 318564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318569 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 318575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318583 */   GIR_RootConstrainSelectedInstOperands,
     /* 318584 */   // GIR_Coverage, 5295,
     /* 318584 */   GIR_EraseRootFromParent_Done,
     /* 318585 */ // Label 6429: @318585
     /* 318585 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(318615), // Rule ID 469 //
     /* 318590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 318604 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 318604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 318609 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318613 */   GIR_RootConstrainSelectedInstOperands,
     /* 318614 */   // GIR_Coverage, 469,
     /* 318614 */   GIR_Done,
     /* 318615 */ // Label 6430: @318615
     /* 318615 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(318645), // Rule ID 475 //
     /* 318620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 318634 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 318634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 318639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318643 */   GIR_RootConstrainSelectedInstOperands,
     /* 318644 */   // GIR_Coverage, 475,
     /* 318644 */   GIR_Done,
     /* 318645 */ // Label 6431: @318645
     /* 318645 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(318675), // Rule ID 505 //
     /* 318650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 318653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 318656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318664 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 318664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 318669 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318673 */   GIR_RootConstrainSelectedInstOperands,
     /* 318674 */   // GIR_Coverage, 505,
     /* 318674 */   GIR_Done,
     /* 318675 */ // Label 6432: @318675
     /* 318675 */ GIM_Reject,
     /* 318676 */ // Label 6407: @318676
     /* 318676 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(318813), // Rule ID 5326 //
     /* 318681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318699 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318702 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318706 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318710 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318712 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 318719 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 318719 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 318722 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 318726 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318746 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318753 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318756 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318760 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318779 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318782 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318785 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318811 */   GIR_RootConstrainSelectedInstOperands,
     /* 318812 */   // GIR_Coverage, 5326,
     /* 318812 */   GIR_EraseRootFromParent_Done,
     /* 318813 */ // Label 6433: @318813
     /* 318813 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(318950), // Rule ID 5327 //
     /* 318818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 318836 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318839 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 318843 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318849 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 318856 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 318856 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 318859 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 318863 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318883 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318888 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318890 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 318893 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318897 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318916 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318919 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318922 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318925 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318930 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318935 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 318943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318945 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318948 */   GIR_RootConstrainSelectedInstOperands,
     /* 318949 */   // GIR_Coverage, 5327,
     /* 318949 */   GIR_EraseRootFromParent_Done,
     /* 318950 */ // Label 6434: @318950
     /* 318950 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(319090), // Rule ID 5318 //
     /* 318955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318973 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318976 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318983 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318987 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318989 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 318996 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 318996 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318999 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 319003 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319023 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319030 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319033 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319037 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319056 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319059 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319062 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319065 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319070 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319075 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319088 */   GIR_RootConstrainSelectedInstOperands,
     /* 319089 */   // GIR_Coverage, 5318,
     /* 319089 */   GIR_EraseRootFromParent_Done,
     /* 319090 */ // Label 6435: @319090
     /* 319090 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(319230), // Rule ID 5319 //
     /* 319095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319105 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319113 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319116 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319123 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319127 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319129 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 319136 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 319136 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319139 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 319143 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319153 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319163 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319170 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319173 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319177 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319196 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319199 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319202 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319205 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319210 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319215 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319228 */   GIR_RootConstrainSelectedInstOperands,
     /* 319229 */   // GIR_Coverage, 5319,
     /* 319229 */   GIR_EraseRootFromParent_Done,
     /* 319230 */ // Label 6436: @319230
     /* 319230 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(319370), // Rule ID 5322 //
     /* 319235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319253 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319256 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319263 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319269 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 319276 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319276 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319279 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 319283 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319298 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319303 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319310 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319313 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319317 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319339 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319342 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319345 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319355 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319368 */   GIR_RootConstrainSelectedInstOperands,
     /* 319369 */   // GIR_Coverage, 5322,
     /* 319369 */   GIR_EraseRootFromParent_Done,
     /* 319370 */ // Label 6437: @319370
     /* 319370 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(319510), // Rule ID 5323 //
     /* 319375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319393 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319396 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319403 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319409 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 319416 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 319423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319443 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319450 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319453 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319457 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319476 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319479 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319482 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319490 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319508 */   GIR_RootConstrainSelectedInstOperands,
     /* 319509 */   // GIR_Coverage, 5323,
     /* 319509 */   GIR_EraseRootFromParent_Done,
     /* 319510 */ // Label 6438: @319510
     /* 319510 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(319642), // Rule ID 5328 //
     /* 319515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319525 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319533 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319536 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319540 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319546 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 319553 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 319553 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319556 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 319560 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319575 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319608 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319611 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319614 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319640 */   GIR_RootConstrainSelectedInstOperands,
     /* 319641 */   // GIR_Coverage, 5328,
     /* 319641 */   GIR_EraseRootFromParent_Done,
     /* 319642 */ // Label 6439: @319642
     /* 319642 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(319774), // Rule ID 5329 //
     /* 319647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319657 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319661 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319665 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319668 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319672 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319678 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 319685 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 319685 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319688 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 319692 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319707 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319714 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319717 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319721 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319726 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319740 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319743 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319746 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319754 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319759 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319772 */   GIR_RootConstrainSelectedInstOperands,
     /* 319773 */   // GIR_Coverage, 5329,
     /* 319773 */   GIR_EraseRootFromParent_Done,
     /* 319774 */ // Label 6440: @319774
     /* 319774 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(319909), // Rule ID 5320 //
     /* 319779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319797 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319800 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319807 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319813 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 319820 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 319820 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319823 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 319827 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319842 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319849 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319852 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319856 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319863 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319866 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319870 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319875 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319878 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319881 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319907 */   GIR_RootConstrainSelectedInstOperands,
     /* 319908 */   // GIR_Coverage, 5320,
     /* 319908 */   GIR_EraseRootFromParent_Done,
     /* 319909 */ // Label 6441: @319909
     /* 319909 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(320044), // Rule ID 5321 //
     /* 319914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319924 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319932 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319935 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319942 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319948 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 319955 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 319955 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319958 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 319962 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 319977 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319984 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319987 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319991 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320010 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320013 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320016 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320019 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320042 */   GIR_RootConstrainSelectedInstOperands,
     /* 320043 */   // GIR_Coverage, 5321,
     /* 320043 */   GIR_EraseRootFromParent_Done,
     /* 320044 */ // Label 6442: @320044
     /* 320044 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(320179), // Rule ID 5324 //
     /* 320049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320067 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320070 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320077 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320083 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 320090 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 320090 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320093 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 320097 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320107 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320112 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320119 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320122 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320126 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320145 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320148 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320151 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320164 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320177 */   GIR_RootConstrainSelectedInstOperands,
     /* 320178 */   // GIR_Coverage, 5324,
     /* 320178 */   GIR_EraseRootFromParent_Done,
     /* 320179 */ // Label 6443: @320179
     /* 320179 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(320314), // Rule ID 5325 //
     /* 320184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320194 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320202 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320205 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320212 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320216 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320218 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 320225 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 320225 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320228 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 320232 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320247 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320254 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320257 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320261 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320280 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320283 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320286 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320294 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320299 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320312 */   GIR_RootConstrainSelectedInstOperands,
     /* 320313 */   // GIR_Coverage, 5325,
     /* 320313 */   GIR_EraseRootFromParent_Done,
     /* 320314 */ // Label 6444: @320314
     /* 320314 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(320394), // Rule ID 5307 //
     /* 320319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320329 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320333 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320337 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320341 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320350 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320356 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 320356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320368 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320374 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320392 */   GIR_RootConstrainSelectedInstOperands,
     /* 320393 */   // GIR_Coverage, 5307,
     /* 320393 */   GIR_EraseRootFromParent_Done,
     /* 320394 */ // Label 6445: @320394
     /* 320394 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(320451), // Rule ID 5291 //
     /* 320399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 320417 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320421 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320423 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 320423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 320430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320435 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320449 */   GIR_RootConstrainSelectedInstOperands,
     /* 320450 */   // GIR_Coverage, 5291,
     /* 320450 */   GIR_EraseRootFromParent_Done,
     /* 320451 */ // Label 6446: @320451
     /* 320451 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(320481), // Rule ID 471 //
     /* 320456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320470 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 320470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 320475 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320479 */   GIR_RootConstrainSelectedInstOperands,
     /* 320480 */   // GIR_Coverage, 471,
     /* 320480 */   GIR_Done,
     /* 320481 */ // Label 6447: @320481
     /* 320481 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(320511), // Rule ID 477 //
     /* 320486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320500 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 320500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 320505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320509 */   GIR_RootConstrainSelectedInstOperands,
     /* 320510 */   // GIR_Coverage, 477,
     /* 320510 */   GIR_Done,
     /* 320511 */ // Label 6448: @320511
     /* 320511 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(320541), // Rule ID 501 //
     /* 320516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 320519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320530 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 320530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 320535 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320539 */   GIR_RootConstrainSelectedInstOperands,
     /* 320540 */   // GIR_Coverage, 501,
     /* 320540 */   GIR_Done,
     /* 320541 */ // Label 6449: @320541
     /* 320541 */ GIM_Reject,
     /* 320542 */ // Label 6408: @320542
     /* 320542 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(320572), // Rule ID 1078 //
     /* 320547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320561 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 320561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 320566 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320570 */   GIR_RootConstrainSelectedInstOperands,
     /* 320571 */   // GIR_Coverage, 1078,
     /* 320571 */   GIR_Done,
     /* 320572 */ // Label 6450: @320572
     /* 320572 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(320615), // Rule ID 13038 //
     /* 320577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320587 */   // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 320587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 320594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 320603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 320608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320613 */   GIR_RootConstrainSelectedInstOperands,
     /* 320614 */   // GIR_Coverage, 13038,
     /* 320614 */   GIR_EraseRootFromParent_Done,
     /* 320615 */ // Label 6451: @320615
     /* 320615 */ GIM_Reject,
     /* 320616 */ // Label 6409: @320616
     /* 320616 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(320646), // Rule ID 1082 //
     /* 320621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320635 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 320635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 320640 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320644 */   GIR_RootConstrainSelectedInstOperands,
     /* 320645 */   // GIR_Coverage, 1082,
     /* 320645 */   GIR_Done,
     /* 320646 */ // Label 6452: @320646
     /* 320646 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(320692), // Rule ID 13036 //
     /* 320651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320661 */   // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 320661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 320668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320673 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 320677 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 320685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320690 */   GIR_RootConstrainSelectedInstOperands,
     /* 320691 */   // GIR_Coverage, 13036,
     /* 320691 */   GIR_EraseRootFromParent_Done,
     /* 320692 */ // Label 6453: @320692
     /* 320692 */ GIM_Reject,
     /* 320693 */ // Label 6410: @320693
     /* 320693 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(320723), // Rule ID 1074 //
     /* 320698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 320704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320712 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 320712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 320717 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320721 */   GIR_RootConstrainSelectedInstOperands,
     /* 320722 */   // GIR_Coverage, 1074,
     /* 320722 */   GIR_Done,
     /* 320723 */ // Label 6454: @320723
     /* 320723 */ GIM_Reject,
     /* 320724 */ // Label 6411: @320724
     /* 320724 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(320754), // Rule ID 1080 //
     /* 320729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 320735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320743 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 320743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 320748 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320752 */   GIR_RootConstrainSelectedInstOperands,
     /* 320753 */   // GIR_Coverage, 1080,
     /* 320753 */   GIR_Done,
     /* 320754 */ // Label 6455: @320754
     /* 320754 */ GIM_Reject,
     /* 320755 */ // Label 6412: @320755
     /* 320755 */ GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(320785), // Rule ID 1076 //
     /* 320760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 320763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 320766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320774 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 320774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 320779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320783 */   GIR_RootConstrainSelectedInstOperands,
     /* 320784 */   // GIR_Coverage, 1076,
     /* 320784 */   GIR_Done,
     /* 320785 */ // Label 6456: @320785
     /* 320785 */ GIM_Reject,
     /* 320786 */ // Label 6413: @320786
     /* 320786 */ GIM_Reject,
     /* 320787 */ // Label 69: @320787
     /* 320787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6464*/ GIMT_Encode4(321106),
     /* 320798 */ /*GILLT_s32*//*Label 6457*/ GIMT_Encode4(320834),
     /* 320802 */ /*GILLT_s64*//*Label 6458*/ GIMT_Encode4(320907), GIMT_Encode4(0),
     /* 320810 */ /*GILLT_v2s32*//*Label 6459*/ GIMT_Encode4(320980),
     /* 320814 */ /*GILLT_v2s64*//*Label 6460*/ GIMT_Encode4(321004),
     /* 320818 */ /*GILLT_v4s16*//*Label 6461*/ GIMT_Encode4(321028),
     /* 320822 */ /*GILLT_v4s32*//*Label 6462*/ GIMT_Encode4(321055), GIMT_Encode4(0),
     /* 320830 */ /*GILLT_v8s16*//*Label 6463*/ GIMT_Encode4(321079),
     /* 320834 */ // Label 6457: @320834
     /* 320834 */ GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(320860), // Rule ID 4571 //
     /* 320839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320849 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 320849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 320854 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320858 */   GIR_RootConstrainSelectedInstOperands,
     /* 320859 */   // GIR_Coverage, 4571,
     /* 320859 */   GIR_Done,
     /* 320860 */ // Label 6465: @320860
     /* 320860 */ GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(320883), // Rule ID 4573 //
     /* 320865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320872 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 320872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 320877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320881 */   GIR_RootConstrainSelectedInstOperands,
     /* 320882 */   // GIR_Coverage, 4573,
     /* 320882 */   GIR_Done,
     /* 320883 */ // Label 6466: @320883
     /* 320883 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(320906), // Rule ID 4575 //
     /* 320888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 320895 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 320895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 320900 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320904 */   GIR_RootConstrainSelectedInstOperands,
     /* 320905 */   // GIR_Coverage, 4575,
     /* 320905 */   GIR_Done,
     /* 320906 */ // Label 6467: @320906
     /* 320906 */ GIM_Reject,
     /* 320907 */ // Label 6458: @320907
     /* 320907 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(320933), // Rule ID 4572 //
     /* 320912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 320915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 320918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320922 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 320922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 320927 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320931 */   GIR_RootConstrainSelectedInstOperands,
     /* 320932 */   // GIR_Coverage, 4572,
     /* 320932 */   GIR_Done,
     /* 320933 */ // Label 6468: @320933
     /* 320933 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(320956), // Rule ID 4574 //
     /* 320938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320945 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 320945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 320950 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320954 */   GIR_RootConstrainSelectedInstOperands,
     /* 320955 */   // GIR_Coverage, 4574,
     /* 320955 */   GIR_Done,
     /* 320956 */ // Label 6469: @320956
     /* 320956 */ GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(320979), // Rule ID 4576 //
     /* 320961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 320968 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 320968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 320973 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 320977 */   GIR_RootConstrainSelectedInstOperands,
     /* 320978 */   // GIR_Coverage, 4576,
     /* 320978 */   GIR_Done,
     /* 320979 */ // Label 6470: @320979
     /* 320979 */ GIM_Reject,
     /* 320980 */ // Label 6459: @320980
     /* 320980 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(321003), // Rule ID 4912 //
     /* 320985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320992 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 320992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 320997 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321001 */   GIR_RootConstrainSelectedInstOperands,
     /* 321002 */   // GIR_Coverage, 4912,
     /* 321002 */   GIR_Done,
     /* 321003 */ // Label 6471: @321003
     /* 321003 */ GIM_Reject,
     /* 321004 */ // Label 6460: @321004
     /* 321004 */ GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(321027), // Rule ID 4914 //
     /* 321009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321016 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 321016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 321021 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321025 */   GIR_RootConstrainSelectedInstOperands,
     /* 321026 */   // GIR_Coverage, 4914,
     /* 321026 */   GIR_Done,
     /* 321027 */ // Label 6472: @321027
     /* 321027 */ GIM_Reject,
     /* 321028 */ // Label 6461: @321028
     /* 321028 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(321054), // Rule ID 4907 //
     /* 321033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321043 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 321043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 321048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321052 */   GIR_RootConstrainSelectedInstOperands,
     /* 321053 */   // GIR_Coverage, 4907,
     /* 321053 */   GIR_Done,
     /* 321054 */ // Label 6473: @321054
     /* 321054 */ GIM_Reject,
     /* 321055 */ // Label 6462: @321055
     /* 321055 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(321078), // Rule ID 4913 //
     /* 321060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321067 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 321067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 321072 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321076 */   GIR_RootConstrainSelectedInstOperands,
     /* 321077 */   // GIR_Coverage, 4913,
     /* 321077 */   GIR_Done,
     /* 321078 */ // Label 6474: @321078
     /* 321078 */ GIM_Reject,
     /* 321079 */ // Label 6463: @321079
     /* 321079 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(321105), // Rule ID 4908 //
     /* 321084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321094 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 321094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 321099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321103 */   GIR_RootConstrainSelectedInstOperands,
     /* 321104 */   // GIR_Coverage, 4908,
     /* 321104 */   GIR_Done,
     /* 321105 */ // Label 6475: @321105
     /* 321105 */ GIM_Reject,
     /* 321106 */ // Label 6464: @321106
     /* 321106 */ GIM_Reject,
     /* 321107 */ // Label 70: @321107
     /* 321107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6483*/ GIMT_Encode4(321426),
     /* 321118 */ /*GILLT_s32*//*Label 6476*/ GIMT_Encode4(321154),
     /* 321122 */ /*GILLT_s64*//*Label 6477*/ GIMT_Encode4(321227), GIMT_Encode4(0),
     /* 321130 */ /*GILLT_v2s32*//*Label 6478*/ GIMT_Encode4(321300),
     /* 321134 */ /*GILLT_v2s64*//*Label 6479*/ GIMT_Encode4(321324),
     /* 321138 */ /*GILLT_v4s16*//*Label 6480*/ GIMT_Encode4(321348),
     /* 321142 */ /*GILLT_v4s32*//*Label 6481*/ GIMT_Encode4(321375), GIMT_Encode4(0),
     /* 321150 */ /*GILLT_v8s16*//*Label 6482*/ GIMT_Encode4(321399),
     /* 321154 */ // Label 6476: @321154
     /* 321154 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(321180), // Rule ID 4595 //
     /* 321159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321169 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 321169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 321174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321178 */   GIR_RootConstrainSelectedInstOperands,
     /* 321179 */   // GIR_Coverage, 4595,
     /* 321179 */   GIR_Done,
     /* 321180 */ // Label 6484: @321180
     /* 321180 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(321203), // Rule ID 4597 //
     /* 321185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321192 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 321192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 321197 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321201 */   GIR_RootConstrainSelectedInstOperands,
     /* 321202 */   // GIR_Coverage, 4597,
     /* 321202 */   GIR_Done,
     /* 321203 */ // Label 6485: @321203
     /* 321203 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(321226), // Rule ID 4599 //
     /* 321208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321215 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 321215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 321220 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321224 */   GIR_RootConstrainSelectedInstOperands,
     /* 321225 */   // GIR_Coverage, 4599,
     /* 321225 */   GIR_Done,
     /* 321226 */ // Label 6486: @321226
     /* 321226 */ GIM_Reject,
     /* 321227 */ // Label 6477: @321227
     /* 321227 */ GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(321253), // Rule ID 4596 //
     /* 321232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321242 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 321242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 321247 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321251 */   GIR_RootConstrainSelectedInstOperands,
     /* 321252 */   // GIR_Coverage, 4596,
     /* 321252 */   GIR_Done,
     /* 321253 */ // Label 6487: @321253
     /* 321253 */ GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(321276), // Rule ID 4598 //
     /* 321258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321265 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 321265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 321270 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321274 */   GIR_RootConstrainSelectedInstOperands,
     /* 321275 */   // GIR_Coverage, 4598,
     /* 321275 */   GIR_Done,
     /* 321276 */ // Label 6488: @321276
     /* 321276 */ GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(321299), // Rule ID 4600 //
     /* 321281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321288 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 321288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 321293 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321297 */   GIR_RootConstrainSelectedInstOperands,
     /* 321298 */   // GIR_Coverage, 4600,
     /* 321298 */   GIR_Done,
     /* 321299 */ // Label 6489: @321299
     /* 321299 */ GIM_Reject,
     /* 321300 */ // Label 6478: @321300
     /* 321300 */ GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(321323), // Rule ID 4922 //
     /* 321305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321312 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 321312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 321317 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321321 */   GIR_RootConstrainSelectedInstOperands,
     /* 321322 */   // GIR_Coverage, 4922,
     /* 321322 */   GIR_Done,
     /* 321323 */ // Label 6490: @321323
     /* 321323 */ GIM_Reject,
     /* 321324 */ // Label 6479: @321324
     /* 321324 */ GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(321347), // Rule ID 4924 //
     /* 321329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321336 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 321336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 321341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321345 */   GIR_RootConstrainSelectedInstOperands,
     /* 321346 */   // GIR_Coverage, 4924,
     /* 321346 */   GIR_Done,
     /* 321347 */ // Label 6491: @321347
     /* 321347 */ GIM_Reject,
     /* 321348 */ // Label 6480: @321348
     /* 321348 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(321374), // Rule ID 4917 //
     /* 321353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321363 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 321363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 321368 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321372 */   GIR_RootConstrainSelectedInstOperands,
     /* 321373 */   // GIR_Coverage, 4917,
     /* 321373 */   GIR_Done,
     /* 321374 */ // Label 6492: @321374
     /* 321374 */ GIM_Reject,
     /* 321375 */ // Label 6481: @321375
     /* 321375 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(321398), // Rule ID 4923 //
     /* 321380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321387 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 321387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 321392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321396 */   GIR_RootConstrainSelectedInstOperands,
     /* 321397 */   // GIR_Coverage, 4923,
     /* 321397 */   GIR_Done,
     /* 321398 */ // Label 6493: @321398
     /* 321398 */ GIM_Reject,
     /* 321399 */ // Label 6482: @321399
     /* 321399 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(321425), // Rule ID 4918 //
     /* 321404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321414 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 321414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 321419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321423 */   GIR_RootConstrainSelectedInstOperands,
     /* 321424 */   // GIR_Coverage, 4918,
     /* 321424 */   GIR_Done,
     /* 321425 */ // Label 6494: @321425
     /* 321425 */ GIM_Reject,
     /* 321426 */ // Label 6483: @321426
     /* 321426 */ GIM_Reject,
     /* 321427 */ // Label 71: @321427
     /* 321427 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6503*/ GIMT_Encode4(322283),
     /* 321438 */ /*GILLT_s16*//*Label 6495*/ GIMT_Encode4(321478),
     /* 321442 */ /*GILLT_s32*//*Label 6496*/ GIMT_Encode4(321697),
     /* 321446 */ /*GILLT_s64*//*Label 6497*/ GIMT_Encode4(321771), GIMT_Encode4(0),
     /* 321454 */ /*GILLT_v2s32*//*Label 6498*/ GIMT_Encode4(321845),
     /* 321458 */ /*GILLT_v2s64*//*Label 6499*/ GIMT_Encode4(321919),
     /* 321462 */ /*GILLT_v4s16*//*Label 6500*/ GIMT_Encode4(321993),
     /* 321466 */ /*GILLT_v4s32*//*Label 6501*/ GIMT_Encode4(322101), GIMT_Encode4(0),
     /* 321474 */ /*GILLT_v8s16*//*Label 6502*/ GIMT_Encode4(322175),
     /* 321478 */ // Label 6495: @321478
     /* 321478 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(321696),
     /* 321483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321490 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(321531), // Rule ID 5193 //
     /* 321495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 321514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321516 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 321516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 321519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321529 */     GIR_RootConstrainSelectedInstOperands,
     /* 321530 */     // GIR_Coverage, 5193,
     /* 321530 */     GIR_EraseRootFromParent_Done,
     /* 321531 */   // Label 6505: @321531
     /* 321531 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(321550), // Rule ID 521 //
     /* 321536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321543 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 321543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 321548 */     GIR_RootConstrainSelectedInstOperands,
     /* 321549 */     // GIR_Coverage, 521,
     /* 321549 */     GIR_Done,
     /* 321550 */   // Label 6506: @321550
     /* 321550 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(321695), // Rule ID 6339 //
     /* 321555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321559 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 321559 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 321562 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 321566 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 321573 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 321576 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 321580 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321585 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 321588 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 321592 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 321595 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321600 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321605 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321610 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 321613 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321617 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321622 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 321625 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 321633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 321637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321642 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 321645 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 321650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 321652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 321655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 321667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 321675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321677 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 321684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 321689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321694 */     // GIR_Coverage, 6339,
     /* 321694 */     GIR_EraseRootFromParent_Done,
     /* 321695 */   // Label 6507: @321695
     /* 321695 */   GIM_Reject,
     /* 321696 */ // Label 6504: @321696
     /* 321696 */ GIM_Reject,
     /* 321697 */ // Label 6496: @321697
     /* 321697 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(321770),
     /* 321702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321709 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(321750), // Rule ID 5194 //
     /* 321714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 321729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 321733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321735 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 321735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 321738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321748 */     GIR_RootConstrainSelectedInstOperands,
     /* 321749 */     // GIR_Coverage, 5194,
     /* 321749 */     GIR_EraseRootFromParent_Done,
     /* 321750 */   // Label 6509: @321750
     /* 321750 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(321769), // Rule ID 522 //
     /* 321755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321762 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 321762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 321767 */     GIR_RootConstrainSelectedInstOperands,
     /* 321768 */     // GIR_Coverage, 522,
     /* 321768 */     GIR_Done,
     /* 321769 */   // Label 6510: @321769
     /* 321769 */   GIM_Reject,
     /* 321770 */ // Label 6508: @321770
     /* 321770 */ GIM_Reject,
     /* 321771 */ // Label 6497: @321771
     /* 321771 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(321844),
     /* 321776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321783 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(321824), // Rule ID 5195 //
     /* 321788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321809 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 321809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 321812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321822 */     GIR_RootConstrainSelectedInstOperands,
     /* 321823 */     // GIR_Coverage, 5195,
     /* 321823 */     GIR_EraseRootFromParent_Done,
     /* 321824 */   // Label 6512: @321824
     /* 321824 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(321843), // Rule ID 523 //
     /* 321829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321836 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 321836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 321841 */     GIR_RootConstrainSelectedInstOperands,
     /* 321842 */     // GIR_Coverage, 523,
     /* 321842 */     GIR_Done,
     /* 321843 */   // Label 6513: @321843
     /* 321843 */   GIM_Reject,
     /* 321844 */ // Label 6511: @321844
     /* 321844 */ GIM_Reject,
     /* 321845 */ // Label 6498: @321845
     /* 321845 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(321918),
     /* 321850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321857 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(321898), // Rule ID 4986 //
     /* 321862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 321881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321883 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 321883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 321886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321896 */     GIR_RootConstrainSelectedInstOperands,
     /* 321897 */     // GIR_Coverage, 4986,
     /* 321897 */     GIR_EraseRootFromParent_Done,
     /* 321898 */   // Label 6515: @321898
     /* 321898 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(321917), // Rule ID 768 //
     /* 321903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321910 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 321910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 321915 */     GIR_RootConstrainSelectedInstOperands,
     /* 321916 */     // GIR_Coverage, 768,
     /* 321916 */     GIR_Done,
     /* 321917 */   // Label 6516: @321917
     /* 321917 */   GIM_Reject,
     /* 321918 */ // Label 6514: @321918
     /* 321918 */ GIM_Reject,
     /* 321919 */ // Label 6499: @321919
     /* 321919 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(321992),
     /* 321924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321931 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(321972), // Rule ID 4988 //
     /* 321936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 321947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 321955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321957 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 321957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 321960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 321970 */     GIR_RootConstrainSelectedInstOperands,
     /* 321971 */     // GIR_Coverage, 4988,
     /* 321971 */     GIR_EraseRootFromParent_Done,
     /* 321972 */   // Label 6518: @321972
     /* 321972 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(321991), // Rule ID 770 //
     /* 321977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321984 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 321984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 321989 */     GIR_RootConstrainSelectedInstOperands,
     /* 321990 */     // GIR_Coverage, 770,
     /* 321990 */     GIR_Done,
     /* 321991 */   // Label 6519: @321991
     /* 321991 */   GIM_Reject,
     /* 321992 */ // Label 6517: @321992
     /* 321992 */ GIM_Reject,
     /* 321993 */ // Label 6500: @321993
     /* 321993 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(322100),
     /* 321998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322005 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(322046), // Rule ID 4989 //
     /* 322010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322031 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 322031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 322034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322044 */     GIR_RootConstrainSelectedInstOperands,
     /* 322045 */     // GIR_Coverage, 4989,
     /* 322045 */     GIR_EraseRootFromParent_Done,
     /* 322046 */   // Label 6521: @322046
     /* 322046 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(322065), // Rule ID 766 //
     /* 322051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322058 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 322058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 322063 */     GIR_RootConstrainSelectedInstOperands,
     /* 322064 */     // GIR_Coverage, 766,
     /* 322064 */     GIR_Done,
     /* 322065 */   // Label 6522: @322065
     /* 322065 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(322099), // Rule ID 6341 //
     /* 322070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322077 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 322077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 322080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322084 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 322094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 322097 */     GIR_RootConstrainSelectedInstOperands,
     /* 322098 */     // GIR_Coverage, 6341,
     /* 322098 */     GIR_EraseRootFromParent_Done,
     /* 322099 */   // Label 6523: @322099
     /* 322099 */   GIM_Reject,
     /* 322100 */ // Label 6520: @322100
     /* 322100 */ GIM_Reject,
     /* 322101 */ // Label 6501: @322101
     /* 322101 */ GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(322174),
     /* 322106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322113 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(322154), // Rule ID 4987 //
     /* 322118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322139 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 322139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 322142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322152 */     GIR_RootConstrainSelectedInstOperands,
     /* 322153 */     // GIR_Coverage, 4987,
     /* 322153 */     GIR_EraseRootFromParent_Done,
     /* 322154 */   // Label 6525: @322154
     /* 322154 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(322173), // Rule ID 769 //
     /* 322159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322166 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 322166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 322171 */     GIR_RootConstrainSelectedInstOperands,
     /* 322172 */     // GIR_Coverage, 769,
     /* 322172 */     GIR_Done,
     /* 322173 */   // Label 6526: @322173
     /* 322173 */   GIM_Reject,
     /* 322174 */ // Label 6524: @322174
     /* 322174 */ GIM_Reject,
     /* 322175 */ // Label 6502: @322175
     /* 322175 */ GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(322282),
     /* 322180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322187 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(322228), // Rule ID 4990 //
     /* 322192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322213 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 322213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 322216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322226 */     GIR_RootConstrainSelectedInstOperands,
     /* 322227 */     // GIR_Coverage, 4990,
     /* 322227 */     GIR_EraseRootFromParent_Done,
     /* 322228 */   // Label 6528: @322228
     /* 322228 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(322247), // Rule ID 767 //
     /* 322233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322240 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 322240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 322245 */     GIR_RootConstrainSelectedInstOperands,
     /* 322246 */     // GIR_Coverage, 767,
     /* 322246 */     GIR_Done,
     /* 322247 */   // Label 6529: @322247
     /* 322247 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(322281), // Rule ID 6342 //
     /* 322252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322259 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 322259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 322262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322266 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 322276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 322279 */     GIR_RootConstrainSelectedInstOperands,
     /* 322280 */     // GIR_Coverage, 6342,
     /* 322280 */     GIR_EraseRootFromParent_Done,
     /* 322281 */   // Label 6530: @322281
     /* 322281 */   GIM_Reject,
     /* 322282 */ // Label 6527: @322282
     /* 322282 */ GIM_Reject,
     /* 322283 */ // Label 6503: @322283
     /* 322283 */ GIM_Reject,
     /* 322284 */ // Label 72: @322284
     /* 322284 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6539*/ GIMT_Encode4(322565),
     /* 322295 */ /*GILLT_s16*//*Label 6531*/ GIMT_Encode4(322335),
     /* 322299 */ /*GILLT_s32*//*Label 6532*/ GIMT_Encode4(322362),
     /* 322303 */ /*GILLT_s64*//*Label 6533*/ GIMT_Encode4(322386), GIMT_Encode4(0),
     /* 322311 */ /*GILLT_v2s32*//*Label 6534*/ GIMT_Encode4(322410),
     /* 322315 */ /*GILLT_v2s64*//*Label 6535*/ GIMT_Encode4(322441),
     /* 322319 */ /*GILLT_v4s16*//*Label 6536*/ GIMT_Encode4(322472),
     /* 322323 */ /*GILLT_v4s32*//*Label 6537*/ GIMT_Encode4(322503), GIMT_Encode4(0),
     /* 322331 */ /*GILLT_v8s16*//*Label 6538*/ GIMT_Encode4(322534),
     /* 322335 */ // Label 6531: @322335
     /* 322335 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(322361), // Rule ID 4811 //
     /* 322340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322350 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 322350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 322353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322355 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322357 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322359 */   GIR_RootConstrainSelectedInstOperands,
     /* 322360 */   // GIR_Coverage, 4811,
     /* 322360 */   GIR_EraseRootFromParent_Done,
     /* 322361 */ // Label 6540: @322361
     /* 322361 */ GIM_Reject,
     /* 322362 */ // Label 6532: @322362
     /* 322362 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(322385), // Rule ID 4808 //
     /* 322367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322374 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 322374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 322377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322379 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322381 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322383 */   GIR_RootConstrainSelectedInstOperands,
     /* 322384 */   // GIR_Coverage, 4808,
     /* 322384 */   GIR_EraseRootFromParent_Done,
     /* 322385 */ // Label 6541: @322385
     /* 322385 */ GIM_Reject,
     /* 322386 */ // Label 6533: @322386
     /* 322386 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(322409), // Rule ID 4805 //
     /* 322391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322398 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 322398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322403 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322405 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322407 */   GIR_RootConstrainSelectedInstOperands,
     /* 322408 */   // GIR_Coverage, 4805,
     /* 322408 */   GIR_EraseRootFromParent_Done,
     /* 322409 */ // Label 6542: @322409
     /* 322409 */ GIM_Reject,
     /* 322410 */ // Label 6534: @322410
     /* 322410 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(322440), // Rule ID 4999 //
     /* 322415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322429 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 322429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 322432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322434 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322436 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322438 */   GIR_RootConstrainSelectedInstOperands,
     /* 322439 */   // GIR_Coverage, 4999,
     /* 322439 */   GIR_EraseRootFromParent_Done,
     /* 322440 */ // Label 6543: @322440
     /* 322440 */ GIM_Reject,
     /* 322441 */ // Label 6535: @322441
     /* 322441 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(322471), // Rule ID 4993 //
     /* 322446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322460 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 322460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 322463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322465 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322467 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322469 */   GIR_RootConstrainSelectedInstOperands,
     /* 322470 */   // GIR_Coverage, 4993,
     /* 322470 */   GIR_EraseRootFromParent_Done,
     /* 322471 */ // Label 6544: @322471
     /* 322471 */ GIM_Reject,
     /* 322472 */ // Label 6536: @322472
     /* 322472 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(322502), // Rule ID 5005 //
     /* 322477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322491 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 322491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 322494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322496 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322498 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322500 */   GIR_RootConstrainSelectedInstOperands,
     /* 322501 */   // GIR_Coverage, 5005,
     /* 322501 */   GIR_EraseRootFromParent_Done,
     /* 322502 */ // Label 6545: @322502
     /* 322502 */ GIM_Reject,
     /* 322503 */ // Label 6537: @322503
     /* 322503 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(322533), // Rule ID 4996 //
     /* 322508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322522 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 322522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 322525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322527 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322529 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322531 */   GIR_RootConstrainSelectedInstOperands,
     /* 322532 */   // GIR_Coverage, 4996,
     /* 322532 */   GIR_EraseRootFromParent_Done,
     /* 322533 */ // Label 6546: @322533
     /* 322533 */ GIM_Reject,
     /* 322534 */ // Label 6538: @322534
     /* 322534 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(322564), // Rule ID 5002 //
     /* 322539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322553 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 322553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 322556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322558 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322560 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322562 */   GIR_RootConstrainSelectedInstOperands,
     /* 322563 */   // GIR_Coverage, 5002,
     /* 322563 */   GIR_EraseRootFromParent_Done,
     /* 322564 */ // Label 6547: @322564
     /* 322564 */ GIM_Reject,
     /* 322565 */ // Label 6539: @322565
     /* 322565 */ GIM_Reject,
     /* 322566 */ // Label 73: @322566
     /* 322566 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6556*/ GIMT_Encode4(322943),
     /* 322577 */ /*GILLT_s16*//*Label 6548*/ GIMT_Encode4(322617),
     /* 322581 */ /*GILLT_s32*//*Label 6549*/ GIMT_Encode4(322655),
     /* 322585 */ /*GILLT_s64*//*Label 6550*/ GIMT_Encode4(322693), GIMT_Encode4(0),
     /* 322593 */ /*GILLT_v2s32*//*Label 6551*/ GIMT_Encode4(322753),
     /* 322597 */ /*GILLT_v2s64*//*Label 6552*/ GIMT_Encode4(322791),
     /* 322601 */ /*GILLT_v4s16*//*Label 6553*/ GIMT_Encode4(322829),
     /* 322605 */ /*GILLT_v4s32*//*Label 6554*/ GIMT_Encode4(322867), GIMT_Encode4(0),
     /* 322613 */ /*GILLT_v8s16*//*Label 6555*/ GIMT_Encode4(322905),
     /* 322617 */ // Label 6548: @322617
     /* 322617 */ GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(322654), // Rule ID 608 //
     /* 322622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 322631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322643 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 322643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 322648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322652 */   GIR_RootConstrainSelectedInstOperands,
     /* 322653 */   // GIR_Coverage, 608,
     /* 322653 */   GIR_Done,
     /* 322654 */ // Label 6557: @322654
     /* 322654 */ GIM_Reject,
     /* 322655 */ // Label 6549: @322655
     /* 322655 */ GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(322692), // Rule ID 610 //
     /* 322660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 322669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322681 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 322681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 322686 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322690 */   GIR_RootConstrainSelectedInstOperands,
     /* 322691 */   // GIR_Coverage, 610,
     /* 322691 */   GIR_Done,
     /* 322692 */ // Label 6558: @322692
     /* 322692 */ GIM_Reject,
     /* 322693 */ // Label 6550: @322693
     /* 322693 */ GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(322752),
     /* 322698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 322704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322716 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(322735), // Rule ID 612 //
     /* 322721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322724 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 322724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322729 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322733 */     GIR_RootConstrainSelectedInstOperands,
     /* 322734 */     // GIR_Coverage, 612,
     /* 322734 */     GIR_Done,
     /* 322735 */   // Label 6560: @322735
     /* 322735 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(322751), // Rule ID 4802 //
     /* 322740 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 322740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322745 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322749 */     GIR_RootConstrainSelectedInstOperands,
     /* 322750 */     // GIR_Coverage, 4802,
     /* 322750 */     GIR_Done,
     /* 322751 */   // Label 6561: @322751
     /* 322751 */   GIM_Reject,
     /* 322752 */ // Label 6559: @322752
     /* 322752 */ GIM_Reject,
     /* 322753 */ // Label 6551: @322753
     /* 322753 */ GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(322790), // Rule ID 1273 //
     /* 322758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322779 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 322779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 322784 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322788 */   GIR_RootConstrainSelectedInstOperands,
     /* 322789 */   // GIR_Coverage, 1273,
     /* 322789 */   GIR_Done,
     /* 322790 */ // Label 6562: @322790
     /* 322790 */ GIM_Reject,
     /* 322791 */ // Label 6552: @322791
     /* 322791 */ GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(322828), // Rule ID 1277 //
     /* 322796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 322805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322817 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 322817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 322822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322826 */   GIR_RootConstrainSelectedInstOperands,
     /* 322827 */   // GIR_Coverage, 1277,
     /* 322827 */   GIR_Done,
     /* 322828 */ // Label 6563: @322828
     /* 322828 */ GIM_Reject,
     /* 322829 */ // Label 6553: @322829
     /* 322829 */ GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(322866), // Rule ID 1269 //
     /* 322834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322855 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 322860 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322864 */   GIR_RootConstrainSelectedInstOperands,
     /* 322865 */   // GIR_Coverage, 1269,
     /* 322865 */   GIR_Done,
     /* 322866 */ // Label 6564: @322866
     /* 322866 */ GIM_Reject,
     /* 322867 */ // Label 6554: @322867
     /* 322867 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(322904), // Rule ID 1275 //
     /* 322872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322893 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 322893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 322898 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322902 */   GIR_RootConstrainSelectedInstOperands,
     /* 322903 */   // GIR_Coverage, 1275,
     /* 322903 */   GIR_Done,
     /* 322904 */ // Label 6565: @322904
     /* 322904 */ GIM_Reject,
     /* 322905 */ // Label 6555: @322905
     /* 322905 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(322942), // Rule ID 1271 //
     /* 322910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322931 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 322931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 322936 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 322940 */   GIR_RootConstrainSelectedInstOperands,
     /* 322941 */   // GIR_Coverage, 1271,
     /* 322941 */   GIR_Done,
     /* 322942 */ // Label 6566: @322942
     /* 322942 */ GIM_Reject,
     /* 322943 */ // Label 6556: @322943
     /* 322943 */ GIM_Reject,
     /* 322944 */ // Label 74: @322944
     /* 322944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6575*/ GIMT_Encode4(323321),
     /* 322955 */ /*GILLT_s16*//*Label 6567*/ GIMT_Encode4(322995),
     /* 322959 */ /*GILLT_s32*//*Label 6568*/ GIMT_Encode4(323033),
     /* 322963 */ /*GILLT_s64*//*Label 6569*/ GIMT_Encode4(323071), GIMT_Encode4(0),
     /* 322971 */ /*GILLT_v2s32*//*Label 6570*/ GIMT_Encode4(323131),
     /* 322975 */ /*GILLT_v2s64*//*Label 6571*/ GIMT_Encode4(323169),
     /* 322979 */ /*GILLT_v4s16*//*Label 6572*/ GIMT_Encode4(323207),
     /* 322983 */ /*GILLT_v4s32*//*Label 6573*/ GIMT_Encode4(323245), GIMT_Encode4(0),
     /* 322991 */ /*GILLT_v8s16*//*Label 6574*/ GIMT_Encode4(323283),
     /* 322995 */ // Label 6567: @322995
     /* 322995 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(323032), // Rule ID 596 //
     /* 323000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323021 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 323021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 323026 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323030 */   GIR_RootConstrainSelectedInstOperands,
     /* 323031 */   // GIR_Coverage, 596,
     /* 323031 */   GIR_Done,
     /* 323032 */ // Label 6576: @323032
     /* 323032 */ GIM_Reject,
     /* 323033 */ // Label 6568: @323033
     /* 323033 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(323070), // Rule ID 598 //
     /* 323038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323059 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 323059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 323064 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323068 */   GIR_RootConstrainSelectedInstOperands,
     /* 323069 */   // GIR_Coverage, 598,
     /* 323069 */   GIR_Done,
     /* 323070 */ // Label 6577: @323070
     /* 323070 */ GIM_Reject,
     /* 323071 */ // Label 6569: @323071
     /* 323071 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(323130),
     /* 323076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323094 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(323113), // Rule ID 600 //
     /* 323099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323102 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 323102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323107 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323111 */     GIR_RootConstrainSelectedInstOperands,
     /* 323112 */     // GIR_Coverage, 600,
     /* 323112 */     GIR_Done,
     /* 323113 */   // Label 6579: @323113
     /* 323113 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(323129), // Rule ID 4801 //
     /* 323118 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 323118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323123 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323127 */     GIR_RootConstrainSelectedInstOperands,
     /* 323128 */     // GIR_Coverage, 4801,
     /* 323128 */     GIR_Done,
     /* 323129 */   // Label 6580: @323129
     /* 323129 */   GIM_Reject,
     /* 323130 */ // Label 6578: @323130
     /* 323130 */ GIM_Reject,
     /* 323131 */ // Label 6570: @323131
     /* 323131 */ GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(323168), // Rule ID 1243 //
     /* 323136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323157 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 323162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323166 */   GIR_RootConstrainSelectedInstOperands,
     /* 323167 */   // GIR_Coverage, 1243,
     /* 323167 */   GIR_Done,
     /* 323168 */ // Label 6581: @323168
     /* 323168 */ GIM_Reject,
     /* 323169 */ // Label 6571: @323169
     /* 323169 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(323206), // Rule ID 1247 //
     /* 323174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323195 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 323200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323204 */   GIR_RootConstrainSelectedInstOperands,
     /* 323205 */   // GIR_Coverage, 1247,
     /* 323205 */   GIR_Done,
     /* 323206 */ // Label 6582: @323206
     /* 323206 */ GIM_Reject,
     /* 323207 */ // Label 6572: @323207
     /* 323207 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(323244), // Rule ID 1239 //
     /* 323212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323233 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 323238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323242 */   GIR_RootConstrainSelectedInstOperands,
     /* 323243 */   // GIR_Coverage, 1239,
     /* 323243 */   GIR_Done,
     /* 323244 */ // Label 6583: @323244
     /* 323244 */ GIM_Reject,
     /* 323245 */ // Label 6573: @323245
     /* 323245 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(323282), // Rule ID 1245 //
     /* 323250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323271 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 323276 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323280 */   GIR_RootConstrainSelectedInstOperands,
     /* 323281 */   // GIR_Coverage, 1245,
     /* 323281 */   GIR_Done,
     /* 323282 */ // Label 6584: @323282
     /* 323282 */ GIM_Reject,
     /* 323283 */ // Label 6574: @323283
     /* 323283 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(323320), // Rule ID 1241 //
     /* 323288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323309 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 323314 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323318 */   GIR_RootConstrainSelectedInstOperands,
     /* 323319 */   // GIR_Coverage, 1241,
     /* 323319 */   GIR_Done,
     /* 323320 */ // Label 6585: @323320
     /* 323320 */ GIM_Reject,
     /* 323321 */ // Label 6575: @323321
     /* 323321 */ GIM_Reject,
     /* 323322 */ // Label 75: @323322
     /* 323322 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6594*/ GIMT_Encode4(323671),
     /* 323333 */ /*GILLT_s16*//*Label 6586*/ GIMT_Encode4(323373),
     /* 323337 */ /*GILLT_s32*//*Label 6587*/ GIMT_Encode4(323411),
     /* 323341 */ /*GILLT_s64*//*Label 6588*/ GIMT_Encode4(323446), GIMT_Encode4(0),
     /* 323349 */ /*GILLT_v2s32*//*Label 6589*/ GIMT_Encode4(323481),
     /* 323353 */ /*GILLT_v2s64*//*Label 6590*/ GIMT_Encode4(323519),
     /* 323357 */ /*GILLT_v4s16*//*Label 6591*/ GIMT_Encode4(323557),
     /* 323361 */ /*GILLT_v4s32*//*Label 6592*/ GIMT_Encode4(323595), GIMT_Encode4(0),
     /* 323369 */ /*GILLT_v8s16*//*Label 6593*/ GIMT_Encode4(323633),
     /* 323373 */ // Label 6586: @323373
     /* 323373 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(323410), // Rule ID 4809 //
     /* 323378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323399 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 323399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 323404 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323408 */   GIR_RootConstrainSelectedInstOperands,
     /* 323409 */   // GIR_Coverage, 4809,
     /* 323409 */   GIR_Done,
     /* 323410 */ // Label 6595: @323410
     /* 323410 */ GIM_Reject,
     /* 323411 */ // Label 6587: @323411
     /* 323411 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(323445), // Rule ID 4806 //
     /* 323416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323434 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 323434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 323439 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323443 */   GIR_RootConstrainSelectedInstOperands,
     /* 323444 */   // GIR_Coverage, 4806,
     /* 323444 */   GIR_Done,
     /* 323445 */ // Label 6596: @323445
     /* 323445 */ GIM_Reject,
     /* 323446 */ // Label 6588: @323446
     /* 323446 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(323480), // Rule ID 4803 //
     /* 323451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323469 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 323469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 323474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323478 */   GIR_RootConstrainSelectedInstOperands,
     /* 323479 */   // GIR_Coverage, 4803,
     /* 323479 */   GIR_Done,
     /* 323480 */ // Label 6597: @323480
     /* 323480 */ GIM_Reject,
     /* 323481 */ // Label 6589: @323481
     /* 323481 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(323518), // Rule ID 4997 //
     /* 323486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323507 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 323512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323516 */   GIR_RootConstrainSelectedInstOperands,
     /* 323517 */   // GIR_Coverage, 4997,
     /* 323517 */   GIR_Done,
     /* 323518 */ // Label 6598: @323518
     /* 323518 */ GIM_Reject,
     /* 323519 */ // Label 6590: @323519
     /* 323519 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(323556), // Rule ID 4991 //
     /* 323524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323545 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 323550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323554 */   GIR_RootConstrainSelectedInstOperands,
     /* 323555 */   // GIR_Coverage, 4991,
     /* 323555 */   GIR_Done,
     /* 323556 */ // Label 6599: @323556
     /* 323556 */ GIM_Reject,
     /* 323557 */ // Label 6591: @323557
     /* 323557 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(323594), // Rule ID 5003 //
     /* 323562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323583 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 323588 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323592 */   GIR_RootConstrainSelectedInstOperands,
     /* 323593 */   // GIR_Coverage, 5003,
     /* 323593 */   GIR_Done,
     /* 323594 */ // Label 6600: @323594
     /* 323594 */ GIM_Reject,
     /* 323595 */ // Label 6592: @323595
     /* 323595 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(323632), // Rule ID 4994 //
     /* 323600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323621 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 323626 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323630 */   GIR_RootConstrainSelectedInstOperands,
     /* 323631 */   // GIR_Coverage, 4994,
     /* 323631 */   GIR_Done,
     /* 323632 */ // Label 6601: @323632
     /* 323632 */ GIM_Reject,
     /* 323633 */ // Label 6593: @323633
     /* 323633 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(323670), // Rule ID 5000 //
     /* 323638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323659 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 323664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323668 */   GIR_RootConstrainSelectedInstOperands,
     /* 323669 */   // GIR_Coverage, 5000,
     /* 323669 */   GIR_Done,
     /* 323670 */ // Label 6602: @323670
     /* 323670 */ GIM_Reject,
     /* 323671 */ // Label 6594: @323671
     /* 323671 */ GIM_Reject,
     /* 323672 */ // Label 76: @323672
     /* 323672 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6611*/ GIMT_Encode4(324021),
     /* 323683 */ /*GILLT_s16*//*Label 6603*/ GIMT_Encode4(323723),
     /* 323687 */ /*GILLT_s32*//*Label 6604*/ GIMT_Encode4(323761),
     /* 323691 */ /*GILLT_s64*//*Label 6605*/ GIMT_Encode4(323796), GIMT_Encode4(0),
     /* 323699 */ /*GILLT_v2s32*//*Label 6606*/ GIMT_Encode4(323831),
     /* 323703 */ /*GILLT_v2s64*//*Label 6607*/ GIMT_Encode4(323869),
     /* 323707 */ /*GILLT_v4s16*//*Label 6608*/ GIMT_Encode4(323907),
     /* 323711 */ /*GILLT_v4s32*//*Label 6609*/ GIMT_Encode4(323945), GIMT_Encode4(0),
     /* 323719 */ /*GILLT_v8s16*//*Label 6610*/ GIMT_Encode4(323983),
     /* 323723 */ // Label 6603: @323723
     /* 323723 */ GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(323760), // Rule ID 4810 //
     /* 323728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323749 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 323749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 323754 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323758 */   GIR_RootConstrainSelectedInstOperands,
     /* 323759 */   // GIR_Coverage, 4810,
     /* 323759 */   GIR_Done,
     /* 323760 */ // Label 6612: @323760
     /* 323760 */ GIM_Reject,
     /* 323761 */ // Label 6604: @323761
     /* 323761 */ GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(323795), // Rule ID 4807 //
     /* 323766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323784 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 323784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 323789 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323793 */   GIR_RootConstrainSelectedInstOperands,
     /* 323794 */   // GIR_Coverage, 4807,
     /* 323794 */   GIR_Done,
     /* 323795 */ // Label 6613: @323795
     /* 323795 */ GIM_Reject,
     /* 323796 */ // Label 6605: @323796
     /* 323796 */ GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(323830), // Rule ID 4804 //
     /* 323801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323819 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 323819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323824 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323828 */   GIR_RootConstrainSelectedInstOperands,
     /* 323829 */   // GIR_Coverage, 4804,
     /* 323829 */   GIR_Done,
     /* 323830 */ // Label 6614: @323830
     /* 323830 */ GIM_Reject,
     /* 323831 */ // Label 6606: @323831
     /* 323831 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(323868), // Rule ID 4998 //
     /* 323836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323857 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 323862 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323866 */   GIR_RootConstrainSelectedInstOperands,
     /* 323867 */   // GIR_Coverage, 4998,
     /* 323867 */   GIR_Done,
     /* 323868 */ // Label 6615: @323868
     /* 323868 */ GIM_Reject,
     /* 323869 */ // Label 6607: @323869
     /* 323869 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(323906), // Rule ID 4992 //
     /* 323874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323895 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 323900 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323904 */   GIR_RootConstrainSelectedInstOperands,
     /* 323905 */   // GIR_Coverage, 4992,
     /* 323905 */   GIR_Done,
     /* 323906 */ // Label 6616: @323906
     /* 323906 */ GIM_Reject,
     /* 323907 */ // Label 6608: @323907
     /* 323907 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(323944), // Rule ID 5004 //
     /* 323912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323933 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 323938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323942 */   GIR_RootConstrainSelectedInstOperands,
     /* 323943 */   // GIR_Coverage, 5004,
     /* 323943 */   GIR_Done,
     /* 323944 */ // Label 6617: @323944
     /* 323944 */ GIM_Reject,
     /* 323945 */ // Label 6609: @323945
     /* 323945 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(323982), // Rule ID 4995 //
     /* 323950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323971 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 323976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323980 */   GIR_RootConstrainSelectedInstOperands,
     /* 323981 */   // GIR_Coverage, 4995,
     /* 323981 */   GIR_Done,
     /* 323982 */ // Label 6618: @323982
     /* 323982 */ GIM_Reject,
     /* 323983 */ // Label 6610: @323983
     /* 323983 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(324020), // Rule ID 5001 //
     /* 323988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324009 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 324014 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324018 */   GIR_RootConstrainSelectedInstOperands,
     /* 324019 */   // GIR_Coverage, 5001,
     /* 324019 */   GIR_Done,
     /* 324020 */ // Label 6619: @324020
     /* 324020 */ GIM_Reject,
     /* 324021 */ // Label 6611: @324021
     /* 324021 */ GIM_Reject,
     /* 324022 */ // Label 77: @324022
     /* 324022 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6628*/ GIMT_Encode4(324724),
     /* 324033 */ /*GILLT_s16*//*Label 6620*/ GIMT_Encode4(324073),
     /* 324037 */ /*GILLT_s32*//*Label 6621*/ GIMT_Encode4(324111),
     /* 324041 */ /*GILLT_s64*//*Label 6622*/ GIMT_Encode4(324149), GIMT_Encode4(0),
     /* 324049 */ /*GILLT_v2s32*//*Label 6623*/ GIMT_Encode4(324209),
     /* 324053 */ /*GILLT_v2s64*//*Label 6624*/ GIMT_Encode4(324312),
     /* 324057 */ /*GILLT_v4s16*//*Label 6625*/ GIMT_Encode4(324415),
     /* 324061 */ /*GILLT_v4s32*//*Label 6626*/ GIMT_Encode4(324518), GIMT_Encode4(0),
     /* 324069 */ /*GILLT_v8s16*//*Label 6627*/ GIMT_Encode4(324621),
     /* 324073 */ // Label 6620: @324073
     /* 324073 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(324110), // Rule ID 614 //
     /* 324078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324099 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 324104 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324108 */   GIR_RootConstrainSelectedInstOperands,
     /* 324109 */   // GIR_Coverage, 614,
     /* 324109 */   GIR_Done,
     /* 324110 */ // Label 6629: @324110
     /* 324110 */ GIM_Reject,
     /* 324111 */ // Label 6621: @324111
     /* 324111 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(324148), // Rule ID 616 //
     /* 324116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324137 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 324142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324146 */   GIR_RootConstrainSelectedInstOperands,
     /* 324147 */   // GIR_Coverage, 616,
     /* 324147 */   GIR_Done,
     /* 324148 */ // Label 6630: @324148
     /* 324148 */ GIM_Reject,
     /* 324149 */ // Label 6622: @324149
     /* 324149 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(324208),
     /* 324154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324172 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(324191), // Rule ID 618 //
     /* 324177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324180 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 324185 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324189 */     GIR_RootConstrainSelectedInstOperands,
     /* 324190 */     // GIR_Coverage, 618,
     /* 324190 */     GIR_Done,
     /* 324191 */   // Label 6632: @324191
     /* 324191 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(324207), // Rule ID 4800 //
     /* 324196 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 324201 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324205 */     GIR_RootConstrainSelectedInstOperands,
     /* 324206 */     // GIR_Coverage, 4800,
     /* 324206 */     GIR_Done,
     /* 324207 */   // Label 6633: @324207
     /* 324207 */   GIM_Reject,
     /* 324208 */ // Label 6631: @324208
     /* 324208 */ GIM_Reject,
     /* 324209 */ // Label 6623: @324209
     /* 324209 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(324311),
     /* 324214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324224 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(324283), // Rule ID 2366 //
     /* 324229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324268 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 324271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324281 */     GIR_RootConstrainSelectedInstOperands,
     /* 324282 */     // GIR_Coverage, 2366,
     /* 324282 */     GIR_EraseRootFromParent_Done,
     /* 324283 */   // Label 6635: @324283
     /* 324283 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(324310), // Rule ID 1288 //
     /* 324288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324299 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 324304 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324308 */     GIR_RootConstrainSelectedInstOperands,
     /* 324309 */     // GIR_Coverage, 1288,
     /* 324309 */     GIR_Done,
     /* 324310 */   // Label 6636: @324310
     /* 324310 */   GIM_Reject,
     /* 324311 */ // Label 6634: @324311
     /* 324311 */ GIM_Reject,
     /* 324312 */ // Label 6624: @324312
     /* 324312 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(324414),
     /* 324317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324327 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(324386), // Rule ID 2372 //
     /* 324332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324371 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 324374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324384 */     GIR_RootConstrainSelectedInstOperands,
     /* 324385 */     // GIR_Coverage, 2372,
     /* 324385 */     GIR_EraseRootFromParent_Done,
     /* 324386 */   // Label 6638: @324386
     /* 324386 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(324413), // Rule ID 1292 //
     /* 324391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324402 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 324407 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324411 */     GIR_RootConstrainSelectedInstOperands,
     /* 324412 */     // GIR_Coverage, 1292,
     /* 324412 */     GIR_Done,
     /* 324413 */   // Label 6639: @324413
     /* 324413 */   GIM_Reject,
     /* 324414 */ // Label 6637: @324414
     /* 324414 */ GIM_Reject,
     /* 324415 */ // Label 6625: @324415
     /* 324415 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(324517),
     /* 324420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324430 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(324489), // Rule ID 2360 //
     /* 324435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324474 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 324477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324487 */     GIR_RootConstrainSelectedInstOperands,
     /* 324488 */     // GIR_Coverage, 2360,
     /* 324488 */     GIR_EraseRootFromParent_Done,
     /* 324489 */   // Label 6641: @324489
     /* 324489 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(324516), // Rule ID 1284 //
     /* 324494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324505 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 324510 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324514 */     GIR_RootConstrainSelectedInstOperands,
     /* 324515 */     // GIR_Coverage, 1284,
     /* 324515 */     GIR_Done,
     /* 324516 */   // Label 6642: @324516
     /* 324516 */   GIM_Reject,
     /* 324517 */ // Label 6640: @324517
     /* 324517 */ GIM_Reject,
     /* 324518 */ // Label 6626: @324518
     /* 324518 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(324620),
     /* 324523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324533 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(324592), // Rule ID 2369 //
     /* 324538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324577 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 324580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324590 */     GIR_RootConstrainSelectedInstOperands,
     /* 324591 */     // GIR_Coverage, 2369,
     /* 324591 */     GIR_EraseRootFromParent_Done,
     /* 324592 */   // Label 6644: @324592
     /* 324592 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(324619), // Rule ID 1290 //
     /* 324597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324608 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 324613 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324617 */     GIR_RootConstrainSelectedInstOperands,
     /* 324618 */     // GIR_Coverage, 1290,
     /* 324618 */     GIR_Done,
     /* 324619 */   // Label 6645: @324619
     /* 324619 */   GIM_Reject,
     /* 324620 */ // Label 6643: @324620
     /* 324620 */ GIM_Reject,
     /* 324621 */ // Label 6627: @324621
     /* 324621 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(324723),
     /* 324626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324636 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(324695), // Rule ID 2363 //
     /* 324641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324680 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 324683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324693 */     GIR_RootConstrainSelectedInstOperands,
     /* 324694 */     // GIR_Coverage, 2363,
     /* 324694 */     GIR_EraseRootFromParent_Done,
     /* 324695 */   // Label 6647: @324695
     /* 324695 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(324722), // Rule ID 1286 //
     /* 324700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324711 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 324716 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324720 */     GIR_RootConstrainSelectedInstOperands,
     /* 324721 */     // GIR_Coverage, 1286,
     /* 324721 */     GIR_Done,
     /* 324722 */   // Label 6648: @324722
     /* 324722 */   GIM_Reject,
     /* 324723 */ // Label 6646: @324723
     /* 324723 */ GIM_Reject,
     /* 324724 */ // Label 6628: @324724
     /* 324724 */ GIM_Reject,
     /* 324725 */ // Label 78: @324725
     /* 324725 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6657*/ GIMT_Encode4(325427),
     /* 324736 */ /*GILLT_s16*//*Label 6649*/ GIMT_Encode4(324776),
     /* 324740 */ /*GILLT_s32*//*Label 6650*/ GIMT_Encode4(324814),
     /* 324744 */ /*GILLT_s64*//*Label 6651*/ GIMT_Encode4(324852), GIMT_Encode4(0),
     /* 324752 */ /*GILLT_v2s32*//*Label 6652*/ GIMT_Encode4(324912),
     /* 324756 */ /*GILLT_v2s64*//*Label 6653*/ GIMT_Encode4(325015),
     /* 324760 */ /*GILLT_v4s16*//*Label 6654*/ GIMT_Encode4(325118),
     /* 324764 */ /*GILLT_v4s32*//*Label 6655*/ GIMT_Encode4(325221), GIMT_Encode4(0),
     /* 324772 */ /*GILLT_v8s16*//*Label 6656*/ GIMT_Encode4(325324),
     /* 324776 */ // Label 6649: @324776
     /* 324776 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(324813), // Rule ID 602 //
     /* 324781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324802 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 324807 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324811 */   GIR_RootConstrainSelectedInstOperands,
     /* 324812 */   // GIR_Coverage, 602,
     /* 324812 */   GIR_Done,
     /* 324813 */ // Label 6658: @324813
     /* 324813 */ GIM_Reject,
     /* 324814 */ // Label 6650: @324814
     /* 324814 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(324851), // Rule ID 604 //
     /* 324819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324840 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 324845 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324849 */   GIR_RootConstrainSelectedInstOperands,
     /* 324850 */   // GIR_Coverage, 604,
     /* 324850 */   GIR_Done,
     /* 324851 */ // Label 6659: @324851
     /* 324851 */ GIM_Reject,
     /* 324852 */ // Label 6651: @324852
     /* 324852 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(324911),
     /* 324857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324875 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(324894), // Rule ID 606 //
     /* 324880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324883 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 324888 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324892 */     GIR_RootConstrainSelectedInstOperands,
     /* 324893 */     // GIR_Coverage, 606,
     /* 324893 */     GIR_Done,
     /* 324894 */   // Label 6661: @324894
     /* 324894 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(324910), // Rule ID 4799 //
     /* 324899 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 324904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324908 */     GIR_RootConstrainSelectedInstOperands,
     /* 324909 */     // GIR_Coverage, 4799,
     /* 324909 */     GIR_Done,
     /* 324910 */   // Label 6662: @324910
     /* 324910 */   GIM_Reject,
     /* 324911 */ // Label 6660: @324911
     /* 324911 */ GIM_Reject,
     /* 324912 */ // Label 6652: @324912
     /* 324912 */ GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(325014),
     /* 324917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324927 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(324986), // Rule ID 2351 //
     /* 324932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324971 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 324974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324984 */     GIR_RootConstrainSelectedInstOperands,
     /* 324985 */     // GIR_Coverage, 2351,
     /* 324985 */     GIR_EraseRootFromParent_Done,
     /* 324986 */   // Label 6664: @324986
     /* 324986 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(325013), // Rule ID 1258 //
     /* 324991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325002 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 325007 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325011 */     GIR_RootConstrainSelectedInstOperands,
     /* 325012 */     // GIR_Coverage, 1258,
     /* 325012 */     GIR_Done,
     /* 325013 */   // Label 6665: @325013
     /* 325013 */   GIM_Reject,
     /* 325014 */ // Label 6663: @325014
     /* 325014 */ GIM_Reject,
     /* 325015 */ // Label 6653: @325015
     /* 325015 */ GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(325117),
     /* 325020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325030 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(325089), // Rule ID 2357 //
     /* 325035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325074 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 325077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325087 */     GIR_RootConstrainSelectedInstOperands,
     /* 325088 */     // GIR_Coverage, 2357,
     /* 325088 */     GIR_EraseRootFromParent_Done,
     /* 325089 */   // Label 6667: @325089
     /* 325089 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(325116), // Rule ID 1262 //
     /* 325094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325105 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 325110 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325114 */     GIR_RootConstrainSelectedInstOperands,
     /* 325115 */     // GIR_Coverage, 1262,
     /* 325115 */     GIR_Done,
     /* 325116 */   // Label 6668: @325116
     /* 325116 */   GIM_Reject,
     /* 325117 */ // Label 6666: @325117
     /* 325117 */ GIM_Reject,
     /* 325118 */ // Label 6654: @325118
     /* 325118 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(325220),
     /* 325123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325133 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(325192), // Rule ID 2345 //
     /* 325138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325177 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 325180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325190 */     GIR_RootConstrainSelectedInstOperands,
     /* 325191 */     // GIR_Coverage, 2345,
     /* 325191 */     GIR_EraseRootFromParent_Done,
     /* 325192 */   // Label 6670: @325192
     /* 325192 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(325219), // Rule ID 1254 //
     /* 325197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325208 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 325213 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325217 */     GIR_RootConstrainSelectedInstOperands,
     /* 325218 */     // GIR_Coverage, 1254,
     /* 325218 */     GIR_Done,
     /* 325219 */   // Label 6671: @325219
     /* 325219 */   GIM_Reject,
     /* 325220 */ // Label 6669: @325220
     /* 325220 */ GIM_Reject,
     /* 325221 */ // Label 6655: @325221
     /* 325221 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(325323),
     /* 325226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325236 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(325295), // Rule ID 2354 //
     /* 325241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325280 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 325283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325293 */     GIR_RootConstrainSelectedInstOperands,
     /* 325294 */     // GIR_Coverage, 2354,
     /* 325294 */     GIR_EraseRootFromParent_Done,
     /* 325295 */   // Label 6673: @325295
     /* 325295 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(325322), // Rule ID 1260 //
     /* 325300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325311 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 325316 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325320 */     GIR_RootConstrainSelectedInstOperands,
     /* 325321 */     // GIR_Coverage, 1260,
     /* 325321 */     GIR_Done,
     /* 325322 */   // Label 6674: @325322
     /* 325322 */   GIM_Reject,
     /* 325323 */ // Label 6672: @325323
     /* 325323 */ GIM_Reject,
     /* 325324 */ // Label 6656: @325324
     /* 325324 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(325426),
     /* 325329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325339 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(325398), // Rule ID 2348 //
     /* 325344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325383 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 325386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325396 */     GIR_RootConstrainSelectedInstOperands,
     /* 325397 */     // GIR_Coverage, 2348,
     /* 325397 */     GIR_EraseRootFromParent_Done,
     /* 325398 */   // Label 6676: @325398
     /* 325398 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(325425), // Rule ID 1256 //
     /* 325403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325414 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 325419 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325423 */     GIR_RootConstrainSelectedInstOperands,
     /* 325424 */     // GIR_Coverage, 1256,
     /* 325424 */     GIR_Done,
     /* 325425 */   // Label 6677: @325425
     /* 325425 */   GIM_Reject,
     /* 325426 */ // Label 6675: @325426
     /* 325426 */ GIM_Reject,
     /* 325427 */ // Label 6657: @325427
     /* 325427 */ GIM_Reject,
     /* 325428 */ // Label 79: @325428
     /* 325428 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6686*/ GIMT_Encode4(325831),
     /* 325439 */ /*GILLT_s32*//*Label 6678*/ GIMT_Encode4(325479),
     /* 325443 */ /*GILLT_s64*//*Label 6679*/ GIMT_Encode4(325553), GIMT_Encode4(0),
     /* 325451 */ /*GILLT_v2s32*//*Label 6680*/ GIMT_Encode4(325627), GIMT_Encode4(0),
     /* 325459 */ /*GILLT_v4s16*//*Label 6681*/ GIMT_Encode4(325661),
     /* 325463 */ /*GILLT_v4s32*//*Label 6682*/ GIMT_Encode4(325695),
     /* 325467 */ /*GILLT_v8s8*//*Label 6683*/ GIMT_Encode4(325729),
     /* 325471 */ /*GILLT_v8s16*//*Label 6684*/ GIMT_Encode4(325763),
     /* 325475 */ /*GILLT_v16s8*//*Label 6685*/ GIMT_Encode4(325797),
     /* 325479 */ // Label 6678: @325479
     /* 325479 */ GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(325552),
     /* 325484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325498 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(325532), // Rule ID 2328 //
     /* 325503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 325518 */     // MIs[1] Operand 1
     /* 325518 */     // No operand predicates
     /* 325518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325520 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 325520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 325523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325530 */     GIR_RootConstrainSelectedInstOperands,
     /* 325531 */     // GIR_Coverage, 2328,
     /* 325531 */     GIR_EraseRootFromParent_Done,
     /* 325532 */   // Label 6688: @325532
     /* 325532 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(325551), // Rule ID 2327 //
     /* 325537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325544 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 325544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 325549 */     GIR_RootConstrainSelectedInstOperands,
     /* 325550 */     // GIR_Coverage, 2327,
     /* 325550 */     GIR_Done,
     /* 325551 */   // Label 6689: @325551
     /* 325551 */   GIM_Reject,
     /* 325552 */ // Label 6687: @325552
     /* 325552 */ GIM_Reject,
     /* 325553 */ // Label 6679: @325553
     /* 325553 */ GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(325626),
     /* 325558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325572 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(325606), // Rule ID 2330 //
     /* 325577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 325592 */     // MIs[1] Operand 1
     /* 325592 */     // No operand predicates
     /* 325592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325594 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 325594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 325597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325604 */     GIR_RootConstrainSelectedInstOperands,
     /* 325605 */     // GIR_Coverage, 2330,
     /* 325605 */     GIR_EraseRootFromParent_Done,
     /* 325606 */   // Label 6691: @325606
     /* 325606 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(325625), // Rule ID 2329 //
     /* 325611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325618 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 325618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 325623 */     GIR_RootConstrainSelectedInstOperands,
     /* 325624 */     // GIR_Coverage, 2329,
     /* 325624 */     GIR_Done,
     /* 325625 */   // Label 6692: @325625
     /* 325625 */   GIM_Reject,
     /* 325626 */ // Label 6690: @325626
     /* 325626 */ GIM_Reject,
     /* 325627 */ // Label 6680: @325627
     /* 325627 */ GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(325660), // Rule ID 1414 //
     /* 325632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325649 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325653 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 325653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 325658 */   GIR_RootConstrainSelectedInstOperands,
     /* 325659 */   // GIR_Coverage, 1414,
     /* 325659 */   GIR_Done,
     /* 325660 */ // Label 6693: @325660
     /* 325660 */ GIM_Reject,
     /* 325661 */ // Label 6681: @325661
     /* 325661 */ GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(325694), // Rule ID 1412 //
     /* 325666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325687 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 325687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 325692 */   GIR_RootConstrainSelectedInstOperands,
     /* 325693 */   // GIR_Coverage, 1412,
     /* 325693 */   GIR_Done,
     /* 325694 */ // Label 6694: @325694
     /* 325694 */ GIM_Reject,
     /* 325695 */ // Label 6682: @325695
     /* 325695 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(325728), // Rule ID 1415 //
     /* 325700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325721 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 325721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 325726 */   GIR_RootConstrainSelectedInstOperands,
     /* 325727 */   // GIR_Coverage, 1415,
     /* 325727 */   GIR_Done,
     /* 325728 */ // Label 6695: @325728
     /* 325728 */ GIM_Reject,
     /* 325729 */ // Label 6683: @325729
     /* 325729 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(325762), // Rule ID 1410 //
     /* 325734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 325740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 325743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325755 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 325755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 325760 */   GIR_RootConstrainSelectedInstOperands,
     /* 325761 */   // GIR_Coverage, 1410,
     /* 325761 */   GIR_Done,
     /* 325762 */ // Label 6696: @325762
     /* 325762 */ GIM_Reject,
     /* 325763 */ // Label 6684: @325763
     /* 325763 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(325796), // Rule ID 1413 //
     /* 325768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325789 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 325789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 325794 */   GIR_RootConstrainSelectedInstOperands,
     /* 325795 */   // GIR_Coverage, 1413,
     /* 325795 */   GIR_Done,
     /* 325796 */ // Label 6697: @325796
     /* 325796 */ GIM_Reject,
     /* 325797 */ // Label 6685: @325797
     /* 325797 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(325830), // Rule ID 1411 //
     /* 325802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 325808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 325811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325823 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 325823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 325828 */   GIR_RootConstrainSelectedInstOperands,
     /* 325829 */   // GIR_Coverage, 1411,
     /* 325829 */   GIR_Done,
     /* 325830 */ // Label 6698: @325830
     /* 325830 */ GIM_Reject,
     /* 325831 */ // Label 6686: @325831
     /* 325831 */ GIM_Reject,
     /* 325832 */ // Label 80: @325832
     /* 325832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6707*/ GIMT_Encode4(326235),
     /* 325843 */ /*GILLT_s32*//*Label 6699*/ GIMT_Encode4(325883),
     /* 325847 */ /*GILLT_s64*//*Label 6700*/ GIMT_Encode4(325957), GIMT_Encode4(0),
     /* 325855 */ /*GILLT_v2s32*//*Label 6701*/ GIMT_Encode4(326031), GIMT_Encode4(0),
     /* 325863 */ /*GILLT_v4s16*//*Label 6702*/ GIMT_Encode4(326065),
     /* 325867 */ /*GILLT_v4s32*//*Label 6703*/ GIMT_Encode4(326099),
     /* 325871 */ /*GILLT_v8s8*//*Label 6704*/ GIMT_Encode4(326133),
     /* 325875 */ /*GILLT_v8s16*//*Label 6705*/ GIMT_Encode4(326167),
     /* 325879 */ /*GILLT_v16s8*//*Label 6706*/ GIMT_Encode4(326201),
     /* 325883 */ // Label 6699: @325883
     /* 325883 */ GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(325956),
     /* 325888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325902 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(325936), // Rule ID 2324 //
     /* 325907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 325922 */     // MIs[1] Operand 1
     /* 325922 */     // No operand predicates
     /* 325922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325924 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 325924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 325927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 325934 */     GIR_RootConstrainSelectedInstOperands,
     /* 325935 */     // GIR_Coverage, 2324,
     /* 325935 */     GIR_EraseRootFromParent_Done,
     /* 325936 */   // Label 6709: @325936
     /* 325936 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(325955), // Rule ID 2323 //
     /* 325941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 325948 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 325948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 325953 */     GIR_RootConstrainSelectedInstOperands,
     /* 325954 */     // GIR_Coverage, 2323,
     /* 325954 */     GIR_Done,
     /* 325955 */   // Label 6710: @325955
     /* 325955 */   GIM_Reject,
     /* 325956 */ // Label 6708: @325956
     /* 325956 */ GIM_Reject,
     /* 325957 */ // Label 6700: @325957
     /* 325957 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(326030),
     /* 325962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 325976 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(326010), // Rule ID 2326 //
     /* 325981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 325984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 325996 */     // MIs[1] Operand 1
     /* 325996 */     // No operand predicates
     /* 325996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325998 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 325998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 326001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326008 */     GIR_RootConstrainSelectedInstOperands,
     /* 326009 */     // GIR_Coverage, 2326,
     /* 326009 */     GIR_EraseRootFromParent_Done,
     /* 326010 */   // Label 6712: @326010
     /* 326010 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(326029), // Rule ID 2325 //
     /* 326015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326022 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 326027 */     GIR_RootConstrainSelectedInstOperands,
     /* 326028 */     // GIR_Coverage, 2325,
     /* 326028 */     GIR_Done,
     /* 326029 */   // Label 6713: @326029
     /* 326029 */   GIM_Reject,
     /* 326030 */ // Label 6711: @326030
     /* 326030 */ GIM_Reject,
     /* 326031 */ // Label 6701: @326031
     /* 326031 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(326064), // Rule ID 1402 //
     /* 326036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326057 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 326062 */   GIR_RootConstrainSelectedInstOperands,
     /* 326063 */   // GIR_Coverage, 1402,
     /* 326063 */   GIR_Done,
     /* 326064 */ // Label 6714: @326064
     /* 326064 */ GIM_Reject,
     /* 326065 */ // Label 6702: @326065
     /* 326065 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(326098), // Rule ID 1400 //
     /* 326070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326091 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 326096 */   GIR_RootConstrainSelectedInstOperands,
     /* 326097 */   // GIR_Coverage, 1400,
     /* 326097 */   GIR_Done,
     /* 326098 */ // Label 6715: @326098
     /* 326098 */ GIM_Reject,
     /* 326099 */ // Label 6703: @326099
     /* 326099 */ GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(326132), // Rule ID 1403 //
     /* 326104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326121 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326125 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 326130 */   GIR_RootConstrainSelectedInstOperands,
     /* 326131 */   // GIR_Coverage, 1403,
     /* 326131 */   GIR_Done,
     /* 326132 */ // Label 6716: @326132
     /* 326132 */ GIM_Reject,
     /* 326133 */ // Label 6704: @326133
     /* 326133 */ GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(326166), // Rule ID 1398 //
     /* 326138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326159 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 326164 */   GIR_RootConstrainSelectedInstOperands,
     /* 326165 */   // GIR_Coverage, 1398,
     /* 326165 */   GIR_Done,
     /* 326166 */ // Label 6717: @326166
     /* 326166 */ GIM_Reject,
     /* 326167 */ // Label 6705: @326167
     /* 326167 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(326200), // Rule ID 1401 //
     /* 326172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326193 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 326198 */   GIR_RootConstrainSelectedInstOperands,
     /* 326199 */   // GIR_Coverage, 1401,
     /* 326199 */   GIR_Done,
     /* 326200 */ // Label 6718: @326200
     /* 326200 */ GIM_Reject,
     /* 326201 */ // Label 6706: @326201
     /* 326201 */ GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(326234), // Rule ID 1399 //
     /* 326206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326227 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 326232 */   GIR_RootConstrainSelectedInstOperands,
     /* 326233 */   // GIR_Coverage, 1399,
     /* 326233 */   GIR_Done,
     /* 326234 */ // Label 6719: @326234
     /* 326234 */ GIM_Reject,
     /* 326235 */ // Label 6707: @326235
     /* 326235 */ GIM_Reject,
     /* 326236 */ // Label 81: @326236
     /* 326236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6728*/ GIMT_Encode4(326639),
     /* 326247 */ /*GILLT_s32*//*Label 6720*/ GIMT_Encode4(326287),
     /* 326251 */ /*GILLT_s64*//*Label 6721*/ GIMT_Encode4(326361), GIMT_Encode4(0),
     /* 326259 */ /*GILLT_v2s32*//*Label 6722*/ GIMT_Encode4(326435), GIMT_Encode4(0),
     /* 326267 */ /*GILLT_v4s16*//*Label 6723*/ GIMT_Encode4(326469),
     /* 326271 */ /*GILLT_v4s32*//*Label 6724*/ GIMT_Encode4(326503),
     /* 326275 */ /*GILLT_v8s8*//*Label 6725*/ GIMT_Encode4(326537),
     /* 326279 */ /*GILLT_v8s16*//*Label 6726*/ GIMT_Encode4(326571),
     /* 326283 */ /*GILLT_v16s8*//*Label 6727*/ GIMT_Encode4(326605),
     /* 326287 */ // Label 6720: @326287
     /* 326287 */ GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(326360),
     /* 326292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326306 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(326340), // Rule ID 2336 //
     /* 326311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 326326 */     // MIs[1] Operand 1
     /* 326326 */     // No operand predicates
     /* 326326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326328 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 326331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326338 */     GIR_RootConstrainSelectedInstOperands,
     /* 326339 */     // GIR_Coverage, 2336,
     /* 326339 */     GIR_EraseRootFromParent_Done,
     /* 326340 */   // Label 6730: @326340
     /* 326340 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(326359), // Rule ID 2335 //
     /* 326345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326352 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 326357 */     GIR_RootConstrainSelectedInstOperands,
     /* 326358 */     // GIR_Coverage, 2335,
     /* 326358 */     GIR_Done,
     /* 326359 */   // Label 6731: @326359
     /* 326359 */   GIM_Reject,
     /* 326360 */ // Label 6729: @326360
     /* 326360 */ GIM_Reject,
     /* 326361 */ // Label 6721: @326361
     /* 326361 */ GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(326434),
     /* 326366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326380 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(326414), // Rule ID 2338 //
     /* 326385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 326400 */     // MIs[1] Operand 1
     /* 326400 */     // No operand predicates
     /* 326400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326402 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 326405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326412 */     GIR_RootConstrainSelectedInstOperands,
     /* 326413 */     // GIR_Coverage, 2338,
     /* 326413 */     GIR_EraseRootFromParent_Done,
     /* 326414 */   // Label 6733: @326414
     /* 326414 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(326433), // Rule ID 2337 //
     /* 326419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326426 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 326431 */     GIR_RootConstrainSelectedInstOperands,
     /* 326432 */     // GIR_Coverage, 2337,
     /* 326432 */     GIR_Done,
     /* 326433 */   // Label 6734: @326433
     /* 326433 */   GIM_Reject,
     /* 326434 */ // Label 6732: @326434
     /* 326434 */ GIM_Reject,
     /* 326435 */ // Label 6722: @326435
     /* 326435 */ GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(326468), // Rule ID 1537 //
     /* 326440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326461 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 326466 */   GIR_RootConstrainSelectedInstOperands,
     /* 326467 */   // GIR_Coverage, 1537,
     /* 326467 */   GIR_Done,
     /* 326468 */ // Label 6735: @326468
     /* 326468 */ GIM_Reject,
     /* 326469 */ // Label 6723: @326469
     /* 326469 */ GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(326502), // Rule ID 1535 //
     /* 326474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326495 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 326500 */   GIR_RootConstrainSelectedInstOperands,
     /* 326501 */   // GIR_Coverage, 1535,
     /* 326501 */   GIR_Done,
     /* 326502 */ // Label 6736: @326502
     /* 326502 */ GIM_Reject,
     /* 326503 */ // Label 6724: @326503
     /* 326503 */ GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(326536), // Rule ID 1538 //
     /* 326508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326529 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 326534 */   GIR_RootConstrainSelectedInstOperands,
     /* 326535 */   // GIR_Coverage, 1538,
     /* 326535 */   GIR_Done,
     /* 326536 */ // Label 6737: @326536
     /* 326536 */ GIM_Reject,
     /* 326537 */ // Label 6725: @326537
     /* 326537 */ GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(326570), // Rule ID 1533 //
     /* 326542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326563 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 326568 */   GIR_RootConstrainSelectedInstOperands,
     /* 326569 */   // GIR_Coverage, 1533,
     /* 326569 */   GIR_Done,
     /* 326570 */ // Label 6738: @326570
     /* 326570 */ GIM_Reject,
     /* 326571 */ // Label 6726: @326571
     /* 326571 */ GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(326604), // Rule ID 1536 //
     /* 326576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326597 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 326602 */   GIR_RootConstrainSelectedInstOperands,
     /* 326603 */   // GIR_Coverage, 1536,
     /* 326603 */   GIR_Done,
     /* 326604 */ // Label 6739: @326604
     /* 326604 */ GIM_Reject,
     /* 326605 */ // Label 6727: @326605
     /* 326605 */ GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(326638), // Rule ID 1534 //
     /* 326610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326627 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326631 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326631 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 326636 */   GIR_RootConstrainSelectedInstOperands,
     /* 326637 */   // GIR_Coverage, 1534,
     /* 326637 */   GIR_Done,
     /* 326638 */ // Label 6740: @326638
     /* 326638 */ GIM_Reject,
     /* 326639 */ // Label 6728: @326639
     /* 326639 */ GIM_Reject,
     /* 326640 */ // Label 82: @326640
     /* 326640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6749*/ GIMT_Encode4(327043),
     /* 326651 */ /*GILLT_s32*//*Label 6741*/ GIMT_Encode4(326691),
     /* 326655 */ /*GILLT_s64*//*Label 6742*/ GIMT_Encode4(326765), GIMT_Encode4(0),
     /* 326663 */ /*GILLT_v2s32*//*Label 6743*/ GIMT_Encode4(326839), GIMT_Encode4(0),
     /* 326671 */ /*GILLT_v4s16*//*Label 6744*/ GIMT_Encode4(326873),
     /* 326675 */ /*GILLT_v4s32*//*Label 6745*/ GIMT_Encode4(326907),
     /* 326679 */ /*GILLT_v8s8*//*Label 6746*/ GIMT_Encode4(326941),
     /* 326683 */ /*GILLT_v8s16*//*Label 6747*/ GIMT_Encode4(326975),
     /* 326687 */ /*GILLT_v16s8*//*Label 6748*/ GIMT_Encode4(327009),
     /* 326691 */ // Label 6741: @326691
     /* 326691 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(326764),
     /* 326696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326710 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(326744), // Rule ID 2332 //
     /* 326715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 326730 */     // MIs[1] Operand 1
     /* 326730 */     // No operand predicates
     /* 326730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326732 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 326735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326742 */     GIR_RootConstrainSelectedInstOperands,
     /* 326743 */     // GIR_Coverage, 2332,
     /* 326743 */     GIR_EraseRootFromParent_Done,
     /* 326744 */   // Label 6751: @326744
     /* 326744 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(326763), // Rule ID 2331 //
     /* 326749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326756 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 326761 */     GIR_RootConstrainSelectedInstOperands,
     /* 326762 */     // GIR_Coverage, 2331,
     /* 326762 */     GIR_Done,
     /* 326763 */   // Label 6752: @326763
     /* 326763 */   GIM_Reject,
     /* 326764 */ // Label 6750: @326764
     /* 326764 */ GIM_Reject,
     /* 326765 */ // Label 6742: @326765
     /* 326765 */ GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(326838),
     /* 326770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326784 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(326818), // Rule ID 2334 //
     /* 326789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 326804 */     // MIs[1] Operand 1
     /* 326804 */     // No operand predicates
     /* 326804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326806 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 326809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326816 */     GIR_RootConstrainSelectedInstOperands,
     /* 326817 */     // GIR_Coverage, 2334,
     /* 326817 */     GIR_EraseRootFromParent_Done,
     /* 326818 */   // Label 6754: @326818
     /* 326818 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(326837), // Rule ID 2333 //
     /* 326823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326830 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 326835 */     GIR_RootConstrainSelectedInstOperands,
     /* 326836 */     // GIR_Coverage, 2333,
     /* 326836 */     GIR_Done,
     /* 326837 */   // Label 6755: @326837
     /* 326837 */   GIM_Reject,
     /* 326838 */ // Label 6753: @326838
     /* 326838 */ GIM_Reject,
     /* 326839 */ // Label 6743: @326839
     /* 326839 */ GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(326872), // Rule ID 1525 //
     /* 326844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326865 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 326870 */   GIR_RootConstrainSelectedInstOperands,
     /* 326871 */   // GIR_Coverage, 1525,
     /* 326871 */   GIR_Done,
     /* 326872 */ // Label 6756: @326872
     /* 326872 */ GIM_Reject,
     /* 326873 */ // Label 6744: @326873
     /* 326873 */ GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(326906), // Rule ID 1523 //
     /* 326878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326899 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 326904 */   GIR_RootConstrainSelectedInstOperands,
     /* 326905 */   // GIR_Coverage, 1523,
     /* 326905 */   GIR_Done,
     /* 326906 */ // Label 6757: @326906
     /* 326906 */ GIM_Reject,
     /* 326907 */ // Label 6745: @326907
     /* 326907 */ GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(326940), // Rule ID 1526 //
     /* 326912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326933 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 326938 */   GIR_RootConstrainSelectedInstOperands,
     /* 326939 */   // GIR_Coverage, 1526,
     /* 326939 */   GIR_Done,
     /* 326940 */ // Label 6758: @326940
     /* 326940 */ GIM_Reject,
     /* 326941 */ // Label 6746: @326941
     /* 326941 */ GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(326974), // Rule ID 1521 //
     /* 326946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326967 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 326972 */   GIR_RootConstrainSelectedInstOperands,
     /* 326973 */   // GIR_Coverage, 1521,
     /* 326973 */   GIR_Done,
     /* 326974 */ // Label 6759: @326974
     /* 326974 */ GIM_Reject,
     /* 326975 */ // Label 6747: @326975
     /* 326975 */ GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(327008), // Rule ID 1524 //
     /* 326980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327001 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 327001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 327006 */   GIR_RootConstrainSelectedInstOperands,
     /* 327007 */   // GIR_Coverage, 1524,
     /* 327007 */   GIR_Done,
     /* 327008 */ // Label 6760: @327008
     /* 327008 */ GIM_Reject,
     /* 327009 */ // Label 6748: @327009
     /* 327009 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(327042), // Rule ID 1522 //
     /* 327014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 327023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327035 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 327035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 327040 */   GIR_RootConstrainSelectedInstOperands,
     /* 327041 */   // GIR_Coverage, 1522,
     /* 327041 */   GIR_Done,
     /* 327042 */ // Label 6761: @327042
     /* 327042 */ GIM_Reject,
     /* 327043 */ // Label 6749: @327043
     /* 327043 */ GIM_Reject,
     /* 327044 */ // Label 83: @327044
     /* 327044 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6771*/ GIMT_Encode4(327858),
     /* 327055 */ /*GILLT_s32*//*Label 6762*/ GIMT_Encode4(327095),
     /* 327059 */ /*GILLT_s64*//*Label 6763*/ GIMT_Encode4(327122), GIMT_Encode4(0),
     /* 327067 */ /*GILLT_v2s32*//*Label 6764*/ GIMT_Encode4(327201),
     /* 327071 */ /*GILLT_v2s64*//*Label 6765*/ GIMT_Encode4(327228),
     /* 327075 */ /*GILLT_v4s16*//*Label 6766*/ GIMT_Encode4(327411),
     /* 327079 */ /*GILLT_v4s32*//*Label 6767*/ GIMT_Encode4(327438),
     /* 327083 */ /*GILLT_v8s8*//*Label 6768*/ GIMT_Encode4(327621),
     /* 327087 */ /*GILLT_v8s16*//*Label 6769*/ GIMT_Encode4(327648),
     /* 327091 */ /*GILLT_v16s8*//*Label 6770*/ GIMT_Encode4(327831),
     /* 327095 */ // Label 6762: @327095
     /* 327095 */ GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(327121), // Rule ID 2317 //
     /* 327100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327114 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 327114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 327119 */   GIR_RootConstrainSelectedInstOperands,
     /* 327120 */   // GIR_Coverage, 2317,
     /* 327120 */   GIR_Done,
     /* 327121 */ // Label 6772: @327121
     /* 327121 */ GIM_Reject,
     /* 327122 */ // Label 6763: @327122
     /* 327122 */ GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(327200),
     /* 327127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327130 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(327153), // Rule ID 1652 //
     /* 327135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327146 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 327146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 327151 */     GIR_RootConstrainSelectedInstOperands,
     /* 327152 */     // GIR_Coverage, 1652,
     /* 327152 */     GIR_Done,
     /* 327153 */   // Label 6774: @327153
     /* 327153 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(327176), // Rule ID 2318 //
     /* 327158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327169 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 327169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 327174 */     GIR_RootConstrainSelectedInstOperands,
     /* 327175 */     // GIR_Coverage, 2318,
     /* 327175 */     GIR_Done,
     /* 327176 */   // Label 6775: @327176
     /* 327176 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(327199), // Rule ID 2514 //
     /* 327181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 327184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327192 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 327192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 327197 */     GIR_RootConstrainSelectedInstOperands,
     /* 327198 */     // GIR_Coverage, 2514,
     /* 327198 */     GIR_Done,
     /* 327199 */   // Label 6776: @327199
     /* 327199 */   GIM_Reject,
     /* 327200 */ // Label 6773: @327200
     /* 327200 */ GIM_Reject,
     /* 327201 */ // Label 6764: @327201
     /* 327201 */ GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(327227), // Rule ID 707 //
     /* 327206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327220 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 327220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 327225 */   GIR_RootConstrainSelectedInstOperands,
     /* 327226 */   // GIR_Coverage, 707,
     /* 327226 */   GIR_Done,
     /* 327227 */ // Label 6777: @327227
     /* 327227 */ GIM_Reject,
     /* 327228 */ // Label 6765: @327228
     /* 327228 */ GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(327410),
     /* 327233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327240 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(327318), // Rule ID 4877 //
     /* 327245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327281 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 327294 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 327301 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 327301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 327304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327316 */     GIR_RootConstrainSelectedInstOperands,
     /* 327317 */     // GIR_Coverage, 4877,
     /* 327317 */     GIR_EraseRootFromParent_Done,
     /* 327318 */   // Label 6779: @327318
     /* 327318 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(327390), // Rule ID 4876 //
     /* 327323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327368 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327375 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 327375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 327378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327388 */     GIR_RootConstrainSelectedInstOperands,
     /* 327389 */     // GIR_Coverage, 4876,
     /* 327389 */     GIR_EraseRootFromParent_Done,
     /* 327390 */   // Label 6780: @327390
     /* 327390 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(327409), // Rule ID 709 //
     /* 327395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327402 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 327402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 327407 */     GIR_RootConstrainSelectedInstOperands,
     /* 327408 */     // GIR_Coverage, 709,
     /* 327408 */     GIR_Done,
     /* 327409 */   // Label 6781: @327409
     /* 327409 */   GIM_Reject,
     /* 327410 */ // Label 6778: @327410
     /* 327410 */ GIM_Reject,
     /* 327411 */ // Label 6766: @327411
     /* 327411 */ GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(327437), // Rule ID 705 //
     /* 327416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327430 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 327430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 327435 */   GIR_RootConstrainSelectedInstOperands,
     /* 327436 */   // GIR_Coverage, 705,
     /* 327436 */   GIR_Done,
     /* 327437 */ // Label 6782: @327437
     /* 327437 */ GIM_Reject,
     /* 327438 */ // Label 6767: @327438
     /* 327438 */ GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(327620),
     /* 327443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327450 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(327528), // Rule ID 4875 //
     /* 327455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327497 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 327504 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 327511 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 327511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 327514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327526 */     GIR_RootConstrainSelectedInstOperands,
     /* 327527 */     // GIR_Coverage, 4875,
     /* 327527 */     GIR_EraseRootFromParent_Done,
     /* 327528 */   // Label 6784: @327528
     /* 327528 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(327600), // Rule ID 4874 //
     /* 327533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327574 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327578 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327585 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 327585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 327588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327598 */     GIR_RootConstrainSelectedInstOperands,
     /* 327599 */     // GIR_Coverage, 4874,
     /* 327599 */     GIR_EraseRootFromParent_Done,
     /* 327600 */   // Label 6785: @327600
     /* 327600 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(327619), // Rule ID 708 //
     /* 327605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327612 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 327612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 327617 */     GIR_RootConstrainSelectedInstOperands,
     /* 327618 */     // GIR_Coverage, 708,
     /* 327618 */     GIR_Done,
     /* 327619 */   // Label 6786: @327619
     /* 327619 */   GIM_Reject,
     /* 327620 */ // Label 6783: @327620
     /* 327620 */ GIM_Reject,
     /* 327621 */ // Label 6768: @327621
     /* 327621 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(327647), // Rule ID 703 //
     /* 327626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327640 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 327640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 327645 */   GIR_RootConstrainSelectedInstOperands,
     /* 327646 */   // GIR_Coverage, 703,
     /* 327646 */   GIR_Done,
     /* 327647 */ // Label 6787: @327647
     /* 327647 */ GIM_Reject,
     /* 327648 */ // Label 6769: @327648
     /* 327648 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(327830),
     /* 327653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327660 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(327738), // Rule ID 4873 //
     /* 327665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327693 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327697 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327701 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327707 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 327714 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 327721 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 327721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 327724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327736 */     GIR_RootConstrainSelectedInstOperands,
     /* 327737 */     // GIR_Coverage, 4873,
     /* 327737 */     GIR_EraseRootFromParent_Done,
     /* 327738 */   // Label 6789: @327738
     /* 327738 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(327810), // Rule ID 4872 //
     /* 327743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327788 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327795 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 327795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 327798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327808 */     GIR_RootConstrainSelectedInstOperands,
     /* 327809 */     // GIR_Coverage, 4872,
     /* 327809 */     GIR_EraseRootFromParent_Done,
     /* 327810 */   // Label 6790: @327810
     /* 327810 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(327829), // Rule ID 706 //
     /* 327815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327822 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 327822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 327827 */     GIR_RootConstrainSelectedInstOperands,
     /* 327828 */     // GIR_Coverage, 706,
     /* 327828 */     GIR_Done,
     /* 327829 */   // Label 6791: @327829
     /* 327829 */   GIM_Reject,
     /* 327830 */ // Label 6788: @327830
     /* 327830 */ GIM_Reject,
     /* 327831 */ // Label 6770: @327831
     /* 327831 */ GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(327857), // Rule ID 704 //
     /* 327836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327850 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 327850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 327855 */   GIR_RootConstrainSelectedInstOperands,
     /* 327856 */   // GIR_Coverage, 704,
     /* 327856 */   GIR_Done,
     /* 327857 */ // Label 6792: @327857
     /* 327857 */ GIM_Reject,
     /* 327858 */ // Label 6771: @327858
     /* 327858 */ GIM_Reject,
     /* 327859 */ // Label 84: @327859
     /* 327859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6795*/ GIMT_Encode4(328024),
     /* 327870 */ /*GILLT_s32*//*Label 6793*/ GIMT_Encode4(327878),
     /* 327874 */ /*GILLT_s64*//*Label 6794*/ GIMT_Encode4(327951),
     /* 327878 */ // Label 6793: @327878
     /* 327878 */ GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(327904), // Rule ID 4718 //
     /* 327883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327893 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 327893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 327898 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327902 */   GIR_RootConstrainSelectedInstOperands,
     /* 327903 */   // GIR_Coverage, 4718,
     /* 327903 */   GIR_Done,
     /* 327904 */ // Label 6796: @327904
     /* 327904 */ GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(327927), // Rule ID 4724 //
     /* 327909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327916 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 327916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 327921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327925 */   GIR_RootConstrainSelectedInstOperands,
     /* 327926 */   // GIR_Coverage, 4724,
     /* 327926 */   GIR_Done,
     /* 327927 */ // Label 6797: @327927
     /* 327927 */ GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(327950), // Rule ID 4726 //
     /* 327932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327939 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 327939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 327944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327948 */   GIR_RootConstrainSelectedInstOperands,
     /* 327949 */   // GIR_Coverage, 4726,
     /* 327949 */   GIR_Done,
     /* 327950 */ // Label 6798: @327950
     /* 327950 */ GIM_Reject,
     /* 327951 */ // Label 6794: @327951
     /* 327951 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(327977), // Rule ID 4720 //
     /* 327956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 327962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327966 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 327966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 327971 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327975 */   GIR_RootConstrainSelectedInstOperands,
     /* 327976 */   // GIR_Coverage, 4720,
     /* 327976 */   GIR_Done,
     /* 327977 */ // Label 6799: @327977
     /* 327977 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(328000), // Rule ID 4728 //
     /* 327982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327989 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 327989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 327994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 327998 */   GIR_RootConstrainSelectedInstOperands,
     /* 327999 */   // GIR_Coverage, 4728,
     /* 327999 */   GIR_Done,
     /* 328000 */ // Label 6800: @328000
     /* 328000 */ GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(328023), // Rule ID 4730 //
     /* 328005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328012 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 328012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 328017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328021 */   GIR_RootConstrainSelectedInstOperands,
     /* 328022 */   // GIR_Coverage, 4730,
     /* 328022 */   GIR_Done,
     /* 328023 */ // Label 6801: @328023
     /* 328023 */ GIM_Reject,
     /* 328024 */ // Label 6795: @328024
     /* 328024 */ GIM_Reject,
     /* 328025 */ // Label 85: @328025
     /* 328025 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(328123),
     /* 328030 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 328033 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6806*/ GIMT_Encode4(328122),
     /* 328044 */   /*GILLT_s16*//*Label 6803*/ GIMT_Encode4(328056),
     /* 328048 */   /*GILLT_s32*//*Label 6804*/ GIMT_Encode4(328080),
     /* 328052 */   /*GILLT_s64*//*Label 6805*/ GIMT_Encode4(328101),
     /* 328056 */   // Label 6803: @328056
     /* 328056 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(328079), // Rule ID 4722 //
     /* 328061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328068 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 328068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 328073 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328077 */     GIR_RootConstrainSelectedInstOperands,
     /* 328078 */     // GIR_Coverage, 4722,
     /* 328078 */     GIR_Done,
     /* 328079 */   // Label 6807: @328079
     /* 328079 */   GIM_Reject,
     /* 328080 */   // Label 6804: @328080
     /* 328080 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(328100), // Rule ID 4732 //
     /* 328085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328089 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 328089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 328094 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328098 */     GIR_RootConstrainSelectedInstOperands,
     /* 328099 */     // GIR_Coverage, 4732,
     /* 328099 */     GIR_Done,
     /* 328100 */   // Label 6808: @328100
     /* 328100 */   GIM_Reject,
     /* 328101 */   // Label 6805: @328101
     /* 328101 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(328121), // Rule ID 4734 //
     /* 328106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328110 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 328110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 328115 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328119 */     GIR_RootConstrainSelectedInstOperands,
     /* 328120 */     // GIR_Coverage, 4734,
     /* 328120 */     GIR_Done,
     /* 328121 */   // Label 6809: @328121
     /* 328121 */   GIM_Reject,
     /* 328122 */   // Label 6806: @328122
     /* 328122 */   GIM_Reject,
     /* 328123 */ // Label 6802: @328123
     /* 328123 */ GIM_Reject,
     /* 328124 */ // Label 86: @328124
     /* 328124 */ GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(328139), // Rule ID 225 //
     /* 328129 */   // MIs[0] addr
     /* 328129 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 328132 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 328132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 328137 */   GIR_RootConstrainSelectedInstOperands,
     /* 328138 */   // GIR_Coverage, 225,
     /* 328138 */   GIR_Done,
     /* 328139 */ // Label 6810: @328139
     /* 328139 */ GIM_Reject,
     /* 328140 */ // Label 87: @328140
     /* 328140 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6822*/ GIMT_Encode4(333511),
     /* 328151 */ /*GILLT_s64*//*Label 6811*/ GIMT_Encode4(328223), GIMT_Encode4(0),
     /* 328159 */ /*GILLT_v2s32*//*Label 6812*/ GIMT_Encode4(328625), GIMT_Encode4(0),
     /* 328167 */ /*GILLT_v4s16*//*Label 6813*/ GIMT_Encode4(329027), GIMT_Encode4(0),
     /* 328175 */ /*GILLT_v8s8*//*Label 6814*/ GIMT_Encode4(329429), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 328187 */ /*GILLT_nxv1s1*//*Label 6815*/ GIMT_Encode4(329609),
     /* 328191 */ /*GILLT_nxv2s1*//*Label 6816*/ GIMT_Encode4(331872),
     /* 328195 */ /*GILLT_nxv2s16*//*Label 6817*/ GIMT_Encode4(332727),
     /* 328199 */ /*GILLT_nxv2s32*//*Label 6818*/ GIMT_Encode4(333014), GIMT_Encode4(0),
     /* 328207 */ /*GILLT_nxv4s1*//*Label 6819*/ GIMT_Encode4(333084),
     /* 328211 */ /*GILLT_nxv4s16*//*Label 6820*/ GIMT_Encode4(333371), GIMT_Encode4(0),
     /* 328219 */ /*GILLT_nxv8s1*//*Label 6821*/ GIMT_Encode4(333441),
     /* 328223 */ // Label 6811: @328223
     /* 328223 */ GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(328624),
     /* 328228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328235 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(328287), // Rule ID 5565 //
     /* 328240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328252 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328259 */     // MIs[0] Operand 2
     /* 328259 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328272 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 328272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 328275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328285 */     GIR_RootConstrainSelectedInstOperands,
     /* 328286 */     // GIR_Coverage, 5565,
     /* 328286 */     GIR_EraseRootFromParent_Done,
     /* 328287 */   // Label 6824: @328287
     /* 328287 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(328339), // Rule ID 5568 //
     /* 328292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328304 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328311 */     // MIs[0] Operand 2
     /* 328311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328324 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 328324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 328327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328337 */     GIR_RootConstrainSelectedInstOperands,
     /* 328338 */     // GIR_Coverage, 5568,
     /* 328338 */     GIR_EraseRootFromParent_Done,
     /* 328339 */   // Label 6825: @328339
     /* 328339 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(328407), // Rule ID 5444 //
     /* 328344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328348 */     // MIs[0] Operand 2
     /* 328348 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328359 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328375 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328379 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328406 */     // GIR_Coverage, 5444,
     /* 328406 */     GIR_EraseRootFromParent_Done,
     /* 328407 */   // Label 6826: @328407
     /* 328407 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(328475), // Rule ID 5449 //
     /* 328412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328416 */     // MIs[0] Operand 2
     /* 328416 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328427 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328439 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328447 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328457 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328474 */     // GIR_Coverage, 5449,
     /* 328474 */     GIR_EraseRootFromParent_Done,
     /* 328475 */   // Label 6827: @328475
     /* 328475 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(328517), // Rule ID 6856 //
     /* 328480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328484 */     // MIs[0] Operand 2
     /* 328484 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328495 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 328495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328500 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328516 */     // GIR_Coverage, 6856,
     /* 328516 */     GIR_EraseRootFromParent_Done,
     /* 328517 */   // Label 6828: @328517
     /* 328517 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(328559), // Rule ID 6857 //
     /* 328522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328526 */     // MIs[0] Operand 2
     /* 328526 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328537 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 328537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328542 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328558 */     // GIR_Coverage, 6857,
     /* 328558 */     GIR_EraseRootFromParent_Done,
     /* 328559 */   // Label 6829: @328559
     /* 328559 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(328623), // Rule ID 6861 //
     /* 328564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328568 */     // MIs[0] Operand 2
     /* 328568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328579 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 328579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 328586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 328598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328605 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328622 */     // GIR_Coverage, 6861,
     /* 328622 */     GIR_EraseRootFromParent_Done,
     /* 328623 */   // Label 6830: @328623
     /* 328623 */   GIM_Reject,
     /* 328624 */ // Label 6823: @328624
     /* 328624 */ GIM_Reject,
     /* 328625 */ // Label 6812: @328625
     /* 328625 */ GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(329026),
     /* 328630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328637 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(328689), // Rule ID 5564 //
     /* 328642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328654 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328661 */     // MIs[0] Operand 2
     /* 328661 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328674 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 328674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 328677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328687 */     GIR_RootConstrainSelectedInstOperands,
     /* 328688 */     // GIR_Coverage, 5564,
     /* 328688 */     GIR_EraseRootFromParent_Done,
     /* 328689 */   // Label 6832: @328689
     /* 328689 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(328741), // Rule ID 5567 //
     /* 328694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328706 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328713 */     // MIs[0] Operand 2
     /* 328713 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328726 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 328726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 328729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328739 */     GIR_RootConstrainSelectedInstOperands,
     /* 328740 */     // GIR_Coverage, 5567,
     /* 328740 */     GIR_EraseRootFromParent_Done,
     /* 328741 */   // Label 6833: @328741
     /* 328741 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(328809), // Rule ID 5434 //
     /* 328746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328750 */     // MIs[0] Operand 2
     /* 328750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328761 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328773 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328777 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328781 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328791 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328798 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328803 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328808 */     // GIR_Coverage, 5434,
     /* 328808 */     GIR_EraseRootFromParent_Done,
     /* 328809 */   // Label 6834: @328809
     /* 328809 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(328877), // Rule ID 5439 //
     /* 328814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328818 */     // MIs[0] Operand 2
     /* 328818 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 328829 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328859 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328876 */     // GIR_Coverage, 5439,
     /* 328876 */     GIR_EraseRootFromParent_Done,
     /* 328877 */   // Label 6835: @328877
     /* 328877 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(328919), // Rule ID 6853 //
     /* 328882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328886 */     // MIs[0] Operand 2
     /* 328886 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328897 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 328897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328902 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328918 */     // GIR_Coverage, 6853,
     /* 328918 */     GIR_EraseRootFromParent_Done,
     /* 328919 */   // Label 6836: @328919
     /* 328919 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(328961), // Rule ID 6855 //
     /* 328924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328928 */     // MIs[0] Operand 2
     /* 328928 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328939 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 328939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328944 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328960 */     // GIR_Coverage, 6855,
     /* 328960 */     GIR_EraseRootFromParent_Done,
     /* 328961 */   // Label 6837: @328961
     /* 328961 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(329025), // Rule ID 6860 //
     /* 328966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328970 */     // MIs[0] Operand 2
     /* 328970 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328981 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 328981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 328988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328997 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329007 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329024 */     // GIR_Coverage, 6860,
     /* 329024 */     GIR_EraseRootFromParent_Done,
     /* 329025 */   // Label 6838: @329025
     /* 329025 */   GIM_Reject,
     /* 329026 */ // Label 6831: @329026
     /* 329026 */ GIM_Reject,
     /* 329027 */ // Label 6813: @329027
     /* 329027 */ GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(329428),
     /* 329032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329039 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(329091), // Rule ID 5563 //
     /* 329044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329056 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329063 */     // MIs[0] Operand 2
     /* 329063 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329076 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 329076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 329079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329089 */     GIR_RootConstrainSelectedInstOperands,
     /* 329090 */     // GIR_Coverage, 5563,
     /* 329090 */     GIR_EraseRootFromParent_Done,
     /* 329091 */   // Label 6840: @329091
     /* 329091 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(329143), // Rule ID 5566 //
     /* 329096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329108 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329115 */     // MIs[0] Operand 2
     /* 329115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329128 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 329128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 329131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329141 */     GIR_RootConstrainSelectedInstOperands,
     /* 329142 */     // GIR_Coverage, 5566,
     /* 329142 */     GIR_EraseRootFromParent_Done,
     /* 329143 */   // Label 6841: @329143
     /* 329143 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(329211), // Rule ID 5424 //
     /* 329148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329152 */     // MIs[0] Operand 2
     /* 329152 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329163 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329175 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329183 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329193 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329210 */     // GIR_Coverage, 5424,
     /* 329210 */     GIR_EraseRootFromParent_Done,
     /* 329211 */   // Label 6842: @329211
     /* 329211 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(329279), // Rule ID 5429 //
     /* 329216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329220 */     // MIs[0] Operand 2
     /* 329220 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329231 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329278 */     // GIR_Coverage, 5429,
     /* 329278 */     GIR_EraseRootFromParent_Done,
     /* 329279 */   // Label 6843: @329279
     /* 329279 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(329321), // Rule ID 6851 //
     /* 329284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329288 */     // MIs[0] Operand 2
     /* 329288 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329299 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 329299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329304 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329320 */     // GIR_Coverage, 6851,
     /* 329320 */     GIR_EraseRootFromParent_Done,
     /* 329321 */   // Label 6844: @329321
     /* 329321 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(329363), // Rule ID 6854 //
     /* 329326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329330 */     // MIs[0] Operand 2
     /* 329330 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329341 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 329341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329346 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329362 */     // GIR_Coverage, 6854,
     /* 329362 */     GIR_EraseRootFromParent_Done,
     /* 329363 */   // Label 6845: @329363
     /* 329363 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(329427), // Rule ID 6859 //
     /* 329368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329372 */     // MIs[0] Operand 2
     /* 329372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329383 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329395 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329399 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329426 */     // GIR_Coverage, 6859,
     /* 329426 */     GIR_EraseRootFromParent_Done,
     /* 329427 */   // Label 6846: @329427
     /* 329427 */   GIM_Reject,
     /* 329428 */ // Label 6839: @329428
     /* 329428 */ GIM_Reject,
     /* 329429 */ // Label 6814: @329429
     /* 329429 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(329608),
     /* 329434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329445 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(329509), // Rule ID 5419 //
     /* 329450 */     // MIs[0] Operand 2
     /* 329450 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 329461 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329481 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329491 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329508 */     // GIR_Coverage, 5419,
     /* 329508 */     GIR_EraseRootFromParent_Done,
     /* 329509 */   // Label 6848: @329509
     /* 329509 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(329547), // Rule ID 6852 //
     /* 329514 */     // MIs[0] Operand 2
     /* 329514 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329525 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 329525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329530 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329546 */     // GIR_Coverage, 6852,
     /* 329546 */     GIR_EraseRootFromParent_Done,
     /* 329547 */   // Label 6849: @329547
     /* 329547 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(329607), // Rule ID 6858 //
     /* 329552 */     // MIs[0] Operand 2
     /* 329552 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329563 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329575 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329606 */     // GIR_Coverage, 6858,
     /* 329606 */     GIR_EraseRootFromParent_Done,
     /* 329607 */   // Label 6850: @329607
     /* 329607 */   GIM_Reject,
     /* 329608 */ // Label 6847: @329608
     /* 329608 */ GIM_Reject,
     /* 329609 */ // Label 6815: @329609
     /* 329609 */ GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(329644), // Rule ID 8914 //
     /* 329614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 329620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329624 */   // MIs[0] Operand 2
     /* 329624 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329635 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 329635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329640 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329642 */   GIR_RootConstrainSelectedInstOperands,
     /* 329643 */   // GIR_Coverage, 8914,
     /* 329643 */   GIR_EraseRootFromParent_Done,
     /* 329644 */ // Label 6851: @329644
     /* 329644 */ GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(329679), // Rule ID 8915 //
     /* 329649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 329655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329659 */   // MIs[0] Operand 2
     /* 329659 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329670 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 329670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329675 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 329677 */   GIR_RootConstrainSelectedInstOperands,
     /* 329678 */   // GIR_Coverage, 8915,
     /* 329678 */   GIR_EraseRootFromParent_Done,
     /* 329679 */ // Label 6852: @329679
     /* 329679 */ GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(329733), // Rule ID 8922 //
     /* 329684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329694 */   // MIs[0] Operand 2
     /* 329694 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329705 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329731 */   GIR_RootConstrainSelectedInstOperands,
     /* 329732 */   // GIR_Coverage, 8922,
     /* 329732 */   GIR_EraseRootFromParent_Done,
     /* 329733 */ // Label 6853: @329733
     /* 329733 */ GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(329787), // Rule ID 8923 //
     /* 329738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329748 */   // MIs[0] Operand 2
     /* 329748 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329759 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329771 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329785 */   GIR_RootConstrainSelectedInstOperands,
     /* 329786 */   // GIR_Coverage, 8923,
     /* 329786 */   GIR_EraseRootFromParent_Done,
     /* 329787 */ // Label 6854: @329787
     /* 329787 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(329841), // Rule ID 8924 //
     /* 329792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329802 */   // MIs[0] Operand 2
     /* 329802 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329813 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329839 */   GIR_RootConstrainSelectedInstOperands,
     /* 329840 */   // GIR_Coverage, 8924,
     /* 329840 */   GIR_EraseRootFromParent_Done,
     /* 329841 */ // Label 6855: @329841
     /* 329841 */ GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(329895), // Rule ID 8925 //
     /* 329846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 329852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329856 */   // MIs[0] Operand 2
     /* 329856 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 329867 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 329867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 329888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329893 */   GIR_RootConstrainSelectedInstOperands,
     /* 329894 */   // GIR_Coverage, 8925,
     /* 329894 */   GIR_EraseRootFromParent_Done,
     /* 329895 */ // Label 6856: @329895
     /* 329895 */ GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(329966), // Rule ID 8934 //
     /* 329900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329910 */   // MIs[0] Operand 2
     /* 329910 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329921 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329921 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329924 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329928 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329933 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 329937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 329939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 329942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329951 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 329954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 329961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329964 */   GIR_RootConstrainSelectedInstOperands,
     /* 329965 */   // GIR_Coverage, 8934,
     /* 329965 */   GIR_EraseRootFromParent_Done,
     /* 329966 */ // Label 6857: @329966
     /* 329966 */ GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(330037), // Rule ID 8935 //
     /* 329971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 329974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 329977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 329981 */   // MIs[0] Operand 2
     /* 329981 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329992 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 329992 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 329995 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 329999 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330004 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330022 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330035 */   GIR_RootConstrainSelectedInstOperands,
     /* 330036 */   // GIR_Coverage, 8935,
     /* 330036 */   GIR_EraseRootFromParent_Done,
     /* 330037 */ // Label 6858: @330037
     /* 330037 */ GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(330108), // Rule ID 8936 //
     /* 330042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330052 */   // MIs[0] Operand 2
     /* 330052 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330063 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330063 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330066 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330070 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330075 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330093 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330103 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330106 */   GIR_RootConstrainSelectedInstOperands,
     /* 330107 */   // GIR_Coverage, 8936,
     /* 330107 */   GIR_EraseRootFromParent_Done,
     /* 330108 */ // Label 6859: @330108
     /* 330108 */ GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(330179), // Rule ID 8937 //
     /* 330113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330123 */   // MIs[0] Operand 2
     /* 330123 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 330134 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330134 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330137 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330141 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330146 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330164 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330177 */   GIR_RootConstrainSelectedInstOperands,
     /* 330178 */   // GIR_Coverage, 8937,
     /* 330178 */   GIR_EraseRootFromParent_Done,
     /* 330179 */ // Label 6860: @330179
     /* 330179 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(330250), // Rule ID 8938 //
     /* 330184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330194 */   // MIs[0] Operand 2
     /* 330194 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330205 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330205 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330208 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330212 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330217 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330235 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330248 */   GIR_RootConstrainSelectedInstOperands,
     /* 330249 */   // GIR_Coverage, 8938,
     /* 330249 */   GIR_EraseRootFromParent_Done,
     /* 330250 */ // Label 6861: @330250
     /* 330250 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(330321), // Rule ID 8939 //
     /* 330255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330265 */   // MIs[0] Operand 2
     /* 330265 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 330276 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330276 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330279 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330283 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330288 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330306 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330319 */   GIR_RootConstrainSelectedInstOperands,
     /* 330320 */   // GIR_Coverage, 8939,
     /* 330320 */   GIR_EraseRootFromParent_Done,
     /* 330321 */ // Label 6862: @330321
     /* 330321 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(330392), // Rule ID 8940 //
     /* 330326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330336 */   // MIs[0] Operand 2
     /* 330336 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 330347 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330347 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330350 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330354 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330359 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330390 */   GIR_RootConstrainSelectedInstOperands,
     /* 330391 */   // GIR_Coverage, 8940,
     /* 330391 */   GIR_EraseRootFromParent_Done,
     /* 330392 */ // Label 6863: @330392
     /* 330392 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(330463), // Rule ID 8941 //
     /* 330397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330407 */   // MIs[0] Operand 2
     /* 330407 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 330418 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330418 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330421 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330425 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330430 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330434 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330448 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330461 */   GIR_RootConstrainSelectedInstOperands,
     /* 330462 */   // GIR_Coverage, 8941,
     /* 330462 */   GIR_EraseRootFromParent_Done,
     /* 330463 */ // Label 6864: @330463
     /* 330463 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(330551), // Rule ID 8950 //
     /* 330468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330478 */   // MIs[0] Operand 2
     /* 330478 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330489 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330489 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330492 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330496 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330501 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330519 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330549 */   GIR_RootConstrainSelectedInstOperands,
     /* 330550 */   // GIR_Coverage, 8950,
     /* 330550 */   GIR_EraseRootFromParent_Done,
     /* 330551 */ // Label 6865: @330551
     /* 330551 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(330639), // Rule ID 8951 //
     /* 330556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330566 */   // MIs[0] Operand 2
     /* 330566 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330577 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330577 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330580 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330584 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330589 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330607 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330624 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330637 */   GIR_RootConstrainSelectedInstOperands,
     /* 330638 */   // GIR_Coverage, 8951,
     /* 330638 */   GIR_EraseRootFromParent_Done,
     /* 330639 */ // Label 6866: @330639
     /* 330639 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(330727), // Rule ID 8952 //
     /* 330644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330654 */   // MIs[0] Operand 2
     /* 330654 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330665 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330665 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330668 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330672 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330677 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330683 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330686 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330690 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330695 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330712 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330725 */   GIR_RootConstrainSelectedInstOperands,
     /* 330726 */   // GIR_Coverage, 8952,
     /* 330726 */   GIR_EraseRootFromParent_Done,
     /* 330727 */ // Label 6867: @330727
     /* 330727 */ GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(330815), // Rule ID 8953 //
     /* 330732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330742 */   // MIs[0] Operand 2
     /* 330742 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 330753 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330753 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330756 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330760 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330765 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330771 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330774 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330778 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330783 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330800 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330813 */   GIR_RootConstrainSelectedInstOperands,
     /* 330814 */   // GIR_Coverage, 8953,
     /* 330814 */   GIR_EraseRootFromParent_Done,
     /* 330815 */ // Label 6868: @330815
     /* 330815 */ GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(330903), // Rule ID 8954 //
     /* 330820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330830 */   // MIs[0] Operand 2
     /* 330830 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330841 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330841 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330844 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330848 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330853 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330859 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330862 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330866 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330871 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330888 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330901 */   GIR_RootConstrainSelectedInstOperands,
     /* 330902 */   // GIR_Coverage, 8954,
     /* 330902 */   GIR_EraseRootFromParent_Done,
     /* 330903 */ // Label 6869: @330903
     /* 330903 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(330991), // Rule ID 8955 //
     /* 330908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 330914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330918 */   // MIs[0] Operand 2
     /* 330918 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 330929 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 330929 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 330932 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330936 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330941 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 330947 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330950 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330954 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330959 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 330962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330976 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330989 */   GIR_RootConstrainSelectedInstOperands,
     /* 330990 */   // GIR_Coverage, 8955,
     /* 330990 */   GIR_EraseRootFromParent_Done,
     /* 330991 */ // Label 6870: @330991
     /* 330991 */ GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(331079), // Rule ID 8956 //
     /* 330996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331006 */   // MIs[0] Operand 2
     /* 331006 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 331017 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331017 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331020 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331024 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331029 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331047 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331064 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331077 */   GIR_RootConstrainSelectedInstOperands,
     /* 331078 */   // GIR_Coverage, 8956,
     /* 331078 */   GIR_EraseRootFromParent_Done,
     /* 331079 */ // Label 6871: @331079
     /* 331079 */ GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(331167), // Rule ID 8957 //
     /* 331084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331094 */   // MIs[0] Operand 2
     /* 331094 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 331105 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331105 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331108 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331112 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331117 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331123 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331126 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331130 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331135 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331152 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331155 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331162 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331165 */   GIR_RootConstrainSelectedInstOperands,
     /* 331166 */   // GIR_Coverage, 8957,
     /* 331166 */   GIR_EraseRootFromParent_Done,
     /* 331167 */ // Label 6872: @331167
     /* 331167 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(331255), // Rule ID 8958 //
     /* 331172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331182 */   // MIs[0] Operand 2
     /* 331182 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 331193 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331193 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331196 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331200 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331205 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331211 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331214 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331218 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331223 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331240 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331253 */   GIR_RootConstrainSelectedInstOperands,
     /* 331254 */   // GIR_Coverage, 8958,
     /* 331254 */   GIR_EraseRootFromParent_Done,
     /* 331255 */ // Label 6873: @331255
     /* 331255 */ GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(331343), // Rule ID 8959 //
     /* 331260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331270 */   // MIs[0] Operand 2
     /* 331270 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 331281 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331281 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331284 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331288 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331293 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331299 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331302 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331306 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331311 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331328 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331341 */   GIR_RootConstrainSelectedInstOperands,
     /* 331342 */   // GIR_Coverage, 8959,
     /* 331342 */   GIR_EraseRootFromParent_Done,
     /* 331343 */ // Label 6874: @331343
     /* 331343 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(331431), // Rule ID 8960 //
     /* 331348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331358 */   // MIs[0] Operand 2
     /* 331358 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 331369 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331369 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331372 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331376 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331381 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331387 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331390 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331394 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331399 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331416 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331429 */   GIR_RootConstrainSelectedInstOperands,
     /* 331430 */   // GIR_Coverage, 8960,
     /* 331430 */   GIR_EraseRootFromParent_Done,
     /* 331431 */ // Label 6875: @331431
     /* 331431 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(331519), // Rule ID 8961 //
     /* 331436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331446 */   // MIs[0] Operand 2
     /* 331446 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 331457 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331457 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331460 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331464 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331469 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331475 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331478 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331482 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331487 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331504 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331517 */   GIR_RootConstrainSelectedInstOperands,
     /* 331518 */   // GIR_Coverage, 8961,
     /* 331518 */   GIR_EraseRootFromParent_Done,
     /* 331519 */ // Label 6876: @331519
     /* 331519 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(331607), // Rule ID 8962 //
     /* 331524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331534 */   // MIs[0] Operand 2
     /* 331534 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 331545 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331545 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331548 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331552 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331557 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331563 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331566 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331570 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331575 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331592 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331605 */   GIR_RootConstrainSelectedInstOperands,
     /* 331606 */   // GIR_Coverage, 8962,
     /* 331606 */   GIR_EraseRootFromParent_Done,
     /* 331607 */ // Label 6877: @331607
     /* 331607 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(331695), // Rule ID 8963 //
     /* 331612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331622 */   // MIs[0] Operand 2
     /* 331622 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 331633 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331651 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331654 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331658 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331663 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331680 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331693 */   GIR_RootConstrainSelectedInstOperands,
     /* 331694 */   // GIR_Coverage, 8963,
     /* 331694 */   GIR_EraseRootFromParent_Done,
     /* 331695 */ // Label 6878: @331695
     /* 331695 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(331783), // Rule ID 8964 //
     /* 331700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331710 */   // MIs[0] Operand 2
     /* 331710 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 331721 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331739 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331742 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331746 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331751 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331768 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331781 */   GIR_RootConstrainSelectedInstOperands,
     /* 331782 */   // GIR_Coverage, 8964,
     /* 331782 */   GIR_EraseRootFromParent_Done,
     /* 331783 */ // Label 6879: @331783
     /* 331783 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(331871), // Rule ID 8965 //
     /* 331788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331798 */   // MIs[0] Operand 2
     /* 331798 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 331809 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331809 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331812 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331816 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331821 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331827 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331830 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331834 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331839 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331844 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331847 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331851 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331856 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331869 */   GIR_RootConstrainSelectedInstOperands,
     /* 331870 */   // GIR_Coverage, 8965,
     /* 331870 */   GIR_EraseRootFromParent_Done,
     /* 331871 */ // Label 6880: @331871
     /* 331871 */ GIM_Reject,
     /* 331872 */ // Label 6816: @331872
     /* 331872 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(331907), // Rule ID 8916 //
     /* 331877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331887 */   // MIs[0] Operand 2
     /* 331887 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331898 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 331898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331903 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331905 */   GIR_RootConstrainSelectedInstOperands,
     /* 331906 */   // GIR_Coverage, 8916,
     /* 331906 */   GIR_EraseRootFromParent_Done,
     /* 331907 */ // Label 6881: @331907
     /* 331907 */ GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(331942), // Rule ID 8917 //
     /* 331912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 331918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331922 */   // MIs[0] Operand 2
     /* 331922 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331933 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 331933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331938 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 331940 */   GIR_RootConstrainSelectedInstOperands,
     /* 331941 */   // GIR_Coverage, 8917,
     /* 331941 */   GIR_EraseRootFromParent_Done,
     /* 331942 */ // Label 6882: @331942
     /* 331942 */ GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(331996), // Rule ID 8926 //
     /* 331947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 331953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331957 */   // MIs[0] Operand 2
     /* 331957 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331968 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 331968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331994 */   GIR_RootConstrainSelectedInstOperands,
     /* 331995 */   // GIR_Coverage, 8926,
     /* 331995 */   GIR_EraseRootFromParent_Done,
     /* 331996 */ // Label 6883: @331996
     /* 331996 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(332050), // Rule ID 8927 //
     /* 332001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332011 */   // MIs[0] Operand 2
     /* 332011 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332022 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332034 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332048 */   GIR_RootConstrainSelectedInstOperands,
     /* 332049 */   // GIR_Coverage, 8927,
     /* 332049 */   GIR_EraseRootFromParent_Done,
     /* 332050 */ // Label 6884: @332050
     /* 332050 */ GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(332104), // Rule ID 8928 //
     /* 332055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332065 */   // MIs[0] Operand 2
     /* 332065 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332076 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332088 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332102 */   GIR_RootConstrainSelectedInstOperands,
     /* 332103 */   // GIR_Coverage, 8928,
     /* 332103 */   GIR_EraseRootFromParent_Done,
     /* 332104 */ // Label 6885: @332104
     /* 332104 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(332158), // Rule ID 8929 //
     /* 332109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332119 */   // MIs[0] Operand 2
     /* 332119 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332130 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332142 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332156 */   GIR_RootConstrainSelectedInstOperands,
     /* 332157 */   // GIR_Coverage, 8929,
     /* 332157 */   GIR_EraseRootFromParent_Done,
     /* 332158 */ // Label 6886: @332158
     /* 332158 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(332229), // Rule ID 8942 //
     /* 332163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332173 */   // MIs[0] Operand 2
     /* 332173 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332184 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332184 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332187 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332191 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332196 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332214 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332227 */   GIR_RootConstrainSelectedInstOperands,
     /* 332228 */   // GIR_Coverage, 8942,
     /* 332228 */   GIR_EraseRootFromParent_Done,
     /* 332229 */ // Label 6887: @332229
     /* 332229 */ GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(332300), // Rule ID 8943 //
     /* 332234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332244 */   // MIs[0] Operand 2
     /* 332244 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332255 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332255 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332258 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332262 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332267 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332271 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332285 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332298 */   GIR_RootConstrainSelectedInstOperands,
     /* 332299 */   // GIR_Coverage, 8943,
     /* 332299 */   GIR_EraseRootFromParent_Done,
     /* 332300 */ // Label 6888: @332300
     /* 332300 */ GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(332371), // Rule ID 8944 //
     /* 332305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332315 */   // MIs[0] Operand 2
     /* 332315 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332326 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332338 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332356 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332369 */   GIR_RootConstrainSelectedInstOperands,
     /* 332370 */   // GIR_Coverage, 8944,
     /* 332370 */   GIR_EraseRootFromParent_Done,
     /* 332371 */ // Label 6889: @332371
     /* 332371 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(332442), // Rule ID 8945 //
     /* 332376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332386 */   // MIs[0] Operand 2
     /* 332386 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332397 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332397 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332400 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332404 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332409 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332427 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332440 */   GIR_RootConstrainSelectedInstOperands,
     /* 332441 */   // GIR_Coverage, 8945,
     /* 332441 */   GIR_EraseRootFromParent_Done,
     /* 332442 */ // Label 6890: @332442
     /* 332442 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(332513), // Rule ID 8946 //
     /* 332447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332457 */   // MIs[0] Operand 2
     /* 332457 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 332468 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332468 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332471 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332475 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332480 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332498 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332508 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332511 */   GIR_RootConstrainSelectedInstOperands,
     /* 332512 */   // GIR_Coverage, 8946,
     /* 332512 */   GIR_EraseRootFromParent_Done,
     /* 332513 */ // Label 6891: @332513
     /* 332513 */ GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(332584), // Rule ID 8947 //
     /* 332518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332528 */   // MIs[0] Operand 2
     /* 332528 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 332539 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332539 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332542 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332546 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332551 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332569 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332582 */   GIR_RootConstrainSelectedInstOperands,
     /* 332583 */   // GIR_Coverage, 8947,
     /* 332583 */   GIR_EraseRootFromParent_Done,
     /* 332584 */ // Label 6892: @332584
     /* 332584 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(332655), // Rule ID 8948 //
     /* 332589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332599 */   // MIs[0] Operand 2
     /* 332599 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 332610 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332610 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332613 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332617 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332622 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332640 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332653 */   GIR_RootConstrainSelectedInstOperands,
     /* 332654 */   // GIR_Coverage, 8948,
     /* 332654 */   GIR_EraseRootFromParent_Done,
     /* 332655 */ // Label 6893: @332655
     /* 332655 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(332726), // Rule ID 8949 //
     /* 332660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332670 */   // MIs[0] Operand 2
     /* 332670 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 332681 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332681 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332684 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332688 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332693 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332711 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332724 */   GIR_RootConstrainSelectedInstOperands,
     /* 332725 */   // GIR_Coverage, 8949,
     /* 332725 */   GIR_EraseRootFromParent_Done,
     /* 332726 */ // Label 6894: @332726
     /* 332726 */ GIM_Reject,
     /* 332727 */ // Label 6817: @332727
     /* 332727 */ GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(332762), // Rule ID 8966 //
     /* 332732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 332738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332742 */   // MIs[0] Operand 2
     /* 332742 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332753 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 332753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332758 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332760 */   GIR_RootConstrainSelectedInstOperands,
     /* 332761 */   // GIR_Coverage, 8966,
     /* 332761 */   GIR_EraseRootFromParent_Done,
     /* 332762 */ // Label 6895: @332762
     /* 332762 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(332797), // Rule ID 8967 //
     /* 332767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 332773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332777 */   // MIs[0] Operand 2
     /* 332777 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332788 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 332788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332793 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 332795 */   GIR_RootConstrainSelectedInstOperands,
     /* 332796 */   // GIR_Coverage, 8967,
     /* 332796 */   GIR_EraseRootFromParent_Done,
     /* 332797 */ // Label 6896: @332797
     /* 332797 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(332851), // Rule ID 8972 //
     /* 332802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332812 */   // MIs[0] Operand 2
     /* 332812 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332823 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 332830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332835 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332849 */   GIR_RootConstrainSelectedInstOperands,
     /* 332850 */   // GIR_Coverage, 8972,
     /* 332850 */   GIR_EraseRootFromParent_Done,
     /* 332851 */ // Label 6897: @332851
     /* 332851 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(332905), // Rule ID 8973 //
     /* 332856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332866 */   // MIs[0] Operand 2
     /* 332866 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332877 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 332884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332889 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 332898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332900 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332903 */   GIR_RootConstrainSelectedInstOperands,
     /* 332904 */   // GIR_Coverage, 8973,
     /* 332904 */   GIR_EraseRootFromParent_Done,
     /* 332905 */ // Label 6898: @332905
     /* 332905 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(332959), // Rule ID 8974 //
     /* 332910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332920 */   // MIs[0] Operand 2
     /* 332920 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332931 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332931 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332934 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 332938 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332943 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 332947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 332952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 332954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332957 */   GIR_RootConstrainSelectedInstOperands,
     /* 332958 */   // GIR_Coverage, 8974,
     /* 332958 */   GIR_EraseRootFromParent_Done,
     /* 332959 */ // Label 6899: @332959
     /* 332959 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(333013), // Rule ID 8975 //
     /* 332964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 332970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 332974 */   // MIs[0] Operand 2
     /* 332974 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332985 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 332985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 332988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 332992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332997 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 333001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 333006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333011 */   GIR_RootConstrainSelectedInstOperands,
     /* 333012 */   // GIR_Coverage, 8975,
     /* 333012 */   GIR_EraseRootFromParent_Done,
     /* 333013 */ // Label 6900: @333013
     /* 333013 */ GIM_Reject,
     /* 333014 */ // Label 6818: @333014
     /* 333014 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(333083),
     /* 333019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 333022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333026 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(333054), // Rule ID 8970 //
     /* 333031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333034 */     // MIs[0] Operand 2
     /* 333034 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333045 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 333045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 333048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333052 */     GIR_RootConstrainSelectedInstOperands,
     /* 333053 */     // GIR_Coverage, 8970,
     /* 333053 */     GIR_EraseRootFromParent_Done,
     /* 333054 */   // Label 6902: @333054
     /* 333054 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(333082), // Rule ID 8971 //
     /* 333059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333062 */     // MIs[0] Operand 2
     /* 333062 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333073 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 333073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 333076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333080 */     GIR_RootConstrainSelectedInstOperands,
     /* 333081 */     // GIR_Coverage, 8971,
     /* 333081 */     GIR_EraseRootFromParent_Done,
     /* 333082 */   // Label 6903: @333082
     /* 333082 */   GIM_Reject,
     /* 333083 */ // Label 6901: @333083
     /* 333083 */ GIM_Reject,
     /* 333084 */ // Label 6819: @333084
     /* 333084 */ GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(333119), // Rule ID 8918 //
     /* 333089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333099 */   // MIs[0] Operand 2
     /* 333099 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333110 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 333110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333115 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333117 */   GIR_RootConstrainSelectedInstOperands,
     /* 333118 */   // GIR_Coverage, 8918,
     /* 333118 */   GIR_EraseRootFromParent_Done,
     /* 333119 */ // Label 6904: @333119
     /* 333119 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(333154), // Rule ID 8919 //
     /* 333124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333134 */   // MIs[0] Operand 2
     /* 333134 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333145 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 333145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333150 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333152 */   GIR_RootConstrainSelectedInstOperands,
     /* 333153 */   // GIR_Coverage, 8919,
     /* 333153 */   GIR_EraseRootFromParent_Done,
     /* 333154 */ // Label 6905: @333154
     /* 333154 */ GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(333208), // Rule ID 8930 //
     /* 333159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333169 */   // MIs[0] Operand 2
     /* 333169 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333180 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333192 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333206 */   GIR_RootConstrainSelectedInstOperands,
     /* 333207 */   // GIR_Coverage, 8930,
     /* 333207 */   GIR_EraseRootFromParent_Done,
     /* 333208 */ // Label 6906: @333208
     /* 333208 */ GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(333262), // Rule ID 8931 //
     /* 333213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333223 */   // MIs[0] Operand 2
     /* 333223 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333234 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333246 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333260 */   GIR_RootConstrainSelectedInstOperands,
     /* 333261 */   // GIR_Coverage, 8931,
     /* 333261 */   GIR_EraseRootFromParent_Done,
     /* 333262 */ // Label 6907: @333262
     /* 333262 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(333316), // Rule ID 8932 //
     /* 333267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333277 */   // MIs[0] Operand 2
     /* 333277 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 333288 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333300 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333314 */   GIR_RootConstrainSelectedInstOperands,
     /* 333315 */   // GIR_Coverage, 8932,
     /* 333315 */   GIR_EraseRootFromParent_Done,
     /* 333316 */ // Label 6908: @333316
     /* 333316 */ GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(333370), // Rule ID 8933 //
     /* 333321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333331 */   // MIs[0] Operand 2
     /* 333331 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 333342 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333368 */   GIR_RootConstrainSelectedInstOperands,
     /* 333369 */   // GIR_Coverage, 8933,
     /* 333369 */   GIR_EraseRootFromParent_Done,
     /* 333370 */ // Label 6909: @333370
     /* 333370 */ GIM_Reject,
     /* 333371 */ // Label 6820: @333371
     /* 333371 */ GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(333440),
     /* 333376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333383 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(333411), // Rule ID 8968 //
     /* 333388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333391 */     // MIs[0] Operand 2
     /* 333391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333402 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 333405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333409 */     GIR_RootConstrainSelectedInstOperands,
     /* 333410 */     // GIR_Coverage, 8968,
     /* 333410 */     GIR_EraseRootFromParent_Done,
     /* 333411 */   // Label 6911: @333411
     /* 333411 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(333439), // Rule ID 8969 //
     /* 333416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333419 */     // MIs[0] Operand 2
     /* 333419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333430 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 333433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333437 */     GIR_RootConstrainSelectedInstOperands,
     /* 333438 */     // GIR_Coverage, 8969,
     /* 333438 */     GIR_EraseRootFromParent_Done,
     /* 333439 */   // Label 6912: @333439
     /* 333439 */   GIM_Reject,
     /* 333440 */ // Label 6910: @333440
     /* 333440 */ GIM_Reject,
     /* 333441 */ // Label 6821: @333441
     /* 333441 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(333510),
     /* 333446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333453 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(333481), // Rule ID 8920 //
     /* 333458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333461 */     // MIs[0] Operand 2
     /* 333461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333472 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 333472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333479 */     GIR_RootConstrainSelectedInstOperands,
     /* 333480 */     // GIR_Coverage, 8920,
     /* 333480 */     GIR_EraseRootFromParent_Done,
     /* 333481 */   // Label 6914: @333481
     /* 333481 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(333509), // Rule ID 8921 //
     /* 333486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333489 */     // MIs[0] Operand 2
     /* 333489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 333500 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 333500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333507 */     GIR_RootConstrainSelectedInstOperands,
     /* 333508 */     // GIR_Coverage, 8921,
     /* 333508 */     GIR_EraseRootFromParent_Done,
     /* 333509 */   // Label 6915: @333509
     /* 333509 */   GIM_Reject,
     /* 333510 */ // Label 6913: @333510
     /* 333510 */ GIM_Reject,
     /* 333511 */ // Label 6822: @333511
     /* 333511 */ GIM_Reject,
     /* 333512 */ // Label 88: @333512
     /* 333512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6931*/ GIMT_Encode4(360908),
     /* 333523 */ /*GILLT_s64*//*Label 6916*/ GIMT_Encode4(333607), GIMT_Encode4(0),
     /* 333531 */ /*GILLT_v2s32*//*Label 6917*/ GIMT_Encode4(334317),
     /* 333535 */ /*GILLT_v2s64*//*Label 6918*/ GIMT_Encode4(337848),
     /* 333539 */ /*GILLT_v4s16*//*Label 6919*/ GIMT_Encode4(340677),
     /* 333543 */ /*GILLT_v4s32*//*Label 6920*/ GIMT_Encode4(344317),
     /* 333547 */ /*GILLT_v8s8*//*Label 6921*/ GIMT_Encode4(346981),
     /* 333551 */ /*GILLT_v8s16*//*Label 6922*/ GIMT_Encode4(348825),
     /* 333555 */ /*GILLT_v16s8*//*Label 6923*/ GIMT_Encode4(351800), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 333567 */ /*GILLT_nxv2s16*//*Label 6924*/ GIMT_Encode4(353380),
     /* 333571 */ /*GILLT_nxv2s32*//*Label 6925*/ GIMT_Encode4(353505),
     /* 333575 */ /*GILLT_nxv2s64*//*Label 6926*/ GIMT_Encode4(353630), GIMT_Encode4(0),
     /* 333583 */ /*GILLT_nxv4s16*//*Label 6927*/ GIMT_Encode4(355544),
     /* 333587 */ /*GILLT_nxv4s32*//*Label 6928*/ GIMT_Encode4(355696), GIMT_Encode4(0),
     /* 333595 */ /*GILLT_nxv8s16*//*Label 6929*/ GIMT_Encode4(357664), GIMT_Encode4(0),
     /* 333603 */ /*GILLT_nxv16s8*//*Label 6930*/ GIMT_Encode4(359858),
     /* 333607 */ // Label 6916: @333607
     /* 333607 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(334316),
     /* 333612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 333618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 333621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333625 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(333755), // Rule ID 5713 //
     /* 333630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333663 */     // MIs[2] Operand 1
     /* 333663 */     // No operand predicates
     /* 333663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333671 */     // MIs[3] Operand 1
     /* 333671 */     // No operand predicates
     /* 333671 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333673 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333673 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333676 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333680 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333685 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333688 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333692 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333700 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333717 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333754 */     // GIR_Coverage, 5713,
     /* 333754 */     GIR_EraseRootFromParent_Done,
     /* 333755 */   // Label 6933: @333755
     /* 333755 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(333916), // Rule ID 5714 //
     /* 333760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 333776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333793 */     // MIs[2] Operand 1
     /* 333793 */     // No operand predicates
     /* 333793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333801 */     // MIs[3] Operand 1
     /* 333801 */     // No operand predicates
     /* 333801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333803 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333803 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 333806 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333810 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333815 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 333818 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 333822 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 333825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333830 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333847 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333850 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333854 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 333874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 333885 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 333888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 333891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 333898 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333915 */     // GIR_Coverage, 5714,
     /* 333915 */     GIR_EraseRootFromParent_Done,
     /* 333916 */   // Label 6934: @333916
     /* 333916 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(334046), // Rule ID 5737 //
     /* 333921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 333929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 333950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333954 */     // MIs[2] Operand 1
     /* 333954 */     // No operand predicates
     /* 333954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 333958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 333962 */     // MIs[3] Operand 1
     /* 333962 */     // No operand predicates
     /* 333962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 333964 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 333964 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333967 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 333971 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333976 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 333983 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 333986 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333991 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 333999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 334003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334008 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334028 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334045 */     // GIR_Coverage, 5737,
     /* 334045 */     GIR_EraseRootFromParent_Done,
     /* 334046 */   // Label 6935: @334046
     /* 334046 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(334207), // Rule ID 5738 //
     /* 334051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 334067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334084 */     // MIs[2] Operand 1
     /* 334084 */     // No operand predicates
     /* 334084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334092 */     // MIs[3] Operand 1
     /* 334092 */     // No operand predicates
     /* 334092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334094 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334094 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 334097 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334101 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334106 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 334109 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334113 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 334116 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334121 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334126 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334129 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334133 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334138 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334141 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334145 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334148 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 334165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334170 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 334179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334206 */     // GIR_Coverage, 5738,
     /* 334206 */     GIR_EraseRootFromParent_Done,
     /* 334207 */   // Label 6936: @334207
     /* 334207 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(334243), // Rule ID 6632 //
     /* 334212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334230 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 334230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334242 */     // GIR_Coverage, 6632,
     /* 334242 */     GIR_EraseRootFromParent_Done,
     /* 334243 */   // Label 6937: @334243
     /* 334243 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(334279), // Rule ID 6634 //
     /* 334248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334266 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 334266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334278 */     // GIR_Coverage, 6634,
     /* 334278 */     GIR_EraseRootFromParent_Done,
     /* 334279 */   // Label 6938: @334279
     /* 334279 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(334315), // Rule ID 6636 //
     /* 334284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334302 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 334302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334305 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 334307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334314 */     // GIR_Coverage, 6636,
     /* 334314 */     GIR_EraseRootFromParent_Done,
     /* 334315 */   // Label 6939: @334315
     /* 334315 */   GIM_Reject,
     /* 334316 */ // Label 6932: @334316
     /* 334316 */ GIM_Reject,
     /* 334317 */ // Label 6917: @334317
     /* 334317 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(337847),
     /* 334322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 334325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334335 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(334444), // Rule ID 4262 //
     /* 334340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334360 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334367 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334384 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334411 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334443 */     // GIR_Coverage, 4262,
     /* 334443 */     GIR_EraseRootFromParent_Done,
     /* 334444 */   // Label 6941: @334444
     /* 334444 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(334553), // Rule ID 4263 //
     /* 334449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334469 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334472 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334476 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334493 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334552 */     // GIR_Coverage, 4263,
     /* 334552 */     GIR_EraseRootFromParent_Done,
     /* 334553 */   // Label 6942: @334553
     /* 334553 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(334662), // Rule ID 4370 //
     /* 334558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334585 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334602 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334661 */     // GIR_Coverage, 4370,
     /* 334661 */     GIR_EraseRootFromParent_Done,
     /* 334662 */   // Label 6943: @334662
     /* 334662 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(334771), // Rule ID 4371 //
     /* 334667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334687 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334694 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334711 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334738 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334770 */     // GIR_Coverage, 4371,
     /* 334770 */     GIR_EraseRootFromParent_Done,
     /* 334771 */   // Label 6944: @334771
     /* 334771 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(334876), // Rule ID 4268 //
     /* 334776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334799 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334816 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334875 */     // GIR_Coverage, 4268,
     /* 334875 */     GIR_EraseRootFromParent_Done,
     /* 334876 */   // Label 6945: @334876
     /* 334876 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(334981), // Rule ID 4270 //
     /* 334881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334904 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334921 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334948 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334980 */     // GIR_Coverage, 4270,
     /* 334980 */     GIR_EraseRootFromParent_Done,
     /* 334981 */   // Label 6946: @334981
     /* 334981 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(335086), // Rule ID 4376 //
     /* 334986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335002 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335009 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335026 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335053 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335085 */     // GIR_Coverage, 4376,
     /* 335085 */     GIR_EraseRootFromParent_Done,
     /* 335086 */   // Label 6947: @335086
     /* 335086 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(335191), // Rule ID 4378 //
     /* 335091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335131 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335158 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335190 */     // GIR_Coverage, 4378,
     /* 335190 */     GIR_EraseRootFromParent_Done,
     /* 335191 */   // Label 6948: @335191
     /* 335191 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(335295), // Rule ID 4260 //
     /* 335196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335216 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335223 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335240 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335262 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335294 */     // GIR_Coverage, 4260,
     /* 335294 */     GIR_EraseRootFromParent_Done,
     /* 335295 */   // Label 6949: @335295
     /* 335295 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(335399), // Rule ID 4261 //
     /* 335300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335320 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335327 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335344 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335366 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335398 */     // GIR_Coverage, 4261,
     /* 335398 */     GIR_EraseRootFromParent_Done,
     /* 335399 */   // Label 6950: @335399
     /* 335399 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(335503), // Rule ID 4368 //
     /* 335404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335408 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335414 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335424 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335431 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335448 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335470 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335502 */     // GIR_Coverage, 4368,
     /* 335502 */     GIR_EraseRootFromParent_Done,
     /* 335503 */   // Label 6951: @335503
     /* 335503 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(335607), // Rule ID 4369 //
     /* 335508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335528 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335535 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335552 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335606 */     // GIR_Coverage, 4369,
     /* 335606 */     GIR_EraseRootFromParent_Done,
     /* 335607 */   // Label 6952: @335607
     /* 335607 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(335707), // Rule ID 4264 //
     /* 335612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335628 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335635 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335645 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335652 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335674 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335706 */     // GIR_Coverage, 4264,
     /* 335706 */     GIR_EraseRootFromParent_Done,
     /* 335707 */   // Label 6953: @335707
     /* 335707 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(335807), // Rule ID 4266 //
     /* 335712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335728 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335735 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335752 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335806 */     // GIR_Coverage, 4266,
     /* 335806 */     GIR_EraseRootFromParent_Done,
     /* 335807 */   // Label 6954: @335807
     /* 335807 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(335907), // Rule ID 4372 //
     /* 335812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335828 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335835 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335852 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335874 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335906 */     // GIR_Coverage, 4372,
     /* 335906 */     GIR_EraseRootFromParent_Done,
     /* 335907 */   // Label 6955: @335907
     /* 335907 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(336007), // Rule ID 4374 //
     /* 335912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335935 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335952 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335974 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336006 */     // GIR_Coverage, 4374,
     /* 336006 */     GIR_EraseRootFromParent_Done,
     /* 336007 */   // Label 6956: @336007
     /* 336007 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(336127), // Rule ID 6411 //
     /* 336012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336031 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336034 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336038 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336045 */     // MIs[2] Rn
     /* 336045 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 336049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336060 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 336060 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 336063 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336067 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 336081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336089 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 336092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 336096 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336126 */     // GIR_Coverage, 6411,
     /* 336126 */     GIR_EraseRootFromParent_Done,
     /* 336127 */   // Label 6957: @336127
     /* 336127 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(336247), // Rule ID 6413 //
     /* 336132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336151 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336154 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336158 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336165 */     // MIs[2] Rn
     /* 336165 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 336169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336180 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 336180 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 336183 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336187 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 336201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 336212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 336216 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336246 */     // GIR_Coverage, 6413,
     /* 336246 */     GIR_EraseRootFromParent_Done,
     /* 336247 */   // Label 6958: @336247
     /* 336247 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(336377), // Rule ID 5707 //
     /* 336252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336285 */     // MIs[2] Operand 1
     /* 336285 */     // No operand predicates
     /* 336285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336293 */     // MIs[3] Operand 1
     /* 336293 */     // No operand predicates
     /* 336293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336295 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336307 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336314 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336317 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336322 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336339 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336359 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336376 */     // GIR_Coverage, 5707,
     /* 336376 */     GIR_EraseRootFromParent_Done,
     /* 336377 */   // Label 6959: @336377
     /* 336377 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(336538), // Rule ID 5708 //
     /* 336382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336415 */     // MIs[2] Operand 1
     /* 336415 */     // No operand predicates
     /* 336415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336423 */     // MIs[3] Operand 1
     /* 336423 */     // No operand predicates
     /* 336423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336425 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336425 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336428 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336432 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336437 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336440 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336444 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336447 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336452 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336457 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336460 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336464 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336469 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336476 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336501 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336507 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336520 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336537 */     // GIR_Coverage, 5708,
     /* 336537 */     GIR_EraseRootFromParent_Done,
     /* 336538 */   // Label 6960: @336538
     /* 336538 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(336668), // Rule ID 5731 //
     /* 336543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336576 */     // MIs[2] Operand 1
     /* 336576 */     // No operand predicates
     /* 336576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336584 */     // MIs[3] Operand 1
     /* 336584 */     // No operand predicates
     /* 336584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336586 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336598 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336601 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336605 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336608 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336613 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336630 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336650 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336667 */     // GIR_Coverage, 5731,
     /* 336667 */     GIR_EraseRootFromParent_Done,
     /* 336668 */   // Label 6961: @336668
     /* 336668 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(336829), // Rule ID 5732 //
     /* 336673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336706 */     // MIs[2] Operand 1
     /* 336706 */     // No operand predicates
     /* 336706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336714 */     // MIs[3] Operand 1
     /* 336714 */     // No operand predicates
     /* 336714 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336716 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336716 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336719 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336723 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336728 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336731 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336735 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336738 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336743 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336760 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336763 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336767 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336770 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336775 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336811 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336818 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336828 */     // GIR_Coverage, 5732,
     /* 336828 */     GIR_EraseRootFromParent_Done,
     /* 336829 */   // Label 6962: @336829
     /* 336829 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(336895), // Rule ID 5662 //
     /* 336834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336852 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 336852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 336855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336894 */     // GIR_Coverage, 5662,
     /* 336894 */     GIR_EraseRootFromParent_Done,
     /* 336895 */   // Label 6963: @336895
     /* 336895 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(336961), // Rule ID 5674 //
     /* 336900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336918 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 336918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 336921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 336942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336960 */     // GIR_Coverage, 5674,
     /* 336960 */     GIR_EraseRootFromParent_Done,
     /* 336961 */   // Label 6964: @336961
     /* 336961 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(337096), // Rule ID 5682 //
     /* 336966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 336978 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 336982 */     // MIs[1] Operand 1
     /* 336982 */     // No operand predicates
     /* 336982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 336986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336990 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 336994 */     // MIs[2] Operand 1
     /* 336994 */     // No operand predicates
     /* 336994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336996 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 336996 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 336999 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337003 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337010 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337013 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337017 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337022 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337025 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337029 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337032 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337042 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 337054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337059 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 337065 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 337071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337078 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337095 */     // GIR_Coverage, 5682,
     /* 337095 */     GIR_EraseRootFromParent_Done,
     /* 337096 */   // Label 6965: @337096
     /* 337096 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(337228), // Rule ID 6419 //
     /* 337101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337113 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337116 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337120 */     // MIs[1] Rn
     /* 337120 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337141 */     // MIs[2] Operand 1
     /* 337141 */     // No operand predicates
     /* 337141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337143 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337162 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337170 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 337182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337187 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337197 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337210 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337227 */     // GIR_Coverage, 6419,
     /* 337227 */     GIR_EraseRootFromParent_Done,
     /* 337228 */   // Label 6966: @337228
     /* 337228 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(337360), // Rule ID 6420 //
     /* 337233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337252 */     // MIs[1] Rn
     /* 337252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337269 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337273 */     // MIs[2] Operand 1
     /* 337273 */     // No operand predicates
     /* 337273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337275 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337287 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337294 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337297 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337302 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 337314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337342 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337359 */     // GIR_Coverage, 6420,
     /* 337359 */     GIR_EraseRootFromParent_Done,
     /* 337360 */   // Label 6967: @337360
     /* 337360 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(337543), // Rule ID 5740 //
     /* 337365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 337373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337390 */     // MIs[2] Operand 1
     /* 337390 */     // No operand predicates
     /* 337390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337392 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337392 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 337395 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337399 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337406 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 337409 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337413 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337418 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337421 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 337425 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 337428 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337433 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337438 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337443 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337446 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337450 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337457 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337460 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337464 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337469 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337472 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337476 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337479 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337506 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 337512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337525 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337542 */     // GIR_Coverage, 5740,
     /* 337542 */     GIR_EraseRootFromParent_Done,
     /* 337543 */   // Label 6968: @337543
     /* 337543 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(337721), // Rule ID 5685 //
     /* 337548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337568 */     // MIs[1] Operand 1
     /* 337568 */     // No operand predicates
     /* 337568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337570 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337570 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 337573 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337577 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337584 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 337587 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337591 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337596 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337599 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337603 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 337606 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337611 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337616 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337621 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337624 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337628 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337647 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337654 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 337693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 337696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337720 */     // GIR_Coverage, 5685,
     /* 337720 */     GIR_EraseRootFromParent_Done,
     /* 337721 */   // Label 6969: @337721
     /* 337721 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(337846), // Rule ID 5688 //
     /* 337726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 337738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337746 */     // MIs[1] Operand 1
     /* 337746 */     // No operand predicates
     /* 337746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337748 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 337748 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337751 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337755 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337762 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337765 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337769 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337774 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337777 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337781 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 337806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337811 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 337817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 337821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337845 */     // GIR_Coverage, 5688,
     /* 337845 */     GIR_EraseRootFromParent_Done,
     /* 337846 */   // Label 6970: @337846
     /* 337846 */   GIM_Reject,
     /* 337847 */ // Label 6940: @337847
     /* 337847 */ GIM_Reject,
     /* 337848 */ // Label 6918: @337848
     /* 337848 */ GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(340676),
     /* 337853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 337859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 337862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337866 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(337975), // Rule ID 4286 //
     /* 337871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337875 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337891 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 337898 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 337902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 337915 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 337915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 337922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337942 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 337958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 337964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337974 */     // GIR_Coverage, 4286,
     /* 337974 */     GIR_EraseRootFromParent_Done,
     /* 337975 */   // Label 6972: @337975
     /* 337975 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(338084), // Rule ID 4287 //
     /* 337980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337984 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 337990 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 337992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 337996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338000 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338003 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338007 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338024 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338051 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338083 */     // GIR_Coverage, 4287,
     /* 338083 */     GIR_EraseRootFromParent_Done,
     /* 338084 */   // Label 6973: @338084
     /* 338084 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(338193), // Rule ID 4394 //
     /* 338089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338109 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338116 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338126 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338133 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338192 */     // GIR_Coverage, 4394,
     /* 338192 */     GIR_EraseRootFromParent_Done,
     /* 338193 */   // Label 6974: @338193
     /* 338193 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(338302), // Rule ID 4395 //
     /* 338198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338202 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338208 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338218 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338221 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338225 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338242 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338301 */     // GIR_Coverage, 4395,
     /* 338301 */     GIR_EraseRootFromParent_Done,
     /* 338302 */   // Label 6975: @338302
     /* 338302 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(338407), // Rule ID 4292 //
     /* 338307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338323 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338330 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338340 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338347 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338374 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338406 */     // GIR_Coverage, 4292,
     /* 338406 */     GIR_EraseRootFromParent_Done,
     /* 338407 */   // Label 6976: @338407
     /* 338407 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(338512), // Rule ID 4294 //
     /* 338412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338428 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338435 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338439 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338452 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338479 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338511 */     // GIR_Coverage, 4294,
     /* 338511 */     GIR_EraseRootFromParent_Done,
     /* 338512 */   // Label 6977: @338512
     /* 338512 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(338617), // Rule ID 4400 //
     /* 338517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338533 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338540 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338557 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338584 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338616 */     // GIR_Coverage, 4400,
     /* 338616 */     GIR_EraseRootFromParent_Done,
     /* 338617 */   // Label 6978: @338617
     /* 338617 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(338722), // Rule ID 4402 //
     /* 338622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338638 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338645 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338655 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338662 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338689 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338721 */     // GIR_Coverage, 4402,
     /* 338721 */     GIR_EraseRootFromParent_Done,
     /* 338722 */   // Label 6979: @338722
     /* 338722 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(338826), // Rule ID 4284 //
     /* 338727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338731 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338737 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338747 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338750 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338754 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338758 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338764 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 338771 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 338771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 338778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338793 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338825 */     // GIR_Coverage, 4284,
     /* 338825 */     GIR_EraseRootFromParent_Done,
     /* 338826 */   // Label 6980: @338826
     /* 338826 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(338930), // Rule ID 4285 //
     /* 338831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338835 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338841 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338851 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 338875 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 338875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 338882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338929 */     // GIR_Coverage, 4285,
     /* 338929 */     GIR_EraseRootFromParent_Done,
     /* 338930 */   // Label 6981: @338930
     /* 338930 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(339034), // Rule ID 4392 //
     /* 338935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338939 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338945 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338955 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338962 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338972 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 338979 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 338979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 338986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339001 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339033 */     // GIR_Coverage, 4392,
     /* 339033 */     GIR_EraseRootFromParent_Done,
     /* 339034 */   // Label 6982: @339034
     /* 339034 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(339138), // Rule ID 4393 //
     /* 339039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339043 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339049 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339059 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339066 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339076 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339083 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339105 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339137 */     // GIR_Coverage, 4393,
     /* 339137 */     GIR_EraseRootFromParent_Done,
     /* 339138 */   // Label 6983: @339138
     /* 339138 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(339238), // Rule ID 4288 //
     /* 339143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339159 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339166 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339176 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339183 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339237 */     // GIR_Coverage, 4288,
     /* 339237 */     GIR_EraseRootFromParent_Done,
     /* 339238 */   // Label 6984: @339238
     /* 339238 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(339338), // Rule ID 4290 //
     /* 339243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339259 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339266 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339276 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339283 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339305 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339337 */     // GIR_Coverage, 4290,
     /* 339337 */     GIR_EraseRootFromParent_Done,
     /* 339338 */   // Label 6985: @339338
     /* 339338 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(339438), // Rule ID 4396 //
     /* 339343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339359 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339362 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339366 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339376 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339383 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339405 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339437 */     // GIR_Coverage, 4396,
     /* 339437 */     GIR_EraseRootFromParent_Done,
     /* 339438 */   // Label 6986: @339438
     /* 339438 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(339538), // Rule ID 4398 //
     /* 339443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339459 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339462 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339466 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339476 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339483 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339505 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339527 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339537 */     // GIR_Coverage, 4398,
     /* 339537 */     GIR_EraseRootFromParent_Done,
     /* 339538 */   // Label 6987: @339538
     /* 339538 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(339616), // Rule ID 1941 //
     /* 339543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 339546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339583 */     // MIs[2] Operand 1
     /* 339583 */     // No operand predicates
     /* 339583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339591 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339595 */     // MIs[3] Operand 1
     /* 339595 */     // No operand predicates
     /* 339595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339597 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 339597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 339614 */     GIR_RootConstrainSelectedInstOperands,
     /* 339615 */     // GIR_Coverage, 1941,
     /* 339615 */     GIR_EraseRootFromParent_Done,
     /* 339616 */   // Label 6988: @339616
     /* 339616 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(339707), // Rule ID 7367 //
     /* 339621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 339624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 339636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 339644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339648 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 339651 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 339658 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 339661 */     // MIs[2] Rn
     /* 339661 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 339665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 339670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339678 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 339682 */     // MIs[3] Operand 1
     /* 339682 */     // No operand predicates
     /* 339682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339684 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15795>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 339684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 339687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 339691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 339694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 339698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 339705 */     GIR_RootConstrainSelectedInstOperands,
     /* 339706 */     // GIR_Coverage, 7367,
     /* 339706 */     GIR_EraseRootFromParent_Done,
     /* 339707 */   // Label 6989: @339707
     /* 339707 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(339774), // Rule ID 5711 //
     /* 339712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339745 */     // MIs[2] Operand 1
     /* 339745 */     // No operand predicates
     /* 339745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339753 */     // MIs[3] Operand 1
     /* 339753 */     // No operand predicates
     /* 339753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339755 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339772 */     GIR_RootConstrainSelectedInstOperands,
     /* 339773 */     // GIR_Coverage, 5711,
     /* 339773 */     GIR_EraseRootFromParent_Done,
     /* 339774 */   // Label 6990: @339774
     /* 339774 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(339872), // Rule ID 5712 //
     /* 339779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339812 */     // MIs[2] Operand 1
     /* 339812 */     // No operand predicates
     /* 339812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339820 */     // MIs[3] Operand 1
     /* 339820 */     // No operand predicates
     /* 339820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339822 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 339822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339834 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 339837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 339844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339859 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339870 */     GIR_RootConstrainSelectedInstOperands,
     /* 339871 */     // GIR_Coverage, 5712,
     /* 339871 */     GIR_EraseRootFromParent_Done,
     /* 339872 */   // Label 6991: @339872
     /* 339872 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(339939), // Rule ID 5735 //
     /* 339877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339910 */     // MIs[2] Operand 1
     /* 339910 */     // No operand predicates
     /* 339910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339918 */     // MIs[3] Operand 1
     /* 339918 */     // No operand predicates
     /* 339918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339920 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 339920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 339923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 339927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 339930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 339934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 339937 */     GIR_RootConstrainSelectedInstOperands,
     /* 339938 */     // GIR_Coverage, 5735,
     /* 339938 */     GIR_EraseRootFromParent_Done,
     /* 339939 */   // Label 6992: @339939
     /* 339939 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(340037), // Rule ID 5736 //
     /* 339944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 339952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 339960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 339973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339977 */     // MIs[2] Operand 1
     /* 339977 */     // No operand predicates
     /* 339977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 339981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 339985 */     // MIs[3] Operand 1
     /* 339985 */     // No operand predicates
     /* 339985 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 339987 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 339987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 339990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339999 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340035 */     GIR_RootConstrainSelectedInstOperands,
     /* 340036 */     // GIR_Coverage, 5736,
     /* 340036 */     GIR_EraseRootFromParent_Done,
     /* 340037 */   // Label 6993: @340037
     /* 340037 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(340103), // Rule ID 5666 //
     /* 340042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340060 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 340060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340087 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340102 */     // GIR_Coverage, 5666,
     /* 340102 */     GIR_EraseRootFromParent_Done,
     /* 340103 */   // Label 6994: @340103
     /* 340103 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(340169), // Rule ID 5676 //
     /* 340108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340126 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 340126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340158 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340168 */     // GIR_Coverage, 5676,
     /* 340168 */     GIR_EraseRootFromParent_Done,
     /* 340169 */   // Label 6995: @340169
     /* 340169 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(340247), // Rule ID 7366 //
     /* 340174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 340177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340189 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 340192 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 340199 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 340202 */     // MIs[1] Rn
     /* 340202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340223 */     // MIs[2] Operand 1
     /* 340223 */     // No operand predicates
     /* 340223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340225 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15795>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 340228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340245 */     GIR_RootConstrainSelectedInstOperands,
     /* 340246 */     // GIR_Coverage, 7366,
     /* 340246 */     GIR_EraseRootFromParent_Done,
     /* 340247 */   // Label 6996: @340247
     /* 340247 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(340316), // Rule ID 6402 //
     /* 340252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340271 */     // MIs[1] Rn
     /* 340271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340288 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340292 */     // MIs[2] Operand 1
     /* 340292 */     // No operand predicates
     /* 340292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340294 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 340297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340314 */     GIR_RootConstrainSelectedInstOperands,
     /* 340315 */     // GIR_Coverage, 6402,
     /* 340315 */     GIR_EraseRootFromParent_Done,
     /* 340316 */   // Label 6997: @340316
     /* 340316 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(340385), // Rule ID 6403 //
     /* 340321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340333 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340340 */     // MIs[1] Rn
     /* 340340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340361 */     // MIs[2] Operand 1
     /* 340361 */     // No operand predicates
     /* 340361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340363 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 340366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340383 */     GIR_RootConstrainSelectedInstOperands,
     /* 340384 */     // GIR_Coverage, 6403,
     /* 340384 */     GIR_EraseRootFromParent_Done,
     /* 340385 */   // Label 6998: @340385
     /* 340385 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(340434), // Rule ID 5683 //
     /* 340390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340398 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340402 */     // MIs[1] Operand 1
     /* 340402 */     // No operand predicates
     /* 340402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340410 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340414 */     // MIs[2] Operand 1
     /* 340414 */     // No operand predicates
     /* 340414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340416 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 340416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 340419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 340426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340432 */     GIR_RootConstrainSelectedInstOperands,
     /* 340433 */     // GIR_Coverage, 5683,
     /* 340433 */     GIR_EraseRootFromParent_Done,
     /* 340434 */   // Label 6999: @340434
     /* 340434 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(340535), // Rule ID 5741 //
     /* 340439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 340447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340464 */     // MIs[2] Operand 1
     /* 340464 */     // No operand predicates
     /* 340464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340466 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 340469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 340499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 340527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340533 */     GIR_RootConstrainSelectedInstOperands,
     /* 340534 */     // GIR_Coverage, 5741,
     /* 340534 */     GIR_EraseRootFromParent_Done,
     /* 340535 */   // Label 7000: @340535
     /* 340535 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(340579), // Rule ID 1937 //
     /* 340540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340563 */     // MIs[1] Operand 1
     /* 340563 */     // No operand predicates
     /* 340563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340565 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 340565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 340568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 340575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340577 */     GIR_RootConstrainSelectedInstOperands,
     /* 340578 */     // GIR_Coverage, 1937,
     /* 340578 */     GIR_EraseRootFromParent_Done,
     /* 340579 */   // Label 7001: @340579
     /* 340579 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(340675), // Rule ID 5687 //
     /* 340584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 340596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340604 */     // MIs[1] Operand 1
     /* 340604 */     // No operand predicates
     /* 340604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340606 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 340606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 340609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 340639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 340667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340673 */     GIR_RootConstrainSelectedInstOperands,
     /* 340674 */     // GIR_Coverage, 5687,
     /* 340674 */     GIR_EraseRootFromParent_Done,
     /* 340675 */   // Label 7002: @340675
     /* 340675 */   GIM_Reject,
     /* 340676 */ // Label 6971: @340676
     /* 340676 */ GIM_Reject,
     /* 340677 */ // Label 6919: @340677
     /* 340677 */ GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(344316),
     /* 340682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340685 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(340811), // Rule ID 4226 //
     /* 340690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340704 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340710 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340720 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340723 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340727 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340734 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340744 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340751 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 340758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340778 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340810 */     // GIR_Coverage, 4226,
     /* 340810 */     GIR_EraseRootFromParent_Done,
     /* 340811 */   // Label 7004: @340811
     /* 340811 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(340937), // Rule ID 4227 //
     /* 340816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 340819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340830 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340836 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340846 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340849 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340853 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340860 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 340877 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 340884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 340899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 340904 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 340926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340936 */     // GIR_Coverage, 4227,
     /* 340936 */     GIR_EraseRootFromParent_Done,
     /* 340937 */   // Label 7005: @340937
     /* 340937 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(341056), // Rule ID 4334 //
     /* 340942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 340945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 340948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340956 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 340962 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 340964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 340968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340972 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340979 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340989 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 340996 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 340996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 340999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341023 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341055 */     // GIR_Coverage, 4334,
     /* 341055 */     GIR_EraseRootFromParent_Done,
     /* 341056 */   // Label 7006: @341056
     /* 341056 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(341175), // Rule ID 4335 //
     /* 341061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341075 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341081 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341091 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341094 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341098 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341108 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341115 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341142 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341174 */     // GIR_Coverage, 4335,
     /* 341174 */     GIR_EraseRootFromParent_Done,
     /* 341175 */   // Label 7007: @341175
     /* 341175 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(341297), // Rule ID 4232 //
     /* 341180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341206 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341209 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341213 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341220 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341237 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341264 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341296 */     // GIR_Coverage, 4232,
     /* 341296 */     GIR_EraseRootFromParent_Done,
     /* 341297 */   // Label 7008: @341297
     /* 341297 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(341419), // Rule ID 4234 //
     /* 341302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341328 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341331 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341335 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341342 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341359 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341386 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341418 */     // GIR_Coverage, 4234,
     /* 341418 */     GIR_EraseRootFromParent_Done,
     /* 341419 */   // Label 7009: @341419
     /* 341419 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(341534), // Rule ID 4340 //
     /* 341424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341450 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341457 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341467 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341474 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341501 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341533 */     // GIR_Coverage, 4340,
     /* 341533 */     GIR_EraseRootFromParent_Done,
     /* 341534 */   // Label 7010: @341534
     /* 341534 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(341649), // Rule ID 4342 //
     /* 341539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341565 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341572 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341589 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341616 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341648 */     // GIR_Coverage, 4342,
     /* 341648 */     GIR_EraseRootFromParent_Done,
     /* 341649 */   // Label 7011: @341649
     /* 341649 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(341770), // Rule ID 4224 //
     /* 341654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341668 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341674 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341684 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341687 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341691 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341698 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341715 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341737 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341769 */     // GIR_Coverage, 4224,
     /* 341769 */     GIR_EraseRootFromParent_Done,
     /* 341770 */   // Label 7012: @341770
     /* 341770 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(341891), // Rule ID 4225 //
     /* 341775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341789 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341795 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341805 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341808 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341812 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341819 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 341836 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 341836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 341843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341858 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341890 */     // GIR_Coverage, 4225,
     /* 341890 */     GIR_EraseRootFromParent_Done,
     /* 341891 */   // Label 7013: @341891
     /* 341891 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(342005), // Rule ID 4332 //
     /* 341896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341910 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341916 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341926 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341933 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 341950 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 341950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 341957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 341972 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342004 */     // GIR_Coverage, 4332,
     /* 342004 */     GIR_EraseRootFromParent_Done,
     /* 342005 */   // Label 7014: @342005
     /* 342005 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(342119), // Rule ID 4333 //
     /* 342010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342024 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342030 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342040 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342047 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342064 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342118 */     // GIR_Coverage, 4333,
     /* 342118 */     GIR_EraseRootFromParent_Done,
     /* 342119 */   // Label 7015: @342119
     /* 342119 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(342236), // Rule ID 4228 //
     /* 342124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342150 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342153 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342157 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342164 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342181 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342203 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342235 */     // GIR_Coverage, 4228,
     /* 342235 */     GIR_EraseRootFromParent_Done,
     /* 342236 */   // Label 7016: @342236
     /* 342236 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(342353), // Rule ID 4230 //
     /* 342241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342267 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342270 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342274 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342281 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342291 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342298 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342352 */     // GIR_Coverage, 4230,
     /* 342352 */     GIR_EraseRootFromParent_Done,
     /* 342353 */   // Label 7017: @342353
     /* 342353 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(342463), // Rule ID 4336 //
     /* 342358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342384 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342391 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342408 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342430 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342462 */     // GIR_Coverage, 4336,
     /* 342462 */     GIR_EraseRootFromParent_Done,
     /* 342463 */   // Label 7018: @342463
     /* 342463 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(342573), // Rule ID 4338 //
     /* 342468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342494 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342501 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342518 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342540 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342572 */     // GIR_Coverage, 4338,
     /* 342572 */     GIR_EraseRootFromParent_Done,
     /* 342573 */   // Label 7019: @342573
     /* 342573 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(342703), // Rule ID 6415 //
     /* 342578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342607 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342610 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342614 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 342621 */     // MIs[2] Rn
     /* 342621 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 342625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 342630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342636 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 342636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 342639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 342643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 342650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 342657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342662 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 342668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 342672 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342685 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342702 */     // GIR_Coverage, 6415,
     /* 342702 */     GIR_EraseRootFromParent_Done,
     /* 342703 */   // Label 7020: @342703
     /* 342703 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(342843), // Rule ID 5701 //
     /* 342708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342751 */     // MIs[2] Operand 1
     /* 342751 */     // No operand predicates
     /* 342751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342759 */     // MIs[3] Operand 1
     /* 342759 */     // No operand predicates
     /* 342759 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342761 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342773 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 342776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 342780 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 342783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342805 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 342811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 342818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 342832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342842 */     // GIR_Coverage, 5701,
     /* 342842 */     GIR_EraseRootFromParent_Done,
     /* 342843 */   // Label 7021: @342843
     /* 342843 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(343014), // Rule ID 5702 //
     /* 342848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 342866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 342870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 342887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342891 */     // MIs[2] Operand 1
     /* 342891 */     // No operand predicates
     /* 342891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 342895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 342899 */     // MIs[3] Operand 1
     /* 342899 */     // No operand predicates
     /* 342899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 342901 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 342901 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 342904 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342908 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342913 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 342916 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342920 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 342923 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342928 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342933 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 342936 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342940 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342945 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 342948 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 342952 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 342955 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342960 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 342968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 342972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342977 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 342980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 342983 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 342986 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 342989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 342994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342996 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343008 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343013 */     // GIR_Coverage, 5702,
     /* 343013 */     GIR_EraseRootFromParent_Done,
     /* 343014 */   // Label 7022: @343014
     /* 343014 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(343154), // Rule ID 5725 //
     /* 343019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343062 */     // MIs[2] Operand 1
     /* 343062 */     // No operand predicates
     /* 343062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343070 */     // MIs[3] Operand 1
     /* 343070 */     // No operand predicates
     /* 343070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343072 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343072 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343075 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343079 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343084 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343091 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343116 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343136 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343153 */     // GIR_Coverage, 5725,
     /* 343153 */     GIR_EraseRootFromParent_Done,
     /* 343154 */   // Label 7023: @343154
     /* 343154 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(343325), // Rule ID 5726 //
     /* 343159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343202 */     // MIs[2] Operand 1
     /* 343202 */     // No operand predicates
     /* 343202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343210 */     // MIs[3] Operand 1
     /* 343210 */     // No operand predicates
     /* 343210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343212 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343212 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 343215 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343219 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343224 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 343227 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343231 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 343234 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343239 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343244 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343247 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343251 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343256 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343259 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343263 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343266 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343271 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343288 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 343297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343307 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343319 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343324 */     // GIR_Coverage, 5726,
     /* 343324 */     GIR_EraseRootFromParent_Done,
     /* 343325 */   // Label 7024: @343325
     /* 343325 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(343404), // Rule ID 5656 //
     /* 343330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 343352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343358 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 343358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 343361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 343374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 343393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343403 */     // GIR_Coverage, 5656,
     /* 343403 */     GIR_EraseRootFromParent_Done,
     /* 343404 */   // Label 7025: @343404
     /* 343404 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(343480), // Rule ID 5658 //
     /* 343409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343437 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 343440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343479 */     // GIR_Coverage, 5658,
     /* 343479 */     GIR_EraseRootFromParent_Done,
     /* 343480 */   // Label 7026: @343480
     /* 343480 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(343556), // Rule ID 5668 //
     /* 343485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343513 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 343516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343555 */     // GIR_Coverage, 5668,
     /* 343555 */     GIR_EraseRootFromParent_Done,
     /* 343556 */   // Label 7027: @343556
     /* 343556 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(343701), // Rule ID 5680 //
     /* 343561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 343583 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 343587 */     // MIs[1] Operand 1
     /* 343587 */     // No operand predicates
     /* 343587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343599 */     // MIs[2] Operand 1
     /* 343599 */     // No operand predicates
     /* 343599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343601 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 343601 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 343604 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343608 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 343615 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 343618 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343622 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343627 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 343630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 343634 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343642 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343647 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 343659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343664 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 343670 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 343676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343683 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343700 */     // GIR_Coverage, 5680,
     /* 343700 */     GIR_EraseRootFromParent_Done,
     /* 343701 */   // Label 7028: @343701
     /* 343701 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(343850), // Rule ID 6418 //
     /* 343706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343731 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343735 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 343742 */     // MIs[1] Rn
     /* 343742 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343763 */     // MIs[2] Operand 1
     /* 343763 */     // No operand predicates
     /* 343763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343765 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 343765 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343768 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343772 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343777 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 343784 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343787 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343792 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 343804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 343815 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343819 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343832 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343849 */     // GIR_Coverage, 6418,
     /* 343849 */     GIR_EraseRootFromParent_Done,
     /* 343850 */   // Label 7029: @343850
     /* 343850 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(343992), // Rule ID 6421 //
     /* 343855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343880 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 343884 */     // MIs[1] Rn
     /* 343884 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 343888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 343897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343901 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 343905 */     // MIs[2] Operand 1
     /* 343905 */     // No operand predicates
     /* 343905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343907 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 343907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343919 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343922 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 343926 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343929 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 343946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343951 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 343957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343961 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343974 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343991 */     // GIR_Coverage, 6421,
     /* 343991 */     GIR_EraseRootFromParent_Done,
     /* 343992 */   // Label 7030: @343992
     /* 343992 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(344180), // Rule ID 5678 //
     /* 343997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 344027 */     // MIs[1] Operand 1
     /* 344027 */     // No operand predicates
     /* 344027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344029 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 344029 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 344032 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344036 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 344043 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 344046 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344050 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344055 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 344058 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344062 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 344065 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344070 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344075 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344080 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 344083 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344087 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344094 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 344097 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344101 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344106 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344109 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344113 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344116 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 344138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 344155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344162 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344179 */     // GIR_Coverage, 5678,
     /* 344179 */     GIR_EraseRootFromParent_Done,
     /* 344180 */   // Label 7031: @344180
     /* 344180 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(344315), // Rule ID 5689 //
     /* 344185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 344215 */     // MIs[1] Operand 1
     /* 344215 */     // No operand predicates
     /* 344215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344217 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 344217 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 344220 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344224 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344231 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 344234 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344238 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344243 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344246 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344250 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 344275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344280 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344297 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344304 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344314 */     // GIR_Coverage, 5689,
     /* 344314 */     GIR_EraseRootFromParent_Done,
     /* 344315 */   // Label 7032: @344315
     /* 344315 */   GIM_Reject,
     /* 344316 */ // Label 7003: @344316
     /* 344316 */ GIM_Reject,
     /* 344317 */ // Label 6920: @344317
     /* 344317 */ GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(346980),
     /* 344322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344335 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(344444), // Rule ID 4250 //
     /* 344340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344360 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344367 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344377 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344384 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344411 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344443 */     // GIR_Coverage, 4250,
     /* 344443 */     GIR_EraseRootFromParent_Done,
     /* 344444 */   // Label 7034: @344444
     /* 344444 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(344553), // Rule ID 4251 //
     /* 344449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344469 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344472 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344476 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344486 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344493 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344552 */     // GIR_Coverage, 4251,
     /* 344552 */     GIR_EraseRootFromParent_Done,
     /* 344553 */   // Label 7035: @344553
     /* 344553 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(344662), // Rule ID 4358 //
     /* 344558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344578 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344585 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344595 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344602 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344629 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344661 */     // GIR_Coverage, 4358,
     /* 344661 */     GIR_EraseRootFromParent_Done,
     /* 344662 */   // Label 7036: @344662
     /* 344662 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(344771), // Rule ID 4359 //
     /* 344667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344687 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344690 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344694 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344704 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344711 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344738 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344770 */     // GIR_Coverage, 4359,
     /* 344770 */     GIR_EraseRootFromParent_Done,
     /* 344771 */   // Label 7037: @344771
     /* 344771 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(344876), // Rule ID 4256 //
     /* 344776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344799 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344809 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344816 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344875 */     // GIR_Coverage, 4256,
     /* 344875 */     GIR_EraseRootFromParent_Done,
     /* 344876 */   // Label 7038: @344876
     /* 344876 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(344981), // Rule ID 4258 //
     /* 344881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344897 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344904 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 344921 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 344928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344948 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344980 */     // GIR_Coverage, 4258,
     /* 344980 */     GIR_EraseRootFromParent_Done,
     /* 344981 */   // Label 7039: @344981
     /* 344981 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(345086), // Rule ID 4364 //
     /* 344986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345002 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345005 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345009 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345026 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345053 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345085 */     // GIR_Coverage, 4364,
     /* 345085 */     GIR_EraseRootFromParent_Done,
     /* 345086 */   // Label 7040: @345086
     /* 345086 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(345191), // Rule ID 4366 //
     /* 345091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345131 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345158 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345190 */     // GIR_Coverage, 4366,
     /* 345190 */     GIR_EraseRootFromParent_Done,
     /* 345191 */   // Label 7041: @345191
     /* 345191 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(345295), // Rule ID 4248 //
     /* 345196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345216 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345219 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345223 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345240 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345262 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345294 */     // GIR_Coverage, 4248,
     /* 345294 */     GIR_EraseRootFromParent_Done,
     /* 345295 */   // Label 7042: @345295
     /* 345295 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(345399), // Rule ID 4249 //
     /* 345300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345304 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345310 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345320 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345327 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345344 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345366 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345398 */     // GIR_Coverage, 4249,
     /* 345398 */     GIR_EraseRootFromParent_Done,
     /* 345399 */   // Label 7043: @345399
     /* 345399 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(345503), // Rule ID 4356 //
     /* 345404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345408 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345414 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345424 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345431 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345441 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345448 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345470 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345502 */     // GIR_Coverage, 4356,
     /* 345502 */     GIR_EraseRootFromParent_Done,
     /* 345503 */   // Label 7044: @345503
     /* 345503 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(345607), // Rule ID 4357 //
     /* 345508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345528 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345531 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345535 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345552 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345606 */     // GIR_Coverage, 4357,
     /* 345606 */     GIR_EraseRootFromParent_Done,
     /* 345607 */   // Label 7045: @345607
     /* 345607 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(345707), // Rule ID 4252 //
     /* 345612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345628 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345635 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345645 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345652 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345674 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345706 */     // GIR_Coverage, 4252,
     /* 345706 */     GIR_EraseRootFromParent_Done,
     /* 345707 */   // Label 7046: @345707
     /* 345707 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(345807), // Rule ID 4254 //
     /* 345712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345728 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345735 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345752 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345806 */     // GIR_Coverage, 4254,
     /* 345806 */     GIR_EraseRootFromParent_Done,
     /* 345807 */   // Label 7047: @345807
     /* 345807 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(345907), // Rule ID 4360 //
     /* 345812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345828 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345835 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345852 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345874 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345906 */     // GIR_Coverage, 4360,
     /* 345906 */     GIR_EraseRootFromParent_Done,
     /* 345907 */   // Label 7048: @345907
     /* 345907 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(346007), // Rule ID 4362 //
     /* 345912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345928 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345935 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345945 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345952 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345974 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346006 */     // GIR_Coverage, 4362,
     /* 346006 */     GIR_EraseRootFromParent_Done,
     /* 346007 */   // Label 7049: @346007
     /* 346007 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(346085), // Rule ID 1940 //
     /* 346012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346048 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346052 */     // MIs[2] Operand 1
     /* 346052 */     // No operand predicates
     /* 346052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346060 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346064 */     // MIs[3] Operand 1
     /* 346064 */     // No operand predicates
     /* 346064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346066 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 346066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 346076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 346083 */     GIR_RootConstrainSelectedInstOperands,
     /* 346084 */     // GIR_Coverage, 1940,
     /* 346084 */     GIR_EraseRootFromParent_Done,
     /* 346085 */   // Label 7050: @346085
     /* 346085 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(346152), // Rule ID 5705 //
     /* 346090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346123 */     // MIs[2] Operand 1
     /* 346123 */     // No operand predicates
     /* 346123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346131 */     // MIs[3] Operand 1
     /* 346131 */     // No operand predicates
     /* 346131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346133 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 346133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346138 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346150 */     GIR_RootConstrainSelectedInstOperands,
     /* 346151 */     // GIR_Coverage, 5705,
     /* 346151 */     GIR_EraseRootFromParent_Done,
     /* 346152 */   // Label 7051: @346152
     /* 346152 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(346250), // Rule ID 5706 //
     /* 346157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346190 */     // MIs[2] Operand 1
     /* 346190 */     // No operand predicates
     /* 346190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346198 */     // MIs[3] Operand 1
     /* 346198 */     // No operand predicates
     /* 346198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346200 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 346200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346212 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 346222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346237 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346248 */     GIR_RootConstrainSelectedInstOperands,
     /* 346249 */     // GIR_Coverage, 5706,
     /* 346249 */     GIR_EraseRootFromParent_Done,
     /* 346250 */   // Label 7052: @346250
     /* 346250 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(346317), // Rule ID 5729 //
     /* 346255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346288 */     // MIs[2] Operand 1
     /* 346288 */     // No operand predicates
     /* 346288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346296 */     // MIs[3] Operand 1
     /* 346296 */     // No operand predicates
     /* 346296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346298 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 346298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346315 */     GIR_RootConstrainSelectedInstOperands,
     /* 346316 */     // GIR_Coverage, 5729,
     /* 346316 */     GIR_EraseRootFromParent_Done,
     /* 346317 */   // Label 7053: @346317
     /* 346317 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(346415), // Rule ID 5730 //
     /* 346322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346355 */     // MIs[2] Operand 1
     /* 346355 */     // No operand predicates
     /* 346355 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346359 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346363 */     // MIs[3] Operand 1
     /* 346363 */     // No operand predicates
     /* 346363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346365 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 346365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346377 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 346387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346413 */     GIR_RootConstrainSelectedInstOperands,
     /* 346414 */     // GIR_Coverage, 5730,
     /* 346414 */     GIR_EraseRootFromParent_Done,
     /* 346415 */   // Label 7054: @346415
     /* 346415 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(346481), // Rule ID 5664 //
     /* 346420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346438 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 346438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346480 */     // GIR_Coverage, 5664,
     /* 346480 */     GIR_EraseRootFromParent_Done,
     /* 346481 */   // Label 7055: @346481
     /* 346481 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(346547), // Rule ID 5672 //
     /* 346486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346504 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 346504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346546 */     // GIR_Coverage, 5672,
     /* 346546 */     GIR_EraseRootFromParent_Done,
     /* 346547 */   // Label 7056: @346547
     /* 346547 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(346600), // Rule ID 5681 //
     /* 346552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 346564 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 346568 */     // MIs[1] Operand 1
     /* 346568 */     // No operand predicates
     /* 346568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346580 */     // MIs[2] Operand 1
     /* 346580 */     // No operand predicates
     /* 346580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346582 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 346582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 346585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 346592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 346598 */     GIR_RootConstrainSelectedInstOperands,
     /* 346599 */     // GIR_Coverage, 5681,
     /* 346599 */     GIR_EraseRootFromParent_Done,
     /* 346600 */   // Label 7057: @346600
     /* 346600 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(346669), // Rule ID 6400 //
     /* 346605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346617 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 346624 */     // MIs[1] Rn
     /* 346624 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 346628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346645 */     // MIs[2] Operand 1
     /* 346645 */     // No operand predicates
     /* 346645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346647 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 346647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 346650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 346657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346667 */     GIR_RootConstrainSelectedInstOperands,
     /* 346668 */     // GIR_Coverage, 6400,
     /* 346668 */     GIR_EraseRootFromParent_Done,
     /* 346669 */   // Label 7058: @346669
     /* 346669 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(346738), // Rule ID 6401 //
     /* 346674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346686 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346689 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 346693 */     // MIs[1] Rn
     /* 346693 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 346697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 346702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346710 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346714 */     // MIs[2] Operand 1
     /* 346714 */     // No operand predicates
     /* 346714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346716 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 346716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 346719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346721 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 346726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346736 */     GIR_RootConstrainSelectedInstOperands,
     /* 346737 */     // GIR_Coverage, 6401,
     /* 346737 */     GIR_EraseRootFromParent_Done,
     /* 346738 */   // Label 7059: @346738
     /* 346738 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(346839), // Rule ID 5739 //
     /* 346743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 346751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 346755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 346764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346768 */     // MIs[2] Operand 1
     /* 346768 */     // No operand predicates
     /* 346768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346770 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 346770 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 346773 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346777 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346796 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 346803 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 346806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346826 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 346831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346837 */     GIR_RootConstrainSelectedInstOperands,
     /* 346838 */     // GIR_Coverage, 5739,
     /* 346838 */     GIR_EraseRootFromParent_Done,
     /* 346839 */   // Label 7060: @346839
     /* 346839 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(346883), // Rule ID 1936 //
     /* 346844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 346859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346867 */     // MIs[1] Operand 1
     /* 346867 */     // No operand predicates
     /* 346867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346869 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 346869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 346872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 346879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346881 */     GIR_RootConstrainSelectedInstOperands,
     /* 346882 */     // GIR_Coverage, 1936,
     /* 346882 */     GIR_EraseRootFromParent_Done,
     /* 346883 */   // Label 7061: @346883
     /* 346883 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(346979), // Rule ID 5686 //
     /* 346888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 346900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346908 */     // MIs[1] Operand 1
     /* 346908 */     // No operand predicates
     /* 346908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346910 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 346910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 346913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 346924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 346939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 346943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 346946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346977 */     GIR_RootConstrainSelectedInstOperands,
     /* 346978 */     // GIR_Coverage, 5686,
     /* 346978 */     GIR_EraseRootFromParent_Done,
     /* 346979 */   // Label 7062: @346979
     /* 346979 */   GIM_Reject,
     /* 346980 */ // Label 7033: @346980
     /* 346980 */ GIM_Reject,
     /* 346981 */ // Label 6921: @346981
     /* 346981 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(348824),
     /* 346986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346989 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(347115), // Rule ID 4190 //
     /* 346994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347008 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347014 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347024 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347027 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347031 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347038 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 347055 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 347062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347082 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347114 */     // GIR_Coverage, 4190,
     /* 347114 */     GIR_EraseRootFromParent_Done,
     /* 347115 */   // Label 7064: @347115
     /* 347115 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(347241), // Rule ID 4191 //
     /* 347120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347134 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347140 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347150 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347153 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347157 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347164 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 347181 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 347188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347208 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347240 */     // GIR_Coverage, 4191,
     /* 347240 */     GIR_EraseRootFromParent_Done,
     /* 347241 */   // Label 7065: @347241
     /* 347241 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(347363), // Rule ID 4196 //
     /* 347246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347272 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347275 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347279 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347286 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347296 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 347303 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 347310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347330 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347357 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347362 */     // GIR_Coverage, 4196,
     /* 347362 */     GIR_EraseRootFromParent_Done,
     /* 347363 */   // Label 7066: @347363
     /* 347363 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(347485), // Rule ID 4198 //
     /* 347368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347394 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347397 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347401 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347408 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 347425 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 347432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347452 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347484 */     // GIR_Coverage, 4198,
     /* 347484 */     GIR_EraseRootFromParent_Done,
     /* 347485 */   // Label 7067: @347485
     /* 347485 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(347606), // Rule ID 4188 //
     /* 347490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347504 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347510 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347520 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347523 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347527 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 347551 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 347551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 347558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347605 */     // GIR_Coverage, 4188,
     /* 347605 */     GIR_EraseRootFromParent_Done,
     /* 347606 */   // Label 7068: @347606
     /* 347606 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(347727), // Rule ID 4189 //
     /* 347611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347641 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347644 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347648 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347655 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347665 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 347672 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 347672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 347679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347694 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347726 */     // GIR_Coverage, 4189,
     /* 347726 */     GIR_EraseRootFromParent_Done,
     /* 347727 */   // Label 7069: @347727
     /* 347727 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(347844), // Rule ID 4192 //
     /* 347732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347758 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347761 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347765 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347772 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 347789 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 347789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 347796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347811 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347843 */     // GIR_Coverage, 4192,
     /* 347843 */     GIR_EraseRootFromParent_Done,
     /* 347844 */   // Label 7070: @347844
     /* 347844 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(347961), // Rule ID 4194 //
     /* 347849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347875 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347878 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347882 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347889 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 347906 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 347906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 347913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 347928 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347960 */     // GIR_Coverage, 4194,
     /* 347960 */     GIR_EraseRootFromParent_Done,
     /* 347961 */   // Label 7071: @347961
     /* 347961 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(348101), // Rule ID 5719 //
     /* 347966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 347988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 347996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348009 */     // MIs[2] Operand 1
     /* 348009 */     // No operand predicates
     /* 348009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348017 */     // MIs[3] Operand 1
     /* 348017 */     // No operand predicates
     /* 348017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348019 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 348019 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348022 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348026 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348031 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 348038 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 348069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 348076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348083 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348100 */     // GIR_Coverage, 5719,
     /* 348100 */     GIR_EraseRootFromParent_Done,
     /* 348101 */   // Label 7072: @348101
     /* 348101 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(348272), // Rule ID 5720 //
     /* 348106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348149 */     // MIs[2] Operand 1
     /* 348149 */     // No operand predicates
     /* 348149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348157 */     // MIs[3] Operand 1
     /* 348157 */     // No operand predicates
     /* 348157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348159 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 348159 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 348162 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348166 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348171 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 348174 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348178 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 348181 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348186 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348191 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348194 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348198 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348203 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348206 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 348210 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348213 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348218 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348235 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 348241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 348244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 348247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348254 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348271 */     // GIR_Coverage, 5720,
     /* 348271 */     GIR_EraseRootFromParent_Done,
     /* 348272 */   // Label 7073: @348272
     /* 348272 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(348351), // Rule ID 5651 //
     /* 348277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348305 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 348305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348317 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 348321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348350 */     // GIR_Coverage, 5651,
     /* 348350 */     GIR_EraseRootFromParent_Done,
     /* 348351 */   // Label 7074: @348351
     /* 348351 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(348500), // Rule ID 6417 //
     /* 348356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348378 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348381 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 348385 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348392 */     // MIs[1] Rn
     /* 348392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 348396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 348401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 348405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348413 */     // MIs[2] Operand 1
     /* 348413 */     // No operand predicates
     /* 348413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348415 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 348415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348427 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348430 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 348434 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348437 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348442 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 348454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348459 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 348465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348469 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348482 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348499 */     // GIR_Coverage, 6417,
     /* 348499 */     GIR_EraseRootFromParent_Done,
     /* 348500 */   // Label 7075: @348500
     /* 348500 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(348635), // Rule ID 5690 //
     /* 348505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 348527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348535 */     // MIs[1] Operand 1
     /* 348535 */     // No operand predicates
     /* 348535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348537 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 348537 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 348540 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348544 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 348554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348563 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 348566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348570 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 348595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348600 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 348606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 348610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348634 */     // GIR_Coverage, 5690,
     /* 348634 */     GIR_EraseRootFromParent_Done,
     /* 348635 */   // Label 7076: @348635
     /* 348635 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(348823), // Rule ID 5691 //
     /* 348640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 348643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 348662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348670 */     // MIs[1] Operand 1
     /* 348670 */     // No operand predicates
     /* 348670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348672 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348672 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 348675 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348679 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 348686 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 348689 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348693 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348698 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 348701 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 348705 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 348708 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348713 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348718 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348723 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 348726 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 348730 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 348737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 348740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 348744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348749 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 348752 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348756 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348769 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348786 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 348792 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 348795 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 348798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348805 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348822 */     // GIR_Coverage, 5691,
     /* 348822 */     GIR_EraseRootFromParent_Done,
     /* 348823 */   // Label 7077: @348823
     /* 348823 */   GIM_Reject,
     /* 348824 */ // Label 7063: @348824
     /* 348824 */ GIM_Reject,
     /* 348825 */ // Label 6922: @348825
     /* 348825 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(351799),
     /* 348830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348833 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(348959), // Rule ID 4214 //
     /* 348838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348852 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348858 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348868 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348871 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348875 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 348882 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 348899 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 348899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 348902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 348906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 348921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 348926 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 348948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 348958 */     // GIR_Coverage, 4214,
     /* 348958 */     GIR_EraseRootFromParent_Done,
     /* 348959 */   // Label 7079: @348959
     /* 348959 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(349085), // Rule ID 4215 //
     /* 348964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348978 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348984 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348994 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348997 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349001 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349008 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349025 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349052 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349084 */     // GIR_Coverage, 4215,
     /* 349084 */     GIR_EraseRootFromParent_Done,
     /* 349085 */   // Label 7080: @349085
     /* 349085 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(349204), // Rule ID 4322 //
     /* 349090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349104 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349110 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349120 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349127 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349144 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349171 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349203 */     // GIR_Coverage, 4322,
     /* 349203 */     GIR_EraseRootFromParent_Done,
     /* 349204 */   // Label 7081: @349204
     /* 349204 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(349323), // Rule ID 4323 //
     /* 349209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349223 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349229 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349239 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349242 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349246 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349263 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349290 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349322 */     // GIR_Coverage, 4323,
     /* 349322 */     GIR_EraseRootFromParent_Done,
     /* 349323 */   // Label 7082: @349323
     /* 349323 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(349445), // Rule ID 4220 //
     /* 349328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349354 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349357 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349361 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349368 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349378 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349385 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349444 */     // GIR_Coverage, 4220,
     /* 349444 */     GIR_EraseRootFromParent_Done,
     /* 349445 */   // Label 7083: @349445
     /* 349445 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(349567), // Rule ID 4222 //
     /* 349450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349476 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349479 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349483 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349490 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349507 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349534 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349566 */     // GIR_Coverage, 4222,
     /* 349566 */     GIR_EraseRootFromParent_Done,
     /* 349567 */   // Label 7084: @349567
     /* 349567 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(349682), // Rule ID 4328 //
     /* 349572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349598 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349601 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349605 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349615 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349622 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349649 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349681 */     // GIR_Coverage, 4328,
     /* 349681 */     GIR_EraseRootFromParent_Done,
     /* 349682 */   // Label 7085: @349682
     /* 349682 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(349797), // Rule ID 4330 //
     /* 349687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349713 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349720 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349730 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349737 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349764 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349796 */     // GIR_Coverage, 4330,
     /* 349796 */     GIR_EraseRootFromParent_Done,
     /* 349797 */   // Label 7086: @349797
     /* 349797 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(349918), // Rule ID 4212 //
     /* 349802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349816 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349822 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349832 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349835 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349839 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349846 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 349863 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 349863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 349870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 349885 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349917 */     // GIR_Coverage, 4212,
     /* 349917 */     GIR_EraseRootFromParent_Done,
     /* 349918 */   // Label 7087: @349918
     /* 349918 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(350039), // Rule ID 4213 //
     /* 349923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349937 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349943 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349953 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349956 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349960 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349967 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 349984 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 349984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 349991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350006 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350038 */     // GIR_Coverage, 4213,
     /* 350038 */     GIR_EraseRootFromParent_Done,
     /* 350039 */   // Label 7088: @350039
     /* 350039 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(350153), // Rule ID 4320 //
     /* 350044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350058 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350064 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350074 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350081 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350091 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350098 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350120 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350152 */     // GIR_Coverage, 4320,
     /* 350152 */     GIR_EraseRootFromParent_Done,
     /* 350153 */   // Label 7089: @350153
     /* 350153 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(350267), // Rule ID 4321 //
     /* 350158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350172 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350178 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350188 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350195 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350212 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350266 */     // GIR_Coverage, 4321,
     /* 350266 */     GIR_EraseRootFromParent_Done,
     /* 350267 */   // Label 7090: @350267
     /* 350267 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(350384), // Rule ID 4216 //
     /* 350272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350301 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350305 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350312 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350329 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350351 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350383 */     // GIR_Coverage, 4216,
     /* 350383 */     GIR_EraseRootFromParent_Done,
     /* 350384 */   // Label 7091: @350384
     /* 350384 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(350501), // Rule ID 4218 //
     /* 350389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350415 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350418 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350422 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350429 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350439 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350446 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350468 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350500 */     // GIR_Coverage, 4218,
     /* 350500 */     GIR_EraseRootFromParent_Done,
     /* 350501 */   // Label 7092: @350501
     /* 350501 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(350611), // Rule ID 4324 //
     /* 350506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350532 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350539 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350556 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350578 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350610 */     // GIR_Coverage, 4324,
     /* 350610 */     GIR_EraseRootFromParent_Done,
     /* 350611 */   // Label 7093: @350611
     /* 350611 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(350721), // Rule ID 4326 //
     /* 350616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350642 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350649 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350659 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350666 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350688 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350720 */     // GIR_Coverage, 4326,
     /* 350720 */     GIR_EraseRootFromParent_Done,
     /* 350721 */   // Label 7094: @350721
     /* 350721 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(350809), // Rule ID 1939 //
     /* 350726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 350729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350772 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350776 */     // MIs[2] Operand 1
     /* 350776 */     // No operand predicates
     /* 350776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350784 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 350788 */     // MIs[3] Operand 1
     /* 350788 */     // No operand predicates
     /* 350788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350790 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 350790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 350797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 350800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 350807 */     GIR_RootConstrainSelectedInstOperands,
     /* 350808 */     // GIR_Coverage, 1939,
     /* 350808 */     GIR_EraseRootFromParent_Done,
     /* 350809 */   // Label 7095: @350809
     /* 350809 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(350886), // Rule ID 5699 //
     /* 350814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 350840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350857 */     // MIs[2] Operand 1
     /* 350857 */     // No operand predicates
     /* 350857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350865 */     // MIs[3] Operand 1
     /* 350865 */     // No operand predicates
     /* 350865 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350867 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 350867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350872 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350884 */     GIR_RootConstrainSelectedInstOperands,
     /* 350885 */     // GIR_Coverage, 5699,
     /* 350885 */     GIR_EraseRootFromParent_Done,
     /* 350886 */   // Label 7096: @350886
     /* 350886 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(350994), // Rule ID 5700 //
     /* 350891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 350909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 350913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 350917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 350921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 350930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350934 */     // MIs[2] Operand 1
     /* 350934 */     // No operand predicates
     /* 350934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 350938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 350942 */     // MIs[3] Operand 1
     /* 350942 */     // No operand predicates
     /* 350942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 350944 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 350944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 350947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 350959 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 350963 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 350966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 350976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 350979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 350983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 350986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 350992 */     GIR_RootConstrainSelectedInstOperands,
     /* 350993 */     // GIR_Coverage, 5700,
     /* 350993 */     GIR_EraseRootFromParent_Done,
     /* 350994 */   // Label 7097: @350994
     /* 350994 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(351071), // Rule ID 5723 //
     /* 350999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351042 */     // MIs[2] Operand 1
     /* 351042 */     // No operand predicates
     /* 351042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351050 */     // MIs[3] Operand 1
     /* 351050 */     // No operand predicates
     /* 351050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351052 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 351052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351069 */     GIR_RootConstrainSelectedInstOperands,
     /* 351070 */     // GIR_Coverage, 5723,
     /* 351070 */     GIR_EraseRootFromParent_Done,
     /* 351071 */   // Label 7098: @351071
     /* 351071 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(351179), // Rule ID 5724 //
     /* 351076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 351102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351119 */     // MIs[2] Operand 1
     /* 351119 */     // No operand predicates
     /* 351119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351127 */     // MIs[3] Operand 1
     /* 351127 */     // No operand predicates
     /* 351127 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351129 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 351129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351141 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 351144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 351151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351177 */     GIR_RootConstrainSelectedInstOperands,
     /* 351178 */     // GIR_Coverage, 5724,
     /* 351178 */     GIR_EraseRootFromParent_Done,
     /* 351179 */   // Label 7099: @351179
     /* 351179 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(351258), // Rule ID 5654 //
     /* 351184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351212 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 351212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 351215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 351228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 351247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351257 */     // GIR_Coverage, 5654,
     /* 351257 */     GIR_EraseRootFromParent_Done,
     /* 351258 */   // Label 7100: @351258
     /* 351258 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(351334), // Rule ID 5660 //
     /* 351263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351291 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 351291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351333 */     // GIR_Coverage, 5660,
     /* 351333 */     GIR_EraseRootFromParent_Done,
     /* 351334 */   // Label 7101: @351334
     /* 351334 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(351410), // Rule ID 5670 //
     /* 351339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351367 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 351367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351409 */     // GIR_Coverage, 5670,
     /* 351409 */     GIR_EraseRootFromParent_Done,
     /* 351410 */   // Label 7102: @351410
     /* 351410 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(351473), // Rule ID 5679 //
     /* 351415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 351437 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 351441 */     // MIs[1] Operand 1
     /* 351441 */     // No operand predicates
     /* 351441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 351445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351449 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351453 */     // MIs[2] Operand 1
     /* 351453 */     // No operand predicates
     /* 351453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351455 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 351455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 351458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 351465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 351471 */     GIR_RootConstrainSelectedInstOperands,
     /* 351472 */     // GIR_Coverage, 5679,
     /* 351472 */     GIR_EraseRootFromParent_Done,
     /* 351473 */   // Label 7103: @351473
     /* 351473 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(351559), // Rule ID 6399 //
     /* 351478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351503 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 351507 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 351514 */     // MIs[1] Rn
     /* 351514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 351518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 351523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 351527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351531 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351535 */     // MIs[2] Operand 1
     /* 351535 */     // No operand predicates
     /* 351535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351537 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 351537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 351540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 351547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351557 */     GIR_RootConstrainSelectedInstOperands,
     /* 351558 */     // GIR_Coverage, 6399,
     /* 351558 */     GIR_EraseRootFromParent_Done,
     /* 351559 */   // Label 7104: @351559
     /* 351559 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(351638), // Rule ID 6404 //
     /* 351564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351586 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351589 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 351593 */     // MIs[1] Rn
     /* 351593 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 351597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 351602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 351606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351614 */     // MIs[2] Operand 1
     /* 351614 */     // No operand predicates
     /* 351614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351616 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 351616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 351619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 351626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351636 */     GIR_RootConstrainSelectedInstOperands,
     /* 351637 */     // GIR_Coverage, 6404,
     /* 351637 */     GIR_EraseRootFromParent_Done,
     /* 351638 */   // Label 7105: @351638
     /* 351638 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(351692), // Rule ID 1935 //
     /* 351643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 351668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351676 */     // MIs[1] Operand 1
     /* 351676 */     // No operand predicates
     /* 351676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351678 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 351678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 351681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 351688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351690 */     GIR_RootConstrainSelectedInstOperands,
     /* 351691 */     // GIR_Coverage, 1935,
     /* 351691 */     GIR_EraseRootFromParent_Done,
     /* 351692 */   // Label 7106: @351692
     /* 351692 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(351798), // Rule ID 5684 //
     /* 351697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 351719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351727 */     // MIs[1] Operand 1
     /* 351727 */     // No operand predicates
     /* 351727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351729 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 351729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 351732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351755 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 351762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 351765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351775 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 351790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351796 */     GIR_RootConstrainSelectedInstOperands,
     /* 351797 */     // GIR_Coverage, 5684,
     /* 351797 */     GIR_EraseRootFromParent_Done,
     /* 351798 */   // Label 7107: @351798
     /* 351798 */   GIM_Reject,
     /* 351799 */ // Label 7078: @351799
     /* 351799 */ GIM_Reject,
     /* 351800 */ // Label 6923: @351800
     /* 351800 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(353379),
     /* 351805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 351808 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(351934), // Rule ID 4178 //
     /* 351813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351827 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351833 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351843 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351846 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351850 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351857 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351867 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 351874 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 351874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 351877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 351881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 351896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 351901 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 351923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 351933 */     // GIR_Coverage, 4178,
     /* 351933 */     GIR_EraseRootFromParent_Done,
     /* 351934 */   // Label 7109: @351934
     /* 351934 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(352060), // Rule ID 4179 //
     /* 351939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351953 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 351959 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 351961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351969 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351972 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351976 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 351983 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351993 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 352000 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 352007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352027 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352059 */     // GIR_Coverage, 4179,
     /* 352059 */     GIR_EraseRootFromParent_Done,
     /* 352060 */   // Label 7110: @352060
     /* 352060 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(352182), // Rule ID 4184 //
     /* 352065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352091 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352094 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352098 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352105 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352115 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 352122 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 352129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352149 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352176 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352181 */     // GIR_Coverage, 4184,
     /* 352181 */     GIR_EraseRootFromParent_Done,
     /* 352182 */   // Label 7111: @352182
     /* 352182 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(352304), // Rule ID 4186 //
     /* 352187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352213 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352216 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352220 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352227 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352237 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 352244 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 352251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352271 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352303 */     // GIR_Coverage, 4186,
     /* 352303 */     GIR_EraseRootFromParent_Done,
     /* 352304 */   // Label 7112: @352304
     /* 352304 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(352425), // Rule ID 4176 //
     /* 352309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352329 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352339 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352342 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352346 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352353 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352363 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352370 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352392 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352424 */     // GIR_Coverage, 4176,
     /* 352424 */     GIR_EraseRootFromParent_Done,
     /* 352425 */   // Label 7113: @352425
     /* 352425 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(352546), // Rule ID 4177 //
     /* 352430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352460 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352463 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352467 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352474 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352478 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352484 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 352491 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 352491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 352498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352513 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352545 */     // GIR_Coverage, 4177,
     /* 352545 */     GIR_EraseRootFromParent_Done,
     /* 352546 */   // Label 7114: @352546
     /* 352546 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(352663), // Rule ID 4180 //
     /* 352551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352577 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352580 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352584 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352591 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352601 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352608 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352630 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352662 */     // GIR_Coverage, 4180,
     /* 352662 */     GIR_EraseRootFromParent_Done,
     /* 352663 */   // Label 7115: @352663
     /* 352663 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(352780), // Rule ID 4182 //
     /* 352668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352694 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352697 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352701 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352708 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 352725 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 352725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 352732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352747 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352779 */     // GIR_Coverage, 4182,
     /* 352779 */     GIR_EraseRootFromParent_Done,
     /* 352780 */   // Label 7116: @352780
     /* 352780 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(352868), // Rule ID 1938 //
     /* 352785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 352814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352831 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352835 */     // MIs[2] Operand 1
     /* 352835 */     // No operand predicates
     /* 352835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 352847 */     // MIs[3] Operand 1
     /* 352847 */     // No operand predicates
     /* 352847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352849 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 352849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 352859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 352866 */     GIR_RootConstrainSelectedInstOperands,
     /* 352867 */     // GIR_Coverage, 1938,
     /* 352867 */     GIR_EraseRootFromParent_Done,
     /* 352868 */   // Label 7117: @352868
     /* 352868 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(352945), // Rule ID 5717 //
     /* 352873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 352899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352916 */     // MIs[2] Operand 1
     /* 352916 */     // No operand predicates
     /* 352916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352924 */     // MIs[3] Operand 1
     /* 352924 */     // No operand predicates
     /* 352924 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 352926 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 352926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 352929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352931 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 352933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 352936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 352943 */     GIR_RootConstrainSelectedInstOperands,
     /* 352944 */     // GIR_Coverage, 5717,
     /* 352944 */     GIR_EraseRootFromParent_Done,
     /* 352945 */   // Label 7118: @352945
     /* 352945 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(353053), // Rule ID 5718 //
     /* 352950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 352972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 352976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 352980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 352985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 352989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352993 */     // MIs[2] Operand 1
     /* 352993 */     // No operand predicates
     /* 352993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 352997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353001 */     // MIs[3] Operand 1
     /* 353001 */     // No operand predicates
     /* 353001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353003 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 353003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 353018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353022 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 353025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353040 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353051 */     GIR_RootConstrainSelectedInstOperands,
     /* 353052 */     // GIR_Coverage, 5718,
     /* 353052 */     GIR_EraseRootFromParent_Done,
     /* 353053 */   // Label 7119: @353053
     /* 353053 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(353132), // Rule ID 5649 //
     /* 353058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353086 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 353086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 353102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353131 */     // GIR_Coverage, 5649,
     /* 353131 */     GIR_EraseRootFromParent_Done,
     /* 353132 */   // Label 7120: @353132
     /* 353132 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(353218), // Rule ID 6398 //
     /* 353137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353162 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 353166 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353173 */     // MIs[1] Rn
     /* 353173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 353177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 353182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 353186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353194 */     // MIs[2] Operand 1
     /* 353194 */     // No operand predicates
     /* 353194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353196 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 353196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 353199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 353206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353216 */     GIR_RootConstrainSelectedInstOperands,
     /* 353217 */     // GIR_Coverage, 6398,
     /* 353217 */     GIR_EraseRootFromParent_Done,
     /* 353218 */   // Label 7121: @353218
     /* 353218 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(353272), // Rule ID 1934 //
     /* 353223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 353248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353256 */     // MIs[1] Operand 1
     /* 353256 */     // No operand predicates
     /* 353256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353258 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 353258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 353261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 353268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 353270 */     GIR_RootConstrainSelectedInstOperands,
     /* 353271 */     // GIR_Coverage, 1934,
     /* 353271 */     GIR_EraseRootFromParent_Done,
     /* 353272 */   // Label 7122: @353272
     /* 353272 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(353378), // Rule ID 5692 //
     /* 353277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 353280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 353299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353307 */     // MIs[1] Operand 1
     /* 353307 */     // No operand predicates
     /* 353307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353309 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353309 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 353312 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353316 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 353326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 353342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 353345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 353367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 353370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353376 */     GIR_RootConstrainSelectedInstOperands,
     /* 353377 */     // GIR_Coverage, 5692,
     /* 353377 */     GIR_EraseRootFromParent_Done,
     /* 353378 */   // Label 7123: @353378
     /* 353378 */   GIM_Reject,
     /* 353379 */ // Label 7108: @353379
     /* 353379 */ GIM_Reject,
     /* 353380 */ // Label 6924: @353380
     /* 353380 */ GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(353504), // Rule ID 11123 //
     /* 353385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 353391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353405 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353409 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 353409 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 353412 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353416 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353421 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 353425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 353427 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 353430 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 353434 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353439 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353442 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 353445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353447 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353450 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 353454 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353459 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 353462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 353471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353476 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353479 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353482 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 353485 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 353493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353495 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353500 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 353502 */   GIR_RootConstrainSelectedInstOperands,
     /* 353503 */   // GIR_Coverage, 11123,
     /* 353503 */   GIR_EraseRootFromParent_Done,
     /* 353504 */ // Label 7124: @353504
     /* 353504 */ GIM_Reject,
     /* 353505 */ // Label 6925: @353505
     /* 353505 */ GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(353629), // Rule ID 11126 //
     /* 353510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 353516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353519 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353534 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 353534 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 353537 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353541 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353546 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 353550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 353552 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 353555 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 353559 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353564 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353567 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 353570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353572 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353575 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 353579 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353584 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 353587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 353596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353601 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353604 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353607 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 353610 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 353613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 353618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353620 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 353622 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353625 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 353627 */   GIR_RootConstrainSelectedInstOperands,
     /* 353628 */   // GIR_Coverage, 11126,
     /* 353628 */   GIR_EraseRootFromParent_Done,
     /* 353629 */ // Label 7125: @353629
     /* 353629 */ GIM_Reject,
     /* 353630 */ // Label 6926: @353630
     /* 353630 */ GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(355543),
     /* 353635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 353638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353648 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(353757), // Rule ID 4310 //
     /* 353653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353657 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353663 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353673 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353676 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353680 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 353697 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 353704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353724 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353756 */     // GIR_Coverage, 4310,
     /* 353756 */     GIR_EraseRootFromParent_Done,
     /* 353757 */   // Label 7127: @353757
     /* 353757 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(353866), // Rule ID 4311 //
     /* 353762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353766 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353772 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353782 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353785 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353789 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353799 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 353806 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 353813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353833 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353865 */     // GIR_Coverage, 4311,
     /* 353865 */     GIR_EraseRootFromParent_Done,
     /* 353866 */   // Label 7128: @353866
     /* 353866 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(353975), // Rule ID 4418 //
     /* 353871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353875 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353891 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353898 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353908 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 353915 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 353915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 353918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 353922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353942 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 353964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353974 */     // GIR_Coverage, 4418,
     /* 353974 */     GIR_EraseRootFromParent_Done,
     /* 353975 */   // Label 7129: @353975
     /* 353975 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(354084), // Rule ID 4419 //
     /* 353980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353984 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353990 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354000 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354003 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354007 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354017 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354024 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354051 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354083 */     // GIR_Coverage, 4419,
     /* 354083 */     GIR_EraseRootFromParent_Done,
     /* 354084 */   // Label 7130: @354084
     /* 354084 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(354189), // Rule ID 4316 //
     /* 354089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354129 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354156 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354188 */     // GIR_Coverage, 4316,
     /* 354188 */     GIR_EraseRootFromParent_Done,
     /* 354189 */   // Label 7131: @354189
     /* 354189 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(354294), // Rule ID 4318 //
     /* 354194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354210 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354217 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354227 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354234 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354261 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354293 */     // GIR_Coverage, 4318,
     /* 354293 */     GIR_EraseRootFromParent_Done,
     /* 354294 */   // Label 7132: @354294
     /* 354294 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(354399), // Rule ID 4424 //
     /* 354299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354315 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354322 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354339 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354366 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354398 */     // GIR_Coverage, 4424,
     /* 354398 */     GIR_EraseRootFromParent_Done,
     /* 354399 */   // Label 7133: @354399
     /* 354399 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(354504), // Rule ID 4426 //
     /* 354404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354420 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354427 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354444 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354471 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354503 */     // GIR_Coverage, 4426,
     /* 354503 */     GIR_EraseRootFromParent_Done,
     /* 354504 */   // Label 7134: @354504
     /* 354504 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(354608), // Rule ID 4308 //
     /* 354509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354519 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354529 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 354553 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 354553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 354560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354575 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354607 */     // GIR_Coverage, 4308,
     /* 354607 */     GIR_EraseRootFromParent_Done,
     /* 354608 */   // Label 7135: @354608
     /* 354608 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(354712), // Rule ID 4309 //
     /* 354613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354617 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354623 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354633 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354640 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 354657 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 354657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 354664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354679 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354711 */     // GIR_Coverage, 4309,
     /* 354711 */     GIR_EraseRootFromParent_Done,
     /* 354712 */   // Label 7136: @354712
     /* 354712 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(354816), // Rule ID 4416 //
     /* 354717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354737 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354744 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 354761 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 354761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 354768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354783 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354815 */     // GIR_Coverage, 4416,
     /* 354815 */     GIR_EraseRootFromParent_Done,
     /* 354816 */   // Label 7137: @354816
     /* 354816 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(354920), // Rule ID 4417 //
     /* 354821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354825 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354831 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354841 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 354865 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 354865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 354872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354887 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354919 */     // GIR_Coverage, 4417,
     /* 354919 */     GIR_EraseRootFromParent_Done,
     /* 354920 */   // Label 7138: @354920
     /* 354920 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(355020), // Rule ID 4312 //
     /* 354925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354941 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354948 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 354965 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 354965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 354972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354987 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355019 */     // GIR_Coverage, 4312,
     /* 355019 */     GIR_EraseRootFromParent_Done,
     /* 355020 */   // Label 7139: @355020
     /* 355020 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(355120), // Rule ID 4314 //
     /* 355025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355041 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355048 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355058 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355065 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355087 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355119 */     // GIR_Coverage, 4314,
     /* 355119 */     GIR_EraseRootFromParent_Done,
     /* 355120 */   // Label 7140: @355120
     /* 355120 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(355220), // Rule ID 4420 //
     /* 355125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355141 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355144 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355148 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355158 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355165 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355187 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355219 */     // GIR_Coverage, 4420,
     /* 355219 */     GIR_EraseRootFromParent_Done,
     /* 355220 */   // Label 7141: @355220
     /* 355220 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(355320), // Rule ID 4422 //
     /* 355225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355241 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355244 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355248 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355258 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355265 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355287 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355309 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355314 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355319 */     // GIR_Coverage, 4422,
     /* 355319 */     GIR_EraseRootFromParent_Done,
     /* 355320 */   // Label 7142: @355320
     /* 355320 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(355431), // Rule ID 11122 //
     /* 355325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355336 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 355336 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355339 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 355343 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355348 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 355352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355354 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355357 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 355361 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355366 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355369 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 355381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355386 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 355398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355403 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355406 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355412 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 355420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355422 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355427 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355429 */     GIR_RootConstrainSelectedInstOperands,
     /* 355430 */     // GIR_Coverage, 11122,
     /* 355430 */     GIR_EraseRootFromParent_Done,
     /* 355431 */   // Label 7143: @355431
     /* 355431 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(355542), // Rule ID 11128 //
     /* 355436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355447 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 355447 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355450 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 355454 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355459 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 355463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355465 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355468 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 355472 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355477 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355480 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355485 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355488 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 355492 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 355509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355514 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355517 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355520 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355523 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 355531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355533 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355538 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355540 */     GIR_RootConstrainSelectedInstOperands,
     /* 355541 */     // GIR_Coverage, 11128,
     /* 355541 */     GIR_EraseRootFromParent_Done,
     /* 355542 */   // Label 7144: @355542
     /* 355542 */   GIM_Reject,
     /* 355543 */ // Label 7126: @355543
     /* 355543 */ GIM_Reject,
     /* 355544 */ // Label 6927: @355544
     /* 355544 */ GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(355695), // Rule ID 11124 //
     /* 355549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 355555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 355558 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 355569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355573 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 355573 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 355576 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355580 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355585 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 355591 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 355596 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355601 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355604 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 355608 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355613 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 355616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355618 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355621 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 355625 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355630 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355633 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355638 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355641 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 355645 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355650 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 355662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355667 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355670 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355673 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355676 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 355684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355686 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355691 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355693 */   GIR_RootConstrainSelectedInstOperands,
     /* 355694 */   // GIR_Coverage, 11124,
     /* 355694 */   GIR_EraseRootFromParent_Done,
     /* 355695 */ // Label 7145: @355695
     /* 355695 */ GIM_Reject,
     /* 355696 */ // Label 6928: @355696
     /* 355696 */ GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(357663),
     /* 355701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 355704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 355707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 355710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355714 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(355823), // Rule ID 4274 //
     /* 355719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355739 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355742 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355746 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355763 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355790 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355822 */     // GIR_Coverage, 4274,
     /* 355822 */     GIR_EraseRootFromParent_Done,
     /* 355823 */   // Label 7147: @355823
     /* 355823 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(355932), // Rule ID 4275 //
     /* 355828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355832 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355838 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355848 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355855 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355865 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355872 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355899 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355931 */     // GIR_Coverage, 4275,
     /* 355931 */     GIR_EraseRootFromParent_Done,
     /* 355932 */   // Label 7148: @355932
     /* 355932 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(356041), // Rule ID 4382 //
     /* 355937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355941 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355947 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355957 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355960 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355964 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355974 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355981 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356008 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356040 */     // GIR_Coverage, 4382,
     /* 356040 */     GIR_EraseRootFromParent_Done,
     /* 356041 */   // Label 7149: @356041
     /* 356041 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(356150), // Rule ID 4383 //
     /* 356046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356050 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356056 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356066 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356073 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356083 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356090 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356117 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356149 */     // GIR_Coverage, 4383,
     /* 356149 */     GIR_EraseRootFromParent_Done,
     /* 356150 */   // Label 7150: @356150
     /* 356150 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(356255), // Rule ID 4280 //
     /* 356155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356171 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356178 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356188 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356195 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356222 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356254 */     // GIR_Coverage, 4280,
     /* 356254 */     GIR_EraseRootFromParent_Done,
     /* 356255 */   // Label 7151: @356255
     /* 356255 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(356360), // Rule ID 4282 //
     /* 356260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356276 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356283 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356293 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356300 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356327 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356359 */     // GIR_Coverage, 4282,
     /* 356359 */     GIR_EraseRootFromParent_Done,
     /* 356360 */   // Label 7152: @356360
     /* 356360 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(356465), // Rule ID 4388 //
     /* 356365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356381 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356384 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356388 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356398 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356405 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356432 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356464 */     // GIR_Coverage, 4388,
     /* 356464 */     GIR_EraseRootFromParent_Done,
     /* 356465 */   // Label 7153: @356465
     /* 356465 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(356570), // Rule ID 4390 //
     /* 356470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356486 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356493 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356510 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356537 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356569 */     // GIR_Coverage, 4390,
     /* 356569 */     GIR_EraseRootFromParent_Done,
     /* 356570 */   // Label 7154: @356570
     /* 356570 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(356674), // Rule ID 4272 //
     /* 356575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356595 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356602 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356619 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356641 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356673 */     // GIR_Coverage, 4272,
     /* 356673 */     GIR_EraseRootFromParent_Done,
     /* 356674 */   // Label 7155: @356674
     /* 356674 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(356778), // Rule ID 4273 //
     /* 356679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356683 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356689 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356699 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356702 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356706 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356723 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356745 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356777 */     // GIR_Coverage, 4273,
     /* 356777 */     GIR_EraseRootFromParent_Done,
     /* 356778 */   // Label 7156: @356778
     /* 356778 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(356882), // Rule ID 4380 //
     /* 356783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356787 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356793 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356810 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356820 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356827 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356849 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356881 */     // GIR_Coverage, 4380,
     /* 356881 */     GIR_EraseRootFromParent_Done,
     /* 356882 */   // Label 7157: @356882
     /* 356882 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(356986), // Rule ID 4381 //
     /* 356887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356891 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356897 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356907 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356914 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356931 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356953 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356985 */     // GIR_Coverage, 4381,
     /* 356985 */     GIR_EraseRootFromParent_Done,
     /* 356986 */   // Label 7158: @356986
     /* 356986 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(357086), // Rule ID 4276 //
     /* 356991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357007 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357014 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357024 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357031 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357053 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357085 */     // GIR_Coverage, 4276,
     /* 357085 */     GIR_EraseRootFromParent_Done,
     /* 357086 */   // Label 7159: @357086
     /* 357086 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(357186), // Rule ID 4278 //
     /* 357091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357131 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357153 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357175 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357185 */     // GIR_Coverage, 4278,
     /* 357185 */     GIR_EraseRootFromParent_Done,
     /* 357186 */   // Label 7160: @357186
     /* 357186 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(357286), // Rule ID 4384 //
     /* 357191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357207 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357210 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357214 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357224 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357231 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357285 */     // GIR_Coverage, 4384,
     /* 357285 */     GIR_EraseRootFromParent_Done,
     /* 357286 */   // Label 7161: @357286
     /* 357286 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(357386), // Rule ID 4386 //
     /* 357291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357307 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357314 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357331 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357385 */     // GIR_Coverage, 4386,
     /* 357385 */     GIR_EraseRootFromParent_Done,
     /* 357386 */   // Label 7162: @357386
     /* 357386 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(357524), // Rule ID 11121 //
     /* 357391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357402 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 357402 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 357405 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357409 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357414 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 357420 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357425 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357430 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 357433 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 357437 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357442 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 357450 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 357454 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357459 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357462 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 357465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 357470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 357474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357479 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 357482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 357487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 357491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357496 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357499 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357502 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357505 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 357508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 357513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357515 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 357517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 357522 */     GIR_RootConstrainSelectedInstOperands,
     /* 357523 */     // GIR_Coverage, 11121,
     /* 357523 */     GIR_EraseRootFromParent_Done,
     /* 357524 */   // Label 7163: @357524
     /* 357524 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(357662), // Rule ID 11127 //
     /* 357529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357540 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 357540 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 357543 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357547 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357552 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 357558 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357563 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357568 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 357571 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 357575 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357580 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357585 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 357588 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 357592 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357597 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357600 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 357603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357605 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 357608 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 357612 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357617 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 357620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 357622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 357625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 357629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357634 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357637 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357640 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357643 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 357646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 357651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 357653 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 357655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 357660 */     GIR_RootConstrainSelectedInstOperands,
     /* 357661 */     // GIR_Coverage, 11127,
     /* 357661 */     GIR_EraseRootFromParent_Done,
     /* 357662 */   // Label 7164: @357662
     /* 357662 */   GIM_Reject,
     /* 357663 */ // Label 7146: @357663
     /* 357663 */ GIM_Reject,
     /* 357664 */ // Label 6929: @357664
     /* 357664 */ GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(359857),
     /* 357669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 357672 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357798), // Rule ID 4238 //
     /* 357677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357691 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357697 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357707 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357710 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357714 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 357721 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357731 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 357738 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 357745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 357787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357797 */     // GIR_Coverage, 4238,
     /* 357797 */     GIR_EraseRootFromParent_Done,
     /* 357798 */   // Label 7166: @357798
     /* 357798 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357924), // Rule ID 4239 //
     /* 357803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 357806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357817 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357823 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357833 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357836 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357840 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 357847 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 357864 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 357871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357891 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 357913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 357923 */     // GIR_Coverage, 4239,
     /* 357923 */     GIR_EraseRootFromParent_Done,
     /* 357924 */   // Label 7167: @357924
     /* 357924 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(358043), // Rule ID 4346 //
     /* 357929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 357932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357949 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357959 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357962 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357966 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357976 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 357983 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 357983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 357986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 357990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358042 */     // GIR_Coverage, 4346,
     /* 358042 */     GIR_EraseRootFromParent_Done,
     /* 358043 */   // Label 7168: @358043
     /* 358043 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(358162), // Rule ID 4347 //
     /* 358048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358062 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358068 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358078 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358085 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358102 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358129 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358161 */     // GIR_Coverage, 4347,
     /* 358161 */     GIR_EraseRootFromParent_Done,
     /* 358162 */   // Label 7169: @358162
     /* 358162 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(358284), // Rule ID 4244 //
     /* 358167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358193 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358196 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358200 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358207 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358224 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358251 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358283 */     // GIR_Coverage, 4244,
     /* 358283 */     GIR_EraseRootFromParent_Done,
     /* 358284 */   // Label 7170: @358284
     /* 358284 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(358406), // Rule ID 4246 //
     /* 358289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358315 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358318 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358322 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358329 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358346 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358373 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358405 */     // GIR_Coverage, 4246,
     /* 358405 */     GIR_EraseRootFromParent_Done,
     /* 358406 */   // Label 7171: @358406
     /* 358406 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(358521), // Rule ID 4352 //
     /* 358411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358437 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358444 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358454 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358461 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358488 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358520 */     // GIR_Coverage, 4352,
     /* 358520 */     GIR_EraseRootFromParent_Done,
     /* 358521 */   // Label 7172: @358521
     /* 358521 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(358636), // Rule ID 4354 //
     /* 358526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358552 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358559 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358569 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358576 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358603 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358635 */     // GIR_Coverage, 4354,
     /* 358635 */     GIR_EraseRootFromParent_Done,
     /* 358636 */   // Label 7173: @358636
     /* 358636 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(358757), // Rule ID 4236 //
     /* 358641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358671 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358674 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358678 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358685 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 358702 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 358702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 358709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358724 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358756 */     // GIR_Coverage, 4236,
     /* 358756 */     GIR_EraseRootFromParent_Done,
     /* 358757 */   // Label 7174: @358757
     /* 358757 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(358878), // Rule ID 4237 //
     /* 358762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358776 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358782 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358792 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358795 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358799 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358806 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358816 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 358823 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 358823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 358830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358845 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358877 */     // GIR_Coverage, 4237,
     /* 358877 */     GIR_EraseRootFromParent_Done,
     /* 358878 */   // Label 7175: @358878
     /* 358878 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358992), // Rule ID 4344 //
     /* 358883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358897 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358903 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358913 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358920 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358930 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 358937 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 358937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 358944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358959 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358991 */     // GIR_Coverage, 4344,
     /* 358991 */     GIR_EraseRootFromParent_Done,
     /* 358992 */   // Label 7176: @358992
     /* 358992 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(359106), // Rule ID 4345 //
     /* 358997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359011 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359017 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359027 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359034 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359051 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359073 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359105 */     // GIR_Coverage, 4345,
     /* 359105 */     GIR_EraseRootFromParent_Done,
     /* 359106 */   // Label 7177: @359106
     /* 359106 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(359223), // Rule ID 4240 //
     /* 359111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359137 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359140 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359144 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359151 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359161 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359168 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359222 */     // GIR_Coverage, 4240,
     /* 359222 */     GIR_EraseRootFromParent_Done,
     /* 359223 */   // Label 7178: @359223
     /* 359223 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(359340), // Rule ID 4242 //
     /* 359228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359254 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359257 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359261 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359268 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359285 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359307 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359339 */     // GIR_Coverage, 4242,
     /* 359339 */     GIR_EraseRootFromParent_Done,
     /* 359340 */   // Label 7179: @359340
     /* 359340 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(359450), // Rule ID 4348 //
     /* 359345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359371 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359374 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359378 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359388 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359395 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359417 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359449 */     // GIR_Coverage, 4348,
     /* 359449 */     GIR_EraseRootFromParent_Done,
     /* 359450 */   // Label 7180: @359450
     /* 359450 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(359560), // Rule ID 4350 //
     /* 359455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359481 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359488 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359498 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359505 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359559 */     // GIR_Coverage, 4350,
     /* 359559 */     GIR_EraseRootFromParent_Done,
     /* 359560 */   // Label 7181: @359560
     /* 359560 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(359708), // Rule ID 11120 //
     /* 359565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359586 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 359586 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 359589 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359593 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359598 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 359604 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359609 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359614 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 359617 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 359621 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359626 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359631 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 359634 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 359638 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359643 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 359646 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 359649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 359654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 359658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359663 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 359666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 359675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359680 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359686 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 359689 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 359697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 359699 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359704 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 359706 */     GIR_RootConstrainSelectedInstOperands,
     /* 359707 */     // GIR_Coverage, 11120,
     /* 359707 */     GIR_EraseRootFromParent_Done,
     /* 359708 */   // Label 7182: @359708
     /* 359708 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(359856), // Rule ID 11125 //
     /* 359713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 359716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359734 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 359734 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 359737 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359741 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359746 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 359752 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 359757 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 359762 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 359765 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 359769 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359774 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 359777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 359779 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 359782 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 359786 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359791 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 359794 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 359797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 359799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 359802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 359806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359811 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 359814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 359819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 359823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 359831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 359834 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 359837 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 359840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 359845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 359847 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 359849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359852 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 359854 */     GIR_RootConstrainSelectedInstOperands,
     /* 359855 */     // GIR_Coverage, 11125,
     /* 359855 */     GIR_EraseRootFromParent_Done,
     /* 359856 */   // Label 7183: @359856
     /* 359856 */   GIM_Reject,
     /* 359857 */ // Label 7165: @359857
     /* 359857 */ GIM_Reject,
     /* 359858 */ // Label 6930: @359858
     /* 359858 */ GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(360907),
     /* 359863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 359866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359876 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(359992), // Rule ID 4202 //
     /* 359881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359885 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359891 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359901 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359904 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359908 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 359915 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359925 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 359932 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 359932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 359935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 359939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359959 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 359981 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 359991 */     // GIR_Coverage, 4202,
     /* 359991 */     GIR_EraseRootFromParent_Done,
     /* 359992 */   // Label 7185: @359992
     /* 359992 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(360108), // Rule ID 4203 //
     /* 359997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360001 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360007 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360017 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360020 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360024 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360031 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360041 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 360048 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 360055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360075 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360107 */     // GIR_Coverage, 4203,
     /* 360107 */     GIR_EraseRootFromParent_Done,
     /* 360108 */   // Label 7186: @360108
     /* 360108 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(360220), // Rule ID 4208 //
     /* 360113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360129 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360132 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360136 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360143 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360153 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 360160 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 360167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360187 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360219 */     // GIR_Coverage, 4208,
     /* 360219 */     GIR_EraseRootFromParent_Done,
     /* 360220 */   // Label 7187: @360220
     /* 360220 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(360332), // Rule ID 4210 //
     /* 360225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360241 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360244 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360248 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 360272 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 360279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360299 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360331 */     // GIR_Coverage, 4210,
     /* 360331 */     GIR_EraseRootFromParent_Done,
     /* 360332 */   // Label 7188: @360332
     /* 360332 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(360443), // Rule ID 4200 //
     /* 360337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360341 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360347 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360357 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360360 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360364 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360371 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 360388 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 360388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 360395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360410 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360442 */     // GIR_Coverage, 4200,
     /* 360442 */     GIR_EraseRootFromParent_Done,
     /* 360443 */   // Label 7189: @360443
     /* 360443 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(360554), // Rule ID 4201 //
     /* 360448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360452 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360458 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360468 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360471 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360475 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360482 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360492 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 360499 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 360499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 360506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360521 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360553 */     // GIR_Coverage, 4201,
     /* 360553 */     GIR_EraseRootFromParent_Done,
     /* 360554 */   // Label 7190: @360554
     /* 360554 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(360661), // Rule ID 4204 //
     /* 360559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360575 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360578 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360582 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360589 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 360606 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 360606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 360613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360628 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360660 */     // GIR_Coverage, 4204,
     /* 360660 */     GIR_EraseRootFromParent_Done,
     /* 360661 */   // Label 7191: @360661
     /* 360661 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(360768), // Rule ID 4206 //
     /* 360666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360682 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360685 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360689 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360696 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 360713 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 360713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 360720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360735 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360767 */     // GIR_Coverage, 4206,
     /* 360767 */     GIR_EraseRootFromParent_Done,
     /* 360768 */   // Label 7192: @360768
     /* 360768 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(360906), // Rule ID 11119 //
     /* 360773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360784 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 360784 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360787 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360791 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360796 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360802 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360807 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360812 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360815 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 360819 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360824 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360829 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360832 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 360836 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360841 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360844 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360849 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360852 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 360856 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360861 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 360873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360884 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360887 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 360895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360897 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360902 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360904 */     GIR_RootConstrainSelectedInstOperands,
     /* 360905 */     // GIR_Coverage, 11119,
     /* 360905 */     GIR_EraseRootFromParent_Done,
     /* 360906 */   // Label 7193: @360906
     /* 360906 */   GIM_Reject,
     /* 360907 */ // Label 7184: @360907
     /* 360907 */ GIM_Reject,
     /* 360908 */ // Label 6931: @360908
     /* 360908 */ GIM_Reject,
     /* 360909 */ // Label 89: @360909
     /* 360909 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7197*/ GIMT_Encode4(363826),
     /* 360920 */ /*GILLT_s16*//*Label 7194*/ GIMT_Encode4(360932),
     /* 360924 */ /*GILLT_s32*//*Label 7195*/ GIMT_Encode4(361566),
     /* 360928 */ /*GILLT_s64*//*Label 7196*/ GIMT_Encode4(363159),
     /* 360932 */ // Label 7194: @360932
     /* 360932 */ GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(360976), // Rule ID 11168 //
     /* 360937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 360943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360950 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 360954 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 360954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360959 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 360965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360970 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360975 */   // GIR_Coverage, 11168,
     /* 360975 */   GIR_EraseRootFromParent_Done,
     /* 360976 */ // Label 7198: @360976
     /* 360976 */ GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(361020), // Rule ID 11169 //
     /* 360981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 360987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 360990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360994 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 360998 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 360998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361003 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 361009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361019 */   // GIR_Coverage, 11169,
     /* 361019 */   GIR_EraseRootFromParent_Done,
     /* 361020 */ // Label 7199: @361020
     /* 361020 */ GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(361064), // Rule ID 11170 //
     /* 361025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 361031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361038 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361042 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 361042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361047 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 361053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361063 */   // GIR_Coverage, 11170,
     /* 361063 */   GIR_EraseRootFromParent_Done,
     /* 361064 */ // Label 7200: @361064
     /* 361064 */ GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(361109), // Rule ID 5748 //
     /* 361069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361083 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361087 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 361087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361092 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 361098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361108 */   // GIR_Coverage, 5748,
     /* 361108 */   GIR_EraseRootFromParent_Done,
     /* 361109 */ // Label 7201: @361109
     /* 361109 */ GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(361154), // Rule ID 5751 //
     /* 361114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361136 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 361140 */   // MIs[1] Operand 1
     /* 361140 */   // No operand predicates
     /* 361140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361142 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 361142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 361145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361147 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361149 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 361152 */   GIR_RootConstrainSelectedInstOperands,
     /* 361153 */   // GIR_Coverage, 5751,
     /* 361153 */   GIR_EraseRootFromParent_Done,
     /* 361154 */ // Label 7202: @361154
     /* 361154 */ GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(361230), // Rule ID 11143 //
     /* 361159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361180 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 361184 */   // MIs[1] Operand 1
     /* 361184 */   // No operand predicates
     /* 361184 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361186 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 361186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 361193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361198 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 361202 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 361205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361212 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 361219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361229 */   // GIR_Coverage, 11143,
     /* 361229 */   GIR_EraseRootFromParent_Done,
     /* 361230 */ // Label 7203: @361230
     /* 361230 */ GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(361306), // Rule ID 11144 //
     /* 361235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 361241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361256 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 361260 */   // MIs[1] Operand 1
     /* 361260 */   // No operand predicates
     /* 361260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361262 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 361262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 361269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 361278 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 361281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361288 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 361295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361300 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361305 */   // GIR_Coverage, 11144,
     /* 361305 */   GIR_EraseRootFromParent_Done,
     /* 361306 */ // Label 7204: @361306
     /* 361306 */ GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(361382), // Rule ID 11145 //
     /* 361311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 361317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361332 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 361336 */   // MIs[1] Operand 1
     /* 361336 */   // No operand predicates
     /* 361336 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361338 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 361338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 361345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361350 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 361354 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 361357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361364 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 361371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361381 */   // GIR_Coverage, 11145,
     /* 361381 */   GIR_EraseRootFromParent_Done,
     /* 361382 */ // Label 7205: @361382
     /* 361382 */ GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(361443), // Rule ID 11133 //
     /* 361387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361404 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 361404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 361411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361416 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361422 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 361426 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 361434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 361436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361439 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361441 */   GIR_RootConstrainSelectedInstOperands,
     /* 361442 */   // GIR_Coverage, 11133,
     /* 361442 */   GIR_EraseRootFromParent_Done,
     /* 361443 */ // Label 7206: @361443
     /* 361443 */ GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(361504), // Rule ID 11134 //
     /* 361448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 361454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361465 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 361465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 361472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361477 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 361487 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 361495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 361497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361500 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361502 */   GIR_RootConstrainSelectedInstOperands,
     /* 361503 */   // GIR_Coverage, 11134,
     /* 361503 */   GIR_EraseRootFromParent_Done,
     /* 361504 */ // Label 7207: @361504
     /* 361504 */ GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(361565), // Rule ID 11135 //
     /* 361509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 361515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361526 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 361526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 361533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361538 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361544 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 361548 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 361556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 361558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361561 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361563 */   GIR_RootConstrainSelectedInstOperands,
     /* 361564 */   // GIR_Coverage, 11135,
     /* 361564 */   GIR_EraseRootFromParent_Done,
     /* 361565 */ // Label 7208: @361565
     /* 361565 */ GIM_Reject,
     /* 361566 */ // Label 7195: @361566
     /* 361566 */ GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(361611), // Rule ID 6925 //
     /* 361571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361585 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361589 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 361589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361594 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 361600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361610 */   // GIR_Coverage, 6925,
     /* 361610 */   GIR_EraseRootFromParent_Done,
     /* 361611 */ // Label 7209: @361611
     /* 361611 */ GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(361656), // Rule ID 6926 //
     /* 361616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 361619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361630 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361634 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 361634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361639 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 361645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361655 */   // GIR_Coverage, 6926,
     /* 361655 */   GIR_EraseRootFromParent_Done,
     /* 361656 */ // Label 7210: @361656
     /* 361656 */ GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(361700), // Rule ID 11164 //
     /* 361661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 361667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361674 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361678 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 361678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361683 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361699 */   // GIR_Coverage, 11164,
     /* 361699 */   GIR_EraseRootFromParent_Done,
     /* 361700 */ // Label 7211: @361700
     /* 361700 */ GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(361744), // Rule ID 11165 //
     /* 361705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361718 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361722 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 361722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361727 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361743 */   // GIR_Coverage, 11165,
     /* 361743 */   GIR_EraseRootFromParent_Done,
     /* 361744 */ // Label 7212: @361744
     /* 361744 */ GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(361788), // Rule ID 11166 //
     /* 361749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 361755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361762 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361766 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 361766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361771 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361787 */   // GIR_Coverage, 11166,
     /* 361787 */   GIR_EraseRootFromParent_Done,
     /* 361788 */ // Label 7213: @361788
     /* 361788 */ GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(361832), // Rule ID 11171 //
     /* 361793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 361799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361806 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361810 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 361810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361815 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361826 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361831 */   // GIR_Coverage, 11171,
     /* 361831 */   GIR_EraseRootFromParent_Done,
     /* 361832 */ // Label 7214: @361832
     /* 361832 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(361876), // Rule ID 11172 //
     /* 361837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 361843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361850 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361854 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 361854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361859 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 361865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361870 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361875 */   // GIR_Coverage, 11172,
     /* 361875 */   GIR_EraseRootFromParent_Done,
     /* 361876 */ // Label 7215: @361876
     /* 361876 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(361921), // Rule ID 5747 //
     /* 361881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 361884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361895 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361899 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 361899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361904 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 361910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 361915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361920 */   // GIR_Coverage, 5747,
     /* 361920 */   GIR_EraseRootFromParent_Done,
     /* 361921 */ // Label 7216: @361921
     /* 361921 */ GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(361994), // Rule ID 11149 //
     /* 361926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 361932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361947 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 361951 */   // MIs[1] Operand 1
     /* 361951 */   // No operand predicates
     /* 361951 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361953 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 361953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 361956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361965 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 361971 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361976 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 361984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 361986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361989 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 361992 */   GIR_RootConstrainSelectedInstOperands,
     /* 361993 */   // GIR_Coverage, 11149,
     /* 361993 */   GIR_EraseRootFromParent_Done,
     /* 361994 */ // Label 7217: @361994
     /* 361994 */ GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(362067), // Rule ID 11150 //
     /* 361999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362012 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362016 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362020 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362024 */   // MIs[1] Operand 1
     /* 362024 */   // No operand predicates
     /* 362024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362026 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 362026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 362029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362038 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 362044 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362049 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 362057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362062 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 362065 */   GIR_RootConstrainSelectedInstOperands,
     /* 362066 */   // GIR_Coverage, 11150,
     /* 362066 */   GIR_EraseRootFromParent_Done,
     /* 362067 */ // Label 7218: @362067
     /* 362067 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362140), // Rule ID 11151 //
     /* 362072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362093 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362097 */   // MIs[1] Operand 1
     /* 362097 */   // No operand predicates
     /* 362097 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362099 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 362099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362111 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 362117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 362130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362135 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 362138 */   GIR_RootConstrainSelectedInstOperands,
     /* 362139 */   // GIR_Coverage, 11151,
     /* 362139 */   GIR_EraseRootFromParent_Done,
     /* 362140 */ // Label 7219: @362140
     /* 362140 */ GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362188), // Rule ID 1926 //
     /* 362145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 362148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 362151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362170 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 362174 */   // MIs[1] Operand 1
     /* 362174 */   // No operand predicates
     /* 362174 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362176 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 362179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362181 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362183 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362186 */   GIR_RootConstrainSelectedInstOperands,
     /* 362187 */   // GIR_Coverage, 1926,
     /* 362187 */   GIR_EraseRootFromParent_Done,
     /* 362188 */ // Label 7220: @362188
     /* 362188 */ GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(362236), // Rule ID 1927 //
     /* 362193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 362196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362210 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362214 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362218 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 362222 */   // MIs[1] Operand 1
     /* 362222 */   // No operand predicates
     /* 362222 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362224 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 362227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362229 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362231 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362234 */   GIR_RootConstrainSelectedInstOperands,
     /* 362235 */   // GIR_Coverage, 1927,
     /* 362235 */   GIR_EraseRootFromParent_Done,
     /* 362236 */ // Label 7221: @362236
     /* 362236 */ GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362284), // Rule ID 1928 //
     /* 362241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 362244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362266 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 362270 */   // MIs[1] Operand 1
     /* 362270 */   // No operand predicates
     /* 362270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362272 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 362275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362277 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362279 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362282 */   GIR_RootConstrainSelectedInstOperands,
     /* 362283 */   // GIR_Coverage, 1928,
     /* 362283 */   GIR_EraseRootFromParent_Done,
     /* 362284 */ // Label 7222: @362284
     /* 362284 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362332), // Rule ID 1930 //
     /* 362289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 362295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362314 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 362318 */   // MIs[1] Operand 1
     /* 362318 */   // No operand predicates
     /* 362318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362320 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 362323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362325 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362327 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362330 */   GIR_RootConstrainSelectedInstOperands,
     /* 362331 */   // GIR_Coverage, 1930,
     /* 362331 */   GIR_EraseRootFromParent_Done,
     /* 362332 */ // Label 7223: @362332
     /* 362332 */ GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362380), // Rule ID 1931 //
     /* 362337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362362 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362366 */   // MIs[1] Operand 1
     /* 362366 */   // No operand predicates
     /* 362366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362368 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 362371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362373 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362375 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362378 */   GIR_RootConstrainSelectedInstOperands,
     /* 362379 */   // GIR_Coverage, 1931,
     /* 362379 */   GIR_EraseRootFromParent_Done,
     /* 362380 */ // Label 7224: @362380
     /* 362380 */ GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(362428), // Rule ID 1932 //
     /* 362385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362410 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362414 */   // MIs[1] Operand 1
     /* 362414 */   // No operand predicates
     /* 362414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362416 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 362419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362421 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362423 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362426 */   GIR_RootConstrainSelectedInstOperands,
     /* 362427 */   // GIR_Coverage, 1932,
     /* 362427 */   GIR_EraseRootFromParent_Done,
     /* 362428 */ // Label 7225: @362428
     /* 362428 */ GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(362473), // Rule ID 5750 //
     /* 362433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362455 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362459 */   // MIs[1] Operand 1
     /* 362459 */   // No operand predicates
     /* 362459 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362461 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 362461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 362464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362466 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362468 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362471 */   GIR_RootConstrainSelectedInstOperands,
     /* 362472 */   // GIR_Coverage, 5750,
     /* 362472 */   GIR_EraseRootFromParent_Done,
     /* 362473 */ // Label 7226: @362473
     /* 362473 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(362549), // Rule ID 11139 //
     /* 362478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362491 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362495 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362499 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 362503 */   // MIs[1] Operand 1
     /* 362503 */   // No operand predicates
     /* 362503 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362505 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 362505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 362512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362517 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362521 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362531 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362548 */   // GIR_Coverage, 11139,
     /* 362548 */   GIR_EraseRootFromParent_Done,
     /* 362549 */ // Label 7227: @362549
     /* 362549 */ GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(362625), // Rule ID 11140 //
     /* 362554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362567 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362575 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 362579 */   // MIs[1] Operand 1
     /* 362579 */   // No operand predicates
     /* 362579 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362581 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 362581 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362584 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 362588 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362593 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362597 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362607 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362614 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362624 */   // GIR_Coverage, 11140,
     /* 362624 */   GIR_EraseRootFromParent_Done,
     /* 362625 */ // Label 7228: @362625
     /* 362625 */ GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(362701), // Rule ID 11141 //
     /* 362630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362643 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362647 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362651 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 362655 */   // MIs[1] Operand 1
     /* 362655 */   // No operand predicates
     /* 362655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362657 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 362657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 362664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362669 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362673 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362683 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362700 */   // GIR_Coverage, 11141,
     /* 362700 */   GIR_EraseRootFromParent_Done,
     /* 362701 */ // Label 7229: @362701
     /* 362701 */ GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(362777), // Rule ID 11146 //
     /* 362706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362727 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 362731 */   // MIs[1] Operand 1
     /* 362731 */   // No operand predicates
     /* 362731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362733 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 362733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 362740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362745 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362749 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362759 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362771 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362776 */   // GIR_Coverage, 11146,
     /* 362776 */   GIR_EraseRootFromParent_Done,
     /* 362777 */ // Label 7230: @362777
     /* 362777 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(362853), // Rule ID 11147 //
     /* 362782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 362788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362803 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 362807 */   // MIs[1] Operand 1
     /* 362807 */   // No operand predicates
     /* 362807 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362809 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 362809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 362812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 362816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 362825 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 362828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362835 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 362842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362852 */   // GIR_Coverage, 11147,
     /* 362852 */   GIR_EraseRootFromParent_Done,
     /* 362853 */ // Label 7231: @362853
     /* 362853 */ GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(362914), // Rule ID 11129 //
     /* 362858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362875 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 362875 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362878 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 362882 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362887 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362893 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362897 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 362905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362910 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362912 */   GIR_RootConstrainSelectedInstOperands,
     /* 362913 */   // GIR_Coverage, 11129,
     /* 362913 */   GIR_EraseRootFromParent_Done,
     /* 362914 */ // Label 7232: @362914
     /* 362914 */ GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(362975), // Rule ID 11130 //
     /* 362919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362932 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362936 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 362936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 362943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362948 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362954 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362958 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 362966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362971 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362973 */   GIR_RootConstrainSelectedInstOperands,
     /* 362974 */   // GIR_Coverage, 11130,
     /* 362974 */   GIR_EraseRootFromParent_Done,
     /* 362975 */ // Label 7233: @362975
     /* 362975 */ GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(363036), // Rule ID 11131 //
     /* 362980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362997 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 362997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 363004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363009 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363015 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363019 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 363027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363032 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363034 */   GIR_RootConstrainSelectedInstOperands,
     /* 363035 */   // GIR_Coverage, 11131,
     /* 363035 */   GIR_EraseRootFromParent_Done,
     /* 363036 */ // Label 7234: @363036
     /* 363036 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(363097), // Rule ID 11136 //
     /* 363041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363058 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 363058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 363065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363070 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363076 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363080 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 363088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 363090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363093 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363095 */   GIR_RootConstrainSelectedInstOperands,
     /* 363096 */   // GIR_Coverage, 11136,
     /* 363096 */   GIR_EraseRootFromParent_Done,
     /* 363097 */ // Label 7235: @363097
     /* 363097 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(363158), // Rule ID 11137 //
     /* 363102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 363108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363119 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 363119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 363126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363131 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363137 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363141 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 363149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 363151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363154 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363156 */   GIR_RootConstrainSelectedInstOperands,
     /* 363157 */   // GIR_Coverage, 11137,
     /* 363157 */   GIR_EraseRootFromParent_Done,
     /* 363158 */ // Label 7236: @363158
     /* 363158 */ GIM_Reject,
     /* 363159 */ // Label 7196: @363159
     /* 363159 */ GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(363204), // Rule ID 6924 //
     /* 363164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363178 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363182 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 363182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363187 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 363193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363198 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363203 */   // GIR_Coverage, 6924,
     /* 363203 */   GIR_EraseRootFromParent_Done,
     /* 363204 */ // Label 7237: @363204
     /* 363204 */ GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(363248), // Rule ID 11167 //
     /* 363209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363222 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363226 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 363226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363231 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 363237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363242 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363247 */   // GIR_Coverage, 11167,
     /* 363247 */   GIR_EraseRootFromParent_Done,
     /* 363248 */ // Label 7238: @363248
     /* 363248 */ GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(363292), // Rule ID 11173 //
     /* 363253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363266 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363270 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 363270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363275 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 363281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363291 */   // GIR_Coverage, 11173,
     /* 363291 */   GIR_EraseRootFromParent_Done,
     /* 363292 */ // Label 7239: @363292
     /* 363292 */ GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(363337), // Rule ID 5746 //
     /* 363297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363311 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363315 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 363315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363320 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 363326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363336 */   // GIR_Coverage, 5746,
     /* 363336 */   GIR_EraseRootFromParent_Done,
     /* 363337 */ // Label 7240: @363337
     /* 363337 */ GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(363410), // Rule ID 11152 //
     /* 363342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363363 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 363367 */   // MIs[1] Operand 1
     /* 363367 */   // No operand predicates
     /* 363367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363369 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 363369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 363372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363381 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 363387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 363400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363405 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 363408 */   GIR_RootConstrainSelectedInstOperands,
     /* 363409 */   // GIR_Coverage, 11152,
     /* 363409 */   GIR_EraseRootFromParent_Done,
     /* 363410 */ // Label 7241: @363410
     /* 363410 */ GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(363458), // Rule ID 1929 //
     /* 363415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 363418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363440 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 363444 */   // MIs[1] Operand 1
     /* 363444 */   // No operand predicates
     /* 363444 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363446 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 363449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363451 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363453 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363456 */   GIR_RootConstrainSelectedInstOperands,
     /* 363457 */   // GIR_Coverage, 1929,
     /* 363457 */   GIR_EraseRootFromParent_Done,
     /* 363458 */ // Label 7242: @363458
     /* 363458 */ GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(363506), // Rule ID 1933 //
     /* 363463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363480 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363484 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363488 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 363492 */   // MIs[1] Operand 1
     /* 363492 */   // No operand predicates
     /* 363492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363494 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 363497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363499 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363501 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363504 */   GIR_RootConstrainSelectedInstOperands,
     /* 363505 */   // GIR_Coverage, 1933,
     /* 363505 */   GIR_EraseRootFromParent_Done,
     /* 363506 */ // Label 7243: @363506
     /* 363506 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(363551), // Rule ID 5749 //
     /* 363511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363525 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363529 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363533 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 363537 */   // MIs[1] Operand 1
     /* 363537 */   // No operand predicates
     /* 363537 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363539 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 363539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 363542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363544 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363546 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363549 */   GIR_RootConstrainSelectedInstOperands,
     /* 363550 */   // GIR_Coverage, 5749,
     /* 363550 */   GIR_EraseRootFromParent_Done,
     /* 363551 */ // Label 7244: @363551
     /* 363551 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(363627), // Rule ID 11142 //
     /* 363556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363577 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 363581 */   // MIs[1] Operand 1
     /* 363581 */   // No operand predicates
     /* 363581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363583 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 363583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 363590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363595 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363599 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363609 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363621 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363626 */   // GIR_Coverage, 11142,
     /* 363626 */   GIR_EraseRootFromParent_Done,
     /* 363627 */ // Label 7245: @363627
     /* 363627 */ GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(363703), // Rule ID 11148 //
     /* 363632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363645 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363653 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 363657 */   // MIs[1] Operand 1
     /* 363657 */   // No operand predicates
     /* 363657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363659 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 363659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 363666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363671 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363675 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363685 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363702 */   // GIR_Coverage, 11148,
     /* 363702 */   GIR_EraseRootFromParent_Done,
     /* 363703 */ // Label 7246: @363703
     /* 363703 */ GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(363764), // Rule ID 11132 //
     /* 363708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363725 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 363725 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363728 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 363732 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363737 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363743 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363747 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 363755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363760 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363762 */   GIR_RootConstrainSelectedInstOperands,
     /* 363763 */   // GIR_Coverage, 11132,
     /* 363763 */   GIR_EraseRootFromParent_Done,
     /* 363764 */ // Label 7247: @363764
     /* 363764 */ GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(363825), // Rule ID 11138 //
     /* 363769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363786 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 363786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 363793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363798 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363804 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363808 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 363816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 363818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363821 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363823 */   GIR_RootConstrainSelectedInstOperands,
     /* 363824 */   // GIR_Coverage, 11138,
     /* 363824 */   GIR_EraseRootFromParent_Done,
     /* 363825 */ // Label 7248: @363825
     /* 363825 */ GIM_Reject,
     /* 363826 */ // Label 7197: @363826
     /* 363826 */ GIM_Reject,
     /* 363827 */ // Label 90: @363827
     /* 363827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7256*/ GIMT_Encode4(366146),
     /* 363838 */ /*GILLT_nxv2s16*//*Label 7249*/ GIMT_Encode4(363878),
     /* 363842 */ /*GILLT_nxv2s32*//*Label 7250*/ GIMT_Encode4(364237),
     /* 363846 */ /*GILLT_nxv2s64*//*Label 7251*/ GIMT_Encode4(364539), GIMT_Encode4(0),
     /* 363854 */ /*GILLT_nxv4s16*//*Label 7252*/ GIMT_Encode4(364914),
     /* 363858 */ /*GILLT_nxv4s32*//*Label 7253*/ GIMT_Encode4(365216), GIMT_Encode4(0),
     /* 363866 */ /*GILLT_nxv8s16*//*Label 7254*/ GIMT_Encode4(365591), GIMT_Encode4(0),
     /* 363874 */ /*GILLT_nxv16s8*//*Label 7255*/ GIMT_Encode4(366002),
     /* 363878 */ // Label 7249: @363878
     /* 363878 */ GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(364236),
     /* 363883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 363886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363890 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(363954), // Rule ID 5980 //
     /* 363895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 363906 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 363910 */     // MIs[1] Operand 1
     /* 363910 */     // No operand predicates
     /* 363910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363912 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 363912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 363919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 363943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363953 */     // GIR_Coverage, 5980,
     /* 363953 */     GIR_EraseRootFromParent_Done,
     /* 363954 */   // Label 7258: @363954
     /* 363954 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(364011), // Rule ID 2675 //
     /* 363959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 363974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 363995 */     // MIs[2] Operand 1
     /* 363995 */     // No operand predicates
     /* 363995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363997 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 363997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364009 */     GIR_RootConstrainSelectedInstOperands,
     /* 364010 */     // GIR_Coverage, 2675,
     /* 364010 */     GIR_EraseRootFromParent_Done,
     /* 364011 */   // Label 7259: @364011
     /* 364011 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(364068), // Rule ID 2677 //
     /* 364016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 364031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364048 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364052 */     // MIs[2] Operand 1
     /* 364052 */     // No operand predicates
     /* 364052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364054 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364066 */     GIR_RootConstrainSelectedInstOperands,
     /* 364067 */     // GIR_Coverage, 2677,
     /* 364067 */     GIR_EraseRootFromParent_Done,
     /* 364068 */   // Label 7260: @364068
     /* 364068 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(364125), // Rule ID 8284 //
     /* 364073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364105 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 364109 */     // MIs[2] Operand 1
     /* 364109 */     // No operand predicates
     /* 364109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364111 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 364111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364123 */     GIR_RootConstrainSelectedInstOperands,
     /* 364124 */     // GIR_Coverage, 8284,
     /* 364124 */     GIR_EraseRootFromParent_Done,
     /* 364125 */   // Label 7261: @364125
     /* 364125 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(364159), // Rule ID 8327 //
     /* 364130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364141 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 364145 */     // MIs[1] Operand 1
     /* 364145 */     // No operand predicates
     /* 364145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364147 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 364147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 364150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364152 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 364157 */     GIR_RootConstrainSelectedInstOperands,
     /* 364158 */     // GIR_Coverage, 8327,
     /* 364158 */     GIR_EraseRootFromParent_Done,
     /* 364159 */   // Label 7262: @364159
     /* 364159 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(364235), // Rule ID 8305 //
     /* 364164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364171 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 364174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364197 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364200 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364204 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 364207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364233 */     GIR_RootConstrainSelectedInstOperands,
     /* 364234 */     // GIR_Coverage, 8305,
     /* 364234 */     GIR_EraseRootFromParent_Done,
     /* 364235 */   // Label 7263: @364235
     /* 364235 */   GIM_Reject,
     /* 364236 */ // Label 7257: @364236
     /* 364236 */ GIM_Reject,
     /* 364237 */ // Label 7250: @364237
     /* 364237 */ GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(364538),
     /* 364242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 364245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364249 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(364313), // Rule ID 5978 //
     /* 364254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364265 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364269 */     // MIs[1] Operand 1
     /* 364269 */     // No operand predicates
     /* 364269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364271 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364312 */     // GIR_Coverage, 5978,
     /* 364312 */     GIR_EraseRootFromParent_Done,
     /* 364313 */   // Label 7265: @364313
     /* 364313 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(364370), // Rule ID 8293 //
     /* 364318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 364333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364350 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 364354 */     // MIs[2] Operand 1
     /* 364354 */     // No operand predicates
     /* 364354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364356 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 364356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364368 */     GIR_RootConstrainSelectedInstOperands,
     /* 364369 */     // GIR_Coverage, 8293,
     /* 364369 */     GIR_EraseRootFromParent_Done,
     /* 364370 */   // Label 7266: @364370
     /* 364370 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(364427), // Rule ID 8302 //
     /* 364375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 364390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364407 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364411 */     // MIs[2] Operand 1
     /* 364411 */     // No operand predicates
     /* 364411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364413 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364425 */     GIR_RootConstrainSelectedInstOperands,
     /* 364426 */     // GIR_Coverage, 8302,
     /* 364426 */     GIR_EraseRootFromParent_Done,
     /* 364427 */   // Label 7267: @364427
     /* 364427 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(364461), // Rule ID 8329 //
     /* 364432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364443 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 364447 */     // MIs[1] Operand 1
     /* 364447 */     // No operand predicates
     /* 364447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364449 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 364449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 364452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364454 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 364459 */     GIR_RootConstrainSelectedInstOperands,
     /* 364460 */     // GIR_Coverage, 8329,
     /* 364460 */     GIR_EraseRootFromParent_Done,
     /* 364461 */   // Label 7268: @364461
     /* 364461 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(364537), // Rule ID 8307 //
     /* 364466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364473 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 364476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364499 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364506 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 364509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364535 */     GIR_RootConstrainSelectedInstOperands,
     /* 364536 */     // GIR_Coverage, 8307,
     /* 364536 */     GIR_EraseRootFromParent_Done,
     /* 364537 */   // Label 7269: @364537
     /* 364537 */   GIM_Reject,
     /* 364538 */ // Label 7264: @364538
     /* 364538 */ GIM_Reject,
     /* 364539 */ // Label 7251: @364539
     /* 364539 */ GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(364913),
     /* 364544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 364547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364551 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(364605), // Rule ID 5973 //
     /* 364556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 364563 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364604 */     // GIR_Coverage, 5973,
     /* 364604 */     GIR_EraseRootFromParent_Done,
     /* 364605 */   // Label 7271: @364605
     /* 364605 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(364669), // Rule ID 5977 //
     /* 364610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364621 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364625 */     // MIs[1] Operand 1
     /* 364625 */     // No operand predicates
     /* 364625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364627 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364668 */     // GIR_Coverage, 5977,
     /* 364668 */     GIR_EraseRootFromParent_Done,
     /* 364669 */   // Label 7272: @364669
     /* 364669 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(364726), // Rule ID 2672 //
     /* 364674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364710 */     // MIs[2] Operand 1
     /* 364710 */     // No operand predicates
     /* 364710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364712 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364724 */     GIR_RootConstrainSelectedInstOperands,
     /* 364725 */     // GIR_Coverage, 2672,
     /* 364725 */     GIR_EraseRootFromParent_Done,
     /* 364726 */   // Label 7273: @364726
     /* 364726 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(364783), // Rule ID 8299 //
     /* 364731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364767 */     // MIs[2] Operand 1
     /* 364767 */     // No operand predicates
     /* 364767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364769 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364781 */     GIR_RootConstrainSelectedInstOperands,
     /* 364782 */     // GIR_Coverage, 8299,
     /* 364782 */     GIR_EraseRootFromParent_Done,
     /* 364783 */   // Label 7274: @364783
     /* 364783 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(364817), // Rule ID 8330 //
     /* 364788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364799 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 364803 */     // MIs[1] Operand 1
     /* 364803 */     // No operand predicates
     /* 364803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364805 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 364805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 364808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364810 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 364815 */     GIR_RootConstrainSelectedInstOperands,
     /* 364816 */     // GIR_Coverage, 8330,
     /* 364816 */     GIR_EraseRootFromParent_Done,
     /* 364817 */   // Label 7275: @364817
     /* 364817 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(364836), // Rule ID 2391 //
     /* 364822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364829 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 364829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 364834 */     GIR_RootConstrainSelectedInstOperands,
     /* 364835 */     // GIR_Coverage, 2391,
     /* 364835 */     GIR_Done,
     /* 364836 */   // Label 7276: @364836
     /* 364836 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(364912), // Rule ID 8308 //
     /* 364841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364848 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364848 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 364851 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364855 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364874 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 364884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364910 */     GIR_RootConstrainSelectedInstOperands,
     /* 364911 */     // GIR_Coverage, 8308,
     /* 364911 */     GIR_EraseRootFromParent_Done,
     /* 364912 */   // Label 7277: @364912
     /* 364912 */   GIM_Reject,
     /* 364913 */ // Label 7270: @364913
     /* 364913 */ GIM_Reject,
     /* 364914 */ // Label 7252: @364914
     /* 364914 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(365215),
     /* 364919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364926 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(364990), // Rule ID 5981 //
     /* 364931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364942 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364946 */     // MIs[1] Operand 1
     /* 364946 */     // No operand predicates
     /* 364946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364948 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364960 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364989 */     // GIR_Coverage, 5981,
     /* 364989 */     GIR_EraseRootFromParent_Done,
     /* 364990 */   // Label 7279: @364990
     /* 364990 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(365047), // Rule ID 2676 //
     /* 364995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 365010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365031 */     // MIs[2] Operand 1
     /* 365031 */     // No operand predicates
     /* 365031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365033 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365045 */     GIR_RootConstrainSelectedInstOperands,
     /* 365046 */     // GIR_Coverage, 2676,
     /* 365046 */     GIR_EraseRootFromParent_Done,
     /* 365047 */   // Label 7280: @365047
     /* 365047 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(365104), // Rule ID 8287 //
     /* 365052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365088 */     // MIs[2] Operand 1
     /* 365088 */     // No operand predicates
     /* 365088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365090 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 365090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365102 */     GIR_RootConstrainSelectedInstOperands,
     /* 365103 */     // GIR_Coverage, 8287,
     /* 365103 */     GIR_EraseRootFromParent_Done,
     /* 365104 */   // Label 7281: @365104
     /* 365104 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(365138), // Rule ID 8326 //
     /* 365109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365120 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 365124 */     // MIs[1] Operand 1
     /* 365124 */     // No operand predicates
     /* 365124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365126 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 365126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 365129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365131 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 365136 */     GIR_RootConstrainSelectedInstOperands,
     /* 365137 */     // GIR_Coverage, 8326,
     /* 365137 */     GIR_EraseRootFromParent_Done,
     /* 365138 */   // Label 7282: @365138
     /* 365138 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(365214), // Rule ID 8304 //
     /* 365143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365150 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365183 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 365186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365212 */     GIR_RootConstrainSelectedInstOperands,
     /* 365213 */     // GIR_Coverage, 8304,
     /* 365213 */     GIR_EraseRootFromParent_Done,
     /* 365214 */   // Label 7283: @365214
     /* 365214 */   GIM_Reject,
     /* 365215 */ // Label 7278: @365215
     /* 365215 */ GIM_Reject,
     /* 365216 */ // Label 7253: @365216
     /* 365216 */ GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(365590),
     /* 365221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365228 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(365282), // Rule ID 5974 //
     /* 365233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 365240 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365281 */     // GIR_Coverage, 5974,
     /* 365281 */     GIR_EraseRootFromParent_Done,
     /* 365282 */   // Label 7285: @365282
     /* 365282 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(365346), // Rule ID 5979 //
     /* 365287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365298 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365302 */     // MIs[1] Operand 1
     /* 365302 */     // No operand predicates
     /* 365302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365304 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365345 */     // GIR_Coverage, 5979,
     /* 365345 */     GIR_EraseRootFromParent_Done,
     /* 365346 */   // Label 7286: @365346
     /* 365346 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(365403), // Rule ID 2669 //
     /* 365351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365383 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365387 */     // MIs[2] Operand 1
     /* 365387 */     // No operand predicates
     /* 365387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365389 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365401 */     GIR_RootConstrainSelectedInstOperands,
     /* 365402 */     // GIR_Coverage, 2669,
     /* 365402 */     GIR_EraseRootFromParent_Done,
     /* 365403 */   // Label 7287: @365403
     /* 365403 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(365460), // Rule ID 8296 //
     /* 365408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365444 */     // MIs[2] Operand 1
     /* 365444 */     // No operand predicates
     /* 365444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365446 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365458 */     GIR_RootConstrainSelectedInstOperands,
     /* 365459 */     // GIR_Coverage, 8296,
     /* 365459 */     GIR_EraseRootFromParent_Done,
     /* 365460 */   // Label 7288: @365460
     /* 365460 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(365494), // Rule ID 8328 //
     /* 365465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365476 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 365480 */     // MIs[1] Operand 1
     /* 365480 */     // No operand predicates
     /* 365480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365482 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 365482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 365485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365487 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 365492 */     GIR_RootConstrainSelectedInstOperands,
     /* 365493 */     // GIR_Coverage, 8328,
     /* 365493 */     GIR_EraseRootFromParent_Done,
     /* 365494 */   // Label 7289: @365494
     /* 365494 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(365513), // Rule ID 2390 //
     /* 365499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 365506 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 365506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 365511 */     GIR_RootConstrainSelectedInstOperands,
     /* 365512 */     // GIR_Coverage, 2390,
     /* 365512 */     GIR_Done,
     /* 365513 */   // Label 7290: @365513
     /* 365513 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(365589), // Rule ID 8306 //
     /* 365518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365525 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365551 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365558 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 365561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365587 */     GIR_RootConstrainSelectedInstOperands,
     /* 365588 */     // GIR_Coverage, 8306,
     /* 365588 */     GIR_EraseRootFromParent_Done,
     /* 365589 */   // Label 7291: @365589
     /* 365589 */   GIM_Reject,
     /* 365590 */ // Label 7284: @365590
     /* 365590 */ GIM_Reject,
     /* 365591 */ // Label 7254: @365591
     /* 365591 */ GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(365652), // Rule ID 5975 //
     /* 365596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365606 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 365610 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365610 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365613 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365617 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365622 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365646 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365651 */   // GIR_Coverage, 5975,
     /* 365651 */   GIR_EraseRootFromParent_Done,
     /* 365652 */ // Label 7292: @365652
     /* 365652 */ GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(365723), // Rule ID 5982 //
     /* 365657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365675 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365679 */   // MIs[1] Operand 1
     /* 365679 */   // No operand predicates
     /* 365679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365681 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365722 */   // GIR_Coverage, 5982,
     /* 365722 */   GIR_EraseRootFromParent_Done,
     /* 365723 */ // Label 7293: @365723
     /* 365723 */ GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(365787), // Rule ID 2666 //
     /* 365728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365746 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365750 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365754 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365759 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365763 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365767 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365771 */   // MIs[2] Operand 1
     /* 365771 */   // No operand predicates
     /* 365771 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365773 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 365773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365778 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365782 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365785 */   GIR_RootConstrainSelectedInstOperands,
     /* 365786 */   // GIR_Coverage, 2666,
     /* 365786 */   GIR_EraseRootFromParent_Done,
     /* 365787 */ // Label 7294: @365787
     /* 365787 */ GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(365851), // Rule ID 8290 //
     /* 365792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365810 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365814 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365818 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365823 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365827 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365831 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365835 */   // MIs[2] Operand 1
     /* 365835 */   // No operand predicates
     /* 365835 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365837 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 365837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365842 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365846 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365849 */   GIR_RootConstrainSelectedInstOperands,
     /* 365850 */   // GIR_Coverage, 8290,
     /* 365850 */   GIR_EraseRootFromParent_Done,
     /* 365851 */ // Label 7295: @365851
     /* 365851 */ GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(365892), // Rule ID 8325 //
     /* 365856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365874 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 365878 */   // MIs[1] Operand 1
     /* 365878 */   // No operand predicates
     /* 365878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365880 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 365880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 365883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365885 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 365890 */   GIR_RootConstrainSelectedInstOperands,
     /* 365891 */   // GIR_Coverage, 8325,
     /* 365891 */   GIR_EraseRootFromParent_Done,
     /* 365892 */ // Label 7296: @365892
     /* 365892 */ GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(365918), // Rule ID 2389 //
     /* 365897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 365911 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 365911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 365916 */   GIR_RootConstrainSelectedInstOperands,
     /* 365917 */   // GIR_Coverage, 2389,
     /* 365917 */   GIR_Done,
     /* 365918 */ // Label 7297: @365918
     /* 365918 */ GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(366001), // Rule ID 8303 //
     /* 365923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365937 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365937 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365940 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365944 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365963 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365966 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365970 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 365973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365999 */   GIR_RootConstrainSelectedInstOperands,
     /* 366000 */   // GIR_Coverage, 8303,
     /* 366000 */   GIR_EraseRootFromParent_Done,
     /* 366001 */ // Label 7298: @366001
     /* 366001 */ GIM_Reject,
     /* 366002 */ // Label 7255: @366002
     /* 366002 */ GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(366145),
     /* 366007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366014 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(366068), // Rule ID 5976 //
     /* 366019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 366026 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366038 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366067 */     // GIR_Coverage, 5976,
     /* 366067 */     GIR_EraseRootFromParent_Done,
     /* 366068 */   // Label 7300: @366068
     /* 366068 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(366125), // Rule ID 2663 //
     /* 366073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 366088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366105 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 366109 */     // MIs[2] Operand 1
     /* 366109 */     // No operand predicates
     /* 366109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366111 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 366111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 366114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366123 */     GIR_RootConstrainSelectedInstOperands,
     /* 366124 */     // GIR_Coverage, 2663,
     /* 366124 */     GIR_EraseRootFromParent_Done,
     /* 366125 */   // Label 7301: @366125
     /* 366125 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(366144), // Rule ID 2388 //
     /* 366130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 366137 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 366137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 366142 */     GIR_RootConstrainSelectedInstOperands,
     /* 366143 */     // GIR_Coverage, 2388,
     /* 366143 */     GIR_Done,
     /* 366144 */   // Label 7302: @366144
     /* 366144 */   GIM_Reject,
     /* 366145 */ // Label 7299: @366145
     /* 366145 */ GIM_Reject,
     /* 366146 */ // Label 7256: @366146
     /* 366146 */ GIM_Reject,
     /* 366147 */ // Label 91: @366147
     /* 366147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7305*/ GIMT_Encode4(366298),
     /* 366158 */ /*GILLT_s32*//*Label 7303*/ GIMT_Encode4(366166),
     /* 366162 */ /*GILLT_s64*//*Label 7304*/ GIMT_Encode4(366232),
     /* 366166 */ // Label 7303: @366166
     /* 366166 */ GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(366231),
     /* 366171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366182 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(366197), // Rule ID 2321 //
     /* 366187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 366190 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 366195 */     GIR_RootConstrainSelectedInstOperands,
     /* 366196 */     // GIR_Coverage, 2321,
     /* 366196 */     GIR_Done,
     /* 366197 */   // Label 7307: @366197
     /* 366197 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(366230), // Rule ID 3995 //
     /* 366202 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 366202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 366209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 366223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366228 */     GIR_RootConstrainSelectedInstOperands,
     /* 366229 */     // GIR_Coverage, 3995,
     /* 366229 */     GIR_EraseRootFromParent_Done,
     /* 366230 */   // Label 7308: @366230
     /* 366230 */   GIM_Reject,
     /* 366231 */ // Label 7306: @366231
     /* 366231 */ GIM_Reject,
     /* 366232 */ // Label 7304: @366232
     /* 366232 */ GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(366297),
     /* 366237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366248 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(366263), // Rule ID 2322 //
     /* 366253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 366256 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 366261 */     GIR_RootConstrainSelectedInstOperands,
     /* 366262 */     // GIR_Coverage, 2322,
     /* 366262 */     GIR_Done,
     /* 366263 */   // Label 7310: @366263
     /* 366263 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(366296), // Rule ID 3996 //
     /* 366268 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 366268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 366271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 366275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 366289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366294 */     GIR_RootConstrainSelectedInstOperands,
     /* 366295 */     // GIR_Coverage, 3996,
     /* 366295 */     GIR_EraseRootFromParent_Done,
     /* 366296 */   // Label 7311: @366296
     /* 366296 */   GIM_Reject,
     /* 366297 */ // Label 7309: @366297
     /* 366297 */ GIM_Reject,
     /* 366298 */ // Label 7305: @366298
     /* 366298 */ GIM_Reject,
     /* 366299 */ // Label 92: @366299
     /* 366299 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7320*/ GIMT_Encode4(366972),
     /* 366310 */ /*GILLT_s32*//*Label 7312*/ GIMT_Encode4(366350),
     /* 366314 */ /*GILLT_s64*//*Label 7313*/ GIMT_Encode4(366580), GIMT_Encode4(0),
     /* 366322 */ /*GILLT_v2s32*//*Label 7314*/ GIMT_Encode4(366810), GIMT_Encode4(0),
     /* 366330 */ /*GILLT_v4s16*//*Label 7315*/ GIMT_Encode4(366837),
     /* 366334 */ /*GILLT_v4s32*//*Label 7316*/ GIMT_Encode4(366864),
     /* 366338 */ /*GILLT_v8s8*//*Label 7317*/ GIMT_Encode4(366891),
     /* 366342 */ /*GILLT_v8s16*//*Label 7318*/ GIMT_Encode4(366918),
     /* 366346 */ /*GILLT_v16s8*//*Label 7319*/ GIMT_Encode4(366945),
     /* 366350 */ // Label 7312: @366350
     /* 366350 */ GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(366579),
     /* 366355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366362 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(366462), // Rule ID 3997 //
     /* 366367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366407 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 366411 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 366415 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366419 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 366423 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366427 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366432 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 366436 */     // MIs[3] Rn
     /* 366436 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 366441 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366445 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366449 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366451 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 366454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 366460 */     GIR_RootConstrainSelectedInstOperands,
     /* 366461 */     // GIR_Coverage, 3997,
     /* 366461 */     GIR_EraseRootFromParent_Done,
     /* 366462 */   // Label 7322: @366462
     /* 366462 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(366562), // Rule ID 13721 //
     /* 366467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366507 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 366511 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 366515 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366520 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 366524 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366528 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366532 */     // MIs[4] Rn
     /* 366532 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 366537 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 366541 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366545 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366549 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366551 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 366554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 366560 */     GIR_RootConstrainSelectedInstOperands,
     /* 366561 */     // GIR_Coverage, 13721,
     /* 366561 */     GIR_EraseRootFromParent_Done,
     /* 366562 */   // Label 7323: @366562
     /* 366562 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(366578), // Rule ID 180 //
     /* 366567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366571 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 366576 */     GIR_RootConstrainSelectedInstOperands,
     /* 366577 */     // GIR_Coverage, 180,
     /* 366577 */     GIR_Done,
     /* 366578 */   // Label 7324: @366578
     /* 366578 */   GIM_Reject,
     /* 366579 */ // Label 7321: @366579
     /* 366579 */ GIM_Reject,
     /* 366580 */ // Label 7313: @366580
     /* 366580 */ GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(366809),
     /* 366585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366592 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(366692), // Rule ID 3998 //
     /* 366597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 366609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 366625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 366641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 366645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 366653 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366657 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366662 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 366666 */     // MIs[3] Rn
     /* 366666 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 366671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366679 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366681 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 366684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 366690 */     GIR_RootConstrainSelectedInstOperands,
     /* 366691 */     // GIR_Coverage, 3998,
     /* 366691 */     GIR_EraseRootFromParent_Done,
     /* 366692 */   // Label 7326: @366692
     /* 366692 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(366792), // Rule ID 13722 //
     /* 366697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 366709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 366725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 366741 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 366745 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 366754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366762 */     // MIs[4] Rn
     /* 366762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 366767 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 366771 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366775 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366779 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366781 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 366784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 366790 */     GIR_RootConstrainSelectedInstOperands,
     /* 366791 */     // GIR_Coverage, 13722,
     /* 366791 */     GIR_EraseRootFromParent_Done,
     /* 366792 */   // Label 7327: @366792
     /* 366792 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(366808), // Rule ID 181 //
     /* 366797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366801 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 366806 */     GIR_RootConstrainSelectedInstOperands,
     /* 366807 */     // GIR_Coverage, 181,
     /* 366807 */     GIR_Done,
     /* 366808 */   // Label 7328: @366808
     /* 366808 */   GIM_Reject,
     /* 366809 */ // Label 7325: @366809
     /* 366809 */ GIM_Reject,
     /* 366810 */ // Label 7314: @366810
     /* 366810 */ GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(366836), // Rule ID 720 //
     /* 366815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366829 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 366829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 366834 */   GIR_RootConstrainSelectedInstOperands,
     /* 366835 */   // GIR_Coverage, 720,
     /* 366835 */   GIR_Done,
     /* 366836 */ // Label 7329: @366836
     /* 366836 */ GIM_Reject,
     /* 366837 */ // Label 7315: @366837
     /* 366837 */ GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(366863), // Rule ID 718 //
     /* 366842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 366848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366856 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 366856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 366861 */   GIR_RootConstrainSelectedInstOperands,
     /* 366862 */   // GIR_Coverage, 718,
     /* 366862 */   GIR_Done,
     /* 366863 */ // Label 7330: @366863
     /* 366863 */ GIM_Reject,
     /* 366864 */ // Label 7316: @366864
     /* 366864 */ GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(366890), // Rule ID 721 //
     /* 366869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366883 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 366883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 366888 */   GIR_RootConstrainSelectedInstOperands,
     /* 366889 */   // GIR_Coverage, 721,
     /* 366889 */   GIR_Done,
     /* 366890 */ // Label 7331: @366890
     /* 366890 */ GIM_Reject,
     /* 366891 */ // Label 7317: @366891
     /* 366891 */ GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(366917), // Rule ID 716 //
     /* 366896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 366902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366910 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 366910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 366915 */   GIR_RootConstrainSelectedInstOperands,
     /* 366916 */   // GIR_Coverage, 716,
     /* 366916 */   GIR_Done,
     /* 366917 */ // Label 7332: @366917
     /* 366917 */ GIM_Reject,
     /* 366918 */ // Label 7318: @366918
     /* 366918 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(366944), // Rule ID 719 //
     /* 366923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 366929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366937 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 366937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 366942 */   GIR_RootConstrainSelectedInstOperands,
     /* 366943 */   // GIR_Coverage, 719,
     /* 366943 */   GIR_Done,
     /* 366944 */ // Label 7333: @366944
     /* 366944 */ GIM_Reject,
     /* 366945 */ // Label 7319: @366945
     /* 366945 */ GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(366971), // Rule ID 717 //
     /* 366950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 366956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366964 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 366964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 366969 */   GIR_RootConstrainSelectedInstOperands,
     /* 366970 */   // GIR_Coverage, 717,
     /* 366970 */   GIR_Done,
     /* 366971 */ // Label 7334: @366971
     /* 366971 */ GIM_Reject,
     /* 366972 */ // Label 7320: @366972
     /* 366972 */ GIM_Reject,
     /* 366973 */ // Label 93: @366973
     /* 366973 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7339*/ GIMT_Encode4(367132),
     /* 366984 */ /*GILLT_s32*//*Label 7335*/ GIMT_Encode4(367024),
     /* 366988 */ /*GILLT_s64*//*Label 7336*/ GIMT_Encode4(367051), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 367012 */ /*GILLT_v8s8*//*Label 7337*/ GIMT_Encode4(367078), GIMT_Encode4(0),
     /* 367020 */ /*GILLT_v16s8*//*Label 7338*/ GIMT_Encode4(367105),
     /* 367024 */ // Label 7335: @367024
     /* 367024 */ GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(367050), // Rule ID 2319 //
     /* 367029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 367032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367043 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 367048 */   GIR_RootConstrainSelectedInstOperands,
     /* 367049 */   // GIR_Coverage, 2319,
     /* 367049 */   GIR_Done,
     /* 367050 */ // Label 7340: @367050
     /* 367050 */ GIM_Reject,
     /* 367051 */ // Label 7336: @367051
     /* 367051 */ GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(367077), // Rule ID 2320 //
     /* 367056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 367059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367070 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 367075 */   GIR_RootConstrainSelectedInstOperands,
     /* 367076 */   // GIR_Coverage, 2320,
     /* 367076 */   GIR_Done,
     /* 367077 */ // Label 7341: @367077
     /* 367077 */ GIM_Reject,
     /* 367078 */ // Label 7337: @367078
     /* 367078 */ GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(367104), // Rule ID 764 //
     /* 367083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367097 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 367097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 367102 */   GIR_RootConstrainSelectedInstOperands,
     /* 367103 */   // GIR_Coverage, 764,
     /* 367103 */   GIR_Done,
     /* 367104 */ // Label 7342: @367104
     /* 367104 */ GIM_Reject,
     /* 367105 */ // Label 7338: @367105
     /* 367105 */ GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(367131), // Rule ID 765 //
     /* 367110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367124 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 367124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 367129 */   GIR_RootConstrainSelectedInstOperands,
     /* 367130 */   // GIR_Coverage, 765,
     /* 367130 */   GIR_Done,
     /* 367131 */ // Label 7343: @367131
     /* 367131 */ GIM_Reject,
     /* 367132 */ // Label 7339: @367132
     /* 367132 */ GIM_Reject,
     /* 367133 */ // Label 94: @367133
     /* 367133 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7351*/ GIMT_Encode4(367446),
     /* 367144 */ /*GILLT_s32*//*Label 7344*/ GIMT_Encode4(367180),
     /* 367148 */ /*GILLT_s64*//*Label 7345*/ GIMT_Encode4(367253), GIMT_Encode4(0),
     /* 367156 */ /*GILLT_v2s32*//*Label 7346*/ GIMT_Encode4(367326),
     /* 367160 */ /*GILLT_v2s64*//*Label 7347*/ GIMT_Encode4(367350),
     /* 367164 */ /*GILLT_v4s16*//*Label 7348*/ GIMT_Encode4(367374),
     /* 367168 */ /*GILLT_v4s32*//*Label 7349*/ GIMT_Encode4(367398), GIMT_Encode4(0),
     /* 367176 */ /*GILLT_v8s16*//*Label 7350*/ GIMT_Encode4(367422),
     /* 367180 */ // Label 7344: @367180
     /* 367180 */ GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(367252),
     /* 367185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367192 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(367235), // Rule ID 4001 //
     /* 367197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 367205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367218 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 367222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367224 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 367227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367233 */     GIR_RootConstrainSelectedInstOperands,
     /* 367234 */     // GIR_Coverage, 4001,
     /* 367234 */     GIR_EraseRootFromParent_Done,
     /* 367235 */   // Label 7353: @367235
     /* 367235 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(367251), // Rule ID 185 //
     /* 367240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367244 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 367249 */     GIR_RootConstrainSelectedInstOperands,
     /* 367250 */     // GIR_Coverage, 185,
     /* 367250 */     GIR_Done,
     /* 367251 */   // Label 7354: @367251
     /* 367251 */   GIM_Reject,
     /* 367252 */ // Label 7352: @367252
     /* 367252 */ GIM_Reject,
     /* 367253 */ // Label 7345: @367253
     /* 367253 */ GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(367325),
     /* 367258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367265 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(367308), // Rule ID 4002 //
     /* 367270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 367278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 367282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367291 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 367295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367297 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 367300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367306 */     GIR_RootConstrainSelectedInstOperands,
     /* 367307 */     // GIR_Coverage, 4002,
     /* 367307 */     GIR_EraseRootFromParent_Done,
     /* 367308 */   // Label 7356: @367308
     /* 367308 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(367324), // Rule ID 186 //
     /* 367313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367317 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 367322 */     GIR_RootConstrainSelectedInstOperands,
     /* 367323 */     // GIR_Coverage, 186,
     /* 367323 */     GIR_Done,
     /* 367324 */   // Label 7357: @367324
     /* 367324 */   GIM_Reject,
     /* 367325 */ // Label 7355: @367325
     /* 367325 */ GIM_Reject,
     /* 367326 */ // Label 7346: @367326
     /* 367326 */ GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(367349), // Rule ID 4976 //
     /* 367331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367342 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 367342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 367347 */   GIR_RootConstrainSelectedInstOperands,
     /* 367348 */   // GIR_Coverage, 4976,
     /* 367348 */   GIR_Done,
     /* 367349 */ // Label 7358: @367349
     /* 367349 */ GIM_Reject,
     /* 367350 */ // Label 7347: @367350
     /* 367350 */ GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(367373), // Rule ID 4978 //
     /* 367355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367366 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 367366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 367371 */   GIR_RootConstrainSelectedInstOperands,
     /* 367372 */   // GIR_Coverage, 4978,
     /* 367372 */   GIR_Done,
     /* 367373 */ // Label 7359: @367373
     /* 367373 */ GIM_Reject,
     /* 367374 */ // Label 7348: @367374
     /* 367374 */ GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(367397), // Rule ID 4974 //
     /* 367379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367390 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 367390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 367395 */   GIR_RootConstrainSelectedInstOperands,
     /* 367396 */   // GIR_Coverage, 4974,
     /* 367396 */   GIR_Done,
     /* 367397 */ // Label 7360: @367397
     /* 367397 */ GIM_Reject,
     /* 367398 */ // Label 7349: @367398
     /* 367398 */ GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(367421), // Rule ID 4977 //
     /* 367403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367414 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 367414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 367419 */   GIR_RootConstrainSelectedInstOperands,
     /* 367420 */   // GIR_Coverage, 4977,
     /* 367420 */   GIR_Done,
     /* 367421 */ // Label 7361: @367421
     /* 367421 */ GIM_Reject,
     /* 367422 */ // Label 7350: @367422
     /* 367422 */ GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(367445), // Rule ID 4975 //
     /* 367427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367438 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 367438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 367443 */   GIR_RootConstrainSelectedInstOperands,
     /* 367444 */   // GIR_Coverage, 4975,
     /* 367444 */   GIR_Done,
     /* 367445 */ // Label 7362: @367445
     /* 367445 */ GIM_Reject,
     /* 367446 */ // Label 7351: @367446
     /* 367446 */ GIM_Reject,
     /* 367447 */ // Label 95: @367447
     /* 367447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7367*/ GIMT_Encode4(367600),
     /* 367458 */ /*GILLT_s32*//*Label 7363*/ GIMT_Encode4(367498),
     /* 367462 */ /*GILLT_s64*//*Label 7364*/ GIMT_Encode4(367522), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 367486 */ /*GILLT_v8s8*//*Label 7365*/ GIMT_Encode4(367546), GIMT_Encode4(0),
     /* 367494 */ /*GILLT_v16s8*//*Label 7366*/ GIMT_Encode4(367573),
     /* 367498 */ // Label 7363: @367498
     /* 367498 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(367521), // Rule ID 182 //
     /* 367503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367514 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 367519 */   GIR_RootConstrainSelectedInstOperands,
     /* 367520 */   // GIR_Coverage, 182,
     /* 367520 */   GIR_Done,
     /* 367521 */ // Label 7368: @367521
     /* 367521 */ GIM_Reject,
     /* 367522 */ // Label 7364: @367522
     /* 367522 */ GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(367545), // Rule ID 183 //
     /* 367527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367538 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 367543 */   GIR_RootConstrainSelectedInstOperands,
     /* 367544 */   // GIR_Coverage, 183,
     /* 367544 */   GIR_Done,
     /* 367545 */ // Label 7369: @367545
     /* 367545 */ GIM_Reject,
     /* 367546 */ // Label 7365: @367546
     /* 367546 */ GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(367572), // Rule ID 974 //
     /* 367551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367565 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 367565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 367570 */   GIR_RootConstrainSelectedInstOperands,
     /* 367571 */   // GIR_Coverage, 974,
     /* 367571 */   GIR_Done,
     /* 367572 */ // Label 7370: @367572
     /* 367572 */ GIM_Reject,
     /* 367573 */ // Label 7366: @367573
     /* 367573 */ GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(367599), // Rule ID 975 //
     /* 367578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367592 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 367592 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 367597 */   GIR_RootConstrainSelectedInstOperands,
     /* 367598 */   // GIR_Coverage, 975,
     /* 367598 */   GIR_Done,
     /* 367599 */ // Label 7371: @367599
     /* 367599 */ GIM_Reject,
     /* 367600 */ // Label 7367: @367600
     /* 367600 */ GIM_Reject,
     /* 367601 */ // Label 96: @367601
     /* 367601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7380*/ GIMT_Encode4(368091),
     /* 367612 */ /*GILLT_s16*//*Label 7372*/ GIMT_Encode4(367652),
     /* 367616 */ /*GILLT_s32*//*Label 7373*/ GIMT_Encode4(367683),
     /* 367620 */ /*GILLT_s64*//*Label 7374*/ GIMT_Encode4(367714), GIMT_Encode4(0),
     /* 367628 */ /*GILLT_v2s32*//*Label 7375*/ GIMT_Encode4(367745),
     /* 367632 */ /*GILLT_v2s64*//*Label 7376*/ GIMT_Encode4(367776),
     /* 367636 */ /*GILLT_v4s16*//*Label 7377*/ GIMT_Encode4(367807),
     /* 367640 */ /*GILLT_v4s32*//*Label 7378*/ GIMT_Encode4(367838), GIMT_Encode4(0),
     /* 367648 */ /*GILLT_v8s16*//*Label 7379*/ GIMT_Encode4(367869),
     /* 367652 */ // Label 7372: @367652
     /* 367652 */ GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(367682), // Rule ID 552 //
     /* 367657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 367660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 367663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 367671 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 367671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 367676 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367680 */   GIR_RootConstrainSelectedInstOperands,
     /* 367681 */   // GIR_Coverage, 552,
     /* 367681 */   GIR_Done,
     /* 367682 */ // Label 7381: @367682
     /* 367682 */ GIM_Reject,
     /* 367683 */ // Label 7373: @367683
     /* 367683 */ GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(367713), // Rule ID 554 //
     /* 367688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367702 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 367702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 367707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367711 */   GIR_RootConstrainSelectedInstOperands,
     /* 367712 */   // GIR_Coverage, 554,
     /* 367712 */   GIR_Done,
     /* 367713 */ // Label 7382: @367713
     /* 367713 */ GIM_Reject,
     /* 367714 */ // Label 7374: @367714
     /* 367714 */ GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(367744), // Rule ID 556 //
     /* 367719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 367722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367733 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 367733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 367738 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367742 */   GIR_RootConstrainSelectedInstOperands,
     /* 367743 */   // GIR_Coverage, 556,
     /* 367743 */   GIR_Done,
     /* 367744 */ // Label 7383: @367744
     /* 367744 */ GIM_Reject,
     /* 367745 */ // Label 7375: @367745
     /* 367745 */ GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(367775), // Rule ID 913 //
     /* 367750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367764 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 367764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 367769 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367773 */   GIR_RootConstrainSelectedInstOperands,
     /* 367774 */   // GIR_Coverage, 913,
     /* 367774 */   GIR_Done,
     /* 367775 */ // Label 7384: @367775
     /* 367775 */ GIM_Reject,
     /* 367776 */ // Label 7376: @367776
     /* 367776 */ GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(367806), // Rule ID 917 //
     /* 367781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367795 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 367795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 367800 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367804 */   GIR_RootConstrainSelectedInstOperands,
     /* 367805 */   // GIR_Coverage, 917,
     /* 367805 */   GIR_Done,
     /* 367806 */ // Label 7385: @367806
     /* 367806 */ GIM_Reject,
     /* 367807 */ // Label 7377: @367807
     /* 367807 */ GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(367837), // Rule ID 909 //
     /* 367812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367826 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 367826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 367831 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367835 */   GIR_RootConstrainSelectedInstOperands,
     /* 367836 */   // GIR_Coverage, 909,
     /* 367836 */   GIR_Done,
     /* 367837 */ // Label 7386: @367837
     /* 367837 */ GIM_Reject,
     /* 367838 */ // Label 7378: @367838
     /* 367838 */ GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(367868), // Rule ID 915 //
     /* 367843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367857 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 367857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 367862 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367866 */   GIR_RootConstrainSelectedInstOperands,
     /* 367867 */   // GIR_Coverage, 915,
     /* 367867 */   GIR_Done,
     /* 367868 */ // Label 7387: @367868
     /* 367868 */ GIM_Reject,
     /* 367869 */ // Label 7379: @367869
     /* 367869 */ GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(368090),
     /* 367874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367885 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(367904), // Rule ID 911 //
     /* 367890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 367893 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 367893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 367898 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 367902 */     GIR_RootConstrainSelectedInstOperands,
     /* 367903 */     // GIR_Coverage, 911,
     /* 367903 */     GIR_Done,
     /* 367904 */   // Label 7389: @367904
     /* 367904 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(368089), // Rule ID 6957 //
     /* 367909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 367912 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 367912 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 367915 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 367919 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367924 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 367928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 367930 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 367933 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 367937 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367942 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 367945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 367947 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 367950 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367954 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367959 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 367965 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367970 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367975 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 367978 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 367982 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367987 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 367990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 367992 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 367995 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 367999 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368004 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 368007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 368009 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 368012 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 368016 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368021 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 368024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 368026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368052 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 368079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 368087 */     GIR_RootConstrainSelectedInstOperands,
     /* 368088 */     // GIR_Coverage, 6957,
     /* 368088 */     GIR_EraseRootFromParent_Done,
     /* 368089 */   // Label 7390: @368089
     /* 368089 */   GIM_Reject,
     /* 368090 */ // Label 7388: @368090
     /* 368090 */ GIM_Reject,
     /* 368091 */ // Label 7380: @368091
     /* 368091 */ GIM_Reject,
     /* 368092 */ // Label 97: @368092
     /* 368092 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7399*/ GIMT_Encode4(368391),
     /* 368103 */ /*GILLT_s16*//*Label 7391*/ GIMT_Encode4(368143),
     /* 368107 */ /*GILLT_s32*//*Label 7392*/ GIMT_Encode4(368174),
     /* 368111 */ /*GILLT_s64*//*Label 7393*/ GIMT_Encode4(368205), GIMT_Encode4(0),
     /* 368119 */ /*GILLT_v2s32*//*Label 7394*/ GIMT_Encode4(368236),
     /* 368123 */ /*GILLT_v2s64*//*Label 7395*/ GIMT_Encode4(368267),
     /* 368127 */ /*GILLT_v4s16*//*Label 7396*/ GIMT_Encode4(368298),
     /* 368131 */ /*GILLT_v4s32*//*Label 7397*/ GIMT_Encode4(368329), GIMT_Encode4(0),
     /* 368139 */ /*GILLT_v8s16*//*Label 7398*/ GIMT_Encode4(368360),
     /* 368143 */ // Label 7391: @368143
     /* 368143 */ GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(368173), // Rule ID 570 //
     /* 368148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368162 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 368167 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368171 */   GIR_RootConstrainSelectedInstOperands,
     /* 368172 */   // GIR_Coverage, 570,
     /* 368172 */   GIR_Done,
     /* 368173 */ // Label 7400: @368173
     /* 368173 */ GIM_Reject,
     /* 368174 */ // Label 7392: @368174
     /* 368174 */ GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(368204), // Rule ID 572 //
     /* 368179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368193 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 368198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368202 */   GIR_RootConstrainSelectedInstOperands,
     /* 368203 */   // GIR_Coverage, 572,
     /* 368203 */   GIR_Done,
     /* 368204 */ // Label 7401: @368204
     /* 368204 */ GIM_Reject,
     /* 368205 */ // Label 7393: @368205
     /* 368205 */ GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(368235), // Rule ID 574 //
     /* 368210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368224 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 368224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 368229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368233 */   GIR_RootConstrainSelectedInstOperands,
     /* 368234 */   // GIR_Coverage, 574,
     /* 368234 */   GIR_Done,
     /* 368235 */ // Label 7402: @368235
     /* 368235 */ GIM_Reject,
     /* 368236 */ // Label 7394: @368236
     /* 368236 */ GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(368266), // Rule ID 960 //
     /* 368241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368255 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 368255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 368260 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368264 */   GIR_RootConstrainSelectedInstOperands,
     /* 368265 */   // GIR_Coverage, 960,
     /* 368265 */   GIR_Done,
     /* 368266 */ // Label 7403: @368266
     /* 368266 */ GIM_Reject,
     /* 368267 */ // Label 7395: @368267
     /* 368267 */ GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(368297), // Rule ID 964 //
     /* 368272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368286 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 368286 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 368291 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368295 */   GIR_RootConstrainSelectedInstOperands,
     /* 368296 */   // GIR_Coverage, 964,
     /* 368296 */   GIR_Done,
     /* 368297 */ // Label 7404: @368297
     /* 368297 */ GIM_Reject,
     /* 368298 */ // Label 7396: @368298
     /* 368298 */ GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(368328), // Rule ID 956 //
     /* 368303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368317 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 368317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 368322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368326 */   GIR_RootConstrainSelectedInstOperands,
     /* 368327 */   // GIR_Coverage, 956,
     /* 368327 */   GIR_Done,
     /* 368328 */ // Label 7405: @368328
     /* 368328 */ GIM_Reject,
     /* 368329 */ // Label 7397: @368329
     /* 368329 */ GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(368359), // Rule ID 962 //
     /* 368334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368348 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 368353 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368357 */   GIR_RootConstrainSelectedInstOperands,
     /* 368358 */   // GIR_Coverage, 962,
     /* 368358 */   GIR_Done,
     /* 368359 */ // Label 7406: @368359
     /* 368359 */ GIM_Reject,
     /* 368360 */ // Label 7398: @368360
     /* 368360 */ GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(368390), // Rule ID 958 //
     /* 368365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368379 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368379 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 368384 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368388 */   GIR_RootConstrainSelectedInstOperands,
     /* 368389 */   // GIR_Coverage, 958,
     /* 368389 */   GIR_Done,
     /* 368390 */ // Label 7407: @368390
     /* 368390 */ GIM_Reject,
     /* 368391 */ // Label 7399: @368391
     /* 368391 */ GIM_Reject,
     /* 368392 */ // Label 98: @368392
     /* 368392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7416*/ GIMT_Encode4(368882),
     /* 368403 */ /*GILLT_s16*//*Label 7408*/ GIMT_Encode4(368443),
     /* 368407 */ /*GILLT_s32*//*Label 7409*/ GIMT_Encode4(368474),
     /* 368411 */ /*GILLT_s64*//*Label 7410*/ GIMT_Encode4(368505), GIMT_Encode4(0),
     /* 368419 */ /*GILLT_v2s32*//*Label 7411*/ GIMT_Encode4(368536),
     /* 368423 */ /*GILLT_v2s64*//*Label 7412*/ GIMT_Encode4(368567),
     /* 368427 */ /*GILLT_v4s16*//*Label 7413*/ GIMT_Encode4(368598),
     /* 368431 */ /*GILLT_v4s32*//*Label 7414*/ GIMT_Encode4(368629), GIMT_Encode4(0),
     /* 368439 */ /*GILLT_v8s16*//*Label 7415*/ GIMT_Encode4(368660),
     /* 368443 */ // Label 7408: @368443
     /* 368443 */ GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(368473), // Rule ID 540 //
     /* 368448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368462 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368462 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 368467 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368471 */   GIR_RootConstrainSelectedInstOperands,
     /* 368472 */   // GIR_Coverage, 540,
     /* 368472 */   GIR_Done,
     /* 368473 */ // Label 7417: @368473
     /* 368473 */ GIM_Reject,
     /* 368474 */ // Label 7409: @368474
     /* 368474 */ GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(368504), // Rule ID 542 //
     /* 368479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368493 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 368498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368502 */   GIR_RootConstrainSelectedInstOperands,
     /* 368503 */   // GIR_Coverage, 542,
     /* 368503 */   GIR_Done,
     /* 368504 */ // Label 7418: @368504
     /* 368504 */ GIM_Reject,
     /* 368505 */ // Label 7410: @368505
     /* 368505 */ GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(368535), // Rule ID 544 //
     /* 368510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368524 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 368524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 368529 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368533 */   GIR_RootConstrainSelectedInstOperands,
     /* 368534 */   // GIR_Coverage, 544,
     /* 368534 */   GIR_Done,
     /* 368535 */ // Label 7419: @368535
     /* 368535 */ GIM_Reject,
     /* 368536 */ // Label 7411: @368536
     /* 368536 */ GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(368566), // Rule ID 893 //
     /* 368541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368555 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 368555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 368560 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368564 */   GIR_RootConstrainSelectedInstOperands,
     /* 368565 */   // GIR_Coverage, 893,
     /* 368565 */   GIR_Done,
     /* 368566 */ // Label 7420: @368566
     /* 368566 */ GIM_Reject,
     /* 368567 */ // Label 7412: @368567
     /* 368567 */ GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(368597), // Rule ID 897 //
     /* 368572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368586 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 368586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 368591 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368595 */   GIR_RootConstrainSelectedInstOperands,
     /* 368596 */   // GIR_Coverage, 897,
     /* 368596 */   GIR_Done,
     /* 368597 */ // Label 7421: @368597
     /* 368597 */ GIM_Reject,
     /* 368598 */ // Label 7413: @368598
     /* 368598 */ GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(368628), // Rule ID 889 //
     /* 368603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368617 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 368617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 368622 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368626 */   GIR_RootConstrainSelectedInstOperands,
     /* 368627 */   // GIR_Coverage, 889,
     /* 368627 */   GIR_Done,
     /* 368628 */ // Label 7422: @368628
     /* 368628 */ GIM_Reject,
     /* 368629 */ // Label 7414: @368629
     /* 368629 */ GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(368659), // Rule ID 895 //
     /* 368634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368648 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 368653 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368657 */   GIR_RootConstrainSelectedInstOperands,
     /* 368658 */   // GIR_Coverage, 895,
     /* 368658 */   GIR_Done,
     /* 368659 */ // Label 7423: @368659
     /* 368659 */ GIM_Reject,
     /* 368660 */ // Label 7415: @368660
     /* 368660 */ GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(368881),
     /* 368665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368676 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(368695), // Rule ID 891 //
     /* 368681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368684 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 368689 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368693 */     GIR_RootConstrainSelectedInstOperands,
     /* 368694 */     // GIR_Coverage, 891,
     /* 368694 */     GIR_Done,
     /* 368695 */   // Label 7425: @368695
     /* 368695 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(368880), // Rule ID 6959 //
     /* 368700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 368703 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 368703 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 368706 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 368710 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368715 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 368719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 368721 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 368724 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 368728 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368733 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 368736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 368738 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 368741 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368745 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368750 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368756 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368761 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368766 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 368769 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 368773 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368778 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 368781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 368783 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 368786 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 368790 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368795 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 368798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 368800 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 368803 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 368807 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368812 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 368815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 368817 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368820 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368824 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368843 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 368870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 368878 */     GIR_RootConstrainSelectedInstOperands,
     /* 368879 */     // GIR_Coverage, 6959,
     /* 368879 */     GIR_EraseRootFromParent_Done,
     /* 368880 */   // Label 7426: @368880
     /* 368880 */   GIM_Reject,
     /* 368881 */ // Label 7424: @368881
     /* 368881 */ GIM_Reject,
     /* 368882 */ // Label 7416: @368882
     /* 368882 */ GIM_Reject,
     /* 368883 */ // Label 99: @368883
     /* 368883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7435*/ GIMT_Encode4(369373),
     /* 368894 */ /*GILLT_s16*//*Label 7427*/ GIMT_Encode4(368934),
     /* 368898 */ /*GILLT_s32*//*Label 7428*/ GIMT_Encode4(368965),
     /* 368902 */ /*GILLT_s64*//*Label 7429*/ GIMT_Encode4(368996), GIMT_Encode4(0),
     /* 368910 */ /*GILLT_v2s32*//*Label 7430*/ GIMT_Encode4(369027),
     /* 368914 */ /*GILLT_v2s64*//*Label 7431*/ GIMT_Encode4(369058),
     /* 368918 */ /*GILLT_v4s16*//*Label 7432*/ GIMT_Encode4(369089),
     /* 368922 */ /*GILLT_v4s32*//*Label 7433*/ GIMT_Encode4(369120), GIMT_Encode4(0),
     /* 368930 */ /*GILLT_v8s16*//*Label 7434*/ GIMT_Encode4(369151),
     /* 368934 */ // Label 7427: @368934
     /* 368934 */ GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(368964), // Rule ID 558 //
     /* 368939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368953 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 368958 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368962 */   GIR_RootConstrainSelectedInstOperands,
     /* 368963 */   // GIR_Coverage, 558,
     /* 368963 */   GIR_Done,
     /* 368964 */ // Label 7436: @368964
     /* 368964 */ GIM_Reject,
     /* 368965 */ // Label 7428: @368965
     /* 368965 */ GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(368995), // Rule ID 560 //
     /* 368970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368984 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 368989 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368993 */   GIR_RootConstrainSelectedInstOperands,
     /* 368994 */   // GIR_Coverage, 560,
     /* 368994 */   GIR_Done,
     /* 368995 */ // Label 7437: @368995
     /* 368995 */ GIM_Reject,
     /* 368996 */ // Label 7429: @368996
     /* 368996 */ GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(369026), // Rule ID 562 //
     /* 369001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369015 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 369020 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369024 */   GIR_RootConstrainSelectedInstOperands,
     /* 369025 */   // GIR_Coverage, 562,
     /* 369025 */   GIR_Done,
     /* 369026 */ // Label 7438: @369026
     /* 369026 */ GIM_Reject,
     /* 369027 */ // Label 7430: @369027
     /* 369027 */ GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(369057), // Rule ID 923 //
     /* 369032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 369038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369046 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 369046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 369051 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369055 */   GIR_RootConstrainSelectedInstOperands,
     /* 369056 */   // GIR_Coverage, 923,
     /* 369056 */   GIR_Done,
     /* 369057 */ // Label 7439: @369057
     /* 369057 */ GIM_Reject,
     /* 369058 */ // Label 7431: @369058
     /* 369058 */ GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(369088), // Rule ID 927 //
     /* 369063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369077 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 369077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 369082 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369086 */   GIR_RootConstrainSelectedInstOperands,
     /* 369087 */   // GIR_Coverage, 927,
     /* 369087 */   GIR_Done,
     /* 369088 */ // Label 7440: @369088
     /* 369088 */ GIM_Reject,
     /* 369089 */ // Label 7432: @369089
     /* 369089 */ GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(369119), // Rule ID 919 //
     /* 369094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369108 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 369108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 369113 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369117 */   GIR_RootConstrainSelectedInstOperands,
     /* 369118 */   // GIR_Coverage, 919,
     /* 369118 */   GIR_Done,
     /* 369119 */ // Label 7441: @369119
     /* 369119 */ GIM_Reject,
     /* 369120 */ // Label 7433: @369120
     /* 369120 */ GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(369150), // Rule ID 925 //
     /* 369125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369139 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 369139 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 369144 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369148 */   GIR_RootConstrainSelectedInstOperands,
     /* 369149 */   // GIR_Coverage, 925,
     /* 369149 */   GIR_Done,
     /* 369150 */ // Label 7442: @369150
     /* 369150 */ GIM_Reject,
     /* 369151 */ // Label 7434: @369151
     /* 369151 */ GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(369372),
     /* 369156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369167 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(369186), // Rule ID 921 //
     /* 369172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369175 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 369175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 369180 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369184 */     GIR_RootConstrainSelectedInstOperands,
     /* 369185 */     // GIR_Coverage, 921,
     /* 369185 */     GIR_Done,
     /* 369186 */   // Label 7444: @369186
     /* 369186 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(369371), // Rule ID 6967 //
     /* 369191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 369194 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 369194 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 369197 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 369201 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369206 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 369212 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 369215 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 369219 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369224 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 369227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 369229 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 369232 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369236 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369241 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369247 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369252 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369257 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 369260 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 369264 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369269 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 369272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369274 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 369277 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 369281 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369286 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 369291 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 369294 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 369298 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369303 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 369306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369308 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369311 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369315 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369334 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369337 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369369 */     GIR_RootConstrainSelectedInstOperands,
     /* 369370 */     // GIR_Coverage, 6967,
     /* 369370 */     GIR_EraseRootFromParent_Done,
     /* 369371 */   // Label 7445: @369371
     /* 369371 */   GIM_Reject,
     /* 369372 */ // Label 7443: @369372
     /* 369372 */ GIM_Reject,
     /* 369373 */ // Label 7435: @369373
     /* 369373 */ GIM_Reject,
     /* 369374 */ // Label 100: @369374
     /* 369374 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7454*/ GIMT_Encode4(369864),
     /* 369385 */ /*GILLT_s16*//*Label 7446*/ GIMT_Encode4(369425),
     /* 369389 */ /*GILLT_s32*//*Label 7447*/ GIMT_Encode4(369456),
     /* 369393 */ /*GILLT_s64*//*Label 7448*/ GIMT_Encode4(369487), GIMT_Encode4(0),
     /* 369401 */ /*GILLT_v2s32*//*Label 7449*/ GIMT_Encode4(369518),
     /* 369405 */ /*GILLT_v2s64*//*Label 7450*/ GIMT_Encode4(369549),
     /* 369409 */ /*GILLT_v4s16*//*Label 7451*/ GIMT_Encode4(369580),
     /* 369413 */ /*GILLT_v4s32*//*Label 7452*/ GIMT_Encode4(369611), GIMT_Encode4(0),
     /* 369421 */ /*GILLT_v8s16*//*Label 7453*/ GIMT_Encode4(369642),
     /* 369425 */ // Label 7446: @369425
     /* 369425 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(369455), // Rule ID 534 //
     /* 369430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369444 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 369444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 369449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369453 */   GIR_RootConstrainSelectedInstOperands,
     /* 369454 */   // GIR_Coverage, 534,
     /* 369454 */   GIR_Done,
     /* 369455 */ // Label 7455: @369455
     /* 369455 */ GIM_Reject,
     /* 369456 */ // Label 7447: @369456
     /* 369456 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(369486), // Rule ID 536 //
     /* 369461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369475 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 369475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 369480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369484 */   GIR_RootConstrainSelectedInstOperands,
     /* 369485 */   // GIR_Coverage, 536,
     /* 369485 */   GIR_Done,
     /* 369486 */ // Label 7456: @369486
     /* 369486 */ GIM_Reject,
     /* 369487 */ // Label 7448: @369487
     /* 369487 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(369517), // Rule ID 538 //
     /* 369492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369506 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 369511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369515 */   GIR_RootConstrainSelectedInstOperands,
     /* 369516 */   // GIR_Coverage, 538,
     /* 369516 */   GIR_Done,
     /* 369517 */ // Label 7457: @369517
     /* 369517 */ GIM_Reject,
     /* 369518 */ // Label 7449: @369518
     /* 369518 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(369548), // Rule ID 883 //
     /* 369523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 369529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369537 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 369537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 369542 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369546 */   GIR_RootConstrainSelectedInstOperands,
     /* 369547 */   // GIR_Coverage, 883,
     /* 369547 */   GIR_Done,
     /* 369548 */ // Label 7458: @369548
     /* 369548 */ GIM_Reject,
     /* 369549 */ // Label 7450: @369549
     /* 369549 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(369579), // Rule ID 887 //
     /* 369554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369568 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 369568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 369573 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369577 */   GIR_RootConstrainSelectedInstOperands,
     /* 369578 */   // GIR_Coverage, 887,
     /* 369578 */   GIR_Done,
     /* 369579 */ // Label 7459: @369579
     /* 369579 */ GIM_Reject,
     /* 369580 */ // Label 7451: @369580
     /* 369580 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(369610), // Rule ID 879 //
     /* 369585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369599 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 369599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 369604 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369608 */   GIR_RootConstrainSelectedInstOperands,
     /* 369609 */   // GIR_Coverage, 879,
     /* 369609 */   GIR_Done,
     /* 369610 */ // Label 7460: @369610
     /* 369610 */ GIM_Reject,
     /* 369611 */ // Label 7452: @369611
     /* 369611 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(369641), // Rule ID 885 //
     /* 369616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369630 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 369630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 369635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369639 */   GIR_RootConstrainSelectedInstOperands,
     /* 369640 */   // GIR_Coverage, 885,
     /* 369640 */   GIR_Done,
     /* 369641 */ // Label 7461: @369641
     /* 369641 */ GIM_Reject,
     /* 369642 */ // Label 7453: @369642
     /* 369642 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(369863),
     /* 369647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369658 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(369677), // Rule ID 881 //
     /* 369663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369666 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 369666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 369671 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369675 */     GIR_RootConstrainSelectedInstOperands,
     /* 369676 */     // GIR_Coverage, 881,
     /* 369676 */     GIR_Done,
     /* 369677 */   // Label 7463: @369677
     /* 369677 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(369862), // Rule ID 6961 //
     /* 369682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 369685 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 369685 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 369688 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 369692 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369697 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 369703 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 369706 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 369710 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369715 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 369718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 369720 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 369723 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369727 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369732 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369738 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369743 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369748 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 369751 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 369755 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369760 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 369763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369765 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 369768 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 369772 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369777 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 369782 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 369785 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 369789 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369794 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 369797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369831 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369860 */     GIR_RootConstrainSelectedInstOperands,
     /* 369861 */     // GIR_Coverage, 6961,
     /* 369861 */     GIR_EraseRootFromParent_Done,
     /* 369862 */   // Label 7464: @369862
     /* 369862 */   GIM_Reject,
     /* 369863 */ // Label 7462: @369863
     /* 369863 */ GIM_Reject,
     /* 369864 */ // Label 7454: @369864
     /* 369864 */ GIM_Reject,
     /* 369865 */ // Label 101: @369865
     /* 369865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7473*/ GIMT_Encode4(370990),
     /* 369876 */ /*GILLT_s16*//*Label 7465*/ GIMT_Encode4(369916),
     /* 369880 */ /*GILLT_s32*//*Label 7466*/ GIMT_Encode4(370142),
     /* 369884 */ /*GILLT_s64*//*Label 7467*/ GIMT_Encode4(370368), GIMT_Encode4(0),
     /* 369892 */ /*GILLT_v2s32*//*Label 7468*/ GIMT_Encode4(370540),
     /* 369896 */ /*GILLT_v2s64*//*Label 7469*/ GIMT_Encode4(370578),
     /* 369900 */ /*GILLT_v4s16*//*Label 7470*/ GIMT_Encode4(370616),
     /* 369904 */ /*GILLT_v4s32*//*Label 7471*/ GIMT_Encode4(370654), GIMT_Encode4(0),
     /* 369912 */ /*GILLT_v8s16*//*Label 7472*/ GIMT_Encode4(370692),
     /* 369916 */ // Label 7465: @369916
     /* 369916 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(370141),
     /* 369921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 369927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369931 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(370022), // Rule ID 6881 //
     /* 369936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369957 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 369961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369969 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 369973 */     // MIs[2] Rn
     /* 369973 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 369978 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 369982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369984 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 369984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 369987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369996 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 370015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370020 */     GIR_RootConstrainSelectedInstOperands,
     /* 370021 */     // GIR_Coverage, 6881,
     /* 370021 */     GIR_EraseRootFromParent_Done,
     /* 370022 */   // Label 7475: @370022
     /* 370022 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(370113), // Rule ID 13856 //
     /* 370027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 370052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370064 */     // MIs[2] Rn
     /* 370064 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370069 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370075 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 370075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370087 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 370106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370111 */     GIR_RootConstrainSelectedInstOperands,
     /* 370112 */     // GIR_Coverage, 13856,
     /* 370112 */     GIR_EraseRootFromParent_Done,
     /* 370113 */   // Label 7476: @370113
     /* 370113 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(370140), // Rule ID 583 //
     /* 370118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 370121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370129 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 370129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 370134 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370138 */     GIR_RootConstrainSelectedInstOperands,
     /* 370139 */     // GIR_Coverage, 583,
     /* 370139 */     GIR_Done,
     /* 370140 */   // Label 7477: @370140
     /* 370140 */   GIM_Reject,
     /* 370141 */ // Label 7474: @370141
     /* 370141 */ GIM_Reject,
     /* 370142 */ // Label 7466: @370142
     /* 370142 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(370367),
     /* 370147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370157 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(370248), // Rule ID 6879 //
     /* 370162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370183 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370199 */     // MIs[2] Rn
     /* 370199 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370204 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370210 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 370210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370222 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 370241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370246 */     GIR_RootConstrainSelectedInstOperands,
     /* 370247 */     // GIR_Coverage, 6879,
     /* 370247 */     GIR_EraseRootFromParent_Done,
     /* 370248 */   // Label 7479: @370248
     /* 370248 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(370339), // Rule ID 13854 //
     /* 370253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370274 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 370278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370290 */     // MIs[2] Rn
     /* 370290 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370295 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370301 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 370301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370313 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 370332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370337 */     GIR_RootConstrainSelectedInstOperands,
     /* 370338 */     // GIR_Coverage, 13854,
     /* 370338 */     GIR_EraseRootFromParent_Done,
     /* 370339 */   // Label 7480: @370339
     /* 370339 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(370366), // Rule ID 585 //
     /* 370344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370355 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 370355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 370360 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370364 */     GIR_RootConstrainSelectedInstOperands,
     /* 370365 */     // GIR_Coverage, 585,
     /* 370365 */     GIR_Done,
     /* 370366 */   // Label 7481: @370366
     /* 370366 */   GIM_Reject,
     /* 370367 */ // Label 7478: @370367
     /* 370367 */ GIM_Reject,
     /* 370368 */ // Label 7467: @370368
     /* 370368 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(370539),
     /* 370373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370383 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(370447), // Rule ID 6877 //
     /* 370388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370409 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370425 */     // MIs[2] Rn
     /* 370425 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370430 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370436 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 370436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 370439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370445 */     GIR_RootConstrainSelectedInstOperands,
     /* 370446 */     // GIR_Coverage, 6877,
     /* 370446 */     GIR_EraseRootFromParent_Done,
     /* 370447 */   // Label 7483: @370447
     /* 370447 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(370511), // Rule ID 13852 //
     /* 370452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370473 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 370477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370489 */     // MIs[2] Rn
     /* 370489 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370500 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 370500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 370503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370509 */     GIR_RootConstrainSelectedInstOperands,
     /* 370510 */     // GIR_Coverage, 13852,
     /* 370510 */     GIR_EraseRootFromParent_Done,
     /* 370511 */   // Label 7484: @370511
     /* 370511 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(370538), // Rule ID 587 //
     /* 370516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370527 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 370527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 370532 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370536 */     GIR_RootConstrainSelectedInstOperands,
     /* 370537 */     // GIR_Coverage, 587,
     /* 370537 */     GIR_Done,
     /* 370538 */   // Label 7485: @370538
     /* 370538 */   GIM_Reject,
     /* 370539 */ // Label 7482: @370539
     /* 370539 */ GIM_Reject,
     /* 370540 */ // Label 7468: @370540
     /* 370540 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(370577), // Rule ID 1202 //
     /* 370545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 370554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370566 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 370566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 370571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370575 */   GIR_RootConstrainSelectedInstOperands,
     /* 370576 */   // GIR_Coverage, 1202,
     /* 370576 */   GIR_Done,
     /* 370577 */ // Label 7486: @370577
     /* 370577 */ GIM_Reject,
     /* 370578 */ // Label 7469: @370578
     /* 370578 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(370615), // Rule ID 1206 //
     /* 370583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 370592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370604 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 370604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 370609 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370613 */   GIR_RootConstrainSelectedInstOperands,
     /* 370614 */   // GIR_Coverage, 1206,
     /* 370614 */   GIR_Done,
     /* 370615 */ // Label 7487: @370615
     /* 370615 */ GIM_Reject,
     /* 370616 */ // Label 7470: @370616
     /* 370616 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(370653), // Rule ID 1198 //
     /* 370621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 370630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370642 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 370642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 370647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370651 */   GIR_RootConstrainSelectedInstOperands,
     /* 370652 */   // GIR_Coverage, 1198,
     /* 370652 */   GIR_Done,
     /* 370653 */ // Label 7488: @370653
     /* 370653 */ GIM_Reject,
     /* 370654 */ // Label 7471: @370654
     /* 370654 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(370691), // Rule ID 1204 //
     /* 370659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 370668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370680 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 370680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 370685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370689 */   GIR_RootConstrainSelectedInstOperands,
     /* 370690 */   // GIR_Coverage, 1204,
     /* 370690 */   GIR_Done,
     /* 370691 */ // Label 7489: @370691
     /* 370691 */ GIM_Reject,
     /* 370692 */ // Label 7472: @370692
     /* 370692 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(370989),
     /* 370697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 370703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370715 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(370734), // Rule ID 1200 //
     /* 370720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370723 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 370723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 370728 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370732 */     GIR_RootConstrainSelectedInstOperands,
     /* 370733 */     // GIR_Coverage, 1200,
     /* 370733 */     GIR_Done,
     /* 370734 */   // Label 7491: @370734
     /* 370734 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(370988), // Rule ID 6970 //
     /* 370739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 370742 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 370742 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 370745 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370749 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370754 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 370758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 370760 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 370763 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370767 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370772 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 370778 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 370781 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 370785 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370790 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 370793 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 370796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 370798 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 370801 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370805 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370810 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 370816 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370821 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370826 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 370829 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370833 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370838 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 370841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 370843 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 370846 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370850 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370855 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370861 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370866 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370871 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 370874 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370878 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370883 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 370886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370888 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 370891 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 370895 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370900 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370903 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 370906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 370908 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 370911 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 370915 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370920 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 370923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370951 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370957 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 370960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 370978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 370986 */     GIR_RootConstrainSelectedInstOperands,
     /* 370987 */     // GIR_Coverage, 6970,
     /* 370987 */     GIR_EraseRootFromParent_Done,
     /* 370988 */   // Label 7492: @370988
     /* 370988 */   GIM_Reject,
     /* 370989 */ // Label 7490: @370989
     /* 370989 */ GIM_Reject,
     /* 370990 */ // Label 7473: @370990
     /* 370990 */ GIM_Reject,
     /* 370991 */ // Label 102: @370991
     /* 370991 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7501*/ GIMT_Encode4(371606),
     /* 371002 */ /*GILLT_s16*//*Label 7493*/ GIMT_Encode4(371042),
     /* 371006 */ /*GILLT_s32*//*Label 7494*/ GIMT_Encode4(371080),
     /* 371010 */ /*GILLT_s64*//*Label 7495*/ GIMT_Encode4(371118), GIMT_Encode4(0),
     /* 371018 */ /*GILLT_v2s32*//*Label 7496*/ GIMT_Encode4(371156),
     /* 371022 */ /*GILLT_v2s64*//*Label 7497*/ GIMT_Encode4(371194),
     /* 371026 */ /*GILLT_v4s16*//*Label 7498*/ GIMT_Encode4(371232),
     /* 371030 */ /*GILLT_v4s32*//*Label 7499*/ GIMT_Encode4(371270), GIMT_Encode4(0),
     /* 371038 */ /*GILLT_v8s16*//*Label 7500*/ GIMT_Encode4(371308),
     /* 371042 */ // Label 7493: @371042
     /* 371042 */ GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(371079), // Rule ID 631 //
     /* 371047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 371053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371068 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 371068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 371073 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371077 */   GIR_RootConstrainSelectedInstOperands,
     /* 371078 */   // GIR_Coverage, 631,
     /* 371078 */   GIR_Done,
     /* 371079 */ // Label 7502: @371079
     /* 371079 */ GIM_Reject,
     /* 371080 */ // Label 7494: @371080
     /* 371080 */ GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(371117), // Rule ID 633 //
     /* 371085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371106 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 371106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 371111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371115 */   GIR_RootConstrainSelectedInstOperands,
     /* 371116 */   // GIR_Coverage, 633,
     /* 371116 */   GIR_Done,
     /* 371117 */ // Label 7503: @371117
     /* 371117 */ GIM_Reject,
     /* 371118 */ // Label 7495: @371118
     /* 371118 */ GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(371155), // Rule ID 635 //
     /* 371123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 371132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371144 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 371144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 371149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371153 */   GIR_RootConstrainSelectedInstOperands,
     /* 371154 */   // GIR_Coverage, 635,
     /* 371154 */   GIR_Done,
     /* 371155 */ // Label 7504: @371155
     /* 371155 */ GIM_Reject,
     /* 371156 */ // Label 7496: @371156
     /* 371156 */ GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(371193), // Rule ID 1342 //
     /* 371161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 371170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371182 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 371182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 371187 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371191 */   GIR_RootConstrainSelectedInstOperands,
     /* 371192 */   // GIR_Coverage, 1342,
     /* 371192 */   GIR_Done,
     /* 371193 */ // Label 7505: @371193
     /* 371193 */ GIM_Reject,
     /* 371194 */ // Label 7497: @371194
     /* 371194 */ GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(371231), // Rule ID 1346 //
     /* 371199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 371208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371220 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 371220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 371225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371229 */   GIR_RootConstrainSelectedInstOperands,
     /* 371230 */   // GIR_Coverage, 1346,
     /* 371230 */   GIR_Done,
     /* 371231 */ // Label 7506: @371231
     /* 371231 */ GIM_Reject,
     /* 371232 */ // Label 7498: @371232
     /* 371232 */ GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(371269), // Rule ID 1338 //
     /* 371237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 371246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371258 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 371258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 371263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371267 */   GIR_RootConstrainSelectedInstOperands,
     /* 371268 */   // GIR_Coverage, 1338,
     /* 371268 */   GIR_Done,
     /* 371269 */ // Label 7507: @371269
     /* 371269 */ GIM_Reject,
     /* 371270 */ // Label 7499: @371270
     /* 371270 */ GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(371307), // Rule ID 1344 //
     /* 371275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 371284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371296 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 371296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 371301 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371305 */   GIR_RootConstrainSelectedInstOperands,
     /* 371306 */   // GIR_Coverage, 1344,
     /* 371306 */   GIR_Done,
     /* 371307 */ // Label 7508: @371307
     /* 371307 */ GIM_Reject,
     /* 371308 */ // Label 7500: @371308
     /* 371308 */ GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(371605),
     /* 371313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 371319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371331 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(371350), // Rule ID 1340 //
     /* 371336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371339 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 371339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 371344 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371348 */     GIR_RootConstrainSelectedInstOperands,
     /* 371349 */     // GIR_Coverage, 1340,
     /* 371349 */     GIR_Done,
     /* 371350 */   // Label 7510: @371350
     /* 371350 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(371604), // Rule ID 6976 //
     /* 371355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371358 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 371358 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 371361 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371365 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371370 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 371376 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 371379 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371383 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371388 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 371394 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 371397 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 371401 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371406 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 371409 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 371412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 371414 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 371417 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371421 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371426 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371432 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371437 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371442 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 371445 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371449 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371454 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 371457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 371459 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 371462 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371466 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371471 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371482 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371487 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 371490 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371494 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371499 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 371502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371504 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 371507 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 371511 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371516 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371519 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 371522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 371524 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 371527 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 371531 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371536 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 371539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371541 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371544 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371548 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371567 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371570 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 371576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 371594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 371602 */     GIR_RootConstrainSelectedInstOperands,
     /* 371603 */     // GIR_Coverage, 6976,
     /* 371603 */     GIR_EraseRootFromParent_Done,
     /* 371604 */   // Label 7511: @371604
     /* 371604 */   GIM_Reject,
     /* 371605 */ // Label 7509: @371605
     /* 371605 */ GIM_Reject,
     /* 371606 */ // Label 7501: @371606
     /* 371606 */ GIM_Reject,
     /* 371607 */ // Label 103: @371607
     /* 371607 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7520*/ GIMT_Encode4(375328),
     /* 371618 */ /*GILLT_s16*//*Label 7512*/ GIMT_Encode4(371658),
     /* 371622 */ /*GILLT_s32*//*Label 7513*/ GIMT_Encode4(372212),
     /* 371626 */ /*GILLT_s64*//*Label 7514*/ GIMT_Encode4(372760), GIMT_Encode4(0),
     /* 371634 */ /*GILLT_v2s32*//*Label 7515*/ GIMT_Encode4(373308),
     /* 371638 */ /*GILLT_v2s64*//*Label 7516*/ GIMT_Encode4(373838),
     /* 371642 */ /*GILLT_v4s16*//*Label 7517*/ GIMT_Encode4(374196),
     /* 371646 */ /*GILLT_v4s32*//*Label 7518*/ GIMT_Encode4(374538), GIMT_Encode4(0),
     /* 371654 */ /*GILLT_v8s16*//*Label 7519*/ GIMT_Encode4(374896),
     /* 371658 */ // Label 7512: @371658
     /* 371658 */ GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(372211),
     /* 371663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 371666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371673 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(371786), // Rule ID 6211 //
     /* 371678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 371731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371739 */     // MIs[3] Operand 1
     /* 371739 */     // No operand predicates
     /* 371739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371741 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 371741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371753 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 371759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 371772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 371781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 371784 */     GIR_RootConstrainSelectedInstOperands,
     /* 371785 */     // GIR_Coverage, 6211,
     /* 371785 */     GIR_EraseRootFromParent_Done,
     /* 371786 */   // Label 7522: @371786
     /* 371786 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(371899), // Rule ID 13833 //
     /* 371791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 371819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371823 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 371827 */     // MIs[2] Operand 1
     /* 371827 */     // No operand predicates
     /* 371827 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 371831 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371835 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371839 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 371843 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371848 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 371852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 371854 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 371854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371866 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 371872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 371885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 371894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 371897 */     GIR_RootConstrainSelectedInstOperands,
     /* 371898 */     // GIR_Coverage, 13833,
     /* 371898 */     GIR_EraseRootFromParent_Done,
     /* 371899 */   // Label 7523: @371899
     /* 371899 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(371978), // Rule ID 13770 //
     /* 371904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371928 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 371932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 371938 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 371938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371950 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 371956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 371969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 371973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371976 */     GIR_RootConstrainSelectedInstOperands,
     /* 371977 */     // GIR_Coverage, 13770,
     /* 371977 */     GIR_EraseRootFromParent_Done,
     /* 371978 */   // Label 7524: @371978
     /* 371978 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(372057), // Rule ID 4790 //
     /* 371983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 371994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372017 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 372017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372029 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 372035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 372048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372055 */     GIR_RootConstrainSelectedInstOperands,
     /* 372056 */     // GIR_Coverage, 4790,
     /* 372056 */     GIR_EraseRootFromParent_Done,
     /* 372057 */   // Label 7525: @372057
     /* 372057 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(372120), // Rule ID 13385 //
     /* 372062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372098 */     // MIs[2] Operand 1
     /* 372098 */     // No operand predicates
     /* 372098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372104 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372118 */     GIR_RootConstrainSelectedInstOperands,
     /* 372119 */     // GIR_Coverage, 13385,
     /* 372119 */     GIR_EraseRootFromParent_Done,
     /* 372120 */   // Label 7526: @372120
     /* 372120 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(372183), // Rule ID 2011 //
     /* 372125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372165 */     // MIs[2] Operand 1
     /* 372165 */     // No operand predicates
     /* 372165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372167 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372181 */     GIR_RootConstrainSelectedInstOperands,
     /* 372182 */     // GIR_Coverage, 2011,
     /* 372182 */     GIR_EraseRootFromParent_Done,
     /* 372183 */   // Label 7527: @372183
     /* 372183 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(372210), // Rule ID 619 //
     /* 372188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372199 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 372199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 372204 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372208 */     GIR_RootConstrainSelectedInstOperands,
     /* 372209 */     // GIR_Coverage, 619,
     /* 372209 */     GIR_Done,
     /* 372210 */   // Label 7528: @372210
     /* 372210 */   GIM_Reject,
     /* 372211 */ // Label 7521: @372211
     /* 372211 */ GIM_Reject,
     /* 372212 */ // Label 7513: @372212
     /* 372212 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(372759),
     /* 372217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372227 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(372340), // Rule ID 6213 //
     /* 372232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372256 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372289 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372293 */     // MIs[3] Operand 1
     /* 372293 */     // No operand predicates
     /* 372293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372295 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372307 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 372313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372338 */     GIR_RootConstrainSelectedInstOperands,
     /* 372339 */     // GIR_Coverage, 6213,
     /* 372339 */     GIR_EraseRootFromParent_Done,
     /* 372340 */   // Label 7530: @372340
     /* 372340 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(372453), // Rule ID 13835 //
     /* 372345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372381 */     // MIs[2] Operand 1
     /* 372381 */     // No operand predicates
     /* 372381 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372385 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372389 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372393 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372397 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372402 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372408 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372420 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 372426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372451 */     GIR_RootConstrainSelectedInstOperands,
     /* 372452 */     // GIR_Coverage, 13835,
     /* 372452 */     GIR_EraseRootFromParent_Done,
     /* 372453 */   // Label 7531: @372453
     /* 372453 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(372529), // Rule ID 13772 //
     /* 372458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372489 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 372489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372501 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 372507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 372520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372527 */     GIR_RootConstrainSelectedInstOperands,
     /* 372528 */     // GIR_Coverage, 13772,
     /* 372528 */     GIR_EraseRootFromParent_Done,
     /* 372529 */   // Label 7532: @372529
     /* 372529 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(372605), // Rule ID 4792 //
     /* 372534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372559 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372565 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 372565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372577 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 372583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 372596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372603 */     GIR_RootConstrainSelectedInstOperands,
     /* 372604 */     // GIR_Coverage, 4792,
     /* 372604 */     GIR_EraseRootFromParent_Done,
     /* 372605 */   // Label 7533: @372605
     /* 372605 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(372668), // Rule ID 13387 //
     /* 372610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372646 */     // MIs[2] Operand 1
     /* 372646 */     // No operand predicates
     /* 372646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372652 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372666 */     GIR_RootConstrainSelectedInstOperands,
     /* 372667 */     // GIR_Coverage, 13387,
     /* 372667 */     GIR_EraseRootFromParent_Done,
     /* 372668 */   // Label 7534: @372668
     /* 372668 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(372731), // Rule ID 2013 //
     /* 372673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372709 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372713 */     // MIs[2] Operand 1
     /* 372713 */     // No operand predicates
     /* 372713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372715 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372729 */     GIR_RootConstrainSelectedInstOperands,
     /* 372730 */     // GIR_Coverage, 2013,
     /* 372730 */     GIR_EraseRootFromParent_Done,
     /* 372731 */   // Label 7535: @372731
     /* 372731 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(372758), // Rule ID 621 //
     /* 372736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 372739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372747 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 372747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 372752 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372756 */     GIR_RootConstrainSelectedInstOperands,
     /* 372757 */     // GIR_Coverage, 621,
     /* 372757 */     GIR_Done,
     /* 372758 */   // Label 7536: @372758
     /* 372758 */   GIM_Reject,
     /* 372759 */ // Label 7529: @372759
     /* 372759 */ GIM_Reject,
     /* 372760 */ // Label 7514: @372760
     /* 372760 */ GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(373307),
     /* 372765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 372768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 372771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372775 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(372888), // Rule ID 6215 //
     /* 372780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372841 */     // MIs[3] Operand 1
     /* 372841 */     // No operand predicates
     /* 372841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372843 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372855 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 372874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372886 */     GIR_RootConstrainSelectedInstOperands,
     /* 372887 */     // GIR_Coverage, 6215,
     /* 372887 */     GIR_EraseRootFromParent_Done,
     /* 372888 */   // Label 7538: @372888
     /* 372888 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(373001), // Rule ID 13837 //
     /* 372893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 372929 */     // MIs[2] Operand 1
     /* 372929 */     // No operand predicates
     /* 372929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 372941 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372945 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372950 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372956 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 372956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 372959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372968 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 372987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372999 */     GIR_RootConstrainSelectedInstOperands,
     /* 373000 */     // GIR_Coverage, 13837,
     /* 373000 */     GIR_EraseRootFromParent_Done,
     /* 373001 */   // Label 7539: @373001
     /* 373001 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(373077), // Rule ID 13774 //
     /* 373006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373027 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373037 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 373037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373049 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 373068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373075 */     GIR_RootConstrainSelectedInstOperands,
     /* 373076 */     // GIR_Coverage, 13774,
     /* 373076 */     GIR_EraseRootFromParent_Done,
     /* 373077 */   // Label 7540: @373077
     /* 373077 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(373153), // Rule ID 4794 //
     /* 373082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373107 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373113 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 373113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373125 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 373144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373151 */     GIR_RootConstrainSelectedInstOperands,
     /* 373152 */     // GIR_Coverage, 4794,
     /* 373152 */     GIR_EraseRootFromParent_Done,
     /* 373153 */   // Label 7541: @373153
     /* 373153 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(373216), // Rule ID 13389 //
     /* 373158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373194 */     // MIs[2] Operand 1
     /* 373194 */     // No operand predicates
     /* 373194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373200 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373214 */     GIR_RootConstrainSelectedInstOperands,
     /* 373215 */     // GIR_Coverage, 13389,
     /* 373215 */     GIR_EraseRootFromParent_Done,
     /* 373216 */   // Label 7542: @373216
     /* 373216 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(373279), // Rule ID 2015 //
     /* 373221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373261 */     // MIs[2] Operand 1
     /* 373261 */     // No operand predicates
     /* 373261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373263 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373277 */     GIR_RootConstrainSelectedInstOperands,
     /* 373278 */     // GIR_Coverage, 2015,
     /* 373278 */     GIR_EraseRootFromParent_Done,
     /* 373279 */   // Label 7543: @373279
     /* 373279 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(373306), // Rule ID 623 //
     /* 373284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373295 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 373295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 373300 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373304 */     GIR_RootConstrainSelectedInstOperands,
     /* 373305 */     // GIR_Coverage, 623,
     /* 373305 */     GIR_Done,
     /* 373306 */   // Label 7544: @373306
     /* 373306 */   GIM_Reject,
     /* 373307 */ // Label 7537: @373307
     /* 373307 */ GIM_Reject,
     /* 373308 */ // Label 7515: @373308
     /* 373308 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(373837),
     /* 373313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 373319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373323 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(373409), // Rule ID 13377 //
     /* 373328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373372 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373376 */     // MIs[3] Operand 1
     /* 373376 */     // No operand predicates
     /* 373376 */     // MIs[1] Operand 2
     /* 373376 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 373387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373393 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373407 */     GIR_RootConstrainSelectedInstOperands,
     /* 373408 */     // GIR_Coverage, 13377,
     /* 373408 */     GIR_EraseRootFromParent_Done,
     /* 373409 */   // Label 7546: @373409
     /* 373409 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(373495), // Rule ID 2003 //
     /* 373414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373466 */     // MIs[3] Operand 1
     /* 373466 */     // No operand predicates
     /* 373466 */     // MIs[1] Operand 2
     /* 373466 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 373477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373479 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373484 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373493 */     GIR_RootConstrainSelectedInstOperands,
     /* 373494 */     // GIR_Coverage, 2003,
     /* 373494 */     GIR_EraseRootFromParent_Done,
     /* 373495 */   // Label 7547: @373495
     /* 373495 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(373558), // Rule ID 13378 //
     /* 373500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373532 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373536 */     // MIs[2] Operand 1
     /* 373536 */     // No operand predicates
     /* 373536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373542 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373556 */     GIR_RootConstrainSelectedInstOperands,
     /* 373557 */     // GIR_Coverage, 13378,
     /* 373557 */     GIR_EraseRootFromParent_Done,
     /* 373558 */   // Label 7548: @373558
     /* 373558 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(373621), // Rule ID 2004 //
     /* 373563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373599 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373603 */     // MIs[2] Operand 1
     /* 373603 */     // No operand predicates
     /* 373603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373605 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373619 */     GIR_RootConstrainSelectedInstOperands,
     /* 373620 */     // GIR_Coverage, 2004,
     /* 373620 */     GIR_EraseRootFromParent_Done,
     /* 373621 */   // Label 7549: @373621
     /* 373621 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(373715), // Rule ID 13839 //
     /* 373626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373649 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373649 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 373652 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373656 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 373666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373675 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373682 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373713 */     GIR_RootConstrainSelectedInstOperands,
     /* 373714 */     // GIR_Coverage, 13839,
     /* 373714 */     GIR_EraseRootFromParent_Done,
     /* 373715 */   // Label 7550: @373715
     /* 373715 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(373809), // Rule ID 6217 //
     /* 373720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 373736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373743 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373743 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 373746 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373750 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 373760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373769 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 373779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373807 */     GIR_RootConstrainSelectedInstOperands,
     /* 373808 */     // GIR_Coverage, 6217,
     /* 373808 */     GIR_EraseRootFromParent_Done,
     /* 373809 */   // Label 7551: @373809
     /* 373809 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(373836), // Rule ID 1322 //
     /* 373814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373825 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 373825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 373830 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373834 */     GIR_RootConstrainSelectedInstOperands,
     /* 373835 */     // GIR_Coverage, 1322,
     /* 373835 */     GIR_Done,
     /* 373836 */   // Label 7552: @373836
     /* 373836 */   GIM_Reject,
     /* 373837 */ // Label 7545: @373837
     /* 373837 */ GIM_Reject,
     /* 373838 */ // Label 7516: @373838
     /* 373838 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(374195),
     /* 373843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 373849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373853 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(373916), // Rule ID 13383 //
     /* 373858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 373869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373894 */     // MIs[2] Operand 1
     /* 373894 */     // No operand predicates
     /* 373894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373900 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 373903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373914 */     GIR_RootConstrainSelectedInstOperands,
     /* 373915 */     // GIR_Coverage, 13383,
     /* 373915 */     GIR_EraseRootFromParent_Done,
     /* 373916 */   // Label 7554: @373916
     /* 373916 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(373979), // Rule ID 2009 //
     /* 373921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 373936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373961 */     // MIs[2] Operand 1
     /* 373961 */     // No operand predicates
     /* 373961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373963 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 373966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373977 */     GIR_RootConstrainSelectedInstOperands,
     /* 373978 */     // GIR_Coverage, 2009,
     /* 373978 */     GIR_EraseRootFromParent_Done,
     /* 373979 */   // Label 7555: @373979
     /* 373979 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(374073), // Rule ID 13843 //
     /* 373984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 373992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 373996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374007 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374033 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374036 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374071 */     GIR_RootConstrainSelectedInstOperands,
     /* 374072 */     // GIR_Coverage, 13843,
     /* 374072 */     GIR_EraseRootFromParent_Done,
     /* 374073 */   // Label 7556: @374073
     /* 374073 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(374167), // Rule ID 6221 //
     /* 374078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 374094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374101 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374134 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374165 */     GIR_RootConstrainSelectedInstOperands,
     /* 374166 */     // GIR_Coverage, 6221,
     /* 374166 */     GIR_EraseRootFromParent_Done,
     /* 374167 */   // Label 7557: @374167
     /* 374167 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(374194), // Rule ID 1326 //
     /* 374172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374183 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 374183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 374188 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374192 */     GIR_RootConstrainSelectedInstOperands,
     /* 374193 */     // GIR_Coverage, 1326,
     /* 374193 */     GIR_Done,
     /* 374194 */   // Label 7558: @374194
     /* 374194 */   GIM_Reject,
     /* 374195 */ // Label 7553: @374195
     /* 374195 */ GIM_Reject,
     /* 374196 */ // Label 7517: @374196
     /* 374196 */ GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(374537),
     /* 374201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 374204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 374207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374211 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(374297), // Rule ID 13371 //
     /* 374216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 374227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374260 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374264 */     // MIs[3] Operand 1
     /* 374264 */     // No operand predicates
     /* 374264 */     // MIs[1] Operand 2
     /* 374264 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374281 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374295 */     GIR_RootConstrainSelectedInstOperands,
     /* 374296 */     // GIR_Coverage, 13371,
     /* 374296 */     GIR_EraseRootFromParent_Done,
     /* 374297 */   // Label 7560: @374297
     /* 374297 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(374383), // Rule ID 1997 //
     /* 374302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 374317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374350 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374354 */     // MIs[3] Operand 1
     /* 374354 */     // No operand predicates
     /* 374354 */     // MIs[1] Operand 2
     /* 374354 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374367 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374381 */     GIR_RootConstrainSelectedInstOperands,
     /* 374382 */     // GIR_Coverage, 1997,
     /* 374382 */     GIR_EraseRootFromParent_Done,
     /* 374383 */   // Label 7561: @374383
     /* 374383 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(374446), // Rule ID 13372 //
     /* 374388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374420 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374424 */     // MIs[2] Operand 1
     /* 374424 */     // No operand predicates
     /* 374424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374430 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374444 */     GIR_RootConstrainSelectedInstOperands,
     /* 374445 */     // GIR_Coverage, 13372,
     /* 374445 */     GIR_EraseRootFromParent_Done,
     /* 374446 */   // Label 7562: @374446
     /* 374446 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(374509), // Rule ID 1998 //
     /* 374451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374487 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374491 */     // MIs[2] Operand 1
     /* 374491 */     // No operand predicates
     /* 374491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374493 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374507 */     GIR_RootConstrainSelectedInstOperands,
     /* 374508 */     // GIR_Coverage, 1998,
     /* 374508 */     GIR_EraseRootFromParent_Done,
     /* 374509 */   // Label 7563: @374509
     /* 374509 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(374536), // Rule ID 1318 //
     /* 374514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374525 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 374525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 374530 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374534 */     GIR_RootConstrainSelectedInstOperands,
     /* 374535 */     // GIR_Coverage, 1318,
     /* 374535 */     GIR_Done,
     /* 374536 */   // Label 7564: @374536
     /* 374536 */   GIM_Reject,
     /* 374537 */ // Label 7559: @374537
     /* 374537 */ GIM_Reject,
     /* 374538 */ // Label 7518: @374538
     /* 374538 */ GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(374895),
     /* 374543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 374549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374553 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(374616), // Rule ID 13381 //
     /* 374558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374594 */     // MIs[2] Operand 1
     /* 374594 */     // No operand predicates
     /* 374594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374600 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374614 */     GIR_RootConstrainSelectedInstOperands,
     /* 374615 */     // GIR_Coverage, 13381,
     /* 374615 */     GIR_EraseRootFromParent_Done,
     /* 374616 */   // Label 7566: @374616
     /* 374616 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(374679), // Rule ID 2007 //
     /* 374621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374657 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374661 */     // MIs[2] Operand 1
     /* 374661 */     // No operand predicates
     /* 374661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374663 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374677 */     GIR_RootConstrainSelectedInstOperands,
     /* 374678 */     // GIR_Coverage, 2007,
     /* 374678 */     GIR_EraseRootFromParent_Done,
     /* 374679 */   // Label 7567: @374679
     /* 374679 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(374773), // Rule ID 13841 //
     /* 374684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374707 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374771 */     GIR_RootConstrainSelectedInstOperands,
     /* 374772 */     // GIR_Coverage, 13841,
     /* 374772 */     GIR_EraseRootFromParent_Done,
     /* 374773 */   // Label 7568: @374773
     /* 374773 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(374867), // Rule ID 6219 //
     /* 374778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374801 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374834 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 374855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374865 */     GIR_RootConstrainSelectedInstOperands,
     /* 374866 */     // GIR_Coverage, 6219,
     /* 374866 */     GIR_EraseRootFromParent_Done,
     /* 374867 */   // Label 7569: @374867
     /* 374867 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(374894), // Rule ID 1324 //
     /* 374872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374883 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 374883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 374888 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374892 */     GIR_RootConstrainSelectedInstOperands,
     /* 374893 */     // GIR_Coverage, 1324,
     /* 374893 */     GIR_Done,
     /* 374894 */   // Label 7570: @374894
     /* 374894 */   GIM_Reject,
     /* 374895 */ // Label 7565: @374895
     /* 374895 */ GIM_Reject,
     /* 374896 */ // Label 7519: @374896
     /* 374896 */ GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(375327),
     /* 374901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 374907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374911 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(374974), // Rule ID 13375 //
     /* 374916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374948 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374952 */     // MIs[2] Operand 1
     /* 374952 */     // No operand predicates
     /* 374952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374958 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 374961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374972 */     GIR_RootConstrainSelectedInstOperands,
     /* 374973 */     // GIR_Coverage, 13375,
     /* 374973 */     GIR_EraseRootFromParent_Done,
     /* 374974 */   // Label 7572: @374974
     /* 374974 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(375037), // Rule ID 2001 //
     /* 374979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375019 */     // MIs[2] Operand 1
     /* 375019 */     // No operand predicates
     /* 375019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375021 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 375024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375035 */     GIR_RootConstrainSelectedInstOperands,
     /* 375036 */     // GIR_Coverage, 2001,
     /* 375036 */     GIR_EraseRootFromParent_Done,
     /* 375037 */   // Label 7573: @375037
     /* 375037 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(375064), // Rule ID 1320 //
     /* 375042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375053 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 375053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 375058 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375062 */     GIR_RootConstrainSelectedInstOperands,
     /* 375063 */     // GIR_Coverage, 1320,
     /* 375063 */     GIR_Done,
     /* 375064 */   // Label 7574: @375064
     /* 375064 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(375326), // Rule ID 6974 //
     /* 375069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 375072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375080 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 375080 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 375083 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375087 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375092 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 375096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 375098 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 375101 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375105 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375110 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 375114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 375116 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 375119 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 375123 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375128 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 375131 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 375134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 375136 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 375139 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375143 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375148 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 375154 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375159 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375164 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 375167 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375171 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375176 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 375179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 375181 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 375184 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375188 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375193 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375199 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375204 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375209 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 375212 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375216 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375221 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 375224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 375226 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 375229 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 375233 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375238 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 375241 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 375244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 375246 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 375249 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 375253 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375258 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 375261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 375263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 375266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375292 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 375295 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 375316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 375324 */     GIR_RootConstrainSelectedInstOperands,
     /* 375325 */     // GIR_Coverage, 6974,
     /* 375325 */     GIR_EraseRootFromParent_Done,
     /* 375326 */   // Label 7575: @375326
     /* 375326 */   GIM_Reject,
     /* 375327 */ // Label 7571: @375327
     /* 375327 */ GIM_Reject,
     /* 375328 */ // Label 7520: @375328
     /* 375328 */ GIM_Reject,
     /* 375329 */ // Label 104: @375329
     /* 375329 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7584*/ GIMT_Encode4(375944),
     /* 375340 */ /*GILLT_s16*//*Label 7576*/ GIMT_Encode4(375380),
     /* 375344 */ /*GILLT_s32*//*Label 7577*/ GIMT_Encode4(375418),
     /* 375348 */ /*GILLT_s64*//*Label 7578*/ GIMT_Encode4(375456), GIMT_Encode4(0),
     /* 375356 */ /*GILLT_v2s32*//*Label 7579*/ GIMT_Encode4(375494),
     /* 375360 */ /*GILLT_v2s64*//*Label 7580*/ GIMT_Encode4(375532),
     /* 375364 */ /*GILLT_v4s16*//*Label 7581*/ GIMT_Encode4(375570),
     /* 375368 */ /*GILLT_v4s32*//*Label 7582*/ GIMT_Encode4(375608), GIMT_Encode4(0),
     /* 375376 */ /*GILLT_v8s16*//*Label 7583*/ GIMT_Encode4(375646),
     /* 375380 */ // Label 7576: @375380
     /* 375380 */ GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(375417), // Rule ID 589 //
     /* 375385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 375391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375406 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 375406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 375411 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375415 */   GIR_RootConstrainSelectedInstOperands,
     /* 375416 */   // GIR_Coverage, 589,
     /* 375416 */   GIR_Done,
     /* 375417 */ // Label 7585: @375417
     /* 375417 */ GIM_Reject,
     /* 375418 */ // Label 7577: @375418
     /* 375418 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(375455), // Rule ID 591 //
     /* 375423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 375429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375444 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 375444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 375449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375453 */   GIR_RootConstrainSelectedInstOperands,
     /* 375454 */   // GIR_Coverage, 591,
     /* 375454 */   GIR_Done,
     /* 375455 */ // Label 7586: @375455
     /* 375455 */ GIM_Reject,
     /* 375456 */ // Label 7578: @375456
     /* 375456 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(375493), // Rule ID 593 //
     /* 375461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 375467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 375470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375482 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 375482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 375487 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375491 */   GIR_RootConstrainSelectedInstOperands,
     /* 375492 */   // GIR_Coverage, 593,
     /* 375492 */   GIR_Done,
     /* 375493 */ // Label 7587: @375493
     /* 375493 */ GIM_Reject,
     /* 375494 */ // Label 7579: @375494
     /* 375494 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(375531), // Rule ID 1227 //
     /* 375499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 375505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 375508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375520 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 375520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 375525 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375529 */   GIR_RootConstrainSelectedInstOperands,
     /* 375530 */   // GIR_Coverage, 1227,
     /* 375530 */   GIR_Done,
     /* 375531 */ // Label 7588: @375531
     /* 375531 */ GIM_Reject,
     /* 375532 */ // Label 7580: @375532
     /* 375532 */ GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(375569), // Rule ID 1231 //
     /* 375537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 375543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 375546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375558 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 375558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 375563 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375567 */   GIR_RootConstrainSelectedInstOperands,
     /* 375568 */   // GIR_Coverage, 1231,
     /* 375568 */   GIR_Done,
     /* 375569 */ // Label 7589: @375569
     /* 375569 */ GIM_Reject,
     /* 375570 */ // Label 7581: @375570
     /* 375570 */ GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(375607), // Rule ID 1223 //
     /* 375575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 375581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 375584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375596 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 375596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 375601 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375605 */   GIR_RootConstrainSelectedInstOperands,
     /* 375606 */   // GIR_Coverage, 1223,
     /* 375606 */   GIR_Done,
     /* 375607 */ // Label 7590: @375607
     /* 375607 */ GIM_Reject,
     /* 375608 */ // Label 7582: @375608
     /* 375608 */ GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(375645), // Rule ID 1229 //
     /* 375613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 375622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375634 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 375634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 375639 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375643 */   GIR_RootConstrainSelectedInstOperands,
     /* 375644 */   // GIR_Coverage, 1229,
     /* 375644 */   GIR_Done,
     /* 375645 */ // Label 7591: @375645
     /* 375645 */ GIM_Reject,
     /* 375646 */ // Label 7583: @375646
     /* 375646 */ GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(375943),
     /* 375651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 375657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375669 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(375688), // Rule ID 1225 //
     /* 375674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375677 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 375677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 375682 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375686 */     GIR_RootConstrainSelectedInstOperands,
     /* 375687 */     // GIR_Coverage, 1225,
     /* 375687 */     GIR_Done,
     /* 375688 */   // Label 7593: @375688
     /* 375688 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(375942), // Rule ID 6972 //
     /* 375693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 375696 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 375696 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 375699 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375703 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375708 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 375712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 375714 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 375717 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375721 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375726 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 375730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 375732 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 375735 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 375739 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375744 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 375747 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 375750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 375752 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 375755 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375759 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375764 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 375770 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375775 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375780 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 375783 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375787 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375792 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 375795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 375797 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 375800 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375804 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375809 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375815 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375820 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375825 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 375828 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375832 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375837 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 375840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 375842 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 375845 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 375849 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375854 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 375857 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 375860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 375862 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 375865 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 375869 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375874 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 375877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 375879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 375882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375908 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 375911 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 375932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 375940 */     GIR_RootConstrainSelectedInstOperands,
     /* 375941 */     // GIR_Coverage, 6972,
     /* 375941 */     GIR_EraseRootFromParent_Done,
     /* 375942 */   // Label 7594: @375942
     /* 375942 */   GIM_Reject,
     /* 375943 */ // Label 7592: @375943
     /* 375943 */ GIM_Reject,
     /* 375944 */ // Label 7584: @375944
     /* 375944 */ GIM_Reject,
     /* 375945 */ // Label 105: @375945
     /* 375945 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7603*/ GIMT_Encode4(391551),
     /* 375956 */ /*GILLT_s16*//*Label 7595*/ GIMT_Encode4(375996),
     /* 375960 */ /*GILLT_s32*//*Label 7596*/ GIMT_Encode4(378770),
     /* 375964 */ /*GILLT_s64*//*Label 7597*/ GIMT_Encode4(381700), GIMT_Encode4(0),
     /* 375972 */ /*GILLT_v2s32*//*Label 7598*/ GIMT_Encode4(384630),
     /* 375976 */ /*GILLT_v2s64*//*Label 7599*/ GIMT_Encode4(386151),
     /* 375980 */ /*GILLT_v4s16*//*Label 7600*/ GIMT_Encode4(387672),
     /* 375984 */ /*GILLT_v4s32*//*Label 7601*/ GIMT_Encode4(388851), GIMT_Encode4(0),
     /* 375992 */ /*GILLT_v8s16*//*Label 7602*/ GIMT_Encode4(390372),
     /* 375996 */ // Label 7595: @375996
     /* 375996 */ GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(378769),
     /* 376001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 376004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 376010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376014 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(376164), // Rule ID 4852 //
     /* 376019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376068 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 376084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376091 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376103 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 376150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 376162 */     GIR_RootConstrainSelectedInstOperands,
     /* 376163 */     // GIR_Coverage, 4852,
     /* 376163 */     GIR_EraseRootFromParent_Done,
     /* 376164 */   // Label 7605: @376164
     /* 376164 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(376311), // Rule ID 4816 //
     /* 376169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376217 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376221 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376225 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376230 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376240 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376252 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376280 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 376299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376309 */     GIR_RootConstrainSelectedInstOperands,
     /* 376310 */     // GIR_Coverage, 4816,
     /* 376310 */     GIR_EraseRootFromParent_Done,
     /* 376311 */   // Label 7606: @376311
     /* 376311 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(376458), // Rule ID 13783 //
     /* 376316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376352 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376372 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376377 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376387 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376399 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376427 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 376446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376456 */     GIR_RootConstrainSelectedInstOperands,
     /* 376457 */     // GIR_Coverage, 13783,
     /* 376457 */     GIR_EraseRootFromParent_Done,
     /* 376458 */   // Label 7607: @376458
     /* 376458 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(376589), // Rule ID 6049 //
     /* 376463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376487 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376511 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376515 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 376528 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376532 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376536 */     // MIs[4] Operand 1
     /* 376536 */     // No operand predicates
     /* 376536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376542 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 376584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 376587 */     GIR_RootConstrainSelectedInstOperands,
     /* 376588 */     // GIR_Coverage, 6049,
     /* 376588 */     GIR_EraseRootFromParent_Done,
     /* 376589 */   // Label 7608: @376589
     /* 376589 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(376720), // Rule ID 6081 //
     /* 376594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376626 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376630 */     // MIs[2] Operand 1
     /* 376630 */     // No operand predicates
     /* 376630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376638 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 376642 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 376646 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376650 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376654 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 376658 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376663 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 376667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376671 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376673 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376685 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 376715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376718 */     GIR_RootConstrainSelectedInstOperands,
     /* 376719 */     // GIR_Coverage, 6081,
     /* 376719 */     GIR_EraseRootFromParent_Done,
     /* 376720 */   // Label 7609: @376720
     /* 376720 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(376851), // Rule ID 6145 //
     /* 376725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376761 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 376790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376798 */     // MIs[4] Operand 1
     /* 376798 */     // No operand predicates
     /* 376798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376802 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376804 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 376846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 376849 */     GIR_RootConstrainSelectedInstOperands,
     /* 376850 */     // GIR_Coverage, 6145,
     /* 376850 */     GIR_EraseRootFromParent_Done,
     /* 376851 */   // Label 7610: @376851
     /* 376851 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(376982), // Rule ID 6113 //
     /* 376856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 376892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376900 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 376904 */     // MIs[3] Operand 1
     /* 376904 */     // No operand predicates
     /* 376904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 376908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376916 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 376920 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376925 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 376929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376933 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 376935 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 376935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376947 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 376966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 376970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 376977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376980 */     GIR_RootConstrainSelectedInstOperands,
     /* 376981 */     // GIR_Coverage, 6113,
     /* 376981 */     GIR_EraseRootFromParent_Done,
     /* 376982 */   // Label 7611: @376982
     /* 376982 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(377117), // Rule ID 2455 //
     /* 376987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377036 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377046 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 377049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377058 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377064 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377069 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377086 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 377105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377115 */     GIR_RootConstrainSelectedInstOperands,
     /* 377116 */     // GIR_Coverage, 2455,
     /* 377116 */     GIR_EraseRootFromParent_Done,
     /* 377117 */   // Label 7612: @377117
     /* 377117 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(377236), // Rule ID 6017 //
     /* 377122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377183 */     // MIs[3] Operand 1
     /* 377183 */     // No operand predicates
     /* 377183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377189 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377201 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 377220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377234 */     GIR_RootConstrainSelectedInstOperands,
     /* 377235 */     // GIR_Coverage, 6017,
     /* 377235 */     GIR_EraseRootFromParent_Done,
     /* 377236 */   // Label 7613: @377236
     /* 377236 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(377355), // Rule ID 2537 //
     /* 377241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377277 */     // MIs[2] Operand 1
     /* 377277 */     // No operand predicates
     /* 377277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377308 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377320 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 377339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377353 */     GIR_RootConstrainSelectedInstOperands,
     /* 377354 */     // GIR_Coverage, 2537,
     /* 377354 */     GIR_EraseRootFromParent_Done,
     /* 377355 */   // Label 7614: @377355
     /* 377355 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(377455), // Rule ID 4814 //
     /* 377360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377411 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 377411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377423 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377453 */     GIR_RootConstrainSelectedInstOperands,
     /* 377454 */     // GIR_Coverage, 4814,
     /* 377454 */     GIR_EraseRootFromParent_Done,
     /* 377455 */   // Label 7615: @377455
     /* 377455 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(377555), // Rule ID 4850 //
     /* 377460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377511 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 377511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377523 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 377542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 377549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 377553 */     GIR_RootConstrainSelectedInstOperands,
     /* 377554 */     // GIR_Coverage, 4850,
     /* 377554 */     GIR_EraseRootFromParent_Done,
     /* 377555 */   // Label 7616: @377555
     /* 377555 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(377652), // Rule ID 13779 //
     /* 377560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377596 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377610 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377622 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377650 */     GIR_RootConstrainSelectedInstOperands,
     /* 377651 */     // GIR_Coverage, 13779,
     /* 377651 */     GIR_EraseRootFromParent_Done,
     /* 377652 */   // Label 7617: @377652
     /* 377652 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(377752), // Rule ID 13781 //
     /* 377657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377698 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377708 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 377708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377750 */     GIR_RootConstrainSelectedInstOperands,
     /* 377751 */     // GIR_Coverage, 13781,
     /* 377751 */     GIR_EraseRootFromParent_Done,
     /* 377752 */   // Label 7618: @377752
     /* 377752 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(377852), // Rule ID 4848 //
     /* 377757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377808 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 377839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 377850 */     GIR_RootConstrainSelectedInstOperands,
     /* 377851 */     // GIR_Coverage, 4848,
     /* 377851 */     GIR_EraseRootFromParent_Done,
     /* 377852 */   // Label 7619: @377852
     /* 377852 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(377949), // Rule ID 4812 //
     /* 377857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377907 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377919 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377947 */     GIR_RootConstrainSelectedInstOperands,
     /* 377948 */     // GIR_Coverage, 4812,
     /* 377948 */     GIR_EraseRootFromParent_Done,
     /* 377949 */   // Label 7620: @377949
     /* 377949 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(378033), // Rule ID 6079 //
     /* 377954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377986 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377990 */     // MIs[2] Operand 1
     /* 377990 */     // No operand predicates
     /* 377990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 378002 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378013 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 378024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378031 */     GIR_RootConstrainSelectedInstOperands,
     /* 378032 */     // GIR_Coverage, 6079,
     /* 378032 */     GIR_EraseRootFromParent_Done,
     /* 378033 */   // Label 7621: @378033
     /* 378033 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(378114), // Rule ID 6111 //
     /* 378038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378082 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378086 */     // MIs[3] Operand 1
     /* 378086 */     // No operand predicates
     /* 378086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378096 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378112 */     GIR_RootConstrainSelectedInstOperands,
     /* 378113 */     // GIR_Coverage, 6111,
     /* 378113 */     GIR_EraseRootFromParent_Done,
     /* 378114 */   // Label 7622: @378114
     /* 378114 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(378198), // Rule ID 6143 //
     /* 378119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378168 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378172 */     // MIs[3] Operand 1
     /* 378172 */     // No operand predicates
     /* 378172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378178 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378196 */     GIR_RootConstrainSelectedInstOperands,
     /* 378197 */     // GIR_Coverage, 6143,
     /* 378197 */     GIR_EraseRootFromParent_Done,
     /* 378198 */   // Label 7623: @378198
     /* 378198 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(378279), // Rule ID 6047 //
     /* 378203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378251 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378255 */     // MIs[3] Operand 1
     /* 378255 */     // No operand predicates
     /* 378255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378261 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378277 */     GIR_RootConstrainSelectedInstOperands,
     /* 378278 */     // GIR_Coverage, 6047,
     /* 378278 */     GIR_EraseRootFromParent_Done,
     /* 378279 */   // Label 7624: @378279
     /* 378279 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(378364), // Rule ID 2453 //
     /* 378284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378308 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378322 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378362 */     GIR_RootConstrainSelectedInstOperands,
     /* 378363 */     // GIR_Coverage, 2453,
     /* 378363 */     GIR_EraseRootFromParent_Done,
     /* 378364 */   // Label 7625: @378364
     /* 378364 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(378449), // Rule ID 2451 //
     /* 378369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378397 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378407 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378419 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378447 */     GIR_RootConstrainSelectedInstOperands,
     /* 378448 */     // GIR_Coverage, 2451,
     /* 378448 */     GIR_EraseRootFromParent_Done,
     /* 378449 */   // Label 7626: @378449
     /* 378449 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(378518), // Rule ID 2535 //
     /* 378454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378490 */     // MIs[2] Operand 1
     /* 378490 */     // No operand predicates
     /* 378490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378500 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 378503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378516 */     GIR_RootConstrainSelectedInstOperands,
     /* 378517 */     // GIR_Coverage, 2535,
     /* 378517 */     GIR_EraseRootFromParent_Done,
     /* 378518 */   // Label 7627: @378518
     /* 378518 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(378587), // Rule ID 6015 //
     /* 378523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378559 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378563 */     // MIs[2] Operand 1
     /* 378563 */     // No operand predicates
     /* 378563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378569 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 378572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378576 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378585 */     GIR_RootConstrainSelectedInstOperands,
     /* 378586 */     // GIR_Coverage, 6015,
     /* 378586 */     GIR_EraseRootFromParent_Done,
     /* 378587 */   // Label 7628: @378587
     /* 378587 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(378637), // Rule ID 13225 //
     /* 378592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378622 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378635 */     GIR_RootConstrainSelectedInstOperands,
     /* 378636 */     // GIR_Coverage, 13225,
     /* 378636 */     GIR_EraseRootFromParent_Done,
     /* 378637 */   // Label 7629: @378637
     /* 378637 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(378687), // Rule ID 643 //
     /* 378642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378672 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378685 */     GIR_RootConstrainSelectedInstOperands,
     /* 378686 */     // GIR_Coverage, 643,
     /* 378686 */     GIR_EraseRootFromParent_Done,
     /* 378687 */   // Label 7630: @378687
     /* 378687 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(378737), // Rule ID 655 //
     /* 378692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 378707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378722 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 378725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 378735 */     GIR_RootConstrainSelectedInstOperands,
     /* 378736 */     // GIR_Coverage, 655,
     /* 378736 */     GIR_EraseRootFromParent_Done,
     /* 378737 */   // Label 7631: @378737
     /* 378737 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(378768), // Rule ID 637 //
     /* 378742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378757 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378762 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 378766 */     GIR_RootConstrainSelectedInstOperands,
     /* 378767 */     // GIR_Coverage, 637,
     /* 378767 */     GIR_Done,
     /* 378768 */   // Label 7632: @378768
     /* 378768 */   GIM_Reject,
     /* 378769 */ // Label 7604: @378769
     /* 378769 */ GIM_Reject,
     /* 378770 */ // Label 7596: @378770
     /* 378770 */ GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(381699),
     /* 378775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 378778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 378781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 378784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378788 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(378938), // Rule ID 4858 //
     /* 378793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378817 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378833 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378842 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 378850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378854 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 378858 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378865 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 378865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 378868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378877 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 378883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 378896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378905 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 378911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 378916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 378924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 378932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 378936 */     GIR_RootConstrainSelectedInstOperands,
     /* 378937 */     // GIR_Coverage, 4858,
     /* 378937 */     GIR_EraseRootFromParent_Done,
     /* 378938 */   // Label 7634: @378938
     /* 378938 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(379085), // Rule ID 4822 //
     /* 378943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 378946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378967 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 378983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 378987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378991 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 378995 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 378999 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379004 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379014 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379026 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379032 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379037 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379054 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 379073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379083 */     GIR_RootConstrainSelectedInstOperands,
     /* 379084 */     // GIR_Coverage, 4822,
     /* 379084 */     GIR_EraseRootFromParent_Done,
     /* 379085 */   // Label 7635: @379085
     /* 379085 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(379232), // Rule ID 13789 //
     /* 379090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379126 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379142 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379146 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379151 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379161 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379173 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379179 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379184 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379201 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 379220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379230 */     GIR_RootConstrainSelectedInstOperands,
     /* 379231 */     // GIR_Coverage, 13789,
     /* 379231 */     GIR_EraseRootFromParent_Done,
     /* 379232 */   // Label 7636: @379232
     /* 379232 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(379363), // Rule ID 6065 //
     /* 379237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379261 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379298 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 379302 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379306 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379310 */     // MIs[4] Operand 1
     /* 379310 */     // No operand predicates
     /* 379310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379314 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379316 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379328 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 379358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 379361 */     GIR_RootConstrainSelectedInstOperands,
     /* 379362 */     // GIR_Coverage, 6065,
     /* 379362 */     GIR_EraseRootFromParent_Done,
     /* 379363 */   // Label 7637: @379363
     /* 379363 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(379494), // Rule ID 6097 //
     /* 379368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379400 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379404 */     // MIs[2] Operand 1
     /* 379404 */     // No operand predicates
     /* 379404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 379416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 379420 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379424 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379428 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 379432 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379437 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 379441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379445 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379447 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379459 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379492 */     GIR_RootConstrainSelectedInstOperands,
     /* 379493 */     // GIR_Coverage, 6097,
     /* 379493 */     GIR_EraseRootFromParent_Done,
     /* 379494 */   // Label 7638: @379494
     /* 379494 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(379625), // Rule ID 6161 //
     /* 379499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379535 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379547 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379551 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 379564 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379568 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379572 */     // MIs[4] Operand 1
     /* 379572 */     // No operand predicates
     /* 379572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379578 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379590 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 379620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 379623 */     GIR_RootConstrainSelectedInstOperands,
     /* 379624 */     // GIR_Coverage, 6161,
     /* 379624 */     GIR_EraseRootFromParent_Done,
     /* 379625 */   // Label 7639: @379625
     /* 379625 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(379756), // Rule ID 6129 //
     /* 379630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379678 */     // MIs[3] Operand 1
     /* 379678 */     // No operand predicates
     /* 379678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 379682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379686 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379690 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 379694 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379699 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 379703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379707 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379709 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379721 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 379751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 379754 */     GIR_RootConstrainSelectedInstOperands,
     /* 379755 */     // GIR_Coverage, 6129,
     /* 379755 */     GIR_EraseRootFromParent_Done,
     /* 379756 */   // Label 7640: @379756
     /* 379756 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(379891), // Rule ID 2461 //
     /* 379761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379785 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379810 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379820 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379832 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379838 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379860 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 379879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379889 */     GIR_RootConstrainSelectedInstOperands,
     /* 379890 */     // GIR_Coverage, 2461,
     /* 379890 */     GIR_EraseRootFromParent_Done,
     /* 379891 */   // Label 7641: @379891
     /* 379891 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(380010), // Rule ID 6033 //
     /* 379896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379953 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379957 */     // MIs[3] Operand 1
     /* 379957 */     // No operand predicates
     /* 379957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379963 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379975 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 379994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380008 */     GIR_RootConstrainSelectedInstOperands,
     /* 380009 */     // GIR_Coverage, 6033,
     /* 380009 */     GIR_EraseRootFromParent_Done,
     /* 380010 */   // Label 7642: @380010
     /* 380010 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(380129), // Rule ID 2553 //
     /* 380015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380047 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380051 */     // MIs[2] Operand 1
     /* 380051 */     // No operand predicates
     /* 380051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380059 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380063 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380067 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380072 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 380076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380082 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380094 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 380113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380127 */     GIR_RootConstrainSelectedInstOperands,
     /* 380128 */     // GIR_Coverage, 2553,
     /* 380128 */     GIR_EraseRootFromParent_Done,
     /* 380129 */   // Label 7643: @380129
     /* 380129 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(380229), // Rule ID 4820 //
     /* 380134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380158 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380185 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 380185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380197 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380227 */     GIR_RootConstrainSelectedInstOperands,
     /* 380228 */     // GIR_Coverage, 4820,
     /* 380228 */     GIR_EraseRootFromParent_Done,
     /* 380229 */   // Label 7644: @380229
     /* 380229 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(380329), // Rule ID 4856 //
     /* 380234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 380270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380285 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 380285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380297 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 380316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 380323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 380327 */     GIR_RootConstrainSelectedInstOperands,
     /* 380328 */     // GIR_Coverage, 4856,
     /* 380328 */     GIR_EraseRootFromParent_Done,
     /* 380329 */   // Label 7645: @380329
     /* 380329 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(380426), // Rule ID 13785 //
     /* 380334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380370 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380384 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380396 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380424 */     GIR_RootConstrainSelectedInstOperands,
     /* 380425 */     // GIR_Coverage, 13785,
     /* 380425 */     GIR_EraseRootFromParent_Done,
     /* 380426 */   // Label 7646: @380426
     /* 380426 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(380526), // Rule ID 13787 //
     /* 380431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380472 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380482 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 380482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380494 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380524 */     GIR_RootConstrainSelectedInstOperands,
     /* 380525 */     // GIR_Coverage, 13787,
     /* 380525 */     GIR_EraseRootFromParent_Done,
     /* 380526 */   // Label 7647: @380526
     /* 380526 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(380626), // Rule ID 4854 //
     /* 380531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380559 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 380567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380582 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 380613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380615 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 380624 */     GIR_RootConstrainSelectedInstOperands,
     /* 380625 */     // GIR_Coverage, 4854,
     /* 380625 */     GIR_EraseRootFromParent_Done,
     /* 380626 */   // Label 7648: @380626
     /* 380626 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(380723), // Rule ID 4818 //
     /* 380631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 380642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380681 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380693 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 380716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380721 */     GIR_RootConstrainSelectedInstOperands,
     /* 380722 */     // GIR_Coverage, 4818,
     /* 380722 */     GIR_EraseRootFromParent_Done,
     /* 380723 */   // Label 7649: @380723
     /* 380723 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(380801), // Rule ID 6183 //
     /* 380728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 380765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380769 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380773 */     // MIs[3] Operand 1
     /* 380773 */     // No operand predicates
     /* 380773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380783 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380799 */     GIR_RootConstrainSelectedInstOperands,
     /* 380800 */     // GIR_Coverage, 6183,
     /* 380800 */     GIR_EraseRootFromParent_Done,
     /* 380801 */   // Label 7650: @380801
     /* 380801 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(380885), // Rule ID 6095 //
     /* 380806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380842 */     // MIs[2] Operand 1
     /* 380842 */     // No operand predicates
     /* 380842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380850 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 380854 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380865 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 380876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380883 */     GIR_RootConstrainSelectedInstOperands,
     /* 380884 */     // GIR_Coverage, 6095,
     /* 380884 */     GIR_EraseRootFromParent_Done,
     /* 380885 */   // Label 7651: @380885
     /* 380885 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(380966), // Rule ID 6127 //
     /* 380890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380938 */     // MIs[3] Operand 1
     /* 380938 */     // No operand predicates
     /* 380938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380948 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380964 */     GIR_RootConstrainSelectedInstOperands,
     /* 380965 */     // GIR_Coverage, 6127,
     /* 380965 */     GIR_EraseRootFromParent_Done,
     /* 380966 */   // Label 7652: @380966
     /* 380966 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(381050), // Rule ID 6159 //
     /* 380971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381020 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381024 */     // MIs[3] Operand 1
     /* 381024 */     // No operand predicates
     /* 381024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381030 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381048 */     GIR_RootConstrainSelectedInstOperands,
     /* 381049 */     // GIR_Coverage, 6159,
     /* 381049 */     GIR_EraseRootFromParent_Done,
     /* 381050 */   // Label 7653: @381050
     /* 381050 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(381128), // Rule ID 6205 //
     /* 381055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 381096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381100 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381104 */     // MIs[3] Operand 1
     /* 381104 */     // No operand predicates
     /* 381104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381110 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381126 */     GIR_RootConstrainSelectedInstOperands,
     /* 381127 */     // GIR_Coverage, 6205,
     /* 381127 */     GIR_EraseRootFromParent_Done,
     /* 381128 */   // Label 7654: @381128
     /* 381128 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(381209), // Rule ID 6063 //
     /* 381133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381181 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381185 */     // MIs[3] Operand 1
     /* 381185 */     // No operand predicates
     /* 381185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381191 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381207 */     GIR_RootConstrainSelectedInstOperands,
     /* 381208 */     // GIR_Coverage, 6063,
     /* 381208 */     GIR_EraseRootFromParent_Done,
     /* 381209 */   // Label 7655: @381209
     /* 381209 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(381294), // Rule ID 2459 //
     /* 381214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381238 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381252 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381264 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 381270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 381283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 381290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381292 */     GIR_RootConstrainSelectedInstOperands,
     /* 381293 */     // GIR_Coverage, 2459,
     /* 381293 */     GIR_EraseRootFromParent_Done,
     /* 381294 */   // Label 7656: @381294
     /* 381294 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(381379), // Rule ID 2457 //
     /* 381299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381327 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381337 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381349 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 381368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381377 */     GIR_RootConstrainSelectedInstOperands,
     /* 381378 */     // GIR_Coverage, 2457,
     /* 381378 */     GIR_EraseRootFromParent_Done,
     /* 381379 */   // Label 7657: @381379
     /* 381379 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(381448), // Rule ID 2551 //
     /* 381384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381420 */     // MIs[2] Operand 1
     /* 381420 */     // No operand predicates
     /* 381420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381430 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 381433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381446 */     GIR_RootConstrainSelectedInstOperands,
     /* 381447 */     // GIR_Coverage, 2551,
     /* 381447 */     GIR_EraseRootFromParent_Done,
     /* 381448 */   // Label 7658: @381448
     /* 381448 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(381517), // Rule ID 6031 //
     /* 381453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381489 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381493 */     // MIs[2] Operand 1
     /* 381493 */     // No operand predicates
     /* 381493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381499 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 381502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381515 */     GIR_RootConstrainSelectedInstOperands,
     /* 381516 */     // GIR_Coverage, 6031,
     /* 381516 */     GIR_EraseRootFromParent_Done,
     /* 381517 */   // Label 7659: @381517
     /* 381517 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(381567), // Rule ID 13227 //
     /* 381522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381552 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381565 */     GIR_RootConstrainSelectedInstOperands,
     /* 381566 */     // GIR_Coverage, 13227,
     /* 381566 */     GIR_EraseRootFromParent_Done,
     /* 381567 */   // Label 7660: @381567
     /* 381567 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(381617), // Rule ID 645 //
     /* 381572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381602 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381615 */     GIR_RootConstrainSelectedInstOperands,
     /* 381616 */     // GIR_Coverage, 645,
     /* 381616 */     GIR_EraseRootFromParent_Done,
     /* 381617 */   // Label 7661: @381617
     /* 381617 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(381667), // Rule ID 657 //
     /* 381622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 381637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381652 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 381655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 381661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 381665 */     GIR_RootConstrainSelectedInstOperands,
     /* 381666 */     // GIR_Coverage, 657,
     /* 381666 */     GIR_EraseRootFromParent_Done,
     /* 381667 */   // Label 7662: @381667
     /* 381667 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(381698), // Rule ID 639 //
     /* 381672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381687 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 381692 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 381696 */     GIR_RootConstrainSelectedInstOperands,
     /* 381697 */     // GIR_Coverage, 639,
     /* 381697 */     GIR_Done,
     /* 381698 */   // Label 7663: @381698
     /* 381698 */   GIM_Reject,
     /* 381699 */ // Label 7633: @381699
     /* 381699 */ GIM_Reject,
     /* 381700 */ // Label 7597: @381700
     /* 381700 */ GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(384629),
     /* 381705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 381708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 381711 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381718 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(381868), // Rule ID 4864 //
     /* 381723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381747 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381772 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 381780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 381788 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381795 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 381795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 381798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381807 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 381813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381818 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381835 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 381841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 381854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 381862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 381866 */     GIR_RootConstrainSelectedInstOperands,
     /* 381867 */     // GIR_Coverage, 4864,
     /* 381867 */     GIR_EraseRootFromParent_Done,
     /* 381868 */   // Label 7665: @381868
     /* 381868 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(382015), // Rule ID 4828 //
     /* 381873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381897 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 381913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 381917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381921 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 381925 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 381929 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381934 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 381938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381944 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 381944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 381947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381956 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 381962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 381975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 381990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 381995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 382003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382013 */     GIR_RootConstrainSelectedInstOperands,
     /* 382014 */     // GIR_Coverage, 4828,
     /* 382014 */     GIR_EraseRootFromParent_Done,
     /* 382015 */   // Label 7666: @382015
     /* 382015 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(382162), // Rule ID 13795 //
     /* 382020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382056 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382072 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382076 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382081 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382091 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382103 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 382150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382160 */     GIR_RootConstrainSelectedInstOperands,
     /* 382161 */     // GIR_Coverage, 13795,
     /* 382161 */     GIR_EraseRootFromParent_Done,
     /* 382162 */   // Label 7667: @382162
     /* 382162 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(382293), // Rule ID 6069 //
     /* 382167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382191 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 382211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382215 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382223 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 382232 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382236 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382240 */     // MIs[4] Operand 1
     /* 382240 */     // No operand predicates
     /* 382240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382244 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382246 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382258 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 382288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 382291 */     GIR_RootConstrainSelectedInstOperands,
     /* 382292 */     // GIR_Coverage, 6069,
     /* 382292 */     GIR_EraseRootFromParent_Done,
     /* 382293 */   // Label 7668: @382293
     /* 382293 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(382424), // Rule ID 6101 //
     /* 382298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382330 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382334 */     // MIs[2] Operand 1
     /* 382334 */     // No operand predicates
     /* 382334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 382346 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 382350 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382354 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382358 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 382362 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382367 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 382371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382377 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382389 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382422 */     GIR_RootConstrainSelectedInstOperands,
     /* 382423 */     // GIR_Coverage, 6101,
     /* 382423 */     GIR_EraseRootFromParent_Done,
     /* 382424 */   // Label 7669: @382424
     /* 382424 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(382555), // Rule ID 6165 //
     /* 382429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382465 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382477 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382481 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382485 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382490 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 382494 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382498 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382502 */     // MIs[4] Operand 1
     /* 382502 */     // No operand predicates
     /* 382502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382506 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382508 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382520 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 382550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 382553 */     GIR_RootConstrainSelectedInstOperands,
     /* 382554 */     // GIR_Coverage, 6165,
     /* 382554 */     GIR_EraseRootFromParent_Done,
     /* 382555 */   // Label 7670: @382555
     /* 382555 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(382686), // Rule ID 6133 //
     /* 382560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382604 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382608 */     // MIs[3] Operand 1
     /* 382608 */     // No operand predicates
     /* 382608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 382612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382616 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382620 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 382624 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382629 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 382633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382639 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382651 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382684 */     GIR_RootConstrainSelectedInstOperands,
     /* 382685 */     // GIR_Coverage, 6133,
     /* 382685 */     GIR_EraseRootFromParent_Done,
     /* 382686 */   // Label 7671: @382686
     /* 382686 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(382821), // Rule ID 2467 //
     /* 382691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382740 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382750 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382750 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382753 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382757 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382762 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382768 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382773 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 382809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382819 */     GIR_RootConstrainSelectedInstOperands,
     /* 382820 */     // GIR_Coverage, 2467,
     /* 382820 */     GIR_EraseRootFromParent_Done,
     /* 382821 */   // Label 7672: @382821
     /* 382821 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(382940), // Rule ID 6037 //
     /* 382826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382850 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382866 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 382879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382883 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382887 */     // MIs[3] Operand 1
     /* 382887 */     // No operand predicates
     /* 382887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382891 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382893 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382905 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 382924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 382935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 382938 */     GIR_RootConstrainSelectedInstOperands,
     /* 382939 */     // GIR_Coverage, 6037,
     /* 382939 */     GIR_EraseRootFromParent_Done,
     /* 382940 */   // Label 7673: @382940
     /* 382940 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(383059), // Rule ID 2557 //
     /* 382945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382981 */     // MIs[2] Operand 1
     /* 382981 */     // No operand predicates
     /* 382981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382993 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382997 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383002 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383012 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383024 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 383043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383057 */     GIR_RootConstrainSelectedInstOperands,
     /* 383058 */     // GIR_Coverage, 2557,
     /* 383058 */     GIR_EraseRootFromParent_Done,
     /* 383059 */   // Label 7674: @383059
     /* 383059 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(383159), // Rule ID 4826 //
     /* 383064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 383104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383115 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383127 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383157 */     GIR_RootConstrainSelectedInstOperands,
     /* 383158 */     // GIR_Coverage, 4826,
     /* 383158 */     GIR_EraseRootFromParent_Done,
     /* 383159 */   // Label 7675: @383159
     /* 383159 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(383259), // Rule ID 4862 //
     /* 383164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383188 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 383200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 383208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383215 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383227 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 383246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 383257 */     GIR_RootConstrainSelectedInstOperands,
     /* 383258 */     // GIR_Coverage, 4862,
     /* 383258 */     GIR_EraseRootFromParent_Done,
     /* 383259 */   // Label 7676: @383259
     /* 383259 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(383356), // Rule ID 13791 //
     /* 383264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383300 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383314 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383326 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383354 */     GIR_RootConstrainSelectedInstOperands,
     /* 383355 */     // GIR_Coverage, 13791,
     /* 383355 */     GIR_EraseRootFromParent_Done,
     /* 383356 */   // Label 7677: @383356
     /* 383356 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(383456), // Rule ID 13793 //
     /* 383361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383402 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383412 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383424 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383454 */     GIR_RootConstrainSelectedInstOperands,
     /* 383455 */     // GIR_Coverage, 13793,
     /* 383455 */     GIR_EraseRootFromParent_Done,
     /* 383456 */   // Label 7678: @383456
     /* 383456 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(383556), // Rule ID 4860 //
     /* 383461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383489 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 383497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 383505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383512 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383524 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 383543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 383554 */     GIR_RootConstrainSelectedInstOperands,
     /* 383555 */     // GIR_Coverage, 4860,
     /* 383555 */     GIR_EraseRootFromParent_Done,
     /* 383556 */   // Label 7679: @383556
     /* 383556 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(383653), // Rule ID 4824 //
     /* 383561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383601 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383611 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383623 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 383646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383651 */     GIR_RootConstrainSelectedInstOperands,
     /* 383652 */     // GIR_Coverage, 4824,
     /* 383652 */     GIR_EraseRootFromParent_Done,
     /* 383653 */   // Label 7680: @383653
     /* 383653 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(383731), // Rule ID 6187 //
     /* 383658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383686 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 383695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 383703 */     // MIs[3] Operand 1
     /* 383703 */     // No operand predicates
     /* 383703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383713 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 383713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383729 */     GIR_RootConstrainSelectedInstOperands,
     /* 383730 */     // GIR_Coverage, 6187,
     /* 383730 */     GIR_EraseRootFromParent_Done,
     /* 383731 */   // Label 7681: @383731
     /* 383731 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(383815), // Rule ID 6099 //
     /* 383736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383768 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383772 */     // MIs[2] Operand 1
     /* 383772 */     // No operand predicates
     /* 383772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 383784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383795 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 383806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383813 */     GIR_RootConstrainSelectedInstOperands,
     /* 383814 */     // GIR_Coverage, 6099,
     /* 383814 */     GIR_EraseRootFromParent_Done,
     /* 383815 */   // Label 7682: @383815
     /* 383815 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(383896), // Rule ID 6131 //
     /* 383820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383864 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383868 */     // MIs[3] Operand 1
     /* 383868 */     // No operand predicates
     /* 383868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383878 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383894 */     GIR_RootConstrainSelectedInstOperands,
     /* 383895 */     // GIR_Coverage, 6131,
     /* 383895 */     GIR_EraseRootFromParent_Done,
     /* 383896 */   // Label 7683: @383896
     /* 383896 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(383980), // Rule ID 6163 //
     /* 383901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383950 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383954 */     // MIs[3] Operand 1
     /* 383954 */     // No operand predicates
     /* 383954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383960 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 383971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383978 */     GIR_RootConstrainSelectedInstOperands,
     /* 383979 */     // GIR_Coverage, 6163,
     /* 383979 */     GIR_EraseRootFromParent_Done,
     /* 383980 */   // Label 7684: @383980
     /* 383980 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(384058), // Rule ID 6209 //
     /* 383985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 383993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384030 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384034 */     // MIs[3] Operand 1
     /* 384034 */     // No operand predicates
     /* 384034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384040 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384056 */     GIR_RootConstrainSelectedInstOperands,
     /* 384057 */     // GIR_Coverage, 6209,
     /* 384057 */     GIR_EraseRootFromParent_Done,
     /* 384058 */   // Label 7685: @384058
     /* 384058 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(384139), // Rule ID 6067 //
     /* 384063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384111 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384115 */     // MIs[3] Operand 1
     /* 384115 */     // No operand predicates
     /* 384115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384121 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384137 */     GIR_RootConstrainSelectedInstOperands,
     /* 384138 */     // GIR_Coverage, 6067,
     /* 384138 */     GIR_EraseRootFromParent_Done,
     /* 384139 */   // Label 7686: @384139
     /* 384139 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(384224), // Rule ID 2465 //
     /* 384144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384168 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384182 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384194 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 384200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 384213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 384220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384222 */     GIR_RootConstrainSelectedInstOperands,
     /* 384223 */     // GIR_Coverage, 2465,
     /* 384223 */     GIR_EraseRootFromParent_Done,
     /* 384224 */   // Label 7687: @384224
     /* 384224 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(384309), // Rule ID 2463 //
     /* 384229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384257 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384267 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 384267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384279 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 384285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 384298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384307 */     GIR_RootConstrainSelectedInstOperands,
     /* 384308 */     // GIR_Coverage, 2463,
     /* 384308 */     GIR_EraseRootFromParent_Done,
     /* 384309 */   // Label 7688: @384309
     /* 384309 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(384378), // Rule ID 2555 //
     /* 384314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384346 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384350 */     // MIs[2] Operand 1
     /* 384350 */     // No operand predicates
     /* 384350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384360 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 384363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384376 */     GIR_RootConstrainSelectedInstOperands,
     /* 384377 */     // GIR_Coverage, 2555,
     /* 384377 */     GIR_EraseRootFromParent_Done,
     /* 384378 */   // Label 7689: @384378
     /* 384378 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(384447), // Rule ID 6035 //
     /* 384383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384419 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384423 */     // MIs[2] Operand 1
     /* 384423 */     // No operand predicates
     /* 384423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384429 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 384432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384445 */     GIR_RootConstrainSelectedInstOperands,
     /* 384446 */     // GIR_Coverage, 6035,
     /* 384446 */     GIR_EraseRootFromParent_Done,
     /* 384447 */   // Label 7690: @384447
     /* 384447 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(384497), // Rule ID 13229 //
     /* 384452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384482 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384495 */     GIR_RootConstrainSelectedInstOperands,
     /* 384496 */     // GIR_Coverage, 13229,
     /* 384496 */     GIR_EraseRootFromParent_Done,
     /* 384497 */   // Label 7691: @384497
     /* 384497 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(384547), // Rule ID 647 //
     /* 384502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384532 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384545 */     GIR_RootConstrainSelectedInstOperands,
     /* 384546 */     // GIR_Coverage, 647,
     /* 384546 */     GIR_EraseRootFromParent_Done,
     /* 384547 */   // Label 7692: @384547
     /* 384547 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(384597), // Rule ID 659 //
     /* 384552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 384567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384582 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 384585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 384591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 384595 */     GIR_RootConstrainSelectedInstOperands,
     /* 384596 */     // GIR_Coverage, 659,
     /* 384596 */     GIR_EraseRootFromParent_Done,
     /* 384597 */   // Label 7693: @384597
     /* 384597 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(384628), // Rule ID 641 //
     /* 384602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384617 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 384622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 384626 */     GIR_RootConstrainSelectedInstOperands,
     /* 384627 */     // GIR_Coverage, 641,
     /* 384627 */     GIR_Done,
     /* 384628 */   // Label 7694: @384628
     /* 384628 */   GIM_Reject,
     /* 384629 */ // Label 7664: @384629
     /* 384629 */ GIM_Reject,
     /* 384630 */ // Label 7598: @384630
     /* 384630 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(386150),
     /* 384635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 384641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 384644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384648 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(384726), // Rule ID 6167 //
     /* 384653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384698 */     // MIs[3] Operand 1
     /* 384698 */     // No operand predicates
     /* 384698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384708 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384724 */     GIR_RootConstrainSelectedInstOperands,
     /* 384725 */     // GIR_Coverage, 6167,
     /* 384725 */     GIR_EraseRootFromParent_Done,
     /* 384726 */   // Label 7696: @384726
     /* 384726 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(384810), // Rule ID 6083 //
     /* 384731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384767 */     // MIs[2] Operand 1
     /* 384767 */     // No operand predicates
     /* 384767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384775 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384788 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384790 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 384801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384808 */     GIR_RootConstrainSelectedInstOperands,
     /* 384809 */     // GIR_Coverage, 6083,
     /* 384809 */     GIR_EraseRootFromParent_Done,
     /* 384810 */   // Label 7697: @384810
     /* 384810 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(384891), // Rule ID 6115 //
     /* 384815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384863 */     // MIs[3] Operand 1
     /* 384863 */     // No operand predicates
     /* 384863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384873 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384889 */     GIR_RootConstrainSelectedInstOperands,
     /* 384890 */     // GIR_Coverage, 6115,
     /* 384890 */     GIR_EraseRootFromParent_Done,
     /* 384891 */   // Label 7698: @384891
     /* 384891 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(384975), // Rule ID 6147 //
     /* 384896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 384911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384941 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384945 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384949 */     // MIs[3] Operand 1
     /* 384949 */     // No operand predicates
     /* 384949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384953 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384955 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 384958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384973 */     GIR_RootConstrainSelectedInstOperands,
     /* 384974 */     // GIR_Coverage, 6147,
     /* 384974 */     GIR_EraseRootFromParent_Done,
     /* 384975 */   // Label 7699: @384975
     /* 384975 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(385053), // Rule ID 6189 //
     /* 384980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 384992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 384996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385029 */     // MIs[3] Operand 1
     /* 385029 */     // No operand predicates
     /* 385029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385035 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385051 */     GIR_RootConstrainSelectedInstOperands,
     /* 385052 */     // GIR_Coverage, 6189,
     /* 385052 */     GIR_EraseRootFromParent_Done,
     /* 385053 */   // Label 7700: @385053
     /* 385053 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(385134), // Rule ID 6051 //
     /* 385058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385110 */     // MIs[3] Operand 1
     /* 385110 */     // No operand predicates
     /* 385110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385116 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385132 */     GIR_RootConstrainSelectedInstOperands,
     /* 385133 */     // GIR_Coverage, 6051,
     /* 385133 */     GIR_EraseRootFromParent_Done,
     /* 385134 */   // Label 7701: @385134
     /* 385134 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(385203), // Rule ID 2539 //
     /* 385139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385171 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385175 */     // MIs[2] Operand 1
     /* 385175 */     // No operand predicates
     /* 385175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385185 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 385188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385201 */     GIR_RootConstrainSelectedInstOperands,
     /* 385202 */     // GIR_Coverage, 2539,
     /* 385202 */     GIR_EraseRootFromParent_Done,
     /* 385203 */   // Label 7702: @385203
     /* 385203 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(385272), // Rule ID 6019 //
     /* 385208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385244 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385248 */     // MIs[2] Operand 1
     /* 385248 */     // No operand predicates
     /* 385248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385254 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 385257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385270 */     GIR_RootConstrainSelectedInstOperands,
     /* 385271 */     // GIR_Coverage, 6019,
     /* 385271 */     GIR_EraseRootFromParent_Done,
     /* 385272 */   // Label 7703: @385272
     /* 385272 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(385365), // Rule ID 6171 //
     /* 385277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385316 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385328 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385363 */     GIR_RootConstrainSelectedInstOperands,
     /* 385364 */     // GIR_Coverage, 6171,
     /* 385364 */     GIR_EraseRootFromParent_Done,
     /* 385365 */   // Label 7704: @385365
     /* 385365 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(385464), // Rule ID 6085 //
     /* 385370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385413 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 385456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385462 */     GIR_RootConstrainSelectedInstOperands,
     /* 385463 */     // GIR_Coverage, 6085,
     /* 385463 */     GIR_EraseRootFromParent_Done,
     /* 385464 */   // Label 7705: @385464
     /* 385464 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(385560), // Rule ID 6117 //
     /* 385469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385511 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385526 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385530 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385533 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385558 */     GIR_RootConstrainSelectedInstOperands,
     /* 385559 */     // GIR_Coverage, 6117,
     /* 385559 */     GIR_EraseRootFromParent_Done,
     /* 385560 */   // Label 7706: @385560
     /* 385560 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(385659), // Rule ID 6149 //
     /* 385565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385608 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385620 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385623 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385627 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385657 */     GIR_RootConstrainSelectedInstOperands,
     /* 385658 */     // GIR_Coverage, 6149,
     /* 385658 */     GIR_EraseRootFromParent_Done,
     /* 385659 */   // Label 7707: @385659
     /* 385659 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(385752), // Rule ID 6193 //
     /* 385664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385703 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385750 */     GIR_RootConstrainSelectedInstOperands,
     /* 385751 */     // GIR_Coverage, 6193,
     /* 385751 */     GIR_EraseRootFromParent_Done,
     /* 385752 */   // Label 7708: @385752
     /* 385752 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(385848), // Rule ID 6053 //
     /* 385757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 385784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385799 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385811 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385818 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385846 */     GIR_RootConstrainSelectedInstOperands,
     /* 385847 */     // GIR_Coverage, 6053,
     /* 385847 */     GIR_EraseRootFromParent_Done,
     /* 385848 */   // Label 7709: @385848
     /* 385848 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(385932), // Rule ID 2541 //
     /* 385853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385883 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385905 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 385918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385930 */     GIR_RootConstrainSelectedInstOperands,
     /* 385931 */     // GIR_Coverage, 2541,
     /* 385931 */     GIR_EraseRootFromParent_Done,
     /* 385932 */   // Label 7710: @385932
     /* 385932 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(385982), // Rule ID 13259 //
     /* 385937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385967 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 385967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 385970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385980 */     GIR_RootConstrainSelectedInstOperands,
     /* 385981 */     // GIR_Coverage, 13259,
     /* 385981 */     GIR_EraseRootFromParent_Done,
     /* 385982 */   // Label 7711: @385982
     /* 385982 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(386066), // Rule ID 6021 //
     /* 385987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386017 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 386052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386064 */     GIR_RootConstrainSelectedInstOperands,
     /* 386065 */     // GIR_Coverage, 6021,
     /* 386065 */     GIR_EraseRootFromParent_Done,
     /* 386066 */   // Label 7712: @386066
     /* 386066 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(386116), // Rule ID 1307 //
     /* 386071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386101 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 386101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 386104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386114 */     GIR_RootConstrainSelectedInstOperands,
     /* 386115 */     // GIR_Coverage, 1307,
     /* 386115 */     GIR_EraseRootFromParent_Done,
     /* 386116 */   // Label 7713: @386116
     /* 386116 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(386149), // Rule ID 1297 //
     /* 386121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386136 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 386136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 386139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 386147 */     GIR_RootConstrainSelectedInstOperands,
     /* 386148 */     // GIR_Coverage, 1297,
     /* 386148 */     GIR_EraseRootFromParent_Done,
     /* 386149 */   // Label 7714: @386149
     /* 386149 */   GIM_Reject,
     /* 386150 */ // Label 7695: @386150
     /* 386150 */ GIM_Reject,
     /* 386151 */ // Label 7599: @386151
     /* 386151 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(387671),
     /* 386156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 386162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 386165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386169 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(386247), // Rule ID 6179 //
     /* 386174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 386211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386215 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386219 */     // MIs[3] Operand 1
     /* 386219 */     // No operand predicates
     /* 386219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386229 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386245 */     GIR_RootConstrainSelectedInstOperands,
     /* 386246 */     // GIR_Coverage, 6179,
     /* 386246 */     GIR_EraseRootFromParent_Done,
     /* 386247 */   // Label 7716: @386247
     /* 386247 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(386331), // Rule ID 6091 //
     /* 386252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386288 */     // MIs[2] Operand 1
     /* 386288 */     // No operand predicates
     /* 386288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 386292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386300 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386311 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 386322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386329 */     GIR_RootConstrainSelectedInstOperands,
     /* 386330 */     // GIR_Coverage, 6091,
     /* 386330 */     GIR_EraseRootFromParent_Done,
     /* 386331 */   // Label 7717: @386331
     /* 386331 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(386412), // Rule ID 6123 //
     /* 386336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386380 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386384 */     // MIs[3] Operand 1
     /* 386384 */     // No operand predicates
     /* 386384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386394 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386410 */     GIR_RootConstrainSelectedInstOperands,
     /* 386411 */     // GIR_Coverage, 6123,
     /* 386411 */     GIR_EraseRootFromParent_Done,
     /* 386412 */   // Label 7718: @386412
     /* 386412 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(386496), // Rule ID 6155 //
     /* 386417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386470 */     // MIs[3] Operand 1
     /* 386470 */     // No operand predicates
     /* 386470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386476 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386494 */     GIR_RootConstrainSelectedInstOperands,
     /* 386495 */     // GIR_Coverage, 6155,
     /* 386495 */     GIR_EraseRootFromParent_Done,
     /* 386496 */   // Label 7719: @386496
     /* 386496 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(386574), // Rule ID 6201 //
     /* 386501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 386542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386546 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386550 */     // MIs[3] Operand 1
     /* 386550 */     // No operand predicates
     /* 386550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386556 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386572 */     GIR_RootConstrainSelectedInstOperands,
     /* 386573 */     // GIR_Coverage, 6201,
     /* 386573 */     GIR_EraseRootFromParent_Done,
     /* 386574 */   // Label 7720: @386574
     /* 386574 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(386655), // Rule ID 6059 //
     /* 386579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386627 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386631 */     // MIs[3] Operand 1
     /* 386631 */     // No operand predicates
     /* 386631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386635 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386637 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386653 */     GIR_RootConstrainSelectedInstOperands,
     /* 386654 */     // GIR_Coverage, 6059,
     /* 386654 */     GIR_EraseRootFromParent_Done,
     /* 386655 */   // Label 7721: @386655
     /* 386655 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(386724), // Rule ID 2547 //
     /* 386660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386696 */     // MIs[2] Operand 1
     /* 386696 */     // No operand predicates
     /* 386696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386706 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 386709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386722 */     GIR_RootConstrainSelectedInstOperands,
     /* 386723 */     // GIR_Coverage, 2547,
     /* 386723 */     GIR_EraseRootFromParent_Done,
     /* 386724 */   // Label 7722: @386724
     /* 386724 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(386793), // Rule ID 6027 //
     /* 386729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386769 */     // MIs[2] Operand 1
     /* 386769 */     // No operand predicates
     /* 386769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386775 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 386778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386791 */     GIR_RootConstrainSelectedInstOperands,
     /* 386792 */     // GIR_Coverage, 6027,
     /* 386792 */     GIR_EraseRootFromParent_Done,
     /* 386793 */   // Label 7723: @386793
     /* 386793 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(386886), // Rule ID 6181 //
     /* 386798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 386822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386837 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386856 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 386859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386884 */     GIR_RootConstrainSelectedInstOperands,
     /* 386885 */     // GIR_Coverage, 6181,
     /* 386885 */     GIR_EraseRootFromParent_Done,
     /* 386886 */   // Label 7724: @386886
     /* 386886 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(386985), // Rule ID 6093 //
     /* 386891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 386906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386934 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386946 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386953 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 386956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 386977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386983 */     GIR_RootConstrainSelectedInstOperands,
     /* 386984 */     // GIR_Coverage, 6093,
     /* 386984 */     GIR_EraseRootFromParent_Done,
     /* 386985 */   // Label 7725: @386985
     /* 386985 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(387081), // Rule ID 6125 //
     /* 386990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387032 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387044 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387054 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387059 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387079 */     GIR_RootConstrainSelectedInstOperands,
     /* 387080 */     // GIR_Coverage, 6125,
     /* 387080 */     GIR_EraseRootFromParent_Done,
     /* 387081 */   // Label 7726: @387081
     /* 387081 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(387180), // Rule ID 6157 //
     /* 387086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387129 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387141 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387178 */     GIR_RootConstrainSelectedInstOperands,
     /* 387179 */     // GIR_Coverage, 6157,
     /* 387179 */     GIR_EraseRootFromParent_Done,
     /* 387180 */   // Label 7727: @387180
     /* 387180 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(387273), // Rule ID 6203 //
     /* 387185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387222 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387224 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387271 */     GIR_RootConstrainSelectedInstOperands,
     /* 387272 */     // GIR_Coverage, 6203,
     /* 387272 */     GIR_EraseRootFromParent_Done,
     /* 387273 */   // Label 7728: @387273
     /* 387273 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(387369), // Rule ID 6061 //
     /* 387278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387320 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387367 */     GIR_RootConstrainSelectedInstOperands,
     /* 387368 */     // GIR_Coverage, 6061,
     /* 387368 */     GIR_EraseRootFromParent_Done,
     /* 387369 */   // Label 7729: @387369
     /* 387369 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(387453), // Rule ID 2549 //
     /* 387374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387404 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387416 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387423 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387451 */     GIR_RootConstrainSelectedInstOperands,
     /* 387452 */     // GIR_Coverage, 2549,
     /* 387452 */     GIR_EraseRootFromParent_Done,
     /* 387453 */   // Label 7730: @387453
     /* 387453 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(387503), // Rule ID 13263 //
     /* 387458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387488 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 387488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 387491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387501 */     GIR_RootConstrainSelectedInstOperands,
     /* 387502 */     // GIR_Coverage, 13263,
     /* 387502 */     GIR_EraseRootFromParent_Done,
     /* 387503 */   // Label 7731: @387503
     /* 387503 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(387587), // Rule ID 6029 //
     /* 387508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387538 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387557 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387585 */     GIR_RootConstrainSelectedInstOperands,
     /* 387586 */     // GIR_Coverage, 6029,
     /* 387586 */     GIR_EraseRootFromParent_Done,
     /* 387587 */   // Label 7732: @387587
     /* 387587 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(387637), // Rule ID 1311 //
     /* 387592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387622 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 387622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 387625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387635 */     GIR_RootConstrainSelectedInstOperands,
     /* 387636 */     // GIR_Coverage, 1311,
     /* 387636 */     GIR_EraseRootFromParent_Done,
     /* 387637 */   // Label 7733: @387637
     /* 387637 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(387670), // Rule ID 1301 //
     /* 387642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387657 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 387657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 387660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 387668 */     GIR_RootConstrainSelectedInstOperands,
     /* 387669 */     // GIR_Coverage, 1301,
     /* 387669 */     GIR_EraseRootFromParent_Done,
     /* 387670 */   // Label 7734: @387670
     /* 387670 */   GIM_Reject,
     /* 387671 */ // Label 7715: @387671
     /* 387671 */ GIM_Reject,
     /* 387672 */ // Label 7600: @387672
     /* 387672 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(388850),
     /* 387677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 387683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 387686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387690 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(387774), // Rule ID 6075 //
     /* 387695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387727 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387731 */     // MIs[2] Operand 1
     /* 387731 */     // No operand predicates
     /* 387731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 387735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387739 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387743 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387754 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 387765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387772 */     GIR_RootConstrainSelectedInstOperands,
     /* 387773 */     // GIR_Coverage, 6075,
     /* 387773 */     GIR_EraseRootFromParent_Done,
     /* 387774 */   // Label 7736: @387774
     /* 387774 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(387855), // Rule ID 6107 //
     /* 387779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387827 */     // MIs[3] Operand 1
     /* 387827 */     // No operand predicates
     /* 387827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387837 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387853 */     GIR_RootConstrainSelectedInstOperands,
     /* 387854 */     // GIR_Coverage, 6107,
     /* 387854 */     GIR_EraseRootFromParent_Done,
     /* 387855 */   // Label 7737: @387855
     /* 387855 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(387939), // Rule ID 6139 //
     /* 387860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387905 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387909 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387913 */     // MIs[3] Operand 1
     /* 387913 */     // No operand predicates
     /* 387913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387919 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 387919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 387922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387937 */     GIR_RootConstrainSelectedInstOperands,
     /* 387938 */     // GIR_Coverage, 6139,
     /* 387938 */     GIR_EraseRootFromParent_Done,
     /* 387939 */   // Label 7738: @387939
     /* 387939 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(388020), // Rule ID 6043 //
     /* 387944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 387947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 387963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 387971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387975 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 387984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387992 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387996 */     // MIs[3] Operand 1
     /* 387996 */     // No operand predicates
     /* 387996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388002 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388018 */     GIR_RootConstrainSelectedInstOperands,
     /* 388019 */     // GIR_Coverage, 6043,
     /* 388019 */     GIR_EraseRootFromParent_Done,
     /* 388020 */   // Label 7739: @388020
     /* 388020 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(388089), // Rule ID 2531 //
     /* 388025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388057 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388061 */     // MIs[2] Operand 1
     /* 388061 */     // No operand predicates
     /* 388061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388071 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388087 */     GIR_RootConstrainSelectedInstOperands,
     /* 388088 */     // GIR_Coverage, 2531,
     /* 388088 */     GIR_EraseRootFromParent_Done,
     /* 388089 */   // Label 7740: @388089
     /* 388089 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(388158), // Rule ID 6011 //
     /* 388094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388134 */     // MIs[2] Operand 1
     /* 388134 */     // No operand predicates
     /* 388134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388140 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388156 */     GIR_RootConstrainSelectedInstOperands,
     /* 388157 */     // GIR_Coverage, 6011,
     /* 388157 */     GIR_EraseRootFromParent_Done,
     /* 388158 */   // Label 7741: @388158
     /* 388158 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(388257), // Rule ID 6077 //
     /* 388163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388206 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 388249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388255 */     GIR_RootConstrainSelectedInstOperands,
     /* 388256 */     // GIR_Coverage, 6077,
     /* 388256 */     GIR_EraseRootFromParent_Done,
     /* 388257 */   // Label 7742: @388257
     /* 388257 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(388353), // Rule ID 6109 //
     /* 388262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388304 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388323 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388351 */     GIR_RootConstrainSelectedInstOperands,
     /* 388352 */     // GIR_Coverage, 6109,
     /* 388352 */     GIR_EraseRootFromParent_Done,
     /* 388353 */   // Label 7743: @388353
     /* 388353 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(388452), // Rule ID 6141 //
     /* 388358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388401 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388420 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388450 */     GIR_RootConstrainSelectedInstOperands,
     /* 388451 */     // GIR_Coverage, 6141,
     /* 388451 */     GIR_EraseRootFromParent_Done,
     /* 388452 */   // Label 7744: @388452
     /* 388452 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(388548), // Rule ID 6045 //
     /* 388457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388499 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388511 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388518 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388521 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388546 */     GIR_RootConstrainSelectedInstOperands,
     /* 388547 */     // GIR_Coverage, 6045,
     /* 388547 */     GIR_EraseRootFromParent_Done,
     /* 388548 */   // Label 7745: @388548
     /* 388548 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(388632), // Rule ID 2533 //
     /* 388553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388583 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388602 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388630 */     GIR_RootConstrainSelectedInstOperands,
     /* 388631 */     // GIR_Coverage, 2533,
     /* 388631 */     GIR_EraseRootFromParent_Done,
     /* 388632 */   // Label 7746: @388632
     /* 388632 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(388682), // Rule ID 13255 //
     /* 388637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388667 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 388670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388680 */     GIR_RootConstrainSelectedInstOperands,
     /* 388681 */     // GIR_Coverage, 13255,
     /* 388681 */     GIR_EraseRootFromParent_Done,
     /* 388682 */   // Label 7747: @388682
     /* 388682 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(388766), // Rule ID 6013 //
     /* 388687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388717 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388732 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388736 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388764 */     GIR_RootConstrainSelectedInstOperands,
     /* 388765 */     // GIR_Coverage, 6013,
     /* 388765 */     GIR_EraseRootFromParent_Done,
     /* 388766 */   // Label 7748: @388766
     /* 388766 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(388816), // Rule ID 1303 //
     /* 388771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388801 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 388804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388814 */     GIR_RootConstrainSelectedInstOperands,
     /* 388815 */     // GIR_Coverage, 1303,
     /* 388815 */     GIR_EraseRootFromParent_Done,
     /* 388816 */   // Label 7749: @388816
     /* 388816 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(388849), // Rule ID 1293 //
     /* 388821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388836 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 388836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 388839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 388847 */     GIR_RootConstrainSelectedInstOperands,
     /* 388848 */     // GIR_Coverage, 1293,
     /* 388848 */     GIR_EraseRootFromParent_Done,
     /* 388849 */   // Label 7750: @388849
     /* 388849 */   GIM_Reject,
     /* 388850 */ // Label 7735: @388850
     /* 388850 */ GIM_Reject,
     /* 388851 */ // Label 7601: @388851
     /* 388851 */ GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(390371),
     /* 388856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 388862 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 388865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388869 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(388947), // Rule ID 6173 //
     /* 388874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 388911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388915 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388919 */     // MIs[3] Operand 1
     /* 388919 */     // No operand predicates
     /* 388919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388927 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388929 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 388932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388945 */     GIR_RootConstrainSelectedInstOperands,
     /* 388946 */     // GIR_Coverage, 6173,
     /* 388946 */     GIR_EraseRootFromParent_Done,
     /* 388947 */   // Label 7752: @388947
     /* 388947 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(389031), // Rule ID 6087 //
     /* 388952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 388963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388984 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388988 */     // MIs[2] Operand 1
     /* 388988 */     // No operand predicates
     /* 388988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 388992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389000 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389011 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 389022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389029 */     GIR_RootConstrainSelectedInstOperands,
     /* 389030 */     // GIR_Coverage, 6087,
     /* 389030 */     GIR_EraseRootFromParent_Done,
     /* 389031 */   // Label 7753: @389031
     /* 389031 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(389112), // Rule ID 6119 //
     /* 389036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389080 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389084 */     // MIs[3] Operand 1
     /* 389084 */     // No operand predicates
     /* 389084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389094 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389110 */     GIR_RootConstrainSelectedInstOperands,
     /* 389111 */     // GIR_Coverage, 6119,
     /* 389111 */     GIR_EraseRootFromParent_Done,
     /* 389112 */   // Label 7754: @389112
     /* 389112 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(389196), // Rule ID 6151 //
     /* 389117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389149 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389166 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389170 */     // MIs[3] Operand 1
     /* 389170 */     // No operand predicates
     /* 389170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389174 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389176 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389194 */     GIR_RootConstrainSelectedInstOperands,
     /* 389195 */     // GIR_Coverage, 6151,
     /* 389195 */     GIR_EraseRootFromParent_Done,
     /* 389196 */   // Label 7755: @389196
     /* 389196 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(389274), // Rule ID 6195 //
     /* 389201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389246 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389250 */     // MIs[3] Operand 1
     /* 389250 */     // No operand predicates
     /* 389250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389256 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389272 */     GIR_RootConstrainSelectedInstOperands,
     /* 389273 */     // GIR_Coverage, 6195,
     /* 389273 */     GIR_EraseRootFromParent_Done,
     /* 389274 */   // Label 7756: @389274
     /* 389274 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(389355), // Rule ID 6055 //
     /* 389279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389310 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389327 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389331 */     // MIs[3] Operand 1
     /* 389331 */     // No operand predicates
     /* 389331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389335 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389337 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389353 */     GIR_RootConstrainSelectedInstOperands,
     /* 389354 */     // GIR_Coverage, 6055,
     /* 389354 */     GIR_EraseRootFromParent_Done,
     /* 389355 */   // Label 7757: @389355
     /* 389355 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(389424), // Rule ID 2543 //
     /* 389360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389396 */     // MIs[2] Operand 1
     /* 389396 */     // No operand predicates
     /* 389396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389406 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 389409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389422 */     GIR_RootConstrainSelectedInstOperands,
     /* 389423 */     // GIR_Coverage, 2543,
     /* 389423 */     GIR_EraseRootFromParent_Done,
     /* 389424 */   // Label 7758: @389424
     /* 389424 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(389493), // Rule ID 6023 //
     /* 389429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389465 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389469 */     // MIs[2] Operand 1
     /* 389469 */     // No operand predicates
     /* 389469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389475 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 389478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389491 */     GIR_RootConstrainSelectedInstOperands,
     /* 389492 */     // GIR_Coverage, 6023,
     /* 389492 */     GIR_EraseRootFromParent_Done,
     /* 389493 */   // Label 7759: @389493
     /* 389493 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(389586), // Rule ID 6177 //
     /* 389498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389537 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389556 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389584 */     GIR_RootConstrainSelectedInstOperands,
     /* 389585 */     // GIR_Coverage, 6177,
     /* 389585 */     GIR_EraseRootFromParent_Done,
     /* 389586 */   // Label 7760: @389586
     /* 389586 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(389685), // Rule ID 6089 //
     /* 389591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389634 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389649 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389653 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 389677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389683 */     GIR_RootConstrainSelectedInstOperands,
     /* 389684 */     // GIR_Coverage, 6089,
     /* 389684 */     GIR_EraseRootFromParent_Done,
     /* 389685 */   // Label 7761: @389685
     /* 389685 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(389781), // Rule ID 6121 //
     /* 389690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389732 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389779 */     GIR_RootConstrainSelectedInstOperands,
     /* 389780 */     // GIR_Coverage, 6121,
     /* 389780 */     GIR_EraseRootFromParent_Done,
     /* 389781 */   // Label 7762: @389781
     /* 389781 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(389880), // Rule ID 6153 //
     /* 389786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389829 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389841 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389848 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389878 */     GIR_RootConstrainSelectedInstOperands,
     /* 389879 */     // GIR_Coverage, 6153,
     /* 389879 */     GIR_EraseRootFromParent_Done,
     /* 389880 */   // Label 7763: @389880
     /* 389880 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(389973), // Rule ID 6199 //
     /* 389885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 389901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 389913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389924 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389971 */     GIR_RootConstrainSelectedInstOperands,
     /* 389972 */     // GIR_Coverage, 6199,
     /* 389972 */     GIR_EraseRootFromParent_Done,
     /* 389973 */   // Label 7764: @389973
     /* 389973 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(390069), // Rule ID 6057 //
     /* 389978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390020 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390032 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390067 */     GIR_RootConstrainSelectedInstOperands,
     /* 390068 */     // GIR_Coverage, 6057,
     /* 390068 */     GIR_EraseRootFromParent_Done,
     /* 390069 */   // Label 7765: @390069
     /* 390069 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(390153), // Rule ID 2545 //
     /* 390074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390104 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390116 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390119 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390123 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 390139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390151 */     GIR_RootConstrainSelectedInstOperands,
     /* 390152 */     // GIR_Coverage, 2545,
     /* 390152 */     GIR_EraseRootFromParent_Done,
     /* 390153 */   // Label 7766: @390153
     /* 390153 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(390203), // Rule ID 13261 //
     /* 390158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390188 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 390191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390201 */     GIR_RootConstrainSelectedInstOperands,
     /* 390202 */     // GIR_Coverage, 13261,
     /* 390202 */     GIR_EraseRootFromParent_Done,
     /* 390203 */   // Label 7767: @390203
     /* 390203 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(390287), // Rule ID 6025 //
     /* 390208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390238 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 390273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390285 */     GIR_RootConstrainSelectedInstOperands,
     /* 390286 */     // GIR_Coverage, 6025,
     /* 390286 */     GIR_EraseRootFromParent_Done,
     /* 390287 */   // Label 7768: @390287
     /* 390287 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(390337), // Rule ID 1309 //
     /* 390292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390322 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 390325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390335 */     GIR_RootConstrainSelectedInstOperands,
     /* 390336 */     // GIR_Coverage, 1309,
     /* 390336 */     GIR_EraseRootFromParent_Done,
     /* 390337 */   // Label 7769: @390337
     /* 390337 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(390370), // Rule ID 1299 //
     /* 390342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390357 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 390360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 390368 */     GIR_RootConstrainSelectedInstOperands,
     /* 390369 */     // GIR_Coverage, 1299,
     /* 390369 */     GIR_EraseRootFromParent_Done,
     /* 390370 */   // Label 7770: @390370
     /* 390370 */   GIM_Reject,
     /* 390371 */ // Label 7751: @390371
     /* 390371 */ GIM_Reject,
     /* 390372 */ // Label 7602: @390372
     /* 390372 */ GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(391550),
     /* 390377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 390386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390390 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(390474), // Rule ID 6071 //
     /* 390395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390427 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390431 */     // MIs[2] Operand 1
     /* 390431 */     // No operand predicates
     /* 390431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 390435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390443 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390454 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 390465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390472 */     GIR_RootConstrainSelectedInstOperands,
     /* 390473 */     // GIR_Coverage, 6071,
     /* 390473 */     GIR_EraseRootFromParent_Done,
     /* 390474 */   // Label 7772: @390474
     /* 390474 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(390555), // Rule ID 6103 //
     /* 390479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390523 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390527 */     // MIs[3] Operand 1
     /* 390527 */     // No operand predicates
     /* 390527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390537 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390553 */     GIR_RootConstrainSelectedInstOperands,
     /* 390554 */     // GIR_Coverage, 6103,
     /* 390554 */     GIR_EraseRootFromParent_Done,
     /* 390555 */   // Label 7773: @390555
     /* 390555 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(390639), // Rule ID 6135 //
     /* 390560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390613 */     // MIs[3] Operand 1
     /* 390613 */     // No operand predicates
     /* 390613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390619 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390637 */     GIR_RootConstrainSelectedInstOperands,
     /* 390638 */     // GIR_Coverage, 6135,
     /* 390638 */     GIR_EraseRootFromParent_Done,
     /* 390639 */   // Label 7774: @390639
     /* 390639 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(390720), // Rule ID 6039 //
     /* 390644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 390679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 390688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390692 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390696 */     // MIs[3] Operand 1
     /* 390696 */     // No operand predicates
     /* 390696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390700 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390702 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 390718 */     GIR_RootConstrainSelectedInstOperands,
     /* 390719 */     // GIR_Coverage, 6039,
     /* 390719 */     GIR_EraseRootFromParent_Done,
     /* 390720 */   // Label 7775: @390720
     /* 390720 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(390789), // Rule ID 2527 //
     /* 390725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390757 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390761 */     // MIs[2] Operand 1
     /* 390761 */     // No operand predicates
     /* 390761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390771 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 390774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390787 */     GIR_RootConstrainSelectedInstOperands,
     /* 390788 */     // GIR_Coverage, 2527,
     /* 390788 */     GIR_EraseRootFromParent_Done,
     /* 390789 */   // Label 7776: @390789
     /* 390789 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(390858), // Rule ID 6007 //
     /* 390794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390830 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390834 */     // MIs[2] Operand 1
     /* 390834 */     // No operand predicates
     /* 390834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390840 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 390843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390856 */     GIR_RootConstrainSelectedInstOperands,
     /* 390857 */     // GIR_Coverage, 6007,
     /* 390857 */     GIR_EraseRootFromParent_Done,
     /* 390858 */   // Label 7777: @390858
     /* 390858 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(390957), // Rule ID 6073 //
     /* 390863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 390878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390906 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 390909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390918 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 390949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390955 */     GIR_RootConstrainSelectedInstOperands,
     /* 390956 */     // GIR_Coverage, 6073,
     /* 390956 */     GIR_EraseRootFromParent_Done,
     /* 390957 */   // Label 7778: @390957
     /* 390957 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(391053), // Rule ID 6105 //
     /* 390962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 390989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 390994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391004 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391051 */     GIR_RootConstrainSelectedInstOperands,
     /* 391052 */     // GIR_Coverage, 6105,
     /* 391052 */     GIR_EraseRootFromParent_Done,
     /* 391053 */   // Label 7779: @391053
     /* 391053 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(391152), // Rule ID 6137 //
     /* 391058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391101 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391113 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391120 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391150 */     GIR_RootConstrainSelectedInstOperands,
     /* 391151 */     // GIR_Coverage, 6137,
     /* 391151 */     GIR_EraseRootFromParent_Done,
     /* 391152 */   // Label 7780: @391152
     /* 391152 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(391248), // Rule ID 6041 //
     /* 391157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391199 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391246 */     GIR_RootConstrainSelectedInstOperands,
     /* 391247 */     // GIR_Coverage, 6041,
     /* 391247 */     GIR_EraseRootFromParent_Done,
     /* 391248 */   // Label 7781: @391248
     /* 391248 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(391332), // Rule ID 2529 //
     /* 391253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391283 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391295 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391302 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391330 */     GIR_RootConstrainSelectedInstOperands,
     /* 391331 */     // GIR_Coverage, 2529,
     /* 391331 */     GIR_EraseRootFromParent_Done,
     /* 391332 */   // Label 7782: @391332
     /* 391332 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(391382), // Rule ID 13257 //
     /* 391337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391367 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 391370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391380 */     GIR_RootConstrainSelectedInstOperands,
     /* 391381 */     // GIR_Coverage, 13257,
     /* 391381 */     GIR_EraseRootFromParent_Done,
     /* 391382 */   // Label 7783: @391382
     /* 391382 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(391466), // Rule ID 6009 //
     /* 391387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391417 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391429 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391436 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391464 */     GIR_RootConstrainSelectedInstOperands,
     /* 391465 */     // GIR_Coverage, 6009,
     /* 391465 */     GIR_EraseRootFromParent_Done,
     /* 391466 */   // Label 7784: @391466
     /* 391466 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(391516), // Rule ID 1305 //
     /* 391471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391501 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 391504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391514 */     GIR_RootConstrainSelectedInstOperands,
     /* 391515 */     // GIR_Coverage, 1305,
     /* 391515 */     GIR_EraseRootFromParent_Done,
     /* 391516 */   // Label 7785: @391516
     /* 391516 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(391549), // Rule ID 1295 //
     /* 391521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391536 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 391539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 391547 */     GIR_RootConstrainSelectedInstOperands,
     /* 391548 */     // GIR_Coverage, 1295,
     /* 391548 */     GIR_EraseRootFromParent_Done,
     /* 391549 */   // Label 7786: @391549
     /* 391549 */   GIM_Reject,
     /* 391550 */ // Label 7771: @391550
     /* 391550 */ GIM_Reject,
     /* 391551 */ // Label 7603: @391551
     /* 391551 */ GIM_Reject,
     /* 391552 */ // Label 106: @391552
     /* 391552 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7795*/ GIMT_Encode4(391851),
     /* 391563 */ /*GILLT_s16*//*Label 7787*/ GIMT_Encode4(391603),
     /* 391567 */ /*GILLT_s32*//*Label 7788*/ GIMT_Encode4(391634),
     /* 391571 */ /*GILLT_s64*//*Label 7789*/ GIMT_Encode4(391665), GIMT_Encode4(0),
     /* 391579 */ /*GILLT_v2s32*//*Label 7790*/ GIMT_Encode4(391696),
     /* 391583 */ /*GILLT_v2s64*//*Label 7791*/ GIMT_Encode4(391727),
     /* 391587 */ /*GILLT_v4s16*//*Label 7792*/ GIMT_Encode4(391758),
     /* 391591 */ /*GILLT_v4s32*//*Label 7793*/ GIMT_Encode4(391789), GIMT_Encode4(0),
     /* 391599 */ /*GILLT_v8s16*//*Label 7794*/ GIMT_Encode4(391820),
     /* 391603 */ // Label 7787: @391603
     /* 391603 */ GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(391633), // Rule ID 569 //
     /* 391608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 391611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391622 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 391622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 391627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391631 */   GIR_RootConstrainSelectedInstOperands,
     /* 391632 */   // GIR_Coverage, 569,
     /* 391632 */   GIR_Done,
     /* 391633 */ // Label 7796: @391633
     /* 391633 */ GIM_Reject,
     /* 391634 */ // Label 7788: @391634
     /* 391634 */ GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(391664), // Rule ID 571 //
     /* 391639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391653 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 391653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 391658 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391662 */   GIR_RootConstrainSelectedInstOperands,
     /* 391663 */   // GIR_Coverage, 571,
     /* 391663 */   GIR_Done,
     /* 391664 */ // Label 7797: @391664
     /* 391664 */ GIM_Reject,
     /* 391665 */ // Label 7789: @391665
     /* 391665 */ GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(391695), // Rule ID 573 //
     /* 391670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 391673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391684 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 391684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 391689 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391693 */   GIR_RootConstrainSelectedInstOperands,
     /* 391694 */   // GIR_Coverage, 573,
     /* 391694 */   GIR_Done,
     /* 391695 */ // Label 7798: @391695
     /* 391695 */ GIM_Reject,
     /* 391696 */ // Label 7790: @391696
     /* 391696 */ GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(391726), // Rule ID 959 //
     /* 391701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391715 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 391715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 391720 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391724 */   GIR_RootConstrainSelectedInstOperands,
     /* 391725 */   // GIR_Coverage, 959,
     /* 391725 */   GIR_Done,
     /* 391726 */ // Label 7799: @391726
     /* 391726 */ GIM_Reject,
     /* 391727 */ // Label 7791: @391727
     /* 391727 */ GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(391757), // Rule ID 963 //
     /* 391732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 391738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391746 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 391746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 391751 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391755 */   GIR_RootConstrainSelectedInstOperands,
     /* 391756 */   // GIR_Coverage, 963,
     /* 391756 */   GIR_Done,
     /* 391757 */ // Label 7800: @391757
     /* 391757 */ GIM_Reject,
     /* 391758 */ // Label 7792: @391758
     /* 391758 */ GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(391788), // Rule ID 955 //
     /* 391763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391777 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 391777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 391782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391786 */   GIR_RootConstrainSelectedInstOperands,
     /* 391787 */   // GIR_Coverage, 955,
     /* 391787 */   GIR_Done,
     /* 391788 */ // Label 7801: @391788
     /* 391788 */ GIM_Reject,
     /* 391789 */ // Label 7793: @391789
     /* 391789 */ GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(391819), // Rule ID 961 //
     /* 391794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391808 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 391808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 391813 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391817 */   GIR_RootConstrainSelectedInstOperands,
     /* 391818 */   // GIR_Coverage, 961,
     /* 391818 */   GIR_Done,
     /* 391819 */ // Label 7802: @391819
     /* 391819 */ GIM_Reject,
     /* 391820 */ // Label 7794: @391820
     /* 391820 */ GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(391850), // Rule ID 957 //
     /* 391825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391839 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 391839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 391844 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 391848 */   GIR_RootConstrainSelectedInstOperands,
     /* 391849 */   // GIR_Coverage, 957,
     /* 391849 */   GIR_Done,
     /* 391850 */ // Label 7803: @391850
     /* 391850 */ GIM_Reject,
     /* 391851 */ // Label 7795: @391851
     /* 391851 */ GIM_Reject,
     /* 391852 */ // Label 107: @391852
     /* 391852 */ GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(391865), // Rule ID 6486 //
     /* 391857 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 391857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 391860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 391863 */   GIR_RootConstrainSelectedInstOperands,
     /* 391864 */   // GIR_Coverage, 6486,
     /* 391864 */   GIR_EraseRootFromParent_Done,
     /* 391865 */ // Label 7804: @391865
     /* 391865 */ GIM_Reject,
     /* 391866 */ // Label 108: @391866
     /* 391866 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(391886), // Rule ID 6487 //
     /* 391871 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 391871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 391874 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 391884 */   GIR_RootConstrainSelectedInstOperands,
     /* 391885 */   // GIR_Coverage, 6487,
     /* 391885 */   GIR_EraseRootFromParent_Done,
     /* 391886 */ // Label 7805: @391886
     /* 391886 */ GIM_Reject,
     /* 391887 */ // Label 109: @391887
     /* 391887 */ GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(391911), // Rule ID 6488 //
     /* 391892 */   // MIs[0] kind
     /* 391892 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 391895 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 391900 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 391900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 391903 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 391909 */   GIR_RootConstrainSelectedInstOperands,
     /* 391910 */   // GIR_Coverage, 6488,
     /* 391910 */   GIR_EraseRootFromParent_Done,
     /* 391911 */ // Label 7806: @391911
     /* 391911 */ GIM_Reject,
     /* 391912 */ // Label 110: @391912
     /* 391912 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7810*/ GIMT_Encode4(392221),
     /* 391923 */ /*GILLT_s16*//*Label 7807*/ GIMT_Encode4(391935),
     /* 391927 */ /*GILLT_s32*//*Label 7808*/ GIMT_Encode4(392088),
     /* 391931 */ /*GILLT_s64*//*Label 7809*/ GIMT_Encode4(392193),
     /* 391935 */ // Label 7807: @391935
     /* 391935 */ GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(392036), // Rule ID 5591 //
     /* 391940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 391943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391954 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 391954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 391957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 391961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391966 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391970 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 391976 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 391979 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 391983 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391988 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 391991 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392009 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 392016 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 392029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392034 */   GIR_RootConstrainSelectedInstOperands,
     /* 392035 */   // GIR_Coverage, 5591,
     /* 392035 */   GIR_EraseRootFromParent_Done,
     /* 392036 */ // Label 7811: @392036
     /* 392036 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(392087), // Rule ID 5592 //
     /* 392041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392055 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 392055 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392058 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 392062 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392067 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 392080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392085 */   GIR_RootConstrainSelectedInstOperands,
     /* 392086 */   // GIR_Coverage, 5592,
     /* 392086 */   GIR_EraseRootFromParent_Done,
     /* 392087 */ // Label 7812: @392087
     /* 392087 */ GIM_Reject,
     /* 392088 */ // Label 7808: @392088
     /* 392088 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(392165), // Rule ID 5593 //
     /* 392093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392104 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 392104 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392107 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 392111 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392116 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392120 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392126 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392129 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392133 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392138 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 392145 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392150 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 392158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392163 */   GIR_RootConstrainSelectedInstOperands,
     /* 392164 */   // GIR_Coverage, 5593,
     /* 392164 */   GIR_EraseRootFromParent_Done,
     /* 392165 */ // Label 7813: @392165
     /* 392165 */ GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(392192), // Rule ID 5594 //
     /* 392170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392181 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 392186 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392190 */   GIR_RootConstrainSelectedInstOperands,
     /* 392191 */   // GIR_Coverage, 5594,
     /* 392191 */   GIR_Done,
     /* 392192 */ // Label 7814: @392192
     /* 392192 */ GIM_Reject,
     /* 392193 */ // Label 7809: @392193
     /* 392193 */ GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(392220), // Rule ID 5595 //
     /* 392198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392209 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 392214 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392218 */   GIR_RootConstrainSelectedInstOperands,
     /* 392219 */   // GIR_Coverage, 5595,
     /* 392219 */   GIR_Done,
     /* 392220 */ // Label 7815: @392220
     /* 392220 */ GIM_Reject,
     /* 392221 */ // Label 7810: @392221
     /* 392221 */ GIM_Reject,
     /* 392222 */ // Label 111: @392222
     /* 392222 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7819*/ GIMT_Encode4(392392),
     /* 392233 */ /*GILLT_s16*//*Label 7816*/ GIMT_Encode4(392245),
     /* 392237 */ /*GILLT_s32*//*Label 7817*/ GIMT_Encode4(392306),
     /* 392241 */ /*GILLT_s64*//*Label 7818*/ GIMT_Encode4(392364),
     /* 392245 */ // Label 7816: @392245
     /* 392245 */ GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(392275), // Rule ID 1942 //
     /* 392250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392264 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 392269 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392273 */   GIR_RootConstrainSelectedInstOperands,
     /* 392274 */   // GIR_Coverage, 1942,
     /* 392274 */   GIR_Done,
     /* 392275 */ // Label 7820: @392275
     /* 392275 */ GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(392305), // Rule ID 1944 //
     /* 392280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392294 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 392299 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392303 */   GIR_RootConstrainSelectedInstOperands,
     /* 392304 */   // GIR_Coverage, 1944,
     /* 392304 */   GIR_Done,
     /* 392305 */ // Label 7821: @392305
     /* 392305 */ GIM_Reject,
     /* 392306 */ // Label 7817: @392306
     /* 392306 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(392336), // Rule ID 1946 //
     /* 392311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392325 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 392330 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392334 */   GIR_RootConstrainSelectedInstOperands,
     /* 392335 */   // GIR_Coverage, 1946,
     /* 392335 */   GIR_Done,
     /* 392336 */ // Label 7822: @392336
     /* 392336 */ GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(392363), // Rule ID 5601 //
     /* 392341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392352 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 392357 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392361 */   GIR_RootConstrainSelectedInstOperands,
     /* 392362 */   // GIR_Coverage, 5601,
     /* 392362 */   GIR_Done,
     /* 392363 */ // Label 7823: @392363
     /* 392363 */ GIM_Reject,
     /* 392364 */ // Label 7818: @392364
     /* 392364 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(392391), // Rule ID 5603 //
     /* 392369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392380 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 392385 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392389 */   GIR_RootConstrainSelectedInstOperands,
     /* 392390 */   // GIR_Coverage, 5603,
     /* 392390 */   GIR_Done,
     /* 392391 */ // Label 7824: @392391
     /* 392391 */ GIM_Reject,
     /* 392392 */ // Label 7819: @392392
     /* 392392 */ GIM_Reject,
     /* 392393 */ // Label 112: @392393
     /* 392393 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7828*/ GIMT_Encode4(392563),
     /* 392404 */ /*GILLT_s16*//*Label 7825*/ GIMT_Encode4(392416),
     /* 392408 */ /*GILLT_s32*//*Label 7826*/ GIMT_Encode4(392477),
     /* 392412 */ /*GILLT_s64*//*Label 7827*/ GIMT_Encode4(392535),
     /* 392416 */ // Label 7825: @392416
     /* 392416 */ GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(392446), // Rule ID 1954 //
     /* 392421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392435 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 392440 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392444 */   GIR_RootConstrainSelectedInstOperands,
     /* 392445 */   // GIR_Coverage, 1954,
     /* 392445 */   GIR_Done,
     /* 392446 */ // Label 7829: @392446
     /* 392446 */ GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(392476), // Rule ID 1956 //
     /* 392451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392465 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 392470 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392474 */   GIR_RootConstrainSelectedInstOperands,
     /* 392475 */   // GIR_Coverage, 1956,
     /* 392475 */   GIR_Done,
     /* 392476 */ // Label 7830: @392476
     /* 392476 */ GIM_Reject,
     /* 392477 */ // Label 7826: @392477
     /* 392477 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(392507), // Rule ID 1958 //
     /* 392482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392496 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 392501 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392505 */   GIR_RootConstrainSelectedInstOperands,
     /* 392506 */   // GIR_Coverage, 1958,
     /* 392506 */   GIR_Done,
     /* 392507 */ // Label 7831: @392507
     /* 392507 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(392534), // Rule ID 5609 //
     /* 392512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392523 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 392528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392532 */   GIR_RootConstrainSelectedInstOperands,
     /* 392533 */   // GIR_Coverage, 5609,
     /* 392533 */   GIR_Done,
     /* 392534 */ // Label 7832: @392534
     /* 392534 */ GIM_Reject,
     /* 392535 */ // Label 7827: @392535
     /* 392535 */ GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(392562), // Rule ID 5611 //
     /* 392540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392551 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 392556 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392560 */   GIR_RootConstrainSelectedInstOperands,
     /* 392561 */   // GIR_Coverage, 5611,
     /* 392561 */   GIR_Done,
     /* 392562 */ // Label 7833: @392562
     /* 392562 */ GIM_Reject,
     /* 392563 */ // Label 7828: @392563
     /* 392563 */ GIM_Reject,
     /* 392564 */ // Label 113: @392564
     /* 392564 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7837*/ GIMT_Encode4(392734),
     /* 392575 */ /*GILLT_s16*//*Label 7834*/ GIMT_Encode4(392587),
     /* 392579 */ /*GILLT_s32*//*Label 7835*/ GIMT_Encode4(392648),
     /* 392583 */ /*GILLT_s64*//*Label 7836*/ GIMT_Encode4(392706),
     /* 392587 */ // Label 7834: @392587
     /* 392587 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(392617), // Rule ID 1948 //
     /* 392592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392606 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 392611 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392615 */   GIR_RootConstrainSelectedInstOperands,
     /* 392616 */   // GIR_Coverage, 1948,
     /* 392616 */   GIR_Done,
     /* 392617 */ // Label 7838: @392617
     /* 392617 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(392647), // Rule ID 1950 //
     /* 392622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392636 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 392641 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392645 */   GIR_RootConstrainSelectedInstOperands,
     /* 392646 */   // GIR_Coverage, 1950,
     /* 392646 */   GIR_Done,
     /* 392647 */ // Label 7839: @392647
     /* 392647 */ GIM_Reject,
     /* 392648 */ // Label 7835: @392648
     /* 392648 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(392678), // Rule ID 1952 //
     /* 392653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392667 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 392672 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392676 */   GIR_RootConstrainSelectedInstOperands,
     /* 392677 */   // GIR_Coverage, 1952,
     /* 392677 */   GIR_Done,
     /* 392678 */ // Label 7840: @392678
     /* 392678 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(392705), // Rule ID 5605 //
     /* 392683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392694 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 392699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392703 */   GIR_RootConstrainSelectedInstOperands,
     /* 392704 */   // GIR_Coverage, 5605,
     /* 392704 */   GIR_Done,
     /* 392705 */ // Label 7841: @392705
     /* 392705 */ GIM_Reject,
     /* 392706 */ // Label 7836: @392706
     /* 392706 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(392733), // Rule ID 5607 //
     /* 392711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392722 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392722 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 392727 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392731 */   GIR_RootConstrainSelectedInstOperands,
     /* 392732 */   // GIR_Coverage, 5607,
     /* 392732 */   GIR_Done,
     /* 392733 */ // Label 7842: @392733
     /* 392733 */ GIM_Reject,
     /* 392734 */ // Label 7837: @392734
     /* 392734 */ GIM_Reject,
     /* 392735 */ // Label 114: @392735
     /* 392735 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7846*/ GIMT_Encode4(392905),
     /* 392746 */ /*GILLT_s16*//*Label 7843*/ GIMT_Encode4(392758),
     /* 392750 */ /*GILLT_s32*//*Label 7844*/ GIMT_Encode4(392819),
     /* 392754 */ /*GILLT_s64*//*Label 7845*/ GIMT_Encode4(392877),
     /* 392758 */ // Label 7843: @392758
     /* 392758 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(392788), // Rule ID 1960 //
     /* 392763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392777 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 392782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392786 */   GIR_RootConstrainSelectedInstOperands,
     /* 392787 */   // GIR_Coverage, 1960,
     /* 392787 */   GIR_Done,
     /* 392788 */ // Label 7847: @392788
     /* 392788 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(392818), // Rule ID 1962 //
     /* 392793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392807 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 392812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392816 */   GIR_RootConstrainSelectedInstOperands,
     /* 392817 */   // GIR_Coverage, 1962,
     /* 392817 */   GIR_Done,
     /* 392818 */ // Label 7848: @392818
     /* 392818 */ GIM_Reject,
     /* 392819 */ // Label 7844: @392819
     /* 392819 */ GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(392849), // Rule ID 1964 //
     /* 392824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392838 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 392843 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392847 */   GIR_RootConstrainSelectedInstOperands,
     /* 392848 */   // GIR_Coverage, 1964,
     /* 392848 */   GIR_Done,
     /* 392849 */ // Label 7849: @392849
     /* 392849 */ GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(392876), // Rule ID 5613 //
     /* 392854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392865 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 392870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392874 */   GIR_RootConstrainSelectedInstOperands,
     /* 392875 */   // GIR_Coverage, 5613,
     /* 392875 */   GIR_Done,
     /* 392876 */ // Label 7850: @392876
     /* 392876 */ GIM_Reject,
     /* 392877 */ // Label 7845: @392877
     /* 392877 */ GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(392904), // Rule ID 5615 //
     /* 392882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392893 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 392898 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392902 */   GIR_RootConstrainSelectedInstOperands,
     /* 392903 */   // GIR_Coverage, 5615,
     /* 392903 */   GIR_Done,
     /* 392904 */ // Label 7851: @392904
     /* 392904 */ GIM_Reject,
     /* 392905 */ // Label 7846: @392905
     /* 392905 */ GIM_Reject,
     /* 392906 */ // Label 115: @392906
     /* 392906 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7856*/ GIMT_Encode4(394034),
     /* 392917 */ /*GILLT_s8*//*Label 7852*/ GIMT_Encode4(392933),
     /* 392921 */ /*GILLT_s16*//*Label 7853*/ GIMT_Encode4(392980),
     /* 392925 */ /*GILLT_s32*//*Label 7854*/ GIMT_Encode4(393395),
     /* 392929 */ /*GILLT_s64*//*Label 7855*/ GIMT_Encode4(393848),
     /* 392933 */ // Label 7852: @392933
     /* 392933 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(392956), // Rule ID 5860 //
     /* 392938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 392945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392949 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 392954 */   GIR_RootConstrainSelectedInstOperands,
     /* 392955 */   // GIR_Coverage, 5860,
     /* 392955 */   GIR_Done,
     /* 392956 */ // Label 7857: @392956
     /* 392956 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(392979), // Rule ID 5861 //
     /* 392961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 392968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392972 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392972 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 392977 */   GIR_RootConstrainSelectedInstOperands,
     /* 392978 */   // GIR_Coverage, 5861,
     /* 392978 */   GIR_Done,
     /* 392979 */ // Label 7858: @392979
     /* 392979 */ GIM_Reject,
     /* 392980 */ // Label 7853: @392980
     /* 392980 */ GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(393030), // Rule ID 5807 //
     /* 392985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393000 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393003 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393008 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 393012 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393017 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393019 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 393022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393024 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393028 */   GIR_RootConstrainSelectedInstOperands,
     /* 393029 */   // GIR_Coverage, 5807,
     /* 393029 */   GIR_EraseRootFromParent_Done,
     /* 393030 */ // Label 7859: @393030
     /* 393030 */ GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(393080), // Rule ID 5809 //
     /* 393035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393042 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393046 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393050 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393053 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393058 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 393062 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393069 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 393072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393074 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393078 */   GIR_RootConstrainSelectedInstOperands,
     /* 393079 */   // GIR_Coverage, 5809,
     /* 393079 */   GIR_EraseRootFromParent_Done,
     /* 393080 */ // Label 7860: @393080
     /* 393080 */ GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(393130), // Rule ID 5817 //
     /* 393085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393092 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393096 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393100 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393103 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393108 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 393112 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393119 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 393122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393124 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393128 */   GIR_RootConstrainSelectedInstOperands,
     /* 393129 */   // GIR_Coverage, 5817,
     /* 393129 */   GIR_EraseRootFromParent_Done,
     /* 393130 */ // Label 7861: @393130
     /* 393130 */ GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(393180), // Rule ID 5819 //
     /* 393135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393150 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393153 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 393162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393167 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393169 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 393172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393174 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393178 */   GIR_RootConstrainSelectedInstOperands,
     /* 393179 */   // GIR_Coverage, 5819,
     /* 393179 */   GIR_EraseRootFromParent_Done,
     /* 393180 */ // Label 7862: @393180
     /* 393180 */ GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(393222), // Rule ID 5816 //
     /* 393185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393192 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393200 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393204 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393211 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 393214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393216 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393220 */   GIR_RootConstrainSelectedInstOperands,
     /* 393221 */   // GIR_Coverage, 5816,
     /* 393221 */   GIR_EraseRootFromParent_Done,
     /* 393222 */ // Label 7863: @393222
     /* 393222 */ GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(393264), // Rule ID 5818 //
     /* 393227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393242 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393246 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393251 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393253 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 393256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393258 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393262 */   GIR_RootConstrainSelectedInstOperands,
     /* 393263 */   // GIR_Coverage, 5818,
     /* 393263 */   GIR_EraseRootFromParent_Done,
     /* 393264 */ // Label 7864: @393264
     /* 393264 */ GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(393306), // Rule ID 5806 //
     /* 393269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393276 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393280 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393284 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393288 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393295 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 393298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393300 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393304 */   GIR_RootConstrainSelectedInstOperands,
     /* 393305 */   // GIR_Coverage, 5806,
     /* 393305 */   GIR_EraseRootFromParent_Done,
     /* 393306 */ // Label 7865: @393306
     /* 393306 */ GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(393348), // Rule ID 5808 //
     /* 393311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393318 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393322 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393326 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393330 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393337 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 393340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393342 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393346 */   GIR_RootConstrainSelectedInstOperands,
     /* 393347 */   // GIR_Coverage, 5808,
     /* 393347 */   GIR_EraseRootFromParent_Done,
     /* 393348 */ // Label 7866: @393348
     /* 393348 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(393371), // Rule ID 5862 //
     /* 393353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393364 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 393364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 393369 */   GIR_RootConstrainSelectedInstOperands,
     /* 393370 */   // GIR_Coverage, 5862,
     /* 393370 */   GIR_Done,
     /* 393371 */ // Label 7867: @393371
     /* 393371 */ GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(393394), // Rule ID 5863 //
     /* 393376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393387 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 393387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 393392 */   GIR_RootConstrainSelectedInstOperands,
     /* 393393 */   // GIR_Coverage, 5863,
     /* 393393 */   GIR_Done,
     /* 393394 */ // Label 7868: @393394
     /* 393394 */ GIM_Reject,
     /* 393395 */ // Label 7854: @393395
     /* 393395 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(393445), // Rule ID 5811 //
     /* 393400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393407 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393415 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393418 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 393427 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393434 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 393437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393439 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393443 */   GIR_RootConstrainSelectedInstOperands,
     /* 393444 */   // GIR_Coverage, 5811,
     /* 393444 */   GIR_EraseRootFromParent_Done,
     /* 393445 */ // Label 7869: @393445
     /* 393445 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(393495), // Rule ID 5813 //
     /* 393450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393465 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393468 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393473 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 393477 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393484 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 393487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393489 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393493 */   GIR_RootConstrainSelectedInstOperands,
     /* 393494 */   // GIR_Coverage, 5813,
     /* 393494 */   GIR_EraseRootFromParent_Done,
     /* 393495 */ // Label 7870: @393495
     /* 393495 */ GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(393545), // Rule ID 5821 //
     /* 393500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393515 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393518 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393523 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 393527 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393534 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 393537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393539 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393543 */   GIR_RootConstrainSelectedInstOperands,
     /* 393544 */   // GIR_Coverage, 5821,
     /* 393544 */   GIR_EraseRootFromParent_Done,
     /* 393545 */ // Label 7871: @393545
     /* 393545 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(393595), // Rule ID 5823 //
     /* 393550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393565 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393568 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393573 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 393577 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393584 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 393587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393589 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393593 */   GIR_RootConstrainSelectedInstOperands,
     /* 393594 */   // GIR_Coverage, 5823,
     /* 393594 */   GIR_EraseRootFromParent_Done,
     /* 393595 */ // Label 7872: @393595
     /* 393595 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(393637), // Rule ID 5820 //
     /* 393600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393615 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393626 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 393629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393631 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393635 */   GIR_RootConstrainSelectedInstOperands,
     /* 393636 */   // GIR_Coverage, 5820,
     /* 393636 */   GIR_EraseRootFromParent_Done,
     /* 393637 */ // Label 7873: @393637
     /* 393637 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(393679), // Rule ID 5822 //
     /* 393642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393657 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393661 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393666 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393668 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 393671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393673 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393677 */   GIR_RootConstrainSelectedInstOperands,
     /* 393678 */   // GIR_Coverage, 5822,
     /* 393678 */   GIR_EraseRootFromParent_Done,
     /* 393679 */ // Label 7874: @393679
     /* 393679 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(393721), // Rule ID 5810 //
     /* 393684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393699 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393703 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393708 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393710 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 393713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393715 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393719 */   GIR_RootConstrainSelectedInstOperands,
     /* 393720 */   // GIR_Coverage, 5810,
     /* 393720 */   GIR_EraseRootFromParent_Done,
     /* 393721 */ // Label 7875: @393721
     /* 393721 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(393763), // Rule ID 5812 //
     /* 393726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393733 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393737 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393741 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393745 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393752 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 393752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 393755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393757 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393761 */   GIR_RootConstrainSelectedInstOperands,
     /* 393762 */   // GIR_Coverage, 5812,
     /* 393762 */   GIR_EraseRootFromParent_Done,
     /* 393763 */ // Label 7876: @393763
     /* 393763 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(393824), // Rule ID 5864 //
     /* 393768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393779 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 393779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 393782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 393786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393791 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 393801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393806 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 393813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393823 */   // GIR_Coverage, 5864,
     /* 393823 */   GIR_EraseRootFromParent_Done,
     /* 393824 */ // Label 7877: @393824
     /* 393824 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(393847), // Rule ID 5865 //
     /* 393829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393840 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 393840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 393845 */   GIR_RootConstrainSelectedInstOperands,
     /* 393846 */   // GIR_Coverage, 5865,
     /* 393846 */   GIR_Done,
     /* 393847 */ // Label 7878: @393847
     /* 393847 */ GIM_Reject,
     /* 393848 */ // Label 7855: @393848
     /* 393848 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(394033),
     /* 393853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393860 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(393903), // Rule ID 5815 //
     /* 393865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 393885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393892 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 393892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 393895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393901 */     GIR_RootConstrainSelectedInstOperands,
     /* 393902 */     // GIR_Coverage, 5815,
     /* 393902 */     GIR_EraseRootFromParent_Done,
     /* 393903 */   // Label 7880: @393903
     /* 393903 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(393946), // Rule ID 5825 //
     /* 393908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393916 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393919 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 393928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393935 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 393935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 393938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393944 */     GIR_RootConstrainSelectedInstOperands,
     /* 393945 */     // GIR_Coverage, 5825,
     /* 393945 */     GIR_EraseRootFromParent_Done,
     /* 393946 */   // Label 7881: @393946
     /* 393946 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(393981), // Rule ID 5824 //
     /* 393951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393970 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 393970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 393973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393979 */     GIR_RootConstrainSelectedInstOperands,
     /* 393980 */     // GIR_Coverage, 5824,
     /* 393980 */     GIR_EraseRootFromParent_Done,
     /* 393981 */   // Label 7882: @393981
     /* 393981 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(394016), // Rule ID 5814 //
     /* 393986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394005 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 394008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394014 */     GIR_RootConstrainSelectedInstOperands,
     /* 394015 */     // GIR_Coverage, 5814,
     /* 394015 */     GIR_EraseRootFromParent_Done,
     /* 394016 */   // Label 7883: @394016
     /* 394016 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(394032), // Rule ID 5866 //
     /* 394021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394025 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 394025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 394030 */     GIR_RootConstrainSelectedInstOperands,
     /* 394031 */     // GIR_Coverage, 5866,
     /* 394031 */     GIR_Done,
     /* 394032 */   // Label 7884: @394032
     /* 394032 */   GIM_Reject,
     /* 394033 */ // Label 7879: @394033
     /* 394033 */ GIM_Reject,
     /* 394034 */ // Label 7856: @394034
     /* 394034 */ GIM_Reject,
     /* 394035 */ // Label 116: @394035
     /* 394035 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7888*/ GIMT_Encode4(394237),
     /* 394046 */ /*GILLT_s8*//*Label 7885*/ GIMT_Encode4(394058),
     /* 394050 */ /*GILLT_s16*//*Label 7886*/ GIMT_Encode4(394105),
     /* 394054 */ /*GILLT_s32*//*Label 7887*/ GIMT_Encode4(394152),
     /* 394058 */ // Label 7885: @394058
     /* 394058 */ GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(394081), // Rule ID 5957 //
     /* 394063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394074 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 394079 */   GIR_RootConstrainSelectedInstOperands,
     /* 394080 */   // GIR_Coverage, 5957,
     /* 394080 */   GIR_Done,
     /* 394081 */ // Label 7889: @394081
     /* 394081 */ GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(394104), // Rule ID 5958 //
     /* 394086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394097 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 394102 */   GIR_RootConstrainSelectedInstOperands,
     /* 394103 */   // GIR_Coverage, 5958,
     /* 394103 */   GIR_Done,
     /* 394104 */ // Label 7890: @394104
     /* 394104 */ GIM_Reject,
     /* 394105 */ // Label 7886: @394105
     /* 394105 */ GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(394128), // Rule ID 5959 //
     /* 394110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394121 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 394126 */   GIR_RootConstrainSelectedInstOperands,
     /* 394127 */   // GIR_Coverage, 5959,
     /* 394127 */   GIR_Done,
     /* 394128 */ // Label 7891: @394128
     /* 394128 */ GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(394151), // Rule ID 5960 //
     /* 394133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394144 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 394149 */   GIR_RootConstrainSelectedInstOperands,
     /* 394150 */   // GIR_Coverage, 5960,
     /* 394150 */   GIR_Done,
     /* 394151 */ // Label 7892: @394151
     /* 394151 */ GIM_Reject,
     /* 394152 */ // Label 7887: @394152
     /* 394152 */ GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(394175), // Rule ID 5961 //
     /* 394157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394168 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 394173 */   GIR_RootConstrainSelectedInstOperands,
     /* 394174 */   // GIR_Coverage, 5961,
     /* 394174 */   GIR_Done,
     /* 394175 */ // Label 7893: @394175
     /* 394175 */ GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(394236), // Rule ID 5962 //
     /* 394180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394191 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 394198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394218 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394235 */   // GIR_Coverage, 5962,
     /* 394235 */   GIR_EraseRootFromParent_Done,
     /* 394236 */ // Label 7894: @394236
     /* 394236 */ GIM_Reject,
     /* 394237 */ // Label 7888: @394237
     /* 394237 */ GIM_Reject,
     /* 394238 */ // Label 117: @394238
     /* 394238 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7898*/ GIMT_Encode4(394440),
     /* 394249 */ /*GILLT_s8*//*Label 7895*/ GIMT_Encode4(394261),
     /* 394253 */ /*GILLT_s16*//*Label 7896*/ GIMT_Encode4(394308),
     /* 394257 */ /*GILLT_s32*//*Label 7897*/ GIMT_Encode4(394355),
     /* 394261 */ // Label 7895: @394261
     /* 394261 */ GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(394284), // Rule ID 5951 //
     /* 394266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394277 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 394282 */   GIR_RootConstrainSelectedInstOperands,
     /* 394283 */   // GIR_Coverage, 5951,
     /* 394283 */   GIR_Done,
     /* 394284 */ // Label 7899: @394284
     /* 394284 */ GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(394307), // Rule ID 5952 //
     /* 394289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394300 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 394305 */   GIR_RootConstrainSelectedInstOperands,
     /* 394306 */   // GIR_Coverage, 5952,
     /* 394306 */   GIR_Done,
     /* 394307 */ // Label 7900: @394307
     /* 394307 */ GIM_Reject,
     /* 394308 */ // Label 7896: @394308
     /* 394308 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(394331), // Rule ID 5953 //
     /* 394313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394324 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 394329 */   GIR_RootConstrainSelectedInstOperands,
     /* 394330 */   // GIR_Coverage, 5953,
     /* 394330 */   GIR_Done,
     /* 394331 */ // Label 7901: @394331
     /* 394331 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(394354), // Rule ID 5954 //
     /* 394336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394347 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 394352 */   GIR_RootConstrainSelectedInstOperands,
     /* 394353 */   // GIR_Coverage, 5954,
     /* 394353 */   GIR_Done,
     /* 394354 */ // Label 7902: @394354
     /* 394354 */ GIM_Reject,
     /* 394355 */ // Label 7897: @394355
     /* 394355 */ GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(394378), // Rule ID 5955 //
     /* 394360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394371 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 394376 */   GIR_RootConstrainSelectedInstOperands,
     /* 394377 */   // GIR_Coverage, 5955,
     /* 394377 */   GIR_Done,
     /* 394378 */ // Label 7903: @394378
     /* 394378 */ GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(394439), // Rule ID 5956 //
     /* 394383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394394 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 394401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394406 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394410 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394421 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394438 */   // GIR_Coverage, 5956,
     /* 394438 */   GIR_EraseRootFromParent_Done,
     /* 394439 */ // Label 7904: @394439
     /* 394439 */ GIM_Reject,
     /* 394440 */ // Label 7898: @394440
     /* 394440 */ GIM_Reject,
     /* 394441 */ // Label 118: @394441
     /* 394441 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7908*/ GIMT_Encode4(394643),
     /* 394452 */ /*GILLT_s8*//*Label 7905*/ GIMT_Encode4(394464),
     /* 394456 */ /*GILLT_s16*//*Label 7906*/ GIMT_Encode4(394511),
     /* 394460 */ /*GILLT_s32*//*Label 7907*/ GIMT_Encode4(394558),
     /* 394464 */ // Label 7905: @394464
     /* 394464 */ GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(394487), // Rule ID 5945 //
     /* 394469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394480 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 394485 */   GIR_RootConstrainSelectedInstOperands,
     /* 394486 */   // GIR_Coverage, 5945,
     /* 394486 */   GIR_Done,
     /* 394487 */ // Label 7909: @394487
     /* 394487 */ GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(394510), // Rule ID 5946 //
     /* 394492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394503 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 394508 */   GIR_RootConstrainSelectedInstOperands,
     /* 394509 */   // GIR_Coverage, 5946,
     /* 394509 */   GIR_Done,
     /* 394510 */ // Label 7910: @394510
     /* 394510 */ GIM_Reject,
     /* 394511 */ // Label 7906: @394511
     /* 394511 */ GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(394534), // Rule ID 5947 //
     /* 394516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394527 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 394532 */   GIR_RootConstrainSelectedInstOperands,
     /* 394533 */   // GIR_Coverage, 5947,
     /* 394533 */   GIR_Done,
     /* 394534 */ // Label 7911: @394534
     /* 394534 */ GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(394557), // Rule ID 5948 //
     /* 394539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394550 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 394555 */   GIR_RootConstrainSelectedInstOperands,
     /* 394556 */   // GIR_Coverage, 5948,
     /* 394556 */   GIR_Done,
     /* 394557 */ // Label 7912: @394557
     /* 394557 */ GIM_Reject,
     /* 394558 */ // Label 7907: @394558
     /* 394558 */ GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(394581), // Rule ID 5949 //
     /* 394563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394574 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 394579 */   GIR_RootConstrainSelectedInstOperands,
     /* 394580 */   // GIR_Coverage, 5949,
     /* 394580 */   GIR_Done,
     /* 394581 */ // Label 7913: @394581
     /* 394581 */ GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(394642), // Rule ID 5950 //
     /* 394586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394597 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 394604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394609 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394613 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394624 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394631 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394641 */   // GIR_Coverage, 5950,
     /* 394641 */   GIR_EraseRootFromParent_Done,
     /* 394642 */ // Label 7914: @394642
     /* 394642 */ GIM_Reject,
     /* 394643 */ // Label 7908: @394643
     /* 394643 */ GIM_Reject,
     /* 394644 */ // Label 119: @394644
     /* 394644 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7918*/ GIMT_Encode4(394846),
     /* 394655 */ /*GILLT_s8*//*Label 7915*/ GIMT_Encode4(394667),
     /* 394659 */ /*GILLT_s16*//*Label 7916*/ GIMT_Encode4(394714),
     /* 394663 */ /*GILLT_s32*//*Label 7917*/ GIMT_Encode4(394761),
     /* 394667 */ // Label 7915: @394667
     /* 394667 */ GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(394690), // Rule ID 5939 //
     /* 394672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394683 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 394688 */   GIR_RootConstrainSelectedInstOperands,
     /* 394689 */   // GIR_Coverage, 5939,
     /* 394689 */   GIR_Done,
     /* 394690 */ // Label 7919: @394690
     /* 394690 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(394713), // Rule ID 5940 //
     /* 394695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394706 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 394711 */   GIR_RootConstrainSelectedInstOperands,
     /* 394712 */   // GIR_Coverage, 5940,
     /* 394712 */   GIR_Done,
     /* 394713 */ // Label 7920: @394713
     /* 394713 */ GIM_Reject,
     /* 394714 */ // Label 7916: @394714
     /* 394714 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(394737), // Rule ID 5941 //
     /* 394719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394730 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 394735 */   GIR_RootConstrainSelectedInstOperands,
     /* 394736 */   // GIR_Coverage, 5941,
     /* 394736 */   GIR_Done,
     /* 394737 */ // Label 7921: @394737
     /* 394737 */ GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(394760), // Rule ID 5942 //
     /* 394742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394753 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 394758 */   GIR_RootConstrainSelectedInstOperands,
     /* 394759 */   // GIR_Coverage, 5942,
     /* 394759 */   GIR_Done,
     /* 394760 */ // Label 7922: @394760
     /* 394760 */ GIM_Reject,
     /* 394761 */ // Label 7917: @394761
     /* 394761 */ GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(394784), // Rule ID 5943 //
     /* 394766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394777 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 394782 */   GIR_RootConstrainSelectedInstOperands,
     /* 394783 */   // GIR_Coverage, 5943,
     /* 394783 */   GIR_Done,
     /* 394784 */ // Label 7923: @394784
     /* 394784 */ GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(394845), // Rule ID 5944 //
     /* 394789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394800 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394800 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394803 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 394807 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394812 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394816 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394827 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394844 */   // GIR_Coverage, 5944,
     /* 394844 */   GIR_EraseRootFromParent_Done,
     /* 394845 */ // Label 7924: @394845
     /* 394845 */ GIM_Reject,
     /* 394846 */ // Label 7918: @394846
     /* 394846 */ GIM_Reject,
     /* 394847 */ // Label 120: @394847
     /* 394847 */ GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(394986),
     /* 394852 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 394855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 394859 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(394893), // Rule ID 257 //
     /* 394864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 394871 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 394871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 394874 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 394886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 394891 */     GIR_RootConstrainSelectedInstOperands,
     /* 394892 */     // GIR_Coverage, 257,
     /* 394892 */     GIR_EraseRootFromParent_Done,
     /* 394893 */   // Label 7926: @394893
     /* 394893 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(394927), // Rule ID 258 //
     /* 394898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 394905 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 394905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 394908 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 394920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 394925 */     GIR_RootConstrainSelectedInstOperands,
     /* 394926 */     // GIR_Coverage, 258,
     /* 394926 */     GIR_EraseRootFromParent_Done,
     /* 394927 */   // Label 7927: @394927
     /* 394927 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(394956), // Rule ID 273 //
     /* 394932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 394939 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 394939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 394942 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 394954 */     GIR_RootConstrainSelectedInstOperands,
     /* 394955 */     // GIR_Coverage, 273,
     /* 394955 */     GIR_EraseRootFromParent_Done,
     /* 394956 */   // Label 7928: @394956
     /* 394956 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(394985), // Rule ID 294 //
     /* 394961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 394968 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 394968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 394971 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 394973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 394978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 394983 */     GIR_RootConstrainSelectedInstOperands,
     /* 394984 */     // GIR_Coverage, 294,
     /* 394984 */     GIR_EraseRootFromParent_Done,
     /* 394985 */   // Label 7929: @394985
     /* 394985 */   GIM_Reject,
     /* 394986 */ // Label 7925: @394986
     /* 394986 */ GIM_Reject,
     /* 394987 */ // Label 121: @394987
     /* 394987 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7942*/ GIMT_Encode4(395526),
     /* 394998 */ /*GILLT_s64*//*Label 7930*/ GIMT_Encode4(395082), GIMT_Encode4(0),
     /* 395006 */ /*GILLT_v2s32*//*Label 7931*/ GIMT_Encode4(395120),
     /* 395010 */ /*GILLT_v2s64*//*Label 7932*/ GIMT_Encode4(395158),
     /* 395014 */ /*GILLT_v4s16*//*Label 7933*/ GIMT_Encode4(395196),
     /* 395018 */ /*GILLT_v4s32*//*Label 7934*/ GIMT_Encode4(395234),
     /* 395022 */ /*GILLT_v8s8*//*Label 7935*/ GIMT_Encode4(395272),
     /* 395026 */ /*GILLT_v8s16*//*Label 7936*/ GIMT_Encode4(395310),
     /* 395030 */ /*GILLT_v16s8*//*Label 7937*/ GIMT_Encode4(395348), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 395050 */ /*GILLT_nxv2s64*//*Label 7938*/ GIMT_Encode4(395386), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 395062 */ /*GILLT_nxv4s32*//*Label 7939*/ GIMT_Encode4(395421), GIMT_Encode4(0),
     /* 395070 */ /*GILLT_nxv8s16*//*Label 7940*/ GIMT_Encode4(395456), GIMT_Encode4(0),
     /* 395078 */ /*GILLT_nxv16s8*//*Label 7941*/ GIMT_Encode4(395491),
     /* 395082 */ // Label 7930: @395082
     /* 395082 */ GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(395119), // Rule ID 5054 //
     /* 395087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 395096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395108 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395112 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 395112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395117 */   GIR_RootConstrainSelectedInstOperands,
     /* 395118 */   // GIR_Coverage, 5054,
     /* 395118 */   GIR_Done,
     /* 395119 */ // Label 7943: @395119
     /* 395119 */ GIM_Reject,
     /* 395120 */ // Label 7931: @395120
     /* 395120 */ GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(395157), // Rule ID 5053 //
     /* 395125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 395134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395146 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395150 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 395150 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395155 */   GIR_RootConstrainSelectedInstOperands,
     /* 395156 */   // GIR_Coverage, 5053,
     /* 395156 */   GIR_Done,
     /* 395157 */ // Label 7944: @395157
     /* 395157 */ GIM_Reject,
     /* 395158 */ // Label 7932: @395158
     /* 395158 */ GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(395195), // Rule ID 5058 //
     /* 395163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 395172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395188 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 395188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395193 */   GIR_RootConstrainSelectedInstOperands,
     /* 395194 */   // GIR_Coverage, 5058,
     /* 395194 */   GIR_Done,
     /* 395195 */ // Label 7945: @395195
     /* 395195 */ GIM_Reject,
     /* 395196 */ // Label 7933: @395196
     /* 395196 */ GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(395233), // Rule ID 5052 //
     /* 395201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 395210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395222 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395226 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 395226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395231 */   GIR_RootConstrainSelectedInstOperands,
     /* 395232 */   // GIR_Coverage, 5052,
     /* 395232 */   GIR_Done,
     /* 395233 */ // Label 7946: @395233
     /* 395233 */ GIM_Reject,
     /* 395234 */ // Label 7934: @395234
     /* 395234 */ GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(395271), // Rule ID 5057 //
     /* 395239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395245 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 395248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395260 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395264 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 395264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395269 */   GIR_RootConstrainSelectedInstOperands,
     /* 395270 */   // GIR_Coverage, 5057,
     /* 395270 */   GIR_Done,
     /* 395271 */ // Label 7947: @395271
     /* 395271 */ GIM_Reject,
     /* 395272 */ // Label 7935: @395272
     /* 395272 */ GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(395309), // Rule ID 5051 //
     /* 395277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 395283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 395286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395302 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 395302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395307 */   GIR_RootConstrainSelectedInstOperands,
     /* 395308 */   // GIR_Coverage, 5051,
     /* 395308 */   GIR_Done,
     /* 395309 */ // Label 7948: @395309
     /* 395309 */ GIM_Reject,
     /* 395310 */ // Label 7936: @395310
     /* 395310 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(395347), // Rule ID 5056 //
     /* 395315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 395324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395340 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 395340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395345 */   GIR_RootConstrainSelectedInstOperands,
     /* 395346 */   // GIR_Coverage, 5056,
     /* 395346 */   GIR_Done,
     /* 395347 */ // Label 7949: @395347
     /* 395347 */ GIM_Reject,
     /* 395348 */ // Label 7937: @395348
     /* 395348 */ GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(395385), // Rule ID 5055 //
     /* 395353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 395362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395374 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395378 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 395378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395383 */   GIR_RootConstrainSelectedInstOperands,
     /* 395384 */   // GIR_Coverage, 5055,
     /* 395384 */   GIR_Done,
     /* 395385 */ // Label 7950: @395385
     /* 395385 */ GIM_Reject,
     /* 395386 */ // Label 7938: @395386
     /* 395386 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(395420), // Rule ID 11805 //
     /* 395391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 395397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 395400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 395403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395407 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 395407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395412 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395414 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395416 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395418 */   GIR_RootConstrainSelectedInstOperands,
     /* 395419 */   // GIR_Coverage, 11805,
     /* 395419 */   GIR_EraseRootFromParent_Done,
     /* 395420 */ // Label 7951: @395420
     /* 395420 */ GIM_Reject,
     /* 395421 */ // Label 7939: @395421
     /* 395421 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(395455), // Rule ID 11803 //
     /* 395426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 395432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 395435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 395438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395442 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 395442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395447 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395449 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395451 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395453 */   GIR_RootConstrainSelectedInstOperands,
     /* 395454 */   // GIR_Coverage, 11803,
     /* 395454 */   GIR_EraseRootFromParent_Done,
     /* 395455 */ // Label 7952: @395455
     /* 395455 */ GIM_Reject,
     /* 395456 */ // Label 7940: @395456
     /* 395456 */ GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(395490), // Rule ID 11801 //
     /* 395461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 395467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 395470 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 395473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395477 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 395477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395482 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395484 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395486 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395488 */   GIR_RootConstrainSelectedInstOperands,
     /* 395489 */   // GIR_Coverage, 11801,
     /* 395489 */   GIR_EraseRootFromParent_Done,
     /* 395490 */ // Label 7953: @395490
     /* 395490 */ GIM_Reject,
     /* 395491 */ // Label 7941: @395491
     /* 395491 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(395525), // Rule ID 11799 //
     /* 395496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 395502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 395505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 395508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395512 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 395512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395517 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395519 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395521 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395523 */   GIR_RootConstrainSelectedInstOperands,
     /* 395524 */   // GIR_Coverage, 11799,
     /* 395524 */   GIR_EraseRootFromParent_Done,
     /* 395525 */ // Label 7954: @395525
     /* 395525 */ GIM_Reject,
     /* 395526 */ // Label 7942: @395526
     /* 395526 */ GIM_Reject,
     /* 395527 */ // Label 122: @395527
     /* 395527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7963*/ GIMT_Encode4(397349),
     /* 395538 */ /*GILLT_s64*//*Label 7955*/ GIMT_Encode4(395574), GIMT_Encode4(0),
     /* 395546 */ /*GILLT_v2s32*//*Label 7956*/ GIMT_Encode4(395769),
     /* 395550 */ /*GILLT_v2s64*//*Label 7957*/ GIMT_Encode4(396016),
     /* 395554 */ /*GILLT_v4s16*//*Label 7958*/ GIMT_Encode4(396263),
     /* 395558 */ /*GILLT_v4s32*//*Label 7959*/ GIMT_Encode4(396539),
     /* 395562 */ /*GILLT_v8s8*//*Label 7960*/ GIMT_Encode4(396786),
     /* 395566 */ /*GILLT_v8s16*//*Label 7961*/ GIMT_Encode4(396931),
     /* 395570 */ /*GILLT_v16s8*//*Label 7962*/ GIMT_Encode4(397207),
     /* 395574 */ // Label 7955: @395574
     /* 395574 */ GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(395768),
     /* 395579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395586 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(395633), // Rule ID 6384 //
     /* 395591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395599 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395602 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395606 */     // MIs[1] Rn
     /* 395606 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395617 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 395620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395631 */     GIR_RootConstrainSelectedInstOperands,
     /* 395632 */     // GIR_Coverage, 6384,
     /* 395632 */     GIR_EraseRootFromParent_Done,
     /* 395633 */   // Label 7965: @395633
     /* 395633 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(395680), // Rule ID 6395 //
     /* 395638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395653 */     // MIs[1] Rn
     /* 395653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395664 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 395667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395678 */     GIR_RootConstrainSelectedInstOperands,
     /* 395679 */     // GIR_Coverage, 6395,
     /* 395679 */     GIR_EraseRootFromParent_Done,
     /* 395680 */   // Label 7966: @395680
     /* 395680 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(395727), // Rule ID 13128 //
     /* 395685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395693 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395700 */     // MIs[1] Rn
     /* 395700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395711 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 395714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395725 */     GIR_RootConstrainSelectedInstOperands,
     /* 395726 */     // GIR_Coverage, 13128,
     /* 395726 */     GIR_EraseRootFromParent_Done,
     /* 395727 */   // Label 7967: @395727
     /* 395727 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(395747), // Rule ID 5617 //
     /* 395732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 395736 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 395736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395746 */     // GIR_Coverage, 5617,
     /* 395746 */     GIR_Done,
     /* 395747 */   // Label 7968: @395747
     /* 395747 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(395767), // Rule ID 5618 //
     /* 395752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395756 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 395756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395766 */     // GIR_Coverage, 5618,
     /* 395766 */     GIR_Done,
     /* 395767 */   // Label 7969: @395767
     /* 395767 */   GIM_Reject,
     /* 395768 */ // Label 7964: @395768
     /* 395768 */ GIM_Reject,
     /* 395769 */ // Label 7956: @395769
     /* 395769 */ GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(396015),
     /* 395774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395781 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(395828), // Rule ID 6381 //
     /* 395786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395801 */     // MIs[1] Rn
     /* 395801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395812 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 395815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395826 */     GIR_RootConstrainSelectedInstOperands,
     /* 395827 */     // GIR_Coverage, 6381,
     /* 395827 */     GIR_EraseRootFromParent_Done,
     /* 395828 */   // Label 7971: @395828
     /* 395828 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(395875), // Rule ID 6392 //
     /* 395833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395848 */     // MIs[1] Rn
     /* 395848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395859 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 395862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395873 */     GIR_RootConstrainSelectedInstOperands,
     /* 395874 */     // GIR_Coverage, 6392,
     /* 395874 */     GIR_EraseRootFromParent_Done,
     /* 395875 */   // Label 7972: @395875
     /* 395875 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(395922), // Rule ID 13125 //
     /* 395880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 395888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 395891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 395895 */     // MIs[1] Rn
     /* 395895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 395899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 395904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 395906 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 395906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 395909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 395911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 395920 */     GIR_RootConstrainSelectedInstOperands,
     /* 395921 */     // GIR_Coverage, 13125,
     /* 395921 */     GIR_EraseRootFromParent_Done,
     /* 395922 */   // Label 7973: @395922
     /* 395922 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(395941), // Rule ID 1916 //
     /* 395927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 395934 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 395934 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 395939 */     GIR_RootConstrainSelectedInstOperands,
     /* 395940 */     // GIR_Coverage, 1916,
     /* 395940 */     GIR_Done,
     /* 395941 */   // Label 7974: @395941
     /* 395941 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(396014), // Rule ID 5619 //
     /* 395946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395950 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 395950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 395953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 395967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395976 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 395986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 396004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396012 */     GIR_RootConstrainSelectedInstOperands,
     /* 396013 */     // GIR_Coverage, 5619,
     /* 396013 */     GIR_EraseRootFromParent_Done,
     /* 396014 */   // Label 7975: @396014
     /* 396014 */   GIM_Reject,
     /* 396015 */ // Label 7970: @396015
     /* 396015 */ GIM_Reject,
     /* 396016 */ // Label 7957: @396016
     /* 396016 */ GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(396262),
     /* 396021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396028 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(396075), // Rule ID 6383 //
     /* 396033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396041 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396044 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396048 */     // MIs[1] Rn
     /* 396048 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396059 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 396062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396073 */     GIR_RootConstrainSelectedInstOperands,
     /* 396074 */     // GIR_Coverage, 6383,
     /* 396074 */     GIR_EraseRootFromParent_Done,
     /* 396075 */   // Label 7977: @396075
     /* 396075 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(396122), // Rule ID 6394 //
     /* 396080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396095 */     // MIs[1] Rn
     /* 396095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396106 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 396109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396120 */     GIR_RootConstrainSelectedInstOperands,
     /* 396121 */     // GIR_Coverage, 6394,
     /* 396121 */     GIR_EraseRootFromParent_Done,
     /* 396122 */   // Label 7978: @396122
     /* 396122 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(396169), // Rule ID 13127 //
     /* 396127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396142 */     // MIs[1] Rn
     /* 396142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396153 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 396156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396167 */     GIR_RootConstrainSelectedInstOperands,
     /* 396168 */     // GIR_Coverage, 13127,
     /* 396168 */     GIR_EraseRootFromParent_Done,
     /* 396169 */   // Label 7979: @396169
     /* 396169 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(396188), // Rule ID 1918 //
     /* 396174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 396181 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 396181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 396186 */     GIR_RootConstrainSelectedInstOperands,
     /* 396187 */     // GIR_Coverage, 1918,
     /* 396187 */     GIR_Done,
     /* 396188 */   // Label 7980: @396188
     /* 396188 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(396261), // Rule ID 5621 //
     /* 396193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396197 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 396200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 396214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 396251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396259 */     GIR_RootConstrainSelectedInstOperands,
     /* 396260 */     // GIR_Coverage, 5621,
     /* 396260 */     GIR_EraseRootFromParent_Done,
     /* 396261 */   // Label 7981: @396261
     /* 396261 */   GIM_Reject,
     /* 396262 */ // Label 7976: @396262
     /* 396262 */ GIM_Reject,
     /* 396263 */ // Label 7958: @396263
     /* 396263 */ GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(396324), // Rule ID 6379 //
     /* 396268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396283 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396286 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396290 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 396297 */   // MIs[1] Rn
     /* 396297 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396308 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396313 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396317 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396322 */   GIR_RootConstrainSelectedInstOperands,
     /* 396323 */   // GIR_Coverage, 6379,
     /* 396323 */   GIR_EraseRootFromParent_Done,
     /* 396324 */ // Label 7982: @396324
     /* 396324 */ GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(396378), // Rule ID 6396 //
     /* 396329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396344 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396351 */   // MIs[1] Rn
     /* 396351 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396355 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396362 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396367 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396376 */   GIR_RootConstrainSelectedInstOperands,
     /* 396377 */   // GIR_Coverage, 6396,
     /* 396377 */   GIR_EraseRootFromParent_Done,
     /* 396378 */ // Label 7983: @396378
     /* 396378 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(396432), // Rule ID 13123 //
     /* 396383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396398 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396401 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396405 */   // MIs[1] Rn
     /* 396405 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396409 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396416 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396421 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396425 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396430 */   GIR_RootConstrainSelectedInstOperands,
     /* 396431 */   // GIR_Coverage, 13123,
     /* 396431 */   GIR_EraseRootFromParent_Done,
     /* 396432 */ // Label 7984: @396432
     /* 396432 */ GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(396458), // Rule ID 1914 //
     /* 396437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396451 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 396451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 396456 */   GIR_RootConstrainSelectedInstOperands,
     /* 396457 */   // GIR_Coverage, 1914,
     /* 396457 */   GIR_Done,
     /* 396458 */ // Label 7985: @396458
     /* 396458 */ GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(396538), // Rule ID 5622 //
     /* 396463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396474 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 396477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 396491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396500 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396503 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396507 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 396510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 396528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396536 */   GIR_RootConstrainSelectedInstOperands,
     /* 396537 */   // GIR_Coverage, 5622,
     /* 396537 */   GIR_EraseRootFromParent_Done,
     /* 396538 */ // Label 7986: @396538
     /* 396538 */ GIM_Reject,
     /* 396539 */ // Label 7959: @396539
     /* 396539 */ GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(396785),
     /* 396544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396551 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(396598), // Rule ID 6382 //
     /* 396556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396571 */     // MIs[1] Rn
     /* 396571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396582 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 396585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396596 */     GIR_RootConstrainSelectedInstOperands,
     /* 396597 */     // GIR_Coverage, 6382,
     /* 396597 */     GIR_EraseRootFromParent_Done,
     /* 396598 */   // Label 7988: @396598
     /* 396598 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(396645), // Rule ID 6393 //
     /* 396603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396611 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396614 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396618 */     // MIs[1] Rn
     /* 396618 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396629 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 396632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396643 */     GIR_RootConstrainSelectedInstOperands,
     /* 396644 */     // GIR_Coverage, 6393,
     /* 396644 */     GIR_EraseRootFromParent_Done,
     /* 396645 */   // Label 7989: @396645
     /* 396645 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(396692), // Rule ID 13126 //
     /* 396650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396665 */     // MIs[1] Rn
     /* 396665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396676 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 396679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396690 */     GIR_RootConstrainSelectedInstOperands,
     /* 396691 */     // GIR_Coverage, 13126,
     /* 396691 */     GIR_EraseRootFromParent_Done,
     /* 396692 */   // Label 7990: @396692
     /* 396692 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(396711), // Rule ID 1917 //
     /* 396697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396704 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 396704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 396709 */     GIR_RootConstrainSelectedInstOperands,
     /* 396710 */     // GIR_Coverage, 1917,
     /* 396710 */     GIR_Done,
     /* 396711 */   // Label 7991: @396711
     /* 396711 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(396784), // Rule ID 5620 //
     /* 396716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396720 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396720 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 396723 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396727 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 396737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396753 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 396756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 396774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396782 */     GIR_RootConstrainSelectedInstOperands,
     /* 396783 */     // GIR_Coverage, 5620,
     /* 396783 */     GIR_EraseRootFromParent_Done,
     /* 396784 */   // Label 7992: @396784
     /* 396784 */   GIM_Reject,
     /* 396785 */ // Label 7987: @396785
     /* 396785 */ GIM_Reject,
     /* 396786 */ // Label 7960: @396786
     /* 396786 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(396843), // Rule ID 13121 //
     /* 396791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 396794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396798 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396802 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396806 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396813 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 396817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396819 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 396826 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 396829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 396836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396841 */   GIR_RootConstrainSelectedInstOperands,
     /* 396842 */   // GIR_Coverage, 13121,
     /* 396842 */   GIR_EraseRootFromParent_Done,
     /* 396843 */ // Label 7993: @396843
     /* 396843 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(396904), // Rule ID 6377 //
     /* 396848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396855 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396863 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396866 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396870 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 396877 */   // MIs[1] Rn
     /* 396877 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396881 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396886 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396888 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 396891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396893 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396902 */   GIR_RootConstrainSelectedInstOperands,
     /* 396903 */   // GIR_Coverage, 6377,
     /* 396903 */   GIR_EraseRootFromParent_Done,
     /* 396904 */ // Label 7994: @396904
     /* 396904 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(396930), // Rule ID 1912 //
     /* 396909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396923 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 396923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 396928 */   GIR_RootConstrainSelectedInstOperands,
     /* 396929 */   // GIR_Coverage, 1912,
     /* 396929 */   GIR_Done,
     /* 396930 */ // Label 7995: @396930
     /* 396930 */ GIM_Reject,
     /* 396931 */ // Label 7961: @396931
     /* 396931 */ GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(396992), // Rule ID 6380 //
     /* 396936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396951 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396954 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396958 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 396965 */   // MIs[1] Rn
     /* 396965 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396969 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396974 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396976 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 396979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396981 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396990 */   GIR_RootConstrainSelectedInstOperands,
     /* 396991 */   // GIR_Coverage, 6380,
     /* 396991 */   GIR_EraseRootFromParent_Done,
     /* 396992 */ // Label 7996: @396992
     /* 396992 */ GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(397046), // Rule ID 6397 //
     /* 396997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397004 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397008 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397012 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397015 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397019 */   // MIs[1] Rn
     /* 397019 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397023 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397030 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397035 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397044 */   GIR_RootConstrainSelectedInstOperands,
     /* 397045 */   // GIR_Coverage, 6397,
     /* 397045 */   GIR_EraseRootFromParent_Done,
     /* 397046 */ // Label 7997: @397046
     /* 397046 */ GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(397100), // Rule ID 13124 //
     /* 397051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397058 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397066 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397069 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397073 */   // MIs[1] Rn
     /* 397073 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397077 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397082 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397084 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397089 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397093 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397098 */   GIR_RootConstrainSelectedInstOperands,
     /* 397099 */   // GIR_Coverage, 13124,
     /* 397099 */   GIR_EraseRootFromParent_Done,
     /* 397100 */ // Label 7998: @397100
     /* 397100 */ GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(397126), // Rule ID 1915 //
     /* 397105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397119 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 397119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 397124 */   GIR_RootConstrainSelectedInstOperands,
     /* 397125 */   // GIR_Coverage, 1915,
     /* 397125 */   GIR_Done,
     /* 397126 */ // Label 7999: @397126
     /* 397126 */ GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(397206), // Rule ID 5623 //
     /* 397131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397142 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397142 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 397145 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397149 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 397159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397168 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397171 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397175 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 397178 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397183 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397188 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 397196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397204 */   GIR_RootConstrainSelectedInstOperands,
     /* 397205 */   // GIR_Coverage, 5623,
     /* 397205 */   GIR_EraseRootFromParent_Done,
     /* 397206 */ // Label 8000: @397206
     /* 397206 */ GIM_Reject,
     /* 397207 */ // Label 7962: @397207
     /* 397207 */ GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(397268), // Rule ID 6378 //
     /* 397212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397227 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397230 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397234 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 397241 */   // MIs[1] Rn
     /* 397241 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397245 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397252 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 397255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397257 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397261 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397266 */   GIR_RootConstrainSelectedInstOperands,
     /* 397267 */   // GIR_Coverage, 6378,
     /* 397267 */   GIR_EraseRootFromParent_Done,
     /* 397268 */ // Label 8001: @397268
     /* 397268 */ GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(397322), // Rule ID 13122 //
     /* 397273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 397276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397280 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397284 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397288 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397291 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397295 */   // MIs[1] Rn
     /* 397295 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397299 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397306 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 397309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397311 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397315 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397320 */   GIR_RootConstrainSelectedInstOperands,
     /* 397321 */   // GIR_Coverage, 13122,
     /* 397321 */   GIR_EraseRootFromParent_Done,
     /* 397322 */ // Label 8002: @397322
     /* 397322 */ GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(397348), // Rule ID 1913 //
     /* 397327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397341 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 397341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 397346 */   GIR_RootConstrainSelectedInstOperands,
     /* 397347 */   // GIR_Coverage, 1913,
     /* 397347 */   GIR_Done,
     /* 397348 */ // Label 8003: @397348
     /* 397348 */ GIM_Reject,
     /* 397349 */ // Label 7963: @397349
     /* 397349 */ GIM_Reject,
     /* 397350 */ // Label 123: @397350
     /* 397350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8006*/ GIMT_Encode4(397604),
     /* 397361 */ /*GILLT_v4s16*//*Label 8004*/ GIMT_Encode4(397377), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397373 */ /*GILLT_v8s16*//*Label 8005*/ GIMT_Encode4(397463),
     /* 397377 */ // Label 8004: @397377
     /* 397377 */ GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(397462),
     /* 397382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397396 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(397430), // Rule ID 1922 //
     /* 397401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397416 */     // MIs[1] Operand 1
     /* 397416 */     // No operand predicates
     /* 397416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397418 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397428 */     GIR_RootConstrainSelectedInstOperands,
     /* 397429 */     // GIR_Coverage, 1922,
     /* 397429 */     GIR_EraseRootFromParent_Done,
     /* 397430 */   // Label 8008: @397430
     /* 397430 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(397461), // Rule ID 5624 //
     /* 397435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397447 */     // MIs[1] Operand 1
     /* 397447 */     // No operand predicates
     /* 397447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397449 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 397449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397459 */     GIR_RootConstrainSelectedInstOperands,
     /* 397460 */     // GIR_Coverage, 5624,
     /* 397460 */     GIR_EraseRootFromParent_Done,
     /* 397461 */   // Label 8009: @397461
     /* 397461 */   GIM_Reject,
     /* 397462 */ // Label 8007: @397462
     /* 397462 */ GIM_Reject,
     /* 397463 */ // Label 8005: @397463
     /* 397463 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(397603),
     /* 397468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397478 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(397529), // Rule ID 6388 //
     /* 397483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397498 */     // MIs[1] Rn
     /* 397498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 397511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397513 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397527 */     GIR_RootConstrainSelectedInstOperands,
     /* 397528 */     // GIR_Coverage, 6388,
     /* 397528 */     GIR_EraseRootFromParent_Done,
     /* 397529 */   // Label 8011: @397529
     /* 397529 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(397567), // Rule ID 1923 //
     /* 397534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397553 */     // MIs[1] Operand 1
     /* 397553 */     // No operand predicates
     /* 397553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397555 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 397558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397565 */     GIR_RootConstrainSelectedInstOperands,
     /* 397566 */     // GIR_Coverage, 1923,
     /* 397566 */     GIR_EraseRootFromParent_Done,
     /* 397567 */   // Label 8012: @397567
     /* 397567 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(397602), // Rule ID 5625 //
     /* 397572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397588 */     // MIs[1] Operand 1
     /* 397588 */     // No operand predicates
     /* 397588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397590 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 397590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 397593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397600 */     GIR_RootConstrainSelectedInstOperands,
     /* 397601 */     // GIR_Coverage, 5625,
     /* 397601 */     GIR_EraseRootFromParent_Done,
     /* 397602 */   // Label 8013: @397602
     /* 397602 */   GIM_Reject,
     /* 397603 */ // Label 8010: @397603
     /* 397603 */ GIM_Reject,
     /* 397604 */ // Label 8006: @397604
     /* 397604 */ GIM_Reject,
     /* 397605 */ // Label 124: @397605
     /* 397605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8016*/ GIMT_Encode4(397859),
     /* 397616 */ /*GILLT_v2s32*//*Label 8014*/ GIMT_Encode4(397632), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397628 */ /*GILLT_v4s32*//*Label 8015*/ GIMT_Encode4(397718),
     /* 397632 */ // Label 8014: @397632
     /* 397632 */ GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(397717),
     /* 397637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397651 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(397685), // Rule ID 1920 //
     /* 397656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397671 */     // MIs[1] Operand 1
     /* 397671 */     // No operand predicates
     /* 397671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397673 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 397676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397683 */     GIR_RootConstrainSelectedInstOperands,
     /* 397684 */     // GIR_Coverage, 1920,
     /* 397684 */     GIR_EraseRootFromParent_Done,
     /* 397685 */   // Label 8018: @397685
     /* 397685 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(397716), // Rule ID 5626 //
     /* 397690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397702 */     // MIs[1] Operand 1
     /* 397702 */     // No operand predicates
     /* 397702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397704 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 397704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 397707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397714 */     GIR_RootConstrainSelectedInstOperands,
     /* 397715 */     // GIR_Coverage, 5626,
     /* 397715 */     GIR_EraseRootFromParent_Done,
     /* 397716 */   // Label 8019: @397716
     /* 397716 */   GIM_Reject,
     /* 397717 */ // Label 8017: @397717
     /* 397717 */ GIM_Reject,
     /* 397718 */ // Label 8015: @397718
     /* 397718 */ GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(397858),
     /* 397723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397733 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(397784), // Rule ID 6390 //
     /* 397738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397753 */     // MIs[1] Rn
     /* 397753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 397766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397768 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397782 */     GIR_RootConstrainSelectedInstOperands,
     /* 397783 */     // GIR_Coverage, 6390,
     /* 397783 */     GIR_EraseRootFromParent_Done,
     /* 397784 */   // Label 8021: @397784
     /* 397784 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(397822), // Rule ID 1921 //
     /* 397789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397808 */     // MIs[1] Operand 1
     /* 397808 */     // No operand predicates
     /* 397808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397810 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 397813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397820 */     GIR_RootConstrainSelectedInstOperands,
     /* 397821 */     // GIR_Coverage, 1921,
     /* 397821 */     GIR_EraseRootFromParent_Done,
     /* 397822 */   // Label 8022: @397822
     /* 397822 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(397857), // Rule ID 5627 //
     /* 397827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397843 */     // MIs[1] Operand 1
     /* 397843 */     // No operand predicates
     /* 397843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397845 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 397845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 397848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397855 */     GIR_RootConstrainSelectedInstOperands,
     /* 397856 */     // GIR_Coverage, 5627,
     /* 397856 */     GIR_EraseRootFromParent_Done,
     /* 397857 */   // Label 8023: @397857
     /* 397857 */   GIM_Reject,
     /* 397858 */ // Label 8020: @397858
     /* 397858 */ GIM_Reject,
     /* 397859 */ // Label 8016: @397859
     /* 397859 */ GIM_Reject,
     /* 397860 */ // Label 125: @397860
     /* 397860 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(398005),
     /* 397865 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 397868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397878 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(397929), // Rule ID 6391 //
     /* 397883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397898 */     // MIs[1] Rn
     /* 397898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 397911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397913 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 397916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397927 */     GIR_RootConstrainSelectedInstOperands,
     /* 397928 */     // GIR_Coverage, 6391,
     /* 397928 */     GIR_EraseRootFromParent_Done,
     /* 397929 */   // Label 8025: @397929
     /* 397929 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(398004),
     /* 397934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397938 */     GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(397972), // Rule ID 1919 //
     /* 397943 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397946 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397950 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397954 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397958 */       // MIs[1] Operand 1
     /* 397958 */       // No operand predicates
     /* 397958 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397960 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397960 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 397963 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397965 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397967 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397970 */       GIR_RootConstrainSelectedInstOperands,
     /* 397971 */       // GIR_Coverage, 1919,
     /* 397971 */       GIR_EraseRootFromParent_Done,
     /* 397972 */     // Label 8027: @397972
     /* 397972 */     GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(398003), // Rule ID 5628 //
     /* 397977 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397981 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397985 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397989 */       // MIs[1] Operand 1
     /* 397989 */       // No operand predicates
     /* 397989 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397991 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 397991 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 397994 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397996 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397998 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398001 */       GIR_RootConstrainSelectedInstOperands,
     /* 398002 */       // GIR_Coverage, 5628,
     /* 398002 */       GIR_EraseRootFromParent_Done,
     /* 398003 */     // Label 8028: @398003
     /* 398003 */     GIM_Reject,
     /* 398004 */   // Label 8026: @398004
     /* 398004 */   GIM_Reject,
     /* 398005 */ // Label 8024: @398005
     /* 398005 */ GIM_Reject,
     /* 398006 */ // Label 126: @398006
     /* 398006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8031*/ GIMT_Encode4(398184),
     /* 398017 */ /*GILLT_v8s8*//*Label 8029*/ GIMT_Encode4(398029), GIMT_Encode4(0),
     /* 398025 */ /*GILLT_v16s8*//*Label 8030*/ GIMT_Encode4(398078),
     /* 398029 */ // Label 8029: @398029
     /* 398029 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(398077), // Rule ID 1924 //
     /* 398034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398051 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398059 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 398063 */   // MIs[1] Operand 1
     /* 398063 */   // No operand predicates
     /* 398063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398065 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 398068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398070 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398072 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398075 */   GIR_RootConstrainSelectedInstOperands,
     /* 398076 */   // GIR_Coverage, 1924,
     /* 398076 */   GIR_EraseRootFromParent_Done,
     /* 398077 */ // Label 8032: @398077
     /* 398077 */ GIM_Reject,
     /* 398078 */ // Label 8030: @398078
     /* 398078 */ GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(398183),
     /* 398083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398093 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(398144), // Rule ID 6386 //
     /* 398098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398106 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398113 */     // MIs[1] Rn
     /* 398113 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398128 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 398131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398142 */     GIR_RootConstrainSelectedInstOperands,
     /* 398143 */     // GIR_Coverage, 6386,
     /* 398143 */     GIR_EraseRootFromParent_Done,
     /* 398144 */   // Label 8034: @398144
     /* 398144 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(398182), // Rule ID 1925 //
     /* 398149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 398168 */     // MIs[1] Operand 1
     /* 398168 */     // No operand predicates
     /* 398168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398170 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 398173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398180 */     GIR_RootConstrainSelectedInstOperands,
     /* 398181 */     // GIR_Coverage, 1925,
     /* 398181 */     GIR_EraseRootFromParent_Done,
     /* 398182 */   // Label 8035: @398182
     /* 398182 */   GIM_Reject,
     /* 398183 */ // Label 8033: @398183
     /* 398183 */ GIM_Reject,
     /* 398184 */ // Label 8031: @398184
     /* 398184 */ GIM_Reject,
     /* 398185 */ // Label 127: @398185
     /* 398185 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8045*/ GIMT_Encode4(399834),
     /* 398196 */ /*GILLT_s64*//*Label 8036*/ GIMT_Encode4(398280), GIMT_Encode4(0),
     /* 398204 */ /*GILLT_v2s32*//*Label 8037*/ GIMT_Encode4(398601),
     /* 398208 */ /*GILLT_v2s64*//*Label 8038*/ GIMT_Encode4(398922),
     /* 398212 */ /*GILLT_v4s16*//*Label 8039*/ GIMT_Encode4(399005),
     /* 398216 */ /*GILLT_v4s32*//*Label 8040*/ GIMT_Encode4(399326),
     /* 398220 */ /*GILLT_v8s8*//*Label 8041*/ GIMT_Encode4(399409),
     /* 398224 */ /*GILLT_v8s16*//*Label 8042*/ GIMT_Encode4(399618),
     /* 398228 */ /*GILLT_v16s8*//*Label 8043*/ GIMT_Encode4(399701), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398276 */ /*GILLT_nxv16s8*//*Label 8044*/ GIMT_Encode4(399787),
     /* 398280 */ // Label 8036: @398280
     /* 398280 */ GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(398600),
     /* 398285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398295 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(398410), // Rule ID 5445 //
     /* 398300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398317 */     // MIs[1] Operand 2
     /* 398317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398336 */     // MIs[2] Rn
     /* 398336 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398341 */     // MIs[2] Operand 2
     /* 398341 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 398352 */     // MIs[0] imm
     /* 398352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398360 */     // MIs[3] Operand 1
     /* 398360 */     // No operand predicates
     /* 398360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398362 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398392 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398409 */     // GIR_Coverage, 5445,
     /* 398409 */     GIR_EraseRootFromParent_Done,
     /* 398410 */   // Label 8047: @398410
     /* 398410 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(398525), // Rule ID 5450 //
     /* 398415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398432 */     // MIs[1] Operand 2
     /* 398432 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398451 */     // MIs[2] Rn
     /* 398451 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398456 */     // MIs[2] Operand 2
     /* 398456 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 398467 */     // MIs[0] imm
     /* 398467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398475 */     // MIs[3] Operand 1
     /* 398475 */     // No operand predicates
     /* 398475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398477 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398507 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398524 */     // GIR_Coverage, 5450,
     /* 398524 */     GIR_EraseRootFromParent_Done,
     /* 398525 */   // Label 8048: @398525
     /* 398525 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(398562), // Rule ID 5442 //
     /* 398530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398538 */     // MIs[0] imm
     /* 398538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398546 */     // MIs[1] Operand 1
     /* 398546 */     // No operand predicates
     /* 398546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398548 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398560 */     GIR_RootConstrainSelectedInstOperands,
     /* 398561 */     // GIR_Coverage, 5442,
     /* 398561 */     GIR_EraseRootFromParent_Done,
     /* 398562 */   // Label 8049: @398562
     /* 398562 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(398599), // Rule ID 5447 //
     /* 398567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398575 */     // MIs[0] imm
     /* 398575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398583 */     // MIs[1] Operand 1
     /* 398583 */     // No operand predicates
     /* 398583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398585 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398597 */     GIR_RootConstrainSelectedInstOperands,
     /* 398598 */     // GIR_Coverage, 5447,
     /* 398598 */     GIR_EraseRootFromParent_Done,
     /* 398599 */   // Label 8050: @398599
     /* 398599 */   GIM_Reject,
     /* 398600 */ // Label 8046: @398600
     /* 398600 */ GIM_Reject,
     /* 398601 */ // Label 8037: @398601
     /* 398601 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(398921),
     /* 398606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398616 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(398731), // Rule ID 5435 //
     /* 398621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398638 */     // MIs[1] Operand 2
     /* 398638 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398657 */     // MIs[2] Rn
     /* 398657 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398662 */     // MIs[2] Operand 2
     /* 398662 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 398673 */     // MIs[0] imm
     /* 398673 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398677 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398681 */     // MIs[3] Operand 1
     /* 398681 */     // No operand predicates
     /* 398681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398683 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398695 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398699 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398713 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398730 */     // GIR_Coverage, 5435,
     /* 398730 */     GIR_EraseRootFromParent_Done,
     /* 398731 */   // Label 8052: @398731
     /* 398731 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(398846), // Rule ID 5440 //
     /* 398736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398753 */     // MIs[1] Operand 2
     /* 398753 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398772 */     // MIs[2] Rn
     /* 398772 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398777 */     // MIs[2] Operand 2
     /* 398777 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 398788 */     // MIs[0] imm
     /* 398788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398796 */     // MIs[3] Operand 1
     /* 398796 */     // No operand predicates
     /* 398796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398798 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398845 */     // GIR_Coverage, 5440,
     /* 398845 */     GIR_EraseRootFromParent_Done,
     /* 398846 */   // Label 8053: @398846
     /* 398846 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(398883), // Rule ID 5432 //
     /* 398851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398859 */     // MIs[0] imm
     /* 398859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398867 */     // MIs[1] Operand 1
     /* 398867 */     // No operand predicates
     /* 398867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398869 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398881 */     GIR_RootConstrainSelectedInstOperands,
     /* 398882 */     // GIR_Coverage, 5432,
     /* 398882 */     GIR_EraseRootFromParent_Done,
     /* 398883 */   // Label 8054: @398883
     /* 398883 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(398920), // Rule ID 5437 //
     /* 398888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398896 */     // MIs[0] imm
     /* 398896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398904 */     // MIs[1] Operand 1
     /* 398904 */     // No operand predicates
     /* 398904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398906 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 398909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398918 */     GIR_RootConstrainSelectedInstOperands,
     /* 398919 */     // GIR_Coverage, 5437,
     /* 398919 */     GIR_EraseRootFromParent_Done,
     /* 398920 */   // Label 8055: @398920
     /* 398920 */   GIM_Reject,
     /* 398921 */ // Label 8051: @398921
     /* 398921 */ GIM_Reject,
     /* 398922 */ // Label 8038: @398922
     /* 398922 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(399004),
     /* 398927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398945 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(398974), // Rule ID 5443 //
     /* 398950 */     // MIs[0] imm
     /* 398950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398958 */     // MIs[1] Operand 1
     /* 398958 */     // No operand predicates
     /* 398958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398960 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398972 */     GIR_RootConstrainSelectedInstOperands,
     /* 398973 */     // GIR_Coverage, 5443,
     /* 398973 */     GIR_EraseRootFromParent_Done,
     /* 398974 */   // Label 8057: @398974
     /* 398974 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(399003), // Rule ID 5448 //
     /* 398979 */     // MIs[0] imm
     /* 398979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 398983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398987 */     // MIs[1] Operand 1
     /* 398987 */     // No operand predicates
     /* 398987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398989 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 398989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 398998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399001 */     GIR_RootConstrainSelectedInstOperands,
     /* 399002 */     // GIR_Coverage, 5448,
     /* 399002 */     GIR_EraseRootFromParent_Done,
     /* 399003 */   // Label 8058: @399003
     /* 399003 */   GIM_Reject,
     /* 399004 */ // Label 8056: @399004
     /* 399004 */ GIM_Reject,
     /* 399005 */ // Label 8039: @399005
     /* 399005 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(399325),
     /* 399010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399020 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(399135), // Rule ID 5425 //
     /* 399025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399042 */     // MIs[1] Operand 2
     /* 399042 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399061 */     // MIs[2] Rn
     /* 399061 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399066 */     // MIs[2] Operand 2
     /* 399066 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 399077 */     // MIs[0] imm
     /* 399077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399085 */     // MIs[3] Operand 1
     /* 399085 */     // No operand predicates
     /* 399085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399087 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399117 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399134 */     // GIR_Coverage, 5425,
     /* 399134 */     GIR_EraseRootFromParent_Done,
     /* 399135 */   // Label 8060: @399135
     /* 399135 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(399250), // Rule ID 5430 //
     /* 399140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399157 */     // MIs[1] Operand 2
     /* 399157 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399176 */     // MIs[2] Rn
     /* 399176 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399181 */     // MIs[2] Operand 2
     /* 399181 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 399192 */     // MIs[0] imm
     /* 399192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399200 */     // MIs[3] Operand 1
     /* 399200 */     // No operand predicates
     /* 399200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399202 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399232 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399249 */     // GIR_Coverage, 5430,
     /* 399249 */     GIR_EraseRootFromParent_Done,
     /* 399250 */   // Label 8061: @399250
     /* 399250 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(399287), // Rule ID 5422 //
     /* 399255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399263 */     // MIs[0] imm
     /* 399263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399271 */     // MIs[1] Operand 1
     /* 399271 */     // No operand predicates
     /* 399271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399273 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399285 */     GIR_RootConstrainSelectedInstOperands,
     /* 399286 */     // GIR_Coverage, 5422,
     /* 399286 */     GIR_EraseRootFromParent_Done,
     /* 399287 */   // Label 8062: @399287
     /* 399287 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(399324), // Rule ID 5427 //
     /* 399292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399300 */     // MIs[0] imm
     /* 399300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399308 */     // MIs[1] Operand 1
     /* 399308 */     // No operand predicates
     /* 399308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399310 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399322 */     GIR_RootConstrainSelectedInstOperands,
     /* 399323 */     // GIR_Coverage, 5427,
     /* 399323 */     GIR_EraseRootFromParent_Done,
     /* 399324 */   // Label 8063: @399324
     /* 399324 */   GIM_Reject,
     /* 399325 */ // Label 8059: @399325
     /* 399325 */ GIM_Reject,
     /* 399326 */ // Label 8040: @399326
     /* 399326 */ GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(399408),
     /* 399331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399349 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(399378), // Rule ID 5433 //
     /* 399354 */     // MIs[0] imm
     /* 399354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399362 */     // MIs[1] Operand 1
     /* 399362 */     // No operand predicates
     /* 399362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399364 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399376 */     GIR_RootConstrainSelectedInstOperands,
     /* 399377 */     // GIR_Coverage, 5433,
     /* 399377 */     GIR_EraseRootFromParent_Done,
     /* 399378 */   // Label 8065: @399378
     /* 399378 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(399407), // Rule ID 5438 //
     /* 399383 */     // MIs[0] imm
     /* 399383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399391 */     // MIs[1] Operand 1
     /* 399391 */     // No operand predicates
     /* 399391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399393 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399405 */     GIR_RootConstrainSelectedInstOperands,
     /* 399406 */     // GIR_Coverage, 5438,
     /* 399406 */     GIR_EraseRootFromParent_Done,
     /* 399407 */   // Label 8066: @399407
     /* 399407 */   GIM_Reject,
     /* 399408 */ // Label 8064: @399408
     /* 399408 */ GIM_Reject,
     /* 399409 */ // Label 8041: @399409
     /* 399409 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(399617),
     /* 399414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399424 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(399539), // Rule ID 5420 //
     /* 399429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399446 */     // MIs[1] Operand 2
     /* 399446 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399465 */     // MIs[2] Rn
     /* 399465 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399470 */     // MIs[2] Operand 2
     /* 399470 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 399481 */     // MIs[0] imm
     /* 399481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399489 */     // MIs[3] Operand 1
     /* 399489 */     // No operand predicates
     /* 399489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399491 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399507 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399521 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399538 */     // GIR_Coverage, 5420,
     /* 399538 */     GIR_EraseRootFromParent_Done,
     /* 399539 */   // Label 8068: @399539
     /* 399539 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(399579), // Rule ID 1868 //
     /* 399544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399555 */     // MIs[0] imm
     /* 399555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399563 */     // MIs[1] Operand 1
     /* 399563 */     // No operand predicates
     /* 399563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399565 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399577 */     GIR_RootConstrainSelectedInstOperands,
     /* 399578 */     // GIR_Coverage, 1868,
     /* 399578 */     GIR_EraseRootFromParent_Done,
     /* 399579 */   // Label 8069: @399579
     /* 399579 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(399616), // Rule ID 5417 //
     /* 399584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399592 */     // MIs[0] imm
     /* 399592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399600 */     // MIs[1] Operand 1
     /* 399600 */     // No operand predicates
     /* 399600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399602 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399614 */     GIR_RootConstrainSelectedInstOperands,
     /* 399615 */     // GIR_Coverage, 5417,
     /* 399615 */     GIR_EraseRootFromParent_Done,
     /* 399616 */   // Label 8070: @399616
     /* 399616 */   GIM_Reject,
     /* 399617 */ // Label 8067: @399617
     /* 399617 */ GIM_Reject,
     /* 399618 */ // Label 8042: @399618
     /* 399618 */ GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(399700),
     /* 399623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399641 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(399670), // Rule ID 5423 //
     /* 399646 */     // MIs[0] imm
     /* 399646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399654 */     // MIs[1] Operand 1
     /* 399654 */     // No operand predicates
     /* 399654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399656 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399668 */     GIR_RootConstrainSelectedInstOperands,
     /* 399669 */     // GIR_Coverage, 5423,
     /* 399669 */     GIR_EraseRootFromParent_Done,
     /* 399670 */   // Label 8072: @399670
     /* 399670 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(399699), // Rule ID 5428 //
     /* 399675 */     // MIs[0] imm
     /* 399675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399683 */     // MIs[1] Operand 1
     /* 399683 */     // No operand predicates
     /* 399683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399685 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399697 */     GIR_RootConstrainSelectedInstOperands,
     /* 399698 */     // GIR_Coverage, 5428,
     /* 399698 */     GIR_EraseRootFromParent_Done,
     /* 399699 */   // Label 8073: @399699
     /* 399699 */   GIM_Reject,
     /* 399700 */ // Label 8071: @399700
     /* 399700 */ GIM_Reject,
     /* 399701 */ // Label 8043: @399701
     /* 399701 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(399786),
     /* 399706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 399712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399724 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(399756), // Rule ID 1869 //
     /* 399729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399732 */     // MIs[0] imm
     /* 399732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399740 */     // MIs[1] Operand 1
     /* 399740 */     // No operand predicates
     /* 399740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399742 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399754 */     GIR_RootConstrainSelectedInstOperands,
     /* 399755 */     // GIR_Coverage, 1869,
     /* 399755 */     GIR_EraseRootFromParent_Done,
     /* 399756 */   // Label 8075: @399756
     /* 399756 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(399785), // Rule ID 5418 //
     /* 399761 */     // MIs[0] imm
     /* 399761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399769 */     // MIs[1] Operand 1
     /* 399769 */     // No operand predicates
     /* 399769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399771 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399783 */     GIR_RootConstrainSelectedInstOperands,
     /* 399784 */     // GIR_Coverage, 5418,
     /* 399784 */     GIR_EraseRootFromParent_Done,
     /* 399785 */   // Label 8076: @399785
     /* 399785 */   GIM_Reject,
     /* 399786 */ // Label 8074: @399786
     /* 399786 */ GIM_Reject,
     /* 399787 */ // Label 8044: @399787
     /* 399787 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(399833), // Rule ID 2733 //
     /* 399792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 399795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 399798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 399801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 399805 */   // MIs[0] Op3
     /* 399805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399813 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 399817 */   // MIs[1] Operand 1
     /* 399817 */   // No operand predicates
     /* 399817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399819 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 399819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 399822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 399824 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 399826 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 399828 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 399831 */   GIR_RootConstrainSelectedInstOperands,
     /* 399832 */   // GIR_Coverage, 2733,
     /* 399832 */   GIR_EraseRootFromParent_Done,
     /* 399833 */ // Label 8077: @399833
     /* 399833 */ GIM_Reject,
     /* 399834 */ // Label 8045: @399834
     /* 399834 */ GIM_Reject,
     /* 399835 */ // Label 128: @399835
     /* 399835 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8085*/ GIMT_Encode4(400173),
     /* 399846 */ /*GILLT_s32*//*Label 8078*/ GIMT_Encode4(399882),
     /* 399850 */ /*GILLT_s64*//*Label 8079*/ GIMT_Encode4(399920), GIMT_Encode4(0),
     /* 399858 */ /*GILLT_v2s32*//*Label 8080*/ GIMT_Encode4(399983),
     /* 399862 */ /*GILLT_v2s64*//*Label 8081*/ GIMT_Encode4(400021),
     /* 399866 */ /*GILLT_v4s16*//*Label 8082*/ GIMT_Encode4(400059),
     /* 399870 */ /*GILLT_v4s32*//*Label 8083*/ GIMT_Encode4(400097), GIMT_Encode4(0),
     /* 399878 */ /*GILLT_v8s16*//*Label 8084*/ GIMT_Encode4(400135),
     /* 399882 */ // Label 8078: @399882
     /* 399882 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(399919), // Rule ID 1622 //
     /* 399887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 399893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 399896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399908 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 399908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 399913 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399917 */   GIR_RootConstrainSelectedInstOperands,
     /* 399918 */   // GIR_Coverage, 1622,
     /* 399918 */   GIR_Done,
     /* 399919 */ // Label 8086: @399919
     /* 399919 */ GIM_Reject,
     /* 399920 */ // Label 8079: @399920
     /* 399920 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(399982),
     /* 399925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 399928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 399931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399943 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(399962), // Rule ID 1621 //
     /* 399948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399951 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 399951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 399956 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399960 */     GIR_RootConstrainSelectedInstOperands,
     /* 399961 */     // GIR_Coverage, 1621,
     /* 399961 */     GIR_Done,
     /* 399962 */   // Label 8088: @399962
     /* 399962 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(399981), // Rule ID 5197 //
     /* 399967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399970 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 399970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 399975 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399979 */     GIR_RootConstrainSelectedInstOperands,
     /* 399980 */     // GIR_Coverage, 5197,
     /* 399980 */     GIR_Done,
     /* 399981 */   // Label 8089: @399981
     /* 399981 */   GIM_Reject,
     /* 399982 */ // Label 8087: @399982
     /* 399982 */ GIM_Reject,
     /* 399983 */ // Label 8080: @399983
     /* 399983 */ GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(400020), // Rule ID 1210 //
     /* 399988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400009 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400009 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 400014 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400018 */   GIR_RootConstrainSelectedInstOperands,
     /* 400019 */   // GIR_Coverage, 1210,
     /* 400019 */   GIR_Done,
     /* 400020 */ // Label 8090: @400020
     /* 400020 */ GIM_Reject,
     /* 400021 */ // Label 8081: @400021
     /* 400021 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(400058), // Rule ID 1212 //
     /* 400026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 400035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400047 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 400052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400056 */   GIR_RootConstrainSelectedInstOperands,
     /* 400057 */   // GIR_Coverage, 1212,
     /* 400057 */   GIR_Done,
     /* 400058 */ // Label 8091: @400058
     /* 400058 */ GIM_Reject,
     /* 400059 */ // Label 8082: @400059
     /* 400059 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(400096), // Rule ID 1208 //
     /* 400064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400085 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400085 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 400090 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400094 */   GIR_RootConstrainSelectedInstOperands,
     /* 400095 */   // GIR_Coverage, 1208,
     /* 400095 */   GIR_Done,
     /* 400096 */ // Label 8092: @400096
     /* 400096 */ GIM_Reject,
     /* 400097 */ // Label 8083: @400097
     /* 400097 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(400134), // Rule ID 1211 //
     /* 400102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400123 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 400128 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400132 */   GIR_RootConstrainSelectedInstOperands,
     /* 400133 */   // GIR_Coverage, 1211,
     /* 400133 */   GIR_Done,
     /* 400134 */ // Label 8093: @400134
     /* 400134 */ GIM_Reject,
     /* 400135 */ // Label 8084: @400135
     /* 400135 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(400172), // Rule ID 1209 //
     /* 400140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400161 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 400166 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400170 */   GIR_RootConstrainSelectedInstOperands,
     /* 400171 */   // GIR_Coverage, 1209,
     /* 400171 */   GIR_Done,
     /* 400172 */ // Label 8094: @400172
     /* 400172 */ GIM_Reject,
     /* 400173 */ // Label 8085: @400173
     /* 400173 */ GIM_Reject,
     /* 400174 */ // Label 129: @400174
     /* 400174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8101*/ GIMT_Encode4(400403),
     /* 400185 */ /*GILLT_s64*//*Label 8095*/ GIMT_Encode4(400217), GIMT_Encode4(0),
     /* 400193 */ /*GILLT_v2s32*//*Label 8096*/ GIMT_Encode4(400248),
     /* 400197 */ /*GILLT_v2s64*//*Label 8097*/ GIMT_Encode4(400279),
     /* 400201 */ /*GILLT_v4s16*//*Label 8098*/ GIMT_Encode4(400310),
     /* 400205 */ /*GILLT_v4s32*//*Label 8099*/ GIMT_Encode4(400341), GIMT_Encode4(0),
     /* 400213 */ /*GILLT_v8s16*//*Label 8100*/ GIMT_Encode4(400372),
     /* 400217 */ // Label 8095: @400217
     /* 400217 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(400247), // Rule ID 2513 //
     /* 400222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400236 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 400236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 400241 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400245 */   GIR_RootConstrainSelectedInstOperands,
     /* 400246 */   // GIR_Coverage, 2513,
     /* 400246 */   GIR_Done,
     /* 400247 */ // Label 8102: @400247
     /* 400247 */ GIM_Reject,
     /* 400248 */ // Label 8096: @400248
     /* 400248 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(400278), // Rule ID 773 //
     /* 400253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400267 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 400267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 400272 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400276 */   GIR_RootConstrainSelectedInstOperands,
     /* 400277 */   // GIR_Coverage, 773,
     /* 400277 */   GIR_Done,
     /* 400278 */ // Label 8103: @400278
     /* 400278 */ GIM_Reject,
     /* 400279 */ // Label 8097: @400279
     /* 400279 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(400309), // Rule ID 775 //
     /* 400284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400298 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 400298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 400303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400307 */   GIR_RootConstrainSelectedInstOperands,
     /* 400308 */   // GIR_Coverage, 775,
     /* 400308 */   GIR_Done,
     /* 400309 */ // Label 8104: @400309
     /* 400309 */ GIM_Reject,
     /* 400310 */ // Label 8098: @400310
     /* 400310 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(400340), // Rule ID 771 //
     /* 400315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400329 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 400329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 400334 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400338 */   GIR_RootConstrainSelectedInstOperands,
     /* 400339 */   // GIR_Coverage, 771,
     /* 400339 */   GIR_Done,
     /* 400340 */ // Label 8105: @400340
     /* 400340 */ GIM_Reject,
     /* 400341 */ // Label 8099: @400341
     /* 400341 */ GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(400371), // Rule ID 774 //
     /* 400346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400360 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 400360 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 400365 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400369 */   GIR_RootConstrainSelectedInstOperands,
     /* 400370 */   // GIR_Coverage, 774,
     /* 400370 */   GIR_Done,
     /* 400371 */ // Label 8106: @400371
     /* 400371 */ GIM_Reject,
     /* 400372 */ // Label 8100: @400372
     /* 400372 */ GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(400402), // Rule ID 772 //
     /* 400377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400391 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 400391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 400396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400400 */   GIR_RootConstrainSelectedInstOperands,
     /* 400401 */   // GIR_Coverage, 772,
     /* 400401 */   GIR_Done,
     /* 400402 */ // Label 8107: @400402
     /* 400402 */ GIM_Reject,
     /* 400403 */ // Label 8101: @400403
     /* 400403 */ GIM_Reject,
     /* 400404 */ // Label 130: @400404
     /* 400404 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8115*/ GIMT_Encode4(401067),
     /* 400415 */ /*GILLT_s32*//*Label 8108*/ GIMT_Encode4(400451),
     /* 400419 */ /*GILLT_s64*//*Label 8109*/ GIMT_Encode4(400489), GIMT_Encode4(0),
     /* 400427 */ /*GILLT_v2s32*//*Label 8110*/ GIMT_Encode4(400552),
     /* 400431 */ /*GILLT_v2s64*//*Label 8111*/ GIMT_Encode4(400655),
     /* 400435 */ /*GILLT_v4s16*//*Label 8112*/ GIMT_Encode4(400758),
     /* 400439 */ /*GILLT_v4s32*//*Label 8113*/ GIMT_Encode4(400861), GIMT_Encode4(0),
     /* 400447 */ /*GILLT_v8s16*//*Label 8114*/ GIMT_Encode4(400964),
     /* 400451 */ // Label 8108: @400451
     /* 400451 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(400488), // Rule ID 1624 //
     /* 400456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 400465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400477 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 400477 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 400482 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400486 */   GIR_RootConstrainSelectedInstOperands,
     /* 400487 */   // GIR_Coverage, 1624,
     /* 400487 */   GIR_Done,
     /* 400488 */ // Label 8116: @400488
     /* 400488 */ GIM_Reject,
     /* 400489 */ // Label 8109: @400489
     /* 400489 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(400551),
     /* 400494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400512 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(400531), // Rule ID 1623 //
     /* 400517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400520 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 400525 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400529 */     GIR_RootConstrainSelectedInstOperands,
     /* 400530 */     // GIR_Coverage, 1623,
     /* 400530 */     GIR_Done,
     /* 400531 */   // Label 8118: @400531
     /* 400531 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(400550), // Rule ID 5198 //
     /* 400536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400539 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 400539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 400544 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400548 */     GIR_RootConstrainSelectedInstOperands,
     /* 400549 */     // GIR_Coverage, 5198,
     /* 400549 */     GIR_Done,
     /* 400550 */   // Label 8119: @400550
     /* 400550 */   GIM_Reject,
     /* 400551 */ // Label 8117: @400551
     /* 400551 */ GIM_Reject,
     /* 400552 */ // Label 8110: @400552
     /* 400552 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(400654),
     /* 400557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 400563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400567 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(400626), // Rule ID 1172 //
     /* 400572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400611 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 400614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400624 */     GIR_RootConstrainSelectedInstOperands,
     /* 400625 */     // GIR_Coverage, 1172,
     /* 400625 */     GIR_EraseRootFromParent_Done,
     /* 400626 */   // Label 8121: @400626
     /* 400626 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(400653), // Rule ID 1215 //
     /* 400631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400642 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 400647 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400651 */     GIR_RootConstrainSelectedInstOperands,
     /* 400652 */     // GIR_Coverage, 1215,
     /* 400652 */     GIR_Done,
     /* 400653 */   // Label 8122: @400653
     /* 400653 */   GIM_Reject,
     /* 400654 */ // Label 8120: @400654
     /* 400654 */ GIM_Reject,
     /* 400655 */ // Label 8111: @400655
     /* 400655 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(400757),
     /* 400660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 400666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400670 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(400729), // Rule ID 1176 //
     /* 400675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400714 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 400717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400727 */     GIR_RootConstrainSelectedInstOperands,
     /* 400728 */     // GIR_Coverage, 1176,
     /* 400728 */     GIR_EraseRootFromParent_Done,
     /* 400729 */   // Label 8124: @400729
     /* 400729 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(400756), // Rule ID 1217 //
     /* 400734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400745 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 400750 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400754 */     GIR_RootConstrainSelectedInstOperands,
     /* 400755 */     // GIR_Coverage, 1217,
     /* 400755 */     GIR_Done,
     /* 400756 */   // Label 8125: @400756
     /* 400756 */   GIM_Reject,
     /* 400757 */ // Label 8123: @400757
     /* 400757 */ GIM_Reject,
     /* 400758 */ // Label 8112: @400758
     /* 400758 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(400860),
     /* 400763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400773 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(400832), // Rule ID 1168 //
     /* 400778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400817 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 400820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400830 */     GIR_RootConstrainSelectedInstOperands,
     /* 400831 */     // GIR_Coverage, 1168,
     /* 400831 */     GIR_EraseRootFromParent_Done,
     /* 400832 */   // Label 8127: @400832
     /* 400832 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(400859), // Rule ID 1213 //
     /* 400837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400848 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 400853 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400857 */     GIR_RootConstrainSelectedInstOperands,
     /* 400858 */     // GIR_Coverage, 1213,
     /* 400858 */     GIR_Done,
     /* 400859 */   // Label 8128: @400859
     /* 400859 */   GIM_Reject,
     /* 400860 */ // Label 8126: @400860
     /* 400860 */ GIM_Reject,
     /* 400861 */ // Label 8113: @400861
     /* 400861 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(400963),
     /* 400866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400876 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(400935), // Rule ID 1174 //
     /* 400881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 400905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400920 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 400923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400933 */     GIR_RootConstrainSelectedInstOperands,
     /* 400934 */     // GIR_Coverage, 1174,
     /* 400934 */     GIR_EraseRootFromParent_Done,
     /* 400935 */   // Label 8130: @400935
     /* 400935 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(400962), // Rule ID 1216 //
     /* 400940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400951 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 400956 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400960 */     GIR_RootConstrainSelectedInstOperands,
     /* 400961 */     // GIR_Coverage, 1216,
     /* 400961 */     GIR_Done,
     /* 400962 */   // Label 8131: @400962
     /* 400962 */   GIM_Reject,
     /* 400963 */ // Label 8129: @400963
     /* 400963 */ GIM_Reject,
     /* 400964 */ // Label 8114: @400964
     /* 400964 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(401066),
     /* 400969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400979 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(401038), // Rule ID 1170 //
     /* 400984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 400995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401023 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 401026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401036 */     GIR_RootConstrainSelectedInstOperands,
     /* 401037 */     // GIR_Coverage, 1170,
     /* 401037 */     GIR_EraseRootFromParent_Done,
     /* 401038 */   // Label 8133: @401038
     /* 401038 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(401065), // Rule ID 1214 //
     /* 401043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401054 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 401059 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401063 */     GIR_RootConstrainSelectedInstOperands,
     /* 401064 */     // GIR_Coverage, 1214,
     /* 401064 */     GIR_Done,
     /* 401065 */   // Label 8134: @401065
     /* 401065 */   GIM_Reject,
     /* 401066 */ // Label 8132: @401066
     /* 401066 */ GIM_Reject,
     /* 401067 */ // Label 8115: @401067
     /* 401067 */ GIM_Reject,
     /* 401068 */ // Label 131: @401068
     /* 401068 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8141*/ GIMT_Encode4(401297),
     /* 401079 */ /*GILLT_s64*//*Label 8135*/ GIMT_Encode4(401111), GIMT_Encode4(0),
     /* 401087 */ /*GILLT_v2s32*//*Label 8136*/ GIMT_Encode4(401142),
     /* 401091 */ /*GILLT_v2s64*//*Label 8137*/ GIMT_Encode4(401173),
     /* 401095 */ /*GILLT_v4s16*//*Label 8138*/ GIMT_Encode4(401204),
     /* 401099 */ /*GILLT_v4s32*//*Label 8139*/ GIMT_Encode4(401235), GIMT_Encode4(0),
     /* 401107 */ /*GILLT_v8s16*//*Label 8140*/ GIMT_Encode4(401266),
     /* 401111 */ // Label 8135: @401111
     /* 401111 */ GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(401141), // Rule ID 5229 //
     /* 401116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401130 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 401130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 401135 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401139 */   GIR_RootConstrainSelectedInstOperands,
     /* 401140 */   // GIR_Coverage, 5229,
     /* 401140 */   GIR_Done,
     /* 401141 */ // Label 8142: @401141
     /* 401141 */ GIM_Reject,
     /* 401142 */ // Label 8136: @401142
     /* 401142 */ GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(401172), // Rule ID 778 //
     /* 401147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401161 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 401161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 401166 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401170 */   GIR_RootConstrainSelectedInstOperands,
     /* 401171 */   // GIR_Coverage, 778,
     /* 401171 */   GIR_Done,
     /* 401172 */ // Label 8143: @401172
     /* 401172 */ GIM_Reject,
     /* 401173 */ // Label 8137: @401173
     /* 401173 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(401203), // Rule ID 780 //
     /* 401178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401192 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 401192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 401197 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401201 */   GIR_RootConstrainSelectedInstOperands,
     /* 401202 */   // GIR_Coverage, 780,
     /* 401202 */   GIR_Done,
     /* 401203 */ // Label 8144: @401203
     /* 401203 */ GIM_Reject,
     /* 401204 */ // Label 8138: @401204
     /* 401204 */ GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(401234), // Rule ID 776 //
     /* 401209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401223 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 401223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 401228 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401232 */   GIR_RootConstrainSelectedInstOperands,
     /* 401233 */   // GIR_Coverage, 776,
     /* 401233 */   GIR_Done,
     /* 401234 */ // Label 8145: @401234
     /* 401234 */ GIM_Reject,
     /* 401235 */ // Label 8139: @401235
     /* 401235 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(401265), // Rule ID 779 //
     /* 401240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401254 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 401254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 401259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401263 */   GIR_RootConstrainSelectedInstOperands,
     /* 401264 */   // GIR_Coverage, 779,
     /* 401264 */   GIR_Done,
     /* 401265 */ // Label 8146: @401265
     /* 401265 */ GIM_Reject,
     /* 401266 */ // Label 8140: @401266
     /* 401266 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(401296), // Rule ID 777 //
     /* 401271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401285 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 401285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 401290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401294 */   GIR_RootConstrainSelectedInstOperands,
     /* 401295 */   // GIR_Coverage, 777,
     /* 401295 */   GIR_Done,
     /* 401296 */ // Label 8147: @401296
     /* 401296 */ GIM_Reject,
     /* 401297 */ // Label 8141: @401297
     /* 401297 */ GIM_Reject,
     /* 401298 */ // Label 132: @401298
     /* 401298 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8155*/ GIMT_Encode4(401961),
     /* 401309 */ /*GILLT_s32*//*Label 8148*/ GIMT_Encode4(401345),
     /* 401313 */ /*GILLT_s64*//*Label 8149*/ GIMT_Encode4(401383), GIMT_Encode4(0),
     /* 401321 */ /*GILLT_v2s32*//*Label 8150*/ GIMT_Encode4(401446),
     /* 401325 */ /*GILLT_v2s64*//*Label 8151*/ GIMT_Encode4(401549),
     /* 401329 */ /*GILLT_v4s16*//*Label 8152*/ GIMT_Encode4(401652),
     /* 401333 */ /*GILLT_v4s32*//*Label 8153*/ GIMT_Encode4(401755), GIMT_Encode4(0),
     /* 401341 */ /*GILLT_v8s16*//*Label 8154*/ GIMT_Encode4(401858),
     /* 401345 */ // Label 8148: @401345
     /* 401345 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(401382), // Rule ID 1626 //
     /* 401350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 401359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401371 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 401371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 401376 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401380 */   GIR_RootConstrainSelectedInstOperands,
     /* 401381 */   // GIR_Coverage, 1626,
     /* 401381 */   GIR_Done,
     /* 401382 */ // Label 8156: @401382
     /* 401382 */ GIM_Reject,
     /* 401383 */ // Label 8149: @401383
     /* 401383 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(401445),
     /* 401388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401406 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(401425), // Rule ID 1625 //
     /* 401411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401414 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 401414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 401419 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401423 */     GIR_RootConstrainSelectedInstOperands,
     /* 401424 */     // GIR_Coverage, 1625,
     /* 401424 */     GIR_Done,
     /* 401425 */   // Label 8158: @401425
     /* 401425 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(401444), // Rule ID 5199 //
     /* 401430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401433 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 401433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 401438 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401442 */     GIR_RootConstrainSelectedInstOperands,
     /* 401443 */     // GIR_Coverage, 5199,
     /* 401443 */     GIR_Done,
     /* 401444 */   // Label 8159: @401444
     /* 401444 */   GIM_Reject,
     /* 401445 */ // Label 8157: @401445
     /* 401445 */ GIM_Reject,
     /* 401446 */ // Label 8150: @401446
     /* 401446 */ GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(401548),
     /* 401451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401461 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(401520), // Rule ID 1182 //
     /* 401466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401505 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 401508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401518 */     GIR_RootConstrainSelectedInstOperands,
     /* 401519 */     // GIR_Coverage, 1182,
     /* 401519 */     GIR_EraseRootFromParent_Done,
     /* 401520 */   // Label 8161: @401520
     /* 401520 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(401547), // Rule ID 1220 //
     /* 401525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401536 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 401541 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401545 */     GIR_RootConstrainSelectedInstOperands,
     /* 401546 */     // GIR_Coverage, 1220,
     /* 401546 */     GIR_Done,
     /* 401547 */   // Label 8162: @401547
     /* 401547 */   GIM_Reject,
     /* 401548 */ // Label 8160: @401548
     /* 401548 */ GIM_Reject,
     /* 401549 */ // Label 8151: @401549
     /* 401549 */ GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(401651),
     /* 401554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401564 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(401623), // Rule ID 1186 //
     /* 401569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401608 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 401611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401621 */     GIR_RootConstrainSelectedInstOperands,
     /* 401622 */     // GIR_Coverage, 1186,
     /* 401622 */     GIR_EraseRootFromParent_Done,
     /* 401623 */   // Label 8164: @401623
     /* 401623 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(401650), // Rule ID 1222 //
     /* 401628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401639 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401639 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 401644 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401648 */     GIR_RootConstrainSelectedInstOperands,
     /* 401649 */     // GIR_Coverage, 1222,
     /* 401649 */     GIR_Done,
     /* 401650 */   // Label 8165: @401650
     /* 401650 */   GIM_Reject,
     /* 401651 */ // Label 8163: @401651
     /* 401651 */ GIM_Reject,
     /* 401652 */ // Label 8152: @401652
     /* 401652 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(401754),
     /* 401657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401667 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(401726), // Rule ID 1178 //
     /* 401672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401711 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 401714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401724 */     GIR_RootConstrainSelectedInstOperands,
     /* 401725 */     // GIR_Coverage, 1178,
     /* 401725 */     GIR_EraseRootFromParent_Done,
     /* 401726 */   // Label 8167: @401726
     /* 401726 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(401753), // Rule ID 1218 //
     /* 401731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401742 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 401747 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401751 */     GIR_RootConstrainSelectedInstOperands,
     /* 401752 */     // GIR_Coverage, 1218,
     /* 401752 */     GIR_Done,
     /* 401753 */   // Label 8168: @401753
     /* 401753 */   GIM_Reject,
     /* 401754 */ // Label 8166: @401754
     /* 401754 */ GIM_Reject,
     /* 401755 */ // Label 8153: @401755
     /* 401755 */ GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(401857),
     /* 401760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401770 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(401829), // Rule ID 1184 //
     /* 401775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401814 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 401817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401827 */     GIR_RootConstrainSelectedInstOperands,
     /* 401828 */     // GIR_Coverage, 1184,
     /* 401828 */     GIR_EraseRootFromParent_Done,
     /* 401829 */   // Label 8170: @401829
     /* 401829 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(401856), // Rule ID 1221 //
     /* 401834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401845 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 401850 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401854 */     GIR_RootConstrainSelectedInstOperands,
     /* 401855 */     // GIR_Coverage, 1221,
     /* 401855 */     GIR_Done,
     /* 401856 */   // Label 8171: @401856
     /* 401856 */   GIM_Reject,
     /* 401857 */ // Label 8169: @401857
     /* 401857 */ GIM_Reject,
     /* 401858 */ // Label 8154: @401858
     /* 401858 */ GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(401960),
     /* 401863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401873 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(401932), // Rule ID 1180 //
     /* 401878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401917 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 401920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401930 */     GIR_RootConstrainSelectedInstOperands,
     /* 401931 */     // GIR_Coverage, 1180,
     /* 401931 */     GIR_EraseRootFromParent_Done,
     /* 401932 */   // Label 8173: @401932
     /* 401932 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(401959), // Rule ID 1219 //
     /* 401937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401948 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 401953 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401957 */     GIR_RootConstrainSelectedInstOperands,
     /* 401958 */     // GIR_Coverage, 1219,
     /* 401958 */     GIR_Done,
     /* 401959 */   // Label 8174: @401959
     /* 401959 */   GIM_Reject,
     /* 401960 */ // Label 8172: @401960
     /* 401960 */ GIM_Reject,
     /* 401961 */ // Label 8155: @401961
     /* 401961 */ GIM_Reject,
     /* 401962 */ // Label 133: @401962
     /* 401962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8181*/ GIMT_Encode4(402191),
     /* 401973 */ /*GILLT_s64*//*Label 8175*/ GIMT_Encode4(402005), GIMT_Encode4(0),
     /* 401981 */ /*GILLT_v2s32*//*Label 8176*/ GIMT_Encode4(402036),
     /* 401985 */ /*GILLT_v2s64*//*Label 8177*/ GIMT_Encode4(402067),
     /* 401989 */ /*GILLT_v4s16*//*Label 8178*/ GIMT_Encode4(402098),
     /* 401993 */ /*GILLT_v4s32*//*Label 8179*/ GIMT_Encode4(402129), GIMT_Encode4(0),
     /* 402001 */ /*GILLT_v8s16*//*Label 8180*/ GIMT_Encode4(402160),
     /* 402005 */ // Label 8175: @402005
     /* 402005 */ GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(402035), // Rule ID 5230 //
     /* 402010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402024 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 402029 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402033 */   GIR_RootConstrainSelectedInstOperands,
     /* 402034 */   // GIR_Coverage, 5230,
     /* 402034 */   GIR_Done,
     /* 402035 */ // Label 8182: @402035
     /* 402035 */ GIM_Reject,
     /* 402036 */ // Label 8176: @402036
     /* 402036 */ GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(402066), // Rule ID 783 //
     /* 402041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402055 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 402060 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402064 */   GIR_RootConstrainSelectedInstOperands,
     /* 402065 */   // GIR_Coverage, 783,
     /* 402065 */   GIR_Done,
     /* 402066 */ // Label 8183: @402066
     /* 402066 */ GIM_Reject,
     /* 402067 */ // Label 8177: @402067
     /* 402067 */ GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(402097), // Rule ID 785 //
     /* 402072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402086 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 402091 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402095 */   GIR_RootConstrainSelectedInstOperands,
     /* 402096 */   // GIR_Coverage, 785,
     /* 402096 */   GIR_Done,
     /* 402097 */ // Label 8184: @402097
     /* 402097 */ GIM_Reject,
     /* 402098 */ // Label 8178: @402098
     /* 402098 */ GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(402128), // Rule ID 781 //
     /* 402103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402117 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 402122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402126 */   GIR_RootConstrainSelectedInstOperands,
     /* 402127 */   // GIR_Coverage, 781,
     /* 402127 */   GIR_Done,
     /* 402128 */ // Label 8185: @402128
     /* 402128 */ GIM_Reject,
     /* 402129 */ // Label 8179: @402129
     /* 402129 */ GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(402159), // Rule ID 784 //
     /* 402134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402148 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 402153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402157 */   GIR_RootConstrainSelectedInstOperands,
     /* 402158 */   // GIR_Coverage, 784,
     /* 402158 */   GIR_Done,
     /* 402159 */ // Label 8186: @402159
     /* 402159 */ GIM_Reject,
     /* 402160 */ // Label 8180: @402160
     /* 402160 */ GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(402190), // Rule ID 782 //
     /* 402165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402179 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 402184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402188 */   GIR_RootConstrainSelectedInstOperands,
     /* 402189 */   // GIR_Coverage, 782,
     /* 402189 */   GIR_Done,
     /* 402190 */ // Label 8187: @402190
     /* 402190 */ GIM_Reject,
     /* 402191 */ // Label 8181: @402191
     /* 402191 */ GIM_Reject,
     /* 402192 */ // Label 134: @402192
     /* 402192 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8194*/ GIMT_Encode4(402421),
     /* 402203 */ /*GILLT_s64*//*Label 8188*/ GIMT_Encode4(402235), GIMT_Encode4(0),
     /* 402211 */ /*GILLT_v2s32*//*Label 8189*/ GIMT_Encode4(402266),
     /* 402215 */ /*GILLT_v2s64*//*Label 8190*/ GIMT_Encode4(402297),
     /* 402219 */ /*GILLT_v4s16*//*Label 8191*/ GIMT_Encode4(402328),
     /* 402223 */ /*GILLT_v4s32*//*Label 8192*/ GIMT_Encode4(402359), GIMT_Encode4(0),
     /* 402231 */ /*GILLT_v8s16*//*Label 8193*/ GIMT_Encode4(402390),
     /* 402235 */ // Label 8188: @402235
     /* 402235 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(402265), // Rule ID 5231 //
     /* 402240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402254 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 402259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402263 */   GIR_RootConstrainSelectedInstOperands,
     /* 402264 */   // GIR_Coverage, 5231,
     /* 402264 */   GIR_Done,
     /* 402265 */ // Label 8195: @402265
     /* 402265 */ GIM_Reject,
     /* 402266 */ // Label 8189: @402266
     /* 402266 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(402296), // Rule ID 788 //
     /* 402271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402285 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 402290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402294 */   GIR_RootConstrainSelectedInstOperands,
     /* 402295 */   // GIR_Coverage, 788,
     /* 402295 */   GIR_Done,
     /* 402296 */ // Label 8196: @402296
     /* 402296 */ GIM_Reject,
     /* 402297 */ // Label 8190: @402297
     /* 402297 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(402327), // Rule ID 790 //
     /* 402302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402316 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 402321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402325 */   GIR_RootConstrainSelectedInstOperands,
     /* 402326 */   // GIR_Coverage, 790,
     /* 402326 */   GIR_Done,
     /* 402327 */ // Label 8197: @402327
     /* 402327 */ GIM_Reject,
     /* 402328 */ // Label 8191: @402328
     /* 402328 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(402358), // Rule ID 786 //
     /* 402333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402347 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 402352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402356 */   GIR_RootConstrainSelectedInstOperands,
     /* 402357 */   // GIR_Coverage, 786,
     /* 402357 */   GIR_Done,
     /* 402358 */ // Label 8198: @402358
     /* 402358 */ GIM_Reject,
     /* 402359 */ // Label 8192: @402359
     /* 402359 */ GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(402389), // Rule ID 789 //
     /* 402364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402378 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 402383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402387 */   GIR_RootConstrainSelectedInstOperands,
     /* 402388 */   // GIR_Coverage, 789,
     /* 402388 */   GIR_Done,
     /* 402389 */ // Label 8199: @402389
     /* 402389 */ GIM_Reject,
     /* 402390 */ // Label 8193: @402390
     /* 402390 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(402420), // Rule ID 787 //
     /* 402395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402409 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 402414 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402418 */   GIR_RootConstrainSelectedInstOperands,
     /* 402419 */   // GIR_Coverage, 787,
     /* 402419 */   GIR_Done,
     /* 402420 */ // Label 8200: @402420
     /* 402420 */ GIM_Reject,
     /* 402421 */ // Label 8194: @402421
     /* 402421 */ GIM_Reject,
     /* 402422 */ // Label 135: @402422
     /* 402422 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8207*/ GIMT_Encode4(402651),
     /* 402433 */ /*GILLT_s64*//*Label 8201*/ GIMT_Encode4(402465), GIMT_Encode4(0),
     /* 402441 */ /*GILLT_v2s32*//*Label 8202*/ GIMT_Encode4(402496),
     /* 402445 */ /*GILLT_v2s64*//*Label 8203*/ GIMT_Encode4(402527),
     /* 402449 */ /*GILLT_v4s16*//*Label 8204*/ GIMT_Encode4(402558),
     /* 402453 */ /*GILLT_v4s32*//*Label 8205*/ GIMT_Encode4(402589), GIMT_Encode4(0),
     /* 402461 */ /*GILLT_v8s16*//*Label 8206*/ GIMT_Encode4(402620),
     /* 402465 */ // Label 8201: @402465
     /* 402465 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(402495), // Rule ID 5232 //
     /* 402470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402484 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 402489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402493 */   GIR_RootConstrainSelectedInstOperands,
     /* 402494 */   // GIR_Coverage, 5232,
     /* 402494 */   GIR_Done,
     /* 402495 */ // Label 8208: @402495
     /* 402495 */ GIM_Reject,
     /* 402496 */ // Label 8202: @402496
     /* 402496 */ GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(402526), // Rule ID 793 //
     /* 402501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402515 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 402520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402524 */   GIR_RootConstrainSelectedInstOperands,
     /* 402525 */   // GIR_Coverage, 793,
     /* 402525 */   GIR_Done,
     /* 402526 */ // Label 8209: @402526
     /* 402526 */ GIM_Reject,
     /* 402527 */ // Label 8203: @402527
     /* 402527 */ GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(402557), // Rule ID 795 //
     /* 402532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402546 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 402551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402555 */   GIR_RootConstrainSelectedInstOperands,
     /* 402556 */   // GIR_Coverage, 795,
     /* 402556 */   GIR_Done,
     /* 402557 */ // Label 8210: @402557
     /* 402557 */ GIM_Reject,
     /* 402558 */ // Label 8204: @402558
     /* 402558 */ GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(402588), // Rule ID 791 //
     /* 402563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402577 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 402582 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402586 */   GIR_RootConstrainSelectedInstOperands,
     /* 402587 */   // GIR_Coverage, 791,
     /* 402587 */   GIR_Done,
     /* 402588 */ // Label 8211: @402588
     /* 402588 */ GIM_Reject,
     /* 402589 */ // Label 8205: @402589
     /* 402589 */ GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(402619), // Rule ID 794 //
     /* 402594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402608 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 402613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402617 */   GIR_RootConstrainSelectedInstOperands,
     /* 402618 */   // GIR_Coverage, 794,
     /* 402618 */   GIR_Done,
     /* 402619 */ // Label 8212: @402619
     /* 402619 */ GIM_Reject,
     /* 402620 */ // Label 8206: @402620
     /* 402620 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(402650), // Rule ID 792 //
     /* 402625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402639 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 402644 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402648 */   GIR_RootConstrainSelectedInstOperands,
     /* 402649 */   // GIR_Coverage, 792,
     /* 402649 */   GIR_Done,
     /* 402650 */ // Label 8213: @402650
     /* 402650 */ GIM_Reject,
     /* 402651 */ // Label 8207: @402651
     /* 402651 */ GIM_Reject,
     /* 402652 */ // Label 136: @402652
     /* 402652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8218*/ GIMT_Encode4(402805),
     /* 402663 */ /*GILLT_s32*//*Label 8214*/ GIMT_Encode4(402703),
     /* 402667 */ /*GILLT_s64*//*Label 8215*/ GIMT_Encode4(402727), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 402691 */ /*GILLT_v8s8*//*Label 8216*/ GIMT_Encode4(402751), GIMT_Encode4(0),
     /* 402699 */ /*GILLT_v16s8*//*Label 8217*/ GIMT_Encode4(402778),
     /* 402703 */ // Label 8214: @402703
     /* 402703 */ GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(402726), // Rule ID 4005 //
     /* 402708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 402711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 402715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 402719 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 402719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 402724 */   GIR_RootConstrainSelectedInstOperands,
     /* 402725 */   // GIR_Coverage, 4005,
     /* 402725 */   GIR_Done,
     /* 402726 */ // Label 8219: @402726
     /* 402726 */ GIM_Reject,
     /* 402727 */ // Label 8215: @402727
     /* 402727 */ GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(402750), // Rule ID 4006 //
     /* 402732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 402739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 402743 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 402743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 402748 */   GIR_RootConstrainSelectedInstOperands,
     /* 402749 */   // GIR_Coverage, 4006,
     /* 402749 */   GIR_Done,
     /* 402750 */ // Label 8220: @402750
     /* 402750 */ GIM_Reject,
     /* 402751 */ // Label 8216: @402751
     /* 402751 */ GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(402777), // Rule ID 976 //
     /* 402756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402770 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 402770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 402775 */   GIR_RootConstrainSelectedInstOperands,
     /* 402776 */   // GIR_Coverage, 976,
     /* 402776 */   GIR_Done,
     /* 402777 */ // Label 8221: @402777
     /* 402777 */ GIM_Reject,
     /* 402778 */ // Label 8217: @402778
     /* 402778 */ GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(402804), // Rule ID 977 //
     /* 402783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402797 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 402797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 402802 */   GIR_RootConstrainSelectedInstOperands,
     /* 402803 */   // GIR_Coverage, 977,
     /* 402803 */   GIR_Done,
     /* 402804 */ // Label 8222: @402804
     /* 402804 */ GIM_Reject,
     /* 402805 */ // Label 8218: @402805
     /* 402805 */ GIM_Reject,
     /* 402806 */ // Label 137: @402806
     /* 402806 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8227*/ GIMT_Encode4(402981),
     /* 402817 */ /*GILLT_v4s16*//*Label 8223*/ GIMT_Encode4(402837), GIMT_Encode4(0),
     /* 402825 */ /*GILLT_v8s8*//*Label 8224*/ GIMT_Encode4(402882),
     /* 402829 */ /*GILLT_v8s16*//*Label 8225*/ GIMT_Encode4(402909),
     /* 402833 */ /*GILLT_v16s8*//*Label 8226*/ GIMT_Encode4(402954),
     /* 402837 */ // Label 8223: @402837
     /* 402837 */ GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(402881),
     /* 402842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402853 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(402868), // Rule ID 980 //
     /* 402858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402861 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 402861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 402866 */     GIR_RootConstrainSelectedInstOperands,
     /* 402867 */     // GIR_Coverage, 980,
     /* 402867 */     GIR_Done,
     /* 402868 */   // Label 8229: @402868
     /* 402868 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(402880), // Rule ID 4950 //
     /* 402873 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 402873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 402878 */     GIR_RootConstrainSelectedInstOperands,
     /* 402879 */     // GIR_Coverage, 4950,
     /* 402879 */     GIR_Done,
     /* 402880 */   // Label 8230: @402880
     /* 402880 */   GIM_Reject,
     /* 402881 */ // Label 8228: @402881
     /* 402881 */ GIM_Reject,
     /* 402882 */ // Label 8224: @402882
     /* 402882 */ GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(402908), // Rule ID 978 //
     /* 402887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 402893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402901 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 402901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 402906 */   GIR_RootConstrainSelectedInstOperands,
     /* 402907 */   // GIR_Coverage, 978,
     /* 402907 */   GIR_Done,
     /* 402908 */ // Label 8231: @402908
     /* 402908 */ GIM_Reject,
     /* 402909 */ // Label 8225: @402909
     /* 402909 */ GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(402953),
     /* 402914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402925 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(402940), // Rule ID 981 //
     /* 402930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402933 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 402933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 402938 */     GIR_RootConstrainSelectedInstOperands,
     /* 402939 */     // GIR_Coverage, 981,
     /* 402939 */     GIR_Done,
     /* 402940 */   // Label 8233: @402940
     /* 402940 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(402952), // Rule ID 4952 //
     /* 402945 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 402945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 402950 */     GIR_RootConstrainSelectedInstOperands,
     /* 402951 */     // GIR_Coverage, 4952,
     /* 402951 */     GIR_Done,
     /* 402952 */   // Label 8234: @402952
     /* 402952 */   GIM_Reject,
     /* 402953 */ // Label 8232: @402953
     /* 402953 */ GIM_Reject,
     /* 402954 */ // Label 8226: @402954
     /* 402954 */ GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(402980), // Rule ID 979 //
     /* 402959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 402965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402973 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 402973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 402978 */   GIR_RootConstrainSelectedInstOperands,
     /* 402979 */   // GIR_Coverage, 979,
     /* 402979 */   GIR_Done,
     /* 402980 */ // Label 8235: @402980
     /* 402980 */ GIM_Reject,
     /* 402981 */ // Label 8227: @402981
     /* 402981 */ GIM_Reject,
     /* 402982 */ // Label 138: @402982
     /* 402982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8242*/ GIMT_Encode4(403255),
     /* 402993 */ /*GILLT_v2s32*//*Label 8236*/ GIMT_Encode4(403021), GIMT_Encode4(0),
     /* 403001 */ /*GILLT_v4s16*//*Label 8237*/ GIMT_Encode4(403066),
     /* 403005 */ /*GILLT_v4s32*//*Label 8238*/ GIMT_Encode4(403111),
     /* 403009 */ /*GILLT_v8s8*//*Label 8239*/ GIMT_Encode4(403156),
     /* 403013 */ /*GILLT_v8s16*//*Label 8240*/ GIMT_Encode4(403183),
     /* 403017 */ /*GILLT_v16s8*//*Label 8241*/ GIMT_Encode4(403228),
     /* 403021 */ // Label 8236: @403021
     /* 403021 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(403065),
     /* 403026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403037 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(403052), // Rule ID 986 //
     /* 403042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403045 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 403045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 403050 */     GIR_RootConstrainSelectedInstOperands,
     /* 403051 */     // GIR_Coverage, 986,
     /* 403051 */     GIR_Done,
     /* 403052 */   // Label 8244: @403052
     /* 403052 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(403064), // Rule ID 4954 //
     /* 403057 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 403057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 403062 */     GIR_RootConstrainSelectedInstOperands,
     /* 403063 */     // GIR_Coverage, 4954,
     /* 403063 */     GIR_Done,
     /* 403064 */   // Label 8245: @403064
     /* 403064 */   GIM_Reject,
     /* 403065 */ // Label 8243: @403065
     /* 403065 */ GIM_Reject,
     /* 403066 */ // Label 8237: @403066
     /* 403066 */ GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(403110),
     /* 403071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403082 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(403097), // Rule ID 984 //
     /* 403087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403090 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 403090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 403095 */     GIR_RootConstrainSelectedInstOperands,
     /* 403096 */     // GIR_Coverage, 984,
     /* 403096 */     GIR_Done,
     /* 403097 */   // Label 8247: @403097
     /* 403097 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(403109), // Rule ID 4951 //
     /* 403102 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 403102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 403107 */     GIR_RootConstrainSelectedInstOperands,
     /* 403108 */     // GIR_Coverage, 4951,
     /* 403108 */     GIR_Done,
     /* 403109 */   // Label 8248: @403109
     /* 403109 */   GIM_Reject,
     /* 403110 */ // Label 8246: @403110
     /* 403110 */ GIM_Reject,
     /* 403111 */ // Label 8238: @403111
     /* 403111 */ GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(403155),
     /* 403116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403127 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(403142), // Rule ID 987 //
     /* 403132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403135 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 403135 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 403140 */     GIR_RootConstrainSelectedInstOperands,
     /* 403141 */     // GIR_Coverage, 987,
     /* 403141 */     GIR_Done,
     /* 403142 */   // Label 8250: @403142
     /* 403142 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(403154), // Rule ID 4955 //
     /* 403147 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 403147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 403152 */     GIR_RootConstrainSelectedInstOperands,
     /* 403153 */     // GIR_Coverage, 4955,
     /* 403153 */     GIR_Done,
     /* 403154 */   // Label 8251: @403154
     /* 403154 */   GIM_Reject,
     /* 403155 */ // Label 8249: @403155
     /* 403155 */ GIM_Reject,
     /* 403156 */ // Label 8239: @403156
     /* 403156 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(403182), // Rule ID 982 //
     /* 403161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403175 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 403175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 403180 */   GIR_RootConstrainSelectedInstOperands,
     /* 403181 */   // GIR_Coverage, 982,
     /* 403181 */   GIR_Done,
     /* 403182 */ // Label 8252: @403182
     /* 403182 */ GIM_Reject,
     /* 403183 */ // Label 8240: @403183
     /* 403183 */ GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(403227),
     /* 403188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403199 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(403214), // Rule ID 985 //
     /* 403204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403207 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 403207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 403212 */     GIR_RootConstrainSelectedInstOperands,
     /* 403213 */     // GIR_Coverage, 985,
     /* 403213 */     GIR_Done,
     /* 403214 */   // Label 8254: @403214
     /* 403214 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(403226), // Rule ID 4953 //
     /* 403219 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 403219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 403224 */     GIR_RootConstrainSelectedInstOperands,
     /* 403225 */     // GIR_Coverage, 4953,
     /* 403225 */     GIR_Done,
     /* 403226 */   // Label 8255: @403226
     /* 403226 */   GIM_Reject,
     /* 403227 */ // Label 8253: @403227
     /* 403227 */ GIM_Reject,
     /* 403228 */ // Label 8241: @403228
     /* 403228 */ GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(403254), // Rule ID 983 //
     /* 403233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403247 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 403247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 403252 */   GIR_RootConstrainSelectedInstOperands,
     /* 403253 */   // GIR_Coverage, 983,
     /* 403253 */   GIR_Done,
     /* 403254 */ // Label 8256: @403254
     /* 403254 */ GIM_Reject,
     /* 403255 */ // Label 8242: @403255
     /* 403255 */ GIM_Reject,
     /* 403256 */ // Label 139: @403256
     /* 403256 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8263*/ GIMT_Encode4(403461),
     /* 403267 */ /*GILLT_s64*//*Label 8257*/ GIMT_Encode4(403299), GIMT_Encode4(0),
     /* 403275 */ /*GILLT_v2s32*//*Label 8258*/ GIMT_Encode4(403326),
     /* 403279 */ /*GILLT_v2s64*//*Label 8259*/ GIMT_Encode4(403353),
     /* 403283 */ /*GILLT_v4s16*//*Label 8260*/ GIMT_Encode4(403380),
     /* 403287 */ /*GILLT_v4s32*//*Label 8261*/ GIMT_Encode4(403407), GIMT_Encode4(0),
     /* 403295 */ /*GILLT_v8s16*//*Label 8262*/ GIMT_Encode4(403434),
     /* 403299 */ // Label 8257: @403299
     /* 403299 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(403325), // Rule ID 1008 //
     /* 403304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403318 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 403318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 403323 */   GIR_RootConstrainSelectedInstOperands,
     /* 403324 */   // GIR_Coverage, 1008,
     /* 403324 */   GIR_Done,
     /* 403325 */ // Label 8264: @403325
     /* 403325 */ GIM_Reject,
     /* 403326 */ // Label 8258: @403326
     /* 403326 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(403352), // Rule ID 1004 //
     /* 403331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403345 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 403345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 403350 */   GIR_RootConstrainSelectedInstOperands,
     /* 403351 */   // GIR_Coverage, 1004,
     /* 403351 */   GIR_Done,
     /* 403352 */ // Label 8265: @403352
     /* 403352 */ GIM_Reject,
     /* 403353 */ // Label 8259: @403353
     /* 403353 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(403379), // Rule ID 1010 //
     /* 403358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403372 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 403372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 403377 */   GIR_RootConstrainSelectedInstOperands,
     /* 403378 */   // GIR_Coverage, 1010,
     /* 403378 */   GIR_Done,
     /* 403379 */ // Label 8266: @403379
     /* 403379 */ GIM_Reject,
     /* 403380 */ // Label 8260: @403380
     /* 403380 */ GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(403406), // Rule ID 1000 //
     /* 403385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403399 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 403399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 403404 */   GIR_RootConstrainSelectedInstOperands,
     /* 403405 */   // GIR_Coverage, 1000,
     /* 403405 */   GIR_Done,
     /* 403406 */ // Label 8267: @403406
     /* 403406 */ GIM_Reject,
     /* 403407 */ // Label 8261: @403407
     /* 403407 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(403433), // Rule ID 1006 //
     /* 403412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403426 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 403426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 403431 */   GIR_RootConstrainSelectedInstOperands,
     /* 403432 */   // GIR_Coverage, 1006,
     /* 403432 */   GIR_Done,
     /* 403433 */ // Label 8268: @403433
     /* 403433 */ GIM_Reject,
     /* 403434 */ // Label 8262: @403434
     /* 403434 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(403460), // Rule ID 1002 //
     /* 403439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403453 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 403453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 403458 */   GIR_RootConstrainSelectedInstOperands,
     /* 403459 */   // GIR_Coverage, 1002,
     /* 403459 */   GIR_Done,
     /* 403460 */ // Label 8269: @403460
     /* 403460 */ GIM_Reject,
     /* 403461 */ // Label 8263: @403461
     /* 403461 */ GIM_Reject,
     /* 403462 */ // Label 140: @403462
     /* 403462 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8272*/ GIMT_Encode4(403860),
     /* 403473 */ /*GILLT_v2s64*//*Label 8270*/ GIMT_Encode4(403485), GIMT_Encode4(0),
     /* 403481 */ /*GILLT_v4s32*//*Label 8271*/ GIMT_Encode4(403623),
     /* 403485 */ // Label 8270: @403485
     /* 403485 */ GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(403544), // Rule ID 5841 //
     /* 403490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403501 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 403501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 403504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 403508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 403533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403538 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403543 */   // GIR_Coverage, 5841,
     /* 403543 */   GIR_EraseRootFromParent_Done,
     /* 403544 */ // Label 8273: @403544
     /* 403544 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(403622), // Rule ID 5963 //
     /* 403549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403560 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 403560 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 403563 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 403567 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403572 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 403578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 403581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 403585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 403595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403600 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 403606 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403621 */   // GIR_Coverage, 5963,
     /* 403621 */   GIR_EraseRootFromParent_Done,
     /* 403622 */ // Label 8274: @403622
     /* 403622 */ GIM_Reject,
     /* 403623 */ // Label 8271: @403623
     /* 403623 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(403682), // Rule ID 5837 //
     /* 403628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403639 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 403639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 403646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403651 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403681 */   // GIR_Coverage, 5837,
     /* 403681 */   GIR_EraseRootFromParent_Done,
     /* 403682 */ // Label 8275: @403682
     /* 403682 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(403741), // Rule ID 5838 //
     /* 403687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403698 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 403698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 403705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403710 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 403730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403740 */   // GIR_Coverage, 5838,
     /* 403740 */   GIR_EraseRootFromParent_Done,
     /* 403741 */ // Label 8276: @403741
     /* 403741 */ GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(403800), // Rule ID 5839 //
     /* 403746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403757 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 403757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 403764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403769 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 403789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403799 */   // GIR_Coverage, 5839,
     /* 403799 */   GIR_EraseRootFromParent_Done,
     /* 403800 */ // Label 8277: @403800
     /* 403800 */ GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(403859), // Rule ID 5840 //
     /* 403805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403816 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 403816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 403823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403828 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 403832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 403834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 403837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 403842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 403848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403858 */   // GIR_Coverage, 5840,
     /* 403858 */   GIR_EraseRootFromParent_Done,
     /* 403859 */ // Label 8278: @403859
     /* 403859 */ GIM_Reject,
     /* 403860 */ // Label 8272: @403860
     /* 403860 */ GIM_Reject,
     /* 403861 */ // Label 141: @403861
     /* 403861 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8283*/ GIMT_Encode4(404230),
     /* 403872 */ /*GILLT_v2s32*//*Label 8279*/ GIMT_Encode4(403932), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403884 */ /*GILLT_v4s32*//*Label 8280*/ GIMT_Encode4(404052), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403916 */ /*GILLT_nxv2s64*//*Label 8281*/ GIMT_Encode4(404172), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403928 */ /*GILLT_nxv4s32*//*Label 8282*/ GIMT_Encode4(404201),
     /* 403932 */ // Label 8279: @403932
     /* 403932 */ GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(404051),
     /* 403937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 403943 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 403946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403958 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(404031), // Rule ID 26 //
     /* 403963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 403966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 403974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 403986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404007 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404011 */     // MIs[3] Operand 1
     /* 404011 */     // No operand predicates
     /* 404011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404013 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 404016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 404020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404029 */     GIR_RootConstrainSelectedInstOperands,
     /* 404030 */     // GIR_Coverage, 26,
     /* 404030 */     GIR_EraseRootFromParent_Done,
     /* 404031 */   // Label 8285: @404031
     /* 404031 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(404050), // Rule ID 22 //
     /* 404036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404043 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 404043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 404048 */     GIR_RootConstrainSelectedInstOperands,
     /* 404049 */     // GIR_Coverage, 22,
     /* 404049 */     GIR_Done,
     /* 404050 */   // Label 8286: @404050
     /* 404050 */   GIM_Reject,
     /* 404051 */ // Label 8284: @404051
     /* 404051 */ GIM_Reject,
     /* 404052 */ // Label 8280: @404052
     /* 404052 */ GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(404171),
     /* 404057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 404063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 404066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404078 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(404151), // Rule ID 27 //
     /* 404083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 404094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404127 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404131 */     // MIs[3] Operand 1
     /* 404131 */     // No operand predicates
     /* 404131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404133 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 404136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 404140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404149 */     GIR_RootConstrainSelectedInstOperands,
     /* 404150 */     // GIR_Coverage, 27,
     /* 404150 */     GIR_EraseRootFromParent_Done,
     /* 404151 */   // Label 8288: @404151
     /* 404151 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(404170), // Rule ID 23 //
     /* 404156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404163 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 404163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 404168 */     GIR_RootConstrainSelectedInstOperands,
     /* 404169 */     // GIR_Coverage, 23,
     /* 404169 */     GIR_Done,
     /* 404170 */   // Label 8289: @404170
     /* 404170 */   GIM_Reject,
     /* 404171 */ // Label 8287: @404171
     /* 404171 */ GIM_Reject,
     /* 404172 */ // Label 8281: @404172
     /* 404172 */ GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(404200), // Rule ID 2986 //
     /* 404177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 404183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 404186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 404189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404193 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 404193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 404198 */   GIR_RootConstrainSelectedInstOperands,
     /* 404199 */   // GIR_Coverage, 2986,
     /* 404199 */   GIR_Done,
     /* 404200 */ // Label 8290: @404200
     /* 404200 */ GIM_Reject,
     /* 404201 */ // Label 8282: @404201
     /* 404201 */ GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(404229), // Rule ID 2985 //
     /* 404206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 404212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 404215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 404218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404222 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 404222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 404227 */   GIR_RootConstrainSelectedInstOperands,
     /* 404228 */   // GIR_Coverage, 2985,
     /* 404228 */   GIR_Done,
     /* 404229 */ // Label 8291: @404229
     /* 404229 */ GIM_Reject,
     /* 404230 */ // Label 8283: @404230
     /* 404230 */ GIM_Reject,
     /* 404231 */ // Label 142: @404231
     /* 404231 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8295*/ GIMT_Encode4(404347),
     /* 404242 */ /*GILLT_s16*//*Label 8292*/ GIMT_Encode4(404254),
     /* 404246 */ /*GILLT_s32*//*Label 8293*/ GIMT_Encode4(404285),
     /* 404250 */ /*GILLT_s64*//*Label 8294*/ GIMT_Encode4(404316),
     /* 404254 */ // Label 8292: @404254
     /* 404254 */ GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(404284), // Rule ID 1658 //
     /* 404259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 404262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 404265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404273 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 404273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 404278 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404282 */   GIR_RootConstrainSelectedInstOperands,
     /* 404283 */   // GIR_Coverage, 1658,
     /* 404283 */   GIR_Done,
     /* 404284 */ // Label 8296: @404284
     /* 404284 */ GIM_Reject,
     /* 404285 */ // Label 8293: @404285
     /* 404285 */ GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(404315), // Rule ID 1657 //
     /* 404290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 404293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404304 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 404304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 404309 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404313 */   GIR_RootConstrainSelectedInstOperands,
     /* 404314 */   // GIR_Coverage, 1657,
     /* 404314 */   GIR_Done,
     /* 404315 */ // Label 8297: @404315
     /* 404315 */ GIM_Reject,
     /* 404316 */ // Label 8294: @404316
     /* 404316 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(404346), // Rule ID 1656 //
     /* 404321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 404324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 404327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404335 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 404335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 404340 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404344 */   GIR_RootConstrainSelectedInstOperands,
     /* 404345 */   // GIR_Coverage, 1656,
     /* 404345 */   GIR_Done,
     /* 404346 */ // Label 8298: @404346
     /* 404346 */ GIM_Reject,
     /* 404347 */ // Label 8295: @404347
     /* 404347 */ GIM_Reject,
     /* 404348 */ // Label 143: @404348
     /* 404348 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8302*/ GIMT_Encode4(405580),
     /* 404359 */ /*GILLT_v2s64*//*Label 8299*/ GIMT_Encode4(404379), GIMT_Encode4(0),
     /* 404367 */ /*GILLT_v4s32*//*Label 8300*/ GIMT_Encode4(404940), GIMT_Encode4(0),
     /* 404375 */ /*GILLT_v8s16*//*Label 8301*/ GIMT_Encode4(405501),
     /* 404379 */ // Label 8299: @404379
     /* 404379 */ GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(404939),
     /* 404384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 404390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404394 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(404486), // Rule ID 2054 //
     /* 404399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404435 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404439 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404443 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404447 */     // MIs[3] Operand 1
     /* 404447 */     // No operand predicates
     /* 404447 */     // MIs[1] Operand 2
     /* 404447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 404458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404467 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 404470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404484 */     GIR_RootConstrainSelectedInstOperands,
     /* 404485 */     // GIR_Coverage, 2054,
     /* 404485 */     GIR_EraseRootFromParent_Done,
     /* 404486 */   // Label 8304: @404486
     /* 404486 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(404578), // Rule ID 13426 //
     /* 404491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404535 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404539 */     // MIs[3] Operand 1
     /* 404539 */     // No operand predicates
     /* 404539 */     // MIs[1] Operand 2
     /* 404539 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 404550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404559 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 404562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404576 */     GIR_RootConstrainSelectedInstOperands,
     /* 404577 */     // GIR_Coverage, 13426,
     /* 404577 */     GIR_EraseRootFromParent_Done,
     /* 404578 */   // Label 8305: @404578
     /* 404578 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(404664), // Rule ID 13424 //
     /* 404583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404627 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404631 */     // MIs[3] Operand 1
     /* 404631 */     // No operand predicates
     /* 404631 */     // MIs[1] Operand 2
     /* 404631 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404648 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404662 */     GIR_RootConstrainSelectedInstOperands,
     /* 404663 */     // GIR_Coverage, 13424,
     /* 404663 */     GIR_EraseRootFromParent_Done,
     /* 404664 */   // Label 8306: @404664
     /* 404664 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(404750), // Rule ID 2052 //
     /* 404669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404717 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404721 */     // MIs[3] Operand 1
     /* 404721 */     // No operand predicates
     /* 404721 */     // MIs[1] Operand 2
     /* 404721 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 404732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404734 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404748 */     GIR_RootConstrainSelectedInstOperands,
     /* 404749 */     // GIR_Coverage, 2052,
     /* 404749 */     GIR_EraseRootFromParent_Done,
     /* 404750 */   // Label 8307: @404750
     /* 404750 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(404789), // Rule ID 1741 //
     /* 404755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 404772 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 404772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 404775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 404782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 404787 */     GIR_RootConstrainSelectedInstOperands,
     /* 404788 */     // GIR_Coverage, 1741,
     /* 404788 */     GIR_EraseRootFromParent_Done,
     /* 404789 */   // Label 8308: @404789
     /* 404789 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(404852), // Rule ID 13425 //
     /* 404794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404830 */     // MIs[2] Operand 1
     /* 404830 */     // No operand predicates
     /* 404830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404836 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404850 */     GIR_RootConstrainSelectedInstOperands,
     /* 404851 */     // GIR_Coverage, 13425,
     /* 404851 */     GIR_EraseRootFromParent_Done,
     /* 404852 */   // Label 8309: @404852
     /* 404852 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(404915), // Rule ID 2053 //
     /* 404857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404893 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404897 */     // MIs[2] Operand 1
     /* 404897 */     // No operand predicates
     /* 404897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404899 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 404902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404913 */     GIR_RootConstrainSelectedInstOperands,
     /* 404914 */     // GIR_Coverage, 2053,
     /* 404914 */     GIR_EraseRootFromParent_Done,
     /* 404915 */   // Label 8310: @404915
     /* 404915 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(404938), // Rule ID 1740 //
     /* 404920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404931 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 404931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 404936 */     GIR_RootConstrainSelectedInstOperands,
     /* 404937 */     // GIR_Coverage, 1740,
     /* 404937 */     GIR_Done,
     /* 404938 */   // Label 8311: @404938
     /* 404938 */   GIM_Reject,
     /* 404939 */ // Label 8303: @404939
     /* 404939 */ GIM_Reject,
     /* 404940 */ // Label 8300: @404940
     /* 404940 */ GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(405500),
     /* 404945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 404951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404955 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(405047), // Rule ID 2051 //
     /* 404960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 404983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405004 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405008 */     // MIs[3] Operand 1
     /* 405008 */     // No operand predicates
     /* 405008 */     // MIs[1] Operand 2
     /* 405008 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 405019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405028 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 405031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405045 */     GIR_RootConstrainSelectedInstOperands,
     /* 405046 */     // GIR_Coverage, 2051,
     /* 405046 */     GIR_EraseRootFromParent_Done,
     /* 405047 */   // Label 8313: @405047
     /* 405047 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(405139), // Rule ID 13423 //
     /* 405052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405096 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405100 */     // MIs[3] Operand 1
     /* 405100 */     // No operand predicates
     /* 405100 */     // MIs[1] Operand 2
     /* 405100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 405111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405120 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 405123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405137 */     GIR_RootConstrainSelectedInstOperands,
     /* 405138 */     // GIR_Coverage, 13423,
     /* 405138 */     GIR_EraseRootFromParent_Done,
     /* 405139 */   // Label 8314: @405139
     /* 405139 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(405225), // Rule ID 13421 //
     /* 405144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405188 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405192 */     // MIs[3] Operand 1
     /* 405192 */     // No operand predicates
     /* 405192 */     // MIs[1] Operand 2
     /* 405192 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405209 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405223 */     GIR_RootConstrainSelectedInstOperands,
     /* 405224 */     // GIR_Coverage, 13421,
     /* 405224 */     GIR_EraseRootFromParent_Done,
     /* 405225 */   // Label 8315: @405225
     /* 405225 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(405311), // Rule ID 2049 //
     /* 405230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405278 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405282 */     // MIs[3] Operand 1
     /* 405282 */     // No operand predicates
     /* 405282 */     // MIs[1] Operand 2
     /* 405282 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405295 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405309 */     GIR_RootConstrainSelectedInstOperands,
     /* 405310 */     // GIR_Coverage, 2049,
     /* 405310 */     GIR_EraseRootFromParent_Done,
     /* 405311 */   // Label 8316: @405311
     /* 405311 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(405350), // Rule ID 1739 //
     /* 405316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405333 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 405336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405348 */     GIR_RootConstrainSelectedInstOperands,
     /* 405349 */     // GIR_Coverage, 1739,
     /* 405349 */     GIR_EraseRootFromParent_Done,
     /* 405350 */   // Label 8317: @405350
     /* 405350 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(405413), // Rule ID 13422 //
     /* 405355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405391 */     // MIs[2] Operand 1
     /* 405391 */     // No operand predicates
     /* 405391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405397 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405411 */     GIR_RootConstrainSelectedInstOperands,
     /* 405412 */     // GIR_Coverage, 13422,
     /* 405412 */     GIR_EraseRootFromParent_Done,
     /* 405413 */   // Label 8318: @405413
     /* 405413 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(405476), // Rule ID 2050 //
     /* 405418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405458 */     // MIs[2] Operand 1
     /* 405458 */     // No operand predicates
     /* 405458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405460 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405474 */     GIR_RootConstrainSelectedInstOperands,
     /* 405475 */     // GIR_Coverage, 2050,
     /* 405475 */     GIR_EraseRootFromParent_Done,
     /* 405476 */   // Label 8319: @405476
     /* 405476 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(405499), // Rule ID 1738 //
     /* 405481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405492 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 405492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 405497 */     GIR_RootConstrainSelectedInstOperands,
     /* 405498 */     // GIR_Coverage, 1738,
     /* 405498 */     GIR_Done,
     /* 405499 */   // Label 8320: @405499
     /* 405499 */   GIM_Reject,
     /* 405500 */ // Label 8312: @405500
     /* 405500 */ GIM_Reject,
     /* 405501 */ // Label 8301: @405501
     /* 405501 */ GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(405579),
     /* 405506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 405509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 405512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405516 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(405555), // Rule ID 1737 //
     /* 405521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 405531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 405538 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 405538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 405541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405553 */     GIR_RootConstrainSelectedInstOperands,
     /* 405554 */     // GIR_Coverage, 1737,
     /* 405554 */     GIR_EraseRootFromParent_Done,
     /* 405555 */   // Label 8322: @405555
     /* 405555 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(405578), // Rule ID 1736 //
     /* 405560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405571 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 405571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 405576 */     GIR_RootConstrainSelectedInstOperands,
     /* 405577 */     // GIR_Coverage, 1736,
     /* 405577 */     GIR_Done,
     /* 405578 */   // Label 8323: @405578
     /* 405578 */   GIM_Reject,
     /* 405579 */ // Label 8321: @405579
     /* 405579 */ GIM_Reject,
     /* 405580 */ // Label 8302: @405580
     /* 405580 */ GIM_Reject,
     /* 405581 */ // Label 144: @405581
     /* 405581 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8342*/ GIMT_Encode4(406360),
     /* 405592 */ /*GILLT_v2s32*//*Label 8324*/ GIMT_Encode4(405668),
     /* 405596 */ /*GILLT_v2s64*//*Label 8325*/ GIMT_Encode4(405723),
     /* 405600 */ /*GILLT_v4s16*//*Label 8326*/ GIMT_Encode4(405778),
     /* 405604 */ /*GILLT_v4s32*//*Label 8327*/ GIMT_Encode4(405833),
     /* 405608 */ /*GILLT_v8s8*//*Label 8328*/ GIMT_Encode4(405888),
     /* 405612 */ /*GILLT_v8s16*//*Label 8329*/ GIMT_Encode4(405922),
     /* 405616 */ /*GILLT_v16s8*//*Label 8330*/ GIMT_Encode4(405977), GIMT_Encode4(0),
     /* 405624 */ /*GILLT_nxv2s1*//*Label 8331*/ GIMT_Encode4(406011),
     /* 405628 */ /*GILLT_nxv2s16*//*Label 8332*/ GIMT_Encode4(406037),
     /* 405632 */ /*GILLT_nxv2s32*//*Label 8333*/ GIMT_Encode4(406063),
     /* 405636 */ /*GILLT_nxv2s64*//*Label 8334*/ GIMT_Encode4(406089),
     /* 405640 */ /*GILLT_nxv4s1*//*Label 8335*/ GIMT_Encode4(406136),
     /* 405644 */ /*GILLT_nxv4s16*//*Label 8336*/ GIMT_Encode4(406162),
     /* 405648 */ /*GILLT_nxv4s32*//*Label 8337*/ GIMT_Encode4(406188),
     /* 405652 */ /*GILLT_nxv8s1*//*Label 8338*/ GIMT_Encode4(406235),
     /* 405656 */ /*GILLT_nxv8s16*//*Label 8339*/ GIMT_Encode4(406261),
     /* 405660 */ /*GILLT_nxv16s1*//*Label 8340*/ GIMT_Encode4(406308),
     /* 405664 */ /*GILLT_nxv16s8*//*Label 8341*/ GIMT_Encode4(406334),
     /* 405668 */ // Label 8324: @405668
     /* 405668 */ GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(405722),
     /* 405673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 405676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 405679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405691 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(405706), // Rule ID 1874 //
     /* 405696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405699 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 405699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 405704 */     GIR_RootConstrainSelectedInstOperands,
     /* 405705 */     // GIR_Coverage, 1874,
     /* 405705 */     GIR_Done,
     /* 405706 */   // Label 8344: @405706
     /* 405706 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(405721), // Rule ID 2505 //
     /* 405711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405714 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 405714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 405719 */     GIR_RootConstrainSelectedInstOperands,
     /* 405720 */     // GIR_Coverage, 2505,
     /* 405720 */     GIR_Done,
     /* 405721 */   // Label 8345: @405721
     /* 405721 */   GIM_Reject,
     /* 405722 */ // Label 8343: @405722
     /* 405722 */ GIM_Reject,
     /* 405723 */ // Label 8325: @405723
     /* 405723 */ GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(405777),
     /* 405728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 405731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 405734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405746 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(405761), // Rule ID 1876 //
     /* 405751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405754 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 405754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 405759 */     GIR_RootConstrainSelectedInstOperands,
     /* 405760 */     // GIR_Coverage, 1876,
     /* 405760 */     GIR_Done,
     /* 405761 */   // Label 8347: @405761
     /* 405761 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(405776), // Rule ID 2507 //
     /* 405766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405769 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 405769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 405774 */     GIR_RootConstrainSelectedInstOperands,
     /* 405775 */     // GIR_Coverage, 2507,
     /* 405775 */     GIR_Done,
     /* 405776 */   // Label 8348: @405776
     /* 405776 */   GIM_Reject,
     /* 405777 */ // Label 8346: @405777
     /* 405777 */ GIM_Reject,
     /* 405778 */ // Label 8326: @405778
     /* 405778 */ GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(405832),
     /* 405783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405801 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(405816), // Rule ID 1872 //
     /* 405806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405809 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 405809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 405814 */     GIR_RootConstrainSelectedInstOperands,
     /* 405815 */     // GIR_Coverage, 1872,
     /* 405815 */     GIR_Done,
     /* 405816 */   // Label 8350: @405816
     /* 405816 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(405831), // Rule ID 2503 //
     /* 405821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405824 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 405824 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 405829 */     GIR_RootConstrainSelectedInstOperands,
     /* 405830 */     // GIR_Coverage, 2503,
     /* 405830 */     GIR_Done,
     /* 405831 */   // Label 8351: @405831
     /* 405831 */   GIM_Reject,
     /* 405832 */ // Label 8349: @405832
     /* 405832 */ GIM_Reject,
     /* 405833 */ // Label 8327: @405833
     /* 405833 */ GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(405887),
     /* 405838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 405844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405856 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(405871), // Rule ID 1875 //
     /* 405861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405864 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 405864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 405869 */     GIR_RootConstrainSelectedInstOperands,
     /* 405870 */     // GIR_Coverage, 1875,
     /* 405870 */     GIR_Done,
     /* 405871 */   // Label 8353: @405871
     /* 405871 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(405886), // Rule ID 2506 //
     /* 405876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405879 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 405879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 405884 */     GIR_RootConstrainSelectedInstOperands,
     /* 405885 */     // GIR_Coverage, 2506,
     /* 405885 */     GIR_Done,
     /* 405886 */   // Label 8354: @405886
     /* 405886 */   GIM_Reject,
     /* 405887 */ // Label 8352: @405887
     /* 405887 */ GIM_Reject,
     /* 405888 */ // Label 8328: @405888
     /* 405888 */ GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(405921), // Rule ID 1870 //
     /* 405893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 405899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 405902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405914 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 405914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 405919 */   GIR_RootConstrainSelectedInstOperands,
     /* 405920 */   // GIR_Coverage, 1870,
     /* 405920 */   GIR_Done,
     /* 405921 */ // Label 8355: @405921
     /* 405921 */ GIM_Reject,
     /* 405922 */ // Label 8329: @405922
     /* 405922 */ GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(405976),
     /* 405927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 405933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405945 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(405960), // Rule ID 1873 //
     /* 405950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405953 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 405958 */     GIR_RootConstrainSelectedInstOperands,
     /* 405959 */     // GIR_Coverage, 1873,
     /* 405959 */     GIR_Done,
     /* 405960 */   // Label 8357: @405960
     /* 405960 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(405975), // Rule ID 2504 //
     /* 405965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405968 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 405968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 405973 */     GIR_RootConstrainSelectedInstOperands,
     /* 405974 */     // GIR_Coverage, 2504,
     /* 405974 */     GIR_Done,
     /* 405975 */   // Label 8358: @405975
     /* 405975 */   GIM_Reject,
     /* 405976 */ // Label 8356: @405976
     /* 405976 */ GIM_Reject,
     /* 405977 */ // Label 8330: @405977
     /* 405977 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(406010), // Rule ID 1871 //
     /* 405982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 405988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 405991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406003 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 406008 */   GIR_RootConstrainSelectedInstOperands,
     /* 406009 */   // GIR_Coverage, 1871,
     /* 406009 */   GIR_Done,
     /* 406010 */ // Label 8359: @406010
     /* 406010 */ GIM_Reject,
     /* 406011 */ // Label 8331: @406011
     /* 406011 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(406036), // Rule ID 8910 //
     /* 406016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 406022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 406025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406029 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 406029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 406034 */   GIR_RootConstrainSelectedInstOperands,
     /* 406035 */   // GIR_Coverage, 8910,
     /* 406035 */   GIR_Done,
     /* 406036 */ // Label 8360: @406036
     /* 406036 */ GIM_Reject,
     /* 406037 */ // Label 8332: @406037
     /* 406037 */ GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(406062), // Rule ID 8886 //
     /* 406042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 406048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 406051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406055 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 406055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406060 */   GIR_RootConstrainSelectedInstOperands,
     /* 406061 */   // GIR_Coverage, 8886,
     /* 406061 */   GIR_Done,
     /* 406062 */ // Label 8361: @406062
     /* 406062 */ GIM_Reject,
     /* 406063 */ // Label 8333: @406063
     /* 406063 */ GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(406088), // Rule ID 8887 //
     /* 406068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 406074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 406077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406081 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 406081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406086 */   GIR_RootConstrainSelectedInstOperands,
     /* 406087 */   // GIR_Coverage, 8887,
     /* 406087 */   GIR_Done,
     /* 406088 */ // Label 8362: @406088
     /* 406088 */ GIM_Reject,
     /* 406089 */ // Label 8334: @406089
     /* 406089 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(406135),
     /* 406094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 406097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 406100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406104 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(406119), // Rule ID 8882 //
     /* 406109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406112 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 406112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406117 */     GIR_RootConstrainSelectedInstOperands,
     /* 406118 */     // GIR_Coverage, 8882,
     /* 406118 */     GIR_Done,
     /* 406119 */   // Label 8364: @406119
     /* 406119 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(406134), // Rule ID 8888 //
     /* 406124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406127 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 406127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406132 */     GIR_RootConstrainSelectedInstOperands,
     /* 406133 */     // GIR_Coverage, 8888,
     /* 406133 */     GIR_Done,
     /* 406134 */   // Label 8365: @406134
     /* 406134 */   GIM_Reject,
     /* 406135 */ // Label 8363: @406135
     /* 406135 */ GIM_Reject,
     /* 406136 */ // Label 8335: @406136
     /* 406136 */ GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(406161), // Rule ID 8909 //
     /* 406141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 406147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 406150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406154 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 406154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 406159 */   GIR_RootConstrainSelectedInstOperands,
     /* 406160 */   // GIR_Coverage, 8909,
     /* 406160 */   GIR_Done,
     /* 406161 */ // Label 8366: @406161
     /* 406161 */ GIM_Reject,
     /* 406162 */ // Label 8336: @406162
     /* 406162 */ GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(406187), // Rule ID 8884 //
     /* 406167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 406173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 406176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406180 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 406180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 406185 */   GIR_RootConstrainSelectedInstOperands,
     /* 406186 */   // GIR_Coverage, 8884,
     /* 406186 */   GIR_Done,
     /* 406187 */ // Label 8367: @406187
     /* 406187 */ GIM_Reject,
     /* 406188 */ // Label 8337: @406188
     /* 406188 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(406234),
     /* 406193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 406196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 406199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406203 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(406218), // Rule ID 8881 //
     /* 406208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406211 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 406211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 406216 */     GIR_RootConstrainSelectedInstOperands,
     /* 406217 */     // GIR_Coverage, 8881,
     /* 406217 */     GIR_Done,
     /* 406218 */   // Label 8369: @406218
     /* 406218 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(406233), // Rule ID 8885 //
     /* 406223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406226 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 406226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 406231 */     GIR_RootConstrainSelectedInstOperands,
     /* 406232 */     // GIR_Coverage, 8885,
     /* 406232 */     GIR_Done,
     /* 406233 */   // Label 8370: @406233
     /* 406233 */   GIM_Reject,
     /* 406234 */ // Label 8368: @406234
     /* 406234 */ GIM_Reject,
     /* 406235 */ // Label 8338: @406235
     /* 406235 */ GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(406260), // Rule ID 8908 //
     /* 406240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 406246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 406249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406253 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 406253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 406258 */   GIR_RootConstrainSelectedInstOperands,
     /* 406259 */   // GIR_Coverage, 8908,
     /* 406259 */   GIR_Done,
     /* 406260 */ // Label 8371: @406260
     /* 406260 */ GIM_Reject,
     /* 406261 */ // Label 8339: @406261
     /* 406261 */ GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(406307),
     /* 406266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 406269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 406272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406276 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(406291), // Rule ID 8880 //
     /* 406281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406284 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 406284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 406289 */     GIR_RootConstrainSelectedInstOperands,
     /* 406290 */     // GIR_Coverage, 8880,
     /* 406290 */     GIR_Done,
     /* 406291 */   // Label 8373: @406291
     /* 406291 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(406306), // Rule ID 8883 //
     /* 406296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406299 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 406299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 406304 */     GIR_RootConstrainSelectedInstOperands,
     /* 406305 */     // GIR_Coverage, 8883,
     /* 406305 */     GIR_Done,
     /* 406306 */   // Label 8374: @406306
     /* 406306 */   GIM_Reject,
     /* 406307 */ // Label 8372: @406307
     /* 406307 */ GIM_Reject,
     /* 406308 */ // Label 8340: @406308
     /* 406308 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(406333), // Rule ID 2414 //
     /* 406313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 406319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 406322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406326 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 406326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 406331 */   GIR_RootConstrainSelectedInstOperands,
     /* 406332 */   // GIR_Coverage, 2414,
     /* 406332 */   GIR_Done,
     /* 406333 */ // Label 8375: @406333
     /* 406333 */ GIM_Reject,
     /* 406334 */ // Label 8341: @406334
     /* 406334 */ GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(406359), // Rule ID 8879 //
     /* 406339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 406345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 406348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406352 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 406352 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 406357 */   GIR_RootConstrainSelectedInstOperands,
     /* 406358 */   // GIR_Coverage, 8879,
     /* 406358 */   GIR_Done,
     /* 406359 */ // Label 8376: @406359
     /* 406359 */ GIM_Reject,
     /* 406360 */ // Label 8342: @406360
     /* 406360 */ GIM_Reject,
     /* 406361 */ // Label 145: @406361
     /* 406361 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8395*/ GIMT_Encode4(407140),
     /* 406372 */ /*GILLT_v2s32*//*Label 8377*/ GIMT_Encode4(406448),
     /* 406376 */ /*GILLT_v2s64*//*Label 8378*/ GIMT_Encode4(406503),
     /* 406380 */ /*GILLT_v4s16*//*Label 8379*/ GIMT_Encode4(406558),
     /* 406384 */ /*GILLT_v4s32*//*Label 8380*/ GIMT_Encode4(406613),
     /* 406388 */ /*GILLT_v8s8*//*Label 8381*/ GIMT_Encode4(406668),
     /* 406392 */ /*GILLT_v8s16*//*Label 8382*/ GIMT_Encode4(406702),
     /* 406396 */ /*GILLT_v16s8*//*Label 8383*/ GIMT_Encode4(406757), GIMT_Encode4(0),
     /* 406404 */ /*GILLT_nxv2s1*//*Label 8384*/ GIMT_Encode4(406791),
     /* 406408 */ /*GILLT_nxv2s16*//*Label 8385*/ GIMT_Encode4(406817),
     /* 406412 */ /*GILLT_nxv2s32*//*Label 8386*/ GIMT_Encode4(406843),
     /* 406416 */ /*GILLT_nxv2s64*//*Label 8387*/ GIMT_Encode4(406869),
     /* 406420 */ /*GILLT_nxv4s1*//*Label 8388*/ GIMT_Encode4(406916),
     /* 406424 */ /*GILLT_nxv4s16*//*Label 8389*/ GIMT_Encode4(406942),
     /* 406428 */ /*GILLT_nxv4s32*//*Label 8390*/ GIMT_Encode4(406968),
     /* 406432 */ /*GILLT_nxv8s1*//*Label 8391*/ GIMT_Encode4(407015),
     /* 406436 */ /*GILLT_nxv8s16*//*Label 8392*/ GIMT_Encode4(407041),
     /* 406440 */ /*GILLT_nxv16s1*//*Label 8393*/ GIMT_Encode4(407088),
     /* 406444 */ /*GILLT_nxv16s8*//*Label 8394*/ GIMT_Encode4(407114),
     /* 406448 */ // Label 8377: @406448
     /* 406448 */ GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(406502),
     /* 406453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406471 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(406486), // Rule ID 1881 //
     /* 406476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406479 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 406479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 406484 */     GIR_RootConstrainSelectedInstOperands,
     /* 406485 */     // GIR_Coverage, 1881,
     /* 406485 */     GIR_Done,
     /* 406486 */   // Label 8397: @406486
     /* 406486 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(406501), // Rule ID 5454 //
     /* 406491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406494 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 406499 */     GIR_RootConstrainSelectedInstOperands,
     /* 406500 */     // GIR_Coverage, 5454,
     /* 406500 */     GIR_Done,
     /* 406501 */   // Label 8398: @406501
     /* 406501 */   GIM_Reject,
     /* 406502 */ // Label 8396: @406502
     /* 406502 */ GIM_Reject,
     /* 406503 */ // Label 8378: @406503
     /* 406503 */ GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(406557),
     /* 406508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 406514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406526 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(406541), // Rule ID 1883 //
     /* 406531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406534 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 406534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 406539 */     GIR_RootConstrainSelectedInstOperands,
     /* 406540 */     // GIR_Coverage, 1883,
     /* 406540 */     GIR_Done,
     /* 406541 */   // Label 8400: @406541
     /* 406541 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(406556), // Rule ID 5456 //
     /* 406546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406549 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 406554 */     GIR_RootConstrainSelectedInstOperands,
     /* 406555 */     // GIR_Coverage, 5456,
     /* 406555 */     GIR_Done,
     /* 406556 */   // Label 8401: @406556
     /* 406556 */   GIM_Reject,
     /* 406557 */ // Label 8399: @406557
     /* 406557 */ GIM_Reject,
     /* 406558 */ // Label 8379: @406558
     /* 406558 */ GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(406612),
     /* 406563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 406569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406581 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(406596), // Rule ID 1879 //
     /* 406586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406589 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 406589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 406594 */     GIR_RootConstrainSelectedInstOperands,
     /* 406595 */     // GIR_Coverage, 1879,
     /* 406595 */     GIR_Done,
     /* 406596 */   // Label 8403: @406596
     /* 406596 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(406611), // Rule ID 5452 //
     /* 406601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406604 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 406604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 406609 */     GIR_RootConstrainSelectedInstOperands,
     /* 406610 */     // GIR_Coverage, 5452,
     /* 406610 */     GIR_Done,
     /* 406611 */   // Label 8404: @406611
     /* 406611 */   GIM_Reject,
     /* 406612 */ // Label 8402: @406612
     /* 406612 */ GIM_Reject,
     /* 406613 */ // Label 8380: @406613
     /* 406613 */ GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(406667),
     /* 406618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 406624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406636 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(406651), // Rule ID 1882 //
     /* 406641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406644 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 406644 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 406649 */     GIR_RootConstrainSelectedInstOperands,
     /* 406650 */     // GIR_Coverage, 1882,
     /* 406650 */     GIR_Done,
     /* 406651 */   // Label 8406: @406651
     /* 406651 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(406666), // Rule ID 5455 //
     /* 406656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406659 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 406664 */     GIR_RootConstrainSelectedInstOperands,
     /* 406665 */     // GIR_Coverage, 5455,
     /* 406665 */     GIR_Done,
     /* 406666 */   // Label 8407: @406666
     /* 406666 */   GIM_Reject,
     /* 406667 */ // Label 8405: @406667
     /* 406667 */ GIM_Reject,
     /* 406668 */ // Label 8381: @406668
     /* 406668 */ GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(406701), // Rule ID 1877 //
     /* 406673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 406682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406694 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 406694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 406699 */   GIR_RootConstrainSelectedInstOperands,
     /* 406700 */   // GIR_Coverage, 1877,
     /* 406700 */   GIR_Done,
     /* 406701 */ // Label 8408: @406701
     /* 406701 */ GIM_Reject,
     /* 406702 */ // Label 8382: @406702
     /* 406702 */ GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(406756),
     /* 406707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 406713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406725 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(406740), // Rule ID 1880 //
     /* 406730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406733 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 406733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 406738 */     GIR_RootConstrainSelectedInstOperands,
     /* 406739 */     // GIR_Coverage, 1880,
     /* 406739 */     GIR_Done,
     /* 406740 */   // Label 8410: @406740
     /* 406740 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(406755), // Rule ID 5453 //
     /* 406745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406748 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 406753 */     GIR_RootConstrainSelectedInstOperands,
     /* 406754 */     // GIR_Coverage, 5453,
     /* 406754 */     GIR_Done,
     /* 406755 */   // Label 8411: @406755
     /* 406755 */   GIM_Reject,
     /* 406756 */ // Label 8409: @406756
     /* 406756 */ GIM_Reject,
     /* 406757 */ // Label 8383: @406757
     /* 406757 */ GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(406790), // Rule ID 1878 //
     /* 406762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 406771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406783 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 406788 */   GIR_RootConstrainSelectedInstOperands,
     /* 406789 */   // GIR_Coverage, 1878,
     /* 406789 */   GIR_Done,
     /* 406790 */ // Label 8412: @406790
     /* 406790 */ GIM_Reject,
     /* 406791 */ // Label 8384: @406791
     /* 406791 */ GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(406816), // Rule ID 8913 //
     /* 406796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 406802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 406805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406809 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 406809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 406814 */   GIR_RootConstrainSelectedInstOperands,
     /* 406815 */   // GIR_Coverage, 8913,
     /* 406815 */   GIR_Done,
     /* 406816 */ // Label 8413: @406816
     /* 406816 */ GIM_Reject,
     /* 406817 */ // Label 8385: @406817
     /* 406817 */ GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(406842), // Rule ID 8896 //
     /* 406822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 406828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 406831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406835 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 406835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406840 */   GIR_RootConstrainSelectedInstOperands,
     /* 406841 */   // GIR_Coverage, 8896,
     /* 406841 */   GIR_Done,
     /* 406842 */ // Label 8414: @406842
     /* 406842 */ GIM_Reject,
     /* 406843 */ // Label 8386: @406843
     /* 406843 */ GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(406868), // Rule ID 8897 //
     /* 406848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 406854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 406857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406861 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 406861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406866 */   GIR_RootConstrainSelectedInstOperands,
     /* 406867 */   // GIR_Coverage, 8897,
     /* 406867 */   GIR_Done,
     /* 406868 */ // Label 8415: @406868
     /* 406868 */ GIM_Reject,
     /* 406869 */ // Label 8387: @406869
     /* 406869 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(406915),
     /* 406874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 406877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 406880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406884 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(406899), // Rule ID 8892 //
     /* 406889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406892 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 406892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406897 */     GIR_RootConstrainSelectedInstOperands,
     /* 406898 */     // GIR_Coverage, 8892,
     /* 406898 */     GIR_Done,
     /* 406899 */   // Label 8417: @406899
     /* 406899 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(406914), // Rule ID 8898 //
     /* 406904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406907 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 406907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 406912 */     GIR_RootConstrainSelectedInstOperands,
     /* 406913 */     // GIR_Coverage, 8898,
     /* 406913 */     GIR_Done,
     /* 406914 */   // Label 8418: @406914
     /* 406914 */   GIM_Reject,
     /* 406915 */ // Label 8416: @406915
     /* 406915 */ GIM_Reject,
     /* 406916 */ // Label 8388: @406916
     /* 406916 */ GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(406941), // Rule ID 8912 //
     /* 406921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 406927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 406930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406934 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 406934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 406939 */   GIR_RootConstrainSelectedInstOperands,
     /* 406940 */   // GIR_Coverage, 8912,
     /* 406940 */   GIR_Done,
     /* 406941 */ // Label 8419: @406941
     /* 406941 */ GIM_Reject,
     /* 406942 */ // Label 8389: @406942
     /* 406942 */ GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(406967), // Rule ID 8894 //
     /* 406947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 406953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 406956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406960 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 406960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 406965 */   GIR_RootConstrainSelectedInstOperands,
     /* 406966 */   // GIR_Coverage, 8894,
     /* 406966 */   GIR_Done,
     /* 406967 */ // Label 8420: @406967
     /* 406967 */ GIM_Reject,
     /* 406968 */ // Label 8390: @406968
     /* 406968 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(407014),
     /* 406973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 406976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 406979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406983 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(406998), // Rule ID 8891 //
     /* 406988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406991 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 406991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 406996 */     GIR_RootConstrainSelectedInstOperands,
     /* 406997 */     // GIR_Coverage, 8891,
     /* 406997 */     GIR_Done,
     /* 406998 */   // Label 8422: @406998
     /* 406998 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(407013), // Rule ID 8895 //
     /* 407003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407006 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 407006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 407011 */     GIR_RootConstrainSelectedInstOperands,
     /* 407012 */     // GIR_Coverage, 8895,
     /* 407012 */     GIR_Done,
     /* 407013 */   // Label 8423: @407013
     /* 407013 */   GIM_Reject,
     /* 407014 */ // Label 8421: @407014
     /* 407014 */ GIM_Reject,
     /* 407015 */ // Label 8391: @407015
     /* 407015 */ GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(407040), // Rule ID 8911 //
     /* 407020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 407026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 407029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407033 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 407033 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 407038 */   GIR_RootConstrainSelectedInstOperands,
     /* 407039 */   // GIR_Coverage, 8911,
     /* 407039 */   GIR_Done,
     /* 407040 */ // Label 8424: @407040
     /* 407040 */ GIM_Reject,
     /* 407041 */ // Label 8392: @407041
     /* 407041 */ GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(407087),
     /* 407046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 407049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 407052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407056 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(407071), // Rule ID 8890 //
     /* 407061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407064 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 407064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 407069 */     GIR_RootConstrainSelectedInstOperands,
     /* 407070 */     // GIR_Coverage, 8890,
     /* 407070 */     GIR_Done,
     /* 407071 */   // Label 8426: @407071
     /* 407071 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(407086), // Rule ID 8893 //
     /* 407076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407079 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 407079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 407084 */     GIR_RootConstrainSelectedInstOperands,
     /* 407085 */     // GIR_Coverage, 8893,
     /* 407085 */     GIR_Done,
     /* 407086 */   // Label 8427: @407086
     /* 407086 */   GIM_Reject,
     /* 407087 */ // Label 8425: @407087
     /* 407087 */ GIM_Reject,
     /* 407088 */ // Label 8393: @407088
     /* 407088 */ GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(407113), // Rule ID 2418 //
     /* 407093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 407099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 407102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407106 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 407106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 407111 */   GIR_RootConstrainSelectedInstOperands,
     /* 407112 */   // GIR_Coverage, 2418,
     /* 407112 */   GIR_Done,
     /* 407113 */ // Label 8428: @407113
     /* 407113 */ GIM_Reject,
     /* 407114 */ // Label 8394: @407114
     /* 407114 */ GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(407139), // Rule ID 8889 //
     /* 407119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 407125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 407128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407132 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 407132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 407137 */   GIR_RootConstrainSelectedInstOperands,
     /* 407138 */   // GIR_Coverage, 8889,
     /* 407138 */   GIR_Done,
     /* 407139 */ // Label 8429: @407139
     /* 407139 */ GIM_Reject,
     /* 407140 */ // Label 8395: @407140
     /* 407140 */ GIM_Reject,
     /* 407141 */ // Label 146: @407141
     /* 407141 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8436*/ GIMT_Encode4(407346),
     /* 407152 */ /*GILLT_s64*//*Label 8430*/ GIMT_Encode4(407184), GIMT_Encode4(0),
     /* 407160 */ /*GILLT_v2s32*//*Label 8431*/ GIMT_Encode4(407211),
     /* 407164 */ /*GILLT_v2s64*//*Label 8432*/ GIMT_Encode4(407238),
     /* 407168 */ /*GILLT_v4s16*//*Label 8433*/ GIMT_Encode4(407265),
     /* 407172 */ /*GILLT_v4s32*//*Label 8434*/ GIMT_Encode4(407292), GIMT_Encode4(0),
     /* 407180 */ /*GILLT_v8s16*//*Label 8435*/ GIMT_Encode4(407319),
     /* 407184 */ // Label 8430: @407184
     /* 407184 */ GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(407210), // Rule ID 1069 //
     /* 407189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407203 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 407203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 407208 */   GIR_RootConstrainSelectedInstOperands,
     /* 407209 */   // GIR_Coverage, 1069,
     /* 407209 */   GIR_Done,
     /* 407210 */ // Label 8437: @407210
     /* 407210 */ GIM_Reject,
     /* 407211 */ // Label 8431: @407211
     /* 407211 */ GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(407237), // Rule ID 1065 //
     /* 407216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407230 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 407230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 407235 */   GIR_RootConstrainSelectedInstOperands,
     /* 407236 */   // GIR_Coverage, 1065,
     /* 407236 */   GIR_Done,
     /* 407237 */ // Label 8438: @407237
     /* 407237 */ GIM_Reject,
     /* 407238 */ // Label 8432: @407238
     /* 407238 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(407264), // Rule ID 1071 //
     /* 407243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407257 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 407257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 407262 */   GIR_RootConstrainSelectedInstOperands,
     /* 407263 */   // GIR_Coverage, 1071,
     /* 407263 */   GIR_Done,
     /* 407264 */ // Label 8439: @407264
     /* 407264 */ GIM_Reject,
     /* 407265 */ // Label 8433: @407265
     /* 407265 */ GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(407291), // Rule ID 1061 //
     /* 407270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407284 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 407284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 407289 */   GIR_RootConstrainSelectedInstOperands,
     /* 407290 */   // GIR_Coverage, 1061,
     /* 407290 */   GIR_Done,
     /* 407291 */ // Label 8440: @407291
     /* 407291 */ GIM_Reject,
     /* 407292 */ // Label 8434: @407292
     /* 407292 */ GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(407318), // Rule ID 1067 //
     /* 407297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407311 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 407311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 407316 */   GIR_RootConstrainSelectedInstOperands,
     /* 407317 */   // GIR_Coverage, 1067,
     /* 407317 */   GIR_Done,
     /* 407318 */ // Label 8441: @407318
     /* 407318 */ GIM_Reject,
     /* 407319 */ // Label 8435: @407319
     /* 407319 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(407345), // Rule ID 1063 //
     /* 407324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407338 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 407338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 407343 */   GIR_RootConstrainSelectedInstOperands,
     /* 407344 */   // GIR_Coverage, 1063,
     /* 407344 */   GIR_Done,
     /* 407345 */ // Label 8442: @407345
     /* 407345 */ GIM_Reject,
     /* 407346 */ // Label 8436: @407346
     /* 407346 */ GIM_Reject,
     /* 407347 */ // Label 147: @407347
     /* 407347 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8445*/ GIMT_Encode4(408213),
     /* 407358 */ /*GILLT_v2s64*//*Label 8443*/ GIMT_Encode4(407370), GIMT_Encode4(0),
     /* 407366 */ /*GILLT_v4s32*//*Label 8444*/ GIMT_Encode4(407664),
     /* 407370 */ // Label 8443: @407370
     /* 407370 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(407452), // Rule ID 5827 //
     /* 407375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 407390 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 407393 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 407398 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 407402 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407409 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 407409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 407416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407421 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 407425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407441 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407451 */   // GIR_Coverage, 5827,
     /* 407451 */   GIR_EraseRootFromParent_Done,
     /* 407452 */ // Label 8446: @407452
     /* 407452 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(407526), // Rule ID 5826 //
     /* 407457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407464 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 407472 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407476 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407483 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 407483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 407490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 407499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407525 */   // GIR_Coverage, 5826,
     /* 407525 */   GIR_EraseRootFromParent_Done,
     /* 407526 */ // Label 8447: @407526
     /* 407526 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(407585), // Rule ID 5836 //
     /* 407531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407542 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 407542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 407549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407554 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 407574 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407584 */   // GIR_Coverage, 5836,
     /* 407584 */   GIR_EraseRootFromParent_Done,
     /* 407585 */ // Label 8448: @407585
     /* 407585 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(407663), // Rule ID 5964 //
     /* 407590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407601 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 407601 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407604 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 407608 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407613 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 407617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 407619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 407622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 407626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 407636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 407647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407662 */   // GIR_Coverage, 5964,
     /* 407662 */   GIR_EraseRootFromParent_Done,
     /* 407663 */ // Label 8449: @407663
     /* 407663 */ GIM_Reject,
     /* 407664 */ // Label 8444: @407664
     /* 407664 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(407746), // Rule ID 5829 //
     /* 407669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 407684 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 407687 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 407692 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 407696 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407703 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 407703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 407710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 407719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407745 */   // GIR_Coverage, 5829,
     /* 407745 */   GIR_EraseRootFromParent_Done,
     /* 407746 */ // Label 8450: @407746
     /* 407746 */ GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(407828), // Rule ID 5831 //
     /* 407751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 407766 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 407769 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 407774 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 407778 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407785 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 407785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 407792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407797 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 407801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407822 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407827 */   // GIR_Coverage, 5831,
     /* 407827 */   GIR_EraseRootFromParent_Done,
     /* 407828 */ // Label 8451: @407828
     /* 407828 */ GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(407902), // Rule ID 5828 //
     /* 407833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 407848 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407852 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407857 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407859 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 407859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 407866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407871 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 407875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407891 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407901 */   // GIR_Coverage, 5828,
     /* 407901 */   GIR_EraseRootFromParent_Done,
     /* 407902 */ // Label 8452: @407902
     /* 407902 */ GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(407976), // Rule ID 5830 //
     /* 407907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 407922 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407926 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407933 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 407933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 407940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 407949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 407965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407970 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 407975 */   // GIR_Coverage, 5830,
     /* 407975 */   GIR_EraseRootFromParent_Done,
     /* 407976 */ // Label 8453: @407976
     /* 407976 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(408035), // Rule ID 5832 //
     /* 407981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407992 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 407992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 407995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 407999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408004 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408034 */   // GIR_Coverage, 5832,
     /* 408034 */   GIR_EraseRootFromParent_Done,
     /* 408035 */ // Label 8454: @408035
     /* 408035 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(408094), // Rule ID 5833 //
     /* 408040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408051 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 408051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 408058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408063 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408093 */   // GIR_Coverage, 5833,
     /* 408093 */   GIR_EraseRootFromParent_Done,
     /* 408094 */ // Label 8455: @408094
     /* 408094 */ GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(408153), // Rule ID 5834 //
     /* 408099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408110 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 408110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 408117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408122 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408152 */   // GIR_Coverage, 5834,
     /* 408152 */   GIR_EraseRootFromParent_Done,
     /* 408153 */ // Label 8456: @408153
     /* 408153 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(408212), // Rule ID 5835 //
     /* 408158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408169 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 408169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 408176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408181 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408211 */   // GIR_Coverage, 5835,
     /* 408211 */   GIR_EraseRootFromParent_Done,
     /* 408212 */ // Label 8457: @408212
     /* 408212 */ GIM_Reject,
     /* 408213 */ // Label 8445: @408213
     /* 408213 */ GIM_Reject,
     /* 408214 */ // Label 148: @408214
     /* 408214 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8462*/ GIMT_Encode4(408583),
     /* 408225 */ /*GILLT_v2s32*//*Label 8458*/ GIMT_Encode4(408285), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408237 */ /*GILLT_v4s32*//*Label 8459*/ GIMT_Encode4(408405), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408269 */ /*GILLT_nxv2s64*//*Label 8460*/ GIMT_Encode4(408525), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408281 */ /*GILLT_nxv4s32*//*Label 8461*/ GIMT_Encode4(408554),
     /* 408285 */ // Label 8458: @408285
     /* 408285 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(408404),
     /* 408290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 408299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408311 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(408384), // Rule ID 28 //
     /* 408316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408360 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408364 */     // MIs[3] Operand 1
     /* 408364 */     // No operand predicates
     /* 408364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408366 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 408369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408382 */     GIR_RootConstrainSelectedInstOperands,
     /* 408383 */     // GIR_Coverage, 28,
     /* 408383 */     GIR_EraseRootFromParent_Done,
     /* 408384 */   // Label 8464: @408384
     /* 408384 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(408403), // Rule ID 24 //
     /* 408389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408396 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 408396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 408401 */     GIR_RootConstrainSelectedInstOperands,
     /* 408402 */     // GIR_Coverage, 24,
     /* 408402 */     GIR_Done,
     /* 408403 */   // Label 8465: @408403
     /* 408403 */   GIM_Reject,
     /* 408404 */ // Label 8463: @408404
     /* 408404 */ GIM_Reject,
     /* 408405 */ // Label 8459: @408405
     /* 408405 */ GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(408524),
     /* 408410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 408419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408431 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(408504), // Rule ID 29 //
     /* 408436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408480 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408484 */     // MIs[3] Operand 1
     /* 408484 */     // No operand predicates
     /* 408484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408486 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 408489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408502 */     GIR_RootConstrainSelectedInstOperands,
     /* 408503 */     // GIR_Coverage, 29,
     /* 408503 */     GIR_EraseRootFromParent_Done,
     /* 408504 */   // Label 8467: @408504
     /* 408504 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(408523), // Rule ID 25 //
     /* 408509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408516 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 408516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 408521 */     GIR_RootConstrainSelectedInstOperands,
     /* 408522 */     // GIR_Coverage, 25,
     /* 408522 */     GIR_Done,
     /* 408523 */   // Label 8468: @408523
     /* 408523 */   GIM_Reject,
     /* 408524 */ // Label 8466: @408524
     /* 408524 */ GIM_Reject,
     /* 408525 */ // Label 8460: @408525
     /* 408525 */ GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(408553), // Rule ID 7600 //
     /* 408530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 408536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 408539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 408542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408546 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 408546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 408551 */   GIR_RootConstrainSelectedInstOperands,
     /* 408552 */   // GIR_Coverage, 7600,
     /* 408552 */   GIR_Done,
     /* 408553 */ // Label 8469: @408553
     /* 408553 */ GIM_Reject,
     /* 408554 */ // Label 8461: @408554
     /* 408554 */ GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(408582), // Rule ID 7599 //
     /* 408559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 408562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 408565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 408568 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 408571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 408575 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 408575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 408580 */   GIR_RootConstrainSelectedInstOperands,
     /* 408581 */   // GIR_Coverage, 7599,
     /* 408581 */   GIR_Done,
     /* 408582 */ // Label 8470: @408582
     /* 408582 */ GIM_Reject,
     /* 408583 */ // Label 8462: @408583
     /* 408583 */ GIM_Reject,
     /* 408584 */ // Label 149: @408584
     /* 408584 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8474*/ GIMT_Encode4(408700),
     /* 408595 */ /*GILLT_s16*//*Label 8471*/ GIMT_Encode4(408607),
     /* 408599 */ /*GILLT_s32*//*Label 8472*/ GIMT_Encode4(408638),
     /* 408603 */ /*GILLT_s64*//*Label 8473*/ GIMT_Encode4(408669),
     /* 408607 */ // Label 8471: @408607
     /* 408607 */ GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(408637), // Rule ID 1669 //
     /* 408612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 408615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 408618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408626 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 408626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 408631 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408635 */   GIR_RootConstrainSelectedInstOperands,
     /* 408636 */   // GIR_Coverage, 1669,
     /* 408636 */   GIR_Done,
     /* 408637 */ // Label 8475: @408637
     /* 408637 */ GIM_Reject,
     /* 408638 */ // Label 8472: @408638
     /* 408638 */ GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(408668), // Rule ID 1668 //
     /* 408643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 408646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 408649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408657 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 408657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 408662 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408666 */   GIR_RootConstrainSelectedInstOperands,
     /* 408667 */   // GIR_Coverage, 1668,
     /* 408667 */   GIR_Done,
     /* 408668 */ // Label 8476: @408668
     /* 408668 */ GIM_Reject,
     /* 408669 */ // Label 8473: @408669
     /* 408669 */ GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(408699), // Rule ID 1667 //
     /* 408674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 408677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 408680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408688 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 408688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 408693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 408697 */   GIR_RootConstrainSelectedInstOperands,
     /* 408698 */   // GIR_Coverage, 1667,
     /* 408698 */   GIR_Done,
     /* 408699 */ // Label 8477: @408699
     /* 408699 */ GIM_Reject,
     /* 408700 */ // Label 8474: @408700
     /* 408700 */ GIM_Reject,
     /* 408701 */ // Label 150: @408701
     /* 408701 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8481*/ GIMT_Encode4(409933),
     /* 408712 */ /*GILLT_v2s64*//*Label 8478*/ GIMT_Encode4(408732), GIMT_Encode4(0),
     /* 408720 */ /*GILLT_v4s32*//*Label 8479*/ GIMT_Encode4(409293), GIMT_Encode4(0),
     /* 408728 */ /*GILLT_v8s16*//*Label 8480*/ GIMT_Encode4(409854),
     /* 408732 */ // Label 8478: @408732
     /* 408732 */ GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(409292),
     /* 408737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 408743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408747 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(408839), // Rule ID 2106 //
     /* 408752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408796 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408800 */     // MIs[3] Operand 1
     /* 408800 */     // No operand predicates
     /* 408800 */     // MIs[1] Operand 2
     /* 408800 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 408811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 408820 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 408823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408837 */     GIR_RootConstrainSelectedInstOperands,
     /* 408838 */     // GIR_Coverage, 2106,
     /* 408838 */     GIR_EraseRootFromParent_Done,
     /* 408839 */   // Label 8483: @408839
     /* 408839 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(408931), // Rule ID 13456 //
     /* 408844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408888 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408892 */     // MIs[3] Operand 1
     /* 408892 */     // No operand predicates
     /* 408892 */     // MIs[1] Operand 2
     /* 408892 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 408903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 408912 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 408915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 408922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408929 */     GIR_RootConstrainSelectedInstOperands,
     /* 408930 */     // GIR_Coverage, 13456,
     /* 408930 */     GIR_EraseRootFromParent_Done,
     /* 408931 */   // Label 8484: @408931
     /* 408931 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(409017), // Rule ID 13454 //
     /* 408936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 408947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408980 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408984 */     // MIs[3] Operand 1
     /* 408984 */     // No operand predicates
     /* 408984 */     // MIs[1] Operand 2
     /* 408984 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 408995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409001 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409015 */     GIR_RootConstrainSelectedInstOperands,
     /* 409016 */     // GIR_Coverage, 13454,
     /* 409016 */     GIR_EraseRootFromParent_Done,
     /* 409017 */   // Label 8485: @409017
     /* 409017 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(409103), // Rule ID 2104 //
     /* 409022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409074 */     // MIs[3] Operand 1
     /* 409074 */     // No operand predicates
     /* 409074 */     // MIs[1] Operand 2
     /* 409074 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409087 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409101 */     GIR_RootConstrainSelectedInstOperands,
     /* 409102 */     // GIR_Coverage, 2104,
     /* 409102 */     GIR_EraseRootFromParent_Done,
     /* 409103 */   // Label 8486: @409103
     /* 409103 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(409142), // Rule ID 1831 //
     /* 409108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409125 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 409128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409140 */     GIR_RootConstrainSelectedInstOperands,
     /* 409141 */     // GIR_Coverage, 1831,
     /* 409141 */     GIR_EraseRootFromParent_Done,
     /* 409142 */   // Label 8487: @409142
     /* 409142 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(409205), // Rule ID 13455 //
     /* 409147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409179 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409183 */     // MIs[2] Operand 1
     /* 409183 */     // No operand predicates
     /* 409183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409189 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409203 */     GIR_RootConstrainSelectedInstOperands,
     /* 409204 */     // GIR_Coverage, 13455,
     /* 409204 */     GIR_EraseRootFromParent_Done,
     /* 409205 */   // Label 8488: @409205
     /* 409205 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(409268), // Rule ID 2105 //
     /* 409210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409250 */     // MIs[2] Operand 1
     /* 409250 */     // No operand predicates
     /* 409250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409252 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409266 */     GIR_RootConstrainSelectedInstOperands,
     /* 409267 */     // GIR_Coverage, 2105,
     /* 409267 */     GIR_EraseRootFromParent_Done,
     /* 409268 */   // Label 8489: @409268
     /* 409268 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(409291), // Rule ID 1830 //
     /* 409273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409284 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 409284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 409289 */     GIR_RootConstrainSelectedInstOperands,
     /* 409290 */     // GIR_Coverage, 1830,
     /* 409290 */     GIR_Done,
     /* 409291 */   // Label 8490: @409291
     /* 409291 */   GIM_Reject,
     /* 409292 */ // Label 8482: @409292
     /* 409292 */ GIM_Reject,
     /* 409293 */ // Label 8479: @409293
     /* 409293 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(409853),
     /* 409298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409308 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(409400), // Rule ID 2103 //
     /* 409313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409357 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409361 */     // MIs[3] Operand 1
     /* 409361 */     // No operand predicates
     /* 409361 */     // MIs[1] Operand 2
     /* 409361 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409381 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 409384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409398 */     GIR_RootConstrainSelectedInstOperands,
     /* 409399 */     // GIR_Coverage, 2103,
     /* 409399 */     GIR_EraseRootFromParent_Done,
     /* 409400 */   // Label 8492: @409400
     /* 409400 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(409492), // Rule ID 13453 //
     /* 409405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409449 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409453 */     // MIs[3] Operand 1
     /* 409453 */     // No operand predicates
     /* 409453 */     // MIs[1] Operand 2
     /* 409453 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409464 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409473 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 409476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409490 */     GIR_RootConstrainSelectedInstOperands,
     /* 409491 */     // GIR_Coverage, 13453,
     /* 409491 */     GIR_EraseRootFromParent_Done,
     /* 409492 */   // Label 8493: @409492
     /* 409492 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(409578), // Rule ID 13451 //
     /* 409497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409545 */     // MIs[3] Operand 1
     /* 409545 */     // No operand predicates
     /* 409545 */     // MIs[1] Operand 2
     /* 409545 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409562 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409576 */     GIR_RootConstrainSelectedInstOperands,
     /* 409577 */     // GIR_Coverage, 13451,
     /* 409577 */     GIR_EraseRootFromParent_Done,
     /* 409578 */   // Label 8494: @409578
     /* 409578 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(409664), // Rule ID 2101 //
     /* 409583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409631 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409635 */     // MIs[3] Operand 1
     /* 409635 */     // No operand predicates
     /* 409635 */     // MIs[1] Operand 2
     /* 409635 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409648 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409662 */     GIR_RootConstrainSelectedInstOperands,
     /* 409663 */     // GIR_Coverage, 2101,
     /* 409663 */     GIR_EraseRootFromParent_Done,
     /* 409664 */   // Label 8495: @409664
     /* 409664 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(409703), // Rule ID 1829 //
     /* 409669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409686 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 409686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 409689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409701 */     GIR_RootConstrainSelectedInstOperands,
     /* 409702 */     // GIR_Coverage, 1829,
     /* 409702 */     GIR_EraseRootFromParent_Done,
     /* 409703 */   // Label 8496: @409703
     /* 409703 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(409766), // Rule ID 13452 //
     /* 409708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409740 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409744 */     // MIs[2] Operand 1
     /* 409744 */     // No operand predicates
     /* 409744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409750 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409764 */     GIR_RootConstrainSelectedInstOperands,
     /* 409765 */     // GIR_Coverage, 13452,
     /* 409765 */     GIR_EraseRootFromParent_Done,
     /* 409766 */   // Label 8497: @409766
     /* 409766 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(409829), // Rule ID 2102 //
     /* 409771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409807 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409811 */     // MIs[2] Operand 1
     /* 409811 */     // No operand predicates
     /* 409811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409813 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 409816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409827 */     GIR_RootConstrainSelectedInstOperands,
     /* 409828 */     // GIR_Coverage, 2102,
     /* 409828 */     GIR_EraseRootFromParent_Done,
     /* 409829 */   // Label 8498: @409829
     /* 409829 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(409852), // Rule ID 1828 //
     /* 409834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409845 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 409845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 409850 */     GIR_RootConstrainSelectedInstOperands,
     /* 409851 */     // GIR_Coverage, 1828,
     /* 409851 */     GIR_Done,
     /* 409852 */   // Label 8499: @409852
     /* 409852 */   GIM_Reject,
     /* 409853 */ // Label 8491: @409853
     /* 409853 */ GIM_Reject,
     /* 409854 */ // Label 8480: @409854
     /* 409854 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(409932),
     /* 409859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 409862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 409865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409869 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(409908), // Rule ID 1827 //
     /* 409874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 409884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 409891 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 409891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 409894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409906 */     GIR_RootConstrainSelectedInstOperands,
     /* 409907 */     // GIR_Coverage, 1827,
     /* 409907 */     GIR_EraseRootFromParent_Done,
     /* 409908 */   // Label 8501: @409908
     /* 409908 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(409931), // Rule ID 1826 //
     /* 409913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409924 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 409924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 409929 */     GIR_RootConstrainSelectedInstOperands,
     /* 409930 */     // GIR_Coverage, 1826,
     /* 409930 */     GIR_Done,
     /* 409931 */   // Label 8502: @409931
     /* 409931 */   GIM_Reject,
     /* 409932 */ // Label 8500: @409932
     /* 409932 */ GIM_Reject,
     /* 409933 */ // Label 8481: @409933
     /* 409933 */ GIM_Reject,
     /* 409934 */ // Label 151: @409934
     /* 409934 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8521*/ GIMT_Encode4(410713),
     /* 409945 */ /*GILLT_v2s32*//*Label 8503*/ GIMT_Encode4(410021),
     /* 409949 */ /*GILLT_v2s64*//*Label 8504*/ GIMT_Encode4(410076),
     /* 409953 */ /*GILLT_v4s16*//*Label 8505*/ GIMT_Encode4(410131),
     /* 409957 */ /*GILLT_v4s32*//*Label 8506*/ GIMT_Encode4(410186),
     /* 409961 */ /*GILLT_v8s8*//*Label 8507*/ GIMT_Encode4(410241),
     /* 409965 */ /*GILLT_v8s16*//*Label 8508*/ GIMT_Encode4(410275),
     /* 409969 */ /*GILLT_v16s8*//*Label 8509*/ GIMT_Encode4(410330), GIMT_Encode4(0),
     /* 409977 */ /*GILLT_nxv2s1*//*Label 8510*/ GIMT_Encode4(410364),
     /* 409981 */ /*GILLT_nxv2s16*//*Label 8511*/ GIMT_Encode4(410390),
     /* 409985 */ /*GILLT_nxv2s32*//*Label 8512*/ GIMT_Encode4(410416),
     /* 409989 */ /*GILLT_nxv2s64*//*Label 8513*/ GIMT_Encode4(410442),
     /* 409993 */ /*GILLT_nxv4s1*//*Label 8514*/ GIMT_Encode4(410489),
     /* 409997 */ /*GILLT_nxv4s16*//*Label 8515*/ GIMT_Encode4(410515),
     /* 410001 */ /*GILLT_nxv4s32*//*Label 8516*/ GIMT_Encode4(410541),
     /* 410005 */ /*GILLT_nxv8s1*//*Label 8517*/ GIMT_Encode4(410588),
     /* 410009 */ /*GILLT_nxv8s16*//*Label 8518*/ GIMT_Encode4(410614),
     /* 410013 */ /*GILLT_nxv16s1*//*Label 8519*/ GIMT_Encode4(410661),
     /* 410017 */ /*GILLT_nxv16s8*//*Label 8520*/ GIMT_Encode4(410687),
     /* 410021 */ // Label 8503: @410021
     /* 410021 */ GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(410075),
     /* 410026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410044 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(410059), // Rule ID 1888 //
     /* 410049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410052 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 410057 */     GIR_RootConstrainSelectedInstOperands,
     /* 410058 */     // GIR_Coverage, 1888,
     /* 410058 */     GIR_Done,
     /* 410059 */   // Label 8523: @410059
     /* 410059 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(410074), // Rule ID 5459 //
     /* 410064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410067 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 410072 */     GIR_RootConstrainSelectedInstOperands,
     /* 410073 */     // GIR_Coverage, 5459,
     /* 410073 */     GIR_Done,
     /* 410074 */   // Label 8524: @410074
     /* 410074 */   GIM_Reject,
     /* 410075 */ // Label 8522: @410075
     /* 410075 */ GIM_Reject,
     /* 410076 */ // Label 8504: @410076
     /* 410076 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(410130),
     /* 410081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410099 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(410114), // Rule ID 1890 //
     /* 410104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410107 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 410107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 410112 */     GIR_RootConstrainSelectedInstOperands,
     /* 410113 */     // GIR_Coverage, 1890,
     /* 410113 */     GIR_Done,
     /* 410114 */   // Label 8526: @410114
     /* 410114 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(410129), // Rule ID 5461 //
     /* 410119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410122 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 410122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 410127 */     GIR_RootConstrainSelectedInstOperands,
     /* 410128 */     // GIR_Coverage, 5461,
     /* 410128 */     GIR_Done,
     /* 410129 */   // Label 8527: @410129
     /* 410129 */   GIM_Reject,
     /* 410130 */ // Label 8525: @410130
     /* 410130 */ GIM_Reject,
     /* 410131 */ // Label 8505: @410131
     /* 410131 */ GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(410185),
     /* 410136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 410142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410154 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(410169), // Rule ID 1886 //
     /* 410159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410162 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 410167 */     GIR_RootConstrainSelectedInstOperands,
     /* 410168 */     // GIR_Coverage, 1886,
     /* 410168 */     GIR_Done,
     /* 410169 */   // Label 8529: @410169
     /* 410169 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(410184), // Rule ID 5457 //
     /* 410174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410177 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 410177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 410182 */     GIR_RootConstrainSelectedInstOperands,
     /* 410183 */     // GIR_Coverage, 5457,
     /* 410183 */     GIR_Done,
     /* 410184 */   // Label 8530: @410184
     /* 410184 */   GIM_Reject,
     /* 410185 */ // Label 8528: @410185
     /* 410185 */ GIM_Reject,
     /* 410186 */ // Label 8506: @410186
     /* 410186 */ GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(410240),
     /* 410191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 410197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410209 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(410224), // Rule ID 1889 //
     /* 410214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410217 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 410217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 410222 */     GIR_RootConstrainSelectedInstOperands,
     /* 410223 */     // GIR_Coverage, 1889,
     /* 410223 */     GIR_Done,
     /* 410224 */   // Label 8532: @410224
     /* 410224 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(410239), // Rule ID 5460 //
     /* 410229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410232 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 410232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 410237 */     GIR_RootConstrainSelectedInstOperands,
     /* 410238 */     // GIR_Coverage, 5460,
     /* 410238 */     GIR_Done,
     /* 410239 */   // Label 8533: @410239
     /* 410239 */   GIM_Reject,
     /* 410240 */ // Label 8531: @410240
     /* 410240 */ GIM_Reject,
     /* 410241 */ // Label 8507: @410241
     /* 410241 */ GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(410274), // Rule ID 1884 //
     /* 410246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410267 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 410272 */   GIR_RootConstrainSelectedInstOperands,
     /* 410273 */   // GIR_Coverage, 1884,
     /* 410273 */   GIR_Done,
     /* 410274 */ // Label 8534: @410274
     /* 410274 */ GIM_Reject,
     /* 410275 */ // Label 8508: @410275
     /* 410275 */ GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(410329),
     /* 410280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 410286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410298 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(410313), // Rule ID 1887 //
     /* 410303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410306 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 410311 */     GIR_RootConstrainSelectedInstOperands,
     /* 410312 */     // GIR_Coverage, 1887,
     /* 410312 */     GIR_Done,
     /* 410313 */   // Label 8536: @410313
     /* 410313 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(410328), // Rule ID 5458 //
     /* 410318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410321 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 410321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 410326 */     GIR_RootConstrainSelectedInstOperands,
     /* 410327 */     // GIR_Coverage, 5458,
     /* 410327 */     GIR_Done,
     /* 410328 */   // Label 8537: @410328
     /* 410328 */   GIM_Reject,
     /* 410329 */ // Label 8535: @410329
     /* 410329 */ GIM_Reject,
     /* 410330 */ // Label 8509: @410330
     /* 410330 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(410363), // Rule ID 1885 //
     /* 410335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 410341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 410344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410356 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 410361 */   GIR_RootConstrainSelectedInstOperands,
     /* 410362 */   // GIR_Coverage, 1885,
     /* 410362 */   GIR_Done,
     /* 410363 */ // Label 8538: @410363
     /* 410363 */ GIM_Reject,
     /* 410364 */ // Label 8510: @410364
     /* 410364 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(410389), // Rule ID 8904 //
     /* 410369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 410375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 410378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410382 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 410382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 410387 */   GIR_RootConstrainSelectedInstOperands,
     /* 410388 */   // GIR_Coverage, 8904,
     /* 410388 */   GIR_Done,
     /* 410389 */ // Label 8539: @410389
     /* 410389 */ GIM_Reject,
     /* 410390 */ // Label 8511: @410390
     /* 410390 */ GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(410415), // Rule ID 8866 //
     /* 410395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 410401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 410404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410408 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 410408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410413 */   GIR_RootConstrainSelectedInstOperands,
     /* 410414 */   // GIR_Coverage, 8866,
     /* 410414 */   GIR_Done,
     /* 410415 */ // Label 8540: @410415
     /* 410415 */ GIM_Reject,
     /* 410416 */ // Label 8512: @410416
     /* 410416 */ GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(410441), // Rule ID 8867 //
     /* 410421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 410427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 410430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410434 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 410434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410439 */   GIR_RootConstrainSelectedInstOperands,
     /* 410440 */   // GIR_Coverage, 8867,
     /* 410440 */   GIR_Done,
     /* 410441 */ // Label 8541: @410441
     /* 410441 */ GIM_Reject,
     /* 410442 */ // Label 8513: @410442
     /* 410442 */ GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(410488),
     /* 410447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 410450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 410453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410457 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(410472), // Rule ID 8862 //
     /* 410462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410465 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 410465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410470 */     GIR_RootConstrainSelectedInstOperands,
     /* 410471 */     // GIR_Coverage, 8862,
     /* 410471 */     GIR_Done,
     /* 410472 */   // Label 8543: @410472
     /* 410472 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(410487), // Rule ID 8868 //
     /* 410477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410480 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 410480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410485 */     GIR_RootConstrainSelectedInstOperands,
     /* 410486 */     // GIR_Coverage, 8868,
     /* 410486 */     GIR_Done,
     /* 410487 */   // Label 8544: @410487
     /* 410487 */   GIM_Reject,
     /* 410488 */ // Label 8542: @410488
     /* 410488 */ GIM_Reject,
     /* 410489 */ // Label 8514: @410489
     /* 410489 */ GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(410514), // Rule ID 8903 //
     /* 410494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 410500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 410503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410507 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 410507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 410512 */   GIR_RootConstrainSelectedInstOperands,
     /* 410513 */   // GIR_Coverage, 8903,
     /* 410513 */   GIR_Done,
     /* 410514 */ // Label 8545: @410514
     /* 410514 */ GIM_Reject,
     /* 410515 */ // Label 8515: @410515
     /* 410515 */ GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(410540), // Rule ID 8864 //
     /* 410520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 410526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 410529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410533 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 410533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 410538 */   GIR_RootConstrainSelectedInstOperands,
     /* 410539 */   // GIR_Coverage, 8864,
     /* 410539 */   GIR_Done,
     /* 410540 */ // Label 8546: @410540
     /* 410540 */ GIM_Reject,
     /* 410541 */ // Label 8516: @410541
     /* 410541 */ GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(410587),
     /* 410546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 410549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 410552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410556 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(410571), // Rule ID 8861 //
     /* 410561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410564 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 410564 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 410569 */     GIR_RootConstrainSelectedInstOperands,
     /* 410570 */     // GIR_Coverage, 8861,
     /* 410570 */     GIR_Done,
     /* 410571 */   // Label 8548: @410571
     /* 410571 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(410586), // Rule ID 8865 //
     /* 410576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410579 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 410579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 410584 */     GIR_RootConstrainSelectedInstOperands,
     /* 410585 */     // GIR_Coverage, 8865,
     /* 410585 */     GIR_Done,
     /* 410586 */   // Label 8549: @410586
     /* 410586 */   GIM_Reject,
     /* 410587 */ // Label 8547: @410587
     /* 410587 */ GIM_Reject,
     /* 410588 */ // Label 8517: @410588
     /* 410588 */ GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(410613), // Rule ID 8902 //
     /* 410593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 410599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 410602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410606 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 410606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 410611 */   GIR_RootConstrainSelectedInstOperands,
     /* 410612 */   // GIR_Coverage, 8902,
     /* 410612 */   GIR_Done,
     /* 410613 */ // Label 8550: @410613
     /* 410613 */ GIM_Reject,
     /* 410614 */ // Label 8518: @410614
     /* 410614 */ GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(410660),
     /* 410619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 410622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 410625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410629 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(410644), // Rule ID 8860 //
     /* 410634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410637 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 410637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 410642 */     GIR_RootConstrainSelectedInstOperands,
     /* 410643 */     // GIR_Coverage, 8860,
     /* 410643 */     GIR_Done,
     /* 410644 */   // Label 8552: @410644
     /* 410644 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(410659), // Rule ID 8863 //
     /* 410649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410652 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 410652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 410657 */     GIR_RootConstrainSelectedInstOperands,
     /* 410658 */     // GIR_Coverage, 8863,
     /* 410658 */     GIR_Done,
     /* 410659 */   // Label 8553: @410659
     /* 410659 */   GIM_Reject,
     /* 410660 */ // Label 8551: @410660
     /* 410660 */ GIM_Reject,
     /* 410661 */ // Label 8519: @410661
     /* 410661 */ GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(410686), // Rule ID 2406 //
     /* 410666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 410672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 410675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410679 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 410679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 410684 */   GIR_RootConstrainSelectedInstOperands,
     /* 410685 */   // GIR_Coverage, 2406,
     /* 410685 */   GIR_Done,
     /* 410686 */ // Label 8554: @410686
     /* 410686 */ GIM_Reject,
     /* 410687 */ // Label 8520: @410687
     /* 410687 */ GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(410712), // Rule ID 8859 //
     /* 410692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 410698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 410701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410705 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 410705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 410710 */   GIR_RootConstrainSelectedInstOperands,
     /* 410711 */   // GIR_Coverage, 8859,
     /* 410711 */   GIR_Done,
     /* 410712 */ // Label 8555: @410712
     /* 410712 */ GIM_Reject,
     /* 410713 */ // Label 8521: @410713
     /* 410713 */ GIM_Reject,
     /* 410714 */ // Label 152: @410714
     /* 410714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8574*/ GIMT_Encode4(411493),
     /* 410725 */ /*GILLT_v2s32*//*Label 8556*/ GIMT_Encode4(410801),
     /* 410729 */ /*GILLT_v2s64*//*Label 8557*/ GIMT_Encode4(410856),
     /* 410733 */ /*GILLT_v4s16*//*Label 8558*/ GIMT_Encode4(410911),
     /* 410737 */ /*GILLT_v4s32*//*Label 8559*/ GIMT_Encode4(410966),
     /* 410741 */ /*GILLT_v8s8*//*Label 8560*/ GIMT_Encode4(411021),
     /* 410745 */ /*GILLT_v8s16*//*Label 8561*/ GIMT_Encode4(411055),
     /* 410749 */ /*GILLT_v16s8*//*Label 8562*/ GIMT_Encode4(411110), GIMT_Encode4(0),
     /* 410757 */ /*GILLT_nxv2s1*//*Label 8563*/ GIMT_Encode4(411144),
     /* 410761 */ /*GILLT_nxv2s16*//*Label 8564*/ GIMT_Encode4(411170),
     /* 410765 */ /*GILLT_nxv2s32*//*Label 8565*/ GIMT_Encode4(411196),
     /* 410769 */ /*GILLT_nxv2s64*//*Label 8566*/ GIMT_Encode4(411222),
     /* 410773 */ /*GILLT_nxv4s1*//*Label 8567*/ GIMT_Encode4(411269),
     /* 410777 */ /*GILLT_nxv4s16*//*Label 8568*/ GIMT_Encode4(411295),
     /* 410781 */ /*GILLT_nxv4s32*//*Label 8569*/ GIMT_Encode4(411321),
     /* 410785 */ /*GILLT_nxv8s1*//*Label 8570*/ GIMT_Encode4(411368),
     /* 410789 */ /*GILLT_nxv8s16*//*Label 8571*/ GIMT_Encode4(411394),
     /* 410793 */ /*GILLT_nxv16s1*//*Label 8572*/ GIMT_Encode4(411441),
     /* 410797 */ /*GILLT_nxv16s8*//*Label 8573*/ GIMT_Encode4(411467),
     /* 410801 */ // Label 8556: @410801
     /* 410801 */ GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(410855),
     /* 410806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410824 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(410839), // Rule ID 1895 //
     /* 410829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410832 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 410837 */     GIR_RootConstrainSelectedInstOperands,
     /* 410838 */     // GIR_Coverage, 1895,
     /* 410838 */     GIR_Done,
     /* 410839 */   // Label 8576: @410839
     /* 410839 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(410854), // Rule ID 5464 //
     /* 410844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410847 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 410852 */     GIR_RootConstrainSelectedInstOperands,
     /* 410853 */     // GIR_Coverage, 5464,
     /* 410853 */     GIR_Done,
     /* 410854 */   // Label 8577: @410854
     /* 410854 */   GIM_Reject,
     /* 410855 */ // Label 8575: @410855
     /* 410855 */ GIM_Reject,
     /* 410856 */ // Label 8557: @410856
     /* 410856 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(410910),
     /* 410861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410879 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(410894), // Rule ID 1897 //
     /* 410884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410887 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 410887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 410892 */     GIR_RootConstrainSelectedInstOperands,
     /* 410893 */     // GIR_Coverage, 1897,
     /* 410893 */     GIR_Done,
     /* 410894 */   // Label 8579: @410894
     /* 410894 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(410909), // Rule ID 5466 //
     /* 410899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410902 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 410902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 410907 */     GIR_RootConstrainSelectedInstOperands,
     /* 410908 */     // GIR_Coverage, 5466,
     /* 410908 */     GIR_Done,
     /* 410909 */   // Label 8580: @410909
     /* 410909 */   GIM_Reject,
     /* 410910 */ // Label 8578: @410910
     /* 410910 */ GIM_Reject,
     /* 410911 */ // Label 8558: @410911
     /* 410911 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(410965),
     /* 410916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 410922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410934 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(410949), // Rule ID 1893 //
     /* 410939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410942 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410942 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 410947 */     GIR_RootConstrainSelectedInstOperands,
     /* 410948 */     // GIR_Coverage, 1893,
     /* 410948 */     GIR_Done,
     /* 410949 */   // Label 8582: @410949
     /* 410949 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(410964), // Rule ID 5462 //
     /* 410954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410957 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 410957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 410962 */     GIR_RootConstrainSelectedInstOperands,
     /* 410963 */     // GIR_Coverage, 5462,
     /* 410963 */     GIR_Done,
     /* 410964 */   // Label 8583: @410964
     /* 410964 */   GIM_Reject,
     /* 410965 */ // Label 8581: @410965
     /* 410965 */ GIM_Reject,
     /* 410966 */ // Label 8559: @410966
     /* 410966 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(411020),
     /* 410971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 410977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410989 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(411004), // Rule ID 1896 //
     /* 410994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410997 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 410997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 411002 */     GIR_RootConstrainSelectedInstOperands,
     /* 411003 */     // GIR_Coverage, 1896,
     /* 411003 */     GIR_Done,
     /* 411004 */   // Label 8585: @411004
     /* 411004 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(411019), // Rule ID 5465 //
     /* 411009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411012 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 411012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 411017 */     GIR_RootConstrainSelectedInstOperands,
     /* 411018 */     // GIR_Coverage, 5465,
     /* 411018 */     GIR_Done,
     /* 411019 */   // Label 8586: @411019
     /* 411019 */   GIM_Reject,
     /* 411020 */ // Label 8584: @411020
     /* 411020 */ GIM_Reject,
     /* 411021 */ // Label 8560: @411021
     /* 411021 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(411054), // Rule ID 1891 //
     /* 411026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 411035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411047 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 411047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 411052 */   GIR_RootConstrainSelectedInstOperands,
     /* 411053 */   // GIR_Coverage, 1891,
     /* 411053 */   GIR_Done,
     /* 411054 */ // Label 8587: @411054
     /* 411054 */ GIM_Reject,
     /* 411055 */ // Label 8561: @411055
     /* 411055 */ GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(411109),
     /* 411060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 411066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411078 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(411093), // Rule ID 1894 //
     /* 411083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411086 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 411086 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 411091 */     GIR_RootConstrainSelectedInstOperands,
     /* 411092 */     // GIR_Coverage, 1894,
     /* 411092 */     GIR_Done,
     /* 411093 */   // Label 8589: @411093
     /* 411093 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(411108), // Rule ID 5463 //
     /* 411098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411101 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 411101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 411106 */     GIR_RootConstrainSelectedInstOperands,
     /* 411107 */     // GIR_Coverage, 5463,
     /* 411107 */     GIR_Done,
     /* 411108 */   // Label 8590: @411108
     /* 411108 */   GIM_Reject,
     /* 411109 */ // Label 8588: @411109
     /* 411109 */ GIM_Reject,
     /* 411110 */ // Label 8562: @411110
     /* 411110 */ GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(411143), // Rule ID 1892 //
     /* 411115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 411124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411136 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 411136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 411141 */   GIR_RootConstrainSelectedInstOperands,
     /* 411142 */   // GIR_Coverage, 1892,
     /* 411142 */   GIR_Done,
     /* 411143 */ // Label 8591: @411143
     /* 411143 */ GIM_Reject,
     /* 411144 */ // Label 8563: @411144
     /* 411144 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(411169), // Rule ID 8907 //
     /* 411149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 411155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 411158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411162 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 411162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 411167 */   GIR_RootConstrainSelectedInstOperands,
     /* 411168 */   // GIR_Coverage, 8907,
     /* 411168 */   GIR_Done,
     /* 411169 */ // Label 8592: @411169
     /* 411169 */ GIM_Reject,
     /* 411170 */ // Label 8564: @411170
     /* 411170 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(411195), // Rule ID 8876 //
     /* 411175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 411181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 411184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411188 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 411188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411193 */   GIR_RootConstrainSelectedInstOperands,
     /* 411194 */   // GIR_Coverage, 8876,
     /* 411194 */   GIR_Done,
     /* 411195 */ // Label 8593: @411195
     /* 411195 */ GIM_Reject,
     /* 411196 */ // Label 8565: @411196
     /* 411196 */ GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(411221), // Rule ID 8877 //
     /* 411201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 411207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 411210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411214 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 411214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411219 */   GIR_RootConstrainSelectedInstOperands,
     /* 411220 */   // GIR_Coverage, 8877,
     /* 411220 */   GIR_Done,
     /* 411221 */ // Label 8594: @411221
     /* 411221 */ GIM_Reject,
     /* 411222 */ // Label 8566: @411222
     /* 411222 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(411268),
     /* 411227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 411230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 411233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411237 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(411252), // Rule ID 8872 //
     /* 411242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411245 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 411245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411250 */     GIR_RootConstrainSelectedInstOperands,
     /* 411251 */     // GIR_Coverage, 8872,
     /* 411251 */     GIR_Done,
     /* 411252 */   // Label 8596: @411252
     /* 411252 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(411267), // Rule ID 8878 //
     /* 411257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411260 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 411260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411265 */     GIR_RootConstrainSelectedInstOperands,
     /* 411266 */     // GIR_Coverage, 8878,
     /* 411266 */     GIR_Done,
     /* 411267 */   // Label 8597: @411267
     /* 411267 */   GIM_Reject,
     /* 411268 */ // Label 8595: @411268
     /* 411268 */ GIM_Reject,
     /* 411269 */ // Label 8567: @411269
     /* 411269 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(411294), // Rule ID 8906 //
     /* 411274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 411280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 411283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411287 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 411287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 411292 */   GIR_RootConstrainSelectedInstOperands,
     /* 411293 */   // GIR_Coverage, 8906,
     /* 411293 */   GIR_Done,
     /* 411294 */ // Label 8598: @411294
     /* 411294 */ GIM_Reject,
     /* 411295 */ // Label 8568: @411295
     /* 411295 */ GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(411320), // Rule ID 8874 //
     /* 411300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 411306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 411309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411313 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 411313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411318 */   GIR_RootConstrainSelectedInstOperands,
     /* 411319 */   // GIR_Coverage, 8874,
     /* 411319 */   GIR_Done,
     /* 411320 */ // Label 8599: @411320
     /* 411320 */ GIM_Reject,
     /* 411321 */ // Label 8569: @411321
     /* 411321 */ GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(411367),
     /* 411326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 411332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411336 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(411351), // Rule ID 8871 //
     /* 411341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411344 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 411344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411349 */     GIR_RootConstrainSelectedInstOperands,
     /* 411350 */     // GIR_Coverage, 8871,
     /* 411350 */     GIR_Done,
     /* 411351 */   // Label 8601: @411351
     /* 411351 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(411366), // Rule ID 8875 //
     /* 411356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411359 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 411359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411364 */     GIR_RootConstrainSelectedInstOperands,
     /* 411365 */     // GIR_Coverage, 8875,
     /* 411365 */     GIR_Done,
     /* 411366 */   // Label 8602: @411366
     /* 411366 */   GIM_Reject,
     /* 411367 */ // Label 8600: @411367
     /* 411367 */ GIM_Reject,
     /* 411368 */ // Label 8570: @411368
     /* 411368 */ GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(411393), // Rule ID 8905 //
     /* 411373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 411379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 411382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411386 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 411391 */   GIR_RootConstrainSelectedInstOperands,
     /* 411392 */   // GIR_Coverage, 8905,
     /* 411392 */   GIR_Done,
     /* 411393 */ // Label 8603: @411393
     /* 411393 */ GIM_Reject,
     /* 411394 */ // Label 8571: @411394
     /* 411394 */ GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(411440),
     /* 411399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411409 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(411424), // Rule ID 8870 //
     /* 411414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411417 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 411422 */     GIR_RootConstrainSelectedInstOperands,
     /* 411423 */     // GIR_Coverage, 8870,
     /* 411423 */     GIR_Done,
     /* 411424 */   // Label 8605: @411424
     /* 411424 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(411439), // Rule ID 8873 //
     /* 411429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411432 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 411437 */     GIR_RootConstrainSelectedInstOperands,
     /* 411438 */     // GIR_Coverage, 8873,
     /* 411438 */     GIR_Done,
     /* 411439 */   // Label 8606: @411439
     /* 411439 */   GIM_Reject,
     /* 411440 */ // Label 8604: @411440
     /* 411440 */ GIM_Reject,
     /* 411441 */ // Label 8572: @411441
     /* 411441 */ GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(411466), // Rule ID 2410 //
     /* 411446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411459 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 411464 */   GIR_RootConstrainSelectedInstOperands,
     /* 411465 */   // GIR_Coverage, 2410,
     /* 411465 */   GIR_Done,
     /* 411466 */ // Label 8607: @411466
     /* 411466 */ GIM_Reject,
     /* 411467 */ // Label 8573: @411467
     /* 411467 */ GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(411492), // Rule ID 8869 //
     /* 411472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411485 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 411490 */   GIR_RootConstrainSelectedInstOperands,
     /* 411491 */   // GIR_Coverage, 8869,
     /* 411491 */   GIR_Done,
     /* 411492 */ // Label 8608: @411492
     /* 411492 */ GIM_Reject,
     /* 411493 */ // Label 8574: @411493
     /* 411493 */ GIM_Reject,
     /* 411494 */ // Label 153: @411494
     /* 411494 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8617*/ GIMT_Encode4(412191),
     /* 411505 */ /*GILLT_s64*//*Label 8609*/ GIMT_Encode4(411541), GIMT_Encode4(0),
     /* 411513 */ /*GILLT_v2s32*//*Label 8610*/ GIMT_Encode4(411652),
     /* 411517 */ /*GILLT_v2s64*//*Label 8611*/ GIMT_Encode4(411729),
     /* 411521 */ /*GILLT_v4s16*//*Label 8612*/ GIMT_Encode4(411806),
     /* 411525 */ /*GILLT_v4s32*//*Label 8613*/ GIMT_Encode4(411883),
     /* 411529 */ /*GILLT_v8s8*//*Label 8614*/ GIMT_Encode4(411960),
     /* 411533 */ /*GILLT_v8s16*//*Label 8615*/ GIMT_Encode4(412037),
     /* 411537 */ /*GILLT_v16s8*//*Label 8616*/ GIMT_Encode4(412114),
     /* 411541 */ // Label 8609: @411541
     /* 411541 */ GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(411651),
     /* 411546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 411549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411557 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(411582), // Rule ID 5236 //
     /* 411562 */     // MIs[0] Operand 2
     /* 411562 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 411573 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 411573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 411576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411580 */     GIR_RootConstrainSelectedInstOperands,
     /* 411581 */     // GIR_Coverage, 5236,
     /* 411581 */     GIR_EraseRootFromParent_Done,
     /* 411582 */   // Label 8619: @411582
     /* 411582 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(411616), // Rule ID 2120 //
     /* 411587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411590 */     // MIs[0] imm
     /* 411590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411602 */     // MIs[1] Operand 1
     /* 411602 */     // No operand predicates
     /* 411602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411604 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 411607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411614 */     GIR_RootConstrainSelectedInstOperands,
     /* 411615 */     // GIR_Coverage, 2120,
     /* 411615 */     GIR_EraseRootFromParent_Done,
     /* 411616 */   // Label 8620: @411616
     /* 411616 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(411650), // Rule ID 6260 //
     /* 411621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411624 */     // MIs[0] imm
     /* 411624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411636 */     // MIs[1] Operand 1
     /* 411636 */     // No operand predicates
     /* 411636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411638 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 411638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 411641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411648 */     GIR_RootConstrainSelectedInstOperands,
     /* 411649 */     // GIR_Coverage, 6260,
     /* 411649 */     GIR_EraseRootFromParent_Done,
     /* 411650 */   // Label 8621: @411650
     /* 411650 */   GIM_Reject,
     /* 411651 */ // Label 8618: @411651
     /* 411651 */ GIM_Reject,
     /* 411652 */ // Label 8610: @411652
     /* 411652 */ GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(411728),
     /* 411657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411668 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(411693), // Rule ID 4880 //
     /* 411673 */     // MIs[0] Operand 2
     /* 411673 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 411684 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 411684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 411687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411691 */     GIR_RootConstrainSelectedInstOperands,
     /* 411692 */     // GIR_Coverage, 4880,
     /* 411692 */     GIR_EraseRootFromParent_Done,
     /* 411693 */   // Label 8623: @411693
     /* 411693 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(411727), // Rule ID 2227 //
     /* 411698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411701 */     // MIs[0] imm
     /* 411701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 411713 */     // MIs[1] Operand 1
     /* 411713 */     // No operand predicates
     /* 411713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411715 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 411718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411725 */     GIR_RootConstrainSelectedInstOperands,
     /* 411726 */     // GIR_Coverage, 2227,
     /* 411726 */     GIR_EraseRootFromParent_Done,
     /* 411727 */   // Label 8624: @411727
     /* 411727 */   GIM_Reject,
     /* 411728 */ // Label 8622: @411728
     /* 411728 */ GIM_Reject,
     /* 411729 */ // Label 8611: @411729
     /* 411729 */ GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(411805),
     /* 411734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411745 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(411770), // Rule ID 4884 //
     /* 411750 */     // MIs[0] Operand 2
     /* 411750 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 411761 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 411761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 411764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411768 */     GIR_RootConstrainSelectedInstOperands,
     /* 411769 */     // GIR_Coverage, 4884,
     /* 411769 */     GIR_EraseRootFromParent_Done,
     /* 411770 */   // Label 8626: @411770
     /* 411770 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(411804), // Rule ID 2229 //
     /* 411775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411778 */     // MIs[0] imm
     /* 411778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 411790 */     // MIs[1] Operand 1
     /* 411790 */     // No operand predicates
     /* 411790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411792 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 411795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411802 */     GIR_RootConstrainSelectedInstOperands,
     /* 411803 */     // GIR_Coverage, 2229,
     /* 411803 */     GIR_EraseRootFromParent_Done,
     /* 411804 */   // Label 8627: @411804
     /* 411804 */   GIM_Reject,
     /* 411805 */ // Label 8625: @411805
     /* 411805 */ GIM_Reject,
     /* 411806 */ // Label 8612: @411806
     /* 411806 */ GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(411882),
     /* 411811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411822 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(411847), // Rule ID 4879 //
     /* 411827 */     // MIs[0] Operand 2
     /* 411827 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 411838 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 411838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 411841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411845 */     GIR_RootConstrainSelectedInstOperands,
     /* 411846 */     // GIR_Coverage, 4879,
     /* 411846 */     GIR_EraseRootFromParent_Done,
     /* 411847 */   // Label 8629: @411847
     /* 411847 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(411881), // Rule ID 2225 //
     /* 411852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411855 */     // MIs[0] imm
     /* 411855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 411867 */     // MIs[1] Operand 1
     /* 411867 */     // No operand predicates
     /* 411867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411869 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 411872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411879 */     GIR_RootConstrainSelectedInstOperands,
     /* 411880 */     // GIR_Coverage, 2225,
     /* 411880 */     GIR_EraseRootFromParent_Done,
     /* 411881 */   // Label 8630: @411881
     /* 411881 */   GIM_Reject,
     /* 411882 */ // Label 8628: @411882
     /* 411882 */ GIM_Reject,
     /* 411883 */ // Label 8613: @411883
     /* 411883 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(411959),
     /* 411888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411899 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(411924), // Rule ID 4883 //
     /* 411904 */     // MIs[0] Operand 2
     /* 411904 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 411915 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 411915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 411918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411922 */     GIR_RootConstrainSelectedInstOperands,
     /* 411923 */     // GIR_Coverage, 4883,
     /* 411923 */     GIR_EraseRootFromParent_Done,
     /* 411924 */   // Label 8632: @411924
     /* 411924 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(411958), // Rule ID 2228 //
     /* 411929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411932 */     // MIs[0] imm
     /* 411932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 411944 */     // MIs[1] Operand 1
     /* 411944 */     // No operand predicates
     /* 411944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411946 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 411946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 411949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 411956 */     GIR_RootConstrainSelectedInstOperands,
     /* 411957 */     // GIR_Coverage, 2228,
     /* 411957 */     GIR_EraseRootFromParent_Done,
     /* 411958 */   // Label 8633: @411958
     /* 411958 */   GIM_Reject,
     /* 411959 */ // Label 8631: @411959
     /* 411959 */ GIM_Reject,
     /* 411960 */ // Label 8614: @411960
     /* 411960 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(412036),
     /* 411965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411976 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(412001), // Rule ID 4878 //
     /* 411981 */     // MIs[0] Operand 2
     /* 411981 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 411992 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 411992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 411995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 411997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411999 */     GIR_RootConstrainSelectedInstOperands,
     /* 412000 */     // GIR_Coverage, 4878,
     /* 412000 */     GIR_EraseRootFromParent_Done,
     /* 412001 */   // Label 8635: @412001
     /* 412001 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(412035), // Rule ID 2223 //
     /* 412006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412009 */     // MIs[0] imm
     /* 412009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412021 */     // MIs[1] Operand 1
     /* 412021 */     // No operand predicates
     /* 412021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412023 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 412026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412033 */     GIR_RootConstrainSelectedInstOperands,
     /* 412034 */     // GIR_Coverage, 2223,
     /* 412034 */     GIR_EraseRootFromParent_Done,
     /* 412035 */   // Label 8636: @412035
     /* 412035 */   GIM_Reject,
     /* 412036 */ // Label 8634: @412036
     /* 412036 */ GIM_Reject,
     /* 412037 */ // Label 8615: @412037
     /* 412037 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(412113),
     /* 412042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412053 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(412078), // Rule ID 4882 //
     /* 412058 */     // MIs[0] Operand 2
     /* 412058 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 412069 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 412069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 412072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412076 */     GIR_RootConstrainSelectedInstOperands,
     /* 412077 */     // GIR_Coverage, 4882,
     /* 412077 */     GIR_EraseRootFromParent_Done,
     /* 412078 */   // Label 8638: @412078
     /* 412078 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(412112), // Rule ID 2226 //
     /* 412083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412086 */     // MIs[0] imm
     /* 412086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412098 */     // MIs[1] Operand 1
     /* 412098 */     // No operand predicates
     /* 412098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412100 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 412103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412110 */     GIR_RootConstrainSelectedInstOperands,
     /* 412111 */     // GIR_Coverage, 2226,
     /* 412111 */     GIR_EraseRootFromParent_Done,
     /* 412112 */   // Label 8639: @412112
     /* 412112 */   GIM_Reject,
     /* 412113 */ // Label 8637: @412113
     /* 412113 */ GIM_Reject,
     /* 412114 */ // Label 8616: @412114
     /* 412114 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(412190),
     /* 412119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412130 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(412155), // Rule ID 4881 //
     /* 412135 */     // MIs[0] Operand 2
     /* 412135 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 412146 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 412146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 412149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412153 */     GIR_RootConstrainSelectedInstOperands,
     /* 412154 */     // GIR_Coverage, 4881,
     /* 412154 */     GIR_EraseRootFromParent_Done,
     /* 412155 */   // Label 8641: @412155
     /* 412155 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(412189), // Rule ID 2224 //
     /* 412160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412163 */     // MIs[0] imm
     /* 412163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412175 */     // MIs[1] Operand 1
     /* 412175 */     // No operand predicates
     /* 412175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412177 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 412180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412187 */     GIR_RootConstrainSelectedInstOperands,
     /* 412188 */     // GIR_Coverage, 2224,
     /* 412188 */     GIR_EraseRootFromParent_Done,
     /* 412189 */   // Label 8642: @412189
     /* 412189 */   GIM_Reject,
     /* 412190 */ // Label 8640: @412190
     /* 412190 */ GIM_Reject,
     /* 412191 */ // Label 8617: @412191
     /* 412191 */ GIM_Reject,
     /* 412192 */ // Label 154: @412192
     /* 412192 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8651*/ GIMT_Encode4(412647),
     /* 412203 */ /*GILLT_s64*//*Label 8643*/ GIMT_Encode4(412239), GIMT_Encode4(0),
     /* 412211 */ /*GILLT_v2s32*//*Label 8644*/ GIMT_Encode4(412325),
     /* 412215 */ /*GILLT_v2s64*//*Label 8645*/ GIMT_Encode4(412371),
     /* 412219 */ /*GILLT_v4s16*//*Label 8646*/ GIMT_Encode4(412417),
     /* 412223 */ /*GILLT_v4s32*//*Label 8647*/ GIMT_Encode4(412463),
     /* 412227 */ /*GILLT_v8s8*//*Label 8648*/ GIMT_Encode4(412509),
     /* 412231 */ /*GILLT_v8s16*//*Label 8649*/ GIMT_Encode4(412555),
     /* 412235 */ /*GILLT_v16s8*//*Label 8650*/ GIMT_Encode4(412601),
     /* 412239 */ // Label 8643: @412239
     /* 412239 */ GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(412324),
     /* 412244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 412247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412255 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(412289), // Rule ID 2129 //
     /* 412260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412263 */     // MIs[0] imm
     /* 412263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412275 */     // MIs[1] Operand 1
     /* 412275 */     // No operand predicates
     /* 412275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412277 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 412280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412287 */     GIR_RootConstrainSelectedInstOperands,
     /* 412288 */     // GIR_Coverage, 2129,
     /* 412288 */     GIR_EraseRootFromParent_Done,
     /* 412289 */   // Label 8653: @412289
     /* 412289 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(412323), // Rule ID 6263 //
     /* 412294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412297 */     // MIs[0] imm
     /* 412297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412309 */     // MIs[1] Operand 1
     /* 412309 */     // No operand predicates
     /* 412309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412311 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 412311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 412314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412321 */     GIR_RootConstrainSelectedInstOperands,
     /* 412322 */     // GIR_Coverage, 6263,
     /* 412322 */     GIR_EraseRootFromParent_Done,
     /* 412323 */   // Label 8654: @412323
     /* 412323 */   GIM_Reject,
     /* 412324 */ // Label 8652: @412324
     /* 412324 */ GIM_Reject,
     /* 412325 */ // Label 8644: @412325
     /* 412325 */ GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(412370), // Rule ID 2286 //
     /* 412330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412344 */   // MIs[0] imm
     /* 412344 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412348 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412352 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412356 */   // MIs[1] Operand 1
     /* 412356 */   // No operand predicates
     /* 412356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412358 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 412361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412363 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412365 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412368 */   GIR_RootConstrainSelectedInstOperands,
     /* 412369 */   // GIR_Coverage, 2286,
     /* 412369 */   GIR_EraseRootFromParent_Done,
     /* 412370 */ // Label 8655: @412370
     /* 412370 */ GIM_Reject,
     /* 412371 */ // Label 8645: @412371
     /* 412371 */ GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(412416), // Rule ID 2288 //
     /* 412376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412390 */   // MIs[0] imm
     /* 412390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412398 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412402 */   // MIs[1] Operand 1
     /* 412402 */   // No operand predicates
     /* 412402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412404 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 412407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412409 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412411 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412414 */   GIR_RootConstrainSelectedInstOperands,
     /* 412415 */   // GIR_Coverage, 2288,
     /* 412415 */   GIR_EraseRootFromParent_Done,
     /* 412416 */ // Label 8656: @412416
     /* 412416 */ GIM_Reject,
     /* 412417 */ // Label 8646: @412417
     /* 412417 */ GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(412462), // Rule ID 2284 //
     /* 412422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412436 */   // MIs[0] imm
     /* 412436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412444 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412448 */   // MIs[1] Operand 1
     /* 412448 */   // No operand predicates
     /* 412448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412450 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 412453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412455 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412457 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412460 */   GIR_RootConstrainSelectedInstOperands,
     /* 412461 */   // GIR_Coverage, 2284,
     /* 412461 */   GIR_EraseRootFromParent_Done,
     /* 412462 */ // Label 8657: @412462
     /* 412462 */ GIM_Reject,
     /* 412463 */ // Label 8647: @412463
     /* 412463 */ GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(412508), // Rule ID 2287 //
     /* 412468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412482 */   // MIs[0] imm
     /* 412482 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412486 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412490 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412494 */   // MIs[1] Operand 1
     /* 412494 */   // No operand predicates
     /* 412494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412496 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 412499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412501 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412503 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412506 */   GIR_RootConstrainSelectedInstOperands,
     /* 412507 */   // GIR_Coverage, 2287,
     /* 412507 */   GIR_EraseRootFromParent_Done,
     /* 412508 */ // Label 8658: @412508
     /* 412508 */ GIM_Reject,
     /* 412509 */ // Label 8648: @412509
     /* 412509 */ GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(412554), // Rule ID 2282 //
     /* 412514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412528 */   // MIs[0] imm
     /* 412528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412536 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412540 */   // MIs[1] Operand 1
     /* 412540 */   // No operand predicates
     /* 412540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412542 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 412545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412547 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412549 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412552 */   GIR_RootConstrainSelectedInstOperands,
     /* 412553 */   // GIR_Coverage, 2282,
     /* 412553 */   GIR_EraseRootFromParent_Done,
     /* 412554 */ // Label 8659: @412554
     /* 412554 */ GIM_Reject,
     /* 412555 */ // Label 8649: @412555
     /* 412555 */ GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(412600), // Rule ID 2285 //
     /* 412560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412574 */   // MIs[0] imm
     /* 412574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412582 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412586 */   // MIs[1] Operand 1
     /* 412586 */   // No operand predicates
     /* 412586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412588 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 412591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412593 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412595 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412598 */   GIR_RootConstrainSelectedInstOperands,
     /* 412599 */   // GIR_Coverage, 2285,
     /* 412599 */   GIR_EraseRootFromParent_Done,
     /* 412600 */ // Label 8660: @412600
     /* 412600 */ GIM_Reject,
     /* 412601 */ // Label 8650: @412601
     /* 412601 */ GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(412646), // Rule ID 2283 //
     /* 412606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412620 */   // MIs[0] imm
     /* 412620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412628 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412632 */   // MIs[1] Operand 1
     /* 412632 */   // No operand predicates
     /* 412632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412634 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 412637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412639 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412641 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412644 */   GIR_RootConstrainSelectedInstOperands,
     /* 412645 */   // GIR_Coverage, 2283,
     /* 412645 */   GIR_EraseRootFromParent_Done,
     /* 412646 */ // Label 8661: @412646
     /* 412646 */ GIM_Reject,
     /* 412647 */ // Label 8651: @412647
     /* 412647 */ GIM_Reject,
     /* 412648 */ // Label 155: @412648
     /* 412648 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8680*/ GIMT_Encode4(413427),
     /* 412659 */ /*GILLT_v2s32*//*Label 8662*/ GIMT_Encode4(412735),
     /* 412663 */ /*GILLT_v2s64*//*Label 8663*/ GIMT_Encode4(412790),
     /* 412667 */ /*GILLT_v4s16*//*Label 8664*/ GIMT_Encode4(412845),
     /* 412671 */ /*GILLT_v4s32*//*Label 8665*/ GIMT_Encode4(412900),
     /* 412675 */ /*GILLT_v8s8*//*Label 8666*/ GIMT_Encode4(412955),
     /* 412679 */ /*GILLT_v8s16*//*Label 8667*/ GIMT_Encode4(412989),
     /* 412683 */ /*GILLT_v16s8*//*Label 8668*/ GIMT_Encode4(413044), GIMT_Encode4(0),
     /* 412691 */ /*GILLT_nxv2s1*//*Label 8669*/ GIMT_Encode4(413078),
     /* 412695 */ /*GILLT_nxv2s16*//*Label 8670*/ GIMT_Encode4(413104),
     /* 412699 */ /*GILLT_nxv2s32*//*Label 8671*/ GIMT_Encode4(413130),
     /* 412703 */ /*GILLT_nxv2s64*//*Label 8672*/ GIMT_Encode4(413156),
     /* 412707 */ /*GILLT_nxv4s1*//*Label 8673*/ GIMT_Encode4(413203),
     /* 412711 */ /*GILLT_nxv4s16*//*Label 8674*/ GIMT_Encode4(413229),
     /* 412715 */ /*GILLT_nxv4s32*//*Label 8675*/ GIMT_Encode4(413255),
     /* 412719 */ /*GILLT_nxv8s1*//*Label 8676*/ GIMT_Encode4(413302),
     /* 412723 */ /*GILLT_nxv8s16*//*Label 8677*/ GIMT_Encode4(413328),
     /* 412727 */ /*GILLT_nxv16s1*//*Label 8678*/ GIMT_Encode4(413375),
     /* 412731 */ /*GILLT_nxv16s8*//*Label 8679*/ GIMT_Encode4(413401),
     /* 412735 */ // Label 8662: @412735
     /* 412735 */ GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(412789),
     /* 412740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 412746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412758 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(412773), // Rule ID 1902 //
     /* 412763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412766 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 412766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 412771 */     GIR_RootConstrainSelectedInstOperands,
     /* 412772 */     // GIR_Coverage, 1902,
     /* 412772 */     GIR_Done,
     /* 412773 */   // Label 8682: @412773
     /* 412773 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(412788), // Rule ID 5469 //
     /* 412778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412781 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 412781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 412786 */     GIR_RootConstrainSelectedInstOperands,
     /* 412787 */     // GIR_Coverage, 5469,
     /* 412787 */     GIR_Done,
     /* 412788 */   // Label 8683: @412788
     /* 412788 */   GIM_Reject,
     /* 412789 */ // Label 8681: @412789
     /* 412789 */ GIM_Reject,
     /* 412790 */ // Label 8663: @412790
     /* 412790 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(412844),
     /* 412795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 412801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412813 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(412828), // Rule ID 1904 //
     /* 412818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412821 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 412821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 412826 */     GIR_RootConstrainSelectedInstOperands,
     /* 412827 */     // GIR_Coverage, 1904,
     /* 412827 */     GIR_Done,
     /* 412828 */   // Label 8685: @412828
     /* 412828 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(412843), // Rule ID 5471 //
     /* 412833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412836 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 412841 */     GIR_RootConstrainSelectedInstOperands,
     /* 412842 */     // GIR_Coverage, 5471,
     /* 412842 */     GIR_Done,
     /* 412843 */   // Label 8686: @412843
     /* 412843 */   GIM_Reject,
     /* 412844 */ // Label 8684: @412844
     /* 412844 */ GIM_Reject,
     /* 412845 */ // Label 8664: @412845
     /* 412845 */ GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(412899),
     /* 412850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 412856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412868 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(412883), // Rule ID 1900 //
     /* 412873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412876 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 412876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 412881 */     GIR_RootConstrainSelectedInstOperands,
     /* 412882 */     // GIR_Coverage, 1900,
     /* 412882 */     GIR_Done,
     /* 412883 */   // Label 8688: @412883
     /* 412883 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(412898), // Rule ID 5467 //
     /* 412888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412891 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 412891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 412896 */     GIR_RootConstrainSelectedInstOperands,
     /* 412897 */     // GIR_Coverage, 5467,
     /* 412897 */     GIR_Done,
     /* 412898 */   // Label 8689: @412898
     /* 412898 */   GIM_Reject,
     /* 412899 */ // Label 8687: @412899
     /* 412899 */ GIM_Reject,
     /* 412900 */ // Label 8665: @412900
     /* 412900 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(412954),
     /* 412905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 412911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412923 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(412938), // Rule ID 1903 //
     /* 412928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412931 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 412931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 412936 */     GIR_RootConstrainSelectedInstOperands,
     /* 412937 */     // GIR_Coverage, 1903,
     /* 412937 */     GIR_Done,
     /* 412938 */   // Label 8691: @412938
     /* 412938 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(412953), // Rule ID 5470 //
     /* 412943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412946 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 412946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 412951 */     GIR_RootConstrainSelectedInstOperands,
     /* 412952 */     // GIR_Coverage, 5470,
     /* 412952 */     GIR_Done,
     /* 412953 */   // Label 8692: @412953
     /* 412953 */   GIM_Reject,
     /* 412954 */ // Label 8690: @412954
     /* 412954 */ GIM_Reject,
     /* 412955 */ // Label 8666: @412955
     /* 412955 */ GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(412988), // Rule ID 1898 //
     /* 412960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 412969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412981 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 412981 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 412986 */   GIR_RootConstrainSelectedInstOperands,
     /* 412987 */   // GIR_Coverage, 1898,
     /* 412987 */   GIR_Done,
     /* 412988 */ // Label 8693: @412988
     /* 412988 */ GIM_Reject,
     /* 412989 */ // Label 8667: @412989
     /* 412989 */ GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(413043),
     /* 412994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 413000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413012 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(413027), // Rule ID 1901 //
     /* 413017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413020 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 413020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 413025 */     GIR_RootConstrainSelectedInstOperands,
     /* 413026 */     // GIR_Coverage, 1901,
     /* 413026 */     GIR_Done,
     /* 413027 */   // Label 8695: @413027
     /* 413027 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(413042), // Rule ID 5468 //
     /* 413032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413035 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 413035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 413040 */     GIR_RootConstrainSelectedInstOperands,
     /* 413041 */     // GIR_Coverage, 5468,
     /* 413041 */     GIR_Done,
     /* 413042 */   // Label 8696: @413042
     /* 413042 */   GIM_Reject,
     /* 413043 */ // Label 8694: @413043
     /* 413043 */ GIM_Reject,
     /* 413044 */ // Label 8668: @413044
     /* 413044 */ GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(413077), // Rule ID 1899 //
     /* 413049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413070 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 413075 */   GIR_RootConstrainSelectedInstOperands,
     /* 413076 */   // GIR_Coverage, 1899,
     /* 413076 */   GIR_Done,
     /* 413077 */ // Label 8697: @413077
     /* 413077 */ GIM_Reject,
     /* 413078 */ // Label 8669: @413078
     /* 413078 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(413103), // Rule ID 3348 //
     /* 413083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 413089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 413092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413096 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 413096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 413101 */   GIR_RootConstrainSelectedInstOperands,
     /* 413102 */   // GIR_Coverage, 3348,
     /* 413102 */   GIR_Done,
     /* 413103 */ // Label 8698: @413103
     /* 413103 */ GIM_Reject,
     /* 413104 */ // Label 8670: @413104
     /* 413104 */ GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(413129), // Rule ID 2879 //
     /* 413109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 413115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 413118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413122 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 413122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413127 */   GIR_RootConstrainSelectedInstOperands,
     /* 413128 */   // GIR_Coverage, 2879,
     /* 413128 */   GIR_Done,
     /* 413129 */ // Label 8699: @413129
     /* 413129 */ GIM_Reject,
     /* 413130 */ // Label 8671: @413130
     /* 413130 */ GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(413155), // Rule ID 2880 //
     /* 413135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 413141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 413144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413148 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 413148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413153 */   GIR_RootConstrainSelectedInstOperands,
     /* 413154 */   // GIR_Coverage, 2880,
     /* 413154 */   GIR_Done,
     /* 413155 */ // Label 8700: @413155
     /* 413155 */ GIM_Reject,
     /* 413156 */ // Label 8672: @413156
     /* 413156 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(413202),
     /* 413161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 413164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 413167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413171 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(413186), // Rule ID 2875 //
     /* 413176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413179 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 413179 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413184 */     GIR_RootConstrainSelectedInstOperands,
     /* 413185 */     // GIR_Coverage, 2875,
     /* 413185 */     GIR_Done,
     /* 413186 */   // Label 8702: @413186
     /* 413186 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(413201), // Rule ID 2881 //
     /* 413191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413194 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 413194 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413199 */     GIR_RootConstrainSelectedInstOperands,
     /* 413200 */     // GIR_Coverage, 2881,
     /* 413200 */     GIR_Done,
     /* 413201 */   // Label 8703: @413201
     /* 413201 */   GIM_Reject,
     /* 413202 */ // Label 8701: @413202
     /* 413202 */ GIM_Reject,
     /* 413203 */ // Label 8673: @413203
     /* 413203 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(413228), // Rule ID 3347 //
     /* 413208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 413214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 413217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413221 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 413221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 413226 */   GIR_RootConstrainSelectedInstOperands,
     /* 413227 */   // GIR_Coverage, 3347,
     /* 413227 */   GIR_Done,
     /* 413228 */ // Label 8704: @413228
     /* 413228 */ GIM_Reject,
     /* 413229 */ // Label 8674: @413229
     /* 413229 */ GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(413254), // Rule ID 2877 //
     /* 413234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 413240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 413243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413247 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 413247 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 413252 */   GIR_RootConstrainSelectedInstOperands,
     /* 413253 */   // GIR_Coverage, 2877,
     /* 413253 */   GIR_Done,
     /* 413254 */ // Label 8705: @413254
     /* 413254 */ GIM_Reject,
     /* 413255 */ // Label 8675: @413255
     /* 413255 */ GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(413301),
     /* 413260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 413263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 413266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413270 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(413285), // Rule ID 2874 //
     /* 413275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413278 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 413278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 413283 */     GIR_RootConstrainSelectedInstOperands,
     /* 413284 */     // GIR_Coverage, 2874,
     /* 413284 */     GIR_Done,
     /* 413285 */   // Label 8707: @413285
     /* 413285 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(413300), // Rule ID 2878 //
     /* 413290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413293 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 413293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 413298 */     GIR_RootConstrainSelectedInstOperands,
     /* 413299 */     // GIR_Coverage, 2878,
     /* 413299 */     GIR_Done,
     /* 413300 */   // Label 8708: @413300
     /* 413300 */   GIM_Reject,
     /* 413301 */ // Label 8706: @413301
     /* 413301 */ GIM_Reject,
     /* 413302 */ // Label 8676: @413302
     /* 413302 */ GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(413327), // Rule ID 3346 //
     /* 413307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 413313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 413316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413320 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 413320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 413325 */   GIR_RootConstrainSelectedInstOperands,
     /* 413326 */   // GIR_Coverage, 3346,
     /* 413326 */   GIR_Done,
     /* 413327 */ // Label 8709: @413327
     /* 413327 */ GIM_Reject,
     /* 413328 */ // Label 8677: @413328
     /* 413328 */ GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(413374),
     /* 413333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 413336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 413339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413343 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(413358), // Rule ID 2873 //
     /* 413348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413351 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 413351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 413356 */     GIR_RootConstrainSelectedInstOperands,
     /* 413357 */     // GIR_Coverage, 2873,
     /* 413357 */     GIR_Done,
     /* 413358 */   // Label 8711: @413358
     /* 413358 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(413373), // Rule ID 2876 //
     /* 413363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413366 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 413366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 413371 */     GIR_RootConstrainSelectedInstOperands,
     /* 413372 */     // GIR_Coverage, 2876,
     /* 413372 */     GIR_Done,
     /* 413373 */   // Label 8712: @413373
     /* 413373 */   GIM_Reject,
     /* 413374 */ // Label 8710: @413374
     /* 413374 */ GIM_Reject,
     /* 413375 */ // Label 8678: @413375
     /* 413375 */ GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(413400), // Rule ID 2398 //
     /* 413380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 413386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 413389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413393 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 413393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 413398 */   GIR_RootConstrainSelectedInstOperands,
     /* 413399 */   // GIR_Coverage, 2398,
     /* 413399 */   GIR_Done,
     /* 413400 */ // Label 8713: @413400
     /* 413400 */ GIM_Reject,
     /* 413401 */ // Label 8679: @413401
     /* 413401 */ GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(413426), // Rule ID 2872 //
     /* 413406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 413412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 413415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413419 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 413419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 413424 */   GIR_RootConstrainSelectedInstOperands,
     /* 413425 */   // GIR_Coverage, 2872,
     /* 413425 */   GIR_Done,
     /* 413426 */ // Label 8714: @413426
     /* 413426 */ GIM_Reject,
     /* 413427 */ // Label 8680: @413427
     /* 413427 */ GIM_Reject,
     /* 413428 */ // Label 156: @413428
     /* 413428 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8733*/ GIMT_Encode4(414207),
     /* 413439 */ /*GILLT_v2s32*//*Label 8715*/ GIMT_Encode4(413515),
     /* 413443 */ /*GILLT_v2s64*//*Label 8716*/ GIMT_Encode4(413570),
     /* 413447 */ /*GILLT_v4s16*//*Label 8717*/ GIMT_Encode4(413625),
     /* 413451 */ /*GILLT_v4s32*//*Label 8718*/ GIMT_Encode4(413680),
     /* 413455 */ /*GILLT_v8s8*//*Label 8719*/ GIMT_Encode4(413735),
     /* 413459 */ /*GILLT_v8s16*//*Label 8720*/ GIMT_Encode4(413769),
     /* 413463 */ /*GILLT_v16s8*//*Label 8721*/ GIMT_Encode4(413824), GIMT_Encode4(0),
     /* 413471 */ /*GILLT_nxv2s1*//*Label 8722*/ GIMT_Encode4(413858),
     /* 413475 */ /*GILLT_nxv2s16*//*Label 8723*/ GIMT_Encode4(413884),
     /* 413479 */ /*GILLT_nxv2s32*//*Label 8724*/ GIMT_Encode4(413910),
     /* 413483 */ /*GILLT_nxv2s64*//*Label 8725*/ GIMT_Encode4(413936),
     /* 413487 */ /*GILLT_nxv4s1*//*Label 8726*/ GIMT_Encode4(413983),
     /* 413491 */ /*GILLT_nxv4s16*//*Label 8727*/ GIMT_Encode4(414009),
     /* 413495 */ /*GILLT_nxv4s32*//*Label 8728*/ GIMT_Encode4(414035),
     /* 413499 */ /*GILLT_nxv8s1*//*Label 8729*/ GIMT_Encode4(414082),
     /* 413503 */ /*GILLT_nxv8s16*//*Label 8730*/ GIMT_Encode4(414108),
     /* 413507 */ /*GILLT_nxv16s1*//*Label 8731*/ GIMT_Encode4(414155),
     /* 413511 */ /*GILLT_nxv16s8*//*Label 8732*/ GIMT_Encode4(414181),
     /* 413515 */ // Label 8715: @413515
     /* 413515 */ GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(413569),
     /* 413520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 413526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413538 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(413553), // Rule ID 1909 //
     /* 413543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413546 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 413546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 413551 */     GIR_RootConstrainSelectedInstOperands,
     /* 413552 */     // GIR_Coverage, 1909,
     /* 413552 */     GIR_Done,
     /* 413553 */   // Label 8735: @413553
     /* 413553 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(413568), // Rule ID 5474 //
     /* 413558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413561 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 413566 */     GIR_RootConstrainSelectedInstOperands,
     /* 413567 */     // GIR_Coverage, 5474,
     /* 413567 */     GIR_Done,
     /* 413568 */   // Label 8736: @413568
     /* 413568 */   GIM_Reject,
     /* 413569 */ // Label 8734: @413569
     /* 413569 */ GIM_Reject,
     /* 413570 */ // Label 8716: @413570
     /* 413570 */ GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(413624),
     /* 413575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 413581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413593 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(413608), // Rule ID 1911 //
     /* 413598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413601 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 413601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 413606 */     GIR_RootConstrainSelectedInstOperands,
     /* 413607 */     // GIR_Coverage, 1911,
     /* 413607 */     GIR_Done,
     /* 413608 */   // Label 8738: @413608
     /* 413608 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(413623), // Rule ID 5476 //
     /* 413613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413616 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 413621 */     GIR_RootConstrainSelectedInstOperands,
     /* 413622 */     // GIR_Coverage, 5476,
     /* 413622 */     GIR_Done,
     /* 413623 */   // Label 8739: @413623
     /* 413623 */   GIM_Reject,
     /* 413624 */ // Label 8737: @413624
     /* 413624 */ GIM_Reject,
     /* 413625 */ // Label 8717: @413625
     /* 413625 */ GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(413679),
     /* 413630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 413636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413648 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(413663), // Rule ID 1907 //
     /* 413653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413656 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 413656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 413661 */     GIR_RootConstrainSelectedInstOperands,
     /* 413662 */     // GIR_Coverage, 1907,
     /* 413662 */     GIR_Done,
     /* 413663 */   // Label 8741: @413663
     /* 413663 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(413678), // Rule ID 5472 //
     /* 413668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413671 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 413676 */     GIR_RootConstrainSelectedInstOperands,
     /* 413677 */     // GIR_Coverage, 5472,
     /* 413677 */     GIR_Done,
     /* 413678 */   // Label 8742: @413678
     /* 413678 */   GIM_Reject,
     /* 413679 */ // Label 8740: @413679
     /* 413679 */ GIM_Reject,
     /* 413680 */ // Label 8718: @413680
     /* 413680 */ GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(413734),
     /* 413685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 413691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413703 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(413718), // Rule ID 1910 //
     /* 413708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413711 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 413711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 413716 */     GIR_RootConstrainSelectedInstOperands,
     /* 413717 */     // GIR_Coverage, 1910,
     /* 413717 */     GIR_Done,
     /* 413718 */   // Label 8744: @413718
     /* 413718 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(413733), // Rule ID 5475 //
     /* 413723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413726 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 413726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 413731 */     GIR_RootConstrainSelectedInstOperands,
     /* 413732 */     // GIR_Coverage, 5475,
     /* 413732 */     GIR_Done,
     /* 413733 */   // Label 8745: @413733
     /* 413733 */   GIM_Reject,
     /* 413734 */ // Label 8743: @413734
     /* 413734 */ GIM_Reject,
     /* 413735 */ // Label 8719: @413735
     /* 413735 */ GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(413768), // Rule ID 1905 //
     /* 413740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413761 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 413766 */   GIR_RootConstrainSelectedInstOperands,
     /* 413767 */   // GIR_Coverage, 1905,
     /* 413767 */   GIR_Done,
     /* 413768 */ // Label 8746: @413768
     /* 413768 */ GIM_Reject,
     /* 413769 */ // Label 8720: @413769
     /* 413769 */ GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(413823),
     /* 413774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 413780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413792 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(413807), // Rule ID 1908 //
     /* 413797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413800 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 413800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 413805 */     GIR_RootConstrainSelectedInstOperands,
     /* 413806 */     // GIR_Coverage, 1908,
     /* 413806 */     GIR_Done,
     /* 413807 */   // Label 8748: @413807
     /* 413807 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(413822), // Rule ID 5473 //
     /* 413812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413815 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 413815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 413820 */     GIR_RootConstrainSelectedInstOperands,
     /* 413821 */     // GIR_Coverage, 5473,
     /* 413821 */     GIR_Done,
     /* 413822 */   // Label 8749: @413822
     /* 413822 */   GIM_Reject,
     /* 413823 */ // Label 8747: @413823
     /* 413823 */ GIM_Reject,
     /* 413824 */ // Label 8721: @413824
     /* 413824 */ GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(413857), // Rule ID 1906 //
     /* 413829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413850 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413850 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 413855 */   GIR_RootConstrainSelectedInstOperands,
     /* 413856 */   // GIR_Coverage, 1906,
     /* 413856 */   GIR_Done,
     /* 413857 */ // Label 8750: @413857
     /* 413857 */ GIM_Reject,
     /* 413858 */ // Label 8722: @413858
     /* 413858 */ GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(413883), // Rule ID 8901 //
     /* 413863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 413869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 413872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413876 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 413876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 413881 */   GIR_RootConstrainSelectedInstOperands,
     /* 413882 */   // GIR_Coverage, 8901,
     /* 413882 */   GIR_Done,
     /* 413883 */ // Label 8751: @413883
     /* 413883 */ GIM_Reject,
     /* 413884 */ // Label 8723: @413884
     /* 413884 */ GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(413909), // Rule ID 8856 //
     /* 413889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 413895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 413898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413902 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 413902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413907 */   GIR_RootConstrainSelectedInstOperands,
     /* 413908 */   // GIR_Coverage, 8856,
     /* 413908 */   GIR_Done,
     /* 413909 */ // Label 8752: @413909
     /* 413909 */ GIM_Reject,
     /* 413910 */ // Label 8724: @413910
     /* 413910 */ GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(413935), // Rule ID 8857 //
     /* 413915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 413921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 413924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413928 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 413928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413933 */   GIR_RootConstrainSelectedInstOperands,
     /* 413934 */   // GIR_Coverage, 8857,
     /* 413934 */   GIR_Done,
     /* 413935 */ // Label 8753: @413935
     /* 413935 */ GIM_Reject,
     /* 413936 */ // Label 8725: @413936
     /* 413936 */ GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(413982),
     /* 413941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 413944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 413947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413951 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(413966), // Rule ID 8852 //
     /* 413956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413959 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 413959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413964 */     GIR_RootConstrainSelectedInstOperands,
     /* 413965 */     // GIR_Coverage, 8852,
     /* 413965 */     GIR_Done,
     /* 413966 */   // Label 8755: @413966
     /* 413966 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(413981), // Rule ID 8858 //
     /* 413971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413974 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 413974 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 413979 */     GIR_RootConstrainSelectedInstOperands,
     /* 413980 */     // GIR_Coverage, 8858,
     /* 413980 */     GIR_Done,
     /* 413981 */   // Label 8756: @413981
     /* 413981 */   GIM_Reject,
     /* 413982 */ // Label 8754: @413982
     /* 413982 */ GIM_Reject,
     /* 413983 */ // Label 8726: @413983
     /* 413983 */ GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(414008), // Rule ID 8900 //
     /* 413988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 413994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 413997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414001 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 414001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 414006 */   GIR_RootConstrainSelectedInstOperands,
     /* 414007 */   // GIR_Coverage, 8900,
     /* 414007 */   GIR_Done,
     /* 414008 */ // Label 8757: @414008
     /* 414008 */ GIM_Reject,
     /* 414009 */ // Label 8727: @414009
     /* 414009 */ GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(414034), // Rule ID 8854 //
     /* 414014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 414020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 414023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414027 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 414027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414032 */   GIR_RootConstrainSelectedInstOperands,
     /* 414033 */   // GIR_Coverage, 8854,
     /* 414033 */   GIR_Done,
     /* 414034 */ // Label 8758: @414034
     /* 414034 */ GIM_Reject,
     /* 414035 */ // Label 8728: @414035
     /* 414035 */ GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(414081),
     /* 414040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 414043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 414046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414050 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(414065), // Rule ID 8851 //
     /* 414055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414058 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 414058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414063 */     GIR_RootConstrainSelectedInstOperands,
     /* 414064 */     // GIR_Coverage, 8851,
     /* 414064 */     GIR_Done,
     /* 414065 */   // Label 8760: @414065
     /* 414065 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(414080), // Rule ID 8855 //
     /* 414070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414073 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 414073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414078 */     GIR_RootConstrainSelectedInstOperands,
     /* 414079 */     // GIR_Coverage, 8855,
     /* 414079 */     GIR_Done,
     /* 414080 */   // Label 8761: @414080
     /* 414080 */   GIM_Reject,
     /* 414081 */ // Label 8759: @414081
     /* 414081 */ GIM_Reject,
     /* 414082 */ // Label 8729: @414082
     /* 414082 */ GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(414107), // Rule ID 8899 //
     /* 414087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 414093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 414096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414100 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 414100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 414105 */   GIR_RootConstrainSelectedInstOperands,
     /* 414106 */   // GIR_Coverage, 8899,
     /* 414106 */   GIR_Done,
     /* 414107 */ // Label 8762: @414107
     /* 414107 */ GIM_Reject,
     /* 414108 */ // Label 8730: @414108
     /* 414108 */ GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(414154),
     /* 414113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 414116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 414119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414123 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(414138), // Rule ID 8850 //
     /* 414128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414131 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 414131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 414136 */     GIR_RootConstrainSelectedInstOperands,
     /* 414137 */     // GIR_Coverage, 8850,
     /* 414137 */     GIR_Done,
     /* 414138 */   // Label 8764: @414138
     /* 414138 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(414153), // Rule ID 8853 //
     /* 414143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414146 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 414146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 414151 */     GIR_RootConstrainSelectedInstOperands,
     /* 414152 */     // GIR_Coverage, 8853,
     /* 414152 */     GIR_Done,
     /* 414153 */   // Label 8765: @414153
     /* 414153 */   GIM_Reject,
     /* 414154 */ // Label 8763: @414154
     /* 414154 */ GIM_Reject,
     /* 414155 */ // Label 8731: @414155
     /* 414155 */ GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(414180), // Rule ID 2402 //
     /* 414160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 414166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 414169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414173 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 414173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 414178 */   GIR_RootConstrainSelectedInstOperands,
     /* 414179 */   // GIR_Coverage, 2402,
     /* 414179 */   GIR_Done,
     /* 414180 */ // Label 8766: @414180
     /* 414180 */ GIM_Reject,
     /* 414181 */ // Label 8732: @414181
     /* 414181 */ GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(414206), // Rule ID 8849 //
     /* 414186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 414192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 414195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414199 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 414199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 414204 */   GIR_RootConstrainSelectedInstOperands,
     /* 414205 */   // GIR_Coverage, 8849,
     /* 414205 */   GIR_Done,
     /* 414206 */ // Label 8767: @414206
     /* 414206 */ GIM_Reject,
     /* 414207 */ // Label 8733: @414207
     /* 414207 */ GIM_Reject,
     /* 414208 */ // Label 157: @414208
     /* 414208 */ GIM_Reject,
     /* 414209 */ }; // Size: 414209 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
